<?php
/*
	+-----------------------------------------------------------------------------+
	| ILIAS open source                                                           |
	+-----------------------------------------------------------------------------+
	| Copyright (c) 1998-2001 ILIAS open source, University of Cologne            |
	|                                                                             |
	| This program is free software; you can redistribute it and/or               |
	| modify it under the terms of the GNU General Public License                 |
	| as published by the Free Software Foundation; either version 2              |
	| of the License, or (at your option) any later version.                      |
	|                                                                             |
	| This program is distributed in the hope that it will be useful,             |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of              |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               |
	| GNU General Public License for more details.                                |
	|                                                                             |
	| You should have received a copy of the GNU General Public License           |
	| along with this program; if not, write to the Free Software                 |
	| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. |
	+-----------------------------------------------------------------------------+
*/

/**
* QTI assessmentcontrol class
*
* @author Helmut Schottmüller <helmut.schottmueller@mac.com>
* @version $Id$
*
* @package assessment
*/
class ilQTIAssessmentcontrol
{
	var $hintswitch;
	var $solutionswitch;
	var $view;
	var $feedbackswitch;
	
	function ilQTIAssessmentcontrol()
	{
		$this->hintswitch = "";
		$this->solutionswitch = "";
		$this->view = "All";
		$this->feedbackswitch = "";
	}
	
	function setView($a_view)
	{
		switch ($a_view)
		{
			case "Administrator":
			case "AdminAuthority":
			case "Assessor":
			case "Author":
			case "Candidate":
			case "InvigilatorProctor":
			case "Psychometrician":
			case "Scorer":
			case "Tutor":
				$this->view = $a_view;
				break;
			default:
				$this->view = "All";
				break;
		}
	}
	
	function getView()
	{
		return $this->view;
	}

	function setHintswitch($a_hintswitch)
	{
		switch ($a_hintswitch)
		{
			case "Yes":
			case "No":
				$this->hintswitch = $a_hintswitch;
				break;
			default:
				$this->hintswitch = "Yes";
				break;
		}
	}
	
	function getHintswitch()
	{
		return $this->hintswitch;
	}
	
	function setSolutionswitch($a_solutionswitch)
	{
		switch ($a_solutionswitch)
		{
			case "Yes":
			case "No":
				$this->solutionswitch = $a_solutionswitch;
				break;
			default:
				$this->solutionswitch = "Yes";
				break;
		}
	}
	
	function getSolutionswitch()
	{
		return $this->solutionswitch;
	}

	function setFeedbackswitch($a_feedbackswitch)
	{
		switch ($a_feedbackswitch)
		{
			case "Yes":
			case "No":
				$this->feedbackswitch = $a_feedbackswitch;
				break;
			default:
				$this->feedbackswitch = "Yes";
				break;
		}
	}
	
	function getFeedbackswitch()
	{
		return $this->feedbackswitch;
	}
	
}
?>
