<?php
function setupILIASDatabase()
{
	global $ilDB;



//
// acc_access_key
//
$fields = array (
	"lang_key" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"function_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"access_key" => array (
		"notnull" => false
		,"length" => 1
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("acc_access_key", $fields);

$pk_fields = array("lang_key","function_id");
$ilDB->addPrimaryKey("acc_access_key", $pk_fields);


//
// acc_cache
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"result" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("acc_cache", $fields);

$pk_fields = array("user_id");
$ilDB->addPrimaryKey("acc_cache", $pk_fields);


//
// acc_user_access_key
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"function_id" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"access_key" => array (
		"notnull" => false
		,"length" => 1
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("acc_user_access_key", $fields);

$pk_fields = array("user_id","function_id");
$ilDB->addPrimaryKey("acc_user_access_key", $pk_fields);


//
// acl_ws
//
$fields = array (
	"node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"object_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"extended_data" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("acl_ws", $fields);

$pk_fields = array("node_id","object_id");
$ilDB->addPrimaryKey("acl_ws", $pk_fields);


//
// addressbook
//
$fields = array (
	"addr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"login" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"firstname" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"lastname" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"email" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"auto_update" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("addressbook", $fields);

$pk_fields = array("addr_id");
$ilDB->addPrimaryKey("addressbook", $pk_fields);

$in_fields = array("user_id","login","firstname","lastname");
$ilDB->addIndex("addressbook", $in_fields, "i1", false);

$ilDB->createSequence("addressbook", 1);


//
// addressbook_mlist
//
$fields = array (
	"ml_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"createdate" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"changedate" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"lmode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("addressbook_mlist", $fields);

$pk_fields = array("ml_id");
$ilDB->addPrimaryKey("addressbook_mlist", $pk_fields);

$in_fields = array("user_id");
$ilDB->addIndex("addressbook_mlist", $in_fields, "i1", false);

$ilDB->createSequence("addressbook_mlist", 1);


//
// addressbook_mlist_ass
//
$fields = array (
	"a_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ml_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"addr_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("addressbook_mlist_ass", $fields);

$pk_fields = array("a_id");
$ilDB->addPrimaryKey("addressbook_mlist_ass", $pk_fields);

$in_fields = array("ml_id");
$ilDB->addIndex("addressbook_mlist_ass", $in_fields, "i1", false);

$in_fields = array("addr_id");
$ilDB->addIndex("addressbook_mlist_ass", $in_fields, "i2", false);

$ilDB->createSequence("addressbook_mlist_ass", 1);


//
// adl_shared_data
//
$fields = array (
	"slm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"target_id" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"store" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("adl_shared_data", $fields);


//
// adm_set_templ_hide_tab
//
$fields = array (
	"template_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tab_id" => array (
		"notnull" => true
		,"length" => 80
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("adm_set_templ_hide_tab", $fields);


//
// adm_set_templ_value
//
$fields = array (
	"template_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"setting" => array (
		"notnull" => true
		,"length" => 40
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"hide" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("adm_set_templ_value", $fields);


//
// adm_settings_template
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 5
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"auto_generated" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adm_settings_template", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("adm_settings_template", $pk_fields);

$ilDB->createSequence("adm_settings_template", 3);

$ilDB->insert("adm_settings_template", array(
'id' => array('integer', '1'), 'type' => array('text', 'tst'), 'title' => array('text', 'il_astpl_loc_initial'), 'description' => array('clob', 'il_astpl_loc_initial_desc'), 'auto_generated' => array('integer', '1')));

$ilDB->insert("adm_settings_template", array(
'id' => array('integer', '2'), 'type' => array('text', 'tst'), 'title' => array('text', 'il_astpl_loc_qualified'), 'description' => array('clob', 'il_astpl_loc_qualified_desc'), 'auto_generated' => array('integer', '1')));


//
// adv_md_obj_rec_select
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"rec_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_obj_rec_select", $fields);

$pk_fields = array("obj_id","sub_type","rec_id");
$ilDB->addPrimaryKey("adv_md_obj_rec_select", $pk_fields);


//
// adv_md_record
//
$fields = array (
	"record_id" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"active" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("adv_md_record", $fields);

$pk_fields = array("record_id");
$ilDB->addPrimaryKey("adv_md_record", $pk_fields);

$ilDB->createSequence("adv_md_record", 1);


//
// adv_md_record_objs
//
$fields = array (
	"record_id" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 6
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("adv_md_record_objs", $fields);

$pk_fields = array("record_id","obj_type","sub_type");
$ilDB->addPrimaryKey("adv_md_record_objs", $pk_fields);


//
// adv_md_substitutions
//
$fields = array (
	"obj_type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"substitution" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"hide_description" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hide_field_names" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_substitutions", $fields);

$pk_fields = array("obj_type");
$ilDB->addPrimaryKey("adv_md_substitutions", $pk_fields);


//
// adv_md_values_date
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "date"
	)
	,"disabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_values_date", $fields);

$pk_fields = array("obj_id","sub_type","sub_id","field_id");
$ilDB->addPrimaryKey("adv_md_values_date", $pk_fields);


//
// adv_md_values_datetime
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"disabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_values_datetime", $fields);

$pk_fields = array("obj_id","sub_type","sub_id","field_id");
$ilDB->addPrimaryKey("adv_md_values_datetime", $pk_fields);


//
// adv_md_values_float
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"disabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_values_float", $fields);

$pk_fields = array("obj_id","sub_type","sub_id","field_id");
$ilDB->addPrimaryKey("adv_md_values_float", $pk_fields);


//
// adv_md_values_int
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"disabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_values_int", $fields);

$pk_fields = array("obj_id","sub_type","sub_id","field_id");
$ilDB->addPrimaryKey("adv_md_values_int", $pk_fields);


//
// adv_md_values_location
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"loc_lat" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"loc_long" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"loc_zoom" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"disabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_values_location", $fields);

$pk_fields = array("obj_id","sub_type","sub_id","field_id");
$ilDB->addPrimaryKey("adv_md_values_location", $pk_fields);


//
// adv_md_values_text
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"disabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_md_values_text", $fields);

$pk_fields = array("obj_id","field_id","sub_type","sub_id");
$ilDB->addPrimaryKey("adv_md_values_text", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("adv_md_values_text", $in_fields, "i1", false);


//
// adv_mdf_definition
//
$fields = array (
	"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"record_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"position" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_values" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
	,"searchable" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"required" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("adv_mdf_definition", $fields);

$pk_fields = array("field_id");
$ilDB->addPrimaryKey("adv_mdf_definition", $pk_fields);

$ilDB->createSequence("adv_mdf_definition", 1);


//
// aicc_course
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"course_creator" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"course_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"course_system" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"course_title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"c_level" => array (
		"notnull" => false
		,"length" => 5
		,"fixed" => false
		,"type" => "text"
	)
	,"max_fields_cst" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"max_fields_ort" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"total_aus" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"total_blocks" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"total_complex_obj" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"total_objectives" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"version" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"max_normal" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("aicc_course", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("aicc_course", $pk_fields);


//
// aicc_object
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"slm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"system_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"developer_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"c_type" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("aicc_object", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("aicc_object", $pk_fields);

$in_fields = array("slm_id");
$ilDB->addIndex("aicc_object", $in_fields, "i1", false);

$ilDB->createSequence("aicc_object", 1);


//
// aicc_units
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"c_type" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"command_line" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"max_time_allowed" => array (
		"notnull" => false
		,"type" => "time"
	)
	,"time_limit_action" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"max_score" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"core_vendor" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"system_vendor" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"file_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"mastery_score" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"web_launch" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"au_password" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("aicc_units", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("aicc_units", $pk_fields);

$ilDB->createSequence("aicc_units", 1);


//
// ass_log
//
$fields = array (
	"ass_log_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"logtext" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"question_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"original_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"test_only" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ass_log", $fields);

$pk_fields = array("ass_log_id");
$ilDB->addPrimaryKey("ass_log", $pk_fields);

$in_fields = array("user_fi","obj_fi");
$ilDB->addIndex("ass_log", $in_fields, "i1", false);

$in_fields = array("obj_fi");
$ilDB->addIndex("ass_log", $in_fields, "i2", false);

$ilDB->createSequence("ass_log", 1);


//
// benchmark
//
$fields = array (
	"cdate" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"module" => array (
		"notnull" => false
		,"length" => 150
		,"fixed" => false
		,"type" => "text"
	)
	,"benchmark" => array (
		"notnull" => false
		,"length" => 150
		,"fixed" => false
		,"type" => "text"
	)
	,"duration" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"sql_stmt" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("benchmark", $fields);

$in_fields = array("module","benchmark");
$ilDB->addIndex("benchmark", $in_fields, "i1", false);


//
// booking_entry
//
$fields = array (
	"booking_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"deadline" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"num_bookings" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"target_obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"booking_group" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("booking_entry", $fields);

$pk_fields = array("booking_id");
$ilDB->addPrimaryKey("booking_entry", $pk_fields);

$ilDB->createSequence("booking_entry", 1);


//
// booking_obj_assignment
//
$fields = array (
	"booking_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"target_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("booking_obj_assignment", $fields);

$pk_fields = array("booking_id","target_obj_id");
$ilDB->addPrimaryKey("booking_obj_assignment", $pk_fields);


//
// booking_object
//
$fields = array (
	"booking_object_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => true
		,"length" => 255
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"schedule_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"pool_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"nr_items" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"info_file" => array (
		"notnull" => false
		,"length" => 500
		,"fixed" => false
		,"type" => "text"
	)
	,"post_text" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"post_file" => array (
		"notnull" => false
		,"length" => 500
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("booking_object", $fields);

$pk_fields = array("booking_object_id");
$ilDB->addPrimaryKey("booking_object", $pk_fields);

$ilDB->createSequence("booking_object", 1);


//
// booking_reservation
//
$fields = array (
	"booking_reservation_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"object_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"date_from" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"date_to" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"group_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("booking_reservation", $fields);

$pk_fields = array("booking_reservation_id");
$ilDB->addPrimaryKey("booking_reservation", $pk_fields);

$in_fields = array("user_id");
$ilDB->addIndex("booking_reservation", $in_fields, "i1", false);

$in_fields = array("object_id");
$ilDB->addIndex("booking_reservation", $in_fields, "i2", false);

$ilDB->createSequence("booking_reservation", 1);


//
// booking_schedule
//
$fields = array (
	"booking_schedule_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => true
		,"length" => 255
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"pool_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"deadline" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rent_min" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rent_max" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"raster" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"auto_break" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("booking_schedule", $fields);

$pk_fields = array("booking_schedule_id");
$ilDB->addPrimaryKey("booking_schedule", $pk_fields);

$ilDB->createSequence("booking_schedule", 1);


//
// booking_schedule_slot
//
$fields = array (
	"booking_schedule_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"day_id" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"slot_id" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"times" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("booking_schedule_slot", $fields);

$pk_fields = array("booking_schedule_id","day_id","slot_id");
$ilDB->addPrimaryKey("booking_schedule_slot", $pk_fields);


//
// booking_settings
//
$fields = array (
	"booking_pool_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"public_log" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"pool_offline" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"slots_no" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"schedule_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"ovlimit" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("booking_settings", $fields);

$pk_fields = array("booking_pool_id");
$ilDB->addPrimaryKey("booking_settings", $pk_fields);


//
// booking_user
//
$fields = array (
	"entry_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"booking_message" => array (
		"notnull" => false
		,"length" => 1024
		,"fixed" => false
		,"type" => "text"
	)
	,"notification_sent" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("booking_user", $fields);

$pk_fields = array("entry_id","user_id");
$ilDB->addPrimaryKey("booking_user", $pk_fields);


//
// bookmark_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"target" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("bookmark_data", $fields);

$pk_fields = array("obj_id","user_id");
$ilDB->addPrimaryKey("bookmark_data", $pk_fields);

$ilDB->createSequence("bookmark_data", 2);

$ilDB->insert("bookmark_data", array(
'obj_id' => array('integer', '1'), 'user_id' => array('integer', '0'), 'title' => array('text', 'dummy_folder'), 'description' => array('text', ''), 'target' => array('text', ''), 'type' => array('text', 'bmf')));


//
// bookmark_social_bm
//
$fields = array (
	"sbm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sbm_title" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"sbm_link" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"sbm_icon" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"sbm_active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("bookmark_social_bm", $fields);

$pk_fields = array("sbm_id");
$ilDB->addPrimaryKey("bookmark_social_bm", $pk_fields);

$ilDB->createSequence("bookmark_social_bm", 95);

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '80'), 'sbm_title' => array('text', 'Facebook'), 'sbm_link' => array('text', 'http://www.facebook.com/share.php?u={LINK}&t={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/facebook.png'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '81'), 'sbm_title' => array('text', 'Google'), 'sbm_link' => array('text', 'http://www.google.com/bookmarks/mark?op=add&hl=de&bkmk={LINK}&annotation=&labels=&title={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/google.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '82'), 'sbm_title' => array('text', 'Linkarena'), 'sbm_link' => array('text', 'http://linkarena.com/bookmarks/addlink/?url={LINK}&title={TITLE}&desc=&tags='), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/linkarena.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '83'), 'sbm_title' => array('text', 'Live'), 'sbm_link' => array('text', 'http://favorites.live.com/quickadd.aspx?marklet=1&mkt=en-us&top=0&url={LINK}&title={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/live.png'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '84'), 'sbm_title' => array('text', 'Newsvine'), 'sbm_link' => array('text', 'http://www.newsvine.com/_wine/save?popoff=1&u={LINK}&tags=&blurb={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/newsvine.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '85'), 'sbm_title' => array('text', 'Reddit'), 'sbm_link' => array('text', 'http://reddit.com/submit?url={LINK}&title={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/reddit.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '86'), 'sbm_title' => array('text', 'Yahoo'), 'sbm_link' => array('text', 'http://myweb2.search.yahoo.com/myresults/bookmarklet?t={TITLE}&d=&tag=&u={LINK}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/yahoo.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '87'), 'sbm_title' => array('text', 'Yigg'), 'sbm_link' => array('text', 'http://yigg.de/neu?exturl={LINK}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/yigg.png'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '88'), 'sbm_title' => array('text', 'studiVZ meinVZ schülerVZ'), 'sbm_link' => array('text', 'http://www.studivz.net/Link/Selection/Url/?u={LINK}&desc={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/studiVZ.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '89'), 'sbm_title' => array('text', 'MySpace'), 'sbm_link' => array('text', 'http://www.myspace.com/index.cfm?fuseaction=postto&u={LINK}&t={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/myspace.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '90'), 'sbm_title' => array('text', 'Del.icio.us'), 'sbm_link' => array('text', 'http://del.icio.us/post?url={LINK}&title={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/delicious.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '91'), 'sbm_title' => array('text', 'Digg'), 'sbm_link' => array('text', 'http://digg.com/submit?phase=2&url={LINK}&title={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/digg.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '92'), 'sbm_title' => array('text', 'Folkd'), 'sbm_link' => array('text', 'http://www.folkd.com/submit/{LINK}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/folkd.gif'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '93'), 'sbm_title' => array('text', 'Mister Wong'), 'sbm_link' => array('text', 'http://www.mister-wong.de/index.php?action=addurl&bm_url={LINK}&title={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/wong.jpg'), 'sbm_active' => array('integer', '1')));

$ilDB->insert("bookmark_social_bm", array(
'sbm_id' => array('integer', '94'), 'sbm_title' => array('text', 'StumbleUpon'), 'sbm_link' => array('text', 'http://www.stumbleupon.com/submit?url={LINK}&title={TITLE}'), 'sbm_icon' => array('text', 'templates/default/images/socialbookmarks/stumbleupon.jpg'), 'sbm_active' => array('integer', '1')));


//
// bookmark_tree
//
$fields = array (
	"tree" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("bookmark_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("bookmark_tree", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("bookmark_tree", $in_fields, "i2", false);

$in_fields = array("child","tree");
$ilDB->addIndex("bookmark_tree", $in_fields, "i3", false);

$ilDB->insert("bookmark_tree", array(
'tree' => array('integer', '6'), 'child' => array('integer', '1'), 'parent' => array('integer', '0'), 'lft' => array('integer', '1'), 'rgt' => array('integer', '2'), 'depth' => array('integer', '1')));


//
// cache_clob
//
$fields = array (
	"component" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"entry_id" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"expire_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ilias_version" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"int_key_1" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"int_key_2" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"text_key_1" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"text_key_2" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cache_clob", $fields);

$pk_fields = array("component","name","entry_id");
$ilDB->addPrimaryKey("cache_clob", $pk_fields);

$in_fields = array("expire_time");
$ilDB->addIndex("cache_clob", $in_fields, "et", false);

$in_fields = array("ilias_version");
$ilDB->addIndex("cache_clob", $in_fields, "iv", false);


//
// cache_text
//
$fields = array (
	"component" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"entry_id" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"expire_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ilias_version" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"int_key_1" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"int_key_2" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"text_key_1" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"text_key_2" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cache_text", $fields);

$pk_fields = array("component","name","entry_id");
$ilDB->addPrimaryKey("cache_text", $pk_fields);

$in_fields = array("expire_time");
$ilDB->addIndex("cache_text", $in_fields, "et", false);

$in_fields = array("ilias_version");
$ilDB->addIndex("cache_text", $in_fields, "iv", false);


//
// cal_auth_token
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"hash" => array (
		"notnull" => true
		,"length" => 32
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"selection" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"calendar" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ical" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"c_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_auth_token", $fields);

$pk_fields = array("user_id","hash");
$ilDB->addPrimaryKey("cal_auth_token", $pk_fields);

$in_fields = array("hash");
$ilDB->addIndex("cal_auth_token", $in_fields, "i1", false);


//
// cal_cat_assignments
//
$fields = array (
	"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_cat_assignments", $fields);

$pk_fields = array("cal_id","cat_id");
$ilDB->addPrimaryKey("cal_cat_assignments", $pk_fields);

$in_fields = array("cat_id");
$ilDB->addIndex("cal_cat_assignments", $in_fields, "i2", false);


//
// cal_categories
//
$fields = array (
	"cat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => true
		,"type" => "text"
	)
	,"color" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => true
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"loc_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"remote_url" => array (
		"notnull" => false
		,"length" => 500
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_user" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_pass" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_sync" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("cal_categories", $fields);

$pk_fields = array("cat_id");
$ilDB->addPrimaryKey("cal_categories", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("cal_categories", $in_fields, "i2", false);

$in_fields = array("type");
$ilDB->addIndex("cal_categories", $in_fields, "i3", false);

$ilDB->createSequence("cal_categories", 1);


//
// cal_categories_hidden
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_categories_hidden", $fields);

$pk_fields = array("user_id","cat_id");
$ilDB->addPrimaryKey("cal_categories_hidden", $pk_fields);

$in_fields = array("cat_id");
$ilDB->addIndex("cal_categories_hidden", $in_fields, "i1", false);


//
// cal_ch_group
//
$fields = array (
	"grp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"multiple_assignments" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cal_ch_group", $fields);

$pk_fields = array("grp_id");
$ilDB->addPrimaryKey("cal_ch_group", $pk_fields);

$ilDB->createSequence("cal_ch_group", 1);


//
// cal_ch_settings
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"admin_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_ch_settings", $fields);

$pk_fields = array("user_id","admin_id");
$ilDB->addPrimaryKey("cal_ch_settings", $pk_fields);


//
// cal_entries
//
$fields = array (
	"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => true
		,"type" => "text"
	)
	,"subtitle" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"location" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"fullday" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"starta" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"enda" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"informations" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"auto_generated" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"context_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"translation_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_milestone" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"completion" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"notification" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_entries", $fields);

$pk_fields = array("cal_id");
$ilDB->addPrimaryKey("cal_entries", $pk_fields);

$in_fields = array("last_update");
$ilDB->addIndex("cal_entries", $in_fields, "i1", false);

$in_fields = array("context_id");
$ilDB->addIndex("cal_entries", $in_fields, "i2", false);

$ilDB->createSequence("cal_entries", 1);


//
// cal_entry_responsible
//
$fields = array (
	"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_entry_responsible", $fields);

$pk_fields = array("cal_id","user_id");
$ilDB->addPrimaryKey("cal_entry_responsible", $pk_fields);


//
// cal_notification
//
$fields = array (
	"notification_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"email" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cal_notification", $fields);

$pk_fields = array("notification_id");
$ilDB->addPrimaryKey("cal_notification", $pk_fields);

$in_fields = array("cal_id");
$ilDB->addIndex("cal_notification", $in_fields, "i1", false);

$ilDB->createSequence("cal_notification", 1);


//
// cal_rec_exclusion
//
$fields = array (
	"excl_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"excl_date" => array (
		"notnull" => false
		,"type" => "date"
	)
);
$ilDB->createTable("cal_rec_exclusion", $fields);

$pk_fields = array("excl_id");
$ilDB->addPrimaryKey("cal_rec_exclusion", $pk_fields);

$in_fields = array("cal_id");
$ilDB->addIndex("cal_rec_exclusion", $in_fields, "i1", false);

$ilDB->createSequence("cal_rec_exclusion", 1);


//
// cal_recurrence_rules
//
$fields = array (
	"rule_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cal_recurrence" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"freq_type" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => true
		,"type" => "text"
	)
	,"freq_until_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"freq_until_count" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"intervall" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"byday" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"byweekno" => array (
		"notnull" => false
		,"length" => 64
		,"default" => "0"
		,"fixed" => true
		,"type" => "text"
	)
	,"bymonth" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"bymonthday" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"byyearday" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"bysetpos" => array (
		"notnull" => false
		,"length" => 64
		,"default" => "0"
		,"fixed" => true
		,"type" => "text"
	)
	,"weekstart" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("cal_recurrence_rules", $fields);

$pk_fields = array("rule_id");
$ilDB->addPrimaryKey("cal_recurrence_rules", $pk_fields);

$in_fields = array("cal_id");
$ilDB->addIndex("cal_recurrence_rules", $in_fields, "i1", false);

$ilDB->createSequence("cal_recurrence_rules", 1);


//
// cal_registrations
//
$fields = array (
	"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"dstart" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"dend" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_registrations", $fields);

$pk_fields = array("cal_id","usr_id","dstart","dend");
$ilDB->addPrimaryKey("cal_registrations", $pk_fields);


//
// cal_shared
//
$fields = array (
	"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"writable" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_shared", $fields);

$pk_fields = array("cal_id","obj_id");
$ilDB->addPrimaryKey("cal_shared", $pk_fields);

$in_fields = array("obj_id","obj_type");
$ilDB->addIndex("cal_shared", $in_fields, "i1", false);


//
// cal_shared_status
//
$fields = array (
	"cal_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cal_shared_status", $fields);

$pk_fields = array("cal_id","usr_id");
$ilDB->addPrimaryKey("cal_shared_status", $pk_fields);


//
// catch_write_events
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ts" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("catch_write_events", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("catch_write_events", $pk_fields);


//
// chat_blocked
//
$fields = array (
	"chat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chat_blocked", $fields);


//
// chat_invitations
//
$fields = array (
	"chat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"guest_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"guest_informed" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"invitation_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chat_invitations", $fields);

$pk_fields = array("chat_id","room_id","guest_id");
$ilDB->addPrimaryKey("chat_invitations", $pk_fields);

$in_fields = array("guest_id","guest_informed","invitation_time");
$ilDB->addIndex("chat_invitations", $in_fields, "i1", false);


//
// chat_record_data
//
$fields = array (
	"record_data_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"record_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"message" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"msg_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chat_record_data", $fields);

$pk_fields = array("record_data_id");
$ilDB->addPrimaryKey("chat_record_data", $pk_fields);

$ilDB->createSequence("chat_record_data", 1);


//
// chat_records
//
$fields = array (
	"record_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"moderator_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"chat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"start_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"end_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chat_records", $fields);

$pk_fields = array("record_id");
$ilDB->addPrimaryKey("chat_records", $pk_fields);

$ilDB->createSequence("chat_records", 1);


//
// chat_room_messages
//
$fields = array (
	"entry_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"chat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"message" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"commit_timestamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chat_room_messages", $fields);

$pk_fields = array("entry_id");
$ilDB->addPrimaryKey("chat_room_messages", $pk_fields);

$ilDB->createSequence("chat_room_messages", 1);


//
// chat_rooms
//
$fields = array (
	"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"chat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"owner" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chat_rooms", $fields);

$pk_fields = array("room_id");
$ilDB->addPrimaryKey("chat_rooms", $pk_fields);

$ilDB->createSequence("chat_rooms", 1);


//
// chat_smilies
//
$fields = array (
	"smiley_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"smiley_keywords" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"smiley_path" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("chat_smilies", $fields);

$pk_fields = array("smiley_id");
$ilDB->addPrimaryKey("chat_smilies", $pk_fields);

$ilDB->createSequence("chat_smilies", 1);


//
// chat_user
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"chat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_conn_timestamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"kicked" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chat_user", $fields);

$pk_fields = array("usr_id","chat_id","room_id");
$ilDB->addPrimaryKey("chat_user", $pk_fields);


//
// chatroom_admconfig
//
$fields = array (
	"instance_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"server_settings" => array (
		"notnull" => true
		,"length" => 2000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"default_config" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"client_settings" => array (
		"notnull" => true
		,"length" => 1000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("chatroom_admconfig", $fields);

$pk_fields = array("instance_id");
$ilDB->addPrimaryKey("chatroom_admconfig", $pk_fields);

$ilDB->createSequence("chatroom_admconfig", 1);


//
// chatroom_bans
//
$fields = array (
	"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"timestamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"remark" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("chatroom_bans", $fields);


//
// chatroom_history
//
$fields = array (
	"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"message" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"timestamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"sub_room" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_history", $fields);


//
// chatroom_proomaccess
//
$fields = array (
	"proom_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_proomaccess", $fields);


//
// chatroom_prooms
//
$fields = array (
	"proom_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"parent_id" => array (
		"notnull" => true
		,"length" => 2000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => true
		,"length" => 200
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"owner" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"closed" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_public" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_prooms", $fields);

$pk_fields = array("proom_id");
$ilDB->addPrimaryKey("chatroom_prooms", $pk_fields);

$ilDB->createSequence("chatroom_prooms", 1);


//
// chatroom_psessions
//
$fields = array (
	"proom_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"connected" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"disconnected" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_psessions", $fields);


//
// chatroom_sessions
//
$fields = array (
	"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"userdata" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"connected" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"disconnected" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_sessions", $fields);


//
// chatroom_settings
//
$fields = array (
	"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"object_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"room_type" => array (
		"notnull" => true
		,"length" => 20
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"allow_anonymous" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"allow_custom_usernames" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"enable_history" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"restrict_history" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"autogen_usernames" => array (
		"notnull" => false
		,"length" => 50
		,"default" => "Anonymous #"
		,"fixed" => false
		,"type" => "text"
	)
	,"allow_private_rooms" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"display_past_msgs" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"private_rooms_enabled" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_settings", $fields);

$pk_fields = array("room_id");
$ilDB->addPrimaryKey("chatroom_settings", $pk_fields);

$ilDB->createSequence("chatroom_settings", 3);

$ilDB->insert("chatroom_settings", array(
'room_id' => array('integer', '1'), 'object_id' => array('integer', '132'), 'room_type' => array('text', 'repository'), 'allow_anonymous' => array('integer', '0'), 'allow_custom_usernames' => array('integer', '0'), 'enable_history' => array('integer', '0'), 'restrict_history' => array('integer', '0'), 'autogen_usernames' => array('text', 'Autogen #'), 'allow_private_rooms' => array('integer', '0'), 'display_past_msgs' => array('integer', '0'), 'private_rooms_enabled' => array('integer', '0')));

$ilDB->insert("chatroom_settings", array(
'room_id' => array('integer', '2'), 'object_id' => array('integer', '185'), 'room_type' => array('text', 'default'), 'allow_anonymous' => array('integer', '0'), 'allow_custom_usernames' => array('integer', '0'), 'enable_history' => array('integer', '0'), 'restrict_history' => array('integer', '0'), 'autogen_usernames' => array('text', 'Anonymous #'), 'allow_private_rooms' => array('integer', '1'), 'display_past_msgs' => array('integer', '0'), 'private_rooms_enabled' => array('integer', '1')));


//
// chatroom_smilies
//
$fields = array (
	"smiley_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"smiley_keywords" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"smiley_path" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("chatroom_smilies", $fields);

$pk_fields = array("smiley_id");
$ilDB->addPrimaryKey("chatroom_smilies", $pk_fields);

$ilDB->createSequence("chatroom_smilies", 1);


//
// chatroom_uploads
//
$fields = array (
	"upload_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"filename" => array (
		"notnull" => true
		,"length" => 200
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"filetype" => array (
		"notnull" => true
		,"length" => 200
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"timestamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_uploads", $fields);

$pk_fields = array("upload_id");
$ilDB->addPrimaryKey("chatroom_uploads", $pk_fields);

$ilDB->createSequence("chatroom_uploads", 1);


//
// chatroom_users
//
$fields = array (
	"room_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"userdata" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"connected" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("chatroom_users", $fields);

$pk_fields = array("room_id","user_id");
$ilDB->addPrimaryKey("chatroom_users", $pk_fields);


//
// cmi_comment
//
$fields = array (
	"cmi_comment_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cmi_node_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"c_comment" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"c_timestamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"location" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"sourceislms" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cmi_comment", $fields);

$pk_fields = array("cmi_comment_id");
$ilDB->addPrimaryKey("cmi_comment", $pk_fields);

$in_fields = array("cmi_node_id");
$ilDB->addIndex("cmi_comment", $in_fields, "i2", false);

$ilDB->createSequence("cmi_comment", 1);


//
// cmi_correct_response
//
$fields = array (
	"cmi_correct_resp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cmi_interaction_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"pattern" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cmi_correct_response", $fields);

$pk_fields = array("cmi_correct_resp_id");
$ilDB->addPrimaryKey("cmi_correct_response", $pk_fields);

$in_fields = array("cmi_interaction_id");
$ilDB->addIndex("cmi_correct_response", $in_fields, "i1", false);

$ilDB->createSequence("cmi_correct_response", 1);


//
// cmi_custom
//
$fields = array (
	"sco_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lvalue" => array (
		"notnull" => true
		,"length" => 64
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"rvalue" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"c_timestamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("cmi_custom", $fields);

$pk_fields = array("user_id","lvalue","obj_id","sco_id");
$ilDB->addPrimaryKey("cmi_custom", $pk_fields);


//
// cmi_gobjective
//
$fields = array (
	"user_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"satisfied" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"measure" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"scope_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"objective_id" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"score_raw" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"score_min" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"score_max" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"progress_measure" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"completion_status" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cmi_gobjective", $fields);

$in_fields = array("scope_id","objective_id");
$ilDB->addIndex("cmi_gobjective", $in_fields, "i2", false);

$in_fields = array("user_id","objective_id","scope_id");
$ilDB->addUniqueConstraint("cmi_gobjective", $in_fields, "c1");


//
// cmi_interaction
//
$fields = array (
	"cmi_interaction_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cmi_node_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"latency" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"result" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"c_timestamp" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"c_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"weighting" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"learner_response" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("cmi_interaction", $fields);

$pk_fields = array("cmi_interaction_id");
$ilDB->addPrimaryKey("cmi_interaction", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("cmi_interaction", $in_fields, "i2", false);

$in_fields = array("c_type");
$ilDB->addIndex("cmi_interaction", $in_fields, "i3", false);

$in_fields = array("cmi_node_id");
$ilDB->addIndex("cmi_interaction", $in_fields, "i4", false);

$ilDB->createSequence("cmi_interaction", 1);


//
// cmi_node
//
$fields = array (
	"accesscount" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"accessduration" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"accessed" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"activityabsduration" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"activityattemptcount" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"activityexpduration" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"activityprogstatus" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"attemptabsduration" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptcomplamount" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"attemptcomplstatus" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"attemptexpduration" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptprogstatus" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"audio_captioning" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"audio_level" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"availablechildren" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"cmi_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"completion" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"completion_status" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"completion_threshold" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"credit" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"delivery_speed" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"c_entry" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"c_exit" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"c_language" => array (
		"notnull" => false
		,"length" => 5
		,"fixed" => false
		,"type" => "text"
	)
	,"launch_data" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"learner_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"location" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"c_max" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"c_min" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"c_mode" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"modified" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"progress_measure" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"c_raw" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"scaled" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"scaled_passing_score" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"session_time" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"success_status" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"suspend_data" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"total_time" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"c_timestamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"additional_tables" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cmi_node", $fields);

$pk_fields = array("cmi_node_id");
$ilDB->addPrimaryKey("cmi_node", $pk_fields);

$in_fields = array("cp_node_id");
$ilDB->addIndex("cmi_node", $in_fields, "i1", false);

$in_fields = array("completion_status");
$ilDB->addIndex("cmi_node", $in_fields, "i2", false);

$in_fields = array("credit");
$ilDB->addIndex("cmi_node", $in_fields, "i3", false);

$in_fields = array("user_id");
$ilDB->addIndex("cmi_node", $in_fields, "i5", false);

$ilDB->createSequence("cmi_node", 1);


//
// cmi_objective
//
$fields = array (
	"cmi_interaction_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"cmi_node_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"cmi_objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"c_max" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"c_min" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"c_raw" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"scaled" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"progress_measure" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"success_status" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"scope" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"completion_status" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cmi_objective", $fields);

$pk_fields = array("cmi_objective_id");
$ilDB->addPrimaryKey("cmi_objective", $pk_fields);

$in_fields = array("cmi_interaction_id");
$ilDB->addIndex("cmi_objective", $in_fields, "i2", false);

$in_fields = array("id");
$ilDB->addIndex("cmi_objective", $in_fields, "i3", false);

$in_fields = array("success_status");
$ilDB->addIndex("cmi_objective", $in_fields, "i4", false);

$ilDB->createSequence("cmi_objective", 1);


//
// conditions
//
$fields = array (
	"condition_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"target_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"target_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"target_type" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"trigger_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"trigger_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"trigger_type" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"operator" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"ref_handling" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"obligatory" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"num_obligatory" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hidden_status" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("conditions", $fields);

$pk_fields = array("condition_id");
$ilDB->addPrimaryKey("conditions", $pk_fields);

$in_fields = array("target_obj_id","target_type");
$ilDB->addIndex("conditions", $in_fields, "tot", false);

$in_fields = array("target_obj_id");
$ilDB->addIndex("conditions", $in_fields, "i1", false);

$ilDB->createSequence("conditions", 1);


//
// container_reference
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"target_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("container_reference", $fields);

$pk_fields = array("obj_id","target_obj_id");
$ilDB->addPrimaryKey("container_reference", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("container_reference", $in_fields, "i1", false);


//
// container_settings
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"keyword" => array (
		"notnull" => true
		,"length" => 40
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("container_settings", $fields);

$pk_fields = array("id","keyword");
$ilDB->addPrimaryKey("container_settings", $pk_fields);


//
// container_sorting
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"position" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 5
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("container_sorting", $fields);

$pk_fields = array("obj_id","child_id","parent_id");
$ilDB->addPrimaryKey("container_sorting", $pk_fields);


//
// container_sorting_bl
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"block_ids" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("container_sorting_bl", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("container_sorting_bl", $pk_fields);


//
// container_sorting_set
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sort_mode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sort_direction" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"new_items_position" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"new_items_order" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("container_sorting_set", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("container_sorting_set", $pk_fields);


//
// content_object
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"default_layout" => array (
		"notnull" => false
		,"length" => 100
		,"default" => "toc2win"
		,"fixed" => false
		,"type" => "text"
	)
	,"stylesheet" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"page_header" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "st_title"
		,"fixed" => true
		,"type" => "text"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"toc_active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "y"
		,"fixed" => true
		,"type" => "text"
	)
	,"lm_menu_active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "y"
		,"fixed" => true
		,"type" => "text"
	)
	,"toc_mode" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "chapters"
		,"fixed" => true
		,"type" => "text"
	)
	,"clean_frames" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"print_view_active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "y"
		,"fixed" => true
		,"type" => "text"
	)
	,"numbering" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"hist_user_comments" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"public_access_mode" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "complete"
		,"fixed" => true
		,"type" => "text"
	)
	,"public_html_file" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"public_xml_file" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"downloads_active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"downloads_public_active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "y"
		,"fixed" => true
		,"type" => "text"
	)
	,"header_page" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"footer_page" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"no_glo_appendix" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"layout_per_page" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"public_scorm_file" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"rating" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hide_head_foot_print" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"disable_def_feedback" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rating_pages" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"progr_icons" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"store_tries" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"restrict_forw_nav" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("content_object", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("content_object", $pk_fields);


//
// copg_multilang
//
$fields = array (
	"parent_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"master_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("copg_multilang", $fields);

$pk_fields = array("parent_type","parent_id");
$ilDB->addPrimaryKey("copg_multilang", $pk_fields);


//
// copg_multilang_lang
//
$fields = array (
	"parent_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("copg_multilang_lang", $fields);

$pk_fields = array("parent_type","parent_id","lang");
$ilDB->addPrimaryKey("copg_multilang_lang", $pk_fields);


//
// copg_pc_def
//
$fields = array (
	"pc_type" => array (
		"notnull" => true
		,"length" => 20
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 40
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"directory" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"int_links" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"style_classes" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"xsl" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"component" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"def_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("copg_pc_def", $fields);

$pk_fields = array("pc_type");
$ilDB->addPrimaryKey("copg_pc_def", $pk_fields);

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'cach'), 'name' => array('text', 'ConsultationHours'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Modules/Portfolio'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'mcrs'), 'name' => array('text', 'MyCourses'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Modules/Portfolio'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'amdpl'), 'name' => array('text', 'AMDPageList'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Modules/Wiki'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'blog'), 'name' => array('text', 'Blog'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'incl'), 'name' => array('text', 'ContentInclude'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '1'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'flit'), 'name' => array('text', 'FileItem'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'flst'), 'name' => array('text', 'FileList'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'iim'), 'name' => array('text', 'InteractiveImage'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '1'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'list'), 'name' => array('text', 'List'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'li'), 'name' => array('text', 'ListItem'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'lpe'), 'name' => array('text', 'LoginPageElement'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'map'), 'name' => array('text', 'Map'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'media'), 'name' => array('text', 'MediaObject'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'par'), 'name' => array('text', 'Paragraph'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '1'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'plach'), 'name' => array('text', 'PlaceHolder'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'plug'), 'name' => array('text', 'Plugged'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'prof'), 'name' => array('text', 'Profile'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'pcqst'), 'name' => array('text', 'Question'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'qover'), 'name' => array('text', 'QuestionOverview'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'repobj'), 'name' => array('text', 'Resources'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'sec'), 'name' => array('text', 'Section'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'skills'), 'name' => array('text', 'Skills'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'dtab'), 'name' => array('text', 'DataTable'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'tab'), 'name' => array('text', 'Table'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'td'), 'name' => array('text', 'TableData'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'tabs'), 'name' => array('text', 'Tabs'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '1'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'tabstab'), 'name' => array('text', 'Tab'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'vrfc'), 'name' => array('text', 'Verification'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'src'), 'name' => array('text', 'SourceCode'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '1')));

$ilDB->insert("copg_pc_def", array(
'pc_type' => array('text', 'templ'), 'name' => array('text', 'ContentTemplate'), 'directory' => array('text', 'classes'), 'int_links' => array('integer', '0'), 'style_classes' => array('integer', '0'), 'xsl' => array('integer', '0'), 'component' => array('text', 'Services/COPage'), 'def_enabled' => array('integer', '0')));


//
// copg_pobj_def
//
$fields = array (
	"parent_type" => array (
		"notnull" => true
		,"length" => 20
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"class_name" => array (
		"notnull" => true
		,"length" => 80
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"directory" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"component" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("copg_pobj_def", $fields);

$pk_fields = array("parent_type");
$ilDB->addPrimaryKey("copg_pobj_def", $pk_fields);

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'dclf'), 'class_name' => array('text', 'ilDataCollectionRecordViewViewdefinition'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/DataCollection')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'prtf'), 'class_name' => array('text', 'ilPortfolioPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/Portfolio')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'prtt'), 'class_name' => array('text', 'ilPortfolioTemplatePage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/Portfolio')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'lobj'), 'class_name' => array('text', 'ilLOPage'), 'directory' => array('text', 'classes/Objectives'), 'component' => array('text', 'Modules/Course')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'lm'), 'class_name' => array('text', 'ilLMPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/LearningModule')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'blp'), 'class_name' => array('text', 'ilBlogPosting'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/Blog')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'wpg'), 'class_name' => array('text', 'ilWikiPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/Wiki')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'qht'), 'class_name' => array('text', 'ilAssHintPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/TestQuestionPool')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'qpl'), 'class_name' => array('text', 'ilAssQuestionPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/TestQuestionPool')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'qfbg'), 'class_name' => array('text', 'ilAssGenFeedbackPage'), 'directory' => array('text', 'classes/feedback'), 'component' => array('text', 'Modules/TestQuestionPool')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'qfbs'), 'class_name' => array('text', 'ilAssSpecFeedbackPage'), 'directory' => array('text', 'classes/feedback'), 'component' => array('text', 'Modules/TestQuestionPool')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'sahs'), 'class_name' => array('text', 'ilSCORM2004Page'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/Scorm2004')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'gdf'), 'class_name' => array('text', 'ilGlossaryDefPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/Glossary')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'mep'), 'class_name' => array('text', 'ilMediaPoolPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Modules/MediaPool')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'impr'), 'class_name' => array('text', 'ilImprint'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Services/Imprint')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'stys'), 'class_name' => array('text', 'ilPageLayoutPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Services/Style')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'auth'), 'class_name' => array('text', 'ilLoginPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Services/Authentication')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'shop'), 'class_name' => array('text', 'ilShopPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Services/Payment')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'cont'), 'class_name' => array('text', 'ilContainerPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Services/Container')));

$ilDB->insert("copg_pobj_def", array(
'parent_type' => array('text', 'cstr'), 'class_name' => array('text', 'ilContainerStartObjectsPage'), 'directory' => array('text', 'classes'), 'component' => array('text', 'Services/Container')));


//
// copy_wizard_options
//
$fields = array (
	"copy_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"source_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"options" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("copy_wizard_options", $fields);

$pk_fields = array("copy_id","source_id");
$ilDB->addPrimaryKey("copy_wizard_options", $pk_fields);


//
// cp_auxilaryresource
//
$fields = array (
	"auxiliaryresourceid" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"purpose" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_auxilaryresource", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_auxilaryresource", $pk_fields);


//
// cp_condition
//
$fields = array (
	"c_condition" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"measurethreshold" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"c_operator" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"referencedobjective" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_condition", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_condition", $pk_fields);


//
// cp_datamap
//
$fields = array (
	"sco_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"slm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"target_id" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"read_shared_data" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"write_shared_data" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_datamap", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_datamap", $pk_fields);


//
// cp_dependency
//
$fields = array (
	"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"resourceid" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_dependency", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_dependency", $pk_fields);

$in_fields = array("resourceid");
$ilDB->addIndex("cp_dependency", $in_fields, "i2", false);


//
// cp_file
//
$fields = array (
	"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"href" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_file", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_file", $pk_fields);


//
// cp_hidelmsui
//
$fields = array (
	"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_hidelmsui", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_hidelmsui", $pk_fields);

$in_fields = array("value");
$ilDB->addIndex("cp_hidelmsui", $in_fields, "i1", false);


//
// cp_item
//
$fields = array (
	"completionthreshold" => array (
		"notnull" => false
		,"length" => 50
		,"default" => "1.0"
		,"fixed" => false
		,"type" => "text"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"datafromlms" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"isvisible" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"parameters" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"resourceid" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"sequencingid" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"timelimitaction" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"progressweight" => array (
		"notnull" => false
		,"length" => 50
		,"default" => "1.0"
		,"fixed" => false
		,"type" => "text"
	)
	,"completedbymeasure" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_item", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_item", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("cp_item", $in_fields, "i1", false);

$in_fields = array("sequencingid");
$ilDB->addIndex("cp_item", $in_fields, "i2", false);


//
// cp_manifest
//
$fields = array (
	"base" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"defaultorganization" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"uri" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"version" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_manifest", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_manifest", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("cp_manifest", $in_fields, "i1", false);


//
// cp_mapinfo
//
$fields = array (
	"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"readnormalmeasure" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"readsatisfiedstatus" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"targetobjectiveid" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"writenormalmeasure" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"writesatisfiedstatus" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_mapinfo", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_mapinfo", $pk_fields);

$in_fields = array("targetobjectiveid");
$ilDB->addIndex("cp_mapinfo", $in_fields, "i1", false);


//
// cp_node
//
$fields = array (
	"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nodename" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"slm_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_node", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_node", $pk_fields);

$in_fields = array("nodename");
$ilDB->addIndex("cp_node", $in_fields, "i2", false);

$in_fields = array("slm_id");
$ilDB->addIndex("cp_node", $in_fields, "i3", false);

$ilDB->createSequence("cp_node", 1);


//
// cp_objective
//
$fields = array (
	"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"minnormalmeasure" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"objectiveid" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"c_primary" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"satisfiedbymeasure" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_objective", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_objective", $pk_fields);


//
// cp_organization
//
$fields = array (
	"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"objectivesglobtosys" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sequencingid" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"structure" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_organization", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_organization", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("cp_organization", $in_fields, "i1", false);

$in_fields = array("sequencingid");
$ilDB->addIndex("cp_organization", $in_fields, "i2", false);


//
// cp_package
//
$fields = array (
	"created" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"c_identifier" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"jsdata" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"modified" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"persistprevattempts" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"c_settings" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"xmldata" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"activitytree" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"global_to_system" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"shared_data_global_to_system" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_package", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("cp_package", $pk_fields);

$in_fields = array("c_identifier");
$ilDB->addIndex("cp_package", $in_fields, "i1", false);


//
// cp_resource
//
$fields = array (
	"base" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"href" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"scormtype" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"c_type" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_resource", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_resource", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("cp_resource", $in_fields, "i1", false);


//
// cp_rule
//
$fields = array (
	"action" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"childactivityset" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"conditioncombination" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"minimumcount" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"minimumpercent" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"c_type" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("cp_rule", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_rule", $pk_fields);


//
// cp_sequencing
//
$fields = array (
	"activityabsdurlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"activityexpdurlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptabsdurlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptexpdurlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptlimit" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"begintimelimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"choice" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"choiceexit" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"completionbycontent" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"constrainchoice" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"cp_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"endtimelimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"flow" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"forwardonly" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"measuresatisfactive" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"objectivemeasweight" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"objectivebycontent" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"preventactivation" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"randomizationtiming" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"reorderchildren" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"requiredcompleted" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"requiredincomplete" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"requirednotsatisfied" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"requiredforsatisfied" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"rollupobjectivesatis" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rollupprogcompletion" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"selectcount" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"selectiontiming" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"sequencingid" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"tracked" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"usecurattemptobjinfo" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"usecurattemptproginfo" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_sequencing", $fields);

$pk_fields = array("cp_node_id");
$ilDB->addPrimaryKey("cp_sequencing", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("cp_sequencing", $in_fields, "i1", false);


//
// cp_suspend
//
$fields = array (
	"data" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"user_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_suspend", $fields);

$in_fields = array("user_id","obj_id");
$ilDB->addUniqueConstraint("cp_suspend", $in_fields, "c1");


//
// cp_tree
//
$fields = array (
	"child" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cp_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("cp_tree", $in_fields, "i1", false);

$in_fields = array("obj_id");
$ilDB->addIndex("cp_tree", $in_fields, "i2", false);

$in_fields = array("parent");
$ilDB->addIndex("cp_tree", $in_fields, "i3", false);


//
// cron_job
//
$fields = array (
	"job_id" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"component" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"schedule_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"schedule_value" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_status" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_status_user_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_status_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_status_ts" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_result_status" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_result_user_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_result_code" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"job_result_message" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"job_result_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_result_ts" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"class" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"path" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"running_ts" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"job_result_dur" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"alive_ts" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("cron_job", $fields);

$pk_fields = array("job_id");
$ilDB->addPrimaryKey("cron_job", $pk_fields);

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'exc_feedback_notification'), 'component' => array('text', 'Modules/Exercise'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', '1'), 'job_status_user_id' => array('integer', '0'), 'job_status_type' => array('integer', '0'), 'job_status_ts' => array('integer', '1381511097'), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilExcCronFeedbackNotification'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'frm_notification'), 'component' => array('text', 'Modules/Forum'), 'schedule_type' => array('integer', '3'), 'schedule_value' => array('integer', '1'), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilForumCronNotification'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'lm_link_check'), 'component' => array('text', 'Modules/LearningModule'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilLearningModuleCronLinkCheck'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'survey_notification'), 'component' => array('text', 'Modules/Survey'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', '1'), 'job_status_user_id' => array('integer', '0'), 'job_status_type' => array('integer', '0'), 'job_status_ts' => array('integer', '1381511099'), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilSurveyCronNotification'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'webr_link_check'), 'component' => array('text', 'Modules/WebResource'), 'schedule_type' => array('integer', '1'), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilWebResourceCronLinkCheck'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'cal_consultation'), 'component' => array('text', 'Services/Calendar'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilConsultationHourCron'), 'path' => array('text', 'Services/Calendar/classes/ConsultationHours/'), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'ldap_sync'), 'component' => array('text', 'Services/LDAP'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilLDAPCronSynchronization'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'mail_notification'), 'component' => array('text', 'Services/Mail'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilMailCronNotification'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'mail_address_sync'), 'component' => array('text', 'Services/Mail'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilMailCronAddressbookSync'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'mem_notification'), 'component' => array('text', 'Services/Membership'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilMembershipCronNotifications'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'pay_notification'), 'component' => array('text', 'Services/Payment'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilPaymentCronNotification'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'src_lucene_indexer'), 'component' => array('text', 'Services/Search'), 'schedule_type' => array('integer', '1'), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilLuceneIndexer'), 'path' => array('text', 'Services/Search/classes/Lucene/'), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'lp_object_statistics'), 'component' => array('text', 'Services/Tracking'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', '1'), 'job_status_user_id' => array('integer', '0'), 'job_status_type' => array('integer', '0'), 'job_status_ts' => array('integer', '1381511103'), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilLPCronObjectStatistics'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'user_inactive'), 'component' => array('text', 'Services/User'), 'schedule_type' => array('integer', '1'), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilCronDeleteInactiveUserAccounts'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'user_inactivated'), 'component' => array('text', 'Services/User'), 'schedule_type' => array('integer', '1'), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilCronDeleteInactivatedUserAccounts'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'user_check_accounts'), 'component' => array('text', 'Services/User'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilUserCronCheckAccounts'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));

$ilDB->insert("cron_job", array(
'job_id' => array('text', 'rep_disk_quota'), 'component' => array('text', 'Services/WebDAV'), 'schedule_type' => array('integer', ''), 'schedule_value' => array('integer', ''), 'job_status' => array('integer', ''), 'job_status_user_id' => array('integer', ''), 'job_status_type' => array('integer', ''), 'job_status_ts' => array('integer', ''), 'job_result_status' => array('integer', ''), 'job_result_user_id' => array('integer', ''), 'job_result_code' => array('text', ''), 'job_result_message' => array('text', ''), 'job_result_type' => array('integer', ''), 'job_result_ts' => array('integer', ''), 'class' => array('text', 'ilDAVCronDiskQuota'), 'path' => array('text', ''), 'running_ts' => array('integer', ''), 'job_result_dur' => array('integer', ''), 'alive_ts' => array('integer', '')));


//
// crs_archives
//
$fields = array (
	"archive_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"course_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"archive_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"archive_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"archive_date" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"archive_size" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"archive_lang" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("crs_archives", $fields);

$pk_fields = array("archive_id");
$ilDB->addPrimaryKey("crs_archives", $pk_fields);

$ilDB->createSequence("crs_archives", 1);


//
// crs_f_definitions
//
$fields = array (
	"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"field_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_values" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"field_required" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_values_opt" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("crs_f_definitions", $fields);

$pk_fields = array("field_id");
$ilDB->addPrimaryKey("crs_f_definitions", $pk_fields);

$ilDB->createSequence("crs_f_definitions", 1);


//
// crs_file
//
$fields = array (
	"file_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"course_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"file_name" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"file_type" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"file_size" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_file", $fields);

$pk_fields = array("file_id");
$ilDB->addPrimaryKey("crs_file", $pk_fields);

$ilDB->createSequence("crs_file", 1);


//
// crs_groupings
//
$fields = array (
	"crs_grp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"crs_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"crs_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"unique_field" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("crs_groupings", $fields);

$pk_fields = array("crs_grp_id");
$ilDB->addPrimaryKey("crs_groupings", $pk_fields);

$in_fields = array("crs_id");
$ilDB->addIndex("crs_groupings", $in_fields, "i1", false);


//
// crs_items
//
$fields = array (
	"parent_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"timing_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"timing_start" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"timing_end" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"suggestion_start" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"suggestion_end" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"changeable" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"earliest_start" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"latest_end" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"visible" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"position" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_items", $fields);

$pk_fields = array("parent_id","obj_id");
$ilDB->addPrimaryKey("crs_items", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("crs_items", $in_fields, "ob", false);


//
// crs_lm_history
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"crs_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lm_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lm_page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_access" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_lm_history", $fields);

$pk_fields = array("usr_id","crs_ref_id","lm_ref_id");
$ilDB->addPrimaryKey("crs_lm_history", $pk_fields);


//
// crs_objective_lm
//
$fields = array (
	"lm_ass_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"position" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_objective_lm", $fields);

$pk_fields = array("lm_ass_id");
$ilDB->addPrimaryKey("crs_objective_lm", $pk_fields);

$ilDB->createSequence("crs_objective_lm", 1);


//
// crs_objective_qst
//
$fields = array (
	"qst_ass_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_objective_qst", $fields);

$pk_fields = array("qst_ass_id");
$ilDB->addPrimaryKey("crs_objective_qst", $pk_fields);

$ilDB->createSequence("crs_objective_qst", 1);


//
// crs_objective_status
//
$fields = array (
	"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_objective_status", $fields);

$pk_fields = array("objective_id","user_id");
$ilDB->addPrimaryKey("crs_objective_status", $pk_fields);


//
// crs_objective_status_p
//
$fields = array (
	"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_objective_status_p", $fields);

$pk_fields = array("objective_id","user_id");
$ilDB->addPrimaryKey("crs_objective_status_p", $pk_fields);


//
// crs_objective_tst
//
$fields = array (
	"test_objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tst_status" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"tst_limit" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"tst_limit_p" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_objective_tst", $fields);

$pk_fields = array("test_objective_id");
$ilDB->addPrimaryKey("crs_objective_tst", $pk_fields);

$ilDB->createSequence("crs_objective_tst", 1);


//
// crs_objectives
//
$fields = array (
	"crs_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 70
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 500
		,"fixed" => false
		,"type" => "text"
	)
	,"position" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"passes" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_objectives", $fields);

$pk_fields = array("objective_id");
$ilDB->addPrimaryKey("crs_objectives", $pk_fields);

$in_fields = array("crs_id");
$ilDB->addIndex("crs_objectives", $in_fields, "i1", false);

$ilDB->createSequence("crs_objectives", 1);


//
// crs_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"syllabus" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_responsibility" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_phone" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_email" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_consultation" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"activation_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"activation_start" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"activation_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sub_limitation_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_start" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sub_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sub_password" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_mem_limit" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_max_members" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sub_notify" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"view_mode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sortorder" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"archive_start" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"archive_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"archive_type" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"abo" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"waiting_list" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"important" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"show_members" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"latitude" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"longitude" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"location_zoom" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"enable_course_map" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"session_limit" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"session_prev" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "-1"
		,"type" => "integer"
	)
	,"session_next" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "-1"
		,"type" => "integer"
	)
	,"reg_ac_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"reg_ac" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"status_dt" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "2"
		,"type" => "integer"
	)
	,"auto_notification" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"mail_members_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("crs_settings", $pk_fields);


//
// crs_start
//
$fields = array (
	"crs_start_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"crs_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_start", $fields);

$pk_fields = array("crs_start_id");
$ilDB->addPrimaryKey("crs_start", $pk_fields);

$in_fields = array("crs_id");
$ilDB->addIndex("crs_start", $in_fields, "i1", false);

$ilDB->createSequence("crs_start", 1);


//
// crs_timings_planed
//
$fields = array (
	"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"planed_start" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"planed_end" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_timings_planed", $fields);

$pk_fields = array("item_id","usr_id");
$ilDB->addPrimaryKey("crs_timings_planed", $pk_fields);


//
// crs_timings_usr_accept
//
$fields = array (
	"crs_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"accept" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"remark" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"visible" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_timings_usr_accept", $fields);

$pk_fields = array("crs_id","usr_id");
$ilDB->addPrimaryKey("crs_timings_usr_accept", $pk_fields);


//
// crs_user_data
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("crs_user_data", $fields);

$pk_fields = array("usr_id","field_id");
$ilDB->addPrimaryKey("crs_user_data", $pk_fields);


//
// crs_waiting_list
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("crs_waiting_list", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("crs_waiting_list", $pk_fields);


//
// ctrl_calls
//
$fields = array (
	"parent" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"child" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"comp_prefix" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ctrl_calls", $fields);

$in_fields = array("parent");
$ilDB->addIndex("ctrl_calls", $in_fields, "i1", false);

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilobjuserfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilobjusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilcontainerlinklistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilcontainerpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilportfoliopagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomadmingui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomadmingui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomadmingui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomadmingui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomadmingui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjchatroomgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilinccoursegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilinccoursegui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilinccoursegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilinccoursegui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilinccoursegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilinccoursegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilinccoursegui'), 'child' => array('text', 'ilobjilincclassroomgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjilincclassroomgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexerciseverificationgui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilcertificategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexercisegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilexassignmentgui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexerciseadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilexercisehandlergui'), 'child' => array('text', 'ilobjexercisegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilsessionoverviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilobjectservicesettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilmemberexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilmemberagreementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilobjectcustomuserfieldsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilcontainerpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilcoursecontentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilobjcoursegroupinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupgui'), 'child' => array('text', 'ilgroupregistrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjgroupadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotewikigui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotewikigui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotewikigui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarypresentationgui'), 'child' => array('text', 'ilpresentationlisttablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarypresentationgui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarypresentationgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarypresentationgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilobjtaxonomygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjglossarygui'), 'child' => array('text', 'ilglossarytermgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarydefpagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarydefpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarydefpagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarydefpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarydefpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarydefpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarydefpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpresentationlisttablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarytermgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarytermgui'), 'child' => array('text', 'ilglossarydefpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossarytermgui'), 'child' => array('text', 'iltermdefinitioneditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltermdefinitioneditorgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltermdefinitioneditorgui'), 'child' => array('text', 'ilglossarydefpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilglossaryeditorgui'), 'child' => array('text', 'ilobjglossarygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjitemgroupgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjitemgroupgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjitemgroupgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilassquestionfeedbackeditinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilquestioneditgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004chaptergui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004chaptergui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagenodegui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004pagenodegui'), 'child' => array('text', 'ilscorm2004pagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004seqchaptergui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004seqchaptergui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm13player'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004assetgui'), 'child' => array('text', 'ilscorm2004pagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004assetgui'), 'child' => array('text', 'ilpcquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004assetgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004assetgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004scogui'), 'child' => array('text', 'ilscorm2004pagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004scogui'), 'child' => array('text', 'ilpcquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004scogui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilscorm2004scogui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004trackingitemstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004trackingitemsperuserfiltergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004trackingitemsperscofiltergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'illicensegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004assetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilcertificategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004scogui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004pagenodegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004seqchaptergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilscorm2004chaptergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscorm2004learningmodulegui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursereferencegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursereferencegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpollgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpollgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpollgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpollgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpollgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpollgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilforummoderatorsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilforumexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjforumadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilforummoderatorsgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsessiongui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsessiongui'), 'child' => array('text', 'ilmembershipgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsessiongui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsessiongui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsessiongui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsessiongui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsessiongui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsystemfoldergui'), 'child' => array('text', 'ilcronmanagergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsystemfoldergui'), 'child' => array('text', 'ilobjectownershipmanagementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsystemfoldergui'), 'child' => array('text', 'ilimprintgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsystemfoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotefilegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotefilegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotefilegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyskillgui'), 'child' => array('text', 'ilsurveyskillthresholdsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyconstraintsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyskillthresholdsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyadministrationgui'), 'child' => array('text', 'ilsettingstemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyskilldeterminationgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilsurveyparticipantsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilsurveyconstraintsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilsurveyeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilsurveyskillgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilsurveyskilldeterminationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilsurveyexecutiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveygui'), 'child' => array('text', 'ilsurveyevaluationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyparticipantsgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveypagegui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyeditorgui'), 'child' => array('text', 'ilsurveypagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyeditorgui'), 'child' => array('text', 'surveymatrixquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyeditorgui'), 'child' => array('text', 'surveytextquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyeditorgui'), 'child' => array('text', 'surveysinglechoicequestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyeditorgui'), 'child' => array('text', 'surveymetricquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsurveyeditorgui'), 'child' => array('text', 'surveymultiplechoicequestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assformulaquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assorderinghorizontalgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'asserrortextgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'asstextquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'asssinglechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'asstextsubsetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assnumericgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assjavaappletgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assimagemapquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assorderingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'asskprimchoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assmatchingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assclozetestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestioneditgui'), 'child' => array('text', 'assmultiplechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionfeedbackeditinggui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionfeedbackeditinggui'), 'child' => array('text', 'ilassspecfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionfeedbackeditinggui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintsgui'), 'child' => array('text', 'ilconfirmationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintsgui'), 'child' => array('text', 'iltoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintsgui'), 'child' => array('text', 'ilasshintpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintsgui'), 'child' => array('text', 'ilassquestionhintstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintsgui'), 'child' => array('text', 'ilassquestionhintgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolsettingsgeneralgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assquestiongui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassspecfeedbackpagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassspecfeedbackpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassspecfeedbackpagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassspecfeedbackpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassspecfeedbackpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassspecfeedbackpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassspecfeedbackpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassgenfeedbackpagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassgenfeedbackpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassgenfeedbackpagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassgenfeedbackpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassgenfeedbackpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassgenfeedbackpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassgenfeedbackpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpreviewgui'), 'child' => array('text', 'ilassspecfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpreviewgui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpreviewgui'), 'child' => array('text', 'ilassquestionhintrequestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpreviewgui'), 'child' => array('text', 'ilassquestionrelatednavigationbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpreviewgui'), 'child' => array('text', 'ilassquestionpreviewtoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilquestionbrowsertablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'asskprimchoicegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintrequestgui'), 'child' => array('text', 'ilasshintpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintrequestgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintrequestgui'), 'child' => array('text', 'ilconfirmationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintrequestgui'), 'child' => array('text', 'ilassquestionhintstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilasshintpagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilasshintpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilasshintpagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilasshintpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilasshintpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilasshintpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilasshintpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assfileuploadgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'asserrortextgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assflashquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'asskprimchoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilassquestionpreviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assformulaquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilobjquestionpoolsettingsgeneralgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'illocalunitconfigurationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilassquestionfeedbackeditinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilassquestionhintsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilobjtaxonomygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilquestionpoolexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'asstextquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'asssinglechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'asstextsubsetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assnumericgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assjavaappletgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assimagemapquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assorderingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assmatchingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assclozetestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assmultiplechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'iltoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilquestionbrowsertablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjquestionpoolgui'), 'child' => array('text', 'assorderinghorizontalgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilassquestionhintgui'), 'child' => array('text', 'ilasshintpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotegroupgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotegroupgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotegroupgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilorgunitstaffgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilorgunittypegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilorgunitsimpleuserimportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilorgunitsimpleimportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilextidgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilorgunitstaffgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilorgunitexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'illocalusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'iltranslationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ildidactictemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilusertablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilobjuserfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilobjusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilcontainerlinklistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjorgunitgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotecategorygui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotecategorygui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotecategorygui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategoryreferencegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategoryreferencegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudplugininfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudpluginheaderactiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudplugininitgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudpluginfiletreegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudpluginitemcreationlistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudpluginactionlistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudplugindeletegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudpluginsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudplugincreatefoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcloudpluginuploadgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcloudgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotecoursegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotecoursegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotecoursegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilwikistatgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikipagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikisettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilwikistatgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilwikipagetemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilwikipagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwikigui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilwikihandlergui'), 'child' => array('text', 'ilobjwikigui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilbookmarkblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdnewsblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilnewsforcontextblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilusersonlineblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdselecteditemsblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilexternalfeedblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ildummyblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdtaggingblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdexternalfeedblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdnotesblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdsysmessageblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdmailblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilclassificationblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpdcalendarblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilcalendarblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilchatroomblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilpollblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcolumngui'), 'child' => array('text', 'ilwikiadvmetadatablockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ildidactictemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilcontainerpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilcoursecontentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjblogadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilportfoliopagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbloggui'), 'child' => array('text', 'ilblogpostinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilblogpostinggui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilblogpostinggui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilblogpostinggui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilblogpostinggui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilblogpostinggui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilblogpostinggui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilblogpostinggui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbookingpoolgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbookingpoolgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbookingpoolgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbookingpoolgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbookingpoolgui'), 'child' => array('text', 'ilbookingschedulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbookingpoolgui'), 'child' => array('text', 'ilbookingobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbookingpoolgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilbookingschedulegui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilobjecttranslationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilcontainerlinklistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilcontainerpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrootfoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexternalfeedgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexternalfeedgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexternalfeedgui'), 'child' => array('text', 'ilexternalfeedblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilexternalfeedhandlergui'), 'child' => array('text', 'ilobjexternalfeedgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmeditorgui'), 'child' => array('text', 'ilobjlearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmeditorgui'), 'child' => array('text', 'ilobjdlbookgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilpagemultilanggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilassquestionfeedbackeditinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilquestioneditgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilnewsitemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'illmpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'ilglossarydefpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpresentationgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpageobjectgui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illmpageobjectgui'), 'child' => array('text', 'illmpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilstructureobjectgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilstructureobjectgui'), 'child' => array('text', 'ilconditionhandlergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'ilstructureobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdlbookgui'), 'child' => array('text', 'illmpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningresourcessettingsgui'), 'child' => array('text', 'illicenseoverviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningresourcessettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilobjecttranslationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilpagemultilanggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'ilstructureobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlearningmodulegui'), 'child' => array('text', 'illmpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcoursecontentgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcoursecontentgui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcoursecontentgui'), 'child' => array('text', 'ilcoursearchivesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcourseparticipantsgroupsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcoursearchivesgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcourseverificationgui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoeditorgui'), 'child' => array('text', 'illopagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoeditorgui'), 'child' => array('text', 'ilconditionhandlergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoeditorgui'), 'child' => array('text', 'ilcontainerstartobjectsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoeditorgui'), 'child' => array('text', 'ilcourseobjectivesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'illopagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcontainerstartobjectspagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcontainerstartobjectsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilobjectservicesettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcertificategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ildidactictemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcourseparticipantsgroupsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'illicenseoverviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcontainerpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilsessionoverviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilmemberagreementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilobjectcustomuserfieldsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilmemberexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcoursecontentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilconditionhandlergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilobjcoursegroupinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcourseobjectivesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'ilcourseregistrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcoursegui'), 'child' => array('text', 'illoeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ilpagemultilanggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illopagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcourseregistrationgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcourseadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilscormtrackingitemstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilscormtrackingitemsperuserfiltergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilscormtrackingitemsperscofiltergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilscormofflinemodeuserstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'illicensegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilcertificategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormlearningmodulegui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilobjscorm2004learningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilobjscormlearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilscormofflinemodegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilscorm13player'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilhacppresentationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilaiccpresentationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahspresentationgui'), 'child' => array('text', 'ilscormpresentationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjhacplearningmodulegui'), 'child' => array('text', 'illicensegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjhacplearningmodulegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjhacplearningmodulegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjhacplearningmodulegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjhacplearningmodulegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjhacplearningmodulegui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahseditgui'), 'child' => array('text', 'ilobjscorm2004learningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahseditgui'), 'child' => array('text', 'ilobjhacplearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahseditgui'), 'child' => array('text', 'ilobjaicclearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsahseditgui'), 'child' => array('text', 'ilobjscormlearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsahslearningmodulegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsahslearningmodulegui'), 'child' => array('text', 'illicensegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsahslearningmodulegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsahslearningmodulegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsahslearningmodulegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsahslearningmodulegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsahslearningmodulegui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjscormverificationgui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjaicclearningmodulegui'), 'child' => array('text', 'illicensegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjaicclearningmodulegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjaicclearningmodulegui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjaicclearningmodulegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjaicclearningmodulegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjaicclearningmodulegui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjworkspacerootfoldergui'), 'child' => array('text', 'ilobjectownershipmanagementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjworkspacerootfoldergui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmediacasthandlergui'), 'child' => array('text', 'ilobjmediacastgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediacastgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediacastgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediacastgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediacastgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediacastsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'illicensegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfilebasedlmgui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilhtlmeditorgui'), 'child' => array('text', 'ilobjfilebasedlmgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilhtlmpresentationgui'), 'child' => array('text', 'ilobjfilebasedlmgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestevaluationgui'), 'child' => array('text', 'iltestpassdeletionconfirmationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestevaluationgui'), 'child' => array('text', 'iltestresultstoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestevaluationgui'), 'child' => array('text', 'iltestpassdetailsoverviewtablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerfixedquestionsetgui'), 'child' => array('text', 'iltestpasswordprotectiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerfixedquestionsetgui'), 'child' => array('text', 'iltestsubmissionreviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerfixedquestionsetgui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerfixedquestionsetgui'), 'child' => array('text', 'iltestsignaturegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerfixedquestionsetgui'), 'child' => array('text', 'ilassquestionhintrequestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerfixedquestionsetgui'), 'child' => array('text', 'ilassspecfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerfixedquestionsetgui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestskilladministrationgui'), 'child' => array('text', 'iltestskilllevelthresholdsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestskilladministrationgui'), 'child' => array('text', 'iltestskillquestionassignmentsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestpasswordprotectiongui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestdynamicquestionsetconfiggui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestsubmissionreviewgui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestskillquestionassignmentsgui'), 'child' => array('text', 'ilskillselectorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestskillquestionassignmentsgui'), 'child' => array('text', 'iltestskillquestionassignmentstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'iltestpasswordprotectiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'iltestsubmissionreviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'iltoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'iltestdynamicquestionsetstatistictablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'ilassquestionhintrequestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'ilassspecfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerdynamicquestionsetgui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'asskprimchoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilassquestionpreviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestskillevaluationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestskilladministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestsettingschangeconfirmationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestresultstoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestpassdetailsoverviewtablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assformulaquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'illocalunitconfigurationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilassquestionfeedbackeditinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilassquestionhintsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestrandomquestionsetconfiggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilobjtestdynamicquestionsetconfiggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilobjtestsettingsscoringresultsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilobjtestsettingsgeneralgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilobjquestionpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assflashquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'asstextquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assfileuploadgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'asssinglechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltesttoplistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assorderinghorizontalgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'asstextsubsetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestscoringbyquestionsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'asserrortextgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assnumericgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assjavaappletgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assimagemapquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assorderingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assmatchingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assclozetestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'assmultiplechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestscoringgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilassspecfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestevaluationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilmarkschemagui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestplayerdynamicquestionsetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestplayerrandomquestionsetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestplayerfixedquestionsetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilcertificategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilobjcoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'ilscoringadjustmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestgui'), 'child' => array('text', 'iltestservicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestskilllevelthresholdsgui'), 'child' => array('text', 'iltestskilllevelthresholdstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjassessmentfoldergui'), 'child' => array('text', 'ilglobalunitconfigurationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjassessmentfoldergui'), 'child' => array('text', 'ilsettingstemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjassessmentfoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestrandomquestionsetconfiggui'), 'child' => array('text', 'iltestrandomquestionsetpooldefinitionformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestrandomquestionsetconfiggui'), 'child' => array('text', 'iltestrandomquestionsetsourcepooldefinitionlisttablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestrandomquestionsetconfiggui'), 'child' => array('text', 'iltestrandomquestionsetsourcepooldefinitionlisttoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestrandomquestionsetconfiggui'), 'child' => array('text', 'iltestrandomquestionsetgeneralconfigformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestdynamicquestionsetstatistictablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestpassdetailsoverviewtablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerrandomquestionsetgui'), 'child' => array('text', 'iltestpasswordprotectiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerrandomquestionsetgui'), 'child' => array('text', 'iltestsubmissionreviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerrandomquestionsetgui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerrandomquestionsetgui'), 'child' => array('text', 'iltestsignaturegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerrandomquestionsetgui'), 'child' => array('text', 'ilassquestionhintrequestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerrandomquestionsetgui'), 'child' => array('text', 'ilassspecfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestplayerrandomquestionsetgui'), 'child' => array('text', 'ilassgenfeedbackpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assformulaquestiongui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'asstextquestiongui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'asssinglechoicegui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'asstextsubsetgui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assnumericgui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assjavaappletgui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assimagemapquestiongui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assorderingquestiongui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assmatchingquestiongui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assclozetestgui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'assmultiplechoicegui'), 'child' => array('text', 'iltestexpresspageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ilobjquestionpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ilassquestionpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assformulaquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'asstextquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'asssinglechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'asstextsubsetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assnumericgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assjavaappletgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assimagemapquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assorderingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assmatchingquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assclozetestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexpresspageobjectgui'), 'child' => array('text', 'assmultiplechoicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestsettingsscoringresultsgui'), 'child' => array('text', 'ilconfirmationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestsettingsscoringresultsgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestverificationgui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestsettingsgeneralgui'), 'child' => array('text', 'iltestsettingschangeconfirmationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestsettingsgeneralgui'), 'child' => array('text', 'ilconfirmationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtestsettingsgeneralgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestexportgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestskillevaluationgui'), 'child' => array('text', 'iltestpersonalskillsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestskillevaluationgui'), 'child' => array('text', 'iltestskillevaluationtoolbargui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestrandomquestionsetgeneralconfigformgui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltestrandomquestionsetpooldefinitionformgui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'ilsurveyphrasesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'surveymatrixquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'surveytextquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'surveysinglechoicequestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'surveymetricquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsurveyquestionpoolgui'), 'child' => array('text', 'surveymultiplechoicequestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliotemplatepagegui'), 'child' => array('text', 'ilconsultationhoursgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliotemplatepagegui'), 'child' => array('text', 'ilcalendarmonthgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliotemplatepagegui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliotemplatepagegui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliotemplatepagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliotemplatepagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliogui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliogui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliogui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliogui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliogui'), 'child' => array('text', 'ilportfoliopagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ilconsultationhoursgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ilcalendarmonthgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ilblogpostinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ilobjbloggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliopagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjmediaobjectssettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremotetestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjfileaccesssettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjbibliographicgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjbibliographicadmingui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjtaxonomyadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjexerciseadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjgroupadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcourseadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjwebresourceadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjrepositorysettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcloudgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjecssettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremotegroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremotefilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremoteglossarygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremotelearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremotewikigui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremotecategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjdatacollectiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjpollgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjbloggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjremotecoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcoursereferencegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcategoryreferencegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsurveyadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcalendarsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcomponentsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjmdsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjlanguageextgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjpersonaldesktopsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjnewssettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjprivacysecuritygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjadvancededitinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjusertrackinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjexternaltoolssettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjassessmentfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjstylesettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsearchsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjrecoveryfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjpaymentsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjobjectfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjmailgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjlanguagefoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjchatservergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjauthsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjrolefoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsystemfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjportfoliotemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsessiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjrootfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjroletemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjlinkresourcegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjilincclassroomgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjilinccoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjuserfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjrolegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjfilebasedlmgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjmediapoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjexercisegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsurveygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjtestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsurveyquestionpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjquestionpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjglossarygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjdlbookgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjlearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjforumgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjchatroomgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsahslearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilcourseobjectivesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjfilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjtaggingsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjsystemcheckgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjhelpsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjaccessibilitysettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjtermsofservicegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjcertificatesettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjnotificationadmingui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjobjecttemplateadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjskillmanagementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjchatroomadmingui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjitemgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjforumadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjorgunitgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjwikisettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjwikigui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjblogadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjbookingpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjexternalfeedgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjlearningresourcessettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjmediacastgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjmediacastsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladministrationgui'), 'child' => array('text', 'ilobjportfolioadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfolioadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilportfoliorepositorygui'), 'child' => array('text', 'ilobjportfoliogui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjportfoliotemplategui'), 'child' => array('text', 'ilportfoliotemplatepagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectionrecordviewgui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectionrecordviewgui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectiontreepickinputgui'), 'child' => array('text', 'ildatacollectionrecordeditgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilobjusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionrecordlistviewdefinitiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilobjfilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionfieldlistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectiontableeditgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionrecordviewviewdefinitiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionrecordviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionrecordeditviewdefinitiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionrecordlistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectiontreepickinputgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionrecordeditgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ildatacollectionfieldeditgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjdatacollectiongui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectionrecordviewviewdefinitiongui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectionrecordviewviewdefinitiongui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectionrecordviewviewdefinitiongui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectionrecordviewviewdefinitiongui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ildatacollectionrecordviewviewdefinitiongui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illinkresourcehandlergui'), 'child' => array('text', 'ilobjlinkresourcegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilworkspaceaccessgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlinkresourcegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjwebresourceadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremoteglossarygui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremoteglossarygui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremoteglossarygui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotetestgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotetestgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotetestgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicdetailsgui'), 'child' => array('text', 'ilbibliographicgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjportfoliotemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjcloudgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremotetestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremotegroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremotefilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremoteglossarygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremotelearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremotewikigui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremotecategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjpollgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjdatacollectiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjcategoryreferencegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjcoursereferencegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjsessiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjremotecoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjrootfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjlinkresourcegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjilincclassroomgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjilinccoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjbloggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjrolegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjfilebasedlmgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjmediapoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjexercisegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjsurveygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjtestgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjsurveyquestionpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjquestionpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjglossarygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjdlbookgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjlearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjforumgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjchatroomgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjsahslearningmodulegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilcourseobjectivesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjcoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjfilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjchatroomadmingui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjitemgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjwikigui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjbookingpoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjexternalfeedgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjmediacastgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrepositorygui'), 'child' => array('text', 'ilobjbibliographicgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ildatabibliographicrecordlisttablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilbibliographicdetailsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilobjusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicadminlibrariesformgui'), 'child' => array('text', 'ilobjbibliographicadmingui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicadmingui'), 'child' => array('text', 'ilobjbibliographicadminattributeordergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicadmingui'), 'child' => array('text', 'ilobjbibliographicadminlibrariesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjbibliographicadmingui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotelearningmodulegui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotelearningmodulegui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjremotelearningmodulegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjworkspacefoldergui'), 'child' => array('text', 'ilobjectownershipmanagementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjworkspacefoldergui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilobjstylesheetgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilobjecttranslationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilusertablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ildidactictemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcategorygui'), 'child' => array('text', 'ilobjtaxonomygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmediapoolpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmediapoolpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmediapoolpagegui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmediapoolpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmediapoolpresentationgui'), 'child' => array('text', 'ilobjmediapoolgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilobjmediaobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilobjfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilinfoscreengui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilmediapoolpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediapoolgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarusersettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcalendarsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarinboxgui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarcategorygui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarcategorygui'), 'child' => array('text', 'ilcalendarselectionblockgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendardaygui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarblockgui'), 'child' => array('text', 'ilcalendardaygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarblockgui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarblockgui'), 'child' => array('text', 'ilcalendarmonthgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarblockgui'), 'child' => array('text', 'ilcalendarweekgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarblockgui'), 'child' => array('text', 'ilcalendarinboxgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarblockgui'), 'child' => array('text', 'ilconsultationhoursgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendarmonthgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendarusersettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendarcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendarweekgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendardaygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendarinboxgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilcalendarsubscriptiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarpresentationgui'), 'child' => array('text', 'ilconsultationhoursgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdcalendarblockgui'), 'child' => array('text', 'ilcalendardaygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdcalendarblockgui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdcalendarblockgui'), 'child' => array('text', 'ilcalendarmonthgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdcalendarblockgui'), 'child' => array('text', 'ilcalendarweekgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdcalendarblockgui'), 'child' => array('text', 'ilcalendarinboxgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdcalendarblockgui'), 'child' => array('text', 'ilconsultationhoursgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilconsultationhoursgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilconsultationhoursgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarweekgui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendarmonthgui'), 'child' => array('text', 'ilcalendarappointmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalskillsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilskillcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilbasicskilltemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilskillrootgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilskilltemplatereferencegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilskilltemplatecategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilskillprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjskillmanagementgui'), 'child' => array('text', 'ilbasicskillgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilskillselfevaluationgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilskillprofilegui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilbasicskillgui'), 'child' => array('text', 'ilcertificategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmdsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmdsettingsgui'), 'child' => array('text', 'iladvancedmdsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmdeditorgui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilaccountregistrationgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilregistrationcodestablegui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilregistrationsettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmemberagreementgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmemberexportgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilinfoscreengui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilinfoscreengui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilinfoscreengui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilinfoscreengui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilimprintgui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilimprintgui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilimprintgui'), 'child' => array('text', 'ilmediapooltargetselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilimprintgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilimprintgui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedmdsettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcomponentsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpcplaceholdergui'), 'child' => array('text', 'ilpcmediaobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpccontenttemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcparagraphgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpctablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpctabledatagui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcmediaobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpclistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpclistitemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcfilelistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcfileitemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilobjmediaobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcsourcecodegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcquestiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcsectiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcdatatablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcresourcesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcmapgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcpluggedgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpctabsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcplaceholdergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpccontentincludegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcloginpageelementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcinteractiveimagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcverificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcbloggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcquestionoverviewgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcskillsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcconsultationhoursgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcmycoursesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageeditorgui'), 'child' => array('text', 'ilpcamdpagelistgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpciimtriggereditorgui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpcmediaobjectgui'), 'child' => array('text', 'ilobjmediaobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpcmediaobjectgui'), 'child' => array('text', 'ilpcimagemapeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpcinteractiveimagegui'), 'child' => array('text', 'ilpciimtriggereditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpcimagemapeditorgui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilnewsitemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpageobjectgui'), 'child' => array('text', 'ilpagemultilanggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpcloginpageelementgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjobjecttemplateadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjobjecttemplateadministrationgui'), 'child' => array('text', 'ildidactictemplatesettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpermissiongui'), 'child' => array('text', 'ildidactictemplategui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpermissiongui'), 'child' => array('text', 'ilobjrolegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpermissiongui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpermissiongui'), 'child' => array('text', 'ilobjectpermissionstatusgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrolefoldergui'), 'child' => array('text', 'ildidactictemplatesettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrolefoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', '[yourclassname]'), 'child' => array('text', 'into your class header.".'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjadvancededitinggui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjroletemplategui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilconditionhandlergui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjectpermissionstatusgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrolegui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrolegui'), 'child' => array('text', 'ilexportgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilrbaclogtablegui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltruserobjectspropstablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illplistofobjectsgui'), 'child' => array('text', 'iluserfiltergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illplistofobjectsgui'), 'child' => array('text', 'iltruserobjectspropstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illplistofobjectsgui'), 'child' => array('text', 'iltrsummarytablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illplistofobjectsgui'), 'child' => array('text', 'iltrobjectuserspropstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illplistofobjectsgui'), 'child' => array('text', 'iltrmatrixtablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illplistofprogressgui'), 'child' => array('text', 'illpprogresstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltrsummarytablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illplistofsettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illpprogresstablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltrobjectuserspropstablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjusertrackinggui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjusertrackinggui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjusertrackinggui'), 'child' => array('text', 'illpobjectstatisticsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjusertrackinggui'), 'child' => array('text', 'ilsessionstatisticsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illearningprogressgui'), 'child' => array('text', 'illplistofobjectsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illearningprogressgui'), 'child' => array('text', 'illplistofsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illearningprogressgui'), 'child' => array('text', 'illplistofprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illearningprogressgui'), 'child' => array('text', 'illpobjectstatisticsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illpobjectstatisticsdailytablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illpobjectstatisticstablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illpobjectstatisticslptablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illpobjectstatisticsadmintablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illpobjectstatisticsgui'), 'child' => array('text', 'illpobjectstatisticstablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illpobjectstatisticstypestablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmailgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailformgui'), 'child' => array('text', 'ilmailfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailformgui'), 'child' => array('text', 'ilmailattachmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailformgui'), 'child' => array('text', 'ilmailsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailformgui'), 'child' => array('text', 'ilmailsearchcoursesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailformgui'), 'child' => array('text', 'ilmailsearchgroupsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailformgui'), 'child' => array('text', 'ilmailinglistsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailgui'), 'child' => array('text', 'ilmailfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailgui'), 'child' => array('text', 'ilmailformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailgui'), 'child' => array('text', 'ilmailaddressbookgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailgui'), 'child' => array('text', 'ilmailoptionsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailgui'), 'child' => array('text', 'ilmailattachmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailgui'), 'child' => array('text', 'ilmailsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailgui'), 'child' => array('text', 'ilobjusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailfoldergui'), 'child' => array('text', 'ilmailoptionsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailfoldergui'), 'child' => array('text', 'ilmailattachmentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailfoldergui'), 'child' => array('text', 'ilmailsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailfoldergui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjnotificationadmingui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilnotificationgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalprofilegui'), 'child' => array('text', 'ilnotificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalprofilegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilnotificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilobjlanguageextgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilpersonalprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilbookmarkadministrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilobjusergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilpdnotesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilpdnewsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilcalendarpresentationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilmailsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilmailaddressbookgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilpersonalworkspacegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilpersonalsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilportfoliorepositorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilpersonalskillsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonaldesktopgui'), 'child' => array('text', 'ilobjchatroomgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfileaccesssettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjfileaccesssettingsgui'), 'child' => array('text', 'ilfmsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtaxonomyadministrationgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtaxonomygui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilformpropertydispatchgui'), 'child' => array('text', 'iltaxselectinputgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilformpropertydispatchgui'), 'child' => array('text', 'ilrepositoryselectorinputgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilformpropertydispatchgui'), 'child' => array('text', 'illinkinputgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilformpropertydispatchgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlanguagefoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjlanguageextgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpagelayoutgui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpagelayoutgui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpagelayoutgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpagelayoutgui'), 'child' => array('text', 'ilpageobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjstylesettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjstylesettingsgui'), 'child' => array('text', 'ilpagelayoutgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjstylesheetgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjcertificatesettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtermsofservicegui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilusertablegui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcustomuserfieldsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalsettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjusergui'), 'child' => array('text', 'illearningprogressgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjusergui'), 'child' => array('text', 'ilobjectownershipmanagementgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilaccountcodestablegui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilaccountcodesgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjuserfoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjuserfoldergui'), 'child' => array('text', 'ilusertablegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjuserfoldergui'), 'child' => array('text', 'ilaccountcodesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjuserfoldergui'), 'child' => array('text', 'ilcustomuserfieldsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjuserfoldergui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpublicuserprofilegui'), 'child' => array('text', 'ilobjportfoliogui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'ilregistrationsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'illdapsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'ilradiussettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'ilauthshibbolethsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'ilopenidsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'ilcassettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjauthsettingsgui'), 'child' => array('text', 'ilauthloginpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilauthloginpageeditorgui'), 'child' => array('text', 'illoginpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoginpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoginpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoginpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoginpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoginpagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoginpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illoginpagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjaccessibilitysettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrepositorysettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjplugindispatchgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdnotesgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpropertyformgui'), 'child' => array('text', 'ilformpropertydispatchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illinkinputgui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ileditclipboardgui'), 'child' => array('text', 'ilobjmediaobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilnavigationhistorygui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcassettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailaddressbookgui'), 'child' => array('text', 'ilmailsearchcoursesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailaddressbookgui'), 'child' => array('text', 'ilmailsearchgroupsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailaddressbookgui'), 'child' => array('text', 'ilmailinglistsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilmailaddressbookgui'), 'child' => array('text', 'ilmailformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshopgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshopadvancedsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshopshoppingcartgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshopboughtobjectsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilpurchasebmfgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshoppersonalsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilpaymentgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilpaymentadmingui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshopinfogui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilpurchasebillgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshopnewsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'iltermsconditionsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshoppurchasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilshoplinkbuilder'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopcontroller'), 'child' => array('text', 'ilpaymentobjectselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpaymentstatisticgui'), 'child' => array('text', 'ilpaymentobjectselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpaymentsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpaymentsettingsgui'), 'child' => array('text', 'ilshoptopicsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpaymentsettingsgui'), 'child' => array('text', 'ilshoppagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpaymentsettingsgui'), 'child' => array('text', 'ilrepositorysearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpaymentsettingsgui'), 'child' => array('text', 'ilpaymentobjectselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopgui'), 'child' => array('text', 'ilshoppagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshopinfogui'), 'child' => array('text', 'ilshoppagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpaymentadmingui'), 'child' => array('text', 'ilpaymenttrusteegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpaymentadmingui'), 'child' => array('text', 'ilpaymentstatisticgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpaymentadmingui'), 'child' => array('text', 'ilpaymentobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpaymentadmingui'), 'child' => array('text', 'ilpaymentcoupongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpaymentadmingui'), 'child' => array('text', 'ilpaymentobjectselector'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpaymentobjectgui'), 'child' => array('text', 'ilshoppagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppurchasegui'), 'child' => array('text', 'ilshoppagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilshoppagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltermsconditionsgui'), 'child' => array('text', 'ilshoppagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjhelpsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilhelpgui'), 'child' => array('text', 'illmpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectsgui'), 'child' => array('text', 'ilcontainerstartobjectspagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerpagegui'), 'child' => array('text', 'ilpagemultilanggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ilpageeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ileditclipboardgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerstartobjectspagegui'), 'child' => array('text', 'ilpagemultilanggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcontainerlinklistgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illdapsettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilstartupgui'), 'child' => array('text', 'ilaccountregistrationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilstartupgui'), 'child' => array('text', 'ilpasswordassistancegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilstartupgui'), 'child' => array('text', 'illoginpagegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsystemcheckgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjtaggingsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjexternaltoolssettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjrecoveryfoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcalendargui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illicensegui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illicenseoverviewgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjobjectfoldergui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjectownershipmanagementgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjectactivationgui'), 'child' => array('text', 'ilconditionhandlergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjectservicesettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjectcopygui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcommonactiondispatchergui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcommonactiondispatchergui'), 'child' => array('text', 'iltagginggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcommonactiondispatchergui'), 'child' => array('text', 'ilobjectactivationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcommonactiondispatchergui'), 'child' => array('text', 'ilratinggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsharedresourcegui'), 'child' => array('text', 'ilobjbloggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsharedresourcegui'), 'child' => array('text', 'ilobjfilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsharedresourcegui'), 'child' => array('text', 'ilobjtestverificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsharedresourcegui'), 'child' => array('text', 'ilobjexerciseverificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsharedresourcegui'), 'child' => array('text', 'ilobjlinkresourcegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsharedresourcegui'), 'child' => array('text', 'ilobjportfoliogui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjworkspacerootfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjworkspacefoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjfilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjbloggui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjtestverificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjexerciseverificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjlinkresourcegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjcourseverificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpersonalworkspacegui'), 'child' => array('text', 'ilobjscormverificationgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilworkspaceaccessgui'), 'child' => array('text', 'ilmailsearchcoursesgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilworkspaceaccessgui'), 'child' => array('text', 'ilmailsearchgroupsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilworkspaceaccessgui'), 'child' => array('text', 'ilmailsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilworkspaceaccessgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilexportgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilecssettingsgui'), 'child' => array('text', 'ilecsmappingsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilecssettingsgui'), 'child' => array('text', 'ilecsparticipantsettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjecssettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjecssettingsgui'), 'child' => array('text', 'ilecssettingsgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilfmsettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilauthshibbolethsettingsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdselecteditemsblockgui'), 'child' => array('text', 'ilcommonactiondispatchergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilusersonlineblockgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjpersonaldesktopsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilaccordionpropertiesstorage'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilnotification'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpermanentlinkgui'), 'child' => array('text', 'ilnotegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpermanentlinkgui'), 'child' => array('text', 'ilcolumngui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpermanentlinkgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltabletemplatesstorage'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iltablepropertiesstorage'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediaobjectssettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilimagemapeditorgui'), 'child' => array('text', 'ilinternallinkgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediaobjectgui'), 'child' => array('text', 'ilmdeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediaobjectgui'), 'child' => array('text', 'ilimagemapeditorgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjmediaobjectgui'), 'child' => array('text', 'ilfilesystemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilpdnewsgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilnewsforcontextblockgui'), 'child' => array('text', 'ilnewsitemgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjnewssettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjprivacysecuritygui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilratinggui'), 'child' => array('text', 'ilratingcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilcronmanagergui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchcontroller'), 'child' => array('text', 'ilsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchcontroller'), 'child' => array('text', 'iladvancedsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchcontroller'), 'child' => array('text', 'illucenesearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchcontroller'), 'child' => array('text', 'illuceneadvancedsearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchcontroller'), 'child' => array('text', 'illuceneusersearchgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchcontroller'), 'child' => array('text', 'ilsearchbasegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilcontainergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilobjcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilobjcoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilobjfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilobjgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilobjrootfolderguigui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilsearchgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilobjsearchsettingsgui'), 'child' => array('text', 'ilpermissiongui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneusersearchgui'), 'child' => array('text', 'ilpublicuserprofilegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilcontainergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilobjcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilobjcoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilobjfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilobjgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilobjrootfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illuceneadvancedsearchgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilpropertyformgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilcontainergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilobjcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilobjcoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilobjfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilobjgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilobjrootfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'illucenesearchgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilobjectgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilcontainergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilobjcategorygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilobjcoursegui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilobjfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilobjgroupgui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilobjrootfoldergui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iladvancedsearchgui'), 'child' => array('text', 'ilobjectcopygui'), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'iluserfiltergui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));

$ilDB->insert("ctrl_calls", array(
'parent' => array('text', 'ilbookmarkadministrationgui'), 'child' => array('text', ''), 'comp_prefix' => array('text', '')));


//
// ctrl_classfile
//
$fields = array (
	"class" => array (
		"notnull" => true
		,"length" => 100
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"filename" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
	,"comp_prefix" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"plugin_path" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
	,"cid" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ctrl_classfile", $fields);

$pk_fields = array("class");
$ilDB->addPrimaryKey("ctrl_classfile", $pk_fields);

$in_fields = array("cid");
$ilDB->addIndex("ctrl_classfile", $in_fields, "i1", false);

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailinglistsgui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailingListsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailaddressbookgui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailAddressbookGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailsearchcoursesgui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailSearchCoursesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcassettingsgui'), 'filename' => array('text', 'Services/CAS/classes/class.ilCASSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnavigationhistorygui'), 'filename' => array('text', 'Services/Navigation/classes/class.ilNavigationHistoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilgooglemapgui'), 'filename' => array('text', 'Services/Maps/classes/class.ilGoogleMapGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmapgui'), 'filename' => array('text', 'Services/Maps/classes/class.ilMapGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilopenlayersmapgui'), 'filename' => array('text', 'Services/Maps/classes/class.ilOpenLayersMapGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilclipboardtablegui'), 'filename' => array('text', 'Services/Clipboard/classes/class.ilClipboardTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ileditclipboardgui'), 'filename' => array('text', 'Services/Clipboard/classes/class.ilEditClipboardGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilroleautocompleteinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilRoleAutoCompleteInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilflashfileinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilFlashFileInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatetimeinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilDateTimeInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilformpropertydispatchgui'), 'filename' => array('text', 'Services/Form/classes/class.ilFormPropertyDispatchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illocationinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilLocationInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilemailinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilEMailInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcolorpickerinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilColorPickerInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilalphabetinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilAlphabetInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilformsectionheadergui'), 'filename' => array('text', 'Services/Form/classes/class.ilFormSectionHeaderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhierarchyformgui'), 'filename' => array('text', 'Services/Form/classes/class.ilHierarchyFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnoneditablevaluegui'), 'filename' => array('text', 'Services/Form/classes/class.ilNonEditableValueGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnumberinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilNumberInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhiddeninputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilHiddenInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illinkinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilLinkInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilimagefileinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilImageFileInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpasswordinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilPasswordInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfilewizardinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilFileWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluserlogininputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilUserLoginInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatedurationinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilDateDurationInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltextwizardinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilTextWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcombinationinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilCombinationInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcheckboxinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilCheckboxInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfeedurlinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilFeedUrlInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfileinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilFileInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilformgui'), 'filename' => array('text', 'Services/Form/classes/class.ilFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvselectinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilAdvSelectInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '10')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilradiogroupinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilRadioGroupInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '11')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnestedlistinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilNestedListInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '12')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepositoryselectorinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilRepositorySelectorInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '13')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmultiselectinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilMultiSelectInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '14')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbirthdayinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilBirthdayInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '15')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltextinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilTextInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '16')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpropertyformgui'), 'filename' => array('text', 'Services/Form/classes/class.ilPropertyFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '17')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcountryselectinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilCountrySelectInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '18')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcssrectinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilCSSRectInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '19')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcheckboxgroupinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilCheckboxGroupInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilformpropertygui'), 'filename' => array('text', 'Services/Form/classes/class.ilFormPropertyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildragdropfileinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilDragDropFileInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilselectinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilSelectInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilformulainputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilFormulaInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilselectbuilderinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilSelectBuilderInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcustominputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilCustomInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsubenabledformpropertygui'), 'filename' => array('text', 'Services/Form/classes/class.ilSubEnabledFormPropertyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildurationinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilDurationInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltextareainputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilTextAreaInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilregexpinputgui'), 'filename' => array('text', 'Services/Form/classes/class.ilRegExpInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdnotesgui'), 'filename' => array('text', 'Services/Notes/classes/class.ilPDNotesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnotegui'), 'filename' => array('text', 'Services/Notes/classes/class.ilNoteGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdnotesblockgui'), 'filename' => array('text', 'Services/Notes/classes/class.ilPDNotesBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilopenidsettingsgui'), 'filename' => array('text', 'Services/OpenId/classes/class.ilOpenIdSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilopenidprovidertablegui'), 'filename' => array('text', 'Services/OpenId/classes/class.ilOpenIdProviderTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illinkcheckertablegui'), 'filename' => array('text', 'Services/LinkChecker/classes/class.ilLinkCheckerTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepdependenciestablegui'), 'filename' => array('text', 'Services/Repository/classes/class.ilRepDependenciesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectplugingui'), 'filename' => array('text', 'Services/Repository/classes/class.ilObjectPluginGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjplugindispatchgui'), 'filename' => array('text', 'Services/Repository/classes/class.ilObjPluginDispatchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepositoryexplorergui'), 'filename' => array('text', 'Services/Repository/classes/class.ilRepositoryExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilreputilgui'), 'filename' => array('text', 'Services/Repository/classes/class.ilRepUtilGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrashtablegui'), 'filename' => array('text', 'Services/Repository/classes/class.ilTrashTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladminsubitemstablegui'), 'filename' => array('text', 'Services/Repository/classes/class.ilAdminSubItemsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjrepositorysettingsgui'), 'filename' => array('text', 'Services/Repository/classes/class.ilObjRepositorySettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepositorygui'), 'filename' => array('text', 'Services/Repository/classes/class.ilRepositoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '1z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnewitemgrouptablegui'), 'filename' => array('text', 'Services/Repository/classes/class.ilNewItemGroupTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '20')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectpluginlistgui'), 'filename' => array('text', 'Services/Repository/classes/class.ilObjectPluginListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '21')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmodulestablegui'), 'filename' => array('text', 'Services/Repository/classes/class.ilModulesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '22')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepositoryselectorexplorergui'), 'filename' => array('text', 'Services/Repository/classes/class.ilRepositorySelectorExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '23')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjaccessibilitysettingsgui'), 'filename' => array('text', 'Services/Accessibility/classes/class.ilObjAccessibilitySettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '24')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccesskeygui'), 'filename' => array('text', 'Services/Accessibility/classes/class.ilAccessKeyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '25')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illoginpagegui'), 'filename' => array('text', 'Services/Authentication/classes/class.ilLoginPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '26')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccesskeytablegui'), 'filename' => array('text', 'Services/Accessibility/classes/class.ilAccessKeyTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '27')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilauthloginpageeditorgui'), 'filename' => array('text', 'Services/Authentication/classes/class.ilAuthLoginPageEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '28')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsessionremindergui'), 'filename' => array('text', 'Services/Authentication/classes/class.ilSessionReminderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '29')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilauthloginpageeditortablegui'), 'filename' => array('text', 'Services/Authentication/classes/class.ilAuthLoginPageEditorTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsessionstatisticsgui'), 'filename' => array('text', 'Services/Authentication/classes/class.ilSessionStatisticsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjauthsettingsgui'), 'filename' => array('text', 'Services/Authentication/classes/class.ilObjAuthSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpublicuserprofilegui'), 'filename' => array('text', 'Services/User/classes/class.ilPublicUserProfileGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpersonalprofilegui'), 'filename' => array('text', 'Services/User/classes/class.ilPersonalProfileGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilroleassignmenttablegui'), 'filename' => array('text', 'Services/User/classes/class.ilRoleAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjuserfoldergui'), 'filename' => array('text', 'Services/User/classes/class.ilObjUserFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccountcodesgui'), 'filename' => array('text', 'Services/User/classes/class.ilAccountCodesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccountcodestablegui'), 'filename' => array('text', 'Services/User/classes/class.ilAccountCodesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcustomuserfieldsettingstablegui'), 'filename' => array('text', 'Services/User/classes/class.ilCustomUserFieldSettingsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjusergui'), 'filename' => array('text', 'Services/User/classes/class.ilObjUserGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluserfieldsettingstablegui'), 'filename' => array('text', 'Services/User/classes/class.ilUserFieldSettingsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpersonalsettingsgui'), 'filename' => array('text', 'Services/User/classes/class.ilPersonalSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcustomuserfieldsgui'), 'filename' => array('text', 'Services/User/classes/class.ilCustomUserFieldsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilusertablegui'), 'filename' => array('text', 'Services/User/classes/class.ilUserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluserlptablegui'), 'filename' => array('text', 'Services/User/classes/class.ilUserLPTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermsofserviceacceptancehistorytablegui'), 'filename' => array('text', 'Services/TermsOfService/classes/class.ilTermsOfServiceAcceptanceHistoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermsofserviceagreementbylanguagetablegui'), 'filename' => array('text', 'Services/TermsOfService/classes/class.ilTermsOfServiceAgreementByLanguageTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtermsofservicegui'), 'filename' => array('text', 'Services/TermsOfService/classes/class.ilObjTermsOfServiceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermsofservicetablegui'), 'filename' => array('text', 'Services/TermsOfService/classes/class.ilTermsOfServiceTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermsofservicesigneddocumentformelementgui'), 'filename' => array('text', 'Services/TermsOfService/classes/form/class.ilTermsOfServiceSignedDocumentFormElementGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcertificatesettingsgui'), 'filename' => array('text', 'Services/Certificate/classes/class.ilObjCertificateSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcertificategui'), 'filename' => array('text', 'Services/Certificate/classes/class.ilCertificateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbackgroundimageinputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilBackgroundImageInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsysstylecatassignmenttablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilSysStyleCatAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilstyletablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilStyleTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '2z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrblborderstyleinputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilTRBLBorderStyleInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '30')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilstylemediaquerytablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilStyleMediaQueryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '31')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrblnumericstylevalueinputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilTRBLNumericStyleValueInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '32')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltabletemplatestablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilTableTemplatesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '33')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrblborderwidthinputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilTRBLBorderWidthInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '34')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjstylesheetgui'), 'filename' => array('text', 'Services/Style/classes/class.ilObjStyleSheetGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '35')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjstylesettingsgui'), 'filename' => array('text', 'Services/Style/classes/class.ilObjStyleSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '36')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpagelayouttablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilPageLayoutTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '37')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsystemstylestablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilSystemStylesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '38')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontentstylestablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilContentStylesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '39')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfontsizeinputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilFontSizeInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpastestylecharacteristictablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilPasteStyleCharacteristicTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilstylecolortablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilStyleColorTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnumericstylevalueinputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilNumericStyleValueInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpagelayoutgui'), 'filename' => array('text', 'Services/Style/classes/class.ilPageLayoutGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrblcolorpickerinputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilTRBLColorPickerInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilstyleimagetablegui'), 'filename' => array('text', 'Services/Style/classes/class.ilStyleImageTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlanguagegui'), 'filename' => array('text', 'Services/Language/classes/class.ilObjLanguageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbackgroundpositioninputgui'), 'filename' => array('text', 'Services/Style/classes/class.ilBackgroundPositionInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlanguageextgui'), 'filename' => array('text', 'Services/Language/classes/class.ilObjLanguageExtGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illanguageexttablegui'), 'filename' => array('text', 'Services/Language/classes/class.ilLanguageExtTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illanguagetablegui'), 'filename' => array('text', 'Services/Language/classes/class.ilLanguageTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlanguagefoldergui'), 'filename' => array('text', 'Services/Language/classes/class.ilObjLanguageFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxassigneditemstablegui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxAssignedItemsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxonomylisttablegui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxonomyListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxselectinputgui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxSelectInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxmdgui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxMDGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxonomyadministrationrepositorytablegui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxonomyAdministrationRepositoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxonomytablegui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxonomyTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxassigninputgui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxAssignInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtaxonomygui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilObjTaxonomyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtaxonomyadministrationgui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilObjTaxonomyAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltaxonomyexplorergui'), 'filename' => array('text', 'Services/Taxonomy/classes/class.ilTaxonomyExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhistorytablegui'), 'filename' => array('text', 'Services/History/classes/class.ilHistoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjfileaccesssettingsgui'), 'filename' => array('text', 'Services/WebDAV/classes/class.ilObjFileAccessSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnotificationgui'), 'filename' => array('text', 'Services/Notifications/classes/class.ilNotificationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '3z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjnotificationadmingui'), 'filename' => array('text', 'Services/Notifications/classes/class.ilObjNotificationAdminGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '40')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailfoldergui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '41')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdsysmessageblockgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilPDSysMessageBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '42')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailformplaceholderspropertygui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailFormPlaceholdersPropertyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '43')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '44')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdmailgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilPDMailGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '45')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailformgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '46')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailquickfilterinputgui'), 'filename' => array('text', 'Services/Mail/classes/Form/class.ilMailQuickFilterInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '47')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmailgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilObjMailGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '48')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailattachmenttablegui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailAttachmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '49')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailoptionsgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailOptionsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailfoldertablegui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailFolderTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdmailblockgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilPDMailBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailattachmentgui'), 'filename' => array('text', 'Services/Mail/classes/class.ilMailAttachmentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpobjectstatisticstypestablegui'), 'filename' => array('text', 'Services/Tracking/classes/object_statistics/class.ilLPObjectStatisticsTypesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpobjectstatisticsgui'), 'filename' => array('text', 'Services/Tracking/classes/object_statistics/class.ilLPObjectStatisticsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpobjectstatisticsadmintablegui'), 'filename' => array('text', 'Services/Tracking/classes/object_statistics/class.ilLPObjectStatisticsAdminTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpobjectstatisticslptablegui'), 'filename' => array('text', 'Services/Tracking/classes/object_statistics/class.ilLPObjectStatisticsLPTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpobjectstatisticstablegui'), 'filename' => array('text', 'Services/Tracking/classes/object_statistics/class.ilLPObjectStatisticsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpobjectstatisticsdailytablegui'), 'filename' => array('text', 'Services/Tracking/classes/object_statistics/class.ilLPObjectStatisticsDailyTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illearningprogressgui'), 'filename' => array('text', 'Services/Tracking/classes/class.ilLearningProgressGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illptablebasegui'), 'filename' => array('text', 'Services/Tracking/classes/class.ilLPTableBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjusertrackinggui'), 'filename' => array('text', 'Services/Tracking/classes/class.ilObjUserTrackingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illearningprogressbasegui'), 'filename' => array('text', 'Services/Tracking/classes/class.ilLearningProgressBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpcollectionsettingstablegui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilLPCollectionSettingsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrobjectuserspropstablegui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilTrObjectUsersPropsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illpprogresstablegui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilLPProgressTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illplistofsettingsgui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilLPListOfSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrsummarytablegui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilTrSummaryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrmatrixtablegui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilTrMatrixTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illplistofprogressgui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilLPListOfProgressGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illplistofobjectsgui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilLPListOfObjectsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltruserobjectspropstablegui'), 'filename' => array('text', 'Services/Tracking/classes/repository_statistics/class.ilTrUserObjectsPropsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilroleadoptpermissiontablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilRoleAdoptPermissionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectroletemplateoptionstablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilObjectRoleTemplateOptionsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectrolepermissiontablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilObjectRolePermissionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '4z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilroletablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilRoleTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '50')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjrolefoldergui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilObjRoleFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '51')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrbaclogtablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilRbacLogTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '52')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjrolegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilObjRoleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '53')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccesspermissionsstatustablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilAccessPermissionsStatusTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '54')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectpermissionstatusgui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilObjectPermissionStatusGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '55')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectroletemplatepermissiontablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilObjectRoleTemplatePermissionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '56')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconditionhandlergui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilConditionHandlerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '57')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpermission2gui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilPermission2GUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '58')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassigneduserstablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilAssignedUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '59')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconditionhandlertablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilConditionHandlerTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpermissiongui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilPermissionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilroleselectiontablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilRoleSelectionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjroletemplategui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilObjRoleTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilavailablerolesstatustablegui'), 'filename' => array('text', 'Services/AccessControl/classes/class.ilAvailableRolesStatusTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilradiussettingsgui'), 'filename' => array('text', 'Services/Radius/classes/class.ilRadiusSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjadvancededitinggui'), 'filename' => array('text', 'Services/AdvancedEditing/classes/class.ilObjAdvancedEditingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', '[yourclassname]'), 'filename' => array('text', 'Services/UICore/classes/class.ilCtrl.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilclassificationblockgui'), 'filename' => array('text', 'Services/Classification/classes/class.ilClassificationBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildidactictemplatesettingsgui'), 'filename' => array('text', 'Services/DidacticTemplate/classes/class.ilDidacticTemplateSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildidactictemplatesettingstablegui'), 'filename' => array('text', 'Services/DidacticTemplate/classes/class.ilDidacticTemplateSettingsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildidactictemplategui'), 'filename' => array('text', 'Services/DidacticTemplate/classes/class.ilDidacticTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjobjecttemplateadministrationgui'), 'filename' => array('text', 'Services/DidacticTemplate/classes/class.ilObjObjectTemplateAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcquestionoverviewgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCQuestionOverviewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpoolselectorgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPoolSelectorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpagemultilanggui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPageMultiLangGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcloginpageelementgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCLoginPageElementGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfileselectorgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilFileSelectorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpciimoverlaystablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCIIMOverlaysTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcopyselfassquestiontablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilCopySelfAssQuestionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpclistitemgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCListItemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpageobjectgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPageObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpctabsgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCTabsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcimagemapeditorgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCImageMapEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpctabledatagui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCTableDataGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpctablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '5z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcimagemaptablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCImageMapTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '60')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcverificationgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCVerificationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '61')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcinteractiveimagegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCInteractiveImageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '62')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpciimpopuptablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCIIMPopupTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '63')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpagemultilangtablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPageMultiLangTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '64')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpagecomponentplugingui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPageComponentPluginGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '65')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpagehistorytablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPageHistoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '66')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcfilelistgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCFileListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '67')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcpluggedgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCPluggedGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '68')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcprofilegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCProfileGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '69')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpageeditorgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPageEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpciimtriggertablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCIIMTriggerTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcfileitemgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCFileItemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcsectiongui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCSectionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcquestiongui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcfilelisttablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCFileListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcskillsgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCSkillsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcsourcecodegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCSourceCodeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcmediaobjectgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCMediaObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpciimtriggereditorgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCIIMTriggerEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpagecontentgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPageContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpctabstablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCTabsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcresourcesgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCResourcesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpclistgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpccontenttemplategui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCContentTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcplaceholdergui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCPlaceHolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcmapgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCMapGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcbloggui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCBlogGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcdatatablegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCDataTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcparagraphgui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCParagraphGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpccontentincludegui'), 'filename' => array('text', 'Services/COPage/classes/class.ilPCContentIncludeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcomponentsettingsgui'), 'filename' => array('text', 'Services/Component/classes/class.ilObjComponentSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpluginsoverviewtablegui'), 'filename' => array('text', 'Services/Component/classes/class.ilPluginsOverviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpluginconfiggui'), 'filename' => array('text', 'Services/Component/classes/class.ilPluginConfigGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcomponentstablegui'), 'filename' => array('text', 'Services/Component/classes/class.ilComponentsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilframesetgui'), 'filename' => array('text', 'Services/Frameset/classes/class.ilFramesetGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '6z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedmdfieldtablegui'), 'filename' => array('text', 'Services/AdvancedMetaData/classes/class.ilAdvancedMDFieldTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '70')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedmdrecordexportfilestablegui'), 'filename' => array('text', 'Services/AdvancedMetaData/classes/class.ilAdvancedMDRecordExportFilesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '71')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedmdsettingsgui'), 'filename' => array('text', 'Services/AdvancedMetaData/classes/class.ilAdvancedMDSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '72')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedmdrecordtablegui'), 'filename' => array('text', 'Services/AdvancedMetaData/classes/class.ilAdvancedMDRecordTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '73')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedmdrecordgui'), 'filename' => array('text', 'Services/AdvancedMetaData/classes/class.ilAdvancedMDRecordGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '74')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilimprintgui'), 'filename' => array('text', 'Services/Imprint/classes/class.ilImprintGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '75')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilinfoscreengui'), 'filename' => array('text', 'Services/InfoScreen/classes/class.ilInfoScreenGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '76')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwaitinglisttablegui'), 'filename' => array('text', 'Services/Membership/classes/class.ilWaitingListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '77')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmemberexportgui'), 'filename' => array('text', 'Services/Membership/classes/Export/class.ilMemberExportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '78')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmembershipregistrationsettingsgui'), 'filename' => array('text', 'Services/Membership/classes/class.ilMembershipRegistrationSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '79')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmemberagreementgui'), 'filename' => array('text', 'Services/Membership/classes/class.ilMemberAgreementGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmembershipgui'), 'filename' => array('text', 'Services/Membership/classes/class.ilMembershipGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectcustomuserfieldstablegui'), 'filename' => array('text', 'Services/Membership/classes/class.ilObjectCustomUserFieldsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectcustomuserfieldsgui'), 'filename' => array('text', 'Services/Membership/classes/class.ilObjectCustomUserFieldsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsubscribertablegui'), 'filename' => array('text', 'Services/Membership/classes/class.ilSubscriberTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmembershipadministrationgui'), 'filename' => array('text', 'Services/Membership/classes/class.ilMembershipAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilregistrationgui'), 'filename' => array('text', 'Services/Membership/classes/class.ilRegistrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilregistrationsettingsgui'), 'filename' => array('text', 'Services/Registration/classes/class.ilRegistrationSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilregistrationcodestablegui'), 'filename' => array('text', 'Services/Registration/classes/class.ilRegistrationCodesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccountregistrationgui'), 'filename' => array('text', 'Services/Registration/classes/class.ilAccountRegistrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmdcopyrighttablegui'), 'filename' => array('text', 'Services/MetaData/classes/class.ilMDCopyrightTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltypicallearningtimeinputgui'), 'filename' => array('text', 'Services/MetaData/classes/class.ilTypicalLearningTimeInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmdcopyrightselectiongui'), 'filename' => array('text', 'Services/MetaData/classes/class.ilMDCopyrightSelectionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcopyrightinputgui'), 'filename' => array('text', 'Services/MetaData/classes/class.ilCopyrightInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmdeditorgui'), 'filename' => array('text', 'Services/MetaData/classes/class.ilMDEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmdsettingsgui'), 'filename' => array('text', 'Services/MetaData/classes/class.ilObjMDSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'arconfigformgui'), 'filename' => array('text', 'Services/ActiveRecord/_Examples/Config/class.arConfigFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'arstoragerecordgui'), 'filename' => array('text', 'Services/ActiveRecord/_Examples/StorageRecord/class.arStorageRecordGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'arindextablegui'), 'filename' => array('text', 'Services/ActiveRecord/Views/Index/class.arIndexTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ardisplaygui'), 'filename' => array('text', 'Services/ActiveRecord/Views/Display/class.arDisplayGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'argui'), 'filename' => array('text', 'Services/ActiveRecord/Views/class.arGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ardeletegui'), 'filename' => array('text', 'Services/ActiveRecord/Views/Delete/class.arDeleteGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'areditgui'), 'filename' => array('text', 'Services/ActiveRecord/Views/Edit/class.arEditGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilltemplatetreeexplorergui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillTemplateTreeExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilltreeexplorergui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillTreeExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillusagetablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillUsageTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '7z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillleveltablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillLevelTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '80')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilselfevaluationsimpletablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSelfEvaluationSimpleTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '81')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbasicskillgui'), 'filename' => array('text', 'Services/Skill/classes/class.ilBasicSkillGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '82')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillprofilegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillProfileGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '83')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjskillmanagementgui'), 'filename' => array('text', 'Services/Skill/classes/class.ilObjSkillManagementGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '84')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpersonalskilltablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilPersonalSkillTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '85')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillselfevaluationgui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillSelfEvaluationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '86')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilltemplatecategorygui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillTemplateCategoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '87')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilllevelprofileassignmenttablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillLevelProfileAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '88')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpersonalskillexplorergui'), 'filename' => array('text', 'Services/Skill/classes/class.ilPersonalSkillExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '89')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilltemplatereferencegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillTemplateReferenceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilllevelresourcestablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillLevelResourcesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillrootgui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillRootGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillselectorgui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillSelectorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillassignmaterialstablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillAssignMaterialsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbasicskilltemplategui'), 'filename' => array('text', 'Services/Skill/classes/class.ilBasicSkillTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillprofileusertablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillProfileUserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilvirtualskilltreeexplorergui'), 'filename' => array('text', 'Services/Skill/classes/class.ilVirtualSkillTreeExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilltemplategui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillcategorygui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillCategoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillprofiletablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillProfileTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpersonalskillsgui'), 'filename' => array('text', 'Services/Skill/classes/class.ilPersonalSkillsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillselfevalskilltablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillSelfEvalSkillTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillprofilelevelstablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillProfileLevelsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskillcattablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillCatTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilskilltreenodegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSkillTreeNodeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilselfevaluationtablegui'), 'filename' => array('text', 'Services/Skill/classes/class.ilSelfEvaluationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarmonthgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarMonthGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarappointmentstablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarAppointmentsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarchangedappointmentstablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarChangedAppointmentsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilminicalendargui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilMiniCalendarGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarweekgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarWeekGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarsharedlisttablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarSharedListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarsubscriptiongui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarSubscriptionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarappointmentpanelgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarAppointmentPanelGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarheadernavigationgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarHeaderNavigationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '8z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarselectionblockgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarSelectionBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '90')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconsultationhourgrouptablegui'), 'filename' => array('text', 'Services/Calendar/classes/ConsultationHours/class.ilConsultationHourGroupTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '91')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconsultationhoursgui'), 'filename' => array('text', 'Services/Calendar/classes/ConsultationHours/class.ilConsultationHoursGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '92')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconsultationhourstablegui'), 'filename' => array('text', 'Services/Calendar/classes/ConsultationHours/class.ilConsultationHoursTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '93')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconsultationhourbookingtablegui'), 'filename' => array('text', 'Services/Calendar/classes/ConsultationHours/class.ilConsultationHourBookingTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '94')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarrecurrencegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarRecurrenceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '95')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrecurrenceinputgui'), 'filename' => array('text', 'Services/Calendar/classes/Form/class.ilRecurrenceInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '96')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarinboxsharedtablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarInboxSharedTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '97')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdcalendarblockgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilPDCalendarBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '98')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarmanagetablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarManageTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '99')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarpresentationgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9a')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarblockgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9b')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarsharedrolelisttablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarSharedRoleListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9c')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendardaygui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarDayGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9d')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarshareduserlisttablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarSharedUserListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9e')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarcategorygui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarCategoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9f')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarcategorytablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarCategoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9g')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarinboxgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarInboxGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9h')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcalendarsettingsgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilObjCalendarSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9i')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarusersettingsgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarUserSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9j')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmilestoneresponsiblestablegui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilMilestoneResponsiblesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9k')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcalendarappointmentgui'), 'filename' => array('text', 'Services/Calendar/classes/class.ilCalendarAppointmentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9l')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediapooltablegui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilMediaPoolTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9m')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediapoolgui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilObjMediaPoolGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9n')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediapoolpresentationgui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilMediaPoolPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9o')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediapoolpagegui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilMediaPoolPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9p')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediapoolsubitemlistgui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilObjMediaPoolSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9q')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluploaddirfilestablegui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilUploadDirFilesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9r')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediapoolexplorergui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilMediaPoolExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9s')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediapoollistgui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilObjMediaPoolListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9t')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediapoolpageusagestablegui'), 'filename' => array('text', 'Modules/MediaPool/classes/class.ilMediaPoolPageUsagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9u')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcategorygui'), 'filename' => array('text', 'Modules/Category/classes/class.ilObjCategoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9v')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcategorylistgui'), 'filename' => array('text', 'Modules/Category/classes/class.ilObjCategoryListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9w')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfileversiontablegui'), 'filename' => array('text', 'Modules/File/classes/class.ilFileVersionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9x')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjfilelistgui'), 'filename' => array('text', 'Modules/File/classes/class.ilObjFileListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9y')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjfilegui'), 'filename' => array('text', 'Modules/File/classes/class.ilObjFileGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', '9z')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjchatroomlistgui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilObjChatroomListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilchatroomobjectgui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilChatroomObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilchatroomsmiliestablegui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilChatroomSmiliesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbanneduserstablegui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilBannedUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilchatroomblockgui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilChatroomBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjchatroomadmingui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilObjChatroomAdminGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilchatroomsmiliesgui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilChatroomSmiliesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjchatroomgui'), 'filename' => array('text', 'Modules/Chatroom/classes/class.ilObjChatroomGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ililinkconfirmationtablegui'), 'filename' => array('text', 'Modules/ILinc/classes/class.iliLinkConfirmationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjilinccoursegui'), 'filename' => array('text', 'Modules/ILinc/classes/class.ilObjiLincCourseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'a9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjilinccourselistgui'), 'filename' => array('text', 'Modules/ILinc/classes/class.ilObjiLincCourseListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'aa')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjilincclassroomgui'), 'filename' => array('text', 'Modules/ILinc/classes/class.ilObjiLincClassroomGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ab')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ililinkmemberstablegui'), 'filename' => array('text', 'Modules/ILinc/classes/class.iliLinkMembersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ac')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjilincclassroomlistgui'), 'filename' => array('text', 'Modules/ILinc/classes/class.ilObjiLincClassroomListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ad')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjilincusergui'), 'filename' => array('text', 'Modules/ILinc/classes/class.ilObjiLincUserGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ae')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexercisemembertablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExerciseMemberTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'af')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexerciseverificationgui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilObjExerciseVerificationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ag')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfeedbackconfirmationtable2gui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilFeedbackConfirmationTable2GUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ah')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexercisesubitemlistgui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilObjExerciseSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ai')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexcdeliveredfilestablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExcDeliveredFilesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'aj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexercisegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilObjExerciseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ak')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexerciselistgui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilObjExerciseListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'al')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexassignmentteamtablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExAssignmentTeamTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'am')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexassignmentteamlogtablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExAssignmentTeamLogTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'an')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexassignmentgui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExAssignmentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ao')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassignmentstablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilAssignmentsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ap')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexerciseverificationtablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExerciseVerificationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'aq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexerciseadministrationgui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilObjExerciseAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ar')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpublicsubmissionstablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilPublicSubmissionsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'as')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexassignmentpeerreviewtablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExAssignmentPeerReviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'at')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexassignmentpeerreviewoverviewtablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExAssignmentPeerReviewOverviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'au')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexercisehandlergui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExerciseHandlerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'av')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexassignmentlisttexttablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExAssignmentListTextTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'aw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexgradestablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExGradesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ax')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexparticipanttablegui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilExParticipantTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ay')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexerciseverificationlistgui'), 'filename' => array('text', 'Modules/Exercise/classes/class.ilObjExerciseVerificationListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'az')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilgroupparticipantstablegui'), 'filename' => array('text', 'Modules/Group/classes/class.ilGroupParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilgroupeditparticipantstablegui'), 'filename' => array('text', 'Modules/Group/classes/class.ilGroupEditParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilgroupregistrationgui'), 'filename' => array('text', 'Modules/Group/classes/class.ilGroupRegistrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjgroupgui'), 'filename' => array('text', 'Modules/Group/classes/class.ilObjGroupGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjgroupadministrationgui'), 'filename' => array('text', 'Modules/Group/classes/class.ilObjGroupAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjgrouplistgui'), 'filename' => array('text', 'Modules/Group/classes/class.ilObjGroupListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotewikigui'), 'filename' => array('text', 'Modules/RemoteWiki/classes/class.ilObjRemoteWikiGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotewikilistgui'), 'filename' => array('text', 'Modules/RemoteWiki/classes/class.ilObjRemoteWikiListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermquicklisttablegui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilTermQuickListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglossarylocatorgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilGlossaryLocatorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'b9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjglossarylistgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilObjGlossaryListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ba')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglossarypresentationgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilGlossaryPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjglossarysubitemlistgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilObjGlossarySubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjglossarygui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilObjGlossaryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglossarydefpagegui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilGlossaryDefPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'be')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermusagestablegui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilTermUsagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpresentationlisttablegui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilPresentationListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglossarytermgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilGlossaryTermGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilgloadvcolsortinputgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilGloAdvColSortInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermdefinitioneditorgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilTermDefinitionEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglossaryeditorgui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilGlossaryEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermlisttablegui'), 'filename' => array('text', 'Modules/Glossary/classes/class.ilTermListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjitemgrouplistgui'), 'filename' => array('text', 'Modules/ItemGroup/classes/class.ilObjItemGroupListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilitemgroupitemstablegui'), 'filename' => array('text', 'Modules/ItemGroup/classes/class.ilItemGroupItemsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjitemgroupgui'), 'filename' => array('text', 'Modules/ItemGroup/classes/class.ilObjItemGroupGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglossaryselectorgui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilGlossarySelectorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004pagegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004PageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004trackingitemsperuserfiltergui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004TrackingItemsPerUserFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'br')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004chaptergui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004ChapterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bs')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004trackingitemstablegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004TrackingItemsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004trackingtablegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004TrackingTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004nodegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004NodeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004exporttablegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004ExportTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004pagenodegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004PageNodeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectivesalignmenttablegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilObjectivesAlignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'by')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004seqchaptergui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004SeqChapterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'bz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004organizationhformgui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004OrganizationHFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm13player'), 'filename' => array('text', 'Modules/Scorm2004/classes/ilSCORM13Player.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004assetgui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004AssetGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004trackingitemsperscofiltergui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004TrackingItemsPerScoFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004scogui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004ScoGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjscorm2004learningmodulegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilObjSCORM2004LearningModuleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscorm2004editorexplorergui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilSCORM2004EditorExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormspecialpagestablegui'), 'filename' => array('text', 'Modules/Scorm2004/classes/class.ilScormSpecialPagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcoursereferencegui'), 'filename' => array('text', 'Modules/CourseReference/classes/class.ilObjCourseReferenceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcoursereferencelistgui'), 'filename' => array('text', 'Modules/CourseReference/classes/class.ilObjCourseReferenceListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'c9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpollanswertablegui'), 'filename' => array('text', 'Modules/Poll/classes/class.ilPollAnswerTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ca')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjpollgui'), 'filename' => array('text', 'Modules/Poll/classes/class.ilObjPollGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjpolllistgui'), 'filename' => array('text', 'Modules/Poll/classes/class.ilObjPollListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpollblockgui'), 'filename' => array('text', 'Modules/Poll/classes/class.ilPollBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpollusertablegui'), 'filename' => array('text', 'Modules/Poll/classes/class.ilPollUserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ce')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjforumgui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilObjForumGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjforumadministrationgui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilObjForumAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjforumsubitemlistgui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilObjForumSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ch')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilforummoderatorsgui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilForumModeratorsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ci')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilforumstatisticstablegui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilForumStatisticsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjforumlistgui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilObjForumListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ck')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilforumtopictablegui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilForumTopicTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilforumexportgui'), 'filename' => array('text', 'Modules/Forum/classes/class.ilForumExportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsessionparticipantstablegui'), 'filename' => array('text', 'Modules/Session/classes/class.ilSessionParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsessiongui'), 'filename' => array('text', 'Modules/Session/classes/class.ilObjSessionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'co')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsessionlistgui'), 'filename' => array('text', 'Modules/Session/classes/class.ilObjSessionListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsessionmaterialstablegui'), 'filename' => array('text', 'Modules/Session/classes/class.ilSessionMaterialsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsessionoverviewgui'), 'filename' => array('text', 'Modules/Session/classes/class.ilSessionOverviewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsessionmembershipregistrationsettingsgui'), 'filename' => array('text', 'Modules/Session/classes/class.ilSessionMembershipRegistrationSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cs')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsessionfiletablegui'), 'filename' => array('text', 'Modules/Session/classes/class.ilSessionFileTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ct')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsystemfoldergui'), 'filename' => array('text', 'Modules/SystemFolder/classes/class.ilObjSystemFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbenchmarktablegui'), 'filename' => array('text', 'Modules/SystemFolder/classes/class.ilBenchmarkTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotefilegui'), 'filename' => array('text', 'Modules/RemoteFile/classes/class.ilObjRemoteFileGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotefilelistgui'), 'filename' => array('text', 'Modules/RemoteFile/classes/class.ilObjRemoteFileListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyskillgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveySkillGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyskillthresholdstablegui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveySkillThresholdsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'cz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsurveylistgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilObjSurveyListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyconstraintsgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveyConstraintsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyskillthresholdsgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveySkillThresholdsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyskillassignmenttablegui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveySkillAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyquestiontablegui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveyQuestionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveycodesedittablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyCodesEditTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyexporttablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyExportTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveymaintenancetablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyMaintenanceTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyinviteduserstablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyInvitedUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyquestionbrowsertablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyQuestionbrowserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'd9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyappraiseestablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyAppraiseesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'da')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveyconstraintstablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.SurveyConstraintsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'db')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveycodestablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyCodesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyquestionblockbrowsertablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyQuestionblockbrowserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyresultscumulatedtablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyResultsCumulatedTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'de')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilspecialuserstablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSpecialUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'df')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfounduserstablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilFoundUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyresultsusertablegui'), 'filename' => array('text', 'Modules/Survey/classes/tables/class.ilSurveyResultsUserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsurveyadministrationgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilObjSurveyAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'di')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyskilldeterminationgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveySkillDeterminationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsurveygui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilObjSurveyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyevaluationgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveyEvaluationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyskilltablegui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveySkillTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyskillchangestablegui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveySkillChangesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyexecutiongui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveyExecutionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'do')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyparticipantsgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveyParticipantsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveypagegui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveyPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyeditorgui'), 'filename' => array('text', 'Modules/Survey/classes/class.ilSurveyEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionpreviewtoolbargui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionPreviewToolbarGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ds')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assfileuploadgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assFileUploadGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionhintstablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionHintsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'du')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'asstextsubsetgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assTextSubsetGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionhintabstractgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionHintAbstractGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestioneditgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilQuestionEditGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assclozetestgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assClozeTestGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilimagewizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilImageWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'dz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglobalunitconfigurationgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilGlobalUnitConfigurationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnestedorderinggui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilNestedOrderingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assmultiplechoicegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assMultipleChoiceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assmatchingquestiongui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assMatchingQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionfeedbackeditinggui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionFeedbackEditingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assjavaappletgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assJavaAppletGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilkprimchoicewizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilKprimChoiceWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionhintsgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionHintsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsolutiontitleinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilSolutionTitleInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'asserrortextgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assErrorTextGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'e9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilerrortextwizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilErrorTextWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ea')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjquestionpoolsettingsgeneralgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilObjQuestionPoolSettingsGeneralGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'eb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illocalunitconfigurationgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilLocalUnitConfigurationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ec')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assquestiongui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ed')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsuggestedsolutionselectorgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilSuggestedSolutionSelectorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ee')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'asssinglechoicegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assSingleChoiceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ef')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assimagemapquestiongui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assImagemapQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'eg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assflashquestiongui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assFlashQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'eh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmatchingpairwizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilMatchingPairWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ei')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilkvpwizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilKVPWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ej')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilclozegapinputbuildergui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/Form/class.ilClozeGapInputBuilderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ek')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassspecfeedbackpagegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/feedback/class.ilAssSpecFeedbackPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'el')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassgenfeedbackpagegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/feedback/class.ilAssGenFeedbackPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'em')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionrelatednavigationbargui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionRelatedNavigationBarGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'en')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmatchingwizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilMatchingWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'eo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsuggestedsolutioninputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilSuggestedSolutionInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ep')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilimagemapfileinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilImagemapFileInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'eq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilunitconfigurationgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilUnitConfigurationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'er')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsinglechoicewizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilSingleChoiceWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'es')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'asstextquestiongui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assTextQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'et')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjquestionpoollistgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilObjQuestionPoolListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'eu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assorderingquestiongui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assOrderingQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ev')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionpreviewgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionPreviewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ew')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilanswerwizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAnswerWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ex')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglobalunitcategorytablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilGlobalUnitCategoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ey')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilunittablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilUnitTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ez')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestionusagestablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilQuestionUsagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestioncumulatedstatisticstablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilQuestionCumulatedStatisticsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestionpoolprintviewtablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilQuestionPoolPrintViewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestionpoolexporttablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilQuestionPoolExportTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestionbrowsertablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilQuestionBrowserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illocalunitcategorytablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilLocalUnitCategoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilunitcategorytablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilUnitCategoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestioninternallinkselectiontablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.ilQuestionInternalLinkSelectionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assfileuploadfiletablegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/tables/class.assFileUploadFileTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'asskprimchoicegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assKprimChoiceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'f9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionhintrequestgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionHintRequestGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fa')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assformulaquestiongui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assFormulaQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilessaykeywordwizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilEssayKeywordWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilquestionpoolexportgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilQuestionPoolExportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjquestionpoolgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilObjQuestionPoolGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fe')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmultiplechoicewizardinputgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilMultipleChoiceWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ff')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assnumericgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assNumericGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionpagegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilasshintpagegui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssHintPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'assorderinghorizontalgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.assOrderingHorizontalGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassquestionhintgui'), 'filename' => array('text', 'Modules/TestQuestionPool/classes/class.ilAssQuestionHintGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotegroupgui'), 'filename' => array('text', 'Modules/RemoteGroup/classes/class.ilObjRemoteGroupGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotegrouplistgui'), 'filename' => array('text', 'Modules/RemoteGroup/classes/class.ilObjRemoteGroupListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunitexplorergui'), 'filename' => array('text', 'Modules/OrgUnit/classes/class.ilOrgUnitExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunitsimpleuserimportgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/SimpleUserImport/class.ilOrgUnitSimpleUserImportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunitexportgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/class.ilOrgUnitExportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilextidgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/ExtId/class.ilExtIdGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunitsimpleimportgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/SimpleImport/class.ilOrgUnitSimpleImportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunitstaffgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Staff/class.ilOrgUnitStaffGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fs')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunitstafftablegui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Staff/class.ilOrgUnitStaffTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ft')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunitotherrolestablegui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Staff/class.ilOrgUnitOtherRolesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunittypeadvancedmetadataformgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Types/class.ilOrgUnitTypeAdvancedMetaDataFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunittypegui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Types/class.ilOrgUnitTypeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunittypeformgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Types/class.ilOrgUnitTypeFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunittypetablegui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Types/class.ilOrgUnitTypeTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorgunittypecustomiconsformgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Types/class.ilOrgUnitTypeCustomIconsFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'fz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjorgunitsettingsformgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Settings/class.ilObjOrgUnitSettingsFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjorgunitlistgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/class.ilObjOrgUnitListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilorguuserpickertoolbarinputgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/class.ilOrguUserPickerToolbarInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltranslationgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/Translation/class.ilTranslationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illocalusergui'), 'filename' => array('text', 'Modules/OrgUnit/classes/LocalUser/class.ilLocalUserGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjorgunitgui'), 'filename' => array('text', 'Modules/OrgUnit/classes/class.ilObjOrgUnitGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotecategorygui'), 'filename' => array('text', 'Modules/RemoteCategory/classes/class.ilObjRemoteCategoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotecategorylistgui'), 'filename' => array('text', 'Modules/RemoteCategory/classes/class.ilObjRemoteCategoryListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcategoryreferencegui'), 'filename' => array('text', 'Modules/CategoryReference/classes/class.ilObjCategoryReferenceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcategoryreferencelistgui'), 'filename' => array('text', 'Modules/CategoryReference/classes/class.ilObjCategoryReferenceListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'g9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginitemcreationlistgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginItemCreationListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ga')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudplugininitgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginInitGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginactionlistgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginActionListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginuploadgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginUploadGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginlistgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ge')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginsettingsgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginheaderactiongui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginHeaderActionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudplugininfoscreengui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginInfoScreenGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginfiletreegui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginFileTreeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudplugingui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudpluginconfiggui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginConfigGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudplugincreationgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginCreationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcloudlistgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilObjCloudListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudplugindeletegui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginDeleteGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcloudplugincreatefoldergui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilCloudPluginCreateFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'go')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcloudgui'), 'filename' => array('text', 'Modules/Cloud/classes/class.ilObjCloudGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotecoursegui'), 'filename' => array('text', 'Modules/RemoteCourse/classes/class.ilObjRemoteCourseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotecourselistgui'), 'filename' => array('text', 'Modules/RemoteCourse/classes/class.ilObjRemoteCourseListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjwikilistgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilObjWikiListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gs')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikipagegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikisideblockgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiSideBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikipagestablegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiPagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikisearchblockgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiSearchBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilimportantpagestablegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilImportantPagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikirecentchangestablegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiRecentChangesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjwikisettingsgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilObjWikiSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'gz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikiexportordertablegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiExportOrderTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjwikigui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilObjWikiGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcamdpagelistgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilPCAMDPageListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikistatgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiStatGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikisearchresultstablegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiSearchResultsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikiimportantpagesblockgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiImportantPagesBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikihandlergui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiHandlerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikicontributorstablegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiContributorsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjwikisubitemlistgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilObjWikiSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikipagetemplategui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiPageTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'h9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikifunctionsblockgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiFunctionsBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ha')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikiadvmetadatablockgui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiAdvMetaDataBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwikipagetemplatestablegui'), 'filename' => array('text', 'Modules/Wiki/classes/class.ilWikiPageTemplatesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjfolderlistgui'), 'filename' => array('text', 'Modules/Folder/classes/class.ilObjFolderListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjfoldergui'), 'filename' => array('text', 'Modules/Folder/classes/class.ilObjFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'he')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjblogadministrationgui'), 'filename' => array('text', 'Modules/Blog/classes/class.ilObjBlogAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbloggui'), 'filename' => array('text', 'Modules/Blog/classes/class.ilObjBlogGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbloglistgui'), 'filename' => array('text', 'Modules/Blog/classes/class.ilObjBlogListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilblogpostinggui'), 'filename' => array('text', 'Modules/Blog/classes/class.ilBlogPostingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontributortablegui'), 'filename' => array('text', 'Modules/Blog/classes/class.ilContributorTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbookingpoolgui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilObjBookingPoolGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookingschedulestablegui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilBookingSchedulesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbookingpoollistgui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilObjBookingPoolListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookingschedulegui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilBookingScheduleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookingreservationstablegui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilBookingReservationsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ho')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookingobjectstablegui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilBookingObjectsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookingobjectgui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilBookingObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscheduleinputgui'), 'filename' => array('text', 'Modules/BookingManager/classes/class.ilScheduleInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjrootfoldergui'), 'filename' => array('text', 'Modules/RootFolder/classes/class.ilObjRootFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hs')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjrootfolderlistgui'), 'filename' => array('text', 'Modules/RootFolder/classes/class.ilObjRootFolderListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ht')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexternalfeedgui'), 'filename' => array('text', 'Modules/ExternalFeed/classes/class.ilObjExternalFeedGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexternalfeedlistgui'), 'filename' => array('text', 'Modules/ExternalFeed/classes/class.ilObjExternalFeedListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexternalfeedhandlergui'), 'filename' => array('text', 'Modules/ExternalFeed/classes/class.ilExternalFeedHandlerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illinkstablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLinksTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmeditorgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmobjectgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'hz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmpagegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhelpmappingtablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilHelpMappingTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmpresentationgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmquestionlisttablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMQuestionListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlearningmodulelistgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilObjLearningModuleListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbibitemgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilBibItemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmeditorexplorergui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMEditorExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmtocexplorergui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMTOCExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexportidtablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilExportIDTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmpageobjectgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMPageObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'i9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcontentobjectgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilObjContentObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ia')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmtableofcontentsexplorergui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMTableOfContentsExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ib')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilchapterhierarchyformgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilChapterHierarchyFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ic')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilstructureobjectgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilStructureObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'id')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjdlbooklistgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilObjDlBookListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ie')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlearningmodulesubitemlistgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilObjLearningModuleSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'if')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpublicsectionexplorergui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilPublicSectionExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ig')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjdlbookgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilObjDlBookGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ih')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlearningresourcessettingsgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilObjLearningResourcesSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ii')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmmenuitemstablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMMenuItemsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ij')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmblockeduserstablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMBlockedUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ik')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlearningmodulegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilObjLearningModuleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'il')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmglossarytablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMGlossaryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'im')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhelptooltiptablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilHelpTooltipTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'in')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontobjlocatorgui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilContObjLocatorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'io')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmexplorergui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ip')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illmpagestablegui'), 'filename' => array('text', 'Modules/LearningModule/classes/class.ilLMPagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'iq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcoursecontentgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ir')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseparticipantsgroupsgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseParticipantsGroupsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'is')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcoursegroupingtablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseGroupingTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'it')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseparticipantstablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'iu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcoursearchivesgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseArchivesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'iv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseobjectivequestionassignmenttablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseObjectiveQuestionAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'iw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseeditparticipantstablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseEditParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ix')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseobjectivematerialassignmenttablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseObjectiveMaterialAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'iy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcoursegroupinggui'), 'filename' => array('text', 'Modules/Course/classes/class.ilObjCourseGroupingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'iz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseparticipantsgroupstablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseParticipantsGroupsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcourselistgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilObjCourseListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseobjectivequestionstablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseObjectiveQuestionsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseobjectivelistgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseObjectiveListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseobjectivesgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseObjectivesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcoursegroupingassignmenttablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseGroupingAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcoursestartobjectstablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseStartObjectsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseinfofiletablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseInfoFileTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcoursegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilObjCourseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcourseverificationlistgui'), 'filename' => array('text', 'Modules/Course/classes/Verification/class.ilObjCourseVerificationListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'j9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseverificationtablegui'), 'filename' => array('text', 'Modules/Course/classes/Verification/class.ilCourseVerificationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ja')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcourseverificationgui'), 'filename' => array('text', 'Modules/Course/classes/Verification/class.ilObjCourseVerificationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illoeditorgui'), 'filename' => array('text', 'Modules/Course/classes/Objectives/class.ilLOEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illopagegui'), 'filename' => array('text', 'Modules/Course/classes/Objectives/class.ilLOPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illotestassignmenttablegui'), 'filename' => array('text', 'Modules/Course/classes/Objectives/class.ilLOTestAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'je')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseobjectivestablegui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseObjectivesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcourseregistrationgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilCourseRegistrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjcourseadministrationgui'), 'filename' => array('text', 'Modules/Course/classes/class.ilObjCourseAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackingitemsscotablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingItemsScoTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ji')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackingitemstablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingItemsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackingitemsperusertablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingItemsPerUserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjscormlearningmodulegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilObjSCORMLearningModuleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsahslearningmodulelistgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilObjSAHSLearningModuleListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackingitemsperscofiltergui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingItemsPerScoFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackingitemsperuserfiltergui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingItemsPerUserFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackinguserstablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormofflinemodeuserstablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMOfflineModeUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormobjectgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormpresentationgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'js')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormresourcegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMResourceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormitemgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMItemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ju')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormorganizationgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMOrganizationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormresourcesgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMResourcesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormorganizationsgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMOrganizationsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormmanifestgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/SCORM/class.ilSCORMManifestGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsahspresentationgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSAHSPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'jz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjhacplearningmodulegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilObjHACPLearningModuleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsahseditgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSAHSEditGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhacppresentationgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/HACP/class.ilHACPPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsahslearningmodulegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilObjSAHSLearningModuleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjscormverificationgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/Verification/class.ilObjSCORMVerificationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormverificationtablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/Verification/class.ilSCORMVerificationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjscormverificationlistgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/Verification/class.ilObjSCORMVerificationListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackingitemperusertablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingItemPerUserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjaicclearningmodulegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilObjAICCLearningModuleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormofflinemodegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMOfflineModeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'k9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscormtrackingitemsperscotablegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/class.ilSCORMTrackingItemsPerScoTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ka')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaiccobjectgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/AICC/class.ilAICCObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaiccunitgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/AICC/class.ilAICCUnitGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaicccoursegui'), 'filename' => array('text', 'Modules/ScormAicc/classes/AICC/class.ilAICCCourseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaiccblockgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/AICC/class.ilAICCBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ke')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaiccpresentationgui'), 'filename' => array('text', 'Modules/ScormAicc/classes/AICC/class.ilAICCPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjworkspacerootfolderlistgui'), 'filename' => array('text', 'Modules/WorkspaceRootFolder/classes/class.ilObjWorkspaceRootFolderListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjworkspacerootfoldergui'), 'filename' => array('text', 'Modules/WorkspaceRootFolder/classes/class.ilObjWorkspaceRootFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediacastlistgui'), 'filename' => array('text', 'Modules/MediaCast/classes/class.ilObjMediaCastListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ki')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediacasthandlergui'), 'filename' => array('text', 'Modules/MediaCast/classes/class.ilMediaCastHandlerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediacastgui'), 'filename' => array('text', 'Modules/MediaCast/classes/class.ilObjMediaCastGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediacasttablegui'), 'filename' => array('text', 'Modules/MediaCast/classes/class.ilMediaCastTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediacastsettingsgui'), 'filename' => array('text', 'Modules/MediaCast/classes/class.ilObjMediaCastSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'km')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjfilebasedlmgui'), 'filename' => array('text', 'Modules/HTMLLearningModule/classes/class.ilObjFileBasedLMGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhtlmeditorgui'), 'filename' => array('text', 'Modules/HTMLLearningModule/classes/class.ilHTLMEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ko')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhtlmpresentationgui'), 'filename' => array('text', 'Modules/HTMLLearningModule/classes/class.ilHTLMPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjfilebasedlmlistgui'), 'filename' => array('text', 'Modules/HTMLLearningModule/classes/class.ilObjFileBasedLMListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestsettingschangeconfirmationgui'), 'filename' => array('text', 'Modules/Test/classes/confirmations/class.ilTestSettingsChangeConfirmationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestpassdeletionconfirmationgui'), 'filename' => array('text', 'Modules/Test/classes/confirmations/class.ilTestPassDeletionConfirmationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ks')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestevaluationgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestEvaluationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestplayerfixedquestionsetgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestPlayerFixedQuestionSetGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ku')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtestgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjTestGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestskilladministrationgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestSkillAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestpasswordprotectiongui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestPasswordProtectionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtestdynamicquestionsetconfiggui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjTestDynamicQuestionSetConfigGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ky')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtestlistgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjTestListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'kz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestrandomquestionsetsourcepooldefinitionlisttoolbargui'), 'filename' => array('text', 'Modules/Test/classes/toolbars/class.ilTestRandomQuestionSetSourcePoolDefinitionListToolbarGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestskillevaluationtoolbargui'), 'filename' => array('text', 'Modules/Test/classes/toolbars/class.ilTestSkillEvaluationToolbarGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestresultstoolbargui'), 'filename' => array('text', 'Modules/Test/classes/toolbars/class.ilTestResultsToolbarGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestsignaturegui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestSignatureGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestsubmissionreviewgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestSubmissionReviewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilscoringadjustmentgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilScoringAdjustmentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestskillquestionassignmentsgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestSkillQuestionAssignmentsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestscoringbyquestionsgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestScoringByQuestionsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestplayerabstractgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestPlayerAbstractGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestplayerdynamicquestionsetgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestPlayerDynamicQuestionSetGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'l9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtestverificationlistgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjTestVerificationListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'la')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestservicegui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestServiceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestskilllevelthresholdsgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestSkillLevelThresholdsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjassessmentfoldergui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjAssessmentFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ld')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestrandomquestionsetconfiggui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestRandomQuestionSetConfigGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'le')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestmanscoringparticipantstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestManScoringParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestaggregatedresultstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestAggregatedResultsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestparticipantstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestpassmanualscoringoverviewtablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestPassManualScoringOverviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'li')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilresultsbyquestiontablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilResultsByQuestionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestpassoverviewtablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestPassOverviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestinviterolestablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestInviteRolesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'll')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassessmentfolderlogtablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilAssessmentFolderLogTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltesthistorytablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestHistoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ln')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestverificationtablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestVerificationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illistofquestionstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilListOfQuestionsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltrackedquestionstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTrackedQuestionsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestquestionstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestQuestionsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestaveragereachedpointstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestAverageReachedPointsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ls')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestmanscoringparticipantsbyselectedquestionandpasstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestManScoringParticipantsBySelectedQuestionAndPassTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestdynamicquestionsetstatistictablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestDynamicQuestionSetStatisticTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestpersonaldefaultsettingstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestPersonalDefaultSettingsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestpassdetailsoverviewtablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestPassDetailsOverviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestskillquestionassignmentstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestSkillQuestionAssignmentsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestexporttablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestExportTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ly')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltimingoverviewtablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTimingOverviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'lz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilassessmentfolderlogadministrationtablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilAssessmentFolderLogAdministrationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestquestionbrowsertablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestQuestionBrowserTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestinviteuserstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestInviteUsersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestfixedparticipantstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestFixedParticipantsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestrandomquestionsetsourcepooldefinitionlisttablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestRandomQuestionSetSourcePoolDefinitionListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmarkschematablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilMarkSchemaTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestskilllevelthresholdstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestSkillLevelThresholdsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilevaluationalltablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilEvaluationAllTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestinvitegroupstablegui'), 'filename' => array('text', 'Modules/Test/classes/tables/class.ilTestInviteGroupsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestscoringgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestScoringGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'm9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestplayerrandomquestionsetgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestPlayerRandomQuestionSetGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ma')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestpersonalskillsgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestPersonalSkillsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestexpresspageobjectgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestExpressPageObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtestsettingsscoringresultsgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjTestSettingsScoringResultsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'md')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestsettingsgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'me')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtestverificationgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjTestVerificationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtestsettingsgeneralgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilObjTestSettingsGeneralGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestexportgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestExportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmarkschemagui'), 'filename' => array('text', 'Modules/Test/classes/class.ilMarkSchemaGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrandomtestroinputgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilRandomTestROInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestskillevaluationgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestSkillEvaluationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestrandomquestionsetgeneralconfigformgui'), 'filename' => array('text', 'Modules/Test/classes/forms/class.ilTestRandomQuestionSetGeneralConfigFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ml')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestrandomquestionsetpooldefinitionformgui'), 'filename' => array('text', 'Modules/Test/classes/forms/class.ilTestRandomQuestionSetPoolDefinitionFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltesttoplistgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestToplistGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltestoutputgui'), 'filename' => array('text', 'Modules/Test/classes/class.ilTestOutputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmatrixrowwizardinputgui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.ilMatrixRowWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsurveyquestionpoollistgui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.ilObjSurveyQuestionPoolListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyphrasesgui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.ilSurveyPhrasesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcategorywizardinputgui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.ilCategoryWizardInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ms')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveymultiplechoicequestiongui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.SurveyMultipleChoiceQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveymetricquestiongui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.SurveyMetricQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveysynctablegui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.ilSurveySyncTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveymaterialstablegui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/tables/class.ilSurveyMaterialsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyquestionpoolexporttablegui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/tables/class.ilSurveyQuestionPoolExportTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyphrasestablegui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/tables/class.ilSurveyPhrasesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'my')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveysavephrasetablegui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/tables/class.ilSurveySavePhraseTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'mz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsurveyquestionstablegui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/tables/class.ilSurveyQuestionsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveymaterialssourcetablegui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/tables/class.SurveyMaterialsSourceTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsurveyquestionpoolgui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.ilObjSurveyQuestionPoolGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveytextquestiongui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.SurveyTextQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveymatrixquestiongui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.SurveyMatrixQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveysinglechoicequestiongui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.SurveySingleChoiceQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'surveyquestiongui'), 'filename' => array('text', 'Modules/SurveyQuestionPool/classes/class.SurveyQuestionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcconsultationhoursgui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilPCConsultationHoursGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpcmycoursesgui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilPCMyCoursesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilportfoliotablegui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilPortfolioTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'n9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilportfoliotemplatepagegui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilPortfolioTemplatePageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'na')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjportfoliotemplatelistgui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilObjPortfolioTemplateListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjportfoliogui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilObjPortfolioGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilportfoliopagegui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilPortfolioPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjportfolioadministrationgui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilObjPortfolioAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ne')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilportfoliorepositorygui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilPortfolioRepositoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilportfoliopagetablegui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilPortfolioPageTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ng')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjportfoliobasegui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilObjPortfolioBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjportfoliotemplategui'), 'filename' => array('text', 'Modules/Portfolio/classes/class.ilObjPortfolioTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ni')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionrecordviewgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionRecordViewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectiontableeditgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionTableEditGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectiontreepickinputgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionTreePickInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionrecordlistviewdefinitiongui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionRecordListViewdefinitionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionfieldlisttablegui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionFieldListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionfieldlistgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionFieldListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'no')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjdatacollectiongui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilObjDataCollectionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'np')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionrecordviewviewdefinitiongui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionRecordViewViewdefinitionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionfieldeditgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionFieldEditGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionrecordeditgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionRecordEditGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ns')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionrecordlisttablegui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionRecordListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjdatacollectionlistgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilObjDataCollectionListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildclcheckboxinputgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDclCheckboxInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildatacollectionrecordlistgui'), 'filename' => array('text', 'Modules/DataCollection/classes/class.ilDataCollectionRecordListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illinkresourcehandlergui'), 'filename' => array('text', 'Modules/WebResource/classes/class.ilLinkResourceHandlerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwebresourcelinktablegui'), 'filename' => array('text', 'Modules/WebResource/classes/class.ilWebResourceLinkTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ny')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwebresourceeditablelinktablegui'), 'filename' => array('text', 'Modules/WebResource/classes/class.ilWebResourceEditableLinkTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'nz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlinkresourcelistgui'), 'filename' => array('text', 'Modules/WebResource/classes/class.ilObjLinkResourceListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlinkresourcesubitemlistgui'), 'filename' => array('text', 'Modules/WebResource/classes/class.ilObjLinkResourceSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjlinkresourcegui'), 'filename' => array('text', 'Modules/WebResource/classes/class.ilObjLinkResourceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjwebresourceadministrationgui'), 'filename' => array('text', 'Modules/WebResource/classes/class.ilObjWebResourceAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremoteglossarylistgui'), 'filename' => array('text', 'Modules/RemoteGlossary/classes/class.ilObjRemoteGlossaryListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremoteglossarygui'), 'filename' => array('text', 'Modules/RemoteGlossary/classes/class.ilObjRemoteGlossaryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotetestgui'), 'filename' => array('text', 'Modules/RemoteTest/classes/class.ilObjRemoteTestGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotetestlistgui'), 'filename' => array('text', 'Modules/RemoteTest/classes/class.ilObjRemoteTestListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbibliographiclistgui'), 'filename' => array('text', 'Modules/Bibliographic/classes/class.ilObjBibliographicListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbibliographicdetailsgui'), 'filename' => array('text', 'Modules/Bibliographic/classes/class.ilBibliographicDetailsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'o9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbibliographicdetailsgui'), 'filename' => array('text', 'Modules/Bibliographic/classes/class.ilBibliographicDetailsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oa')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbibliographicgui'), 'filename' => array('text', 'Modules/Bibliographic/classes/class.ilObjBibliographicGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ob')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbibliographicadminlibrariesformgui'), 'filename' => array('text', 'Modules/Bibliographic/classes/Admin/class.ilObjBibliographicAdminLibrariesFormGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbibliographicadmintablegui'), 'filename' => array('text', 'Modules/Bibliographic/classes/Admin/class.ilObjBibliographicAdminTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'od')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbibliographicadminlibrariesgui'), 'filename' => array('text', 'Modules/Bibliographic/classes/Admin/class.ilObjBibliographicAdminLibrariesGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oe')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjbibliographicadmingui'), 'filename' => array('text', 'Modules/Bibliographic/classes/class.ilObjBibliographicAdminGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'of')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotelearningmodulegui'), 'filename' => array('text', 'Modules/RemoteLearningModule/classes/class.ilObjRemoteLearningModuleGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'og')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjremotelearningmodulelistgui'), 'filename' => array('text', 'Modules/RemoteLearningModule/classes/class.ilObjRemoteLearningModuleListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjworkspacefolderlistgui'), 'filename' => array('text', 'Modules/WorkspaceFolder/classes/class.ilObjWorkspaceFolderListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjworkspacefoldertablegui'), 'filename' => array('text', 'Modules/WorkspaceFolder/classes/class.ilObjWorkspaceFolderTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjworkspacefoldergui'), 'filename' => array('text', 'Modules/WorkspaceFolder/classes/class.ilObjWorkspaceFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ok')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailsearchgui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ol')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladdressbooktablegui'), 'filename' => array('text', 'Services/Contact/classes/class.ilAddressbookTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'om')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailinglistsmemberstablegui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailingListsMembersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'on')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailsearchcoursestablegui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailSearchCoursesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailsearchgroupsgui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailSearchGroupsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'op')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailsearchcoursesmemberstablegui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailSearchCoursesMembersTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmailingliststablegui'), 'filename' => array('text', 'Services/Contact/classes/class.ilMailingListsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'or')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopadvancedsearchgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopAdvancedSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'os')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopfiltergui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ot')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoppersonalsettingsgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopPersonalSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ou')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopcontroller'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopController.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ov')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoppingcarttablegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShoppingCartTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ow')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpaymentstatisticgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPaymentStatisticGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ox')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoppersonalsettingstopicstablegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopPersonalSettingsTopicsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoptablegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'oz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjpaymentsettingsgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilObjPaymentSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbillingmailplaceholderspropertygui'), 'filename' => array('text', 'Services/Payment/classes/class.ilBillingMailPlaceholdersPropertyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopinfogui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopInfoGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpurchasebasegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPurchaseBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopcouponstablegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopCouponsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpaymentadmingui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPaymentAdminGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoptopicstablegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopTopicsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpaymentobjectgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPaymentObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpurchasebillgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPurchaseBillGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'p9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoppurchasegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopPurchaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pa')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopbasegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfiltergui'), 'filename' => array('text', 'Services/Payment/classes/class.ilFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilinvoicenumberplaceholderspropertygui'), 'filename' => array('text', 'Services/Payment/classes/class.ilInvoiceNumberPlaceholdersPropertyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpaymenttrusteegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPaymentTrusteeGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pe')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedsearchfiltergui'), 'filename' => array('text', 'Services/Payment/classes/class.ilAdvancedSearchFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopboughtobjectsgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopBoughtObjectsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpaymentcoupongui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPaymentCouponGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ph')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpaymentobjectselector'), 'filename' => array('text', 'Services/Payment/classes/class.ilPaymentObjectSelector.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopnewsgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopNewsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoppagegui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopshoppingcartgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopShoppingCartGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltermsconditionsgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilTermsConditionsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpurchasebmfgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilPurchaseBMFGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshoptopicsgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopTopicsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'po')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshopresultpresentationgui'), 'filename' => array('text', 'Services/Payment/classes/class.ilShopResultPresentationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmainmenugui'), 'filename' => array('text', 'Services/MainMenu/classes/class.ilMainMenuGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjhelpsettingsgui'), 'filename' => array('text', 'Services/Help/classes/class.ilObjHelpSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhelpgui'), 'filename' => array('text', 'Services/Help/classes/class.ilHelpGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ps')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilhelpmoduletablegui'), 'filename' => array('text', 'Services/Help/classes/class.ilHelpModuleTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfilesystemtablegui'), 'filename' => array('text', 'Services/FileSystem/classes/class.ilFileSystemTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfilesystemgui'), 'filename' => array('text', 'Services/FileSystem/classes/class.ilFileSystemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladttestgui'), 'filename' => array('text', 'Services/ADT/classes/_Example/class.ilADTTestGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladtbasedobjectgui'), 'filename' => array('text', 'Services/ADT/classes/_Example/class.ilADTBasedObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'px')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexplorerselectinputgui'), 'filename' => array('text', 'Services/UIComponent/Explorer2/classes/class.ilExplorerSelectInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'py')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexplorerbasegui'), 'filename' => array('text', 'Services/UIComponent/Explorer2/classes/class.ilExplorerBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'pz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltreeexplorergui'), 'filename' => array('text', 'Services/UIComponent/Explorer2/classes/class.ilTreeExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illightboxgui'), 'filename' => array('text', 'Services/UIComponent/Lightbox/classes/class.ilLightboxGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedselectionlistgui'), 'filename' => array('text', 'Services/UIComponent/AdvancedSelectionList/classes/class.ilAdvancedSelectionListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltoolbargui'), 'filename' => array('text', 'Services/UIComponent/Toolbar/classes/class.ilToolbarGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmodalgui'), 'filename' => array('text', 'Services/UIComponent/Modal/classes/class.ilModalGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilgroupedlistgui'), 'filename' => array('text', 'Services/UIComponent/GroupedList/classes/class.ilGroupedListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iloverlaygui'), 'filename' => array('text', 'Services/UIComponent/Overlay/classes/class.ilOverlayGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilglyphgui'), 'filename' => array('text', 'Services/UIComponent/Glyph/classes/class.ilGlyphGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluihookplugingui'), 'filename' => array('text', 'Services/UIComponent/classes/class.ilUIHookPluginGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluipluginroutergui'), 'filename' => array('text', 'Services/UIComponent/classes/class.ilUIPluginRouterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'q9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltexthighlightergui'), 'filename' => array('text', 'Services/UIComponent/TextHighlighter/classes/class.ilTextHighlighterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qa')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcheckboxlistoverlaygui'), 'filename' => array('text', 'Services/UIComponent/CheckboxListOverlay/classes/class.ilCheckboxListOverlayGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcharselectorradiogroupinputgui'), 'filename' => array('text', 'Services/UIComponent/CharSelector/classes/class.ilCharSelectorRadioGroupInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcharselectorgui'), 'filename' => array('text', 'Services/UIComponent/CharSelector/classes/class.ilCharSelectorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltooltipgui'), 'filename' => array('text', 'Services/UIComponent/Tooltip/classes/class.ilTooltipGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qe')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltabsgui'), 'filename' => array('text', 'Services/UIComponent/Tabs/classes/class.ilTabsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilchecklistgui'), 'filename' => array('text', 'Services/UIComponent/Checklist/classes/class.ilChecklistGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpanelgui'), 'filename' => array('text', 'Services/UIComponent/Panel/classes/class.ilPanelGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainergui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qi')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainercontentgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerstartobjectsgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerStartObjectsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerstartobjectscontentgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerStartObjectsContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ql')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerpagegui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerstartobjectscontenttablegui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerStartObjectsContentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerilinccontentgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerILincContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerstartobjectspagegui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerStartObjectsPageGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainersessionscontentgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerSessionsContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerbytypecontentgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerByTypeContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainersimplecontentgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerSimpleContentGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qs')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerstartobjectstablegui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerStartObjectsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerlinklistgui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerLinkListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmemberviewgui'), 'filename' => array('text', 'Services/Container/classes/class.ilMemberViewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerobjectivegui'), 'filename' => array('text', 'Services/Container/classes/class.ilContainerObjectiveGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illdaprolemappingtablegui'), 'filename' => array('text', 'Services/LDAP/classes/class.ilLDAPRoleMappingTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illdaproleassignmenttablegui'), 'filename' => array('text', 'Services/LDAP/classes/class.ilLDAPRoleAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illdapsettingsgui'), 'filename' => array('text', 'Services/LDAP/classes/class.ilLDAPSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'qz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcontainerreferencegui'), 'filename' => array('text', 'Services/ContainerReference/classes/class.ilContainerReferenceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdexternalfeedblockgui'), 'filename' => array('text', 'Services/Feeds/classes/class.ilPDExternalFeedBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfileuploadgui'), 'filename' => array('text', 'Services/FileUpload/classes/class.ilFileUploadGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpasswordassistancegui'), 'filename' => array('text', 'Services/Init/classes/class.ilPasswordAssistanceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilstartupgui'), 'filename' => array('text', 'Services/Init/classes/class.ilStartUpGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsystemcheckgui'), 'filename' => array('text', 'Services/SystemCheck/classes/class.ilObjSystemCheckGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtaggingsettingsgui'), 'filename' => array('text', 'Services/Tagging/classes/class.ilObjTaggingSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluserfortagtablegui'), 'filename' => array('text', 'Services/Tagging/classes/class.ilUserForTagTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltagginggui'), 'filename' => array('text', 'Services/Tagging/classes/class.ilTaggingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdtaggingblockgui'), 'filename' => array('text', 'Services/Tagging/classes/class.ilPDTaggingBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'r9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsettingstemplatetablegui'), 'filename' => array('text', 'Services/Administration/classes/class.ilSettingsTemplateTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ra')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladministrationcommandgui'), 'filename' => array('text', 'Services/Administration/classes/class.ilAdministrationCommandGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladministrationexplorergui'), 'filename' => array('text', 'Services/Administration/classes/class.ilAdministrationExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladministrationgui'), 'filename' => array('text', 'Services/Administration/classes/class.ilAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjexternaltoolssettingsgui'), 'filename' => array('text', 'Services/Administration/classes/class.ilObjExternalToolsSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 're')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjrecoveryfoldergui'), 'filename' => array('text', 'Services/Administration/classes/class.ilObjRecoveryFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsettingstemplategui'), 'filename' => array('text', 'Services/Administration/classes/class.ilSettingsTemplateGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilblockgui'), 'filename' => array('text', 'Services/Block/classes/class.ilBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildummyblockgui'), 'filename' => array('text', 'Services/Block/classes/class.ilDummyBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ri')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexternalfeedblockgui'), 'filename' => array('text', 'Services/Block/classes/class.ilExternalFeedBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcolumngui'), 'filename' => array('text', 'Services/Block/classes/class.ilColumnGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illicensegui'), 'filename' => array('text', 'Services/License/classes/class.ilLicenseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illicenseoverviewgui'), 'filename' => array('text', 'Services/License/classes/class.ilLicenseOverviewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illicenseoverviewtablegui'), 'filename' => array('text', 'Services/License/classes/class.ilLicenseOverviewTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjecttranslationtablegui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectTranslationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ro')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjobjectfoldergui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjObjectFolderGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectlistgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobject2gui'), 'filename' => array('text', 'Services/Object/classes/class.ilObject2GUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rs')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectownershipmanagementgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectOwnershipManagementGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectcopyselectiontablegui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectCopySelectionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ru')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectactivationgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectActivationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjecttablegui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectsubitemlistgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectservicesettingsgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectServiceSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ry')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectaddnewitemgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectAddNewItemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'rz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsubitemlistgui'), 'filename' => array('text', 'Services/Object/classes/class.ilSubItemListGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectownershipmanagementtablegui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectOwnershipManagementTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectcopygui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectCopyGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjtypedefinitiongui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjTypeDefinitionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjclipboardtablegui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjClipboardTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjecttranslation2tablegui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectTranslation2TableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcommonactiondispatchergui'), 'filename' => array('text', 'Services/Object/classes/class.ilCommonActionDispatcherGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjecttranslationgui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectTranslationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjectcopysearchresulttablegui'), 'filename' => array('text', 'Services/Object/classes/class.ilObjectCopySearchResultTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilworkspacesharetablegui'), 'filename' => array('text', 'Services/PersonalWorkspace/classes/class.ilWorkspaceShareTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 's9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsharedresourcegui'), 'filename' => array('text', 'Services/PersonalWorkspace/classes/class.ilSharedResourceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sa')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpersonalworkspacegui'), 'filename' => array('text', 'Services/PersonalWorkspace/classes/class.ilPersonalWorkspaceGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilworkspaceaccessgui'), 'filename' => array('text', 'Services/PersonalWorkspace/classes/class.ilWorkspaceAccessGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilworkspaceaccesstablegui'), 'filename' => array('text', 'Services/PersonalWorkspace/classes/class.ilWorkspaceAccessTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sd')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsubitemselectiontablegui'), 'filename' => array('text', 'Services/Export/classes/class.ilSubItemSelectionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'se')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexporttablegui'), 'filename' => array('text', 'Services/Export/classes/class.ilExportTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexportselectiontablegui'), 'filename' => array('text', 'Services/Export/classes/class.ilExportSelectionTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilexportgui'), 'filename' => array('text', 'Services/Export/classes/class.ilExportGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecscommunitytablegui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilECSCommunityTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'si')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecsreleasedcontenttablegui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilECSReleasedContentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecsimportedcontenttablegui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilECSImportedContentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecscategorymappingtablegui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilECSCategoryMappingTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecsnodemappingtreetablegui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/Mapping/class.ilECSNodeMappingTreeTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecsmappingsettingsgui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/Mapping/class.ilECSMappingSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilremoteobjectbasegui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilRemoteObjectBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'so')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecsparticipantsettingsgui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilECSParticipantSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjecssettingsgui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilObjECSSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecsservertablegui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilECSServerTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilecssettingsgui'), 'filename' => array('text', 'Services/WebServices/ECS/classes/class.ilECSSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ss')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilfmsettingsgui'), 'filename' => array('text', 'Services/WebServices/FileManager/classes/class.ilFMSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'st')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpathgui'), 'filename' => array('text', 'Services/Tree/classes/class.ilPathGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'su')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconfirmationtablegui'), 'filename' => array('text', 'Services/Utilities/classes/class.ilConfirmationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilconfirmationgui'), 'filename' => array('text', 'Services/Utilities/classes/class.ilConfirmationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illocatorgui'), 'filename' => array('text', 'Services/Locator/classes/class.ilLocatorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcaptchainputgui'), 'filename' => array('text', 'Services/Captcha/classes/class.ilCaptchaInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sy')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrenderertablegui'), 'filename' => array('text', 'Services/Preview/classes/class.ilRendererTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'sz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpreviewgui'), 'filename' => array('text', 'Services/Preview/classes/class.ilPreviewGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilshibbolethroleassignmenttablegui'), 'filename' => array('text', 'Services/AuthShibboleth/classes/class.ilShibbolethRoleAssignmentTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilauthshibbolethsettingsgui'), 'filename' => array('text', 'Services/AuthShibboleth/classes/class.ilAuthShibbolethSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdselecteditemsblockgui'), 'filename' => array('text', 'Services/PersonalDesktop/classes/class.ilPDSelectedItemsBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ildesktopitemgui'), 'filename' => array('text', 'Services/PersonalDesktop/classes/class.ilDesktopItemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilusersonlineblockgui'), 'filename' => array('text', 'Services/PersonalDesktop/classes/class.ilUsersOnlineBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdcontentblockgui'), 'filename' => array('text', 'Services/PersonalDesktop/classes/class.ilPDContentBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpersonaldesktopgui'), 'filename' => array('text', 'Services/PersonalDesktop/classes/class.ilPersonalDesktopGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjpersonaldesktopsettingsgui'), 'filename' => array('text', 'Services/PersonalDesktop/classes/class.ilObjPersonalDesktopSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccordiongui'), 'filename' => array('text', 'Services/Accordion/classes/class.ilAccordionGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 't9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilaccordionpropertiesstorage'), 'filename' => array('text', 'Services/Accordion/classes/class.ilAccordionPropertiesStorage.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ta')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnotification'), 'filename' => array('text', 'Services/Notification/classes/class.ilNotification.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tb')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilworkflowgui'), 'filename' => array('text', 'Services/Workflow/classes/class.ilWorkflowGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpermanentlinkgui'), 'filename' => array('text', 'Services/PermanentLink/classes/class.ilPermanentLinkGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'td')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltablegui'), 'filename' => array('text', 'Services/Table/classes/class.ilTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'te')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltabletemplatesstorage'), 'filename' => array('text', 'Services/Table/classes/class.ilTableTemplatesStorage.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltable2gui'), 'filename' => array('text', 'Services/Table/classes/class.ilTable2GUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tg')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iltablepropertiesstorage'), 'filename' => array('text', 'Services/Table/classes/class.ilTablePropertiesStorage.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'th')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediaobjectssettingsgui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilObjMediaObjectsSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ti')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilimagemapeditorgui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilImageMapEditorGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilwidthheightinputgui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilWidthHeightInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilimagemaptablegui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilImageMapTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tl')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediaplayergui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilMediaPlayerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tm')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjmediaobjectgui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilObjMediaObjectGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tn')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmediaobjectusagestablegui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilMediaObjectUsagesTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'to')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmobsubtitletablegui'), 'filename' => array('text', 'Services/MediaObjects/classes/class.ilMobSubtitleTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tp')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnewsforcontexttablegui'), 'filename' => array('text', 'Services/News/classes/class.ilNewsForContextTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdnewsgui'), 'filename' => array('text', 'Services/News/classes/class.ilPDNewsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tr')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnewsforcontextblockgui'), 'filename' => array('text', 'Services/News/classes/class.ilNewsForContextBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ts')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdnewstablegui'), 'filename' => array('text', 'Services/News/classes/class.ilPDNewsTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tt')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjnewssettingsgui'), 'filename' => array('text', 'Services/News/classes/class.ilObjNewsSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrssbuttongui'), 'filename' => array('text', 'Services/News/classes/class.ilRSSButtonGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tv')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilnewsitemgui'), 'filename' => array('text', 'Services/News/classes/class.ilNewsItemGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tw')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilpdnewsblockgui'), 'filename' => array('text', 'Services/News/classes/class.ilPDNewsBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tx')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjprivacysecuritygui'), 'filename' => array('text', 'Services/PrivacySecurity/classes/class.ilObjPrivacySecurityGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ty')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilinternallinkgui'), 'filename' => array('text', 'Services/Link/classes/class.ilInternalLinkGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'tz')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illinktargetobjectexplorergui'), 'filename' => array('text', 'Services/Link/classes/class.ilLinkTargetObjectExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u0')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilintlinkrepitemexplorergui'), 'filename' => array('text', 'Services/Link/classes/class.ilIntLinkRepItemExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u1')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilratinggui'), 'filename' => array('text', 'Services/Rating/classes/class.ilRatingGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u2')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilratingcategorygui'), 'filename' => array('text', 'Services/Rating/classes/class.ilRatingCategoryGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u3')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilratingcategorytablegui'), 'filename' => array('text', 'Services/Rating/classes/class.ilRatingCategoryTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u4')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcronmanagergui'), 'filename' => array('text', 'Services/Cron/classes/class.ilCronManagerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u5')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilcronmanagertablegui'), 'filename' => array('text', 'Services/Cron/classes/class.ilCronManagerTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u6')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsearchresulttablegui'), 'filename' => array('text', 'Services/Search/classes/class.ilSearchResultTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u7')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepositoryobjectresulttablegui'), 'filename' => array('text', 'Services/Search/classes/class.ilRepositoryObjectResultTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u8')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsearchcontroller'), 'filename' => array('text', 'Services/Search/classes/class.ilSearchController.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'u9')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepositoryuserresulttablegui'), 'filename' => array('text', 'Services/Search/classes/class.ilRepositoryUserResultTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ua')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illucenequeryinputgui'), 'filename' => array('text', 'Services/Search/classes/Form/class.ilLuceneQueryInputGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ub')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsearchbasegui'), 'filename' => array('text', 'Services/Search/classes/class.ilSearchBaseGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uc')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsearchgui'), 'filename' => array('text', 'Services/Search/classes/class.ilSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ud')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilobjsearchsettingsgui'), 'filename' => array('text', 'Services/Search/classes/class.ilObjSearchSettingsGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ue')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illuceneusersearchgui'), 'filename' => array('text', 'Services/Search/classes/Lucene/class.ilLuceneUserSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uf')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illuceneadvancedsearchgui'), 'filename' => array('text', 'Services/Search/classes/Lucene/class.ilLuceneAdvancedSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ug')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illucenesearchgui'), 'filename' => array('text', 'Services/Search/classes/Lucene/class.ilLuceneSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uh')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'illuceneadvancedsearchactivationtablegui'), 'filename' => array('text', 'Services/Search/classes/Lucene/class.ilLuceneAdvancedSearchActivationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ui')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iladvancedsearchgui'), 'filename' => array('text', 'Services/Search/classes/class.ilAdvancedSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uj')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'iluserfiltergui'), 'filename' => array('text', 'Services/Search/classes/class.ilUserFilterGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uk')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilmainmenusearchgui'), 'filename' => array('text', 'Services/Search/classes/class.ilMainMenuSearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ul')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilrepositorysearchgui'), 'filename' => array('text', 'Services/Search/classes/class.ilRepositorySearchGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'um')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookmarkadministrationgui'), 'filename' => array('text', 'Services/Bookmarks/classes/class.ilBookmarkAdministrationGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'un')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookmarkexplorergui'), 'filename' => array('text', 'Services/Bookmarks/classes/class.ilBookmarkExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uo')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookmarkmoveexplorergui'), 'filename' => array('text', 'Services/Bookmarks/classes/class.ilBookmarkMoveExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'up')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookmarkblockexplorergui'), 'filename' => array('text', 'Services/Bookmarks/classes/class.ilBookmarkBlockExplorerGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uq')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookmarkblockgui'), 'filename' => array('text', 'Services/Bookmarks/classes/class.ilBookmarkBlockGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ur')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilbookmarkadministrationtablegui'), 'filename' => array('text', 'Services/Bookmarks/classes/class.ilBookmarkAdministrationTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'us')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsetupgui'), 'filename' => array('text', 'setup/classes/class.ilSetupGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'ut')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilclientlisttablegui'), 'filename' => array('text', 'setup/classes/class.ilClientListTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uu')));

$ilDB->insert("ctrl_classfile", array(
'class' => array('text', 'ilsetuplanguagetablegui'), 'filename' => array('text', 'setup/classes/class.ilSetupLanguageTableGUI.php'), 'comp_prefix' => array('text', ''), 'plugin_path' => array('text', ''), 'cid' => array('text', 'uv')));


//
// ctrl_structure
//
$fields = array (
	"root_class" => array (
		"notnull" => true
		,"length" => 40
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"call_node" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"forward" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"parent" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("ctrl_structure", $fields);

$pk_fields = array("root_class");
$ilDB->addPrimaryKey("ctrl_structure", $pk_fields);

$ilDB->insert("ctrl_structure", array(
'root_class' => array('text', 'ilrepositorygui'), 'call_node' => array('clob', 'a:3647:{i:1;a:2:{s:5:"class";s:15:"ilrepositorygui";s:6:"parent";i:0;}i:2;a:2:{s:5:"class";s:21:"ilcourseobjectivesgui";s:6:"parent";i:1;}i:3;a:2:{s:5:"class";s:16:"ilobjcategorygui";s:6:"parent";i:1;}i:4;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3;}i:5;a:2:{s:5:"class";s:0:"";s:6:"parent";i:4;}i:6;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:4;}i:7;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:4;}i:8;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:7;}i:9;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:7;}i:10;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:9;}i:11;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:7;}i:12;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:11;}i:13;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:7;}i:14;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:13;}i:15;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:7;}i:16;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:15;}i:17;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:4;}i:18;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:4;}i:19;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:4;}i:20;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:4;}i:21;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:4;}i:22;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:21;}i:23;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:4;}i:24;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:23;}i:25;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:23;}i:26;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:25;}i:27;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:23;}i:28;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:27;}i:29;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:23;}i:30;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:29;}i:31;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:23;}i:32;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:31;}i:33;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:4;}i:34;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:4;}i:35;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:4;}i:36;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:4;}i:37;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:4;}i:38;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:4;}i:39;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:4;}i:40;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:4;}i:41;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:4;}i:42;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:41;}i:43;a:2:{s:5:"class";s:22:"ilcontainerlinklistgui";s:6:"parent";i:3;}i:44;a:2:{s:5:"class";s:0:"";s:6:"parent";i:43;}i:45;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3;}i:46;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:45;}i:47;a:2:{s:5:"class";s:0:"";s:6:"parent";i:46;}i:48;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:46;}i:49;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:46;}i:50;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:49;}i:51;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:49;}i:52;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:51;}i:53;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:49;}i:54;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:53;}i:55;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:49;}i:56;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:55;}i:57;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:49;}i:58;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:57;}i:59;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:46;}i:60;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:46;}i:61;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:46;}i:62;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:46;}i:63;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:46;}i:64;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:63;}i:65;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:46;}i:66;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:65;}i:67;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:65;}i:68;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:67;}i:69;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:65;}i:70;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:69;}i:71;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:65;}i:72;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:71;}i:73;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:65;}i:74;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:73;}i:75;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:46;}i:76;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:46;}i:77;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:46;}i:78;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:46;}i:79;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:46;}i:80;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:46;}i:81;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:46;}i:82;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:46;}i:83;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:46;}i:84;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:83;}i:85;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:45;}i:86;a:2:{s:5:"class";s:0:"";s:6:"parent";i:85;}i:87;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:45;}i:88;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:45;}i:89;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3;}i:90;a:2:{s:5:"class";s:0:"";s:6:"parent";i:89;}i:91;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:3;}i:92;a:2:{s:5:"class";s:0:"";s:6:"parent";i:91;}i:93;a:2:{s:5:"class";s:18:"ilobjuserfoldergui";s:6:"parent";i:3;}i:94;a:2:{s:5:"class";s:20:"iladminusersearchgui";s:6:"parent";i:93;}i:95;a:2:{s:5:"class";s:12:"ilobjusergui";s:6:"parent";i:94;}i:96;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:95;}i:97;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:96;}i:98;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:96;}i:99;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:98;}i:100;a:2:{s:5:"class";s:0:"";s:6:"parent";i:99;}i:101;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:98;}i:102;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:101;}i:103;a:2:{s:5:"class";s:0:"";s:6:"parent";i:102;}i:104;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:102;}i:105;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:98;}i:106;a:2:{s:5:"class";s:0:"";s:6:"parent";i:105;}i:107;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:98;}i:108;a:2:{s:5:"class";s:0:"";s:6:"parent";i:107;}i:109;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:96;}i:110;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:109;}i:111;a:2:{s:5:"class";s:0:"";s:6:"parent";i:110;}i:112;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:109;}i:113;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:112;}i:114;a:2:{s:5:"class";s:0:"";s:6:"parent";i:113;}i:115;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:113;}i:116;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:109;}i:117;a:2:{s:5:"class";s:0:"";s:6:"parent";i:116;}i:118;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:96;}i:119;a:2:{s:5:"class";s:0:"";s:6:"parent";i:118;}i:120;a:2:{s:5:"class";s:17:"ilobjilincusergui";s:6:"parent";i:95;}i:121;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:93;}i:122;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:121;}i:123;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:122;}i:124;a:2:{s:5:"class";s:14:"ilusertablegui";s:6:"parent";i:93;}i:125;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:124;}i:126;a:2:{s:5:"class";s:0:"";s:6:"parent";i:125;}i:127;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:125;}i:128;a:2:{s:5:"class";s:12:"ilobjusergui";s:6:"parent";i:3;}i:129;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:128;}i:130;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:129;}i:131;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:129;}i:132;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:131;}i:133;a:2:{s:5:"class";s:0:"";s:6:"parent";i:132;}i:134;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:131;}i:135;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:134;}i:136;a:2:{s:5:"class";s:0:"";s:6:"parent";i:135;}i:137;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:135;}i:138;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:131;}i:139;a:2:{s:5:"class";s:0:"";s:6:"parent";i:138;}i:140;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:131;}i:141;a:2:{s:5:"class";s:0:"";s:6:"parent";i:140;}i:142;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:129;}i:143;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:142;}i:144;a:2:{s:5:"class";s:0:"";s:6:"parent";i:143;}i:145;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:142;}i:146;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:145;}i:147;a:2:{s:5:"class";s:0:"";s:6:"parent";i:146;}i:148;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:146;}i:149;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:142;}i:150;a:2:{s:5:"class";s:0:"";s:6:"parent";i:149;}i:151;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:129;}i:152;a:2:{s:5:"class";s:0:"";s:6:"parent";i:151;}i:153;a:2:{s:5:"class";s:17:"ilobjilincusergui";s:6:"parent";i:128;}i:154;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3;}i:155;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:154;}i:156;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:155;}i:157;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:156;}i:158;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:156;}i:159;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:158;}i:160;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:156;}i:161;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:154;}i:162;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:154;}i:163;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:154;}i:164;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:163;}i:165;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:163;}i:166;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:165;}i:167;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:165;}i:168;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:167;}i:169;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:165;}i:170;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:163;}i:171;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:163;}i:172;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:163;}i:173;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:163;}i:174;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:163;}i:175;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:163;}i:176;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:163;}i:177;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:163;}i:178;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:177;}i:179;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:178;}i:180;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:178;}i:181;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:180;}i:182;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:178;}i:183;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:177;}i:184;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:183;}i:185;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:163;}i:186;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:163;}i:187;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:186;}i:188;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:187;}i:189;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:188;}i:190;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:188;}i:191;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:190;}i:192;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:188;}i:193;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:187;}i:194;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:193;}i:195;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:163;}i:196;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:163;}i:197;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:196;}i:198;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:197;}i:199;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:197;}i:200;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:197;}i:201;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:197;}i:202;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:197;}i:203;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:197;}i:204;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:197;}i:205;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:197;}i:206;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:197;}i:207;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:197;}i:208;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:163;}i:209;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:163;}i:210;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:163;}i:211;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:163;}i:212;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:163;}i:213;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:163;}i:214;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:154;}i:215;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3;}i:216;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:215;}i:217;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:216;}i:218;a:2:{s:5:"class";s:25:"ilobjcategoryreferencegui";s:6:"parent";i:1;}i:219;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:218;}i:220;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:219;}i:221;a:2:{s:5:"class";s:0:"";s:6:"parent";i:220;}i:222;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:220;}i:223;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:220;}i:224;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:223;}i:225;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:223;}i:226;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:225;}i:227;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:223;}i:228;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:227;}i:229;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:223;}i:230;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:229;}i:231;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:223;}i:232;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:231;}i:233;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:220;}i:234;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:220;}i:235;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:220;}i:236;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:220;}i:237;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:220;}i:238;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:237;}i:239;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:220;}i:240;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:239;}i:241;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:239;}i:242;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:241;}i:243;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:239;}i:244;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:243;}i:245;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:239;}i:246;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:245;}i:247;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:239;}i:248;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:247;}i:249;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:220;}i:250;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:220;}i:251;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:220;}i:252;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:220;}i:253;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:220;}i:254;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:220;}i:255;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:220;}i:256;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:220;}i:257;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:220;}i:258;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:257;}i:259;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:219;}i:260;a:2:{s:5:"class";s:0:"";s:6:"parent";i:259;}i:261;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:219;}i:262;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:219;}i:263;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:218;}i:264;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:263;}i:265;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:264;}i:266;a:2:{s:5:"class";s:12:"ilobjchatgui";s:6:"parent";i:1;}i:267;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:266;}i:268;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:267;}i:269;a:2:{s:5:"class";s:0:"";s:6:"parent";i:268;}i:270;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:268;}i:271;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:268;}i:272;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:271;}i:273;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:271;}i:274;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:273;}i:275;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:271;}i:276;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:275;}i:277;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:271;}i:278;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:277;}i:279;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:271;}i:280;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:279;}i:281;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:268;}i:282;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:268;}i:283;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:268;}i:284;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:268;}i:285;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:268;}i:286;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:285;}i:287;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:268;}i:288;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:287;}i:289;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:287;}i:290;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:289;}i:291;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:287;}i:292;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:291;}i:293;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:287;}i:294;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:293;}i:295;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:287;}i:296;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:295;}i:297;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:268;}i:298;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:268;}i:299;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:268;}i:300;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:268;}i:301;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:268;}i:302;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:268;}i:303;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:268;}i:304;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:268;}i:305;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:268;}i:306;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:305;}i:307;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:267;}i:308;a:2:{s:5:"class";s:0:"";s:6:"parent";i:307;}i:309;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:267;}i:310;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:267;}i:311;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:266;}i:312;a:2:{s:5:"class";s:0:"";s:6:"parent";i:311;}i:313;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:266;}i:314;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:313;}i:315;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:314;}i:316;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:266;}i:317;a:2:{s:5:"class";s:14:"ilobjcoursegui";s:6:"parent";i:1;}i:318;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:317;}i:319;a:2:{s:5:"class";s:0:"";s:6:"parent";i:318;}i:320;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:318;}i:321;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:318;}i:322;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:321;}i:323;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:321;}i:324;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:323;}i:325;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:321;}i:326;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:325;}i:327;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:321;}i:328;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:327;}i:329;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:321;}i:330;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:329;}i:331;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:318;}i:332;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:318;}i:333;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:318;}i:334;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:318;}i:335;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:318;}i:336;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:335;}i:337;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:318;}i:338;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:337;}i:339;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:337;}i:340;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:339;}i:341;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:337;}i:342;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:341;}i:343;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:337;}i:344;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:343;}i:345;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:337;}i:346;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:345;}i:347;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:318;}i:348;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:318;}i:349;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:318;}i:350;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:318;}i:351;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:318;}i:352;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:318;}i:353;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:318;}i:354;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:318;}i:355;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:318;}i:356;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:355;}i:357;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:317;}i:358;a:2:{s:5:"class";s:0:"";s:6:"parent";i:357;}i:359;a:2:{s:5:"class";s:20:"ilcourseagreementgui";s:6:"parent";i:317;}i:360;a:2:{s:5:"class";s:0:"";s:6:"parent";i:359;}i:361;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:317;}i:362;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:361;}i:363;a:2:{s:5:"class";s:0:"";s:6:"parent";i:362;}i:364;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:362;}i:365;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:362;}i:366;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:365;}i:367;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:365;}i:368;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:367;}i:369;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:365;}i:370;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:369;}i:371;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:365;}i:372;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:371;}i:373;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:365;}i:374;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:373;}i:375;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:362;}i:376;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:362;}i:377;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:362;}i:378;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:362;}i:379;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:362;}i:380;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:379;}i:381;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:362;}i:382;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:381;}i:383;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:381;}i:384;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:383;}i:385;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:381;}i:386;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:385;}i:387;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:381;}i:388;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:387;}i:389;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:381;}i:390;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:389;}i:391;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:362;}i:392;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:362;}i:393;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:362;}i:394;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:362;}i:395;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:362;}i:396;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:362;}i:397;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:362;}i:398;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:362;}i:399;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:362;}i:400;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:399;}i:401;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:361;}i:402;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:361;}i:403;a:2:{s:5:"class";s:0:"";s:6:"parent";i:402;}i:404;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:317;}i:405;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:404;}i:406;a:2:{s:5:"class";s:0:"";s:6:"parent";i:405;}i:407;a:2:{s:5:"class";s:21:"ilcourseobjectivesgui";s:6:"parent";i:317;}i:408;a:2:{s:5:"class";s:23:"ilcourseregistrationgui";s:6:"parent";i:317;}i:409;a:2:{s:5:"class";s:0:"";s:6:"parent";i:408;}i:410;a:2:{s:5:"class";s:21:"ilcourseuserfieldsgui";s:6:"parent";i:317;}i:411;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:317;}i:412;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:411;}i:413;a:2:{s:5:"class";s:0:"";s:6:"parent";i:412;}i:414;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:412;}i:415;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:412;}i:416;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:415;}i:417;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:415;}i:418;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:417;}i:419;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:415;}i:420;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:419;}i:421;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:415;}i:422;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:421;}i:423;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:415;}i:424;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:423;}i:425;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:412;}i:426;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:412;}i:427;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:412;}i:428;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:412;}i:429;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:412;}i:430;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:429;}i:431;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:412;}i:432;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:431;}i:433;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:431;}i:434;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:433;}i:435;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:431;}i:436;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:435;}i:437;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:431;}i:438;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:437;}i:439;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:431;}i:440;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:439;}i:441;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:412;}i:442;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:412;}i:443;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:412;}i:444;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:412;}i:445;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:412;}i:446;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:412;}i:447;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:412;}i:448;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:412;}i:449;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:412;}i:450;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:449;}i:451;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:411;}i:452;a:2:{s:5:"class";s:0:"";s:6:"parent";i:451;}i:453;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:411;}i:454;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:411;}i:455;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:317;}i:456;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:455;}i:457;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:455;}i:458;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:457;}i:459;a:2:{s:5:"class";s:0:"";s:6:"parent";i:458;}i:460;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:457;}i:461;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:460;}i:462;a:2:{s:5:"class";s:0:"";s:6:"parent";i:461;}i:463;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:461;}i:464;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:457;}i:465;a:2:{s:5:"class";s:0:"";s:6:"parent";i:464;}i:466;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:457;}i:467;a:2:{s:5:"class";s:0:"";s:6:"parent";i:466;}i:468;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:455;}i:469;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:468;}i:470;a:2:{s:5:"class";s:0:"";s:6:"parent";i:469;}i:471;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:468;}i:472;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:471;}i:473;a:2:{s:5:"class";s:0:"";s:6:"parent";i:472;}i:474;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:472;}i:475;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:468;}i:476;a:2:{s:5:"class";s:0:"";s:6:"parent";i:475;}i:477;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:455;}i:478;a:2:{s:5:"class";s:0:"";s:6:"parent";i:477;}i:479;a:2:{s:5:"class";s:20:"illicenseoverviewgui";s:6:"parent";i:317;}i:480;a:2:{s:5:"class";s:0:"";s:6:"parent";i:479;}i:481;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:317;}i:482;a:2:{s:5:"class";s:17:"ilmemberexportgui";s:6:"parent";i:317;}i:483;a:2:{s:5:"class";s:0:"";s:6:"parent";i:482;}i:484;a:2:{s:5:"class";s:22:"ilobjcoursegroupinggui";s:6:"parent";i:317;}i:485;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:317;}i:486;a:2:{s:5:"class";s:0:"";s:6:"parent";i:485;}i:487;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:317;}i:488;a:2:{s:5:"class";s:0:"";s:6:"parent";i:487;}i:489;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:317;}i:490;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:489;}i:491;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:490;}i:492;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:491;}i:493;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:491;}i:494;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:493;}i:495;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:491;}i:496;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:489;}i:497;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:489;}i:498;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:489;}i:499;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:498;}i:500;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:498;}i:501;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:500;}i:502;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:500;}i:503;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:502;}i:504;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:500;}i:505;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:498;}i:506;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:498;}i:507;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:498;}i:508;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:498;}i:509;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:498;}i:510;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:498;}i:511;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:498;}i:512;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:498;}i:513;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:512;}i:514;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:513;}i:515;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:513;}i:516;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:515;}i:517;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:513;}i:518;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:512;}i:519;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:518;}i:520;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:498;}i:521;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:498;}i:522;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:521;}i:523;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:522;}i:524;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:523;}i:525;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:523;}i:526;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:525;}i:527;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:523;}i:528;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:522;}i:529;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:528;}i:530;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:498;}i:531;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:498;}i:532;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:531;}i:533;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:532;}i:534;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:532;}i:535;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:532;}i:536;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:532;}i:537;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:532;}i:538;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:532;}i:539;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:532;}i:540;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:532;}i:541;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:532;}i:542;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:532;}i:543;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:498;}i:544;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:498;}i:545;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:498;}i:546;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:498;}i:547;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:498;}i:548;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:498;}i:549;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:489;}i:550;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:317;}i:551;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:550;}i:552;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:551;}i:553;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:317;}i:554;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:317;}i:555;a:2:{s:5:"class";s:20:"ilsessionoverviewgui";s:6:"parent";i:317;}i:556;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:317;}i:557;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:556;}i:558;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:557;}i:559;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:558;}i:560;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:559;}i:561;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:559;}i:562;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:561;}i:563;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:559;}i:564;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:557;}i:565;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:557;}i:566;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:557;}i:567;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:566;}i:568;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:566;}i:569;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:568;}i:570;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:568;}i:571;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:570;}i:572;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:568;}i:573;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:566;}i:574;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:566;}i:575;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:566;}i:576;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:566;}i:577;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:566;}i:578;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:566;}i:579;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:566;}i:580;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:566;}i:581;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:580;}i:582;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:581;}i:583;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:581;}i:584;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:583;}i:585;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:581;}i:586;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:580;}i:587;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:586;}i:588;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:566;}i:589;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:566;}i:590;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:589;}i:591;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:590;}i:592;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:591;}i:593;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:591;}i:594;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:593;}i:595;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:591;}i:596;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:590;}i:597;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:596;}i:598;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:566;}i:599;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:566;}i:600;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:599;}i:601;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:600;}i:602;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:600;}i:603;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:600;}i:604;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:600;}i:605;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:600;}i:606;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:600;}i:607;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:600;}i:608;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:600;}i:609;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:600;}i:610;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:600;}i:611;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:566;}i:612;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:566;}i:613;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:566;}i:614;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:566;}i:615;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:566;}i:616;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:566;}i:617;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:557;}i:618;a:2:{s:5:"class";s:23:"ilobjcoursereferencegui";s:6:"parent";i:1;}i:619;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:618;}i:620;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:619;}i:621;a:2:{s:5:"class";s:0:"";s:6:"parent";i:620;}i:622;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:620;}i:623;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:620;}i:624;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:623;}i:625;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:623;}i:626;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:625;}i:627;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:623;}i:628;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:627;}i:629;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:623;}i:630;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:629;}i:631;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:623;}i:632;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:631;}i:633;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:620;}i:634;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:620;}i:635;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:620;}i:636;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:620;}i:637;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:620;}i:638;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:637;}i:639;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:620;}i:640;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:639;}i:641;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:639;}i:642;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:641;}i:643;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:639;}i:644;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:643;}i:645;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:639;}i:646;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:645;}i:647;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:639;}i:648;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:647;}i:649;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:620;}i:650;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:620;}i:651;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:620;}i:652;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:620;}i:653;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:620;}i:654;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:620;}i:655;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:620;}i:656;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:620;}i:657;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:620;}i:658;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:657;}i:659;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:619;}i:660;a:2:{s:5:"class";s:0:"";s:6:"parent";i:659;}i:661;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:619;}i:662;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:619;}i:663;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:618;}i:664;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:663;}i:665;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:664;}i:666;a:2:{s:5:"class";s:14:"ilobjdlbookgui";s:6:"parent";i:1;}i:667;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:666;}i:668;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:667;}i:669;a:2:{s:5:"class";s:0:"";s:6:"parent";i:668;}i:670;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:668;}i:671;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:668;}i:672;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:671;}i:673;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:671;}i:674;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:673;}i:675;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:671;}i:676;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:675;}i:677;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:671;}i:678;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:677;}i:679;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:671;}i:680;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:679;}i:681;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:668;}i:682;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:668;}i:683;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:668;}i:684;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:668;}i:685;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:668;}i:686;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:685;}i:687;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:668;}i:688;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:687;}i:689;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:687;}i:690;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:689;}i:691;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:687;}i:692;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:691;}i:693;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:687;}i:694;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:693;}i:695;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:687;}i:696;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:695;}i:697;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:668;}i:698;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:668;}i:699;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:668;}i:700;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:668;}i:701;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:668;}i:702;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:668;}i:703;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:668;}i:704;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:668;}i:705;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:668;}i:706;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:705;}i:707;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:667;}i:708;a:2:{s:5:"class";s:0:"";s:6:"parent";i:707;}i:709;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:667;}i:710;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:667;}i:711;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:666;}i:712;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:711;}i:713;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:711;}i:714;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:713;}i:715;a:2:{s:5:"class";s:0:"";s:6:"parent";i:714;}i:716;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:713;}i:717;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:716;}i:718;a:2:{s:5:"class";s:0:"";s:6:"parent";i:717;}i:719;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:717;}i:720;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:713;}i:721;a:2:{s:5:"class";s:0:"";s:6:"parent";i:720;}i:722;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:713;}i:723;a:2:{s:5:"class";s:0:"";s:6:"parent";i:722;}i:724;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:711;}i:725;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:724;}i:726;a:2:{s:5:"class";s:0:"";s:6:"parent";i:725;}i:727;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:724;}i:728;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:727;}i:729;a:2:{s:5:"class";s:0:"";s:6:"parent";i:728;}i:730;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:728;}i:731;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:724;}i:732;a:2:{s:5:"class";s:0:"";s:6:"parent";i:731;}i:733;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:711;}i:734;a:2:{s:5:"class";s:0:"";s:6:"parent";i:733;}i:735;a:2:{s:5:"class";s:17:"illmpageobjectgui";s:6:"parent";i:666;}i:736;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:735;}i:737;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:736;}i:738;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:737;}i:739;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:738;}i:740;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:738;}i:741;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:740;}i:742;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:738;}i:743;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:736;}i:744;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:736;}i:745;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:736;}i:746;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:745;}i:747;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:745;}i:748;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:747;}i:749;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:747;}i:750;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:749;}i:751;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:747;}i:752;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:745;}i:753;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:745;}i:754;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:745;}i:755;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:745;}i:756;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:745;}i:757;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:745;}i:758;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:745;}i:759;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:745;}i:760;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:759;}i:761;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:760;}i:762;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:760;}i:763;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:762;}i:764;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:760;}i:765;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:759;}i:766;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:765;}i:767;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:745;}i:768;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:745;}i:769;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:768;}i:770;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:769;}i:771;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:770;}i:772;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:770;}i:773;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:772;}i:774;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:770;}i:775;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:769;}i:776;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:775;}i:777;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:745;}i:778;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:745;}i:779;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:778;}i:780;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:779;}i:781;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:779;}i:782;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:779;}i:783;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:779;}i:784;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:779;}i:785;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:779;}i:786;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:779;}i:787;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:779;}i:788;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:779;}i:789;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:779;}i:790;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:745;}i:791;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:745;}i:792;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:745;}i:793;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:745;}i:794;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:745;}i:795;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:745;}i:796;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:736;}i:797;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:666;}i:798;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:666;}i:799;a:2:{s:5:"class";s:0:"";s:6:"parent";i:798;}i:800;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:666;}i:801;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:800;}i:802;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:801;}i:803;a:2:{s:5:"class";s:20:"ilstructureobjectgui";s:6:"parent";i:666;}i:804;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:803;}i:805;a:2:{s:5:"class";s:0:"";s:6:"parent";i:804;}i:806;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:803;}i:807;a:2:{s:5:"class";s:16:"ilobjexercisegui";s:6:"parent";i:1;}i:808;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:807;}i:809;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:808;}i:810;a:2:{s:5:"class";s:0:"";s:6:"parent";i:809;}i:811;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:809;}i:812;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:809;}i:813;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:812;}i:814;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:812;}i:815;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:814;}i:816;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:812;}i:817;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:816;}i:818;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:812;}i:819;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:818;}i:820;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:812;}i:821;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:820;}i:822;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:809;}i:823;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:809;}i:824;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:809;}i:825;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:809;}i:826;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:809;}i:827;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:826;}i:828;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:809;}i:829;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:828;}i:830;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:828;}i:831;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:830;}i:832;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:828;}i:833;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:832;}i:834;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:828;}i:835;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:834;}i:836;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:828;}i:837;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:836;}i:838;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:809;}i:839;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:809;}i:840;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:809;}i:841;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:809;}i:842;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:809;}i:843;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:809;}i:844;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:809;}i:845;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:809;}i:846;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:809;}i:847;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:846;}i:848;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:808;}i:849;a:2:{s:5:"class";s:0:"";s:6:"parent";i:848;}i:850;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:808;}i:851;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:808;}i:852;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:807;}i:853;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:852;}i:854;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:852;}i:855;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:854;}i:856;a:2:{s:5:"class";s:0:"";s:6:"parent";i:855;}i:857;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:854;}i:858;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:857;}i:859;a:2:{s:5:"class";s:0:"";s:6:"parent";i:858;}i:860;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:858;}i:861;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:854;}i:862;a:2:{s:5:"class";s:0:"";s:6:"parent";i:861;}i:863;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:854;}i:864;a:2:{s:5:"class";s:0:"";s:6:"parent";i:863;}i:865;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:852;}i:866;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:865;}i:867;a:2:{s:5:"class";s:0:"";s:6:"parent";i:866;}i:868;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:865;}i:869;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:868;}i:870;a:2:{s:5:"class";s:0:"";s:6:"parent";i:869;}i:871;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:869;}i:872;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:865;}i:873;a:2:{s:5:"class";s:0:"";s:6:"parent";i:872;}i:874;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:852;}i:875;a:2:{s:5:"class";s:0:"";s:6:"parent";i:874;}i:876;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:807;}i:877;a:2:{s:5:"class";s:0:"";s:6:"parent";i:876;}i:878;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:807;}i:879;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:878;}i:880;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:879;}i:881;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:807;}i:882;a:2:{s:5:"class";s:20:"ilobjexternalfeedgui";s:6:"parent";i:1;}i:883;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:882;}i:884;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:882;}i:885;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:884;}i:886;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:885;}i:887;a:2:{s:5:"class";s:19:"ilobjfilebasedlmgui";s:6:"parent";i:1;}i:888;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:887;}i:889;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:887;}i:890;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:889;}i:891;a:2:{s:5:"class";s:0:"";s:6:"parent";i:890;}i:892;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:890;}i:893;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:890;}i:894;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:893;}i:895;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:893;}i:896;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:895;}i:897;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:893;}i:898;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:897;}i:899;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:893;}i:900;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:899;}i:901;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:893;}i:902;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:901;}i:903;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:890;}i:904;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:890;}i:905;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:890;}i:906;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:890;}i:907;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:890;}i:908;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:907;}i:909;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:890;}i:910;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:909;}i:911;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:909;}i:912;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:911;}i:913;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:909;}i:914;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:913;}i:915;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:909;}i:916;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:915;}i:917;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:909;}i:918;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:917;}i:919;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:890;}i:920;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:890;}i:921;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:890;}i:922;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:890;}i:923;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:890;}i:924;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:890;}i:925;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:890;}i:926;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:890;}i:927;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:890;}i:928;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:927;}i:929;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:889;}i:930;a:2:{s:5:"class";s:0:"";s:6:"parent";i:929;}i:931;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:889;}i:932;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:889;}i:933;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:887;}i:934;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:933;}i:935;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:933;}i:936;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:935;}i:937;a:2:{s:5:"class";s:0:"";s:6:"parent";i:936;}i:938;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:935;}i:939;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:938;}i:940;a:2:{s:5:"class";s:0:"";s:6:"parent";i:939;}i:941;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:939;}i:942;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:935;}i:943;a:2:{s:5:"class";s:0:"";s:6:"parent";i:942;}i:944;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:935;}i:945;a:2:{s:5:"class";s:0:"";s:6:"parent";i:944;}i:946;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:933;}i:947;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:946;}i:948;a:2:{s:5:"class";s:0:"";s:6:"parent";i:947;}i:949;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:946;}i:950;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:949;}i:951;a:2:{s:5:"class";s:0:"";s:6:"parent";i:950;}i:952;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:950;}i:953;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:946;}i:954;a:2:{s:5:"class";s:0:"";s:6:"parent";i:953;}i:955;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:933;}i:956;a:2:{s:5:"class";s:0:"";s:6:"parent";i:955;}i:957;a:2:{s:5:"class";s:12:"illicensegui";s:6:"parent";i:887;}i:958;a:2:{s:5:"class";s:0:"";s:6:"parent";i:957;}i:959;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:887;}i:960;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:887;}i:961;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:960;}i:962;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:961;}i:963;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:887;}i:964;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:963;}i:965;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:964;}i:966;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:965;}i:967;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:966;}i:968;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:966;}i:969;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:968;}i:970;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:966;}i:971;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:964;}i:972;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:964;}i:973;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:964;}i:974;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:973;}i:975;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:973;}i:976;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:975;}i:977;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:975;}i:978;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:977;}i:979;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:975;}i:980;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:973;}i:981;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:973;}i:982;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:973;}i:983;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:973;}i:984;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:973;}i:985;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:973;}i:986;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:973;}i:987;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:973;}i:988;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:987;}i:989;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:988;}i:990;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:988;}i:991;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:990;}i:992;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:988;}i:993;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:987;}i:994;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:993;}i:995;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:973;}i:996;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:973;}i:997;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:996;}i:998;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:997;}i:999;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:998;}i:1000;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:998;}i:1001;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1000;}i:1002;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:998;}i:1003;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:997;}i:1004;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1003;}i:1005;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:973;}i:1006;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:973;}i:1007;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1006;}i:1008;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1007;}i:1009;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1007;}i:1010;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1007;}i:1011;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1007;}i:1012;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1007;}i:1013;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1007;}i:1014;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1007;}i:1015;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1007;}i:1016;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1007;}i:1017;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1007;}i:1018;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:973;}i:1019;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:973;}i:1020;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:973;}i:1021;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:973;}i:1022;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:973;}i:1023;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:973;}i:1024;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:964;}i:1025;a:2:{s:5:"class";s:12:"ilobjfilegui";s:6:"parent";i:1;}i:1026;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1025;}i:1027;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1026;}i:1028;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1027;}i:1029;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1027;}i:1030;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1027;}i:1031;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1030;}i:1032;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1030;}i:1033;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1032;}i:1034;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1030;}i:1035;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1034;}i:1036;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1030;}i:1037;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1036;}i:1038;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1030;}i:1039;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1038;}i:1040;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1027;}i:1041;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1027;}i:1042;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1027;}i:1043;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1027;}i:1044;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1027;}i:1045;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1044;}i:1046;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1027;}i:1047;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1046;}i:1048;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1046;}i:1049;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1048;}i:1050;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1046;}i:1051;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1050;}i:1052;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1046;}i:1053;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1052;}i:1054;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1046;}i:1055;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1054;}i:1056;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1027;}i:1057;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1027;}i:1058;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1027;}i:1059;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1027;}i:1060;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1027;}i:1061;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1027;}i:1062;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1027;}i:1063;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1027;}i:1064;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1027;}i:1065;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1064;}i:1066;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1026;}i:1067;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1066;}i:1068;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1026;}i:1069;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1026;}i:1070;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1025;}i:1071;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1025;}i:1072;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1071;}i:1073;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1025;}i:1074;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1073;}i:1075;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1074;}i:1076;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:1025;}i:1077;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1076;}i:1078;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1077;}i:1079;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1078;}i:1080;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1079;}i:1081;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1079;}i:1082;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1081;}i:1083;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1079;}i:1084;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1077;}i:1085;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1077;}i:1086;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1077;}i:1087;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1086;}i:1088;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1086;}i:1089;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1088;}i:1090;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1088;}i:1091;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1090;}i:1092;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1088;}i:1093;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1086;}i:1094;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1086;}i:1095;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1086;}i:1096;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1086;}i:1097;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1086;}i:1098;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1086;}i:1099;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1086;}i:1100;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1086;}i:1101;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1100;}i:1102;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1101;}i:1103;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1101;}i:1104;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1103;}i:1105;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1101;}i:1106;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1100;}i:1107;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1106;}i:1108;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1086;}i:1109;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1086;}i:1110;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1109;}i:1111;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1110;}i:1112;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1111;}i:1113;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1111;}i:1114;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1113;}i:1115;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1111;}i:1116;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1110;}i:1117;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1116;}i:1118;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1086;}i:1119;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1086;}i:1120;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1119;}i:1121;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1120;}i:1122;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1120;}i:1123;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1120;}i:1124;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1120;}i:1125;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1120;}i:1126;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1120;}i:1127;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1120;}i:1128;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1120;}i:1129;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1120;}i:1130;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1120;}i:1131;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1086;}i:1132;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1086;}i:1133;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1086;}i:1134;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1086;}i:1135;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1086;}i:1136;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1086;}i:1137;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1077;}i:1138;a:2:{s:5:"class";s:14:"ilobjfoldergui";s:6:"parent";i:1;}i:1139;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1138;}i:1140;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1139;}i:1141;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1139;}i:1142;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1139;}i:1143;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1142;}i:1144;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1142;}i:1145;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1144;}i:1146;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1142;}i:1147;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1146;}i:1148;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1142;}i:1149;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1148;}i:1150;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1142;}i:1151;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1150;}i:1152;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1139;}i:1153;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1139;}i:1154;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1139;}i:1155;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1139;}i:1156;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1139;}i:1157;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1156;}i:1158;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1139;}i:1159;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1158;}i:1160;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1158;}i:1161;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1160;}i:1162;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1158;}i:1163;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1162;}i:1164;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1158;}i:1165;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1164;}i:1166;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1158;}i:1167;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1166;}i:1168;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1139;}i:1169;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1139;}i:1170;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1139;}i:1171;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1139;}i:1172;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1139;}i:1173;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1139;}i:1174;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1139;}i:1175;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1139;}i:1176;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1139;}i:1177;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1176;}i:1178;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1138;}i:1179;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1178;}i:1180;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:1138;}i:1181;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1180;}i:1182;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1181;}i:1183;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1181;}i:1184;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1181;}i:1185;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1184;}i:1186;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1184;}i:1187;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1186;}i:1188;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1184;}i:1189;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1188;}i:1190;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1184;}i:1191;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1190;}i:1192;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1184;}i:1193;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1192;}i:1194;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1181;}i:1195;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1181;}i:1196;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1181;}i:1197;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1181;}i:1198;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1181;}i:1199;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1198;}i:1200;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1181;}i:1201;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1200;}i:1202;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1200;}i:1203;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1202;}i:1204;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1200;}i:1205;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1204;}i:1206;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1200;}i:1207;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1206;}i:1208;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1200;}i:1209;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1208;}i:1210;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1181;}i:1211;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1181;}i:1212;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1181;}i:1213;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1181;}i:1214;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1181;}i:1215;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1181;}i:1216;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1181;}i:1217;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1181;}i:1218;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1181;}i:1219;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1218;}i:1220;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:1180;}i:1221;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:1180;}i:1222;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1221;}i:1223;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:1138;}i:1224;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1223;}i:1225;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1224;}i:1226;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1138;}i:1227;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1226;}i:1228;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1227;}i:1229;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1227;}i:1230;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1227;}i:1231;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1230;}i:1232;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1230;}i:1233;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1232;}i:1234;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1230;}i:1235;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1234;}i:1236;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1230;}i:1237;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1236;}i:1238;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1230;}i:1239;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1238;}i:1240;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1227;}i:1241;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1227;}i:1242;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1227;}i:1243;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1227;}i:1244;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1227;}i:1245;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1244;}i:1246;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1227;}i:1247;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1246;}i:1248;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1246;}i:1249;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1248;}i:1250;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1246;}i:1251;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1250;}i:1252;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1246;}i:1253;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1252;}i:1254;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1246;}i:1255;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1254;}i:1256;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1227;}i:1257;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1227;}i:1258;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1227;}i:1259;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1227;}i:1260;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1227;}i:1261;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1227;}i:1262;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1227;}i:1263;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1227;}i:1264;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1227;}i:1265;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1264;}i:1266;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1226;}i:1267;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1266;}i:1268;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1226;}i:1269;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1226;}i:1270;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:1138;}i:1271;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:1270;}i:1272;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:1270;}i:1273;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1272;}i:1274;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1273;}i:1275;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:1272;}i:1276;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1275;}i:1277;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1276;}i:1278;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1276;}i:1279;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1272;}i:1280;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1279;}i:1281;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:1272;}i:1282;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1281;}i:1283;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:1270;}i:1284;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1283;}i:1285;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1284;}i:1286;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:1283;}i:1287;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1286;}i:1288;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1287;}i:1289;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1287;}i:1290;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1283;}i:1291;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1290;}i:1292;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:1270;}i:1293;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1292;}i:1294;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1138;}i:1295;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1294;}i:1296;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:1138;}i:1297;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1296;}i:1298;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1138;}i:1299;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1298;}i:1300;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1299;}i:1301;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1300;}i:1302;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1300;}i:1303;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1302;}i:1304;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1300;}i:1305;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1298;}i:1306;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1298;}i:1307;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1298;}i:1308;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1307;}i:1309;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1307;}i:1310;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1309;}i:1311;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1309;}i:1312;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1311;}i:1313;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1309;}i:1314;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1307;}i:1315;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1307;}i:1316;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1307;}i:1317;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1307;}i:1318;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1307;}i:1319;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1307;}i:1320;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1307;}i:1321;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1307;}i:1322;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1321;}i:1323;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1322;}i:1324;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1322;}i:1325;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1324;}i:1326;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1322;}i:1327;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1321;}i:1328;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1327;}i:1329;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1307;}i:1330;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1307;}i:1331;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1330;}i:1332;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1331;}i:1333;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1332;}i:1334;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1332;}i:1335;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1334;}i:1336;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1332;}i:1337;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1331;}i:1338;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1337;}i:1339;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1307;}i:1340;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1307;}i:1341;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1340;}i:1342;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1341;}i:1343;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1341;}i:1344;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1341;}i:1345;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1341;}i:1346;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1341;}i:1347;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1341;}i:1348;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1341;}i:1349;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1341;}i:1350;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1341;}i:1351;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1341;}i:1352;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1307;}i:1353;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1307;}i:1354;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1307;}i:1355;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1307;}i:1356;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1307;}i:1357;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1307;}i:1358;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1298;}i:1359;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1138;}i:1360;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1359;}i:1361;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1360;}i:1362;a:2:{s:5:"class";s:13:"ilobjforumgui";s:6:"parent";i:1;}i:1363;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1362;}i:1364;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1363;}i:1365;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1363;}i:1366;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1363;}i:1367;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1366;}i:1368;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1366;}i:1369;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1368;}i:1370;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1366;}i:1371;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1370;}i:1372;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1366;}i:1373;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1372;}i:1374;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1366;}i:1375;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1374;}i:1376;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1363;}i:1377;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1363;}i:1378;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1363;}i:1379;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1363;}i:1380;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1363;}i:1381;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1380;}i:1382;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1363;}i:1383;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1382;}i:1384;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1382;}i:1385;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1384;}i:1386;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1382;}i:1387;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1386;}i:1388;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1382;}i:1389;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1388;}i:1390;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1382;}i:1391;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1390;}i:1392;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1363;}i:1393;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1363;}i:1394;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1363;}i:1395;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1363;}i:1396;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1363;}i:1397;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1363;}i:1398;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1363;}i:1399;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1363;}i:1400;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1363;}i:1401;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1400;}i:1402;a:2:{s:5:"class";s:16:"ilforumexportgui";s:6:"parent";i:1362;}i:1403;a:2:{s:5:"class";s:20:"ilforummoderatorsgui";s:6:"parent";i:1362;}i:1404;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1362;}i:1405;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1404;}i:1406;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1405;}i:1407;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1405;}i:1408;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1405;}i:1409;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1408;}i:1410;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1408;}i:1411;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1410;}i:1412;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1408;}i:1413;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1412;}i:1414;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1408;}i:1415;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1414;}i:1416;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1408;}i:1417;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1416;}i:1418;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1405;}i:1419;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1405;}i:1420;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1405;}i:1421;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1405;}i:1422;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1405;}i:1423;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1422;}i:1424;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1405;}i:1425;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1424;}i:1426;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1424;}i:1427;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1426;}i:1428;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1424;}i:1429;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1428;}i:1430;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1424;}i:1431;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1430;}i:1432;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1424;}i:1433;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1432;}i:1434;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1405;}i:1435;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1405;}i:1436;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1405;}i:1437;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1405;}i:1438;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1405;}i:1439;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1405;}i:1440;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1405;}i:1441;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1405;}i:1442;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1405;}i:1443;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1442;}i:1444;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1404;}i:1445;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1444;}i:1446;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1404;}i:1447;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1404;}i:1448;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1362;}i:1449;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1448;}i:1450;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1362;}i:1451;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1450;}i:1452;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1451;}i:1453;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1362;}i:1454;a:2:{s:5:"class";s:16:"ilobjglossarygui";s:6:"parent";i:1;}i:1455;a:2:{s:5:"class";s:17:"ilglossarytermgui";s:6:"parent";i:1454;}i:1456;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1455;}i:1457;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1456;}i:1458;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1457;}i:1459;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1458;}i:1460;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1458;}i:1461;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1460;}i:1462;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1458;}i:1463;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1456;}i:1464;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1456;}i:1465;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1456;}i:1466;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1465;}i:1467;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1465;}i:1468;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1467;}i:1469;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1467;}i:1470;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1469;}i:1471;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1467;}i:1472;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1465;}i:1473;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1465;}i:1474;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1465;}i:1475;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1465;}i:1476;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1465;}i:1477;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1465;}i:1478;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1465;}i:1479;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1465;}i:1480;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1479;}i:1481;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1480;}i:1482;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1480;}i:1483;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1482;}i:1484;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1480;}i:1485;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1479;}i:1486;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1485;}i:1487;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1465;}i:1488;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1465;}i:1489;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1488;}i:1490;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1489;}i:1491;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1490;}i:1492;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1490;}i:1493;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1492;}i:1494;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1490;}i:1495;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1489;}i:1496;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1495;}i:1497;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1465;}i:1498;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1465;}i:1499;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1498;}i:1500;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1499;}i:1501;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1499;}i:1502;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1499;}i:1503;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1499;}i:1504;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1499;}i:1505;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1499;}i:1506;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1499;}i:1507;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1499;}i:1508;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1499;}i:1509;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1499;}i:1510;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1465;}i:1511;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1465;}i:1512;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1465;}i:1513;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1465;}i:1514;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1465;}i:1515;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1465;}i:1516;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1456;}i:1517;a:2:{s:5:"class";s:25:"iltermdefinitioneditorgui";s:6:"parent";i:1455;}i:1518;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1517;}i:1519;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1517;}i:1520;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1519;}i:1521;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1520;}i:1522;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1521;}i:1523;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1521;}i:1524;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1523;}i:1525;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1521;}i:1526;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1519;}i:1527;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1519;}i:1528;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1519;}i:1529;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1528;}i:1530;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1528;}i:1531;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1530;}i:1532;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1530;}i:1533;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1532;}i:1534;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1530;}i:1535;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1528;}i:1536;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1528;}i:1537;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1528;}i:1538;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1528;}i:1539;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1528;}i:1540;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1528;}i:1541;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1528;}i:1542;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1528;}i:1543;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1542;}i:1544;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1543;}i:1545;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1543;}i:1546;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1545;}i:1547;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1543;}i:1548;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1542;}i:1549;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1548;}i:1550;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1528;}i:1551;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1528;}i:1552;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1551;}i:1553;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1552;}i:1554;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1553;}i:1555;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1553;}i:1556;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1555;}i:1557;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1553;}i:1558;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1552;}i:1559;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1558;}i:1560;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1528;}i:1561;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1528;}i:1562;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1561;}i:1563;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1562;}i:1564;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1562;}i:1565;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1562;}i:1566;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1562;}i:1567;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1562;}i:1568;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1562;}i:1569;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1562;}i:1570;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1562;}i:1571;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1562;}i:1572;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1562;}i:1573;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1528;}i:1574;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1528;}i:1575;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1528;}i:1576;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1528;}i:1577;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1528;}i:1578;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1528;}i:1579;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1519;}i:1580;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1454;}i:1581;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1580;}i:1582;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1581;}i:1583;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1581;}i:1584;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1581;}i:1585;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1584;}i:1586;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1584;}i:1587;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1586;}i:1588;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1584;}i:1589;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1588;}i:1590;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1584;}i:1591;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1590;}i:1592;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1584;}i:1593;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1592;}i:1594;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1581;}i:1595;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1581;}i:1596;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1581;}i:1597;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1581;}i:1598;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1581;}i:1599;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1598;}i:1600;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1581;}i:1601;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1600;}i:1602;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1600;}i:1603;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1602;}i:1604;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1600;}i:1605;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1604;}i:1606;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1600;}i:1607;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1606;}i:1608;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1600;}i:1609;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1608;}i:1610;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1581;}i:1611;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1581;}i:1612;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1581;}i:1613;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1581;}i:1614;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1581;}i:1615;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1581;}i:1616;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1581;}i:1617;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1581;}i:1618;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1581;}i:1619;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1618;}i:1620;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1580;}i:1621;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1620;}i:1622;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1580;}i:1623;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1580;}i:1624;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1454;}i:1625;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1454;}i:1626;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1625;}i:1627;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1626;}i:1628;a:2:{s:5:"class";s:13:"ilobjgroupgui";s:6:"parent";i:1;}i:1629;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1628;}i:1630;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1628;}i:1631;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1630;}i:1632;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1630;}i:1633;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1630;}i:1634;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1633;}i:1635;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1633;}i:1636;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1635;}i:1637;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1633;}i:1638;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1637;}i:1639;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1633;}i:1640;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1639;}i:1641;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1633;}i:1642;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1641;}i:1643;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1630;}i:1644;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1630;}i:1645;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1630;}i:1646;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1630;}i:1647;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1630;}i:1648;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1647;}i:1649;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1630;}i:1650;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1649;}i:1651;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1649;}i:1652;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1651;}i:1653;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1649;}i:1654;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1653;}i:1655;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1649;}i:1656;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1655;}i:1657;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1649;}i:1658;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1657;}i:1659;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1630;}i:1660;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1630;}i:1661;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1630;}i:1662;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1630;}i:1663;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1630;}i:1664;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1630;}i:1665;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1630;}i:1666;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1630;}i:1667;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1630;}i:1668;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1667;}i:1669;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1628;}i:1670;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1669;}i:1671;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:1628;}i:1672;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1671;}i:1673;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1672;}i:1674;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1672;}i:1675;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1672;}i:1676;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1675;}i:1677;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1675;}i:1678;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1677;}i:1679;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1675;}i:1680;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1679;}i:1681;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1675;}i:1682;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1681;}i:1683;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1675;}i:1684;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1683;}i:1685;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1672;}i:1686;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1672;}i:1687;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1672;}i:1688;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1672;}i:1689;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1672;}i:1690;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1689;}i:1691;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1672;}i:1692;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1691;}i:1693;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1691;}i:1694;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1693;}i:1695;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1691;}i:1696;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1695;}i:1697;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1691;}i:1698;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1697;}i:1699;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1691;}i:1700;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1699;}i:1701;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1672;}i:1702;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1672;}i:1703;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1672;}i:1704;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1672;}i:1705;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1672;}i:1706;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1672;}i:1707;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1672;}i:1708;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1672;}i:1709;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1672;}i:1710;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1709;}i:1711;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:1671;}i:1712;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:1671;}i:1713;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1712;}i:1714;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:1628;}i:1715;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1714;}i:1716;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1715;}i:1717;a:2:{s:5:"class";s:22:"ilgroupregistrationgui";s:6:"parent";i:1628;}i:1718;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1628;}i:1719;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1718;}i:1720;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1719;}i:1721;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1719;}i:1722;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1719;}i:1723;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1722;}i:1724;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1722;}i:1725;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1724;}i:1726;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1722;}i:1727;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1726;}i:1728;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1722;}i:1729;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1728;}i:1730;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1722;}i:1731;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1730;}i:1732;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1719;}i:1733;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1719;}i:1734;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1719;}i:1735;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1719;}i:1736;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1719;}i:1737;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1736;}i:1738;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1719;}i:1739;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1738;}i:1740;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1738;}i:1741;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1740;}i:1742;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1738;}i:1743;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1742;}i:1744;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1738;}i:1745;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1744;}i:1746;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1738;}i:1747;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1746;}i:1748;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1719;}i:1749;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1719;}i:1750;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1719;}i:1751;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1719;}i:1752;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1719;}i:1753;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1719;}i:1754;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1719;}i:1755;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1719;}i:1756;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1719;}i:1757;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1756;}i:1758;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1718;}i:1759;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1758;}i:1760;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1718;}i:1761;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1718;}i:1762;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:1628;}i:1763;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:1762;}i:1764;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:1762;}i:1765;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1764;}i:1766;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1765;}i:1767;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:1764;}i:1768;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1767;}i:1769;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1768;}i:1770;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1768;}i:1771;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1764;}i:1772;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1771;}i:1773;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:1764;}i:1774;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1773;}i:1775;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:1762;}i:1776;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1775;}i:1777;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1776;}i:1778;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:1775;}i:1779;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1778;}i:1780;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1779;}i:1781;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1779;}i:1782;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1775;}i:1783;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1782;}i:1784;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:1762;}i:1785;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1784;}i:1786;a:2:{s:5:"class";s:22:"ilobjcoursegroupinggui";s:6:"parent";i:1628;}i:1787;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1628;}i:1788;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1787;}i:1789;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:1628;}i:1790;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1789;}i:1791;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1628;}i:1792;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1791;}i:1793;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1792;}i:1794;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1793;}i:1795;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1793;}i:1796;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1795;}i:1797;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1793;}i:1798;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1791;}i:1799;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1791;}i:1800;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1791;}i:1801;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1800;}i:1802;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1800;}i:1803;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1802;}i:1804;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1802;}i:1805;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1804;}i:1806;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1802;}i:1807;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1800;}i:1808;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1800;}i:1809;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1800;}i:1810;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1800;}i:1811;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1800;}i:1812;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1800;}i:1813;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1800;}i:1814;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1800;}i:1815;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1814;}i:1816;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1815;}i:1817;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1815;}i:1818;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1817;}i:1819;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1815;}i:1820;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1814;}i:1821;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1820;}i:1822;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1800;}i:1823;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1800;}i:1824;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1823;}i:1825;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1824;}i:1826;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1825;}i:1827;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1825;}i:1828;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1827;}i:1829;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1825;}i:1830;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1824;}i:1831;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1830;}i:1832;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1800;}i:1833;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1800;}i:1834;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1833;}i:1835;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1834;}i:1836;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1834;}i:1837;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1834;}i:1838;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1834;}i:1839;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1834;}i:1840;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1834;}i:1841;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1834;}i:1842;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1834;}i:1843;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1834;}i:1844;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1834;}i:1845;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1800;}i:1846;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1800;}i:1847;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1800;}i:1848;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1800;}i:1849;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1800;}i:1850;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1800;}i:1851;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1791;}i:1852;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1628;}i:1853;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1852;}i:1854;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1853;}i:1855;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1628;}i:1856;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1628;}i:1857;a:2:{s:5:"class";s:22:"ilobjilincclassroomgui";s:6:"parent";i:1;}i:1858;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1857;}i:1859;a:2:{s:5:"class";s:19:"ilobjilinccoursegui";s:6:"parent";i:1;}i:1860;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1859;}i:1861;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1860;}i:1862;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1860;}i:1863;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1860;}i:1864;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1863;}i:1865;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1863;}i:1866;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1865;}i:1867;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1863;}i:1868;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1867;}i:1869;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1863;}i:1870;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1869;}i:1871;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1863;}i:1872;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1871;}i:1873;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1860;}i:1874;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1860;}i:1875;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1860;}i:1876;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1860;}i:1877;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1860;}i:1878;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1877;}i:1879;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1860;}i:1880;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1879;}i:1881;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1879;}i:1882;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1881;}i:1883;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1879;}i:1884;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1883;}i:1885;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1879;}i:1886;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1885;}i:1887;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1879;}i:1888;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1887;}i:1889;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1860;}i:1890;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1860;}i:1891;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1860;}i:1892;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1860;}i:1893;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1860;}i:1894;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1860;}i:1895;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1860;}i:1896;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1860;}i:1897;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1860;}i:1898;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1897;}i:1899;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1859;}i:1900;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1899;}i:1901;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1900;}i:1902;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1900;}i:1903;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1900;}i:1904;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1903;}i:1905;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1903;}i:1906;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1905;}i:1907;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1903;}i:1908;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1907;}i:1909;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1903;}i:1910;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1909;}i:1911;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1903;}i:1912;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1911;}i:1913;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1900;}i:1914;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1900;}i:1915;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1900;}i:1916;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1900;}i:1917;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1900;}i:1918;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1917;}i:1919;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1900;}i:1920;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1919;}i:1921;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1919;}i:1922;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1921;}i:1923;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1919;}i:1924;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1923;}i:1925;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1919;}i:1926;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1925;}i:1927;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1919;}i:1928;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1927;}i:1929;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1900;}i:1930;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1900;}i:1931;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1900;}i:1932;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1900;}i:1933;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1900;}i:1934;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1900;}i:1935;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1900;}i:1936;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1900;}i:1937;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1900;}i:1938;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1937;}i:1939;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1899;}i:1940;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1939;}i:1941;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1899;}i:1942;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1899;}i:1943;a:2:{s:5:"class";s:22:"ilobjilincclassroomgui";s:6:"parent";i:1859;}i:1944;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1943;}i:1945;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1859;}i:1946;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1945;}i:1947;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1946;}i:1948;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1859;}i:1949;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1859;}i:1950;a:2:{s:5:"class";s:22:"ilobjlearningmodulegui";s:6:"parent";i:1;}i:1951;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1950;}i:1952;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1951;}i:1953;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1952;}i:1954;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1952;}i:1955;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1952;}i:1956;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1955;}i:1957;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1955;}i:1958;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1957;}i:1959;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1955;}i:1960;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1959;}i:1961;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1955;}i:1962;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1961;}i:1963;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1955;}i:1964;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1963;}i:1965;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1952;}i:1966;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1952;}i:1967;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1952;}i:1968;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1952;}i:1969;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1952;}i:1970;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1969;}i:1971;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1952;}i:1972;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1971;}i:1973;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1971;}i:1974;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1973;}i:1975;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1971;}i:1976;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1975;}i:1977;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1971;}i:1978;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1977;}i:1979;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1971;}i:1980;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1979;}i:1981;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1952;}i:1982;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1952;}i:1983;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1952;}i:1984;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1952;}i:1985;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1952;}i:1986;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1952;}i:1987;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1952;}i:1988;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1952;}i:1989;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1952;}i:1990;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1989;}i:1991;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1951;}i:1992;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1991;}i:1993;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1951;}i:1994;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1951;}i:1995;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:1950;}i:1996;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:1995;}i:1997;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:1995;}i:1998;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1997;}i:1999;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1998;}i:2000;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:1997;}i:2001;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2000;}i:2002;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2001;}i:2003;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2001;}i:2004;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1997;}i:2005;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2004;}i:2006;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:1997;}i:2007;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2006;}i:2008;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:1995;}i:2009;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2008;}i:2010;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2009;}i:2011;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:2008;}i:2012;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2011;}i:2013;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2012;}i:2014;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2012;}i:2015;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2008;}i:2016;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2015;}i:2017;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:1995;}i:2018;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2017;}i:2019;a:2:{s:5:"class";s:17:"illmpageobjectgui";s:6:"parent";i:1950;}i:2020;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2019;}i:2021;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2020;}i:2022;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2021;}i:2023;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2022;}i:2024;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2022;}i:2025;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2024;}i:2026;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2022;}i:2027;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2020;}i:2028;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2020;}i:2029;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2020;}i:2030;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2029;}i:2031;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2029;}i:2032;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2031;}i:2033;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2031;}i:2034;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2033;}i:2035;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2031;}i:2036;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2029;}i:2037;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2029;}i:2038;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2029;}i:2039;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2029;}i:2040;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2029;}i:2041;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2029;}i:2042;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2029;}i:2043;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2029;}i:2044;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2043;}i:2045;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2044;}i:2046;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2044;}i:2047;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2046;}i:2048;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2044;}i:2049;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2043;}i:2050;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2049;}i:2051;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2029;}i:2052;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2029;}i:2053;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2052;}i:2054;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2053;}i:2055;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2054;}i:2056;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2054;}i:2057;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2056;}i:2058;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2054;}i:2059;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2053;}i:2060;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2059;}i:2061;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2029;}i:2062;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2029;}i:2063;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2062;}i:2064;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2063;}i:2065;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2063;}i:2066;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2063;}i:2067;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2063;}i:2068;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2063;}i:2069;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2063;}i:2070;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2063;}i:2071;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2063;}i:2072;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2063;}i:2073;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2063;}i:2074;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2029;}i:2075;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2029;}i:2076;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2029;}i:2077;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2029;}i:2078;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2029;}i:2079;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2029;}i:2080;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2020;}i:2081;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1950;}i:2082;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:1950;}i:2083;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2082;}i:2084;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1950;}i:2085;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2084;}i:2086;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2085;}i:2087;a:2:{s:5:"class";s:20:"ilstructureobjectgui";s:6:"parent";i:1950;}i:2088;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:2087;}i:2089;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2088;}i:2090;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2087;}i:2091;a:2:{s:5:"class";s:20:"ilobjlinkresourcegui";s:6:"parent";i:1;}i:2092;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2091;}i:2093;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2092;}i:2094;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2093;}i:2095;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2093;}i:2096;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2093;}i:2097;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2096;}i:2098;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2096;}i:2099;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2098;}i:2100;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2096;}i:2101;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2100;}i:2102;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2096;}i:2103;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2102;}i:2104;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2096;}i:2105;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2104;}i:2106;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2093;}i:2107;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2093;}i:2108;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2093;}i:2109;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2093;}i:2110;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2093;}i:2111;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2110;}i:2112;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2093;}i:2113;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2112;}i:2114;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2112;}i:2115;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2114;}i:2116;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2112;}i:2117;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2116;}i:2118;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2112;}i:2119;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2118;}i:2120;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2112;}i:2121;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2120;}i:2122;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2093;}i:2123;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2093;}i:2124;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2093;}i:2125;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2093;}i:2126;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2093;}i:2127;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2093;}i:2128;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2093;}i:2129;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2093;}i:2130;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2093;}i:2131;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2130;}i:2132;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2092;}i:2133;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2132;}i:2134;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2092;}i:2135;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2092;}i:2136;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2091;}i:2137;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2091;}i:2138;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2137;}i:2139;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2091;}i:2140;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2139;}i:2141;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2140;}i:2142;a:2:{s:5:"class";s:17:"ilobjmediacastgui";s:6:"parent";i:1;}i:2143;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2142;}i:2144;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2143;}i:2145;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2144;}i:2146;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2144;}i:2147;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2144;}i:2148;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2147;}i:2149;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2147;}i:2150;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2149;}i:2151;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2147;}i:2152;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2151;}i:2153;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2147;}i:2154;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2153;}i:2155;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2147;}i:2156;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2155;}i:2157;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2144;}i:2158;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2144;}i:2159;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2144;}i:2160;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2144;}i:2161;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2144;}i:2162;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2161;}i:2163;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2144;}i:2164;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2163;}i:2165;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2163;}i:2166;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2165;}i:2167;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2163;}i:2168;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2167;}i:2169;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2163;}i:2170;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2169;}i:2171;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2163;}i:2172;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2171;}i:2173;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2144;}i:2174;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2144;}i:2175;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2144;}i:2176;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2144;}i:2177;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2144;}i:2178;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2144;}i:2179;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2144;}i:2180;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2144;}i:2181;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2144;}i:2182;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2181;}i:2183;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2143;}i:2184;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2183;}i:2185;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2143;}i:2186;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2143;}i:2187;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2142;}i:2188;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2187;}i:2189;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2188;}i:2190;a:2:{s:5:"class";s:17:"ilobjmediapoolgui";s:6:"parent";i:1;}i:2191;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2190;}i:2192;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2191;}i:2193;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2192;}i:2194;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2192;}i:2195;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2194;}i:2196;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2192;}i:2197;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2190;}i:2198;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2197;}i:2199;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2198;}i:2200;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2198;}i:2201;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2198;}i:2202;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2201;}i:2203;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2201;}i:2204;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2203;}i:2205;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2201;}i:2206;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2205;}i:2207;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2201;}i:2208;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2207;}i:2209;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2201;}i:2210;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2209;}i:2211;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2198;}i:2212;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2198;}i:2213;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2198;}i:2214;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2198;}i:2215;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2198;}i:2216;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2215;}i:2217;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2198;}i:2218;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2217;}i:2219;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2217;}i:2220;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2219;}i:2221;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2217;}i:2222;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2221;}i:2223;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2217;}i:2224;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2223;}i:2225;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2217;}i:2226;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2225;}i:2227;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2198;}i:2228;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2198;}i:2229;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2198;}i:2230;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2198;}i:2231;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2198;}i:2232;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2198;}i:2233;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2198;}i:2234;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2198;}i:2235;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2198;}i:2236;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2235;}i:2237;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2197;}i:2238;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2237;}i:2239;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2197;}i:2240;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2197;}i:2241;a:2:{s:5:"class";s:18:"ilmediapoolpagegui";s:6:"parent";i:2190;}i:2242;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2241;}i:2243;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2242;}i:2244;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2243;}i:2245;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2243;}i:2246;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2245;}i:2247;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2243;}i:2248;a:2:{s:5:"class";s:25:"ilmediapooltargetselector";s:6:"parent";i:2241;}i:2249;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2241;}i:2250;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2249;}i:2251;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2249;}i:2252;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2251;}i:2253;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2251;}i:2254;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2253;}i:2255;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2251;}i:2256;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2249;}i:2257;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2249;}i:2258;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2249;}i:2259;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2249;}i:2260;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2249;}i:2261;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2249;}i:2262;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2249;}i:2263;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2249;}i:2264;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2263;}i:2265;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2264;}i:2266;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2264;}i:2267;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2266;}i:2268;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2264;}i:2269;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2263;}i:2270;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2269;}i:2271;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2249;}i:2272;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2249;}i:2273;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2272;}i:2274;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2273;}i:2275;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2274;}i:2276;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2274;}i:2277;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2276;}i:2278;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2274;}i:2279;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2273;}i:2280;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2279;}i:2281;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2249;}i:2282;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2249;}i:2283;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2282;}i:2284;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2283;}i:2285;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2283;}i:2286;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2283;}i:2287;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2283;}i:2288;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2283;}i:2289;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2283;}i:2290;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2283;}i:2291;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2283;}i:2292;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2283;}i:2293;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2283;}i:2294;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2249;}i:2295;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2249;}i:2296;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2249;}i:2297;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2249;}i:2298;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2249;}i:2299;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2249;}i:2300;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2241;}i:2301;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2300;}i:2302;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2301;}i:2303;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2302;}i:2304;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2302;}i:2305;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2304;}i:2306;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2302;}i:2307;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2300;}i:2308;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2300;}i:2309;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2300;}i:2310;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2309;}i:2311;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2309;}i:2312;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2311;}i:2313;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2311;}i:2314;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2313;}i:2315;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2311;}i:2316;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2309;}i:2317;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2309;}i:2318;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2309;}i:2319;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2309;}i:2320;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2309;}i:2321;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2309;}i:2322;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2309;}i:2323;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2309;}i:2324;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2323;}i:2325;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2324;}i:2326;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2324;}i:2327;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2326;}i:2328;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2324;}i:2329;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2323;}i:2330;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2329;}i:2331;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2309;}i:2332;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2309;}i:2333;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2332;}i:2334;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2333;}i:2335;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2334;}i:2336;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2334;}i:2337;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2336;}i:2338;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2334;}i:2339;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2333;}i:2340;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2339;}i:2341;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2309;}i:2342;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2309;}i:2343;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2342;}i:2344;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2343;}i:2345;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2343;}i:2346;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2343;}i:2347;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2343;}i:2348;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2343;}i:2349;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2343;}i:2350;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2343;}i:2351;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2343;}i:2352;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2343;}i:2353;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2343;}i:2354;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2309;}i:2355;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2309;}i:2356;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2309;}i:2357;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2309;}i:2358;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2309;}i:2359;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2309;}i:2360;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2300;}i:2361;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2241;}i:2362;a:2:{s:5:"class";s:14:"ilobjfoldergui";s:6:"parent";i:2190;}i:2363;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2362;}i:2364;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2363;}i:2365;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2363;}i:2366;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2363;}i:2367;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2366;}i:2368;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2366;}i:2369;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2368;}i:2370;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2366;}i:2371;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2370;}i:2372;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2366;}i:2373;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2372;}i:2374;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2366;}i:2375;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2374;}i:2376;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2363;}i:2377;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2363;}i:2378;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2363;}i:2379;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2363;}i:2380;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2363;}i:2381;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2380;}i:2382;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2363;}i:2383;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2382;}i:2384;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2382;}i:2385;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2384;}i:2386;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2382;}i:2387;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2386;}i:2388;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2382;}i:2389;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2388;}i:2390;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2382;}i:2391;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2390;}i:2392;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2363;}i:2393;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2363;}i:2394;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2363;}i:2395;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2363;}i:2396;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2363;}i:2397;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2363;}i:2398;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2363;}i:2399;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2363;}i:2400;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2363;}i:2401;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2400;}i:2402;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:2362;}i:2403;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2402;}i:2404;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:2362;}i:2405;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2404;}i:2406;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2405;}i:2407;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2405;}i:2408;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2405;}i:2409;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2408;}i:2410;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2408;}i:2411;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2410;}i:2412;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2408;}i:2413;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2412;}i:2414;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2408;}i:2415;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2414;}i:2416;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2408;}i:2417;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2416;}i:2418;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2405;}i:2419;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2405;}i:2420;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2405;}i:2421;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2405;}i:2422;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2405;}i:2423;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2422;}i:2424;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2405;}i:2425;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2424;}i:2426;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2424;}i:2427;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2426;}i:2428;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2424;}i:2429;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2428;}i:2430;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2424;}i:2431;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2430;}i:2432;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2424;}i:2433;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2432;}i:2434;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2405;}i:2435;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2405;}i:2436;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2405;}i:2437;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2405;}i:2438;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2405;}i:2439;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2405;}i:2440;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2405;}i:2441;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2405;}i:2442;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2405;}i:2443;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2442;}i:2444;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:2404;}i:2445;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:2404;}i:2446;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2445;}i:2447;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:2362;}i:2448;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:2447;}i:2449;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2448;}i:2450;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2362;}i:2451;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2450;}i:2452;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2451;}i:2453;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2451;}i:2454;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2451;}i:2455;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2454;}i:2456;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2454;}i:2457;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2456;}i:2458;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2454;}i:2459;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2458;}i:2460;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2454;}i:2461;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2460;}i:2462;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2454;}i:2463;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2462;}i:2464;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2451;}i:2465;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2451;}i:2466;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2451;}i:2467;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2451;}i:2468;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2451;}i:2469;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2468;}i:2470;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2451;}i:2471;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2470;}i:2472;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2470;}i:2473;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2472;}i:2474;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2470;}i:2475;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2474;}i:2476;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2470;}i:2477;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2476;}i:2478;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2470;}i:2479;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2478;}i:2480;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2451;}i:2481;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2451;}i:2482;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2451;}i:2483;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2451;}i:2484;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2451;}i:2485;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2451;}i:2486;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2451;}i:2487;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2451;}i:2488;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2451;}i:2489;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2488;}i:2490;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2450;}i:2491;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2490;}i:2492;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2450;}i:2493;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2450;}i:2494;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:2362;}i:2495;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:2494;}i:2496;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:2494;}i:2497;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2496;}i:2498;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2497;}i:2499;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:2496;}i:2500;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2499;}i:2501;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2500;}i:2502;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2500;}i:2503;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2496;}i:2504;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2503;}i:2505;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:2496;}i:2506;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2505;}i:2507;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:2494;}i:2508;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2507;}i:2509;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2508;}i:2510;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:2507;}i:2511;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2510;}i:2512;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2511;}i:2513;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2511;}i:2514;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2507;}i:2515;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2514;}i:2516;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:2494;}i:2517;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2516;}i:2518;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2362;}i:2519;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2518;}i:2520;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:2362;}i:2521;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2520;}i:2522;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2362;}i:2523;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2522;}i:2524;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2523;}i:2525;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2524;}i:2526;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2524;}i:2527;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2526;}i:2528;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2524;}i:2529;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2522;}i:2530;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2522;}i:2531;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2522;}i:2532;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2531;}i:2533;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2531;}i:2534;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2533;}i:2535;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2533;}i:2536;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2535;}i:2537;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2533;}i:2538;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2531;}i:2539;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2531;}i:2540;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2531;}i:2541;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2531;}i:2542;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2531;}i:2543;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2531;}i:2544;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2531;}i:2545;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2531;}i:2546;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2545;}i:2547;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2546;}i:2548;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2546;}i:2549;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2548;}i:2550;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2546;}i:2551;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2545;}i:2552;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2551;}i:2553;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2531;}i:2554;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2531;}i:2555;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2554;}i:2556;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2555;}i:2557;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2556;}i:2558;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2556;}i:2559;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2558;}i:2560;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2556;}i:2561;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2555;}i:2562;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2561;}i:2563;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2531;}i:2564;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2531;}i:2565;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2564;}i:2566;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2565;}i:2567;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2565;}i:2568;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2565;}i:2569;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2565;}i:2570;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2565;}i:2571;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2565;}i:2572;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2565;}i:2573;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2565;}i:2574;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2565;}i:2575;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2565;}i:2576;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2531;}i:2577;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2531;}i:2578;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2531;}i:2579;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2531;}i:2580;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2531;}i:2581;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2531;}i:2582;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2522;}i:2583;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2362;}i:2584;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2583;}i:2585;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2584;}i:2586;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2190;}i:2587;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2586;}i:2588;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2586;}i:2589;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2588;}i:2590;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2586;}i:2591;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2190;}i:2592;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2591;}i:2593;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2592;}i:2594;a:2:{s:5:"class";s:20:"ilobjquestionpoolgui";s:6:"parent";i:1;}i:2595;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2594;}i:2596;a:2:{s:5:"class";s:15:"asserrortextgui";s:6:"parent";i:2594;}i:2597;a:2:{s:5:"class";s:16:"assfileuploadgui";s:6:"parent";i:2594;}i:2598;a:2:{s:5:"class";s:19:"assflashquestiongui";s:6:"parent";i:2594;}i:2599;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2594;}i:2600;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2594;}i:2601;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2594;}i:2602;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2594;}i:2603;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2594;}i:2604;a:2:{s:5:"class";s:24:"assorderinghorizontalgui";s:6:"parent";i:2594;}i:2605;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2594;}i:2606;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2594;}i:2607;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2594;}i:2608;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2594;}i:2609;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2594;}i:2610;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2594;}i:2611;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2610;}i:2612;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2594;}i:2613;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2612;}i:2614;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2613;}i:2615;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2614;}i:2616;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2614;}i:2617;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2616;}i:2618;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2614;}i:2619;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2612;}i:2620;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2612;}i:2621;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2612;}i:2622;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2621;}i:2623;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2621;}i:2624;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2623;}i:2625;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2623;}i:2626;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2625;}i:2627;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2623;}i:2628;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2621;}i:2629;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2621;}i:2630;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2621;}i:2631;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2621;}i:2632;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2621;}i:2633;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2621;}i:2634;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2621;}i:2635;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2621;}i:2636;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2635;}i:2637;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2636;}i:2638;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2636;}i:2639;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2638;}i:2640;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2636;}i:2641;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2635;}i:2642;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2641;}i:2643;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2621;}i:2644;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2621;}i:2645;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2644;}i:2646;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2645;}i:2647;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2646;}i:2648;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2646;}i:2649;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2648;}i:2650;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2646;}i:2651;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2645;}i:2652;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2651;}i:2653;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2621;}i:2654;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2621;}i:2655;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2654;}i:2656;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2655;}i:2657;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2655;}i:2658;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2655;}i:2659;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2655;}i:2660;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2655;}i:2661;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2655;}i:2662;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2655;}i:2663;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2655;}i:2664;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2655;}i:2665;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2655;}i:2666;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2621;}i:2667;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2621;}i:2668;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2621;}i:2669;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2621;}i:2670;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2621;}i:2671;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2621;}i:2672;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2612;}i:2673;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2594;}i:2674;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2673;}i:2675;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2674;}i:2676;a:2:{s:5:"class";s:20:"ilobjremotecoursegui";s:6:"parent";i:1;}i:2677;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2676;}i:2678;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2677;}i:2679;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2678;}i:2680;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2678;}i:2681;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2678;}i:2682;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2681;}i:2683;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2681;}i:2684;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2683;}i:2685;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2681;}i:2686;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2685;}i:2687;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2681;}i:2688;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2687;}i:2689;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2681;}i:2690;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2689;}i:2691;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2678;}i:2692;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2678;}i:2693;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2678;}i:2694;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2678;}i:2695;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2678;}i:2696;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2695;}i:2697;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2678;}i:2698;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2697;}i:2699;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2697;}i:2700;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2699;}i:2701;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2697;}i:2702;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2701;}i:2703;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2697;}i:2704;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2703;}i:2705;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2697;}i:2706;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2705;}i:2707;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2678;}i:2708;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2678;}i:2709;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2678;}i:2710;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2678;}i:2711;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2678;}i:2712;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2678;}i:2713;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2678;}i:2714;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2678;}i:2715;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2678;}i:2716;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2715;}i:2717;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2677;}i:2718;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2717;}i:2719;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2677;}i:2720;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2677;}i:2721;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2676;}i:2722;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2721;}i:2723;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2722;}i:2724;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1;}i:2725;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2724;}i:2726;a:2:{s:5:"class";s:18:"ilobjrootfoldergui";s:6:"parent";i:1;}i:2727;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2726;}i:2728;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2727;}i:2729;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2727;}i:2730;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2727;}i:2731;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2730;}i:2732;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2730;}i:2733;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2732;}i:2734;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2730;}i:2735;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2734;}i:2736;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2730;}i:2737;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2736;}i:2738;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2730;}i:2739;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2738;}i:2740;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2727;}i:2741;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2727;}i:2742;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2727;}i:2743;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2727;}i:2744;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2727;}i:2745;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2744;}i:2746;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2727;}i:2747;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2746;}i:2748;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2746;}i:2749;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2748;}i:2750;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2746;}i:2751;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2750;}i:2752;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2746;}i:2753;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2752;}i:2754;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2746;}i:2755;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2754;}i:2756;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2727;}i:2757;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2727;}i:2758;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2727;}i:2759;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2727;}i:2760;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2727;}i:2761;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2727;}i:2762;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2727;}i:2763;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2727;}i:2764;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2727;}i:2765;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2764;}i:2766;a:2:{s:5:"class";s:22:"ilcontainerlinklistgui";s:6:"parent";i:2726;}i:2767;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2766;}i:2768;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2726;}i:2769;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2768;}i:2770;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:2726;}i:2771;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2770;}i:2772;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2726;}i:2773;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2772;}i:2774;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2773;}i:2775;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2774;}i:2776;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2774;}i:2777;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2776;}i:2778;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2774;}i:2779;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2772;}i:2780;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2772;}i:2781;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2772;}i:2782;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2781;}i:2783;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2781;}i:2784;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2783;}i:2785;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2783;}i:2786;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2785;}i:2787;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2783;}i:2788;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2781;}i:2789;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2781;}i:2790;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2781;}i:2791;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2781;}i:2792;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2781;}i:2793;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2781;}i:2794;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2781;}i:2795;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2781;}i:2796;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2795;}i:2797;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2796;}i:2798;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2796;}i:2799;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2798;}i:2800;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2796;}i:2801;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2795;}i:2802;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2801;}i:2803;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2781;}i:2804;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2781;}i:2805;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2804;}i:2806;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2805;}i:2807;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2806;}i:2808;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2806;}i:2809;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2808;}i:2810;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2806;}i:2811;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2805;}i:2812;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2811;}i:2813;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2781;}i:2814;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2781;}i:2815;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2814;}i:2816;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2815;}i:2817;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2815;}i:2818;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2815;}i:2819;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2815;}i:2820;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2815;}i:2821;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2815;}i:2822;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2815;}i:2823;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2815;}i:2824;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2815;}i:2825;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2815;}i:2826;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2781;}i:2827;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2781;}i:2828;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2781;}i:2829;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2781;}i:2830;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2781;}i:2831;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2781;}i:2832;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2772;}i:2833;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2726;}i:2834;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2833;}i:2835;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2834;}i:2836;a:2:{s:5:"class";s:26:"ilobjsahslearningmodulegui";s:6:"parent";i:1;}i:2837;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2836;}i:2838;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2836;}i:2839;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2838;}i:2840;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2839;}i:2841;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2839;}i:2842;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2839;}i:2843;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2842;}i:2844;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2842;}i:2845;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2844;}i:2846;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2842;}i:2847;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2846;}i:2848;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2842;}i:2849;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2848;}i:2850;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2842;}i:2851;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2850;}i:2852;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2839;}i:2853;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2839;}i:2854;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2839;}i:2855;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2839;}i:2856;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2839;}i:2857;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2856;}i:2858;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2839;}i:2859;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2858;}i:2860;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2858;}i:2861;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2860;}i:2862;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2858;}i:2863;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2862;}i:2864;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2858;}i:2865;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2864;}i:2866;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2858;}i:2867;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2866;}i:2868;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2839;}i:2869;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2839;}i:2870;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2839;}i:2871;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2839;}i:2872;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2839;}i:2873;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2839;}i:2874;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2839;}i:2875;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2839;}i:2876;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2839;}i:2877;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2876;}i:2878;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2838;}i:2879;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2878;}i:2880;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2838;}i:2881;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2838;}i:2882;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:2836;}i:2883;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:2882;}i:2884;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:2882;}i:2885;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2884;}i:2886;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2885;}i:2887;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:2884;}i:2888;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2887;}i:2889;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2888;}i:2890;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2888;}i:2891;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2884;}i:2892;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2891;}i:2893;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:2884;}i:2894;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2893;}i:2895;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:2882;}i:2896;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2895;}i:2897;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2896;}i:2898;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:2895;}i:2899;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2898;}i:2900;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2899;}i:2901;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2899;}i:2902;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2895;}i:2903;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2902;}i:2904;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:2882;}i:2905;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2904;}i:2906;a:2:{s:5:"class";s:12:"illicensegui";s:6:"parent";i:2836;}i:2907;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2906;}i:2908;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2836;}i:2909;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2836;}i:2910;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2909;}i:2911;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2910;}i:2912;a:2:{s:5:"class";s:15:"ilobjsessiongui";s:6:"parent";i:1;}i:2913;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:2912;}i:2914;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:2913;}i:2915;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2914;}i:2916;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2912;}i:2917;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2916;}i:2918;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2917;}i:2919;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2917;}i:2920;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2917;}i:2921;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2920;}i:2922;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2920;}i:2923;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2922;}i:2924;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2920;}i:2925;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2924;}i:2926;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2920;}i:2927;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2926;}i:2928;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2920;}i:2929;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2928;}i:2930;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2917;}i:2931;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2917;}i:2932;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2917;}i:2933;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2917;}i:2934;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2917;}i:2935;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2934;}i:2936;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2917;}i:2937;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2936;}i:2938;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2936;}i:2939;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2938;}i:2940;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2936;}i:2941;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2940;}i:2942;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2936;}i:2943;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2942;}i:2944;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2936;}i:2945;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2944;}i:2946;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2917;}i:2947;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2917;}i:2948;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2917;}i:2949;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2917;}i:2950;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2917;}i:2951;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2917;}i:2952;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2917;}i:2953;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2917;}i:2954;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2917;}i:2955;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2954;}i:2956;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2916;}i:2957;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2956;}i:2958;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2916;}i:2959;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2916;}i:2960;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2912;}i:2961;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2960;}i:2962;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2912;}i:2963;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2962;}i:2964;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2963;}i:2965;a:2:{s:5:"class";s:14:"ilobjsurveygui";s:6:"parent";i:1;}i:2966;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2965;}i:2967;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2966;}i:2968;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2967;}i:2969;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2967;}i:2970;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2967;}i:2971;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2970;}i:2972;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2970;}i:2973;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2972;}i:2974;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2970;}i:2975;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2974;}i:2976;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2970;}i:2977;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2976;}i:2978;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2970;}i:2979;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2978;}i:2980;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2967;}i:2981;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2967;}i:2982;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2967;}i:2983;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2967;}i:2984;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2967;}i:2985;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2984;}i:2986;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2967;}i:2987;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2986;}i:2988;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2986;}i:2989;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2988;}i:2990;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2986;}i:2991;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2990;}i:2992;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2986;}i:2993;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2992;}i:2994;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2986;}i:2995;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2994;}i:2996;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2967;}i:2997;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2967;}i:2998;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2967;}i:2999;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2967;}i:3000;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2967;}i:3001;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2967;}i:3002;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2967;}i:3003;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2967;}i:3004;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2967;}i:3005;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3004;}i:3006;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2966;}i:3007;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3006;}i:3008;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2966;}i:3009;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2966;}i:3010;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2965;}i:3011;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2965;}i:3012;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3011;}i:3013;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2965;}i:3014;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3013;}i:3015;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3014;}i:3016;a:2:{s:5:"class";s:21:"ilsurveyevaluationgui";s:6:"parent";i:2965;}i:3017;a:2:{s:5:"class";s:20:"ilsurveyexecutiongui";s:6:"parent";i:2965;}i:3018;a:2:{s:5:"class";s:26:"ilobjsurveyquestionpoolgui";s:6:"parent";i:1;}i:3019;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3018;}i:3020;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3018;}i:3021;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3020;}i:3022;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3018;}i:3023;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3022;}i:3024;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3023;}i:3025;a:2:{s:5:"class";s:18:"ilsurveyphrasesgui";s:6:"parent";i:3018;}i:3026;a:2:{s:5:"class";s:23:"surveymatrixquestiongui";s:6:"parent";i:3018;}i:3027;a:2:{s:5:"class";s:23:"surveymetricquestiongui";s:6:"parent";i:3018;}i:3028;a:2:{s:5:"class";s:31:"surveymultiplechoicequestiongui";s:6:"parent";i:3018;}i:3029;a:2:{s:5:"class";s:29:"surveysinglechoicequestiongui";s:6:"parent";i:3018;}i:3030;a:2:{s:5:"class";s:21:"surveytextquestiongui";s:6:"parent";i:3018;}i:3031;a:2:{s:5:"class";s:12:"ilobjtestgui";s:6:"parent";i:1;}i:3032;a:2:{s:5:"class";s:16:"ilcertificategui";s:6:"parent";i:3031;}i:3033;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3031;}i:3034;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3033;}i:3035;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3034;}i:3036;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3034;}i:3037;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3034;}i:3038;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3037;}i:3039;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3037;}i:3040;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3039;}i:3041;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3037;}i:3042;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3041;}i:3043;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3037;}i:3044;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3043;}i:3045;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3037;}i:3046;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3045;}i:3047;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3034;}i:3048;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3034;}i:3049;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3034;}i:3050;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3034;}i:3051;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3034;}i:3052;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3051;}i:3053;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3034;}i:3054;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3053;}i:3055;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3053;}i:3056;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3055;}i:3057;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3053;}i:3058;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3057;}i:3059;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3053;}i:3060;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3059;}i:3061;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3053;}i:3062;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3061;}i:3063;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3034;}i:3064;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3034;}i:3065;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3034;}i:3066;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3034;}i:3067;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3034;}i:3068;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3034;}i:3069;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3034;}i:3070;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3034;}i:3071;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3034;}i:3072;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3071;}i:3073;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3033;}i:3074;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3073;}i:3075;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3033;}i:3076;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3033;}i:3077;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3031;}i:3078;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3077;}i:3079;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3077;}i:3080;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3079;}i:3081;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3080;}i:3082;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3079;}i:3083;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3082;}i:3084;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3083;}i:3085;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3083;}i:3086;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3079;}i:3087;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3086;}i:3088;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3079;}i:3089;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3088;}i:3090;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3077;}i:3091;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3090;}i:3092;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3091;}i:3093;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3090;}i:3094;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3093;}i:3095;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3094;}i:3096;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3094;}i:3097;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3090;}i:3098;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3097;}i:3099;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3077;}i:3100;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3099;}i:3101;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3031;}i:3102;a:2:{s:5:"class";s:14:"ilobjcoursegui";s:6:"parent";i:3031;}i:3103;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3102;}i:3104;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3103;}i:3105;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3103;}i:3106;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3103;}i:3107;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3106;}i:3108;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3106;}i:3109;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3108;}i:3110;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3106;}i:3111;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3110;}i:3112;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3106;}i:3113;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3112;}i:3114;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3106;}i:3115;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3114;}i:3116;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3103;}i:3117;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3103;}i:3118;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3103;}i:3119;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3103;}i:3120;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3103;}i:3121;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3120;}i:3122;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3103;}i:3123;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3122;}i:3124;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3122;}i:3125;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3124;}i:3126;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3122;}i:3127;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3126;}i:3128;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3122;}i:3129;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3128;}i:3130;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3122;}i:3131;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3130;}i:3132;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3103;}i:3133;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3103;}i:3134;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3103;}i:3135;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3103;}i:3136;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3103;}i:3137;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3103;}i:3138;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3103;}i:3139;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3103;}i:3140;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3103;}i:3141;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3140;}i:3142;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:3102;}i:3143;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3142;}i:3144;a:2:{s:5:"class";s:20:"ilcourseagreementgui";s:6:"parent";i:3102;}i:3145;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3144;}i:3146;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:3102;}i:3147;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3146;}i:3148;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3147;}i:3149;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3147;}i:3150;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3147;}i:3151;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3150;}i:3152;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3150;}i:3153;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3152;}i:3154;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3150;}i:3155;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3154;}i:3156;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3150;}i:3157;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3156;}i:3158;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3150;}i:3159;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3158;}i:3160;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3147;}i:3161;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3147;}i:3162;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3147;}i:3163;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3147;}i:3164;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3147;}i:3165;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3164;}i:3166;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3147;}i:3167;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3166;}i:3168;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3166;}i:3169;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3168;}i:3170;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3166;}i:3171;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3170;}i:3172;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3166;}i:3173;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3172;}i:3174;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3166;}i:3175;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3174;}i:3176;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3147;}i:3177;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3147;}i:3178;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3147;}i:3179;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3147;}i:3180;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3147;}i:3181;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3147;}i:3182;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3147;}i:3183;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3147;}i:3184;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3147;}i:3185;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3184;}i:3186;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:3146;}i:3187;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:3146;}i:3188;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3187;}i:3189;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:3102;}i:3190;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:3189;}i:3191;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3190;}i:3192;a:2:{s:5:"class";s:21:"ilcourseobjectivesgui";s:6:"parent";i:3102;}i:3193;a:2:{s:5:"class";s:23:"ilcourseregistrationgui";s:6:"parent";i:3102;}i:3194;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3193;}i:3195;a:2:{s:5:"class";s:21:"ilcourseuserfieldsgui";s:6:"parent";i:3102;}i:3196;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3102;}i:3197;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3196;}i:3198;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3197;}i:3199;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3197;}i:3200;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3197;}i:3201;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3200;}i:3202;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3200;}i:3203;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3202;}i:3204;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3200;}i:3205;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3204;}i:3206;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3200;}i:3207;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3206;}i:3208;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3200;}i:3209;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3208;}i:3210;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3197;}i:3211;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3197;}i:3212;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3197;}i:3213;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3197;}i:3214;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3197;}i:3215;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3214;}i:3216;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3197;}i:3217;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3216;}i:3218;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3216;}i:3219;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3218;}i:3220;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3216;}i:3221;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3220;}i:3222;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3216;}i:3223;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3222;}i:3224;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3216;}i:3225;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3224;}i:3226;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3197;}i:3227;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3197;}i:3228;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3197;}i:3229;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3197;}i:3230;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3197;}i:3231;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3197;}i:3232;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3197;}i:3233;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3197;}i:3234;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3197;}i:3235;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3234;}i:3236;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3196;}i:3237;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3236;}i:3238;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3196;}i:3239;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3196;}i:3240;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3102;}i:3241;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3240;}i:3242;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3240;}i:3243;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3242;}i:3244;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3243;}i:3245;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3242;}i:3246;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3245;}i:3247;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3246;}i:3248;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3246;}i:3249;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3242;}i:3250;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3249;}i:3251;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3242;}i:3252;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3251;}i:3253;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3240;}i:3254;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3253;}i:3255;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3254;}i:3256;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3253;}i:3257;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3256;}i:3258;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3257;}i:3259;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3257;}i:3260;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3253;}i:3261;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3260;}i:3262;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3240;}i:3263;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3262;}i:3264;a:2:{s:5:"class";s:20:"illicenseoverviewgui";s:6:"parent";i:3102;}i:3265;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3264;}i:3266;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3102;}i:3267;a:2:{s:5:"class";s:17:"ilmemberexportgui";s:6:"parent";i:3102;}i:3268;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3267;}i:3269;a:2:{s:5:"class";s:22:"ilobjcoursegroupinggui";s:6:"parent";i:3102;}i:3270;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3102;}i:3271;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3270;}i:3272;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:3102;}i:3273;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3272;}i:3274;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3102;}i:3275;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3274;}i:3276;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3275;}i:3277;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3276;}i:3278;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3276;}i:3279;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3278;}i:3280;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3276;}i:3281;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3274;}i:3282;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3274;}i:3283;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3274;}i:3284;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3283;}i:3285;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3283;}i:3286;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3285;}i:3287;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3285;}i:3288;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3287;}i:3289;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3285;}i:3290;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3283;}i:3291;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3283;}i:3292;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3283;}i:3293;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3283;}i:3294;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3283;}i:3295;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3283;}i:3296;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3283;}i:3297;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3283;}i:3298;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3297;}i:3299;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3298;}i:3300;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3298;}i:3301;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3300;}i:3302;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3298;}i:3303;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3297;}i:3304;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3303;}i:3305;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3283;}i:3306;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3283;}i:3307;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3306;}i:3308;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3307;}i:3309;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3308;}i:3310;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3308;}i:3311;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3310;}i:3312;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3308;}i:3313;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3307;}i:3314;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3313;}i:3315;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3283;}i:3316;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3283;}i:3317;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3316;}i:3318;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3317;}i:3319;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3317;}i:3320;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3317;}i:3321;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3317;}i:3322;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3317;}i:3323;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3317;}i:3324;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3317;}i:3325;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3317;}i:3326;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3317;}i:3327;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3317;}i:3328;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3283;}i:3329;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3283;}i:3330;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3283;}i:3331;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3283;}i:3332;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3283;}i:3333;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3283;}i:3334;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3274;}i:3335;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3102;}i:3336;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3335;}i:3337;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3336;}i:3338;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3102;}i:3339;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3102;}i:3340;a:2:{s:5:"class";s:20:"ilsessionoverviewgui";s:6:"parent";i:3102;}i:3341;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:3102;}i:3342;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3341;}i:3343;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3342;}i:3344;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3343;}i:3345;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3344;}i:3346;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3344;}i:3347;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3346;}i:3348;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3344;}i:3349;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3342;}i:3350;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3342;}i:3351;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3342;}i:3352;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3351;}i:3353;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3351;}i:3354;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3353;}i:3355;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3353;}i:3356;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3355;}i:3357;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3353;}i:3358;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3351;}i:3359;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3351;}i:3360;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3351;}i:3361;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3351;}i:3362;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3351;}i:3363;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3351;}i:3364;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3351;}i:3365;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3351;}i:3366;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3365;}i:3367;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3366;}i:3368;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3366;}i:3369;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3368;}i:3370;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3366;}i:3371;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3365;}i:3372;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3371;}i:3373;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3351;}i:3374;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3351;}i:3375;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3374;}i:3376;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3375;}i:3377;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3376;}i:3378;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3376;}i:3379;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3378;}i:3380;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3376;}i:3381;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3375;}i:3382;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3381;}i:3383;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3351;}i:3384;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3351;}i:3385;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3384;}i:3386;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3385;}i:3387;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3385;}i:3388;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3385;}i:3389;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3385;}i:3390;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3385;}i:3391;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3385;}i:3392;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3385;}i:3393;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3385;}i:3394;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3385;}i:3395;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3385;}i:3396;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3351;}i:3397;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3351;}i:3398;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3351;}i:3399;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3351;}i:3400;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3351;}i:3401;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3351;}i:3402;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3342;}i:3403;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3031;}i:3404;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3403;}i:3405;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3031;}i:3406;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3405;}i:3407;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3406;}i:3408;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:3031;}i:3409;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3408;}i:3410;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3409;}i:3411;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3410;}i:3412;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3411;}i:3413;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3411;}i:3414;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3413;}i:3415;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3411;}i:3416;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3409;}i:3417;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3409;}i:3418;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3409;}i:3419;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3418;}i:3420;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3418;}i:3421;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3420;}i:3422;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3420;}i:3423;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3422;}i:3424;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3420;}i:3425;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3418;}i:3426;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3418;}i:3427;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3418;}i:3428;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3418;}i:3429;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3418;}i:3430;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3418;}i:3431;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3418;}i:3432;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3418;}i:3433;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3432;}i:3434;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3433;}i:3435;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3433;}i:3436;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3435;}i:3437;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3433;}i:3438;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3432;}i:3439;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3438;}i:3440;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3418;}i:3441;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3418;}i:3442;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3441;}i:3443;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3442;}i:3444;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3443;}i:3445;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3443;}i:3446;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3445;}i:3447;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3443;}i:3448;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3442;}i:3449;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3448;}i:3450;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3418;}i:3451;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3418;}i:3452;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3451;}i:3453;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3452;}i:3454;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3452;}i:3455;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3452;}i:3456;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3452;}i:3457;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3452;}i:3458;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3452;}i:3459;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3452;}i:3460;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3452;}i:3461;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3452;}i:3462;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3452;}i:3463;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3418;}i:3464;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3418;}i:3465;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3418;}i:3466;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3418;}i:3467;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3418;}i:3468;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3418;}i:3469;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3409;}i:3470;a:2:{s:5:"class";s:19:"iltestevaluationgui";s:6:"parent";i:3031;}i:3471;a:2:{s:5:"class";s:15:"iltestoutputgui";s:6:"parent";i:3031;}i:3472;a:2:{s:5:"class";s:16:"iltestscoringgui";s:6:"parent";i:3031;}i:3473;a:2:{s:5:"class";s:16:"iltestservicegui";s:6:"parent";i:3031;}i:3474;a:2:{s:5:"class";s:12:"ilobjwikigui";s:6:"parent";i:1;}i:3475;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3474;}i:3476;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3475;}i:3477;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3476;}i:3478;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3476;}i:3479;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3476;}i:3480;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3479;}i:3481;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3479;}i:3482;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3481;}i:3483;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3479;}i:3484;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3483;}i:3485;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3479;}i:3486;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3485;}i:3487;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3479;}i:3488;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3487;}i:3489;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3476;}i:3490;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3476;}i:3491;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3476;}i:3492;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3476;}i:3493;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3476;}i:3494;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3493;}i:3495;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3476;}i:3496;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3495;}i:3497;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3495;}i:3498;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3497;}i:3499;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3495;}i:3500;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3499;}i:3501;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3495;}i:3502;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3501;}i:3503;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3495;}i:3504;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3503;}i:3505;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3476;}i:3506;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3476;}i:3507;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3476;}i:3508;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3476;}i:3509;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3476;}i:3510;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3476;}i:3511;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3476;}i:3512;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3476;}i:3513;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3476;}i:3514;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3513;}i:3515;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3475;}i:3516;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3515;}i:3517;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3475;}i:3518;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3475;}i:3519;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:3474;}i:3520;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3519;}i:3521;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3474;}i:3522;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3521;}i:3523;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3522;}i:3524;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3474;}i:3525;a:2:{s:5:"class";s:13:"ilwikipagegui";s:6:"parent";i:3474;}i:3526;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3525;}i:3527;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3526;}i:3528;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3527;}i:3529;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3527;}i:3530;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3529;}i:3531;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3527;}i:3532;a:2:{s:5:"class";s:25:"ilmediapooltargetselector";s:6:"parent";i:3525;}i:3533;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3525;}i:3534;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3525;}i:3535;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3534;}i:3536;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3534;}i:3537;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3536;}i:3538;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3536;}i:3539;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3538;}i:3540;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3536;}i:3541;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3534;}i:3542;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3534;}i:3543;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3534;}i:3544;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3534;}i:3545;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3534;}i:3546;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3534;}i:3547;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3534;}i:3548;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3534;}i:3549;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3548;}i:3550;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3549;}i:3551;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3549;}i:3552;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3551;}i:3553;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3549;}i:3554;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3548;}i:3555;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3554;}i:3556;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3534;}i:3557;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3534;}i:3558;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3557;}i:3559;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3558;}i:3560;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3559;}i:3561;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3559;}i:3562;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3561;}i:3563;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3559;}i:3564;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3558;}i:3565;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3564;}i:3566;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3534;}i:3567;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3534;}i:3568;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3567;}i:3569;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3568;}i:3570;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3568;}i:3571;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3568;}i:3572;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3568;}i:3573;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3568;}i:3574;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3568;}i:3575;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3568;}i:3576;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3568;}i:3577;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3568;}i:3578;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3568;}i:3579;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3534;}i:3580;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3534;}i:3581;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3534;}i:3582;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3534;}i:3583;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3534;}i:3584;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3534;}i:3585;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3525;}i:3586;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3585;}i:3587;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3586;}i:3588;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3587;}i:3589;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3587;}i:3590;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3589;}i:3591;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3587;}i:3592;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3585;}i:3593;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3585;}i:3594;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3585;}i:3595;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3594;}i:3596;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3594;}i:3597;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3596;}i:3598;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3596;}i:3599;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3598;}i:3600;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3596;}i:3601;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3594;}i:3602;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3594;}i:3603;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3594;}i:3604;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3594;}i:3605;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3594;}i:3606;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3594;}i:3607;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3594;}i:3608;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3594;}i:3609;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3608;}i:3610;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3609;}i:3611;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3609;}i:3612;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3611;}i:3613;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3609;}i:3614;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3608;}i:3615;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3614;}i:3616;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3594;}i:3617;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3594;}i:3618;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3617;}i:3619;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3618;}i:3620;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3619;}i:3621;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3619;}i:3622;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3621;}i:3623;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3619;}i:3624;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3618;}i:3625;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3624;}i:3626;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3594;}i:3627;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3594;}i:3628;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3627;}i:3629;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3628;}i:3630;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3628;}i:3631;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3628;}i:3632;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3628;}i:3633;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3628;}i:3634;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3628;}i:3635;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3628;}i:3636;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3628;}i:3637;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3628;}i:3638;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3628;}i:3639;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3594;}i:3640;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3594;}i:3641;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3594;}i:3642;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3594;}i:3643;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3594;}i:3644;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3594;}i:3645;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3585;}i:3646;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3525;}i:3647;a:2:{s:5:"class";s:11:"ilratinggui";s:6:"parent";i:3525;}}'), 'forward' => array('clob', 'a:70:{s:16:"ilcalendardaygui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarinboxgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarmonthgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:17:"ilcalendarweekgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:13:"ilnewsitemgui";}s:20:"ilpdcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:22:"ilpublicuserprofilegui";}s:11:"ilcolumngui";a:17:{i:0;s:18:"ilbookmarkblockgui";i:1;s:18:"ilcalendarblockgui";i:2;s:14:"ilchatblockgui";i:3;s:15:"ildummyblockgui";i:4;s:22:"ilexternalfeedblockgui";i:5;s:14:"ilhtmlblockgui";i:6;s:24:"ilnewsforcontextblockgui";i:7;s:20:"ilpdcalendarblockgui";i:8;s:24:"ilpdexternalfeedblockgui";i:9;s:20:"ilpdfeedbackblockgui";i:10;s:16:"ilpdmailblockgui";i:11;s:16:"ilpdnewsblockgui";i:12;s:17:"ilpdnotesblockgui";i:13;s:25:"ilpdselecteditemsblockgui";i:14;s:22:"ilpdsysmessageblockgui";i:15;s:19:"ilpdtaggingblockgui";i:16;s:21:"ilusersonlineblockgui";}s:15:"ilinfoscreengui";a:4:{i:0;s:11:"ilcolumngui";i:1;s:13:"ilfeedbackgui";i:2;s:9:"ilnotegui";i:3;s:22:"ilpublicuserprofilegui";}s:25:"ilformpropertydispatchgui";a:1:{i:0;s:28:"ilrepositoryselectorinputgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:20:"illplistofobjectsgui";a:4:{i:0;s:13:"illpfiltergui";i:1;s:19:"illpobjectstablegui";i:2;s:17:"ilpdfpresentation";i:3;s:15:"iluserfiltergui";}s:20:"illpprogresstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:21:"illplistofprogressgui";a:3:{i:0;s:13:"illpfiltergui";i:1;s:20:"illpprogresstablegui";i:2;s:17:"ilpdfpresentation";}s:21:"illearningprogressgui";a:4:{i:0;s:17:"illmstatisticsgui";i:1;s:20:"illplistofobjectsgui";i:2;s:21:"illplistofprogressgui";i:3;s:21:"illplistofsettingsgui";}s:12:"ilobjusergui";a:2:{i:0;s:21:"illearningprogressgui";i:1;s:17:"ilobjilincusergui";}s:20:"iladminusersearchgui";a:1:{i:0;s:12:"ilobjusergui";}s:12:"ilobjrolegui";a:1:{i:0;s:21:"ilrepositorysearchgui";}s:15:"ilpermissiongui";a:1:{i:0;s:12:"ilobjrolegui";}s:14:"ilusertablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:18:"ilobjuserfoldergui";a:3:{i:0;s:20:"iladminusersearchgui";i:1;s:15:"ilpermissiongui";i:2;s:14:"ilusertablegui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:19:"ilobjmediaobjectgui";a:3:{i:0;s:15:"ilfilesystemgui";i:1;s:19:"ilimagemapeditorgui";i:2;s:13:"ilmdeditorgui";}s:18:"ileditclipboardgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:21:"ilpcimagemapeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:17:"ilquestioneditgui";a:10:{i:0;s:15:"assclozetestgui";i:1;s:22:"assimagemapquestiongui";i:2;s:16:"assjavaappletgui";i:3;s:22:"assmatchingquestiongui";i:4;s:20:"assmultiplechoicegui";i:5;s:13:"assnumericgui";i:6;s:22:"assorderingquestiongui";i:7;s:18:"asssinglechoicegui";i:8;s:18:"asstextquestiongui";i:9;s:16:"asstextsubsetgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:15:"ilpageeditorgui";a:20:{i:0;s:17:"ilinternallinkgui";i:1;s:19:"ilobjmediaobjectgui";i:2;s:21:"ilpccontentincludegui";i:3;s:16:"ilpcdatatablegui";i:4;s:15:"ilpcfileitemgui";i:5;s:15:"ilpcfilelistgui";i:6;s:11:"ilpclistgui";i:7;s:15:"ilpclistitemgui";i:8;s:10:"ilpcmapgui";i:9;s:18:"ilpcmediaobjectgui";i:10;s:16:"ilpcparagraphgui";i:11;s:18:"ilpcplaceholdergui";i:12;s:14:"ilpcpluggedgui";i:13;s:15:"ilpcquestiongui";i:14;s:16:"ilpcresourcesgui";i:15;s:14:"ilpcsectiongui";i:16;s:17:"ilpcsourcecodegui";i:17;s:16:"ilpctabledatagui";i:18;s:12:"ilpctablegui";i:19;s:11:"ilpctabsgui";}s:15:"ilpageobjectgui";a:5:{i:0;s:18:"ileditclipboardgui";i:1;s:13:"ilmdeditorgui";i:2;s:9:"ilnotegui";i:3;s:15:"ilpageeditorgui";i:4;s:22:"ilpublicuserprofilegui";}s:16:"ilobjcategorygui";a:9:{i:0;s:11:"ilcolumngui";i:1;s:22:"ilcontainerlinklistgui";i:2;s:15:"ilinfoscreengui";i:3;s:15:"ilobjectcopygui";i:4;s:18:"ilobjstylesheetgui";i:5;s:18:"ilobjuserfoldergui";i:6;s:12:"ilobjusergui";i:7;s:15:"ilpageobjectgui";i:8;s:15:"ilpermissiongui";}s:25:"ilobjcategoryreferencegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:12:"ilobjchatgui";a:4:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilobjectcopygui";i:2;s:15:"ilpermissiongui";i:3;s:22:"ilpublicuserprofilegui";}s:18:"ilcoursecontentgui";a:3:{i:0;s:11:"ilcolumngui";i:1;s:19:"ilcoursearchivesgui";i:2;s:32:"ilcourseobjectivepresentationgui";}s:29:"ilcourseitemadministrationgui";a:1:{i:0;s:27:"ilconditionhandlerinterface";}s:17:"ilshoppurchasegui";a:1:{i:0;s:15:"ilpageobjectgui";}s:14:"ilobjcoursegui";a:22:{i:0;s:11:"ilcolumngui";i:1;s:27:"ilconditionhandlerinterface";i:2;s:20:"ilcourseagreementgui";i:3;s:18:"ilcoursecontentgui";i:4;s:29:"ilcourseitemadministrationgui";i:5;s:21:"ilcourseobjectivesgui";i:6;s:23:"ilcourseregistrationgui";i:7;s:21:"ilcourseuserfieldsgui";i:8;s:15:"ilinfoscreengui";i:9;s:21:"illearningprogressgui";i:10;s:20:"illicenseoverviewgui";i:11;s:13:"ilmdeditorgui";i:12;s:17:"ilmemberexportgui";i:13;s:22:"ilobjcoursegroupinggui";i:14;s:15:"ilobjectcopygui";i:15;s:18:"ilobjstylesheetgui";i:16;s:15:"ilpageobjectgui";i:17;s:15:"ilpermissiongui";i:18;s:22:"ilpublicuserprofilegui";i:19;s:21:"ilrepositorysearchgui";i:20;s:20:"ilsessionoverviewgui";i:21;s:17:"ilshoppurchasegui";}s:23:"ilobjcoursereferencegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:17:"illmpageobjectgui";a:1:{i:0;s:15:"ilpageobjectgui";}s:20:"ilstructureobjectgui";a:2:{i:0;s:27:"ilconditionhandlerinterface";i:1;s:13:"ilmdeditorgui";}s:14:"ilobjdlbookgui";a:7:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:17:"illmpageobjectgui";i:3;s:13:"ilmdeditorgui";i:4;s:18:"ilobjstylesheetgui";i:5;s:15:"ilpermissiongui";i:6;s:20:"ilstructureobjectgui";}s:16:"ilobjexercisegui";a:5:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";i:4;s:21:"ilrepositorysearchgui";}s:20:"ilobjexternalfeedgui";a:2:{i:0;s:22:"ilexternalfeedblockgui";i:1;s:15:"ilpermissiongui";}s:19:"ilobjfilebasedlmgui";a:7:{i:0;s:15:"ilfilesystemgui";i:1;s:15:"ilinfoscreengui";i:2;s:21:"illearningprogressgui";i:3;s:12:"illicensegui";i:4;s:13:"ilmdeditorgui";i:5;s:15:"ilpermissiongui";i:6;s:17:"ilshoppurchasegui";}s:12:"ilobjfilegui";a:5:{i:0;s:15:"ilinfoscreengui";i:1;s:13:"ilmdeditorgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";i:4;s:17:"ilshoppurchasegui";}s:14:"ilobjfoldergui";a:10:{i:0;s:11:"ilcolumngui";i:1;s:27:"ilconditionhandlerinterface";i:2;s:18:"ilcoursecontentgui";i:3;s:29:"ilcourseitemadministrationgui";i:4;s:15:"ilinfoscreengui";i:5;s:21:"illearningprogressgui";i:6;s:15:"ilobjectcopygui";i:7;s:18:"ilobjstylesheetgui";i:8;s:15:"ilpageobjectgui";i:9;s:15:"ilpermissiongui";}s:13:"ilobjforumgui";a:7:{i:0;s:11:"ilcolumngui";i:1;s:16:"ilforumexportgui";i:2;s:20:"ilforummoderatorsgui";i:3;s:15:"ilinfoscreengui";i:4;s:15:"ilobjectcopygui";i:5;s:15:"ilpermissiongui";i:6;s:22:"ilpublicuserprofilegui";}s:25:"iltermdefinitioneditorgui";a:2:{i:0;s:13:"ilmdeditorgui";i:1;s:15:"ilpageobjectgui";}s:17:"ilglossarytermgui";a:2:{i:0;s:15:"ilpageobjectgui";i:1;s:25:"iltermdefinitioneditorgui";}s:16:"ilobjglossarygui";a:4:{i:0;s:17:"ilglossarytermgui";i:1;s:15:"ilinfoscreengui";i:2;s:13:"ilmdeditorgui";i:3;s:15:"ilpermissiongui";}s:13:"ilobjgroupgui";a:14:{i:0;s:11:"ilcolumngui";i:1;s:27:"ilconditionhandlerinterface";i:2;s:18:"ilcoursecontentgui";i:3;s:29:"ilcourseitemadministrationgui";i:4;s:22:"ilgroupregistrationgui";i:5;s:15:"ilinfoscreengui";i:6;s:21:"illearningprogressgui";i:7;s:22:"ilobjcoursegroupinggui";i:8;s:15:"ilobjectcopygui";i:9;s:18:"ilobjstylesheetgui";i:10;s:15:"ilpageobjectgui";i:11;s:15:"ilpermissiongui";i:12;s:22:"ilpublicuserprofilegui";i:13;s:21:"ilrepositorysearchgui";}s:19:"ilobjilinccoursegui";a:6:{i:0;s:11:"ilcolumngui";i:1;s:15:"ilinfoscreengui";i:2;s:22:"ilobjilincclassroomgui";i:3;s:15:"ilpermissiongui";i:4;s:22:"ilpublicuserprofilegui";i:5;s:21:"ilrepositorysearchgui";}s:22:"ilobjlearningmodulegui";a:7:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:17:"illmpageobjectgui";i:3;s:13:"ilmdeditorgui";i:4;s:18:"ilobjstylesheetgui";i:5;s:15:"ilpermissiongui";i:6;s:20:"ilstructureobjectgui";}s:20:"ilobjlinkresourcegui";a:4:{i:0;s:15:"ilinfoscreengui";i:1;s:13:"ilmdeditorgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";}s:17:"ilobjmediacastgui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:18:"ilmediapoolpagegui";a:5:{i:0;s:18:"ileditclipboardgui";i:1;s:25:"ilmediapooltargetselector";i:2;s:15:"ilpageeditorgui";i:3;s:15:"ilpageobjectgui";i:4;s:22:"ilpublicuserprofilegui";}s:17:"ilobjmediapoolgui";a:6:{i:0;s:18:"ileditclipboardgui";i:1;s:15:"ilinfoscreengui";i:2;s:18:"ilmediapoolpagegui";i:3;s:14:"ilobjfoldergui";i:4;s:19:"ilobjmediaobjectgui";i:5;s:15:"ilpermissiongui";}s:20:"ilobjquestionpoolgui";a:18:{i:0;s:15:"assclozetestgui";i:1;s:15:"asserrortextgui";i:2;s:16:"assfileuploadgui";i:3;s:19:"assflashquestiongui";i:4;s:22:"assimagemapquestiongui";i:5;s:16:"assjavaappletgui";i:6;s:22:"assmatchingquestiongui";i:7;s:20:"assmultiplechoicegui";i:8;s:13:"assnumericgui";i:9;s:24:"assorderinghorizontalgui";i:10;s:22:"assorderingquestiongui";i:11;s:18:"asssinglechoicegui";i:12;s:18:"asstextquestiongui";i:13;s:16:"asstextsubsetgui";i:14;s:13:"ilmdeditorgui";i:15;s:15:"ilobjectcopygui";i:16;s:15:"ilpageobjectgui";i:17;s:15:"ilpermissiongui";}s:20:"ilobjremotecoursegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:18:"ilobjrootfoldergui";a:6:{i:0;s:11:"ilcolumngui";i:1;s:22:"ilcontainerlinklistgui";i:2;s:15:"ilobjectcopygui";i:3;s:18:"ilobjstylesheetgui";i:4;s:15:"ilpageobjectgui";i:5;s:15:"ilpermissiongui";}s:26:"ilobjsahslearningmodulegui";a:6:{i:0;s:15:"ilfilesystemgui";i:1;s:15:"ilinfoscreengui";i:2;s:21:"illearningprogressgui";i:3;s:12:"illicensegui";i:4;s:13:"ilmdeditorgui";i:5;s:15:"ilpermissiongui";}s:15:"ilobjsessiongui";a:4:{i:0;s:29:"ilcourseitemadministrationgui";i:1;s:15:"ilinfoscreengui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";}s:14:"ilobjsurveygui";a:6:{i:0;s:15:"ilinfoscreengui";i:1;s:13:"ilmdeditorgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";i:4;s:21:"ilsurveyevaluationgui";i:5;s:20:"ilsurveyexecutiongui";}s:26:"ilobjsurveyquestionpoolgui";a:9:{i:0;s:13:"ilmdeditorgui";i:1;s:15:"ilobjectcopygui";i:2;s:15:"ilpermissiongui";i:3;s:18:"ilsurveyphrasesgui";i:4;s:23:"surveymatrixquestiongui";i:5;s:23:"surveymetricquestiongui";i:6;s:31:"surveymultiplechoicequestiongui";i:7;s:29:"surveysinglechoicequestiongui";i:8;s:21:"surveytextquestiongui";}s:12:"ilobjtestgui";a:12:{i:0;s:16:"ilcertificategui";i:1;s:15:"ilinfoscreengui";i:2;s:21:"illearningprogressgui";i:3;s:13:"ilmdeditorgui";i:4;s:14:"ilobjcoursegui";i:5;s:15:"ilobjectcopygui";i:6;s:15:"ilpermissiongui";i:7;s:17:"ilshoppurchasegui";i:8;s:19:"iltestevaluationgui";i:9;s:15:"iltestoutputgui";i:10;s:16:"iltestscoringgui";i:11;s:16:"iltestservicegui";}s:13:"ilwikipagegui";a:7:{i:0;s:18:"ileditclipboardgui";i:1;s:25:"ilmediapooltargetselector";i:2;s:9:"ilnotegui";i:3;s:15:"ilpageeditorgui";i:4;s:15:"ilpageobjectgui";i:5;s:22:"ilpublicuserprofilegui";i:6;s:11:"ilratinggui";}s:12:"ilobjwikigui";a:5:{i:0;s:15:"ilinfoscreengui";i:1;s:18:"ilobjstylesheetgui";i:2;s:15:"ilpermissiongui";i:3;s:22:"ilpublicuserprofilegui";i:4;s:13:"ilwikipagegui";}s:15:"ilrepositorygui";a:31:{i:0;s:21:"ilcourseobjectivesgui";i:1;s:16:"ilobjcategorygui";i:2;s:25:"ilobjcategoryreferencegui";i:3;s:12:"ilobjchatgui";i:4;s:14:"ilobjcoursegui";i:5;s:23:"ilobjcoursereferencegui";i:6;s:14:"ilobjdlbookgui";i:7;s:16:"ilobjexercisegui";i:8;s:20:"ilobjexternalfeedgui";i:9;s:19:"ilobjfilebasedlmgui";i:10;s:12:"ilobjfilegui";i:11;s:14:"ilobjfoldergui";i:12;s:13:"ilobjforumgui";i:13;s:16:"ilobjglossarygui";i:14;s:13:"ilobjgroupgui";i:15;s:22:"ilobjilincclassroomgui";i:16;s:19:"ilobjilinccoursegui";i:17;s:22:"ilobjlearningmodulegui";i:18;s:20:"ilobjlinkresourcegui";i:19;s:17:"ilobjmediacastgui";i:20;s:17:"ilobjmediapoolgui";i:21;s:20:"ilobjquestionpoolgui";i:22;s:20:"ilobjremotecoursegui";i:23;s:12:"ilobjrolegui";i:24;s:18:"ilobjrootfoldergui";i:25;s:26:"ilobjsahslearningmodulegui";i:26;s:15:"ilobjsessiongui";i:27;s:14:"ilobjsurveygui";i:28;s:26:"ilobjsurveyquestionpoolgui";i:29;s:12:"ilobjtestgui";i:30;s:12:"ilobjwikigui";}}'), 'parent' => array('clob', 'a:161:{s:24:"ilcalendarappointmentgui";a:6:{i:0;s:16:"ilcalendardaygui";i:1;s:18:"ilcalendarinboxgui";i:2;s:18:"ilcalendarmonthgui";i:3;s:17:"ilcalendarweekgui";i:4;s:18:"ilcalendarblockgui";i:5;s:20:"ilpdcalendarblockgui";}s:16:"ilcalendardaygui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarinboxgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarmonthgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:17:"ilcalendarweekgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:13:"ilnewsitemgui";a:1:{i:0;s:24:"ilnewsforcontextblockgui";}s:22:"ilpublicuserprofilegui";a:11:{i:0;s:21:"ilusersonlineblockgui";i:1;s:15:"ilinfoscreengui";i:2;s:15:"ilpageobjectgui";i:3;s:12:"ilobjchatgui";i:4;s:14:"ilobjcoursegui";i:5;s:13:"ilobjforumgui";i:6;s:13:"ilobjgroupgui";i:7;s:19:"ilobjilinccoursegui";i:8;s:18:"ilmediapoolpagegui";i:9;s:13:"ilwikipagegui";i:10;s:12:"ilobjwikigui";}s:18:"ilbookmarkblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:18:"ilcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilchatblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:15:"ildummyblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilexternalfeedblockgui";a:2:{i:0;s:11:"ilcolumngui";i:1;s:20:"ilobjexternalfeedgui";}s:14:"ilhtmlblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilpdexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdfeedbackblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdmailblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdnewsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:17:"ilpdnotesblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:25:"ilpdselecteditemsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilpdsysmessageblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:19:"ilpdtaggingblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:11:"ilcolumngui";a:9:{i:0;s:15:"ilinfoscreengui";i:1;s:16:"ilobjcategorygui";i:2;s:18:"ilcoursecontentgui";i:3;s:14:"ilobjcoursegui";i:4;s:14:"ilobjfoldergui";i:5;s:13:"ilobjforumgui";i:6;s:13:"ilobjgroupgui";i:7;s:19:"ilobjilinccoursegui";i:8;s:18:"ilobjrootfoldergui";}s:13:"ilfeedbackgui";a:1:{i:0;s:15:"ilinfoscreengui";}s:9:"ilnotegui";a:3:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpageobjectgui";i:2;s:13:"ilwikipagegui";}s:28:"ilrepositoryselectorinputgui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:25:"ilformpropertydispatchgui";a:3:{i:0;s:19:"illpobjectstablegui";i:1;s:20:"illpprogresstablegui";i:2;s:14:"ilusertablegui";}s:13:"illpfiltergui";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:17:"ilpdfpresentation";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:15:"iluserfiltergui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:20:"illpprogresstablegui";a:1:{i:0;s:21:"illplistofprogressgui";}s:17:"illmstatisticsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:20:"illplistofobjectsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofprogressgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofsettingsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illearningprogressgui";a:10:{i:0;s:12:"ilobjusergui";i:1;s:14:"ilobjcoursegui";i:2;s:14:"ilobjdlbookgui";i:3;s:16:"ilobjexercisegui";i:4;s:19:"ilobjfilebasedlmgui";i:5;s:14:"ilobjfoldergui";i:6;s:13:"ilobjgroupgui";i:7;s:22:"ilobjlearningmodulegui";i:8;s:26:"ilobjsahslearningmodulegui";i:9;s:12:"ilobjtestgui";}s:17:"ilobjilincusergui";a:1:{i:0;s:12:"ilobjusergui";}s:12:"ilobjusergui";a:2:{i:0;s:20:"iladminusersearchgui";i:1;s:16:"ilobjcategorygui";}s:21:"ilrepositorysearchgui";a:5:{i:0;s:12:"ilobjrolegui";i:1;s:14:"ilobjcoursegui";i:2;s:16:"ilobjexercisegui";i:3;s:13:"ilobjgroupgui";i:4;s:19:"ilobjilinccoursegui";}s:12:"ilobjrolegui";a:2:{i:0;s:15:"ilpermissiongui";i:1;s:15:"ilrepositorygui";}s:20:"iladminusersearchgui";a:1:{i:0;s:18:"ilobjuserfoldergui";}s:15:"ilpermissiongui";a:29:{i:0;s:18:"ilobjuserfoldergui";i:1;s:16:"ilobjcategorygui";i:2;s:25:"ilobjcategoryreferencegui";i:3;s:12:"ilobjchatgui";i:4;s:14:"ilobjcoursegui";i:5;s:23:"ilobjcoursereferencegui";i:6;s:14:"ilobjdlbookgui";i:7;s:16:"ilobjexercisegui";i:8;s:20:"ilobjexternalfeedgui";i:9;s:19:"ilobjfilebasedlmgui";i:10;s:12:"ilobjfilegui";i:11;s:14:"ilobjfoldergui";i:12;s:13:"ilobjforumgui";i:13;s:16:"ilobjglossarygui";i:14;s:13:"ilobjgroupgui";i:15;s:19:"ilobjilinccoursegui";i:16;s:22:"ilobjlearningmodulegui";i:17;s:20:"ilobjlinkresourcegui";i:18;s:17:"ilobjmediacastgui";i:19;s:17:"ilobjmediapoolgui";i:20;s:20:"ilobjquestionpoolgui";i:21;s:20:"ilobjremotecoursegui";i:22;s:18:"ilobjrootfoldergui";i:23;s:26:"ilobjsahslearningmodulegui";i:24;s:15:"ilobjsessiongui";i:25;s:14:"ilobjsurveygui";i:26;s:26:"ilobjsurveyquestionpoolgui";i:27;s:12:"ilobjtestgui";i:28;s:12:"ilobjwikigui";}s:14:"ilusertablegui";a:1:{i:0;s:18:"ilobjuserfoldergui";}s:17:"ilinternallinkgui";a:3:{i:0;s:19:"ilimagemapeditorgui";i:1;s:21:"ilpcimagemapeditorgui";i:2;s:15:"ilpageeditorgui";}s:15:"ilfilesystemgui";a:3:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:19:"ilobjfilebasedlmgui";i:2;s:26:"ilobjsahslearningmodulegui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:13:"ilmdeditorgui";a:16:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:15:"ilpageobjectgui";i:2;s:14:"ilobjcoursegui";i:3;s:20:"ilstructureobjectgui";i:4;s:14:"ilobjdlbookgui";i:5;s:19:"ilobjfilebasedlmgui";i:6;s:12:"ilobjfilegui";i:7;s:25:"iltermdefinitioneditorgui";i:8;s:16:"ilobjglossarygui";i:9;s:22:"ilobjlearningmodulegui";i:10;s:20:"ilobjlinkresourcegui";i:11;s:20:"ilobjquestionpoolgui";i:12;s:26:"ilobjsahslearningmodulegui";i:13;s:14:"ilobjsurveygui";i:14;s:26:"ilobjsurveyquestionpoolgui";i:15;s:12:"ilobjtestgui";}s:19:"ilobjmediaobjectgui";a:4:{i:0;s:18:"ileditclipboardgui";i:1;s:18:"ilpcmediaobjectgui";i:2;s:15:"ilpageeditorgui";i:3;s:17:"ilobjmediapoolgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:18:"ilpcplaceholdergui";i:1;s:15:"ilpageeditorgui";}s:15:"assclozetestgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:22:"assimagemapquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:16:"assjavaappletgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:22:"assmatchingquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:20:"assmultiplechoicegui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:13:"assnumericgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:22:"assorderingquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:18:"asssinglechoicegui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:18:"asstextquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:16:"asstextsubsetgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:17:"ilquestioneditgui";a:1:{i:0;s:15:"ilpcquestiongui";}s:21:"ilpccontentincludegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcdatatablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfileitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfilelistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpclistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpclistitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:10:"ilpcmapgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcparagraphgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcpluggedgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcresourcesgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcsectiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:17:"ilpcsourcecodegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpctabledatagui";a:1:{i:0;s:15:"ilpageeditorgui";}s:12:"ilpctablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpctabsgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ileditclipboardgui";a:4:{i:0;s:15:"ilpageobjectgui";i:1;s:18:"ilmediapoolpagegui";i:2;s:17:"ilobjmediapoolgui";i:3;s:13:"ilwikipagegui";}s:15:"ilpageeditorgui";a:3:{i:0;s:15:"ilpageobjectgui";i:1;s:18:"ilmediapoolpagegui";i:2;s:13:"ilwikipagegui";}s:22:"ilcontainerlinklistgui";a:2:{i:0;s:16:"ilobjcategorygui";i:1;s:18:"ilobjrootfoldergui";}s:15:"ilinfoscreengui";a:24:{i:0;s:16:"ilobjcategorygui";i:1;s:25:"ilobjcategoryreferencegui";i:2;s:12:"ilobjchatgui";i:3;s:14:"ilobjcoursegui";i:4;s:23:"ilobjcoursereferencegui";i:5;s:14:"ilobjdlbookgui";i:6;s:16:"ilobjexercisegui";i:7;s:19:"ilobjfilebasedlmgui";i:8;s:12:"ilobjfilegui";i:9;s:14:"ilobjfoldergui";i:10;s:13:"ilobjforumgui";i:11;s:16:"ilobjglossarygui";i:12;s:13:"ilobjgroupgui";i:13;s:19:"ilobjilinccoursegui";i:14;s:22:"ilobjlearningmodulegui";i:15;s:20:"ilobjlinkresourcegui";i:16;s:17:"ilobjmediacastgui";i:17;s:17:"ilobjmediapoolgui";i:18;s:20:"ilobjremotecoursegui";i:19;s:26:"ilobjsahslearningmodulegui";i:20;s:15:"ilobjsessiongui";i:21;s:14:"ilobjsurveygui";i:22;s:12:"ilobjtestgui";i:23;s:12:"ilobjwikigui";}s:15:"ilobjectcopygui";a:15:{i:0;s:16:"ilobjcategorygui";i:1;s:12:"ilobjchatgui";i:2;s:14:"ilobjcoursegui";i:3;s:16:"ilobjexercisegui";i:4;s:12:"ilobjfilegui";i:5;s:14:"ilobjfoldergui";i:6;s:13:"ilobjforumgui";i:7;s:13:"ilobjgroupgui";i:8;s:20:"ilobjlinkresourcegui";i:9;s:20:"ilobjquestionpoolgui";i:10;s:18:"ilobjrootfoldergui";i:11;s:15:"ilobjsessiongui";i:12;s:14:"ilobjsurveygui";i:13;s:26:"ilobjsurveyquestionpoolgui";i:14;s:12:"ilobjtestgui";}s:18:"ilobjstylesheetgui";a:8:{i:0;s:16:"ilobjcategorygui";i:1;s:14:"ilobjcoursegui";i:2;s:14:"ilobjdlbookgui";i:3;s:14:"ilobjfoldergui";i:4;s:13:"ilobjgroupgui";i:5;s:22:"ilobjlearningmodulegui";i:6;s:18:"ilobjrootfoldergui";i:7;s:12:"ilobjwikigui";}s:18:"ilobjuserfoldergui";a:1:{i:0;s:16:"ilobjcategorygui";}s:15:"ilpageobjectgui";a:12:{i:0;s:16:"ilobjcategorygui";i:1;s:17:"ilshoppurchasegui";i:2;s:14:"ilobjcoursegui";i:3;s:17:"illmpageobjectgui";i:4;s:14:"ilobjfoldergui";i:5;s:25:"iltermdefinitioneditorgui";i:6;s:17:"ilglossarytermgui";i:7;s:13:"ilobjgroupgui";i:8;s:18:"ilmediapoolpagegui";i:9;s:20:"ilobjquestionpoolgui";i:10;s:18:"ilobjrootfoldergui";i:11;s:13:"ilwikipagegui";}s:19:"ilcoursearchivesgui";a:1:{i:0;s:18:"ilcoursecontentgui";}s:32:"ilcourseobjectivepresentationgui";a:1:{i:0;s:18:"ilcoursecontentgui";}s:27:"ilconditionhandlerinterface";a:5:{i:0;s:29:"ilcourseitemadministrationgui";i:1;s:14:"ilobjcoursegui";i:2;s:20:"ilstructureobjectgui";i:3;s:14:"ilobjfoldergui";i:4;s:13:"ilobjgroupgui";}s:20:"ilcourseagreementgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:18:"ilcoursecontentgui";a:3:{i:0;s:14:"ilobjcoursegui";i:1;s:14:"ilobjfoldergui";i:2;s:13:"ilobjgroupgui";}s:29:"ilcourseitemadministrationgui";a:4:{i:0;s:14:"ilobjcoursegui";i:1;s:14:"ilobjfoldergui";i:2;s:13:"ilobjgroupgui";i:3;s:15:"ilobjsessiongui";}s:21:"ilcourseobjectivesgui";a:2:{i:0;s:14:"ilobjcoursegui";i:1;s:15:"ilrepositorygui";}s:23:"ilcourseregistrationgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:21:"ilcourseuserfieldsgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:20:"illicenseoverviewgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:17:"ilmemberexportgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:22:"ilobjcoursegroupinggui";a:2:{i:0;s:14:"ilobjcoursegui";i:1;s:13:"ilobjgroupgui";}s:20:"ilsessionoverviewgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:17:"ilshoppurchasegui";a:4:{i:0;s:14:"ilobjcoursegui";i:1;s:19:"ilobjfilebasedlmgui";i:2;s:12:"ilobjfilegui";i:3;s:12:"ilobjtestgui";}s:17:"illmpageobjectgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:20:"ilstructureobjectgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:12:"illicensegui";a:2:{i:0;s:19:"ilobjfilebasedlmgui";i:1;s:26:"ilobjsahslearningmodulegui";}s:16:"ilforumexportgui";a:1:{i:0;s:13:"ilobjforumgui";}s:20:"ilforummoderatorsgui";a:1:{i:0;s:13:"ilobjforumgui";}s:25:"iltermdefinitioneditorgui";a:1:{i:0;s:17:"ilglossarytermgui";}s:17:"ilglossarytermgui";a:1:{i:0;s:16:"ilobjglossarygui";}s:22:"ilgroupregistrationgui";a:1:{i:0;s:13:"ilobjgroupgui";}s:22:"ilobjilincclassroomgui";a:2:{i:0;s:19:"ilobjilinccoursegui";i:1;s:15:"ilrepositorygui";}s:25:"ilmediapooltargetselector";a:2:{i:0;s:18:"ilmediapoolpagegui";i:1;s:13:"ilwikipagegui";}s:18:"ilmediapoolpagegui";a:1:{i:0;s:17:"ilobjmediapoolgui";}s:14:"ilobjfoldergui";a:2:{i:0;s:17:"ilobjmediapoolgui";i:1;s:15:"ilrepositorygui";}s:15:"asserrortextgui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:16:"assfileuploadgui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:19:"assflashquestiongui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:24:"assorderinghorizontalgui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:21:"ilsurveyevaluationgui";a:1:{i:0;s:14:"ilobjsurveygui";}s:20:"ilsurveyexecutiongui";a:1:{i:0;s:14:"ilobjsurveygui";}s:18:"ilsurveyphrasesgui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:23:"surveymatrixquestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:23:"surveymetricquestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:31:"surveymultiplechoicequestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:29:"surveysinglechoicequestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:21:"surveytextquestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:16:"ilcertificategui";a:1:{i:0;s:12:"ilobjtestgui";}s:14:"ilobjcoursegui";a:2:{i:0;s:12:"ilobjtestgui";i:1;s:15:"ilrepositorygui";}s:19:"iltestevaluationgui";a:1:{i:0;s:12:"ilobjtestgui";}s:15:"iltestoutputgui";a:1:{i:0;s:12:"ilobjtestgui";}s:16:"iltestscoringgui";a:1:{i:0;s:12:"ilobjtestgui";}s:16:"iltestservicegui";a:1:{i:0;s:12:"ilobjtestgui";}s:11:"ilratinggui";a:1:{i:0;s:13:"ilwikipagegui";}s:13:"ilwikipagegui";a:1:{i:0;s:12:"ilobjwikigui";}s:16:"ilobjcategorygui";a:1:{i:0;s:15:"ilrepositorygui";}s:25:"ilobjcategoryreferencegui";a:1:{i:0;s:15:"ilrepositorygui";}s:12:"ilobjchatgui";a:1:{i:0;s:15:"ilrepositorygui";}s:23:"ilobjcoursereferencegui";a:1:{i:0;s:15:"ilrepositorygui";}s:14:"ilobjdlbookgui";a:1:{i:0;s:15:"ilrepositorygui";}s:16:"ilobjexercisegui";a:1:{i:0;s:15:"ilrepositorygui";}s:20:"ilobjexternalfeedgui";a:1:{i:0;s:15:"ilrepositorygui";}s:19:"ilobjfilebasedlmgui";a:1:{i:0;s:15:"ilrepositorygui";}s:12:"ilobjfilegui";a:1:{i:0;s:15:"ilrepositorygui";}s:13:"ilobjforumgui";a:1:{i:0;s:15:"ilrepositorygui";}s:16:"ilobjglossarygui";a:1:{i:0;s:15:"ilrepositorygui";}s:13:"ilobjgroupgui";a:1:{i:0;s:15:"ilrepositorygui";}s:19:"ilobjilinccoursegui";a:1:{i:0;s:15:"ilrepositorygui";}s:22:"ilobjlearningmodulegui";a:1:{i:0;s:15:"ilrepositorygui";}s:20:"ilobjlinkresourcegui";a:1:{i:0;s:15:"ilrepositorygui";}s:17:"ilobjmediacastgui";a:1:{i:0;s:15:"ilrepositorygui";}s:17:"ilobjmediapoolgui";a:1:{i:0;s:15:"ilrepositorygui";}s:20:"ilobjquestionpoolgui";a:1:{i:0;s:15:"ilrepositorygui";}s:20:"ilobjremotecoursegui";a:1:{i:0;s:15:"ilrepositorygui";}s:18:"ilobjrootfoldergui";a:1:{i:0;s:15:"ilrepositorygui";}s:26:"ilobjsahslearningmodulegui";a:1:{i:0;s:15:"ilrepositorygui";}s:15:"ilobjsessiongui";a:1:{i:0;s:15:"ilrepositorygui";}s:14:"ilobjsurveygui";a:1:{i:0;s:15:"ilrepositorygui";}s:26:"ilobjsurveyquestionpoolgui";a:1:{i:0;s:15:"ilrepositorygui";}s:12:"ilobjtestgui";a:1:{i:0;s:15:"ilrepositorygui";}s:12:"ilobjwikigui";a:1:{i:0;s:15:"ilrepositorygui";}}')));

$ilDB->insert("ctrl_structure", array(
'root_class' => array('text', 'ilpersonaldesktopgui'), 'call_node' => array('clob', 'a:185:{i:1;a:2:{s:5:"class";s:20:"ilpersonaldesktopgui";s:6:"parent";i:0;}i:2;a:2:{s:5:"class";s:27:"ilbookmarkadministrationgui";s:6:"parent";i:1;}i:3;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2;}i:4;a:2:{s:5:"class";s:25:"ilcalendarpresentationgui";s:6:"parent";i:1;}i:5;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:4;}i:6;a:2:{s:5:"class";s:21:"ilcalendarcategorygui";s:6:"parent";i:4;}i:7;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:6;}i:8;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:4;}i:9;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:8;}i:10;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:4;}i:11;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:10;}i:12;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:4;}i:13;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:12;}i:14;a:2:{s:5:"class";s:25:"ilcalendarusersettingsgui";s:6:"parent";i:4;}i:15;a:2:{s:5:"class";s:0:"";s:6:"parent";i:14;}i:16;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:4;}i:17;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:16;}i:18;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1;}i:19;a:2:{s:5:"class";s:0:"";s:6:"parent";i:18;}i:20;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:18;}i:21;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:18;}i:22;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:21;}i:23;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:21;}i:24;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:23;}i:25;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:21;}i:26;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:25;}i:27;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:21;}i:28;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:27;}i:29;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:21;}i:30;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:29;}i:31;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:18;}i:32;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:18;}i:33;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:18;}i:34;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:18;}i:35;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:18;}i:36;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:35;}i:37;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:18;}i:38;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:37;}i:39;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:37;}i:40;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:39;}i:41;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:37;}i:42;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:41;}i:43;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:37;}i:44;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:43;}i:45;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:37;}i:46;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:45;}i:47;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:18;}i:48;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:18;}i:49;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:18;}i:50;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:18;}i:51;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:18;}i:52;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:18;}i:53;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:18;}i:54;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:18;}i:55;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:18;}i:56;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:55;}i:57;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1;}i:58;a:2:{s:5:"class";s:0:"";s:6:"parent";i:57;}i:59;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:1;}i:60;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:59;}i:61;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:59;}i:62;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:61;}i:63;a:2:{s:5:"class";s:0:"";s:6:"parent";i:62;}i:64;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:61;}i:65;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:64;}i:66;a:2:{s:5:"class";s:0:"";s:6:"parent";i:65;}i:67;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:65;}i:68;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:61;}i:69;a:2:{s:5:"class";s:0:"";s:6:"parent";i:68;}i:70;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:61;}i:71;a:2:{s:5:"class";s:0:"";s:6:"parent";i:70;}i:72;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:59;}i:73;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:72;}i:74;a:2:{s:5:"class";s:0:"";s:6:"parent";i:73;}i:75;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:72;}i:76;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:75;}i:77;a:2:{s:5:"class";s:0:"";s:6:"parent";i:76;}i:78;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:76;}i:79;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:72;}i:80;a:2:{s:5:"class";s:0:"";s:6:"parent";i:79;}i:81;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:59;}i:82;a:2:{s:5:"class";s:0:"";s:6:"parent";i:81;}i:83;a:2:{s:5:"class";s:20:"ilmailaddressbookgui";s:6:"parent";i:1;}i:84;a:2:{s:5:"class";s:13:"ilmailformgui";s:6:"parent";i:83;}i:85;a:2:{s:5:"class";s:19:"ilmailattachmentgui";s:6:"parent";i:84;}i:86;a:2:{s:5:"class";s:15:"ilmailfoldergui";s:6:"parent";i:84;}i:87;a:2:{s:5:"class";s:19:"ilmailattachmentgui";s:6:"parent";i:86;}i:88;a:2:{s:5:"class";s:16:"ilmailoptionsgui";s:6:"parent";i:86;}i:89;a:2:{s:5:"class";s:15:"ilmailsearchgui";s:6:"parent";i:86;}i:90;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:86;}i:91;a:2:{s:5:"class";s:22:"ilmailsearchcoursesgui";s:6:"parent";i:84;}i:92;a:2:{s:5:"class";s:21:"ilmailsearchgroupsgui";s:6:"parent";i:84;}i:93;a:2:{s:5:"class";s:15:"ilmailsearchgui";s:6:"parent";i:84;}i:94;a:2:{s:5:"class";s:17:"ilmailinglistsgui";s:6:"parent";i:83;}i:95;a:2:{s:5:"class";s:22:"ilmailsearchcoursesgui";s:6:"parent";i:83;}i:96;a:2:{s:5:"class";s:21:"ilmailsearchgroupsgui";s:6:"parent";i:83;}i:97;a:2:{s:5:"class";s:9:"ilobjchat";s:6:"parent";i:83;}i:98;a:2:{s:5:"class";s:12:"ilobjchatgui";s:6:"parent";i:83;}i:99;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:98;}i:100;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:99;}i:101;a:2:{s:5:"class";s:0:"";s:6:"parent";i:100;}i:102;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:100;}i:103;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:100;}i:104;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:103;}i:105;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:103;}i:106;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:105;}i:107;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:103;}i:108;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:107;}i:109;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:103;}i:110;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:109;}i:111;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:103;}i:112;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:111;}i:113;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:100;}i:114;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:100;}i:115;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:100;}i:116;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:100;}i:117;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:100;}i:118;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:117;}i:119;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:100;}i:120;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:119;}i:121;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:119;}i:122;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:121;}i:123;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:119;}i:124;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:123;}i:125;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:119;}i:126;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:125;}i:127;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:119;}i:128;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:127;}i:129;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:100;}i:130;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:100;}i:131;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:100;}i:132;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:100;}i:133;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:100;}i:134;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:100;}i:135;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:100;}i:136;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:100;}i:137;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:100;}i:138;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:137;}i:139;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:99;}i:140;a:2:{s:5:"class";s:0:"";s:6:"parent";i:139;}i:141;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:99;}i:142;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:99;}i:143;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:98;}i:144;a:2:{s:5:"class";s:0:"";s:6:"parent";i:143;}i:145;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:98;}i:146;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:145;}i:147;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:146;}i:148;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:98;}i:149;a:2:{s:5:"class";s:15:"ilmailsearchgui";s:6:"parent";i:1;}i:150;a:2:{s:5:"class";s:19:"ilobjlanguageextgui";s:6:"parent";i:1;}i:151;a:2:{s:5:"class";s:0:"";s:6:"parent";i:150;}i:152;a:2:{s:5:"class";s:12:"ilobjusergui";s:6:"parent";i:1;}i:153;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:152;}i:154;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:153;}i:155;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:153;}i:156;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:155;}i:157;a:2:{s:5:"class";s:0:"";s:6:"parent";i:156;}i:158;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:155;}i:159;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:158;}i:160;a:2:{s:5:"class";s:0:"";s:6:"parent";i:159;}i:161;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:159;}i:162;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:155;}i:163;a:2:{s:5:"class";s:0:"";s:6:"parent";i:162;}i:164;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:155;}i:165;a:2:{s:5:"class";s:0:"";s:6:"parent";i:164;}i:166;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:153;}i:167;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:166;}i:168;a:2:{s:5:"class";s:0:"";s:6:"parent";i:167;}i:169;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:166;}i:170;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:169;}i:171;a:2:{s:5:"class";s:0:"";s:6:"parent";i:170;}i:172;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:170;}i:173;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:166;}i:174;a:2:{s:5:"class";s:0:"";s:6:"parent";i:173;}i:175;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:153;}i:176;a:2:{s:5:"class";s:0:"";s:6:"parent";i:175;}i:177;a:2:{s:5:"class";s:17:"ilobjilincusergui";s:6:"parent";i:152;}i:178;a:2:{s:5:"class";s:11:"ilpdnewsgui";s:6:"parent";i:1;}i:179;a:2:{s:5:"class";s:0:"";s:6:"parent";i:178;}i:180;a:2:{s:5:"class";s:12:"ilpdnotesgui";s:6:"parent";i:1;}i:181;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:180;}i:182;a:2:{s:5:"class";s:0:"";s:6:"parent";i:181;}i:183;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:180;}i:184;a:2:{s:5:"class";s:20:"ilpersonalprofilegui";s:6:"parent";i:1;}i:185;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:184;}}'), 'forward' => array('clob', 'a:28:{s:21:"ilcalendarcategorygui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:16:"ilcalendardaygui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarinboxgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarmonthgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:17:"ilcalendarweekgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:25:"ilcalendarpresentationgui";a:7:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:21:"ilcalendarcategorygui";i:2;s:16:"ilcalendardaygui";i:3;s:18:"ilcalendarinboxgui";i:4;s:18:"ilcalendarmonthgui";i:5;s:25:"ilcalendarusersettingsgui";i:6;s:17:"ilcalendarweekgui";}s:18:"ilcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:13:"ilnewsitemgui";}s:20:"ilpdcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:22:"ilpublicuserprofilegui";}s:11:"ilcolumngui";a:17:{i:0;s:18:"ilbookmarkblockgui";i:1;s:18:"ilcalendarblockgui";i:2;s:14:"ilchatblockgui";i:3;s:15:"ildummyblockgui";i:4;s:22:"ilexternalfeedblockgui";i:5;s:14:"ilhtmlblockgui";i:6;s:24:"ilnewsforcontextblockgui";i:7;s:20:"ilpdcalendarblockgui";i:8;s:24:"ilpdexternalfeedblockgui";i:9;s:20:"ilpdfeedbackblockgui";i:10;s:16:"ilpdmailblockgui";i:11;s:16:"ilpdnewsblockgui";i:12;s:17:"ilpdnotesblockgui";i:13;s:25:"ilpdselecteditemsblockgui";i:14;s:22:"ilpdsysmessageblockgui";i:15;s:19:"ilpdtaggingblockgui";i:16;s:21:"ilusersonlineblockgui";}s:25:"ilformpropertydispatchgui";a:1:{i:0;s:28:"ilrepositoryselectorinputgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:20:"illplistofobjectsgui";a:4:{i:0;s:13:"illpfiltergui";i:1;s:19:"illpobjectstablegui";i:2;s:17:"ilpdfpresentation";i:3;s:15:"iluserfiltergui";}s:20:"illpprogresstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:21:"illplistofprogressgui";a:3:{i:0;s:13:"illpfiltergui";i:1;s:20:"illpprogresstablegui";i:2;s:17:"ilpdfpresentation";}s:21:"illearningprogressgui";a:4:{i:0;s:17:"illmstatisticsgui";i:1;s:20:"illplistofobjectsgui";i:2;s:21:"illplistofprogressgui";i:3;s:21:"illplistofsettingsgui";}s:15:"ilmailfoldergui";a:4:{i:0;s:19:"ilmailattachmentgui";i:1;s:16:"ilmailoptionsgui";i:2;s:15:"ilmailsearchgui";i:3;s:22:"ilpublicuserprofilegui";}s:13:"ilmailformgui";a:5:{i:0;s:19:"ilmailattachmentgui";i:1;s:15:"ilmailfoldergui";i:2;s:22:"ilmailsearchcoursesgui";i:3;s:21:"ilmailsearchgroupsgui";i:4;s:15:"ilmailsearchgui";}s:15:"ilinfoscreengui";a:4:{i:0;s:11:"ilcolumngui";i:1;s:13:"ilfeedbackgui";i:2;s:9:"ilnotegui";i:3;s:22:"ilpublicuserprofilegui";}s:12:"ilobjrolegui";a:1:{i:0;s:21:"ilrepositorysearchgui";}s:15:"ilpermissiongui";a:1:{i:0;s:12:"ilobjrolegui";}s:12:"ilobjchatgui";a:4:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilobjectcopygui";i:2;s:15:"ilpermissiongui";i:3;s:22:"ilpublicuserprofilegui";}s:20:"ilmailaddressbookgui";a:6:{i:0;s:13:"ilmailformgui";i:1;s:17:"ilmailinglistsgui";i:2;s:22:"ilmailsearchcoursesgui";i:3;s:21:"ilmailsearchgroupsgui";i:4;s:9:"ilobjchat";i:5;s:12:"ilobjchatgui";}s:12:"ilobjusergui";a:2:{i:0;s:21:"illearningprogressgui";i:1;s:17:"ilobjilincusergui";}s:12:"ilpdnotesgui";a:2:{i:0;s:13:"ilfeedbackgui";i:1;s:9:"ilnotegui";}s:20:"ilpersonalprofilegui";a:1:{i:0;s:22:"ilpublicuserprofilegui";}s:20:"ilpersonaldesktopgui";a:12:{i:0;s:27:"ilbookmarkadministrationgui";i:1;s:25:"ilcalendarpresentationgui";i:2;s:11:"ilcolumngui";i:3;s:13:"ilfeedbackgui";i:4;s:21:"illearningprogressgui";i:5;s:20:"ilmailaddressbookgui";i:6;s:15:"ilmailsearchgui";i:7;s:19:"ilobjlanguageextgui";i:8;s:12:"ilobjusergui";i:9;s:11:"ilpdnewsgui";i:10;s:12:"ilpdnotesgui";i:11;s:20:"ilpersonalprofilegui";}}'), 'parent' => array('clob', 'a:65:{s:24:"ilcalendarappointmentgui";a:8:{i:0;s:21:"ilcalendarcategorygui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";i:5;s:25:"ilcalendarpresentationgui";i:6;s:18:"ilcalendarblockgui";i:7;s:20:"ilpdcalendarblockgui";}s:21:"ilcalendarcategorygui";a:1:{i:0;s:25:"ilcalendarpresentationgui";}s:16:"ilcalendardaygui";a:3:{i:0;s:25:"ilcalendarpresentationgui";i:1;s:18:"ilcalendarblockgui";i:2;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarinboxgui";a:3:{i:0;s:25:"ilcalendarpresentationgui";i:1;s:18:"ilcalendarblockgui";i:2;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarmonthgui";a:3:{i:0;s:25:"ilcalendarpresentationgui";i:1;s:18:"ilcalendarblockgui";i:2;s:20:"ilpdcalendarblockgui";}s:25:"ilcalendarusersettingsgui";a:1:{i:0;s:25:"ilcalendarpresentationgui";}s:17:"ilcalendarweekgui";a:3:{i:0;s:25:"ilcalendarpresentationgui";i:1;s:18:"ilcalendarblockgui";i:2;s:20:"ilpdcalendarblockgui";}s:13:"ilnewsitemgui";a:1:{i:0;s:24:"ilnewsforcontextblockgui";}s:22:"ilpublicuserprofilegui";a:5:{i:0;s:21:"ilusersonlineblockgui";i:1;s:15:"ilmailfoldergui";i:2;s:15:"ilinfoscreengui";i:3;s:12:"ilobjchatgui";i:4;s:20:"ilpersonalprofilegui";}s:18:"ilbookmarkblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:18:"ilcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilchatblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:15:"ildummyblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilhtmlblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilpdexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdfeedbackblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdmailblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdnewsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:17:"ilpdnotesblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:25:"ilpdselecteditemsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilpdsysmessageblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:19:"ilpdtaggingblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:28:"ilrepositoryselectorinputgui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:25:"ilformpropertydispatchgui";a:2:{i:0;s:19:"illpobjectstablegui";i:1;s:20:"illpprogresstablegui";}s:13:"illpfiltergui";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:17:"ilpdfpresentation";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:15:"iluserfiltergui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:20:"illpprogresstablegui";a:1:{i:0;s:21:"illplistofprogressgui";}s:17:"illmstatisticsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:20:"illplistofobjectsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofprogressgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofsettingsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:19:"ilmailattachmentgui";a:2:{i:0;s:15:"ilmailfoldergui";i:1;s:13:"ilmailformgui";}s:16:"ilmailoptionsgui";a:1:{i:0;s:15:"ilmailfoldergui";}s:15:"ilmailsearchgui";a:3:{i:0;s:15:"ilmailfoldergui";i:1;s:13:"ilmailformgui";i:2;s:20:"ilpersonaldesktopgui";}s:15:"ilmailfoldergui";a:1:{i:0;s:13:"ilmailformgui";}s:22:"ilmailsearchcoursesgui";a:2:{i:0;s:13:"ilmailformgui";i:1;s:20:"ilmailaddressbookgui";}s:21:"ilmailsearchgroupsgui";a:2:{i:0;s:13:"ilmailformgui";i:1;s:20:"ilmailaddressbookgui";}s:11:"ilcolumngui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:20:"ilpersonaldesktopgui";}s:13:"ilfeedbackgui";a:3:{i:0;s:15:"ilinfoscreengui";i:1;s:12:"ilpdnotesgui";i:2;s:20:"ilpersonaldesktopgui";}s:9:"ilnotegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:12:"ilpdnotesgui";}s:21:"ilrepositorysearchgui";a:1:{i:0;s:12:"ilobjrolegui";}s:12:"ilobjrolegui";a:1:{i:0;s:15:"ilpermissiongui";}s:15:"ilinfoscreengui";a:1:{i:0;s:12:"ilobjchatgui";}s:15:"ilobjectcopygui";a:1:{i:0;s:12:"ilobjchatgui";}s:15:"ilpermissiongui";a:1:{i:0;s:12:"ilobjchatgui";}s:13:"ilmailformgui";a:1:{i:0;s:20:"ilmailaddressbookgui";}s:17:"ilmailinglistsgui";a:1:{i:0;s:20:"ilmailaddressbookgui";}s:9:"ilobjchat";a:1:{i:0;s:20:"ilmailaddressbookgui";}s:12:"ilobjchatgui";a:1:{i:0;s:20:"ilmailaddressbookgui";}s:21:"illearningprogressgui";a:2:{i:0;s:12:"ilobjusergui";i:1;s:20:"ilpersonaldesktopgui";}s:17:"ilobjilincusergui";a:1:{i:0;s:12:"ilobjusergui";}s:27:"ilbookmarkadministrationgui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}s:25:"ilcalendarpresentationgui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}s:20:"ilmailaddressbookgui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}s:19:"ilobjlanguageextgui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}s:12:"ilobjusergui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}s:11:"ilpdnewsgui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}s:12:"ilpdnotesgui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}s:20:"ilpersonalprofilegui";a:1:{i:0;s:20:"ilpersonaldesktopgui";}}')));

$ilDB->insert("ctrl_structure", array(
'root_class' => array('text', 'illmpresentationgui'), 'call_node' => array('clob', 'a:108:{i:1;a:2:{s:5:"class";s:19:"illmpresentationgui";s:6:"parent";i:0;}i:2;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1;}i:3;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2;}i:4;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3;}i:5;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3;}i:6;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3;}i:7;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:6;}i:8;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:6;}i:9;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:8;}i:10;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:6;}i:11;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:10;}i:12;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:6;}i:13;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:12;}i:14;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:6;}i:15;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:14;}i:16;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3;}i:17;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3;}i:18;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3;}i:19;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3;}i:20;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3;}i:21;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:20;}i:22;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3;}i:23;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:22;}i:24;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:22;}i:25;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:24;}i:26;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:22;}i:27;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:26;}i:28;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:22;}i:29;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:28;}i:30;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:22;}i:31;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:30;}i:32;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3;}i:33;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3;}i:34;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3;}i:35;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3;}i:36;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3;}i:37;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3;}i:38;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3;}i:39;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3;}i:40;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3;}i:41;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:40;}i:42;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2;}i:43;a:2:{s:5:"class";s:0:"";s:6:"parent";i:42;}i:44;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2;}i:45;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2;}i:46;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1;}i:47;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:1;}i:48;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:47;}i:49;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:48;}i:50;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:49;}i:51;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:50;}i:52;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:50;}i:53;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:52;}i:54;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:50;}i:55;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:48;}i:56;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:48;}i:57;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:48;}i:58;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:57;}i:59;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:57;}i:60;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:59;}i:61;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:59;}i:62;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:61;}i:63;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:59;}i:64;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:57;}i:65;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:57;}i:66;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:57;}i:67;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:57;}i:68;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:57;}i:69;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:57;}i:70;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:57;}i:71;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:57;}i:72;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:71;}i:73;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:72;}i:74;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:72;}i:75;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:74;}i:76;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:72;}i:77;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:71;}i:78;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:77;}i:79;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:57;}i:80;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:57;}i:81;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:80;}i:82;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:81;}i:83;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:82;}i:84;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:82;}i:85;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:84;}i:86;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:82;}i:87;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:81;}i:88;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:87;}i:89;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:57;}i:90;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:57;}i:91;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:90;}i:92;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:91;}i:93;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:91;}i:94;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:91;}i:95;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:91;}i:96;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:91;}i:97;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:91;}i:98;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:91;}i:99;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:91;}i:100;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:91;}i:101;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:91;}i:102;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:57;}i:103;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:57;}i:104;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:57;}i:105;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:57;}i:106;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:57;}i:107;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:57;}i:108;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:48;}}'), 'forward' => array('clob', 'a:22:{s:16:"ilcalendardaygui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarinboxgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarmonthgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:17:"ilcalendarweekgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:13:"ilnewsitemgui";}s:20:"ilpdcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:22:"ilpublicuserprofilegui";}s:11:"ilcolumngui";a:17:{i:0;s:18:"ilbookmarkblockgui";i:1;s:18:"ilcalendarblockgui";i:2;s:14:"ilchatblockgui";i:3;s:15:"ildummyblockgui";i:4;s:22:"ilexternalfeedblockgui";i:5;s:14:"ilhtmlblockgui";i:6;s:24:"ilnewsforcontextblockgui";i:7;s:20:"ilpdcalendarblockgui";i:8;s:24:"ilpdexternalfeedblockgui";i:9;s:20:"ilpdfeedbackblockgui";i:10;s:16:"ilpdmailblockgui";i:11;s:16:"ilpdnewsblockgui";i:12;s:17:"ilpdnotesblockgui";i:13;s:25:"ilpdselecteditemsblockgui";i:14;s:22:"ilpdsysmessageblockgui";i:15;s:19:"ilpdtaggingblockgui";i:16;s:21:"ilusersonlineblockgui";}s:15:"ilinfoscreengui";a:4:{i:0;s:11:"ilcolumngui";i:1;s:13:"ilfeedbackgui";i:2;s:9:"ilnotegui";i:3;s:22:"ilpublicuserprofilegui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:19:"ilobjmediaobjectgui";a:3:{i:0;s:15:"ilfilesystemgui";i:1;s:19:"ilimagemapeditorgui";i:2;s:13:"ilmdeditorgui";}s:18:"ileditclipboardgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:21:"ilpcimagemapeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:17:"ilquestioneditgui";a:10:{i:0;s:15:"assclozetestgui";i:1;s:22:"assimagemapquestiongui";i:2;s:16:"assjavaappletgui";i:3;s:22:"assmatchingquestiongui";i:4;s:20:"assmultiplechoicegui";i:5;s:13:"assnumericgui";i:6;s:22:"assorderingquestiongui";i:7;s:18:"asssinglechoicegui";i:8;s:18:"asstextquestiongui";i:9;s:16:"asstextsubsetgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:15:"ilpageeditorgui";a:20:{i:0;s:17:"ilinternallinkgui";i:1;s:19:"ilobjmediaobjectgui";i:2;s:21:"ilpccontentincludegui";i:3;s:16:"ilpcdatatablegui";i:4;s:15:"ilpcfileitemgui";i:5;s:15:"ilpcfilelistgui";i:6;s:11:"ilpclistgui";i:7;s:15:"ilpclistitemgui";i:8;s:10:"ilpcmapgui";i:9;s:18:"ilpcmediaobjectgui";i:10;s:16:"ilpcparagraphgui";i:11;s:18:"ilpcplaceholdergui";i:12;s:14:"ilpcpluggedgui";i:13;s:15:"ilpcquestiongui";i:14;s:16:"ilpcresourcesgui";i:15;s:14:"ilpcsectiongui";i:16;s:17:"ilpcsourcecodegui";i:17;s:16:"ilpctabledatagui";i:18;s:12:"ilpctablegui";i:19;s:11:"ilpctabsgui";}s:15:"ilpageobjectgui";a:5:{i:0;s:18:"ileditclipboardgui";i:1;s:13:"ilmdeditorgui";i:2;s:9:"ilnotegui";i:3;s:15:"ilpageeditorgui";i:4;s:22:"ilpublicuserprofilegui";}s:17:"ilshoppurchasegui";a:1:{i:0;s:15:"ilpageobjectgui";}s:19:"illmpresentationgui";a:3:{i:0;s:15:"ilinfoscreengui";i:1;s:9:"ilnotegui";i:2;s:17:"ilshoppurchasegui";}}'), 'parent' => array('clob', 'a:67:{s:24:"ilcalendarappointmentgui";a:6:{i:0;s:16:"ilcalendardaygui";i:1;s:18:"ilcalendarinboxgui";i:2;s:18:"ilcalendarmonthgui";i:3;s:17:"ilcalendarweekgui";i:4;s:18:"ilcalendarblockgui";i:5;s:20:"ilpdcalendarblockgui";}s:16:"ilcalendardaygui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarinboxgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarmonthgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:17:"ilcalendarweekgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:13:"ilnewsitemgui";a:1:{i:0;s:24:"ilnewsforcontextblockgui";}s:22:"ilpublicuserprofilegui";a:3:{i:0;s:21:"ilusersonlineblockgui";i:1;s:15:"ilinfoscreengui";i:2;s:15:"ilpageobjectgui";}s:18:"ilbookmarkblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:18:"ilcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilchatblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:15:"ildummyblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilhtmlblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilpdexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdfeedbackblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdmailblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdnewsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:17:"ilpdnotesblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:25:"ilpdselecteditemsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilpdsysmessageblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:19:"ilpdtaggingblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:11:"ilcolumngui";a:1:{i:0;s:15:"ilinfoscreengui";}s:13:"ilfeedbackgui";a:1:{i:0;s:15:"ilinfoscreengui";}s:9:"ilnotegui";a:3:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpageobjectgui";i:2;s:19:"illmpresentationgui";}s:17:"ilinternallinkgui";a:3:{i:0;s:19:"ilimagemapeditorgui";i:1;s:21:"ilpcimagemapeditorgui";i:2;s:15:"ilpageeditorgui";}s:15:"ilfilesystemgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:13:"ilmdeditorgui";a:2:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:15:"ilpageobjectgui";}s:19:"ilobjmediaobjectgui";a:3:{i:0;s:18:"ileditclipboardgui";i:1;s:18:"ilpcmediaobjectgui";i:2;s:15:"ilpageeditorgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:18:"ilpcplaceholdergui";i:1;s:15:"ilpageeditorgui";}s:15:"assclozetestgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:22:"assimagemapquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:16:"assjavaappletgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:22:"assmatchingquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:20:"assmultiplechoicegui";a:1:{i:0;s:17:"ilquestioneditgui";}s:13:"assnumericgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:22:"assorderingquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:18:"asssinglechoicegui";a:1:{i:0;s:17:"ilquestioneditgui";}s:18:"asstextquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:16:"asstextsubsetgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:17:"ilquestioneditgui";a:1:{i:0;s:15:"ilpcquestiongui";}s:21:"ilpccontentincludegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcdatatablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfileitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfilelistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpclistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpclistitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:10:"ilpcmapgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcparagraphgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcpluggedgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcresourcesgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcsectiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:17:"ilpcsourcecodegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpctabledatagui";a:1:{i:0;s:15:"ilpageeditorgui";}s:12:"ilpctablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpctabsgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ileditclipboardgui";a:1:{i:0;s:15:"ilpageobjectgui";}s:15:"ilpageeditorgui";a:1:{i:0;s:15:"ilpageobjectgui";}s:15:"ilpageobjectgui";a:1:{i:0;s:17:"ilshoppurchasegui";}s:15:"ilinfoscreengui";a:1:{i:0;s:19:"illmpresentationgui";}s:17:"ilshoppurchasegui";a:1:{i:0;s:19:"illmpresentationgui";}}')));

$ilDB->insert("ctrl_structure", array(
'root_class' => array('text', 'illmeditorgui'), 'call_node' => array('clob', 'a:283:{i:1;a:2:{s:5:"class";s:13:"illmeditorgui";s:6:"parent";i:0;}i:2;a:2:{s:5:"class";s:14:"ilobjdlbookgui";s:6:"parent";i:1;}i:3;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2;}i:4;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3;}i:5;a:2:{s:5:"class";s:0:"";s:6:"parent";i:4;}i:6;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:4;}i:7;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:4;}i:8;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:7;}i:9;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:7;}i:10;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:9;}i:11;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:7;}i:12;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:11;}i:13;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:7;}i:14;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:13;}i:15;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:7;}i:16;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:15;}i:17;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:4;}i:18;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:4;}i:19;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:4;}i:20;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:4;}i:21;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:4;}i:22;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:21;}i:23;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:4;}i:24;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:23;}i:25;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:23;}i:26;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:25;}i:27;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:23;}i:28;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:27;}i:29;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:23;}i:30;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:29;}i:31;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:23;}i:32;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:31;}i:33;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:4;}i:34;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:4;}i:35;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:4;}i:36;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:4;}i:37;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:4;}i:38;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:4;}i:39;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:4;}i:40;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:4;}i:41;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:4;}i:42;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:41;}i:43;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3;}i:44;a:2:{s:5:"class";s:0:"";s:6:"parent";i:43;}i:45;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3;}i:46;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3;}i:47;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:2;}i:48;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:47;}i:49;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:47;}i:50;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:49;}i:51;a:2:{s:5:"class";s:0:"";s:6:"parent";i:50;}i:52;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:49;}i:53;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:52;}i:54;a:2:{s:5:"class";s:0:"";s:6:"parent";i:53;}i:55;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:53;}i:56;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:49;}i:57;a:2:{s:5:"class";s:0:"";s:6:"parent";i:56;}i:58;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:49;}i:59;a:2:{s:5:"class";s:0:"";s:6:"parent";i:58;}i:60;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:47;}i:61;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:60;}i:62;a:2:{s:5:"class";s:0:"";s:6:"parent";i:61;}i:63;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:60;}i:64;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:63;}i:65;a:2:{s:5:"class";s:0:"";s:6:"parent";i:64;}i:66;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:64;}i:67;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:60;}i:68;a:2:{s:5:"class";s:0:"";s:6:"parent";i:67;}i:69;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:47;}i:70;a:2:{s:5:"class";s:0:"";s:6:"parent";i:69;}i:71;a:2:{s:5:"class";s:17:"illmpageobjectgui";s:6:"parent";i:2;}i:72;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:71;}i:73;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:72;}i:74;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:73;}i:75;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:74;}i:76;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:74;}i:77;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:76;}i:78;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:74;}i:79;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:72;}i:80;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:72;}i:81;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:72;}i:82;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:81;}i:83;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:81;}i:84;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:83;}i:85;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:83;}i:86;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:85;}i:87;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:83;}i:88;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:81;}i:89;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:81;}i:90;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:81;}i:91;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:81;}i:92;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:81;}i:93;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:81;}i:94;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:81;}i:95;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:81;}i:96;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:95;}i:97;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:96;}i:98;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:96;}i:99;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:98;}i:100;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:96;}i:101;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:95;}i:102;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:101;}i:103;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:81;}i:104;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:81;}i:105;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:104;}i:106;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:105;}i:107;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:106;}i:108;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:106;}i:109;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:108;}i:110;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:106;}i:111;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:105;}i:112;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:111;}i:113;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:81;}i:114;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:81;}i:115;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:114;}i:116;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:115;}i:117;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:115;}i:118;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:115;}i:119;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:115;}i:120;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:115;}i:121;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:115;}i:122;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:115;}i:123;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:115;}i:124;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:115;}i:125;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:115;}i:126;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:81;}i:127;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:81;}i:128;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:81;}i:129;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:81;}i:130;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:81;}i:131;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:81;}i:132;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:72;}i:133;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2;}i:134;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:2;}i:135;a:2:{s:5:"class";s:0:"";s:6:"parent";i:134;}i:136;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2;}i:137;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:136;}i:138;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:137;}i:139;a:2:{s:5:"class";s:20:"ilstructureobjectgui";s:6:"parent";i:2;}i:140;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:139;}i:141;a:2:{s:5:"class";s:0:"";s:6:"parent";i:140;}i:142;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:139;}i:143;a:2:{s:5:"class";s:22:"ilobjlearningmodulegui";s:6:"parent";i:1;}i:144;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:143;}i:145;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:144;}i:146;a:2:{s:5:"class";s:0:"";s:6:"parent";i:145;}i:147;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:145;}i:148;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:145;}i:149;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:148;}i:150;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:148;}i:151;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:150;}i:152;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:148;}i:153;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:152;}i:154;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:148;}i:155;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:154;}i:156;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:148;}i:157;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:156;}i:158;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:145;}i:159;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:145;}i:160;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:145;}i:161;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:145;}i:162;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:145;}i:163;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:162;}i:164;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:145;}i:165;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:164;}i:166;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:164;}i:167;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:166;}i:168;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:164;}i:169;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:168;}i:170;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:164;}i:171;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:170;}i:172;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:164;}i:173;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:172;}i:174;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:145;}i:175;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:145;}i:176;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:145;}i:177;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:145;}i:178;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:145;}i:179;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:145;}i:180;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:145;}i:181;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:145;}i:182;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:145;}i:183;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:182;}i:184;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:144;}i:185;a:2:{s:5:"class";s:0:"";s:6:"parent";i:184;}i:186;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:144;}i:187;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:144;}i:188;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:143;}i:189;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:188;}i:190;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:188;}i:191;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:190;}i:192;a:2:{s:5:"class";s:0:"";s:6:"parent";i:191;}i:193;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:190;}i:194;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:193;}i:195;a:2:{s:5:"class";s:0:"";s:6:"parent";i:194;}i:196;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:194;}i:197;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:190;}i:198;a:2:{s:5:"class";s:0:"";s:6:"parent";i:197;}i:199;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:190;}i:200;a:2:{s:5:"class";s:0:"";s:6:"parent";i:199;}i:201;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:188;}i:202;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:201;}i:203;a:2:{s:5:"class";s:0:"";s:6:"parent";i:202;}i:204;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:201;}i:205;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:204;}i:206;a:2:{s:5:"class";s:0:"";s:6:"parent";i:205;}i:207;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:205;}i:208;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:201;}i:209;a:2:{s:5:"class";s:0:"";s:6:"parent";i:208;}i:210;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:188;}i:211;a:2:{s:5:"class";s:0:"";s:6:"parent";i:210;}i:212;a:2:{s:5:"class";s:17:"illmpageobjectgui";s:6:"parent";i:143;}i:213;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:212;}i:214;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:213;}i:215;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:214;}i:216;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:215;}i:217;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:215;}i:218;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:217;}i:219;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:215;}i:220;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:213;}i:221;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:213;}i:222;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:213;}i:223;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:222;}i:224;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:222;}i:225;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:224;}i:226;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:224;}i:227;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:226;}i:228;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:224;}i:229;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:222;}i:230;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:222;}i:231;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:222;}i:232;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:222;}i:233;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:222;}i:234;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:222;}i:235;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:222;}i:236;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:222;}i:237;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:236;}i:238;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:237;}i:239;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:237;}i:240;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:239;}i:241;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:237;}i:242;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:236;}i:243;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:242;}i:244;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:222;}i:245;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:222;}i:246;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:245;}i:247;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:246;}i:248;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:247;}i:249;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:247;}i:250;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:249;}i:251;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:247;}i:252;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:246;}i:253;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:252;}i:254;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:222;}i:255;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:222;}i:256;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:255;}i:257;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:256;}i:258;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:256;}i:259;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:256;}i:260;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:256;}i:261;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:256;}i:262;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:256;}i:263;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:256;}i:264;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:256;}i:265;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:256;}i:266;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:256;}i:267;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:222;}i:268;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:222;}i:269;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:222;}i:270;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:222;}i:271;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:222;}i:272;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:222;}i:273;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:213;}i:274;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:143;}i:275;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:143;}i:276;a:2:{s:5:"class";s:0:"";s:6:"parent";i:275;}i:277;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:143;}i:278;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:277;}i:279;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:278;}i:280;a:2:{s:5:"class";s:20:"ilstructureobjectgui";s:6:"parent";i:143;}i:281;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:280;}i:282;a:2:{s:5:"class";s:0:"";s:6:"parent";i:281;}i:283;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:280;}}'), 'forward' => array('clob', 'a:33:{s:16:"ilcalendardaygui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarinboxgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarmonthgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:17:"ilcalendarweekgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:13:"ilnewsitemgui";}s:20:"ilpdcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:22:"ilpublicuserprofilegui";}s:11:"ilcolumngui";a:17:{i:0;s:18:"ilbookmarkblockgui";i:1;s:18:"ilcalendarblockgui";i:2;s:14:"ilchatblockgui";i:3;s:15:"ildummyblockgui";i:4;s:22:"ilexternalfeedblockgui";i:5;s:14:"ilhtmlblockgui";i:6;s:24:"ilnewsforcontextblockgui";i:7;s:20:"ilpdcalendarblockgui";i:8;s:24:"ilpdexternalfeedblockgui";i:9;s:20:"ilpdfeedbackblockgui";i:10;s:16:"ilpdmailblockgui";i:11;s:16:"ilpdnewsblockgui";i:12;s:17:"ilpdnotesblockgui";i:13;s:25:"ilpdselecteditemsblockgui";i:14;s:22:"ilpdsysmessageblockgui";i:15;s:19:"ilpdtaggingblockgui";i:16;s:21:"ilusersonlineblockgui";}s:15:"ilinfoscreengui";a:4:{i:0;s:11:"ilcolumngui";i:1;s:13:"ilfeedbackgui";i:2;s:9:"ilnotegui";i:3;s:22:"ilpublicuserprofilegui";}s:25:"ilformpropertydispatchgui";a:1:{i:0;s:28:"ilrepositoryselectorinputgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:20:"illplistofobjectsgui";a:4:{i:0;s:13:"illpfiltergui";i:1;s:19:"illpobjectstablegui";i:2;s:17:"ilpdfpresentation";i:3;s:15:"iluserfiltergui";}s:20:"illpprogresstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:21:"illplistofprogressgui";a:3:{i:0;s:13:"illpfiltergui";i:1;s:20:"illpprogresstablegui";i:2;s:17:"ilpdfpresentation";}s:21:"illearningprogressgui";a:4:{i:0;s:17:"illmstatisticsgui";i:1;s:20:"illplistofobjectsgui";i:2;s:21:"illplistofprogressgui";i:3;s:21:"illplistofsettingsgui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:19:"ilobjmediaobjectgui";a:3:{i:0;s:15:"ilfilesystemgui";i:1;s:19:"ilimagemapeditorgui";i:2;s:13:"ilmdeditorgui";}s:18:"ileditclipboardgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:21:"ilpcimagemapeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:17:"ilquestioneditgui";a:10:{i:0;s:15:"assclozetestgui";i:1;s:22:"assimagemapquestiongui";i:2;s:16:"assjavaappletgui";i:3;s:22:"assmatchingquestiongui";i:4;s:20:"assmultiplechoicegui";i:5;s:13:"assnumericgui";i:6;s:22:"assorderingquestiongui";i:7;s:18:"asssinglechoicegui";i:8;s:18:"asstextquestiongui";i:9;s:16:"asstextsubsetgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:15:"ilpageeditorgui";a:20:{i:0;s:17:"ilinternallinkgui";i:1;s:19:"ilobjmediaobjectgui";i:2;s:21:"ilpccontentincludegui";i:3;s:16:"ilpcdatatablegui";i:4;s:15:"ilpcfileitemgui";i:5;s:15:"ilpcfilelistgui";i:6;s:11:"ilpclistgui";i:7;s:15:"ilpclistitemgui";i:8;s:10:"ilpcmapgui";i:9;s:18:"ilpcmediaobjectgui";i:10;s:16:"ilpcparagraphgui";i:11;s:18:"ilpcplaceholdergui";i:12;s:14:"ilpcpluggedgui";i:13;s:15:"ilpcquestiongui";i:14;s:16:"ilpcresourcesgui";i:15;s:14:"ilpcsectiongui";i:16;s:17:"ilpcsourcecodegui";i:17;s:16:"ilpctabledatagui";i:18;s:12:"ilpctablegui";i:19;s:11:"ilpctabsgui";}s:15:"ilpageobjectgui";a:5:{i:0;s:18:"ileditclipboardgui";i:1;s:13:"ilmdeditorgui";i:2;s:9:"ilnotegui";i:3;s:15:"ilpageeditorgui";i:4;s:22:"ilpublicuserprofilegui";}s:17:"illmpageobjectgui";a:1:{i:0;s:15:"ilpageobjectgui";}s:12:"ilobjrolegui";a:1:{i:0;s:21:"ilrepositorysearchgui";}s:15:"ilpermissiongui";a:1:{i:0;s:12:"ilobjrolegui";}s:20:"ilstructureobjectgui";a:2:{i:0;s:27:"ilconditionhandlerinterface";i:1;s:13:"ilmdeditorgui";}s:14:"ilobjdlbookgui";a:7:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:17:"illmpageobjectgui";i:3;s:13:"ilmdeditorgui";i:4;s:18:"ilobjstylesheetgui";i:5;s:15:"ilpermissiongui";i:6;s:20:"ilstructureobjectgui";}s:22:"ilobjlearningmodulegui";a:7:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:17:"illmpageobjectgui";i:3;s:13:"ilmdeditorgui";i:4;s:18:"ilobjstylesheetgui";i:5;s:15:"ilpermissiongui";i:6;s:20:"ilstructureobjectgui";}s:13:"illmeditorgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}}'), 'parent' => array('clob', 'a:87:{s:24:"ilcalendarappointmentgui";a:6:{i:0;s:16:"ilcalendardaygui";i:1;s:18:"ilcalendarinboxgui";i:2;s:18:"ilcalendarmonthgui";i:3;s:17:"ilcalendarweekgui";i:4;s:18:"ilcalendarblockgui";i:5;s:20:"ilpdcalendarblockgui";}s:16:"ilcalendardaygui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarinboxgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarmonthgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:17:"ilcalendarweekgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:13:"ilnewsitemgui";a:1:{i:0;s:24:"ilnewsforcontextblockgui";}s:22:"ilpublicuserprofilegui";a:3:{i:0;s:21:"ilusersonlineblockgui";i:1;s:15:"ilinfoscreengui";i:2;s:15:"ilpageobjectgui";}s:18:"ilbookmarkblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:18:"ilcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilchatblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:15:"ildummyblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilhtmlblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilpdexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdfeedbackblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdmailblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdnewsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:17:"ilpdnotesblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:25:"ilpdselecteditemsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilpdsysmessageblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:19:"ilpdtaggingblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:11:"ilcolumngui";a:1:{i:0;s:15:"ilinfoscreengui";}s:13:"ilfeedbackgui";a:1:{i:0;s:15:"ilinfoscreengui";}s:9:"ilnotegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpageobjectgui";}s:28:"ilrepositoryselectorinputgui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:25:"ilformpropertydispatchgui";a:2:{i:0;s:19:"illpobjectstablegui";i:1;s:20:"illpprogresstablegui";}s:13:"illpfiltergui";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:17:"ilpdfpresentation";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:15:"iluserfiltergui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:20:"illpprogresstablegui";a:1:{i:0;s:21:"illplistofprogressgui";}s:17:"illmstatisticsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:20:"illplistofobjectsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofprogressgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofsettingsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:17:"ilinternallinkgui";a:3:{i:0;s:19:"ilimagemapeditorgui";i:1;s:21:"ilpcimagemapeditorgui";i:2;s:15:"ilpageeditorgui";}s:15:"ilfilesystemgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:13:"ilmdeditorgui";a:5:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:15:"ilpageobjectgui";i:2;s:20:"ilstructureobjectgui";i:3;s:14:"ilobjdlbookgui";i:4;s:22:"ilobjlearningmodulegui";}s:19:"ilobjmediaobjectgui";a:3:{i:0;s:18:"ileditclipboardgui";i:1;s:18:"ilpcmediaobjectgui";i:2;s:15:"ilpageeditorgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:18:"ilpcplaceholdergui";i:1;s:15:"ilpageeditorgui";}s:15:"assclozetestgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:22:"assimagemapquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:16:"assjavaappletgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:22:"assmatchingquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:20:"assmultiplechoicegui";a:1:{i:0;s:17:"ilquestioneditgui";}s:13:"assnumericgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:22:"assorderingquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:18:"asssinglechoicegui";a:1:{i:0;s:17:"ilquestioneditgui";}s:18:"asstextquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:16:"asstextsubsetgui";a:1:{i:0;s:17:"ilquestioneditgui";}s:17:"ilquestioneditgui";a:1:{i:0;s:15:"ilpcquestiongui";}s:21:"ilpccontentincludegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcdatatablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfileitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfilelistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpclistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpclistitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:10:"ilpcmapgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcparagraphgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcpluggedgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcresourcesgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcsectiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:17:"ilpcsourcecodegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpctabledatagui";a:1:{i:0;s:15:"ilpageeditorgui";}s:12:"ilpctablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpctabsgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ileditclipboardgui";a:1:{i:0;s:15:"ilpageobjectgui";}s:15:"ilpageeditorgui";a:1:{i:0;s:15:"ilpageobjectgui";}s:15:"ilpageobjectgui";a:1:{i:0;s:17:"illmpageobjectgui";}s:21:"ilrepositorysearchgui";a:1:{i:0;s:12:"ilobjrolegui";}s:12:"ilobjrolegui";a:1:{i:0;s:15:"ilpermissiongui";}s:27:"ilconditionhandlerinterface";a:1:{i:0;s:20:"ilstructureobjectgui";}s:15:"ilinfoscreengui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:21:"illearningprogressgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:17:"illmpageobjectgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:18:"ilobjstylesheetgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:15:"ilpermissiongui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:20:"ilstructureobjectgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:14:"ilobjdlbookgui";a:1:{i:0;s:13:"illmeditorgui";}s:22:"ilobjlearningmodulegui";a:1:{i:0;s:13:"illmeditorgui";}}')));

$ilDB->insert("ctrl_structure", array(
'root_class' => array('text', 'iladministrationgui'), 'call_node' => array('clob', 'a:4052:{i:1;a:2:{s:5:"class";s:19:"iladministrationgui";s:6:"parent";i:0;}i:2;a:2:{s:5:"class";s:21:"ilcourseobjectivesgui";s:6:"parent";i:1;}i:3;a:2:{s:5:"class";s:29:"ilobjaccessibilitysettingsgui";s:6:"parent";i:1;}i:4;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3;}i:5;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:4;}i:6;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:5;}i:7;a:2:{s:5:"class";s:23:"ilobjadvancededitinggui";s:6:"parent";i:1;}i:8;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:7;}i:9;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:8;}i:10;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:9;}i:11;a:2:{s:5:"class";s:24:"ilobjassessmentfoldergui";s:6:"parent";i:1;}i:12;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:11;}i:13;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:12;}i:14;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:13;}i:15;a:2:{s:5:"class";s:20:"ilobjauthsettingsgui";s:6:"parent";i:1;}i:16;a:2:{s:5:"class";s:27:"ilauthshibbolethsettingsgui";s:6:"parent";i:15;}i:17;a:2:{s:5:"class";s:0:"";s:6:"parent";i:16;}i:18;a:2:{s:5:"class";s:17:"illdapsettingsgui";s:6:"parent";i:15;}i:19;a:2:{s:5:"class";s:0:"";s:6:"parent";i:18;}i:20;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:15;}i:21;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:20;}i:22;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:21;}i:23;a:2:{s:5:"class";s:19:"ilradiussettingsgui";s:6:"parent";i:15;}i:24;a:2:{s:5:"class";s:25:"ilregistrationsettingsgui";s:6:"parent";i:15;}i:25;a:2:{s:5:"class";s:0:"";s:6:"parent";i:24;}i:26;a:2:{s:5:"class";s:24:"ilobjcalendarsettingsgui";s:6:"parent";i:1;}i:27;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:26;}i:28;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:27;}i:29;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:28;}i:30;a:2:{s:5:"class";s:16:"ilobjcategorygui";s:6:"parent";i:1;}i:31;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:30;}i:32;a:2:{s:5:"class";s:0:"";s:6:"parent";i:31;}i:33;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:31;}i:34;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:31;}i:35;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:34;}i:36;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:34;}i:37;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:36;}i:38;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:34;}i:39;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:38;}i:40;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:34;}i:41;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:40;}i:42;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:34;}i:43;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:42;}i:44;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:31;}i:45;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:31;}i:46;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:31;}i:47;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:31;}i:48;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:31;}i:49;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:48;}i:50;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:31;}i:51;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:50;}i:52;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:50;}i:53;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:52;}i:54;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:50;}i:55;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:54;}i:56;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:50;}i:57;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:56;}i:58;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:50;}i:59;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:58;}i:60;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:31;}i:61;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:31;}i:62;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:31;}i:63;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:31;}i:64;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:31;}i:65;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:31;}i:66;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:31;}i:67;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:31;}i:68;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:31;}i:69;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:68;}i:70;a:2:{s:5:"class";s:22:"ilcontainerlinklistgui";s:6:"parent";i:30;}i:71;a:2:{s:5:"class";s:0:"";s:6:"parent";i:70;}i:72;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:30;}i:73;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:72;}i:74;a:2:{s:5:"class";s:0:"";s:6:"parent";i:73;}i:75;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:73;}i:76;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:73;}i:77;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:76;}i:78;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:76;}i:79;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:78;}i:80;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:76;}i:81;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:80;}i:82;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:76;}i:83;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:82;}i:84;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:76;}i:85;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:84;}i:86;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:73;}i:87;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:73;}i:88;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:73;}i:89;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:73;}i:90;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:73;}i:91;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:90;}i:92;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:73;}i:93;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:92;}i:94;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:92;}i:95;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:94;}i:96;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:92;}i:97;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:96;}i:98;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:92;}i:99;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:98;}i:100;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:92;}i:101;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:100;}i:102;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:73;}i:103;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:73;}i:104;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:73;}i:105;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:73;}i:106;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:73;}i:107;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:73;}i:108;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:73;}i:109;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:73;}i:110;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:73;}i:111;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:110;}i:112;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:72;}i:113;a:2:{s:5:"class";s:0:"";s:6:"parent";i:112;}i:114;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:72;}i:115;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:72;}i:116;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:30;}i:117;a:2:{s:5:"class";s:0:"";s:6:"parent";i:116;}i:118;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:30;}i:119;a:2:{s:5:"class";s:0:"";s:6:"parent";i:118;}i:120;a:2:{s:5:"class";s:18:"ilobjuserfoldergui";s:6:"parent";i:30;}i:121;a:2:{s:5:"class";s:20:"iladminusersearchgui";s:6:"parent";i:120;}i:122;a:2:{s:5:"class";s:12:"ilobjusergui";s:6:"parent";i:121;}i:123;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:122;}i:124;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:123;}i:125;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:123;}i:126;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:125;}i:127;a:2:{s:5:"class";s:0:"";s:6:"parent";i:126;}i:128;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:125;}i:129;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:128;}i:130;a:2:{s:5:"class";s:0:"";s:6:"parent";i:129;}i:131;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:129;}i:132;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:125;}i:133;a:2:{s:5:"class";s:0:"";s:6:"parent";i:132;}i:134;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:125;}i:135;a:2:{s:5:"class";s:0:"";s:6:"parent";i:134;}i:136;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:123;}i:137;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:136;}i:138;a:2:{s:5:"class";s:0:"";s:6:"parent";i:137;}i:139;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:136;}i:140;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:139;}i:141;a:2:{s:5:"class";s:0:"";s:6:"parent";i:140;}i:142;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:140;}i:143;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:136;}i:144;a:2:{s:5:"class";s:0:"";s:6:"parent";i:143;}i:145;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:123;}i:146;a:2:{s:5:"class";s:0:"";s:6:"parent";i:145;}i:147;a:2:{s:5:"class";s:17:"ilobjilincusergui";s:6:"parent";i:122;}i:148;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:120;}i:149;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:148;}i:150;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:149;}i:151;a:2:{s:5:"class";s:14:"ilusertablegui";s:6:"parent";i:120;}i:152;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:151;}i:153;a:2:{s:5:"class";s:0:"";s:6:"parent";i:152;}i:154;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:152;}i:155;a:2:{s:5:"class";s:12:"ilobjusergui";s:6:"parent";i:30;}i:156;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:155;}i:157;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:156;}i:158;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:156;}i:159;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:158;}i:160;a:2:{s:5:"class";s:0:"";s:6:"parent";i:159;}i:161;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:158;}i:162;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:161;}i:163;a:2:{s:5:"class";s:0:"";s:6:"parent";i:162;}i:164;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:162;}i:165;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:158;}i:166;a:2:{s:5:"class";s:0:"";s:6:"parent";i:165;}i:167;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:158;}i:168;a:2:{s:5:"class";s:0:"";s:6:"parent";i:167;}i:169;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:156;}i:170;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:169;}i:171;a:2:{s:5:"class";s:0:"";s:6:"parent";i:170;}i:172;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:169;}i:173;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:172;}i:174;a:2:{s:5:"class";s:0:"";s:6:"parent";i:173;}i:175;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:173;}i:176;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:169;}i:177;a:2:{s:5:"class";s:0:"";s:6:"parent";i:176;}i:178;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:156;}i:179;a:2:{s:5:"class";s:0:"";s:6:"parent";i:178;}i:180;a:2:{s:5:"class";s:17:"ilobjilincusergui";s:6:"parent";i:155;}i:181;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:30;}i:182;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:181;}i:183;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:182;}i:184;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:183;}i:185;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:183;}i:186;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:185;}i:187;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:183;}i:188;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:181;}i:189;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:181;}i:190;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:181;}i:191;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:190;}i:192;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:190;}i:193;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:192;}i:194;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:192;}i:195;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:194;}i:196;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:192;}i:197;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:190;}i:198;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:190;}i:199;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:190;}i:200;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:190;}i:201;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:190;}i:202;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:190;}i:203;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:190;}i:204;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:190;}i:205;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:204;}i:206;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:205;}i:207;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:205;}i:208;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:207;}i:209;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:205;}i:210;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:204;}i:211;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:210;}i:212;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:190;}i:213;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:190;}i:214;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:213;}i:215;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:214;}i:216;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:215;}i:217;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:215;}i:218;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:217;}i:219;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:215;}i:220;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:214;}i:221;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:220;}i:222;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:190;}i:223;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:190;}i:224;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:223;}i:225;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:224;}i:226;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:224;}i:227;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:224;}i:228;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:224;}i:229;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:224;}i:230;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:224;}i:231;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:224;}i:232;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:224;}i:233;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:224;}i:234;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:224;}i:235;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:190;}i:236;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:190;}i:237;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:190;}i:238;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:190;}i:239;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:190;}i:240;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:190;}i:241;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:181;}i:242;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:30;}i:243;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:242;}i:244;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:243;}i:245;a:2:{s:5:"class";s:25:"ilobjcategoryreferencegui";s:6:"parent";i:1;}i:246;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:245;}i:247;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:246;}i:248;a:2:{s:5:"class";s:0:"";s:6:"parent";i:247;}i:249;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:247;}i:250;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:247;}i:251;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:250;}i:252;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:250;}i:253;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:252;}i:254;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:250;}i:255;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:254;}i:256;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:250;}i:257;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:256;}i:258;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:250;}i:259;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:258;}i:260;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:247;}i:261;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:247;}i:262;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:247;}i:263;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:247;}i:264;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:247;}i:265;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:264;}i:266;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:247;}i:267;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:266;}i:268;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:266;}i:269;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:268;}i:270;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:266;}i:271;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:270;}i:272;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:266;}i:273;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:272;}i:274;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:266;}i:275;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:274;}i:276;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:247;}i:277;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:247;}i:278;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:247;}i:279;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:247;}i:280;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:247;}i:281;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:247;}i:282;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:247;}i:283;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:247;}i:284;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:247;}i:285;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:284;}i:286;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:246;}i:287;a:2:{s:5:"class";s:0:"";s:6:"parent";i:286;}i:288;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:246;}i:289;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:246;}i:290;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:245;}i:291;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:290;}i:292;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:291;}i:293;a:2:{s:5:"class";s:27:"ilobjcertificatesettingsgui";s:6:"parent";i:1;}i:294;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:293;}i:295;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:294;}i:296;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:295;}i:297;a:2:{s:5:"class";s:12:"ilobjchatgui";s:6:"parent";i:1;}i:298;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:297;}i:299;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:298;}i:300;a:2:{s:5:"class";s:0:"";s:6:"parent";i:299;}i:301;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:299;}i:302;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:299;}i:303;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:302;}i:304;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:302;}i:305;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:304;}i:306;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:302;}i:307;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:306;}i:308;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:302;}i:309;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:308;}i:310;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:302;}i:311;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:310;}i:312;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:299;}i:313;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:299;}i:314;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:299;}i:315;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:299;}i:316;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:299;}i:317;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:316;}i:318;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:299;}i:319;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:318;}i:320;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:318;}i:321;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:320;}i:322;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:318;}i:323;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:322;}i:324;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:318;}i:325;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:324;}i:326;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:318;}i:327;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:326;}i:328;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:299;}i:329;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:299;}i:330;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:299;}i:331;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:299;}i:332;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:299;}i:333;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:299;}i:334;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:299;}i:335;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:299;}i:336;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:299;}i:337;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:336;}i:338;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:298;}i:339;a:2:{s:5:"class";s:0:"";s:6:"parent";i:338;}i:340;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:298;}i:341;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:298;}i:342;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:297;}i:343;a:2:{s:5:"class";s:0:"";s:6:"parent";i:342;}i:344;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:297;}i:345;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:344;}i:346;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:345;}i:347;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:297;}i:348;a:2:{s:5:"class";s:18:"ilobjchatservergui";s:6:"parent";i:1;}i:349;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:348;}i:350;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:349;}i:351;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:350;}i:352;a:2:{s:5:"class";s:25:"ilobjcomponentsettingsgui";s:6:"parent";i:1;}i:353;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:352;}i:354;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:353;}i:355;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:354;}i:356;a:2:{s:5:"class";s:14:"ilobjcoursegui";s:6:"parent";i:1;}i:357;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:356;}i:358;a:2:{s:5:"class";s:0:"";s:6:"parent";i:357;}i:359;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:357;}i:360;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:357;}i:361;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:360;}i:362;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:360;}i:363;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:362;}i:364;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:360;}i:365;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:364;}i:366;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:360;}i:367;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:366;}i:368;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:360;}i:369;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:368;}i:370;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:357;}i:371;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:357;}i:372;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:357;}i:373;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:357;}i:374;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:357;}i:375;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:374;}i:376;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:357;}i:377;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:376;}i:378;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:376;}i:379;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:378;}i:380;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:376;}i:381;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:380;}i:382;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:376;}i:383;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:382;}i:384;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:376;}i:385;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:384;}i:386;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:357;}i:387;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:357;}i:388;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:357;}i:389;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:357;}i:390;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:357;}i:391;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:357;}i:392;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:357;}i:393;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:357;}i:394;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:357;}i:395;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:394;}i:396;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:356;}i:397;a:2:{s:5:"class";s:0:"";s:6:"parent";i:396;}i:398;a:2:{s:5:"class";s:20:"ilcourseagreementgui";s:6:"parent";i:356;}i:399;a:2:{s:5:"class";s:0:"";s:6:"parent";i:398;}i:400;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:356;}i:401;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:400;}i:402;a:2:{s:5:"class";s:0:"";s:6:"parent";i:401;}i:403;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:401;}i:404;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:401;}i:405;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:404;}i:406;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:404;}i:407;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:406;}i:408;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:404;}i:409;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:408;}i:410;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:404;}i:411;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:410;}i:412;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:404;}i:413;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:412;}i:414;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:401;}i:415;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:401;}i:416;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:401;}i:417;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:401;}i:418;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:401;}i:419;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:418;}i:420;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:401;}i:421;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:420;}i:422;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:420;}i:423;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:422;}i:424;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:420;}i:425;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:424;}i:426;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:420;}i:427;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:426;}i:428;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:420;}i:429;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:428;}i:430;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:401;}i:431;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:401;}i:432;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:401;}i:433;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:401;}i:434;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:401;}i:435;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:401;}i:436;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:401;}i:437;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:401;}i:438;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:401;}i:439;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:438;}i:440;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:400;}i:441;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:400;}i:442;a:2:{s:5:"class";s:0:"";s:6:"parent";i:441;}i:443;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:356;}i:444;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:443;}i:445;a:2:{s:5:"class";s:0:"";s:6:"parent";i:444;}i:446;a:2:{s:5:"class";s:21:"ilcourseobjectivesgui";s:6:"parent";i:356;}i:447;a:2:{s:5:"class";s:23:"ilcourseregistrationgui";s:6:"parent";i:356;}i:448;a:2:{s:5:"class";s:0:"";s:6:"parent";i:447;}i:449;a:2:{s:5:"class";s:21:"ilcourseuserfieldsgui";s:6:"parent";i:356;}i:450;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:356;}i:451;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:450;}i:452;a:2:{s:5:"class";s:0:"";s:6:"parent";i:451;}i:453;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:451;}i:454;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:451;}i:455;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:454;}i:456;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:454;}i:457;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:456;}i:458;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:454;}i:459;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:458;}i:460;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:454;}i:461;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:460;}i:462;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:454;}i:463;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:462;}i:464;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:451;}i:465;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:451;}i:466;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:451;}i:467;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:451;}i:468;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:451;}i:469;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:468;}i:470;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:451;}i:471;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:470;}i:472;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:470;}i:473;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:472;}i:474;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:470;}i:475;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:474;}i:476;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:470;}i:477;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:476;}i:478;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:470;}i:479;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:478;}i:480;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:451;}i:481;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:451;}i:482;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:451;}i:483;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:451;}i:484;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:451;}i:485;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:451;}i:486;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:451;}i:487;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:451;}i:488;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:451;}i:489;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:488;}i:490;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:450;}i:491;a:2:{s:5:"class";s:0:"";s:6:"parent";i:490;}i:492;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:450;}i:493;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:450;}i:494;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:356;}i:495;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:494;}i:496;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:494;}i:497;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:496;}i:498;a:2:{s:5:"class";s:0:"";s:6:"parent";i:497;}i:499;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:496;}i:500;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:499;}i:501;a:2:{s:5:"class";s:0:"";s:6:"parent";i:500;}i:502;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:500;}i:503;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:496;}i:504;a:2:{s:5:"class";s:0:"";s:6:"parent";i:503;}i:505;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:496;}i:506;a:2:{s:5:"class";s:0:"";s:6:"parent";i:505;}i:507;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:494;}i:508;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:507;}i:509;a:2:{s:5:"class";s:0:"";s:6:"parent";i:508;}i:510;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:507;}i:511;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:510;}i:512;a:2:{s:5:"class";s:0:"";s:6:"parent";i:511;}i:513;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:511;}i:514;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:507;}i:515;a:2:{s:5:"class";s:0:"";s:6:"parent";i:514;}i:516;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:494;}i:517;a:2:{s:5:"class";s:0:"";s:6:"parent";i:516;}i:518;a:2:{s:5:"class";s:20:"illicenseoverviewgui";s:6:"parent";i:356;}i:519;a:2:{s:5:"class";s:0:"";s:6:"parent";i:518;}i:520;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:356;}i:521;a:2:{s:5:"class";s:17:"ilmemberexportgui";s:6:"parent";i:356;}i:522;a:2:{s:5:"class";s:0:"";s:6:"parent";i:521;}i:523;a:2:{s:5:"class";s:22:"ilobjcoursegroupinggui";s:6:"parent";i:356;}i:524;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:356;}i:525;a:2:{s:5:"class";s:0:"";s:6:"parent";i:524;}i:526;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:356;}i:527;a:2:{s:5:"class";s:0:"";s:6:"parent";i:526;}i:528;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:356;}i:529;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:528;}i:530;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:529;}i:531;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:530;}i:532;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:530;}i:533;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:532;}i:534;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:530;}i:535;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:528;}i:536;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:528;}i:537;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:528;}i:538;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:537;}i:539;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:537;}i:540;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:539;}i:541;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:539;}i:542;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:541;}i:543;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:539;}i:544;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:537;}i:545;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:537;}i:546;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:537;}i:547;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:537;}i:548;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:537;}i:549;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:537;}i:550;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:537;}i:551;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:537;}i:552;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:551;}i:553;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:552;}i:554;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:552;}i:555;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:554;}i:556;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:552;}i:557;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:551;}i:558;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:557;}i:559;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:537;}i:560;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:537;}i:561;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:560;}i:562;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:561;}i:563;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:562;}i:564;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:562;}i:565;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:564;}i:566;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:562;}i:567;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:561;}i:568;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:567;}i:569;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:537;}i:570;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:537;}i:571;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:570;}i:572;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:571;}i:573;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:571;}i:574;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:571;}i:575;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:571;}i:576;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:571;}i:577;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:571;}i:578;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:571;}i:579;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:571;}i:580;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:571;}i:581;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:571;}i:582;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:537;}i:583;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:537;}i:584;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:537;}i:585;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:537;}i:586;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:537;}i:587;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:537;}i:588;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:528;}i:589;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:356;}i:590;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:589;}i:591;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:590;}i:592;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:356;}i:593;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:356;}i:594;a:2:{s:5:"class";s:20:"ilsessionoverviewgui";s:6:"parent";i:356;}i:595;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:356;}i:596;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:595;}i:597;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:596;}i:598;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:597;}i:599;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:598;}i:600;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:598;}i:601;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:600;}i:602;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:598;}i:603;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:596;}i:604;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:596;}i:605;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:596;}i:606;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:605;}i:607;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:605;}i:608;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:607;}i:609;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:607;}i:610;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:609;}i:611;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:607;}i:612;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:605;}i:613;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:605;}i:614;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:605;}i:615;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:605;}i:616;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:605;}i:617;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:605;}i:618;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:605;}i:619;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:605;}i:620;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:619;}i:621;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:620;}i:622;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:620;}i:623;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:622;}i:624;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:620;}i:625;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:619;}i:626;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:625;}i:627;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:605;}i:628;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:605;}i:629;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:628;}i:630;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:629;}i:631;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:630;}i:632;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:630;}i:633;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:632;}i:634;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:630;}i:635;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:629;}i:636;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:635;}i:637;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:605;}i:638;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:605;}i:639;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:638;}i:640;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:639;}i:641;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:639;}i:642;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:639;}i:643;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:639;}i:644;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:639;}i:645;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:639;}i:646;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:639;}i:647;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:639;}i:648;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:639;}i:649;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:639;}i:650;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:605;}i:651;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:605;}i:652;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:605;}i:653;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:605;}i:654;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:605;}i:655;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:605;}i:656;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:596;}i:657;a:2:{s:5:"class";s:23:"ilobjcoursereferencegui";s:6:"parent";i:1;}i:658;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:657;}i:659;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:658;}i:660;a:2:{s:5:"class";s:0:"";s:6:"parent";i:659;}i:661;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:659;}i:662;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:659;}i:663;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:662;}i:664;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:662;}i:665;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:664;}i:666;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:662;}i:667;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:666;}i:668;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:662;}i:669;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:668;}i:670;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:662;}i:671;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:670;}i:672;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:659;}i:673;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:659;}i:674;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:659;}i:675;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:659;}i:676;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:659;}i:677;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:676;}i:678;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:659;}i:679;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:678;}i:680;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:678;}i:681;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:680;}i:682;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:678;}i:683;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:682;}i:684;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:678;}i:685;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:684;}i:686;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:678;}i:687;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:686;}i:688;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:659;}i:689;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:659;}i:690;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:659;}i:691;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:659;}i:692;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:659;}i:693;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:659;}i:694;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:659;}i:695;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:659;}i:696;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:659;}i:697;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:696;}i:698;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:658;}i:699;a:2:{s:5:"class";s:0:"";s:6:"parent";i:698;}i:700;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:658;}i:701;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:658;}i:702;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:657;}i:703;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:702;}i:704;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:703;}i:705;a:2:{s:5:"class";s:14:"ilobjdlbookgui";s:6:"parent";i:1;}i:706;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:705;}i:707;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:706;}i:708;a:2:{s:5:"class";s:0:"";s:6:"parent";i:707;}i:709;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:707;}i:710;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:707;}i:711;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:710;}i:712;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:710;}i:713;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:712;}i:714;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:710;}i:715;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:714;}i:716;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:710;}i:717;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:716;}i:718;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:710;}i:719;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:718;}i:720;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:707;}i:721;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:707;}i:722;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:707;}i:723;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:707;}i:724;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:707;}i:725;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:724;}i:726;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:707;}i:727;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:726;}i:728;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:726;}i:729;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:728;}i:730;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:726;}i:731;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:730;}i:732;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:726;}i:733;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:732;}i:734;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:726;}i:735;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:734;}i:736;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:707;}i:737;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:707;}i:738;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:707;}i:739;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:707;}i:740;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:707;}i:741;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:707;}i:742;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:707;}i:743;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:707;}i:744;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:707;}i:745;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:744;}i:746;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:706;}i:747;a:2:{s:5:"class";s:0:"";s:6:"parent";i:746;}i:748;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:706;}i:749;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:706;}i:750;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:705;}i:751;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:750;}i:752;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:750;}i:753;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:752;}i:754;a:2:{s:5:"class";s:0:"";s:6:"parent";i:753;}i:755;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:752;}i:756;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:755;}i:757;a:2:{s:5:"class";s:0:"";s:6:"parent";i:756;}i:758;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:756;}i:759;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:752;}i:760;a:2:{s:5:"class";s:0:"";s:6:"parent";i:759;}i:761;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:752;}i:762;a:2:{s:5:"class";s:0:"";s:6:"parent";i:761;}i:763;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:750;}i:764;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:763;}i:765;a:2:{s:5:"class";s:0:"";s:6:"parent";i:764;}i:766;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:763;}i:767;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:766;}i:768;a:2:{s:5:"class";s:0:"";s:6:"parent";i:767;}i:769;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:767;}i:770;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:763;}i:771;a:2:{s:5:"class";s:0:"";s:6:"parent";i:770;}i:772;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:750;}i:773;a:2:{s:5:"class";s:0:"";s:6:"parent";i:772;}i:774;a:2:{s:5:"class";s:17:"illmpageobjectgui";s:6:"parent";i:705;}i:775;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:774;}i:776;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:775;}i:777;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:776;}i:778;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:777;}i:779;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:777;}i:780;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:779;}i:781;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:777;}i:782;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:775;}i:783;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:775;}i:784;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:775;}i:785;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:784;}i:786;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:784;}i:787;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:786;}i:788;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:786;}i:789;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:788;}i:790;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:786;}i:791;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:784;}i:792;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:784;}i:793;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:784;}i:794;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:784;}i:795;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:784;}i:796;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:784;}i:797;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:784;}i:798;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:784;}i:799;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:798;}i:800;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:799;}i:801;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:799;}i:802;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:801;}i:803;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:799;}i:804;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:798;}i:805;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:804;}i:806;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:784;}i:807;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:784;}i:808;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:807;}i:809;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:808;}i:810;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:809;}i:811;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:809;}i:812;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:811;}i:813;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:809;}i:814;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:808;}i:815;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:814;}i:816;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:784;}i:817;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:784;}i:818;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:817;}i:819;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:818;}i:820;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:818;}i:821;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:818;}i:822;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:818;}i:823;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:818;}i:824;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:818;}i:825;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:818;}i:826;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:818;}i:827;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:818;}i:828;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:818;}i:829;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:784;}i:830;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:784;}i:831;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:784;}i:832;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:784;}i:833;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:784;}i:834;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:784;}i:835;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:775;}i:836;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:705;}i:837;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:705;}i:838;a:2:{s:5:"class";s:0:"";s:6:"parent";i:837;}i:839;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:705;}i:840;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:839;}i:841;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:840;}i:842;a:2:{s:5:"class";s:20:"ilstructureobjectgui";s:6:"parent";i:705;}i:843;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:842;}i:844;a:2:{s:5:"class";s:0:"";s:6:"parent";i:843;}i:845;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:842;}i:846;a:2:{s:5:"class";s:16:"ilobjexercisegui";s:6:"parent";i:1;}i:847;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:846;}i:848;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:847;}i:849;a:2:{s:5:"class";s:0:"";s:6:"parent";i:848;}i:850;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:848;}i:851;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:848;}i:852;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:851;}i:853;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:851;}i:854;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:853;}i:855;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:851;}i:856;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:855;}i:857;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:851;}i:858;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:857;}i:859;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:851;}i:860;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:859;}i:861;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:848;}i:862;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:848;}i:863;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:848;}i:864;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:848;}i:865;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:848;}i:866;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:865;}i:867;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:848;}i:868;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:867;}i:869;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:867;}i:870;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:869;}i:871;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:867;}i:872;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:871;}i:873;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:867;}i:874;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:873;}i:875;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:867;}i:876;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:875;}i:877;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:848;}i:878;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:848;}i:879;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:848;}i:880;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:848;}i:881;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:848;}i:882;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:848;}i:883;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:848;}i:884;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:848;}i:885;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:848;}i:886;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:885;}i:887;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:847;}i:888;a:2:{s:5:"class";s:0:"";s:6:"parent";i:887;}i:889;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:847;}i:890;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:847;}i:891;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:846;}i:892;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:891;}i:893;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:891;}i:894;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:893;}i:895;a:2:{s:5:"class";s:0:"";s:6:"parent";i:894;}i:896;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:893;}i:897;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:896;}i:898;a:2:{s:5:"class";s:0:"";s:6:"parent";i:897;}i:899;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:897;}i:900;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:893;}i:901;a:2:{s:5:"class";s:0:"";s:6:"parent";i:900;}i:902;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:893;}i:903;a:2:{s:5:"class";s:0:"";s:6:"parent";i:902;}i:904;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:891;}i:905;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:904;}i:906;a:2:{s:5:"class";s:0:"";s:6:"parent";i:905;}i:907;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:904;}i:908;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:907;}i:909;a:2:{s:5:"class";s:0:"";s:6:"parent";i:908;}i:910;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:908;}i:911;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:904;}i:912;a:2:{s:5:"class";s:0:"";s:6:"parent";i:911;}i:913;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:891;}i:914;a:2:{s:5:"class";s:0:"";s:6:"parent";i:913;}i:915;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:846;}i:916;a:2:{s:5:"class";s:0:"";s:6:"parent";i:915;}i:917;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:846;}i:918;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:917;}i:919;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:918;}i:920;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:846;}i:921;a:2:{s:5:"class";s:20:"ilobjexternalfeedgui";s:6:"parent";i:1;}i:922;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:921;}i:923;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:921;}i:924;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:923;}i:925;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:924;}i:926;a:2:{s:5:"class";s:29:"ilobjexternaltoolssettingsgui";s:6:"parent";i:1;}i:927;a:2:{s:5:"class";s:16:"ilecssettingsgui";s:6:"parent";i:926;}i:928;a:2:{s:5:"class";s:0:"";s:6:"parent";i:927;}i:929;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:926;}i:930;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:929;}i:931;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:930;}i:932;a:2:{s:5:"class";s:26:"ilobjfileaccesssettingsgui";s:6:"parent";i:1;}i:933;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:932;}i:934;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:933;}i:935;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:934;}i:936;a:2:{s:5:"class";s:19:"ilobjfilebasedlmgui";s:6:"parent";i:1;}i:937;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:936;}i:938;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:936;}i:939;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:938;}i:940;a:2:{s:5:"class";s:0:"";s:6:"parent";i:939;}i:941;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:939;}i:942;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:939;}i:943;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:942;}i:944;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:942;}i:945;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:944;}i:946;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:942;}i:947;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:946;}i:948;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:942;}i:949;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:948;}i:950;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:942;}i:951;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:950;}i:952;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:939;}i:953;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:939;}i:954;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:939;}i:955;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:939;}i:956;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:939;}i:957;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:956;}i:958;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:939;}i:959;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:958;}i:960;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:958;}i:961;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:960;}i:962;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:958;}i:963;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:962;}i:964;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:958;}i:965;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:964;}i:966;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:958;}i:967;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:966;}i:968;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:939;}i:969;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:939;}i:970;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:939;}i:971;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:939;}i:972;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:939;}i:973;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:939;}i:974;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:939;}i:975;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:939;}i:976;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:939;}i:977;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:976;}i:978;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:938;}i:979;a:2:{s:5:"class";s:0:"";s:6:"parent";i:978;}i:980;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:938;}i:981;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:938;}i:982;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:936;}i:983;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:982;}i:984;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:982;}i:985;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:984;}i:986;a:2:{s:5:"class";s:0:"";s:6:"parent";i:985;}i:987;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:984;}i:988;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:987;}i:989;a:2:{s:5:"class";s:0:"";s:6:"parent";i:988;}i:990;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:988;}i:991;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:984;}i:992;a:2:{s:5:"class";s:0:"";s:6:"parent";i:991;}i:993;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:984;}i:994;a:2:{s:5:"class";s:0:"";s:6:"parent";i:993;}i:995;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:982;}i:996;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:995;}i:997;a:2:{s:5:"class";s:0:"";s:6:"parent";i:996;}i:998;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:995;}i:999;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:998;}i:1000;a:2:{s:5:"class";s:0:"";s:6:"parent";i:999;}i:1001;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:999;}i:1002;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:995;}i:1003;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1002;}i:1004;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:982;}i:1005;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1004;}i:1006;a:2:{s:5:"class";s:12:"illicensegui";s:6:"parent";i:936;}i:1007;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1006;}i:1008;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:936;}i:1009;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:936;}i:1010;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1009;}i:1011;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1010;}i:1012;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:936;}i:1013;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1012;}i:1014;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1013;}i:1015;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1014;}i:1016;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1015;}i:1017;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1015;}i:1018;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1017;}i:1019;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1015;}i:1020;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1013;}i:1021;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1013;}i:1022;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1013;}i:1023;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1022;}i:1024;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1022;}i:1025;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1024;}i:1026;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1024;}i:1027;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1026;}i:1028;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1024;}i:1029;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1022;}i:1030;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1022;}i:1031;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1022;}i:1032;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1022;}i:1033;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1022;}i:1034;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1022;}i:1035;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1022;}i:1036;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1022;}i:1037;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1036;}i:1038;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1037;}i:1039;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1037;}i:1040;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1039;}i:1041;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1037;}i:1042;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1036;}i:1043;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1042;}i:1044;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1022;}i:1045;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1022;}i:1046;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1045;}i:1047;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1046;}i:1048;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1047;}i:1049;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1047;}i:1050;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1049;}i:1051;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1047;}i:1052;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1046;}i:1053;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1052;}i:1054;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1022;}i:1055;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1022;}i:1056;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1055;}i:1057;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1056;}i:1058;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1056;}i:1059;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1056;}i:1060;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1056;}i:1061;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1056;}i:1062;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1056;}i:1063;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1056;}i:1064;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1056;}i:1065;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1056;}i:1066;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1056;}i:1067;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1022;}i:1068;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1022;}i:1069;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1022;}i:1070;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1022;}i:1071;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1022;}i:1072;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1022;}i:1073;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1013;}i:1074;a:2:{s:5:"class";s:12:"ilobjfilegui";s:6:"parent";i:1;}i:1075;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1074;}i:1076;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1075;}i:1077;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1076;}i:1078;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1076;}i:1079;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1076;}i:1080;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1079;}i:1081;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1079;}i:1082;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1081;}i:1083;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1079;}i:1084;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1083;}i:1085;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1079;}i:1086;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1085;}i:1087;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1079;}i:1088;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1087;}i:1089;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1076;}i:1090;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1076;}i:1091;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1076;}i:1092;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1076;}i:1093;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1076;}i:1094;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1093;}i:1095;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1076;}i:1096;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1095;}i:1097;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1095;}i:1098;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1097;}i:1099;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1095;}i:1100;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1099;}i:1101;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1095;}i:1102;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1101;}i:1103;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1095;}i:1104;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1103;}i:1105;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1076;}i:1106;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1076;}i:1107;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1076;}i:1108;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1076;}i:1109;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1076;}i:1110;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1076;}i:1111;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1076;}i:1112;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1076;}i:1113;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1076;}i:1114;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1113;}i:1115;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1075;}i:1116;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1115;}i:1117;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1075;}i:1118;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1075;}i:1119;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1074;}i:1120;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1074;}i:1121;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1120;}i:1122;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1074;}i:1123;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1122;}i:1124;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1123;}i:1125;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:1074;}i:1126;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1125;}i:1127;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1126;}i:1128;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1127;}i:1129;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1128;}i:1130;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1128;}i:1131;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1130;}i:1132;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1128;}i:1133;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1126;}i:1134;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1126;}i:1135;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1126;}i:1136;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1135;}i:1137;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1135;}i:1138;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1137;}i:1139;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1137;}i:1140;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1139;}i:1141;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1137;}i:1142;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1135;}i:1143;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1135;}i:1144;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1135;}i:1145;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1135;}i:1146;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1135;}i:1147;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1135;}i:1148;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1135;}i:1149;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1135;}i:1150;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1149;}i:1151;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1150;}i:1152;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1150;}i:1153;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1152;}i:1154;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1150;}i:1155;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1149;}i:1156;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1155;}i:1157;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1135;}i:1158;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1135;}i:1159;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1158;}i:1160;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1159;}i:1161;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1160;}i:1162;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1160;}i:1163;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1162;}i:1164;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1160;}i:1165;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1159;}i:1166;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1165;}i:1167;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1135;}i:1168;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1135;}i:1169;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1168;}i:1170;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1169;}i:1171;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1169;}i:1172;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1169;}i:1173;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1169;}i:1174;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1169;}i:1175;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1169;}i:1176;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1169;}i:1177;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1169;}i:1178;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1169;}i:1179;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1169;}i:1180;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1135;}i:1181;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1135;}i:1182;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1135;}i:1183;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1135;}i:1184;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1135;}i:1185;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1135;}i:1186;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1126;}i:1187;a:2:{s:5:"class";s:14:"ilobjfoldergui";s:6:"parent";i:1;}i:1188;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1187;}i:1189;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1188;}i:1190;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1188;}i:1191;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1188;}i:1192;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1191;}i:1193;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1191;}i:1194;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1193;}i:1195;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1191;}i:1196;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1195;}i:1197;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1191;}i:1198;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1197;}i:1199;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1191;}i:1200;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1199;}i:1201;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1188;}i:1202;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1188;}i:1203;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1188;}i:1204;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1188;}i:1205;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1188;}i:1206;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1205;}i:1207;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1188;}i:1208;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1207;}i:1209;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1207;}i:1210;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1209;}i:1211;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1207;}i:1212;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1211;}i:1213;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1207;}i:1214;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1213;}i:1215;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1207;}i:1216;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1215;}i:1217;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1188;}i:1218;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1188;}i:1219;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1188;}i:1220;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1188;}i:1221;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1188;}i:1222;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1188;}i:1223;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1188;}i:1224;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1188;}i:1225;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1188;}i:1226;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1225;}i:1227;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1187;}i:1228;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1227;}i:1229;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:1187;}i:1230;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1229;}i:1231;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1230;}i:1232;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1230;}i:1233;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1230;}i:1234;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1233;}i:1235;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1233;}i:1236;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1235;}i:1237;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1233;}i:1238;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1237;}i:1239;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1233;}i:1240;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1239;}i:1241;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1233;}i:1242;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1241;}i:1243;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1230;}i:1244;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1230;}i:1245;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1230;}i:1246;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1230;}i:1247;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1230;}i:1248;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1247;}i:1249;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1230;}i:1250;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1249;}i:1251;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1249;}i:1252;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1251;}i:1253;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1249;}i:1254;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1253;}i:1255;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1249;}i:1256;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1255;}i:1257;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1249;}i:1258;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1257;}i:1259;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1230;}i:1260;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1230;}i:1261;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1230;}i:1262;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1230;}i:1263;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1230;}i:1264;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1230;}i:1265;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1230;}i:1266;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1230;}i:1267;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1230;}i:1268;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1267;}i:1269;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:1229;}i:1270;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:1229;}i:1271;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1270;}i:1272;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:1187;}i:1273;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1272;}i:1274;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1273;}i:1275;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1187;}i:1276;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1275;}i:1277;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1276;}i:1278;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1276;}i:1279;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1276;}i:1280;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1279;}i:1281;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1279;}i:1282;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1281;}i:1283;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1279;}i:1284;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1283;}i:1285;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1279;}i:1286;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1285;}i:1287;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1279;}i:1288;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1287;}i:1289;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1276;}i:1290;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1276;}i:1291;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1276;}i:1292;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1276;}i:1293;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1276;}i:1294;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1293;}i:1295;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1276;}i:1296;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1295;}i:1297;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1295;}i:1298;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1297;}i:1299;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1295;}i:1300;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1299;}i:1301;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1295;}i:1302;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1301;}i:1303;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1295;}i:1304;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1303;}i:1305;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1276;}i:1306;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1276;}i:1307;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1276;}i:1308;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1276;}i:1309;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1276;}i:1310;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1276;}i:1311;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1276;}i:1312;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1276;}i:1313;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1276;}i:1314;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1313;}i:1315;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1275;}i:1316;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1315;}i:1317;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1275;}i:1318;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1275;}i:1319;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:1187;}i:1320;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:1319;}i:1321;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:1319;}i:1322;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1321;}i:1323;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1322;}i:1324;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:1321;}i:1325;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1324;}i:1326;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1325;}i:1327;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1325;}i:1328;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1321;}i:1329;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1328;}i:1330;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:1321;}i:1331;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1330;}i:1332;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:1319;}i:1333;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1332;}i:1334;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1333;}i:1335;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:1332;}i:1336;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1335;}i:1337;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1336;}i:1338;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1336;}i:1339;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1332;}i:1340;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1339;}i:1341;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:1319;}i:1342;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1341;}i:1343;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1187;}i:1344;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1343;}i:1345;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:1187;}i:1346;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1345;}i:1347;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1187;}i:1348;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1347;}i:1349;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1348;}i:1350;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1349;}i:1351;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1349;}i:1352;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1351;}i:1353;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1349;}i:1354;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1347;}i:1355;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1347;}i:1356;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1347;}i:1357;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1356;}i:1358;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1356;}i:1359;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1358;}i:1360;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1358;}i:1361;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1360;}i:1362;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1358;}i:1363;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1356;}i:1364;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1356;}i:1365;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1356;}i:1366;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1356;}i:1367;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1356;}i:1368;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1356;}i:1369;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1356;}i:1370;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1356;}i:1371;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1370;}i:1372;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1371;}i:1373;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1371;}i:1374;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1373;}i:1375;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1371;}i:1376;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1370;}i:1377;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1376;}i:1378;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1356;}i:1379;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1356;}i:1380;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1379;}i:1381;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1380;}i:1382;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1381;}i:1383;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1381;}i:1384;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1383;}i:1385;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1381;}i:1386;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1380;}i:1387;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1386;}i:1388;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1356;}i:1389;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1356;}i:1390;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1389;}i:1391;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1390;}i:1392;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1390;}i:1393;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1390;}i:1394;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1390;}i:1395;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1390;}i:1396;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1390;}i:1397;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1390;}i:1398;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1390;}i:1399;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1390;}i:1400;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1390;}i:1401;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1356;}i:1402;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1356;}i:1403;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1356;}i:1404;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1356;}i:1405;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1356;}i:1406;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1356;}i:1407;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1347;}i:1408;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1187;}i:1409;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1408;}i:1410;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1409;}i:1411;a:2:{s:5:"class";s:13:"ilobjforumgui";s:6:"parent";i:1;}i:1412;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1411;}i:1413;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1412;}i:1414;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1412;}i:1415;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1412;}i:1416;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1415;}i:1417;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1415;}i:1418;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1417;}i:1419;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1415;}i:1420;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1419;}i:1421;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1415;}i:1422;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1421;}i:1423;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1415;}i:1424;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1423;}i:1425;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1412;}i:1426;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1412;}i:1427;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1412;}i:1428;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1412;}i:1429;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1412;}i:1430;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1429;}i:1431;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1412;}i:1432;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1431;}i:1433;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1431;}i:1434;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1433;}i:1435;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1431;}i:1436;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1435;}i:1437;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1431;}i:1438;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1437;}i:1439;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1431;}i:1440;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1439;}i:1441;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1412;}i:1442;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1412;}i:1443;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1412;}i:1444;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1412;}i:1445;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1412;}i:1446;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1412;}i:1447;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1412;}i:1448;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1412;}i:1449;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1412;}i:1450;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1449;}i:1451;a:2:{s:5:"class";s:16:"ilforumexportgui";s:6:"parent";i:1411;}i:1452;a:2:{s:5:"class";s:20:"ilforummoderatorsgui";s:6:"parent";i:1411;}i:1453;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1411;}i:1454;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1453;}i:1455;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1454;}i:1456;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1454;}i:1457;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1454;}i:1458;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1457;}i:1459;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1457;}i:1460;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1459;}i:1461;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1457;}i:1462;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1461;}i:1463;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1457;}i:1464;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1463;}i:1465;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1457;}i:1466;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1465;}i:1467;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1454;}i:1468;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1454;}i:1469;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1454;}i:1470;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1454;}i:1471;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1454;}i:1472;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1471;}i:1473;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1454;}i:1474;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1473;}i:1475;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1473;}i:1476;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1475;}i:1477;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1473;}i:1478;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1477;}i:1479;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1473;}i:1480;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1479;}i:1481;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1473;}i:1482;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1481;}i:1483;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1454;}i:1484;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1454;}i:1485;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1454;}i:1486;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1454;}i:1487;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1454;}i:1488;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1454;}i:1489;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1454;}i:1490;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1454;}i:1491;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1454;}i:1492;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1491;}i:1493;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1453;}i:1494;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1493;}i:1495;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1453;}i:1496;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1453;}i:1497;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1411;}i:1498;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1497;}i:1499;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1411;}i:1500;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1499;}i:1501;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1500;}i:1502;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1411;}i:1503;a:2:{s:5:"class";s:16:"ilobjglossarygui";s:6:"parent";i:1;}i:1504;a:2:{s:5:"class";s:17:"ilglossarytermgui";s:6:"parent";i:1503;}i:1505;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1504;}i:1506;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1505;}i:1507;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1506;}i:1508;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1507;}i:1509;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1507;}i:1510;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1509;}i:1511;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1507;}i:1512;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1505;}i:1513;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1505;}i:1514;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1505;}i:1515;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1514;}i:1516;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1514;}i:1517;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1516;}i:1518;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1516;}i:1519;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1518;}i:1520;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1516;}i:1521;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1514;}i:1522;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1514;}i:1523;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1514;}i:1524;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1514;}i:1525;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1514;}i:1526;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1514;}i:1527;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1514;}i:1528;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1514;}i:1529;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1528;}i:1530;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1529;}i:1531;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1529;}i:1532;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1531;}i:1533;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1529;}i:1534;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1528;}i:1535;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1534;}i:1536;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1514;}i:1537;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1514;}i:1538;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1537;}i:1539;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1538;}i:1540;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1539;}i:1541;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1539;}i:1542;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1541;}i:1543;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1539;}i:1544;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1538;}i:1545;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1544;}i:1546;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1514;}i:1547;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1514;}i:1548;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1547;}i:1549;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1548;}i:1550;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1548;}i:1551;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1548;}i:1552;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1548;}i:1553;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1548;}i:1554;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1548;}i:1555;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1548;}i:1556;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1548;}i:1557;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1548;}i:1558;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1548;}i:1559;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1514;}i:1560;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1514;}i:1561;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1514;}i:1562;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1514;}i:1563;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1514;}i:1564;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1514;}i:1565;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1505;}i:1566;a:2:{s:5:"class";s:25:"iltermdefinitioneditorgui";s:6:"parent";i:1504;}i:1567;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1566;}i:1568;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1566;}i:1569;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1568;}i:1570;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1569;}i:1571;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1570;}i:1572;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1570;}i:1573;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1572;}i:1574;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1570;}i:1575;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1568;}i:1576;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1568;}i:1577;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1568;}i:1578;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1577;}i:1579;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1577;}i:1580;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1579;}i:1581;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1579;}i:1582;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1581;}i:1583;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1579;}i:1584;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1577;}i:1585;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1577;}i:1586;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1577;}i:1587;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1577;}i:1588;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1577;}i:1589;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1577;}i:1590;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1577;}i:1591;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1577;}i:1592;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1591;}i:1593;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1592;}i:1594;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1592;}i:1595;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1594;}i:1596;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1592;}i:1597;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1591;}i:1598;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1597;}i:1599;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1577;}i:1600;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1577;}i:1601;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1600;}i:1602;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1601;}i:1603;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1602;}i:1604;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1602;}i:1605;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1604;}i:1606;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1602;}i:1607;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1601;}i:1608;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1607;}i:1609;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1577;}i:1610;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1577;}i:1611;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1610;}i:1612;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1611;}i:1613;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1611;}i:1614;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1611;}i:1615;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1611;}i:1616;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1611;}i:1617;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1611;}i:1618;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1611;}i:1619;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1611;}i:1620;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1611;}i:1621;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1611;}i:1622;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1577;}i:1623;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1577;}i:1624;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1577;}i:1625;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1577;}i:1626;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1577;}i:1627;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1577;}i:1628;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1568;}i:1629;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1503;}i:1630;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1629;}i:1631;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1630;}i:1632;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1630;}i:1633;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1630;}i:1634;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1633;}i:1635;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1633;}i:1636;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1635;}i:1637;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1633;}i:1638;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1637;}i:1639;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1633;}i:1640;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1639;}i:1641;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1633;}i:1642;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1641;}i:1643;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1630;}i:1644;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1630;}i:1645;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1630;}i:1646;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1630;}i:1647;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1630;}i:1648;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1647;}i:1649;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1630;}i:1650;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1649;}i:1651;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1649;}i:1652;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1651;}i:1653;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1649;}i:1654;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1653;}i:1655;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1649;}i:1656;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1655;}i:1657;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1649;}i:1658;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1657;}i:1659;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1630;}i:1660;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1630;}i:1661;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1630;}i:1662;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1630;}i:1663;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1630;}i:1664;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1630;}i:1665;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1630;}i:1666;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1630;}i:1667;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1630;}i:1668;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1667;}i:1669;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1629;}i:1670;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1669;}i:1671;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1629;}i:1672;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1629;}i:1673;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1503;}i:1674;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1503;}i:1675;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1674;}i:1676;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1675;}i:1677;a:2:{s:5:"class";s:13:"ilobjgroupgui";s:6:"parent";i:1;}i:1678;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1677;}i:1679;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1677;}i:1680;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1679;}i:1681;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1679;}i:1682;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1679;}i:1683;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1682;}i:1684;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1682;}i:1685;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1684;}i:1686;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1682;}i:1687;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1686;}i:1688;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1682;}i:1689;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1688;}i:1690;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1682;}i:1691;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1690;}i:1692;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1679;}i:1693;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1679;}i:1694;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1679;}i:1695;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1679;}i:1696;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1679;}i:1697;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1696;}i:1698;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1679;}i:1699;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1698;}i:1700;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1698;}i:1701;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1700;}i:1702;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1698;}i:1703;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1702;}i:1704;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1698;}i:1705;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1704;}i:1706;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1698;}i:1707;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1706;}i:1708;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1679;}i:1709;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1679;}i:1710;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1679;}i:1711;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1679;}i:1712;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1679;}i:1713;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1679;}i:1714;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1679;}i:1715;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1679;}i:1716;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1679;}i:1717;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1716;}i:1718;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1677;}i:1719;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1718;}i:1720;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:1677;}i:1721;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1720;}i:1722;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1721;}i:1723;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1721;}i:1724;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1721;}i:1725;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1724;}i:1726;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1724;}i:1727;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1726;}i:1728;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1724;}i:1729;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1728;}i:1730;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1724;}i:1731;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1730;}i:1732;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1724;}i:1733;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1732;}i:1734;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1721;}i:1735;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1721;}i:1736;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1721;}i:1737;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1721;}i:1738;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1721;}i:1739;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1738;}i:1740;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1721;}i:1741;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1740;}i:1742;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1740;}i:1743;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1742;}i:1744;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1740;}i:1745;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1744;}i:1746;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1740;}i:1747;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1746;}i:1748;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1740;}i:1749;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1748;}i:1750;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1721;}i:1751;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1721;}i:1752;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1721;}i:1753;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1721;}i:1754;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1721;}i:1755;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1721;}i:1756;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1721;}i:1757;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1721;}i:1758;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1721;}i:1759;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1758;}i:1760;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:1720;}i:1761;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:1720;}i:1762;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1761;}i:1763;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:1677;}i:1764;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:1763;}i:1765;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1764;}i:1766;a:2:{s:5:"class";s:22:"ilgroupregistrationgui";s:6:"parent";i:1677;}i:1767;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1677;}i:1768;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1767;}i:1769;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1768;}i:1770;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1768;}i:1771;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1768;}i:1772;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1771;}i:1773;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1771;}i:1774;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1773;}i:1775;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1771;}i:1776;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1775;}i:1777;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1771;}i:1778;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1777;}i:1779;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1771;}i:1780;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1779;}i:1781;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1768;}i:1782;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1768;}i:1783;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1768;}i:1784;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1768;}i:1785;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1768;}i:1786;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1785;}i:1787;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1768;}i:1788;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1787;}i:1789;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1787;}i:1790;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1789;}i:1791;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1787;}i:1792;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1791;}i:1793;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1787;}i:1794;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1793;}i:1795;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1787;}i:1796;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1795;}i:1797;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1768;}i:1798;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1768;}i:1799;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1768;}i:1800;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1768;}i:1801;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1768;}i:1802;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1768;}i:1803;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1768;}i:1804;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1768;}i:1805;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1768;}i:1806;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1805;}i:1807;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1767;}i:1808;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1807;}i:1809;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1767;}i:1810;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1767;}i:1811;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:1677;}i:1812;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:1811;}i:1813;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:1811;}i:1814;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1813;}i:1815;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1814;}i:1816;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:1813;}i:1817;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1816;}i:1818;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1817;}i:1819;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1817;}i:1820;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1813;}i:1821;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1820;}i:1822;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:1813;}i:1823;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1822;}i:1824;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:1811;}i:1825;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:1824;}i:1826;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1825;}i:1827;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:1824;}i:1828;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:1827;}i:1829;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1828;}i:1830;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:1828;}i:1831;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:1824;}i:1832;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1831;}i:1833;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:1811;}i:1834;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1833;}i:1835;a:2:{s:5:"class";s:22:"ilobjcoursegroupinggui";s:6:"parent";i:1677;}i:1836;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:1677;}i:1837;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1836;}i:1838;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:1677;}i:1839;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1838;}i:1840;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:1677;}i:1841;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:1840;}i:1842;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1841;}i:1843;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1842;}i:1844;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1842;}i:1845;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1844;}i:1846;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1842;}i:1847;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1840;}i:1848;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1840;}i:1849;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:1840;}i:1850;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1849;}i:1851;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1849;}i:1852;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1851;}i:1853;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1851;}i:1854;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1853;}i:1855;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1851;}i:1856;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:1849;}i:1857;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:1849;}i:1858;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:1849;}i:1859;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:1849;}i:1860;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:1849;}i:1861;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:1849;}i:1862;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:1849;}i:1863;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1849;}i:1864;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1863;}i:1865;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1864;}i:1866;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1864;}i:1867;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1866;}i:1868;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1864;}i:1869;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1863;}i:1870;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1869;}i:1871;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:1849;}i:1872;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:1849;}i:1873;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:1872;}i:1874;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:1873;}i:1875;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:1874;}i:1876;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:1874;}i:1877;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1876;}i:1878;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:1874;}i:1879;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:1873;}i:1880;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:1879;}i:1881;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:1849;}i:1882;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:1849;}i:1883;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:1882;}i:1884;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:1883;}i:1885;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:1883;}i:1886;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:1883;}i:1887;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:1883;}i:1888;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:1883;}i:1889;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:1883;}i:1890;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:1883;}i:1891;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:1883;}i:1892;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:1883;}i:1893;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:1883;}i:1894;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:1849;}i:1895;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:1849;}i:1896;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:1849;}i:1897;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:1849;}i:1898;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:1849;}i:1899;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:1849;}i:1900;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1840;}i:1901;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1677;}i:1902;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1901;}i:1903;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1902;}i:1904;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1677;}i:1905;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1677;}i:1906;a:2:{s:5:"class";s:22:"ilobjilincclassroomgui";s:6:"parent";i:1;}i:1907;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1906;}i:1908;a:2:{s:5:"class";s:19:"ilobjilinccoursegui";s:6:"parent";i:1;}i:1909;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1908;}i:1910;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1909;}i:1911;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1909;}i:1912;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1909;}i:1913;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1912;}i:1914;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1912;}i:1915;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1914;}i:1916;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1912;}i:1917;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1916;}i:1918;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1912;}i:1919;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1918;}i:1920;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1912;}i:1921;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1920;}i:1922;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1909;}i:1923;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1909;}i:1924;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1909;}i:1925;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1909;}i:1926;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1909;}i:1927;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1926;}i:1928;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1909;}i:1929;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1928;}i:1930;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1928;}i:1931;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1930;}i:1932;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1928;}i:1933;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1932;}i:1934;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1928;}i:1935;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1934;}i:1936;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1928;}i:1937;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1936;}i:1938;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1909;}i:1939;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1909;}i:1940;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1909;}i:1941;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1909;}i:1942;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1909;}i:1943;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1909;}i:1944;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1909;}i:1945;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1909;}i:1946;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1909;}i:1947;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1946;}i:1948;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:1908;}i:1949;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:1948;}i:1950;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1949;}i:1951;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:1949;}i:1952;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:1949;}i:1953;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1952;}i:1954;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1952;}i:1955;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1954;}i:1956;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1952;}i:1957;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1956;}i:1958;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1952;}i:1959;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1958;}i:1960;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1952;}i:1961;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1960;}i:1962;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:1949;}i:1963;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:1949;}i:1964;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:1949;}i:1965;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:1949;}i:1966;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:1949;}i:1967;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:1966;}i:1968;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:1949;}i:1969;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1968;}i:1970;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:1968;}i:1971;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1970;}i:1972;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:1968;}i:1973;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1972;}i:1974;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:1968;}i:1975;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1974;}i:1976;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:1968;}i:1977;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:1976;}i:1978;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:1949;}i:1979;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:1949;}i:1980;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:1949;}i:1981;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:1949;}i:1982;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:1949;}i:1983;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:1949;}i:1984;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:1949;}i:1985;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:1949;}i:1986;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:1949;}i:1987;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1986;}i:1988;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:1948;}i:1989;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1988;}i:1990;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:1948;}i:1991;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1948;}i:1992;a:2:{s:5:"class";s:22:"ilobjilincclassroomgui";s:6:"parent";i:1908;}i:1993;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1992;}i:1994;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1908;}i:1995;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1994;}i:1996;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1995;}i:1997;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:1908;}i:1998;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:1908;}i:1999;a:2:{s:5:"class";s:19:"ilobjlanguageextgui";s:6:"parent";i:1;}i:2000;a:2:{s:5:"class";s:0:"";s:6:"parent";i:1999;}i:2001;a:2:{s:5:"class";s:22:"ilobjlanguagefoldergui";s:6:"parent";i:1;}i:2002;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2001;}i:2003;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2002;}i:2004;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2003;}i:2005;a:2:{s:5:"class";s:22:"ilobjlearningmodulegui";s:6:"parent";i:1;}i:2006;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2005;}i:2007;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2006;}i:2008;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2007;}i:2009;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2007;}i:2010;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2007;}i:2011;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2010;}i:2012;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2010;}i:2013;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2012;}i:2014;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2010;}i:2015;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2014;}i:2016;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2010;}i:2017;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2016;}i:2018;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2010;}i:2019;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2018;}i:2020;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2007;}i:2021;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2007;}i:2022;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2007;}i:2023;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2007;}i:2024;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2007;}i:2025;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2024;}i:2026;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2007;}i:2027;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2026;}i:2028;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2026;}i:2029;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2028;}i:2030;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2026;}i:2031;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2030;}i:2032;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2026;}i:2033;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2032;}i:2034;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2026;}i:2035;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2034;}i:2036;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2007;}i:2037;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2007;}i:2038;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2007;}i:2039;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2007;}i:2040;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2007;}i:2041;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2007;}i:2042;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2007;}i:2043;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2007;}i:2044;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2007;}i:2045;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2044;}i:2046;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2006;}i:2047;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2046;}i:2048;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2006;}i:2049;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2006;}i:2050;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:2005;}i:2051;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:2050;}i:2052;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:2050;}i:2053;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2052;}i:2054;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2053;}i:2055;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:2052;}i:2056;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2055;}i:2057;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2056;}i:2058;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2056;}i:2059;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2052;}i:2060;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2059;}i:2061;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:2052;}i:2062;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2061;}i:2063;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:2050;}i:2064;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2063;}i:2065;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2064;}i:2066;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:2063;}i:2067;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2066;}i:2068;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2067;}i:2069;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2067;}i:2070;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2063;}i:2071;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2070;}i:2072;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:2050;}i:2073;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2072;}i:2074;a:2:{s:5:"class";s:17:"illmpageobjectgui";s:6:"parent";i:2005;}i:2075;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2074;}i:2076;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2075;}i:2077;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2076;}i:2078;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2077;}i:2079;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2077;}i:2080;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2079;}i:2081;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2077;}i:2082;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2075;}i:2083;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2075;}i:2084;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2075;}i:2085;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2084;}i:2086;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2084;}i:2087;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2086;}i:2088;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2086;}i:2089;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2088;}i:2090;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2086;}i:2091;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2084;}i:2092;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2084;}i:2093;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2084;}i:2094;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2084;}i:2095;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2084;}i:2096;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2084;}i:2097;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2084;}i:2098;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2084;}i:2099;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2098;}i:2100;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2099;}i:2101;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2099;}i:2102;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2101;}i:2103;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2099;}i:2104;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2098;}i:2105;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2104;}i:2106;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2084;}i:2107;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2084;}i:2108;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2107;}i:2109;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2108;}i:2110;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2109;}i:2111;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2109;}i:2112;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2111;}i:2113;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2109;}i:2114;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2108;}i:2115;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2114;}i:2116;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2084;}i:2117;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2084;}i:2118;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2117;}i:2119;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2118;}i:2120;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2118;}i:2121;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2118;}i:2122;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2118;}i:2123;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2118;}i:2124;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2118;}i:2125;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2118;}i:2126;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2118;}i:2127;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2118;}i:2128;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2118;}i:2129;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2084;}i:2130;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2084;}i:2131;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2084;}i:2132;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2084;}i:2133;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2084;}i:2134;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2084;}i:2135;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2075;}i:2136;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2005;}i:2137;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:2005;}i:2138;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2137;}i:2139;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2005;}i:2140;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2139;}i:2141;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2140;}i:2142;a:2:{s:5:"class";s:20:"ilstructureobjectgui";s:6:"parent";i:2005;}i:2143;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:2142;}i:2144;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2143;}i:2145;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2142;}i:2146;a:2:{s:5:"class";s:33:"ilobjlearningresourcessettingsgui";s:6:"parent";i:1;}i:2147;a:2:{s:5:"class";s:20:"illicenseoverviewgui";s:6:"parent";i:2146;}i:2148;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2147;}i:2149;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2146;}i:2150;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2149;}i:2151;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2150;}i:2152;a:2:{s:5:"class";s:20:"ilobjlinkresourcegui";s:6:"parent";i:1;}i:2153;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2152;}i:2154;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2153;}i:2155;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2154;}i:2156;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2154;}i:2157;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2154;}i:2158;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2157;}i:2159;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2157;}i:2160;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2159;}i:2161;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2157;}i:2162;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2161;}i:2163;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2157;}i:2164;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2163;}i:2165;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2157;}i:2166;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2165;}i:2167;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2154;}i:2168;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2154;}i:2169;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2154;}i:2170;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2154;}i:2171;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2154;}i:2172;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2171;}i:2173;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2154;}i:2174;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2173;}i:2175;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2173;}i:2176;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2175;}i:2177;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2173;}i:2178;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2177;}i:2179;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2173;}i:2180;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2179;}i:2181;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2173;}i:2182;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2181;}i:2183;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2154;}i:2184;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2154;}i:2185;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2154;}i:2186;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2154;}i:2187;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2154;}i:2188;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2154;}i:2189;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2154;}i:2190;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2154;}i:2191;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2154;}i:2192;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2191;}i:2193;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2153;}i:2194;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2193;}i:2195;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2153;}i:2196;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2153;}i:2197;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2152;}i:2198;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2152;}i:2199;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2198;}i:2200;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2152;}i:2201;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2200;}i:2202;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2201;}i:2203;a:2:{s:5:"class";s:12:"ilobjmailgui";s:6:"parent";i:1;}i:2204;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2203;}i:2205;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2204;}i:2206;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2205;}i:2207;a:2:{s:5:"class";s:18:"ilobjmdsettingsgui";s:6:"parent";i:1;}i:2208;a:2:{s:5:"class";s:23:"iladvancedmdsettingsgui";s:6:"parent";i:2207;}i:2209;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2208;}i:2210;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2207;}i:2211;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2210;}i:2212;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2211;}i:2213;a:2:{s:5:"class";s:17:"ilobjmediacastgui";s:6:"parent";i:1;}i:2214;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2213;}i:2215;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2214;}i:2216;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2215;}i:2217;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2215;}i:2218;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2215;}i:2219;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2218;}i:2220;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2218;}i:2221;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2220;}i:2222;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2218;}i:2223;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2222;}i:2224;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2218;}i:2225;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2224;}i:2226;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2218;}i:2227;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2226;}i:2228;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2215;}i:2229;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2215;}i:2230;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2215;}i:2231;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2215;}i:2232;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2215;}i:2233;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2232;}i:2234;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2215;}i:2235;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2234;}i:2236;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2234;}i:2237;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2236;}i:2238;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2234;}i:2239;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2238;}i:2240;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2234;}i:2241;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2240;}i:2242;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2234;}i:2243;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2242;}i:2244;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2215;}i:2245;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2215;}i:2246;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2215;}i:2247;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2215;}i:2248;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2215;}i:2249;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2215;}i:2250;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2215;}i:2251;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2215;}i:2252;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2215;}i:2253;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2252;}i:2254;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2214;}i:2255;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2254;}i:2256;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2214;}i:2257;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2214;}i:2258;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2213;}i:2259;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2258;}i:2260;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2259;}i:2261;a:2:{s:5:"class";s:25:"ilobjmediacastsettingsgui";s:6:"parent";i:1;}i:2262;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2261;}i:2263;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2262;}i:2264;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2263;}i:2265;a:2:{s:5:"class";s:28:"ilobjmediaobjectssettingsgui";s:6:"parent";i:1;}i:2266;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2265;}i:2267;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2266;}i:2268;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2267;}i:2269;a:2:{s:5:"class";s:17:"ilobjmediapoolgui";s:6:"parent";i:1;}i:2270;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2269;}i:2271;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2270;}i:2272;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2271;}i:2273;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2271;}i:2274;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2273;}i:2275;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2271;}i:2276;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2269;}i:2277;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2276;}i:2278;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2277;}i:2279;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2277;}i:2280;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2277;}i:2281;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2280;}i:2282;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2280;}i:2283;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2282;}i:2284;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2280;}i:2285;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2284;}i:2286;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2280;}i:2287;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2286;}i:2288;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2280;}i:2289;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2288;}i:2290;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2277;}i:2291;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2277;}i:2292;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2277;}i:2293;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2277;}i:2294;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2277;}i:2295;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2294;}i:2296;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2277;}i:2297;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2296;}i:2298;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2296;}i:2299;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2298;}i:2300;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2296;}i:2301;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2300;}i:2302;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2296;}i:2303;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2302;}i:2304;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2296;}i:2305;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2304;}i:2306;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2277;}i:2307;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2277;}i:2308;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2277;}i:2309;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2277;}i:2310;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2277;}i:2311;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2277;}i:2312;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2277;}i:2313;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2277;}i:2314;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2277;}i:2315;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2314;}i:2316;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2276;}i:2317;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2316;}i:2318;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2276;}i:2319;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2276;}i:2320;a:2:{s:5:"class";s:18:"ilmediapoolpagegui";s:6:"parent";i:2269;}i:2321;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2320;}i:2322;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2321;}i:2323;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2322;}i:2324;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2322;}i:2325;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2324;}i:2326;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2322;}i:2327;a:2:{s:5:"class";s:25:"ilmediapooltargetselector";s:6:"parent";i:2320;}i:2328;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2320;}i:2329;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2328;}i:2330;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2328;}i:2331;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2330;}i:2332;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2330;}i:2333;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2332;}i:2334;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2330;}i:2335;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2328;}i:2336;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2328;}i:2337;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2328;}i:2338;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2328;}i:2339;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2328;}i:2340;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2328;}i:2341;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2328;}i:2342;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2328;}i:2343;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2342;}i:2344;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2343;}i:2345;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2343;}i:2346;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2345;}i:2347;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2343;}i:2348;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2342;}i:2349;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2348;}i:2350;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2328;}i:2351;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2328;}i:2352;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2351;}i:2353;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2352;}i:2354;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2353;}i:2355;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2353;}i:2356;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2355;}i:2357;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2353;}i:2358;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2352;}i:2359;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2358;}i:2360;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2328;}i:2361;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2328;}i:2362;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2361;}i:2363;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2362;}i:2364;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2362;}i:2365;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2362;}i:2366;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2362;}i:2367;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2362;}i:2368;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2362;}i:2369;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2362;}i:2370;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2362;}i:2371;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2362;}i:2372;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2362;}i:2373;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2328;}i:2374;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2328;}i:2375;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2328;}i:2376;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2328;}i:2377;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2328;}i:2378;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2328;}i:2379;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2320;}i:2380;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2379;}i:2381;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2380;}i:2382;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2381;}i:2383;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2381;}i:2384;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2383;}i:2385;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2381;}i:2386;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2379;}i:2387;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2379;}i:2388;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2379;}i:2389;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2388;}i:2390;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2388;}i:2391;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2390;}i:2392;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2390;}i:2393;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2392;}i:2394;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2390;}i:2395;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2388;}i:2396;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2388;}i:2397;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2388;}i:2398;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2388;}i:2399;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2388;}i:2400;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2388;}i:2401;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2388;}i:2402;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2388;}i:2403;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2402;}i:2404;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2403;}i:2405;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2403;}i:2406;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2405;}i:2407;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2403;}i:2408;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2402;}i:2409;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2408;}i:2410;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2388;}i:2411;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2388;}i:2412;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2411;}i:2413;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2412;}i:2414;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2413;}i:2415;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2413;}i:2416;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2415;}i:2417;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2413;}i:2418;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2412;}i:2419;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2418;}i:2420;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2388;}i:2421;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2388;}i:2422;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2421;}i:2423;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2422;}i:2424;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2422;}i:2425;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2422;}i:2426;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2422;}i:2427;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2422;}i:2428;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2422;}i:2429;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2422;}i:2430;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2422;}i:2431;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2422;}i:2432;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2422;}i:2433;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2388;}i:2434;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2388;}i:2435;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2388;}i:2436;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2388;}i:2437;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2388;}i:2438;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2388;}i:2439;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2379;}i:2440;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2320;}i:2441;a:2:{s:5:"class";s:14:"ilobjfoldergui";s:6:"parent";i:2269;}i:2442;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2441;}i:2443;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2442;}i:2444;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2442;}i:2445;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2442;}i:2446;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2445;}i:2447;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2445;}i:2448;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2447;}i:2449;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2445;}i:2450;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2449;}i:2451;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2445;}i:2452;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2451;}i:2453;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2445;}i:2454;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2453;}i:2455;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2442;}i:2456;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2442;}i:2457;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2442;}i:2458;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2442;}i:2459;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2442;}i:2460;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2459;}i:2461;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2442;}i:2462;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2461;}i:2463;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2461;}i:2464;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2463;}i:2465;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2461;}i:2466;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2465;}i:2467;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2461;}i:2468;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2467;}i:2469;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2461;}i:2470;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2469;}i:2471;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2442;}i:2472;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2442;}i:2473;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2442;}i:2474;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2442;}i:2475;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2442;}i:2476;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2442;}i:2477;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2442;}i:2478;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2442;}i:2479;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2442;}i:2480;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2479;}i:2481;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:2441;}i:2482;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2481;}i:2483;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:2441;}i:2484;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2483;}i:2485;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2484;}i:2486;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2484;}i:2487;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2484;}i:2488;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2487;}i:2489;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2487;}i:2490;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2489;}i:2491;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2487;}i:2492;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2491;}i:2493;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2487;}i:2494;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2493;}i:2495;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2487;}i:2496;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2495;}i:2497;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2484;}i:2498;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2484;}i:2499;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2484;}i:2500;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2484;}i:2501;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2484;}i:2502;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2501;}i:2503;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2484;}i:2504;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2503;}i:2505;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2503;}i:2506;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2505;}i:2507;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2503;}i:2508;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2507;}i:2509;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2503;}i:2510;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2509;}i:2511;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2503;}i:2512;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2511;}i:2513;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2484;}i:2514;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2484;}i:2515;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2484;}i:2516;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2484;}i:2517;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2484;}i:2518;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2484;}i:2519;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2484;}i:2520;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2484;}i:2521;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2484;}i:2522;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2521;}i:2523;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:2483;}i:2524;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:2483;}i:2525;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2524;}i:2526;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:2441;}i:2527;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:2526;}i:2528;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2527;}i:2529;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2441;}i:2530;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2529;}i:2531;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2530;}i:2532;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2530;}i:2533;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2530;}i:2534;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2533;}i:2535;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2533;}i:2536;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2535;}i:2537;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2533;}i:2538;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2537;}i:2539;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2533;}i:2540;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2539;}i:2541;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2533;}i:2542;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2541;}i:2543;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2530;}i:2544;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2530;}i:2545;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2530;}i:2546;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2530;}i:2547;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2530;}i:2548;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2547;}i:2549;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2530;}i:2550;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2549;}i:2551;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2549;}i:2552;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2551;}i:2553;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2549;}i:2554;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2553;}i:2555;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2549;}i:2556;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2555;}i:2557;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2549;}i:2558;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2557;}i:2559;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2530;}i:2560;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2530;}i:2561;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2530;}i:2562;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2530;}i:2563;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2530;}i:2564;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2530;}i:2565;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2530;}i:2566;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2530;}i:2567;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2530;}i:2568;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2567;}i:2569;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2529;}i:2570;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2569;}i:2571;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2529;}i:2572;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2529;}i:2573;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:2441;}i:2574;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:2573;}i:2575;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:2573;}i:2576;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2575;}i:2577;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2576;}i:2578;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:2575;}i:2579;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2578;}i:2580;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2579;}i:2581;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2579;}i:2582;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2575;}i:2583;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2582;}i:2584;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:2575;}i:2585;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2584;}i:2586;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:2573;}i:2587;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:2586;}i:2588;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2587;}i:2589;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:2586;}i:2590;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:2589;}i:2591;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2590;}i:2592;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:2590;}i:2593;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:2586;}i:2594;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2593;}i:2595;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:2573;}i:2596;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2595;}i:2597;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2441;}i:2598;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2597;}i:2599;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:2441;}i:2600;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2599;}i:2601;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2441;}i:2602;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2601;}i:2603;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2602;}i:2604;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2603;}i:2605;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2603;}i:2606;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2605;}i:2607;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2603;}i:2608;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2601;}i:2609;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2601;}i:2610;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2601;}i:2611;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2610;}i:2612;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2610;}i:2613;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2612;}i:2614;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2612;}i:2615;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2614;}i:2616;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2612;}i:2617;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2610;}i:2618;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2610;}i:2619;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2610;}i:2620;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2610;}i:2621;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2610;}i:2622;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2610;}i:2623;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2610;}i:2624;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2610;}i:2625;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2624;}i:2626;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2625;}i:2627;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2625;}i:2628;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2627;}i:2629;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2625;}i:2630;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2624;}i:2631;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2630;}i:2632;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2610;}i:2633;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2610;}i:2634;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2633;}i:2635;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2634;}i:2636;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2635;}i:2637;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2635;}i:2638;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2637;}i:2639;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2635;}i:2640;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2634;}i:2641;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2640;}i:2642;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2610;}i:2643;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2610;}i:2644;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2643;}i:2645;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2644;}i:2646;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2644;}i:2647;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2644;}i:2648;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2644;}i:2649;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2644;}i:2650;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2644;}i:2651;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2644;}i:2652;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2644;}i:2653;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2644;}i:2654;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2644;}i:2655;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2610;}i:2656;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2610;}i:2657;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2610;}i:2658;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2610;}i:2659;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2610;}i:2660;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2610;}i:2661;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2601;}i:2662;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2441;}i:2663;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2662;}i:2664;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2663;}i:2665;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2269;}i:2666;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2665;}i:2667;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2665;}i:2668;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2667;}i:2669;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2665;}i:2670;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2269;}i:2671;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2670;}i:2672;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2671;}i:2673;a:2:{s:5:"class";s:20:"ilobjnewssettingsgui";s:6:"parent";i:1;}i:2674;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2673;}i:2675;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2674;}i:2676;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2675;}i:2677;a:2:{s:5:"class";s:20:"ilobjobjectfoldergui";s:6:"parent";i:1;}i:2678;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2677;}i:2679;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2678;}i:2680;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2679;}i:2681;a:2:{s:5:"class";s:23:"ilobjpaymentsettingsgui";s:6:"parent";i:1;}i:2682;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2681;}i:2683;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2682;}i:2684;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2683;}i:2685;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2684;}i:2686;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2684;}i:2687;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2686;}i:2688;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2684;}i:2689;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2682;}i:2690;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2682;}i:2691;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2682;}i:2692;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2691;}i:2693;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2691;}i:2694;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2693;}i:2695;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2693;}i:2696;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2695;}i:2697;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2693;}i:2698;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2691;}i:2699;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2691;}i:2700;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2691;}i:2701;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2691;}i:2702;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2691;}i:2703;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2691;}i:2704;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2691;}i:2705;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2691;}i:2706;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2705;}i:2707;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2706;}i:2708;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2706;}i:2709;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2708;}i:2710;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2706;}i:2711;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2705;}i:2712;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2711;}i:2713;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2691;}i:2714;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2691;}i:2715;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2714;}i:2716;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2715;}i:2717;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2716;}i:2718;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2716;}i:2719;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2718;}i:2720;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2716;}i:2721;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2715;}i:2722;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2721;}i:2723;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2691;}i:2724;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2691;}i:2725;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2724;}i:2726;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2725;}i:2727;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2725;}i:2728;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2725;}i:2729;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2725;}i:2730;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2725;}i:2731;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2725;}i:2732;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2725;}i:2733;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2725;}i:2734;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2725;}i:2735;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2725;}i:2736;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2691;}i:2737;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2691;}i:2738;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2691;}i:2739;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2691;}i:2740;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2691;}i:2741;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2691;}i:2742;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2682;}i:2743;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2681;}i:2744;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2743;}i:2745;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2744;}i:2746;a:2:{s:5:"class";s:15:"ilshoptopicsgui";s:6:"parent";i:2681;}i:2747;a:2:{s:5:"class";s:31:"ilobjpersonaldesktopsettingsgui";s:6:"parent";i:1;}i:2748;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2747;}i:2749;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2748;}i:2750;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2749;}i:2751;a:2:{s:5:"class";s:23:"ilobjprivacysecuritygui";s:6:"parent";i:1;}i:2752;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2751;}i:2753;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2752;}i:2754;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2753;}i:2755;a:2:{s:5:"class";s:20:"ilobjquestionpoolgui";s:6:"parent";i:1;}i:2756;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2755;}i:2757;a:2:{s:5:"class";s:15:"asserrortextgui";s:6:"parent";i:2755;}i:2758;a:2:{s:5:"class";s:16:"assfileuploadgui";s:6:"parent";i:2755;}i:2759;a:2:{s:5:"class";s:19:"assflashquestiongui";s:6:"parent";i:2755;}i:2760;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2755;}i:2761;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2755;}i:2762;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2755;}i:2763;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2755;}i:2764;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2755;}i:2765;a:2:{s:5:"class";s:24:"assorderinghorizontalgui";s:6:"parent";i:2755;}i:2766;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2755;}i:2767;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2755;}i:2768;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2755;}i:2769;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2755;}i:2770;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2755;}i:2771;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2755;}i:2772;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2771;}i:2773;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2755;}i:2774;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2773;}i:2775;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2774;}i:2776;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2775;}i:2777;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2775;}i:2778;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2777;}i:2779;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2775;}i:2780;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2773;}i:2781;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2773;}i:2782;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2773;}i:2783;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2782;}i:2784;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2782;}i:2785;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2784;}i:2786;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2784;}i:2787;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2786;}i:2788;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2784;}i:2789;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2782;}i:2790;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2782;}i:2791;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2782;}i:2792;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2782;}i:2793;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2782;}i:2794;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2782;}i:2795;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2782;}i:2796;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2782;}i:2797;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2796;}i:2798;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2797;}i:2799;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2797;}i:2800;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2799;}i:2801;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2797;}i:2802;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2796;}i:2803;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2802;}i:2804;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2782;}i:2805;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2782;}i:2806;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2805;}i:2807;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2806;}i:2808;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2807;}i:2809;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2807;}i:2810;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2809;}i:2811;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2807;}i:2812;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2806;}i:2813;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2812;}i:2814;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2782;}i:2815;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2782;}i:2816;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2815;}i:2817;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2816;}i:2818;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2816;}i:2819;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2816;}i:2820;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2816;}i:2821;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2816;}i:2822;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2816;}i:2823;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2816;}i:2824;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2816;}i:2825;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2816;}i:2826;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2816;}i:2827;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2782;}i:2828;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2782;}i:2829;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2782;}i:2830;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2782;}i:2831;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2782;}i:2832;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2782;}i:2833;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2773;}i:2834;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2755;}i:2835;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2834;}i:2836;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2835;}i:2837;a:2:{s:5:"class";s:22:"ilobjrecoveryfoldergui";s:6:"parent";i:1;}i:2838;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2837;}i:2839;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2838;}i:2840;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2839;}i:2841;a:2:{s:5:"class";s:20:"ilobjremotecoursegui";s:6:"parent";i:1;}i:2842;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:2841;}i:2843;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2842;}i:2844;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2843;}i:2845;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2843;}i:2846;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2843;}i:2847;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2846;}i:2848;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2846;}i:2849;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2848;}i:2850;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2846;}i:2851;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2850;}i:2852;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2846;}i:2853;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2852;}i:2854;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2846;}i:2855;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2854;}i:2856;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2843;}i:2857;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2843;}i:2858;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2843;}i:2859;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2843;}i:2860;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2843;}i:2861;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2860;}i:2862;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2843;}i:2863;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2862;}i:2864;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2862;}i:2865;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2864;}i:2866;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2862;}i:2867;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2866;}i:2868;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2862;}i:2869;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2868;}i:2870;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2862;}i:2871;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2870;}i:2872;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2843;}i:2873;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2843;}i:2874;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2843;}i:2875;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2843;}i:2876;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2843;}i:2877;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2843;}i:2878;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2843;}i:2879;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2843;}i:2880;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2843;}i:2881;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2880;}i:2882;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:2842;}i:2883;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2882;}i:2884;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2842;}i:2885;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2842;}i:2886;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2841;}i:2887;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2886;}i:2888;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2887;}i:2889;a:2:{s:5:"class";s:18:"ilobjrolefoldergui";s:6:"parent";i:1;}i:2890;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2889;}i:2891;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:2890;}i:2892;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2891;}i:2893;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:1;}i:2894;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:2893;}i:2895;a:2:{s:5:"class";s:20:"ilobjroletemplategui";s:6:"parent";i:1;}i:2896;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2895;}i:2897;a:2:{s:5:"class";s:18:"ilobjrootfoldergui";s:6:"parent";i:1;}i:2898;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:2897;}i:2899;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2898;}i:2900;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:2898;}i:2901;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:2898;}i:2902;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2901;}i:2903;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2901;}i:2904;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2903;}i:2905;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2901;}i:2906;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2905;}i:2907;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2901;}i:2908;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2907;}i:2909;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2901;}i:2910;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2909;}i:2911;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:2898;}i:2912;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:2898;}i:2913;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:2898;}i:2914;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:2898;}i:2915;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:2898;}i:2916;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:2915;}i:2917;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:2898;}i:2918;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2917;}i:2919;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:2917;}i:2920;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2919;}i:2921;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:2917;}i:2922;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2921;}i:2923;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:2917;}i:2924;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2923;}i:2925;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:2917;}i:2926;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:2925;}i:2927;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:2898;}i:2928;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:2898;}i:2929;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:2898;}i:2930;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:2898;}i:2931;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:2898;}i:2932;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:2898;}i:2933;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:2898;}i:2934;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:2898;}i:2935;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:2898;}i:2936;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2935;}i:2937;a:2:{s:5:"class";s:22:"ilcontainerlinklistgui";s:6:"parent";i:2897;}i:2938;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2937;}i:2939;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:2897;}i:2940;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2939;}i:2941;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:2897;}i:2942;a:2:{s:5:"class";s:0:"";s:6:"parent";i:2941;}i:2943;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:2897;}i:2944;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:2943;}i:2945;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2944;}i:2946;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2945;}i:2947;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2945;}i:2948;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2947;}i:2949;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2945;}i:2950;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2943;}i:2951;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:2943;}i:2952;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:2943;}i:2953;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2952;}i:2954;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2952;}i:2955;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2954;}i:2956;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2954;}i:2957;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2956;}i:2958;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2954;}i:2959;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:2952;}i:2960;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:2952;}i:2961;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:2952;}i:2962;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:2952;}i:2963;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:2952;}i:2964;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:2952;}i:2965;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:2952;}i:2966;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2952;}i:2967;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2966;}i:2968;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2967;}i:2969;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2967;}i:2970;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2969;}i:2971;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2967;}i:2972;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2966;}i:2973;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2972;}i:2974;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:2952;}i:2975;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:2952;}i:2976;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:2975;}i:2977;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:2976;}i:2978;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:2977;}i:2979;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:2977;}i:2980;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2979;}i:2981;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:2977;}i:2982;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:2976;}i:2983;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:2982;}i:2984;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:2952;}i:2985;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:2952;}i:2986;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:2985;}i:2987;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:2986;}i:2988;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:2986;}i:2989;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:2986;}i:2990;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:2986;}i:2991;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:2986;}i:2992;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:2986;}i:2993;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:2986;}i:2994;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:2986;}i:2995;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:2986;}i:2996;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:2986;}i:2997;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:2952;}i:2998;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:2952;}i:2999;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:2952;}i:3000;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:2952;}i:3001;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:2952;}i:3002;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:2952;}i:3003;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:2943;}i:3004;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:2897;}i:3005;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3004;}i:3006;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3005;}i:3007;a:2:{s:5:"class";s:26:"ilobjsahslearningmodulegui";s:6:"parent";i:1;}i:3008;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3007;}i:3009;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3007;}i:3010;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3009;}i:3011;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3010;}i:3012;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3010;}i:3013;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3010;}i:3014;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3013;}i:3015;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3013;}i:3016;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3015;}i:3017;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3013;}i:3018;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3017;}i:3019;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3013;}i:3020;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3019;}i:3021;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3013;}i:3022;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3021;}i:3023;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3010;}i:3024;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3010;}i:3025;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3010;}i:3026;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3010;}i:3027;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3010;}i:3028;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3027;}i:3029;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3010;}i:3030;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3029;}i:3031;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3029;}i:3032;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3031;}i:3033;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3029;}i:3034;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3033;}i:3035;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3029;}i:3036;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3035;}i:3037;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3029;}i:3038;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3037;}i:3039;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3010;}i:3040;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3010;}i:3041;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3010;}i:3042;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3010;}i:3043;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3010;}i:3044;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3010;}i:3045;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3010;}i:3046;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3010;}i:3047;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3010;}i:3048;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3047;}i:3049;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3009;}i:3050;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3049;}i:3051;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3009;}i:3052;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3009;}i:3053;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3007;}i:3054;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3053;}i:3055;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3053;}i:3056;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3055;}i:3057;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3056;}i:3058;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3055;}i:3059;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3058;}i:3060;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3059;}i:3061;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3059;}i:3062;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3055;}i:3063;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3062;}i:3064;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3055;}i:3065;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3064;}i:3066;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3053;}i:3067;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3066;}i:3068;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3067;}i:3069;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3066;}i:3070;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3069;}i:3071;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3070;}i:3072;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3070;}i:3073;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3066;}i:3074;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3073;}i:3075;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3053;}i:3076;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3075;}i:3077;a:2:{s:5:"class";s:12:"illicensegui";s:6:"parent";i:3007;}i:3078;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3077;}i:3079;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3007;}i:3080;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3007;}i:3081;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3080;}i:3082;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3081;}i:3083;a:2:{s:5:"class";s:22:"ilobjsearchsettingsgui";s:6:"parent";i:1;}i:3084;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3083;}i:3085;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3084;}i:3086;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3085;}i:3087;a:2:{s:5:"class";s:15:"ilobjsessiongui";s:6:"parent";i:1;}i:3088;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:3087;}i:3089;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:3088;}i:3090;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3089;}i:3091;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3087;}i:3092;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3091;}i:3093;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3092;}i:3094;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3092;}i:3095;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3092;}i:3096;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3095;}i:3097;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3095;}i:3098;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3097;}i:3099;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3095;}i:3100;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3099;}i:3101;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3095;}i:3102;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3101;}i:3103;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3095;}i:3104;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3103;}i:3105;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3092;}i:3106;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3092;}i:3107;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3092;}i:3108;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3092;}i:3109;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3092;}i:3110;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3109;}i:3111;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3092;}i:3112;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3111;}i:3113;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3111;}i:3114;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3113;}i:3115;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3111;}i:3116;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3115;}i:3117;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3111;}i:3118;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3117;}i:3119;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3111;}i:3120;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3119;}i:3121;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3092;}i:3122;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3092;}i:3123;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3092;}i:3124;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3092;}i:3125;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3092;}i:3126;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3092;}i:3127;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3092;}i:3128;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3092;}i:3129;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3092;}i:3130;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3129;}i:3131;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3091;}i:3132;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3131;}i:3133;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3091;}i:3134;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3091;}i:3135;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3087;}i:3136;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3135;}i:3137;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3087;}i:3138;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3137;}i:3139;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3138;}i:3140;a:2:{s:5:"class";s:21:"ilobjstylesettingsgui";s:6:"parent";i:1;}i:3141;a:2:{s:5:"class";s:15:"ilpagelayoutgui";s:6:"parent";i:3140;}i:3142;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3141;}i:3143;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3142;}i:3144;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3143;}i:3145;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3143;}i:3146;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3145;}i:3147;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3143;}i:3148;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3141;}i:3149;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3148;}i:3150;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3148;}i:3151;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3150;}i:3152;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3150;}i:3153;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3152;}i:3154;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3150;}i:3155;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3148;}i:3156;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3148;}i:3157;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3148;}i:3158;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3148;}i:3159;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3148;}i:3160;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3148;}i:3161;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3148;}i:3162;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3148;}i:3163;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3162;}i:3164;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3163;}i:3165;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3163;}i:3166;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3165;}i:3167;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3163;}i:3168;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3162;}i:3169;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3168;}i:3170;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3148;}i:3171;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3148;}i:3172;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3171;}i:3173;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3172;}i:3174;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3173;}i:3175;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3173;}i:3176;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3175;}i:3177;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3173;}i:3178;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3172;}i:3179;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3178;}i:3180;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3148;}i:3181;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3148;}i:3182;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3181;}i:3183;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3182;}i:3184;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3182;}i:3185;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3182;}i:3186;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3182;}i:3187;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3182;}i:3188;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3182;}i:3189;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3182;}i:3190;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3182;}i:3191;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3182;}i:3192;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3182;}i:3193;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3148;}i:3194;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3148;}i:3195;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3148;}i:3196;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3148;}i:3197;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3148;}i:3198;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3148;}i:3199;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3141;}i:3200;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3199;}i:3201;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3200;}i:3202;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3201;}i:3203;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3201;}i:3204;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3203;}i:3205;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3201;}i:3206;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3199;}i:3207;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3199;}i:3208;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3199;}i:3209;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3208;}i:3210;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3208;}i:3211;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3210;}i:3212;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3210;}i:3213;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3212;}i:3214;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3210;}i:3215;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3208;}i:3216;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3208;}i:3217;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3208;}i:3218;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3208;}i:3219;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3208;}i:3220;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3208;}i:3221;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3208;}i:3222;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3208;}i:3223;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3222;}i:3224;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3223;}i:3225;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3223;}i:3226;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3225;}i:3227;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3223;}i:3228;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3222;}i:3229;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3228;}i:3230;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3208;}i:3231;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3208;}i:3232;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3231;}i:3233;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3232;}i:3234;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3233;}i:3235;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3233;}i:3236;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3235;}i:3237;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3233;}i:3238;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3232;}i:3239;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3238;}i:3240;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3208;}i:3241;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3208;}i:3242;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3241;}i:3243;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3242;}i:3244;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3242;}i:3245;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3242;}i:3246;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3242;}i:3247;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3242;}i:3248;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3242;}i:3249;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3242;}i:3250;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3242;}i:3251;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3242;}i:3252;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3242;}i:3253;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3208;}i:3254;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3208;}i:3255;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3208;}i:3256;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3208;}i:3257;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3208;}i:3258;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3208;}i:3259;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3199;}i:3260;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3141;}i:3261;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3140;}i:3262;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3261;}i:3263;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3262;}i:3264;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:1;}i:3265;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3264;}i:3266;a:2:{s:5:"class";s:28:"ilobjsurveyadministrationgui";s:6:"parent";i:1;}i:3267;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3266;}i:3268;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3267;}i:3269;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3268;}i:3270;a:2:{s:5:"class";s:14:"ilobjsurveygui";s:6:"parent";i:1;}i:3271;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3270;}i:3272;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3271;}i:3273;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3272;}i:3274;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3272;}i:3275;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3272;}i:3276;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3275;}i:3277;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3275;}i:3278;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3277;}i:3279;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3275;}i:3280;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3279;}i:3281;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3275;}i:3282;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3281;}i:3283;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3275;}i:3284;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3283;}i:3285;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3272;}i:3286;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3272;}i:3287;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3272;}i:3288;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3272;}i:3289;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3272;}i:3290;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3289;}i:3291;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3272;}i:3292;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3291;}i:3293;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3291;}i:3294;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3293;}i:3295;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3291;}i:3296;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3295;}i:3297;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3291;}i:3298;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3297;}i:3299;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3291;}i:3300;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3299;}i:3301;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3272;}i:3302;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3272;}i:3303;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3272;}i:3304;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3272;}i:3305;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3272;}i:3306;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3272;}i:3307;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3272;}i:3308;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3272;}i:3309;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3272;}i:3310;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3309;}i:3311;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3271;}i:3312;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3311;}i:3313;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3271;}i:3314;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3271;}i:3315;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3270;}i:3316;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3270;}i:3317;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3316;}i:3318;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3270;}i:3319;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3318;}i:3320;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3319;}i:3321;a:2:{s:5:"class";s:21:"ilsurveyevaluationgui";s:6:"parent";i:3270;}i:3322;a:2:{s:5:"class";s:20:"ilsurveyexecutiongui";s:6:"parent";i:3270;}i:3323;a:2:{s:5:"class";s:26:"ilobjsurveyquestionpoolgui";s:6:"parent";i:1;}i:3324;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3323;}i:3325;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3323;}i:3326;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3325;}i:3327;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3323;}i:3328;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3327;}i:3329;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3328;}i:3330;a:2:{s:5:"class";s:18:"ilsurveyphrasesgui";s:6:"parent";i:3323;}i:3331;a:2:{s:5:"class";s:23:"surveymatrixquestiongui";s:6:"parent";i:3323;}i:3332;a:2:{s:5:"class";s:23:"surveymetricquestiongui";s:6:"parent";i:3323;}i:3333;a:2:{s:5:"class";s:31:"surveymultiplechoicequestiongui";s:6:"parent";i:3323;}i:3334;a:2:{s:5:"class";s:29:"surveysinglechoicequestiongui";s:6:"parent";i:3323;}i:3335;a:2:{s:5:"class";s:21:"surveytextquestiongui";s:6:"parent";i:3323;}i:3336;a:2:{s:5:"class";s:20:"ilobjsystemfoldergui";s:6:"parent";i:1;}i:3337;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3336;}i:3338;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3337;}i:3339;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3338;}i:3340;a:2:{s:5:"class";s:23:"ilobjtaggingsettingsgui";s:6:"parent";i:1;}i:3341;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3340;}i:3342;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3341;}i:3343;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3342;}i:3344;a:2:{s:5:"class";s:12:"ilobjtestgui";s:6:"parent";i:1;}i:3345;a:2:{s:5:"class";s:16:"ilcertificategui";s:6:"parent";i:3344;}i:3346;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3344;}i:3347;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3346;}i:3348;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3347;}i:3349;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3347;}i:3350;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3347;}i:3351;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3350;}i:3352;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3350;}i:3353;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3352;}i:3354;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3350;}i:3355;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3354;}i:3356;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3350;}i:3357;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3356;}i:3358;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3350;}i:3359;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3358;}i:3360;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3347;}i:3361;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3347;}i:3362;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3347;}i:3363;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3347;}i:3364;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3347;}i:3365;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3364;}i:3366;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3347;}i:3367;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3366;}i:3368;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3366;}i:3369;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3368;}i:3370;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3366;}i:3371;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3370;}i:3372;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3366;}i:3373;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3372;}i:3374;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3366;}i:3375;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3374;}i:3376;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3347;}i:3377;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3347;}i:3378;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3347;}i:3379;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3347;}i:3380;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3347;}i:3381;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3347;}i:3382;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3347;}i:3383;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3347;}i:3384;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3347;}i:3385;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3384;}i:3386;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3346;}i:3387;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3386;}i:3388;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3346;}i:3389;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3346;}i:3390;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3344;}i:3391;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3390;}i:3392;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3390;}i:3393;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3392;}i:3394;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3393;}i:3395;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3392;}i:3396;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3395;}i:3397;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3396;}i:3398;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3396;}i:3399;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3392;}i:3400;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3399;}i:3401;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3392;}i:3402;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3401;}i:3403;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3390;}i:3404;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3403;}i:3405;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3404;}i:3406;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3403;}i:3407;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3406;}i:3408;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3407;}i:3409;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3407;}i:3410;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3403;}i:3411;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3410;}i:3412;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3390;}i:3413;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3412;}i:3414;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3344;}i:3415;a:2:{s:5:"class";s:14:"ilobjcoursegui";s:6:"parent";i:3344;}i:3416;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3415;}i:3417;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3416;}i:3418;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3416;}i:3419;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3416;}i:3420;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3419;}i:3421;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3419;}i:3422;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3421;}i:3423;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3419;}i:3424;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3423;}i:3425;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3419;}i:3426;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3425;}i:3427;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3419;}i:3428;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3427;}i:3429;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3416;}i:3430;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3416;}i:3431;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3416;}i:3432;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3416;}i:3433;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3416;}i:3434;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3433;}i:3435;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3416;}i:3436;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3435;}i:3437;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3435;}i:3438;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3437;}i:3439;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3435;}i:3440;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3439;}i:3441;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3435;}i:3442;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3441;}i:3443;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3435;}i:3444;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3443;}i:3445;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3416;}i:3446;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3416;}i:3447;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3416;}i:3448;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3416;}i:3449;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3416;}i:3450;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3416;}i:3451;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3416;}i:3452;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3416;}i:3453;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3416;}i:3454;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3453;}i:3455;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:3415;}i:3456;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3455;}i:3457;a:2:{s:5:"class";s:20:"ilcourseagreementgui";s:6:"parent";i:3415;}i:3458;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3457;}i:3459;a:2:{s:5:"class";s:18:"ilcoursecontentgui";s:6:"parent";i:3415;}i:3460;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3459;}i:3461;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3460;}i:3462;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3460;}i:3463;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3460;}i:3464;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3463;}i:3465;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3463;}i:3466;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3465;}i:3467;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3463;}i:3468;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3467;}i:3469;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3463;}i:3470;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3469;}i:3471;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3463;}i:3472;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3471;}i:3473;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3460;}i:3474;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3460;}i:3475;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3460;}i:3476;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3460;}i:3477;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3460;}i:3478;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3477;}i:3479;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3460;}i:3480;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3479;}i:3481;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3479;}i:3482;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3481;}i:3483;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3479;}i:3484;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3483;}i:3485;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3479;}i:3486;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3485;}i:3487;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3479;}i:3488;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3487;}i:3489;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3460;}i:3490;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3460;}i:3491;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3460;}i:3492;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3460;}i:3493;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3460;}i:3494;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3460;}i:3495;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3460;}i:3496;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3460;}i:3497;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3460;}i:3498;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3497;}i:3499;a:2:{s:5:"class";s:19:"ilcoursearchivesgui";s:6:"parent";i:3459;}i:3500;a:2:{s:5:"class";s:32:"ilcourseobjectivepresentationgui";s:6:"parent";i:3459;}i:3501;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3500;}i:3502;a:2:{s:5:"class";s:29:"ilcourseitemadministrationgui";s:6:"parent";i:3415;}i:3503;a:2:{s:5:"class";s:27:"ilconditionhandlerinterface";s:6:"parent";i:3502;}i:3504;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3503;}i:3505;a:2:{s:5:"class";s:21:"ilcourseobjectivesgui";s:6:"parent";i:3415;}i:3506;a:2:{s:5:"class";s:23:"ilcourseregistrationgui";s:6:"parent";i:3415;}i:3507;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3506;}i:3508;a:2:{s:5:"class";s:21:"ilcourseuserfieldsgui";s:6:"parent";i:3415;}i:3509;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3415;}i:3510;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3509;}i:3511;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3510;}i:3512;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3510;}i:3513;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3510;}i:3514;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3513;}i:3515;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3513;}i:3516;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3515;}i:3517;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3513;}i:3518;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3517;}i:3519;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3513;}i:3520;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3519;}i:3521;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3513;}i:3522;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3521;}i:3523;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3510;}i:3524;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3510;}i:3525;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3510;}i:3526;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3510;}i:3527;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3510;}i:3528;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3527;}i:3529;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3510;}i:3530;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3529;}i:3531;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3529;}i:3532;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3531;}i:3533;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3529;}i:3534;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3533;}i:3535;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3529;}i:3536;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3535;}i:3537;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3529;}i:3538;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3537;}i:3539;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3510;}i:3540;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3510;}i:3541;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3510;}i:3542;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3510;}i:3543;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3510;}i:3544;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3510;}i:3545;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3510;}i:3546;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3510;}i:3547;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3510;}i:3548;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3547;}i:3549;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3509;}i:3550;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3549;}i:3551;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3509;}i:3552;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3509;}i:3553;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3415;}i:3554;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3553;}i:3555;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3553;}i:3556;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3555;}i:3557;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3556;}i:3558;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3555;}i:3559;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3558;}i:3560;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3559;}i:3561;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3559;}i:3562;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3555;}i:3563;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3562;}i:3564;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3555;}i:3565;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3564;}i:3566;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3553;}i:3567;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3566;}i:3568;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3567;}i:3569;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3566;}i:3570;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3569;}i:3571;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3570;}i:3572;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3570;}i:3573;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3566;}i:3574;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3573;}i:3575;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3553;}i:3576;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3575;}i:3577;a:2:{s:5:"class";s:20:"illicenseoverviewgui";s:6:"parent";i:3415;}i:3578;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3577;}i:3579;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3415;}i:3580;a:2:{s:5:"class";s:17:"ilmemberexportgui";s:6:"parent";i:3415;}i:3581;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3580;}i:3582;a:2:{s:5:"class";s:22:"ilobjcoursegroupinggui";s:6:"parent";i:3415;}i:3583;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3415;}i:3584;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3583;}i:3585;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:3415;}i:3586;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3585;}i:3587;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3415;}i:3588;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3587;}i:3589;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3588;}i:3590;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3589;}i:3591;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3589;}i:3592;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3591;}i:3593;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3589;}i:3594;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3587;}i:3595;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3587;}i:3596;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3587;}i:3597;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3596;}i:3598;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3596;}i:3599;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3598;}i:3600;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3598;}i:3601;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3600;}i:3602;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3598;}i:3603;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3596;}i:3604;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3596;}i:3605;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3596;}i:3606;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3596;}i:3607;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3596;}i:3608;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3596;}i:3609;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3596;}i:3610;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3596;}i:3611;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3610;}i:3612;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3611;}i:3613;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3611;}i:3614;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3613;}i:3615;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3611;}i:3616;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3610;}i:3617;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3616;}i:3618;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3596;}i:3619;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3596;}i:3620;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3619;}i:3621;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3620;}i:3622;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3621;}i:3623;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3621;}i:3624;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3623;}i:3625;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3621;}i:3626;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3620;}i:3627;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3626;}i:3628;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3596;}i:3629;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3596;}i:3630;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3629;}i:3631;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3630;}i:3632;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3630;}i:3633;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3630;}i:3634;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3630;}i:3635;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3630;}i:3636;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3630;}i:3637;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3630;}i:3638;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3630;}i:3639;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3630;}i:3640;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3630;}i:3641;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3596;}i:3642;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3596;}i:3643;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3596;}i:3644;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3596;}i:3645;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3596;}i:3646;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3596;}i:3647;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3587;}i:3648;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3415;}i:3649;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3648;}i:3650;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3649;}i:3651;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3415;}i:3652;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3415;}i:3653;a:2:{s:5:"class";s:20:"ilsessionoverviewgui";s:6:"parent";i:3415;}i:3654;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:3415;}i:3655;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3654;}i:3656;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3655;}i:3657;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3656;}i:3658;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3657;}i:3659;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3657;}i:3660;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3659;}i:3661;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3657;}i:3662;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3655;}i:3663;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3655;}i:3664;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3655;}i:3665;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3664;}i:3666;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3664;}i:3667;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3666;}i:3668;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3666;}i:3669;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3668;}i:3670;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3666;}i:3671;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3664;}i:3672;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3664;}i:3673;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3664;}i:3674;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3664;}i:3675;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3664;}i:3676;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3664;}i:3677;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3664;}i:3678;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3664;}i:3679;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3678;}i:3680;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3679;}i:3681;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3679;}i:3682;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3681;}i:3683;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3679;}i:3684;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3678;}i:3685;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3684;}i:3686;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3664;}i:3687;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3664;}i:3688;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3687;}i:3689;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3688;}i:3690;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3689;}i:3691;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3689;}i:3692;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3691;}i:3693;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3689;}i:3694;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3688;}i:3695;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3694;}i:3696;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3664;}i:3697;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3664;}i:3698;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3697;}i:3699;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3698;}i:3700;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3698;}i:3701;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3698;}i:3702;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3698;}i:3703;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3698;}i:3704;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3698;}i:3705;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3698;}i:3706;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3698;}i:3707;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3698;}i:3708;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3698;}i:3709;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3664;}i:3710;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3664;}i:3711;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3664;}i:3712;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3664;}i:3713;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3664;}i:3714;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3664;}i:3715;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3655;}i:3716;a:2:{s:5:"class";s:15:"ilobjectcopygui";s:6:"parent";i:3344;}i:3717;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3716;}i:3718;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3344;}i:3719;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3718;}i:3720;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3719;}i:3721;a:2:{s:5:"class";s:17:"ilshoppurchasegui";s:6:"parent";i:3344;}i:3722;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3721;}i:3723;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3722;}i:3724;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3723;}i:3725;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3724;}i:3726;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3724;}i:3727;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3726;}i:3728;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3724;}i:3729;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3722;}i:3730;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3722;}i:3731;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3722;}i:3732;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3731;}i:3733;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3731;}i:3734;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3733;}i:3735;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3733;}i:3736;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3735;}i:3737;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3733;}i:3738;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3731;}i:3739;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3731;}i:3740;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3731;}i:3741;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3731;}i:3742;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3731;}i:3743;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3731;}i:3744;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3731;}i:3745;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3731;}i:3746;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3745;}i:3747;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3746;}i:3748;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3746;}i:3749;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3748;}i:3750;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3746;}i:3751;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3745;}i:3752;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3751;}i:3753;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3731;}i:3754;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3731;}i:3755;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3754;}i:3756;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3755;}i:3757;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3756;}i:3758;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3756;}i:3759;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3758;}i:3760;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3756;}i:3761;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3755;}i:3762;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3761;}i:3763;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3731;}i:3764;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3731;}i:3765;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3764;}i:3766;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3765;}i:3767;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3765;}i:3768;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3765;}i:3769;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3765;}i:3770;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3765;}i:3771;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3765;}i:3772;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3765;}i:3773;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3765;}i:3774;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3765;}i:3775;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3765;}i:3776;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3731;}i:3777;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3731;}i:3778;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3731;}i:3779;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3731;}i:3780;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3731;}i:3781;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3731;}i:3782;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3722;}i:3783;a:2:{s:5:"class";s:19:"iltestevaluationgui";s:6:"parent";i:3344;}i:3784;a:2:{s:5:"class";s:15:"iltestoutputgui";s:6:"parent";i:3344;}i:3785;a:2:{s:5:"class";s:16:"iltestscoringgui";s:6:"parent";i:3344;}i:3786;a:2:{s:5:"class";s:16:"iltestservicegui";s:6:"parent";i:3344;}i:3787;a:2:{s:5:"class";s:18:"ilobjuserfoldergui";s:6:"parent";i:1;}i:3788;a:2:{s:5:"class";s:20:"iladminusersearchgui";s:6:"parent";i:3787;}i:3789;a:2:{s:5:"class";s:12:"ilobjusergui";s:6:"parent";i:3788;}i:3790;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3789;}i:3791;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3790;}i:3792;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3790;}i:3793;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3792;}i:3794;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3793;}i:3795;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3792;}i:3796;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3795;}i:3797;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3796;}i:3798;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3796;}i:3799;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3792;}i:3800;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3799;}i:3801;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3792;}i:3802;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3801;}i:3803;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3790;}i:3804;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3803;}i:3805;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3804;}i:3806;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3803;}i:3807;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3806;}i:3808;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3807;}i:3809;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3807;}i:3810;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3803;}i:3811;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3810;}i:3812;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3790;}i:3813;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3812;}i:3814;a:2:{s:5:"class";s:17:"ilobjilincusergui";s:6:"parent";i:3789;}i:3815;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3787;}i:3816;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3815;}i:3817;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3816;}i:3818;a:2:{s:5:"class";s:14:"ilusertablegui";s:6:"parent";i:3787;}i:3819;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3818;}i:3820;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3819;}i:3821;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3819;}i:3822;a:2:{s:5:"class";s:12:"ilobjusergui";s:6:"parent";i:1;}i:3823;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3822;}i:3824;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3823;}i:3825;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3823;}i:3826;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3825;}i:3827;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3826;}i:3828;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3825;}i:3829;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3828;}i:3830;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3829;}i:3831;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3829;}i:3832;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3825;}i:3833;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3832;}i:3834;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3825;}i:3835;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3834;}i:3836;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3823;}i:3837;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3836;}i:3838;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3837;}i:3839;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3836;}i:3840;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3839;}i:3841;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3840;}i:3842;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3840;}i:3843;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3836;}i:3844;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3843;}i:3845;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3823;}i:3846;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3845;}i:3847;a:2:{s:5:"class";s:17:"ilobjilincusergui";s:6:"parent";i:3822;}i:3848;a:2:{s:5:"class";s:20:"ilobjusertrackinggui";s:6:"parent";i:1;}i:3849;a:2:{s:5:"class";s:21:"illearningprogressgui";s:6:"parent";i:3848;}i:3850;a:2:{s:5:"class";s:17:"illmstatisticsgui";s:6:"parent";i:3849;}i:3851;a:2:{s:5:"class";s:20:"illplistofobjectsgui";s:6:"parent";i:3849;}i:3852;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3851;}i:3853;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3852;}i:3854;a:2:{s:5:"class";s:19:"illpobjectstablegui";s:6:"parent";i:3851;}i:3855;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3854;}i:3856;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3855;}i:3857;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3855;}i:3858;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3851;}i:3859;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3858;}i:3860;a:2:{s:5:"class";s:15:"iluserfiltergui";s:6:"parent";i:3851;}i:3861;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3860;}i:3862;a:2:{s:5:"class";s:21:"illplistofprogressgui";s:6:"parent";i:3849;}i:3863;a:2:{s:5:"class";s:13:"illpfiltergui";s:6:"parent";i:3862;}i:3864;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3863;}i:3865;a:2:{s:5:"class";s:20:"illpprogresstablegui";s:6:"parent";i:3862;}i:3866;a:2:{s:5:"class";s:25:"ilformpropertydispatchgui";s:6:"parent";i:3865;}i:3867;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3866;}i:3868;a:2:{s:5:"class";s:28:"ilrepositoryselectorinputgui";s:6:"parent";i:3866;}i:3869;a:2:{s:5:"class";s:17:"ilpdfpresentation";s:6:"parent";i:3862;}i:3870;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3869;}i:3871;a:2:{s:5:"class";s:21:"illplistofsettingsgui";s:6:"parent";i:3849;}i:3872;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3871;}i:3873;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3848;}i:3874;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3873;}i:3875;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3874;}i:3876;a:2:{s:5:"class";s:12:"ilobjwikigui";s:6:"parent";i:1;}i:3877;a:2:{s:5:"class";s:15:"ilinfoscreengui";s:6:"parent";i:3876;}i:3878;a:2:{s:5:"class";s:11:"ilcolumngui";s:6:"parent";i:3877;}i:3879;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3878;}i:3880;a:2:{s:5:"class";s:18:"ilbookmarkblockgui";s:6:"parent";i:3878;}i:3881;a:2:{s:5:"class";s:18:"ilcalendarblockgui";s:6:"parent";i:3878;}i:3882;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3881;}i:3883;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3881;}i:3884;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3883;}i:3885;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3881;}i:3886;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3885;}i:3887;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3881;}i:3888;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3887;}i:3889;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3881;}i:3890;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3889;}i:3891;a:2:{s:5:"class";s:14:"ilchatblockgui";s:6:"parent";i:3878;}i:3892;a:2:{s:5:"class";s:15:"ildummyblockgui";s:6:"parent";i:3878;}i:3893;a:2:{s:5:"class";s:22:"ilexternalfeedblockgui";s:6:"parent";i:3878;}i:3894;a:2:{s:5:"class";s:14:"ilhtmlblockgui";s:6:"parent";i:3878;}i:3895;a:2:{s:5:"class";s:24:"ilnewsforcontextblockgui";s:6:"parent";i:3878;}i:3896;a:2:{s:5:"class";s:13:"ilnewsitemgui";s:6:"parent";i:3895;}i:3897;a:2:{s:5:"class";s:20:"ilpdcalendarblockgui";s:6:"parent";i:3878;}i:3898;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3897;}i:3899;a:2:{s:5:"class";s:16:"ilcalendardaygui";s:6:"parent";i:3897;}i:3900;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3899;}i:3901;a:2:{s:5:"class";s:18:"ilcalendarinboxgui";s:6:"parent";i:3897;}i:3902;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3901;}i:3903;a:2:{s:5:"class";s:18:"ilcalendarmonthgui";s:6:"parent";i:3897;}i:3904;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3903;}i:3905;a:2:{s:5:"class";s:17:"ilcalendarweekgui";s:6:"parent";i:3897;}i:3906;a:2:{s:5:"class";s:24:"ilcalendarappointmentgui";s:6:"parent";i:3905;}i:3907;a:2:{s:5:"class";s:24:"ilpdexternalfeedblockgui";s:6:"parent";i:3878;}i:3908;a:2:{s:5:"class";s:20:"ilpdfeedbackblockgui";s:6:"parent";i:3878;}i:3909;a:2:{s:5:"class";s:16:"ilpdmailblockgui";s:6:"parent";i:3878;}i:3910;a:2:{s:5:"class";s:16:"ilpdnewsblockgui";s:6:"parent";i:3878;}i:3911;a:2:{s:5:"class";s:17:"ilpdnotesblockgui";s:6:"parent";i:3878;}i:3912;a:2:{s:5:"class";s:25:"ilpdselecteditemsblockgui";s:6:"parent";i:3878;}i:3913;a:2:{s:5:"class";s:22:"ilpdsysmessageblockgui";s:6:"parent";i:3878;}i:3914;a:2:{s:5:"class";s:19:"ilpdtaggingblockgui";s:6:"parent";i:3878;}i:3915;a:2:{s:5:"class";s:21:"ilusersonlineblockgui";s:6:"parent";i:3878;}i:3916;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3915;}i:3917;a:2:{s:5:"class";s:13:"ilfeedbackgui";s:6:"parent";i:3877;}i:3918;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3917;}i:3919;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3877;}i:3920;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3877;}i:3921;a:2:{s:5:"class";s:18:"ilobjstylesheetgui";s:6:"parent";i:3876;}i:3922;a:2:{s:5:"class";s:0:"";s:6:"parent";i:3921;}i:3923;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:3876;}i:3924;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:3923;}i:3925;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:3924;}i:3926;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3876;}i:3927;a:2:{s:5:"class";s:13:"ilwikipagegui";s:6:"parent";i:3876;}i:3928;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3927;}i:3929;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3928;}i:3930;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3929;}i:3931;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3929;}i:3932;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3931;}i:3933;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3929;}i:3934;a:2:{s:5:"class";s:25:"ilmediapooltargetselector";s:6:"parent";i:3927;}i:3935;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3927;}i:3936;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3927;}i:3937;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3936;}i:3938;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3936;}i:3939;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3938;}i:3940;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3938;}i:3941;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3940;}i:3942;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3938;}i:3943;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3936;}i:3944;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3936;}i:3945;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3936;}i:3946;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3936;}i:3947;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3936;}i:3948;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3936;}i:3949;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3936;}i:3950;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3936;}i:3951;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3950;}i:3952;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3951;}i:3953;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3951;}i:3954;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3953;}i:3955;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3951;}i:3956;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3950;}i:3957;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3956;}i:3958;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3936;}i:3959;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3936;}i:3960;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3959;}i:3961;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3960;}i:3962;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3961;}i:3963;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3961;}i:3964;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3963;}i:3965;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3961;}i:3966;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:3960;}i:3967;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3966;}i:3968;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3936;}i:3969;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3936;}i:3970;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:3969;}i:3971;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:3970;}i:3972;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:3970;}i:3973;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:3970;}i:3974;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:3970;}i:3975;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:3970;}i:3976;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:3970;}i:3977;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:3970;}i:3978;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:3970;}i:3979;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:3970;}i:3980;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:3970;}i:3981;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3936;}i:3982;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3936;}i:3983;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3936;}i:3984;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3936;}i:3985;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3936;}i:3986;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3936;}i:3987;a:2:{s:5:"class";s:15:"ilpageobjectgui";s:6:"parent";i:3927;}i:3988;a:2:{s:5:"class";s:18:"ileditclipboardgui";s:6:"parent";i:3987;}i:3989;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3988;}i:3990;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3989;}i:3991;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3989;}i:3992;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3991;}i:3993;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3989;}i:3994;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3987;}i:3995;a:2:{s:5:"class";s:9:"ilnotegui";s:6:"parent";i:3987;}i:3996;a:2:{s:5:"class";s:15:"ilpageeditorgui";s:6:"parent";i:3987;}i:3997;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:3996;}i:3998;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:3996;}i:3999;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:3998;}i:4000;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:3998;}i:4001;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:4000;}i:4002;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:3998;}i:4003;a:2:{s:5:"class";s:21:"ilpccontentincludegui";s:6:"parent";i:3996;}i:4004;a:2:{s:5:"class";s:16:"ilpcdatatablegui";s:6:"parent";i:3996;}i:4005;a:2:{s:5:"class";s:15:"ilpcfileitemgui";s:6:"parent";i:3996;}i:4006;a:2:{s:5:"class";s:15:"ilpcfilelistgui";s:6:"parent";i:3996;}i:4007;a:2:{s:5:"class";s:11:"ilpclistgui";s:6:"parent";i:3996;}i:4008;a:2:{s:5:"class";s:15:"ilpclistitemgui";s:6:"parent";i:3996;}i:4009;a:2:{s:5:"class";s:10:"ilpcmapgui";s:6:"parent";i:3996;}i:4010;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:3996;}i:4011;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:4010;}i:4012;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:4011;}i:4013;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:4011;}i:4014;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:4013;}i:4015;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:4011;}i:4016;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:4010;}i:4017;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:4016;}i:4018;a:2:{s:5:"class";s:16:"ilpcparagraphgui";s:6:"parent";i:3996;}i:4019;a:2:{s:5:"class";s:18:"ilpcplaceholdergui";s:6:"parent";i:3996;}i:4020;a:2:{s:5:"class";s:18:"ilpcmediaobjectgui";s:6:"parent";i:4019;}i:4021;a:2:{s:5:"class";s:19:"ilobjmediaobjectgui";s:6:"parent";i:4020;}i:4022;a:2:{s:5:"class";s:15:"ilfilesystemgui";s:6:"parent";i:4021;}i:4023;a:2:{s:5:"class";s:19:"ilimagemapeditorgui";s:6:"parent";i:4021;}i:4024;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:4023;}i:4025;a:2:{s:5:"class";s:13:"ilmdeditorgui";s:6:"parent";i:4021;}i:4026;a:2:{s:5:"class";s:21:"ilpcimagemapeditorgui";s:6:"parent";i:4020;}i:4027;a:2:{s:5:"class";s:17:"ilinternallinkgui";s:6:"parent";i:4026;}i:4028;a:2:{s:5:"class";s:14:"ilpcpluggedgui";s:6:"parent";i:3996;}i:4029;a:2:{s:5:"class";s:15:"ilpcquestiongui";s:6:"parent";i:3996;}i:4030;a:2:{s:5:"class";s:17:"ilquestioneditgui";s:6:"parent";i:4029;}i:4031;a:2:{s:5:"class";s:15:"assclozetestgui";s:6:"parent";i:4030;}i:4032;a:2:{s:5:"class";s:22:"assimagemapquestiongui";s:6:"parent";i:4030;}i:4033;a:2:{s:5:"class";s:16:"assjavaappletgui";s:6:"parent";i:4030;}i:4034;a:2:{s:5:"class";s:22:"assmatchingquestiongui";s:6:"parent";i:4030;}i:4035;a:2:{s:5:"class";s:20:"assmultiplechoicegui";s:6:"parent";i:4030;}i:4036;a:2:{s:5:"class";s:13:"assnumericgui";s:6:"parent";i:4030;}i:4037;a:2:{s:5:"class";s:22:"assorderingquestiongui";s:6:"parent";i:4030;}i:4038;a:2:{s:5:"class";s:18:"asssinglechoicegui";s:6:"parent";i:4030;}i:4039;a:2:{s:5:"class";s:18:"asstextquestiongui";s:6:"parent";i:4030;}i:4040;a:2:{s:5:"class";s:16:"asstextsubsetgui";s:6:"parent";i:4030;}i:4041;a:2:{s:5:"class";s:16:"ilpcresourcesgui";s:6:"parent";i:3996;}i:4042;a:2:{s:5:"class";s:14:"ilpcsectiongui";s:6:"parent";i:3996;}i:4043;a:2:{s:5:"class";s:17:"ilpcsourcecodegui";s:6:"parent";i:3996;}i:4044;a:2:{s:5:"class";s:16:"ilpctabledatagui";s:6:"parent";i:3996;}i:4045;a:2:{s:5:"class";s:12:"ilpctablegui";s:6:"parent";i:3996;}i:4046;a:2:{s:5:"class";s:11:"ilpctabsgui";s:6:"parent";i:3996;}i:4047;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3987;}i:4048;a:2:{s:5:"class";s:22:"ilpublicuserprofilegui";s:6:"parent";i:3927;}i:4049;a:2:{s:5:"class";s:11:"ilratinggui";s:6:"parent";i:3927;}i:4050;a:2:{s:5:"class";s:15:"ilpermissiongui";s:6:"parent";i:1;}i:4051;a:2:{s:5:"class";s:12:"ilobjrolegui";s:6:"parent";i:4050;}i:4052;a:2:{s:5:"class";s:21:"ilrepositorysearchgui";s:6:"parent";i:4051;}}'), 'forward' => array('clob', 'a:100:{s:12:"ilobjrolegui";a:1:{i:0;s:21:"ilrepositorysearchgui";}s:15:"ilpermissiongui";a:1:{i:0;s:12:"ilobjrolegui";}s:29:"ilobjaccessibilitysettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:23:"ilobjadvancededitinggui";a:1:{i:0;s:15:"ilpermissiongui";}s:24:"ilobjassessmentfoldergui";a:1:{i:0;s:15:"ilpermissiongui";}s:20:"ilobjauthsettingsgui";a:5:{i:0;s:27:"ilauthshibbolethsettingsgui";i:1;s:17:"illdapsettingsgui";i:2;s:15:"ilpermissiongui";i:3;s:19:"ilradiussettingsgui";i:4;s:25:"ilregistrationsettingsgui";}s:24:"ilobjcalendarsettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:16:"ilcalendardaygui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarinboxgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarmonthgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:17:"ilcalendarweekgui";a:1:{i:0;s:24:"ilcalendarappointmentgui";}s:18:"ilcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:13:"ilnewsitemgui";}s:20:"ilpdcalendarblockgui";a:5:{i:0;s:24:"ilcalendarappointmentgui";i:1;s:16:"ilcalendardaygui";i:2;s:18:"ilcalendarinboxgui";i:3;s:18:"ilcalendarmonthgui";i:4;s:17:"ilcalendarweekgui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:22:"ilpublicuserprofilegui";}s:11:"ilcolumngui";a:17:{i:0;s:18:"ilbookmarkblockgui";i:1;s:18:"ilcalendarblockgui";i:2;s:14:"ilchatblockgui";i:3;s:15:"ildummyblockgui";i:4;s:22:"ilexternalfeedblockgui";i:5;s:14:"ilhtmlblockgui";i:6;s:24:"ilnewsforcontextblockgui";i:7;s:20:"ilpdcalendarblockgui";i:8;s:24:"ilpdexternalfeedblockgui";i:9;s:20:"ilpdfeedbackblockgui";i:10;s:16:"ilpdmailblockgui";i:11;s:16:"ilpdnewsblockgui";i:12;s:17:"ilpdnotesblockgui";i:13;s:25:"ilpdselecteditemsblockgui";i:14;s:22:"ilpdsysmessageblockgui";i:15;s:19:"ilpdtaggingblockgui";i:16;s:21:"ilusersonlineblockgui";}s:15:"ilinfoscreengui";a:4:{i:0;s:11:"ilcolumngui";i:1;s:13:"ilfeedbackgui";i:2;s:9:"ilnotegui";i:3;s:22:"ilpublicuserprofilegui";}s:25:"ilformpropertydispatchgui";a:1:{i:0;s:28:"ilrepositoryselectorinputgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:20:"illplistofobjectsgui";a:4:{i:0;s:13:"illpfiltergui";i:1;s:19:"illpobjectstablegui";i:2;s:17:"ilpdfpresentation";i:3;s:15:"iluserfiltergui";}s:20:"illpprogresstablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:21:"illplistofprogressgui";a:3:{i:0;s:13:"illpfiltergui";i:1;s:20:"illpprogresstablegui";i:2;s:17:"ilpdfpresentation";}s:21:"illearningprogressgui";a:4:{i:0;s:17:"illmstatisticsgui";i:1;s:20:"illplistofobjectsgui";i:2;s:21:"illplistofprogressgui";i:3;s:21:"illplistofsettingsgui";}s:12:"ilobjusergui";a:2:{i:0;s:21:"illearningprogressgui";i:1;s:17:"ilobjilincusergui";}s:20:"iladminusersearchgui";a:1:{i:0;s:12:"ilobjusergui";}s:14:"ilusertablegui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:18:"ilobjuserfoldergui";a:3:{i:0;s:20:"iladminusersearchgui";i:1;s:15:"ilpermissiongui";i:2;s:14:"ilusertablegui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:19:"ilobjmediaobjectgui";a:3:{i:0;s:15:"ilfilesystemgui";i:1;s:19:"ilimagemapeditorgui";i:2;s:13:"ilmdeditorgui";}s:18:"ileditclipboardgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:17:"ilinternallinkgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:21:"ilpcimagemapeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:17:"ilquestioneditgui";a:10:{i:0;s:15:"assclozetestgui";i:1;s:22:"assimagemapquestiongui";i:2;s:16:"assjavaappletgui";i:3;s:22:"assmatchingquestiongui";i:4;s:20:"assmultiplechoicegui";i:5;s:13:"assnumericgui";i:6;s:22:"assorderingquestiongui";i:7;s:18:"asssinglechoicegui";i:8;s:18:"asstextquestiongui";i:9;s:16:"asstextsubsetgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:17:"ilquestioneditgui";}s:15:"ilpageeditorgui";a:20:{i:0;s:17:"ilinternallinkgui";i:1;s:19:"ilobjmediaobjectgui";i:2;s:21:"ilpccontentincludegui";i:3;s:16:"ilpcdatatablegui";i:4;s:15:"ilpcfileitemgui";i:5;s:15:"ilpcfilelistgui";i:6;s:11:"ilpclistgui";i:7;s:15:"ilpclistitemgui";i:8;s:10:"ilpcmapgui";i:9;s:18:"ilpcmediaobjectgui";i:10;s:16:"ilpcparagraphgui";i:11;s:18:"ilpcplaceholdergui";i:12;s:14:"ilpcpluggedgui";i:13;s:15:"ilpcquestiongui";i:14;s:16:"ilpcresourcesgui";i:15;s:14:"ilpcsectiongui";i:16;s:17:"ilpcsourcecodegui";i:17;s:16:"ilpctabledatagui";i:18;s:12:"ilpctablegui";i:19;s:11:"ilpctabsgui";}s:15:"ilpageobjectgui";a:5:{i:0;s:18:"ileditclipboardgui";i:1;s:13:"ilmdeditorgui";i:2;s:9:"ilnotegui";i:3;s:15:"ilpageeditorgui";i:4;s:22:"ilpublicuserprofilegui";}s:16:"ilobjcategorygui";a:9:{i:0;s:11:"ilcolumngui";i:1;s:22:"ilcontainerlinklistgui";i:2;s:15:"ilinfoscreengui";i:3;s:15:"ilobjectcopygui";i:4;s:18:"ilobjstylesheetgui";i:5;s:18:"ilobjuserfoldergui";i:6;s:12:"ilobjusergui";i:7;s:15:"ilpageobjectgui";i:8;s:15:"ilpermissiongui";}s:25:"ilobjcategoryreferencegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:27:"ilobjcertificatesettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:12:"ilobjchatgui";a:4:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilobjectcopygui";i:2;s:15:"ilpermissiongui";i:3;s:22:"ilpublicuserprofilegui";}s:18:"ilobjchatservergui";a:1:{i:0;s:15:"ilpermissiongui";}s:25:"ilobjcomponentsettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:18:"ilcoursecontentgui";a:3:{i:0;s:11:"ilcolumngui";i:1;s:19:"ilcoursearchivesgui";i:2;s:32:"ilcourseobjectivepresentationgui";}s:29:"ilcourseitemadministrationgui";a:1:{i:0;s:27:"ilconditionhandlerinterface";}s:17:"ilshoppurchasegui";a:1:{i:0;s:15:"ilpageobjectgui";}s:14:"ilobjcoursegui";a:22:{i:0;s:11:"ilcolumngui";i:1;s:27:"ilconditionhandlerinterface";i:2;s:20:"ilcourseagreementgui";i:3;s:18:"ilcoursecontentgui";i:4;s:29:"ilcourseitemadministrationgui";i:5;s:21:"ilcourseobjectivesgui";i:6;s:23:"ilcourseregistrationgui";i:7;s:21:"ilcourseuserfieldsgui";i:8;s:15:"ilinfoscreengui";i:9;s:21:"illearningprogressgui";i:10;s:20:"illicenseoverviewgui";i:11;s:13:"ilmdeditorgui";i:12;s:17:"ilmemberexportgui";i:13;s:22:"ilobjcoursegroupinggui";i:14;s:15:"ilobjectcopygui";i:15;s:18:"ilobjstylesheetgui";i:16;s:15:"ilpageobjectgui";i:17;s:15:"ilpermissiongui";i:18;s:22:"ilpublicuserprofilegui";i:19;s:21:"ilrepositorysearchgui";i:20;s:20:"ilsessionoverviewgui";i:21;s:17:"ilshoppurchasegui";}s:23:"ilobjcoursereferencegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:17:"illmpageobjectgui";a:1:{i:0;s:15:"ilpageobjectgui";}s:20:"ilstructureobjectgui";a:2:{i:0;s:27:"ilconditionhandlerinterface";i:1;s:13:"ilmdeditorgui";}s:14:"ilobjdlbookgui";a:7:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:17:"illmpageobjectgui";i:3;s:13:"ilmdeditorgui";i:4;s:18:"ilobjstylesheetgui";i:5;s:15:"ilpermissiongui";i:6;s:20:"ilstructureobjectgui";}s:16:"ilobjexercisegui";a:5:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";i:4;s:21:"ilrepositorysearchgui";}s:20:"ilobjexternalfeedgui";a:2:{i:0;s:22:"ilexternalfeedblockgui";i:1;s:15:"ilpermissiongui";}s:29:"ilobjexternaltoolssettingsgui";a:2:{i:0;s:16:"ilecssettingsgui";i:1;s:15:"ilpermissiongui";}s:26:"ilobjfileaccesssettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:19:"ilobjfilebasedlmgui";a:7:{i:0;s:15:"ilfilesystemgui";i:1;s:15:"ilinfoscreengui";i:2;s:21:"illearningprogressgui";i:3;s:12:"illicensegui";i:4;s:13:"ilmdeditorgui";i:5;s:15:"ilpermissiongui";i:6;s:17:"ilshoppurchasegui";}s:12:"ilobjfilegui";a:5:{i:0;s:15:"ilinfoscreengui";i:1;s:13:"ilmdeditorgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";i:4;s:17:"ilshoppurchasegui";}s:14:"ilobjfoldergui";a:10:{i:0;s:11:"ilcolumngui";i:1;s:27:"ilconditionhandlerinterface";i:2;s:18:"ilcoursecontentgui";i:3;s:29:"ilcourseitemadministrationgui";i:4;s:15:"ilinfoscreengui";i:5;s:21:"illearningprogressgui";i:6;s:15:"ilobjectcopygui";i:7;s:18:"ilobjstylesheetgui";i:8;s:15:"ilpageobjectgui";i:9;s:15:"ilpermissiongui";}s:13:"ilobjforumgui";a:7:{i:0;s:11:"ilcolumngui";i:1;s:16:"ilforumexportgui";i:2;s:20:"ilforummoderatorsgui";i:3;s:15:"ilinfoscreengui";i:4;s:15:"ilobjectcopygui";i:5;s:15:"ilpermissiongui";i:6;s:22:"ilpublicuserprofilegui";}s:25:"iltermdefinitioneditorgui";a:2:{i:0;s:13:"ilmdeditorgui";i:1;s:15:"ilpageobjectgui";}s:17:"ilglossarytermgui";a:2:{i:0;s:15:"ilpageobjectgui";i:1;s:25:"iltermdefinitioneditorgui";}s:16:"ilobjglossarygui";a:4:{i:0;s:17:"ilglossarytermgui";i:1;s:15:"ilinfoscreengui";i:2;s:13:"ilmdeditorgui";i:3;s:15:"ilpermissiongui";}s:13:"ilobjgroupgui";a:14:{i:0;s:11:"ilcolumngui";i:1;s:27:"ilconditionhandlerinterface";i:2;s:18:"ilcoursecontentgui";i:3;s:29:"ilcourseitemadministrationgui";i:4;s:22:"ilgroupregistrationgui";i:5;s:15:"ilinfoscreengui";i:6;s:21:"illearningprogressgui";i:7;s:22:"ilobjcoursegroupinggui";i:8;s:15:"ilobjectcopygui";i:9;s:18:"ilobjstylesheetgui";i:10;s:15:"ilpageobjectgui";i:11;s:15:"ilpermissiongui";i:12;s:22:"ilpublicuserprofilegui";i:13;s:21:"ilrepositorysearchgui";}s:19:"ilobjilinccoursegui";a:6:{i:0;s:11:"ilcolumngui";i:1;s:15:"ilinfoscreengui";i:2;s:22:"ilobjilincclassroomgui";i:3;s:15:"ilpermissiongui";i:4;s:22:"ilpublicuserprofilegui";i:5;s:21:"ilrepositorysearchgui";}s:22:"ilobjlanguagefoldergui";a:1:{i:0;s:15:"ilpermissiongui";}s:22:"ilobjlearningmodulegui";a:7:{i:0;s:15:"ilinfoscreengui";i:1;s:21:"illearningprogressgui";i:2;s:17:"illmpageobjectgui";i:3;s:13:"ilmdeditorgui";i:4;s:18:"ilobjstylesheetgui";i:5;s:15:"ilpermissiongui";i:6;s:20:"ilstructureobjectgui";}s:33:"ilobjlearningresourcessettingsgui";a:2:{i:0;s:20:"illicenseoverviewgui";i:1;s:15:"ilpermissiongui";}s:20:"ilobjlinkresourcegui";a:4:{i:0;s:15:"ilinfoscreengui";i:1;s:13:"ilmdeditorgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";}s:12:"ilobjmailgui";a:1:{i:0;s:15:"ilpermissiongui";}s:18:"ilobjmdsettingsgui";a:2:{i:0;s:23:"iladvancedmdsettingsgui";i:1;s:15:"ilpermissiongui";}s:17:"ilobjmediacastgui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:25:"ilobjmediacastsettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:28:"ilobjmediaobjectssettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:18:"ilmediapoolpagegui";a:5:{i:0;s:18:"ileditclipboardgui";i:1;s:25:"ilmediapooltargetselector";i:2;s:15:"ilpageeditorgui";i:3;s:15:"ilpageobjectgui";i:4;s:22:"ilpublicuserprofilegui";}s:17:"ilobjmediapoolgui";a:6:{i:0;s:18:"ileditclipboardgui";i:1;s:15:"ilinfoscreengui";i:2;s:18:"ilmediapoolpagegui";i:3;s:14:"ilobjfoldergui";i:4;s:19:"ilobjmediaobjectgui";i:5;s:15:"ilpermissiongui";}s:20:"ilobjnewssettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:20:"ilobjobjectfoldergui";a:1:{i:0;s:15:"ilpermissiongui";}s:23:"ilobjpaymentsettingsgui";a:3:{i:0;s:15:"ilpageobjectgui";i:1;s:15:"ilpermissiongui";i:2;s:15:"ilshoptopicsgui";}s:31:"ilobjpersonaldesktopsettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:23:"ilobjprivacysecuritygui";a:1:{i:0;s:15:"ilpermissiongui";}s:20:"ilobjquestionpoolgui";a:18:{i:0;s:15:"assclozetestgui";i:1;s:15:"asserrortextgui";i:2;s:16:"assfileuploadgui";i:3;s:19:"assflashquestiongui";i:4;s:22:"assimagemapquestiongui";i:5;s:16:"assjavaappletgui";i:6;s:22:"assmatchingquestiongui";i:7;s:20:"assmultiplechoicegui";i:8;s:13:"assnumericgui";i:9;s:24:"assorderinghorizontalgui";i:10;s:22:"assorderingquestiongui";i:11;s:18:"asssinglechoicegui";i:12;s:18:"asstextquestiongui";i:13;s:16:"asstextsubsetgui";i:14;s:13:"ilmdeditorgui";i:15;s:15:"ilobjectcopygui";i:16;s:15:"ilpageobjectgui";i:17;s:15:"ilpermissiongui";}s:22:"ilobjrecoveryfoldergui";a:1:{i:0;s:15:"ilpermissiongui";}s:20:"ilobjremotecoursegui";a:2:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpermissiongui";}s:18:"ilobjrolefoldergui";a:1:{i:0;s:15:"ilpermissiongui";}s:18:"ilobjrootfoldergui";a:6:{i:0;s:11:"ilcolumngui";i:1;s:22:"ilcontainerlinklistgui";i:2;s:15:"ilobjectcopygui";i:3;s:18:"ilobjstylesheetgui";i:4;s:15:"ilpageobjectgui";i:5;s:15:"ilpermissiongui";}s:26:"ilobjsahslearningmodulegui";a:6:{i:0;s:15:"ilfilesystemgui";i:1;s:15:"ilinfoscreengui";i:2;s:21:"illearningprogressgui";i:3;s:12:"illicensegui";i:4;s:13:"ilmdeditorgui";i:5;s:15:"ilpermissiongui";}s:22:"ilobjsearchsettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:15:"ilobjsessiongui";a:4:{i:0;s:29:"ilcourseitemadministrationgui";i:1;s:15:"ilinfoscreengui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";}s:15:"ilpagelayoutgui";a:4:{i:0;s:18:"ileditclipboardgui";i:1;s:15:"ilpageeditorgui";i:2;s:15:"ilpageobjectgui";i:3;s:22:"ilpublicuserprofilegui";}s:21:"ilobjstylesettingsgui";a:2:{i:0;s:15:"ilpagelayoutgui";i:1;s:15:"ilpermissiongui";}s:28:"ilobjsurveyadministrationgui";a:1:{i:0;s:15:"ilpermissiongui";}s:14:"ilobjsurveygui";a:6:{i:0;s:15:"ilinfoscreengui";i:1;s:13:"ilmdeditorgui";i:2;s:15:"ilobjectcopygui";i:3;s:15:"ilpermissiongui";i:4;s:21:"ilsurveyevaluationgui";i:5;s:20:"ilsurveyexecutiongui";}s:26:"ilobjsurveyquestionpoolgui";a:9:{i:0;s:13:"ilmdeditorgui";i:1;s:15:"ilobjectcopygui";i:2;s:15:"ilpermissiongui";i:3;s:18:"ilsurveyphrasesgui";i:4;s:23:"surveymatrixquestiongui";i:5;s:23:"surveymetricquestiongui";i:6;s:31:"surveymultiplechoicequestiongui";i:7;s:29:"surveysinglechoicequestiongui";i:8;s:21:"surveytextquestiongui";}s:20:"ilobjsystemfoldergui";a:1:{i:0;s:15:"ilpermissiongui";}s:23:"ilobjtaggingsettingsgui";a:1:{i:0;s:15:"ilpermissiongui";}s:12:"ilobjtestgui";a:12:{i:0;s:16:"ilcertificategui";i:1;s:15:"ilinfoscreengui";i:2;s:21:"illearningprogressgui";i:3;s:13:"ilmdeditorgui";i:4;s:14:"ilobjcoursegui";i:5;s:15:"ilobjectcopygui";i:6;s:15:"ilpermissiongui";i:7;s:17:"ilshoppurchasegui";i:8;s:19:"iltestevaluationgui";i:9;s:15:"iltestoutputgui";i:10;s:16:"iltestscoringgui";i:11;s:16:"iltestservicegui";}s:20:"ilobjusertrackinggui";a:2:{i:0;s:21:"illearningprogressgui";i:1;s:15:"ilpermissiongui";}s:13:"ilwikipagegui";a:7:{i:0;s:18:"ileditclipboardgui";i:1;s:25:"ilmediapooltargetselector";i:2;s:9:"ilnotegui";i:3;s:15:"ilpageeditorgui";i:4;s:15:"ilpageobjectgui";i:5;s:22:"ilpublicuserprofilegui";i:6;s:11:"ilratinggui";}s:12:"ilobjwikigui";a:5:{i:0;s:15:"ilinfoscreengui";i:1;s:18:"ilobjstylesheetgui";i:2;s:15:"ilpermissiongui";i:3;s:22:"ilpublicuserprofilegui";i:4;s:13:"ilwikipagegui";}s:19:"iladministrationgui";a:66:{i:0;s:21:"ilcourseobjectivesgui";i:1;s:29:"ilobjaccessibilitysettingsgui";i:2;s:23:"ilobjadvancededitinggui";i:3;s:24:"ilobjassessmentfoldergui";i:4;s:20:"ilobjauthsettingsgui";i:5;s:24:"ilobjcalendarsettingsgui";i:6;s:16:"ilobjcategorygui";i:7;s:25:"ilobjcategoryreferencegui";i:8;s:27:"ilobjcertificatesettingsgui";i:9;s:12:"ilobjchatgui";i:10;s:18:"ilobjchatservergui";i:11;s:25:"ilobjcomponentsettingsgui";i:12;s:14:"ilobjcoursegui";i:13;s:23:"ilobjcoursereferencegui";i:14;s:14:"ilobjdlbookgui";i:15;s:16:"ilobjexercisegui";i:16;s:20:"ilobjexternalfeedgui";i:17;s:29:"ilobjexternaltoolssettingsgui";i:18;s:26:"ilobjfileaccesssettingsgui";i:19;s:19:"ilobjfilebasedlmgui";i:20;s:12:"ilobjfilegui";i:21;s:14:"ilobjfoldergui";i:22;s:13:"ilobjforumgui";i:23;s:16:"ilobjglossarygui";i:24;s:13:"ilobjgroupgui";i:25;s:22:"ilobjilincclassroomgui";i:26;s:19:"ilobjilinccoursegui";i:27;s:19:"ilobjlanguageextgui";i:28;s:22:"ilobjlanguagefoldergui";i:29;s:22:"ilobjlearningmodulegui";i:30;s:33:"ilobjlearningresourcessettingsgui";i:31;s:20:"ilobjlinkresourcegui";i:32;s:12:"ilobjmailgui";i:33;s:18:"ilobjmdsettingsgui";i:34;s:17:"ilobjmediacastgui";i:35;s:25:"ilobjmediacastsettingsgui";i:36;s:28:"ilobjmediaobjectssettingsgui";i:37;s:17:"ilobjmediapoolgui";i:38;s:20:"ilobjnewssettingsgui";i:39;s:20:"ilobjobjectfoldergui";i:40;s:23:"ilobjpaymentsettingsgui";i:41;s:31:"ilobjpersonaldesktopsettingsgui";i:42;s:23:"ilobjprivacysecuritygui";i:43;s:20:"ilobjquestionpoolgui";i:44;s:22:"ilobjrecoveryfoldergui";i:45;s:20:"ilobjremotecoursegui";i:46;s:18:"ilobjrolefoldergui";i:47;s:12:"ilobjrolegui";i:48;s:20:"ilobjroletemplategui";i:49;s:18:"ilobjrootfoldergui";i:50;s:26:"ilobjsahslearningmodulegui";i:51;s:22:"ilobjsearchsettingsgui";i:52;s:15:"ilobjsessiongui";i:53;s:21:"ilobjstylesettingsgui";i:54;s:18:"ilobjstylesheetgui";i:55;s:28:"ilobjsurveyadministrationgui";i:56;s:14:"ilobjsurveygui";i:57;s:26:"ilobjsurveyquestionpoolgui";i:58;s:20:"ilobjsystemfoldergui";i:59;s:23:"ilobjtaggingsettingsgui";i:60;s:12:"ilobjtestgui";i:61;s:18:"ilobjuserfoldergui";i:62;s:12:"ilobjusergui";i:63;s:20:"ilobjusertrackinggui";i:64;s:12:"ilobjwikigui";i:65;s:15:"ilpermissiongui";}}'), 'parent' => array('clob', 'a:200:{s:21:"ilrepositorysearchgui";a:5:{i:0;s:12:"ilobjrolegui";i:1;s:14:"ilobjcoursegui";i:2;s:16:"ilobjexercisegui";i:3;s:13:"ilobjgroupgui";i:4;s:19:"ilobjilinccoursegui";}s:12:"ilobjrolegui";a:2:{i:0;s:15:"ilpermissiongui";i:1;s:19:"iladministrationgui";}s:15:"ilpermissiongui";a:59:{i:0;s:29:"ilobjaccessibilitysettingsgui";i:1;s:23:"ilobjadvancededitinggui";i:2;s:24:"ilobjassessmentfoldergui";i:3;s:20:"ilobjauthsettingsgui";i:4;s:24:"ilobjcalendarsettingsgui";i:5;s:18:"ilobjuserfoldergui";i:6;s:16:"ilobjcategorygui";i:7;s:25:"ilobjcategoryreferencegui";i:8;s:27:"ilobjcertificatesettingsgui";i:9;s:12:"ilobjchatgui";i:10;s:18:"ilobjchatservergui";i:11;s:25:"ilobjcomponentsettingsgui";i:12;s:14:"ilobjcoursegui";i:13;s:23:"ilobjcoursereferencegui";i:14;s:14:"ilobjdlbookgui";i:15;s:16:"ilobjexercisegui";i:16;s:20:"ilobjexternalfeedgui";i:17;s:29:"ilobjexternaltoolssettingsgui";i:18;s:26:"ilobjfileaccesssettingsgui";i:19;s:19:"ilobjfilebasedlmgui";i:20;s:12:"ilobjfilegui";i:21;s:14:"ilobjfoldergui";i:22;s:13:"ilobjforumgui";i:23;s:16:"ilobjglossarygui";i:24;s:13:"ilobjgroupgui";i:25;s:19:"ilobjilinccoursegui";i:26;s:22:"ilobjlanguagefoldergui";i:27;s:22:"ilobjlearningmodulegui";i:28;s:33:"ilobjlearningresourcessettingsgui";i:29;s:20:"ilobjlinkresourcegui";i:30;s:12:"ilobjmailgui";i:31;s:18:"ilobjmdsettingsgui";i:32;s:17:"ilobjmediacastgui";i:33;s:25:"ilobjmediacastsettingsgui";i:34;s:28:"ilobjmediaobjectssettingsgui";i:35;s:17:"ilobjmediapoolgui";i:36;s:20:"ilobjnewssettingsgui";i:37;s:20:"ilobjobjectfoldergui";i:38;s:23:"ilobjpaymentsettingsgui";i:39;s:31:"ilobjpersonaldesktopsettingsgui";i:40;s:23:"ilobjprivacysecuritygui";i:41;s:20:"ilobjquestionpoolgui";i:42;s:22:"ilobjrecoveryfoldergui";i:43;s:20:"ilobjremotecoursegui";i:44;s:18:"ilobjrolefoldergui";i:45;s:18:"ilobjrootfoldergui";i:46;s:26:"ilobjsahslearningmodulegui";i:47;s:22:"ilobjsearchsettingsgui";i:48;s:15:"ilobjsessiongui";i:49;s:21:"ilobjstylesettingsgui";i:50;s:28:"ilobjsurveyadministrationgui";i:51;s:14:"ilobjsurveygui";i:52;s:26:"ilobjsurveyquestionpoolgui";i:53;s:20:"ilobjsystemfoldergui";i:54;s:23:"ilobjtaggingsettingsgui";i:55;s:12:"ilobjtestgui";i:56;s:20:"ilobjusertrackinggui";i:57;s:12:"ilobjwikigui";i:58;s:19:"iladministrationgui";}s:27:"ilauthshibbolethsettingsgui";a:1:{i:0;s:20:"ilobjauthsettingsgui";}s:17:"illdapsettingsgui";a:1:{i:0;s:20:"ilobjauthsettingsgui";}s:19:"ilradiussettingsgui";a:1:{i:0;s:20:"ilobjauthsettingsgui";}s:25:"ilregistrationsettingsgui";a:1:{i:0;s:20:"ilobjauthsettingsgui";}s:24:"ilcalendarappointmentgui";a:6:{i:0;s:16:"ilcalendardaygui";i:1;s:18:"ilcalendarinboxgui";i:2;s:18:"ilcalendarmonthgui";i:3;s:17:"ilcalendarweekgui";i:4;s:18:"ilcalendarblockgui";i:5;s:20:"ilpdcalendarblockgui";}s:16:"ilcalendardaygui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarinboxgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:18:"ilcalendarmonthgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:17:"ilcalendarweekgui";a:2:{i:0;s:18:"ilcalendarblockgui";i:1;s:20:"ilpdcalendarblockgui";}s:13:"ilnewsitemgui";a:1:{i:0;s:24:"ilnewsforcontextblockgui";}s:22:"ilpublicuserprofilegui";a:12:{i:0;s:21:"ilusersonlineblockgui";i:1;s:15:"ilinfoscreengui";i:2;s:15:"ilpageobjectgui";i:3;s:12:"ilobjchatgui";i:4;s:14:"ilobjcoursegui";i:5;s:13:"ilobjforumgui";i:6;s:13:"ilobjgroupgui";i:7;s:19:"ilobjilinccoursegui";i:8;s:18:"ilmediapoolpagegui";i:9;s:15:"ilpagelayoutgui";i:10;s:13:"ilwikipagegui";i:11;s:12:"ilobjwikigui";}s:18:"ilbookmarkblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:18:"ilcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:14:"ilchatblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:15:"ildummyblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilexternalfeedblockgui";a:2:{i:0;s:11:"ilcolumngui";i:1;s:20:"ilobjexternalfeedgui";}s:14:"ilhtmlblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilnewsforcontextblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdcalendarblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:24:"ilpdexternalfeedblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:20:"ilpdfeedbackblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdmailblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:16:"ilpdnewsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:17:"ilpdnotesblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:25:"ilpdselecteditemsblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:22:"ilpdsysmessageblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:19:"ilpdtaggingblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:21:"ilusersonlineblockgui";a:1:{i:0;s:11:"ilcolumngui";}s:11:"ilcolumngui";a:9:{i:0;s:15:"ilinfoscreengui";i:1;s:16:"ilobjcategorygui";i:2;s:18:"ilcoursecontentgui";i:3;s:14:"ilobjcoursegui";i:4;s:14:"ilobjfoldergui";i:5;s:13:"ilobjforumgui";i:6;s:13:"ilobjgroupgui";i:7;s:19:"ilobjilinccoursegui";i:8;s:18:"ilobjrootfoldergui";}s:13:"ilfeedbackgui";a:1:{i:0;s:15:"ilinfoscreengui";}s:9:"ilnotegui";a:3:{i:0;s:15:"ilinfoscreengui";i:1;s:15:"ilpageobjectgui";i:2;s:13:"ilwikipagegui";}s:28:"ilrepositoryselectorinputgui";a:1:{i:0;s:25:"ilformpropertydispatchgui";}s:25:"ilformpropertydispatchgui";a:3:{i:0;s:19:"illpobjectstablegui";i:1;s:20:"illpprogresstablegui";i:2;s:14:"ilusertablegui";}s:13:"illpfiltergui";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:19:"illpobjectstablegui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:17:"ilpdfpresentation";a:2:{i:0;s:20:"illplistofobjectsgui";i:1;s:21:"illplistofprogressgui";}s:15:"iluserfiltergui";a:1:{i:0;s:20:"illplistofobjectsgui";}s:20:"illpprogresstablegui";a:1:{i:0;s:21:"illplistofprogressgui";}s:17:"illmstatisticsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:20:"illplistofobjectsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofprogressgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illplistofsettingsgui";a:1:{i:0;s:21:"illearningprogressgui";}s:21:"illearningprogressgui";a:11:{i:0;s:12:"ilobjusergui";i:1;s:14:"ilobjcoursegui";i:2;s:14:"ilobjdlbookgui";i:3;s:16:"ilobjexercisegui";i:4;s:19:"ilobjfilebasedlmgui";i:5;s:14:"ilobjfoldergui";i:6;s:13:"ilobjgroupgui";i:7;s:22:"ilobjlearningmodulegui";i:8;s:26:"ilobjsahslearningmodulegui";i:9;s:12:"ilobjtestgui";i:10;s:20:"ilobjusertrackinggui";}s:17:"ilobjilincusergui";a:1:{i:0;s:12:"ilobjusergui";}s:12:"ilobjusergui";a:3:{i:0;s:20:"iladminusersearchgui";i:1;s:16:"ilobjcategorygui";i:2;s:19:"iladministrationgui";}s:20:"iladminusersearchgui";a:1:{i:0;s:18:"ilobjuserfoldergui";}s:14:"ilusertablegui";a:1:{i:0;s:18:"ilobjuserfoldergui";}s:17:"ilinternallinkgui";a:3:{i:0;s:19:"ilimagemapeditorgui";i:1;s:21:"ilpcimagemapeditorgui";i:2;s:15:"ilpageeditorgui";}s:15:"ilfilesystemgui";a:3:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:19:"ilobjfilebasedlmgui";i:2;s:26:"ilobjsahslearningmodulegui";}s:19:"ilimagemapeditorgui";a:1:{i:0;s:19:"ilobjmediaobjectgui";}s:13:"ilmdeditorgui";a:16:{i:0;s:19:"ilobjmediaobjectgui";i:1;s:15:"ilpageobjectgui";i:2;s:14:"ilobjcoursegui";i:3;s:20:"ilstructureobjectgui";i:4;s:14:"ilobjdlbookgui";i:5;s:19:"ilobjfilebasedlmgui";i:6;s:12:"ilobjfilegui";i:7;s:25:"iltermdefinitioneditorgui";i:8;s:16:"ilobjglossarygui";i:9;s:22:"ilobjlearningmodulegui";i:10;s:20:"ilobjlinkresourcegui";i:11;s:20:"ilobjquestionpoolgui";i:12;s:26:"ilobjsahslearningmodulegui";i:13;s:14:"ilobjsurveygui";i:14;s:26:"ilobjsurveyquestionpoolgui";i:15;s:12:"ilobjtestgui";}s:19:"ilobjmediaobjectgui";a:4:{i:0;s:18:"ileditclipboardgui";i:1;s:18:"ilpcmediaobjectgui";i:2;s:15:"ilpageeditorgui";i:3;s:17:"ilobjmediapoolgui";}s:21:"ilpcimagemapeditorgui";a:1:{i:0;s:18:"ilpcmediaobjectgui";}s:18:"ilpcmediaobjectgui";a:2:{i:0;s:18:"ilpcplaceholdergui";i:1;s:15:"ilpageeditorgui";}s:15:"assclozetestgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:22:"assimagemapquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:16:"assjavaappletgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:22:"assmatchingquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:20:"assmultiplechoicegui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:13:"assnumericgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:22:"assorderingquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:18:"asssinglechoicegui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:18:"asstextquestiongui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:16:"asstextsubsetgui";a:2:{i:0;s:17:"ilquestioneditgui";i:1;s:20:"ilobjquestionpoolgui";}s:17:"ilquestioneditgui";a:1:{i:0;s:15:"ilpcquestiongui";}s:21:"ilpccontentincludegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcdatatablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfileitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcfilelistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpclistgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpclistitemgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:10:"ilpcmapgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcparagraphgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ilpcplaceholdergui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcpluggedgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:15:"ilpcquestiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpcresourcesgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:14:"ilpcsectiongui";a:1:{i:0;s:15:"ilpageeditorgui";}s:17:"ilpcsourcecodegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:16:"ilpctabledatagui";a:1:{i:0;s:15:"ilpageeditorgui";}s:12:"ilpctablegui";a:1:{i:0;s:15:"ilpageeditorgui";}s:11:"ilpctabsgui";a:1:{i:0;s:15:"ilpageeditorgui";}s:18:"ileditclipboardgui";a:5:{i:0;s:15:"ilpageobjectgui";i:1;s:18:"ilmediapoolpagegui";i:2;s:17:"ilobjmediapoolgui";i:3;s:15:"ilpagelayoutgui";i:4;s:13:"ilwikipagegui";}s:15:"ilpageeditorgui";a:4:{i:0;s:15:"ilpageobjectgui";i:1;s:18:"ilmediapoolpagegui";i:2;s:15:"ilpagelayoutgui";i:3;s:13:"ilwikipagegui";}s:22:"ilcontainerlinklistgui";a:2:{i:0;s:16:"ilobjcategorygui";i:1;s:18:"ilobjrootfoldergui";}s:15:"ilinfoscreengui";a:24:{i:0;s:16:"ilobjcategorygui";i:1;s:25:"ilobjcategoryreferencegui";i:2;s:12:"ilobjchatgui";i:3;s:14:"ilobjcoursegui";i:4;s:23:"ilobjcoursereferencegui";i:5;s:14:"ilobjdlbookgui";i:6;s:16:"ilobjexercisegui";i:7;s:19:"ilobjfilebasedlmgui";i:8;s:12:"ilobjfilegui";i:9;s:14:"ilobjfoldergui";i:10;s:13:"ilobjforumgui";i:11;s:16:"ilobjglossarygui";i:12;s:13:"ilobjgroupgui";i:13;s:19:"ilobjilinccoursegui";i:14;s:22:"ilobjlearningmodulegui";i:15;s:20:"ilobjlinkresourcegui";i:16;s:17:"ilobjmediacastgui";i:17;s:17:"ilobjmediapoolgui";i:18;s:20:"ilobjremotecoursegui";i:19;s:26:"ilobjsahslearningmodulegui";i:20;s:15:"ilobjsessiongui";i:21;s:14:"ilobjsurveygui";i:22;s:12:"ilobjtestgui";i:23;s:12:"ilobjwikigui";}s:15:"ilobjectcopygui";a:15:{i:0;s:16:"ilobjcategorygui";i:1;s:12:"ilobjchatgui";i:2;s:14:"ilobjcoursegui";i:3;s:16:"ilobjexercisegui";i:4;s:12:"ilobjfilegui";i:5;s:14:"ilobjfoldergui";i:6;s:13:"ilobjforumgui";i:7;s:13:"ilobjgroupgui";i:8;s:20:"ilobjlinkresourcegui";i:9;s:20:"ilobjquestionpoolgui";i:10;s:18:"ilobjrootfoldergui";i:11;s:15:"ilobjsessiongui";i:12;s:14:"ilobjsurveygui";i:13;s:26:"ilobjsurveyquestionpoolgui";i:14;s:12:"ilobjtestgui";}s:18:"ilobjstylesheetgui";a:9:{i:0;s:16:"ilobjcategorygui";i:1;s:14:"ilobjcoursegui";i:2;s:14:"ilobjdlbookgui";i:3;s:14:"ilobjfoldergui";i:4;s:13:"ilobjgroupgui";i:5;s:22:"ilobjlearningmodulegui";i:6;s:18:"ilobjrootfoldergui";i:7;s:12:"ilobjwikigui";i:8;s:19:"iladministrationgui";}s:18:"ilobjuserfoldergui";a:2:{i:0;s:16:"ilobjcategorygui";i:1;s:19:"iladministrationgui";}s:15:"ilpageobjectgui";a:14:{i:0;s:16:"ilobjcategorygui";i:1;s:17:"ilshoppurchasegui";i:2;s:14:"ilobjcoursegui";i:3;s:17:"illmpageobjectgui";i:4;s:14:"ilobjfoldergui";i:5;s:25:"iltermdefinitioneditorgui";i:6;s:17:"ilglossarytermgui";i:7;s:13:"ilobjgroupgui";i:8;s:18:"ilmediapoolpagegui";i:9;s:23:"ilobjpaymentsettingsgui";i:10;s:20:"ilobjquestionpoolgui";i:11;s:18:"ilobjrootfoldergui";i:12;s:15:"ilpagelayoutgui";i:13;s:13:"ilwikipagegui";}s:19:"ilcoursearchivesgui";a:1:{i:0;s:18:"ilcoursecontentgui";}s:32:"ilcourseobjectivepresentationgui";a:1:{i:0;s:18:"ilcoursecontentgui";}s:27:"ilconditionhandlerinterface";a:5:{i:0;s:29:"ilcourseitemadministrationgui";i:1;s:14:"ilobjcoursegui";i:2;s:20:"ilstructureobjectgui";i:3;s:14:"ilobjfoldergui";i:4;s:13:"ilobjgroupgui";}s:20:"ilcourseagreementgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:18:"ilcoursecontentgui";a:3:{i:0;s:14:"ilobjcoursegui";i:1;s:14:"ilobjfoldergui";i:2;s:13:"ilobjgroupgui";}s:29:"ilcourseitemadministrationgui";a:4:{i:0;s:14:"ilobjcoursegui";i:1;s:14:"ilobjfoldergui";i:2;s:13:"ilobjgroupgui";i:3;s:15:"ilobjsessiongui";}s:21:"ilcourseobjectivesgui";a:2:{i:0;s:14:"ilobjcoursegui";i:1;s:19:"iladministrationgui";}s:23:"ilcourseregistrationgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:21:"ilcourseuserfieldsgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:20:"illicenseoverviewgui";a:2:{i:0;s:14:"ilobjcoursegui";i:1;s:33:"ilobjlearningresourcessettingsgui";}s:17:"ilmemberexportgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:22:"ilobjcoursegroupinggui";a:2:{i:0;s:14:"ilobjcoursegui";i:1;s:13:"ilobjgroupgui";}s:20:"ilsessionoverviewgui";a:1:{i:0;s:14:"ilobjcoursegui";}s:17:"ilshoppurchasegui";a:4:{i:0;s:14:"ilobjcoursegui";i:1;s:19:"ilobjfilebasedlmgui";i:2;s:12:"ilobjfilegui";i:3;s:12:"ilobjtestgui";}s:17:"illmpageobjectgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:20:"ilstructureobjectgui";a:2:{i:0;s:14:"ilobjdlbookgui";i:1;s:22:"ilobjlearningmodulegui";}s:16:"ilecssettingsgui";a:1:{i:0;s:29:"ilobjexternaltoolssettingsgui";}s:12:"illicensegui";a:2:{i:0;s:19:"ilobjfilebasedlmgui";i:1;s:26:"ilobjsahslearningmodulegui";}s:16:"ilforumexportgui";a:1:{i:0;s:13:"ilobjforumgui";}s:20:"ilforummoderatorsgui";a:1:{i:0;s:13:"ilobjforumgui";}s:25:"iltermdefinitioneditorgui";a:1:{i:0;s:17:"ilglossarytermgui";}s:17:"ilglossarytermgui";a:1:{i:0;s:16:"ilobjglossarygui";}s:22:"ilgroupregistrationgui";a:1:{i:0;s:13:"ilobjgroupgui";}s:22:"ilobjilincclassroomgui";a:2:{i:0;s:19:"ilobjilinccoursegui";i:1;s:19:"iladministrationgui";}s:23:"iladvancedmdsettingsgui";a:1:{i:0;s:18:"ilobjmdsettingsgui";}s:25:"ilmediapooltargetselector";a:2:{i:0;s:18:"ilmediapoolpagegui";i:1;s:13:"ilwikipagegui";}s:18:"ilmediapoolpagegui";a:1:{i:0;s:17:"ilobjmediapoolgui";}s:14:"ilobjfoldergui";a:2:{i:0;s:17:"ilobjmediapoolgui";i:1;s:19:"iladministrationgui";}s:15:"ilshoptopicsgui";a:1:{i:0;s:23:"ilobjpaymentsettingsgui";}s:15:"asserrortextgui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:16:"assfileuploadgui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:19:"assflashquestiongui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:24:"assorderinghorizontalgui";a:1:{i:0;s:20:"ilobjquestionpoolgui";}s:15:"ilpagelayoutgui";a:1:{i:0;s:21:"ilobjstylesettingsgui";}s:21:"ilsurveyevaluationgui";a:1:{i:0;s:14:"ilobjsurveygui";}s:20:"ilsurveyexecutiongui";a:1:{i:0;s:14:"ilobjsurveygui";}s:18:"ilsurveyphrasesgui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:23:"surveymatrixquestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:23:"surveymetricquestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:31:"surveymultiplechoicequestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:29:"surveysinglechoicequestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:21:"surveytextquestiongui";a:1:{i:0;s:26:"ilobjsurveyquestionpoolgui";}s:16:"ilcertificategui";a:1:{i:0;s:12:"ilobjtestgui";}s:14:"ilobjcoursegui";a:2:{i:0;s:12:"ilobjtestgui";i:1;s:19:"iladministrationgui";}s:19:"iltestevaluationgui";a:1:{i:0;s:12:"ilobjtestgui";}s:15:"iltestoutputgui";a:1:{i:0;s:12:"ilobjtestgui";}s:16:"iltestscoringgui";a:1:{i:0;s:12:"ilobjtestgui";}s:16:"iltestservicegui";a:1:{i:0;s:12:"ilobjtestgui";}s:11:"ilratinggui";a:1:{i:0;s:13:"ilwikipagegui";}s:13:"ilwikipagegui";a:1:{i:0;s:12:"ilobjwikigui";}s:29:"ilobjaccessibilitysettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:23:"ilobjadvancededitinggui";a:1:{i:0;s:19:"iladministrationgui";}s:24:"ilobjassessmentfoldergui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjauthsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:24:"ilobjcalendarsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:16:"ilobjcategorygui";a:1:{i:0;s:19:"iladministrationgui";}s:25:"ilobjcategoryreferencegui";a:1:{i:0;s:19:"iladministrationgui";}s:27:"ilobjcertificatesettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:12:"ilobjchatgui";a:1:{i:0;s:19:"iladministrationgui";}s:18:"ilobjchatservergui";a:1:{i:0;s:19:"iladministrationgui";}s:25:"ilobjcomponentsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:23:"ilobjcoursereferencegui";a:1:{i:0;s:19:"iladministrationgui";}s:14:"ilobjdlbookgui";a:1:{i:0;s:19:"iladministrationgui";}s:16:"ilobjexercisegui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjexternalfeedgui";a:1:{i:0;s:19:"iladministrationgui";}s:29:"ilobjexternaltoolssettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:26:"ilobjfileaccesssettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:19:"ilobjfilebasedlmgui";a:1:{i:0;s:19:"iladministrationgui";}s:12:"ilobjfilegui";a:1:{i:0;s:19:"iladministrationgui";}s:13:"ilobjforumgui";a:1:{i:0;s:19:"iladministrationgui";}s:16:"ilobjglossarygui";a:1:{i:0;s:19:"iladministrationgui";}s:13:"ilobjgroupgui";a:1:{i:0;s:19:"iladministrationgui";}s:19:"ilobjilinccoursegui";a:1:{i:0;s:19:"iladministrationgui";}s:19:"ilobjlanguageextgui";a:1:{i:0;s:19:"iladministrationgui";}s:22:"ilobjlanguagefoldergui";a:1:{i:0;s:19:"iladministrationgui";}s:22:"ilobjlearningmodulegui";a:1:{i:0;s:19:"iladministrationgui";}s:33:"ilobjlearningresourcessettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjlinkresourcegui";a:1:{i:0;s:19:"iladministrationgui";}s:12:"ilobjmailgui";a:1:{i:0;s:19:"iladministrationgui";}s:18:"ilobjmdsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:17:"ilobjmediacastgui";a:1:{i:0;s:19:"iladministrationgui";}s:25:"ilobjmediacastsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:28:"ilobjmediaobjectssettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:17:"ilobjmediapoolgui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjnewssettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjobjectfoldergui";a:1:{i:0;s:19:"iladministrationgui";}s:23:"ilobjpaymentsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:31:"ilobjpersonaldesktopsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:23:"ilobjprivacysecuritygui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjquestionpoolgui";a:1:{i:0;s:19:"iladministrationgui";}s:22:"ilobjrecoveryfoldergui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjremotecoursegui";a:1:{i:0;s:19:"iladministrationgui";}s:18:"ilobjrolefoldergui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjroletemplategui";a:1:{i:0;s:19:"iladministrationgui";}s:18:"ilobjrootfoldergui";a:1:{i:0;s:19:"iladministrationgui";}s:26:"ilobjsahslearningmodulegui";a:1:{i:0;s:19:"iladministrationgui";}s:22:"ilobjsearchsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:15:"ilobjsessiongui";a:1:{i:0;s:19:"iladministrationgui";}s:21:"ilobjstylesettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:28:"ilobjsurveyadministrationgui";a:1:{i:0;s:19:"iladministrationgui";}s:14:"ilobjsurveygui";a:1:{i:0;s:19:"iladministrationgui";}s:26:"ilobjsurveyquestionpoolgui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjsystemfoldergui";a:1:{i:0;s:19:"iladministrationgui";}s:23:"ilobjtaggingsettingsgui";a:1:{i:0;s:19:"iladministrationgui";}s:12:"ilobjtestgui";a:1:{i:0;s:19:"iladministrationgui";}s:20:"ilobjusertrackinggui";a:1:{i:0;s:19:"iladministrationgui";}s:12:"ilobjwikigui";a:1:{i:0;s:19:"iladministrationgui";}}')));


//
// data_cache
//
$fields = array (
	"module" => array (
		"notnull" => true
		,"length" => 50
		,"default" => "common"
		,"fixed" => false
		,"type" => "text"
	)
	,"keyword" => array (
		"notnull" => true
		,"length" => 50
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("data_cache", $fields);

$pk_fields = array("module","keyword");
$ilDB->addPrimaryKey("data_cache", $pk_fields);


//
// dav_lock
//
$fields = array (
	"token" => array (
		"notnull" => true
		,"length" => 255
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ilias_owner" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"dav_owner" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"expires" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "w"
		,"fixed" => true
		,"type" => "text"
	)
	,"scope" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "s"
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("dav_lock", $fields);

$pk_fields = array("token");
$ilDB->addPrimaryKey("dav_lock", $pk_fields);

$in_fields = array("obj_id","node_id");
$ilDB->addIndex("dav_lock", $in_fields, "i1", false);

$in_fields = array("obj_id","node_id","token");
$ilDB->addIndex("dav_lock", $in_fields, "i2", false);

$in_fields = array("expires");
$ilDB->addIndex("dav_lock", $in_fields, "i3", false);

$in_fields = array("token");
$ilDB->addUniqueConstraint("dav_lock", $in_fields, "c1");


//
// dav_property
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ns" => array (
		"notnull" => true
		,"length" => 120
		,"default" => "DAV:"
		,"fixed" => false
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 120
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("dav_property", $fields);

$pk_fields = array("obj_id","node_id","name","ns");
$ilDB->addPrimaryKey("dav_property", $pk_fields);

$in_fields = array("obj_id","node_id");
$ilDB->addIndex("dav_property", $in_fields, "i1", false);


//
// dbk_translations
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("dbk_translations", $fields);

$pk_fields = array("id","tr_id");
$ilDB->addPrimaryKey("dbk_translations", $pk_fields);


//
// desktop_item
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => false
		,"type" => "text"
	)
	,"parameters" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("desktop_item", $fields);

$in_fields = array("user_id");
$ilDB->addIndex("desktop_item", $in_fields, "i1", false);

$in_fields = array("item_id");
$ilDB->addIndex("desktop_item", $in_fields, "it", false);


//
// didactic_tpl_a
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tpl_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"type_id" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("didactic_tpl_a", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("didactic_tpl_a", $pk_fields);

$ilDB->createSequence("didactic_tpl_a", 1);


//
// didactic_tpl_abr
//
$fields = array (
	"action_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"filter_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("didactic_tpl_abr", $fields);

$pk_fields = array("action_id");
$ilDB->addPrimaryKey("didactic_tpl_abr", $pk_fields);


//
// didactic_tpl_alp
//
$fields = array (
	"action_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"filter_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"template_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"template_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("didactic_tpl_alp", $fields);

$pk_fields = array("action_id");
$ilDB->addPrimaryKey("didactic_tpl_alp", $pk_fields);


//
// didactic_tpl_alr
//
$fields = array (
	"action_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"role_template_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("didactic_tpl_alr", $fields);

$pk_fields = array("action_id");
$ilDB->addPrimaryKey("didactic_tpl_alr", $pk_fields);


//
// didactic_tpl_fp
//
$fields = array (
	"pattern_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"pattern_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"pattern_sub_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"pattern" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("didactic_tpl_fp", $fields);

$pk_fields = array("pattern_id");
$ilDB->addPrimaryKey("didactic_tpl_fp", $pk_fields);

$ilDB->createSequence("didactic_tpl_fp", 1);


//
// didactic_tpl_objs
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tpl_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("didactic_tpl_objs", $fields);

$pk_fields = array("ref_id","tpl_id");
$ilDB->addPrimaryKey("didactic_tpl_objs", $pk_fields);


//
// didactic_tpl_sa
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 8
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("didactic_tpl_sa", $fields);

$pk_fields = array("id","obj_type");
$ilDB->addPrimaryKey("didactic_tpl_sa", $pk_fields);


//
// didactic_tpl_settings
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"info" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("didactic_tpl_settings", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("didactic_tpl_settings", $pk_fields);

$ilDB->createSequence("didactic_tpl_settings", 1);


//
// ecs_cmap_rule
//
$fields = array (
	"rid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"sid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"attribute" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"is_filter" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"filter" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"create_subdir" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"subdir_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"directory" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ecs_cmap_rule", $fields);

$pk_fields = array("rid");
$ilDB->addPrimaryKey("ecs_cmap_rule", $pk_fields);

$ilDB->createSequence("ecs_cmap_rule", 1);


//
// ecs_cms_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"server_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"tree_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"term" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"deleted" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cms_id" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ecs_cms_data", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("ecs_cms_data", $pk_fields);

$ilDB->createSequence("ecs_cms_data", 1);


//
// ecs_cms_tree
//
$fields = array (
	"tree" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_cms_tree", $fields);

$pk_fields = array("tree","child");
$ilDB->addPrimaryKey("ecs_cms_tree", $pk_fields);


//
// ecs_community
//
$fields = array (
	"sid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"cid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"own_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"cname" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"mids" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ecs_community", $fields);

$pk_fields = array("sid","cid");
$ilDB->addPrimaryKey("ecs_community", $pk_fields);


//
// ecs_container_mapping
//
$fields = array (
	"mapping_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"container_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"mapping_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mapping_value" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"date_range_start" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"date_range_end" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_container_mapping", $fields);

$pk_fields = array("mapping_id");
$ilDB->addPrimaryKey("ecs_container_mapping", $pk_fields);

$ilDB->createSequence("ecs_container_mapping", 1);


//
// ecs_course_assignments
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"sid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"cms_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"cms_sub_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_course_assignments", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("ecs_course_assignments", $pk_fields);

$ilDB->createSequence("ecs_course_assignments", 1);


//
// ecs_crs_mapping_atts
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"sid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ecs_crs_mapping_atts", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("ecs_crs_mapping_atts", $pk_fields);

$ilDB->createSequence("ecs_crs_mapping_atts", 1);


//
// ecs_data_mapping
//
$fields = array (
	"sid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mapping_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ecs_field" => array (
		"notnull" => true
		,"length" => 32
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"advmd_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_data_mapping", $fields);

$pk_fields = array("sid","mapping_type","ecs_field");
$ilDB->addPrimaryKey("ecs_data_mapping", $pk_fields);


//
// ecs_events
//
$fields = array (
	"event_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => true
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"op" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => true
		,"type" => "text"
	)
	,"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_events", $fields);

$pk_fields = array("event_id");
$ilDB->addPrimaryKey("ecs_events", $pk_fields);

$ilDB->createSequence("ecs_events", 1);


//
// ecs_export
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"econtent_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_export", $fields);

$pk_fields = array("server_id","obj_id");
$ilDB->addPrimaryKey("ecs_export", $pk_fields);


//
// ecs_import
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_id" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"ecs_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"content_id" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"econtent_id" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ecs_import", $fields);

$pk_fields = array("server_id","obj_id");
$ilDB->addPrimaryKey("ecs_import", $pk_fields);


//
// ecs_node_mapping_a
//
$fields = array (
	"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cs_root" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cs_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"title_update" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"position_update" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"tree_update" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_node_mapping_a", $fields);

$pk_fields = array("server_id","mid","cs_root","cs_id");
$ilDB->addPrimaryKey("ecs_node_mapping_a", $pk_fields);


//
// ecs_part_settings
//
$fields = array (
	"sid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"export" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"import" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"import_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"cname" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"token" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"export_types" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"import_types" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"dtoken" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("ecs_part_settings", $fields);


//
// ecs_remote_user
//
$fields = array (
	"eru_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"remote_usr_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("ecs_remote_user", $fields);

$pk_fields = array("eru_id");
$ilDB->addPrimaryKey("ecs_remote_user", $pk_fields);

$ilDB->createSequence("ecs_remote_user", 1);


//
// ecs_server
//
$fields = array (
	"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"protocol" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"server" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"port" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"auth_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"client_cert_path" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"ca_cert_path" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"key_path" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"key_password" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"cert_serial" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"polling_time" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"global_role" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"econtent_rcp" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"user_rcp" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"approval_rcp" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"duration" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"auth_user" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"auth_pass" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ecs_server", $fields);

$pk_fields = array("server_id");
$ilDB->addPrimaryKey("ecs_server", $pk_fields);

$ilDB->createSequence("ecs_server", 1);


//
// event
//
$fields = array (
	"event_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 70
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"location" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"tutor_name" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"tutor_email" => array (
		"notnull" => false
		,"length" => 127
		,"fixed" => false
		,"type" => "text"
	)
	,"tutor_phone" => array (
		"notnull" => false
		,"length" => 127
		,"fixed" => false
		,"type" => "text"
	)
	,"details" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"registration" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"participation" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reg_type" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reg_limit_users" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reg_waiting_list" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reg_limited" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("event", $fields);

$pk_fields = array("event_id");
$ilDB->addPrimaryKey("event", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("event", $in_fields, "i1", false);

$ilDB->createSequence("event", 1);


//
// event_appointment
//
$fields = array (
	"appointment_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"event_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"e_start" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"e_end" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"starting_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ending_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"fulltime" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("event_appointment", $fields);

$pk_fields = array("appointment_id");
$ilDB->addPrimaryKey("event_appointment", $pk_fields);

$ilDB->createSequence("event_appointment", 1);


//
// event_file
//
$fields = array (
	"file_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"event_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"file_name" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"file_type" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"file_size" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("event_file", $fields);

$pk_fields = array("file_id");
$ilDB->addPrimaryKey("event_file", $pk_fields);

$ilDB->createSequence("event_file", 1);


//
// event_items
//
$fields = array (
	"event_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("event_items", $fields);

$pk_fields = array("event_id","item_id");
$ilDB->addPrimaryKey("event_items", $pk_fields);

$in_fields = array("event_id");
$ilDB->addIndex("event_items", $in_fields, "i1", false);


//
// event_participants
//
$fields = array (
	"event_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"registered" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"participated" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mark" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"e_comment" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("event_participants", $fields);

$pk_fields = array("event_id","usr_id");
$ilDB->addPrimaryKey("event_participants", $pk_fields);


//
// exc_assignment
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"exc_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"time_stamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"instruction" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"start_time" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mandatory" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"peer" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"peer_min" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"fb_file" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"fb_cron" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"fb_cron_done" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"peer_dl" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"peer_file" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"peer_prsl" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"fb_date" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("exc_assignment", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("exc_assignment", $pk_fields);

$ilDB->createSequence("exc_assignment", 1);


//
// exc_assignment_peer
//
$fields = array (
	"ass_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"giver_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"peer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"pcomment" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("exc_assignment_peer", $fields);

$pk_fields = array("ass_id","giver_id","peer_id");
$ilDB->addPrimaryKey("exc_assignment_peer", $pk_fields);


//
// exc_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"instruction" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"time_stamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"pass_mode" => array (
		"notnull" => true
		,"length" => 8
		,"default" => "all"
		,"fixed" => false
		,"type" => "text"
	)
	,"pass_nr" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"show_submissions" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"compl_by_submission" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"certificate_visibility" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("exc_data", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("exc_data", $pk_fields);

$in_fields = array("instruction");
$ilDB->addIndex("exc_data", $in_fields, "i1", true);


//
// exc_mem_ass_status
//
$fields = array (
	"ass_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"notice" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"returned" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"solved" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"status_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"sent" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sent_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"feedback_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"feedback" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 9
		,"default" => "notgraded"
		,"fixed" => true
		,"type" => "text"
	)
	,"mark" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"u_comment" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("exc_mem_ass_status", $fields);

$pk_fields = array("ass_id","usr_id");
$ilDB->addPrimaryKey("exc_mem_ass_status", $pk_fields);


//
// exc_members
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"notice" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"returned" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"solved" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"status_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"sent" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sent_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"feedback_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"feedback" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 9
		,"default" => "notgraded"
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("exc_members", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("exc_members", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("exc_members", $in_fields, "ob", false);


//
// exc_returned
//
$fields = array (
	"returned_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"filename" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"filetitle" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"mimetype" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"ts" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"ass_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"atext" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("exc_returned", $fields);

$pk_fields = array("returned_id");
$ilDB->addPrimaryKey("exc_returned", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("exc_returned", $in_fields, "i1", false);

$in_fields = array("user_id");
$ilDB->addIndex("exc_returned", $in_fields, "i2", false);

$ilDB->createSequence("exc_returned", 1);


//
// exc_usr_tutor
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tutor_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"download_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"ass_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("exc_usr_tutor", $fields);

$pk_fields = array("ass_id","usr_id","tutor_id");
$ilDB->addPrimaryKey("exc_usr_tutor", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("exc_usr_tutor", $in_fields, "ob", false);


//
// export_file_info
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"export_type" => array (
		"notnull" => true
		,"length" => 32
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"file_name" => array (
		"notnull" => true
		,"length" => 64
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"version" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"create_date" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"filename" => array (
		"notnull" => true
		,"length" => 64
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("export_file_info", $fields);

$pk_fields = array("obj_id","export_type","filename");
$ilDB->addPrimaryKey("export_file_info", $pk_fields);

$in_fields = array("create_date");
$ilDB->addIndex("export_file_info", $in_fields, "i1", false);


//
// export_options
//
$fields = array (
	"export_id" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"keyword" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"pos" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("export_options", $fields);

$pk_fields = array("export_id","keyword","ref_id");
$ilDB->addPrimaryKey("export_options", $pk_fields);


//
// feedback_items
//
$fields = array (
	"fb_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"anonymous" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"required" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"show_on" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"text_answer" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"votes" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"starttime" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"endtime" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"repeat_interval" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"interval_unit" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"first_vote_best" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("feedback_items", $fields);

$pk_fields = array("fb_id");
$ilDB->addPrimaryKey("feedback_items", $pk_fields);

$ilDB->createSequence("feedback_items", 1);


//
// feedback_results
//
$fields = array (
	"fb_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"vote" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"note" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"votetime" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("feedback_results", $fields);


//
// file_based_lm
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"startfile" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"show_lic" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"show_bib" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("file_based_lm", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("file_based_lm", $pk_fields);


//
// file_data
//
$fields = array (
	"file_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"file_name" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => true
		,"type" => "text"
	)
	,"file_type" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => true
		,"type" => "text"
	)
	,"file_size" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"version" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"f_mode" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "object"
		,"fixed" => true
		,"type" => "text"
	)
	,"rating" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("file_data", $fields);

$pk_fields = array("file_id");
$ilDB->addPrimaryKey("file_data", $pk_fields);


//
// file_usage
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usage_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"usage_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usage_hist_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usage_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("file_usage", $fields);

$pk_fields = array("id","usage_type","usage_id","usage_hist_nr","usage_lang");
$ilDB->addPrimaryKey("file_usage", $pk_fields);


//
// frm_data
//
$fields = array (
	"top_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_frm_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"top_description" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"top_num_posts" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_num_threads" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_last_post" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"top_mods" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"visits" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"update_user" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_usr_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("frm_data", $fields);

$pk_fields = array("top_pk");
$ilDB->addPrimaryKey("frm_data", $pk_fields);

$in_fields = array("top_frm_fk");
$ilDB->addIndex("frm_data", $in_fields, "i1", false);

$ilDB->createSequence("frm_data", 1);


//
// frm_notification
//
$fields = array (
	"notification_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"frm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thread_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"admin_force_noti" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_toggle_noti" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id_noti" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("frm_notification", $fields);

$pk_fields = array("notification_id");
$ilDB->addPrimaryKey("frm_notification", $pk_fields);

$in_fields = array("user_id","thread_id");
$ilDB->addIndex("frm_notification", $in_fields, "i1", false);

$ilDB->createSequence("frm_notification", 1);


//
// frm_posts
//
$fields = array (
	"pos_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos_top_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos_thr_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos_usr_alias" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"pos_subject" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"pos_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"pos_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"update_user" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos_cens" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos_cens_com" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"notify" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_name" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"pos_status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"pos_message" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"pos_author_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos_display_user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_author_moderator" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("frm_posts", $fields);

$pk_fields = array("pos_pk");
$ilDB->addPrimaryKey("frm_posts", $pk_fields);

$in_fields = array("pos_thr_fk");
$ilDB->addIndex("frm_posts", $in_fields, "i1", false);

$in_fields = array("pos_top_fk");
$ilDB->addIndex("frm_posts", $in_fields, "i2", false);

$in_fields = array("pos_date");
$ilDB->addIndex("frm_posts", $in_fields, "i3", false);

$in_fields = array("pos_subject");
$ilDB->addIndex("frm_posts", $in_fields, "i4", true);

$ilDB->createSequence("frm_posts", 1);


//
// frm_posts_tree
//
$fields = array (
	"fpt_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thr_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pos_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent_pos" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"fpt_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("frm_posts_tree", $fields);

$pk_fields = array("fpt_pk");
$ilDB->addPrimaryKey("frm_posts_tree", $pk_fields);

$ilDB->createSequence("frm_posts_tree", 1);


//
// frm_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"default_view" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"anonymized" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"statistics_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"post_activation" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"admin_force_noti" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_toggle_noti" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"preset_subject" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"notification_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"add_re_subject" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mark_mod_posts" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thread_sorting" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thread_rating" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("frm_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("frm_settings", $pk_fields);


//
// frm_thread_access
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thread_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"access_old" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"access_last" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"access_old_ts" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("frm_thread_access", $fields);

$pk_fields = array("usr_id","obj_id","thread_id");
$ilDB->addPrimaryKey("frm_thread_access", $pk_fields);

$in_fields = array("access_last");
$ilDB->addIndex("frm_thread_access", $in_fields, "i1", false);


//
// frm_threads
//
$fields = array (
	"thr_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thr_top_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thr_subject" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"thr_usr_alias" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"thr_num_posts" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thr_last_post" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"thr_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"thr_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"visits" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_name" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"is_sticky" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_closed" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thread_sorting" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"avg_rating" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"thr_author_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thr_display_user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("frm_threads", $fields);

$pk_fields = array("thr_pk");
$ilDB->addPrimaryKey("frm_threads", $pk_fields);

$in_fields = array("thr_top_fk");
$ilDB->addIndex("frm_threads", $in_fields, "i2", false);

$in_fields = array("thr_subject");
$ilDB->addIndex("frm_threads", $in_fields, "i1", true);

$ilDB->createSequence("frm_threads", 1);


//
// frm_user_read
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"thread_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"post_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("frm_user_read", $fields);

$pk_fields = array("usr_id","obj_id","thread_id","post_id");
$ilDB->addPrimaryKey("frm_user_read", $pk_fields);


//
// glo_advmd_col_order
//
$fields = array (
	"glo_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("glo_advmd_col_order", $fields);

$pk_fields = array("glo_id","field_id");
$ilDB->addPrimaryKey("glo_advmd_col_order", $pk_fields);


//
// glossary
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"virtual" => array (
		"notnull" => false
		,"length" => 7
		,"default" => "none"
		,"fixed" => true
		,"type" => "text"
	)
	,"public_html_file" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"public_xml_file" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"glo_menu_active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "y"
		,"fixed" => true
		,"type" => "text"
	)
	,"downloads_active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"pres_mode" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "table"
		,"fixed" => false
		,"type" => "text"
	)
	,"snippet_length" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "200"
		,"type" => "integer"
	)
	,"show_tax" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("glossary", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("glossary", $pk_fields);


//
// glossary_definition
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"term_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"short_text" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"short_text_dirty" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("glossary_definition", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("glossary_definition", $pk_fields);

$ilDB->createSequence("glossary_definition", 1);


//
// glossary_term
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"glo_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"term" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("glossary_term", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("glossary_term", $pk_fields);

$in_fields = array("glo_id");
$ilDB->addIndex("glossary_term", $in_fields, "i1", false);

$in_fields = array("term");
$ilDB->addIndex("glossary_term", $in_fields, "i2", true);

$ilDB->createSequence("glossary_term", 1);


//
// grp_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"grp_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"registration_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"registration_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"registration_unlimited" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"registration_start" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"registration_end" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"registration_password" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => true
		,"type" => "text"
	)
	,"registration_mem_limit" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"registration_max_members" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"waiting_list" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"latitude" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"longitude" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"location_zoom" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"enablemap" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reg_ac_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"reg_ac" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"view_mode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "6"
		,"type" => "integer"
	)
	,"mail_members_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("grp_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("grp_settings", $pk_fields);


//
// help_map
//
$fields = array (
	"chap" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"component" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"screen_id" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"screen_sub_id" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"perm" => array (
		"notnull" => true
		,"length" => 20
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"module_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("help_map", $fields);

$pk_fields = array("component","screen_id","screen_sub_id","chap","perm","module_id");
$ilDB->addPrimaryKey("help_map", $pk_fields);

$in_fields = array("screen_id");
$ilDB->addIndex("help_map", $in_fields, "sc", false);

$in_fields = array("chap");
$ilDB->addIndex("help_map", $in_fields, "ch", false);


//
// help_module
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("help_module", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("help_module", $pk_fields);

$ilDB->createSequence("help_module", 1);


//
// help_tooltip
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tt_text" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"tt_id" => array (
		"notnull" => true
		,"length" => 200
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"comp" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "de"
		,"fixed" => true
		,"type" => "text"
	)
	,"module_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("help_tooltip", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("help_tooltip", $pk_fields);

$in_fields = array("tt_id","module_id");
$ilDB->addIndex("help_tooltip", $in_fields, "i1", false);

$ilDB->createSequence("help_tooltip", 1);


//
// history
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"action" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"hdate" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"info_params" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"user_comment" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("history", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("history", $pk_fields);

$in_fields = array("obj_id","obj_type");
$ilDB->addIndex("history", $in_fields, "i1", false);

$ilDB->createSequence("history", 1);


//
// il_bibl_attribute
//
$fields = array (
	"entry_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_bibl_attribute", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_bibl_attribute", $pk_fields);

$ilDB->createSequence("il_bibl_attribute", 1);


//
// il_bibl_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"filename" => array (
		"notnull" => false
		,"length" => 256
		,"fixed" => false
		,"type" => "text"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("il_bibl_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_bibl_data", $pk_fields);


//
// il_bibl_entry
//
$fields = array (
	"data_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_bibl_entry", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_bibl_entry", $pk_fields);

$ilDB->createSequence("il_bibl_entry", 1);


//
// il_bibl_overview_model
//
$fields = array (
	"ovm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"filetype" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"literature_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"pattern" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_bibl_overview_model", $fields);

$pk_fields = array("ovm_id");
$ilDB->addPrimaryKey("il_bibl_overview_model", $pk_fields);

$ilDB->insert("il_bibl_overview_model", array(
'ovm_id' => array('integer', '1'), 'filetype' => array('text', 'bib'), 'literature_type' => array('text', 'default'), 'pattern' => array('text', '[<strong>|bib_default_author|</strong> ][|bib_default_title|]: <Emph>[|bib_default_publisher| ][|bib_default_year| ][|bib_default_address|]</Emph>')));

$ilDB->insert("il_bibl_overview_model", array(
'ovm_id' => array('integer', '2'), 'filetype' => array('text', 'ris'), 'literature_type' => array('text', 'default'), 'pattern' => array('text', '[<strong>|ris_default_a1|</strong> ][<strong>|ris_default_au|</strong> ][|ris_default_t1|][ |ris_default_ti|]: <Emph>[|ris_default_pb| ][|ris_default_y1| ][|ris_default_py| ][|ris_default_cy|]</Emph>')));


//
// il_bibl_settings
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 50
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"url" => array (
		"notnull" => true
		,"length" => 128
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"img" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"show_in_list" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_bibl_settings", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_bibl_settings", $pk_fields);

$ilDB->createSequence("il_bibl_settings", 1);


//
// il_block_setting
//
$fields = array (
	"type" => array (
		"notnull" => true
		,"length" => 20
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"block_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"setting" => array (
		"notnull" => true
		,"length" => 40
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_block_setting", $fields);

$pk_fields = array("type","user_id","block_id","setting");
$ilDB->addPrimaryKey("il_block_setting", $pk_fields);


//
// il_blog
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"bg_color" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"font_color" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"img" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"ppic" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rss_active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"approval" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"abs_shorten" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"abs_shorten_len" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"abs_image" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"abs_img_width" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"abs_img_height" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"keywords" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"authors" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"nav_mode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"nav_list_post" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "10"
		,"type" => "integer"
	)
	,"nav_list_mon" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ov_post" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nav_order" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_blog", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_blog", $pk_fields);


//
// il_blog_posting
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"blog_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"created" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"author" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"approved" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_blog_posting", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_blog_posting", $pk_fields);

$in_fields = array("created");
$ilDB->addIndex("il_blog_posting", $in_fields, "i1", false);

$ilDB->createSequence("il_blog_posting", 1);


//
// il_certificate
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_certificate", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("il_certificate", $pk_fields);


//
// il_cld_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"service" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"root_folder" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"root_id" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"owner_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"auth_complete" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("il_cld_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_cld_data", $pk_fields);


//
// il_component
//
$fields = array (
	"type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_component", $fields);

$pk_fields = array("type","id");
$ilDB->addPrimaryKey("il_component", $pk_fields);

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'WorkspaceFolder'), 'id' => array('text', 'wfld')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteLearningModule'), 'id' => array('text', 'rlm')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Bibliographic'), 'id' => array('text', 'bibl')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteTest'), 'id' => array('text', 'rtst')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteGlossary'), 'id' => array('text', 'rglo')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'WebResource'), 'id' => array('text', 'webr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'DataCollection'), 'id' => array('text', 'dcl')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Portfolio'), 'id' => array('text', 'prtf')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'SurveyQuestionPool'), 'id' => array('text', 'spl')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Test'), 'id' => array('text', 'tst')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'HTMLLearningModule'), 'id' => array('text', 'htlm')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'MediaCast'), 'id' => array('text', 'mcst')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'WorkspaceRootFolder'), 'id' => array('text', 'wsrt')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'ScormAicc'), 'id' => array('text', 'sahs')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Course'), 'id' => array('text', 'crs')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'LearningModule'), 'id' => array('text', 'lm')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'ExternalFeed'), 'id' => array('text', 'feed')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RootFolder'), 'id' => array('text', 'root')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'BookingManager'), 'id' => array('text', 'book')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Blog'), 'id' => array('text', 'blog')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Folder'), 'id' => array('text', 'fold')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Wiki'), 'id' => array('text', 'wiki')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteCourse'), 'id' => array('text', 'rcrs')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Cloud'), 'id' => array('text', 'cld')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'CategoryReference'), 'id' => array('text', 'catr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteCategory'), 'id' => array('text', 'rcat')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'OrgUnit'), 'id' => array('text', 'orgu')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteGroup'), 'id' => array('text', 'rgrp')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'TestQuestionPool'), 'id' => array('text', 'qpl')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Survey'), 'id' => array('text', 'svy')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteFile'), 'id' => array('text', 'rfil')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'SystemFolder'), 'id' => array('text', 'adm')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Session'), 'id' => array('text', 'sess')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Forum'), 'id' => array('text', 'frm')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Poll'), 'id' => array('text', 'poll')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'CourseReference'), 'id' => array('text', 'crsr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Scorm2004'), 'id' => array('text', 'sc13')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'ItemGroup'), 'id' => array('text', 'itgr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Glossary'), 'id' => array('text', 'glo')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'RemoteWiki'), 'id' => array('text', 'rwik')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Group'), 'id' => array('text', 'grp')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Exercise'), 'id' => array('text', 'exc')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'ILinc'), 'id' => array('text', 'ilnc')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Chatroom'), 'id' => array('text', 'chtr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'File'), 'id' => array('text', 'file')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'Category'), 'id' => array('text', 'cat')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Modules'), 'name' => array('text', 'MediaPool'), 'id' => array('text', 'mep')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Calendar'), 'id' => array('text', 'cal')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Skill'), 'id' => array('text', 'skll')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'MetaData'), 'id' => array('text', 'meta')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Membership'), 'id' => array('text', 'mmbr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Imprint'), 'id' => array('text', 'impr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'AdvancedMetaData'), 'id' => array('text', 'amet')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Component'), 'id' => array('text', 'comp')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'COPage'), 'id' => array('text', 'copg')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'DidacticTemplate'), 'id' => array('text', 'otpl')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'AdvancedEditing'), 'id' => array('text', 'adve')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'AccessControl'), 'id' => array('text', 'ac')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Tracking'), 'id' => array('text', 'trac')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Mail'), 'id' => array('text', 'mail')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Notifications'), 'id' => array('text', 'nota')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'WebDAV'), 'id' => array('text', 'wbdv')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Taxonomy'), 'id' => array('text', 'tax')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Language'), 'id' => array('text', 'lang')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Style'), 'id' => array('text', 'styl')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Certificate'), 'id' => array('text', 'cert')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'TermsOfService'), 'id' => array('text', 'tos')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'User'), 'id' => array('text', 'user')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Authentication'), 'id' => array('text', 'auth')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Accessibility'), 'id' => array('text', 'acc')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Repository'), 'id' => array('text', 'rep')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Navigation'), 'id' => array('text', 'navh')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Payment'), 'id' => array('text', 'paym')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Help'), 'id' => array('text', 'help')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'UIComponent'), 'id' => array('text', 'ui')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Container'), 'id' => array('text', 'cont')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'LDAP'), 'id' => array('text', 'ldap')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'ContainerReference'), 'id' => array('text', 'cntr')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'EventHandling'), 'id' => array('text', 'evnt')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Init'), 'id' => array('text', 'init')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'SystemCheck'), 'id' => array('text', 'sysc')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Tagging'), 'id' => array('text', 'tag')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Administration'), 'id' => array('text', 'adm')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Object'), 'id' => array('text', 'obj')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'PersonalWorkspace'), 'id' => array('text', 'pwsp')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'WebServices'), 'id' => array('text', 'wsrv')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Preview'), 'id' => array('text', 'prvw')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'AuthShibboleth'), 'id' => array('text', 'shiba')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'PersonalDesktop'), 'id' => array('text', 'pdsk')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Accordion'), 'id' => array('text', 'accrdn')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Table'), 'id' => array('text', 'table')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'MediaObjects'), 'id' => array('text', 'mob')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'News'), 'id' => array('text', 'news')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'PrivacySecurity'), 'id' => array('text', 'ps')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Link'), 'id' => array('text', 'link')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Cron'), 'id' => array('text', 'cron')));

$ilDB->insert("il_component", array(
'type' => array('text', 'Services'), 'name' => array('text', 'Search'), 'id' => array('text', 'src')));


//
// il_custom_block
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"context_obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"context_obj_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"context_sub_obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"context_sub_obj_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_custom_block", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_custom_block", $pk_fields);

$ilDB->createSequence("il_custom_block", 1);


//
// il_dcl_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"main_table_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rating" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"public_notes" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"approval" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"notification" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_data", $pk_fields);

$ilDB->createSequence("il_dcl_data", 1);


//
// il_dcl_datatype
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 256
		,"fixed" => false
		,"type" => "text"
	)
	,"ildb_type" => array (
		"notnull" => true
		,"length" => 256
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"storage_location" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"sort" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_datatype", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_datatype", $pk_fields);

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '1'), 'title' => array('text', 'integer'), 'ildb_type' => array('text', 'integer'), 'storage_location' => array('integer', '2'), 'sort' => array('integer', '10')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '2'), 'title' => array('text', 'text'), 'ildb_type' => array('text', 'text'), 'storage_location' => array('integer', '1'), 'sort' => array('integer', '0')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '3'), 'title' => array('text', 'reference'), 'ildb_type' => array('text', 'integer'), 'storage_location' => array('integer', '2'), 'sort' => array('integer', '60')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '4'), 'title' => array('text', 'boolean'), 'ildb_type' => array('text', 'integer'), 'storage_location' => array('integer', '2'), 'sort' => array('integer', '20')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '5'), 'title' => array('text', 'datetime'), 'ildb_type' => array('text', 'date'), 'storage_location' => array('integer', '3'), 'sort' => array('integer', '30')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '6'), 'title' => array('text', 'file'), 'ildb_type' => array('text', 'integer'), 'storage_location' => array('integer', '2'), 'sort' => array('integer', '50')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '7'), 'title' => array('text', 'rating'), 'ildb_type' => array('text', 'integer'), 'storage_location' => array('integer', '0'), 'sort' => array('integer', '80')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '8'), 'title' => array('text', 'ILIAS_reference'), 'ildb_type' => array('text', 'integer'), 'storage_location' => array('integer', '2'), 'sort' => array('integer', '70')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '9'), 'title' => array('text', 'mob'), 'ildb_type' => array('text', 'integer'), 'storage_location' => array('integer', '2'), 'sort' => array('integer', '40')));

$ilDB->insert("il_dcl_datatype", array(
'id' => array('integer', '11'), 'title' => array('text', 'formula'), 'ildb_type' => array('text', 'text'), 'storage_location' => array('integer', '0'), 'sort' => array('integer', '90')));


//
// il_dcl_datatype_prop
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"datatype_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 256
		,"fixed" => false
		,"type" => "text"
	)
	,"inputformat" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_datatype_prop", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_datatype_prop", $pk_fields);

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '1'), 'datatype_id' => array('integer', '2'), 'title' => array('text', 'length'), 'inputformat' => array('integer', '1')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '2'), 'datatype_id' => array('integer', '2'), 'title' => array('text', 'regex'), 'inputformat' => array('integer', '2')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '3'), 'datatype_id' => array('integer', '3'), 'title' => array('text', 'table_id'), 'inputformat' => array('integer', '1')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '4'), 'datatype_id' => array('integer', '2'), 'title' => array('text', 'url'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '5'), 'datatype_id' => array('integer', '2'), 'title' => array('text', 'text_area'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '6'), 'datatype_id' => array('integer', '3'), 'title' => array('text', 'reference_link'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '7'), 'datatype_id' => array('integer', '9'), 'title' => array('text', 'width'), 'inputformat' => array('integer', '1')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '8'), 'datatype_id' => array('integer', '9'), 'title' => array('text', 'height'), 'inputformat' => array('integer', '1')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '9'), 'datatype_id' => array('integer', '8'), 'title' => array('text', 'learning_progress'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '10'), 'datatype_id' => array('integer', '8'), 'title' => array('text', 'ILIAS_reference_link'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '11'), 'datatype_id' => array('integer', '3'), 'title' => array('text', 'multiple_selection'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '12'), 'datatype_id' => array('integer', '11'), 'title' => array('text', 'expression'), 'inputformat' => array('integer', '2')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '13'), 'datatype_id' => array('integer', '8'), 'title' => array('text', 'display_action_menu'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '14'), 'datatype_id' => array('integer', '2'), 'title' => array('text', 'link_detail_page'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '15'), 'datatype_id' => array('integer', '9'), 'title' => array('text', 'link_detail_page'), 'inputformat' => array('integer', '4')));

$ilDB->insert("il_dcl_datatype_prop", array(
'id' => array('integer', '16'), 'datatype_id' => array('integer', '9'), 'title' => array('text', 'allowed_file_types'), 'inputformat' => array('integer', '12')));


//
// il_dcl_field
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"table_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 256
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"datatype_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"required" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"is_unique" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_locked" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_field", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_field", $pk_fields);

$ilDB->createSequence("il_dcl_field", 1);


//
// il_dcl_field_prop
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"datatype_prop_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 256
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_dcl_field_prop", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_field_prop", $pk_fields);

$ilDB->createSequence("il_dcl_field_prop", 1);


//
// il_dcl_record
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"table_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"owner" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"last_edit_by" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_record", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_record", $pk_fields);

$ilDB->createSequence("il_dcl_record", 1);


//
// il_dcl_record_field
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"record_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_record_field", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_record_field", $pk_fields);

$ilDB->createSequence("il_dcl_record_field", 1);


//
// il_dcl_stloc1_value
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"record_field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_dcl_stloc1_value", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_stloc1_value", $pk_fields);

$ilDB->createSequence("il_dcl_stloc1_value", 1);


//
// il_dcl_stloc2_value
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"record_field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_stloc2_value", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_stloc2_value", $pk_fields);

$ilDB->createSequence("il_dcl_stloc2_value", 1);


//
// il_dcl_stloc3_value
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"record_field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
);
$ilDB->createTable("il_dcl_stloc3_value", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_stloc3_value", $pk_fields);

$ilDB->createSequence("il_dcl_stloc3_value", 1);


//
// il_dcl_table
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 256
		,"fixed" => false
		,"type" => "text"
	)
	,"add_perm" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"edit_perm" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"delete_perm" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"edit_by_owner" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"limited" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"limit_start" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"limit_end" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"is_visible" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"export_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"default_sort_field_id" => array (
		"notnull" => true
		,"length" => 16
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"default_sort_field_order" => array (
		"notnull" => true
		,"length" => 4
		,"default" => "asc"
		,"fixed" => false
		,"type" => "text"
	)
	,"public_comments" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"view_own_records_perm" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_table", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_table", $pk_fields);

$ilDB->createSequence("il_dcl_table", 1);


//
// il_dcl_view
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"table_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"formtype" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_view", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_dcl_view", $pk_fields);

$ilDB->createSequence("il_dcl_view", 1);


//
// il_dcl_viewdefinition
//
$fields = array (
	"view_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"field" => array (
		"notnull" => true
		,"length" => 255
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"field_order" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"is_set" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_dcl_viewdefinition", $fields);


//
// il_disk_quota
//
$fields = array (
	"owner_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"src_type" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"src_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"src_size" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_disk_quota", $fields);

$pk_fields = array("owner_id","src_type","src_obj_id");
$ilDB->addPrimaryKey("il_disk_quota", $pk_fields);


//
// il_event_handling
//
$fields = array (
	"component" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_event_handling", $fields);

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/Tracking')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'raise'), 'id' => array('text', 'create')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'raise'), 'id' => array('text', 'update')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'raise'), 'id' => array('text', 'delete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'raise'), 'id' => array('text', 'addParticipant')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'raise'), 'id' => array('text', 'deleteParticipant')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'raise'), 'id' => array('text', 'addToWaitingList')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Course'), 'type' => array('text', 'raise'), 'id' => array('text', 'addSubscriber')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/OrgUnit'), 'type' => array('text', 'raise'), 'id' => array('text', 'delete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Session'), 'type' => array('text', 'raise'), 'id' => array('text', 'create')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Session'), 'type' => array('text', 'raise'), 'id' => array('text', 'update')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Session'), 'type' => array('text', 'raise'), 'id' => array('text', 'delete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Session'), 'type' => array('text', 'raise'), 'id' => array('text', 'addToWaitingList')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Session'), 'type' => array('text', 'raise'), 'id' => array('text', 'addSubscriber')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Forum'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/News')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Forum'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Course')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Forum'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Group')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Group'), 'type' => array('text', 'raise'), 'id' => array('text', 'create')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Group'), 'type' => array('text', 'raise'), 'id' => array('text', 'update')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Group'), 'type' => array('text', 'raise'), 'id' => array('text', 'delete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Group'), 'type' => array('text', 'raise'), 'id' => array('text', 'addParticipant')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Group'), 'type' => array('text', 'raise'), 'id' => array('text', 'deleteParticipant')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Group'), 'type' => array('text', 'raise'), 'id' => array('text', 'addToWaitingList')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Group'), 'type' => array('text', 'raise'), 'id' => array('text', 'addSubscriber')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Exercise'), 'type' => array('text', 'raise'), 'id' => array('text', 'createAssignment')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Exercise'), 'type' => array('text', 'raise'), 'id' => array('text', 'updateAssignment')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Exercise'), 'type' => array('text', 'raise'), 'id' => array('text', 'deleteAssignment')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Exercise'), 'type' => array('text', 'raise'), 'id' => array('text', 'delete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/Category'), 'type' => array('text', 'raise'), 'id' => array('text', 'delete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Modules/MediaPool'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/Object')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Calendar'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Group')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Calendar'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Session')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Calendar'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Course')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Calendar'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Exercise')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Tracking'), 'type' => array('text', 'raise'), 'id' => array('text', 'updateStatus')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Tracking'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/Object')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Tracking'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/Tree')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/TermsOfService'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/User')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/User'), 'type' => array('text', 'raise'), 'id' => array('text', 'afterUpdate')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/User'), 'type' => array('text', 'raise'), 'id' => array('text', 'deleteUser')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/User'), 'type' => array('text', 'raise'), 'id' => array('text', 'afterCreate')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Authentication'), 'type' => array('text', 'raise'), 'id' => array('text', 'afterLogin')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Authentication'), 'type' => array('text', 'raise'), 'id' => array('text', 'expiredSessionDetected')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Authentication'), 'type' => array('text', 'raise'), 'id' => array('text', 'reachedSessionPoolLimit')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/ContainerReference'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Course')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/ContainerReference'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Category')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Tagging'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/Object')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Object'), 'type' => array('text', 'raise'), 'id' => array('text', 'create')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Object'), 'type' => array('text', 'raise'), 'id' => array('text', 'update')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Object'), 'type' => array('text', 'raise'), 'id' => array('text', 'toTrash')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Object'), 'type' => array('text', 'raise'), 'id' => array('text', 'delete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Object'), 'type' => array('text', 'raise'), 'id' => array('text', 'undelete')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/WebServices/ECS'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Course')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/WebServices/ECS'), 'type' => array('text', 'listen'), 'id' => array('text', 'Modules/Group')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/WebServices/ECS'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/User')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/News'), 'type' => array('text', 'raise'), 'id' => array('text', 'readNews')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/News'), 'type' => array('text', 'raise'), 'id' => array('text', 'unreadNews')));

$ilDB->insert("il_event_handling", array(
'component' => array('text', 'Services/Search'), 'type' => array('text', 'listen'), 'id' => array('text', 'Services/Object')));


//
// il_exc_team
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ass_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_exc_team", $fields);

$pk_fields = array("ass_id","user_id");
$ilDB->addPrimaryKey("il_exc_team", $pk_fields);

$ilDB->createSequence("il_exc_team", 1);


//
// il_exc_team_log
//
$fields = array (
	"team_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"details" => array (
		"notnull" => false
		,"length" => 500
		,"fixed" => false
		,"type" => "text"
	)
	,"action" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_exc_team_log", $fields);


//
// il_external_feed_block
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"feed_url" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_external_feed_block", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_external_feed_block", $pk_fields);

$ilDB->createSequence("il_external_feed_block", 1);


//
// il_html_block
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"content" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_html_block", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_html_block", $pk_fields);


//
// il_log
//
$fields = array (
	"created" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"log_level" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"message" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
	,"module" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_log", $fields);

$in_fields = array("created");
$ilDB->addIndex("il_log", $in_fields, "i1", false);

$in_fields = array("module");
$ilDB->addIndex("il_log", $in_fields, "i2", false);

$in_fields = array("log_level");
$ilDB->addIndex("il_log", $in_fields, "i3", false);


//
// il_md_cpr_selections
//
$fields = array (
	"entry_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"copyright" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"costs" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cpr_restrictions" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_md_cpr_selections", $fields);

$pk_fields = array("entry_id");
$ilDB->addPrimaryKey("il_md_cpr_selections", $pk_fields);

$ilDB->createSequence("il_md_cpr_selections", 7);

$ilDB->insert("il_md_cpr_selections", array(
'entry_id' => array('integer', '1'), 'title' => array('text', 'Attribution Non-commercial No Derivatives'), 'description' => array('clob', 'Creative Commons License'), 'copyright' => array('clob', '<a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/3.0/">
<img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-nd/3.0/88x31.png" />
</a>
<br />This 
<span xmlns:dc="http://purl.org/dc/elements/1.1/" href="http://purl.org/dc/dcmitype/" rel="dc:type">work</span> is licensed under a 
<a rel="license" href="http://creativecommons.org/licenses/by-nc-nd/3.0/">Creative Commons Attribution-Noncommercial-No Derivative Works 3.0 License</a>.'), 'language' => array('text', 'en'), 'costs' => array('integer', '0'), 'cpr_restrictions' => array('integer', '1')));

$ilDB->insert("il_md_cpr_selections", array(
'entry_id' => array('integer', '2'), 'title' => array('text', 'Attribution Non-commercial Share Alike (by-nc-sa)'), 'description' => array('clob', 'Creative Commons License'), 'copyright' => array('clob', '<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/3.0/">
<img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-sa/3.0/88x31.png" />
</a>
<br />This 
<span xmlns:dc="http://purl.org/dc/elements/1.1/" href="http://purl.org/dc/dcmitype/" rel="dc:type">work</span> is licensed under a 
<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/3.0/">Creative Commons Attribution-Noncommercial-Share Alike 3.0 License</a>.'), 'language' => array('text', 'en'), 'costs' => array('integer', '0'), 'cpr_restrictions' => array('integer', '1')));

$ilDB->insert("il_md_cpr_selections", array(
'entry_id' => array('integer', '3'), 'title' => array('text', 'Attribution Non-commercial (by-nc)'), 'description' => array('clob', 'Creative Commons License'), 'copyright' => array('clob', '<a rel="license" href="http://creativecommons.org/licenses/by-nc/3.0/">
<img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc/3.0/88x31.png" />
</a>
<br />This 
<span xmlns:dc="http://purl.org/dc/elements/1.1/" href="http://purl.org/dc/dcmitype/" rel="dc:type">work</span> is licensed under a 
<a rel="license" href="http://creativecommons.org/licenses/by-nc/3.0/">Creative Commons Attribution-Noncommercial 3.0 License</a>.'), 'language' => array('text', 'en'), 'costs' => array('integer', '0'), 'cpr_restrictions' => array('integer', '1')));

$ilDB->insert("il_md_cpr_selections", array(
'entry_id' => array('integer', '4'), 'title' => array('text', 'Attribution No Derivatives (by-nd)'), 'description' => array('clob', 'Creative Commons License'), 'copyright' => array('clob', '<a rel="license" href="http://creativecommons.org/licenses/by-nd/3.0/">
<img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nd/3.0/88x31.png" />
</a>
<br />This 
<span xmlns:dc="http://purl.org/dc/elements/1.1/" href="http://purl.org/dc/dcmitype/" rel="dc:type">work</span> is licensed under a 
<a rel="license" href="http://creativecommons.org/licenses/by-nd/3.0/">Creative Commons Attribution-No Derivative Works 3.0 License</a>.'), 'language' => array('text', 'en'), 'costs' => array('integer', '0'), 'cpr_restrictions' => array('integer', '1')));

$ilDB->insert("il_md_cpr_selections", array(
'entry_id' => array('integer', '5'), 'title' => array('text', 'Attribution Share Alike (by-sa)'), 'description' => array('clob', 'Creative Commons License'), 'copyright' => array('clob', '<a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">
<img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" />
</a>
<br />This 
<span xmlns:dc="http://purl.org/dc/elements/1.1/" href="http://purl.org/dc/dcmitype/" rel="dc:type">work</span> is licensed under a 
<a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-Share Alike 3.0 License</a>.'), 'language' => array('text', 'en'), 'costs' => array('integer', '0'), 'cpr_restrictions' => array('integer', '1')));

$ilDB->insert("il_md_cpr_selections", array(
'entry_id' => array('integer', '6'), 'title' => array('text', 'Attribution (by)'), 'description' => array('clob', 'Creative Commons License'), 'copyright' => array('clob', '<a rel="license" href="http://creativecommons.org/licenses/by/3.0/">
<img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by/3.0/88x31.png" />
</a>
<br />This 
<span xmlns:dc="http://purl.org/dc/elements/1.1/" href=\\"http://purl.org/dc/dcmitype/" rel="dc:type">work</span> is licensed under a 
<a rel="license" href="http://creativecommons.org/licenses/by/3.0/">Creative Commons Attribution 3.0 License</a>.'), 'language' => array('text', 'en'), 'costs' => array('integer', '0'), 'cpr_restrictions' => array('integer', '1')));


//
// il_media_cast_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"public_files" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"downloadable" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"def_access" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sortmode" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "3"
		,"type" => "integer"
	)
	,"viewmode" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_media_cast_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_media_cast_data", $pk_fields);


//
// il_media_cast_data_ord
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"pos" => array (
		"notnull" => true
		,"length" => 3
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_media_cast_data_ord", $fields);

$pk_fields = array("obj_id","item_id");
$ilDB->addPrimaryKey("il_media_cast_data_ord", $pk_fields);


//
// il_meta_annotation
//
$fields = array (
	"meta_annotation_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"entity" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"a_date" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"description_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_annotation", $fields);

$pk_fields = array("meta_annotation_id");
$ilDB->addPrimaryKey("il_meta_annotation", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_annotation", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_annotation", 1);


//
// il_meta_classification
//
$fields = array (
	"meta_classification_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"purpose" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"description_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_classification", $fields);

$pk_fields = array("meta_classification_id");
$ilDB->addPrimaryKey("il_meta_classification", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_classification", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_classification", 1);


//
// il_meta_contribute
//
$fields = array (
	"meta_contribute_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"role" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"c_date" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_contribute", $fields);

$pk_fields = array("meta_contribute_id");
$ilDB->addPrimaryKey("il_meta_contribute", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_contribute", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_contribute", 1);


//
// il_meta_description
//
$fields = array (
	"meta_description_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"description_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_description", $fields);

$pk_fields = array("meta_description_id");
$ilDB->addPrimaryKey("il_meta_description", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_description", $in_fields, "i1", false);

$in_fields = array("description");
$ilDB->addIndex("il_meta_description", $in_fields, "i2", true);

$ilDB->createSequence("il_meta_description", 1);


//
// il_meta_educational
//
$fields = array (
	"meta_educational_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"interactivity_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"learning_resource_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"interactivity_level" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"semantic_density" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"intended_end_user_role" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"context" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"difficulty" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"typical_learning_time" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_educational", $fields);

$pk_fields = array("meta_educational_id");
$ilDB->addPrimaryKey("il_meta_educational", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_educational", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_educational", 1);


//
// il_meta_entity
//
$fields = array (
	"meta_entity_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"entity" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_entity", $fields);

$pk_fields = array("meta_entity_id");
$ilDB->addPrimaryKey("il_meta_entity", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_entity", $in_fields, "i1", false);

$in_fields = array("entity");
$ilDB->addIndex("il_meta_entity", $in_fields, "i2", true);

$ilDB->createSequence("il_meta_entity", 1);


//
// il_meta_format
//
$fields = array (
	"meta_format_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"format" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_format", $fields);

$pk_fields = array("meta_format_id");
$ilDB->addPrimaryKey("il_meta_format", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_format", $in_fields, "i1", false);

$in_fields = array("format");
$ilDB->addIndex("il_meta_format", $in_fields, "i2", false);

$ilDB->createSequence("il_meta_format", 1);


//
// il_meta_general
//
$fields = array (
	"meta_general_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"general_structure" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"title_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"coverage" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"coverage_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_general", $fields);

$pk_fields = array("meta_general_id");
$ilDB->addPrimaryKey("il_meta_general", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_general", $in_fields, "i1", false);

$in_fields = array("title","coverage");
$ilDB->addIndex("il_meta_general", $in_fields, "i2", true);

$ilDB->createSequence("il_meta_general", 1);


//
// il_meta_identifier
//
$fields = array (
	"meta_identifier_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"catalog" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"entry" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_identifier", $fields);

$pk_fields = array("meta_identifier_id");
$ilDB->addPrimaryKey("il_meta_identifier", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_identifier", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_identifier", 1);


//
// il_meta_identifier_
//
$fields = array (
	"meta_identifier__id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"catalog" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"entry" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_identifier_", $fields);

$pk_fields = array("meta_identifier__id");
$ilDB->addPrimaryKey("il_meta_identifier_", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_identifier_", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_identifier_", 1);


//
// il_meta_keyword
//
$fields = array (
	"meta_keyword_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"keyword" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"keyword_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_keyword", $fields);

$pk_fields = array("meta_keyword_id");
$ilDB->addPrimaryKey("il_meta_keyword", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_keyword", $in_fields, "i1", false);

$in_fields = array("keyword");
$ilDB->addIndex("il_meta_keyword", $in_fields, "i2", true);

$ilDB->createSequence("il_meta_keyword", 1);


//
// il_meta_language
//
$fields = array (
	"meta_language_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_language", $fields);

$pk_fields = array("meta_language_id");
$ilDB->addPrimaryKey("il_meta_language", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_language", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_language", 1);


//
// il_meta_lifecycle
//
$fields = array (
	"meta_lifecycle_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"lifecycle_status" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"meta_version" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"version_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_lifecycle", $fields);

$pk_fields = array("meta_lifecycle_id");
$ilDB->addPrimaryKey("il_meta_lifecycle", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_lifecycle", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_lifecycle", 1);


//
// il_meta_location
//
$fields = array (
	"meta_location_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"location" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"location_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_location", $fields);

$pk_fields = array("meta_location_id");
$ilDB->addPrimaryKey("il_meta_location", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_location", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_location", 1);


//
// il_meta_meta_data
//
$fields = array (
	"meta_meta_data_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"meta_data_scheme" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
	,"language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_meta_data", $fields);

$pk_fields = array("meta_meta_data_id");
$ilDB->addPrimaryKey("il_meta_meta_data", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_meta_data", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_meta_data", 1);


//
// il_meta_relation
//
$fields = array (
	"meta_relation_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"kind" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_relation", $fields);

$pk_fields = array("meta_relation_id");
$ilDB->addPrimaryKey("il_meta_relation", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_relation", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_relation", 1);


//
// il_meta_requirement
//
$fields = array (
	"meta_requirement_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"operating_system_name" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"os_min_version" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"os_max_version" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"browser_name" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"browser_minimum_version" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"browser_maximum_version" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"or_composite_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_meta_requirement", $fields);

$pk_fields = array("meta_requirement_id");
$ilDB->addPrimaryKey("il_meta_requirement", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_requirement", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_requirement", 1);


//
// il_meta_rights
//
$fields = array (
	"meta_rights_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"costs" => array (
		"notnull" => false
		,"length" => 3
		,"fixed" => true
		,"type" => "text"
	)
	,"cpr_and_or" => array (
		"notnull" => false
		,"length" => 3
		,"fixed" => true
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"description_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_rights", $fields);

$pk_fields = array("meta_rights_id");
$ilDB->addPrimaryKey("il_meta_rights", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_rights", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_rights", 1);


//
// il_meta_tar
//
$fields = array (
	"meta_tar_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"typical_age_range" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"tar_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"tar_min" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"tar_max" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_tar", $fields);

$pk_fields = array("meta_tar_id");
$ilDB->addPrimaryKey("il_meta_tar", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_tar", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_tar", 1);


//
// il_meta_taxon
//
$fields = array (
	"meta_taxon_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"taxon" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"taxon_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"taxon_id" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_taxon", $fields);

$pk_fields = array("meta_taxon_id");
$ilDB->addPrimaryKey("il_meta_taxon", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_taxon", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_taxon", 1);


//
// il_meta_taxon_path
//
$fields = array (
	"meta_taxon_path_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"source" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"source_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_taxon_path", $fields);

$pk_fields = array("meta_taxon_path_id");
$ilDB->addPrimaryKey("il_meta_taxon_path", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_taxon_path", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_taxon_path", 1);


//
// il_meta_technical
//
$fields = array (
	"meta_technical_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"t_size" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"ir" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"ir_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"opr" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"opr_language" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"duration" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_meta_technical", $fields);

$pk_fields = array("meta_technical_id");
$ilDB->addPrimaryKey("il_meta_technical", $pk_fields);

$in_fields = array("rbac_id","obj_id");
$ilDB->addIndex("il_meta_technical", $in_fields, "i1", false);

$ilDB->createSequence("il_meta_technical", 1);


//
// il_new_item_grp
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"titles" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"pos" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_new_item_grp", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_new_item_grp", $pk_fields);

$ilDB->createSequence("il_new_item_grp", 1);


//
// il_news_item
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"priority" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"content" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"context_obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"context_obj_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"context_sub_obj_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"context_sub_obj_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"content_type" => array (
		"notnull" => false
		,"length" => 5
		,"default" => "text"
		,"fixed" => true
		,"type" => "text"
	)
	,"creation_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"update_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"user_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"visibility" => array (
		"notnull" => false
		,"length" => 6
		,"default" => "users"
		,"fixed" => true
		,"type" => "text"
	)
	,"content_long" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"content_is_lang_var" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mob_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"playtime" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"start_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"end_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"content_text_is_lang_var" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mob_cnt_download" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mob_cnt_play" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_news_item", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_news_item", $pk_fields);

$in_fields = array("context_obj_id");
$ilDB->addIndex("il_news_item", $in_fields, "i1", false);

$in_fields = array("creation_date");
$ilDB->addIndex("il_news_item", $in_fields, "i2", false);

$in_fields = array("mob_id");
$ilDB->addIndex("il_news_item", $in_fields, "mo", false);

$ilDB->createSequence("il_news_item", 1);


//
// il_news_read
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"news_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_news_read", $fields);

$pk_fields = array("user_id","news_id");
$ilDB->addPrimaryKey("il_news_read", $pk_fields);

$in_fields = array("user_id");
$ilDB->addIndex("il_news_read", $in_fields, "i1", false);

$in_fields = array("news_id");
$ilDB->addIndex("il_news_read", $in_fields, "i2", false);


//
// il_news_subscription
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_news_subscription", $fields);

$pk_fields = array("user_id","ref_id");
$ilDB->addPrimaryKey("il_news_subscription", $pk_fields);


//
// il_object_def
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"class_name" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"component" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"location" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
	,"checkbox" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"inherit" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"translate" => array (
		"notnull" => false
		,"length" => 5
		,"fixed" => true
		,"type" => "text"
	)
	,"devmode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"allow_link" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"allow_copy" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rbac" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"system" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sideblock" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"default_pos" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"grp" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => true
		,"type" => "text"
	)
	,"default_pres_pos" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"export" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"repository" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"workspace" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"administration" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"amet" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_object_def", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_object_def", $pk_fields);

$ilDB->insert("il_object_def", array(
'id' => array('text', 'wfld'), 'class_name' => array('text', 'WorkspaceFolder'), 'component' => array('text', 'Modules/WorkspaceFolder'), 'location' => array('text', 'Modules/WorkspaceFolder/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '300'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '300'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rlm'), 'class_name' => array('text', 'RemoteLearningModule'), 'component' => array('text', 'Modules/RemoteLearningModule'), 'location' => array('text', 'Modules/RemoteLearningModule/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'lres'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'bibl'), 'class_name' => array('text', 'Bibliographic'), 'component' => array('text', 'Modules/Bibliographic'), 'location' => array('text', 'Modules/Bibliographic/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '360'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '360'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'bibs'), 'class_name' => array('text', 'BibliographicAdmin'), 'component' => array('text', 'Modules/Bibliographic'), 'location' => array('text', 'Modules/Bibliographic/classes/Admin'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rtst'), 'class_name' => array('text', 'RemoteTest'), 'component' => array('text', 'Modules/RemoteTest'), 'location' => array('text', 'Modules/RemoteTest/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'tst'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rglo'), 'class_name' => array('text', 'RemoteGlossary'), 'component' => array('text', 'Modules/RemoteGlossary'), 'location' => array('text', 'Modules/RemoteGlossary/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'glo'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'webr'), 'class_name' => array('text', 'LinkResource'), 'component' => array('text', 'Modules/WebResource'), 'location' => array('text', 'Modules/WebResource/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '100'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '120'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'wbrs'), 'class_name' => array('text', 'WebResourceAdministration'), 'component' => array('text', 'Modules/WebResource'), 'location' => array('text', 'Modules/WebResource/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'dcl'), 'class_name' => array('text', 'DataCollection'), 'component' => array('text', 'Modules/DataCollection'), 'location' => array('text', 'Modules/DataCollection/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '340'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '340'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'prtf'), 'class_name' => array('text', 'Portfolio'), 'component' => array('text', 'Modules/Portfolio'), 'location' => array('text', 'Modules/Portfolio/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'prtt'), 'class_name' => array('text', 'PortfolioTemplate'), 'component' => array('text', 'Modules/Portfolio'), 'location' => array('text', 'Modules/Portfolio/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '500'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '500'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'prfa'), 'class_name' => array('text', 'PortfolioAdministration'), 'component' => array('text', 'Modules/Portfolio'), 'location' => array('text', 'Modules/Portfolio/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'spl'), 'class_name' => array('text', 'SurveyQuestionPool'), 'component' => array('text', 'Modules/SurveyQuestionPool'), 'location' => array('text', 'Modules/SurveyQuestionPool/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '220'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '210'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'tst'), 'class_name' => array('text', 'Test'), 'component' => array('text', 'Modules/Test'), 'location' => array('text', 'Modules/Test/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '180'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '170'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'assf'), 'class_name' => array('text', 'AssessmentFolder'), 'component' => array('text', 'Modules/Test'), 'location' => array('text', 'Modules/Test/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'tstv'), 'class_name' => array('text', 'TestVerification'), 'component' => array('text', 'Modules/Test'), 'location' => array('text', 'Modules/Test/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '90'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '150'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'htlm'), 'class_name' => array('text', 'FileBasedLM'), 'component' => array('text', 'Modules/HTMLLearningModule'), 'location' => array('text', 'Modules/HTMLLearningModule/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '130'), 'grp' => array('text', 'lres'), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'mcst'), 'class_name' => array('text', 'MediaCast'), 'component' => array('text', 'Modules/MediaCast'), 'location' => array('text', 'Modules/MediaCast/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', ''), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '110'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '130'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'mcts'), 'class_name' => array('text', 'MediaCastSettings'), 'component' => array('text', 'Modules/MediaCast'), 'location' => array('text', 'Modules/MediaCast/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'wsrt'), 'class_name' => array('text', 'WorkspaceRootFolder'), 'component' => array('text', 'Modules/WorkspaceRootFolder'), 'location' => array('text', 'Modules/WorkspaceRootFolder/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'sahs'), 'class_name' => array('text', 'SAHSLearningModule'), 'component' => array('text', 'Modules/ScormAicc'), 'location' => array('text', 'Modules/ScormAicc/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '140'), 'grp' => array('text', 'lres'), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'scov'), 'class_name' => array('text', 'SCORMVerification'), 'component' => array('text', 'Modules/ScormAicc'), 'location' => array('text', 'Modules/ScormAicc/classes/Verification'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '90'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '150'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'crs'), 'class_name' => array('text', 'Course'), 'component' => array('text', 'Modules/Course'), 'location' => array('text', 'Modules/Course/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '20'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '30'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '1')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'crss'), 'class_name' => array('text', 'CourseAdministration'), 'component' => array('text', 'Modules/Course'), 'location' => array('text', 'Modules/Course/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'crsv'), 'class_name' => array('text', 'CourseVerification'), 'component' => array('text', 'Modules/Course'), 'location' => array('text', 'Modules/Course/classes/Verification'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '90'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '150'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'lm'), 'class_name' => array('text', 'LearningModule'), 'component' => array('text', 'Modules/LearningModule'), 'location' => array('text', 'Modules/LearningModule/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', 'db'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '120'), 'grp' => array('text', 'lres'), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'lrss'), 'class_name' => array('text', 'LearningResourcesSettings'), 'component' => array('text', 'Modules/LearningModule'), 'location' => array('text', 'Modules/LearningModule/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'feed'), 'class_name' => array('text', 'ExternalFeed'), 'component' => array('text', 'Modules/ExternalFeed'), 'location' => array('text', 'Modules/ExternalFeed/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', ''), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '1'), 'default_pos' => array('integer', '80'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'root'), 'class_name' => array('text', 'RootFolder'), 'component' => array('text', 'Modules/RootFolder'), 'location' => array('text', 'Modules/RootFolder/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'book'), 'class_name' => array('text', 'BookingPool'), 'component' => array('text', 'Modules/BookingManager'), 'location' => array('text', 'Modules/BookingManager/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', ''), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '250'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '250'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'blog'), 'class_name' => array('text', 'Blog'), 'component' => array('text', 'Modules/Blog'), 'location' => array('text', 'Modules/Blog/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '330'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '330'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'blga'), 'class_name' => array('text', 'BlogAdministration'), 'component' => array('text', 'Modules/Blog'), 'location' => array('text', 'Modules/Blog/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'fold'), 'class_name' => array('text', 'Folder'), 'component' => array('text', 'Modules/Folder'), 'location' => array('text', 'Modules/Folder/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '40'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '20'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'wiki'), 'class_name' => array('text', 'Wiki'), 'component' => array('text', 'Modules/Wiki'), 'location' => array('text', 'Modules/Wiki/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', ''), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '115'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '140'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'wiks'), 'class_name' => array('text', 'WikiSettings'), 'component' => array('text', 'Modules/Wiki'), 'location' => array('text', 'Modules/Wiki/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rcrs'), 'class_name' => array('text', 'RemoteCourse'), 'component' => array('text', 'Modules/RemoteCourse'), 'location' => array('text', 'Modules/RemoteCourse/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'crs'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '1')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'cld'), 'class_name' => array('text', 'Cloud'), 'component' => array('text', 'Modules/Cloud'), 'location' => array('text', 'Modules/Cloud/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '440'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '440'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'catr'), 'class_name' => array('text', 'CategoryReference'), 'component' => array('text', 'Modules/CategoryReference'), 'location' => array('text', 'Modules/CategoryReference/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '15'), 'grp' => array('text', 'cat'), 'default_pres_pos' => array('integer', '10'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rcat'), 'class_name' => array('text', 'RemoteCategory'), 'component' => array('text', 'Modules/RemoteCategory'), 'location' => array('text', 'Modules/RemoteCategory/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'cat'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'orgu'), 'class_name' => array('text', 'OrgUnit'), 'component' => array('text', 'Modules/OrgUnit'), 'location' => array('text', 'Modules/OrgUnit/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', 'db'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '10'), 'grp' => array('text', 'orgu'), 'default_pres_pos' => array('integer', '10'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rgrp'), 'class_name' => array('text', 'RemoteGroup'), 'component' => array('text', 'Modules/RemoteGroup'), 'location' => array('text', 'Modules/RemoteGroup/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'grp'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'qpl'), 'class_name' => array('text', 'QuestionPool'), 'component' => array('text', 'Modules/TestQuestionPool'), 'location' => array('text', 'Modules/TestQuestionPool/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '210'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '200'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'svy'), 'class_name' => array('text', 'Survey'), 'component' => array('text', 'Modules/Survey'), 'location' => array('text', 'Modules/Survey/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '190'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '180'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'svyf'), 'class_name' => array('text', 'SurveyAdministration'), 'component' => array('text', 'Modules/Survey'), 'location' => array('text', 'Modules/Survey/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rfil'), 'class_name' => array('text', 'RemoteFile'), 'component' => array('text', 'Modules/RemoteFile'), 'location' => array('text', 'Modules/RemoteFile/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'file'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'adm'), 'class_name' => array('text', 'SystemFolder'), 'component' => array('text', 'Modules/SystemFolder'), 'location' => array('text', 'Modules/SystemFolder/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'sess'), 'class_name' => array('text', 'Session'), 'component' => array('text', 'Modules/Session'), 'location' => array('text', 'Modules/Session/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '15'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '15'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'frm'), 'class_name' => array('text', 'Forum'), 'component' => array('text', 'Modules/Forum'), 'location' => array('text', 'Modules/Forum/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '70'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '90'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'frma'), 'class_name' => array('text', 'ForumAdministration'), 'component' => array('text', 'Modules/Forum'), 'location' => array('text', 'Modules/Forum/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'poll'), 'class_name' => array('text', 'Poll'), 'component' => array('text', 'Modules/Poll'), 'location' => array('text', 'Modules/Poll/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '1'), 'default_pos' => array('integer', '350'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '350'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'crsr'), 'class_name' => array('text', 'CourseReference'), 'component' => array('text', 'Modules/CourseReference'), 'location' => array('text', 'Modules/CourseReference/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '25'), 'grp' => array('text', 'crs'), 'default_pres_pos' => array('integer', '20'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'itgr'), 'class_name' => array('text', 'ItemGroup'), 'component' => array('text', 'Modules/ItemGroup'), 'location' => array('text', 'Modules/ItemGroup/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '45'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '5'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'glo'), 'class_name' => array('text', 'Glossary'), 'component' => array('text', 'Modules/Glossary'), 'location' => array('text', 'Modules/Glossary/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '160'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '110'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rwik'), 'class_name' => array('text', 'RemoteWiki'), 'component' => array('text', 'Modules/RemoteWiki'), 'location' => array('text', 'Modules/RemoteWiki/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '30'), 'grp' => array('text', 'wiki'), 'default_pres_pos' => array('integer', '40'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'grp'), 'class_name' => array('text', 'Group'), 'component' => array('text', 'Modules/Group'), 'location' => array('text', 'Modules/Group/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '50'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '70'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'grps'), 'class_name' => array('text', 'GroupAdministration'), 'component' => array('text', 'Modules/Group'), 'location' => array('text', 'Modules/Group/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'exc'), 'class_name' => array('text', 'Exercise'), 'component' => array('text', 'Modules/Exercise'), 'location' => array('text', 'Modules/Exercise/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', ''), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '170'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '160'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'excs'), 'class_name' => array('text', 'ExerciseAdministration'), 'component' => array('text', 'Modules/Exercise'), 'location' => array('text', 'Modules/Exercise/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'excv'), 'class_name' => array('text', 'ExerciseVerification'), 'component' => array('text', 'Modules/Exercise'), 'location' => array('text', 'Modules/Exercise/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '100'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '160'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'icrs'), 'class_name' => array('text', 'iLincCourse'), 'component' => array('text', 'Modules/ILinc'), 'location' => array('text', 'Modules/ILinc/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '230'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '50'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'icla'), 'class_name' => array('text', 'iLincClassroom'), 'component' => array('text', 'Modules/ILinc'), 'location' => array('text', 'Modules/ILinc/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '240'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '60'), 'export' => array('integer', '0'), 'repository' => array('integer', '0'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'chtr'), 'class_name' => array('text', 'Chatroom'), 'component' => array('text', 'Modules/Chatroom'), 'location' => array('text', 'Modules/Chatroom/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '90'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '150'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'chta'), 'class_name' => array('text', 'ChatroomAdmin'), 'component' => array('text', 'Modules/Chatroom'), 'location' => array('text', 'Modules/Chatroom/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'file'), 'class_name' => array('text', 'File'), 'component' => array('text', 'Modules/File'), 'location' => array('text', 'Modules/File/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '90'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '150'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '1'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'cat'), 'class_name' => array('text', 'Category'), 'component' => array('text', 'Modules/Category'), 'location' => array('text', 'Modules/Category/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', 'db'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '10'), 'grp' => array('text', 'cat'), 'default_pres_pos' => array('integer', '10'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '1')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'mep'), 'class_name' => array('text', 'MediaPool'), 'component' => array('text', 'Modules/MediaPool'), 'location' => array('text', 'Modules/MediaPool/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '1'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '1'), 'allow_copy' => array('integer', '1'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '200'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '190'), 'export' => array('integer', '1'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'cals'), 'class_name' => array('text', 'CalendarSettings'), 'component' => array('text', 'Services/Calendar'), 'location' => array('text', 'Services/Calendar/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'skmg'), 'class_name' => array('text', 'SkillManagement'), 'component' => array('text', 'Services/Skill'), 'location' => array('text', 'Services/Skill/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'mds'), 'class_name' => array('text', 'MDSettings'), 'component' => array('text', 'Services/MetaData'), 'location' => array('text', 'Services/MetaData/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'cmps'), 'class_name' => array('text', 'ComponentSettings'), 'component' => array('text', 'Services/Component'), 'location' => array('text', 'Services/Component/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'otpl'), 'class_name' => array('text', 'ObjectTemplateAdministration'), 'component' => array('text', 'Services/DidacticTemplate'), 'location' => array('text', 'Services/DidacticTemplate/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'adve'), 'class_name' => array('text', 'AdvancedEditing'), 'component' => array('text', 'Services/AdvancedEditing'), 'location' => array('text', 'Services/AdvancedEditing/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rolf'), 'class_name' => array('text', 'RoleFolder'), 'component' => array('text', 'Services/AccessControl'), 'location' => array('text', 'Services/AccessControl/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'role'), 'class_name' => array('text', 'Role'), 'component' => array('text', 'Services/AccessControl'), 'location' => array('text', 'Services/AccessControl/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'rolt'), 'class_name' => array('text', 'RoleTemplate'), 'component' => array('text', 'Services/AccessControl'), 'location' => array('text', 'Services/AccessControl/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'trac'), 'class_name' => array('text', 'UserTracking'), 'component' => array('text', 'Services/Tracking'), 'location' => array('text', 'Services/Tracking/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'mail'), 'class_name' => array('text', 'Mail'), 'component' => array('text', 'Services/Mail'), 'location' => array('text', 'Services/Mail/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'nota'), 'class_name' => array('text', 'NotificationAdmin'), 'component' => array('text', 'Services/Notifications'), 'location' => array('text', 'Services/Notifications/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'facs'), 'class_name' => array('text', 'FileAccessSettings'), 'component' => array('text', 'Services/WebDAV'), 'location' => array('text', 'Services/WebDAV/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'tax'), 'class_name' => array('text', 'Taxonomy'), 'component' => array('text', 'Services/Taxonomy'), 'location' => array('text', 'Services/Taxonomy/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'taxs'), 'class_name' => array('text', 'TaxonomyAdministration'), 'component' => array('text', 'Services/Taxonomy'), 'location' => array('text', 'Services/Taxonomy/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'lngf'), 'class_name' => array('text', 'LanguageFolder'), 'component' => array('text', 'Services/Language'), 'location' => array('text', 'Services/Language/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'lng'), 'class_name' => array('text', 'Language'), 'component' => array('text', 'Services/Language'), 'location' => array('text', 'Services/Language/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'sty'), 'class_name' => array('text', 'StyleSheet'), 'component' => array('text', 'Services/Style'), 'location' => array('text', 'Services/Style/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'stys'), 'class_name' => array('text', 'StyleSettings'), 'component' => array('text', 'Services/Style'), 'location' => array('text', 'Services/Style/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'cert'), 'class_name' => array('text', 'CertificateSettings'), 'component' => array('text', 'Services/Certificate'), 'location' => array('text', 'Services/Certificate/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'tos'), 'class_name' => array('text', 'TermsOfService'), 'component' => array('text', 'Services/TermsOfService'), 'location' => array('text', 'Services/TermsOfService/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'usr'), 'class_name' => array('text', 'User'), 'component' => array('text', 'Services/User'), 'location' => array('text', 'Services/User/classes'), 'checkbox' => array('integer', '1'), 'inherit' => array('integer', '0'), 'translate' => array('text', '0'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '0'), 'system' => array('integer', '0'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'usrf'), 'class_name' => array('text', 'UserFolder'), 'component' => array('text', 'Services/User'), 'location' => array('text', 'Services/User/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '1'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'auth'), 'class_name' => array('text', 'AuthSettings'), 'component' => array('text', 'Services/Authentication'), 'location' => array('text', 'Services/Authentication/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'accs'), 'class_name' => array('text', 'AccessibilitySettings'), 'component' => array('text', 'Services/Accessibility'), 'location' => array('text', 'Services/Accessibility/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'reps'), 'class_name' => array('text', 'RepositorySettings'), 'component' => array('text', 'Services/Repository'), 'location' => array('text', 'Services/Repository/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'pays'), 'class_name' => array('text', 'PaymentSettings'), 'component' => array('text', 'Services/Payment'), 'location' => array('text', 'Services/Payment/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'hlps'), 'class_name' => array('text', 'HelpSettings'), 'component' => array('text', 'Services/Help'), 'location' => array('text', 'Services/Help/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'sysc'), 'class_name' => array('text', 'SystemCheck'), 'component' => array('text', 'Services/SystemCheck'), 'location' => array('text', 'Services/SystemCheck/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'tags'), 'class_name' => array('text', 'TaggingSettings'), 'component' => array('text', 'Services/Tagging'), 'location' => array('text', 'Services/Tagging/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'recf'), 'class_name' => array('text', 'RecoveryFolder'), 'component' => array('text', 'Services/Administration'), 'location' => array('text', 'Services/Administration/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'extt'), 'class_name' => array('text', 'ExternalToolsSettings'), 'component' => array('text', 'Services/Administration'), 'location' => array('text', 'Services/Administration/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'objf'), 'class_name' => array('text', 'ObjectFolder'), 'component' => array('text', 'Services/Object'), 'location' => array('text', 'Services/Object/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '1'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '0'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'ecss'), 'class_name' => array('text', 'ECSSettings'), 'component' => array('text', 'Services/WebServices'), 'location' => array('text', 'Services/WebServices/ECS/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'pdts'), 'class_name' => array('text', 'PersonalDesktopSettings'), 'component' => array('text', 'Services/PersonalDesktop'), 'location' => array('text', 'Services/PersonalDesktop/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'mobs'), 'class_name' => array('text', 'MediaObjectsSettings'), 'component' => array('text', 'Services/MediaObjects'), 'location' => array('text', 'Services/MediaObjects/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'nwss'), 'class_name' => array('text', 'NewsSettings'), 'component' => array('text', 'Services/News'), 'location' => array('text', 'Services/News/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'ps'), 'class_name' => array('text', 'PrivacySecurity'), 'component' => array('text', 'Services/PrivacySecurity'), 'location' => array('text', 'Services/PrivacySecurity/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));

$ilDB->insert("il_object_def", array(
'id' => array('text', 'seas'), 'class_name' => array('text', 'SearchSettings'), 'component' => array('text', 'Services/Search'), 'location' => array('text', 'Services/Search/classes'), 'checkbox' => array('integer', '0'), 'inherit' => array('integer', '0'), 'translate' => array('text', 'sys'), 'devmode' => array('integer', '0'), 'allow_link' => array('integer', '0'), 'allow_copy' => array('integer', '0'), 'rbac' => array('integer', '1'), 'system' => array('integer', '1'), 'sideblock' => array('integer', '0'), 'default_pos' => array('integer', '0'), 'grp' => array('text', ''), 'default_pres_pos' => array('integer', '0'), 'export' => array('integer', '0'), 'repository' => array('integer', '1'), 'workspace' => array('integer', '0'), 'administration' => array('integer', '1'), 'amet' => array('integer', '0')));


//
// il_object_group
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"default_pres_pos" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_object_group", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_object_group", $pk_fields);

$ilDB->insert("il_object_group", array(
'id' => array('text', 'tst'), 'name' => array('text', 'Tests'), 'default_pres_pos' => array('integer', '170')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'crs'), 'name' => array('text', 'Courses'), 'default_pres_pos' => array('integer', '30')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'lres'), 'name' => array('text', 'LearningResources'), 'default_pres_pos' => array('integer', '100')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'wiki'), 'name' => array('text', 'Wikis'), 'default_pres_pos' => array('integer', '140')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'orgu'), 'name' => array('text', 'Organisational Unit'), 'default_pres_pos' => array('integer', '10')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'glo'), 'name' => array('text', 'Glossaries'), 'default_pres_pos' => array('integer', '110')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'grp'), 'name' => array('text', 'Groups'), 'default_pres_pos' => array('integer', '70')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'file'), 'name' => array('text', 'Files'), 'default_pres_pos' => array('integer', '150')));

$ilDB->insert("il_object_group", array(
'id' => array('text', 'cat'), 'name' => array('text', 'Categories'), 'default_pres_pos' => array('integer', '10')));


//
// il_object_sub_type
//
$fields = array (
	"obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"amet" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_object_sub_type", $fields);

$pk_fields = array("obj_type","sub_type");
$ilDB->addPrimaryKey("il_object_sub_type", $pk_fields);

$ilDB->insert("il_object_sub_type", array(
'obj_type' => array('text', 'wiki'), 'sub_type' => array('text', 'wpg'), 'amet' => array('integer', '1')));

$ilDB->insert("il_object_sub_type", array(
'obj_type' => array('text', 'orgu'), 'sub_type' => array('text', 'orgu_type'), 'amet' => array('integer', '1')));

$ilDB->insert("il_object_sub_type", array(
'obj_type' => array('text', 'glo'), 'sub_type' => array('text', 'term'), 'amet' => array('integer', '1')));


//
// il_object_subobj
//
$fields = array (
	"parent" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"subobj" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"mmax" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_object_subobj", $fields);

$pk_fields = array("parent","subobj");
$ilDB->addPrimaryKey("il_object_subobj", $pk_fields);

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'wfld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'wfld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'bibl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'bibl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'bibl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'bibl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'bibl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'bibl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'bibs'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rtst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rtst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rglo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rglo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'webr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'wbrs'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'dcl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'dcl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'dcl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'dcl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'dcl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'dcl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'prtt'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'prtt'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'prtt'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'prtt'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'prtt'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'prtt'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'prfa'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'spl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'spl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'spl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'spl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'spl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'spl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'tst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'tst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'tst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'tst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'tst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'tst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'assf'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'tstv'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'tstv'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'htlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'htlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'htlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'htlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'htlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'htlm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'mcst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'mcst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'mcst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'mcst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'mcst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'mcst'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'mcts'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'sahs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'sahs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'sahs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'sahs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'sahs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'sahs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'scov'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'scov'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'crs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'crs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'crs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'crss'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'crsv'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'crsv'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'lm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'lm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'lm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'lm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'lm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'lm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'lrss'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'feed'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'feed'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'feed'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'feed'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'adm'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'book'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'book'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'book'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'book'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'book'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'blog'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'blga'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'fold'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'fold'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'fold'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'fold'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'wiki'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'wiki'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'wiki'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'wiki'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'wiki'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'wiki'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'wiks'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rcrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rcrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'rcrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'rcrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'cld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'cld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'cld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'cld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'cld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'cld'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'catr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'catr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'catr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'catr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'catr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rcat'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rcat'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'rcat'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'rcat'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'orgu'), 'subobj' => array('text', 'orgu'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'orgu'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rgrp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rgrp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'rgrp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'rgrp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'qpl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'qpl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'qpl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'qpl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'qpl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'qpl'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'svy'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'svy'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'svy'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'svy'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'svy'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'svy'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'svyf'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rfil'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rfil'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'sess'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'sess'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'sess'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'sess'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'frm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'frm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'frm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'frm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'frm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'frm'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'frma'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'poll'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'poll'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'poll'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'poll'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'poll'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'poll'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'crsr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'crsr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'crsr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'crsr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'crsr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'itgr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'itgr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'itgr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'itgr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'itgr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'itgr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'glo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'glo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'glo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'glo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'glo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'glo'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'rwik'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'rwik'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'grp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'grp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'grp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'grp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'grp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'grp'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'grps'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'exc'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'exc'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'exc'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'exc'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'exc'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'exc'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'excs'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'excv'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'excv'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'icrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'icrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'icrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'icrs'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'icrs'), 'subobj' => array('text', 'icla'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'chtr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'chtr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'chtr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'chtr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'chtr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'chtr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'chta'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wsrt'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'wfld'), 'subobj' => array('text', 'file'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'cat'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'cat'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'cat'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'cat'), 'subobj' => array('text', 'mep'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'crs'), 'subobj' => array('text', 'mep'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'fold'), 'subobj' => array('text', 'mep'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'grp'), 'subobj' => array('text', 'mep'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'recf'), 'subobj' => array('text', 'mep'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'root'), 'subobj' => array('text', 'mep'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'cals'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'skmg'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'mds'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'cmps'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'otpl'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'adve'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'rolf'), 'subobj' => array('text', 'rolt'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'rolf'), 'subobj' => array('text', 'role'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'rolf'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'trac'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'mail'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'nota'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'facs'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'taxs'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'lngf'), 'subobj' => array('text', 'lng'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'lngf'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'stys'), 'subobj' => array('text', 'sty'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'stys'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'cert'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'tos'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'usrf'), 'subobj' => array('text', 'usr'), 'mmax' => array('integer', '0')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'usrf'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'auth'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'accs'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'reps'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'pays'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'hlps'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'sysc'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'tags'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'recf'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'extt'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'objf'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'ecss'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'pdts'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'mobs'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'nwss'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'ps'), 'mmax' => array('integer', '1')));

$ilDB->insert("il_object_subobj", array(
'parent' => array('text', 'adm'), 'subobj' => array('text', 'seas'), 'mmax' => array('integer', '1')));


//
// il_plugin
//
$fields = array (
	"component_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"component_name" => array (
		"notnull" => true
		,"length" => 90
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"slot_id" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 40
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"last_update_version" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => true
		,"type" => "text"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"db_version" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"plugin_id" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_plugin", $fields);

$pk_fields = array("component_type","component_name","slot_id","name");
$ilDB->addPrimaryKey("il_plugin", $pk_fields);


//
// il_pluginslot
//
$fields = array (
	"component" => array (
		"notnull" => true
		,"length" => 200
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_pluginslot", $fields);

$pk_fields = array("component","id");
$ilDB->addPrimaryKey("il_pluginslot", $pk_fields);

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Modules/SurveyQuestionPool'), 'id' => array('text', 'svyq'), 'name' => array('text', 'SurveyQuestions')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Modules/Test'), 'id' => array('text', 'texp'), 'name' => array('text', 'Export')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Modules/Test'), 'id' => array('text', 'tsig'), 'name' => array('text', 'Signature')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Modules/Cloud'), 'id' => array('text', 'cldh'), 'name' => array('text', 'CloudHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Modules/OrgUnit'), 'id' => array('text', 'orgutypehk'), 'name' => array('text', 'OrgUnitTypeHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Modules/TestQuestionPool'), 'id' => array('text', 'qst'), 'name' => array('text', 'Questions')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/AdvancedMetaData'), 'id' => array('text', 'amdc'), 'name' => array('text', 'AdvancedMDClaiming')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/COPage'), 'id' => array('text', 'pgcp'), 'name' => array('text', 'PageComponent')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/User'), 'id' => array('text', 'udfc'), 'name' => array('text', 'UDFClaiming')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/Authentication'), 'id' => array('text', 'authhk'), 'name' => array('text', 'AuthenticationHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/Repository'), 'id' => array('text', 'robj'), 'name' => array('text', 'RepositoryObject')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/UIComponent'), 'id' => array('text', 'uihk'), 'name' => array('text', 'UserInterfaceHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/LDAP'), 'id' => array('text', 'ldaphk'), 'name' => array('text', 'LDAPHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/EventHandling'), 'id' => array('text', 'evhk'), 'name' => array('text', 'EventHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/Preview'), 'id' => array('text', 'pvre'), 'name' => array('text', 'PreviewRenderer')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/AuthShibboleth'), 'id' => array('text', 'shibhk'), 'name' => array('text', 'ShibbolethAuthenticationHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/PersonalDesktop'), 'id' => array('text', 'pdhk'), 'name' => array('text', 'PersonalDesktopHook')));

$ilDB->insert("il_pluginslot", array(
'component' => array('text', 'Services/Cron'), 'id' => array('text', 'crnhk'), 'name' => array('text', 'CronHook')));


//
// il_poll
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"question" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"image" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"online_status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"view_results" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "3"
		,"type" => "integer"
	)
	,"period" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"period_begin" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"period_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"max_answers" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"result_sort" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"non_anon" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"show_results_as" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_poll", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_poll", $pk_fields);


//
// il_poll_answer
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"poll_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"answer" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"pos" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_poll_answer", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_poll_answer", $pk_fields);

$ilDB->createSequence("il_poll_answer", 1);


//
// il_poll_vote
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"poll_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_poll_vote", $fields);

$pk_fields = array("user_id","poll_id","answer_id");
$ilDB->addPrimaryKey("il_poll_vote", $pk_fields);


//
// il_qpl_qst_fq_res
//
$fields = array (
	"result_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"result" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"range_min" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"range_max" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"tolerance" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"unit_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"formula" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rating_simple" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"rating_sign" => array (
		"notnull" => true
		,"default" => "0.25"
		,"type" => "float"
	)
	,"rating_value" => array (
		"notnull" => true
		,"default" => "0.25"
		,"type" => "float"
	)
	,"rating_unit" => array (
		"notnull" => true
		,"default" => "0.25"
		,"type" => "float"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"resprecision" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"result_type" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"range_min_txt" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"range_max_txt" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_qpl_qst_fq_res", $fields);

$pk_fields = array("result_id");
$ilDB->addPrimaryKey("il_qpl_qst_fq_res", $pk_fields);

$ilDB->createSequence("il_qpl_qst_fq_res", 1);


//
// il_qpl_qst_fq_res_unit
//
$fields = array (
	"result_unit_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"result" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"unit_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_qpl_qst_fq_res_unit", $fields);

$pk_fields = array("result_unit_id");
$ilDB->addPrimaryKey("il_qpl_qst_fq_res_unit", $pk_fields);

$in_fields = array("question_fi","unit_fi");
$ilDB->addIndex("il_qpl_qst_fq_res_unit", $in_fields, "i1", false);

$ilDB->createSequence("il_qpl_qst_fq_res_unit", 1);


//
// il_qpl_qst_fq_ucat
//
$fields = array (
	"category_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"category" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_qpl_qst_fq_ucat", $fields);

$pk_fields = array("category_id");
$ilDB->addPrimaryKey("il_qpl_qst_fq_ucat", $pk_fields);

$ilDB->createSequence("il_qpl_qst_fq_ucat", 1);


//
// il_qpl_qst_fq_unit
//
$fields = array (
	"unit_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"unit" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"factor" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"baseunit_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"category_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_qpl_qst_fq_unit", $fields);

$pk_fields = array("unit_id");
$ilDB->addPrimaryKey("il_qpl_qst_fq_unit", $pk_fields);

$ilDB->createSequence("il_qpl_qst_fq_unit", 1);


//
// il_qpl_qst_fq_var
//
$fields = array (
	"variable_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"variable" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"range_min" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"range_max" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"unit_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"step_dim_min" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"step_dim_max" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"varprecision" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"intprecision" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"range_min_txt" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"range_max_txt" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_qpl_qst_fq_var", $fields);

$pk_fields = array("variable_id");
$ilDB->addPrimaryKey("il_qpl_qst_fq_var", $pk_fields);

$ilDB->createSequence("il_qpl_qst_fq_var", 1);


//
// il_rating
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"sub_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rating" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"category_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("il_rating", $fields);

$pk_fields = array("obj_id","obj_type","sub_obj_id","sub_obj_type","user_id","category_id");
$ilDB->addPrimaryKey("il_rating", $pk_fields);

$in_fields = array("obj_id","obj_type","sub_obj_id","sub_obj_type");
$ilDB->addIndex("il_rating", $in_fields, "obj", false);


//
// il_rating_cat
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"parent_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"pos" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_rating_cat", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_rating_cat", $pk_fields);

$ilDB->createSequence("il_rating_cat", 1);


//
// il_request_token
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"token" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"stamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"session_id" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_request_token", $fields);

$in_fields = array("user_id");
$ilDB->addIndex("il_request_token", $in_fields, "i1", false);

$in_fields = array("session_id");
$ilDB->addIndex("il_request_token", $in_fields, "i2", false);

$in_fields = array("token");
$ilDB->addIndex("il_request_token", $in_fields, "i3", false);

$in_fields = array("stamp");
$ilDB->addIndex("il_request_token", $in_fields, "i4", false);


//
// il_subscribers
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"subject" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_subscribers", $fields);

$pk_fields = array("usr_id","obj_id");
$ilDB->addPrimaryKey("il_subscribers", $pk_fields);


//
// il_tag
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"sub_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tag" => array (
		"notnull" => true
		,"length" => 100
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"is_offline" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_tag", $fields);

$pk_fields = array("obj_id","obj_type","sub_obj_id","sub_obj_type","user_id","tag");
$ilDB->addPrimaryKey("il_tag", $pk_fields);

$in_fields = array("obj_id","obj_type","sub_obj_id","sub_obj_type");
$ilDB->addIndex("il_tag", $in_fields, "i1", false);

$in_fields = array("tag");
$ilDB->addIndex("il_tag", $in_fields, "i2", false);

$in_fields = array("user_id");
$ilDB->addIndex("il_tag", $in_fields, "i3", false);


//
// il_verification
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"parameters" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"raw_data" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("il_verification", $fields);

$in_fields = array("id");
$ilDB->addIndex("il_verification", $in_fields, "i1", false);


//
// il_wiki_contributor
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"status_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("il_wiki_contributor", $fields);

$pk_fields = array("wiki_id","user_id");
$ilDB->addPrimaryKey("il_wiki_contributor", $pk_fields);


//
// il_wiki_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"startpage" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"short" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rating" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"introduction" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"public_notes" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"imp_pages" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"page_toc" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rating_side" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rating_new" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rating_ext" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rating_overall" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"empty_page_templ" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_wiki_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_wiki_data", $pk_fields);


//
// il_wiki_imp_pages
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ord" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"indent" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("il_wiki_imp_pages", $fields);


//
// il_wiki_missing_page
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"source_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"target_name" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("il_wiki_missing_page", $fields);

$in_fields = array("wiki_id");
$ilDB->addIndex("il_wiki_missing_page", $in_fields, "i1", false);


//
// il_wiki_page
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"blocked" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rating" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hide_adv_md" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("il_wiki_page", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("il_wiki_page", $pk_fields);

$ilDB->createSequence("il_wiki_page", 1);


//
// ilinc_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"i_type" => array (
		"notnull" => false
		,"length" => 5
		,"fixed" => false
		,"type" => "text"
	)
	,"course_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"contact_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_responsibili" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_phone" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"contact_email" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"activation_unlimited" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"activation_start" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"activation_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"activation_offline" => array (
		"notnull" => false
		,"length" => 3
		,"fixed" => false
		,"type" => "text"
	)
	,"subscription_unlimit" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"subscription_start" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"subscription_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"subscription_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"subscription_passwd" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"akclassvalue1" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"akclassvalue2" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ilinc_data", $fields);

$in_fields = array("obj_id");
$ilDB->addIndex("ilinc_data", $in_fields, "i1", false);


//
// ilinc_registration
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_text" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"application_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("ilinc_registration", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("ilinc_registration", $pk_fields);

$in_fields = array("usr_id");
$ilDB->addIndex("ilinc_registration", $in_fields, "i1", false);


//
// int_link
//
$fields = array (
	"source_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"source_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"target_type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"target_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"target_inst" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"source_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("int_link", $fields);

$pk_fields = array("source_type","source_id","source_lang","target_type","target_id","target_inst");
$ilDB->addPrimaryKey("int_link", $pk_fields);

$in_fields = array("target_type","target_id","target_inst");
$ilDB->addIndex("int_link", $in_fields, "ta", false);

$in_fields = array("source_type","source_id");
$ilDB->addIndex("int_link", $in_fields, "so", false);


//
// item_group_item
//
$fields = array (
	"item_group_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("item_group_item", $fields);

$pk_fields = array("item_group_id","item_ref_id");
$ilDB->addPrimaryKey("item_group_item", $pk_fields);


//
// last_visited
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"sub_obj_id" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"goto_link" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("last_visited", $fields);

$pk_fields = array("user_id","nr");
$ilDB->addPrimaryKey("last_visited", $pk_fields);


//
// ldap_attribute_mapping
//
$fields = array (
	"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"keyword" => array (
		"notnull" => true
		,"length" => 32
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"perform_update" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ldap_attribute_mapping", $fields);

$pk_fields = array("server_id","keyword");
$ilDB->addPrimaryKey("ldap_attribute_mapping", $pk_fields);

$in_fields = array("server_id");
$ilDB->addIndex("ldap_attribute_mapping", $in_fields, "i1", false);


//
// ldap_rg_mapping
//
$fields = array (
	"mapping_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"url" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"dn" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"member_attribute" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"member_isdn" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"role" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mapping_info" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"mapping_info_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("ldap_rg_mapping", $fields);

$pk_fields = array("mapping_id");
$ilDB->addPrimaryKey("ldap_rg_mapping", $pk_fields);

$ilDB->createSequence("ldap_rg_mapping", 1);


//
// ldap_role_assignments
//
$fields = array (
	"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rule_id" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"dn" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"attribute" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"isdn" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"att_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"att_value" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"role_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"add_on_update" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"remove_on_update" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"plugin_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("ldap_role_assignments", $fields);

$pk_fields = array("server_id","rule_id");
$ilDB->addPrimaryKey("ldap_role_assignments", $pk_fields);

$ilDB->createSequence("ldap_role_assignments", 1);


//
// ldap_server_settings
//
$fields = array (
	"server_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"url" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"version" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"base_dn" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"referrals" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tls" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"bind_type" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"bind_user" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"bind_pass" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"search_base" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"user_scope" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_attribute" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"filter" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"group_dn" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"group_scope" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"group_filter" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"group_member" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"group_memberisdn" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"group_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"group_attribute" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
	,"group_optional" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"group_user_filter" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"sync_on_login" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sync_per_cron" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"role_sync_active" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"role_bind_dn" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"role_bind_pass" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"migration" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"authentication" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"authentication_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ldap_server_settings", $fields);

$pk_fields = array("server_id");
$ilDB->addPrimaryKey("ldap_server_settings", $pk_fields);

$ilDB->createSequence("ldap_server_settings", 1);


//
// license_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"licenses" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"used" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"remarks" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("license_data", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("license_data", $pk_fields);


//
// link_check
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"url" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"parent_type" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"http_status_code" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_check" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("link_check", $fields);


//
// link_check_report
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("link_check_report", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("link_check_report", $pk_fields);


//
// lm_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => true
		,"type" => "text"
	)
	,"lm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"public_access" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "y"
		,"fixed" => true
		,"type" => "text"
	)
	,"layout" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("lm_data", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("lm_data", $pk_fields);

$in_fields = array("lm_id");
$ilDB->addIndex("lm_data", $in_fields, "i1", false);

$in_fields = array("type");
$ilDB->addIndex("lm_data", $in_fields, "i2", false);

$in_fields = array("import_id");
$ilDB->addIndex("lm_data", $in_fields, "im", false);

$ilDB->createSequence("lm_data", 2);

$ilDB->insert("lm_data", array(
'obj_id' => array('integer', '1'), 'title' => array('text', 'dummy'), 'type' => array('text', 'du'), 'lm_id' => array('integer', '0'), 'import_id' => array('text', ''), 'public_access' => array('text', 'n'), 'create_date' => array('timestamp', ''), 'last_update' => array('timestamp', ''), 'active' => array('text', 'y'), 'layout' => array('text', '')));


//
// lm_data_transl
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("lm_data_transl", $fields);

$pk_fields = array("id","lang");
$ilDB->addPrimaryKey("lm_data_transl", $pk_fields);


//
// lm_glossaries
//
$fields = array (
	"lm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"glo_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("lm_glossaries", $fields);

$pk_fields = array("lm_id","glo_id");
$ilDB->addPrimaryKey("lm_glossaries", $pk_fields);


//
// lm_menu
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"link_type" => array (
		"notnull" => false
		,"length" => 6
		,"default" => "extern"
		,"fixed" => true
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"target" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"link_ref_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("lm_menu", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("lm_menu", $pk_fields);

$in_fields = array("link_type");
$ilDB->addIndex("lm_menu", $in_fields, "i1", false);

$in_fields = array("lm_id");
$ilDB->addIndex("lm_menu", $in_fields, "i2", false);

$in_fields = array("active");
$ilDB->addIndex("lm_menu", $in_fields, "i3", false);

$ilDB->createSequence("lm_menu", 1);


//
// lm_read_event
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"read_count" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"spent_seconds" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_access" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("lm_read_event", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("lm_read_event", $pk_fields);


//
// lm_tree
//
$fields = array (
	"lm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("lm_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("lm_tree", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("lm_tree", $in_fields, "i2", false);

$in_fields = array("lm_id");
$ilDB->addIndex("lm_tree", $in_fields, "i3", false);


//
// lng_data
//
$fields = array (
	"module" => array (
		"notnull" => true
		,"length" => 30
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"identifier" => array (
		"notnull" => true
		,"length" => 60
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"lang_key" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"local_change" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"remarks" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("lng_data", $fields);

$pk_fields = array("module","identifier","lang_key");
$ilDB->addPrimaryKey("lng_data", $pk_fields);

$in_fields = array("module");
$ilDB->addIndex("lng_data", $in_fields, "i1", false);

$in_fields = array("lang_key");
$ilDB->addIndex("lng_data", $in_fields, "i2", false);


//
// lng_modules
//
$fields = array (
	"module" => array (
		"notnull" => true
		,"length" => 30
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"lang_key" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"lang_array" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("lng_modules", $fields);

$pk_fields = array("module","lang_key");
$ilDB->addPrimaryKey("lng_modules", $pk_fields);

$ilDB->insert("lng_modules", array(
'module' => array('text', 'barometer'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:54:{s:9:"anonymous";s:9:"Anonymous";s:10:"bar_create";s:19:"Create New Feedback";s:13:"barometer_add";s:16:"Add new Feedback";s:27:"barometer_conflict_anon_req";s:95:"Anonymization can not be combined with type ‘Required’. Please choose one of these options.";s:15:"barometer_title";s:8:"Feedback";s:4:"best";s:4:"Best";s:13:"change_course";s:13:"Change Course";s:10:"chart_type";s:10:"Chart type";s:11:"chart_users";s:10:"Chart user";s:11:"chart_votes";s:11:"Chart votes";s:3:"day";s:3:"Day";s:4:"days";s:4:"Days";s:6:"delete";s:6:"Delete";s:8:"duration";s:8:"Duration";s:14:"edit_barometer";s:13:"Edit feedback";s:4:"edit";s:4:"Edit";s:5:"every";s:5:"every";s:19:"feedb_edit_feedback";s:13:"Edit Feedback";s:19:"feedb_feedback_list";s:13:"Feedback List";s:23:"feedb_feedback_settings";s:17:"Feedback Settings";s:10:"feedb_time";s:4:"Time";s:10:"first_vote";s:14:"1. Vote is the";s:4:"from";s:4:"From";s:5:"hours";s:5:"Hours";s:5:"lines";s:5:"Lines";s:5:"login";s:5:"Login";s:14:"missing_fields";s:39:"Please fill in all required information";s:5:"month";s:5:"Month";s:6:"months";s:6:"Months";s:8:"new_vote";s:8:"New vote";s:4:"note";s:7:"Comment";s:8:"optional";s:8:"Optional";s:7:"options";s:7:"Options";s:3:"pie";s:3:"Pie";s:6:"repeat";s:12:"Repeat Every";s:8:"required";s:8:"Required";s:9:"save_vote";s:11:"Submit vote";s:4:"save";s:4:"Save";s:4:"skip";s:4:"Skip";s:10:"statistics";s:10:"Statistics";s:6:"status";s:6:"Status";s:5:"table";s:5:"Table";s:11:"text_answer";s:11:"Text answer";s:4:"text";s:4:"Text";s:4:"time";s:7:"Running";s:5:"title";s:5:"Title";s:4:"type";s:4:"Type";s:5:"until";s:5:"Until";s:4:"user";s:4:"User";s:4:"vote";s:4:"Vote";s:5:"votes";s:5:"Votes";s:5:"weeks";s:5:"Weeks";s:5:"worst";s:5:"Worst";s:4:"year";s:4:"Year";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'bibitem'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:58:{s:11:"bibitem_add";s:3:"Add";s:14:"bibitem_author";s:6:"Author";s:10:"bibitem_av";s:2:"AV";s:15:"bibitem_bibitem";s:27:"Bibliographical information";s:12:"bibitem_book";s:4:"Book";s:17:"bibitem_booktitle";s:10:"Book title";s:15:"bibitem_catalog";s:7:"Catalog";s:20:"bibitem_choose_index";s:44:"Please select a bibliographical information:";s:23:"bibitem_cross_reference";s:15:"Cross reference";s:14:"bibitem_delete";s:6:"Delete";s:20:"bibitem_dissertation";s:12:"Dissertation";s:15:"bibitem_edition";s:7:"Edition";s:14:"bibitem_editor";s:6:"Editor";s:13:"bibitem_entry";s:5:"Entry";s:18:"bibitem_first_name";s:10:"First name";s:23:"bibitem_grey_literature";s:15:"Grey literature";s:21:"bibitem_how_published";s:13:"How published";s:18:"bibitem_identifier";s:10:"Identifier";s:14:"bibitem_inbook";s:7:"In book";s:21:"bibitem_inproceedings";s:14:"In proceedings";s:19:"bibitem_institution";s:11:"Institution";s:16:"bibitem_internet";s:8:"Internet";s:12:"bibitem_isbn";s:4:"ISBN";s:12:"bibitem_issn";s:4:"ISSN";s:23:"bibitem_journal_article";s:15:"Journal article";s:15:"bibitem_journal";s:7:"Journal";s:15:"bibitem_keyword";s:7:"Keyword";s:13:"bibitem_label";s:5:"Label";s:16:"bibitem_language";s:8:"Language";s:17:"bibitem_last_name";s:9:"Last name";s:14:"bibitem_manual";s:6:"Manual";s:21:"bibitem_master_thesis";s:13:"Master thesis";s:19:"bibitem_middle_name";s:11:"Middle name";s:13:"bibitem_month";s:5:"Month";s:19:"bibitem_new_element";s:11:"New element";s:25:"bibitem_newspaper_article";s:17:"Newspaper article";s:17:"bibitem_not_found";s:41:"No bibliographical information available.";s:12:"bibitem_note";s:4:"Note";s:14:"bibitem_number";s:6:"Number";s:20:"bibitem_organization";s:12:"Organization";s:13:"bibitem_pages";s:5:"Pages";s:18:"bibitem_phd_thesis";s:10:"PhD thesis";s:21:"bibitem_please_select";s:13:"Please select";s:13:"bibitem_print";s:5:"Print";s:19:"bibitem_proceedings";s:11:"Proceedings";s:17:"bibitem_publisher";s:9:"Publisher";s:12:"bibitem_save";s:4:"Save";s:14:"bibitem_school";s:6:"School";s:21:"bibitem_series_editor";s:6:"Editor";s:20:"bibitem_series_title";s:12:"Series title";s:21:"bibitem_series_volume";s:6:"Volume";s:14:"bibitem_series";s:6:"Series";s:24:"bibitem_technical_report";s:16:"Technical report";s:12:"bibitem_type";s:4:"Type";s:19:"bibitem_unpublished";s:11:"Unpublished";s:11:"bibitem_url";s:3:"URL";s:23:"bibitem_where_published";s:15:"Where published";s:12:"bibitem_year";s:4:"Year";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'crs_'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:12:"crs_archives";s:8:"Archives";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'ilinc'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:14:{s:13:"akclassvalue1";s:13:"Cost center 1";s:13:"akclassvalue2";s:13:"Cost center 2";s:13:"akclassvalues";s:12:"Cost centers";s:18:"ilinc_akuservalue1";s:13:"Cost center 1";s:18:"ilinc_akuservalue2";s:13:"Cost center 2";s:23:"ilinc_akuservalues_desc";s:105:"Enter here the code of the cost center(s) for this user. These values will be stored at the iLinc server.";s:28:"ilinc_akuservalues_refreshed";s:20:"Cost centers updated";s:18:"ilinc_akuservalues";s:12:"Cost centers";s:22:"ilinc_connection_error";s:37:"Error: No connection to iLinc Server!";s:27:"ilinc_member_administration";s:17:"Edit Participants";s:20:"ilinc_no_account_yet";s:20:"No iLinc Account yet";s:16:"ilinc_user_added";s:36:"User account created on iLinc server";s:13:"ilinc_user_id";s:12:"iLinc UserID";s:19:"ilinc_user_settings";s:19:"iLinc User settings";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'jscalendar'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:58:{s:19:"about_calendar_long";s:373:"DHTML Date/Time Selector\\n(c) dynarch.com 2002-2003\\nFor latest version visit: http://dynarch.com/mishoo/calendar.epl\\nDistributed under GNU LGPL.  See http://gnu.org/licenses/lgpl.html for details.\\n\\nDate selection:\\n- Use the Â«, Â» buttons to select year\\n- Use the <, > buttons to select month\\n- Hold mouse button on any of the above buttons for faster selection.";s:14:"about_calendar";s:18:"About the calendar";s:10:"about_time";s:144:"\\n\\nTime selection:\\n- Click on any of the time parts to increase it\\n- or Shift-click to decrease it\\n- or click and drag for faster selection.";s:5:"close";s:5:"Close";s:9:"day_first";s:16:"Display %s first";s:15:"def_date_format";s:8:"%Y-%m-%d";s:12:"drag_to_move";s:12:"Drag to move";s:8:"go_today";s:8:"Go Today";s:4:"l_01";s:7:"January";s:4:"l_02";s:8:"February";s:4:"l_03";s:5:"March";s:4:"l_04";s:5:"April";s:4:"l_05";s:3:"May";s:4:"l_06";s:4:"June";s:4:"l_07";s:4:"July";s:4:"l_08";s:6:"August";s:4:"l_09";s:9:"September";s:4:"l_10";s:7:"October";s:4:"l_11";s:8:"November";s:4:"l_12";s:8:"December";s:4:"l_fr";s:6:"Friday";s:4:"l_mo";s:6:"Monday";s:4:"l_sa";s:8:"Saturday";s:4:"l_su";s:6:"Sunday";s:4:"l_th";s:8:"Thursday";s:4:"l_tu";s:7:"Tuesday";s:4:"l_we";s:9:"Wednesday";s:10:"next_month";s:26:"Next month (hold for menu)";s:9:"next_year";s:25:"Next year (hold for menu)";s:13:"open_calendar";s:71:"Click here to open a calendar for date selection (JavaScript required!)";s:10:"part_today";s:8:" (today)";s:10:"prev_month";s:27:"Prev. month (hold for menu)";s:9:"prev_year";s:26:"Prev. year (hold for menu)";s:4:"s_01";s:3:"Jan";s:4:"s_02";s:3:"Feb";s:4:"s_03";s:3:"Mar";s:4:"s_04";s:3:"Apr";s:4:"s_05";s:3:"May";s:4:"s_06";s:3:"Jun";s:4:"s_07";s:3:"Jul";s:4:"s_08";s:3:"Aug";s:4:"s_09";s:3:"Sep";s:4:"s_10";s:3:"Oct";s:4:"s_11";s:3:"Nov";s:4:"s_12";s:3:"Dec";s:4:"s_fr";s:2:"Fr";s:4:"s_mo";s:2:"Mo";s:4:"s_sa";s:2:"Sa";s:4:"s_su";s:2:"Su";s:4:"s_th";s:2:"Th";s:4:"s_tu";s:2:"Tu";s:4:"s_we";s:2:"We";s:11:"select_date";s:11:"Select date";s:9:"time_part";s:37:"(Shift-)Click or drag to change value";s:4:"time";s:4:"Time";s:5:"today";s:5:"Today";s:14:"tt_date_format";s:9:"%a, %b %e";s:2:"wk";s:2:"wk";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'pwassist'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:17:{s:19:"password_assistance";s:19:"Password Assistance";s:20:"pwassist_enter_email";s:350:"Please enter an e-mail address and submit the form.\\nILIAS will send an e-mail to that address. The e-mail contains all user names which have registered this e-mail address.\\nChoose a suitable username and use the password service to retrieve a new password. If you do not retrieve any e-mail by this service please contact your course admin or %1$s.";s:33:"pwassist_enter_username_and_email";s:378:"Enter a username and the associated e-mail address in the fields shown below.\\nILIAS will send a message to that e-mail address. The message contains an address for a web page, where you can enter a new password for the user account.\\nIn case you are unable to assign a password to your user account using this form, contact your course administration or send an e-mail to %1$s.";s:40:"pwassist_enter_username_and_new_password";s:60:"Enter the username and the new password in the fields below.";s:26:"pwassist_invalid_auth_mode";s:90:"The user won\'t be authenticated directly at ILIAS. Thus, sending a password is impossible.";s:22:"pwassist_invalid_email";s:97:"Please correct your e-mail address.\\nThe given e-mail address could not be found in the database.";s:34:"pwassist_invalid_username_or_email";s:133:"Please correct the text in the entry fields.\\nThe username and e-mail address you have entered do not match an entry in the database.";s:24:"pwassist_login_not_match";s:138:"Please enter another username.\\nThe username you have entered does not match the username for which you had asked for password assistance.";s:18:"pwassist_mail_body";s:1158:"Register a new password for your user account:\\n\\t%1$s\\n\\nThis message has been generated automatically by the ILIAS server\\n\\t%2$s\\n\\nYou (or someone at %3$s) has asked for password assistance for the user account "%4$s".\\n\\nPlease check carefully the conditions listed below, and proceed accordingly:\\n\\n- If you have used the password assistance form on the ILIAS server by accident:\\nDelete this mail.\\n\\n- If you are certain, that you never asked for password assistance at this ILIAS server:\\nPlease contact %5$s.\\n\\n- If you asked for password assistance, please proceed as follows:\\n\\n1. Open your browser.\\n\\n2. Enter the following address in your browser:\\n\\t%6$s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your e-mail program has inserted these line breaks.\\n\\n3. On the web page shown by your browser, enter a new password for your user account.\\n\\nPlease note, that for security reasons, you can perform the three steps above only exactly once and for a limited time only. Afterwards the address becomes invalid, and you have to use the password assistance page on the ILIAS server again.";s:18:"pwassist_mail_sent";s:61:"A message has been sent to %1$s.\\nPlease check your mail box.";s:21:"pwassist_mail_subject";s:25:"ILIAS Password Assistance";s:23:"pwassist_no_email_found";s:112:"You can not use the password assistance, since there is no e-Mail address for the user account you have entered.";s:22:"pwassist_not_permitted";s:103:"Please enter another username.\\nPassword assistance is not permitted for the username you have entered.";s:26:"pwassist_password_assigned";s:59:"The password has been successfully assigned to user "%1$s".";s:24:"pwassist_session_expired";s:261:"Please fill in this form again.\\nYour password assistance session has expired. This may have happened, because you tried to use the link that has been sent by e-mail to you more than once, or because too much time has passed since the link has been sent to you.";s:21:"pwassist_update_error";s:141:"Please contact your system administrator.\\nThe password could not be assigned to the user account due to an error whe updating the data base.";s:27:"pwassist_username_mail_body";s:909:"These are the active username found for the given e-mail address:\\n%s\\n\\nThis message has been created automatically by the following ILIAS Server:\\n\\t%s\\n\\nYou (or somebody with IP  %s) have requested support for forgotten user names for the e-mail address \'%s\'.\\n\\nPlease check the following and act as suggested::\\n\\n-You have requested this e-mail by accident:\\nDelete this e-mail.\\n\\n-You are sure, that you never requested this e-mail:\\nPlease contact %s.\\n\\n- If you requested this e-mail, please proceed as follows::\\n\\n1. Start your internet browser.\\n\\n2. Enter the following url:\\n\\t%s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your e-mail program has inserted these line breaks.\\n\\n3. Your Browser now shows the Password-Service. Use this page together with one of the usernames and the according e-mail address to retrieve a new password.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'block_html'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:3:{s:24:"block_html_block_content";s:7:"Content";s:21:"block_html_block_head";s:10:"HTML Block";s:22:"block_html_block_title";s:5:"Title";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'delic'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:5:{s:20:"delic_add_info_links";s:35:"Add Delicious Links on Info Screens";s:22:"delic_add_to_delicious";s:16:"Add to Delicious";s:20:"delic_extt_delicious";s:9:"Delicious";s:14:"delic_settings";s:18:"Delicious Settings";s:18:"delic_user_profile";s:48:"Enable Delicious Account Setting in User Profile";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'gmaps'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:13:{s:18:"gmaps_api_key_desc";s:92:"In order to use the Google Maps extension, you need to sign up for a Google Maps API key at:";s:13:"gmaps_api_key";s:7:"API Key";s:23:"gmaps_enable_gmaps_info";s:59:"Activates Google Maps in user profiles, groups and courses.";s:18:"gmaps_enable_gmaps";s:18:"Enable Google Maps";s:16:"gmaps_extt_gmaps";s:11:"Google Maps";s:14:"gmaps_latitude";s:8:"Latitude";s:15:"gmaps_longitude";s:9:"Longitude";s:20:"gmaps_lookup_address";s:14:"Lookup Address";s:25:"gmaps_public_profile_info";s:30:"Show location in your profile.";s:14:"gmaps_settings";s:20:"Google Maps Settings";s:23:"gmaps_std_location_desc";s:26:"Click map to set location.";s:18:"gmaps_std_location";s:16:"Default Location";s:16:"gmaps_zoom_level";s:10:"Zoom Level";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'jsmath'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:12:{s:27:"jsmath_default_setting_info";s:169:"If checked, jsMath will be used as default method to render LaTeX code for all users who did not enable or disable the jsMath support in their personal profile settings.";s:22:"jsmath_default_setting";s:14:"Use as default";s:25:"jsmath_enable_jsmath_info";s:76:"Activates support for jsMath based mathematical output of LaTeX expressions.";s:20:"jsmath_enable_jsmath";s:13:"Enable jsMath";s:23:"jsmath_enable_user_desc";s:205:"Activate jsMath for the output of mathematical formulae. jsMath output produces scaleable formulae and requires activated Javascript. When jsMath output is deactived, formulae will be rendered as graphics.";s:18:"jsmath_enable_user";s:21:"Enable jsMath support";s:18:"jsmath_extt_jsmath";s:6:"jsMath";s:20:"jsmath_no_javascript";s:381:"If you don\'t see the correct mathematical formula next to this hint, then you have jsMath output enabled but your web browser doesn\'t support JavaScript or JavaScript is disabled. To see mathematical formulae, please activate JavaScript in your web browser and reload this page or go to <strong>Personal Desktop &gt; Personal Profile &gt; jsMath</strong> and disable jsMath output.";s:21:"jsmath_path_not_found";s:88:"Cannot find jsMath.js in the given path. Please check the jsMath location on the server!";s:26:"jsmath_path_to_jsmath_desc";s:121:"The path to the jsMath base directory relative to the ILIAS base directory, e.g. &quot;./Services/Javascript/jsMath&quot;";s:21:"jsmath_path_to_jsmath";s:14:"Path to jsMath";s:15:"jsmath_settings";s:15:"jsMath Settings";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'trac#'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:28:"trac_mode_test_finished_info";s:39:"Users have to finish a test completely.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rcrs'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:3:{s:9:"rcrs_call";s:15:"Call ECS Course";s:17:"rcrs_general_info";s:19:"General Information";s:23:"rcrs_local_informations";s:19:"Further Information";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'sahs'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:50:{s:12:"sahs_chapter";s:7:"Chapter";s:19:"sahs_insert_chapter";s:14:"Insert Chapter";s:16:"sahs_insert_page";s:11:"Insert Page";s:22:"sahs_insert_pagelayout";s:20:"Insert Template Page";s:20:"sahs_insert_scenario";s:24:"Insert Sequenced Chapter";s:15:"sahs_insert_sco";s:10:"Insert SCO";s:24:"sahs_learning_objectives";s:19:"Learning Objectives";s:16:"sahs_new_chapter";s:11:"New Chapter";s:13:"sahs_new_page";s:8:"New Page";s:12:"sahs_new_sco";s:7:"New SCO";s:19:"sahs_oa_no_chapters";s:137:"This screen will list all learning objectives and their assigned questions. You need to create chapters, SCOs, pages and questions first.";s:15:"sahs_oa_no_scos";s:42:"The chapter does not contain any SCOs yet.";s:24:"sahs_objective_alignment";s:20:"Objectives Alignment";s:14:"sahs_objective";s:18:"Learning Objective";s:25:"sahs_objectives_alignment";s:29:"Learning Objectives Alignment";s:15:"sahs_objectives";s:19:"Learning Objectives";s:17:"sahs_organization";s:12:"Organization";s:9:"sahs_page";s:4:"Page";s:15:"sahs_properties";s:10:"Properties";s:14:"sahs_questions";s:9:"Questions";s:18:"sahs_sco_objective";s:10:"Objectives";s:15:"sahs_sequencing";s:10:"Sequencing";s:9:"sahs_unit";s:3:"SCO";s:14:"sahs_new_asset";s:9:"New Asset";s:15:"sahs_insert_ass";s:12:"Insert Asset";s:25:"sahs_hide_objectives_page";s:32:"Hide Description/Objectives Page";s:30:"sahs_hide_objectives_page_info";s:93:"If checked, the SCO description and objectives page will not be included in the presentation.";s:14:"sahs_list_info";s:63:"Use leading * for bullet lists or leading # for numbered lists.";s:27:"sahs_insert_ass_inside_chap";s:29:"Insert Asset (inside chapter)";s:27:"sahs_insert_sco_inside_chap";s:27:"Insert SCO (inside chapter)";s:37:"sahs_insert_sco_from_clip_inside_chap";s:42:"Paste SCOs from Clipboard (inside chapter)";s:37:"sahs_insert_ass_from_clip_inside_chap";s:44:"Paste Assets from Clipboard (inside chapter)";s:25:"sahs_insert_ass_from_clip";s:27:"Paste Assets from Clipboard";s:24:"sahs_insert_special_page";s:19:"Insert Special Page";s:25:"sahs_choose_page_template";s:20:"Choose Page Template";s:24:"sahs_choose_special_page";s:19:"Choose Special Page";s:22:"sahs_sco_final_message";s:37:"You have successfully completed "%s".";s:24:"sahs_authoring_mode_info";s:130:"The SCORM ZIP package must have been created with the ILIAS SCORM editor and it must have been exported as SCORM 1.2/2004 package.";s:19:"sahs_authoring_mode";s:14:"Authoring Mode";s:19:"sahs_std_sequencing";s:19:"Standard Sequencing";s:24:"sahs_std_sequencing_info";s:40:"Use ILIAS standard sequencing behaviour.";s:22:"sahs_import_sequencing";s:17:"Import Sequencing";s:27:"sahs_import_sequencing_info";s:68:"Import sequencing information from package (Sequencing Expert Mode).";s:25:"sahs_activate_expert_mode";s:31:"Activate Sequencing Expert Mode";s:30:"sahs_activate_expert_mode_info";s:190:"The sequencing expert mode allows you to directly edit the sequencing information of the package tree. If you are unsure what this means we recommend to use the default sequencing behaviour.";s:36:"sahs_choose_pages_chap_scos_ass_only";s:58:"Please select either pages, SCOs, assets or chapters only.";s:21:"cont_insert_into_chap";s:27:"Insert items inside chapter";s:22:"cont_insert_after_chap";s:26:"Insert items after chapter";s:20:"sahs_desc_objectives";s:22:"Description/Objectives";s:33:"scorm_create_export_file_html_one";s:48:"Create Export File (HTML, One Page, Review Mode)";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'shib'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:36:{s:16:"shib_add_missing";s:20:"Assign Missing Roles";s:15:"shib_add_remove";s:16:"Add/Remove Roles";s:20:"shib_assignment_type";s:18:"Kind of Assignment";s:14:"shib_attr_info";s:62:"Assign by a specific attribute in the Shibboleth User Profile.";s:19:"shib_attribute_name";s:14:"Attribute Name";s:20:"shib_attribute_value";s:15:"Attribute Value";s:14:"shib_attribute";s:14:"User Attribute";s:26:"shib_check_role_assignment";s:38:"Assignment of Roles After Later Logins";s:16:"shib_choose_role";s:11:"Choose Role";s:25:"shib_confirm_del_role_ass";s:49:"Do you really want to delete the following rules?";s:17:"shib_deleted_rule";s:25:"Deleted role assignments.";s:16:"shib_global_role";s:11:"Global Role";s:15:"shib_ilias_role";s:15:"ILIAS Role Name";s:15:"shib_local_role";s:10:"Local Role";s:22:"shib_missing_attr_name";s:32:"Please enter the attribute name.";s:23:"shib_missing_attr_value";s:33:"Please enter the attribute value.";s:22:"shib_missing_plugin_id";s:31:"Please enter a valid plugin id.";s:17:"shib_missing_role";s:23:"Please select one role.";s:13:"shib_new_rule";s:12:"Add new Rule";s:14:"shib_plugin_id";s:9:"Plugin Id";s:16:"shib_plugin_info";s:75:"Validate the role assignment with a plugin. Please enter a valid plugin id.";s:11:"shib_plugin";s:20:"Assignment by Plugin";s:22:"shib_remove_deprecated";s:25:"Deassign Deprecated Roles";s:19:"shib_role_ass_table";s:29:"New Rule for Role Assignments";s:20:"shib_role_assignment";s:16:"Role Assignments";s:22:"shib_role_by_attribute";s:20:"Shibboleth Attribute";s:19:"shib_role_by_plugin";s:9:"By Plugin";s:19:"shib_role_name_info";s:69:"Please choose either a global role or enter the name of a local role.";s:14:"shib_role_name";s:15:"ILIAS Role Name";s:19:"shib_role_selection";s:14:"Role Selection";s:19:"shib_rule_condition";s:9:"Condition";s:14:"shib_rule_type";s:18:"Type of Assignment";s:17:"shib_rules_tables";s:28:"Active Role Assignment Rules";s:13:"shib_settings";s:19:"Shibboleth Settings";s:26:"shib_update_role_ass_table";s:25:"Edit Role Assignment Rule";s:17:"shib_update_roles";s:16:"Role Assignments";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'license'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:17:{s:9:"arbitrary";s:9:"arbitrary";s:24:"course_licenses_exceeded";s:148:"By adding users the potential accesses will exceed the available licenses. Look at the tab ‘Licenses’ to see which licenses have to be extended.";s:20:"course_licenses_rare";s:134:"Warning: only %s licenses are available for a course object. Look at the tab ‘Licenses’ to see which licenses have to be extended.";s:12:"edit_license";s:12:"Edit license";s:17:"existing_licenses";s:17:"Existing licenses";s:20:"license_counter_info";s:74:"Allows counting used licenses of purchased SCORM and HTML learning modules";s:15:"license_counter";s:15:"License counter";s:15:"license_updated";s:29:"The license data was updated.";s:20:"license_warning_info";s:113:"Up to this number of remaining licenses for a course object a warning is presented when a user enters the course.";s:15:"license_warning";s:15:"License warning";s:30:"potential_accesses_explanation";s:84:"Every user with read access who hasn\'t accessed so far counts as a potential access.";s:18:"potential_accesses";s:18:"Potential accesses";s:30:"remaining_licenses_explanation";s:66:"The available licenses are calculated as purchased minus consumed.";s:18:"remaining_licenses";s:18:"Available licenses";s:25:"used_licenses_explanation";s:48:"Every first access of a user consumes a license.";s:13:"used_licenses";s:17:"Consumed licenses";s:25:"zero_licenses_explanation";s:38:"Enter a 0 to deactivate the licensing.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'chat'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:211:{s:11:"cancel_talk";s:14:"Cancel address";s:14:"cancel_whisper";s:14:"Cancel whisper";s:19:"chat_access_blocked";s:38:"You are excluded from these chat rooms";s:17:"chat_active_users";s:26:"Present Users in Chat Room";s:11:"chat_active";s:6:"Active";s:22:"chat_add_allowed_hosts";s:82:"Please add the address of the host(s) which are allowed to access the chat server.";s:17:"chat_add_blocking";s:10:"Block user";s:20:"chat_add_external_ip";s:36:"Please add the server\'s external IP.";s:20:"chat_add_internal_ip";s:36:"Please add the server\'s internal IP.";s:27:"chat_add_moderator_password";s:32:"Please add a moderator password.";s:13:"chat_add_port";s:27:"Please add the server port.";s:25:"chat_add_private_chatroom";s:21:"Add Private Chat Room";s:15:"chat_add_smiley";s:10:"Add Smiley";s:17:"chat_add_ssl_port";s:31:"Please add the server SSL port.";s:23:"chat_add_to_addressbook";s:15:"Add to Contacts";s:20:"chat_add_to_bookmark";s:16:"Add to Bookmarks";s:25:"chat_added_to_addressbook";s:48:"The User \' %s \' has been added to your Contacts.";s:23:"chat_added_to_bookmarks";s:66:"The Room \' %s \' has been added to the top folder of your Bookmarks";s:17:"chat_address_user";s:7:"Address";s:12:"chat_address";s:7:"Address";s:9:"chat_aqua";s:4:"aqua";s:10:"chat_arial";s:5:"Arial";s:22:"chat_available_smilies";s:17:"Available Smileys";s:10:"chat_black";s:5:"black";s:15:"chat_block_user";s:5:"Block";s:21:"chat_blocked_unlocked";s:6:"Unlock";s:18:"chat_blocked_users";s:13:"Blocked users";s:12:"chat_blocked";s:17:"Restricted access";s:9:"chat_blue";s:4:"blue";s:9:"chat_bold";s:4:"Bold";s:29:"chat_cannot_connect_to_server";s:58:"ILIAS cannot build a socket connection to the chat server.";s:20:"chat_chat_invitation";s:16:"Chat Invitations";s:18:"chat_chatroom_body";s:10:"Chat room:";s:20:"chat_chatroom_rename";s:14:"Edit chat room";s:14:"chat_chatrooms";s:10:"Chat Rooms";s:15:"chat_chatviewer";s:11:"Chat Viewer";s:10:"chat_color";s:10:"Font color";s:32:"chat_confirm_delete_private_room";s:41:"Are you sure to delete this private room?";s:26:"chat_confirm_delete_smiley";s:57:"Are you sure that all selected Smileys should be deleted?";s:19:"chat_confirm_delete";s:48:"Are you sure that you want to delete this rooms?";s:22:"chat_confirm_kick_user";s:31:"Are you sure to kick this user?";s:24:"chat_confirm_user_invite";s:42:"The User will be invited to this Chat Room";s:23:"chat_current_image_path";s:18:"Current Image Path";s:33:"chat_default_bookmark_description";s:24:"Link to Chat Room \' %s \'";s:27:"chat_default_bookmark_title";s:13:"Chat Link: %s";s:20:"chat_delete_selected";s:23:"Delete selected Smileys";s:16:"chat_delete_sure";s:47:"Are you sure, you want to delete this chat room";s:19:"chat_disinvite_user";s:44:"Disinvite/remove user from private chat room";s:14:"chat_disinvite";s:9:"Disinvite";s:14:"chat_drop_user";s:11:"User kicked";s:16:"chat_edit_smiley";s:11:"Edit Smiley";s:9:"chat_edit";s:9:"Edit chat";s:10:"chat_empty";s:5:"Empty";s:22:"chat_enable_autoscroll";s:17:"Enable Autoscroll";s:25:"chat_enter_valid_username";s:30:"Please enter a valid username.";s:15:"chat_export_all";s:50:"No restrictions (all users with access may export)";s:16:"chat_export_info";s:86:"Displays an export button for the current room. The messages will be exported to html.";s:21:"chat_export_moderator";s:15:"Moderators only";s:23:"chat_export_period_info";s:31:"Export the given number of days";s:18:"chat_export_period";s:13:"Export period";s:18:"chat_export_status";s:27:"Required export permissions";s:9:"chat_face";s:9:"Font type";s:12:"chat_fuchsia";s:7:"fuchsia";s:21:"chat_general_settings";s:16:"General Settings";s:9:"chat_gray";s:4:"gray";s:10:"chat_green";s:5:"green";s:17:"chat_hide_details";s:12:"Hide details";s:17:"chat_hide_smilies";s:12:"Hide smileys";s:20:"chat_hide_textformat";s:15:"Hide Textformat";s:16:"chat_html_export";s:11:"HTML export";s:10:"chat_ilias";s:17:"ILIAS Chat module";s:15:"chat_image_path";s:10:"Image Path";s:13:"chat_inactive";s:8:"Inactive";s:10:"chat_input";s:5:"Input";s:19:"chat_insert_message";s:23:"Please insert a message";s:20:"chat_invitation_body";s:24:"Invitation to chat from:";s:23:"chat_invitation_subject";s:15:"Chat invitation";s:16:"chat_invite_user";s:11:"Invite user";s:11:"chat_invite";s:6:"Invite";s:15:"chat_invited_by";s:10:"Invited by";s:11:"chat_italic";s:6:"Italic";s:22:"chat_kick_user_session";s:9:"Kick user";s:9:"chat_kick";s:4:"Kick";s:21:"chat_kicked_from_room";s:68:"You have been kicked from this chat room, you cannot write messages.";s:14:"chat_level_all";s:3:"All";s:16:"chat_level_debug";s:5:"Debug";s:16:"chat_level_error";s:5:"Error";s:16:"chat_level_fatal";s:5:"Fatal";s:15:"chat_level_info";s:4:"Info";s:9:"chat_lime";s:4:"lime";s:11:"chat_maroon";s:6:"maroon";s:28:"chat_message_notify_activate";s:18:"Chat Notifications";s:30:"chat_message_notify_deactivate";s:25:"Deactivate Message Notify";s:19:"chat_message_notify";s:16:"Message Notifier";s:21:"chat_messages_deleted";s:27:"Messages have been deleted.";s:23:"chat_moderator_password";s:18:"Moderator password";s:9:"chat_navy";s:4:"navy";s:32:"chat_new_invitation_sound_status";s:57:"Play a sound when user receives an invitation to the chat";s:29:"chat_new_message_sound_status";s:59:"Play a sound when a new message has been posted to the chat";s:16:"chat_new_message";s:11:"New message";s:20:"chat_no_active_users";s:25:"No further users present.";s:15:"chat_no_blocked";s:26:"No blocked users available";s:18:"chat_no_connection";s:27:"Cannot contact chat server.";s:21:"chat_no_delete_public";s:38:"The public chat room cannot be deleted";s:20:"chat_no_online_users";s:24:"No further users online.";s:28:"chat_no_recordings_available";s:42:"No recordings are available at the moment.";s:22:"chat_no_refresh_public";s:41:"The public chat room cannot be refreshed.";s:21:"chat_no_rename_public";s:33:"The public room cannot be renamed";s:21:"chat_no_room_selected";s:26:"No room has been selected.";s:22:"chat_no_users_selected";s:28:"You have to select one user.";s:18:"chat_no_write_perm";s:22:"No permission to write";s:23:"chat_notification_intro";s:72:"This mail was automatically sent to you by the ILIAS installation %s, %s";s:10:"chat_olive";s:5:"olive";s:17:"chat_online_users";s:18:"Other Users Online";s:9:"chat_open";s:10:"Enter Room";s:20:"chat_private_message";s:15:"Private Message";s:12:"chat_profile";s:7:"Profile";s:16:"chat_public_room";s:16:"Public chat room";s:11:"chat_purple";s:6:"purple";s:20:"chat_recent_postings";s:20:"Recent Chat Postings";s:21:"chat_recording_action";s:6:"Action";s:26:"chat_recording_description";s:11:"Description";s:24:"chat_recording_moderator";s:9:"Moderator";s:24:"chat_recording_not_found";s:25:"Could not find recording.";s:22:"chat_recording_running";s:17:"Recording running";s:22:"chat_recording_started";s:17:"Recording started";s:22:"chat_recording_stopped";s:17:"Recording stopped";s:25:"chat_recording_time_frame";s:10:"Time frame";s:20:"chat_recording_title";s:18:"Title of recording";s:27:"chat_recordings_delete_sure";s:32:"Deleting records - are you sure?";s:23:"chat_recordings_deleted";s:24:"Recordings were deleted.";s:26:"chat_recordings_select_one";s:50:"Please choose recordings you would like to delete.";s:15:"chat_recordings";s:10:"Recordings";s:8:"chat_red";s:3:"red";s:12:"chat_refresh";s:7:"Refresh";s:14:"chat_refreshed";s:48:"Deleted all messages of the selected chat rooms.";s:15:"chat_room_added";s:19:"Added new chat room";s:24:"chat_room_does_not_exist";s:84:"The Chat Room does not exist. Maybe it has been removed or you used an invalid link.";s:14:"chat_room_name";s:17:"Name of chat room";s:17:"chat_room_renamed";s:18:"Chat room renamed.";s:16:"chat_room_select";s:17:"Private chat room";s:18:"chat_rooms_deleted";s:21:"Chat room(s) deleted.";s:10:"chat_rooms";s:10:"Chat Rooms";s:20:"chat_select_one_room";s:27:"Please select one chat room";s:21:"chat_server_allowed_b";s:30:"(e.g. 192.168.1.1,192.168.1.2)";s:19:"chat_server_allowed";s:13:"Allowed hosts";s:23:"chat_server_external_ip";s:14:"Server Address";s:23:"chat_server_internal_ip";s:18:"Server internal IP";s:19:"chat_server_logfile";s:13:"Log file path";s:20:"chat_server_loglevel";s:9:"Log level";s:22:"chat_server_not_active";s:29:"The chat server is not active";s:16:"chat_server_port";s:11:"Server Port";s:20:"chat_server_settings";s:20:"Chat server settings";s:22:"chat_server_ssl_active";s:10:"SSL active";s:20:"chat_server_ssl_port";s:15:"Server SSL Port";s:24:"chat_server_ssl_settings";s:12:"SSL Settings";s:19:"chat_settings_saved";s:14:"Settings saved";s:17:"chat_show_details";s:12:"Show details";s:17:"chat_show_smilies";s:12:"Show smileys";s:20:"chat_show_textformat";s:11:"Format text";s:11:"chat_silver";s:6:"silver";s:33:"chat_smiley_image_only_if_changed";s:122:"Please enter a new Image only if you want to change the existing. If no new Image is given, the existing won\'t be changed.";s:17:"chat_smiley_image";s:12:"Smiley Image";s:19:"chat_smiley_keyword";s:15:"Smiley Shortcut";s:38:"chat_smiley_keywords_one_per_line_note";s:94:"You can enter multiple Keywords for each Smiley. Each line will be used as a seperate Keyword.";s:20:"chat_smiley_keywords";s:16:"Smiley Shortcuts";s:21:"chat_smilies_activate";s:16:"Activate Smileys";s:23:"chat_smilies_deactivate";s:18:"Deactivate Smileys";s:30:"chat_smilies_dir_not_available";s:126:"The smiley data directory could not be created. This ILIAS will not be able to use chat smileys as further actions are needed.";s:27:"chat_smilies_dir_not_exists";s:79:"The smiley data directory does not exist. Trying to setup folders and database.";s:29:"chat_smilies_dir_not_writable";s:90:"Your smiley data directory exists but is not writable. You will not be able to add smiles.";s:24:"chat_smilies_initialized";s:57:"The smiley data has been initialized and is ready to use.";s:19:"chat_smilies_status";s:12:"Chat Smileys";s:26:"chat_sound_status_activate";s:15:"Activate Sounds";s:28:"chat_sound_status_deactivate";s:17:"Deactivate Sounds";s:11:"chat_sounds";s:6:"Sounds";s:20:"chat_start_recording";s:15:"Start recording";s:17:"chat_status_saved";s:27:"The status has been changed";s:11:"chat_status";s:6:"Status";s:19:"chat_stop_recording";s:14:"Stop recording";s:11:"chat_tahoma";s:6:"Tahoma";s:9:"chat_teal";s:4:"teal";s:15:"chat_textformat";s:11:"Format text";s:10:"chat_times";s:5:"Times";s:18:"chat_title_missing";s:21:"Please insert a name.";s:17:"chat_to_chat_body";s:11:"To the chat";s:9:"chat_type";s:9:"Font face";s:19:"chat_unblocked_user";s:37:"The selected user have been unlocked.";s:15:"chat_underlined";s:10:"Underlined";s:24:"chat_unkick_user_session";s:11:"Unkick user";s:11:"chat_unkick";s:6:"Unkick";s:18:"chat_upload_smiley";s:13:"Upload Smiley";s:25:"chat_user_already_blocked";s:52:"The access for the selected user is already blocked.";s:32:"chat_user_already_in_addressbook";s:37:"The User is already in your Contacts.";s:17:"chat_user_blocked";s:37:"Blocked access for the selected user.";s:25:"chat_user_dropped_private";s:59:"The user was disinvited/removed from the private chat room.";s:17:"chat_user_dropped";s:11:"User kicked";s:16:"chat_user_hidden";s:6:"hidden";s:25:"chat_user_invited_private";s:51:"The user was invited to the private chat room \'%s\'.";s:24:"chat_user_invited_public";s:38:"The user was invited to the chat \'%s\'.";s:17:"chat_user_invited";s:21:"Invited user to chat.";s:14:"chat_user_name";s:8:"Username";s:18:"chat_user_unkicked";s:27:"The user has been unkicked.";s:17:"chat_user_visible";s:7:"visible";s:12:"chat_whisper";s:7:"Whisper";s:11:"chat_yellow";s:6:"yellow";s:5:"chats";s:5:"Chats";s:19:"check_configuration";s:40:"Please check the chat server\'s settings.";s:12:"edit_smilies";s:12:"Edit Smileys";s:8:"my_chats";s:8:"My Chats";s:33:"chat_activate_status_notification";s:74:"Show notification about new chat invitations and messages in main menu bar";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'exp'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:10:{s:15:"exp_create_file";s:18:"Create Export File";s:16:"exp_export_files";s:12:"Export Files";s:8:"exp_html";s:4:"HTML";s:17:"exp_really_delete";s:48:"Do you really want to delete these export files?";s:9:"exp_scorm";s:5:"SCORM";s:23:"exp_select_max_one_item";s:98:"Please select one item only. This action cannot be executed for multiple objects at the same time.";s:7:"exp_xml";s:3:"XML";s:19:"exp_create_xml_file";s:27:"Create Export Package (XML)";s:14:"export_created";s:35:"A new export file has been created.";s:16:"exp_file_created";s:33:"The export file has been created.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'export'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:13:{s:22:"export_create_new_file";s:22:"Create New Export File";s:13:"export_create";s:6:"Create";s:18:"export_export_date";s:11:"Export Date";s:23:"export_last_export_file";s:20:"Use Last Export File";s:18:"export_last_export";s:11:"Last Export";s:16:"export_last_file";s:9:"Last File";s:20:"export_omit_resource";s:13:"Omit Resource";s:11:"export_omit";s:4:"Omit";s:15:"export_resource";s:8:"Resource";s:23:"export_select_resources";s:16:"Select Resources";s:15:"export_existing";s:5:"Reuse";s:21:"export_save_selection";s:12:"Start Export";s:7:"no_file";s:7:"No file";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'feed'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:19:{s:30:"block_feed_block_feed_url_info";s:62:"Must be a valid RSS/Atom URL, e.g. http://www.ilias.de/rss.php";s:25:"block_feed_block_feed_url";s:8:"Feed URL";s:21:"block_feed_block_head";s:17:"External Web Feed";s:22:"block_feed_block_title";s:5:"Title";s:27:"feed_disable_rep_feeds_info";s:108:"Disables presentation of external web feeds in case of an unexpected problem due to an external feed source.";s:22:"feed_disable_rep_feeds";s:14:"Hide Web Feeds";s:15:"feed_feed_items";s:12:"Feed Item(s)";s:17:"feed_loading_feed";s:15:"Loading Feed...";s:21:"feed_no_js_click_here";s:37:"If feed is not displayed, click here.";s:17:"feed_no_valid_url";s:26:"The Feed URL is not valid.";s:21:"feed_nr_pd_feeds_info";s:200:"Sets the maximum number of external web feeds, that users may add to their personal desktop. Existing feeds are not deleted, if option is set to a lower value. ‘0‘ disables the feature completely.";s:16:"feed_nr_pd_feeds";s:44:"Number of External Feeds on Personal Desktop";s:21:"feed_open_source_page";s:18:"Open in New Window";s:15:"feed_proxy_info";s:32:"Proxy host for socket connection";s:20:"feed_proxy_port_info";s:32:"Proxy port for socket connection";s:15:"feed_proxy_port";s:10:"Proxy Port";s:10:"feed_proxy";s:10:"Proxy Host";s:13:"feed_settings";s:27:"External Web Feeds Settings";s:11:"feed_import";s:11:"Import Feed";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'mep'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:42:{s:12:"mep_all_mobs";s:17:"All Media Objects";s:7:"mep_all";s:3:"All";s:9:"mep_clone";s:28:"Clone an existing media pool";s:26:"mep_content_snippet_in_use";s:53:"Content snippet \'%s\' is in use and cannot be deleted.";s:15:"mep_copy_to_mep";s:18:"Copy to Media Pool";s:26:"mep_create_content_snippet";s:22:"Create Content Snippet";s:17:"mep_create_folder";s:13:"Create Folder";s:14:"mep_create_mob";s:19:"Create Media Object";s:10:"mep_create";s:23:"Create a new media pool";s:18:"mep_default_height";s:14:"Default Height";s:29:"mep_default_width_height_info";s:75:"Default width and height are used as presets for new media object creation.";s:17:"mep_default_width";s:13:"Default Width";s:24:"mep_edit_content_snippet";s:20:"Edit Content Snippet";s:15:"mep_edit_folder";s:11:"Edit Folder";s:18:"mep_folder_content";s:14:"Folder Content";s:10:"mep_folder";s:6:"Folder";s:10:"mep_format";s:6:"Format";s:10:"mep_import";s:19:"Import a media pool";s:23:"mep_new_content_snippet";s:19:"New Content Snippet";s:14:"mep_new_folder";s:10:"New Folder";s:16:"mep_page_created";s:24:"Content snippet created.";s:19:"mep_page_properties";s:15:"Page Properties";s:17:"mep_parent_folder";s:13:"Parent Folder";s:13:"mep_thumbnail";s:9:"Thumbnail";s:25:"mep_title_and_description";s:21:"Title and Description";s:11:"mep_unknown";s:7:"Unknown";s:24:"mobs_activate_pages_info";s:113:"Allows to create content snippets in media pools. These snippets can be re-used (not edited) in learning modules.";s:19:"mobs_activate_pages";s:20:"Use Content Snippets";s:34:"mobs_always_show_file_manager_info";s:101:"If deactivated the file manager for media objects will be hidden for simple mime types (e.g. images).";s:29:"mobs_always_show_file_manager";s:24:"Always Show File Manager";s:24:"mobs_restrict_file_types";s:19:"Restrict File Types";s:29:"mobs_restrict_file_types_info";s:164:"Enter a comma separated list of file suffixes (e.g. jpg,gif) that are allowed to be uploaded into media objects. If no value is entered, all file types are allowed.";s:26:"mep_create_from_upload_dir";s:42:"Create Media Objects from Upload Directory";s:24:"mep_sel_upload_dir_files";s:24:"Select Files/Directories";s:20:"mep_upload_dir_files";s:27:"Files from Upload Directory";s:8:"mep_file";s:4:"File";s:22:"mep_create_media_files";s:20:"Create Media Objects";s:15:"mep_up_dir_move";s:41:"Move Files from Upload Directory (Faster)";s:15:"mep_up_dir_copy";s:70:"Copy Files from Upload Directory (Keeps files in the upload directory)";s:42:"mep_content_snippet_used_in_older_versions";s:179:"Please note: This snippet is used in older versions of some pages. If these pages are rolled back to a version that includes this snippet, the snippet will be missing in the page.";s:19:"mep_choose_from_mep";s:16:"Choose from Pool";s:22:"mep_choose_from_folder";s:18:"Choose from Folder";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'tbl'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:7:{s:13:"tbl_templates";s:4:"View";s:19:"tbl_template_create";s:17:"Save Current View";s:19:"tbl_template_delete";s:17:"Delete Saved View";s:20:"tbl_template_created";s:32:"The current view has been saved.";s:20:"tbl_template_deleted";s:32:"The saved view has been deleted.";s:14:"tbl_export_csv";s:11:"Export .csv";s:16:"tbl_export_excel";s:11:"Export .xls";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'auth'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:46:{s:27:"auth_account_migration_keep";s:29:"Migrate Existing User Account";s:27:"auth_account_migration_name";s:9:"Migration";s:26:"auth_account_migration_new";s:23:"Create New User Account";s:22:"auth_account_migration";s:17:"New ILIAS Account";s:13:"auth_info_add";s:88:"Choose this option if you have never registered to ILIAS. A new account will be created.";s:17:"auth_info_migrate";s:120:"If you have already an ILIAS account, enter username and password to migrate your personal data (mail, test results...).";s:21:"auth_openid_configure";s:31:"Configure OpenId-Authentication";s:28:"auth_openid_deleted_provider";s:32:"Removed selected OpenID provider";s:18:"auth_openid_enable";s:21:"Enable OpenId Support";s:24:"auth_openid_login_info_a";s:55:"Please enter your OpenID username and choose a provider";s:17:"auth_openid_login";s:11:"Your OpenID";s:26:"auth_openid_migration_info";s:121:"Activate this option to give new users the possibility to migrate their existing ILIAS accounts to OpenId authentication.";s:21:"auth_openid_migration";s:18:"Account Migration:";s:24:"auth_openid_provider_add";s:12:"Add Provider";s:25:"auth_openid_provider_edit";s:13:"Edit Provider";s:24:"auth_openid_provider_tbl";s:15:"OpenID Provider";s:20:"auth_openid_provider";s:18:"Provider Selection";s:23:"auth_openid_role_select";s:5:"Role:";s:20:"auth_openid_settings";s:15:"OpenId Settings";s:21:"auth_openid_sync_info";s:91:"If enabled new user accounts will be created automatically after successful authentication.";s:16:"auth_openid_sync";s:20:"User Synchronization";s:39:"auth_openid_uncontrolled_selection_info";s:135:"If enabled, any OpenID Provider can be used for authentication. Otherwise the provider has to be chosen from a list of valid providers.";s:34:"auth_openid_uncontrolled_selection";s:31:"Uncontrolled Provider Selection";s:20:"auth_openid_url_info";s:91:"Enter an OpenID url and replace the username with "%s". For example: http://%s.myopenid.com";s:11:"auth_openid";s:6:"OpenId";s:23:"auth_rad_migration_info";s:121:"Activate this option to give new users the possibility to migrate their existing ILIAS accounts to Radius authentication.";s:18:"auth_rad_migration";s:18:"Account Migration:";s:24:"auth_radius_charset_info";s:107:"Please choose the character encoding for the communication with the radius server. If unsure, choose UTF-8.";s:19:"auth_radius_charset";s:18:"Character Encoding";s:20:"auth_radius_sync_rad";s:37:"Automatic generation of user accounts";s:25:"auth_radius_sync_rad_info";s:137:"Creates automatically ILIAS user accounts, for users that successfully authenticated against Radius, without having an ILIAS account yet.";s:16:"auth_radius_ldap";s:26:"Synchronization using LDAP";s:21:"auth_radius_ldap_info";s:115:"If enabled, the synchronization of user accounts and role assignments is done using an existing LDAP configuration.";s:9:"auth_sync";s:20:"User Synchronisation";s:13:"auth_sync_cas";s:37:"Automatic generation of user accounts";s:18:"auth_sync_cas_info";s:134:"Creates automatically ILIAS user accounts, for users that successfully authenticated against CAS, without having an ILIAS account yet.";s:21:"login_page_switch_rte";s:20:"Use Rich-Text-Editor";s:21:"login_page_switch_ipe";s:21:"Use ILIAS Page Editor";s:26:"login_page_editor_switched";s:39:"The active page editor has been changed";s:19:"login_page_activate";s:38:"Activate Editor for Selected Languages";s:17:"auth_account_code";s:4:"Code";s:22:"auth_account_code_info";s:61:"To re-activate your account you can use a ILIAS account code.";s:23:"auth_account_code_title";s:12:"Account Code";s:22:"auth_account_code_used";s:81:"Your account has been re-activated. Please login once again for security reasons.";s:17:"auth_login_editor";s:18:"Loginscreen Editor";s:18:"auth_auth_settings";s:8:"Settings";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'chatroom'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:133:{s:22:"chat_enable_autoscroll";s:17:"Enable Autoscroll";s:28:"chat_message_notify_activate";s:18:"Chat Notifications";s:32:"chat_new_invitation_sound_status";s:57:"Play a sound when user receives an invitation to the chat";s:29:"chat_new_message_sound_status";s:59:"Play a sound when a new message has been posted to the chat";s:13:"chat_settings";s:13:"Chat Settings";s:16:"chat_select_room";s:16:"Select Chat Room";s:14:"history_by_day";s:13:"Daily History";s:17:"no_username_given";s:24:"Please choose a username";s:18:"history_by_session";s:15:"Session History";s:9:"connected";s:22:"Connection Established";s:6:"period";s:6:"Period";s:12:"disconnected";s:17:"Connection Closed";s:15:"allow_anonymous";s:21:"Allow Anonymous Login";s:17:"autogen_usernames";s:25:"Auto Generated User Names";s:22:"allow_custom_usernames";s:23:"Allow Custom User Names";s:14:"enable_history";s:14:"Enable History";s:16:"restrict_history";s:16:"Restrict History";s:21:"restrict_history_info";s:51:"No entries generated during absence from chat room.";s:19:"allow_private_rooms";s:19:"Allow Private Rooms";s:16:"settings_general";s:7:"General";s:16:"settings_privacy";s:7:"Privacy";s:22:"autogen_usernames_info";s:134:"Pattern for auto generated user names that is assigned to anonymous user accounts. ‘#’ will be automatically replaced by a number.";s:4:"bans";s:4:"Bans";s:11:"permissions";s:11:"Permissions";s:6:"remark";s:6:"Remark";s:7:"session";s:7:"Session";s:9:"fontcolor";s:10:"Font Color";s:9:"fontstyle";s:10:"Font Style";s:8:"fontsize";s:9:"Font Size";s:6:"italic";s:6:"Italic";s:10:"underlined";s:10:"Underlined";s:22:"select_custom_username";s:22:"Select Custom Username";s:15:"custom_username";s:15:"Custom Username";s:5:"enter";s:15:"Enter Chat Room";s:10:"fontfamily";s:11:"Font Family";s:5:"small";s:5:"Small";s:5:"large";s:5:"Large";s:13:"duration_from";s:4:"From";s:11:"duration_to";s:2:"To";s:8:"obj_chtr";s:8:"Chatroom";s:12:"chat_message";s:7:"Message";s:19:"chat_message_to_all";s:6:"To All";s:20:"chat_message_options";s:7:"Display";s:20:"chat_message_display";s:7:"Options";s:13:"chat_mainroom";s:9:"Main Room";s:10:"chat_leave";s:5:"Leave";s:9:"chat_join";s:4:"Join";s:11:"chat_delete";s:6:"Delete";s:11:"chat_invite";s:6:"Invite";s:9:"chat_kick";s:4:"Kick";s:8:"chat_ban";s:3:"Ban";s:12:"chat_address";s:7:"Address";s:12:"chat_whisper";s:7:"Whisper";s:27:"chat_connection_established";s:47:"+++ <b>#username#</b> has entered chat room +++";s:28:"chat_connection_disconnected";s:44:"--- <b>#username#</b> left the chat room ---";s:17:"chat_invite_users";s:12:"Invite Users";s:19:"chat_right_box_user";s:4:"User";s:28:"chat_create_new_private_room";s:23:"Create new Private Room";s:17:"chat_private_room";s:12:"Private Room";s:16:"chat_to_mainroom";s:12:"To Main Room";s:31:"chat_create_private_room_button";s:19:"Create Private Room";s:8:"moderate";s:8:"Moderate";s:23:"chatroom_smiley_keyword";s:7:"Keyword";s:15:"chat_invitation";s:55:"Invitation from [INVITER_NAME] to chat room [ROOM_NAME]";s:20:"chat_invitation_long";s:179:"[SALUTATION]\\n\\nYou have been invited to a chat room:\\nChat room Title: [ROOM_NAME]\\nInvited by: [INVITER_NAME]\\nURL: [LINK]\\n\\nTo join the chat room, please follow the given URL.";s:21:"chat_invitation_short";s:51:"Please click the title link to enter the chat room.";s:14:"settings_title";s:8:"Settings";s:19:"history_byday_title";s:25:"Show Conversation per Day";s:23:"history_bysession_title";s:29:"Show Conversation per Session";s:15:"ban_table_title";s:12:"Banned Users";s:4:"main";s:9:"Main Room";s:20:"soap_must_be_enabled";s:72:"You must active SOAP support in the general settings to enable the chat.";s:11:"auto_scroll";s:16:"Scroll to Bottom";s:19:"public_chat_created";s:54:"The public chat room has been added to the repository.";s:15:"lost_connection";s:50:"The connection to the chat server was interrupted.";s:6:"banned";s:40:"You have been banned from this chat room";s:5:"unban";s:5:"Unban";s:17:"unable_to_connect";s:59:"The connection to the chat server could not be established.";s:13:"chtr_moderate";s:41:"User can moderate discussion in chat room";s:19:"unkown_private_room";s:20:"Unknown private room";s:26:"server_further_information";s:118:"You can find further information about the server configuration in the <a href="%1$s" target="_blank">readme file</a>.";s:8:"chtr_new";s:13:"New Chat Room";s:8:"chtr_add";s:13:"Add Chat Room";s:15:"welcome_to_chat";s:24:"Welcome to the chat room";s:12:"user_invited";s:26:"The user has been invited.";s:11:"user_kicked";s:39:"The user <b>#user#</b> has been kicked.";s:17:"user_invited_self";s:57:"<b>#user#</b> invited you to the chat room <b>#room#</b>.";s:19:"private_room_closed";s:45:"The chat room <b>#title#</b> has been closed.";s:20:"private_room_entered";s:43:"Welcome to the private room <b>#title#</b>.";s:17:"private_room_left";s:64:"The user <b>#user#</b> has left the private room <b>#title#</b>.";s:25:"private_room_entered_user";s:67:"The user <b>#user#</b> has entered the private room <b>#title#</b>.";s:24:"kicked_from_private_room";s:58:"You have been kicked from the private room <b>#title#</b>.";s:18:"chatserver_address";s:25:"IP-Address of Chat Server";s:15:"chatserver_port";s:19:"Port of Chat Server";s:13:"instance_name";s:17:"Unique Identifier";s:9:"ilias_url";s:35:"Base-URL of your ILIAS Installation";s:9:"soap_user";s:17:"Name of SOAP User";s:18:"soap_user_password";s:21:"Password of SOAP User";s:8:"hint_osd";s:64:"If enabled, users are notified by a popup about new invitations.";s:17:"hint_osd_interval";s:165:"Polling interval for checking of new notifications. A lower number will notify the user more quickly but increases the number of requests the web server must handle.";s:16:"hint_unique_name";s:263:"A name that is used by ILIAS and the chat server to identify your ILIAS. If using more than one client per chat server, this name must be unique per ILIAS instance.<br/>The name may contain letters (A-Z/a-z), numerics (0-9) and the characters ‘-’ and ‘_’.";s:14:"enable_smilies";s:14:"Enable Smileys";s:19:"hint_enable_smilies";s:101:"If activated, configured text sequences are replaced with an icon. See Smileys tab for configuration.";s:17:"display_past_msgs";s:23:"Number of Past Messages";s:22:"hint_display_past_msgs";s:102:"Number of previous messages shown when chat room is entered. A value of ‘0’ disables this feature.";s:8:"speak_to";s:22:"Speak to <b>#user#</b>";s:10:"whisper_to";s:24:"Whisper to <b>#user#</b>";s:18:"leave_private_room";s:18:"Leave Private Room";s:19:"delete_private_room";s:19:"Delete Private Room";s:22:"invite_to_private_room";s:22:"Invite to Current Room";s:5:"scope";s:17:"Room/Private Room";s:12:"user_in_room";s:34:"Invite user from current chat room";s:13:"user_in_ilias";s:33:"Search and invite user from ILIAS";s:13:"kick_question";s:54:"Do you really want to kick the user from current room?";s:12:"ban_question";s:53:"Do you really want to ban the user from current room?";s:15:"history_cleared";s:47:"The message history was deleted by a moderator.";s:18:"clear_room_history";s:22:"Delete Message History";s:27:"clear_room_history_question";s:62:"Do you really want to delete all messages of the current room?";s:14:"anonymous_hint";s:124:"Make sure to set the proper permissions in the ‘Permissions’ tab to allow anonymous user access to this repository item.";s:24:"create_private_room_text";s:17:"Private room name";s:15:"invite_username";s:8:"Username";s:6:"layout";s:6:"Layout";s:13:"show_settings";s:13:"Show Settings";s:13:"hide_settings";s:13:"Hide Settings";s:21:"private_rooms_enabled";s:19:"Allow Private Rooms";s:26:"private_rooms_enabled_info";s:91:"If activated, users can create private rooms. Only invited users have access to this rooms.";s:16:"no_further_users";s:22:"No other users present";s:5:"users";s:5:"Users";s:11:"no_messages";s:49:"There are no saved messages for the given period.";s:21:"history_title_general";s:30:"Conversation in Chat Room "%s"";s:26:"history_title_private_room";s:33:"Conversation in Private Room "%s"";s:11:"end_whisper";s:6:"Cancel";s:17:"room_in_container";s:11:"%s (in: %s)";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'cmps'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:61:{s:13:"cmps_activate";s:8:"Activate";s:11:"cmps_active";s:6:"Active";s:17:"cmps_add_new_rank";s:31:"Position in Add-New-Object List";s:14:"cmps_available";s:9:"Available";s:16:"cmps_basic_files";s:11:"Basic Files";s:15:"cmps_class_file";s:10:"Class File";s:14:"cmps_component";s:9:"Component";s:20:"cmps_current_version";s:15:"Current Version";s:13:"cmps_database";s:8:"Database";s:14:"cmps_db_update";s:16:"DB Update Script";s:15:"cmps_deactivate";s:10:"Deactivate";s:8:"cmps_dir";s:9:"Directory";s:21:"cmps_disable_creation";s:16:"Disable Creation";s:24:"cmps_duplicate_positions";s:70:"Please note, that the following positions are assigned multiple times:";s:18:"cmps_edit_settings";s:8:"Settings";s:17:"cmps_file_version";s:19:"Update File Version";s:10:"cmps_group";s:5:"Group";s:7:"cmps_id";s:2:"ID";s:22:"cmps_ilias_max_version";s:18:"Max. ILIAS Version";s:22:"cmps_ilias_min_version";s:18:"Min. ILIAS Version";s:13:"cmps_inactive";s:8:"Inactive";s:15:"cmps_lang_files";s:14:"Language Files";s:16:"cmps_lang_prefix";s:25:"Language Variables Prefix";s:14:"cmps_languages";s:9:"Languages";s:13:"cmps_main_dir";s:14:"Main Directory";s:12:"cmps_missing";s:7:"Missing";s:11:"cmps_module";s:6:"Module";s:9:"cmps_name";s:4:"Name";s:30:"cmps_needs_newer_ilias_version";s:76:"This plugin version only runs on newer ILIAS versions. Please upgrade ILIAS.";s:31:"cmps_needs_newer_plugin_version";s:75:"This ILIAS version needs a newer plugin version. Please upgrade the plugin.";s:17:"cmps_needs_update";s:13:"Needs update.";s:18:"cmps_needs_upgrade";s:111:"The plugin version currently installed is older than a previously installed version. Please upgrade the plugin.";s:32:"cmps_no_db_update_file_available";s:30:"No DB update script available.";s:31:"cmps_no_language_file_available";s:27:"No language file available.";s:21:"cmps_plugin_activated";s:30:"The plugin has been activated.";s:23:"cmps_plugin_db_prefixes";s:17:"DB Table Prefixes";s:23:"cmps_plugin_deactivated";s:32:"The plugin has been deactivated.";s:16:"cmps_plugin_dirs";s:18:"Plugin Directories";s:16:"cmps_plugin_file";s:11:"Plugin File";s:25:"cmps_plugin_lang_prefixes";s:24:"Plugin Language Prefixes";s:16:"cmps_plugin_slot";s:11:"Plugin Slot";s:11:"cmps_plugin";s:6:"Plugin";s:12:"cmps_plugins";s:7:"Plugins";s:24:"cmps_refresh_plugins_inf";s:27:"Refresh Plugins Information";s:12:"cmps_refresh";s:17:"Refresh Languages";s:15:"cmps_rep_object";s:22:"Repository Object Type";s:16:"cmps_responsible";s:11:"Responsible";s:17:"cmps_save_options";s:4:"Save";s:12:"cmps_service";s:7:"Service";s:13:"cmps_services";s:8:"Services";s:17:"cmps_show_details";s:12:"Show Details";s:11:"cmps_status";s:6:"Status";s:14:"cmps_update_db";s:9:"Update DB";s:11:"cmps_update";s:6:"Update";s:12:"cmps_version";s:7:"Version";s:20:"database_is_uptodate";s:27:"The database is up to date.";s:10:"no_changes";s:10:"No changes";s:14:"cmps_configure";s:9:"Configure";s:20:"cmps_enable_creation";s:15:"Enable Creation";s:10:"cmps_slots";s:5:"Slots";s:28:"cmps_repository_object_types";s:23:"Repository Object Types";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'acc'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:18:{s:14:"acc_access_key";s:10:"Access Key";s:15:"acc_access_keys";s:11:"Access Keys";s:12:"acc_comp_frm";s:5:"Forum";s:15:"acc_comp_global";s:6:"Global";s:13:"acc_comp_mail";s:4:"Mail";s:13:"acc_component";s:9:"Component";s:10:"acc_delete";s:6:"Delete";s:16:"acc_forward_mail";s:12:"Forward Mail";s:12:"acc_function";s:8:"Function";s:16:"acc_last_visited";s:12:"Last Visited";s:17:"acc_mark_all_read";s:13:"Mark All Read";s:8:"acc_next";s:4:"Next";s:12:"acc_previous";s:8:"Previous";s:9:"acc_reply";s:5:"Reply";s:12:"acc_tree_off";s:8:"Tree Off";s:11:"acc_tree_on";s:7:"Tree On";s:20:"acc_last_rep_visited";s:23:"Repository/Last Visited";s:20:"acc_personal_desktop";s:16:"Personal Desktop";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'frm'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:10:"frm_import";s:12:"Import Forum";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'tstv'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:11:"tstv_create";s:23:"Create Test Certificate";s:16:"tstv_create_info";s:56:"Select a completed test to generate a certificate for it";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'excv'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:11:"excv_create";s:27:"Create Exercise Certificate";s:16:"excv_create_info";s:60:"Select a completed exercise to generate a certificate for it";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'adm'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:23:"adm_update_skill_tables";s:24:"Update Competence Tables";s:23:"adm_update_skill_status";s:24:"Update Competence Status";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'chatroom_adm'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:38:{s:26:"chatroom_available_smilies";s:17:"Available Smileys";s:24:"chatroom_delete_selected";s:23:"Delete Selected Smileys";s:21:"chatroom_smiley_image";s:6:"Smiley";s:19:"chatroom_add_smiley";s:10:"Add Smiley";s:19:"chatroom_image_path";s:14:"Path to Smiley";s:24:"chatroom_smiley_keywords";s:8:"Keywords";s:42:"chatroom_smiley_keywords_one_per_line_note";s:20:"One Keyword per Line";s:22:"chatroom_upload_smiley";s:13:"Upload Smiley";s:8:"protocol";s:8:"Protocol";s:8:"instance";s:8:"Instance";s:6:"smiley";s:7:"Smilies";s:20:"chatroom_edit_smiley";s:11:"Edit Smiley";s:34:"chatroom_current_smiley_image_path";s:14:"Current Smiley";s:29:"chatroom_current_smiley_image";s:19:"Current Smiley Icon";s:37:"chatroom_smiley_image_only_if_changed";s:67:"Choose a new smiley icon only if the current one is to be replaced.";s:15:"server_settings";s:19:"Chatserver Settings";s:15:"client_settings";s:16:"General Settings";s:10:"priv_hosts";s:16:"Privileged Hosts";s:5:"https";s:5:"HTTPS";s:12:"chat_enabled";s:11:"Enable Chat";s:10:"enable_osd";s:30:"Enable On-Screen Notifications";s:4:"hash";s:4:"Hash";s:22:"general_settings_title";s:21:"General Chat Settings";s:13:"osd_intervall";s:25:"Refreshinterval (seconds)";s:25:"chatserver_settings_title";s:19:"Chatserver Settings";s:30:"chatroom_confirm_delete_smiley";s:52:"Are you sure you want to delete the selected smiley?";s:27:"chat_smilies_dir_not_exists";s:33:"Smilies directory does not exist.";s:24:"chat_smilies_initialized";s:24:"Chat smileys initialized";s:8:"keystore";s:8:"Keystore";s:7:"keypass";s:7:"Keypass";s:9:"storepass";s:9:"Storepass";s:23:"settings_has_been_saved";s:23:"Settings has been saved";s:9:"port_info";s:179:"Rarely used ports are often blocked by firewalls or proxy servers. The user\'s browser will not be able to establish a connection to the chat server if the defined port is blocked.";s:29:"chat_cannot_connect_to_server";s:58:"ILIAS cannot build a socket connection to the chat server.";s:20:"public_chat_settings";s:25:"Public Chat Room Settings";s:23:"public_chat_permissions";s:28:"Public Chat Room Permissions";s:21:"play_invitation_sound";s:44:"Play a sound when receiving a new invitation";s:14:"soap_user_hint";s:247:"This user is used to send information from the chat server to the ilias installation. No special permissions are required.<br/>If you create a new account, please make sure that you are able to login with this user (e.g. accept licence agreement).";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'search'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:176:{s:18:"add_members_header";s:11:"Add Members";s:19:"adv_md_search_title";s:27:"Search in Extended Metadata";s:14:"append_results";s:14:"Append results";s:18:"last_search_result";s:18:"Last Search Result";s:21:"lucene_activate_field";s:15:"Activate Search";s:30:"lucene_advanced_settings_table";s:15:"Search Settings";s:24:"lucene_advanced_settings";s:15:"Advanced Search";s:30:"lucene_advances_settings_table";s:24:"Advances Search Settings";s:22:"lucene_all_occurrences";s:26:"... %s other occurrence(s)";s:10:"lucene_and";s:3:"AND";s:10:"lucene_cpu";s:25:"Maximum Number of Threads";s:17:"lucene_create_ini";s:25:"Create Configuration File";s:28:"lucene_default_operator_info";s:196:"Please choose the default operator for boolean queries. In default mode (‘AND’) terms are considered to be in conjunction. In ‘OR’ mode terms without any modifiers are considered optional.";s:23:"lucene_default_operator";s:16:"Default Operator";s:19:"lucene_download_ini";s:27:"Download Configuration File";s:20:"lucene_err_ampersand";s:81:"Queries containing the special characters && must be in the form: term1 && term2.";s:21:"lucene_err_and_or_not";s:82:"Queries containing AND/OR/NOT must be in the form: term1 AND|OR|NOT|AND NOT term2.";s:19:"lucene_err_asterisk";s:79:"The wildcard (*) character must be preceded by at least one alphabet or number.";s:16:"lucene_err_caret";s:92:"The caret (^) character must be preceded by alphanumeric characters and followed by numbers.";s:16:"lucene_err_colon";s:123:"Field declarations (:) must be preceded by at least one alphabet or number and followed by at least one alphabet or number.";s:27:"lucene_err_exclamation_mark";s:80:"Queries containing the special character (!) must be in the form: term1 ! term2.";s:28:"lucene_err_parenthesis_empty";s:48:"Parentheses must contain at least one character.";s:33:"lucene_err_parenthesis_not_closed";s:27:"Parentheses must be closed.";s:21:"lucene_err_plus_minus";s:74:"(+) and (-) modifiers must be followed by at least one alphabet or number.";s:24:"lucene_err_question_mark";s:84:"The question mark (?) character must be preceded by at least one alphabet or number.";s:27:"lucene_err_quotes_not_empty";s:47:"Quotes (") must contain at least one character.";s:17:"lucene_err_quotes";s:33:"Please close all quote (") marks.";s:20:"lucene_err_squigglet";s:92:"The tilde (~) character must be preceded by alphanumeric characters and followed by numbers.";s:23:"lucene_general_settings";s:16:"General Settings";s:16:"lucene_host_info";s:60:"Please enter the hostname or Ip-address for the java server.";s:11:"lucene_host";s:4:"Host";s:22:"lucene_index_path_info";s:54:"Please enter a directory name for storing index files.";s:17:"lucene_index_path";s:25:"Directory for Index Files";s:27:"lucene_last_index_time_info";s:71:"Please modify this settings only if you have installed an index backup.";s:22:"lucene_last_index_time";s:21:"Last Index Generation";s:12:"lucene_level";s:9:"Log-Level";s:15:"lucene_log_info";s:134:"Enter the absolute path to a file in which log messages will we written. If the file does not exist, it will be created automatically.";s:10:"lucene_log";s:15:"Path to Logfile";s:19:"lucene_max_sub_info";s:102:"Please enter maximum number of sub-items (Forum threads, Glossary terms...) that are shown by default.";s:14:"lucene_max_sub";s:19:"Number of Sub-items";s:21:"lucene_more_hits_link";s:15:"%s more hits...";s:20:"lucene_num_frag_info";s:63:"Please choose the maximum number of highlighted text fragments.";s:20:"lucene_num_fragments";s:24:"Number of Text Fragments";s:9:"lucene_or";s:2:"OR";s:11:"lucene_port";s:4:"Port";s:22:"lucene_relevance_short";s:9:"Relevance";s:16:"lucene_relevance";s:27:"Relevance of Search Results";s:19:"lucene_settings_tab";s:6:"Lucene";s:21:"lucene_settings_title";s:15:"Lucene Settings";s:26:"lucene_show_relevance_info";s:132:"Search results are sorted by their relevance. If activated, the relevance is shown as additional information for each search result.";s:21:"lucene_show_relevance";s:14:"Show Relevance";s:21:"lucene_size_frag_info";s:61:"Please choose the maximum size of highlighted text fragments.";s:21:"lucene_size_fragments";s:22:"Size of Text Fragments";s:21:"lucene_tbl_create_ini";s:27:"Create Java-Server Ini-File";s:13:"search_active";s:20:"Include active users";s:23:"search_added_new_folder";s:17:"Added new folder.";s:13:"search_adv_md";s:17:"Extended Metadata";s:15:"search_advanced";s:15:"Advanced Search";s:18:"search_all_results";s:11:"All results";s:16:"search_all_words";s:37:"All words <small>(<i>AND</i>)</small>";s:10:"search_and";s:3:"and";s:15:"search_any_word";s:35:"Any word <small>(<i>OR</i>)</small>";s:10:"search_any";s:9:"-- Any --";s:16:"search_area_info";s:52:"Please select an area where the search should start.";s:11:"search_area";s:4:"Area";s:27:"search_auto_complete_length";s:36:"Number of Auto Complete List Entries";s:12:"search_below";s:8:"Beneath:";s:13:"search_change";s:6:"Change";s:25:"search_choose_object_type";s:30:"Please choose one object type.";s:20:"search_concatenation";s:13:"Concatenation";s:14:"search_content";s:12:"Page Content";s:16:"search_crs_title";s:11:"Course Name";s:18:"search_dbk_content";s:25:"Digital Library (content)";s:15:"search_dbk_meta";s:26:"Digital Library (metadata)";s:18:"search_delete_sure";s:54:"The object and its content will be deleted permanently";s:19:"search_details_info";s:58:"Detailed search. Please select one or more resource types.";s:13:"search_direct";s:13:"Direct search";s:16:"search_fast_info";s:64:"Search for titles, descriptions and keywords in all object types";s:22:"search_for_crs_members";s:25:"Search for Course Members";s:22:"search_for_grp_members";s:24:"Search for Group Members";s:23:"search_for_role_members";s:23:"Search for Role Members";s:16:"search_for_users";s:16:"Search for users";s:16:"search_full_info";s:55:"Choose this option to search in a large amount of data.";s:12:"search_group";s:6:"Groups";s:16:"search_grp_title";s:10:"Group Name";s:22:"search_hide_adv_search";s:20:"Hide Advanced Search";s:11:"search_hits";s:9:"Found in:";s:17:"search_in_magazin";s:17:"In the repository";s:16:"search_in_result";s:21:"Search within results";s:15:"search_inactive";s:22:"Include inactive users";s:12:"search_index";s:14:"Indexed search";s:16:"search_like_info";s:39:"Choose this option to get best results.";s:20:"search_limit_reached";s:107:"Your search produced more than %s hits. You can restrict the search terms to receive more detailed results.";s:17:"search_lm_content";s:28:"Learning materials (content)";s:14:"search_lm_meta";s:29:"Learning materials (metadata)";s:10:"search_lom";s:12:"LOM Metadata";s:18:"search_lucene_host";s:13:"Lucene-Server";s:18:"search_lucene_info";s:83:"If activated, it is possible to search in PDF, HTML files and HTML-Learning modules";s:18:"search_lucene_port";s:11:"Lucene-Port";s:20:"search_lucene_readme";s:17:"Setup information";s:13:"search_lucene";s:13:"Lucene search";s:11:"search_meta";s:8:"Metadata";s:20:"search_minimum_three";s:50:"Your search must be at least three characters long";s:30:"search_move_folder_not_allowed";s:23:"Folder cannot be moved.";s:14:"search_move_to";s:8:"Move to:";s:24:"search_my_search_results";s:17:"My search results";s:17:"search_new_folder";s:10:"New folder";s:18:"search_no_category";s:43:"You have not selected any search categories";s:27:"search_no_connection_lucene";s:32:"Cannot connect to Lucene server.";s:20:"search_no_match_hint";s:228:"Your search for <b>%s</b> did not match any documents.<br /><br />Suggestions:<br />• Make sure all words are spelled correctly.<br />• Try different keywords.<br />• Try more general keywords.<br />• Try fewer keywords.";s:15:"search_no_match";s:37:"Your search did not match any results";s:23:"search_no_results_saved";s:17:"No results saved.";s:21:"search_no_search_term";s:38:"You have not selected any search terms";s:19:"search_no_selection";s:22:"You made no selection.";s:21:"search_object_renamed";s:15:"Object renamed.";s:22:"search_objects_deleted";s:18:"Object(s) deleted.";s:20:"search_objects_moved";s:14:"Objects moved.";s:17:"search_one_action";s:18:"Select one action.";s:9:"search_or";s:2:"or";s:16:"search_page_next";s:4:"Next";s:16:"search_page_prev";s:8:"Previous";s:11:"search_page";s:8:"Results:";s:19:"search_rename_title";s:12:"Rename title";s:20:"search_results_saved";s:20:"Search results saved";s:14:"search_results";s:14:"Search Results";s:17:"search_role_title";s:9:"Role Name";s:21:"search_save_as_select";s:8:"Save as:";s:17:"search_search_for";s:10:"Search for";s:30:"search_search_no_results_saved";s:33:"There are no search results saved";s:21:"search_search_results";s:14:"Search Results";s:18:"search_search_term";s:11:"Search Term";s:32:"search_select_exactly_one_object";s:35:"You must select exactly one object.";s:20:"search_select_folder";s:78:"Please select exactly one folder. It is not possible to rename search results.";s:24:"search_select_one_action";s:21:"--Select one action--";s:31:"search_select_one_folder_select";s:21:"--Select one folder--";s:24:"search_select_one_result";s:33:"Select at least one search result";s:24:"search_select_one_select";s:21:"--Select one folder--";s:17:"search_select_one";s:17:"Select one folder";s:25:"search_select_search_area";s:18:"Select Search Area";s:18:"search_show_result";s:4:"Show";s:23:"search_term_combination";s:11:"Combination";s:24:"search_title_description";s:19:"Title / Description";s:14:"search_tst_svy";s:13:"Tests/Surveys";s:11:"search_type";s:4:"Type";s:20:"search_user_extended";s:20:"Extended User Search";s:18:"search_user_simple";s:18:"Simple User Search";s:11:"search_user";s:5:"Users";s:12:"search_users";s:12:"Search Users";s:5:"until";s:5:"up to";s:18:"search_item_filter";s:14:"Search by Type";s:23:"search_item_filter_form";s:14:"Search by Type";s:28:"search_item_filter_form_info";s:50:"Search can be restricted to the chosen file types.";s:13:"lucene_max_fs";s:25:"Maximum File Size (in MB)";s:18:"lucene_max_fs_info";s:76:"Defines the file size limit. Bigger files will not be included in the index.";s:25:"search_err_user_not_exist";s:43:"A user with that login name does not exist.";s:29:"lucene_offline_filter_setting";s:14:"Offline Filter";s:34:"lucene_offline_filter_setting_info";s:93:"If enabled, objects can filtered in the ‘Advanced Search’ by their online/offline status.";s:21:"lucene_offline_filter";s:13:"Online-Status";s:20:"search_option_online";s:6:"Online";s:21:"search_option_offline";s:7:"Offline";s:21:"search_filter_by_type";s:14:"Filter by Type";s:10:"search_off";s:3:"Off";s:37:"search_add_members_from_container_grp";s:26:"Add Users of Current Group";s:37:"search_add_members_from_container_crs";s:27:"Add Users of Current Course";s:15:"search_mime_pdf";s:9:"PDF Files";s:16:"search_mime_word";s:10:"Word Files";s:17:"search_mime_excel";s:11:"Excel Files";s:22:"search_mime_powerpoint";s:16:"Powerpoint Files";s:17:"search_mime_image";s:6:"Images";s:25:"lucene_show_sub_relevance";s:23:"Show Sub-Item Relevance";s:23:"search_mime_filter_form";s:16:"Mime Type Filter";s:22:"lucene_prefix_wildcard";s:23:"Prefix Wildcard Queries";s:27:"lucene_prefix_wildcard_info";s:63:"Supports prefix wildcard queries: ‘*LIAS’ finds ‘ILIAS’";s:23:"search_user_search_form";s:27:"Search in Personal Profiles";s:28:"search_user_search_info_form";s:82:"Data in personal profiles of users is indexed and can be used to search for users.";s:19:"search_minimum_info";s:47:"Your search must be at least %s characters long";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'pdesk'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:10:{s:23:"bm_num_bookmark_folders";s:9:"Folder(s)";s:16:"bm_num_bookmarks";s:11:"Bookmark(s)";s:22:"pdesk_feedback_request";s:16:"Feedback Request";s:15:"pdesk_feedbacks";s:19:"Feedback Request(s)";s:11:"pdesk_intro";s:33:"Welcome to your Personal Desktop!";s:12:"pdesk_intro2";s:160:"This is your personal space for organising your working and learning. You can put resources from other areas on your personal desktop. Doing so takes two steps:";s:12:"pdesk_intro3";s:69:"Click on \'%s\' and browse the existing working and learning resources.";s:12:"pdesk_intro4";s:134:"If you have found something of interest, put it on your desktop by clicking <i>Add to Desktop</i> in the object\'s <i>Actions</i> menu.";s:22:"bookmark_select_target";s:21:"Please select target.";s:17:"bookmark_moved_ok";s:24:"Bookmark has been moved.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'wfld'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:3:{s:8:"wfld_new";s:17:"Create New Folder";s:8:"wfld_add";s:13:"Create Folder";s:9:"wfld_edit";s:11:"Edit Folder";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'cptch'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:6:{s:17:"cptch_wrong_input";s:11:"Wrong Input";s:29:"cptch_freetype_support_needed";s:68:"To use this feature you need to enable freetype support in your PHP.";s:17:"captcha_code_info";s:55:"Please type in the letters and characters of the image.";s:19:"captcha_code_reload";s:14:"Load new image";s:19:"captcha_audio_title";s:71:"Audio Captcha. Click to hear the letters and characters of the captcha.";s:15:"captcha_alt_txt";s:66:"This is a visual captcha. Click the tab to get to an audio captcha";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'objref'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:5:{s:15:"objref_edit_ref";s:15:"Target Settings";s:17:"objref_edit_title";s:14:"Title Settings";s:21:"objref_title_settings";s:20:"Edit Reference Title";s:18:"objref_reuse_title";s:24:"Reuse Title of Reference";s:19:"objref_custom_title";s:16:"Use Custom Title";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'itgr'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:5:{s:9:"itgr_edit";s:16:"Edit Item Groups";s:14:"itgr_materials";s:9:"Materials";s:9:"itgr_item";s:4:"Item";s:23:"itgr_assigned_materials";s:18:"Assigned Materials";s:15:"itgr_assignment";s:10:"Assignment";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rcat'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:9:"rcat_call";s:17:"Call ECS Category";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rwik'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:9:"rwik_call";s:13:"Call ECS Wiki";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rlm'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:8:"rlm_call";s:24:"Call ECS Learning Module";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rglo'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:9:"rglo_call";s:17:"Call ECS Glossary";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rfil'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:9:"rfil_call";s:13:"Call ECS File";s:19:"rfil_version_tstamp";s:11:"Upload Date";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rgrp'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:9:"rgrp_call";s:14:"Call ECS Group";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rtst'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:9:"rtst_call";s:13:"Call ECS Test";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'fm'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:7:{s:15:"fm_settings_tab";s:12:"File Manager";s:18:"fm_settings_active";s:19:"Enable File Manager";s:23:"fm_settings_active_info";s:119:"Users can open categories, courses, groups and folders using the ‘Open With File Manager’ action in the repository.";s:17:"fm_settings_local";s:21:"Show Local Filesystem";s:22:"fm_settings_local_info";s:186:"If enabled, the file manager starts with two frames, one shows the local filesystem, the other contains the view on the ILIAS repository. If disabled, only the ILIAS repository is shown.";s:20:"fm_settings_filesize";s:24:"Maximum Upload File Size";s:25:"fm_settings_filesize_info";s:67:"Enter the maximum allowed file size for uploaded files in mebibyte.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'mathjax'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:8:{s:27:"mathjax_enable_mathjax_info";s:77:"Activates support for MathJax based mathematical output of LaTeX expressions.";s:22:"mathjax_enable_mathjax";s:14:"Enable MathJax";s:15:"mathjax_mathjax";s:7:"MathJax";s:28:"mathjax_path_to_mathjax_desc";s:119:"E.g. http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML or a URL to your local installation.";s:23:"mathjax_path_to_mathjax";s:14:"URL to MathJax";s:16:"mathjax_settings";s:16:"MathJax Settings";s:15:"mathjax_limiter";s:17:"Inline Delimiters";s:20:"mathjax_limiter_info";s:81:"Select the inline delimiters as they are configured in your MathJax installation.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'fold'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:3:{s:11:"fold_import";s:13:"Import Folder";s:9:"fold_copy";s:11:"Copy Folder";s:13:"fold_settings";s:15:"Folder Settings";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'cld'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:52:{s:7:"cld_add";s:16:"Add Cloud Object";s:23:"cld_add_download_failed";s:15:"Download Failed";s:12:"cld_add_file";s:4:"File";s:14:"cld_add_folder";s:6:"Folder";s:33:"cld_add_items_from_service_failed";s:29:"Add Items from Service Failed";s:16:"cld_add_new_item";s:12:"Add New Item";s:15:"cld_auth_failed";s:21:"Authentication Failed";s:25:"cld_authentication_failed";s:23:":#Authentication Failed";s:31:"cld_config_entry_does_not_exist";s:27:"Config entry does not exist";s:39:"cld_config_no_valid_get_or_set_function";s:45:"No valid get or set function for config value";s:31:"cld_config_table_does_not_exist";s:27:"Config table does not exist";s:28:"cld_config_unknown_exception";s:17:"Unknown Exception";s:23:"cld_confirm_delete_file";s:55:"Are you sure, that the following file is to be deleted:";s:25:"cld_confirm_delete_folder";s:57:"Are you sure, that the following folder is to be deleted:";s:17:"cld_create_folder";s:13:"Create Folder";s:17:"cld_delete_failed";s:13:"Delete Failed";s:16:"cld_file_deleted";s:14:"Object deleted";s:17:"cld_edit_Settings";s:14:"Cloud Settings";s:9:"cld_empty";s:5:"Empty";s:32:"cld_file_not_existing_on_service";s:29:"File not existing on service:";s:38:"cld_folder_already_existing_on_service";s:35:"Folder already existing on service:";s:18:"cld_folder_created";s:14:"Folder created";s:26:"cld_folder_creation_failed";s:22:"Folder Creation Failed";s:15:"cld_folder_name";s:11:"Folder Name";s:34:"cld_folder_not_existing_on_service";s:31:"Folder not existing on service:";s:45:"cld_id_already_exists_in_file_tree_in_session";s:42:"ID already exists in file tree in session:";s:45:"cld_id_does_not_exist_in_file_tree_in_session";s:42:"ID does not exist in file tree in session:";s:38:"cld_info_add_file_to_current_directory";s:29:"Add File to current directory";s:40:"cld_info_add_folder_to_current_directory";s:31:"Add Folder to current directory";s:17:"cld_invalid_input";s:13:"Invalid Input";s:7:"cld_new";s:16:"New Cloud Object";s:21:"cld_no_service_active";s:22:"No cloud-plugin active";s:23:"cld_no_service_selected";s:19:"No service selected";s:29:"cld_not_authenticated_offline";s:27:"Not Authenticated - Offline";s:49:"cld_only_owner_has_permission_to_change_root_path";s:103:"Due to privacy concerns only the creator of a cloud object has the permission to change it\'s root path.";s:47:"cld_path_does_not_exist_in_file_tree_in_session";s:44:"Path does not exist in file tree in Session:";s:21:"cld_permission_denied";s:17:"Permission Denied";s:43:"cld_permission_to_change_root_folder_denied";s:39:"Permission to change root folder denied";s:41:"cld_plugin_hook_could_not_be_instantiated";s:37:"Plugin hook cloud not be instantiated";s:21:"cld_plugin_not_active";s:20:"Plugin is not active";s:15:"cld_root_folder";s:11:"Root Folder";s:11:"cld_service";s:7:"Service";s:32:"cld_service_class_file_not_found";s:28:"Service class file not found";s:22:"cld_service_not_active";s:18:"Service not active";s:29:"cld_service_specific_settings";s:17:"Specific Settings";s:21:"cld_unknown_exception";s:17:"Unknown Exception";s:30:"cld_upload_failed_max_filesize";s:39:"Upload Failed (Max. File Size exceeded)";s:17:"cld_upload_failed";s:13:"Upload Failed";s:16:"cld_upload_files";s:12:"Upload Files";s:25:"service_specific_settings";s:17:"Specific Settings";s:33:"cld_auth_failed_no_object_created";s:56:"Authentication failed, no Cloud Object has been created.";s:16:"cld_object_added";s:33:"A new Cloud object has been added";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'prtt'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:12:{s:8:"prtt_new";s:22:"New Portfolio Template";s:8:"prtt_add";s:25:"Create Portfolio Template";s:9:"prtt_copy";s:23:"Copy Portfolio Template";s:9:"prtt_edit";s:23:"Edit Portfolio Template";s:27:"prtt_activation_online_info";s:73:"Activate this setting to make the portfolio template accessible to users.";s:32:"prtt_availability_limitless_info";s:71:"Choose this mode for making the portfolio template available limitless.";s:28:"prtt_availability_until_info";s:88:"Choose this mode for making the portfolio template available for a fixed period of time.";s:39:"prtt_activation_limited_visibility_info";s:84:"If chosen, the portfolio template is visible even outside of the given availability.";s:11:"prtt_import";s:25:"Import Portfolio Template";s:15:"prtt_properties";s:29:"Portfolio Template Properties";s:10:"prtt_style";s:24:"Portfolio Template Style";s:22:"prtt_portfolio_created";s:24:"Portfolio Template added";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'glo'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:8:"glo_term";s:13:"Glossary Term";s:8:"glo_copy";s:13:"Copy Glossary";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'mob'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:9:{s:11:"mob_general";s:7:"General";s:13:"mob_subtitles";s:9:"Subtitles";s:18:"mob_subtitle_files";s:14:"Subtitle Files";s:17:"mob_subtitle_file";s:13:"Subtitle File";s:12:"mob_language";s:8:"Language";s:8:"mob_file";s:4:"File";s:21:"mob_really_delete_srt";s:53:"Do you really want to delete the following srt files?";s:21:"mob_srt_files_deleted";s:33:"Subtitle files have been deleted.";s:10:"mob_object";s:6:"Object";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'file'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:14:{s:21:"file_new_version_info";s:64:"Create new file version. Previous versions will not be modified.";s:16:"file_new_version";s:18:"Create New Version";s:17:"replace_file_info";s:43:"All previous file versions will be deleted.";s:16:"file_uploaded_by";s:11:"Uploaded by";s:9:"file_copy";s:9:"Copy File";s:13:"file_download";s:13:"Download File";s:36:"enable_personal_workspace_disk_quota";s:42:"Activate Hard Quota for Personal Workspace";s:41:"enable_personal_workspace_disk_quota_info";s:300:"Allows definition of a hard disk quota for each user account and each global role. This quota only affects files in the personal workspace and in portfolios. As soon as a user exceeds the defined quota, ILIAS will prohibit the user to upload more files until the used disk space is again under quota.";s:29:"personal_workspace_disk_quota";s:38:"Hard Disk Quota for Personal Workspace";s:21:"repository_disk_quota";s:30:"Soft Disk Quota for Repository";s:41:"personal_workspace_quota_exceeded_warning";s:61:"You have exceeded the disk quota for your personal workspace.";s:38:"personal_workspace_quota_status_legend";s:65:"You are using %1$s of your available disk quota of %2$s (%3$d%%).";s:26:"repository_disk_quota_info";s:138:"If activated, the disk-quota of the magazine will be checked for each user and emails will be sent to administrators and users optionally.";s:11:"file_import";s:11:"Import File";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'ldap'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:120:{s:16:"ldap_add_missing";s:20:"Assign Missing Roles";s:15:"ldap_add_remove";s:16:"Add/Remove Roles";s:22:"ldap_add_role_ass_rule";s:29:"New Rule for Role Assignments";s:20:"ldap_assignment_type";s:15:"Assignment Type";s:28:"ldap_authentication_settings";s:23:"Authentication Settings";s:19:"ldap_bind_anonymous";s:16:"Bind Anonymously";s:14:"ldap_bind_user";s:13:"Bind as User:";s:21:"ldap_btn_add_role_ass";s:12:"Add New Rule";s:26:"ldap_check_role_assignment";s:38:"Assignment of Roles After Later Logins";s:25:"ldap_confirm_del_role_ass";s:22:"Delete Role Assignment";s:25:"ldap_deleted_role_mapping";s:19:"Deleted assignment.";s:17:"ldap_deleted_rule";s:34:"Deleted selected role assignments.";s:12:"ldap_dn_info";s:47:"Enter the distinguished name of the LDAP group.";s:23:"ldap_edit_role_ass_rule";s:25:"Edit Role Assignment Rule";s:26:"ldap_err_missing_plugin_id";s:31:"Please enter a valid plugin id.";s:16:"ldap_filter_info";s:109:"Filter that will be added to the search filter this way: (&(userattr=username)<strong>(userfilter)</strong>).";s:27:"ldap_global_role_assignment";s:21:"ILIAS-Role Assignment";s:21:"ldap_global_role_info";s:173:"Please choose an ILIAS Role new users will be assigned to. <span class="asterisk">*</span> The role selection is <b>required</b> in case you chose a type of synchronisation.";s:16:"ldap_global_role";s:11:"Global Role";s:25:"ldap_group_attribute_info";s:34:"The group attribute to search for.";s:20:"ldap_group_attribute";s:19:"Attribute for Group";s:18:"ldap_group_dn_info";s:57:"Gets prepended to ‘BaseDN’ when searching for groups.";s:19:"ldap_group_dn_short";s:9:"Group DN:";s:13:"ldap_group_dn";s:8:"Group DN";s:22:"ldap_group_filter_info";s:147:"Filter that will be added to the search filter when searching for a group: (&(groupattr=group)(memberattr=username)<strong>(groupfilter)</strong>).";s:17:"ldap_group_filter";s:11:"LDAP Filter";s:22:"ldap_group_member_info";s:164:"The attribute of the group object where the user dn may be found. Choose ‘Attribute Value is DN’ if the member attribute is the distinguished name of the users.";s:26:"ldap_group_member_optional";s:28:"Group Membership is Optional";s:23:"ldap_group_member_short";s:10:"Attribute:";s:17:"ldap_group_member";s:22:"Group Member Attribute";s:21:"ldap_group_membership";s:16:"Group Membership";s:20:"ldap_group_name_info";s:80:"The name of the group users have to be a member of to authenticate successfully.";s:15:"ldap_group_name";s:10:"Group Name";s:24:"ldap_group_optional_info";s:198:"If enabled, the group membership is not required for a successful authentication. Please enter a user filter for the members of these groups:<br />(&(userattr=username)<strong>(userfilter)</strong>)";s:23:"ldap_group_restrictions";s:29:"Group Membership Restrictions";s:21:"ldap_group_scope_info";s:53:"Scope for group searching. If unsure choose ‘Sub’";s:16:"ldap_group_scope";s:12:"Search Scope";s:22:"ldap_group_search_base";s:17:"Group Search Base";s:22:"ldap_group_user_filter";s:11:"User Filter";s:21:"ldap_ilias_role_short";s:5:"Role:";s:15:"ldap_ilias_role";s:15:"ILIAS Role Name";s:19:"ldap_info_text_info";s:176:"If entered, this text will be shown on the info screen for the object this role is assigned to. Optionally this text is available in the Repository and on the Personal Desktop.";s:20:"ldap_info_text_short";s:10:"Info Text:";s:14:"ldap_info_text";s:16:"Information Text";s:15:"ldap_local_role";s:10:"Local Role";s:22:"ldap_mapping_info_type";s:56:"Show Information also in the Repository/Personal Desktop";s:18:"ldap_mapping_table";s:51:"Assignment of LDAP Attributes to ILIAS User Profile";s:21:"ldap_mapping_template";s:25:"Template for objectClass:";s:16:"ldap_member_info";s:65:"The attribute of the group object where the user dn may be found.";s:15:"ldap_memberisdn";s:21:"Attribute Value is DN";s:22:"ldap_missing_bind_user";s:84:"You have chosen ‘Bind as User’: Please enter a valid LDAP username and password.";s:28:"ldap_missing_role_assignment";s:58:"Please choose a global role new users will be assigned to.";s:16:"ldap_moment_sync";s:23:"Type of Synchronization";s:24:"ldap_new_role_assignment";s:32:"Add New Role -> Group Assignment";s:14:"ldap_plugin_id";s:9:"Plugin Id";s:16:"ldap_plugin_info";s:75:"Validate the role assignment with a plugin. Please enter a valid plugin id.";s:11:"ldap_plugin";s:20:"Assignment by Plugin";s:19:"ldap_referrals_info";s:177:"If set, determines whether the LDAP library automatically follows referrals returned by LDAP servers or not. This should be disabled if you are using an active directory server.";s:14:"ldap_referrals";s:9:"Referrals";s:22:"ldap_remove_deprecated";s:25:"Deassign Deprecated Roles";s:16:"ldap_role_active";s:28:"Enable Group Synchronization";s:21:"ldap_role_assignments";s:15:"Role Assignment";s:17:"ldap_role_at_info";s:73:"The assignment is based on a specific attribute in the LDAP user profile.";s:17:"ldap_role_at_name";s:14:"Attribute Name";s:18:"ldap_role_at_value";s:15:"Attribute Value";s:24:"ldap_role_bind_pass_info";s:8:"Password";s:19:"ldap_role_bind_pass";s:8:"Password";s:24:"ldap_role_bind_user_info";s:107:"Please enter a distinguished name of a LDAP user account. This user needs write access for the LDAP groups.";s:19:"ldap_role_bind_user";s:8:"Users DN";s:22:"ldap_role_by_attribute";s:14:"LDAP Attribute";s:18:"ldap_role_by_group";s:15:"Groupmembership";s:19:"ldap_role_by_plugin";s:9:"By Plugin";s:27:"ldap_role_group_assignments";s:34:"Existing Role -> Group Assignments";s:16:"ldap_role_grp_at";s:9:"Attribute";s:21:"ldap_role_grp_dn_info";s:60:"Please enter the ‘Distinguished Name’ of the LDAP Group.";s:18:"ldap_role_grp_info";s:74:"Members of a specific LDAP Group will be assigned to the given ILIAS role.";s:18:"ldap_role_grp_isdn";s:21:"Attribute value is DN";s:14:"ldap_role_info";s:83:"Enter the name of an ILIAS Role that will control the membership to the LDAP group.";s:17:"ldap_role_mapping";s:32:"ILIAS Role -> LDAP Group Mapping";s:19:"ldap_role_name_info";s:69:"Please choose either a global role or enter the name of a local role.";s:20:"ldap_role_not_exists";s:36:"A role with that name does not exist";s:24:"ldap_role_selection_info";s:70:"Your selection is ambiguous. Please choose one of the following roles.";s:19:"ldap_role_selection";s:14:"Role Selection";s:18:"ldap_role_settings";s:35:"LDAP Group Synchronization Settings";s:19:"ldap_rule_condition";s:9:"Condition";s:14:"ldap_rule_type";s:18:"Type of Assignment";s:15:"ldap_scope_base";s:4:"Base";s:14:"ldap_scope_one";s:3:"One";s:14:"ldap_scope_sub";s:3:"Sub";s:21:"ldap_search_base_info";s:50:"Gets prepended to basedn when searching for users.";s:18:"ldap_search_filter";s:11:"LDAP Filter";s:19:"ldap_server_bind_dn";s:7:"User DN";s:21:"ldap_server_bind_pass";s:8:"Password";s:19:"ldap_server_binding";s:7:"Binding";s:21:"ldap_server_name_info";s:56:"Please choose a name for this LDAP server configuration.";s:16:"ldap_server_name";s:26:"Name of LDAP Configuration";s:29:"ldap_server_security_settings";s:17:"Security Settings";s:17:"ldap_server_short";s:11:"Server URL:";s:20:"ldap_server_url_info";s:163:"A fully qualified URL for specifying the protocol, url and port to connect to. E.g "ldap://ldap.ilias.de:389".  You may add multiple servers with commas separated.";s:24:"ldap_server_version_info";s:31:"LDAP version to use, usually 3.";s:13:"ldap_settings";s:15:"Server Settings";s:14:"ldap_sync_cron";s:12:"Per Cron-Job";s:15:"ldap_sync_login";s:8:"On Login";s:17:"ldap_tbl_role_ass";s:12:"Active Rules";s:17:"ldap_tls_conflict";s:111:"LDAP-TLS can not be used in combination with LDAPv2. Please choose LDAP version ‘3’ or disable TLS support.";s:22:"ldap_update_field_info";s:20:"Update automatically";s:17:"ldap_update_roles";s:16:"Role Assignments";s:19:"ldap_user_attribute";s:24:"Attribute for Login Name";s:12:"ldap_user_dn";s:16:"User Search Base";s:17:"ldap_user_mapping";s:20:"User Profile Mapping";s:20:"ldap_user_scope_info";s:53:"Scope for user searching. If unsure choose ‘Sub’.";s:15:"ldap_user_scope";s:12:"Search Scope";s:19:"ldap_user_sync_info";s:87:"Defines whether new users are automatically created on login or regularly per Cron-Job.";s:14:"ldap_user_sync";s:29:"User Synchronization Settings";s:10:"ldap_as_ds";s:18:"Use as Data Source";s:15:"ldap_as_ds_info";s:162:"If activated, this LDAP configuration is used only for the synchronization of user accounts in combination with other authentication methods (e.g. CAS or Radius).";s:25:"ldap_edit_role_assignment";s:29:"Edit Role -> Group Assignment";s:19:"ldap_user_sync_cron";s:25:"LDAP User Synchronization";s:16:"ldap_choose_role";s:11:"Choose Role";s:24:"ldap_user_sync_cron_info";s:112:"If activated, user accounts will be imported from the LDAP directory and synchronised continuously as an option.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'mcst'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:77:{s:17:"mcst_add_new_item";s:22:"Add New Mediacast Item";s:32:"mcst_audioportable_settings_info";s:37:"Comma separated list of file suffixes";s:33:"mcst_audioportable_settings_title";s:32:"File Extensions for Audio Format";s:24:"mcst_audioportable_title";s:42:"Additional Audio File for Portable Devices";s:24:"mcst_automatic_detection";s:19:"Automatic Detection";s:24:"mcst_clear_purpose_title";s:6:"Delete";s:23:"mcst_current_value_info";s:39:"Shows the current value of this format.";s:23:"mcst_default_visibility";s:14:"Default Access";s:17:"mcst_det_playtime";s:19:"Determine Play Time";s:27:"mcst_download_audioportable";s:23:"Download Audio Portable";s:22:"mcst_download_standard";s:8:"Download";s:27:"mcst_download_videoportable";s:23:"Download Video Portable";s:22:"mcst_downloadable_info";s:78:"If this option is enabled, links for downloading mediacast items are provided.";s:17:"mcst_downloadable";s:14:"Download Links";s:18:"mcst_duration_info";s:77:"If no value is entered, ILIAS tries do determine the play time automatically.";s:13:"mcst_duration";s:9:"Play Time";s:14:"mcst_edit_item";s:19:"Edit Mediacast Item";s:18:"mcst_edit_settings";s:18:"MediaCast Settings";s:10:"mcst_entry";s:17:"Mediacast Entries";s:28:"mcst_file_extension_settings";s:15:"File Extensions";s:20:"mcst_global_settings";s:15:"Global Settings";s:27:"mcst_incl_files_in_rss_info";s:130:"If enabled, media files are includes as attachments in the RSS feed. Otherwise the feed just notifies subscribers about new items.";s:22:"mcst_incl_files_in_rss";s:33:"Include Media Files as Attachment";s:20:"mcst_last_submission";s:15:"Last Submission";s:31:"mcst_media_cast_not_online_text";s:44:"Mediacast is not online or has been disabled";s:26:"mcst_media_cast_not_online";s:23:"Mediacast is not online";s:15:"mcst_media_cast";s:9:"Mediacast";s:18:"mcst_mimetype_info";s:140:"Select mime type to control plugin used for playback.<br>Please note: Be aware that not every browser contains the plugin you intend to use.";s:13:"mcst_mimetype";s:9:"Mime Type";s:19:"mcst_mimetypes_info";s:34:"Comma separated list of mime types";s:14:"mcst_mimetypes";s:10:"Mime Types";s:30:"mcst_news_item_visibility_info";s:128:"Public news can be accessed without authentication outside of ILIAS via RSS. Please do not include any confidential information.";s:13:"mcst_nr_items";s:15:"Number of Items";s:14:"mcst_play_time";s:9:"Play Time";s:19:"mcst_reference_info";s:32:"Provide URL pointing to resource";s:17:"mcst_set_playtime";s:22:"Playtime has been set.";s:13:"mcst_settings";s:18:"Mediacast Settings";s:27:"mcst_standard_settings_info";s:37:"Comma separated list of file suffixes";s:28:"mcst_standard_settings_title";s:35:"File Extensions for Standard Format";s:19:"mcst_standard_title";s:19:"Standard Media File";s:32:"mcst_unable_to_determin_playtime";s:73:"Unable to determine playtime. Please set it manually be clicking on Edit.";s:32:"mcst_videoportable_settings_info";s:37:"Comma separated list of file suffixes";s:33:"mcst_videoportable_settings_title";s:32:"File Extensions for Video Format";s:24:"mcst_videoportable_title";s:42:"Additional Video File for Portable Devices";s:20:"mcst_visibility_info";s:64:"Public items can be accessed via RSS without any authentication.";s:22:"mcst_visibility_public";s:6:"Public";s:21:"mcst_visibility_users";s:15:"Logged in Users";s:11:"mcst_import";s:16:"Import Mediacast";s:13:"mcst_ordering";s:7:"Sorting";s:31:"mcst_ordering_creation_date_asc";s:36:"By Creation Date, Oldest Item on Top";s:32:"mcst_ordering_creation_date_desc";s:35:"By Creation Date Newest Item on Top";s:19:"mcst_ordering_title";s:28:"Titles in Alphabetical Order";s:20:"mcst_ordering_manual";s:6:"Manual";s:15:"mcst_save_order";s:10:"Save Order";s:20:"mcst_preview_picture";s:15:"Preview Picture";s:25:"mcst_preview_picture_info";s:49:"Only supported by the following main media types:";s:21:"mcst_conv_standard_to";s:24:"Convert Standard File to";s:29:"mcst_conv_videoalternative_to";s:33:"Convert Alternative Video File to";s:11:"mcst_target";s:6:"Target";s:27:"mcst_videoalternative_title";s:39:"Alternative Video File (Use in Browser)";s:12:"mcst_convert";s:7:"Convert";s:21:"mcst_purpose_standard";s:13:"Standard File";s:29:"mcst_purpose_videoalternative";s:22:"Alternative Video File";s:19:"mcst_converted_file";s:24:"File has been converted.";s:13:"mcst_viewmode";s:17:"Presentation Mode";s:9:"mcst_list";s:4:"List";s:12:"mcst_gallery";s:5:"Tiles";s:11:"mcst_manage";s:6:"Manage";s:9:"mcst_play";s:4:"Play";s:26:"mcst_extract_preview_image";s:21:"Extract Preview Image";s:20:"mcst_image_extracted";s:25:"Image has been extracted.";s:27:"mcst_no_extraction_possible";s:57:"Sorry, it was not able to extract an image from the file.";s:11:"mcst_second";s:6:"Second";s:30:"mcst_download_videoalternative";s:25:"Download Alternative File";s:17:"mcst_download_cnt";s:10:"Downloaded";s:13:"mcst_play_cnt";s:6:"Played";s:12:"mcst_webfeed";s:12:"RSS Web Feed";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'news'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:95:{s:19:"news_1_file_created";s:24:"One file has been added.";s:19:"news_1_file_updated";s:26:"One file has been updated.";s:15:"news_1_postings";s:27:"One posting has been added.";s:14:"news_all_items";s:38:"News for all items on Personal Desktop";s:30:"news_allow_longer_periods_info";s:57:"Users may select longer news periods on personal desktop.";s:25:"news_allow_longer_periods";s:20:"Allow Longer Periods";s:31:"news_allow_shorter_periods_info";s:58:"Users may select shorter news periods on personal desktop.";s:26:"news_allow_shorter_periods";s:21:"Allow Shorter Periods";s:22:"news_block_information";s:125:"The <b>News</b> block lists all news that are related to the <b>Personal Items</b> you have selected on the personal desktop.";s:27:"news_block_news_for_context";s:4:"News";s:15:"news_cache_info";s:137:"Update news blocks all x minutes. ‘0’ means every time. Higher values improve performance, but news may link to non-accessible items.";s:10:"news_cache";s:20:"News Cache (Minutes)";s:23:"news_default_visibility";s:14:"Default Access";s:23:"news_edit_news_settings";s:13:"Edit Settings";s:30:"news_enable_internal_news_info";s:148:"Activates news blocks for categories, courses, groups and other objects. Users can subscribe to news and news are presented on the personal desktop.";s:25:"news_enable_internal_news";s:20:"Enable Internal News";s:29:"news_enable_internal_rss_info";s:114:"Allows publishing news items via RSS. These items will be accessible outside of the system without authentication.";s:24:"news_enable_internal_rss";s:28:"Enable RSS for Internal News";s:29:"news_enable_private_feed_info";s:146:"If this option is enabled, public and private news can be obtained by personal RSS feeds outside of ILIAS. Authentication is provided by password.";s:24:"news_enable_private_feed";s:23:"Enable private RSS Feed";s:17:"news_feed_url_for";s:17:"Feed URL for \'%s\'";s:13:"news_feed_url";s:8:"Feed URL";s:38:"news_first_letter_of_word_notification";s:1:"N";s:18:"news_get_feed_info";s:211:"This is a personal news feed URL. The feed includes only news that are declared as public by the author. The feed is not protected by any authentication procedure. Please do not share this URL with other people.";s:19:"news_get_feed_title";s:17:"Personal Feed URL";s:17:"news_get_feed_url";s:12:"Get Feed URL";s:23:"news_get_priv_feed_info";s:311:"This is a personal private news feed URL. The feed includes news that are declared as public and private by the author. This feed is protected by a password, which can be changed under ‘Settings’. Please do not share this URL with other people. Please replace -password- in this URL with your Feed-Password.";s:24:"news_get_priv_feed_title";s:25:"Personal private Feed-URL";s:22:"news_hidden_news_block";s:44:"Block is currently hidden in learner\'s view.";s:25:"news_hide_news_block_info";s:98:"Hide block in learner\'s view. The news block will only be visible for users with write permission.";s:20:"news_hide_news_block";s:15:"Hide News Block";s:19:"news_hide_news_date";s:13:"Starting Date";s:28:"news_hide_news_per_date_info";s:63:"Only news that are newer than a certain date will be displayed.";s:23:"news_hide_news_per_date";s:15:"Show News After";s:15:"news_indefinite";s:10:"Indefinite";s:18:"news_internal_news";s:4:"News";s:17:"news_loading_news";s:15:"Loading News...";s:32:"news_news_item_content_long_info";s:40:"This text will not be published via RSS.";s:27:"news_news_item_content_long";s:9:"Long Text";s:22:"news_news_item_content";s:4:"Text";s:19:"news_news_item_head";s:9:"News Item";s:20:"news_news_item_title";s:8:"Headline";s:30:"news_news_item_visibility_info";s:128:"Public news can be accessed without authentication outside of ILIAS via RSS. Please do not include any confidential information.";s:25:"news_news_item_visibility";s:6:"Access";s:15:"news_news_items";s:12:"News Item(s)";s:21:"news_no_js_click_here";s:38:"If news are not displayed, click here.";s:18:"news_no_news_items";s:18:"No news available.";s:30:"news_notifications_public_info";s:173:"If this option is enabled, notifications can be obtained by personal RSS feeds outside of ILIAS. Please note that this makes notifications accessible without authentication.";s:25:"news_notifications_public";s:20:"Public Notifications";s:18:"news_notifications";s:13:"Notifications";s:21:"news_nr_of_items_info";s:228:"Number of news items that are kept for an object (e.g. a file or a learning module) in the database. Please note, that container objects (e.g. categories, courses) may list more items, because they aggregate news of sub-objects.";s:16:"news_nr_of_items";s:39:"Number of Maximum News Items per Object";s:19:"news_pd_period_info";s:127:"Defines the time period used for news on the personal desktop. Select lower values, if you experience any performance problems.";s:14:"news_pd_period";s:28:"Personal Desktop News Period";s:19:"news_period_1_month";s:10:"Last Month";s:18:"news_period_1_week";s:9:"Last Week";s:18:"news_period_1_year";s:9:"Last Year";s:18:"news_period_x_days";s:12:"Last %s Days";s:20:"news_period_x_months";s:14:"Last %s Months";s:19:"news_period_x_weeks";s:13:"Last %s Weeks";s:21:"news_public_feed_info";s:78:"If this option is enabled, a separate RSS feed is provided for this Mediacast.";s:16:"news_public_feed";s:14:"Extra RSS Feed";s:15:"news_related_to";s:10:"Related To";s:15:"news_rss_period";s:10:"RSS Period";s:13:"news_settings";s:13:"News Settings";s:14:"news_subscribe";s:9:"Subscribe";s:16:"news_time_period";s:11:"Time Period";s:16:"news_unsubscribe";s:11:"Unsubscribe";s:22:"news_visibility_public";s:6:"Public";s:21:"news_visibility_users";s:19:"Authenticated Users";s:20:"news_x_files_created";s:25:"%s Files have been added.";s:20:"news_x_files_updated";s:27:"%s Files have been updated.";s:15:"news_x_postings";s:28:"%s Postings have been added.";s:22:"passwd_equals_ilpasswd";s:59:"Please enter a password different from your ILIAS-password.";s:18:"priv_feed_disabled";s:26:"Private Newsfeed disabled.";s:24:"priv_feed_no_access_body";s:64:"Please contact the system administrator for further information.";s:25:"priv_feed_no_access_title";s:28:"Private Newsfeed is disabled";s:22:"priv_feed_no_auth_body";s:86:"Please make sure you enabled your private Newsfeed and entered the password correctly.";s:23:"priv_feed_no_auth_title";s:21:"Authentication failed";s:18:"priv_feed_settings";s:25:"Private Newsfeed settings";s:16:"news_attached_to";s:11:"Attached to";s:13:"news_add_news";s:8:"Add News";s:21:"news_rss_title_format";s:27:"Title Format of RSS Entries";s:30:"news_rss_title_format_obj_news";s:28:"Object Title - News Headline";s:30:"news_rss_title_format_news_obj";s:28:"News Headline (Object Title)";s:22:"finish_publishing_date";s:18:"Finish Publishing:";s:25:"news_hide_news_until_date";s:15:"Show News Until";s:30:"news_hide_news_until_date_info";s:64:"Only news that has not reached a certain date will be displayed.";s:18:"show_news_end_date";s:11:"Ending Date";s:25:"news_keep_minimal_x_items";s:19:"Keeping Older Items";s:30:"news_keep_minimal_x_items_info";s:86:"Number of older items held available regardless of the system wide defined RSS period.";s:40:"news_news_item_def_visibility_users_info";s:53:"Only authenticated users have access to current news.";s:41:"news_news_item_def_visibility_public_info";s:102:"Current news are accessible in a public RSS webfeed. They should not contain confidential information.";s:31:"news_inactive_private_feed_info";s:77:"Your private news feed is deactivated. Please set a password in the settings.";s:8:"news_rss";s:3:"RSS";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rating'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:28:{s:21:"rating_average_rating";s:14:"Average Rating";s:15:"rating_nr_users";s:10:"%s User(s)";s:18:"rating_your_rating";s:11:"Your Rating";s:14:"rat_one_rating";s:10:"One Rating";s:17:"rat_not_rated_yet";s:13:"Not Rated Yet";s:14:"rat_nr_ratings";s:10:"%s Ratings";s:17:"rating_categories";s:17:"Rating Categories";s:19:"rating_add_category";s:12:"Add Category";s:22:"rating_category_create";s:15:"Create Category";s:19:"rating_category_add";s:3:"Add";s:23:"rating_category_created";s:17:"Category created.";s:20:"rating_category_edit";s:13:"Edit Category";s:22:"rating_category_update";s:4:"Save";s:23:"rating_category_updated";s:15:"Category saved.";s:23:"rating_update_positions";s:10:"Save Order";s:27:"rating_category_delete_sure";s:109:"Are you sure you want to delete the following rating categories?  All ratings for that category will be lost.";s:23:"rating_category_deleted";s:17:"Category deleted.";s:28:"rating_overlay_title_overall";s:14:"Overall Rating";s:21:"rating_overlay_submit";s:13:"Submit Rating";s:19:"rating_number_votes";s:10:"%s Ratings";s:22:"rating_export_category";s:8:"Category";s:18:"rating_export_date";s:4:"Date";s:20:"rating_export_rating";s:6:"Rating";s:23:"rating_new_objects_auto";s:21:"Default Object Rating";s:28:"rating_new_objects_auto_info";s:73:"Rating is activated by default for new files, learning modules and wikis.";s:22:"rating_activate_rating";s:13:"Enable Rating";s:27:"rating_activate_rating_info";s:39:"if enabled, users can rate this object.";s:13:"rating_remove";s:13:"Remove Rating";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rep'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:45:{s:9:"rep_intro";s:26:"Welcome to the Repository!";s:10:"rep_intro1";s:246:"In this area you can create learning and working resources for all users. All resources are organised in categories. Categories can reflect the structure of your organisation (e.g. departments), a hierarchy of disciplines, or classes of a school.";s:10:"rep_intro2";s:53:"Three steps are needed to build an initial structure:";s:10:"rep_intro3";s:74:"Click on the <i>%s</i> button besides the selection list on the top right.";s:10:"rep_intro4";s:79:"In the following form, enter a title and a description, and click on <i>%s</i>.";s:10:"rep_intro5";s:65:"By clicking on the title of the category you enter your category.";s:10:"rep_intro6";s:83:"After that procedure you may add any learning or working resource to your category.";s:16:"rep_dependencies";s:12:"Dependencies";s:20:"rep_object_to_delete";s:9:"To Delete";s:20:"rep_dependent_object";s:24:"Resource with dependence";s:14:"rep_dependency";s:10:"Dependency";s:27:"rep_no_permission_to_delete";s:23:"No permission to delete";s:36:"rep_object_references_cannot_be_read";s:38:"No permissions for %s more references.";s:37:"rep_multiple_reference_deletion_intro";s:41:"Further references exist for this object.";s:43:"rep_multiple_reference_deletion_instruction";s:52:"Please select the ones which should also be deleted:";s:27:"rep_activation_availability";s:12:"Availability";s:21:"rep_activation_online";s:6:"Online";s:21:"rep_activation_access";s:6:"Access";s:28:"rep_activation_limited_start";s:10:"Start Time";s:26:"rep_activation_limited_end";s:11:"Finish Time";s:33:"rep_activation_limited_visibility";s:14:"Always Visible";s:24:"rep_visibility_limitless";s:9:"Unlimited";s:20:"rep_visibility_until";s:27:"Limited Availability Period";s:33:"rep_activation_online_object_info";s:54:"This setting affects all references in the repository.";s:30:"rep_activation_access_ref_info";s:72:"This setting only affects this and no other reference in the repository.";s:16:"rep_object_lists";s:12:"Object Lists";s:16:"rep_custom_icons";s:12:"Custom Icons";s:29:"rep_new_item_group_unassigned";s:12:"Not Assigned";s:19:"rep_new_item_groups";s:8:"Grouping";s:22:"rep_new_item_group_add";s:12:"Add Grouping";s:30:"rep_new_item_group_nr_subitems";s:26:"Number of Assigned Objects";s:38:"rep_new_item_group_unassigned_subitems";s:32:"Number of Unassigned Objects: %s";s:23:"rep_new_item_group_edit";s:13:"Edit Grouping";s:30:"rep_new_item_group_delete_sure";s:56:"Are you sure you want to delete the following groupings?";s:32:"rep_new_item_group_add_separator";s:20:"Add Column Separator";s:28:"rep_new_item_group_separator";s:16:"Column Separator";s:24:"rep_new_item_group_other";s:5:"Other";s:32:"rep_add_new_def_grp_organisation";s:12:"Organisation";s:27:"rep_add_new_def_grp_content";s:7:"Content";s:33:"rep_add_new_def_grp_communication";s:13:"Communication";s:30:"rep_add_new_def_grp_assessment";s:10:"Assessment";s:28:"rep_add_new_def_grp_feedback";s:23:"Feedback and Evaluation";s:29:"rep_add_new_def_grp_templates";s:9:"Templates";s:17:"rep_new_item_menu";s:23:"‘Add New Item’-Menu";s:15:"rep_time_period";s:6:"Period";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'webr'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:20:{s:11:"webr_active";s:6:"Active";s:19:"webr_container_info";s:110:"Please enter a title and optionally a description for the presentation of this Weblink List in the repository.";s:15:"webr_deactivate";s:18:"Deactivate Weblink";s:15:"webr_edit_links";s:13:"Edit Weblinks";s:14:"webr_edit_list";s:13:"Edit Weblinks";s:18:"webr_edit_settings";s:13:"Edit Settings";s:21:"webr_inactive_success";s:31:"The chosen link is deactivated.";s:15:"webr_link_added";s:28:"A new link has been created.";s:16:"webr_link_target";s:14:"Weblink Target";s:15:"webr_link_title";s:12:"Weblink Name";s:14:"webr_list_desc";s:27:"Description of Weblink List";s:15:"webr_list_title";s:21:"Title of Weblink List";s:13:"webr_new_link";s:15:"Add New Weblink";s:16:"webr_sort_manual";s:13:"Sort Manually";s:15:"webr_sort_title";s:28:"Titles in Alphabetical Order";s:12:"webr_sorting";s:15:"Weblink Sorting";s:10:"webr_imort";s:14:"Import Weblink";s:11:"webr_import";s:14:"Import Weblink";s:9:"webr_copy";s:12:"Copy Weblink";s:17:"invalid_links_tbl";s:13:"Invalid Links";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'skmg'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:145:{s:13:"skmg_settings";s:30:"Competence Management Settings";s:16:"skmg_enable_skmg";s:30:"Activate Competence Management";s:11:"skmg_skills";s:11:"Competences";s:21:"skmg_skill_hierarchie";s:20:"Competence Hierarchy";s:23:"skmg_insert_basic_skill";s:23:"Insert Basic Competence";s:26:"skmg_insert_skill_category";s:26:"Insert Competence Category";s:29:"skmg_insert_basic_skill_child";s:35:"Insert Basic Competence as Sub-item";s:32:"skmg_insert_skill_category_child";s:38:"Insert Competence Category as Sub-item";s:14:"skmg_new_skill";s:14:"New Competence";s:23:"skmg_new_skill_category";s:23:"New Competence Category";s:20:"skmg_save_all_titles";s:15:"Save All Titles";s:49:"skmg_choose_only_skill_categories_or_basic_skills";s:74:"Please choose either only basic competences or only competence categories.";s:33:"skmg_insert_basic_skill_from_clip";s:39:"Insert Basic Competences from Clipboard";s:36:"skmg_insert_skill_category_from_clip";s:43:"Insert Competence Categories from Clipboard";s:39:"skmg_insert_basic_skill_from_clip_child";s:52:"Insert Basic Competences from Clipboard as Sub-items";s:42:"skmg_insert_skill_category_from_clip_child";s:56:"Insert Competence Categories from Clipboard as Sub-items";s:36:"skmg_selected_items_have_been_copied";s:32:"Selected items have been copied.";s:33:"skmg_selected_items_have_been_cut";s:29:"Selected items have been cut.";s:25:"skmg_insert_on_same_level";s:20:"Insert on Same Level";s:22:"skmg_insert_as_subitem";s:18:"Insert as Sub-item";s:4:"skll";s:16:"Basic Competence";s:4:"scat";s:19:"Competence Category";s:14:"skmg_add_level";s:9:"Add Level";s:16:"skmg_skill_level";s:16:"Competence Level";s:7:"skmg_nr";s:2:"Nr";s:12:"skmg_trigger";s:7:"Trigger";s:14:"skmg_new_level";s:9:"New Level";s:15:"skmg_edit_level";s:10:"Edit Level";s:17:"skmg_update_order";s:12:"Update Order";s:25:"skmg_really_delete_levels";s:61:"Do you really want to delete the following competence levels?";s:10:"skmg_skill";s:10:"Competence";s:17:"skmg_skill_levels";s:17:"Competence Levels";s:16:"skmg_certificate";s:11:"Certificate";s:24:"skmg_skill_level_trigger";s:24:"Competence Level Trigger";s:15:"skmg_no_trigger";s:10:"No Trigger";s:19:"skmg_remove_trigger";s:14:"Remove Trigger";s:19:"skmg_select_trigger";s:14:"Select Trigger";s:33:"skmg_skill_management_deactivated";s:47:"Competence Management is currently deactivated.";s:21:"skmg_cert_skill_title";s:16:"Competence Title";s:27:"skmg_cert_skill_level_title";s:22:"Competence Level Title";s:29:"skmg_cert_skill_trigger_title";s:24:"Competence Trigger Title";s:26:"skmg_cert_achievement_date";s:16:"Achievement Date";s:30:"skmg_cert_achievement_datetime";s:25:"Achievement Date and Time";s:14:"skmg_edit_scat";s:24:"Edit Competence Category";s:29:"skmg_please_select_self_skill";s:40:"Start a new Self Evaluation. Competence:";s:28:"skmg_execute_self_evaluation";s:5:"Start";s:25:"skmg_your_self_evaluation";s:20:"Your Self-Evaluation";s:14:"skmg_no_skills";s:14:"No Competences";s:25:"skmg_save_self_evaluation";s:22:"Finish Self-Evaluation";s:21:"skmg_self_evaluations";s:16:"Self-Evaluations";s:27:"skmg_update_self_evaluation";s:22:"Update Self-Evaluation";s:32:"skmg_sure_delete_self_evaluation";s:60:"Do you really want to delete the following self-evaluations?";s:36:"skmg_please_select_your_skill_levels";s:37:"Please select your competence levels.";s:20:"skmg_self_evaluation";s:15:"Self-Evaluation";s:14:"skmg_next_step";s:9:"Next Step";s:18:"skmg_previous_step";s:13:"Previous Step";s:20:"skmg_skill_templates";s:20:"Competence Templates";s:23:"skmg_new_skill_template";s:23:"New Competence Template";s:32:"skmg_insert_basic_skill_template";s:26:"Insert Competence Template";s:35:"skmg_insert_skill_template_category";s:35:"Insert Competence Template Category";s:32:"skmg_new_skill_template_category";s:32:"New Competence Template Category";s:38:"skmg_insert_basic_skill_template_child";s:38:"Insert Competence Template as Sub-item";s:41:"skmg_insert_skill_template_category_child";s:47:"Insert Competence Template Category as Sub-item";s:19:"skmg_skill_template";s:19:"Competence Template";s:28:"skmg_skill_template_category";s:28:"Competence Template Category";s:36:"skmg_insert_skill_template_reference";s:36:"Insert Competence Template Reference";s:42:"skmg_insert_skill_template_reference_child";s:48:"Insert Competence Template Reference as Sub-item";s:46:"skmg_insert_skill_template_reference_from_clip";s:51:"Insert Competence Template Reference from Clipboard";s:13:"skmg_new_sktr";s:33:"New Competence Template Reference";s:14:"skmg_edit_sktr";s:34:"Edit Competence Template Reference";s:16:"skmg_list_skills";s:16:"List Competences";s:21:"skmg_assign_materials";s:16:"Assign Materials";s:14:"skmg_add_skill";s:14:"Add Competence";s:15:"skmg_selectable";s:10:"Selectable";s:20:"skmg_selectable_info";s:61:"Allows user to select this category as a personal competence.";s:14:"skmg_materials";s:9:"Materials";s:18:"skmg_remove_skills";s:18:"Remove Competences";s:25:"skmg_really_remove_skills";s:70:"Do you really want to remove the following competences from your list?";s:26:"skmg_create_skill_template";s:26:"Create Competence Template";s:35:"skmg_create_skill_template_category";s:35:"Create Competence Template Category";s:15:"skmg_save_order";s:10:"Save Order";s:10:"skmg_order";s:5:"Order";s:13:"skmg_order_nr";s:12:"Order Number";s:16:"skmg_create_skll";s:17:"Create Competence";s:36:"skmg_create_skill_template_reference";s:36:"Create Competence Template Reference";s:26:"skmg_create_skill_category";s:26:"Create Competence Category";s:14:"skmg_edit_skll";s:24:"Edit Competence Settings";s:9:"skmg_sktr";s:29:"Competence Template Reference";s:10:"skmg_items";s:5:"Items";s:16:"skmg_create_sctp";s:24:"Create Template Category";s:14:"skmg_edit_sctp";s:33:"Edit Competence Template Category";s:9:"skmg_sctp";s:28:"Competence Template Category";s:36:"skmg_insert_skill_template_from_clip";s:41:"Insert Competence Template from Clipboard";s:39:"skmg_insert_template_category_from_clip";s:39:"Insert Template Category from Clipboard";s:39:"skmg_insert_please_choose_one_type_only";s:37:"Please choose only one type of items.";s:10:"skmg_level";s:5:"Level";s:13:"skmg_material";s:8:"Material";s:17:"skmg_remove_skill";s:17:"Remove Competence";s:32:"skmg_from_lower_to_higher_levels";s:76:"Please order the levels from lower ones on top to higher ones at the bottom.";s:17:"skmg_select_skill";s:61:"Click on a competence to add it to your personal competences.";s:33:"skmg_ass_materials_from_workspace";s:193:"Here you can assign materials, e.g. files, from your personal workspace to competence levels. If you would like to add materials to your personal workspace now, please click the following link.";s:19:"skmg_skill_profiles";s:8:"Profiles";s:16:"skmg_add_profile";s:11:"Add Profile";s:17:"skmg_edit_profile";s:12:"Edit Profile";s:20:"skmg_delete_profiles";s:52:"Do you really want to delete the following profiles?";s:26:"skmg_assigned_skill_levels";s:26:"Assigned Competence Levels";s:17:"skmg_assign_level";s:12:"Assign Level";s:12:"skmg_profile";s:7:"Profile";s:18:"skmg_remove_levels";s:13:"Remove Levels";s:30:"skmg_select_skill_level_assign";s:22:"Please select a skill.";s:29:"skmg_confirm_remove_level_ass";s:78:"So you really want to remove the following competence levels from the profile?";s:19:"skmg_assigned_users";s:14:"Assigned Users";s:16:"skmg_assign_user";s:11:"Assign User";s:25:"skmg_confirm_user_removal";s:67:"Do you really want to remove the following users from this profile?";s:14:"skmg_resources";s:9:"Resources";s:17:"skmg_add_resource";s:12:"Add Resource";s:36:"skmg_confirm_level_resources_removal";s:79:"Do you really want to remove the following resources from the competence level?";s:17:"skmg_target_level";s:20:"Profile Target Level";s:15:"skmg_360_survey";s:12:"360° Survey";s:25:"skmg_skill_needs_impr_res";s:127:"You need to improve this competence. The following resources provide learning material aligned to your target competence level.";s:28:"skmg_skill_needs_impr_no_res";s:171:"You need to improve this competence. Unfortunately there are currently no learning resources available providing learning material aligned to your target competence level.";s:24:"skmg_skill_no_needs_impr";s:61:"Your competence level is sufficient for the selected profile.";s:10:"skmg_usage";s:5:"Usage";s:9:"skmg_type";s:4:"Type";s:11:"skmg_number";s:6:"Number";s:24:"skmg_usage_type_info_gen";s:33:"General Use in Repository Objects";s:24:"skmg_usage_type_info_mat";s:53:"Users assigned material from their personal workspace";s:25:"skmg_usage_type_info_user";s:17:"Assigned to Users";s:25:"skmg_usage_type_info_pers";s:35:"Selected by Users as Personal Skill";s:26:"skmg_usage_type_info_seval";s:16:"Self Evaluations";s:25:"skmg_usage_type_info_prof";s:22:"Used in Skill Profiles";s:24:"skmg_usage_type_info_res";s:49:"Repository Objects Assigned as Suggested Resource";s:22:"skmg_usage_obj_objects";s:9:"Object(s)";s:20:"skmg_usage_obj_users";s:7:"User(s)";s:23:"skmg_usage_obj_profiles";s:10:"Profile(s)";s:31:"skmg_cannot_delete_nodes_in_use";s:60:"Some items cannot be deleted, because they are still in use.";s:17:"skmg_status_draft";s:15:"Draft (Offline)";s:22:"skmg_status_draft_info";s:20:"Item will be hidden.";s:19:"skmg_status_publish";s:9:"Published";s:24:"skmg_status_publish_info";s:144:"Item can be used if all parents are published, too. Once items are used, the status cannot be set to draft anymore, neither can they be deleted.";s:20:"skmg_status_outdated";s:8:"Outdated";s:25:"skmg_status_outdated_info";s:175:"Item cannot be newly selected by users as personal skill, or newly assigned to repository objects or skill profiles. However existing assignments and data are still presented.";s:11:"skmg_status";s:6:"Status";s:24:"skmg_no_nodes_selectable";s:46:"Currently there are no competences selectable.";s:24:"skmg_suggested_resources";s:19:"Suggested Resources";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'didactic'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:22:{s:16:"didactic_adm_tab";s:18:"Didactic Templates";s:19:"didactic_import_btn";s:24:"Import Didactic Template";s:23:"didactic_applicable_for";s:14:"Applicable for";s:28:"didactic_available_templates";s:28:"Available Didactic Templates";s:25:"didactic_copy_suc_message";s:24:"Copied didactic template";s:27:"didactic_confirm_delete_msg";s:62:"Do you really want to delete the following didactic templates?";s:19:"didactic_delete_msg";s:27:"Deleted didactic templates.";s:22:"didactic_activated_msg";s:28:"Activated didactic templates";s:24:"didactic_deactivated_msg";s:30:"Deactivated didactic templates";s:18:"didactic_do_export";s:6:"Export";s:27:"didactic_import_table_title";s:29:"Import of a didactic template";s:25:"didactic_back_to_overview";s:16:"Back to Overview";s:23:"didactic_import_success";s:39:"Successfully imported didactic template";s:22:"didactic_import_failed";s:52:"Importing the didactic template failed with message:";s:17:"didactic_edit_tpl";s:22:"Edit Didactic Template";s:26:"didactic_default_type_info";s:43:"Default set of permissions will be applied.";s:21:"didactic_install_info";s:19:"General Information";s:20:"didactic_not_changed";s:43:"The didactic template setting is unchanged.";s:28:"didactic_selected_tpl_option";s:26:"Applied didactic template:";s:25:"didactic_template_applied";s:26:"Applied didactic template.";s:35:"didactic_confirm_apply_new_template";s:104:"Do you really want to apply the chosen didactic template? All current permission settings will get lost!";s:21:"didactic_default_type";s:7:"Default";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'cat'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:3:{s:10:"cat_import";s:15:"Import Category";s:8:"cat_copy";s:13:"Copy Category";s:21:"cat_more_translations";s:17:"More Translations";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'sop'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:23:{s:29:"sop_check_system_requirements";s:28:"Checking system requirements";s:20:"sop_already_exported";s:153:"This Learning Module has already been exported. Please open it with the computer on which you have installed Firefox with the SCORM Offline Player addon.";s:20:"sop_firefox_required";s:173:"Using a SCORM module offline requires an up-to-date Mozilla Firefox Browser (> v. 20)<br /><a href=\'http://www.mozilla.org/en/firefox/new\' target=\'_new\'>Download Firefox</a>";s:15:"sop_xpi_install";s:226:"Please install the following Firefox addon: %s<br />After having successfully installed the xpi you have to refresh the page using the ‘Reload page’ button. Afterwards the SCORM Learning Module can be used in offline mode.";s:15:"sop_reload_page";s:11:"Reload page";s:15:"sop_text_export";s:44:"Export SCORM Learning Module for offline use";s:10:"sop_export";s:28:"SCORM Learning Module Export";s:15:"sop_desc_export";s:157:"A learning module in offline mode can only be used offline. Once the tracking data has been imported back to ILIAS, the learning module will be online again.";s:22:"sop_text_start_offline";s:37:"Start learning module in offline mode";s:17:"sop_start_offline";s:29:"Start learning module offline";s:18:"sop_text_start_som";s:27:"Start SCORM Offline Manager";s:13:"sop_start_som";s:9:"Start SOM";s:22:"sop_text_push_tracking";s:63:"Import offline tracking data to ILIAS and switch to online mode";s:17:"sop_push_tracking";s:20:"Import tracking data";s:21:"sop_msg_lm_not_exists";s:86:"The learning module does either not exist or is inactive in the SCORM Offline Manager.";s:16:"sop_msg_close_lm";s:73:"The learning module is still open. Please close the SCORM Offline Player.";s:22:"sop_msg_export_failure";s:73:"Transferring content or data to SCORM Offline Manager was not successful.";s:17:"sop_msg_export_ok";s:53:"Transferring content and tracking data was successful";s:22:"sop_msg_export_content";s:91:"Transferring content to SCORM Offline Manager. This might need a moment. Please be patient.";s:23:"sop_msg_export_tracking";s:77:"Transferring tracking data to SCORM Offline Manager. Please wait some seconds";s:21:"sop_msg_push_tracking";s:58:"Transferring tracking data to ILIAS. Please wait a moment.";s:29:"sop_msg_push_tracking_failure";s:45:"Transfer of tracking data was not successful.";s:24:"sop_msg_push_tracking_ok";s:41:"Transfer of tracking data was successful.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'crsv'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:11:"crsv_create";s:25:"Create Course Certificate";s:16:"crsv_create_info";s:58:"Select a completed course to generate a certificate for it";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'scov'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:11:"crsv_create";s:24:"Create SCORM Certificate";s:16:"crsv_create_info";s:67:"Select a completed learning module to generate a certificate for it";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'init'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:4:{s:25:"init_error_redirect_click";s:25:"Please click to continue.";s:24:"init_error_redirect_info";s:34:"Redirect not supported by context.";s:22:"init_error_maintenance";s:83:"The server is not available due to maintenance. We apologise for any inconvenience.";s:30:"init_error_authentication_fail";s:22:"Authentication failed.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'common'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:3099:{s:15:"chat_chatviewer";s:11:"Chat Viewer";s:18:"3rd_party_software";s:18:"3rd party software";s:13:"absolute_path";s:13:"Absolute Path";s:20:"accept_usr_agreement";s:22:"Accept user agreement?";s:14:"access_expired";s:7:"expired";s:19:"access_free_granted";s:44:"Set the selected user(s) to unlimited access";s:11:"access_from";s:13:"Access (from)";s:13:"access_public";s:6:"Public";s:21:"access_restrict_enter";s:56:"Please set the period for the limited access restriction";s:17:"access_restricted";s:42:"Set the selected user(s) to limited access";s:12:"access_scope";s:6:"Access";s:16:"access_unlimited";s:9:"Unlimited";s:12:"access_until";s:14:"Access (until)";s:12:"access_users";s:15:"Logged in Users";s:6:"access";s:6:"Access";s:28:"accesscount_registered_users";s:38:"Read by number of distinct ILIAS users";s:10:"accessFree";s:21:"Remove Limited Access";s:14:"accessRestrict";s:18:"Set Limited Access";s:20:"account_expires_body";s:43:"Your account is limited, it will expire at:";s:23:"account_expires_subject";s:20:"Your account expires";s:14:"action_aborted";s:14:"Action aborted";s:6:"action";s:6:"Action";s:7:"actions";s:7:"Actions";s:27:"activate_assessment_logging";s:36:"Activate Test and Assessment Logging";s:14:"activate_block";s:8:"Activate";s:14:"activate_https";s:45:"HTTPS handling by ILIAS<br />(Payment, Login)";s:17:"activate_tracking";s:10:"Activation";s:8:"activate";s:10:"Set Active";s:10:"activation";s:12:"Edit Timings";s:12:"active_roles";s:12:"Active Roles";s:6:"active";s:6:"Active";s:10:"add_author";s:10:"Add Author";s:12:"add_comments";s:13:"Edit comments";s:13:"add_condition";s:16:"Add Precondition";s:10:"add_member";s:10:"Add Member";s:11:"add_members";s:11:"Add Members";s:26:"add_new_user_defined_field";s:20:"Add New Custom Field";s:33:"add_new_user_defined_select_field";s:18:"Add New Select Box";s:31:"add_new_user_defined_text_field";s:18:"Add New Text Field";s:34:"add_new_user_defined_wysiwyg_field";s:33:"Add New Text Area (WYSIWYG) Field";s:8:"add_note";s:8:"Add Note";s:13:"add_parameter";s:13:"New Parameter";s:15:"add_translation";s:15:"Add translation";s:22:"add_user_defined_field";s:13:"Add New Field";s:8:"add_user";s:14:"Add Local User";s:3:"add";s:3:"Add";s:19:"added_new_condition";s:22:"Created new condition.";s:15:"additional_info";s:22:"Additional Information";s:7:"address";s:7:"Address";s:14:"adm_create_tax";s:15:"Create taxonomy";s:16:"admin_force_noti";s:19:"Notification active";s:11:"admin_panel";s:20:"Administration Panel";s:18:"administrate_users";s:25:"Local User Administration";s:12:"administrate";s:12:"Administrate";s:14:"administration";s:14:"Administration";s:13:"administrator";s:13:"Administrator";s:5:"adopt";s:5:"Adopt";s:32:"advanced_editing_allow_html_tags";s:45:"Allow the selected HTML tags for text editing";s:40:"advanced_editing_allow_javascript_editor";s:25:"Enable a Rich Text Editor";s:36:"advanced_editing_assessment_settings";s:56:"Allowed HTML Tags for the ILIAS Test and Assessment tool";s:34:"advanced_editing_frm_post_settings";s:19:"Forum Post Settings";s:35:"advanced_editing_lm_js_editing_desc";s:92:"Enables HTMLArea and JavaScript support for page editing in learning modules and glossaries.";s:30:"advanced_editing_lm_js_editing";s:35:"Enable HTMLArea for Content Editing";s:28:"advanced_editing_lm_settings";s:37:"Learning Module and Glossary Settings";s:23:"advanced_editing_no_rte";s:28:"Do not use rich text editing";s:38:"advanced_editing_rep_page_editing_desc";s:135:"This feature allows adding text/media to pages of a category, course, group or folder. If deactivated, existing content will be hidden.";s:33:"advanced_editing_rep_page_editing";s:36:"Enable Content Editing in Repository";s:30:"advanced_editing_required_tags";s:40:"The following HTML tags are required: %s";s:25:"advanced_editing_settings";s:16:"Editing Settings";s:32:"advanced_editing_survey_settings";s:43:"Allowed HTML Tags for the ILIAS survey tool";s:24:"advanced_editing_tinymce";s:14:"TinyMCE Editor";s:24:"adve_assessment_settings";s:28:"Test and Assessment Settings";s:22:"adve_frm_post_settings";s:11:"Forum Posts";s:21:"adve_general_settings";s:16:"General Settings";s:16:"adve_lm_settings";s:22:"LM / Glossary Settings";s:17:"adve_rep_settings";s:19:"Repository Settings";s:20:"adve_survey_settings";s:15:"Survey Settings";s:10:"agree_date";s:9:"Agreed on";s:11:"all_authors";s:11:"All authors";s:12:"all_commands";s:12:"All Commands";s:16:"all_global_roles";s:12:"Global roles";s:7:"all_lms";s:20:"All learning modules";s:15:"all_local_roles";s:17:"Local roles (all)";s:11:"all_objects";s:11:"All Objects";s:9:"all_roles";s:9:"All Roles";s:10:"all_topics";s:10:"All Topics";s:8:"all_tsts";s:9:"All tests";s:9:"all_users";s:9:"All Users";s:18:"allow_assign_users";s:47:"Allow user assignment for local administrators.";s:20:"allow_override_alert";s:50:"Rules for .htaccess are not interpreted correctly.";s:14:"allow_register";s:44:"Available in registration form for new users";s:23:"already_delivered_files";s:15:"Submitted Files";s:3:"and";s:3:"and";s:16:"announce_changes";s:16:"Announce Changes";s:8:"announce";s:8:"Announce";s:9:"anonymous";s:9:"Anonymous";s:7:"answers";s:7:"Answers";s:12:"any_language";s:12:"Any language";s:13:"append_search";s:21:"Append search results";s:21:"application_completed";s:23:"Application is complete";s:16:"application_date";s:16:"Application Date";s:12:"applications";s:12:"Applications";s:13:"applied_users";s:13:"Applied users";s:12:"apply_filter";s:12:"Apply Filter";s:5:"apply";s:5:"Apply";s:16:"appointment_list";s:16:"Appointment List";s:11:"appointment";s:11:"Appointment";s:12:"approve_date";s:11:"Approved on";s:17:"approve_recipient";s:20:"Login ID of Approver";s:14:"archive_broken";s:36:"Archive seems to be broken or empty.";s:7:"archive";s:7:"Archive";s:12:"are_you_sure";s:13:"Are you sure?";s:15:"arrow_downright";s:28:"Arrow from top to down right";s:15:"articels_unread";s:15:"Unread articles";s:5:"as_of";s:5:"as of";s:13:"ass_log_admin";s:23:"Log Data Administration";s:23:"ass_log_available_tests";s:15:"Available Tests";s:22:"ass_log_count_datasets";s:11:"Log Entries";s:22:"ass_log_delete_entries";s:18:"Delete Log Entries";s:27:"ass_log_delete_no_selection";s:54:"Please select at least one test to delete the Log Data";s:15:"ass_log_deleted";s:52:"The Log Data for the selected tests has been deleted";s:14:"ass_log_output";s:15:"Log Data Output";s:12:"ass_log_path";s:13:"Test Location";s:19:"assessment_defaults";s:40:"Default settings for Test and Assessment";s:26:"assessment_imap_line_color";s:20:"Image Map Line Color";s:23:"assessment_log_datetime";s:9:"Date/Time";s:22:"assessment_log_deleted";s:71:"The Test and Assessment log data has been deleted in the administration";s:23:"assessment_log_for_test";s:8:"For test";s:26:"assessment_log_log_entries";s:11:"log entries";s:22:"assessment_log_logging";s:7:"Logging";s:38:"assessment_log_manual_scoring_activate";s:27:"Activate Manual Scoring for";s:34:"assessment_log_manual_scoring_desc";s:275:"If the Manual Scoring is activated for a question type, all questions of this question type could be manually scored by a test author. Please be careful with these settings, because late manual scoring of automatically scored question types could cause even judical problems!";s:29:"assessment_log_manual_scoring";s:14:"Manual Scoring";s:22:"assessment_log_no_data";s:21:"No log data available";s:21:"assessment_log_no_log";s:78:"It is no log data available to the selected test and the selected time period!";s:28:"assessment_log_open_calendar";s:71:"Click here to open a calendar for date selection (JavaScript required!)";s:23:"assessment_log_question";s:8:"Question";s:26:"assessment_log_select_test";s:28:"--- Please select a test ---";s:19:"assessment_log_text";s:11:"Log message";s:26:"assessment_log_user_answer";s:24:"User answered a question";s:27:"assessment_log_user_answers";s:17:"Show user actions";s:14:"assessment_log";s:59:"Create a Test and Assessment log for a specific time period";s:38:"assessment_settings_reporting_language";s:18:"Reporting language";s:19:"assessment_settings";s:35:"Global Test and Assessment settings";s:30:"assessment_use_javascript_desc";s:83:"Activates JavaScript output for drag and drop actions by default for the first time";s:25:"assessment_use_javascript";s:28:"JavaScript for Drag and Drop";s:31:"assf_allowed_questiontypes_desc";s:224:"All the checked question types will be available in this ILIAS installation. If you don\'t want to allow the creation of a certain question type in this installation, you must remove the selection in the associated check box.";s:26:"assf_allowed_questiontypes";s:24:"Available Question Types";s:18:"assf_questiontypes";s:17:"Question Settings";s:18:"assign_global_role";s:21:"Assign to Global Role";s:15:"assign_lo_forum";s:15:"Assign LO Forum";s:17:"assign_local_role";s:20:"Assign to Local Role";s:19:"assign_user_to_role";s:19:"Assign User to Role";s:6:"assign";s:6:"Assign";s:16:"assigned_members";s:16:"Assigned Members";s:14:"assigned_roles";s:14:"Assigned Roles";s:14:"assigned_users";s:14:"Assigned Users";s:15:"associated_user";s:15:"associated User";s:16:"associated_users";s:16:"associated Users";s:18:"at_least_one_style";s:41:"At least one style must remain activated.";s:11:"at_location";s:11:"at location";s:10:"attachment";s:10:"Attachment";s:11:"attachments";s:11:"Attachments";s:8:"attempts";s:8:"Attempts";s:6:"attend";s:6:"Attend";s:17:"auth_active_roles";s:43:"Global roles available on registration form";s:16:"auth_allow_local";s:26:"Allow Local Authentication";s:25:"auth_cas_allow_local_desc";s:91:"This allows CAS users to authenticate with their local ILIAS username and a local password.";s:18:"auth_cas_auth_desc";s:66:"CAS requires PHP 4.3.1 or higher with CURL support (7.5 or higher)";s:13:"auth_cas_auth";s:28:"Configure CAS Authentication";s:26:"auth_cas_create_users_desc";s:136:"Creates automatically an ILIAS user account, for users that successfully authenticated against CAS, without having an ILIAS account yet.";s:18:"auth_cas_port_desc";s:75:"E.g. 443 if the full CAS server URI is https://auth.yourserver.com:443/cas/";s:20:"auth_cas_server_desc";s:91:"E.g. auth.yourserver.com if the full CAS server URI is https://auth.yourserver.com:443/cas/";s:23:"auth_cas_settings_saved";s:18:"CAS settings saved";s:17:"auth_cas_uri_desc";s:86:"Local URI, e.g. cas if the full CAS server URI is https://auth.yourserver.com:443/cas/";s:31:"auth_cas_user_default_role_desc";s:57:"This role is assigned to automatically created CAS users.";s:8:"auth_cas";s:3:"CAS";s:14:"auth_configure";s:12:"configure...";s:17:"auth_create_users";s:39:"Create non-existing users automatically";s:28:"auth_default_mode_changed_to";s:38:"Default authentication mode changed to";s:12:"auth_default";s:15:"Default setting";s:8:"auth_ecs";s:3:"ECS";s:14:"auth_ldap_desc";s:34:"Authenticate users via LDAP server";s:16:"auth_ldap_enable";s:19:"Enable LDAP support";s:24:"auth_ldap_migration_info";s:119:"Activate this option to give new users the possibility to migrate their existing ILIAS accounts to LDAP authentication.";s:19:"auth_ldap_migration";s:17:"Account Migration";s:24:"auth_ldap_not_configured";s:26:"LDAP is not configured yet";s:24:"auth_ldap_settings_saved";s:19:"LDAP settings saved";s:9:"auth_ldap";s:4:"LDAP";s:15:"auth_local_desc";s:53:"Authenticate users via local ILIAS database (default)";s:10:"auth_local";s:10:"ILIAS Auth";s:23:"auth_login_instructions";s:32:"Instructions shown on login page";s:21:"auth_mode_not_changed";s:17:"(Nothing changed)";s:23:"auth_mode_roles_changed";s:41:"Changed authentication mode for this Role";s:9:"auth_mode";s:19:"Authentication mode";s:26:"auth_new_account_mail_desc";s:158:"Send new account e-mail to user, if user is generated automatically. A password will only be generated, if ‘Allow Local Authentication’ is also activated.";s:11:"auth_openid";s:6:"OpenId";s:16:"auth_per_default";s:11:"Per Default";s:21:"auth_radius_configure";s:31:"Configure RADIUS-Authentication";s:16:"auth_radius_desc";s:36:"Authenticate users via RADIUS server";s:18:"auth_radius_enable";s:21:"Enable RADIUS support";s:26:"auth_radius_not_configured";s:28:"RADIUS is not configured yet";s:16:"auth_radius_port";s:4:"Port";s:23:"auth_radius_server_desc";s:108:"You may add multiple servers with commas separated. Servers are rotated in Round robin fashion when queried.";s:18:"auth_radius_server";s:7:"Servers";s:26:"auth_radius_settings_saved";s:21:"RADIUS settings saved";s:25:"auth_radius_shared_secret";s:13:"Shared secret";s:11:"auth_radius";s:6:"RADIUS";s:26:"auth_remark_non_local_auth";s:122:"When selecting another authentication mode than ILIAS database, you may not change user\'s login name and password anymore.";s:19:"auth_role_auth_mode";s:19:"Authentication mode";s:16:"auth_script_desc";s:38:"Authenticate users via external script";s:11:"auth_script";s:6:"Custom";s:11:"auth_select";s:26:"Select authentication mode";s:14:"auth_selection";s:13:"Login Options";s:13:"auth_settings";s:23:"Authentication Settings";s:14:"auth_shib_desc";s:78:"Authenticate users via Shibboleth, can be used as second authentication method";s:22:"auth_shib_instructions";s:93:"Be sure to read the README for instructions on how to configure Shibboleth support for ILIAS.";s:24:"auth_shib_not_configured";s:32:"Shibboleth is not configured yet";s:9:"auth_shib";s:10:"Shibboleth";s:15:"auth_shibboleth";s:10:"Shibboleth";s:26:"auth_soap_allow_local_desc";s:92:"This allows SOAP users to authenticate with their local ILIAS username and a local password.";s:19:"auth_soap_auth_desc";s:95:"This settings deal only with SOAP based user authentication, not with the ILIAS SOAP interface.";s:14:"auth_soap_auth";s:29:"Configure SOAP Authentication";s:27:"auth_soap_create_users_desc";s:137:"Creates automatically an ILIAS user account, for users that successfully authenticated against SOAP, without having an ILIAS account yet.";s:24:"auth_soap_namespace_desc";s:66:"As defined in WSDL. Must be specified, if .NET SOAP style is used.";s:19:"auth_soap_namespace";s:9:"Namespace";s:19:"auth_soap_port_desc";s:87:"E.g. 8080 if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php";s:21:"auth_soap_server_desc";s:102:"E.g. auth.yourserver.com if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php";s:24:"auth_soap_settings_saved";s:34:"SOAP authentication settings saved";s:18:"auth_soap_uri_desc";s:108:"Local URI, e.g. dir/server.php if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php";s:20:"auth_soap_use_dotnet";s:19:"Use .NET SOAP Style";s:19:"auth_soap_use_https";s:9:"Use HTTPS";s:32:"auth_soap_user_default_role_desc";s:58:"This role is assigned to automatically created SOAP users.";s:27:"auth_soap_user_default_role";s:49:"Default role assigned to SOAP authenticated users";s:9:"auth_soap";s:4:"SOAP";s:22:"auth_user_default_role";s:12:"Default Role";s:18:"authenticate_ilias";s:27:"ILIAS Native Authentication";s:17:"authenticate_with";s:9:"Login to:";s:23:"authentication_settings";s:14:"Authentication";s:6:"author";s:6:"Author";s:14:"authoring_mode";s:14:"Authoring Mode";s:7:"authors";s:7:"Authors";s:17:"auto_registration";s:34:"Automatically approve registration";s:19:"available_languages";s:19:"Available Languages";s:9:"available";s:9:"Available";s:12:"average_time";s:12:"Average time";s:19:"back_to_crs_content";s:22:"Back to Course Content";s:20:"back_to_fold_content";s:22:"Back to Folder Content";s:19:"back_to_grp_content";s:21:"Back to Group Content";s:20:"back_to_sess_content";s:23:"Back to Session Content";s:4:"back";s:4:"Back";s:6:"basedn";s:6:"BaseDN";s:14:"basic_commands";s:14:"Basic Commands";s:10:"basic_data";s:10:"Basic Data";s:14:"basic_settings";s:14:"Basic Settings";s:6:"before";s:6:"before";s:18:"benchmark_settings";s:18:"Benchmark Settings";s:9:"benchmark";s:9:"Benchmark";s:10:"benchmarks";s:10:"Benchmarks";s:8:"bib_data";s:20:"Bibliographical Data";s:8:"big_icon";s:8:"Big Size";s:8:"birthday";s:8:"Birthday";s:13:"bkm_import_ok";s:59:"Successfully imported %d bookmarks and %d bookmark folders.";s:10:"bkm_import";s:16:"Import Bookmarks";s:12:"bkm_sendmail";s:18:"Send as attachment";s:16:"block_management";s:16:"Block Management";s:5:"block";s:5:"Block";s:15:"bm_add_to_ilias";s:15:"ILIAS Bookmarks";s:26:"bm_add_to_social_bookmarks";s:16:"Add to Bookmarks";s:19:"bm_manage_social_bm";s:23:"Manage Social Bookmarks";s:2:"bm";s:8:"Bookmark";s:3:"bmf";s:15:"Bookmark Folder";s:4:"bold";s:4:"Bold";s:8:"bookings";s:8:"Bookings";s:14:"bookmark_added";s:30:"The Bookmark has been created.";s:13:"bookmark_edit";s:13:"Edit Bookmark";s:20:"bookmark_folder_edit";s:20:"Edit Bookmark Folder";s:19:"bookmark_folder_new";s:19:"New Bookmark Folder";s:12:"bookmark_new";s:12:"New Bookmark";s:16:"bookmark_save_to";s:16:"save as bookmark";s:15:"bookmark_target";s:6:"Target";s:12:"bookmarks_of";s:12:"Bookmarks of";s:9:"bookmarks";s:9:"Bookmarks";s:12:"bottom_frame";s:12:"Main Content";s:21:"breadcrumb_navigation";s:21:"Breadcrumb Navigation";s:7:"btn_add";s:3:"Add";s:8:"btn_back";s:4:"Back";s:13:"btn_new_value";s:9:"New value";s:8:"btn_next";s:8:"Continue";s:12:"btn_previous";s:4:"Back";s:17:"btn_remove_system";s:18:"Remove from System";s:12:"btn_undelete";s:7:"Restore";s:3:"buy";s:3:"Buy";s:11:"by_location";s:17:"Order by location";s:7:"by_type";s:13:"Order by type";s:2:"by";s:2:"By";s:5:"bytes";s:5:"Bytes";s:8:"cal_from";s:5:"From:";s:9:"cal_until";s:6:"Until:";s:8:"calendar";s:8:"Calendar";s:6:"cancel";s:6:"Cancel";s:15:"cannot_find_xml";s:25:"Cannot find any XML-file.";s:32:"cannot_uninstall_language_in_use";s:51:"You cannot uninstall the language currently in use!";s:31:"cannot_uninstall_systemlanguage";s:41:"You cannot uninstall the system language!";s:17:"cannot_unzip_file";s:19:"Cannot unpack file.";s:33:"cant_deactivate_if_users_assigned";s:70:"You cannot deactivate a style if there are still users assigned to it.";s:5:"cat_a";s:10:"a Category";s:7:"cat_add";s:12:"Add Category";s:9:"cat_added";s:14:"Category added";s:14:"cat_clear_page";s:10:"Clear Page";s:21:"cat_copy_threads_info";s:76:"Please decide which category items should be copied, linked or even omitted.";s:8:"cat_edit";s:17:"Category Settings";s:7:"cat_new";s:12:"New Category";s:15:"cat_pages_clear";s:22:"Category page cleared.";s:21:"cat_pages_not_created";s:30:"Category page not created yet.";s:16:"cat_pages_undone";s:38:"Last changes for category page undone.";s:9:"cat_pages";s:14:"Category Pages";s:9:"cat_title";s:14:"Category Title";s:26:"cat_undo_last_page_changes";s:22:"Undo Last Page Changes";s:15:"cat_wizard_page";s:24:"Copy Category (Step 2/2)";s:3:"cat";s:8:"Category";s:19:"categories_imported";s:25:"Category import complete.";s:10:"categories";s:10:"Categories";s:14:"catr_edit_info";s:57:"Please choose one category, for creating a new reference.";s:9:"catr_edit";s:23:"Edit Category Reference";s:8:"catr_new";s:25:"Create Category Reference";s:4:"catr";s:18:"Category Reference";s:2:"cc";s:2:"CC";s:10:"censorship";s:10:"Censorship";s:11:"certificate";s:11:"Certificate";s:20:"chac_edit_permission";s:26:"Change permission settings";s:9:"chac_read";s:28:"Read access to chat settings";s:12:"chac_visible";s:25:"Chat settings are visible";s:10:"chac_write";s:18:"Edit chat settings";s:24:"change_active_assignment";s:24:"Change active assignment";s:17:"change_assignment";s:17:"Change assignment";s:19:"change_header_title";s:17:"Edit Header Title";s:14:"change_lo_info";s:14:"Change LO Info";s:15:"change_metadata";s:15:"Change Metadata";s:12:"change_owner";s:12:"Change owner";s:21:"change_sort_direction";s:21:"Change sort direction";s:6:"change";s:6:"Change";s:10:"changeable";s:39:"Changeable in Personal Data and Profile";s:10:"changed_to";s:10:"changed to";s:36:"changing_loginname_not_possible_info";s:82:"You changed your login name at last at %s. The next change can be performed at %s.";s:14:"chapter_number";s:14:"Chapter Number";s:13:"chapter_title";s:13:"Chapter Title";s:7:"chapter";s:7:"Chapter";s:10:"characters";s:10:"characters";s:30:"chat_enter_public_room_tooltip";s:18:"Enter public chat.";s:22:"chat_enter_public_room";s:11:"Public Chat";s:31:"chat_invite_public_room_tooltip";s:22:"Invite to public chat.";s:23:"chat_invite_public_room";s:11:"Public Chat";s:17:"chat_users_active";s:12:"Active users";s:9:"check_all";s:9:"Check all";s:14:"check_langfile";s:31:"Please check your language file";s:15:"check_languages";s:19:"Check All Languages";s:15:"check_link_desc";s:91:"If enabled all external links in ILIAS learning modules will be checked if they are active.";s:10:"check_link";s:13:"Weblink check";s:29:"check_max_allowed_packet_size";s:35:"The page content size is too large.";s:24:"check_user_accounts_desc";s:195:"If enabled, all users whose account expires will be informed by e-mail. Furthermore all users which have not confirmed their account after a registration with e-mail confirmation will be deleted.";s:19:"check_user_accounts";s:19:"Check user accounts";s:24:"check_web_resources_desc";s:59:"If enabled all Weblinks will be checked if they are active.";s:19:"check_web_resources";s:14:"Check Weblinks";s:5:"check";s:5:"Check";s:13:"checked_files";s:16:"Importable files";s:7:"checked";s:7:"Checked";s:32:"chg_ilias_and_webfolder_password";s:25:"Change Webfolder Password";s:18:"chg_ilias_password";s:21:"Change ILIAS Password";s:12:"chg_language";s:15:"Change Language";s:12:"chg_password";s:15:"Change Password";s:15:"choose_language";s:20:"Choose Your Language";s:15:"choose_location";s:15:"Choose Location";s:24:"choose_only_one_language";s:31:"Please choose only one language";s:13:"chown_warning";s:84:"Attention, you may loose access permissions on this object after changing the owner.";s:4:"city";s:11:"City, State";s:12:"cleaned_file";s:22:"File has been cleaned.";s:15:"cleaning_failed";s:16:"Cleaning failed.";s:15:"clear_clipboard";s:15:"Clear Clipboard";s:5:"clear";s:5:"Clear";s:9:"client_id";s:9:"Client ID";s:9:"client_ip";s:9:"Client IP";s:6:"client";s:6:"Client";s:9:"clipboard";s:9:"Clipboard";s:21:"clone_existing_course";s:20:"Copy Existing Course";s:19:"clone_option_in_cat";s:25:"Copy in Existing Category";s:19:"clone_option_in_crs";s:23:"Copy in Existing Course";s:18:"clone_target_title";s:37:"Selection of Target Folder (Step 1/2)";s:12:"clone_target";s:13:"Target Folder";s:12:"close_window";s:12:"Close window";s:5:"close";s:5:"Close";s:7:"cnt_new";s:8:"(%s New)";s:12:"collapse_all";s:12:"Collapse All";s:8:"collapse";s:8:"Collapse";s:9:"collapsed";s:9:"Collapsed";s:7:"columns";s:7:"Columns";s:15:"comma_separated";s:15:"Comma Separated";s:7:"comment";s:7:"Comment";s:7:"compose";s:7:"Compose";s:17:"cond_ref_handling";s:13:"Link Settings";s:15:"cond_ref_shared";s:34:"Shared Preconditions for all Links";s:15:"cond_ref_unique";s:30:"Unique Preconditions for Links";s:26:"condition_already_assigned";s:24:"Object already assigned.";s:24:"condition_circle_created";s:70:"This association is not possible, since the objects would interdepend.";s:17:"condition_deleted";s:18:"Condition deleted.";s:18:"condition_finished";s:8:"Finished";s:22:"condition_not_finished";s:12:"Not finished";s:16:"condition_passed";s:6:"Passed";s:22:"condition_precondition";s:14:"Preconditions:";s:23:"condition_select_object";s:25:"Please select one object.";s:20:"condition_select_one";s:29:"-Please select one condition-";s:16:"condition_update";s:4:"Save";s:9:"condition";s:9:"Condition";s:18:"conditions_updated";s:16:"Conditions saved";s:24:"confirm_delete_parameter";s:43:"Do you really want to delete the parameter?";s:7:"confirm";s:7:"Confirm";s:12:"confirmation";s:12:"Confirmation";s:17:"conflict_handling";s:17:"Conflict handling";s:11:"cont_object";s:6:"Object";s:12:"contact_data";s:19:"Contact Information";s:7:"contact";s:7:"Contact";s:18:"container_no_items";s:22:"No Materials Available";s:9:"container";s:9:"Container";s:13:"content_frame";s:13:"Content Frame";s:14:"content_styles";s:14:"Content Styles";s:7:"content";s:7:"Content";s:7:"context";s:7:"Context";s:13:"continue_work";s:8:"Continue";s:6:"contra";s:6:"Contra";s:13:"cookies_howto";s:21:"How to enable cookies";s:13:"copied_object";s:13:"Copied object";s:8:"copy_all";s:8:"Copy all";s:16:"copy_n_of_suffix";s:13:"- Copy (%1$s)";s:14:"copy_of_suffix";s:6:"- Copy";s:7:"copy_of";s:7:"Copy of";s:19:"copy_selected_items";s:4:"Copy";s:7:"copy_to";s:2:"to";s:4:"copy";s:4:"Copy";s:11:"copyChapter";s:4:"Copy";s:8:"copyPage";s:4:"Copy";s:24:"could_not_verify_account";s:81:"Sorry, we could not verify your account. Please contact the system administrator.";s:5:"count";s:5:"Count";s:7:"country";s:7:"Country";s:6:"course";s:6:"Course";s:7:"courses";s:7:"Courses";s:12:"create_block";s:12:"Create Block";s:11:"create_date";s:10:"Created on";s:18:"create_export_file";s:18:"Create export file";s:9:"create_in";s:9:"Create in";s:17:"create_stylesheet";s:12:"Create Style";s:6:"create";s:6:"Create";s:7:"created";s:13:"Creation Date";s:28:"cron_forum_notification_cron";s:22:"regularly per cron job";s:28:"cron_forum_notification_desc";s:122:"If enabled, all users, who want to be informed about new posts in specified forum threads, will get notifications by mail.";s:33:"cron_forum_notification_crob_desc";s:158:"If enabled, all users who have enabled forum notifications will get a daily mail about all new posts but no immediate notification for each submitted posting.";s:32:"cron_forum_notification_directly";s:23:"directly on new entries";s:29:"cron_forum_notification_never";s:5:"never";s:23:"cron_forum_notification";s:24:"Send Forum Notifications";s:14:"cron_jobs_desc";s:156:"A cron job is an automated process that operates at predefined time intervals. You will find information about the setup in the ‘INSTALL Documentation’.";s:9:"cron_jobs";s:9:"Cron Jobs";s:22:"cron_lucene_index_info";s:122:"If enabled, the lucene search index will be updated. Please configure the lucene server at ’Administration -> Search’.";s:17:"cron_lucene_index";s:26:"Update Lucene search index";s:27:"cron_mail_notification_cron";s:22:"regularly per cron job";s:27:"cron_mail_notification_desc";s:206:"If enabled, all users, who want to be informed about new mail, will get notifications by external mail. Please deactivate the option ‘Globally prevent sending external mails’ first to use this function.";s:28:"cron_mail_notification_never";s:5:"never";s:22:"cron_mail_notification";s:23:"Send Mail Notifications";s:5:"crs_a";s:8:"a Course";s:28:"crs_activation_start_invalid";s:43:"The start and the finish time is not valid.";s:7:"crs_add";s:10:"Add Course";s:9:"crs_added";s:12:"Course added";s:39:"crs_all_questions_answered_successfully";s:46:"You have successfully answered every question.";s:12:"crs_archives";s:8:"Archives";s:22:"crs_at_least_one_admin";s:50:"There has to be at least one course administrator.";s:13:"crs_available";s:17:"Available Courses";s:23:"crs_cancel_waiting_list";s:75:"Do you really want to remove yourself from the waiting list of course "%s"?";s:30:"crs_container_link_not_allowed";s:44:"It is not possible to link container objects";s:21:"crs_copy_threads_info";s:78:"Please decide which course materials should be copied, linked or even omitted.";s:8:"crs_edit";s:11:"Edit Course";s:8:"crs_info";s:4:"Info";s:21:"crs_management_system";s:24:"Course Management System";s:21:"crs_member_not_passed";s:10:"Not passed";s:17:"crs_member_passed";s:6:"Passed";s:19:"crs_members_gallery";s:22:"Course Members Gallery";s:7:"crs_new";s:10:"New Course";s:14:"crs_no_content";s:15:"Without content";s:29:"crs_removed_from_waiting_list";s:60:"You have been detached from the waiting list of course "%s".";s:18:"crs_status_blocked";s:16:"[Access refused]";s:18:"crs_status_pending";s:26:"[Waiting for registration]";s:24:"crs_subscribers_assigned";s:20:"Assigned new user(s)";s:9:"crs_title";s:12:"Course Title";s:15:"crs_unsubscribe";s:23:"Unsubscribe from Course";s:15:"crs_wizard_page";s:22:"Copy Course (Step 2/2)";s:3:"crs";s:6:"Course";s:14:"crsr_edit_info";s:55:"Please choose one course, for creating a new reference.";s:9:"crsr_edit";s:21:"Edit Course Reference";s:8:"crsr_new";s:23:"Create Course Reference";s:4:"crsr";s:16:"Course Reference";s:10:"csv_export";s:10:"CSV-Export";s:15:"cumulative_time";s:15:"Cumulative time";s:14:"cur_number_rec";s:25:"Current number of records";s:16:"current_ip_alert";s:97:"Notice: if you enter a wrong ip you won\'t be able to access the system with this profile anymore.";s:10:"current_ip";s:11:"Current IP:";s:16:"current_password";s:16:"Current Password";s:20:"custom_icon_size_big";s:8:"Big Size";s:25:"custom_icon_size_standard";s:11:"Medium Size";s:21:"custom_icon_size_tiny";s:10:"Small Size";s:3:"cut";s:3:"Cut";s:7:"cutPage";s:3:"Cut";s:5:"daily";s:5:"daily";s:12:"data_privacy";s:21:"Data Privacy Settings";s:16:"database_version";s:24:"Current Database Version";s:8:"database";s:8:"Database";s:7:"dataset";s:4:"Item";s:4:"date";s:4:"Date";s:10:"dateplaner";s:8:"Calendar";s:3:"day";s:3:"Day";s:14:"days_of_period";s:14:"Days of period";s:4:"days";s:4:"Days";s:7:"db_host";s:13:"Database Host";s:7:"db_name";s:13:"Database Name";s:14:"db_need_update";s:25:"Database needs an update!";s:7:"db_pass";s:17:"Database Password";s:7:"db_type";s:13:"Database Type";s:7:"db_user";s:13:"Database User";s:10:"db_version";s:16:"Database Version";s:10:"deactivate";s:12:"Set Inactive";s:17:"decrease_attempts";s:12:"Attempts - 1";s:19:"def_repository_view";s:23:"Default repository view";s:22:"default_auth_mode_info";s:78:"Please choose the authentication method that is preselected on the login page.";s:17:"default_auth_mode";s:29:"Default Authentication Method";s:16:"default_language";s:16:"Default Language";s:21:"default_perm_settings";s:19:"Default Permissions";s:12:"default_role";s:12:"Default Role";s:13:"default_roles";s:13:"Default Roles";s:18:"default_skin_style";s:20:"Default Skin / Style";s:12:"default_skin";s:12:"Default Skin";s:13:"default_style";s:13:"Default Style";s:13:"default_value";s:13:"Default Value";s:7:"default";s:7:"Default";s:8:"defaults";s:8:"Defaults";s:14:"delete_all_rec";s:18:"Delete all records";s:10:"delete_all";s:10:"Delete All";s:20:"delete_existing_file";s:20:"Delete Existing File";s:13:"delete_object";s:16:"Delete Object(s)";s:16:"delete_parameter";s:16:"Delete Parameter";s:21:"delete_selected_items";s:6:"Delete";s:15:"delete_selected";s:15:"Delete Selected";s:14:"delete_tr_data";s:20:"Delete tracking data";s:6:"delete";s:6:"Delete";s:20:"deleted_user_account";s:20:"Deleted user account";s:12:"deleted_user";s:25:"The user has been deleted";s:13:"deleted_users";s:13:"Deleted users";s:7:"deleted";s:7:"Deleted";s:9:"delicious";s:17:"Delicious Account";s:7:"deliver";s:7:"Deliver";s:10:"department";s:10:"Department";s:4:"desc";s:11:"Description";s:11:"description";s:11:"Description";s:16:"desired_password";s:16:"Desired Password";s:13:"desktop_items";s:22:"Personal Desktop Items";s:7:"details";s:7:"Details";s:19:"disable_admin_force";s:23:"Deactivate notification";s:27:"disable_anonymous_fora_desc";s:197:"If this option is enabled, the feature ‘Remain incognito’ is not available in forums anymore. In case this feature is already activated in certain forums, it is still possible to deactivate it.";s:22:"disable_anonymous_fora";s:40:"Disable ‘Remain incognito’ in forums";s:13:"disable_check";s:13:"Disable check";s:22:"disable_ext_lang_maint";s:28:"Disable Extended Maintenance";s:24:"disable_hide_user_toggle";s:31:"Member is allowed to deactivate";s:7:"disable";s:7:"disable";s:8:"disabled";s:8:"Disabled";s:20:"disk_quota_is_1_by_2";s:66:"The effective disk quota is %1$s due to membership in role "%2$s".";s:33:"disk_quota_is_1_instead_of_2_by_3";s:136:"The effective disk quota is %1$s as defined in this user account. The disk quota by role membership would have been %2$s by role "%3$s".";s:28:"disk_quota_is_unlimited_by_1";s:71:"The effective disk quota is unlimited due to membership in role "%1$s".";s:34:"disk_quota_last_reminder_sent_desc";s:93:"Last date on which the user has received a reminder mail because of exceeding the disk quota.";s:29:"disk_quota_last_reminder_sent";s:24:"Last quota reminder sent";s:23:"disk_quota_on_role_desc";s:93:"The disk quota specified on a role affects all user accounts which are assigned to this role.";s:29:"disk_quota_reminder_mail_desc";s:295:"The disk quota reminder mail is sent to active users who have exceeded their disk quota. This e-mail is sent once every day to the users when the daily ILIAS cron job is run. Users who already have received a reminder e-mail receive it again every 7 days as long as they exceed their disk quota.";s:24:"disk_quota_reminder_mail";s:13:"Reminder mail";s:29:"disk_quota_report_not_run_yet";s:110:"No disk quota report available. The daily cron job which determines the disk usage needs to be executed first.";s:17:"disk_quota_report";s:17:"Disk Quota Report";s:10:"disk_quota";s:10:"Disk Quota";s:15:"disk_space_used";s:15:"Disk space used";s:18:"disk_usage_details";s:18:"Disk Usage Details";s:10:"disk_usage";s:10:"Disk Usage";s:27:"display_webdav_actions_info";s:115:"Displays the action ‘Open as webfolder’ next to each category, folder, course and group item in the repository.";s:22:"display_webdav_actions";s:22:"Display WebDAV actions";s:6:"domain";s:6:"Domain";s:4:"down";s:4:"Down";s:27:"download_all_returned_files";s:27:"Download all returned files";s:36:"download_with_uploaded_filename_info";s:478:"Select this option exclusively for backwards compatibility with ILIAS 3.9 and older versions: When this option is selected, the filename of a downloaded file is equal to the filename that was used for uploading the file into ILIAS. If this option is not selected, the filename of a downloaded file is equal to the title of the file object in ILIAS. This option does not affect WebDAV. For WebDAV the filename of a downloaded file is always equal to the title of the file object.";s:31:"download_with_uploaded_filename";s:31:"Download with uploaded filename";s:8:"download";s:8:"Download";s:20:"downloading_settings";s:20:"Downloading Settings";s:6:"drafts";s:6:"Drafts";s:4:"drop";s:4:"Drop";s:17:"edit_cat_settings";s:26:"Advanced Category Settings";s:13:"edit_comments";s:35:"Edit comments for the selected user";s:12:"edit_content";s:12:"Edit Content";s:9:"edit_data";s:9:"Edit Data";s:13:"edit_grouping";s:26:"Edit Membership Limitation";s:15:"edit_operations";s:15:"Edit Operations";s:17:"edit_page_content";s:17:"Edit Page Content";s:9:"edit_page";s:9:"Edit Page";s:17:"edit_perm_ruleset";s:29:"Edit default permission rules";s:15:"edit_properties";s:15:"Edit Properties";s:15:"edit_stylesheet";s:10:"Edit Style";s:4:"edit";s:4:"Edit";s:9:"edited_at";s:9:"Edited at";s:6:"editor";s:6:"Editor";s:14:"email_feedback";s:15:"E-Mail feedback";s:12:"email_footer";s:22:"<br />powered by ILIAS";s:15:"email_not_valid";s:44:"The e-mail address you entered is not valid!";s:5:"email";s:6:"E-Mail";s:18:"enable_admin_force";s:21:"Activate notification";s:15:"enable_calendar";s:15:"Enable Calendar";s:24:"enable_custom_icons_info";s:175:"This allows you to define custom icons for single categories, courses and groups. The properties section of categories, courses and groups will provide an image upload dialog.";s:19:"enable_custom_icons";s:19:"Enable custom icons";s:22:"enable_disk_quota_info";s:414:"Allows definition of a soft disk quota for each user account and each global role. Users that have exceeded the defined disk quota can be notified by ILIAS but are still able to upload more files. <br />This feature requires the activation of the cron job for disk quota! This cron job analyses the disk usage of all user accounts and list it in Administration » User Accounts as well as in the Disk Quota Report.";s:31:"enable_disk_quota_reminder_mail";s:30:"Send disk quota reminder mails";s:27:"enable_download_folder_info";s:65:"Allows download of a folder including sub structures as zip file.";s:22:"enable_download_folder";s:26:"Enable Downloading Folders";s:21:"enable_ext_lang_maint";s:27:"Enable Extended Maintenance";s:27:"enable_fora_statistics_desc";s:59:"If disabled, nobody is able to access the forum statistics.";s:22:"enable_fora_statistics";s:26:"Enable Statistics in Forum";s:23:"enable_hide_user_toggle";s:35:"Member is not allowed to deactivate";s:30:"enable_hist_user_comments_desc";s:73:"Give authors the opportunity to add comments to the history log of pages.";s:25:"enable_hist_user_comments";s:31:"Enable user comments in history";s:19:"enable_js_edit_info";s:121:"This option enables JavaScript editing for all content objects (ILIAS Learning Modules, Glossaries, Assessment Questions)";s:14:"enable_js_edit";s:25:"Enable JavaScript Editing";s:26:"enable_password_assistance";s:26:"Enable password assistance";s:19:"enable_registration";s:28:"Enable new user registration";s:20:"enable_search_engine";s:219:"Open Public Area for Internet Search Engines (e.g Google).<br />The Apache module ‘mod_rewrite’ is required for this extension. Please take care that you have appropriate permissions to use .htaccess configurations.";s:17:"enable_trash_info";s:164:"If enabled, deleted Objects are moved into Trash and may be recovered later. When deactivating this option deleted Objects are removed irreversibly from the System!";s:12:"enable_trash";s:12:"Enable Trash";s:18:"enable_webdav_info";s:243:"Allows WebDAV clients to access the repository as a webfolder. Users can open webfolders using the ‘Open as webfolder’ action in the repository, or by entering the following address in a WebDAV client: <a href="%1$s" folder="%1$s">%1$s</a>";s:13:"enable_webdav";s:20:"Enable WebDAV access";s:6:"enable";s:6:"Enable";s:7:"enabled";s:7:"Enabled";s:16:"enter_in_mb_desc";s:20:"Enter a value in MB.";s:9:"enumerate";s:9:"Enumerate";s:11:"err_1_param";s:17:"Only 1 parameter!";s:11:"err_2_param";s:17:"Only 2 parameter!";s:26:"err_auth_cas_no_ilias_user";s:126:"Login failed. CAS authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.";s:24:"err_auth_ext_user_exists";s:83:"External account \'%s\' for authentication mode \'%s\' is already existing. (User \'%s\')";s:27:"err_auth_ldap_no_ilias_user";s:127:"Login failed. LDAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.";s:22:"err_auth_mode_inactive";s:42:"Your authentication method is deactivated.";s:29:"err_auth_radius_no_ilias_user";s:87:"Login failed. Radius authentication successful, but no corresponding ILIAS user exists.";s:27:"err_auth_soap_no_ilias_user";s:127:"Login failed. SOAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.";s:15:"err_check_input";s:57:"The settings could not be saved. Please check your input.";s:15:"err_count_param";s:29:"Reason: Wrong parameter count";s:24:"err_enter_current_passwd";s:34:"Please enter your current password";s:11:"err_in_line";s:13:"Error in line";s:12:"err_inactive";s:88:"This account has not been activated. Please contact the system administrator for access.";s:16:"err_invalid_port";s:19:"Invalid port number";s:20:"err_ldap_auth_failed";s:102:"User not authenticated on LDAP server! Please ensure that you have the same password in ILIAS and LDAP";s:23:"err_ldap_connect_failed";s:60:"Connection to LDAP server failed! Please check your settings";s:22:"err_ldap_search_failed";s:69:"Connection to LDAP server failed! PLease check BaseDN and Search base";s:23:"err_ldap_user_not_found";s:86:"User not found on LDAP server! Please check attribute for login name and object class.";s:14:"err_no_cookies";s:46:"Please enable session cookies in your browser!";s:21:"err_no_langfile_found";s:23:"No language file found!";s:12:"err_no_param";s:13:"No parameter!";s:16:"err_over_3_param";s:23:"More than 3 parameters!";s:23:"err_role_not_assignable";s:53:"You cannot assign users to this role at this location";s:19:"err_session_expired";s:24:"Your session is expired!";s:17:"err_unknown_error";s:13:"Unknown Error";s:16:"err_wrong_header";s:21:"Reason: Wrong header.";s:15:"err_wrong_login";s:23:"Wrong Login or Password";s:18:"err_wrong_password";s:14:"Wrong Password";s:12:"error_parser";s:26:"Error starting the parser.";s:15:"error_recipient";s:15:"Error Recipient";s:5:"error";s:5:"Error";s:24:"event_ass_materials_prop";s:17:"Session Materials";s:18:"event_assign_files";s:15:"File Assignment";s:7:"exc_add";s:12:"Add Exercise";s:9:"exc_added";s:14:"Exercise added";s:14:"exc_ask_delete";s:12:"Delete file?";s:14:"exc_assign_usr";s:11:"Assign User";s:10:"exc_create";s:15:"Create exercise";s:18:"exc_date_not_valid";s:21:"The date is not valid";s:20:"exc_deassign_members";s:21:"Remove Participant(s)";s:11:"exc_details";s:16:"Exercise details";s:16:"exc_download_all";s:12:"Download All";s:18:"exc_download_files";s:14:"Download Files";s:16:"exc_download_new";s:12:"Download New";s:17:"exc_edit_exercise";s:13:"Edit exercise";s:14:"exc_edit_until";s:10:"Edit Until";s:8:"exc_edit";s:20:"New exercise created";s:17:"exc_exercise_sent";s:13:"Exercise Sent";s:17:"exc_feedback_sent";s:13:"Feedback Sent";s:18:"exc_files_returned";s:15:"Submitted Files";s:9:"exc_files";s:5:"Files";s:10:"exc_groups";s:6:"Groups";s:18:"exc_header_members";s:18:"Exercise (members)";s:15:"exc_instruction";s:17:"Work Instructions";s:19:"exc_last_submission";s:15:"Last Submission";s:14:"exc_mail_users";s:20:"Send mail to user(s)";s:28:"exc_members_already_assigned";s:66:"These users are already assigned to other teams of this assignment";s:20:"exc_members_assigned";s:16:"Members assigned";s:26:"exc_members_comments_saved";s:59:"The exercise comments for the selected user have been saved";s:7:"exc_new";s:12:"New Exercise";s:23:"exc_no_members_assigned";s:19:"No members assigned";s:11:"exc_notices";s:7:"Notices";s:7:"exc_obj";s:8:"Exercise";s:22:"exc_resubmitted_advice";s:118:"This symbol will be displayed in case that a new file has been submitted after the ‘solved’ field has been checked";s:9:"exc_roles";s:5:"Roles";s:16:"exc_save_changes";s:4:"Save";s:12:"exc_schedule";s:8:"Schedule";s:14:"exc_search_for";s:10:"Search for";s:19:"exc_select_one_file";s:31:"Please select exactly one file.";s:17:"exc_send_exercise";s:21:"Send exercise by mail";s:11:"exc_sent_at";s:16:"Sent on <br />%s";s:8:"exc_sent";s:48:"The exercise has been sent to the selected users";s:22:"exc_status_resubmitted";s:11:"Resubmitted";s:16:"exc_status_saved";s:16:"Exercise updated";s:15:"exc_status_sent";s:9:"Delivered";s:17:"exc_status_solved";s:6:"Solved";s:20:"exc_status_submitted";s:9:"Submitted";s:10:"exc_status";s:6:"Status";s:14:"exc_submission";s:10:"Submission";s:19:"exc_time_over_short";s:11:"Time is up.";s:16:"exc_time_to_send";s:22:"Remaining Working Time";s:16:"exc_upload_error";s:20:"Error uploading file";s:9:"exc_users";s:5:"Users";s:3:"exc";s:8:"Exercise";s:4:"excs";s:9:"Exercises";s:7:"execute";s:7:"Execute";s:18:"exercise_time_over";s:91:"The time allocated for completing this exercise is over. Files cannot be submitted anymore!";s:8:"exp_html";s:11:"Export HTML";s:10:"expand_all";s:10:"Expand All";s:6:"expand";s:6:"Expand";s:8:"expanded";s:8:"Expanded";s:14:"explorer_frame";s:13:"Explorer Tree";s:23:"export_format_selection";s:36:"Please select the export file format";s:13:"export_format";s:13:"Export format";s:20:"export_group_members";s:41:"Export group members (to Microsoft Excel)";s:11:"export_html";s:19:"Export as HTML File";s:10:"export_xml";s:18:"Export as XML File";s:6:"export";s:6:"Export";s:21:"ext_acccount_required";s:46:"Please enter the name of the external account.";s:16:"ext_cat_settings";s:31:"Edit Advanced Category Settings";s:8:"ext_link";s:4:"Link";s:14:"extt_configure";s:12:"configure...";s:9:"extt_name";s:16:"Software/Service";s:11:"extt_remark";s:123:"All software and services listed above are not part of ILIAS and do not fall under the ILIAS open source licence agreement.";s:20:"extt_title_configure";s:27:"Configure external software";s:15:"failure_message";s:15:"Failure Message";s:12:"faq_exercise";s:12:"FAQ Exercise";s:3:"fax";s:3:"Fax";s:4:"feed";s:8:"Web Feed";s:18:"feedback_recipient";s:18:"Feedback Recipient";s:8:"feedback";s:8:"Feedback";s:10:"field_name";s:10:"Field Name";s:10:"field_type";s:10:"Field Type";s:6:"file_a";s:6:"a File";s:21:"file_add_and_metadata";s:29:"Upload File and Edit Metadata";s:8:"file_add";s:11:"Upload File";s:10:"file_added";s:13:"File uploaded";s:21:"file_allowed_suffixes";s:19:"Allowed file types:";s:12:"file_created";s:20:"File has been added.";s:9:"file_edit";s:32:"Edit File and Upload New Version";s:9:"file_icon";s:9:"File icon";s:9:"file_info";s:16:"File Information";s:16:"file_is_infected";s:32:"The file is infected by a virus.";s:21:"file_lock_unlock_file";s:16:"Lock/Unlock file";s:14:"file_locked_by";s:14:"File locked by";s:8:"file_new";s:18:"Upload Single File";s:14:"file_not_found";s:14:"File Not Found";s:14:"file_not_valid";s:15:"File not valid!";s:11:"file_notice";s:20:"Maximum upload size:";s:21:"file_suffix_repl_info";s:200:"Enter file types with suffix (separated by comma) that shall be be renamed with a ‘.sec’ when uploaded into webspace to prevent execution of this file. This is done per default for these suffixes:";s:16:"file_suffix_repl";s:30:"File Upload Suffix Replacement";s:12:"file_updated";s:22:"File has been updated.";s:10:"file_valid";s:14:"File is valid!";s:12:"file_version";s:24:"Version Provided in File";s:4:"file";s:4:"File";s:26:"filename_extension_missing";s:27:"File name extension missing";s:24:"filename_extension_short";s:9:"Extension";s:27:"filename_hidden_backup_file";s:18:"Hidden backup file";s:25:"filename_hidden_unix_file";s:16:"Hidden Unix file";s:25:"filename_interoperability";s:16:"Interoperability";s:27:"filename_special_characters";s:63:"Due to the character / this object is not visible in webfolders";s:25:"filename_special_filename";s:57:"Objects with names . and .. are not visible in webfolders";s:19:"filename_visibility";s:10:"Visibility";s:32:"filename_windows_empty_extension";s:94:"Due to the character . at the end of the name this object is not visible in Windows webfolders";s:35:"filename_windows_special_characters";s:95:"Due to one of the characters \\ / : * ? " < > | this object is not visible in Windows webfolders";s:29:"filename_windows_webdav_issue";s:71:"Due to the character # this object is not visible in Windows webfolders";s:8:"filename";s:9:"File Name";s:14:"files_location";s:14:"Files Location";s:5:"files";s:5:"Files";s:8:"filesize";s:9:"File Size";s:8:"filetype";s:9:"File Type";s:28:"fill_out_all_required_fields";s:35:"Please fill out all required fields";s:24:"filter_users_with_access";s:22:"Only users with access";s:28:"filter_users_with_disk_usage";s:31:"Only users with disk space used";s:37:"filter_users_with_exceeded_disk_quota";s:35:"Only users with disk quota exceeded";s:27:"filter_users_without_access";s:25:"Only users without access";s:31:"filter_users_without_disk_usage";s:34:"Only users with no disk space used";s:6:"filter";s:6:"Filter";s:9:"firstname";s:10:"First Name";s:8:"flatview";s:12:"Hide Sidebar";s:6:"fold_a";s:8:"a Folder";s:8:"fold_add";s:10:"Add Folder";s:10:"fold_added";s:12:"Folder added";s:22:"fold_copy_threads_info";s:71:"Please decide which materials should be copied, linked or even omitted.";s:9:"fold_edit";s:11:"Edit Folder";s:8:"fold_new";s:10:"New Folder";s:16:"fold_wizard_page";s:22:"Copy Folder (Step 2/2)";s:4:"fold";s:6:"Folder";s:6:"folder";s:6:"Folder";s:7:"folders";s:7:"Folders";s:26:"force_accept_usr_agreement";s:35:"You must accept the user agreement!";s:8:"forename";s:8:"Forename";s:15:"forgot_password";s:21:"Forgot your password?";s:15:"forgot_username";s:21:"Forgot your username?";s:17:"form_empty_fields";s:29:"Please complete these fields:";s:20:"form_input_not_valid";s:68:"Some data is incomplete or not valid. Please correct the form input.";s:17:"forum_attachments";s:17:"Forum attachments";s:25:"forum_direct_notification";s:19:"Direct Notification";s:26:"forum_general_notification";s:20:"General Notification";s:17:"forum_import_file";s:11:"Import file";s:12:"forum_import";s:12:"Forum import";s:24:"forum_notify_me_directly";s:57:"Please inform me about direct answers to my contribution.";s:25:"forum_notify_me_generally";s:58:"Please inform me about any new contributions to my thread.";s:15:"forum_notify_me";s:32:"Notify me when a reply is posted";s:18:"forum_post_replied";s:34:"Your forum entry has been replied.";s:5:"forum";s:5:"Forum";s:17:"forums_anonymized";s:16:"Forum anonymized";s:16:"forums_anonymous";s:6:"anonym";s:15:"forums_articles";s:8:"Articles";s:33:"forums_disable_forum_notification";s:35:"Disable Notification for this Forum";s:32:"forums_enable_forum_notification";s:34:"Enable Notification for this Forum";s:33:"forums_forum_notification_enabled";s:54:"You will be notified about new messages in this forum.";s:16:"forums_last_post";s:14:"Latest Article";s:17:"forums_moderators";s:10:"Moderators";s:19:"forums_new_articles";s:12:"New Articles";s:28:"forums_notification_settings";s:28:"Forums Notification Settings";s:15:"forums_overview";s:15:"Forums Overview";s:14:"forums_threads";s:7:"Threads";s:16:"forums_use_alias";s:131:"You may use a pseudonym for your posting. If you leave this field blank, your posting will be marked as written by ‘Anonymous’.";s:16:"forums_your_name";s:9:"Your Name";s:6:"forums";s:6:"Forums";s:5:"frm_a";s:7:"a Forum";s:7:"frm_add";s:9:"Add Forum";s:9:"frm_added";s:11:"Forum added";s:11:"frm_article";s:7:"article";s:10:"frm_create";s:12:"Create Forum";s:15:"frm_delete_post";s:24:"Edit and delete postings";s:13:"frm_edit_post";s:15:"Add new posting";s:8:"frm_edit";s:10:"Edit Forum";s:19:"frm_latest_postings";s:15:"Latest Articles";s:7:"frm_new";s:9:"New Forum";s:22:"frm_statistics_ranking";s:7:"Ranking";s:19:"frm_status_new_desc";s:81:"Please select a duration how long the status ‘New’ is kept for forum entries.";s:14:"frm_status_new";s:16:"Status ‘New’";s:3:"frm";s:5:"Forum";s:4:"from";s:4:"From";s:8:"fullname";s:9:"Full name";s:9:"functions";s:9:"Functions";s:20:"further_informations";s:19:"Further Information";s:7:"gdf_add";s:14:"Add Definition";s:7:"gdf_new";s:14:"New Definition";s:8:"gender_f";s:6:"Female";s:8:"gender_m";s:4:"Male";s:6:"gender";s:6:"Gender";s:16:"general_settings";s:16:"General Settings";s:8:"generate";s:8:"Generate";s:7:"glo_add";s:12:"Add Glossary";s:9:"glo_added";s:14:"Glossary added";s:10:"glo_create";s:15:"Create Glossary";s:13:"glo_mode_desc";s:321:"A virtual glossary works like a normal glossary. Additionally it contains the terms from all glossaries that are located on the same level in the repository like the virtual glossary (level) respectively from all glossaries that are located downwards in the repository from the position of the virtual glossary (subtree).";s:14:"glo_mode_level";s:25:"virtual (this level only)";s:15:"glo_mode_normal";s:6:"normal";s:16:"glo_mode_subtree";s:24:"virtual (entire subtree)";s:8:"glo_mode";s:4:"Mode";s:7:"glo_new";s:12:"New Glossary";s:15:"glo_upload_file";s:4:"File";s:3:"glo";s:8:"Glossary";s:14:"global_default";s:14:"Global Default";s:12:"global_fixed";s:12:"Global Fixed";s:15:"global_settings";s:15:"Global settings";s:11:"global_user";s:12:"Global users";s:6:"global";s:6:"Global";s:10:"glossaries";s:10:"Glossaries";s:14:"glossary_added";s:14:"Glossary added";s:8:"glossary";s:8:"Glossary";s:2:"go";s:2:"Go";s:19:"group_access_denied";s:13:"Access Denied";s:17:"group_any_objects";s:24:"No sub-objects available";s:17:"group_create_chat";s:11:"Create chat";s:10:"group_desc";s:17:"Group Description";s:13:"group_details";s:13:"Group Details";s:17:"group_filesharing";s:18:"Group File Sharing";s:17:"group_import_file";s:11:"Import file";s:12:"group_import";s:12:"Group import";s:14:"group_info_reg";s:19:"Admission procedure";s:13:"group_members";s:13:"Group Members";s:19:"group_memstat_admin";s:13:"Administrator";s:20:"group_memstat_member";s:6:"Member";s:13:"group_memstat";s:13:"Member Status";s:10:"group_name";s:10:"Group Name";s:23:"group_new_registrations";s:13:"Join Requests";s:25:"group_no_registration_msg";s:33:"You can join this group directly.";s:21:"group_no_registration";s:10:"Join Group";s:19:"group_not_available";s:18:"No group available";s:13:"group_objects";s:13:"Group Objects";s:31:"group_password_registration_msg";s:126:"If you know the group password, you can join this group. Please contact a group administrator, if you don\'t know the password.";s:34:"group_registration_expiration_date";s:15:"Expiration Date";s:34:"group_registration_expiration_time";s:15:"Expiration Time";s:30:"group_registration_expired_msg";s:121:"The time period for joining this group has expired. Please contact a group administrator, if you want to join this group.";s:26:"group_registration_expired";s:50:"The time period for joining this group has expired";s:23:"group_registration_mode";s:22:"Registration Procedure";s:23:"group_registration_time";s:19:"Registration Period";s:18:"group_registration";s:12:"Registration";s:16:"group_req_direct";s:13:"Join directly";s:18:"group_req_password";s:24:"Join with group password";s:26:"group_req_registration_msg";s:215:"You have to request for membership to access this group. Please describe your interest for becoming member in the message form. You will be notified as soon as an administrator has accepted or declined your request.";s:22:"group_req_registration";s:18:"Request membership";s:11:"group_reset";s:23:"Reset Group Permissions";s:19:"group_status_closed";s:6:"Closed";s:17:"group_status_desc";s:300:"Determines the initial status of the group by using the permission settings from the role templates ‘il_grp_status_closed’ or ‘il_grp_status_open’<br />Public: Group is visible; User may subscribe.<br />Closed: Group is not visible for non-members; User has to be invited by a member to join.";s:19:"group_status_public";s:6:"Public";s:12:"group_status";s:8:"Group is";s:5:"group";s:5:"Group";s:27:"grouping_select_exactly_one";s:48:"Please choose exactly one membership limitation.";s:26:"groupings_assigned_obj_crs";s:16:"Assigned Courses";s:26:"groupings_assigned_obj_grp";s:15:"Assigned Groups";s:9:"groupings";s:22:"Membership Limitations";s:15:"groups_overview";s:15:"Groups Overview";s:6:"groups";s:6:"Groups";s:5:"grp_a";s:7:"a Group";s:14:"grp_add_member";s:13:"Add Member(s)";s:7:"grp_add";s:9:"Add Group";s:9:"grp_added";s:11:"Group added";s:19:"grp_already_applied";s:68:"You have already applied to this group! Please wait for confirmation";s:17:"grp_app_send_mail";s:24:"Send applicant a message";s:8:"grp_back";s:4:"Back";s:19:"grp_btn_unsubscribe";s:22:"Unsubscribe From Group";s:23:"grp_cancel_waiting_list";s:74:"Do you really want to remove yourself from the waiting list of group "%s"?";s:21:"grp_copy_threads_info";s:71:"Please decide which materials should be copied, linked or even omitted.";s:17:"grp_count_members";s:17:"Number of members";s:10:"grp_create";s:12:"Create Group";s:24:"grp_deleted_export_files";s:23:"Deleted selected files.";s:18:"grp_dismiss_member";s:76:"Are you sure you want to unsubscribe the following member(s) from the group?";s:18:"grp_dismiss_myself";s:53:"Are you sure you want to unsubscribe from this group?";s:8:"grp_edit";s:10:"Edit Group";s:30:"grp_err_administrator_required";s:79:"Member could not be removed, at least one administrator per group is required !";s:49:"grp_err_at_least_one_groupadministrator_is_needed";s:49:"Each group needs at least one group administrator";s:13:"grp_err_error";s:17:"An error occurred";s:19:"grp_err_last_member";s:62:"Last member could not be removed, please delete group instead.";s:35:"grp_err_member_could_not_be_removed";s:73:"Member could not be removed. Please verify all dependencies of this user.";s:21:"grp_err_no_permission";s:54:"You do not possess the permissions for this operation.";s:25:"grp_err_registration_data";s:82:"Please enter a password, the expiration date and time for a valid joining period !";s:23:"grp_header_edit_members";s:12:"Edit members";s:14:"grp_list_users";s:10:"List users";s:30:"grp_mail_body_new_subscription";s:39:"You have been subscribed to this group.";s:36:"grp_mail_body_subscription_cancelled";s:35:"Your membership has been cancelled.";s:30:"grp_mail_subj_new_subscription";s:16:"New subscription";s:36:"grp_mail_subj_subscription_cancelled";s:22:"Subscription cancelled";s:21:"grp_mem_change_status";s:25:"Change Participant Status";s:13:"grp_mem_leave";s:25:"Dismiss member from group";s:17:"grp_mem_send_mail";s:27:"Send Participants a Message";s:19:"grp_members_gallery";s:21:"Group Members Gallery";s:27:"grp_msg_applicants_assigned";s:40:"Applicant(s) assigned as group member(s)";s:26:"grp_msg_applicants_removed";s:31:"Applicant(s) removed from list.";s:23:"grp_msg_member_assigned";s:35:"User(s) assigned as group member(s)";s:27:"grp_msg_membership_annulled";s:21:"Cancelled membership.";s:15:"grp_name_exists";s:68:"There is already a group with this name! Please choose another name.";s:14:"grp_new_search";s:10:"New search";s:7:"grp_new";s:9:"New Group";s:22:"grp_no_groups_selected";s:21:"Please select a group";s:20:"grp_no_results_found";s:16:"No results found";s:21:"grp_no_roles_selected";s:20:"Please select a role";s:11:"grp_options";s:7:"Options";s:12:"grp_register";s:4:"Join";s:26:"grp_registration_completed";s:25:"You have joined the group";s:16:"grp_registration";s:10:"Join Group";s:29:"grp_removed_from_waiting_list";s:59:"You have been detached from the waiting list of group "%s".";s:30:"grp_search_enter_search_string";s:28:"Please enter a search string";s:18:"grp_search_members";s:11:"User search";s:24:"grp_select_one_file_only";s:31:"Please select exactly one file.";s:19:"grp_select_one_file";s:23:"Please select one file.";s:15:"grp_wizard_page";s:21:"Copy Group (Step 2/2)";s:3:"grp";s:5:"Group";s:5:"guest";s:5:"Guest";s:6:"guests";s:6:"Guests";s:17:"header_searchable";s:10:"Searchable";s:12:"header_title";s:12:"Header Title";s:27:"header_visible_registration";s:23:"Visible in Registration";s:10:"header_zip";s:36:"Upload Multiple Files as Zip-Archive";s:6:"height";s:6:"Height";s:4:"help";s:4:"Help";s:8:"hh_mm_ss";s:8:"HH:MM:SS";s:5:"hh_mm";s:5:"HH:MM";s:2:"HH";s:5:"HH:MM";s:10:"mm_dd_yyyy";s:10:"MM/DD/YYYY";s:10:"dd_mm_yyyy";s:10:"DD.MM.YYYY";s:10:"yyyy_mm_dd";s:10:"YYYY-MM-DD";s:12:"hide_details";s:12:"Hide Details";s:11:"hide_filter";s:11:"Hide Filter";s:22:"hide_own_online_status";s:21:"Hide My Online Status";s:18:"hide_private_notes";s:10:"Hide Notes";s:14:"hide_structure";s:23:"Disable Structured-View";s:4:"hide";s:4:"Hide";s:4:"hint";s:4:"Hint";s:18:"hist_dbk_delete_pg";s:32:"Page "%1" [%2] has been deleted.";s:18:"hist_dbk_delete_st";s:35:"Chapter "%1" [%2] has been deleted.";s:18:"hist_dbk_pg_create";s:13:"Page created.";s:15:"hist_dbk_pg_cut";s:34:"Page cut out of chapter "%1" [%2].";s:17:"hist_dbk_pg_paste";s:35:"Page pasted into chapter \'%1\' [%2].";s:18:"hist_dbk_pg_update";s:13:"Page changed.";s:20:"hist_dbk_st_cut_page";s:34:"Page "%1" [%2] cut out of chapter.";s:22:"hist_dbk_st_paste_page";s:35:"Page "%1" [%2] pasted into chapter.";s:16:"hist_file_create";s:32:"File created, file name is "%1".";s:21:"hist_file_new_version";s:61:"Added new file version, file name is "%1", new version is %2.";s:17:"hist_file_replace";s:56:"File replaced. New file name is "%1", new version is %2.";s:17:"hist_lm_delete_pg";s:32:"Page "%1" [%2] has been deleted.";s:17:"hist_lm_delete_st";s:35:"Chapter "%1" [%2] has been deleted.";s:17:"hist_lm_pg_create";s:13:"Page created.";s:14:"hist_lm_pg_cut";s:34:"Page cut out of chapter "%1" [%2].";s:16:"hist_lm_pg_paste";s:35:"Page pasted into chapter "%1" [%2].";s:17:"hist_lm_pg_update";s:13:"Page changed.";s:17:"hist_lm_st_create";s:16:"Chapter created.";s:19:"hist_lm_st_cut_page";s:34:"Page "%1" [%2] cut out of chapter.";s:21:"hist_lm_st_paste_page";s:35:"Page "%1" [%2] pasted into chapter.";s:15:"hist_no_entries";s:22:"No entries in history.";s:13:"hist_webr_add";s:34:"Added new Weblink with title: "%1"";s:16:"hist_webr_delete";s:32:"Deleted Weblink with title: "%1"";s:16:"hist_webr_update";s:33:"Modified Weblink with title: "%1"";s:7:"history";s:7:"History";s:13:"hits_per_page";s:9:"Hits/Page";s:5:"hobby";s:17:"Interests/Hobbies";s:4:"home";s:11:"Public Area";s:4:"host";s:4:"Host";s:4:"hour";s:4:"Hour";s:12:"hours_of_day";s:12:"Hours of day";s:5:"hours";s:5:"Hours";s:8:"htlm_add";s:24:"Add HTML Learning Module";s:9:"htlm_edit";s:36:"Edit HTML Learning Module Properties";s:8:"htlm_new";s:24:"New HTML Learning Module";s:4:"htlm";s:20:"Learning Module HTML";s:10:"html_block";s:10:"HTML Block";s:17:"http_not_possible";s:44:"This server is not supporting http requests.";s:9:"http_path";s:9:"HTTP Path";s:4:"http";s:4:"HTTP";s:18:"https_not_possible";s:48:"This server is not supporting HTTPS connections.";s:8:"i2passwd";s:16:"ILIAS 2 password";s:13:"icon_settings";s:12:"Custom Icons";s:4:"icon";s:4:"Icon";s:15:"icons_in_header";s:10:"Header row";s:18:"icons_in_item_rows";s:9:"Item rows";s:25:"icons_in_typed_lists_info";s:123:"Determines where to display icons in item lists that are ordered by type within the repository and on the personal desktop.";s:20:"icons_in_typed_lists";s:27:"Icon position in item lists";s:2:"id";s:2:"ID";s:10:"identifier";s:10:"identifier";s:25:"if_no_title_then_filename";s:38:"Leave blank to use file name as title.";s:20:"if_no_title_then_url";s:30:"Leave blank to display the URL";s:18:"ignore_on_conflict";s:18:"Ignore on conflict";s:17:"il_chat_moderator";s:14:"Chat Moderator";s:12:"il_crs_admin";s:20:"Course Administrator";s:13:"il_crs_member";s:13:"Course Member";s:17:"il_crs_non_member";s:17:"Course non-member";s:12:"il_crs_tutor";s:12:"Course Tutor";s:16:"il_frm_moderator";s:15:"Forum moderator";s:12:"il_grp_admin";s:19:"Group Administrator";s:13:"il_grp_member";s:12:"Group Member";s:20:"il_grp_status_closed";s:12:"Group closed";s:18:"il_grp_status_open";s:10:"Group open";s:28:"ilias_and_webfolder_username";s:28:"ILIAS and Webfolder Username";s:14:"ilias_username";s:14:"ILIAS Username";s:13:"ilias_version";s:13:"ILIAS version";s:11:"im_aim_icon";s:8:"AIM Logo";s:6:"im_aim";s:3:"AIM";s:11:"im_icq_icon";s:8:"ICQ Logo";s:6:"im_icq";s:3:"ICQ";s:14:"im_jabber_icon";s:11:"Jabber Logo";s:9:"im_jabber";s:6:"Jabber";s:11:"im_msn_icon";s:8:"MSN Logo";s:6:"im_msn";s:3:"MSN";s:13:"im_skype_icon";s:10:"Skype Logo";s:8:"im_skype";s:5:"Skype";s:12:"im_voip_icon";s:9:"VoIP Logo";s:7:"im_voip";s:4:"VoIP";s:13:"im_yahoo_icon";s:10:"Yahoo Logo";s:8:"im_yahoo";s:5:"Yahoo";s:16:"image_gen_unsucc";s:93:"Image generation unsuccessful. Contact your system administrator and verify the convert path.";s:5:"image";s:5:"Image";s:10:"import_alm";s:19:"Import AICC Package";s:19:"import_cat_localrol";s:40:"Create local role for every new category";s:16:"import_cat_table";s:61:"The following table is only meaningful if the checkbox is set";s:17:"import_categories";s:17:"Import Categories";s:18:"import_failure_log";s:18:"Import failure log";s:21:"import_file_not_valid";s:29:"The import file is not valid.";s:11:"import_file";s:11:"Import File";s:15:"import_finished";s:28:"Number of imported messages.";s:21:"import_forum_finished";s:28:"The forum has been imported.";s:15:"import_glossary";s:15:"Import Glossary";s:19:"import_grp_finished";s:32:"Imported group without any error";s:10:"import_grp";s:12:"Import Group";s:9:"import_lm";s:28:"Import ILIAS Learning module";s:10:"import_qpl";s:25:"Import Question Pool Test";s:25:"import_questions_into_qpl";s:37:"Import question(s) into question pool";s:16:"import_root_user";s:16:"Import Root User";s:11:"import_sahs";s:25:"Import SCORM/AICC Package";s:10:"import_spl";s:27:"Import Question Pool Survey";s:10:"import_svy";s:13:"Import Survey";s:10:"import_tst";s:11:"Import Test";s:12:"import_users";s:12:"Import Users";s:18:"import_warning_log";s:18:"Import warning log";s:6:"import";s:6:"Import";s:9:"important";s:9:"Important";s:8:"imported";s:8:"imported";s:9:"in_use_by";s:9:"In use by";s:6:"in_use";s:13:"User Language";s:2:"in";s:2:"in";s:8:"inactive";s:8:"Inactive";s:5:"inbox";s:5:"Inbox";s:13:"include_local";s:50:"include local language file when updating language";s:27:"info_access_and_status_info";s:30:"Access- and status information";s:23:"info_access_permissions";s:18:"Access Permissions";s:20:"info_accessFree_sure";s:77:"Are you sure you want to remove the limited access for the following user(s)?";s:18:"info_activate_sure";s:78:"Are you sure that you want to approve the following user(s) as active user(s)?";s:16:"info_assign_sure";s:54:"Are you sure you want to assign the following user(s)?";s:13:"info_assigned";s:8:"assigned";s:20:"info_available_roles";s:15:"Available Roles";s:21:"info_change_user_view";s:11:"Change User";s:20:"info_deactivate_sure";s:63:"Are you sure that you want to deactivate the following user(s)?";s:16:"info_delete_sure";s:59:"Are you sure that you want to delete the following item(s)?";s:28:"info_delete_warning_no_trash";s:102:"(WARNING: Selected Objects will be removed irreversibly from System and may not be recovered anymore!)";s:12:"info_deleted";s:17:"Object(s) Deleted";s:22:"info_enter_login_or_id";s:36:"<i>(Enter login name or user ID)</i>";s:23:"info_err_user_not_exist";s:52:"User with that login name or user_id does not exists";s:14:"info_from_role";s:27:"Granted by Role / Ownership";s:14:"info_is_member";s:14:"User is member";s:18:"info_is_not_member";s:20:"User is not a member";s:12:"info_message";s:19:"Information Message";s:17:"info_not_assigned";s:12:"not assigned";s:20:"info_owner_of_object";s:15:"Owner of object";s:22:"info_permission_origin";s:17:"Original Position";s:22:"info_permission_source";s:15:"Effective From*";s:23:"info_remark_interrupted";s:116:"Role is interrupted at this position. The role\'s default permission settings in effect are located in that position.";s:10:"info_short";s:4:"Info";s:16:"info_status_info";s:19:"Permissions of User";s:10:"info_trash";s:15:"Deleted Objects";s:17:"info_view_of_user";s:4:"User";s:4:"info";s:11:"Information";s:16:"inform_user_mail";s:38:"Send mail to inform user about changes";s:16:"information_abbr";s:4:"Info";s:7:"inifile";s:8:"Ini-File";s:27:"inline_file_extensions_info";s:158:"Files with these extensions are displayed in the browser window.<br/>For example: <b>gif jpg mp3 pdf png</b><br/> All other files are offered for downloading.";s:22:"inline_file_extensions";s:17:"Web-enabled files";s:11:"input_error";s:11:"Input error";s:18:"insert_object_here";s:26:"Insert at Current Position";s:6:"insert";s:6:"Insert";s:7:"inst_id";s:15:"Installation ID";s:9:"inst_info";s:17:"Installation Info";s:9:"inst_name";s:17:"Installation Name";s:13:"install_local";s:18:"Install With Local";s:7:"install";s:7:"Install";s:15:"installed_local";s:20:"Installed With Local";s:9:"installed";s:9:"Installed";s:18:"instant_messengers";s:18:"Instant Messengers";s:11:"institution";s:11:"Institution";s:25:"internal_local_roles_only";s:42:"Local roles (only automatically generated)";s:15:"internal_system";s:15:"Internal system";s:41:"invalid_visible_required_options_selected";s:73:"All fields set to required has to be set to visible in registration, too.";s:20:"invisible_block_mess";s:50:"You do not have the permission to view this block.";s:15:"invisible_block";s:15:"Invisible Block";s:10:"ip_address";s:10:"IP Address";s:15:"is_already_your";s:15:"is already your";s:4:"item";s:4:"Item";s:16:"java_server_host";s:4:"Host";s:16:"java_server_info";s:83:"If activated, it is possible to search in PDF, HTML files and HTML-Learning modules";s:25:"java_server_no_connection";s:41:"Attention: Cannot connect to Java server.";s:16:"java_server_port";s:4:"Port";s:18:"java_server_readme";s:17:"Setup information";s:11:"java_server";s:11:"Java-Server";s:12:"join_session";s:6:"Attend";s:4:"join";s:4:"Join";s:2:"kb";s:5:"KByte";s:8:"keywords";s:8:"Keywords";s:15:"lang_dateformat";s:5:"Y-m-d";s:9:"lang_path";s:13:"Language Path";s:25:"lang_refresh_confirm_info";s:388:"Extended language maintenance is currently activated. Refreshing the languages will read the global language files of ILIAS and probably the local language files from the Customizing directory to the database. Global language files will not affect your manual changes. A local language file will overwrite all manual changes that are older than the saving date of the local language file.";s:29:"lang_refresh_confirm_selected";s:53:"Do you really want to refresh the selected languages?";s:20:"lang_refresh_confirm";s:44:"Do you really want to refresh all languages?";s:16:"lang_sep_decimal";s:1:".";s:17:"lang_sep_thousand";s:1:",";s:15:"lang_size_bytes";s:5:"bytes";s:12:"lang_size_gb";s:2:"GB";s:12:"lang_size_kb";s:2:"KB";s:12:"lang_size_mb";s:2:"MB";s:22:"lang_timeformat_no_sec";s:3:"H:i";s:15:"lang_timeformat";s:5:"H:i:s";s:12:"lang_version";s:1:"1";s:14:"langfile_found";s:19:"Language file found";s:22:"language_not_installed";s:52:"is not installed. Please install that language first";s:8:"language";s:8:"Language";s:27:"languages_already_installed";s:42:"Selected language(s) are already installed";s:29:"languages_already_uninstalled";s:44:"Selected language(s) are already uninstalled";s:17:"languages_updated";s:41:"All installed languages have been updated";s:9:"languages";s:9:"Languages";s:11:"last_access";s:11:"Last Access";s:11:"last_change";s:11:"Last Change";s:14:"last_edited_on";s:14:"Last edited on";s:10:"last_login";s:10:"Last Login";s:12:"last_refresh";s:12:"Last Refresh";s:13:"last_reminder";s:13:"Last reminder";s:11:"last_update";s:11:"Last Update";s:10:"last_visit";s:10:"Last Visit";s:12:"last_visited";s:12:"Last Visited";s:8:"lastname";s:9:"Last Name";s:6:"launch";s:6:"Launch";s:11:"ldap_basedn";s:11:"LDAP BaseDN";s:14:"ldap_configure";s:29:"Configure LDAP Authentication";s:20:"ldap_edit_permission";s:26:"Change permission settings";s:14:"ldap_login_key";s:24:"Attribute for login name";s:16:"ldap_objectclass";s:28:"ObjectClass of user accounts";s:11:"ldap_passwd";s:21:"Your current password";s:9:"ldap_port";s:9:"LDAP Port";s:9:"ldap_read";s:28:"Read access to LDAP settings";s:16:"ldap_search_base";s:16:"LDAP Search base";s:11:"ldap_server";s:15:"LDAP Server URL";s:8:"ldap_tls";s:12:"Use LDAP TLS";s:7:"ldap_v2";s:6:"LDAPv2";s:7:"ldap_v3";s:6:"LDAPv3";s:12:"ldap_version";s:22:"LDAP protokoll version";s:12:"ldap_visible";s:25:"LDAP settings are visible";s:10:"ldap_write";s:18:"Edit LDAP settings";s:4:"ldap";s:4:"LDAP";s:15:"learning module";s:15:"Learning Module";s:16:"learning_objects";s:16:"Learning Objects";s:17:"learning_progress";s:17:"Learning Progress";s:16:"learning_resourc";s:17:"Learning Resource";s:17:"learning_resource";s:17:"Learning Resource";s:18:"learning_resources";s:18:"Learning Resources";s:18:"leave_waiting_list";s:18:"Leave Waiting List";s:6:"legend";s:6:"Legend";s:5:"level";s:5:"Level";s:7:"license";s:7:"License";s:8:"licenses";s:8:"Licenses";s:8:"link_all";s:8:"Link all";s:19:"link_check_body_top";s:114:"You receive mail from ILIAS because you want to be informed about invalid links of the following learning modules:";s:20:"link_check_message_b";s:61:"If enabled, you will be informed about invalid links by mail.";s:27:"link_check_message_disabled";s:17:"Messages disabled";s:26:"link_check_message_enabled";s:16:"Messages enabled";s:18:"link_check_subject";s:21:"[ILIAS] Weblink check";s:10:"link_check";s:13:"Weblink Check";s:22:"link_checker_refreshed";s:14:"Refreshed view";s:17:"link_dynamic_info";s:54:"You can add dynamic parameters like the ILIAS user id.";s:19:"link_selected_items";s:4:"Link";s:4:"link";s:4:"Link";s:13:"linked_object";s:26:"The object has been linked";s:12:"linked_pages";s:12:"Linked Pages";s:15:"links_add_param";s:14:"Add Parameter:";s:19:"links_dyn_parameter";s:18:"Dynamic Parameters";s:18:"links_dynamic_info";s:114:"If enabled, it is possible to append dynamic parameters to Weblinks.<br /> E.g. the ILIAS user ID or the username.";s:13:"links_dynamic";s:26:"Dynamic Weblink Parameters";s:21:"links_existing_params";s:20:"Existing Parameters:";s:10:"links_name";s:14:"Parameter Name";s:19:"links_no_name_given";s:31:"Please choose a parameter name.";s:20:"links_no_value_given";s:32:"Please choose a parameter value.";s:19:"links_not_available";s:13:"Not available";s:23:"links_parameter_deleted";s:18:"Parameter deleted.";s:16:"links_select_one";s:14:"- Select one -";s:16:"links_session_id";s:16:"ILIAS session id";s:13:"links_user_id";s:13:"ILIAS user id";s:15:"links_user_name";s:14:"ILIAS username";s:11:"links_value";s:15:"Parameter Value";s:13:"list_of_pages";s:10:"Pages List";s:17:"list_of_questions";s:13:"Question List";s:4:"list";s:4:"List";s:20:"literature_bookmarks";s:20:"Literature Bookmarks";s:10:"literature";s:10:"Literature";s:4:"lm_a";s:24:"an ILIAS Learning Module";s:6:"lm_add";s:25:"Add ILIAS Learning Module";s:8:"lm_added";s:27:"ILIAS Learning Module added";s:9:"lm_create";s:28:"Create ILIAS Learning Module";s:7:"lm_join";s:34:"Subscribe to ILIAS Learning Module";s:8:"lm_leave";s:37:"Unsubscribe from ILIASLearning Module";s:6:"lm_new";s:25:"New ILIAS Learning Module";s:12:"lm_type_aicc";s:4:"AICC";s:12:"lm_type_hacp";s:4:"HACP";s:13:"lm_type_scorm";s:9:"SCORM 1.2";s:17:"lm_type_scorm2004";s:26:"SCORM 2004 3rd/4th Edition";s:2:"lm";s:21:"Learning Module ILIAS";s:3:"lng";s:8:"Language";s:4:"lngf";s:9:"Languages";s:12:"lo_available";s:37:"Overview Learning Modules and Courses";s:13:"lo_categories";s:13:"LO Categories";s:7:"lo_edit";s:20:"Edit Learning Object";s:6:"lo_new";s:19:"New Learning Object";s:13:"lo_no_content";s:31:"No Learning Resources Available";s:14:"lo_other_langs";s:22:"LOs in Other Languages";s:11:"lo_overview";s:11:"LO Overview";s:2:"lo";s:15:"Learning Object";s:19:"local_language_file";s:19:"local language file";s:20:"local_language_files";s:20:"local language files";s:33:"local_languages_already_installed";s:53:"Selected local language file(s) are already installed";s:5:"local";s:5:"Local";s:8:"location";s:8:"Location";s:7:"locator";s:9:"Location:";s:9:"lock_file";s:9:"Lock file";s:6:"log_in";s:5:"Login";s:9:"logic_and";s:3:"and";s:8:"logic_or";s:2:"or";s:8:"login_as";s:12:"Logged in as";s:10:"login_data";s:10:"Login data";s:12:"login_exists";s:72:"There is already a user with this login name! Please choose another one.";s:22:"login_information_desc";s:61:"Please enter a login information for the respective language.";s:32:"login_information_settings_saved";s:45:"The login information were saved successfully";s:17:"login_information";s:17:"Login Information";s:13:"login_invalid";s:117:"The chosen login is invalid! Only the following characters are allowed (minimum 3 characters): A-Z a-z 0-9 _.-+*@!$%~";s:10:"login_time";s:11:"Time online";s:22:"login_to_ilias_via_cas";s:49:"Login to ILIAS via Central Authentication Service";s:25:"login_to_ilias_via_openid";s:25:"Login to ILIAS via OpenID";s:29:"login_to_ilias_via_shibboleth";s:18:"Login to ILIAS via";s:14:"login_to_ilias";s:14:"Login to ILIAS";s:5:"login";s:5:"Login";s:24:"loginname_already_exists";s:31:"This login name already exists.";s:18:"loginname_settings";s:19:"Login Name Settings";s:11:"logout_text";s:56:"You logged off from ILIAS. Your session has been closed.";s:6:"logout";s:6:"Logout";s:4:"logs";s:8:"Log Data";s:16:"los_last_visited";s:29:"Last Visited Learning Objects";s:3:"los";s:16:"Learning Objects";s:4:"lres";s:18:"Learning Resources";s:11:"mail_a_root";s:7:"Mailbox";s:16:"mail_addressbook";s:8:"Contacts";s:15:"mail_allow_smtp";s:10:"Allow SMTP";s:15:"mail_attachment";s:15:"Mail attachment";s:16:"mail_attachments";s:16:"Mail attachments";s:12:"mail_b_inbox";s:5:"Inbox";s:12:"mail_c_trash";s:5:"Trash";s:13:"mail_d_drafts";s:6:"Drafts";s:22:"mail_delete_error_file";s:19:"Error deleting file";s:17:"mail_delete_error";s:20:"Error while deleting";s:11:"mail_e_sent";s:4:"Sent";s:20:"mail_edit_permission";s:58:"User can change permission settings in Mail administration";s:13:"mail_feedback";s:13:"Mail Feedback";s:12:"mail_folders";s:12:"Mail Folders";s:16:"mail_import_file";s:11:"Export file";s:11:"mail_import";s:6:"Import";s:18:"mail_intern_enable";s:6:"Enable";s:13:"mail_mails_of";s:4:"Mail";s:19:"mail_maxsize_attach";s:20:"Max. attachment size";s:16:"mail_maxsize_box";s:17:"Max. mailbox size";s:17:"mail_maxsize_mail";s:14:"Max. mail size";s:19:"mail_maxtime_attach";s:29:"Max. days to keep attachments";s:17:"mail_maxtime_mail";s:22:"Max. days to keep mail";s:12:"mail_members";s:15:"Mail to Members";s:30:"mail_multiple_recipients_found";s:97:"Enter a more specific mail address. ILIAS found multiple possible recipients for this address: %s";s:23:"mail_no_recipient_found";s:87:"Enter a different mail address. ILIAS couldn\'t find a recipient with this mail address.";s:13:"mail_not_sent";s:14:"Mail not sent!";s:29:"mail_search_courses_not_found";s:55:"No courses were found you are belonging to as a member.";s:28:"mail_search_groups_not_found";s:54:"No groups were found you are belonging to as a member.";s:14:"mail_search_no";s:17:"No entries found.";s:16:"mail_search_word";s:11:"Search word";s:15:"mail_select_one";s:24:"You must select one mail";s:15:"mail_send_error";s:18:"Error sending mail";s:9:"mail_sent";s:10:"Mail sent!";s:13:"mail_settings";s:13:"Mail Settings";s:11:"mail_system";s:14:"System Message";s:23:"mail_use_pear_mail_info";s:144:"Use Pear Mail to parse mailbox addresses. The built in parser in ILIAS is limited. Pear Mail fully supports internet compliant e-mail addresses.";s:18:"mail_use_pear_mail";s:13:"Use Pear Mail";s:12:"mail_z_local";s:12:"User Folders";s:4:"mail";s:4:"Mail";s:8:"mails_pl";s:7:"Mail(s)";s:5:"mails";s:5:"Mails";s:15:"main_menu_frame";s:14:"Top Level Menu";s:9:"main_menu";s:9:"Main Menu";s:20:"manage_tracking_data";s:20:"Manage Tracking Data";s:13:"mark_all_read";s:16:"Mark All as Read";s:15:"mark_all_unread";s:18:"Mark All as Unread";s:14:"marked_entries";s:14:"Marked Entries";s:13:"matriculation";s:20:"Matriculation number";s:14:"max_number_rec";s:25:"Maximum number of records";s:8:"max_time";s:12:"Maximum time";s:8:"mcst_add";s:13:"Add Mediacast";s:8:"mcst_new";s:13:"New Mediacast";s:4:"mcst";s:9:"Mediacast";s:13:"mem_add_to_wl";s:19:"Add to Waiting List";s:19:"mem_alert_no_places";s:35:"There are no free places available.";s:7:"mem_end";s:17:"Registration End:";s:15:"mem_free_places";s:11:"Free Places";s:13:"mem_max_users";s:17:"Maximum of Users:";s:16:"mem_participants";s:12:"Participants";s:15:"mem_reg_expired";s:33:"The registration time is expired.";s:19:"mem_reg_not_started";s:32:"The registration has not started";s:14:"mem_reg_period";s:19:"Registration Period";s:12:"mem_reg_type";s:17:"Registration Type";s:9:"mem_start";s:19:"Registration Start:";s:13:"mem_unlimited";s:9:"Unlimited";s:17:"mem_view_activate";s:16:"Show Member View";s:14:"mem_view_close";s:17:"Close Member View";s:19:"mem_view_deactivate";s:22:"Deactivate Member View";s:13:"mem_view_long";s:11:"Member View";s:25:"mem_waiting_list_position";s:34:"Your Position on the Waiting List:";s:16:"mem_waiting_list";s:22:"Users on Waiting List:";s:13:"member_status";s:13:"Member Status";s:6:"member";s:6:"Member";s:7:"members";s:7:"Members";s:19:"membership_annulled";s:34:"Your membership has been cancelled";s:16:"membership_leave";s:5:"Leave";s:7:"mep_add";s:14:"Add Media Pool";s:9:"mep_added";s:16:"Added Media Pool";s:8:"mep_edit";s:26:"Edit Media Pool Properties";s:7:"mep_new";s:14:"New Media Pool";s:28:"mep_not_insert_already_exist";s:86:"The following items have not been inserted because they are already in the media pool:";s:3:"mep";s:10:"Media Pool";s:15:"message_content";s:15:"Message Content";s:26:"message_no_delivered_files";s:33:"You have not submitted any files.";s:10:"message_to";s:11:"Message to:";s:7:"message";s:7:"Message";s:9:"meta_data";s:8:"Metadata";s:43:"mgs_objects_linked_to_the_following_folders";s:60:"The object(s) was/were linked to the following folder(s): %s";s:7:"migrate";s:7:"Migrate";s:8:"min_time";s:12:"Minimum time";s:6:"minute";s:6:"Minute";s:7:"minutes";s:7:"Minutes";s:12:"missing_perm";s:18:"Missing Permission";s:20:"missing_precondition";s:20:"Missing Precondition";s:7:"missing";s:7:"Missing";s:3:"mob";s:12:"Media Object";s:20:"mod_rewrite_disabled";s:53:"The Apache-Module ‘mod_rewrite’ is not available.";s:10:"moderators";s:10:"Moderators";s:6:"module";s:6:"module";s:7:"modules";s:7:"Modules";s:13:"month_01_long";s:7:"January";s:14:"month_01_short";s:3:"Jan";s:13:"month_02_long";s:8:"February";s:14:"month_02_short";s:3:"Feb";s:13:"month_03_long";s:5:"March";s:14:"month_03_short";s:3:"Mar";s:13:"month_04_long";s:5:"April";s:14:"month_04_short";s:3:"Apr";s:13:"month_05_long";s:3:"May";s:14:"month_05_short";s:3:"May";s:13:"month_06_long";s:4:"June";s:14:"month_06_short";s:3:"Jun";s:13:"month_07_long";s:4:"July";s:14:"month_07_short";s:3:"Jul";s:13:"month_08_long";s:6:"August";s:14:"month_08_short";s:3:"Aug";s:13:"month_09_long";s:9:"September";s:14:"month_09_short";s:3:"Sep";s:13:"month_10_long";s:7:"October";s:14:"month_10_short";s:3:"Oct";s:13:"month_11_long";s:8:"November";s:14:"month_11_short";s:3:"Nov";s:13:"month_12_long";s:8:"December";s:14:"month_12_short";s:3:"Dec";s:5:"month";s:5:"Month";s:7:"monthly";s:7:"monthly";s:6:"months";s:6:"Months";s:15:"mount_webfolder";s:17:"Open as webfolder";s:11:"move_blocks";s:11:"Move Blocks";s:9:"move_down";s:9:"Move Down";s:9:"move_left";s:9:"Move Left";s:10:"move_right";s:10:"Move Right";s:19:"move_selected_items";s:4:"Move";s:7:"move_to";s:7:"Move to";s:7:"move_up";s:7:"Move Up";s:19:"move_users_to_style";s:19:"Move Users to Style";s:4:"move";s:4:"Move";s:11:"moveChapter";s:4:"Move";s:8:"movePage";s:4:"Move";s:10:"msg_cancel";s:16:"Action cancelled";s:14:"msg_changes_ok";s:19:"The changes were OK";s:19:"msg_clear_clipboard";s:17:"Clipboard cleared";s:10:"msg_cloned";s:25:"Selected object(s) copied";s:25:"msg_copy_clipboard_source";s:106:"Now, please select the desired course, whose content should be copied and click the button ‘Continue’.";s:18:"msg_copy_clipboard";s:123:"Now, please select the desired location, where the selected objects should be pasted into and click the button ‘Paste’.";s:28:"msg_copy_clipboard_container";s:126:"Now, please select the desired location, where the selected objects should be pasted into and click the button ‘Continue’.";s:17:"msg_cut_clipboard";s:123:"Now, please select the desired location, where the selected objects should be pasted into and click the button ‘Paste’.";s:14:"msg_cut_copied";s:25:"Selected object(s) moved.";s:24:"msg_deleted_export_files";s:22:"Export file(s) deleted";s:16:"msg_deleted_role";s:12:"Role deleted";s:23:"msg_deleted_roles_rolts";s:32:"Roles and Role Templates deleted";s:17:"msg_deleted_roles";s:13:"Roles deleted";s:16:"msg_deleted_rolt";s:21:"Role Template deleted";s:17:"msg_deleted_rolts";s:21:"Role Template deleted";s:14:"msg_error_copy";s:10:"Copy Error";s:10:"msg_failed";s:20:"Sorry, action failed";s:19:"msg_form_save_error";s:87:"The form data could not be saved. Please check the input fields for any error messages.";s:31:"msg_input_does_not_match_regexp";s:29:"Please provide a valid value.";s:28:"msg_input_either_file_or_url";s:43:"You have to provide either a URL or a file.";s:21:"msg_input_is_required";s:45:"This input is required. Please enter a value.";s:20:"msg_invalid_filetype";s:17:"Invalid file type";s:16:"msg_is_last_role";s:57:"You removed the last global role from the following users";s:30:"msg_last_role_for_registration";s:122:"At least one role must be available in the registration form for new users. This role is currently the only one available.";s:18:"msg_link_clipboard";s:115:"Now, please select the desired location, where the selected objects should be linked to and click the button Paste.";s:10:"msg_linked";s:26:"Selected object(s) linked.";s:19:"msg_may_not_contain";s:44:"This object may not contain objects of type:";s:23:"msg_min_one_active_role";s:52:"Each user must have at least one active global role!";s:16:"msg_min_one_role";s:45:"Each user must have at least one global role!";s:27:"msg_multi_language_selected";s:58:"You selected the same language for different translations!";s:23:"msg_no_default_language";s:86:"No default language specified! You must define one translation as default translation.";s:22:"msg_no_delete_yourself";s:40:"You cannot delete your own user account.";s:11:"msg_no_file";s:58:"You didn\'t choose a file or the selected file was too big.";s:24:"msg_no_language_selected";s:82:"No translation language specified! You must define a language for each translation";s:31:"msg_no_perm_assign_role_to_user";s:55:"You have no permission to change user\'s role assignment";s:31:"msg_no_perm_assign_user_to_role";s:52:"You have no permission to change the user assignment";s:16:"msg_no_perm_copy";s:67:"You have no permission to create a copy of the following object(s):";s:26:"msg_no_perm_create_object1";s:32:"You have no permission to create";s:26:"msg_no_perm_create_object2";s:17:"at this location!";s:23:"msg_no_perm_create_role";s:35:"You have no permission to add roles";s:23:"msg_no_perm_create_rolf";s:120:"You have no permission to create a Role Folder. Therefore you may not stop inheritance of roles or add local roles here.";s:23:"msg_no_perm_create_rolt";s:44:"You have no permission to add role templates";s:23:"msg_no_perm_create_user";s:35:"You have no permission to add users";s:18:"msg_no_perm_create";s:57:"You have no permission to create the following object(s):";s:15:"msg_no_perm_cut";s:54:"You have no permission to cut the following object(s):";s:24:"msg_no_perm_delete_track";s:47:"You have no permission to delete tracking data.";s:18:"msg_no_perm_delete";s:57:"You have no permission to delete the following object(s):";s:16:"msg_no_perm_link";s:69:"You have no permission to create a link from the following object(s):";s:23:"msg_no_perm_modify_role";s:38:"You have no permission to modify roles";s:23:"msg_no_perm_modify_rolt";s:47:"You have no permission to modify role templates";s:23:"msg_no_perm_modify_user";s:42:"You have no permission to modify user data";s:34:"msg_no_perm_paste_object_in_folder";s:63:"You have no permission to paste the object %s in the folder %s.";s:17:"msg_no_perm_paste";s:56:"You have no permission to paste the following object(s):";s:16:"msg_no_perm_perm";s:50:"You have no permission to edit permission settings";s:21:"msg_no_perm_read_item";s:45:"You have no permission to access item \'%s’.";s:19:"msg_no_perm_read_lm";s:52:"You have no permission to read this learning module.";s:22:"msg_no_perm_read_track";s:51:"You have no permission to access the user tracking.";s:16:"msg_no_perm_read";s:43:"You have no permission to access this item.";s:20:"msg_no_perm_undelete";s:58:"You have no permission to restore the following object(s):";s:17:"msg_no_perm_write";s:31:"You have no permission to write";s:20:"msg_no_rolf_allowed1";s:10:"The object";s:20:"msg_no_rolf_allowed2";s:39:"is not allowed to contain a Role Folder";s:15:"msg_no_scan_log";s:28:"Scan log not implemented yet";s:20:"msg_no_search_result";s:16:"No entries found";s:20:"msg_no_search_string";s:23:"Please enter your query";s:38:"msg_no_sysadmin_sysrole_not_assignable";s:77:"Only a System Administrator may assign users to the System Administrator Role";s:12:"msg_no_title";s:21:"Please enter a title.";s:22:"msg_no_type_accessible";s:73:"Sorry. You do not have the permissions to access any [type] of this list.";s:21:"msg_no_type_available";s:50:"Sorry. There is no [type] available at the moment.";s:10:"msg_no_url";s:24:"You didn’t enter a URL";s:26:"msg_not_available_for_anon";s:64:"The page you have chosen is only accessible for registered users";s:17:"msg_not_in_itself";s:49:"It’s not possible to paste the object in itself";s:17:"msg_nothing_found";s:17:"msg_nothing_found";s:15:"msg_obj_created";s:15:"Object created.";s:24:"msg_obj_exists_in_folder";s:46:"The object %s already exists in the folder %s.";s:14:"msg_obj_exists";s:41:"This object already exists in this folder";s:39:"msg_obj_may_not_contain_objects_of_type";s:50:"The object %s may not contain objects of type: %s.";s:16:"msg_obj_modified";s:20:"Modifications saved.";s:15:"msg_obj_no_link";s:250:"It is not possible to link container objects like categories, courses, groups or folder due to technical reasons. Instead you may link several single objects within such a container to other areas or use a reference object for categories and courses.";s:26:"msg_obj_not_deletable_sold";s:71:"Payment is activated for the following objects. They can no be deleted.";s:30:"msg_paste_object_not_in_itself";s:53:"It’s not possible to paste the object %s in itself.";s:28:"msg_perm_adopted_from_itself";s:80:"You cannot adopt permission settings from the current role/role template itself.";s:22:"msg_perm_adopted_from1";s:32:"Permission settings adopted from";s:22:"msg_perm_adopted_from2";s:27:"(Settings have been saved!)";s:11:"msg_removed";s:30:"Object(s) removed from system.";s:16:"msg_role_exists1";s:34:"A role/role template with the name";s:16:"msg_role_exists2";s:42:"already exists! Please choose another name";s:24:"msg_role_reserved_prefix";s:94:"The prefix ‘il_’ is reserved for automatically generated roles. Please choose another name";s:41:"msg_roleassignment_active_changed_comment";s:134:"This setting is not saved to the user’s profile! If the user logs in again, all active role assignments reset to their saved values.";s:33:"msg_roleassignment_active_changed";s:30:"Active role assignment changed";s:26:"msg_roleassignment_changed";s:23:"Role assignment changed";s:25:"msg_sysrole_not_deletable";s:33:"The system role cannot be deleted";s:24:"msg_sysrole_not_editable";s:151:"The permission settings of the system role may not be changed. The system role grants all assigned users unlimited access to all objects and functions.";s:15:"msg_trash_empty";s:28:"There are no deleted objects";s:13:"msg_undeleted";s:19:"Object(s) restored.";s:20:"msg_unit_is_required";s:57:"This input requires a unit. Please enter a correct value.";s:19:"msg_user_last_role1";s:51:"The following users are assigned to this role only:";s:19:"msg_user_last_role2";s:84:"Please delete the users or assign them to another role in order to delete this role.";s:26:"msg_userassignment_changed";s:23:"User assignment changed";s:18:"msg_wrong_filetype";s:22:"File is no zip-archive";s:16:"msg_wrong_format";s:44:"The value you entered is not a valid format.";s:10:"multimedia";s:10:"Multimedia";s:6:"my_bms";s:9:"Bookmarks";s:10:"my_courses";s:10:"My Courses";s:7:"my_frms";s:9:"My Forums";s:7:"my_grps";s:9:"My Groups";s:6:"my_los";s:19:"My Learning Objects";s:7:"my_tsts";s:8:"My Tests";s:4:"name";s:4:"Name";s:5:"never";s:5:"never";s:15:"new_appointment";s:15:"New Appointment";s:10:"new_folder";s:10:"New Folder";s:9:"new_group";s:9:"New Group";s:12:"new_language";s:12:"New Language";s:17:"new_list_password";s:15:"New suggestions";s:13:"new_lowercase";s:3:"new";s:8:"new_mail";s:9:"New mail!";s:24:"new_pass_equals_old_pass";s:36:"The new password equals the old one.";s:3:"new";s:3:"New";s:7:"newline";s:7:"Newline";s:4:"news";s:4:"News";s:4:"next";s:4:"Next";s:8:"nickname";s:8:"Nickname";s:21:"no_access_item_public";s:81:"To access this item you need to be logged in and to have appropriate permissions.";s:14:"no_access_item";s:43:"You have no permission to access this item.";s:21:"no_access_link_object";s:39:"You are not allowed to link this object";s:24:"no_agreement_description";s:134:"There is currently no user agreement text provided with this installation. Please contact the <a href="%1$s">system administrator</a>.";s:22:"no_bm_in_personal_list";s:21:"No bookmarks defined.";s:24:"no_chat_in_personal_list";s:25:"No chats in personal list";s:11:"no_checkbox";s:32:"Please select at least one item.";s:21:"no_condition_selected";s:31:"Please select one precondition.";s:19:"no_conditions_found";s:25:"No preconditions created.";s:11:"no_datasets";s:18:"The table is empty";s:7:"no_date";s:7:"No date";s:14:"no_description";s:14:"No description";s:23:"no_frm_in_personal_list";s:27:"No forums in personal list.";s:19:"no_global_role_left";s:42:"Every user has to be assigned to one role.";s:23:"no_grp_in_personal_list";s:27:"No groups in personal list.";s:19:"no_import_available";s:29:"Import not available for type";s:20:"no_import_file_found";s:20:"No import file found";s:16:"no_invalid_links";s:23:"No invalid links found.";s:8:"no_items";s:8:"No Items";s:20:"no_license_available";s:21:"No license available!";s:8:"no_limit";s:8:"No limit";s:22:"no_lo_in_personal_list";s:37:"No learning objects in personal list.";s:14:"no_local_users";s:23:"There are no local user";s:21:"no_mkisofs_configured";s:70:"You have to configure mkisofs utility in ILIAS setup to run ISO export";s:10:"no_objects";s:10:"No objects";s:8:"no_owner";s:8:"No Owner";s:16:"no_parent_access";s:37:"No access to a superordinated object!";s:21:"no_permission_to_join";s:39:"You are not allowed to join this group!";s:13:"no_permission";s:41:"You do not have the necessary permission.";s:32:"no_roles_user_can_be_assigned_to";s:98:"There are no global roles the user can be assigned to. Therefore you are not allowed to add users.";s:13:"no_start_file";s:14:"No Start File.";s:18:"no_submission_made";s:3:"---";s:8:"no_title";s:8:"No Title";s:23:"no_tst_in_personal_list";s:26:"No tests in personal list.";s:30:"no_user_defined_fields_defined";s:27:"No custom fields available.";s:16:"no_users_applied";s:21:"Please select a user.";s:17:"no_users_selected";s:23:"Please select one user.";s:24:"no_xml_file_found_in_zip";s:35:"XML file within zip file not found:";s:11:"no_zip_file";s:18:"No zip file found.";s:2:"no";s:2:"No";s:29:"non_internal_local_roles_only";s:31:"Local roles (only user defined)";s:4:"none";s:4:"None";s:6:"normal";s:6:"Normal";s:16:"not_accessed_yet";s:16:"Not accessed yet";s:12:"not_accessed";s:12:"Not accessed";s:13:"not_available";s:13:"Not Available";s:25:"not_enabled_or_configured";s:25:"Not configured or enabled";s:19:"not_implemented_yet";s:19:"Not implemented yet";s:13:"not_installed";s:13:"Not Installed";s:13:"not_logged_in";s:21:"You are not logged in";s:18:"note_all_pub_notes";s:9:"All notes";s:17:"note_my_pub_notes";s:13:"My notes only";s:4:"note";s:4:"Note";s:18:"notes_and_comments";s:18:"Notes and Comments";s:5:"notes";s:5:"Notes";s:13:"notifications";s:13:"Notifications";s:9:"num_users";s:15:"Number of Users";s:18:"number_of_accesses";s:18:"Number of accesses";s:17:"number_of_records";s:17:"Number of records";s:13:"obj_accs_desc";s:36:"Settings for accessibility features.";s:8:"obj_accs";s:13:"Accessibility";s:12:"obj_adm_desc";s:90:"Main system settings folder containing all panels to administrate your ILIAS installation.";s:7:"obj_adm";s:14:"Administration";s:13:"obj_adve_desc";s:58:"Administration settings for ILIAS page editor and TinyMCE.";s:8:"obj_adve";s:7:"Editing";s:7:"obj_alm";s:20:"Learning Module AICC";s:13:"obj_assf_desc";s:50:"Platform settings for the Test and Assessment tool";s:8:"obj_assf";s:19:"Test and Assessment";s:13:"obj_auth_desc";s:97:"Configure your authentication mode (local, LDAP, ...) and new account registration settings here.";s:8:"obj_auth";s:31:"Authentication and Registration";s:12:"obj_calendar";s:8:"Calendar";s:13:"obj_cals_desc";s:26:"General Calendar settings.";s:8:"obj_cals";s:8:"Calendar";s:17:"obj_cat_duplicate";s:13:"Copy Category";s:14:"obj_cat_select";s:32:"-- Please select one Category --";s:7:"obj_cat";s:8:"Category";s:8:"obj_catr";s:18:"Category Reference";s:7:"obj_cen";s:12:"Centra Event";s:13:"obj_cert_desc";s:25:"Settings for certificates";s:8:"obj_cert";s:12:"Certificates";s:13:"obj_chac_desc";s:54:"Configure your chat server here. Enable/disable chats.";s:8:"obj_chac";s:11:"Chat Server";s:8:"obj_chap";s:7:"Chapter";s:8:"obj_chat";s:4:"Chat";s:13:"obj_cmps_desc";s:39:"General settings for Repository Plugins";s:8:"obj_cmps";s:7:"Plugins";s:17:"obj_crs_duplicate";s:11:"Copy Course";s:14:"obj_crs_select";s:30:"-- Please select one Course --";s:7:"obj_crs";s:6:"Course";s:8:"obj_crsr";s:16:"Course Reference";s:7:"obj_dbk";s:12:"Digilib Book";s:17:"obj_exc_duplicate";s:13:"Copy Exercise";s:14:"obj_exc_select";s:32:"-- Please select one Exercise --";s:7:"obj_exc";s:8:"Exercise";s:13:"obj_extt_desc";s:67:"Configure external software or services that are supported by ILIAS";s:8:"obj_extt";s:20:"Third Party Software";s:13:"obj_facs_desc";s:44:"Configure access to file and folder objects.";s:8:"obj_facs";s:17:"Files and Folders";s:8:"obj_feed";s:8:"Web Feed";s:18:"obj_file_duplicate";s:9:"Copy File";s:15:"obj_file_inline";s:20:"Learning Module File";s:15:"obj_file_select";s:28:"-- Please select one File --";s:8:"obj_file";s:4:"File";s:18:"obj_fold_duplicate";s:11:"Copy Folder";s:15:"obj_fold_select";s:30:"-- Please select one Folder --";s:8:"obj_fold";s:6:"Folder";s:17:"obj_frm_duplicate";s:10:"Copy Forum";s:14:"obj_frm_select";s:29:"-- Please select one Forum --";s:7:"obj_frm";s:5:"Forum";s:7:"obj_glo";s:8:"Glossary";s:17:"obj_grp_duplicate";s:10:"Copy Group";s:14:"obj_grp_select";s:29:"-- Please select one Group --";s:7:"obj_grp";s:5:"Group";s:8:"obj_htlm";s:20:"Learning Module HTML";s:13:"obj_ldap_desc";s:36:"Configure global LDAP Settings here.";s:8:"obj_ldap";s:13:"LDAP Settings";s:6:"obj_lm";s:21:"Learning Module ILIAS";s:7:"obj_lng";s:8:"Language";s:13:"obj_lngf_desc";s:34:"Manage your system languages here.";s:8:"obj_lngf";s:9:"Languages";s:6:"obj_lo";s:14:"LearningObject";s:13:"obj_lrss_desc";s:40:"Configure all types of learning modules.";s:8:"obj_lrss";s:18:"Learning Resources";s:13:"obj_mail_desc";s:36:"Configure global mail settings here.";s:8:"obj_mail";s:4:"Mail";s:8:"obj_mcst";s:9:"Mediacast";s:13:"obj_mcts_desc";s:31:"General settings for mediacast.";s:8:"obj_mcts";s:9:"Mediacast";s:7:"obj_mep";s:10:"Media Pool";s:7:"obj_mob";s:12:"Media Object";s:13:"obj_mobs_desc";s:43:"Settings for media objects and media pools.";s:8:"obj_mobs";s:19:"Media Objects/Pools";s:13:"obj_not_found";s:16:"Object Not Found";s:8:"obj_note";s:4:"Note";s:8:"obj_notf";s:19:"Note Administration";s:13:"obj_nwss_desc";s:50:"Settings for internal news and external web feeds.";s:8:"obj_nwss";s:18:"News and Web Feeds";s:13:"obj_objf_desc";s:69:"Manage ILIAS object types and object permissions. (only for experts!)";s:8:"obj_objf";s:18:"Object Definitions";s:9:"obj_owner";s:23:"This Object is owned by";s:8:"obj_page";s:4:"Page";s:13:"obj_pays_desc";s:35:"Configure shop settings and vendors";s:8:"obj_pays";s:4:"Shop";s:13:"obj_pdts_desc";s:30:"Configure the Personal Desktop";s:8:"obj_pdts";s:16:"Personal Desktop";s:6:"obj_pg";s:4:"Page";s:11:"obj_ps_desc";s:52:"Configure global privacy and security settings here.";s:6:"obj_ps";s:20:"Privacy and Security";s:17:"obj_qpl_duplicate";s:23:"Copy Question Pool Test";s:14:"obj_qpl_select";s:42:"-- Please select one Question Pool Test --";s:7:"obj_qpl";s:18:"Question Pool Test";s:8:"obj_rcrs";s:10:"ECS Course";s:13:"obj_recf_desc";s:44:"Contains restored Objects from System Check.";s:8:"obj_recf";s:16:"Restored Objects";s:8:"obj_role";s:4:"Role";s:13:"obj_rolf_desc";s:23:"Manage your roles here.";s:19:"obj_rolf_local_desc";s:34:"Contains local roles of object no.";s:14:"obj_rolf_local";s:11:"Local Roles";s:8:"obj_rolf";s:5:"Roles";s:8:"obj_rolt";s:13:"Role Template";s:8:"obj_root";s:17:"Repository - Home";s:8:"obj_sahs";s:26:"Learning Module SCORM/AICC";s:7:"obj_sco";s:3:"SCO";s:13:"obj_seas_desc";s:32:"Manage the search settings here.";s:8:"obj_seas";s:6:"Search";s:18:"obj_sess_duplicate";s:12:"Copy Session";s:15:"obj_sess_select";s:31:"-- Please select one Session --";s:8:"obj_sess";s:7:"Session";s:17:"obj_spl_duplicate";s:25:"Copy Question Pool Survey";s:14:"obj_spl_select";s:44:"-- Please select one Question Pool Survey --";s:7:"obj_spl";s:20:"Question Pool Survey";s:6:"obj_st";s:7:"Chapter";s:7:"obj_sty";s:5:"Style";s:13:"obj_stys_desc";s:42:"Manage system skin and style settings here";s:8:"obj_stys";s:17:"Layout and Styles";s:17:"obj_svy_duplicate";s:11:"Copy Survey";s:14:"obj_svy_select";s:30:"-- Please select one Survey --";s:7:"obj_svy";s:6:"Survey";s:13:"obj_svyf_desc";s:37:"Platform settings for the Survey Tool";s:8:"obj_svyf";s:6:"Survey";s:13:"obj_tags_desc";s:29:"Settings for tagging feature.";s:8:"obj_tags";s:7:"Tagging";s:7:"obj_tax";s:8:"Taxonomy";s:13:"obj_taxf_desc";s:21:"Folder for taxonomies";s:8:"obj_taxf";s:10:"Taxonomies";s:13:"obj_trac_desc";s:54:"Statistics and Learning Progress Settings and Overview";s:8:"obj_trac";s:32:"Statistics and Learning Progress";s:17:"obj_tst_duplicate";s:9:"Copy Test";s:14:"obj_tst_select";s:28:"-- Please select one Test --";s:7:"obj_tst";s:4:"Test";s:7:"obj_typ";s:22:"Object Type Definition";s:8:"obj_type";s:11:"Object Type";s:7:"obj_url";s:3:"URL";s:8:"obj_user";s:4:"User";s:8:"obj_uset";s:13:"User Settings";s:7:"obj_usr";s:4:"User";s:13:"obj_usrf_desc";s:26:"Manage user accounts here.";s:8:"obj_usrf";s:15:"User Management";s:18:"obj_webr_duplicate";s:17:"Copy Weblink list";s:15:"obj_webr_select";s:36:"-- Please select one Weblink list --";s:8:"obj_webr";s:7:"Weblink";s:8:"obj_wiki";s:4:"Wiki";s:3:"obj";s:6:"Object";s:12:"object_added";s:12:"Object added";s:23:"object_copy_in_progress";s:16:"Started Copying.";s:17:"object_duplicated";s:13:"Object copied";s:9:"object_id";s:9:"Object-Id";s:15:"object_imported";s:15:"Object imported";s:6:"object";s:6:"Object";s:7:"objects";s:7:"Objects";s:20:"objf_edit_permission";s:26:"Change permission settings";s:9:"objf_read";s:33:"Read access to Object definitions";s:12:"objf_visible";s:30:"Object definitions are visible";s:10:"objf_write";s:23:"Edit Object definitions";s:4:"objf";s:18:"Object definitions";s:8:"objs_alm";s:21:"AICC Learning Modules";s:8:"objs_cat";s:10:"Categories";s:9:"objs_catr";s:19:"Category References";s:9:"objs_chat";s:5:"Chats";s:12:"objs_confirm";s:14:"Confirm Action";s:8:"objs_crs";s:7:"Courses";s:9:"objs_crsr";s:17:"Course References";s:8:"objs_dbk";s:13:"Digilib Books";s:11:"objs_delete";s:14:"Delete objects";s:8:"objs_exc";s:9:"Exercises";s:9:"objs_feed";s:9:"Web Feeds";s:9:"objs_file";s:5:"Files";s:9:"objs_fold";s:7:"Folders";s:8:"objs_frm";s:6:"Forums";s:8:"objs_glo";s:10:"Glossaries";s:8:"objs_grp";s:6:"Groups";s:9:"objs_htlm";s:21:"HTML Learning Modules";s:7:"objs_lm";s:22:"ILIAS Learning Modules";s:8:"objs_lng";s:9:"Languages";s:7:"objs_lo";s:16:"Learning Objects";s:9:"objs_lres";s:18:"Learning Resources";s:9:"objs_mail";s:4:"Mail";s:9:"objs_mcst";s:10:"Mediacasts";s:8:"objs_mep";s:11:"Media Pools";s:8:"objs_mob";s:13:"Media Objects";s:9:"objs_note";s:5:"Notes";s:7:"objs_pg";s:5:"Pages";s:8:"objs_qpl";s:19:"Question Pools Test";s:8:"objs_qst";s:9:"Questions";s:9:"objs_rcrs";s:11:"ECS Courses";s:9:"objs_role";s:5:"Roles";s:9:"objs_rolt";s:14:"Role Templates";s:9:"objs_sahs";s:27:"SCORM/AICC Learning Modules";s:9:"objs_sess";s:8:"Sessions";s:8:"objs_spl";s:21:"Question Pools Survey";s:7:"objs_st";s:8:"Chapters";s:8:"objs_svy";s:7:"Surveys";s:8:"objs_tst";s:5:"Tests";s:9:"objs_type";s:12:"Object Types";s:8:"objs_url";s:4:"URLs";s:8:"objs_usr";s:5:"Users";s:9:"objs_webr";s:8:"Weblinks";s:9:"objs_wiki";s:5:"Wikis";s:2:"of";s:2:"Of";s:15:"offline_version";s:15:"Offline Version";s:7:"offline";s:7:"Offline";s:2:"ok";s:2:"OK";s:3:"old";s:3:"Old";s:8:"omit_all";s:8:"Omit all";s:4:"omit";s:4:"Omit";s:15:"on_waiting_list";s:27:"You are on the waiting list";s:14:"online_chapter";s:14:"Online Chapter";s:11:"online_time";s:25:"Time online (DD:HH:MM:SS)";s:14:"online_version";s:14:"Online Version";s:6:"online";s:6:"Online";s:26:"open_views_inside_frameset";s:23:"Open views inside frame";s:9:"operation";s:9:"Operation";s:8:"optimize";s:8:"Optimize";s:6:"option";s:6:"Option";s:16:"optional_filters";s:16:"Optional Filters";s:22:"options_for_subobjects";s:23:"Options for sub-objects";s:7:"options";s:7:"Options";s:16:"order_by_answers";s:16:"Order by Answers";s:13:"order_by_date";s:13:"Order by Date";s:8:"order_by";s:8:"Order by";s:12:"organization";s:8:"Provider";s:5:"other";s:5:"Other";s:8:"overview";s:8:"Overview";s:9:"overwrite";s:9:"Overwrite";s:13:"owner_updated";s:14:"Owner updated.";s:5:"owner";s:5:"Owner";s:9:"page_edit";s:9:"Edit Page";s:11:"page_layout";s:11:"Page Layout";s:12:"page_layouts";s:12:"Page Layouts";s:4:"page";s:4:"Page";s:5:"pages";s:5:"Pages";s:9:"parameter";s:9:"Parameter";s:5:"parse";s:5:"Parse";s:6:"passed";s:6:"Passed";s:22:"passwd_generation_info";s:95:"If enabled, a user can select a password only from a list of automatically generated passwords.";s:17:"passwd_generation";s:19:"Password Generation";s:14:"passwd_invalid";s:119:"The new password is invalid! Only the following characters are allowed (minimum 6 characters): A-Z a-z 0-9 _.-+?#*@!$%~";s:11:"passwd_list";s:17:"List of Passwords";s:16:"passwd_not_match";s:83:"Your entries for the new password don’t match! Please re-enter your new password.";s:12:"passwd_wrong";s:34:"The password you entered is wrong!";s:6:"passwd";s:8:"Password";s:28:"password_assistance_disabled";s:96:"Password assistance is only available when user authentication is done via local ILIAS database.";s:24:"password_assistance_info";s:229:"If password assistance is enabled, a link ‘Forgot Password?’ is shown on the login page of ILIAS. Users can use this link to define a new password for their user account without needing assistance from a system administrator.";s:37:"password_change_on_first_login_demand";s:83:"You have to change your initial password before you can start using ILIAS services.";s:14:"password_empty";s:37:"The password field must not be empty.";s:16:"password_expired";s:84:"Your password is expired and has to be changed as the last change was %s day(s) ago.";s:31:"password_must_chars_and_numbers";s:49:"The password must contain characters and numbers.";s:27:"password_must_special_chars";s:45:"The password must contain special characters.";s:16:"password_to_long";s:55:"The password must have at most a size of %s characters.";s:17:"password_to_short";s:56:"The password must have at least a size of %s characters.";s:8:"password";s:8:"Password";s:43:"paste_clipboard_items_into_multiple_objects";s:27:"Paste Into Multiple Objects";s:21:"paste_clipboard_items";s:5:"Paste";s:5:"paste";s:5:"Paste";s:12:"pasteChapter";s:5:"Paste";s:9:"pastePage";s:5:"Paste";s:12:"path_not_set";s:12:"Path not set";s:15:"path_to_babylon";s:15:"Path to Babylon";s:15:"path_to_convert";s:15:"Path to Convert";s:15:"path_to_htmldoc";s:15:"Path to HTMLdoc";s:12:"path_to_java";s:12:"Path to Java";s:13:"path_to_unzip";s:13:"Path to Unzip";s:11:"path_to_zip";s:11:"Path to Zip";s:4:"path";s:4:"Path";s:6:"pathes";s:5:"Paths";s:11:"pay_methods";s:11:"Pay methods";s:15:"payment_buyable";s:7:"Buyable";s:12:"payment_demo";s:4:"Demo";s:13:"payment_in_sc";s:24:"Already in shopping cart";s:20:"payment_payed_access";s:12:"Payed/Access";s:14:"payment_system";s:14:"Payment System";s:9:"pays_edit";s:18:"Edit shop settings";s:20:"pd_enable_chatviewer";s:18:"Enable Chat Viewer";s:32:"pd_enable_contacts_requires_mail";s:24:"Requires mail permission";s:18:"pd_enable_contacts";s:15:"Enable Contacts";s:18:"pd_items_news_info";s:120:"If activated, all news related to items that have been added to the personal desktop will be included in the news block.";s:13:"pd_items_news";s:30:"Include News of Personal Items";s:10:"pdf_export";s:10:"PDF Export";s:10:"per_object";s:17:"Access per object";s:16:"perm_role_info_1";s:98:"This form determines the permissions of role \'%s\' for newly created objects under the object \'%s\'.";s:16:"perm_role_info_2";s:180:"If you want to change the permissions of role \'%s\' for all already existing objects underneath \'%s\' you must check the option \'Change Existing Objects\' at the bottom of the screen.";s:21:"perm_role_info_glob_1";s:94:"This form determines the permissions of role \'%s\' for newly created objects in the repository.";s:21:"perm_role_info_glob_2";s:174:"If you want to change the permissions of role \'%s\' for all existing objects in the repository you must check the option \'Change Existing Objects\' at the bottom of the screen.";s:13:"perm_settings";s:11:"Permissions";s:20:"perm_special_options";s:15:"Special Options";s:10:"perma_link";s:14:"Permanent Link";s:33:"permission_denied_filed_locked_by";s:43:"Access denied. The file was locked by \'%s\'.";s:17:"permission_denied";s:17:"Permission Denied";s:24:"permission_settings_info";s:83:"This form determines which role is allowed to do what with the current object \'%s\'.";s:19:"permission_settings";s:26:"Object Permission Settings";s:10:"permission";s:10:"Permission";s:12:"person_title";s:5:"Title";s:13:"personal_data";s:13:"Personal Data";s:16:"personal_desktop";s:16:"Personal Desktop";s:16:"personal_picture";s:6:"Avatar";s:16:"personal_profile";s:25:"Personal Data and Profile";s:7:"persons";s:7:"Persons";s:4:"pg_a";s:6:"a page";s:6:"pg_add";s:8:"Add page";s:8:"pg_added";s:10:"Page added";s:7:"pg_edit";s:9:"Edit page";s:6:"pg_new";s:8:"New page";s:10:"phone_home";s:11:"Phone, Home";s:12:"phone_mobile";s:13:"Phone, Mobile";s:12:"phone_office";s:13:"Phone, Office";s:5:"phone";s:5:"Phone";s:6:"phrase";s:6:"Phrase";s:13:"please_choose";s:12:"-- Select --";s:19:"please_enter_target";s:21:"Please enter a target";s:18:"please_enter_title";s:20:"Please enter a title";s:40:"please_select_a_delivered_file_to_delete";s:57:"You must select at least one delivered file to delete it!";s:42:"please_select_a_delivered_file_to_download";s:59:"You must select at least one delivered file to download it!";s:13:"please_select";s:19:"-- Please Select --";s:11:"please_wait";s:14:"Please wait...";s:4:"port";s:4:"Port";s:10:"pos_bottom";s:6:"Bottom";s:8:"pos_left";s:4:"Left";s:9:"pos_right";s:5:"Right";s:7:"pos_top";s:3:"Top";s:8:"position";s:8:"Position";s:27:"precondition_not_accessible";s:79:"You do not have sufficient permission to view the precondition(s) of this item.";s:12:"precondition";s:12:"Precondition";s:13:"preconditions";s:13:"Preconditions";s:19:"predefined_template";s:24:"Predefined role template";s:11:"preferences";s:11:"Preferences";s:20:"presentation_options";s:20:"Presentation Options";s:20:"preview_learner_info";s:119:"If enabled, Course and Group administrators have the possibility to view the content form the perspective of a learner.";s:15:"preview_learner";s:11:"Member View";s:8:"previous";s:8:"Previous";s:10:"print_view";s:10:"Print View";s:5:"print";s:5:"Print";s:13:"private_notes";s:13:"Private Notes";s:3:"pro";s:3:"Pro";s:7:"proceed";s:7:"Proceed";s:15:"profile_changed";s:42:"ILIAS eLearning - Your profile has changed";s:18:"profile_incomplete";s:61:"Your profile is incomplete. Please fill in all required data.";s:10:"profile_of";s:10:"Profile of";s:7:"profile";s:7:"Profile";s:10:"properties";s:10:"Properties";s:17:"proxy_connectable";s:23:"Connection established.";s:15:"proxy_host_info";s:20:"Please enter a host.";s:10:"proxy_host";s:4:"Host";s:21:"proxy_not_connectable";s:56:"ILIAS could not build a connection to the defined proxy.";s:27:"proxy_pear_net_socket_error";s:21:"PEAR Net_Socket error";s:15:"proxy_port_info";s:50:"Please enter a port between 0 and 65535, e.g.8080.";s:18:"proxy_port_numeric";s:62:"The entered port has to be a numeric value between 0 and 65535";s:10:"proxy_port";s:4:"Port";s:17:"proxy_status_info";s:102:"To use a proxy in ILIAS (e.g. for web feeds or to check web links) please activate the checkbox above.";s:12:"proxy_status";s:5:"Proxy";s:5:"proxy";s:12:"Proxy-Server";s:16:"pub_section_info";s:230:"If enabled, parts of the system (e.g. repository, workspace, user profiles) can be made available to the internet without authentication. The permissions of the ‘Anonymous’ role will control the access to repository resources.";s:11:"pub_section";s:16:"Anonymous Access";s:12:"public_notes";s:12:"Public Notes";s:26:"public_profile_not_visible";s:25:"The profile is not public";s:14:"public_profile";s:7:"Profile";s:6:"public";s:6:"public";s:16:"publication_date";s:16:"Publication Date";s:11:"publication";s:11:"Publication";s:9:"published";s:9:"Published";s:23:"publishing_organisation";s:23:"Publishing Organization";s:7:"purpose";s:7:"Purpose";s:7:"qpl_add";s:22:"Add Question Pool Test";s:7:"qpl_new";s:22:"New Question Pool Test";s:15:"qpl_upload_file";s:11:"Upload file";s:3:"qpl";s:18:"Question Pool Test";s:9:"quarterly";s:9:"quarterly";s:10:"query_data";s:10:"Query data";s:16:"question_message";s:8:"Question";s:14:"question_pools";s:14:"Question Pools";s:8:"question";s:8:"Question";s:4:"quit";s:4:"Quit";s:5:"quote";s:5:"Quote";s:4:"read";s:4:"Read";s:25:"readcount_anonymous_users";s:33:"Number of anonymous read accesses";s:15:"readcount_users";s:37:"Number of non-anonymous read accesses";s:9:"recf_edit";s:19:"Edit RecoveryFolder";s:9:"recipient";s:9:"Recipient";s:17:"reference_deleted";s:25:"Destination not available";s:12:"reference_of";s:13:"Reference of:";s:16:"referral_comment";s:29:"How did you hear about ILIAS?";s:17:"refresh_languages";s:21:"Refresh All Languages";s:12:"refresh_list";s:12:"Refresh List";s:7:"refresh";s:7:"Refresh";s:6:"refuse";s:6:"Refuse";s:35:"reg_account_confirmation_successful";s:37:"Your user account has been activated.";s:28:"reg_mail_body_2_confirmation";s:92:"The link will only be good for %s, after that you will have to try again from the beginning.";s:28:"reg_mail_body_3_confirmation";s:171:"If this email means nothing to you, then it is possible that somebody else has entered your email address either deliberately or accidentally, so please ignore this email.";s:26:"reg_mail_body_confirmation";s:91:"to activate your account and confirm ownership of this email address, click the link below:";s:34:"reg_mail_body_forgot_password_info";s:132:"To get your password, please use the function « Forgot password? » at the login screen to request a new password for this account.";s:24:"reg_mail_body_salutation";s:5:"Hello";s:19:"reg_mail_body_text1";s:27:"Welcome to ILIAS eLearning!";s:19:"reg_mail_body_text2";s:39:"To access ILIAS use the following data:";s:19:"reg_mail_body_text3";s:29:"Further personal information:";s:29:"reg_mail_subject_confirmation";s:40:"ILIAS eLearning - Your Confirmation Link";s:16:"reg_mail_subject";s:34:"ILIAS eLearning - Your access data";s:19:"reg_passwd_via_mail";s:62:"Your password will be sent to your e-mail address given below.";s:13:"register_info";s:95:"Please fill out the form to register (Fields marked with an asterisk are required information).";s:8:"register";s:8:"Register";s:16:"registered_since";s:16:"Registered since";s:15:"registered_user";s:15:"registered User";s:16:"registered_users";s:16:"registered Users";s:21:"registration_disabled";s:46:"Only available when using local authentication";s:20:"registration_expired";s:30:"Registration period expired...";s:12:"registration";s:24:"New Account Registration";s:10:"related_to";s:10:"Related to";s:23:"remove_personal_picture";s:6:"Remove";s:18:"remove_translation";s:18:"Remove translation";s:6:"remove";s:6:"Remove";s:11:"rename_file";s:11:"Rename File";s:6:"rename";s:6:"Rename";s:18:"repeat_scan_failed";s:21:"Repeated scan failed.";s:20:"repeat_scan_succeded";s:24:"Repeated scan succeeded.";s:11:"repeat_scan";s:23:"Repeating virus scan...";s:12:"replace_file";s:12:"Replace File";s:5:"reply";s:5:"Reply";s:21:"repository_admin_desc";s:81:"Set permissions for repository items, restore or remove objects from system trash";s:16:"repository_admin";s:32:"Repository Trash and Permissions";s:16:"repository_frame";s:18:"Repository Content";s:10:"repository";s:10:"Repository";s:18:"request_membership";s:18:"Request membership";s:12:"require_city";s:12:"Require city";s:15:"require_country";s:15:"Require country";s:20:"require_default_role";s:12:"Require role";s:18:"require_department";s:18:"Require department";s:13:"require_email";s:14:"Require e-mail";s:11:"require_fax";s:11:"Require fax";s:17:"require_firstname";s:18:"Require first name";s:14:"require_gender";s:14:"Require gender";s:13:"require_hobby";s:13:"Require hobby";s:19:"require_institution";s:19:"Require institution";s:16:"require_lastname";s:17:"Require last name";s:13:"require_login";s:13:"Require login";s:17:"require_mandatory";s:9:"mandatory";s:21:"require_matriculation";s:28:"Require matriculation number";s:14:"require_passwd";s:16:"Require password";s:15:"require_passwd2";s:23:"Require retype password";s:18:"require_phone_home";s:18:"Require home phone";s:20:"require_phone_mobile";s:20:"Require mobile phone";s:20:"require_phone_office";s:20:"Require office phone";s:24:"require_referral_comment";s:24:"Require referral comment";s:14:"require_street";s:14:"Require street";s:15:"require_zipcode";s:16:"Require zip code";s:14:"required_field";s:8:"Required";s:15:"res_links_short";s:5:"Links";s:9:"res_links";s:16:"Repository Links";s:12:"reset_filter";s:12:"Reset Filter";s:5:"reset";s:5:"Reset";s:9:"resources";s:9:"Resources";s:15:"retype_password";s:15:"Retype Password";s:5:"right";s:5:"Right";s:6:"rights";s:6:"Rights";s:6:"role_a";s:6:"a Role";s:14:"role_add_local";s:14:"Add Local Role";s:13:"role_add_user";s:19:"Add User(s) to role";s:8:"role_add";s:8:"Add Role";s:10:"role_added";s:10:"Role added";s:24:"role_assigned_desk_items";s:22:"Assigned desktop items";s:26:"role_assigned_desktop_item";s:23:"Created new assignment.";s:23:"role_assignment_updated";s:33:"Role assignment has been updated.";s:15:"role_assignment";s:15:"Role Assignment";s:16:"role_count_users";s:15:"Number of users";s:26:"role_deleted_desktop_items";s:19:"Deleted assignment.";s:12:"role_deleted";s:12:"Role deleted";s:13:"role_desk_add";s:19:"Assign desktop item";s:22:"role_desk_none_created";s:39:"No desktop items assigned to this role.";s:9:"role_edit";s:9:"Edit Role";s:22:"role_header_edit_users";s:22:"Change User Assignment";s:15:"role_list_users";s:10:"List users";s:11:"role_mailto";s:26:"Mail to all assigned Users";s:15:"role_new_search";s:10:"New search";s:8:"role_new";s:8:"New Role";s:23:"role_no_groups_selected";s:21:"Please select a group";s:21:"role_no_results_found";s:16:"No results found";s:22:"role_no_roles_selected";s:20:"Please select a role";s:27:"role_no_users_no_desk_items";s:96:"It is not possible to assign personal desktop items, since you cannot assign users to this role.";s:29:"role_protect_permissions_desc";s:147:"The object permissions cannot be changed by systems operations anymore. Furthermore only administrator of higher levels may change the permissions.";s:24:"role_protect_permissions";s:19:"Protect Permissions";s:31:"role_search_enter_search_string";s:28:"Please enter a search string";s:17:"role_search_users";s:11:"User search";s:24:"role_select_desktop_item";s:60:"Please select one object that will be assigned to this role.";s:20:"role_select_one_item";s:25:"Please select one object.";s:27:"role_sure_delete_desk_items";s:58:"Are you sure you want to delete the following assignments?";s:19:"role_templates_only";s:19:"Role templates only";s:18:"role_user_deassign";s:23:"Deassign user from role";s:14:"role_user_edit";s:17:"Edit account data";s:19:"role_user_send_mail";s:19:"Send user a message";s:4:"role";s:4:"Role";s:22:"roles_of_import_global";s:27:"Global roles of import file";s:21:"roles_of_import_local";s:26:"Local roles of import file";s:5:"roles";s:5:"Roles";s:10:"rolf_added";s:17:"Role folder added";s:16:"rolf_create_role";s:15:"Create New Role";s:16:"rolf_create_rolt";s:24:"Create New Role Template";s:11:"rolf_delete";s:27:"Delete Roles/Role templates";s:20:"rolf_edit_permission";s:26:"Change permission settings";s:24:"rolf_edit_userassignment";s:31:"Change user assignment of Roles";s:9:"rolf_read";s:35:"Read access to Roles/role templates";s:12:"rolf_visible";s:32:"Roles/role templates are visible";s:10:"rolf_write";s:56:"Edit default permission settings of Roles/role templates";s:4:"rolf";s:5:"Roles";s:6:"rolt_a";s:15:"a Role Template";s:8:"rolt_add";s:17:"Add Role Template";s:10:"rolt_added";s:19:"Role template added";s:9:"rolt_edit";s:18:"Edit Role Template";s:8:"rolt_new";s:17:"New Role Template";s:4:"rolt";s:13:"Role Template";s:9:"root_edit";s:21:"Edit system root node";s:3:"row";s:3:"Row";s:4:"rows";s:4:"Rows";s:19:"rte_editor_disabled";s:25:"Rich Text Editor disabled";s:18:"rte_editor_enabled";s:24:"Rich Text Editor enabled";s:10:"sahs_added";s:32:"SCORM/AICC Learning Module added";s:11:"sahs_create";s:33:"Create SCORM/AICC Learning Module";s:26:"sahs_insert_chap_from_clip";s:29:"Paste Chapters from Clipboard";s:26:"sahs_insert_page_from_clip";s:26:"Paste Pages from Clipboard";s:25:"sahs_insert_sco_from_clip";s:25:"Paste SCOs from Clipboard";s:9:"sahs_join";s:39:"Subscribe to SCORM/AICC Learning Module";s:10:"sahs_leave";s:43:"Unsubscribe from SCORM/AICC Learning Module";s:4:"sahs";s:26:"Learning Module SCORM/AICC";s:12:"salutation_f";s:8:"Ms./Mrs.";s:12:"salutation_m";s:3:"Mr.";s:10:"salutation";s:10:"Salutation";s:13:"save_and_back";s:13:"Save And Back";s:26:"save_customer_address_info";s:56:"If enabled, the customers billing address will be stored";s:21:"save_customer_address";s:21:"Store billing address";s:12:"save_message";s:13:"Save as Draft";s:20:"save_params_for_cron";s:27:"Save Parameter for Cron Job";s:12:"save_refresh";s:16:"Save and Refresh";s:11:"save_return";s:15:"Save and Return";s:13:"save_settings";s:13:"Save Settings";s:22:"save_user_related_data";s:29:"Save user related access data";s:4:"save";s:4:"Save";s:18:"saved_successfully";s:18:"Saved Successfully";s:5:"saved";s:5:"Saved";s:9:"scorm_add";s:25:"Add SCORM Learning Module";s:29:"scorm_create_export_file_html";s:25:"Create Export File (HTML)";s:28:"scorm_create_export_file_iso";s:35:"Create Export File (ISO for CD-ROM)";s:28:"scorm_create_export_file_pdf";s:24:"Create Export File (PDF)";s:32:"scorm_create_export_file_scrom12";s:30:"Create Export File (SCORM 1.2)";s:38:"scorm_create_export_file_scrom2004_4th";s:43:"Create Export File (SCORM 2004 4th Edition)";s:34:"scorm_create_export_file_scrom2004";s:43:"Create Export File (SCORM 2004 3rd Edition)";s:9:"scorm_new";s:45:"Create SCORM Learning Module (Authoring Mode)";s:13:"search_active";s:20:"Include active users";s:13:"search_engine";s:19:"Readable .html URLs";s:10:"search_for";s:10:"Search For";s:9:"search_in";s:9:"Search in";s:15:"search_inactive";s:22:"Include inactive users";s:25:"search_minimum_characters";s:27:"The minimum word length is:";s:10:"search_new";s:10:"New Search";s:11:"search_note";s:125:"If &quot;search in&quot; is left blank, all users will be searched. This allows you to find all active or all inactive users.";s:16:"search_recipient";s:16:"Search Recipient";s:13:"search_result";s:13:"Search Result";s:14:"search_results";s:14:"Search Results";s:15:"search_to_short";s:23:"Your query is to short.";s:11:"search_user";s:11:"Search User";s:6:"search";s:6:"Search";s:18:"seas_max_hits_info";s:63:"Please enter a number for the maximum number of search results.";s:13:"seas_max_hits";s:8:"Max hits";s:13:"seas_settings";s:15:"Search settings";s:6:"second";s:6:"Second";s:7:"seconds";s:7:"Seconds";s:8:"sections";s:8:"Sections";s:10:"select_all";s:10:"Select All";s:26:"select_at_least_one_object";s:34:"Please choose at least one object.";s:11:"select_file";s:11:"Select File";s:19:"select_max_one_item";s:27:"Please select one item only";s:11:"select_mode";s:11:"Select mode";s:21:"select_object_to_copy";s:41:"Please select the object you want to copy";s:21:"select_object_to_link";s:47:"Please select the object which you want to link";s:10:"select_one";s:18:"Please select one.";s:11:"select_page";s:11:"Select Page";s:15:"select_password";s:21:"Select a new password";s:26:"select_questionpool_option";s:37:"--- Please select a question pool ---";s:19:"select_questionpool";s:21:"Insert questions into";s:6:"select";s:6:"Select";s:19:"selected_items_back";s:22:"Back to Personal Items";s:14:"selected_items";s:14:"Personal Items";s:26:"selected_languages_updated";s:56:"The selected languages have been updated (if installed):";s:8:"selected";s:8:"Selected";s:18:"send_mail_selected";s:32:"Select mail recipients from list";s:9:"send_mail";s:12:"Send Message";s:4:"send";s:4:"Send";s:6:"sender";s:6:"Sender";s:4:"sent";s:4:"Sent";s:8:"sequence";s:8:"Sequence";s:9:"sequences";s:9:"Sequences";s:11:"server_data";s:11:"Server Info";s:15:"server_software";s:15:"Server Software";s:6:"server";s:6:"Server";s:4:"sess";s:7:"Session";s:22:"session_reminder_alert";s:189:"Your session expires in %1$s at %2$s!\\n\\nChoose OK to continue your session.\\nIf you click Cancel you will not be reminded during the current browser session anymore.\\n\\nInstallation: %3$s.";s:25:"session_reminder_extended";s:32:"Your session was extended for %s";s:21:"session_reminder_info";s:85:"If enabled, you receive a reminder before the online-session of your browser expires.";s:31:"session_reminder_lead_time_info";s:241:"Please specify the lead time for the session reminder in minutes. The reminder displays a warning when only this time span is left before the session expires. Recommended value is 5 (minutes)<br / >The current length of a user session is %s.";s:26:"session_reminder_lead_time";s:8:"Leadtime";s:33:"session_reminder_session_duration";s:23:"(Session Duration: %s).";s:16:"session_reminder";s:16:"Session-Reminder";s:13:"set_edit_mode";s:13:"Set Edit Mode";s:11:"set_offline";s:11:"Set Offline";s:10:"set_online";s:10:"Set Online";s:3:"set";s:3:"Set";s:17:"setSystemLanguage";s:19:"Set System Language";s:24:"settings_for_new_members";s:24:"Settings for new Members";s:14:"settings_saved";s:14:"Saved settings";s:8:"settings";s:8:"Settings";s:15:"setUserLanguage";s:17:"Set User Language";s:11:"shib_active";s:25:"Enable Shibboleth support";s:9:"shib_city";s:18:"Attribute for city";s:14:"shib_configure";s:35:"Configure Shibboleth Authentication";s:12:"shib_country";s:21:"Attribute for country";s:22:"shib_data_conv_warning";s:59:"The data manipulation API file you specified cannot be read";s:14:"shib_data_conv";s:38:"Absolute path to data manipulation API";s:15:"shib_department";s:24:"Attribute for department";s:20:"shib_edit_permission";s:26:"Change permission settings";s:10:"shib_email";s:28:"Attribute for e-mail address";s:20:"shib_federation_name";s:34:"Name of your Shibboleth federation";s:14:"shib_firstname";s:24:"Attribute for first name";s:11:"shib_gender";s:49:"Attribute for gender (must be ‘m’ or ‘f’)";s:31:"shib_general_login_instructions";s:159:"To log in via %s, please click on the login button and choose your organization of the following page.<br>If you have questions concerning this, please ask the";s:36:"shib_general_wayf_login_instructions";s:126:"In case you are not associated with the given organizations and you need access to a course on this server, please contact the";s:13:"shib_idp_list";s:496:"Provide a list of Identity Providers to let the user choose from on the ILIAS login page.<br>On each line there must be a comma-separated tuple for <strong>providerID of IdP</strong> (see the Shibboleth metadata file) and <strong>Name of IdP</strong> as it shall be displayed in the drop-down list.<br>As an optional third parameter you can add the <strong>location of a Shibboleth session initiator</strong> that shall be used in case your ILIAS installation is part of a multi federation setup.";s:16:"shib_institution";s:25:"Attribute for institution";s:30:"shib_invalid_home_organization";s:35:"Please choose a valid organization!";s:13:"shib_language";s:22:"Attribute for language";s:13:"shib_lastname";s:22:"Attribute for lastname";s:17:"shib_login_button";s:131:"Path to the image of a Shibboleth login button that is used to redirect users to the WAYF specified in the Shibboleth configuration";s:36:"shib_login_embedded_wayf_description";s:231:"If this option is chosen, you can provide any HTML code in the login instructions text area below. This can for example be used to embed an own JavaScript WAYF/Discovery Service or create a custom-tailored design of the login area.";s:24:"shib_login_embedded_wayf";s:24:"Design custom login area";s:24:"shib_login_external_wayf";s:25:"Use external WAYF service";s:24:"shib_login_internal_wayf";s:22:"Use ILIAS WAYF service";s:15:"shib_login_type";s:22:"Organization selection";s:10:"shib_login";s:27:"Unique Shibboleth attribute";s:14:"shib_member_of";s:20:"I am a member of ...";s:15:"shib_phone_home";s:31:"Attribute for home phone number";s:17:"shib_phone_mobile";s:33:"Attribute for mobile phone number";s:17:"shib_phone_office";s:33:"Attribute for office phone number";s:9:"shib_read";s:34:"Read access to Shibboleth settings";s:29:"shib_select_home_organization";s:83:"For authentication via %s, please select your organization from the drop down list.";s:19:"shib_settings_saved";s:34:"The Shibboleth settings were saved";s:11:"shib_street";s:20:"Attribute for street";s:10:"shib_title";s:19:"Attribute for title";s:11:"shib_update";s:26:"Update this field on login";s:22:"shib_user_default_role";s:41:"Default role assigned to Shibboleth users";s:12:"shib_visible";s:31:"Shibboleth settings are visible";s:10:"shib_write";s:24:"Edit Shibboleth settings";s:12:"shib_zipcode";s:21:"Attribute for zipcode";s:4:"shib";s:10:"Shibboleth";s:12:"shop_actions";s:7:"Actions";s:4:"shop";s:4:"Shop";s:20:"short_inst_name_info";s:100:"This title will appear in the browser header title bar. If no value is entered, ‘ILIAS’ is used.";s:15:"short_inst_name";s:11:"Short Title";s:12:"show_details";s:12:"Show Details";s:11:"show_filter";s:11:"Show Filter";s:17:"show_hidden_block";s:17:"Show Hidden Block";s:9:"show_list";s:9:"Show List";s:12:"show_members";s:15:"Display Members";s:10:"show_owner";s:10:"Show Owner";s:18:"show_private_notes";s:10:"Show Notes";s:12:"show_profile";s:12:"Show profile";s:14:"show_structure";s:22:"Enable Structured-View";s:17:"show_users_online";s:17:"Show active users";s:4:"show";s:4:"Show";s:10:"side_frame";s:10:"Side Frame";s:9:"signature";s:9:"Signature";s:27:"simultaneous_login_detected";s:76:"Your access is denied because of a simultaneous login with the same account.";s:4:"size";s:4:"Size";s:10:"skin_style";s:20:"Default Skin / Style";s:4:"smtp";s:4:"SMTP";s:29:"soap_user_administration_desc";s:48:"If enabled, ILIAS can be administrated via SOAP.";s:24:"soap_user_administration";s:23:"Administration via SOAP";s:19:"soap_wsdl_path_info";s:163:"Please enter the path to the ilias wsdl file which should be used for the webservice. If you leave this field blank, the following path will be used per default:%s";s:14:"soap_wsdl_path";s:9:"WSDL Path";s:16:"socialbm_disable";s:7:"Disable";s:15:"socialbm_enable";s:6:"Enable";s:30:"socialbm_extt_social_bookmarks";s:16:"Social Bookmarks";s:25:"socialbm_link_description";s:110:"You can use the placeholders &#123;TITLE&#125 and &#123;LINK&#125 to insert the page title or url in the link.";s:26:"socialbm_sure_delete_entry";s:78:"Are you sure that you want to delete the selected Social Bookmarking services?";s:19:"sort_by_this_column";s:19:"Sort by this column";s:14:"sorting_header";s:20:"Content Item Sorting";s:19:"sorting_info_manual";s:60:"Content items can be arranged manually in a preferred order.";s:18:"sorting_info_title";s:72:"Content items are arranged automatically by title in alphabetical order.";s:21:"sorting_manual_header";s:8:"Manually";s:12:"sorting_save";s:12:"Save Sorting";s:20:"sorting_title_header";s:28:"Titles in Alphabetical Order";s:6:"spacer";s:6:"Spacer";s:7:"spl_add";s:24:"Add Question Pool Survey";s:7:"spl_new";s:24:"New Question Pool Survey";s:15:"spl_upload_file";s:11:"Upload file";s:3:"spl";s:20:"Question Pool Survey";s:3:"ssl";s:11:"SSL (HTTPS)";s:4:"st_a";s:9:"a chapter";s:6:"st_add";s:11:"Add chapter";s:8:"st_added";s:13:"Chapter added";s:7:"st_edit";s:12:"Edit chapter";s:6:"st_new";s:11:"New chapter";s:15:"standard_fields";s:15:"Standard Fields";s:13:"standard_icon";s:11:"Medium Size";s:9:"startpage";s:16:"ILIAS Login Page";s:13:"stat_selected";s:8:"Selected";s:20:"state_changed_inside";s:14:"Changed Inside";s:13:"state_changed";s:7:"Changed";s:9:"state_new";s:3:"New";s:12:"state_unread";s:6:"Unread";s:9:"statistic";s:9:"Statistic";s:10:"statistics";s:10:"Statistics";s:20:"status_no_permission";s:21:"No permission granted";s:6:"status";s:6:"Status";s:4:"step";s:4:"Step";s:16:"stop_inheritance";s:16:"Stop inheritance";s:18:"stop_moving_blocks";s:18:"Stop Moving Blocks";s:6:"street";s:6:"Street";s:9:"structure";s:9:"Structure";s:3:"sty";s:5:"Style";s:16:"style_activation";s:16:"Style Activation";s:19:"sub_request_deleted";s:26:"Deleted membership request";s:17:"sub_request_saved";s:24:"Saved membership request";s:11:"subcat_name";s:16:"Subcategory Name";s:14:"subchapter_new";s:15:"New Sub-chapter";s:14:"subject_module";s:14:"Subject Module";s:7:"subject";s:7:"Subject";s:6:"submit";s:6:"Submit";s:10:"subobjects";s:11:"Sub-objects";s:12:"subscription";s:12:"Subscription";s:7:"subtabs";s:7:"SubTabs";s:15:"success_message";s:15:"Success Message";s:7:"summary";s:7:"Summary";s:26:"sure_delete_selected_users";s:52:"Are you sure you want to delete the selected user(s)";s:15:"survey_defaults";s:28:"Default Settings for Surveys";s:32:"survey_unlimited_invitation_desc";s:126:"Allows unlimited invitation in surveys. Unlimited invitation adds the survey to the personal desktop of every registered user.";s:27:"survey_unlimited_invitation";s:20:"Unlimited Invitation";s:7:"svy_add";s:10:"Add survey";s:14:"svy_evaluation";s:10:"Statistics";s:12:"svy_finished";s:29:"You have completed the survey";s:7:"svy_new";s:10:"New survey";s:14:"svy_no_content";s:20:"No surveys available";s:16:"svy_not_finished";s:37:"The survey has not been completed yet";s:15:"svy_not_started";s:36:"You did not take part in this survey";s:15:"svy_participate";s:23:"Participate in a survey";s:7:"svy_run";s:3:"Run";s:15:"svy_upload_file";s:11:"Upload file";s:31:"svy_warning_survey_not_complete";s:24:"The survey is incomplete";s:3:"svy";s:6:"Survey";s:12:"system_check";s:12:"System Check";s:22:"system_choose_language";s:22:"System Choose Language";s:13:"system_groups";s:13:"System Groups";s:10:"system_grp";s:12:"System Group";s:18:"system_information";s:18:"System Information";s:15:"system_language";s:15:"System Language";s:14:"system_message";s:15:"System Messages";s:21:"system_style_settings";s:21:"System Style Settings";s:13:"system_styles";s:13:"System Styles";s:6:"system";s:6:"System";s:16:"systemcheck_cron";s:32:"Process System Check in Cron Job";s:20:"systemcheck_cronform";s:38:"Activation of System Check in Cron Job";s:17:"table_mail_import";s:11:"Mail import";s:4:"tabs";s:4:"Tabs";s:15:"tagging_my_tags";s:7:"My Tags";s:24:"take_over_structure_info";s:116:"If activated, directories in the zip file will be mapped to categories or, if used in groups or courses, to folders.";s:19:"take_over_structure";s:15:"Adopt Structure";s:6:"target";s:6:"Target";s:7:"tax_add";s:12:"Add Taxonomy";s:10:"tax_delete";s:17:"Delete taxonomies";s:19:"tax_edit_permission";s:26:"Change permission settings";s:8:"tax_edit";s:13:"Edit Taxonomy";s:7:"tax_new";s:12:"New Taxonomy";s:8:"tax_read";s:25:"Read access to taxonomies";s:11:"tax_visible";s:19:"Taxonomy is visible";s:9:"tax_write";s:26:"Write access to taxonomies";s:3:"tax";s:8:"Taxonomy";s:20:"taxf_edit_permission";s:26:"Change permission settings";s:9:"taxf_read";s:30:"Read access to taxonomy folder";s:12:"taxf_visible";s:26:"Taxonomy folder is visible";s:10:"taxf_write";s:31:"Write access to taxonomy folder";s:4:"term";s:4:"Term";s:11:"test_intern";s:11:"Test Intern";s:11:"test_module";s:11:"Test Module";s:4:"test";s:4:"Test";s:5:"tests";s:5:"Tests";s:7:"textbox";s:7:"Textbox";s:6:"thread";s:6:"Thread";s:9:"thumbnail";s:9:"Thumbnail";s:6:"time_d";s:3:"Day";s:6:"time_h";s:4:"Hour";s:38:"time_limit_add_time_limit_for_selected";s:52:"Please enter a time period for the selected user(s).";s:24:"time_limit_applied_users";s:13:"Applied users";s:15:"time_limit_from";s:17:"From (time limit)";s:18:"time_limit_message";s:20:"Message (time limit)";s:28:"time_limit_no_users_selected";s:21:"Please select a user.";s:20:"time_limit_not_valid";s:24:"The period is not valid.";s:28:"time_limit_not_within_owners";s:60:"Your access is limited. The period is outside of your limit.";s:16:"time_limit_owner";s:18:"Owner (time limit)";s:18:"time_limit_reached";s:32:"Your user account is not active.";s:20:"time_limit_unlimited";s:22:"Unlimited (time limit)";s:16:"time_limit_until";s:18:"Until (time limit)";s:24:"time_limit_users_updated";s:17:"User data updated";s:10:"time_limit";s:6:"Access";s:11:"time_limits";s:6:"Access";s:12:"time_segment";s:14:"Period of time";s:4:"time";s:4:"Time";s:9:"tiny_icon";s:10:"Small Size";s:10:"title_long";s:10:"Long Title";s:14:"title_required";s:22:"Please insert a title.";s:5:"title";s:5:"Title";s:14:"to_client_list";s:16:"Client Selection";s:10:"to_desktop";s:14:"Add to Desktop";s:9:"to_filter";s:6:"Filter";s:2:"to";s:2:"To";s:5:"today";s:5:"Today";s:19:"toggleGlobalDefault";s:21:"Toggle Global Default";s:17:"toggleGlobalFixed";s:19:"Toggle Global Fixed";s:8:"tomorrow";s:8:"Tomorrow";s:5:"total";s:5:"Total";s:8:"tpl_path";s:13:"Template Path";s:15:"tracked_objects";s:15:"Tracked objects";s:25:"tracking_data_del_confirm";s:81:"Do you really want to delete all tracking data of the specified month and before?";s:21:"tracking_data_deleted";s:21:"Tracking data deleted";s:13:"tracking_data";s:13:"Tracking Data";s:17:"tracking_settings";s:26:"Learning Progress Settings";s:11:"translation";s:11:"Translation";s:5:"trash";s:5:"Trash";s:15:"tree_frame_info";s:96:"Defines whether the tree frame (e.g. repository tree) should appear on the left or on the right.";s:10:"tree_frame";s:10:"Tree Frame";s:9:"tree_left";s:4:"Left";s:10:"tree_right";s:5:"Right";s:4:"tree";s:4:"Tree";s:8:"treeview";s:12:"Show Sidebar";s:7:"tst_add";s:8:"Add test";s:13:"tst_anon_eval";s:7:"Results";s:7:"tst_new";s:8:"New test";s:14:"tst_no_content";s:18:"No tests available";s:7:"tst_run";s:3:"Run";s:26:"tst_statistical_evaluation";s:10:"Statistics";s:14:"tst_statistics";s:10:"Statistics";s:15:"tst_upload_file";s:11:"Upload file";s:20:"tst_user_not_invited";s:39:"You are not supposed to take this test.";s:23:"tst_user_wrong_clientip";s:43:"You don\'t have the right ip using this test";s:29:"tst_warning_test_not_complete";s:25:"The test is not complete!";s:3:"tst";s:4:"Test";s:6:"tutors";s:6:"Tutors";s:27:"txt_add_object_instruction1";s:44:"Browse to the location where you want to add";s:27:"txt_add_object_instruction2";s:1:".";s:24:"txt_registered_passw_gen";s:109:"You successfully registered to ILIAS. You should receive an e-Mail including your generated password shortly.";s:14:"txt_registered";s:112:"You successfully registered to ILIAS. Please click on the button below to login to ILIAS with your user account.";s:13:"txt_submitted";s:228:"You successfully submitted an account request to ILIAS. Your account request will be reviewed by the system administrators, and should be activated within 48 hours. You will not be able to log in until your account is activated.";s:3:"typ";s:22:"Object Type Definition";s:22:"type_your_message_here";s:22:"Type Your Message Here";s:4:"type";s:4:"Type";s:13:"udf_add_field";s:9:"Add Field";s:15:"udf_added_field";s:16:"Added new field.";s:17:"udf_delete_header";s:12:"Delete Field";s:15:"udf_delete_sure";s:71:"Are you sure you want to delete this field and all assigned user data ?";s:21:"udf_duplicate_entries";s:29:"The values have to be unique.";s:17:"udf_field_deleted";s:14:"Deleted field.";s:23:"udf_name_already_exists";s:63:"This field name already exists. Please choose a different name.";s:14:"udf_no_entries";s:31:"Please enter minimum one value.";s:17:"udf_no_name_given";s:26:"Please enter a field name.";s:31:"udf_required_requires_visib_reg";s:84:"When field is set to ‘required’, it must be set to ‘visible in registration’";s:13:"udf_type_date";s:4:"Date";s:17:"udf_type_datetime";s:13:"Date and Time";s:15:"udf_type_select";s:26:"Selection List (Drop-Down)";s:13:"udf_type_text";s:21:"Text Field (One Line)";s:16:"udf_type_wysiwyg";s:19:"Text Area (WYSIWYG)";s:23:"udf_update_select_field";s:15:"Edit Select Box";s:18:"udf_update_success";s:20:"Saved modifications.";s:21:"udf_update_text_field";s:15:"Edit Text Field";s:24:"udf_update_wysiwyg_field";s:30:"Edit Text Area (WYSIWYG) Field";s:17:"udf_value_deleted";s:27:"The value has been deleted.";s:9:"udf_value";s:5:"Value";s:3:"uid";s:3:"UID";s:22:"ums_create_new_account";s:18:"Create New Account";s:17:"ums_explanation_2";s:65:"If this is not your account, please hit ‘Create New Account’.";s:17:"ums_explanation_3";s:198:"Your external account could not be mapped to an ILIAS account. But ILIAS has found multiple accounts with your e-mail address. If one of those is your account, please login with your ILIAS password.";s:17:"ums_explanation_4";s:69:"If none of them is your account, please hit ‘Create New Account’.";s:15:"ums_explanation";s:183:"Your external account could not be mapped to an ILIAS account. But ILIAS has found an account with your e-mail address. If this is your account, please login with your ILIAS password.";s:17:"ums_login_account";s:13:"Login Account";s:15:"unambiguousness";s:19:"Distinguishing mark";s:11:"uncheck_all";s:11:"Uncheck all";s:9:"unchecked";s:9:"Unchecked";s:9:"uninstall";s:9:"Uninstall";s:11:"uninstalled";s:12:"uninstalled.";s:7:"unknown";s:7:"UNKNOWN";s:9:"unlabeled";s:9:"Unlabeled";s:16:"unread_lowercase";s:6:"unread";s:6:"unread";s:6:"Unread";s:10:"unselected";s:10:"Unselected";s:11:"unsubscribe";s:19:"Remove from desktop";s:5:"unzip";s:5:"Unzip";s:2:"up";s:2:"Up";s:14:"update_applied";s:14:"Update Applied";s:15:"update_language";s:15:"Update Language";s:18:"update_on_conflict";s:18:"Update on conflict";s:6:"update";s:4:"Edit";s:27:"upload_error_file_not_found";s:29:"Upload error: File not found.";s:6:"upload";s:6:"Upload";s:20:"uploaded_and_checked";s:71:"The file has been uploaded and checked, you can now start to import it.";s:3:"uri";s:3:"URI";s:5:"url_a";s:5:"a URL";s:7:"url_add";s:7:"Add URL";s:9:"url_added";s:9:"URL added";s:14:"url_create_url";s:10:"Create URL";s:10:"url_delete";s:10:"Delete URL";s:15:"url_description";s:15:"URL Description";s:19:"url_edit_permission";s:26:"Change Permission settings";s:8:"url_edit";s:8:"Edit URL";s:7:"url_new";s:7:"New URL";s:13:"url_not_found";s:14:"File Not Found";s:8:"url_read";s:8:"Open URL";s:12:"url_to_latex";s:23:"URL to LaTeX CGI script";s:11:"url_visible";s:14:"URL is visible";s:9:"url_write";s:8:"Edit URL";s:3:"url";s:3:"URL";s:27:"use_customized_instructions";s:28:"Use customized instructions:";s:24:"use_default_instructions";s:25:"Use default instructions.";s:11:"user_access";s:15:"Access per user";s:14:"user_activated";s:22:"User has been approved";s:10:"user_added";s:10:"User added";s:15:"user_assignment";s:15:"User Assignment";s:22:"user_cant_receive_mail";s:42:"user is not allowed to use the mail system";s:12:"user_comment";s:12:"User comment";s:16:"user_deactivated";s:25:"User has been disapproved";s:19:"user_defined_fields";s:13:"Custom Fields";s:17:"user_defined_list";s:23:"Custom User Data Fields";s:12:"user_deleted";s:12:"User deleted";s:11:"user_detail";s:11:"Detail Data";s:21:"user_ext_account_desc";s:84:"Account used for external authentication. (CAS, SOAP, LDAP or Radius authentication)";s:16:"user_ext_account";s:16:"External Account";s:10:"user_image";s:10:"User Image";s:18:"user_import_failed";s:19:"User import failed.";s:27:"user_imported_with_warnings";s:35:"User import complete with warnings.";s:13:"user_imported";s:21:"User import complete.";s:13:"user_language";s:13:"User Language";s:26:"user_new_account_mail_desc";s:190:"This mail is sent automatically to users that have self-registered or to those who have been registered by an administrator with enabled setting ‘Send mail to inform user about changes’.";s:21:"user_new_account_mail";s:16:"New Account Mail";s:15:"user_not_chosen";s:34:"You did not choose a group-member.";s:14:"user_not_known";s:31:"Please insert a valid username.";s:31:"user_profile_instant_messengers";s:18:"Instant Messengers";s:18:"user_profile_other";s:17:"Other Information";s:26:"user_send_new_account_mail";s:23:"Send new account e-mail";s:15:"user_statistics";s:16:"Statistical Data";s:11:"user_status";s:11:"User Status";s:16:"user_toggle_noti";s:48:"Member is not allowed to deactivate notification";s:4:"user";s:4:"User";s:8:"userdata";s:9:"User Data";s:21:"userfolder_export_csv";s:22:"Comma Separated Values";s:27:"userfolder_export_excel_x86";s:15:"Microsoft Excel";s:27:"userfolder_export_file_size";s:9:"File size";s:22:"userfolder_export_file";s:4:"File";s:23:"userfolder_export_files";s:5:"Files";s:21:"userfolder_export_xml";s:3:"XML";s:8:"username";s:8:"Username";s:18:"users_not_imported";s:71:"The following users do not exist, their messages cannot become imported";s:28:"users_online_show_associated";s:42:"Show members of my courses and groups only";s:19:"users_online_show_n";s:23:"Don\'t show active users";s:34:"users_online_show_short_associated";s:29:"Only course and group members";s:25:"users_online_show_short_n";s:23:"Don\'t show active users";s:25:"users_online_show_short_y";s:21:"Show all active users";s:19:"users_online_show_y";s:21:"Show all active users";s:12:"users_online";s:12:"Active Users";s:5:"users";s:5:"Users";s:12:"usertracking";s:13:"User Tracking";s:5:"usr_a";s:6:"a User";s:15:"usr_active_only";s:17:"Active Users only";s:7:"usr_add";s:8:"Add User";s:9:"usr_added";s:10:"User added";s:19:"usr_agreement_empty";s:30:"The agreement contains no text";s:13:"usr_agreement";s:14:"User Agreement";s:8:"usr_edit";s:9:"Edit User";s:23:"usr_filter_coursemember";s:16:"Member of course";s:23:"usr_filter_empty_result";s:54:"No users found that match the selected filter criteria";s:22:"usr_filter_groupmember";s:15:"Member of group";s:20:"usr_filter_lastlogin";s:18:"Last login of user";s:15:"usr_filter_role";s:13:"Assigned role";s:17:"usr_hits_per_page";s:19:"Hits/page in tables";s:17:"usr_inactive_only";s:19:"Inactive Users only";s:23:"usr_limited_access_only";s:30:"Users with limited access only";s:7:"usr_new";s:8:"New User";s:32:"usr_settings_explanation_profile";s:424:"Check ‘Visible’ to show fields in the registration form and personal data on the personal desktop. Check ‘Changeable’ to allow the user to change the value in the personal data. Please note that visible fields can always be entered in the registration form. Required fields are required in the registration form and the personal data. All data can be changed in the user administration independent on these settings.";s:35:"usr_settings_header_profile_profile";s:24:"Personal profile setting";s:27:"usr_settings_header_profile";s:25:"Standard User Data Fields";s:18:"usr_settings_saved";s:40:"Global user settings saved successfully!";s:22:"usr_settings_visib_lua";s:36:"Visible in Local User Administration";s:27:"usr_settings_changeable_lua";s:39:"Changeable in Local User Administration";s:14:"usr_skin_style";s:12:"Skin / Style";s:9:"usr_style";s:10:"User Style";s:19:"usr_without_courses";s:30:"Users without courses assigned";s:3:"usr";s:4:"User";s:16:"usrf_create_user";s:23:"Create new user account";s:4:"usrf";s:13:"User accounts";s:23:"usrimport_action_failed";s:19:"Action %1$s failed.";s:24:"usrimport_action_ignored";s:20:"Ignored action %1$s.";s:25:"usrimport_action_replaced";s:29:"Replaced action %1$s by %2$s.";s:21:"usrimport_cant_delete";s:60:"Can\'t perform ‘Delete’ action. No such user in database.";s:21:"usrimport_cant_insert";s:63:"Can\'t perform ‘Insert’ action. User is already in database.";s:21:"usrimport_cant_update";s:60:"Can\'t perform ‘Update’ action. No such user in database.";s:32:"usrimport_conflict_handling_info";s:432:"When ‘Ignore on conflict’ is selected, ILIAS ignores an action, if it can not be performed (e. g. an ‘Insert’ action is not done, if there is already a user with the same login in the database.)\\nWhen ‘Update on conflict’ is selected, ILIAS updates the database if an action can not be performed. (e. g. an ‘Insert’ action is replaced by an ‘Update’ action, if a user with the same login exists in the database).";s:41:"usrimport_global_role_for_action_required";s:61:"At least one global role must be specified for "%1$s" action.";s:21:"usrimport_ignore_role";s:11:"Ignore role";s:29:"usrimport_login_is_not_unique";s:20:"Login is not unique.";s:38:"usrimport_no_insert_ext_account_exists";s:67:"Can\'t perform ‘Insert’ action. External account already exists.";s:38:"usrimport_no_update_ext_account_exists";s:67:"Can\'t perform ‘Update’ action. External account already exists.";s:43:"usrimport_with_specified_role_not_permitted";s:41:"Import with specified role not permitted.";s:31:"usrimport_xml_attribute_missing";s:46:"Attribute "%2$s" in element "%1$s" is missing.";s:37:"usrimport_xml_attribute_value_illegal";s:62:"Value "%3$s" of attribute "%2$s" in element "%1$s" is illegal.";s:42:"usrimport_xml_attribute_value_inapplicable";s:85:"Value "%3$s" of attribute "%2$s" in element "%1$s" is inapplicable for "%4$s" action.";s:37:"usrimport_xml_element_content_illegal";s:44:"Content "%2$s" of element "%1$s" is illegal.";s:41:"usrimport_xml_element_for_action_required";s:51:"Element "%1$s" must be specified for "%2$s" action.";s:34:"usrimport_xml_element_inapplicable";s:49:"Element "%1$s" is inapplicable for "%2$s" action.";s:36:"usrimport_xml_pw_bcrypt_missing_salt";s:37:"Missing salt, cannot import password.";s:5:"valid";s:5:"Valid";s:8:"validate";s:8:"Validate";s:5:"value";s:5:"Value";s:14:"vcard_download";s:22:"Download Visiting Card";s:5:"vcard";s:13:"Visiting Card";s:7:"vendors";s:7:"Vendors";s:19:"verification_failed";s:19:"Verification failed";s:24:"verification_failure_log";s:24:"Verification failure log";s:16:"verification_log";s:16:"Verification log";s:24:"verification_warning_log";s:24:"Verification warning log";s:7:"version";s:7:"Version";s:8:"versions";s:8:"Versions";s:12:"view_content";s:12:"View Content";s:4:"view";s:4:"View";s:14:"visible_layers";s:14:"Visible Layers";s:20:"visible_registration";s:23:"Visible in Registration";s:7:"visible";s:7:"Visible";s:7:"visitor";s:7:"Visitor";s:8:"visitors";s:8:"Visitors";s:6:"visits";s:6:"Visits";s:13:"web_resources";s:8:"Weblinks";s:28:"webdav_pear_auth_http_needed";s:127:"You need to install Pear Auth_HTTP to use this function. To do this, enter <code>pear install Auth_HTTP</code> on the terminal.";s:6:"webdav";s:6:"WebDAV";s:18:"webfolder_dir_info";s:122:"You got here, because your browser can\'t open webfolders. Read the <a href="%1$s">instructions for opening webfolders</a>.";s:18:"webfolder_index_of";s:13:"Index of %1$s";s:27:"webfolder_instructions_info";s:479:"The webfolder instructions are shown on browsers, which can not open a webfolder directly. You can use HTML code, and the following placeholders: <b>[WEBFOLDER_TITLE]</b>, <b>[WEBFOLDER_URI]</b>, <b>[WEBFOLDER_URI_IE]</b>, <b>[WEBFOLDER_URI_KONQUEROR]</b>, <b>[WEBFOLDER_URI_NAUTILUS]</b>, <b>[ADMIN_MAIL]</b>, <b>[IF_WINDOWS]</b>...<b>[/IF_WINDOWS]</b>, <b>[IF_MAC]</b>...<b>[/IF_MAC]</b>, <b>[IF_LINUX]</b>...<b>[/IF_LINUX]</b>. Clear the field to get the default instructions.";s:27:"webfolder_instructions_text";s:2920:"<p>Follow the instructions below, to open <b>[WEBFOLDER_TITLE]</b> as a webfolder:</p>[IF_WINDOWS]<h3>Instructions for Windows Vista</h3><ol><li>Press the key combination Windows+E to open Windows Explorer.</li><li>Click on ‘Add Network Place’ in the toolbar.<br/>The ‘Add a Network Place’ wizard will open.</li><li>Click at the link ‘Connect to a website’.</li><li>Select the ‘Choose Another Network Location’ option, and select ‘Next’.<li>In the ‘Internet or Network Address’ field enter<br/><b>[WEBFOLDER_URI]</b><br/>then select ‘Next’.</li><li>Enter your login and password, and select ‘OK’.<br/>Repeat this step until you get to the next dialog window.</li><li>Enter a name for the webfolder, then select ‘Next’.<li>Enter your login and password, and select ‘OK’.<br/>Repeat this step until you get to the next dialog window.</li><li>Select ‘Finish’.</li><li>You can now access the webfolder from the start menu ‘Computer’.</li></ol><h3>Instructions for Windows XP</h3><ol><li>Press the key combination Windows+E to open Windows Explorer.</li><li>Choose the menu ‘Extras &gt; Add Network Place...’.<br/>The ’Add a Network Place’ wizard will open.</li><li>Click at the link ‘Connect to a website ...’.<br/>The assistant window will open.</li><li>Select ‘Next’.</li><li>Select the ‘Choose Another Network Location’ option, and select ‘Next’.<li>In the ‘Internet or Network Address’ field enter<br/><b>[WEBFOLDER_URI]</b><br/>then select ‘Next’.</li><li>Enter your login and password, and select ‘OK’.<li>Enter a name for the webfolder, then select ‘Next’.<li>Enter your login and password, and select ‘OK’.</li><li>Select ‘Finish’.</li><li>This will open the webfolder. You can later access the webfolder from the start menu ‘Network places’ again.</li></ol>[/IF_WINDOWS][IF_MAC]<h3>Instructions for Mac OS X</h3><ol><li>Open the Finder</li><li>Choose the menu ‘Go &gt; Connect to Server...’<br/>The ’Connect to Server’ dialog will open.</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI]</b><br/>and select ’Connect’.</li><li>Enter your login and password, and select ’OK’.</li></ol>[/IF_MAC][IF_LINUX]<h3>Instructions for Linux with Konqueror</h3><ol><li>Start the Konqueror browser</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI_KONQUEROR]</b></li><li>Press the Enter key.</li><li>Enter your login and password, and select ’OK’.</li></ol><h3>Instructions for Linux with Nautilus</h3><ol><li>Start the Nautilus browser</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI_NAUTILUS]</b></li><li>Press the Enter key.</li><li>Enter your login and password, and select ’OK’.</li></ol>[/IF_LINUX]<p>If opening the webfolder does not work, please contact <a href="mailto:[ADMIN_MAIL]">[ADMIN_MAIL]</a>.</p>";s:32:"webfolder_instructions_titletext";s:22:"Open %1$s as webfolder";s:22:"webfolder_instructions";s:22:"Webfolder instructions";s:24:"webfolder_mount_dir_with";s:167:"Open this page as a Webfolder with <a href="%1$s">Internet Explorer 6</a>, <a href="%2$s">Konqueror</a>, <a href="%3$s">Nautilus</a>, <a href="%4$s">other Browser</a>.";s:9:"webfolder";s:9:"Webfolder";s:11:"webr_active";s:6:"Active";s:13:"webr_add_item";s:11:"Add Weblink";s:8:"webr_add";s:11:"Add Weblink";s:17:"webr_delete_items";s:17:"Delete Weblink(s)";s:18:"webr_deleted_items";s:19:"Deleted Weblink(s).";s:18:"webr_disable_check";s:18:"Disable Validation";s:14:"webr_edit_item";s:12:"Edit Weblink";s:9:"webr_edit";s:12:"Edit Weblink";s:16:"webr_fillout_all";s:36:"Please fill out all required fields.";s:17:"webr_item_updated";s:19:"Saved modifications";s:9:"webr_join";s:18:"Subscribe Weblinks";s:21:"webr_last_check_table";s:11:"Last check:";s:15:"webr_last_check";s:10:"Last check";s:10:"webr_leave";s:20:"Unsubscribe Weblinks";s:19:"webr_modified_items";s:20:"Saved modifications.";s:18:"webr_never_checked";s:13:"Never checked";s:8:"webr_new";s:15:"Add New Weblink";s:21:"webr_no_items_created";s:19:"No Weblinks created";s:22:"webr_sure_delete_items";s:54:"Do you really want to delete the following Weblink(s)?";s:4:"webr";s:7:"Weblink";s:11:"webservices";s:4:"SOAP";s:4:"week";s:4:"Week";s:6:"weekly";s:6:"weekly";s:5:"weeks";s:5:"Weeks";s:7:"welcome";s:7:"Welcome";s:13:"who_is_online";s:14:"Who is online?";s:14:"width_x_height";s:14:"Width x Height";s:5:"width";s:5:"Width";s:8:"wiki_add";s:8:"Add Wiki";s:8:"wiki_new";s:8:"New Wiki";s:4:"wiki";s:4:"Wiki";s:4:"with";s:4:"with";s:18:"wizard_search_list";s:67:"Your search produced the following hits. Please select one of them.";s:17:"wizard_title_info";s:59:"Please enter the title of the object you want to duplicate.";s:5:"write";s:5:"Write";s:17:"wrong_ip_detected";s:95:"Your access is denied because of a wrong client ip.<br>Please contact the system administrator.";s:4:"year";s:4:"Year";s:5:"years";s:5:"Years";s:3:"yes";s:3:"Yes";s:9:"yesterday";s:9:"Yesterday";s:23:"you_may_add_local_roles";s:23:"You May Add Local Roles";s:12:"your_message";s:12:"Your Message";s:19:"zip_structure_error";s:49:"Archive contains same file names. Upload aborted.";s:15:"zip_test_failed";s:56:"Zip-Test failed. Please contact you ILIAS administrator.";s:3:"zip";s:8:"Zip Code";s:7:"zipcode";s:8:"Zip Code";s:14:"db_need_hotfix";s:44:"Hotfix available. Please open setup program.";s:14:"session_config";s:16:"Session Settings";s:34:"session_config_maintenance_enabled";s:29:"Maintenance by client allowed";s:35:"session_config_maintenance_disabled";s:33:"Maintenance by client not allowed";s:17:"session_max_count";s:19:"Max active sessions";s:22:"session_max_count_info";s:120:"Defines the maximum number of sessions that can be created simultaneously. Setting this to ‘0’ disables the feature.";s:16:"session_min_idle";s:29:"Min session idle (in minutes)";s:21:"session_min_idle_info";s:188:"When a user idles for at least this period of time the session can be destroyed if another session should be opened for another user and the maximum number of existing sessions is reached.";s:16:"session_max_idle";s:29:"Max session idle (in minutes)";s:21:"session_max_idle_info";s:83:"Defines the maximum period of idle time a user can idle before his session expires.";s:36:"session_max_idle_after_first_request";s:49:"Max session idle after first request (in minutes)";s:41:"session_max_idle_after_first_request_info";s:203:"All sessions that idles for at least this period of time after first request will be destroyed if another session should be opened for another user and the maximum number of existing sessions is reached.";s:21:"reached_session_limit";s:61:"The limit of online users is reached. Please try again later.";s:32:"mail_to_global_roles_not_allowed";s:47:"It is not allowed to send mails to global roles";s:24:"mail_no_valid_group_role";s:19:"No valid group role";s:29:"delete_inactive_user_accounts";s:29:"Delete inactive user accounts";s:34:"delete_inactive_user_accounts_desc";s:82:"If enabled, user accounts will be deleted depending on the date of the last login.";s:36:"delete_inactive_user_accounts_period";s:28:"Days passed since last login";s:41:"delete_inactive_user_accounts_period_desc";s:82:"All user accounts without login within the defined period of time will be deleted.";s:43:"delete_inactive_user_accounts_include_roles";s:14:"Included roles";s:48:"delete_inactive_user_accounts_include_roles_desc";s:56:"Defines the roles that will participate in the deletion.";s:38:"delete_inactive_user_accounts_interval";s:9:"Frequency";s:32:"delete_inactivated_user_accounts";s:32:"Delete inactivated user accounts";s:37:"delete_inactivated_user_accounts_desc";s:80:"If enabled, user accounts will be deleted depending on the date of inactivation.";s:39:"delete_inactivated_user_accounts_period";s:30:"Days passed since inactivation";s:44:"delete_inactivated_user_accounts_period_desc";s:78:"Accounts will be deleted if this period of time has passed since inactivation.";s:46:"delete_inactivated_user_accounts_include_roles";s:14:"Included roles";s:51:"delete_inactivated_user_accounts_include_roles_desc";s:56:"Defines the roles that will participate in the deletion.";s:41:"delete_inactivated_user_accounts_interval";s:9:"Frequency";s:46:"delete_inactivated_user_accounts_interval_desc";s:55:"Deletion conditions will be reviewed in this frequency.";s:8:"obj_frma";s:5:"Forum";s:13:"obj_frma_desc";s:21:"Global Forum Settings";s:20:"show_system_messages";s:15:"System Messages";s:24:"settings_for_all_members";s:51:"Notification activated for all course/group members";s:18:"settings_per_users";s:32:"Settings per Course/Group Member";s:10:"backto_lua";s:33:"Back to Local User Administration";s:22:"sort_activation_header";s:10:"By timings";s:19:"sort_inherit_prefix";s:7:"Default";s:20:"sorting_info_inherit";s:55:"The sorting mode is adopted from a parent course/group.";s:11:"sel_country";s:7:"Country";s:8:"obj_book";s:12:"Booking Pool";s:9:"objs_book";s:13:"Booking Pools";s:17:"country_selection";s:29:"Country (Drop Down Selection)";s:17:"country_free_text";s:25:"Country (Free Text Input)";s:20:"optional_filter_hint";s:44:"Please activate one of the optional filters.";s:19:"sess_fixed_duration";s:22:"Fixed Session Duration";s:36:"sess_load_dependent_session_handling";s:31:"Load Dependent Session Handling";s:9:"sess_mode";s:12:"Session Mode";s:18:"cronjob_last_start";s:26:"Last Start of the Cron Job";s:30:"enable_disk_quota_summary_mail";s:23:"Send Disk Quota Summary";s:35:"enable_disk_quota_summary_mail_desc";s:99:"The disk quota summary is a daily notification containing all users, who exceeded their disk quota.";s:23:"disk_quota_summary_rctp";s:10:"Recipients";s:28:"disk_quota_summary_rctp_desc";s:133:"Enter the user names (comma-separated) of those users who shall receive a daily report with users currently exceeding the disk quota.";s:28:"disk_quota_exceeded_headline";s:51:"The following users have exceeded their disk quota:";s:17:"usrf_profile_link";s:20:"Link to user profile";s:25:"currently_used_disk_space";s:25:"Currently used disk space";s:26:"disk_quota_summary_subject";s:30:"Summary of Exceeded Disk Quota";s:26:"cronjob_last_start_unknown";s:13:"Indeterminate";s:30:"cron_mail_notification_message";s:41:"Send Mail Notifications with Mail-Message";s:35:"cron_mail_notification_message_info";s:89:"If enabled, all users will get notifications with complete mail message by external mail.";s:25:"follow_link_to_read_mails";s:45:"click the following link to read these mails:";s:31:"mails_at_the_ilias_installation";s:58:"You received %1$s new mails at the ILIAS-Installation %2$s";s:30:"mail_at_the_ilias_installation";s:57:"You received %1$s new mail at the ILIAS-Installation %2$s";s:22:"webdav_pwd_instruction";s:147:"We suggest to create a local password for opening the repository as webfolder.<br />This password is only required for the webfolder functionality.";s:30:"webdav_pwd_instruction_success";s:84:"A new local password has been created. You can now open the repository as webfolder.";s:22:"err_auth_apache_failed";s:107:"The authentication has failed. Maybe you have no valid user certificate or your smart card is not inserted.";s:21:"nr_following_sessions";s:27:"%1d following session(s)...";s:7:"obj_ass";s:5:"Asset";s:26:"enable_anonymous_fora_desc";s:104:"If this option is disabled, the feature ‘Posting with pseudonym’ is not available in forums anymore.";s:21:"enable_anonymous_fora";s:28:"Allow posting with pseudonym";s:18:"personal_workspace";s:12:"My Workspace";s:8:"obj_wfld";s:6:"Folder";s:8:"obj_blog";s:4:"Blog";s:29:"preconditions_obligatory_hint";s:54:"You have to fulfill all of the following preconditions";s:27:"preconditions_optional_hint";s:60:"You have to fulfill <b>%s</b> of the following preconditions";s:10:"glo_import";s:15:"Import Glossary";s:22:"title_and_translations";s:22:"Title and Translations";s:13:"rep_main_page";s:4:"Home";s:17:"personal_settings";s:8:"Settings";s:20:"payment_notification";s:22:"Send Shop Notification";s:25:"payment_notification_desc";s:73:"If enabled, users get a reminder to extend the duration of bought objects";s:37:"payment_reminder_notification_subject";s:53:"The access duration of bought objects is ending soon.";s:26:"bought_objects_expire_soon";s:153:"For some of your bought objects the access duration is ending soon. You are able to extend the access duration, by buying an extension for these objects.";s:14:"access_enddate";s:15:"Access End Date";s:22:"toggle_hidden_sections";s:21:"Show More Information";s:20:"show_hidden_sections";s:29:"Show More Information &raquo;";s:21:"hide_visible_sections";s:29:"Hide More Information &raquo;";s:18:"tst_edit_questions";s:14:"Edit Questions";s:5:"first";s:5:"First";s:6:"behind";s:6:"Behind";s:21:"object_purchased_date";s:13:"Purchase-Date";s:15:"object_duration";s:15:"Access-Duration";s:12:"new_customer";s:23:"Are you a new customer?";s:17:"new_customer_info";s:52:"Please click here if you do not have a user account.";s:33:"enable_course_group_notifications";s:37:"Daily Mail for Groups and Course News";s:38:"enable_course_group_notifications_desc";s:66:"If enabled, Participants can subscribe to a daily summary of news.";s:6:"saving";s:9:"Saving...";s:16:"object_not_found";s:16:"Object not found";s:14:"user_not_found";s:14:"User not found";s:20:"cont_iim_create_info";s:63:"Please upload the background picture for the interactive image.";s:21:"cont_iim_overlay_info";s:187:"Overlay images are used to alter (e.g. highlight) parts of the background image when the mouse hovers over them. After uploading the images, you can select them in the ‘Triggers’ tab.";s:28:"cont_iim_content_popups_info";s:195:"Content popups appear, when the user clicks on interactive parts of the background image. On this screen you only define the popups. Their content can be edited on the editing screen of the page.";s:19:"file_upload_pending";s:12:"Pending file";s:27:"invoice_number_reset_period";s:24:"Reset incremental number";s:32:"invoice_number_reset_period_desc";s:73:"Choose the period for resetting the incremental number to the start value";s:48:"payment_userdefined_invoice_number_not_activated";s:43:"Userdefined invoice numbers are not enabled";s:14:"invoice_number";s:14:"Invoice number";s:22:"invoice_number_setting";s:23:"Invoice number settings";s:6:"yearly";s:6:"yearly";s:30:"payment_notification_days_desc";s:117:"Please enter the number days, to define when users should be notified about the limited access time to bought objects";s:25:"payment_notification_days";s:14:"Number of days";s:22:"allow_user_toggle_noti";s:44:"Member is allowed to deactivate notification";s:20:"usr_account_inactive";s:16:"Inactive Account";s:9:"portfolio";s:9:"Portfolio";s:8:"obj_skmg";s:21:"Competence Management";s:13:"obj_skmg_desc";s:45:"Manage competences and competence categories.";s:6:"skills";s:14:"My Competences";s:17:"exc_next_deadline";s:13:"Next Deadline";s:20:"password_allow_chars";s:17:"Allowed chars: %s";s:9:"fold_type";s:11:"Folder Type";s:16:"added_to_desktop";s:39:"The item has been added to the desktop.";s:20:"removed_from_desktop";s:43:"The item has been removed from the desktop.";s:9:"objs_chtr";s:9:"Chatrooms";s:8:"obj_chta";s:4:"Chat";s:8:"obj_chtr";s:8:"Chatroom";s:24:"password_multiple_errors";s:36:"Multiple criteria are not satisfied:";s:31:"password_contains_invalid_chars";s:40:"The password contains invalid characters";s:6:"notice";s:6:"Notice";s:11:"public_room";s:11:"Public room";s:17:"my_courses_groups";s:21:"My Courses and Groups";s:12:"shoppingcart";s:12:"Shoppingcart";s:25:"enable_sahs_protocol_data";s:22:"Activate Protocol Data";s:30:"enable_sahs_protocol_data_desc";s:31:"Show Protocol Data (SCORM/AICC)";s:9:"chtr_copy";s:14:"Copy Chat Room";s:18:"obj_chtr_duplicate";s:14:"Copy Chat Room";s:25:"il_chat_moderator_visible";s:20:"Chat Room is visible";s:22:"il_chat_moderator_read";s:24:"Read access to Chat Room";s:23:"il_chat_moderator_write";s:23:"Edit Chat Room settings";s:26:"il_chat_moderator_moderate";s:18:"Moderate Chat Room";s:21:"obj_il_chat_moderator";s:19:"Chat Room Moderator";s:30:"precondition_required_itemlist";s:21:"Required Precondition";s:19:"precondition_toggle";s:61:"Preconditions that need to be fulfilled to access this object";s:11:"top_of_page";s:11:"Top of page";s:10:"spl_import";s:27:"Import Question Pool Survey";s:16:"contact_sysadmin";s:22:"Contact Administration";s:12:"chta_visible";s:34:"Chatroom Administration is visible";s:9:"chta_read";s:39:"Read access to Chat Room Administration";s:10:"chta_write";s:29:"Edit Chat Room Administration";s:20:"chta_edit_permission";s:26:"Change Permission Settings";s:11:"apache_auth";s:21:"Apache Authentication";s:15:"server_disabled";s:20:"The Chat is Disabled";s:8:"continue";s:8:"continue";s:21:"statutory_regulations";s:21:"Statutory Regulations";s:20:"show_sr_shoppingcart";s:21:"Show in Shopping Cart";s:17:"attach_sr_invoice";s:16:"Attach at e-mail";s:25:"show_sr_shoppingcart_info";s:76:"If enabled, the statutory regulations will be shown within the shopping cart";s:22:"attach_sr_invoice_info";s:75:"If enabled, the statutory regulations will be attached to the billing email";s:22:"ignore_required_fields";s:22:"Ignore required fields";s:27:"ignore_required_fields_info";s:174:"If activated, you can submit this form without filling out all mandatory fields. The new user has to add the missing information on the personal profile after the next login.";s:8:"obj_rcat";s:12:"ECS Category";s:16:"obj_lm_duplicate";s:20:"Copy Learning Module";s:31:"reg_goto_parent_membership_info";s:42:"Only members can access the target object.";s:14:"remove_entries";s:14:"Remove Entries";s:9:"objs_blog";s:5:"Blogs";s:18:"obj_blog_duplicate";s:9:"Copy Blog";s:7:"obj_dcl";s:15:"Data Collection";s:8:"objs_dcl";s:16:"Data Collections";s:16:"obj_dcl_dupliate";s:20:"Copy Data Collection";s:17:"obj_dcl_duplicate";s:20:"Copy Data Collection";s:18:"shib_matriculation";s:34:"Attribute for Matriculation Number";s:20:"soap_connect_timeout";s:18:"Connection Timeout";s:25:"soap_connect_timeout_info";s:90:"The maximum time in seconds until a connect attempt to the SOAP-Webservice is interrupted.";s:17:"obj_mep_duplicate";s:15:"Copy Media Pool";s:18:"obj_mcst_duplicate";s:14:"Copy Mediacast";s:17:"obj_glo_duplicate";s:13:"Copy Glossary";s:18:"obj_htlm_duplicate";s:25:"Copy HTML Learning Module";s:18:"obj_wiki_duplicate";s:9:"Copy Wiki";s:18:"obj_sahs_duplicate";s:20:"Copy Learning Module";s:8:"obj_poll";s:4:"Poll";s:9:"objs_poll";s:5:"Polls";s:18:"obj_poll_dupliate:";s:9:"Copy Poll";s:11:"mail_member";s:14:"Mail to Member";s:7:"imprint";s:12:"Legal Notice";s:18:"crs_list_reg_start";s:18:"Registration Begin";s:16:"crs_list_reg_end";s:16:"Registration End";s:18:"crs_list_reg_noreg";s:24:"No Registration Possible";s:19:"crs_list_reg_period";s:19:"Registration Period";s:23:"crs_list_reg_limit_full";s:14:"No places left";s:25:"crs_list_reg_limit_places";s:11:"Free places";s:13:"obj_hlps_desc";s:28:"Settings for the online help";s:8:"obj_hlps";s:11:"Help System";s:18:"grp_list_reg_start";s:18:"Registration Begin";s:16:"grp_list_reg_end";s:16:"Registration End";s:18:"grp_list_reg_noreg";s:24:"No Registration Possible";s:19:"grp_list_reg_period";s:19:"Registration Period";s:23:"grp_list_reg_limit_full";s:14:"No places left";s:25:"grp_list_reg_limit_places";s:11:"Free places";s:9:"add_entry";s:14:"Add/Edit entry";s:18:"obj_poll_duplicate";s:9:"Copy Poll";s:9:"objs_rcat";s:14:"ECS Categories";s:18:"obj_itgr_duplicate";s:15:"Copy Item Group";s:15:"obj_itgr_select";s:34:"-- Please select one Item Group --";s:8:"obj_itgr";s:10:"Item Group";s:9:"objs_itgr";s:11:"Item Groups";s:8:"itgr_new";s:14:"New Item Group";s:11:"itgr_import";s:17:"Import Item Group";s:9:"itgr_copy";s:15:"Copy Item Group";s:8:"itgr_add";s:14:"Add Item Group";s:15:"search_globally";s:8:"Globally";s:26:"search_at_current_position";s:19:"At Current Position";s:8:"obj_rwik";s:8:"ECS Wiki";s:9:"objs_rwik";s:9:"ECS Wikis";s:7:"obj_rlm";s:19:"ECS Learning Module";s:8:"objs_rlm";s:20:"ECS Learning Modules";s:8:"obj_rglo";s:12:"ECS Glossary";s:9:"objs_rglo";s:14:"ECS Glossaries";s:8:"obj_rfil";s:8:"ECS File";s:9:"objs_rfil";s:9:"ECS Files";s:8:"obj_rgrp";s:9:"ECS Group";s:9:"objs_rgrp";s:10:"ECS Groups";s:8:"obj_tstv";s:16:"Test Certificate";s:8:"obj_excv";s:20:"Exercise Certificate";s:8:"obj_prtf";s:9:"Portfolio";s:8:"obj_rtst";s:8:"ECS Test";s:9:"objs_rtst";s:9:"ECS Tests";s:17:"obj_tool_settings";s:5:"Tools";s:23:"obj_tool_settings_title";s:13:"Tool Settings";s:25:"obj_tool_setting_calendar";s:8:"Calendar";s:8:"fm_start";s:22:"Open With File Manager";s:19:"il_blog_contributor";s:16:"Blog Contributor";s:8:"qpl_copy";s:23:"Copy Question Pool Test";s:16:"edit_assignments";s:16:"Edit Assignments";s:21:"obj_tool_setting_news";s:4:"News";s:8:"obj_ecss";s:3:"ECS";s:13:"obj_ecss_desc";s:20:"General ECS Settings";s:9:"edited_on";s:9:"Edited on";s:12:"obj_tos_desc";s:25:"Terms of Service Settings";s:7:"obj_tos";s:16:"Terms of Service";s:8:"obj_bibl";s:12:"Bibliography";s:9:"objs_bibl";s:14:"Bibliographies";s:8:"obj_bibs";s:12:"Bibliography";s:13:"obj_bibs_desc";s:27:"Bibliography Administration";s:16:"hide_all_details";s:16:"Hide all details";s:16:"show_all_details";s:16:"Show all details";s:26:"select_files_from_computer";s:35:"Select the files from your computer";s:15:"drag_files_here";s:29:"Drag-and-drop your files here";s:14:"selected_files";s:14:"Selected files";s:21:"num_of_selected_files";s:19:"%s file(s) selected";s:18:"cancel_file_upload";s:49:"Do you really want to cancel all pending uploads?";s:12:"upload_files";s:12:"Upload files";s:18:"upload_files_title";s:12:"Upload files";s:14:"upload_pending";s:7:"Pending";s:26:"error_empty_file_or_folder";s:43:"The file size is 0 bytes or it is a folder.";s:27:"error_upload_was_zero_bytes";s:98:"The upload failed as this is a folder, the file size is 0 bytes or the file was renamed meanwhile.";s:9:"uploading";s:12:"Uploading...";s:10:"extracting";s:13:"Extracting...";s:27:"drop_files_on_repo_obj_info";s:52:"Drop the files here to upload them into this object.";s:23:"error_extraction_failed";s:154:"The extraction of the archive and its directories failed. Probably because you don’t have the rights to create folders or categories within this object.";s:15:"upload_settings";s:18:"Uploading Settings";s:17:"enable_dnd_upload";s:27:"Enable drag-and-drop upload";s:22:"enable_dnd_upload_info";s:76:"Files can be uploaded with drag-and-drop from the local computer if enabled.";s:28:"enable_repository_dnd_upload";s:20:"Enable in Repository";s:33:"enable_repository_dnd_upload_info";s:140:"Enables that files can be dragged from the computer directly onto an object in the repository to start uploading the files into this object.";s:18:"concurrent_uploads";s:28:"Number of concurrent uploads";s:23:"concurrent_uploads_info";s:85:"Defines the number of files that can be uploaded per upload process at the same time.";s:13:"download_link";s:13:"Download Link";s:28:"file_confirm_delete_versions";s:51:"Are you sure to delete the following file versions?";s:32:"file_confirm_delete_all_versions";s:96:"You selected all file versions. This will delete the whole file object. Do you want to continue?";s:21:"file_versions_deleted";s:53:"The selected file versions were successfully deleted.";s:30:"file_rollback_select_exact_one";s:69:"Only one file version can be selected to make it the current version.";s:18:"file_rollback_done";s:43:"File version %s is now the current version.";s:24:"file_version_new_version";s:11:"New version";s:19:"file_version_create";s:15:"Initial version";s:20:"file_version_replace";s:21:"All versions replaced";s:21:"file_version_rollback";s:30:"Rollback from version %s by %s";s:13:"file_rollback";s:29:"Make this the current version";s:10:"frm_import";s:12:"Import Forum";s:18:"rpc_pdf_generation";s:14:"PDF-Generation";s:12:"rpc_pdf_font";s:5:"Fonts";s:17:"rpc_pdf_font_info";s:139:"Additional fonts for the generation of PDF files. Other fonts than ‘Helvetica’ and ‘unifont’ must be installed on the ILIAS server.";s:8:"obj_sysc";s:12:"System Check";s:13:"obj_sysc_desc";s:29:"System Check and Repair Tools";s:7:"obj_cld";s:12:"Cloud Object";s:8:"objs_cld";s:13:"Cloud Objects";s:21:"scorm_without_session";s:47:"SCORM 2004: enable storing data without session";s:26:"scorm_without_session_info";s:77:"This ensures the storage of SCORM learning data even if ILIAS session expired";s:19:"msg_obj_no_download";s:21:"cannot be downloaded.";s:23:"download_selected_items";s:8:"Download";s:25:"download_multiple_objects";s:25:"Download Multiple Objects";s:21:"msg_obj_perm_download";s:68:"You do not have sufficient rights to download the following objects:";s:21:"enable_multi_download";s:37:"«Download multiple objects» enabled";s:26:"enable_multi_download_info";s:84:"Enables that multiple folders/files can be selected to download them as zip archive.";s:7:"preview";s:7:"Preview";s:12:"preview_show";s:12:"Show Preview";s:12:"preview_none";s:25:"Preview (not created yet)";s:16:"preview_settings";s:12:"File Preview";s:14:"enable_preview";s:14:"Enable Preview";s:19:"enable_preview_info";s:69:"Enable this option to display preview images on supported file types.";s:23:"max_previews_per_object";s:33:"Number of preview images per file";s:28:"max_previews_per_object_info";s:71:"Defines the maximum number of preview images that are created per file.";s:14:"preview_create";s:14:"Create Preview";s:14:"preview_delete";s:14:"Delete Preview";s:23:"preview_status_creating";s:52:"The preview gets created. This may take some time...";s:23:"preview_status_deleting";s:27:"The preview gets deleted...";s:22:"preview_status_pending";s:61:"The preview has not been created yet. Please try again later.";s:21:"preview_status_failed";s:29:"Failed to create the preview.";s:22:"preview_status_missing";s:32:"No preview exists for this file.";s:15:"preview_loading";s:18:"Loading Preview...";s:24:"loaded_preview_renderers";s:24:"Loaded Preview Renderers";s:20:"renderer_type_plugin";s:6:"Plugin";s:21:"renderer_type_builtin";s:8:"Built-in";s:29:"renderer_supported_repo_types";s:23:"Supported ILIAS Objects";s:29:"renderer_supported_file_types";s:20:"Supported File Types";s:26:"ghostscript_not_configured";s:134:"Ghostscript is not configured. Please open the <a href="setup/setup.php?cmd=mastersettings" target="_blank">Setup</a> to configure it.";s:8:"obj_reps";s:10:"Repository";s:13:"obj_reps_desc";s:35:"General settings for the Repository";s:8:"obj_wbrs";s:7:"Weblink";s:13:"obj_wbrs_desc";s:30:"General settings for Web Links";s:8:"obj_crss";s:6:"Course";s:13:"obj_crss_desc";s:28:"General settings for Courses";s:8:"obj_grps";s:5:"Group";s:13:"obj_grps_desc";s:27:"General settings for Groups";s:8:"obj_prtt";s:18:"Portfolio Template";s:9:"objs_prtt";s:19:"Portfolio Templates";s:18:"obj_prtt_duplicate";s:23:"Copy Portfolio Template";s:9:"objs_orgu";s:20:"Organisational Units";s:8:"obj_orgu";s:19:"Organisational Unit";s:20:"obj_orgu_description";s:45:"Creating and editing organisational structure";s:16:"il_orgu_superior";s:8:"Superior";s:16:"il_orgu_employee";s:8:"Employee";s:22:"view_learning_progress";s:22:"View Learning Progress";s:26:"view_learning_progress_rec";s:45:"View Learning Progress of Unit incl. Subunits";s:31:"ps_password_lowercase_chars_num";s:18:"Lower Case Letters";s:36:"ps_password_lowercase_chars_num_info";s:108:"Please insert the number of lower case letters a password must contain. Enter 0 to disable this requirement.";s:31:"ps_password_uppercase_chars_num";s:15:"Capital Letters";s:36:"ps_password_uppercase_chars_num_info";s:105:"Please insert the number of capital letters a password must contain. Enter 0 to disable this requirement.";s:37:"ps_password_must_not_contain_loginame";s:28:"Prevent Username in Password";s:42:"ps_password_must_not_contain_loginame_info";s:55:"If activated, a password must not contain the username.";s:36:"password_contains_parts_of_login_err";s:73:"The chosen password contains your username. Please insert a new password.";s:33:"password_must_contain_lcase_chars";s:57:"The password must contain at least %s lower case letters.";s:33:"password_must_contain_ucase_chars";s:54:"The password must contain at least %s capital letters.";s:25:"scorm_login_as_learner_id";s:48:"SCORM 2004: set ILIAS Username as cmi.learner_id";s:30:"scorm_login_as_learner_id_info";s:74:"If enabled, the Username instead of the User ID is set for cmi.learner_id.";s:8:"obj_wiks";s:4:"Wiki";s:13:"obj_wiks_desc";s:20:"Global Wiki Settings";s:12:"offline_mode";s:11:"Use offline";s:23:"msg_obj_already_deleted";s:36:"The object has already been deleted.";s:26:"obj_tool_setting_news_info";s:68:"The ‘News’ block will be displayed inside the ‘Content’ tab.";s:30:"obj_tool_setting_calendar_info";s:72:"The ‘Calendar’ block will be displayed inside the ‘Content’ tab.";s:8:"obj_crsv";s:18:"Course Certificate";s:8:"obj_scov";s:17:"SCORM Certificate";s:8:"obj_nota";s:13:"Notifications";s:17:"autocomplete_more";s:4:"more";s:23:"sorting_creation_header";s:16:"By Creation Date";s:21:"sorting_creation_info";s:64:"Content items are arranged automatically by their creation date.";s:17:"sorting_direction";s:17:"Sorting Direction";s:12:"sorting_desc";s:10:"Descendent";s:11:"sorting_asc";s:9:"Ascending";s:20:"il_astpl_loc_initial";s:12:"Initial Test";s:22:"il_astpl_loc_qualified";s:15:"Qualifying Test";s:25:"il_astpl_loc_initial_desc";s:74:"Settings template for initial tests of learning objective oriented courses";s:27:"il_astpl_loc_qualified_desc";s:77:"Settings template for qualifying tests of learning objective oriented courses";s:15:"ps_export_scorm";s:19:"SCORM Tracking Data";s:24:"enable_export_scorm_desc";s:51:"Allow export of user data of SCORM Learning Modules";s:22:"scorm_lp_auto_activate";s:38:"default settings for learning progress";s:27:"scorm_lp_auto_activate_info";s:259:"If learning progress is activated in general, the settings for new SCORM learning modules are set to ‘Collection of SCORM Items’ and all SCOs are selected for learning progress determination. Adjustments are still possible for every SCORM learning module.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'administration'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:286:{s:24:"adm_item_cmd_asynch_info";s:167:"Action commands, e.g. in the repository, are loaded asynchronously. This increases performance in general, but slows down loading of action command lists a little bit.";s:19:"adm_item_cmd_asynch";s:41:"Load Resource Action Lists Asynchronously";s:15:"adm_locale_info";s:155:"Locale setting influences e.g. sorting in lists. Examples are nl_NL or de_DE. Multiple locales can be separated by comma. The first valid one will be used.";s:10:"adm_locale";s:6:"Locale";s:30:"adm_repository_cache_time_info";s:157:"Repository access cache time. Set 0 to disable the cache. Higher values may improve performance but also display actions that lead to a no-permission screen.";s:25:"adm_repository_cache_time";s:21:"Repository Cache Time";s:22:"allow_change_loginname";s:51:"Permit Change of Login Names in ‘Personal Data’";s:16:"analysis_options";s:16:"Analysis options";s:12:"analyze_data";s:33:"Analyze and repair data integrity";s:24:"analyzing_tree_structure";s:27:"Analyzing tree structure...";s:9:"analyzing";s:12:"Analyzing...";s:28:"auth_auth_mode_determination";s:47:"Authentication Method Determination (for Login)";s:14:"auth_automatic";s:14:"Fixed Sequence";s:12:"auth_by_user";s:11:"By the User";s:23:"auth_kind_determination";s:21:"Kind of Determination";s:28:"auth_mode_determination_info";s:158:"Choose either if the users have to select their authentication method on the login screen or if this is managed by a fixed sequence of authentication methods.";s:15:"check_tree_desc";s:89:"Check consistence of entire tree structure. Depending on tree size this may take a while!";s:10:"check_tree";s:20:"Check tree structure";s:10:"clean_desc";s:78:"Remove invalid references and tree entries. Initialize gaps in tree structure.";s:5:"clean";s:8:"Clean up";s:14:"cleaning_final";s:17:"Final cleaning...";s:8:"cleaning";s:11:"Cleaning...";s:29:"confirm_message_course_export";s:94:"You added the course export functionality for one or more fields. Please confirm your changes.";s:13:"course_export";s:18:"Visible in Courses";s:8:"disabled";s:8:"Disabled";s:4:"done";s:4:"Done";s:14:"dump_tree_desc";s:82:"Perform an analysis of the tree and print all tree nodes along with analysis data.";s:9:"dump_tree";s:9:"Dump tree";s:12:"dumping_tree";s:15:"Dumping tree...";s:10:"found_none";s:11:"none found.";s:5:"found";s:6:"found.";s:17:"history_loginname";s:18:"Login Name History";s:17:"initializing_gaps";s:28:"Initializing gaps in tree...";s:23:"language_administration";s:23:"Language Administration";s:20:"language_all_modules";s:11:"All modules";s:24:"language_change_settings";s:24:"Change Language Settings";s:28:"language_clear_local_changes";s:35:"Clear local changes in the database";s:22:"language_cleared_local";s:47:"The local changes were cleared in the database.";s:16:"language_compare";s:7:"Compare";s:24:"language_default_entries";s:18:" (default entries)";s:29:"language_delete_local_changes";s:40:"Delete all local changes in the database";s:26:"language_error_clear_local";s:55:"The local changed could not be cleared in the database!";s:25:"language_error_read_local";s:57:"The local language file does not exist or cannot be read!";s:26:"language_error_write_local";s:42:"The local language file cannot be written!";s:20:"language_export_file";s:20:"Export Language File";s:22:"language_file_imported";s:34:"The language file %s was imported.";s:19:"language_file_scope";s:19:"Language file scope";s:32:"language_former_file_description";s:293:"To compare your local changes with the changes of the last update, please copy the language file of the previously installed ILIAS version to the folder of local language files. The current language file is automatically copied when you save your local language file on the ‘Maintain’ tab.";s:26:"language_former_file_equal";s:61:"The file <b>%s</b> is identical to the current language file.";s:28:"language_former_file_missing";s:30:"The file <b>%s</b> is missing.";s:20:"language_import_file";s:20:"Import Language File";s:27:"language_load_local_changes";s:42:"Load local language file into the database";s:21:"language_loaded_local";s:53:"The local language file was loaded into the database.";s:31:"language_maintain_local_changes";s:22:"Maintain local changes";s:17:"language_maintain";s:8:"Maintain";s:20:"language_maintenance";s:20:"Language Maintenance";s:29:"language_mode_existing_delete";s:23:"Delete existing entries";s:30:"language_mode_existing_keepall";s:25:"Keep all existing entries";s:30:"language_mode_existing_keepnew";s:22:"Keep all local changes";s:30:"language_mode_existing_replace";s:24:"Replace existing entries";s:22:"language_mode_existing";s:16:"Existing Entries";s:24:"language_note_save_local";s:196:"Please save your changes to the local language file regularly. If you do not have write permissions to the customized language files, you may export the local changes and re-import them if needed.";s:25:"language_note_translation";s:142:"Page translation mode is activated for each language separately. Additionally the user needs read and write permission on the language folder.";s:28:"language_process_maintenance";s:19:"Process Maintenance";s:27:"language_save_local_changes";s:43:"Save all changes to the local language file";s:20:"language_saved_local";s:50:"All changes were saved to the local language file.";s:24:"language_scope_commented";s:49:"Shows only entries with comments in language file";s:24:"language_scope_conflicts";s:24:"Local and update changes";s:24:"language_scope_dbremarks";s:44:"Shows only entries with comments in database";s:24:"language_scope_different";s:31:"Different from compare language";s:20:"language_scope_equal";s:25:"Equal to compare language";s:21:"language_scope_global";s:11:"All entries";s:20:"language_scope_local";s:18:"Local changes only";s:24:"language_scope_translate";s:34:"All entries, empty for translation";s:24:"language_scope_unchanged";s:22:"Unchanged entries only";s:17:"language_settings";s:17:"Language Settings";s:19:"language_statistics";s:10:"Statistics";s:29:"language_translation_disabled";s:25:"Page translation disabled";s:28:"language_translation_enabled";s:24:"Page translation enabled";s:25:"language_translation_mode";s:16:"Translation mode";s:13:"log_scan_desc";s:65:"Write scan results to ‘scanlog.log’ in client data directory.";s:8:"log_scan";s:16:"Log scan results";s:35:"loginname_change_blocking_time_info";s:138:"Insert a period in days that a user has to wait before changing again its login name. If you enter 0, user can change login names anytime.";s:46:"loginname_change_blocking_time_invalidity_info";s:30:"Please insert a numeric value.";s:30:"loginname_change_blocking_time";s:38:"Blocking Time for Changing Login Names";s:22:"loginname_history_info";s:134:"If activated, login name changes will be logged in database. This history is accessible in the database table ‘loginname_history’.";s:16:"nothing_to_purge";s:19:"Nothing to purge...";s:17:"nothing_to_remove";s:20:"Nothing to remove...";s:18:"nothing_to_restore";s:21:"Nothing to restore...";s:12:"obj_mds_desc";s:49:"Configure Metadata and Advanced Metadata Settings";s:7:"obj_mds";s:8:"Metadata";s:7:"options";s:7:"Options";s:14:"output_options";s:14:"Output options";s:20:"passwd_auto_generate";s:30:"Password Forwarding/Generation";s:15:"path_to_mkisofs";s:15:"Path to mkisofs";s:45:"reuse_of_loginnames_contained_in_history_info";s:128:"If activated, it is allowed to reuse any login name that is already saved in the history (even if it belongs to a deleted user).";s:20:"purge_age_limit_desc";s:115:"If this field contains a value, only objects which were deleted before the specified number of days will be purged.";s:15:"purge_age_limit";s:9:"Limit age";s:22:"purge_count_limit_desc";s:84:"If this field contains a value, only the specified number of objects will be purged.";s:17:"purge_count_limit";s:11:"Limit count";s:18:"purge_missing_desc";s:57:"Remove all missing and unbound objects found from system.";s:13:"purge_missing";s:21:"Purge missing objects";s:16:"purge_trash_desc";s:44:"Remove all objects in trash bin from system.";s:11:"purge_trash";s:21:"Purge deleted objects";s:21:"purge_type_limit_desc";s:82:"If this field contains a value, only objects of the specified type will be purged.";s:16:"purge_type_limit";s:10:"Limit type";s:20:"purging_missing_objs";s:26:"Purging missing objects...";s:13:"purging_trash";s:16:"Purging trash...";s:20:"purging_unbound_objs";s:26:"Purging unbound objects...";s:7:"purging";s:10:"Purging...";s:23:"removing_invalid_childs";s:32:"Removing invalid tree entries...";s:21:"removing_invalid_refs";s:30:"Removing invalid references...";s:22:"removing_invalid_rolfs";s:32:"Removing invalid role folders...";s:14:"repair_options";s:14:"Repair options";s:20:"restore_missing_desc";s:54:"Restore missing and unbound objects to RecoveryFolder.";s:15:"restore_missing";s:23:"Restore missing objects";s:18:"restore_trash_desc";s:51:"Restore all objects in trash bin to RecoveryFolder.";s:13:"restore_trash";s:23:"Restore deleted objects";s:22:"restoring_missing_objs";s:28:"Restoring missing objects...";s:15:"restoring_trash";s:18:"Restoring trash...";s:22:"restoring_unbound_objs";s:44:"Restoring unbound objects and sub-objects...";s:9:"restoring";s:12:"Restoring...";s:40:"reuse_of_loginnames_contained_in_history";s:20:"Reuse of Login Names";s:14:"scan_completed";s:14:"Scan completed";s:9:"scan_desc";s:58:"Scan system for corrupted/invalid/missing/unbound objects.";s:12:"scan_details";s:12:"Scan details";s:10:"scan_modes";s:15:"Scan modes used";s:4:"scan";s:4:"Scan";s:15:"scanning_system";s:18:"Scanning system...";s:22:"searching_deleted_objs";s:32:"Searching for deleted objects...";s:24:"searching_invalid_childs";s:37:"Searching for invalid tree entries...";s:22:"searching_invalid_refs";s:35:"Searching for invalid references...";s:23:"searching_invalid_rolfs";s:37:"Searching for invalid role folders...";s:22:"searching_missing_objs";s:32:"Searching for missing objects...";s:22:"searching_unbound_objs";s:32:"Searching for unbound objects...";s:7:"skipped";s:7:"skipped";s:10:"start_scan";s:6:"Start!";s:9:"stop_scan";s:5:"Stop!";s:11:"systemcheck";s:12:"System check";s:12:"tree_corrupt";s:44:"Tree is corrupted! See scan log for details.";s:26:"usr_loginname_history_info";s:67:"The user changed its login at last at %s. The former login was: %s.";s:13:"view_last_log";s:18:"View last Scan log";s:8:"view_log";s:12:"View details";s:14:"forum_settings";s:13:"Forumsettings";s:19:"frm_displayed_infos";s:21:"Displayed Information";s:18:"frm_disp_info_desc";s:71:"Please select the attributes which should to be shown in the overviews.";s:25:"adm_rep_tree_presentation";s:28:"Repository Tree Presentation";s:22:"adm_rep_tree_only_cntr";s:14:"Container Only";s:27:"adm_rep_tree_only_cntr_info";s:47:"Only categories, courses and groups are listed.";s:22:"adm_rep_tree_all_types";s:18:"All Resource Types";s:27:"adm_rep_tree_all_types_info";s:46:"All types of resources are listed in the tree.";s:26:"adm_rep_tree_limit_grp_crs";s:48:"Show limited context tree in courses and groups.";s:16:"adm_db_benchmark";s:12:"DB Benchmark";s:25:"adm_activate_db_benchmark";s:18:"Activate Benchmark";s:30:"adm_activate_db_benchmark_desc";s:62:"Benchmarking will be automatically disabled after one request.";s:21:"adm_db_benchmark_user";s:17:"User Account Name";s:26:"adm_db_benchmark_user_desc";s:45:"Only measurements for this user will be made.";s:26:"adm_db_bench_chronological";s:13:"Chronological";s:26:"adm_db_bench_slowest_first";s:13:"Slowest First";s:26:"adm_db_bench_sorted_by_sql";s:13:"Sorted by SQL";s:7:"adm_sql";s:3:"SQL";s:8:"adm_time";s:4:"Time";s:27:"adm_db_bench_by_first_table";s:32:"Aggregated by First Table in SQL";s:17:"adm_nr_statements";s:20:"Number of Statements";s:9:"adm_table";s:5:"Table";s:12:"group_export";s:17:"Visible in Groups";s:31:"adm_rep_tree_limit_grp_crs_info";s:84:"This relies on and automatically activates the ‘Synchronize Tree Frame’ feature.";s:24:"adm_synchronize_rep_tree";s:48:"Synchronize Tree Frame with Repository Main View";s:29:"adm_synchronize_rep_tree_info";s:214:"This highlights the current position in the tree frame, when the user navigates in the repository. Please note that this has a negative influence on system performance, since additional server requests are invoked.";s:21:"language_scope_merged";s:50:"Local changes merged into the global language file";s:20:"language_scope_added";s:20:"Local additions only";s:28:"language_merge_local_changes";s:49:"Merge local changes into the global language file";s:31:"language_delete_local_additions";s:38:"Delete local additions in the database";s:27:"language_error_write_global";s:42:"The global language file can\'t be written!";s:27:"language_error_local_missed";s:39:"The local language file does not exist!";s:27:"language_error_delete_local";s:41:"The local language file can\'t be deleted!";s:27:"language_local_file_deleted";s:36:"The local language file was deleted.";s:26:"language_remove_local_file";s:30:"Delete the local language file";s:22:"language_merged_global";s:60:"The local changes were merged into the global language file.";s:20:"apache_auth_settings";s:6:"Apache";s:15:"apache_settings";s:29:"Configure LDAP Authentication";s:18:"apache_enable_auth";s:36:"Enable Apache Authentication support";s:17:"apache_autocreate";s:25:"Enable account generation";s:19:"apache_default_role";s:17:"Default user role";s:19:"apache_enable_local";s:28:"Enable local user assignment";s:18:"apache_enable_ldap";s:27:"Enable LDAP user assignment";s:26:"apache_auth_indicator_name";s:45:"Indicator-field for successful authentication";s:27:"apache_auth_indicator_value";s:45:"Indicator-value for successful authentication";s:33:"apache_auth_enable_override_login";s:27:"Override default login page";s:33:"apache_auth_target_override_login";s:32:"Target url for custom login page";s:27:"apache_auth_username_config";s:22:"Username configuration";s:32:"apache_auth_username_config_type";s:4:"Type";s:35:"apache_auth_username_direct_mapping";s:19:"Straight assignment";s:37:"apache_auth_username_extended_mapping";s:19:"Extended assignment";s:32:"apache_auth_username_by_function";s:36:"Assign user names by custom function";s:40:"apache_ldap_hint_ldap_must_be_configured";s:41:"LDAP must be configured in administration";s:45:"apache_auth_username_direct_mapping_fieldname";s:20:"Field for assignment";s:11:"auth_apache";s:6:"Apache";s:31:"apache_settings_changed_success";s:19:"Configuration saved";s:38:"apache_auth_authenticate_on_login_page";s:54:"Try Apache authentication when entering the login page";s:22:"adm_settings_templates";s:18:"Settings Templates";s:25:"adm_add_settings_template";s:12:"Add Template";s:26:"adm_edit_settings_template";s:13:"Edit Template";s:13:"adm_hide_tabs";s:9:"Hide Tabs";s:23:"adm_predefined_settings";s:19:"Predefined Settings";s:9:"adm_value";s:16:"Predefined Value";s:8:"adm_hide";s:21:"Hide in Settings Form";s:33:"adm_sure_delete_settings_template";s:53:"Do you really want to delete the following templates?";s:13:"user_criteria";s:20:"Unique user criteria";s:18:"user_criteria_desc";s:136:"Unique user criteria that is used for test results import/export. This is needed to identify identical users on different ILIAS systems.";s:20:"apache_auth_security";s:17:"Security Settings";s:19:"apache_auth_domains";s:27:"Allowed Redirection Domains";s:31:"apache_auth_domains_description";s:282:"Enter one domain per line to allow redirection to this target.<br/>If ILIAS is reachable by more than one domain please enter all target you want to allow.<br />Example: example.com allows the redirection to http://example.com and http://www.example.com and all pages located there.";s:8:"obj_blga";s:4:"Blog";s:13:"obj_blga_desc";s:20:"Global Blog Settings";s:8:"obj_prfa";s:9:"Portfolio";s:13:"obj_prfa_desc";s:25:"Global Portfolio Settings";s:13:"obj_chta_desc";s:19:"Chat Administration";s:9:"adm_basic";s:5:"Basic";s:9:"adm_users";s:5:"Users";s:12:"adm_services";s:8:"Services";s:11:"adm_objects";s:7:"Objects";s:34:"adm_show_comments_tagging_in_lists";s:55:"Show number of notes, comments and tags in object lists";s:8:"obj_otpl";s:18:"Didactic Templates";s:13:"obj_otpl_desc";s:69:"Template for creating new objects with predefined permission settings";s:31:"adm_repository_cache_time_info2";s:170:"It is also possible that repository objects become accessible for users with a certain time lack, e.g. after preconditions have been met or permissions have been changed.";s:27:"adm_rep_shorten_description";s:20:"Shorten Descriptions";s:32:"adm_rep_shorten_description_info";s:64:"If activated all descriptions in object lists will be shortened.";s:34:"adm_rep_shorten_description_length";s:25:"Max. number of characters";s:11:"adm_imprint";s:12:"Legal Notice";s:20:"adm_imprint_inactive";s:63:"Legal notice is not active and users are not able to access it.";s:23:"adm_user_starting_point";s:23:"Personal Starting Point";s:28:"adm_user_starting_point_info";s:53:"Select the page or object which is shown after login.";s:30:"adm_user_starting_point_object";s:17:"Repository Object";s:30:"adm_user_starting_point_ref_id";s:12:"Reference-Id";s:32:"adm_user_starting_point_personal";s:16:"Personal Setting";s:37:"adm_user_starting_point_personal_info";s:50:"If activated users may select their starting page.";s:20:"adm_social_bm_create";s:22:"Create Social Bookmark";s:18:"adm_social_bm_edit";s:20:"Edit Social Bookmark";s:20:"adm_adm_role_protect";s:26:"Protect Administrator Role";s:25:"adm_adm_role_protect_info";s:93:"If enabled, only administrator are allowed to de/assign users from/to the administrator role.";s:23:"feedback_recipient_info";s:45:"This address is used in the footer link "%s".";s:21:"system_check_no_owner";s:17:"Ownerless Objects";s:9:"adm_https";s:5:"HTTPS";s:27:"adm_external_setting_prefix";s:17:"External Settings";s:25:"adm_external_setting_edit";s:13:"Edit Settings";s:36:"adm_user_starting_point_invalid_info";s:37:"This feature is currently not active.";s:14:"vc_information";s:32:"Show Version Control Information";s:29:"vc_information_not_determined";s:58:"ILIAS could not determine any version control information.";s:20:"svn_revision_current";s:20:"Current Revision: %s";s:24:"svn_revision_last_change";s:25:"Last Changed Revision: %s";s:8:"svn_root";s:8:"Root: %s";s:8:"svn_path";s:8:"Path: %s";s:12:"git_revision";s:10:"Number: %s";s:14:"git_hash_short";s:23:"Commit Hash (short): %s";s:15:"git_last_commit";s:15:"Last Commit: %s";s:27:"adm_captcha_anonymous_short";s:7:"Captcha";s:25:"adm_captcha_anonymous_frm";s:122:"Activate captcha for anonymous in forums. Please keep in mind that this may effect the accessibility of your installation.";s:26:"adm_captcha_anonymous_auth";s:126:"Activate captcha for anonymous in login form. Please keep in mind that this may effect the accessibility of your installation.";s:25:"adm_captcha_anonymous_reg";s:133:"Activate captcha for anonymous in registration form. Please keep in mind that this may effect the accessibility of your installation.";s:26:"adm_captcha_anonymous_wiki";s:121:"Activate captcha for anonymous in wikis. Please keep in mind that this may effect the accessibility of your installation.";s:8:"obj_excs";s:8:"Exercise";s:13:"obj_excs_desc";s:24:"Global Exercise Settings";s:8:"obj_taxs";s:8:"Taxonomy";s:13:"obj_taxs_desc";s:24:"Global Taxonomy Settings";s:39:"adm_show_comments_tagging_in_lists_tags";s:30:"Display tags instead of number";s:34:"language_mode_existing_delete_info";s:281:"Delete all entries in the database before importing the file.<br /> WARNING: The imported language file should be complete, otherwise there will be undefined language variables. If that happens, switch to the tab ‘Maintain’ and choose ‘Clear local changes in the database’.";s:35:"language_mode_existing_keepall_info";s:62:"Import only new entries that do not yet exist in the database.";s:35:"language_mode_existing_keepnew_info";s:143:"Import new entries and overwrite all entries that still have their default values. Keep those entries that are already changed in the database.";s:35:"language_mode_existing_replace_info";s:99:"Import new entries and replace all existing entries with the new values defined in the import file.";s:26:"language_scope_global_info";s:83:"Export all database entries of this language. This can be used for backup purposes.";s:25:"language_scope_local_info";s:151:"Export all entries that are locally added or changed in the database. This is similar to the saving of a local language file on the tab ‘Maintain’.";s:25:"language_scope_added_info";s:176:"Export all entries that are locally added in the database. This can be used to backup additional development entries before local changes are deleted on the tab ‘Maintain’.";s:29:"language_scope_unchanged_info";s:200:"Export all default language entries that are not changed in the database. This is the opposite to ‘Local changes only’. Both together are a complete backup of the current language in the database.";s:26:"language_scope_merged_info";s:190:"Export the standard ILIAS language file with all local changes merged in alphabetically by module and identifier. This can be used to update the global language file on the ILIAS SVN server.";s:32:"language_save_local_changes_info";s:300:"Save all locally added or changed database entries to the file Customizing/global/lang/ilias_%s_lang.local and set the language status to ‘Installed With Local’. The web server must have write permission in this folder. Please note that this file is the same for all clients of this installation.";s:32:"language_load_local_changes_info";s:163:"Load the file Customizing/global/lang/ilias_%s_lang.local to the database. New entries of this file are added to the database and existing entries are overwritten.";s:33:"language_clear_local_changes_info";s:145:"Reset the database entries of this language to the default entries defined in lang/ilias_%s.lang. All local changes or additions will be removed.";s:36:"language_delete_local_additions_info";s:59:"Delete all entries that were locally added to the database.";s:33:"language_merge_local_changes_info";s:160:"Merge all local changes and additions alphabetically into the standard language file lang/ilias_%s.lang. The web server must have write permission on this file.";s:31:"language_remove_local_file_info";s:187:"Remove the file Customizing/global/lang/ilias_%s_lang.local and change the language status from ‘Installed With Local’ to ‘Installed’. The changes in the database are not touched.";s:19:"adm_missing_entries";s:15:"Missing Entries";s:28:"adm_missing_entry_add_action";s:3:"Add";s:21:"adm_missing_entry_add";s:13:"Add New Entry";s:31:"adm_user_starting_point_inherit";s:21:"Use Standard-Settings";s:36:"adm_user_starting_point_inherit_info";s:89:"The settings that were made by the administrator of the platform as a whole will be used.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'adve'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:59:{s:12:"adve_grp_glo";s:10:"Glossaries";s:11:"adve_grp_lm";s:22:"ILIAS Learning Modules";s:12:"adve_grp_rep";s:16:"Repository Pages";s:14:"adve_grp_scorm";s:13:"SCORM Editing";s:13:"adve_grp_test";s:19:"Test and Assessment";s:13:"adve_grp_wiki";s:5:"Wikis";s:25:"adve_page_editor_settings";s:17:"ILIAS Page Editor";s:17:"adve_rte_settings";s:14:"TinyMCE Editor";s:26:"adve_text_content_features";s:17:"Text Content Menu";s:15:"adve_pe_general";s:7:"General";s:17:"adve_use_physical";s:32:"Use b/i/u instead of str/emp/imp";s:22:"adve_use_physical_info";s:335:"This setting replaces the semantic style class buttons for strong, emphatic and important with physical attribute buttons b (bold), i (italic) and u (underline). Please note, that this may result in inconsistencies, if the style editor is used and other phyisical attributes are assigned to the strong/emphatic/important style classes.";s:15:"adve_activation";s:10:"Activation";s:17:"adve_use_tiny_mce";s:34:"Enable TinyMCE for WYSIWYG Editing";s:20:"adve_excass_settings";s:20:"Exercise Assignments";s:32:"advanced_editing_excass_settings";s:29:"Exercise Assignments Settings";s:18:"adve_blocking_mode";s:9:"Edit Lock";s:12:"adve_minutes";s:7:"Minutes";s:17:"adve_minutes_info";s:91:"Minutes of inactivity before an edit lock expires and a page can be edited by another user.";s:19:"char_selector_admin";s:75:"Menu for Selecting Special Characters (Unicode) in Tests and Question Pools";s:18:"char_selector_user";s:56:"Menu for Selecting Special Characters (Unicode) in Tests";s:18:"char_selector_test";s:37:"Selector Special Characters (Unicode)";s:31:"char_selector_inherit_info_test";s:170:"Depending on the settings made in the platforms\' administration or those made by individual users on their personal desktop the Ω-button is displayed in the test or not.";s:31:"char_selector_inherit_info_user";s:89:"The settings that were made by the administrator of the platform as a whole will be used.";s:26:"char_selector_inherit_test";s:84:"Settings made either Globally by Administrators or Individually by Users are Applied";s:26:"char_selector_inherit_user";s:21:"Use Standard-Settings";s:28:"char_selector_disabled_admin";s:99:"Ω-Button for Activating the Menu for Selecting Special Characters is displayed only if switched on";s:33:"char_selector_disabled_info_admin";s:257:"The menu for selecting special characters (Unicode) in tests and question pools is activated but the Ω-Button has to be switched on by users on their Personal Desktop and or in individual tests or questions pools. Test Settings will override user settings.";s:32:"char_selector_disabled_info_test";s:110:"Regardless of a user\'s individual setting the special character selector is switched off for taking this test.";s:32:"char_selector_disabled_info_user";s:160:"In tests a menu for selecting special characters will be not displayed. However individual tests ‘force switch on’ the menu though your deactivated it here.";s:27:"char_selector_disabled_test";s:33:"Special Character Selector is Off";s:27:"char_selector_disabled_user";s:45:"Disable Menu for Selecting Special Characters";s:28:"char_selector_inactive_admin";s:61:"Globally Deactivate the Menu for Selecting Special Characters";s:33:"char_selector_inactive_info_admin";s:209:"The menu for selecting special characters is deactivated for the whole system. Users cannot make individual settings on their Personal Desktop nor can individual tests or questions pools switch on the setting.";s:27:"char_selector_enabled_admin";s:90:"Ω-Button for Activating the Menu for Selecting Special Characters is Displayed by Default";s:32:"char_selector_enabled_info_admin";s:305:"The menu for selecting special characters (Unicode) is activated in tests and question pools. It will present users with the selection of Unicode blocks composed below. Users can make individual settings on their Personal Desktop and the setting can be switched on for individual tests or questions pools.";s:31:"char_selector_enabled_info_test";s:169:"Regardless of a user\'s individual setting the Ω-button for switching on the special character selector will be displayed in the test. Special characters can be entered.";s:31:"char_selector_enabled_info_user";s:225:"In tests a menu for selecting special characters will be displayed. However individual tests can prevent this setting from becoming effective and not display the special character menu despite your choice about activating it.";s:26:"char_selector_enabled_test";s:32:"Special Character Selector is On";s:26:"char_selector_enabled_user";s:44:"Enable Menu for Selecting Special Characters";s:20:"char_selector_blocks";s:42:"Available Special Character Sets (Unicode)";s:25:"char_selector_blocks_info";s:119:"All characters of the selected blocks will be listed, but not all of them may be supported by the current browser font.";s:26:"char_selector_custom_items";s:16:"Custom Selection";s:32:"char_selector_custom_items_info1";s:114:"The custom selection will be listed before the selected blocks. Please add your characters in the following style:";s:33:"char_selector_custom_items_info2a";s:5:"A B C";s:33:"char_selector_custom_items_info2b";s:71:"Characters are separated by space, generating separate selector buttons";s:33:"char_selector_custom_items_info3a";s:6:"A BC D";s:33:"char_selector_custom_items_info3b";s:51:"It is possible to put more characters on one button";s:33:"char_selector_custom_items_info4a";s:3:"A-Z";s:33:"char_selector_custom_items_info4b";s:50:"Ranges of characters can be defined with a ‘-’";s:33:"char_selector_custom_items_info5a";s:6:"U+00C0";s:33:"char_selector_custom_items_info5b";s:70:"A character can also be defined in Unicode notation (case insensitive)";s:33:"char_selector_custom_items_info6a";s:13:"U+00C0-U+00CF";s:33:"char_selector_custom_items_info6b";s:44:"Ranges are also possible in Unicode notation";s:25:"char_selector_unicode_all";s:18:"All Unicode Blocks";s:27:"adve_char_selector_settings";s:18:"Character Selector";s:28:"advanced_editing_tst_editing";s:43:"Page Editor for additional question content";s:33:"advanced_editing_tst_editing_desc";s:63:"Activates ILIAS Page Editor for feedback and hint text editing.";s:41:"char_selector_msg_blocks_or_custom_needed";s:93:"When you activate the selector, please choose a character block or enter a special selection!";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'assessment'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1507:{s:23:"no_archive_on_anonymous";s:81:"Archiving is not possible in an anonymous test: option deactivated automatically.";s:8:"autosave";s:16:"Automatic saving";s:13:"autosave_info";s:74:"Answers are automatically saved in specified intervals to avoid data loss.";s:13:"autosave_ival";s:8:"Interval";s:3:"for";s:3:"for";s:50:"tst_objective_oriented_test_pass_without_questions";s:62:"The started pass for test "%s" does not contain any questions.";s:30:"tst_dyn_quest_set_pool_deleted";s:60:"The currently configured questionpool "%s" has been deleted.";s:34:"tst_old_style_rnd_quest_set_broken";s:162:"This random test is in a irreparable state, because one or more connected question pools have been deleted. Therefor participants cannot take the test any longer.";s:25:"solution_contain_keywords";s:67:"Score is granted based on the occurrence of the following keywords:";s:18:"essay_scoring_mode";s:12:"Scoring Mode";s:35:"essay_scoring_mode_without_keywords";s:20:"No Automatic Scoring";s:40:"essay_scoring_mode_without_keywords_desc";s:56:"No points are granted unless the tutor\'s manual scoring.";s:39:"essay_scoring_mode_keyword_relation_any";s:46:"Automatic Scoring with Keywords on Finding ANY";s:44:"essay_scoring_mode_keyword_relation_any_desc";s:73:"For any found keyword the corresponding points are granted automatically.";s:39:"essay_scoring_mode_keyword_relation_all";s:46:"Automatic Scoring with Keywords on Finding ALL";s:44:"essay_scoring_mode_keyword_relation_all_desc";s:64:"The points are granted automatically, if all keywords are found.";s:39:"essay_scoring_mode_keyword_relation_one";s:46:"Automatic Scoring with Keywords on Finding ONE";s:44:"essay_scoring_mode_keyword_relation_one_desc";s:71:"The points are granted automatically, if at least one keyword is found.";s:19:"mark_schema_invalid";s:66:"The mark schema does not validate. Please create a correct schema.";s:25:"assessment_scoring_adjust";s:18:"Enable corrections";s:30:"assessment_scoring_adjust_desc";s:78:"Enables the corrections feature to allow modifications to questions in a test.";s:42:"assessment_log_scoring_adjustment_activate";s:38:"Question types available in adjustment";s:38:"assessment_log_scoring_adjustment_desc";s:199:"Question types checked here are available in adjustment. This setting is regardless of the current ability of the question types, e.g. a question that does not support adjustment is still shown here.";s:17:"qpl_reset_preview";s:13:"Reset Preview";s:21:"qst_preview_reset_msg";s:27:"The preview has been reset.";s:11:"0_unlimited";s:13:"(0=unlimited)";s:31:"tst_question_not_from_pool_info";s:7:"No Pool";s:6:"action";s:6:"Action";s:13:"add_answer_tf";s:18:"True/False Answers";s:13:"add_answer_yn";s:14:"Yes/No Answers";s:10:"add_answer";s:10:"Add Answer";s:20:"add_applet_parameter";s:20:"Add Applet Parameter";s:8:"add_area";s:8:"Add Area";s:10:"add_circle";s:15:"Add circle area";s:7:"add_gap";s:12:"Add Gap Text";s:12:"add_imagemap";s:16:"Import Image Map";s:17:"add_matching_pair";s:17:"Add Matching Pair";s:8:"add_poly";s:16:"Add polygon area";s:16:"add_questionpool";s:17:"Add Question Pool";s:8:"add_rect";s:18:"Add rectangle area";s:12:"add_solution";s:22:"Add Suggested Solution";s:20:"addSuggestedSolution";s:30:"Add Content for Recapitulation";s:28:"all_available_question_pools";s:28:"All available question pools";s:12:"allow_images";s:25:"Image Support for Answers";s:22:"allowedextensions_info";s:144:"Enter a comma separated list of allowed file extensions if you want to restrict the upload to a given set of file extensions (e.g. doc,xls,odt).";s:17:"allowedextensions";s:23:"Allowed File Extensions";s:17:"analyze_errortext";s:18:"Analyze Error Text";s:12:"answer_image";s:12:"Answer Image";s:34:"answer_is_not_correct_but_positive";s:68:"You\'ve got points for your solution but it’s not the best solution";s:15:"answer_is_right";s:24:"Your solution is correct";s:15:"answer_is_wrong";s:22:"Your solution is wrong";s:17:"answer_characters";s:50:" characters allowed, entered number of characters:";s:14:"answer_picture";s:14:"Answer Picture";s:11:"answer_text";s:11:"Answer Text";s:12:"answer_types";s:12:"Answer Types";s:15:"gap_combination";s:15:"Gap Combination";s:6:"answer";s:6:"Answer";s:17:"answers_multiline";s:18:"Multi Line Answers";s:18:"answers_singleline";s:19:"Single Line Answers";s:17:"applet_attributes";s:17:"Applet Attributes";s:20:"applet_new_parameter";s:13:"New Parameter";s:16:"applet_parameter";s:9:"Parameter";s:17:"applet_parameters";s:17:"Applet Parameters";s:5:"apply";s:5:"Apply";s:22:"ass_create_export_file";s:23:"Create Test Export File";s:30:"ass_create_export_test_results";s:31:"Create Test Results Export File";s:30:"ass_create_export_test_archive";s:24:"Create Test Archive File";s:16:"ass_export_files";s:12:"Export Files";s:8:"ass_file";s:4:"File";s:12:"ass_question";s:8:"Question";s:8:"ass_size";s:4:"Size";s:12:"assClozeTest";s:14:"Cloze Question";s:12:"assErrorText";s:10:"Error Text";s:24:"assessment_eval_settings";s:53:"Show the following fields in Evaluation for All Users";s:13:"assFileUpload";s:20:"File Upload Question";s:16:"assFlashQuestion";s:14:"Flash Question";s:19:"assImagemapQuestion";s:29:"Hot Spot / Image Map Question";s:13:"assJavaApplet";s:20:"Java Applet Question";s:19:"assMatchingQuestion";s:17:"Matching Question";s:17:"assMultipleChoice";s:43:"Multiple Choice Question (Multiple Answers)";s:14:"assKprimChoice";s:40:"Multiple Choice Question (Kprim Answers)";s:10:"assNumeric";s:16:"Numeric Question";s:21:"assOrderingHorizontal";s:30:"Ordering Question (Horizontal)";s:19:"assOrderingQuestion";s:28:"Ordering Question (Vertical)";s:12:"assQuestions";s:9:"Questions";s:15:"assSingleChoice";s:40:"Multiple Choice Question (Single Answer)";s:15:"assTextQuestion";s:14:"Essay Question";s:13:"assTextSubset";s:20:"Text Subset Question";s:15:"autosave_failed";s:16:"Autosave failed!";s:16:"autosave_success";s:22:"Autosave successful...";s:16:"available_points";s:16:"Available Points";s:15:"available_terms";s:15:"Available Terms";s:22:"average_reached_points";s:14:"Average Points";s:17:"backtocallingtest";s:24:"Back to the calling test";s:2:"by";s:2:"by";s:11:"cancel_test";s:16:"Suspend the Test";s:17:"cannot_edit_marks";s:154:"There are already learners who ran the test. You can only change the marks if a score reporting date is enabled and the reporting date is not yet reached.";s:16:"cannot_edit_test";s:59:"You do not possess sufficient permissions to edit the test!";s:19:"cannot_execute_test";s:58:"You do not possess sufficient permissions to run the test!";s:17:"cannot_export_qpl";s:70:"You do not possess sufficient permissions to export the question pool!";s:18:"cannot_export_test";s:61:"You do not possess sufficient permissions to export the test!";s:20:"cannot_maintain_test";s:63:"You do not possess sufficient permissions to maintain the test!";s:24:"cannot_read_questionpool";s:73:"You do not possess sufficient permissions to read the question pool data!";s:22:"cannot_save_metaobject";s:64:"You do not possess sufficient permissions to save the meta data!";s:15:"change_solution";s:25:"Change Suggested Solution";s:21:"changelog_description";s:86:"The following table contains all changes of authors which have been made to this test.";s:17:"changelog_heading";s:9:"Changelog";s:23:"changeSuggestedSolution";s:33:"Select type of suggested solution";s:16:"checkbox_checked";s:7:"Checked";s:18:"checkbox_unchecked";s:9:"Unchecked";s:19:"circle_click_center";s:43:"Please click on center of the desired area.";s:19:"circle_click_circle";s:51:"Please click on a circle point of the desired area.";s:6:"circle";s:6:"Circle";s:8:"clientip";s:9:"Client IP";s:15:"close_text_hint";s:219:"To add a new gap set the cursor to the position of your choice and click the button ‘Insert Gap’. Corresponding editing sections will appear below. You can also edit gaps by clicking on the gaps within the gap text.";s:10:"insert_gap";s:10:"Insert Gap";s:34:"cloze_fixed_textlength_description";s:325:"If you enter a value, all text gap fields, not providing an own maximum character limitation, as well as all numeric gap fields will be created with a fixed length of this value, so entering more than the allowed characters is not possible. Note, that for numeric gaps the decimal separator is counted as a regular character.";s:34:"qpl_maxchars_info_numeric_question";s:254:"If you enter a value, the field for the numerical answer will be created with a fixed length of this value, so entering more than the allowed characters is not possible. Note, that for numeric gaps the decimal separator is counted as a regular character.";s:22:"cloze_fixed_textlength";s:17:"Text Field Length";s:10:"cloze_text";s:10:"Cloze Text";s:30:"cloze_textgap_case_insensitive";s:16:"Case Insensitive";s:28:"cloze_textgap_case_sensitive";s:14:"Case Sensitive";s:28:"cloze_textgap_levenshtein_of";s:26:"Levenshtein Distance of %s";s:20:"cloze_textgap_rating";s:15:"Text Gap Rating";s:31:"cloze_textgap_whitespace_before";s:27:"Whitespace before the value";s:30:"cloze_textgap_whitespace_after";s:27:"Whitespace behind the value";s:33:"cloze_textgap_multiple_whitespace";s:20:"Multiple Whitespaces";s:12:"out_of_range";s:12:"Out of range";s:4:"code";s:4:"Code";s:8:"codebase";s:8:"Codebase";s:13:"concatenation";s:13:"Concatenation";s:28:"confirm_delete_all_user_data";s:58:"Are you sure you want to remove all user data of the test?";s:31:"confirm_delete_single_user_data";s:68:"Are you sure you want to remove the test data of the selected users?";s:22:"confirm_sync_questions";s:143:"The question you changed is a copy which has been created for use with the active test. Do you want to change the original of the question too?";s:11:"coordinates";s:11:"Coordinates";s:19:"correct_solution_is";s:23:"The correct solution is";s:7:"counter";s:7:"Counter";s:11:"create_date";s:7:"Created";s:11:"create_gaps";s:23:"Create and Refresh Gaps";s:15:"create_imagemap";s:19:"Create an Image Map";s:10:"create_new";s:10:"Create New";s:23:"customstyle_description";s:132:"It is possible to use a custom style sheet for this test. Please select one of the available style sheets to assign it to this test.";s:11:"customstyle";s:12:"Custom Style";s:16:"definition_image";s:16:"Definition Image";s:15:"definition_text";s:15:"Definition Text";s:10:"definition";s:10:"Definition";s:11:"definitions";s:11:"Definitions";s:33:"delete_all_user_data_confirmation";s:69:"Do you really want to remove the test data of all users in this test?";s:20:"delete_all_user_data";s:29:"Remove Test Data of all Users";s:11:"delete_area";s:11:"Delete Area";s:19:"delete_image_header";s:12:"Remove image";s:21:"delete_image_question";s:39:"Do you really want to remove the image?";s:12:"delete_image";s:12:"Remove Image";s:16:"delete_user_data";s:34:"Remove Test Data of Selected Users";s:23:"deleteSuggestedSolution";s:30:"Remove this suggested solution";s:20:"description_maxchars";s:86:"If nothing entered the maximum number of characters for this text answer is unlimited.";s:26:"detail_ending_time_reached";s:85:"The time allotted for this test is now over. The test had not been available since %s";s:34:"detail_max_processing_time_reached";s:65:"You have reached the maximum allowed processing time of the test!";s:32:"detail_starting_time_not_reached";s:81:"You have not reached the start time of the test. The test will be available on %s";s:23:"detailed_evaluation_for";s:26:"Detailed Evaluation for %s";s:37:"detailed_evaluation_missing_active_id";s:71:"You must call the ‘Detailed Evaluation’ for a selected participant!";s:24:"detailed_evaluation_show";s:24:"Show Detailed Evaluation";s:19:"detailed_evaluation";s:19:"Detailed Evaluation";s:25:"detailed_output_printview";s:41:"Detailed Output with Question Print Views";s:25:"detailed_output_solutions";s:39:"Detailed Output with Question Solutions";s:15:"detailed_output";s:15:"Detailed Output";s:15:"direct_feedback";s:20:"Verify Your Solution";s:18:"disable_javascript";s:35:"Click to disable JavaScript support";s:34:"duplicate_matching_values_selected";s:44:"You have selected duplicate matching values!";s:30:"duplicate_order_values_entered";s:40:"You have entered duplicate order values!";s:9:"duplicate";s:9:"Duplicate";s:22:"ects_allow_ects_grades";s:43:"Show ECTS grade additional to received mark";s:24:"ects_fill_out_all_values";s:42:"Please enter a value for every ECTS grade!";s:18:"ects_grade_a_short";s:9:"EXCELLENT";s:12:"ects_grade_a";s:46:"outstanding performance with only minor errors";s:18:"ects_grade_b_short";s:9:"VERY GOOD";s:12:"ects_grade_b";s:47:"above the average standard but with some errors";s:18:"ects_grade_c_short";s:4:"GOOD";s:12:"ects_grade_c";s:52:"generally sound work with a number of notable errors";s:18:"ects_grade_d_short";s:12:"SATISFACTORY";s:12:"ects_grade_d";s:38:"fair but with significant shortcomings";s:18:"ects_grade_e_short";s:10:"SUFFICIENT";s:12:"ects_grade_e";s:38:"performance meets the minimum criteria";s:18:"ects_grade_f_short";s:4:"FAIL";s:12:"ects_grade_f";s:37:"considerable further work is required";s:19:"ects_grade_fx_short";s:4:"FAIL";s:13:"ects_grade_fx";s:56:"some more work required before the credit can be awarded";s:10:"ects_grade";s:10:"ECTS Grade";s:26:"ects_output_of_ects_grades";s:21:"Output of ECTS grades";s:18:"ects_range_error_a";s:56:"Please enter a value between 0 and 100 for ECTS grade A!";s:18:"ects_range_error_b";s:56:"Please enter a value between 0 and 100 for ECTS grade B!";s:18:"ects_range_error_c";s:56:"Please enter a value between 0 and 100 for ECTS grade C!";s:18:"ects_range_error_d";s:56:"Please enter a value between 0 and 100 for ECTS grade D!";s:18:"ects_range_error_e";s:56:"Please enter a value between 0 and 100 for ECTS grade E!";s:11:"use_ects_fx";s:22:"Use the ‘FX’ grade";s:17:"ects_fx_threshold";s:9:"Threshold";s:22:"ects_fx_threshold_info";s:69:"Please enter the required percentile for granting the ‘FX’ grade.";s:9:"edit_page";s:9:"Edit Page";s:13:"edit_question";s:13:"Edit Question";s:19:"edit_test_questions";s:9:"List View";s:19:"element_height_info";s:98:"This is the minimum height in pixels for term and definition/picture items during the test output.";s:14:"element_height";s:14:"Minimum Height";s:18:"empty_term_message";s:38:"There is a least one empty term field.";s:17:"empty_terms_exist";s:92:"There are already empty term fields. Please fill out these fields before you add more terms.";s:17:"enable_javascript";s:34:"Click to enable JavaScript support";s:7:"end_tag";s:7:"End Tag";s:19:"ending_time_reached";s:32:"You have reached the finish time";s:7:"enlarge";s:7:"Enlarge";s:20:"enter_anonymous_code";s:27:"Enter Anonymous Access Code";s:28:"enter_enough_positive_points";s:110:"The maximum available points must be greater than 0! Please enter sufficient positive points for your answers.";s:20:"err_no_numeric_value";s:28:"Please enter a numeric value";s:23:"error_cloze_not_numeric";s:29:"Please enter a numeric value.";s:20:"error_duplicate_term";s:43:"You selected a matching term more than once";s:28:"error_image_upload_copy_file";s:76:"There was an error moving the uploaded image file to its destination folder!";s:31:"error_image_upload_wrong_format";s:80:"Please upload a valid image file! Supported image formats are gif, jpeg and png.";s:24:"error_importing_question";s:77:"There was an error importing the question(s) from the file you have selected!";s:20:"error_no_lower_limit";s:27:"Please enter a lower bound.";s:20:"error_no_upper_limit";s:28:"Please enter an upper bound.";s:21:"error_open_image_file";s:28:"Error opening an image file!";s:20:"error_open_java_file";s:28:"Error opening a java applet!";s:32:"error_random_question_generation";s:221:"A fatal error occurred during the generation of your random questions for the test. Please contact your administrator with the following information: The system could not create an active ID for user ID %s and test ID %s.";s:21:"error_save_image_file";s:27:"Error saving an image file!";s:14:"errors_section";s:10:"Error Data";s:6:"errors";s:6:"Errors";s:14:"errortext_info";s:356:"Please enter the error text. To mark a word as an error please insert a hash sign (#) in front of the word. To mark a group of words as an error please encapsulate the words group between double brackets (i.e.: here is ((an example)) of it). If you press the &quot;Analyze Error Text&quot; button, all marked words will be extracted for further processing.";s:9:"errortext";s:10:"Error Text";s:21:"score_partsol_enabled";s:27:"Activate Half-Point Scoring";s:26:"score_partsol_enabled_info";s:205:"Usually the participant has to answer the question fully correct to get the configured points. With this option the participant gets the half of the configured points with at least three correct decisions.";s:12:"option_label";s:13:"Option Labels";s:17:"option_label_info";s:91:"The configured phrases will be used as label for the options selectable by the participant.";s:24:"option_label_right_wrong";s:13:"right / wrong";s:18:"option_label_right";s:5:"right";s:18:"option_label_wrong";s:5:"wrong";s:23:"option_label_plus_minus";s:5:"+ / -";s:17:"option_label_plus";s:1:"+";s:18:"option_label_minus";s:1:"-";s:30:"option_label_applicable_or_not";s:27:"applicable / not applicable";s:23:"option_label_applicable";s:10:"applicable";s:27:"option_label_not_applicable";s:14:"not applicable";s:28:"option_label_adequate_or_not";s:23:"adequate / not adequate";s:21:"option_label_adequate";s:8:"adequate";s:25:"option_label_not_adequate";s:12:"not adequate";s:19:"option_label_custom";s:18:"Userdefined Labels";s:24:"option_label_custom_true";s:20:"Label for ‘TRUE’";s:25:"option_label_custom_false";s:21:"Label for ‘FALSE’";s:22:"kprim_instruction_text";s:51:"You have to decide on every statement: [%s] or [%s]";s:18:"kprim_answers_info";s:323:"The multiple choice question type ‘four times decision right/wrong’ (Type K’, also known as Kprim) gives four answers or additions to a question or an incomplete statement. A decision about the correctness is to be done on all four answers/additions. The maximum points are granted only, if all decisions are correct.";s:12:"tst_feedback";s:8:"Feedback";s:16:"ass_process_lock";s:30:"Use Locking During Test Passes";s:21:"ass_process_lock_desc";s:115:"Without the use of any locking mechanism, race conditions are possible. This can lead to inconsistent test results.";s:21:"ass_process_lock_mode";s:26:"Lock Mode during Test Pass";s:26:"ass_process_lock_mode_file";s:20:"Use Filesystem Locks";s:31:"ass_process_lock_mode_file_desc";s:192:"This locking mechanism requests locks on empty files in the filesystem. Concurrent processes for the same user and the same test/question are waiting until the other process releases his lock.";s:24:"ass_process_lock_mode_db";s:24:"Use Database Table Locks";s:29:"ass_process_lock_mode_db_desc";s:225:"This locking mechanism locks tables within the database. Concurrent processes for the same or other users in the same or in another test for the same or another question are waiting until the other process releases his locks.";s:14:"eval_all_users";s:24:"Evaluation for All Users";s:18:"eval_choice_result";s:59:"The choice with the value %s is %s. You received %s points.";s:17:"eval_cloze_result";s:62:"Gap number %s with the value %s is %s. You received %s points.";s:18:"eval_concatenation";s:13:"Concatenation";s:9:"eval_data";s:15:"Evaluation Data";s:26:"eval_found_selected_groups";s:15:"Selected Groups";s:25:"eval_found_selected_users";s:14:"Selected Users";s:20:"eval_imagemap_result";s:54:"The image map selection is %s. You received %s points.";s:16:"eval_java_result";s:58:"The answer for the value %s is %s. You received %s points.";s:16:"eval_legend_link";s:72:"Please refer to the legend for the meaning of the column header symbols.";s:20:"eval_matching_result";s:56:"The matching pair %s - %s is %s. You received %s points.";s:17:"eval_order_result";s:57:"The order for the value %s is %s. You received %s points.";s:18:"eval_search_groups";s:6:"Groups";s:17:"eval_search_roles";s:5:"Roles";s:16:"eval_search_term";s:11:"Search Term";s:17:"eval_search_users";s:5:"Users";s:25:"eval_search_userselection";s:62:"Search the users you want to add to the statistical evaluation";s:19:"eval_selected_users";s:29:"Evaluation for Selected Users";s:13:"exp_eval_data";s:25:"Export evaluation data as";s:20:"exp_type_certificate";s:17:"Certificate (PDF)";s:14:"exp_type_excel";s:15:"Microsoft Excel";s:13:"exp_type_spss";s:27:"Comma Separated Value (CSV)";s:6:"export";s:6:"Export";s:41:"externalscript_additional_parameters_hint";s:151:"Enter the additional script parameters in key-value-coding and separate multiple key-value-pairs with a newline, e.g. <p>key1=Hello<br />key2=World</p>";s:36:"externalscript_additional_parameters";s:17:"Script Parameters";s:22:"externalscript_use_kvc";s:54:"Please use key-value-coding for the script parameters!";s:15:"failed_official";s:6:"failed";s:12:"failed_short";s:6:"failed";s:5:"false";s:5:"False";s:16:"feedback_generic";s:24:"Common Solution Feedback";s:26:"feedback_complete_solution";s:16:"Correct solution";s:28:"feedback_incomplete_solution";s:34:"At least one answer is not correct";s:16:"feedback_answers";s:25:"Feedback for Every Answer";s:12:"file_uploads";s:12:"File Uploads";s:12:"fileDownload";s:13:"File download";s:26:"fill_out_all_answer_fields";s:64:"Please fill out all answer text fields before you add a new one!";s:27:"fill_out_all_matching_pairs";s:60:"Please fill out all matching pairs before you add a new one!";s:39:"fill_out_all_required_fields_add_answer";s:59:"Please fill out all required fields before you add answers!";s:41:"fill_out_all_required_fields_add_matching";s:67:"Please fill out all required fields before you add a matching pair!";s:40:"fill_out_all_required_fields_create_gaps";s:59:"Please fill out all required fields before you create gaps!";s:41:"fill_out_all_required_fields_upload_image";s:61:"Please fill out all required fields before you upload images!";s:44:"fill_out_all_required_fields_upload_imagemap";s:65:"Please fill out all required fields before you upload image maps!";s:44:"fill_out_all_required_fields_upload_material";s:64:"Please fill out all required fields before you upload materials!";s:25:"filter_all_question_types";s:18:"All Question Types";s:24:"filter_all_questionpools";s:18:"All Question Pools";s:26:"filter_show_question_types";s:19:"Show Question Types";s:25:"filter_show_questionpools";s:19:"Show Question Pools";s:12:"filter_users";s:12:"Filter Users";s:6:"filter";s:6:"Filter";s:25:"final_statement_show_desc";s:55:"Shows concluding remarks after the test  was submitted.";s:15:"final_statement";s:18:"Concluding Remarks";s:23:"fixed_participants_hint";s:195:"This test is only accessible for the manually added participants listed below. You can disable this setting by deactivating the checkbox ‘Manually Selected Participants’ in the test settings.";s:36:"tst_res_jump_to_participant_hint_opt";s:23:"--Jump to Participant--";s:31:"tst_res_jump_to_participant_btn";s:4:"Jump";s:32:"tst_participant_fullname_pattern";s:10:"%2$s, %1$s";s:9:"flashfile";s:10:"Flash File";s:12:"forcejs_desc";s:117:"If checked, JavaScript output will be chosen for test questions if a JavaScript output and a fallback solution exist.";s:13:"forcejs_short";s:16:"Force JavaScript";s:7:"forcejs";s:42:"Force JavaScript output for test questions";s:28:"form_msg_area_missing_points";s:34:"Please enter points for all areas.";s:18:"tst_reporting_date";s:4:"Date";s:14:"gap_definition";s:14:"Gap Definition";s:13:"gap_selection";s:13:"Gap Selection";s:3:"gap";s:3:"Gap";s:7:"general";s:7:"General";s:13:"glossary_term";s:13:"Glossary Term";s:22:"graphical_answers_hide";s:29:"Hide Graphical Answer Support";s:22:"graphical_answers_show";s:29:"Show Graphical Answer Support";s:17:"graphical_answers";s:24:"Graphical Answer Support";s:6:"height";s:6:"Height";s:22:"identical_scoring_desc";s:188:"If selected, gaps with identical solutions will be scored, even if the same solution was used twice or more. If not selected, only the first occurrence of the same solution will be scored.";s:17:"identical_scoring";s:17:"Identical Scoring";s:13:"imagemap_file";s:14:"Image Map File";s:15:"imagemap_source";s:16:"Image Map Source";s:8:"imagemap";s:9:"Image Map";s:17:"import_errors_qti";s:63:"The were errors parsing the QTI file. The import was cancelled.";s:15:"import_question";s:18:"Import Question(s)";s:12:"insert_after";s:12:"Insert After";s:13:"insert_before";s:13:"Insert Before";s:21:"internal_links_update";s:6:"Update";s:14:"internal_links";s:14:"Internal Links";s:10:"javaapplet";s:11:"Java Applet";s:13:"keywords_hint";s:271:"Enter a list of keywords, separated by spaces or newlines to add an automatic scoring option for the essay question. If any of the keywords will be found in the answer text of the learner, the default score will be set to the maximum available points instead of 0 points.";s:17:"kiosk_description";s:364:"Exam view runs test in kiosk mode. This hides the browser bar and navigation and all other screen elements that are not part of the test. Participants are prevented from opening an other website.<br />Effectively preventing participants from opening other websites during tests additinally requires deploying a suitable browser enviroment (e.g. Safe Exam Browser).";s:18:"kiosk_options_desc";s:58:"Information is displayed at the top section of the screen.";s:13:"kiosk_options";s:17:"Exam View Options";s:22:"kiosk_show_participant";s:24:"Show Name of Participant";s:16:"kiosk_show_title";s:15:"Show Test Title";s:5:"kiosk";s:9:"Exam View";s:11:"last_update";s:11:"Last Update";s:6:"legend";s:6:"Legend";s:6:"locked";s:6:"locked";s:25:"log_answer_changed_points";s:68:"Manual change of points of test person %s from %d to %d points by %s";s:50:"log_could_not_enter_test_due_to_simultaneous_users";s:99:"The user could not enter the test because the maximum number of simultaneous users has been reached";s:19:"log_create_new_test";s:16:"Created new test";s:19:"log_manual_feedback";s:63:"%s added manual feedback for test person %s and question %s: %s";s:14:"log_mark_added";s:10:"Mark added";s:16:"log_mark_changed";s:12:"Mark changed";s:16:"log_mark_removed";s:12:"Mark removed";s:17:"log_modified_test";s:21:"The test was modified";s:18:"log_question_added";s:26:"Question added at position";s:29:"log_question_position_changed";s:25:"Question position changed";s:20:"log_question_removed";s:16:"Question removed";s:30:"log_random_question_pool_added";s:70:"Added the question pool ‘%s‘ with %s questions for the random test";s:32:"log_random_question_pool_deleted";s:46:"Removed all random question pools for the test";s:30:"log_selected_user_data_removed";s:28:"Removed test data of user %s";s:29:"log_total_amount_of_questions";s:59:"Set the total amount of questions for the random test to %s";s:26:"log_user_answered_question";s:47:"User answered a question and received %s points";s:21:"log_user_data_removed";s:21:"Removed all user data";s:23:"log_user_entered_values";s:19:"User entered values";s:27:"log_user_not_entered_values";s:25:"User did not enter values";s:11:"maintenance";s:11:"Maintenance";s:15:"manscoring_done";s:19:"Scored Participants";s:15:"manscoring_hint";s:248:"You have added at least one question which may require manual scoring. To guarantee a valid presentation of the test results for the participants it is strongly recommended to restrict the access to the test results using a specified date and time.";s:15:"manscoring_none";s:21:"Unscored Participants";s:22:"manscoring_not_allowed";s:95:"The Manual Scoring wasn‘t activated for a question type. You are not allowed to use this tab.";s:18:"manscoring_pending";s:29:"Partially Scored Participants";s:30:"manscoring_questions_not_found";s:76:"This test pass does not contain question types which can be scored manually.";s:23:"manscoring_results_pass";s:35:"Manual Scored Questions for Pass %s";s:22:"manscoring_select_user";s:53:"Please select a participant to set the score manually";s:10:"manscoring";s:14:"Manual Scoring";s:11:"mark_schema";s:11:"Mark Schema";s:25:"grading_status_passed_msg";s:44:"Congratulations, you <b>passed</b> the test.";s:25:"grading_status_failed_msg";s:34:"Sorry, you <b>failed</b> the test.";s:32:"grading_obligations_answered_msg";s:40:"You filled out all compulsory questions.";s:31:"grading_obligations_missing_msg";s:49:"You didn‘t filled out all compulsory questions.";s:16:"grading_mark_msg";s:32:"Your mark is: &quot;[mark]&quot;";s:13:"mark_tst_ects";s:41:"Your ECTS grade is &quot;[markects]&quot;";s:27:"match_terms_and_definitions";s:27:"Match Terms and Definitions";s:24:"match_terms_and_pictures";s:24:"Match Terms and Pictures";s:7:"matches";s:7:"matches";s:13:"matching_pair";s:13:"Matching Pair";s:14:"matching_pairs";s:14:"Matching Pairs";s:33:"matching_question_javascript_hint";s:158:"Please drag a definition/picture on the right side over a term on the left side and drop the definition/picture to match the term with the definition/picture.";s:28:"matching_shuffle_definitions";s:16:"Definitions only";s:25:"matching_shuffle_pictures";s:13:"Pictures only";s:34:"matching_shuffle_terms_definitions";s:28:"Both (Terms and Definitions)";s:31:"matching_shuffle_terms_pictures";s:25:"Both (Terms and Pictures)";s:22:"matching_shuffle_terms";s:10:"Terms only";s:13:"matching_type";s:25:"Matching Question Subtype";s:17:"material_download";s:20:"Material to Download";s:13:"material_file";s:13:"Material File";s:8:"material";s:8:"Material";s:8:"maxchars";s:28:"Maximum Number of Characters";s:27:"maximum_nr_of_tries_reached";s:88:"You have reached the maximum number of passes for this test. The test cannot be entered!";s:14:"maximum_points";s:24:"Maximum Available Points";s:12:"maxsize_info";s:165:"Enter the maximum size in bytes that should be allowed for file uploads. If you leave this field empty, the maximum size of this installation will be chosen instead.";s:7:"maxsize";s:24:"Maximum file upload size";s:7:"meaning";s:7:"Meaning";s:19:"min_percentage_ne_0";s:82:"You must define a minimum percentage of 0 percent! The mark schema wasn’t saved.";s:16:"msg_circle_added";s:12:"Circle added";s:33:"tst_rnd_quest_set_tb_add_pool_btn";s:35:"New Rule for Selection of Questions";s:33:"tst_src_quest_pool_def_list_table";s:39:"Rules for Random Selection of Questions";s:24:"tst_source_question_pool";s:13:"Question Pool";s:19:"tst_filter_taxonomy";s:8:"Taxonomy";s:19:"tst_filter_tax_node";s:13:"Taxonomy Node";s:21:"tst_introduction_text";s:20:"Introductory Message";s:28:"tst_save_and_create_new_rule";s:21:"Save and Add New Rule";s:40:"tst_msg_random_qsc_modified_add_new_rule";s:109:"The configuration for the random set of questions has been modified successfully. You can add a new rule now.";s:43:"tst_msg_random_question_set_config_modified";s:81:"The configuration for the random set of questions has been modified successfully.";s:34:"tst_msg_random_question_set_synced";s:79:"The questions for the current configuration has been synchronized successfully.";s:37:"tst_btn_rebuild_random_question_stage";s:31:"Synchronize Questions from Pool";s:43:"tst_msg_rand_quest_set_stage_pool_last_sync";s:153:"A test with a random set of questions is possible with the current configuration.<br />Date of last synchronisation of selected question pools: <b>%s</b>";s:41:"tst_msg_rand_quest_set_pass_not_buildable";s:127:"A test with a random set of questions is not possible with the current selection of question pools and the amount of questions.";s:39:"tst_msg_rand_quest_set_no_src_pool_defs";s:99:"A test with a random set of questions is not possible without selecting at least one question pool.";s:50:"tst_msg_rand_quest_set_incomplete_quest_amount_cfg";s:102:"A test with a random set of questions is not possible without a correctly defined amount of questions.";s:41:"tst_msg_rand_quest_set_no_pools_available";s:109:"Currently you cannot add new rules for the question selection, because there are no question pools available.";s:47:"tst_msg_rand_quest_set_change_quest_amount_here";s:43:"You can change the question amount here: %s";s:31:"tst_rnd_quest_set_cfg_pool_form";s:31:"Rule for Selection of Questions";s:25:"tst_inp_source_pool_label";s:13:"Question Pool";s:30:"tst_inp_source_pool_filter_tax";s:15:"Taxonomy Filter";s:33:"tst_inp_source_pool_no_tax_filter";s:28:"Use No Taxonomy Based Filter";s:32:"tst_inp_source_pool_filter_tax_x";s:27:"Use Taxonomy "%s" as Filter";s:29:"tst_inp_no_available_tax_hint";s:50:"No Available Taxonomies for Selected Question Pool";s:39:"tst_msg_source_pool_definitions_deleted";s:39:"The rule has been removed successfully.";s:21:"tst_limit_nr_of_tries";s:27:"Limit Number of Test Passes";s:24:"msg_deleted_export_files";s:22:"Export file(s) removed";s:27:"msg_number_of_terms_too_low";s:74:"The number of terms must be greater or equal to the number of definitions.";s:14:"msg_poly_added";s:13:"Polygon added";s:26:"msg_question_count_too_low";s:44:"Please enter a question count greater than 0";s:19:"msg_questions_moved";s:17:"Question(s) moved";s:14:"msg_rect_added";s:15:"Rectangle added";s:21:"msg_selected_for_move";s:31:"Question(s) selected for moving";s:21:"no_selection_for_move";s:31:"No question selected for moving";s:28:"msg_total_questions_too_high";s:104:"The number of questions is greater than the number of available questions in the selected question pools";s:22:"multiline_answers_hide";s:23:"Use Single-Line Answers";s:22:"multiline_answers_show";s:22:"Use Multi-Line Answers";s:20:"multiline_terms_hide";s:21:"Use Single-Line Terms";s:20:"multiline_terms_show";s:20:"Use Multi-Line Terms";s:27:"negative_points_not_allowed";s:45:"You are not allowed to enter negative points!";s:18:"next_question_rows";s:26:"Questions %d - %d of %d »";s:14:"no_passed_mark";s:72:"You must set at least one mark to PASSED! The mark schema was not saved.";s:29:"no_question_selected_for_move";s:46:"Please check at least one question to move it!";s:22:"no_questions_available";s:33:"There are no questions available!";s:12:"no_selection";s:20:"--- No Selection ---";s:27:"no_target_selected_for_move";s:34:"You must select a target position!";s:16:"no_terms_message";s:29:"Please add at least one term.";s:25:"no_user_or_group_selected";s:73:"Please check an option what are you searching for (users, groups, roles)!";s:16:"not_yet_accessed";s:16:"Not yet accessed";s:21:"nr_of_correct_answers";s:27:"Number of Requested Answers";s:17:"number_of_answers";s:17:"Number of Answers";s:11:"numeric_gap";s:11:"Numeric Gap";s:35:"online_exam_show_answer_print_sheet";s:164:"You have finished your online exam. To call the print view of answers and to print out your test results, please press the &quot;Answers’ print view&quot; button.";s:28:"online_exam_show_finish_test";s:146:"You still have to call the final submission of your online exam. Please press the &quot;Finish the test&quot; button to call the final submission.";s:17:"optional_keywords";s:26:"Optional input of keywords";s:2:"or";s:2:"or";s:25:"oq_btn_use_order_pictures";s:19:"Use answer pictures";s:22:"oq_btn_use_order_terms";s:16:"Use answer terms";s:33:"ordering_question_javascript_hint";s:192:"Please drag a definition/picture over the definition/picture where you want to put it and drop it. The underlying definition/picture and all following definitions/pictures will move downwards.";s:14:"ordertext_info";s:225:"Please enter the text that should be ordered horizontally. The ordering text will be separated by the whitespace signs in the text. If you need a different separation, you may use the separator %s to separate your text units.";s:9:"ordertext";s:13:"Ordering Text";s:11:"output_mode";s:11:"Output Mode";s:6:"output";s:6:"Output";s:17:"participants_data";s:17:"Participants Data";s:23:"participants_evaluation";s:36:"Evaluation for all Test Participants";s:35:"participants_invitation_description";s:90:"This test can only be accessed by users you have manually added in tab ‘Participants’.";s:43:"participants_invitation_search_introduction";s:190:"To add defined participants to this test, please select the users in the search below form and invite them into the test. All test participants will be shown on the Participants Data subtab.";s:23:"participants_invitation";s:30:"Manually Selected Participants";s:12:"participants";s:12:"Participants";s:13:"pass_finished";s:7:"%s pass";s:4:"pass";s:4:"Pass";s:15:"passed_official";s:6:"passed";s:11:"passed_only";s:17:"Passed Tests Only";s:12:"passed_short";s:6:"passed";s:15:"passes_finished";s:9:"%s passes";s:17:"percentage_solved";s:46:"You have solved %.2f percent of this question!";s:10:"percentage";s:10:"Percentage";s:10:"percentile";s:10:"Percentile";s:7:"picture";s:7:"Picture";s:13:"please_select";s:19:"-- please select --";s:5:"point";s:5:"Point";s:14:"points_checked";s:19:"Points when Checked";s:12:"points_short";s:3:"Pt.";s:16:"points_unchecked";s:21:"Points when Unchecked";s:17:"points_wrong_info";s:94:"Enter the negative points for each selected word that is not in the list of the marked errors.";s:12:"points_wrong";s:16:"Wrong Selections";s:6:"points";s:6:"Points";s:26:"polygon_click_next_or_save";s:140:"Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)";s:24:"polygon_click_next_point";s:46:"Please click on the next point of the polygon.";s:28:"polygon_click_starting_point";s:50:"Please click on the starting point of the polygon.";s:7:"polygon";s:7:"Polygon";s:8:"postpone";s:17:"Postpone Question";s:10:"remove_gap";s:10:"Remove Gap";s:9:"postponed";s:9:"postponed";s:15:"postpone_status";s:9:"Postponed";s:7:"preview";s:7:"Preview";s:22:"previous_question_rows";s:26:"<< Questions %d - %d of %d";s:13:"print_answers";s:13:"Print Answers";s:34:"qpl_qst_edit_form_taxonomy_section";s:10:"Taxonomies";s:26:"qpl_qst_edit_form_taxonomy";s:13:"Taxonomy "%s"";s:32:"qpl_answertext_fields_not_filled";s:73:"The question could only be saved, if you fill out all answer text fields!";s:41:"qpl_assessment_no_assessment_of_questions";s:111:"There is no assessment of questions available for the selected question. The question was never used in a test.";s:27:"qpl_assessment_of_questions";s:23:"Assessment of Questions";s:31:"qpl_assessment_total_of_answers";s:16:"Total of Answers";s:37:"qpl_assessment_total_of_right_answers";s:66:"Total Percentage of Correct Answers (percentage of maximum points)";s:28:"qpl_confirm_delete_questions";s:56:"Are you sure you want to remove the following questions?";s:25:"qpl_copy_insert_clipboard";s:52:"The selected question(s) are copied to the clipboard";s:20:"qpl_copy_select_none";s:62:"Please check at least one question to copy it to the clipboard";s:42:"qpl_delete_describe_undeleteable_questions";s:86:"The following questions are in use in random tests. You cannot remove these questions:";s:34:"qpl_delete_no_deleteable_questions";s:61:"All questions you tried to remove are in use in a random test";s:21:"qpl_delete_rbac_error";s:43:"You have no rights to remove this question!";s:22:"qpl_delete_select_none";s:47:"Please check at least one question to remove it";s:26:"qpl_display_fullsize_image";s:41:"Click here to display the original image!";s:19:"qpl_edit_rbac_error";s:41:"You have no rights to edit this question!";s:24:"qpl_edit_select_multiple";s:42:"Please check only one question for editing";s:20:"qpl_edit_select_none";s:37:"Please check one question for editing";s:16:"qpl_export_excel";s:20:"Microsoft Excel File";s:22:"qpl_export_select_none";s:47:"Please check at least one question to export it";s:14:"qpl_export_xml";s:12:"QTI XML File";s:47:"qpl_settings_general_form_property_nav_taxonomy";s:34:"Taxonomy Filter as Navigation Tree";s:59:"qpl_settings_general_form_property_nav_taxonomy_description";s:100:"When a taxonomy is selected, it well be presented as navigation tree instead of a table filter item.";s:53:"qpl_settings_general_form_property_opt_notax_selected";s:29:"Use No Navigation Tree Filter";s:17:"tst_pass_deletion";s:15:"Previous Passes";s:29:"tst_pass_deletion_not_allowed";s:46:"The Deletion of Previous Passes is NOT allowed";s:25:"tst_pass_deletion_allowed";s:42:"The Deletion of Previous Passes is allowed";s:22:"qpl_general_properties";s:18:"General Properties";s:28:"qpl_imagemap_preview_missing";s:310:"ILIAS could not create the temporary preview file containing the image map areas. The original image is shown instead. This means that either the web server‘s ImageMagick tool isn‘t configured correctly or there are no write permissions in the temporary directory! Please contact your system administrator.";s:25:"qpl_import_create_new_qpl";s:43:"Import the questions in a new question pool";s:19:"qpl_import_no_items";s:45:"Error: The import file contains no questions!";s:26:"qpl_import_non_ilias_files";s:163:"Error: The import file contains QTI files which are not created by an ILIAS system. Please contact the ILIAS team to get in import filter for your QTI file format.";s:24:"tst_import_non_ilias_zip";s:83:"Error: The filename of the uploaded import file does not match the expected format.";s:33:"qpl_import_verify_found_questions";s:103:"ILIAS found the following questions in the import file. Please select the questions you want to import.";s:25:"qpl_move_insert_clipboard";s:46:"The selected question(s) are marked for moving";s:20:"qpl_move_select_none";s:58:"Please check at least one question to select it for moving";s:27:"qpl_settings_subtab_general";s:16:"General Settings";s:30:"qpl_settings_subtab_taxonomies";s:10:"Taxonomies";s:25:"qpl_form_general_settings";s:16:"General Settings";s:53:"qpl_settings_general_form_property_online_description";s:50:"Only online question pools could be used in tests.";s:41:"qpl_settings_general_form_property_online";s:6:"Online";s:44:"qpl_settings_general_form_prop_show_tax_desc";s:66:"When enabled, possibly created taxonomies are shown for filtering.";s:50:"qpl_settings_general_form_property_show_taxonomies";s:15:"Show Taxonomies";s:20:"qpl_paste_no_objects";s:91:"There are no questions in the clipboard. Please copy or move a question into the clipboard.";s:17:"qpl_paste_success";s:55:"The question(s) have been pasted into the question pool";s:15:"qpl_paste_error";s:142:"At least one question could not pe pasted into the question pool. Possible reason: You tried to move the question into the same question pool.";s:22:"qpl_question_is_in_use";s:216:"The question you are about to edit exists in %s test(s). If you change this question, you will NOT change the question(s) in the test(s), because the system creates a copy of a question when it is inserted in a test!";s:21:"qpl_questions_deleted";s:20:"Question(s) removed.";s:26:"qpl_select_file_for_import";s:34:"You must select a file for import!";s:25:"qpl_qst_inp_matching_mode";s:13:"Matching Mode";s:36:"qpl_qst_inp_matching_mode_one_on_one";s:37:"One Term Matches One Definition (1:1)";s:36:"qpl_qst_inp_matching_mode_all_on_all";s:53:"One or More Terms match One or More Definitions (n:n)";s:13:"qst_hint_self";s:95:"Self-Assessment-Mode active! Enter 0 points for incorrect answers, 1 point for correct answers.";s:15:"qst_nr_of_tries";s:15:"Number of Tries";s:18:"qt_multiple_choice";s:24:"Multiple Choice Question";s:29:"question_cumulated_statistics";s:29:"Cumulated Question Statistics";s:24:"question_instances_title";s:44:"This question is used in the following tests";s:28:"question_marking_description";s:148:"Participants get the option to flag a test question for some purpose. The flags are shown in ‘List of Questions’, provided that it is activated.";s:16:"question_marking";s:18:"Flagging Questions";s:21:"question_not_answered";s:29:"The question was not answered";s:25:"question_saved_for_upload";s:224:"The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!";s:14:"question_short";s:1:"Q";s:16:"question_summary";s:17:"List of Questions";s:19:"obligations_summary";s:28:"List of Compulsory Questions";s:36:"tst_you_have_to_answer_this_question";s:63:"You have to answer this question to be able to finish the test.";s:14:"question_title";s:14:"Question Title";s:13:"question_type";s:13:"Question Type";s:24:"questionpool_not_entered";s:40:"Please enter a name for a question pool!";s:14:"questions_from";s:14:"questions from";s:9:"radio_set";s:3:"Set";s:11:"radio_unset";s:5:"Unset";s:20:"random_accept_sample";s:13:"Accept Sample";s:21:"random_another_sample";s:18:"Get another Sample";s:16:"random_selection";s:16:"Random Selection";s:34:"tst_rnd_quest_set_cfg_general_form";s:33:"Configure Random Set of Questions";s:17:"range_lower_limit";s:11:"Lower Bound";s:17:"range_upper_limit";s:11:"Upper Bound";s:5:"range";s:5:"Range";s:25:"rectangle_click_br_corner";s:60:"Please click on the bottom right corner of the desired area.";s:25:"rectangle_click_tl_corner";s:56:"Please click on the top left corner of the desired area.";s:9:"rectangle";s:9:"Rectangle";s:17:"redirectAfterSave";s:137:"The maximum working time has been reached and your last question has been saved automatically. In a few seconds you will be redirected...";s:6:"region";s:6:"Region";s:21:"remove_as_participant";s:27:"Remove as Fixed Participant";s:15:"remove_question";s:6:"Remove";s:15:"remove_solution";s:25:"Remove Suggested Solution";s:23:"report_date_not_reached";s:88:"You have not reached the reporting date. You will be able to view the test results at %s";s:17:"reset_definitions";s:26:"Reset Definition Positions";s:12:"reset_filter";s:12:"Reset Filter";s:14:"reset_pictures";s:23:"Reset Picture Positions";s:11:"reset_terms";s:20:"Reset Term Positions";s:13:"resize_images";s:13:"Resize Images";s:23:"result_successful_saved";s:40:"Your results have been saved successful!";s:25:"result_unsuccessful_saved";s:47:"There was an error saving the question results!";s:6:"result";s:6:"Result";s:27:"save_before_upload_imagemap";s:63:"You must apply your changes before you can upload an image map!";s:29:"save_before_upload_javaapplet";s:64:"You must apply your changes before you can upload a Java applet!";s:9:"save_edit";s:21:"Save and Edit Content";s:11:"save_finish";s:15:"Finish the Test";s:17:"save_introduction";s:26:"Go to Introductory Message";s:32:"save_back_to_objective_container";s:12:"Go to Course";s:9:"save_next";s:4:"Next";s:13:"save_previous";s:8:"Previous";s:23:"save_text_answer_points";s:17:"Save Essay Points";s:11:"scored_pass";s:11:"Scored Pass";s:7:"scoring";s:19:"Scoring and Results";s:19:"search_found_groups";s:12:"Found Groups";s:18:"search_found_users";s:11:"Found Users";s:13:"search_groups";s:13:"Search Groups";s:14:"search_results";s:14:"Search Results";s:12:"search_roles";s:12:"Search Roles";s:11:"search_term";s:11:"Search Term";s:12:"search_users";s:12:"Search Users";s:35:"see_details_for_further_information";s:35:"See details for suggested solutions";s:16:"select_an_answer";s:31:"--- Please select an answer ---";s:10:"select_gap";s:10:"Select Gap";s:19:"select_max_one_item";s:27:"Please select one item only";s:25:"select_one_submitted_test";s:53:"Please select at least one user who finished the test";s:15:"select_one_user";s:32:"Please select at least one user.";s:17:"select_qpl_option";s:37:"--- Please select a question pool ---";s:40:"select_target_position_for_move_question";s:92:"Please select a target position to move the question(s) and press one of the insert buttons!";s:17:"select_tst_option";s:28:"--- Please select a test ---";s:14:"selected_image";s:14:"Selected Image";s:9:"selection";s:9:"Selection";s:13:"set_edit_mode";s:13:"Set Edit Mode";s:10:"set_filter";s:10:"Set Filter";s:19:"set_manscoring_done";s:32:"Mark as ‘Scored Participant’";s:19:"set_manual_feedback";s:15:"Manual Feedback";s:5:"shape";s:5:"Shape";s:21:"show_detailed_results";s:44:"Show User’s Detailed Results (Marked Pass)";s:18:"show_pass_overview";s:25:"Show Marked Pass Overview";s:17:"show_user_answers";s:28:"Show User’s Marked Answers";s:13:"showinfo_desc";s:125:"Users will be presented with a complete list of test properties on tab ‘Info’, i.e. information on scoring and reporting.";s:8:"showinfo";s:24:"Show all Test Properties";s:21:"showSuggestedSolution";s:4:"Type";s:15:"shuffle_answers";s:15:"Shuffle Answers";s:18:"suggested_solution";s:26:"Content for Recapitulation";s:13:"solution_hint";s:35:"Assigned Content for Recapitulation";s:29:"solution_may_contain_keywords";s:54:"The solution may contain one of the following keywords";s:14:"solution_order";s:14:"Solution Order";s:12:"solutionText";s:4:"Text";s:9:"start_tag";s:9:"Start Tag";s:25:"starting_time_not_reached";s:35:"You have not reached the start time";s:16:"statistical_data";s:16:"Statistical Data";s:10:"statistics";s:10:"Statistics";s:37:"suggested_solution_added_successfully";s:42:"You successfully set a suggested solution!";s:21:"suggestedSolutionType";s:8:"refer to";s:6:"symbol";s:6:"Symbol";s:10:"term_image";s:10:"Term Image";s:9:"term_text";s:9:"Term Text";s:4:"term";s:4:"Term";s:5:"terms";s:5:"Terms";s:14:"test_cancelled";s:22:"The test was cancelled";s:14:"test_reference";s:14:"Test Reference";s:18:"text_answers_saved";s:22:"Essay points modified!";s:12:"text_correct";s:12:"Correct Text";s:8:"text_gap";s:8:"Text Gap";s:26:"text_maximum_chars_allowed";s:91:"Please do not enter more than a maximum of %s characters. Any characters above will be cut.";s:11:"text_rating";s:20:"Text Matching Method";s:10:"text_wrong";s:10:"Wrong Text";s:23:"textsize_errortext_info";s:91:"Enter the text size of the error text in percent if you want another size than 100 percent.";s:13:"textsize_info";s:94:"Enter the text size of the ordering text in percent if you want another size than 100 percent.";s:8:"textsize";s:9:"Text Size";s:19:"thumb_geometry_info";s:109:"The image thumbnails will be created with a maximum values of height and width given, aspect ratio preserved.";s:14:"thumb_geometry";s:18:"Thumbnail Geometry";s:15:"thumb_size_info";s:158:"If you enter a thumbnail size, a thumbnail of this size will be generated for uploaded images. Without a thumbnail size, the original image size will be used.";s:21:"thumb_size_unit_pixel";s:5:"Pixel";s:10:"thumb_size";s:14:"Thumbnail Size";s:11:"time_format";s:8:"HH MM SS";s:25:"too_many_empty_parameters";s:76:"Please fill out your empty applet parameters before you add a new parameter!";s:34:"too_many_targets_selected_for_move";s:44:"You must select exactly one target position!";s:4:"true";s:4:"True";s:23:"tst_access_code_created";s:204:"To provide you with permanent access to your test results and to offer you a possibility to resume this test, a unique test access code was created. Please write down this code use it for further actions.";s:25:"tst_all_user_data_deleted";s:44:"All user data of this test has been removed!";s:30:"tst_allow_instant_verification";s:37:"Allow instant verification of answers";s:26:"tst_allowed_users_time_gap";s:26:"Idle Time for Active Users";s:17:"tst_allowed_users";s:39:"Limit Number of Concurrent Participants";s:21:"tst_already_submitted";s:43:"Test has already been finish and submitted.";s:17:"tst_already_taken";s:19:"Tests Already Taken";s:13:"tst_anonymity";s:11:"Test Record";s:16:"tst_answer_sheet";s:17:"Test Answer Sheet";s:27:"tst_answered_questions_test";s:31:"Questions answered in this test";s:22:"tst_answered_questions";s:18:"Answered Questions";s:20:"tst_best_solution_is";s:20:"The best solution is";s:24:"tst_browse_for_questions";s:13:"Add from Pool";s:30:"tst_change_points_for_question";s:21:"Points for the Answer";s:31:"tst_confirm_delete_results_info";s:90:"Your previous entered question results were removed. You have successfully reset the test!";s:26:"tst_confirm_delete_results";s:287:"You are about to remove all your previous entered question results of this test. This will reset all questions to its default values. Please note, that you cannot reset the number of passes, you already needed for this test. Do you really want to reset all your previous entered results?";s:17:"tst_confirm_print";s:111:"Press button to print all questions with points and solution. The question always appears at the end of a page.";s:26:"tst_confirm_submit_answers";s:123:"Please confirm your submission of your solution. You won\'t be able to revert your answers after pressing the submit button.";s:27:"tst_count_correct_solutions";s:46:"Only Correct and Complete Answers Score Points";s:32:"tst_count_correct_solutions_desc";s:127:"Participants score either the maximum number of points for a fully correct and complete answer or 0 points in every other case.";s:27:"tst_count_partial_solutions";s:47:"Incomplete or Partly Wrong Answers Score Points";s:32:"tst_count_partial_solutions_desc";s:129:"Points for correctly provided partial answers are added up: Participants can score points for incomplete or partly wrong answers.";s:20:"tst_defaults_applied";s:45:"The selected test defaults have been applied.";s:31:"tst_defaults_apply_not_possible";s:117:"ILIAS could not apply the selected test defaults to this test! Maybe this test already contains participant datasets.";s:29:"tst_defaults_apply_select_one";s:79:"Please select exact one test defaults entry to apply the defaults to this test!";s:22:"tst_defaults_available";s:23:"Available test defaults";s:29:"tst_defaults_defaults_of_test";s:28:"the settings of this test as";s:21:"tst_defaults_dont_use";s:35:"--- Use the ILIAS test defaults ---";s:23:"tst_defaults_enter_name";s:51:"Please enter a name for your test default settings!";s:24:"tst_defaults_not_defined";s:55:"You don’t have any test default settings defined yet.";s:24:"tst_delete_all_user_data";s:20:"Remove all User Data";s:23:"tst_delete_missing_mark";s:49:"Please select at least one mark step to remove it";s:18:"tst_delete_results";s:10:"Reset Test";s:29:"tst_dont_use_previous_answers";s:78:"Your previous answers will not be used as default values in future test passes";s:15:"tst_ending_time";s:14:"Finishing Time";s:22:"tst_enter_questionpool";s:71:"Please enter a question pool name where the new question will be stored";s:33:"tst_eval_no_anonymous_aggregation";s:90:"No one has entered the test yet. There are no anonymous aggregated test results available.";s:24:"tst_eval_question_points";s:28:"Question Results for Pass %s";s:24:"tst_eval_results_by_pass";s:27:"List of Answers for Pass %s";s:20:"tst_eval_show_answer";s:11:"Show Answer";s:36:"tst_eval_total_finished_average_time";s:28:"Average test processing time";s:23:"tst_eval_total_finished";s:62:"Total finished tests (Users that used up all possible passes.)";s:36:"tst_eval_total_passed_average_points";s:30:"Average points of passed tests";s:34:"tst_eval_total_passed_average_time";s:43:"Average processing time of all passed tests";s:21:"tst_eval_total_passed";s:18:"Total passed tests";s:22:"tst_eval_total_persons";s:43:"Total number of people who started the test";s:20:"tst_eval_user_answer";s:11:"User Answer";s:11:"review_view";s:6:"Review";s:25:"tst_finish_confirm_button";s:30:"Yes, I want to finish the test";s:32:"tst_finish_confirm_cancel_button";s:36:"No, go back to the previous question";s:32:"tst_finish_confirmation_question";s:194:"You are going to finish this test and reach the maximum number of allowed test passes. You won’t be able to enter this test again to change your answers. Do you really want to finish the test?";s:32:"tst_finish_notification_advanced";s:25:"Send complete test result";s:31:"tst_finish_notification_content";s:17:"Content of e-mail";s:30:"tst_finish_notification_simple";s:29:"Send username and finish date";s:26:"tst_finish_notification_no";s:9:"No e-mail";s:23:"tst_finish_notification";s:12:"Notification";s:28:"tst_finish_notification_desc";s:77:"Sends an e-mail to the test owner for every user that has completed the test.";s:12:"tst_finished";s:8:"Finished";s:34:"tst_fixed_participants_data_exists";s:109:"There are already participants who ran the test. You are not allowed to change the fixed participants status!";s:42:"tst_fixed_participants_disable_description";s:182:"You are about to disable the support for fixed participants in this test. All fixed participants who did not start the test yet will be removed from the test. Do you want to proceed?";s:30:"tst_fixed_participants_disable";s:21:"Confirm Status Change";s:29:"tst_fixed_participating_users";s:31:"Fixed Participants in this Test";s:22:"tst_general_properties";s:16:"General Settings";s:16:"tst_generate_xls";s:14:"Generate Excel";s:19:"tst_heading_scoring";s:7:"Scoring";s:37:"tst_hide_previous_results_description";s:102:"If checked, the previous results of a learner will not be used as default values in future test passes";s:30:"tst_hide_previous_results_hide";s:41:"Hide my results from a previous test pass";s:38:"tst_hide_previous_results_introduction";s:120:"If you’re processing more than one pass of this test, your previous entered results will not be used as default values";s:25:"tst_hide_previous_results";s:21:"Hide Previous Results";s:18:"tst_hide_side_list";s:18:"Hide question list";s:19:"tst_import_no_items";s:45:"Error: The import file contains no questions!";s:33:"tst_import_verify_found_questions";s:123:"ILIAS found the following questions in the test import file. Please select the questions you want to import with this test.";s:34:"tst_in_use_edit_questions_disabled";s:97:"The test is in use by %d user(s). You are not allowed to edit or move the questions in this test!";s:27:"tst_insert_missing_question";s:63:"Please select at least one question to insert it into the test!";s:32:"tst_insert_questions_and_results";s:194:"This test was already executed by %s user(s). Inserting questions to this test will remove all test results of these users. Are you sure you want to insert the following question(s) to the test?";s:20:"tst_insert_questions";s:70:"Are you sure you want to insert the following question(s) to the test?";s:35:"tst_instant_feedback_answer_generic";s:32:"Feedback on Fully Correct Answer";s:40:"tst_instant_feedback_answer_generic_desc";s:301:"If the answer provided is fully correct ILIAS will show one type of feedback upon clicking the ‘Check’ button.  If the answer provided is not fully correct, another type of feedback will be displayed. Both types of feedback have to be prepared in the tab ‘Feedback’ of the respective question.";s:36:"tst_instant_feedback_answer_specific";s:42:"Specific Feedback for Each Answer provided";s:41:"tst_instant_feedback_answer_specific_desc";s:245:"On clicking the ‘Check’-button, ILIAS will show a specific feedback for every answer option selected by the participant. The feedback has to be prepared along with the question. This specific feedback is not supported for all question types.";s:35:"tst_instant_feedback_fix_usr_answer";s:20:"Freeze Answers Given";s:40:"tst_instant_feedback_fix_usr_answer_desc";s:87:"After clicking the ‘Check’-button, participants can no longer change their answers.";s:28:"tst_instant_feedback_results";s:15:"Points Attained";s:33:"tst_instant_feedback_results_desc";s:111:"On clicking the ‘Check’-button ILIAS will display how many points were attained by answering this question.";s:29:"tst_instant_feedback_solution";s:25:"Show Best Possible Answer";s:34:"tst_instant_feedback_solution_desc";s:95:"On clicking the ‘Check’-button ILIAS will display the best possible answer to the question.";s:20:"tst_instant_feedback";s:16:"Instant Feedback";s:24:"tst_instant_verification";s:20:"Instant Verification";s:16:"tst_introduction";s:20:"Introductory Message";s:21:"tst_introduction_desc";s:128:"Shows an introductory message on the tab ‘Info’ of the test. This text is accessible already before the test can be started.";s:18:"tst_invited_nobody";s:68:"No users, groups or roles have been added as fixed test participants";s:27:"tst_invited_selected_groups";s:62:"The selected groups have been added as fixed test participants";s:26:"tst_invited_selected_roles";s:61:"The selected roles have been added as fixed test participants";s:26:"tst_invited_selected_users";s:61:"The selected users have been added as fixed test participants";s:24:"tst_list_of_answers_show";s:20:"Show List of Answers";s:19:"tst_list_of_answers";s:15:"List of Answers";s:25:"tst_list_of_questions_end";s:43:"Show before a participant finishes the test";s:27:"tst_list_of_questions_start";s:32:"Show prior to the first question";s:38:"tst_list_of_questions_with_description";s:29:"Include question descriptions";s:25:"tst_list_of_questions_yes";s:19:"Yes, and additional";s:29:"tst_mark_create_new_mark_step";s:20:"Create New Mark Step";s:34:"tst_mark_create_simple_mark_schema";s:27:"Reset to Simple Mark Schema";s:22:"tst_mark_minimum_level";s:20:"Minimum Level (in %)";s:22:"tst_mark_official_form";s:13:"Official Form";s:15:"tst_mark_passed";s:6:"Passed";s:19:"tst_mark_short_form";s:10:"Short Form";s:8:"tst_mark";s:4:"Mark";s:29:"tst_max_allowed_users_heading";s:70:"The maximum number of simultaneous users in this test has been reached";s:29:"tst_max_allowed_users_message";s:264:"The maximum number of simultaneous active users in the test has been reached. Please try again later to start or resume the test. If one of the active users is inactive for more than %s seconds, you may be able to enter this test. Thank you for your understanding.";s:18:"tst_maximum_points";s:14:"Maximum Points";s:18:"tst_missing_author";s:89:"You have not entered the authors name in the test properties! Please add an authors name.";s:17:"tst_missing_marks";s:96:"You do not have a mark schema in the test! Please add at least a simple mark schema to the test.";s:21:"tst_missing_questions";s:90:"You do not have any questions in the test! Please add at least one question into the test.";s:17:"tst_missing_title";s:87:"You have not entered a test title! Please go to the metadata section and enter a title.";s:23:"tst_must_be_online_exam";s:47:"This option is only available for online exams!";s:22:"tst_no_evaluation_data";s:38:"There is no evaluation data available.";s:24:"tst_no_export_randomtest";s:172:"You cannot export a test with random selection of questions, because every used question pool has to be exported too which leads to enormous complexity of the export files.";s:20:"tst_no_marks_defined";s:72:"There are no marks defined, please create at least a simple mark schema!";s:35:"tst_no_more_available_questionpools";s:42:"There are no more question pools available";s:36:"tst_no_question_selected_for_removal";s:48:"Please check at least one question to remove it!";s:42:"tst_no_question_selected_for_moving_to_qpl";s:67:"Please choose at least one question to be added to a question pool!";s:36:"tst_no_questionpools_for_random_test";s:98:"You have not added a question pool for this random test! Please select at least one question pool.";s:26:"tst_no_questions_available";s:91:"There are no questions available! You need to create new questions or browse for questions.";s:32:"tst_no_questions_for_random_test";s:169:"You have taken no questions from the question pools for this random test! Please take at least one question by setting the amount of questions for an added questionpool.";s:25:"tst_no_solution_available";s:55:"Short answer questions don\'t have a specified solution.";s:18:"tst_no_taken_tests";s:25:"There are no taken tests!";s:12:"tst_no_tries";s:4:"none";s:16:"tst_nr_of_passes";s:21:"Number of Test Passes";s:23:"tst_nr_of_tries_of_user";s:24:"Passes Already Completed";s:15:"tst_nr_of_tries";s:21:"Max. Number of Passes";s:25:"tst_participants_no_fixed";s:62:"There is nobody assigned as a fixed participant for this test!";s:19:"tst_participants_no";s:38:"Nobody has started the test right now!";s:23:"tst_participating_users";s:19:"Participating Users";s:18:"tst_pass_best_pass";s:19:"Score the Best Pass";s:23:"tst_pass_best_pass_desc";s:133:"The pass in which a participant performed best will be scored. This setting does only apply when more than one test pass is possible.";s:16:"tst_pass_details";s:16:"Detailed Results";s:18:"tst_pass_last_pass";s:19:"Score the Last Pass";s:23:"tst_pass_last_pass_desc";s:46:"The last pass of a participant will be scored.";s:16:"tst_pass_scoring";s:23:"Scoring Multiple Passes";s:10:"tst_passes";s:11:"Test Passes";s:21:"tst_allowed_users_max";s:27:"Max. Number of Participants";s:20:"tst_password_details";s:101:"If you define a test password, all users with test access must enter this password to start the test.";s:18:"tst_password_enter";s:14:"Enter Password";s:35:"tst_password_entered_wrong_password";s:70:"You cannot start the test because you entered the wrong test password!";s:25:"tst_password_introduction";s:102:"This test can only be accessed with a test password. Please enter the test password to start the test.";s:17:"tst_password_form";s:19:"Enter Test Password";s:12:"tst_password";s:13:"Test Password";s:18:"tst_percent_solved";s:14:"Percent Solved";s:12:"tst_position";s:17:"Question %s of %s";s:26:"tst_position_without_total";s:11:"Question %s";s:24:"tst_postpone_description";s:63:"The participants may postpone questions to the end of the test.";s:12:"tst_postpone";s:18:"Postpone Questions";s:14:"tst_print_date";s:13:"Date of Print";s:9:"tst_print";s:32:"Test and Assessment - Print View";s:24:"tst_processing_time_desc";s:199:"Participants can work through the test only for a specified period of time. Time is clocking away from the moment a user starts a test for the first time. Suspending the test does not stop the clock.";s:19:"tst_processing_time";s:22:"Limit Duration of Test";s:14:"tst_properties";s:15:"Test Properties";s:13:"tst_qst_order";s:5:"Order";s:19:"tst_qst_resetsolved";s:12:"Set Unsolved";s:20:"tst_qst_result_sheet";s:17:"Show Result Sheet";s:17:"tst_qst_setsolved";s:10:"Set Solved";s:20:"tst_qst_summary_text";s:75:"Here you can see all questions. Use the bulbs to mark a question as solved.";s:17:"tst_question_mark";s:18:"Mark this question";s:19:"tst_question_marked";s:23:"You marked the question";s:19:"tst_question_marker";s:6:"Marker";s:15:"tst_question_no";s:5:"Order";s:18:"tst_question_offer";s:53:"Do you accept this sample or do you want another one?";s:34:"tst_question_selection_description";s:287:"If you only use question pools which contain questions with an equal maximum number of available points, the test will have an equal number of maximum points for all participating users and thus the test results will be better comparable. It is recommended to choose this selection mode.";s:28:"tst_question_selection_equal";s:44:"Use question pools with equal maximum points";s:22:"tst_question_selection";s:18:"Question Selection";s:39:"tst_inp_all_quest_points_equal_per_pool";s:42:"Use Only Pools with Equal Scored Questions";s:44:"tst_inp_all_quest_points_equal_per_pool_desc";s:254:"If enabled, only question pools in which all questions have the same points are offered. Participants of such a test can all have the same number of maximum points, thus the test results will be better comparable. It is recommended to choose this option.";s:29:"tst_inp_quest_amount_cfg_mode";s:19:"Amount of Questions";s:34:"tst_inp_quest_amount_cfg_mode_test";s:39:"Define the amount of questions per test";s:34:"tst_inp_quest_amount_cfg_mode_pool";s:76:"Define the amount of questions per selected question pool and taxonomy node.";s:29:"tst_inp_quest_amount_per_test";s:38:"Number of Questions for the Whole Test";s:36:"tst_inp_quest_amount_per_source_pool";s:15:"Question Amount";s:19:"tst_question_amount";s:15:"Question Amount";s:18:"tst_question_title";s:14:"Question Title";s:29:"tst_qbt_filter_question_title";s:17:"Title of Question";s:17:"tst_question_type";s:13:"Question Type";s:19:"tst_question_unmark";s:33:"Remove the mark for this question";s:22:"tst_questions_inserted";s:21:"Question(s) inserted!";s:21:"tst_questions_removed";s:20:"Question(s) removed!";s:26:"tst_random_nr_of_questions";s:19:"How many questions?";s:25:"tst_random_qpl_unselected";s:90:"There is at least one unselected question pool! You don\'t need to add a new question pool.";s:24:"tst_random_questionpools";s:14:"Question Pools";s:30:"tst_random_select_questionpool";s:53:"Select the question pool to choose the questions from";s:44:"tst_random_selection_question_count_too_high";s:140:"The question count you entered was higher than the maximum number of available questions. The question count has been reduced automatically.";s:50:"tst_random_selection_question_total_count_too_high";s:172:"The question count you entered was higher than the maximum number of available questions for all selected question pools. The question count has been reduced automatically.";s:38:"tst_nonpool_questions_get_lost_warning";s:183:"<b>The current test mode includes questions in its configuration that are not assigned to any question pool. If you change the test mode, these questions will be lost permanently.</b>";s:18:"tst_reached_points";s:6:"Points";s:15:"tst_remove_mark";s:16:"Remove this mark";s:32:"tst_remove_questions_and_results";s:197:"This test was already executed by %s user(s). Removing questions from this test will remove all test results of these users. Are you sure you want to remove the following question(s) from the test?";s:20:"tst_remove_questions";s:70:"Are you sure you want to remove the following questions from the test?";s:21:"tst_report_after_date";s:34:"After a fixed score reporting date";s:31:"tst_report_after_first_question";s:49:"Offer test results when the test has been started";s:25:"tst_report_after_question";s:37:"Allow instant verification of answers";s:21:"tst_report_after_test";s:44:"Offer test results when the test is finished";s:16:"tst_report_never";s:25:"No test results available";s:30:"tst_reset_processing_time_desc";s:134:"The duration will be reset to the defined maximum for every test pass. This setting requires multiple test passes to become effective.";s:25:"tst_reset_processing_time";s:34:"Reset duration for every test pass";s:25:"tst_result_user_name_pass";s:30:"Results of Test Pass %s for %s";s:20:"tst_result_user_name";s:19:"Test Results for %s";s:15:"tst_result_pass";s:20:"Results of Test Pass";s:25:"tst_results_access_always";s:11:"Immediately";s:30:"tst_results_access_always_desc";s:233:"Participants can access their results on the ‘Info’-tab immediately after starting the test pass and while still taking the test. Additionally ILIAS will present them with their test results immediately after finishing  the test.";s:23:"tst_results_access_date";s:4:"Date";s:28:"tst_results_access_date_desc";s:91:"Participants get access to their test results on the ‘Info’-tab after the defined date.";s:27:"tst_results_access_finished";s:27:"After Test Pass is Finished";s:32:"tst_results_access_finished_desc";s:172:"ILIAS displays the test results after the test pass is finished. After finishing the test pass participants can access their test results on the ‘Info’-tab at any time.";s:26:"tst_results_access_enabled";s:22:"Access to Test Results";s:31:"tst_results_access_enabled_desc";s:231:"A button ‘Show Test Results’ will be displayed to participants on the ‘Info’-tab. Options in this and the following sections below configure what information is to be included into the report and when it will be accessible.";s:26:"tst_results_access_setting";s:13:"Point in Time";s:27:"tst_results_details_options";s:46:"Further Details to be Included in Test Results";s:35:"tst_results_grading_opt_show_status";s:39:"Show ‘Passed’ / ‘Failed’ Status";s:40:"tst_results_grading_opt_show_status_desc";s:171:"Information on the ‘Passed’ / ‘Failed’ Status will be appended to the summary test result. Participants can access their test results on the ‘Info’-tab. <br />";s:33:"tst_results_grading_opt_show_mark";s:19:"Show Resulting Mark";s:38:"tst_results_grading_opt_show_mark_desc";s:129:"The resulting mark will be appended to the summary test result. Participants can access their test results on the ‘Info’-tab.";s:22:"tst_results_aggregated";s:23:"Aggregated Test Results";s:27:"tst_results_back_evaluation";s:27:"Back to Evaluation Overview";s:29:"tst_results_back_introduction";s:28:"Back to Introductory Message";s:25:"tst_results_back_overview";s:24:"Back to Results Overview";s:25:"tst_results_overview_pass";s:28:"Results Overview for Pass %s";s:20:"tst_results_overview";s:33:"Pass Overview of the Test Results";s:30:"tst_show_solution_details_desc";s:279:"As an add-on  to the ‘Table of Detailed Test Results’, the participant get a link to a page for each question. This linked page contains the question, the answer provided by the participant, information on whether this was the correct answer and points scored by this answer.";s:32:"tst_show_solution_printview_desc";s:138:"An overview of all questions with the answers of the respective participant is generated. This list will be offered on the ‘Info’-tab.";s:31:"tst_show_solution_feedback_desc";s:256:"Feedback related to the answers provided by the participant is displayed. Please mind  that this option becomes effective only if you have activated ‘Scored Answers of Participant’  and feedback was prepared along with the questions in the first place.";s:35:"tst_show_solution_answers_only_desc";s:193:"If is selected, the ILIAS content you place around a question using the ‘Edit content’ tab page will not be visible in a print-out. If you want to save some paper space, select this option.";s:32:"tst_show_solution_signature_desc";s:175:"The prepared printout version will contain a signature placeholder for the participant. Please mind to activate ‘Table of Detailed Test Results’ to use this functionality.";s:32:"tst_show_solution_suggested_desc";s:347:"If content for recapitulation was assigned to the test questions in the first place, this content will be shown in the ‘Table of Detailed Test Results’-table. Participants get an opportunity for remedial learning. For this option to become effective you have to activate ‘Table of Detailed Test Results’ under ‘Access to Test Results’.";s:11:"tst_results";s:12:"Test Results";s:15:"tst_resume_test";s:15:"Resume the Test";s:22:"tst_score_cut_question";s:60:"For Each Questions Negative Points are set to ‘0 Points’";s:27:"tst_score_cut_question_desc";s:200:"Participants may score negative results for a question that had negative points for assigned to individual answer options. This setting ensures that per question any negativ result is set to 0 points.";s:18:"tst_score_cut_test";s:61:"For the Whole Test a Negative Result is set to ‘0 Points’";s:23:"tst_score_cut_test_desc";s:252:"Participants might score negative points in questions. Scored points of all questions are added up. Only if the overall result of the test is negative this overall result will be set to 0 points. With this setting negative points carry a lot of weight.";s:17:"tst_score_cutting";s:15:"Negative Points";s:24:"tst_score_mcmr_questions";s:38:"Multiple Choice Questions not Answered";s:33:"tst_score_mcmr_use_scoring_system";s:60:"Score Points for Unanswered Questions as Defined in Question";s:38:"tst_score_mcmr_use_scoring_system_desc";s:202:"Despite a multiple choice question was not answered, it still scores points for selecting or not-selecting the answer options as definied in the question. This setting is appropriate only for few cases.";s:42:"tst_score_mcmr_zero_points_when_unanswered";s:36:"Score 0 Points for Unchecked Answers";s:47:"tst_score_mcmr_zero_points_when_unanswered_desc";s:151:"Participants score 0 points for multiple choice questions in which they have not checked any answer option. This setting is appropriate for most tests.";s:24:"tst_score_reporting_date";s:20:"Score Reporting Date";s:19:"tst_score_reporting";s:15:"Score Reporting";s:14:"tst_score_type";s:20:"Score Reporting Type";s:26:"tst_select_file_for_import";s:34:"You must select a file for import!";s:15:"tst_select_qpls";s:45:"Please select a question pool for duplication";s:23:"tst_select_questionpool";s:59:"Please select a question pool to store the created question";s:24:"tst_select_questionpools";s:61:"Please select a question pool to store the imported questions";s:27:"tst_select_random_questions";s:75:"Select the question pool(s) and the amount of questions for the random test";s:15:"tst_select_tsts";s:36:"Please select a test for duplication";s:30:"tst_selected_user_data_deleted";s:62:"The test data of the selected user(s) was removed successfully";s:18:"tst_sequence_fixed";s:34:"The Sequence of Questions is Fixed";s:21:"tst_sequence_postpone";s:52:"Questions may be postponed to the end of a test pass";s:23:"tst_sequence_properties";s:63:"Administering the Test: Functionality Available to Participants";s:12:"tst_sequence";s:8:"Sequence";s:20:"tst_session_settings";s:16:"Session Settings";s:21:"tst_show_answer_sheet";s:12:"Show Answers";s:27:"tst_show_cancel_description";s:181:"Participants are presented with a button to stop the test run and to continue it later. Caution: Suspending the test does not stop the countdown of the maximum duration of the test.";s:15:"tst_show_cancel";s:12:"Suspend Test";s:21:"tst_show_pass_details";s:88:"Show ‘Table of Detailed Test Results’ for each Test Pass upon Selected Point in Time";s:26:"tst_show_pass_details_desc";s:656:"The summary of results will be appended at the point in time indicated in the setting above: A ‘Table of Detailed Test Results’ will show the title of the questionsn and the points scored in a particular test pass. <br> Other than that the table will be displayed after the last test pass possible (setting in link ‘General’, option ‘Limit Number of Test Passes’) or after the test is officially finished (setting in link ‘General’, option ‘Finishing Time’). <br> Further settings about the content of the ‘Table of Detailed Test Results’ can be made in the section ‘Further Details to be Included in Test Results’ of this form.";s:16:"tst_show_results";s:17:"Show Test Results";s:18:"tst_show_side_list";s:24:"Show question list aside";s:30:"tst_show_solution_answers_only";s:36:"Print View of Results (Answers Only)";s:25:"tst_show_solution_details";s:29:"Scored Answers of Participant";s:26:"tst_show_solution_feedback";s:8:"Feedback";s:27:"tst_show_solution_printview";s:45:"Additional ‘List of Answers’ for Printing";s:27:"tst_show_solution_signature";s:21:"Signature Placeholder";s:27:"tst_show_solution_suggested";s:26:"Content for Recapitulation";s:28:"tst_show_summary_description";s:229:"Participants can switch on a list of test questions on the left of the actual question. Additionally, they are presented with a button ‘List of Questions’. On that screen the overall status of all questions will be displayed.";s:16:"tst_show_summary";s:28:"Show ‘List of Questions’";s:33:"tst_shuffle_questions_description";s:77:"Shuffles the sequence of questions for every participant and every test pass.";s:21:"tst_shuffle_questions";s:17:"Shuffle Questions";s:13:"tst_signature";s:9:"Signature";s:18:"tst_single_results";s:19:"Results by Question";s:23:"tst_start_new_test_pass";s:19:"Start New Test Pass";s:14:"tst_start_test";s:14:"Start the Test";s:11:"tst_started";s:12:"Test Started";s:17:"tst_starting_time";s:13:"Starting Time";s:18:"tst_stat_all_users";s:16:"All Participants";s:21:"tst_stat_choose_users";s:45:"(select one or more users from the user list)";s:27:"tst_stat_result_atimeofwork";s:20:"Average Time of Work";s:28:"tst_stat_result_distancemean";s:27:"Distance to Arithmetic Mean";s:30:"tst_stat_result_distancemedian";s:18:"Distance to Median";s:32:"tst_stat_result_distancequintile";s:31:"Distance to Arithmetic Quintile";s:26:"tst_stat_result_firstvisit";s:11:"First Visit";s:25:"tst_stat_result_lastvisit";s:10:"Last Visit";s:27:"tst_stat_result_mark_median";s:14:"Mark of Median";s:22:"tst_stat_result_median";s:31:"Median of Test Result in Points";s:30:"tst_stat_result_pworkedthrough";s:48:"Percent of total workload already worked through";s:20:"tst_stat_result_qmax";s:25:"Total number of Questions";s:30:"tst_stat_result_qworkedthrough";s:32:"Questions already worked through";s:27:"tst_stat_result_rank_median";s:14:"Rank of Median";s:32:"tst_stat_result_rank_participant";s:19:"Rank of Participant";s:28:"tst_stat_result_resultsmarks";s:21:"Test Results in Marks";s:29:"tst_stat_result_resultspoints";s:22:"Test Results in Points";s:29:"tst_stat_result_specification";s:25:"Available Evaluation Data";s:26:"tst_stat_result_timeofwork";s:12:"Time of Work";s:34:"tst_stat_result_total_participants";s:28:"Total Number of Participants";s:23:"tst_stat_selected_users";s:21:"Selected Participants";s:20:"tst_stat_users_intro";s:31:"Show Statistical Evaluation for";s:40:"tst_status_completed_more_tries_possible";s:9:"Completed";s:20:"tst_status_completed";s:9:"completed";s:27:"tst_status_missing_elements";s:35:"The following elements are missing:";s:18:"tst_status_missing";s:49:"There are required elements missing in this test!";s:22:"tst_status_not_entered";s:11:"Not started";s:13:"tst_status_ok";s:60:"The status of the test is OK. There are no missing elements.";s:19:"tst_status_progress";s:11:"In progress";s:22:"tst_submit_answers_txt";s:55:"You now may finish the test by submitting your answers.";s:18:"tst_submit_answers";s:32:"Yes, I want to submit my answers";s:18:"tst_submit_results";s:33:"Yes, I do confirm the submission.";s:15:"tst_test_output";s:11:"Test Output";s:21:"tst_text_count_system";s:14:"Scoring System";s:27:"tst_time_already_spent_left";s:17:"You have %s left.";s:22:"tst_time_already_spent";s:63:"You started the test at %s. Your maximum processing time is %s.";s:21:"tst_title_output_full";s:36:"Question Titles and Available Points";s:28:"tst_title_output_hide_points";s:20:"Only Question Titles";s:25:"tst_title_output_no_title";s:44:"Neither Question Titles nor Available Points";s:16:"tst_title_output";s:19:"Show Question Title";s:31:"tst_total_questions_description";s:183:"If you set this value, the amount of questions entered with the question pools are ignored. If you don\'t set this value, you need to enter an amount with every selected question pool!";s:19:"tst_total_questions";s:25:"Total Amount of Questions";s:12:"tst_tst_date";s:12:"Date of Test";s:16:"tst_type_changed";s:79:"You have changed the test type. All previous processed tests have been removed!";s:16:"tst_type_comment";s:91:"Warning: Changing the test type of a running test will remove all previous processed tests!";s:8:"tst_type";s:9:"Test Type";s:9:"tst_types";s:10:"Test Types";s:7:"exam_id";s:12:"Testpass ID:";s:19:"examid_in_test_pass";s:19:"Display Testpass ID";s:24:"examid_in_test_pass_desc";s:80:"A testpass ID is diplayed in the test. A new ID is generated for every testpass.";s:18:"examid_in_test_res";s:17:"ILIAS Testpass ID";s:23:"examid_in_test_res_desc";s:59:"The ILIAS Testpass ID will be included in the test results.";s:18:"tst_use_javascript";s:40:"Use Javascript for drag and drop actions";s:36:"tst_use_previous_answers_description";s:180:"Participants will be presented with their answers from previous test passes. This option has to be activated by individual participants on the Info-tab before starting a test pass.";s:29:"tst_use_previous_answers_user";s:63:"Use my previous answers as default values in future test passes";s:24:"tst_use_previous_answers";s:20:"Use Previous Answers";s:22:"tst_user_finished_test";s:23:"User finished test (%s)";s:19:"tst_your_answer_was";s:15:"Your answer was";s:16:"tst_your_answers";s:56:"These are your answers given to the following questions.";s:21:"test_enable_archiving";s:16:"Enable Archiving";s:26:"test_enable_archiving_desc";s:113:"In the ‘Export’-tab the whole test comprising all answers of all participants can be exported and downloaded.";s:25:"ass_create_archive_export";s:21:"Create Archive-Export";s:21:"cannot_export_archive";s:33:"Archive-Export cannot be created.";s:13:"tt_assessment";s:15:"Assessment Test";s:14:"tt_online_exam";s:11:"Online Exam";s:18:"tt_self_assessment";s:20:"Self Assessment Test";s:21:"tt_varying_randomtest";s:19:"Varying Random Test";s:9:"unlimited";s:9:"unlimited";s:15:"unlock_question";s:394:"This question is in use of at least one test and there are %s submitted results. If you choose to unlock the question the complete test results of the affected users will be deleted after saving this question. If you want to use a changed version of this question but you do not want to delete the users test results, you can duplicate the question in the question pool and change that version.";s:6:"unlock";s:6:"Unlock";s:12:"upload_image";s:12:"Upload Image";s:15:"upload_imagemap";s:19:"Upload an Image Map";s:17:"uploaded_material";s:17:"Uploaded Material";s:16:"user_not_invited";s:39:"You are not supposed to take this test.";s:19:"user_wrong_clientip";s:44:"You don\'t have the right ip using this test.";s:21:"value_between_x_and_y";s:37:"The value should be between %s and %s";s:6:"values";s:6:"Values";s:29:"warning_question_not_complete";s:29:"The question is not complete!";s:25:"warning_test_not_complete";s:25:"The test is not complete!";s:4:"when";s:4:"when";s:5:"width";s:5:"Width";s:10:"with_order";s:10:"with order";s:14:"worked_through";s:14:"Worked Through";s:8:"answered";s:8:"Answered";s:16:"working_time_avg";s:17:"Avg. Working Time";s:12:"working_time";s:12:"Working Time";s:26:"you_received_a_of_b_points";s:37:"You received %s of %s possible points";s:16:"all_participants";s:16:"All participants";s:27:"with_solutions_participants";s:27:"Participants with solutions";s:30:"without_solutions_participants";s:30:"Participants without solutions";s:16:"tst_show_toplist";s:12:"Show Ranking";s:16:"toplist_by_score";s:19:"High score by score";s:15:"toplist_by_time";s:26:"High score by working time";s:21:"toplist_top_n_results";s:14:"Top %s Results";s:16:"toplist_col_rank";s:4:"Rank";s:23:"toplist_col_participant";s:11:"Participant";s:20:"toplist_col_achieved";s:4:"Date";s:17:"toplist_col_score";s:5:"Score";s:22:"toplist_col_percentage";s:10:"Percentage";s:17:"toplist_col_hints";s:5:"Hints";s:17:"toplist_col_wtime";s:12:"Working Time";s:19:"toplist_your_result";s:12:"Your ranking";s:21:"tst_highscore_enabled";s:7:"Ranking";s:25:"tst_highscore_description";s:279:"Participants are presented with a button ‘Show Ranking’ on the ‘Info’-tab. On clicking it, participants are presented with a league table on their performance in the test. Additionally, you need to activate ‘Access to Test Results’ in order to use this functionality.";s:18:"tst_highscore_anon";s:13:"Without Names";s:30:"tst_highscore_anon_description";s:137:"Ranking is displayed without listing the names of the other participants. This will be the case anyway if the test was taken anonymously.";s:25:"tst_highscore_achieved_ts";s:4:"Date";s:37:"tst_highscore_achieved_ts_description";s:66:"A column containing the test date will be included in the ranking.";s:19:"tst_highscore_score";s:5:"Score";s:31:"tst_highscore_score_description";s:62:"A column containing the score will be included in the ranking.";s:24:"tst_highscore_percentage";s:10:"Percentage";s:36:"tst_highscore_percentage_description";s:73:"A column containing the tests percentage will be included in the ranking.";s:19:"tst_highscore_hints";s:5:"Hints";s:31:"tst_highscore_hints_description";s:72:"A column containing the requested hints will be included in the ranking.";s:19:"tst_highscore_wtime";s:16:"Duration of Test";s:31:"tst_highscore_wtime_description";s:77:"A column containing the duration of the test will be included in the ranking.";s:18:"tst_highscore_mode";s:4:"Mode";s:23:"tst_highscore_own_table";s:22:"Participant\'s Own Rank";s:35:"tst_highscore_own_table_description";s:62:"Participants are advised of their own position in the ranking.";s:23:"tst_highscore_top_table";s:11:"Top Ranking";s:35:"tst_highscore_top_table_description";s:68:"Participants are presented with a table containing the top rankings.";s:24:"tst_highscore_all_tables";s:38:"Participant\'s Own Rank and Top Ranking";s:36:"tst_highscore_all_tables_description";s:89:"Participants get information about the top ranking and their own position in the ranking.";s:21:"tst_highscore_top_num";s:21:"Length of Top Ranking";s:33:"tst_highscore_top_num_description";s:66:"Specify how many ranks are to be included in the top ranking list.";s:26:"tst_highscore_top_num_unit";s:7:"entries";s:29:"tst_rnd_quest_cfg_tab_general";s:13:"Configuration";s:26:"tst_rnd_quest_cfg_tab_pool";s:23:"Selected Question Pools";s:21:"tst_question_set_type";s:27:"Selection of Test Questions";s:27:"tst_question_set_type_fixed";s:22:"Fixed Set of Questions";s:32:"tst_question_set_type_fixed_desc";s:47:"All participants get the same set of questions.";s:28:"tst_question_set_type_random";s:23:"Random Set of Questions";s:33:"tst_question_set_type_random_desc";s:116:"Each participant gets a different set of questions. Questions are randomly selected from one or more question pools.";s:29:"tst_question_set_type_dynamic";s:50:"Question Queue - All Questions from a Questionpool";s:34:"tst_question_set_type_dynamic_desc";s:168:"Participants work through questions from one question pool. Questions answered incorrectly will be presented again. Questions can be added and edited in a running test.";s:55:"tst_change_quest_set_type_from_old_to_new_with_conflict";s:220:"You are about to change the test mode from <b>%s</b> to <b>%s</b>, although a questions/questionpool configuration dependent on the current test mode already exists.<br />This already existing configuration will be lost.";s:44:"tst_msg_dynamic_question_set_config_modified";s:61:"Continues question selection configuration has been modified.";s:59:"tst_msg_cannot_modify_dynamic_question_set_conf_due_to_part";s:95:"Continues question selection configuration cannot be modified due to existing participant data.";s:58:"tst_msg_cannot_modify_random_question_set_conf_due_to_part";s:90:"The random question set configuration cannot be modified due to existing participant data.";s:31:"tst_delete_dyn_test_results_btn";s:19:"Remove Test Results";s:35:"tst_dyn_test_msg_pass_deletion_link";s:23:"Remove Previous Answers";s:33:"tst_dyn_test_pass_deletion_button";s:21:"Reset All Testanswers";s:36:"tst_form_dynamic_question_set_config";s:28:"Continues Question Selection";s:50:"tst_input_dynamic_question_set_source_questionpool";s:20:"Source Question Pool";s:59:"tst_dynamic_question_set_source_questionpool_summary_string";s:28:"%s (Path: %s) [%s Questions]";s:48:"tst_dyn_quest_set_src_qpl_summary_string_trashed";s:27:"%s (Removed) [%s Questions]";s:48:"tst_dyn_quest_set_src_qpl_summary_string_deleted";s:24:"%s (Removed Permanently)";s:55:"tst_input_dynamic_question_set_taxonomie_filter_enabled";s:23:"Provide Taxonomy Filter";s:52:"tst_input_dyn_quest_set_answer_status_filter_enabled";s:28:"Provide Answer Status Filter";s:47:"tst_input_dyn_quest_set_prev_quest_list_enabled";s:45:"Provide List of Previously Answered Questions";s:26:"tst_question_answer_status";s:13:"Answer Status";s:42:"tst_question_answer_status_all_non_correct";s:44:"All Questions (Except Correct Answered Ones)";s:39:"tst_question_answer_status_non_answered";s:22:"Non Answered Questions";s:41:"tst_question_answer_status_wrong_answered";s:24:"Wrong Answered Questions";s:48:"tst_input_dynamic_question_set_question_ordering";s:17:"Question Ordering";s:56:"tst_input_dynamic_question_set_question_ordering_by_date";s:23:"Order Questions by Date";s:49:"tst_inp_dyn_quest_set_quest_ordering_by_date_desc";s:85:"The presentation order for the questions bases upon the question\'s last editing date.";s:55:"tst_input_dynamic_question_set_question_ordering_by_tax";s:27:"Order Questions by Taxonomy";s:48:"tst_inp_dyn_quest_set_quest_ordering_by_tax_desc";s:93:"The presentation order for the questions bases upon the question\'s assignments in a taxonomy.";s:43:"tst_input_dynamic_question_set_ordering_tax";s:17:"Ordering Taxonomy";s:55:"tst_input_dynamic_question_set_ordering_tax_description";s:95:"The test questions will be presented accordingly to their assignments in the selected taxonomy.";s:37:"tst_start_dyn_test_with_cur_quest_sel";s:42:"Start Test with Current Question Selection";s:38:"tst_resume_dyn_test_with_cur_quest_sel";s:43:"Resume Test with Current Question Selection";s:36:"tst_back_dyn_test_with_cur_quest_sel";s:44:"Back to Test with Current Question Selection";s:25:"tst_tracked_question_list";s:29:"Previously Answered Questions";s:34:"tst_dynamic_question_set_selection";s:47:"Test Question Selection and Selection-Statistic";s:33:"tst_dynamic_question_set_complete";s:15:"Total-Statistic";s:21:"tst_num_all_questions";s:23:"Number of All Questions";s:26:"tst_num_selected_questions";s:28:"Number of Selected Questions";s:30:"tst_num_non_answered_questions";s:22:"Non Answered Questions";s:32:"tst_num_wrong_answered_questions";s:24:"Wrong Answered Questions";s:34:"tst_num_correct_answered_questions";s:26:"Correct Answered Questions";s:27:"tst_num_postponed_questions";s:19:"Postponed Questions";s:24:"tst_num_marked_questions";s:16:"Marked Questions";s:38:"tst_change_dyn_test_question_selection";s:33:"Change Current Question Selection";s:46:"tst_dyn_test_msg_currently_finished_completely";s:173:"Currently you have answered all questions from the selected question pool successfully. You can proceed the test when there are new or edited questions in the question pool.";s:45:"tst_dyn_test_msg_currently_finished_selection";s:132:"With the current question selection you have answered all questions successfully. Change the question selection to proceed the test.";s:26:"tst_activate_skill_service";s:27:"Activate Competence Service";s:48:"tst_disabled_skl_due_to_non_fixed_quest_set_type";s:89:"Competence service has been deactivated due to test mode with non fixed set of questions.";s:53:"tst_cannot_enable_skl_due_to_non_fixed_quest_set_type";s:95:"Competence Service activation is not possible due to test mode with non fixed set of questions.";s:19:"tst_tab_competences";s:11:"Competences";s:28:"tst_skl_sub_tab_quest_assign";s:30:"Question/Competence Assignment";s:26:"tst_skl_sub_tab_thresholds";s:21:"Competence Thresholds";s:32:"tst_msg_skl_lvl_thresholds_saved";s:41:"The competence thresholds has been saved.";s:35:"tst_msg_skl_qst_assign_points_saved";s:37:"The competence points has been saved.";s:14:"tst_competence";s:10:"Competence";s:21:"tst_assign_competence";s:17:"Assign Competence";s:21:"tst_remove_competence";s:17:"Remove Competence";s:15:"tst_comp_points";s:17:"Competence Points";s:20:"tst_save_comp_points";s:22:"Save Competence Points";s:17:"tst_num_questions";s:19:"Number of Questions";s:19:"tst_max_comp_points";s:22:"Max. Competence Points";s:9:"tst_level";s:16:"Competence Level";s:13:"tst_threshold";s:10:"Thresholds";s:19:"tst_save_thresholds";s:15:"Save Thresholds";s:21:"tst_show_comp_results";s:23:"Show Competence Results";s:12:"tst_analysis";s:8:"Analysis";s:24:"tst_all_test_competences";s:19:"All Test Competence";s:16:"tst_gap_analysis";s:12:"Gap Analysis";s:15:"tst_test_result";s:11:"Test Result";s:16:"feedback_setting";s:33:"Mode of answer specific feedback.";s:12:"feedback_all";s:46:"Show answer specific feedback for all answers.";s:16:"feedback_checked";s:62:"Show answer specific feedback for all chosen/selected answers.";s:16:"feedback_correct";s:134:"Show answer specific feedback for all correct answers (Correct answers are those, that lead to a positive score when chosen/selected).";s:28:"tst_add_quest_cont_edit_mode";s:44:"Editing Mode for additional Question Content";s:36:"tst_add_quest_cont_edit_mode_default";s:52:"Default Editing Mode for Additional Question Content";s:40:"tst_add_quest_cont_edit_mode_page_object";s:43:"Additional Content Editing with Page Editor";s:31:"tst_question_feedback_edit_page";s:12:"Edit Content";s:43:"tst_question_feedback_back_to_feedback_form";s:24:"Back To Calling Question";s:15:"enable_examview";s:25:"Overview of Answers Given";s:20:"enable_examview_desc";s:120:"Participants are presented with all questions and the answers they provided in an overview prior to submitting the test.";s:18:"show_examview_html";s:9:"On screen";s:17:"show_examview_pdf";s:12:"PDF Download";s:13:"scoringadjust";s:11:"Corrections";s:29:"tst_trigger_result_refreshing";s:55:"Results need to be recalculated. This may take a while.";s:12:"test_scoring";s:15:"Scoring Options";s:12:"test_results";s:20:"Summary Test Results";s:4:"misc";s:12:"Misc Options";s:15:"tst_back_to_top";s:11:"Back to Top";s:25:"tst_back_to_question_list";s:21:"Back to Question List";s:23:"tst_results_tax_filters";s:13:"Result Filter";s:24:"tst_back_to_pass_details";s:20:"Back to Pass Details";s:18:"tst_answer_details";s:14:"Answer Details";s:23:"tst_list_answer_details";s:18:"Show in List Below";s:25:"tst_single_answer_details";s:18:"Show Single Answer";s:37:"tst_pass_details_overview_table_title";s:29:"Detailed Overview for Pass %s";s:27:"tst_btn_show_best_solutions";s:19:"Show Best Solutions";s:27:"tst_btn_hide_best_solutions";s:19:"Hide Best Solutions";s:25:"tst_settings_header_intro";s:32:"Information Before Start of Test";s:29:"tst_settings_header_execution";s:30:"Administering the Test: Access";s:22:"tst_starting_time_desc";s:132:"Point in time after which the test can be started by clicking the button ‚Start‘, participants can provide answers to questions.";s:20:"tst_ending_time_desc";s:124:"Point in time at which the test will be finished: Participants an no longer answer questions, the test is finished by ILIAS.";s:22:"tst_allowed_users_desc";s:178:"ILIAS will monitor the number of participants taking the test at the same time. If more users than maximally allowed try to access ILIAS will prevent them from starting the test.";s:31:"tst_allowed_users_time_gap_desc";s:140:"Participants that do not click in the test for the indicated amount of time will be categorized as ‚inactive‘ and removed from the test.";s:28:"tst_settings_header_test_run";s:31:"Administering the Test: Testrun";s:20:"tst_nr_of_tries_desc";s:48:"Maximum number of passes a participant can take.";s:21:"tst_final_information";s:18:"Finishing the Test";s:16:"saved_adjustment";s:14:"Changes saved.";s:15:"sign_submission";s:31:"Digitally Sign Test Submissions";s:20:"sign_submission_info";s:136:"If this is activated and a signature plugin is installed and active, participants will be requested to digitally sign their submissions.";s:19:"preserve_manscoring";s:24:"Preserve manual scorings";s:24:"preserve_manscoring_info";s:185:"Changes in the scoring of a question may make it necessary to void manual scorings. This option allows to void ALL manual scorings in the test and should be used only in rare occasions.";s:16:"tst_search_users";s:19:"Search Participants";s:23:"info_answer_type_change";s:93:"The question already contains images. You can\'t change the answer type to multi-line answers.";s:11:"mailnottype";s:53:"Send notification even if a user finishes a test pass";s:21:"dont_use_questionpool";s:75:"Don\'t insert the questions in a question pool (only available in this test)";s:29:"ordering_answer_sequence_info";s:83:"The answer sequence you define here will be taken as the correct solution sequence.";s:16:"tst_exp_sc_short";s:49:"Item Analysis Export for Pure Single Choice Tests";s:21:"tst_exp_sc_short_desc";s:207:"In the ‘Statistics’-tab an additional export option is offered. It generates a spreadsheet for item analysis outside of ILIAS. This option only works for tests purely composed of Single Choice Questions.";s:17:"test_enable_views";s:13:"Enabled views";s:21:"test_enable_view_both";s:20:"Table- and Page View";s:24:"test_enable_view_express";s:9:"Page View";s:22:"test_enable_view_table";s:9:"List View";s:31:"tst_express_allow_question_pool";s:32:"Allow Question Pool in Page View";s:43:"tst_express_allow_question_pool_description";s:54:"If checked, questions can be added to a question pool.";s:23:"questions_per_page_view";s:9:"Page View";s:18:"test_next_question";s:13:"Next Question";s:18:"test_prev_question";s:17:"Previous Question";s:12:"test_jump_to";s:16:"Jump to Question";s:19:"ass_create_question";s:15:"Create Question";s:22:"adm_settings_templates";s:18:"Settings Templates";s:10:"intro_desc";s:50:"This message appears at the beginning of the test.";s:24:"test_question_pool_usage";s:21:"Use of Question Pools";s:33:"test_question_pool_usage_optional";s:52:"Questions can be added optionally to a question pool";s:38:"test_question_pool_usage_optional_info";s:44:"The questions can be re-used in other tests.";s:37:"test_question_pool_usage_tst_directly";s:42:"Questions are created directly in the test";s:42:"test_question_pool_usage_tst_directly_info";s:47:"The questions cannot be re-used in other tests.";s:16:"add_new_question";s:16:"Add new Question";s:19:"test_using_template";s:124:"This test uses the template %s. If you do not want to use a template and have access to all settings, please click here: %s.";s:30:"tst_anonymity_no_anonymization";s:43:"Participants\' Results and Names are Tracked";s:28:"tst_anonymity_anonymous_test";s:34:"Participants Take Test Anonymously";s:32:"tst_beginning_ending_information";s:40:"Information at Beginning and End of Test";s:27:"tst_presentation_properties";s:48:"Administering the Test: Behavior of the Question";s:21:"tst_settings_template";s:8:"Template";s:16:"test_delete_page";s:15:"Delete Question";s:14:"test_move_page";s:13:"Move Question";s:25:"assessment_pool_selection";s:14:"Pool Selection";s:18:"assessment_no_pool";s:24:"Do not use question pool";s:24:"assessment_existing_pool";s:26:"Use existing question pool";s:19:"assessment_new_pool";s:24:"Create new question pool";s:27:"test_confirm_template_reset";s:62:"Are you sure that you do not want to use the template anymore?";s:19:"test_template_reset";s:30:"The template has been removed.";s:24:"test_using_template_link";s:27:"Do not use template anymore";s:9:"saveOrder";s:10:"Save Order";s:23:"saveOrderAndObligations";s:26:"Save Order and Obligations";s:10:"obligatory";s:10:"Compulsory";s:28:"not_all_obligations_answered";s:72:"You must answer all compulsory questions before you can finish the test.";s:36:"tst_setting_enable_obligations_label";s:20:"Compulsory Questions";s:35:"tst_setting_enable_obligations_info";s:209:"Only if all compulsory questions are answered ths test can be finished. Compulsory questions can be defined in the ‘List view’. For participants the option ‘Show List of Questions’ should be activated.";s:38:"tst_test_contains_obligatory_questions";s:65:"To end this test you have to answer all compulsory questions (*).";s:29:"copy_and_link_to_questionpool";s:20:"Add to question pool";s:10:"tst_result";s:11:"Test Result";s:19:"tst_remove_question";s:69:"Are you sure you want to remove the following question from the test?";s:28:"ass_completion_by_submission";s:23:"Completed by Submission";s:33:"ass_completion_by_submission_info";s:246:"If enabled, the submission of at least one file causes the completion of this question by granting the maximum score for this question. The score could be manually changed later. Switching this setting does not effect already submitted solutions.";s:26:"copy_no_questions_selected";s:44:"Please select at least one question to copy.";s:22:"copy_questions_success";s:32:"The question(s) has been copied.";s:8:"imported";s:8:"imported";s:56:"cannot_switch_to_online_no_questions_andor_no_mark_steps";s:110:"The status cannot be changed to &quot;online&quot; because there are no questions and/or no marks in the test!";s:15:"test_is_offline";s:47:"You cannot start the test! The test is offline.";s:18:"test_edit_settings";s:13:"Edit Settings";s:57:"tst_set_offline_due_to_switched_question_set_type_setting";s:182:"The test has been set to offline, because the test mode setting has been changed. You have to set a new test mode relating question config before the test can be set to online again.";s:56:"tst_cannot_online_due_to_switched_quest_set_type_setting";s:172:"The test cannot be set to online, because the test mode setting has been changed. You have to set a test mode relating question config before the test can be set to online.";s:24:"tst_link_only_unassigned";s:141:"You have selected at least one question that is already linked to a question pool. Only unassigned questions can be added to a question pool.";s:20:"tst_default_settings";s:25:"Personal Default Settings";s:35:"test_has_datasets_warning_page_view";s:105:"The test already contains data sets. You cannot edit the test questions until you remove these data sets.";s:40:"test_has_datasets_warning_page_view_link";s:17:"Edit Participants";s:31:"tst_results_print_best_solution";s:13:"Best Solution";s:36:"tst_results_print_best_solution_info";s:76:"Additionally for each question the best possible solution will be displayed.";s:12:"tst_question";s:8:"Question";s:24:"tst_participant_solution";s:20:"Participant Solution";s:22:"tst_suggested_solution";s:13:"Best Solution";s:15:"tst_participant";s:11:"Participant";s:22:"tst_participant_status";s:18:"Participant Status";s:16:"tst_edit_scoring";s:12:"Edit Scoring";s:33:"tst_pass_overview_for_participant";s:31:"Test Passes for Participant: %s";s:38:"tst_manscoring_question_section_header";s:12:"Question: %s";s:32:"tst_manscoring_user_notification";s:17:"Send Notification";s:33:"tst_saved_manscoring_successfully";s:66:"The manual scoring for test pass %s for %s was saved successfully.";s:26:"tst_save_manscoring_failed";s:54:"Saving the manual scoring for test pass %s has failed.";s:45:"tst_manscoring_maxpoints_exceeded_input_alert";s:39:"The maximum of %s point(s) is exceeded!";s:44:"tst_manscoring_input_max_points_for_question";s:27:"Maximum Points for Question";s:47:"tst_manscoring_input_question_and_user_solution";s:26:"Question and User Solution";s:34:"tst_manscoring_input_best_solution";s:13:"Best Solution";s:43:"tst_notify_manscoring_done_body_msg_subject";s:38:"Manual Scoring for Test "%s" committed";s:41:"tst_notify_manscoring_done_body_msg_topic";s:35:"Your test has been graded manually:";s:42:"tst_notify_manscoring_done_body_msg_reason";s:75:"You have received this notification, because you participated in this test.";s:29:"tst_setting_offer_hints_label";s:5:"Hints";s:28:"tst_setting_offer_hints_info";s:127:"Participants request hints to answer a question. With every hint presented the maximum number of points to be earned decreases.";s:22:"tst_question_hints_tab";s:5:"Hints";s:31:"tst_question_hints_table_header";s:22:"Hints for Question: %s";s:33:"tst_question_hints_table_no_items";s:17:"No Existing Hints";s:42:"tst_question_hints_table_column_hint_order";s:5:"Order";s:41:"tst_question_hints_table_column_hint_text";s:4:"Hint";s:43:"tst_question_hints_table_column_hint_points";s:16:"Points Deduction";s:39:"tst_question_hints_table_link_edit_hint";s:9:"Edit Hint";s:41:"tst_question_hints_table_link_delete_hint";s:11:"Delete Hint";s:40:"tst_questions_hints_table_cmd_save_order";s:10:"Save Order";s:46:"tst_questions_hints_table_multicmd_delete_hint";s:14:"Delete Hint(s)";s:43:"tst_questions_hints_table_multicmd_cut_hint";s:30:"Cut Hint to Ordering Clipboard";s:52:"tst_questions_hints_table_multicmd_paste_hint_before";s:32:"Prepend Hint to the Selected One";s:51:"tst_questions_hints_table_multicmd_paste_hint_after";s:31:"Append Hint to the Selected One";s:40:"tst_questions_hints_toolbar_cmd_add_hint";s:8:"Add Hint";s:56:"tst_questions_hints_toolbar_cmd_reset_ordering_clipboard";s:29:"Reset Hint Ordering Clipboard";s:53:"tst_question_hints_delete_hints_missing_selection_msg";s:33:"No hint(s) selected for deletion.";s:46:"tst_question_hints_delete_hints_confirm_header";s:51:"Do you really want to delete the following hint(s)?";s:44:"tst_question_hints_delete_hints_confirm_item";s:11:"Hint %s: %s";s:43:"tst_question_hints_delete_hints_confirm_cmd";s:14:"Delete Hint(s)";s:37:"tst_question_hints_delete_success_msg";s:51:"The selected hint(s) has been deleted successfully.";s:50:"tst_question_hints_cut_hints_missing_selection_msg";s:29:"No hint selected for cutting.";s:49:"tst_question_hints_cut_hints_single_selection_msg";s:44:"More than one hint was selected for cutting.";s:35:"tst_question_hints_form_header_edit";s:24:"Hint %s for Question: %s";s:37:"tst_question_hints_form_header_create";s:25:"New Hint for Question: %s";s:39:"tst_question_hints_form_label_hint_text";s:4:"Hint";s:41:"tst_question_hints_form_label_hint_points";s:15:"Point Deduction";s:32:"tst_question_hints_form_cmd_save";s:9:"Save Hint";s:33:"tst_question_hints_form_saved_msg";s:37:"The hint has been saved successfully.";s:35:"tst_question_hints_form_invalid_msg";s:56:"The hint could not been saved. Please check your inputs.";s:52:"tst_question_hints_item_stored_in_ordering_clipboard";s:40:"Hint %s is stored in ordering clipboard.";s:46:"tst_question_hints_ordering_clipboard_resetted";s:38:"The ordering clipboard has been reset.";s:41:"tst_question_hints_save_order_success_msg";s:41:"The order of hint was saved successfully.";s:43:"tst_question_hints_paste_before_success_msg";s:56:"The hint %s has been pasted before hint %s successfully.";s:42:"tst_question_hints_paste_after_success_msg";s:55:"The hint %s has been pasted after hint %s successfully.";s:28:"tst_processing_time_duration";s:28:"Maximum Duration of the Test";s:33:"tst_processing_time_duration_desc";s:41:"Maximum of time granted to take the test.";s:28:"button_request_question_hint";s:12:"Request Hint";s:33:"button_request_next_question_hint";s:17:"Request Next Hint";s:36:"button_show_requested_question_hints";s:20:"Show Requested Hints";s:34:"tst_question_hints_confirm_request";s:12:"Request Hint";s:33:"tst_question_hints_cancel_request";s:16:"Back to Question";s:39:"tst_question_hints_request_confirmation";s:82:"Do you really want to request hint %s? For this hint %s point(s) will be deducted.";s:35:"tst_question_hints_back_to_question";s:16:"Back to Question";s:37:"tst_question_hints_index_column_label";s:7:"Hint %s";s:42:"tst_question_hints_table_column_hint_index";s:5:"Index";s:46:"tst_question_hints_requested_hint_count_header";s:15:"Requested Hints";s:31:"tst_activate_skill_service_desc";s:173:"A new tab ‘Competences’ will be displayed. In this tab questions are assigned to competences, then thresholds are ascribed for reaching a specific level of a competence.";s:46:"tst_question_hints_table_link_edit_hint_points";s:11:"Edit Points";s:44:"tst_question_hints_table_link_edit_hint_page";s:9:"Edit Page";s:39:"tst_question_hints_form_cmd_save_points";s:11:"Save Points";s:53:"tst_question_hints_form_cmd_save_points_and_edit_page";s:26:" Save Points and Edit Page";s:36:"tst_question_hints_back_to_hint_list";s:18:"Question Hint List";s:16:"conf_delete_pass";s:19:"Really delete pass?";s:31:"tst_availability_limitless_info";s:125:"Choose this mode for making the test available and accessible to users (depending on participant restriction settings below).";s:27:"tst_availability_until_info";s:152:"Choose this mode for making the test available and accessible to users for a fixed period of time (depending on participant restriction settings below).";s:26:"tst_activation_online_info";s:42:"If online, participants can take the test.";s:38:"tst_activation_limited_visibility_info";s:128:"Before and after the indicated period it is only the test\'s title that will be displayed. The participants cannot take the test.";s:8:"tst_copy";s:9:"Copy Test";s:17:"oq_btn_nest_terms";s:27:"Switch to term nesting view";s:20:"oq_btn_nest_pictures";s:30:"Switch to picture nesting view";s:19:"oq_btn_define_terms";s:30:"Switch to term definition view";s:22:"oq_btn_define_pictures";s:33:"Switch to picture definition view";s:27:"oq_header_ordering_elements";s:17:"Ordering Elements";s:19:"tst_extratime_added";s:69:"The working time of the participant has been increased by %s minutes.";s:20:"tst_extratime_nodata";s:50:"There are no entries for the selected participant.";s:26:"tst_extratime_notavailable";s:83:"Extra time can be added only for tests with one pass and a maximum processing time.";s:18:"tst_extratime_info";s:132:"If you want to add the working time multiple times for the same participant, please insert the total amount of time you want to add.";s:9:"extratime";s:10:"Extra Time";s:19:"log_added_extratime";s:44:"Added extra %d minutes for participant id %d";s:6:"timing";s:10:"Extra Time";s:22:"tst_change_workingtime";s:32:"Add extra time for a participant";s:17:"tst_imap_qst_mode";s:4:"Mode";s:20:"tst_imap_qst_mode_sc";s:13:"Single Choice";s:20:"tst_imap_qst_mode_mc";s:15:"Multiple Choice";s:18:"tst_test_execution";s:14:"Test Execution";s:28:"redirect_after_finishing_tst";s:8:"Redirect";s:33:"redirect_after_finishing_tst_desc";s:168:"After completion of test each participant is automatically redirected to a defined webpage. This is only valid if the participants have no access to their test results.";s:29:"redirect_after_finishing_rule";s:8:"Redirect";s:13:"redirect_none";s:11:"no redirect";s:22:"redirect_in_kiosk_mode";s:32:"only when exam view is activated";s:15:"redirect_always";s:25:"always to defined webpage";s:15:"redirection_url";s:14:"URL of webpage";s:16:"exp_file_created";s:20:"Export file created.";s:23:"tst_man_scoring_by_part";s:22:"Scoring by Participant";s:22:"tst_man_scoring_by_qst";s:19:"Scoring by Question";s:29:"tst_no_scorable_qst_available";s:30:"No question to score available";s:27:"part_received_a_of_b_points";s:49:"The participant received %s of %s possible points";s:10:"answers_of";s:11:"Answers of:";s:11:"question_id";s:11:"Question ID";s:17:"question_id_short";s:2:"ID";s:25:"apply_def_settings_to_tst";s:14:"Apply Settings";s:25:"tst_show_solution_compare";s:44:"Show Best Solution in ‘Detailed Results’";s:30:"tst_show_solution_compare_desc";s:356:"Participants are presented with an overview comparing their own answers with the best solutions. Please note that this view will be displayed in the ‘Detailed Results’ that can be accessed via the ‘Show Test Results‘-button on the ‘Info’-tab. It will not be displayed in the printable ‘List of Answers’ even though the setting is made here.";s:22:"tst_header_participant";s:12:"Your Answer:";s:19:"tst_header_solution";s:14:"Best Solution:";s:18:"assFormulaQuestion";s:16:"Formula Question";s:13:"parseQuestion";s:14:"Parse Question";s:9:"variables";s:9:"Variables";s:7:"results";s:7:"Results";s:11:"select_unit";s:19:"--- Select Unit ---";s:7:"formula";s:7:"Formula";s:13:"rating_simple";s:13:"Simple Rating";s:4:"unit";s:4:"Unit";s:9:"range_min";s:15:"Range (Minimum)";s:9:"range_max";s:15:"Range (Maximum)";s:12:"step_dim_min";s:19:"Dimension (Minimum)";s:12:"step_dim_max";s:19:"Dimension (Maximum)";s:9:"tolerance";s:13:"Tolerance (%)";s:12:"result_units";s:15:"Available Units";s:9:"all_units";s:9:"All Units";s:9:"precision";s:9:"Precision";s:9:"err_range";s:56:"The maximum range must be greater than the minimum range";s:16:"err_no_min_range";s:34:"Please enter a minimum range value";s:16:"err_no_max_range";s:34:"Please enter a maximum range value";s:16:"err_no_precision";s:24:"Please enter a precision";s:19:"err_wrong_precision";s:61:"The precision must be an integer number greater or equal zero";s:23:"err_no_min_range_number";s:32:"The minimum range must be number";s:23:"err_no_max_range_number";s:32:"The maximum range must be number";s:25:"err_tolerance_wrong_value";s:60:"The tolerance must be a percentage value between 0 and 100´";s:16:"err_wrong_points";s:34:"You must enter points for a result";s:14:"err_no_formula";s:24:"You must enter a formula";s:25:"err_wrong_rating_advanced";s:88:"Please make sure that the addition of the advanced rating settings equals to 100 percent";s:11:"rating_sign";s:9:"Rate Sign";s:12:"rating_value";s:10:"Rate Value";s:11:"rating_unit";s:9:"Rate Unit";s:10:"rated_sign";s:4:"Sign";s:11:"rated_value";s:5:"Value";s:10:"rated_unit";s:4:"Unit";s:13:"suggest_range";s:13:"Suggest Range";s:5:"units";s:5:"Units";s:38:"qpl_qst_formulaquestion_00_no_category";s:20:"No category assigned";s:8:"category";s:8:"Category";s:10:"categories";s:10:"Categories";s:12:"new_category";s:17:"New Unit Category";s:13:"selected_unit";s:13:"Selected Unit";s:8:"new_unit";s:8:"New Unit";s:6:"factor";s:6:"Factor";s:8:"baseunit";s:9:"Base Unit";s:16:"unit_placeholder";s:14:"** New Unit **";s:15:"err_no_unitname";s:24:"Please enter a unit name";s:20:"err_wrong_unitfactor";s:42:"Please enter a correct factor for the unit";s:21:"err_unit_in_variables";s:79:"The unit cannot be deleted. It is already in use in one or more test questions.";s:19:"err_unit_in_results";s:79:"The unit cannot be deleted. It is already in use in one or more test questions.";s:20:"err_unit_is_baseunit";s:67:"The unit cannot be deleted. It is used as base unit by other units.";s:31:"err_rating_advanced_not_allowed";s:122:"A rating other than simple rating is not allowed since you are offering multiple result units with an identical base unit.";s:22:"err_wrong_categoryname";s:28:"The category already exists.";s:25:"un_sure_delete_categories";s:56:"Are you sure you want to delete the selected categories?";s:27:"un_sure_delete_categories_s";s:54:"Are you sure you want to delete the selected category?";s:21:"un_deleted_categories";s:31:"Deletion successfully processed";s:23:"un_deleted_categories_s";s:31:"Deletion successfully processed";s:24:"un_cat_deletion_errors_f";s:33:"Cannot delete certain categories:";s:26:"un_cat_deletion_errors_f_s";s:23:"Cannot delete category:";s:24:"un_cat_deletion_errors_p";s:36:"Could not delete certain categories:";s:26:"un_cat_deletion_errors_p_s";s:26:"Could not delete category:";s:19:"err_category_in_use";s:94:"At least one category cannot be deleted. One or more units of the category are already in use.";s:20:"un_sure_delete_units";s:51:"Are you sure you want to delete the selected units?";s:22:"un_sure_delete_units_s";s:50:"Are you sure you want to delete the selected unit?";s:16:"un_deleted_units";s:31:"Deletion successfully processed";s:18:"un_deleted_units_s";s:31:"Deletion successfully processed";s:25:"un_unit_deletion_errors_f";s:28:"Cannot delete certain units:";s:27:"un_unit_deletion_errors_f_s";s:19:"Cannot delete unit:";s:25:"un_unit_deletion_errors_p";s:31:"Could not delete certain units:";s:27:"un_unit_deletion_errors_p_s";s:22:"Could not delete unit:";s:17:"selected_category";s:21:"Selected Category: %s";s:19:"un_sel_cat_sel_unit";s:40:"Selected Category: %s, Selected Unit: %s";s:11:"un_sequence";s:8:"Sequence";s:24:"un_no_category_id_passed";s:38:"The requested category does not exist.";s:21:"un_category_not_exist";s:38:"The requested category does not exist.";s:20:"un_no_unit_id_passed";s:34:"The requested unit does not exist.";s:17:"un_unit_not_exist";s:34:"The requested unit does not exist.";s:13:"un_save_order";s:10:"Save Order";s:12:"intprecision";s:12:"Divisible By";s:20:"errRecursionInResult";s:43:"The formula contains an infinite recursion.";s:21:"err_duplicate_results";s:84:"You used a result variable more than once. This is not allowed in the question text.";s:23:"err_duplicate_variables";s:77:"You used a variable more than once. This is not allowed in the question text.";s:21:"result_type_selection";s:21:"Result Type Selection";s:10:"result_dec";s:7:"Decimal";s:11:"result_frac";s:8:"Fraction";s:14:"result_co_frac";s:16:"Coprime Fraction";s:14:"no_result_type";s:15:"No Restrictions";s:15:"result_dec_info";s:35:"Valid results are i.e.: 2,3 and 2.3";s:16:"result_frac_info";s:35:"i.e.: 1/3 and 2/6 are valid results";s:19:"result_co_frac_info";s:54:"Canceled out fraction i.e.: only 1/3 is a valid result";s:11:"unit_editor";s:11:"Unit Editor";s:17:"custom_categories";s:19:"Question-Categories";s:14:"adm_categories";s:15:"Pool-Categories";s:33:"change_adm_categories_not_allowed";s:57:"You do not have any permissions concerning this category.";s:28:"change_adm_units_not_allowed";s:46:"This unit can only by changed by administrator";s:20:"expected_result_type";s:20:"Expected result type";s:18:"enter_valid_values";s:63:"Please enter valid value. Chars will be evaluated as incorrect!";s:22:"res_contains_undef_var";s:48:"A result formula contains an undefined variable!";s:23:"que_contains_unused_var";s:78:"The question text contains a variable, that is not used in any result formula!";s:22:"res_contains_undef_res";s:46:"A result formula contains an undefined result!";s:18:"errFormulaQuestion";s:51:"A Formula Question contains incorrect information!!";s:13:"un_show_units";s:10:"Show Units";s:14:"un_local_units";s:11:"Local Units";s:15:"un_global_units";s:12:"Global Units";s:22:"un_units_of_category_x";s:21:"Units of Category: %s";s:14:"un_unit_in_use";s:27:"The unit is already in use.";s:10:"variable_x";s:11:"Variable %s";s:8:"result_x";s:9:"Result %s";s:6:"rating";s:6:"Rating";s:15:"advanced_rating";s:15:"Advanced Rating";s:20:"advanced_rating_info";s:146:"The advanced rating is only available if a unit is assigned to the result. Further rating settings are displayed after saving the specified units.";s:20:"show_answer_overview";s:20:"Show Answer Overview";s:15:"un_add_category";s:12:"Add Category";s:11:"un_add_unit";s:8:"Add Unit";s:16:"fq_question_desc";s:232:"You can define variables by inserting $v1, $v2 ... $vn, results by inserting $r1, $r2 .... $rn at the desired position in the question text. Click on the button ‘Parse Question’ to create editing forms for variables and results.";s:15:"fq_formula_desc";s:571:"You may enter predefined variables ($v1 to $vn), defined results (e.g. $r1), braces for expressions, mathematical operators  + (addition), - (subtraction), * (multiplication), / (division), ^ (nth power), the constants ‘pi’ for pi and ‘e’ for euler\'s constant, as well as the functions ‘sin’, ‘sinh’, ‘arcsin’, ‘asin’, ‘arcsinh’, ‘asinh’, ‘cos’, ‘cosh’, ‘arccos’, ‘acos’, ‘arccosh’, ‘acosh’, ‘tan’, ‘tanh’, ‘arctan’, ‘atan’, ‘arctanh’, ‘atanh’, ‘sqrt’, ‘abs’, ‘ln’ and ‘log’.";s:17:"fq_precision_info";s:43:"Enter the number of desired decimal places.";s:17:"result_units_info";s:103:"The selected units are offered to the learner as part of an answer. The learner has to choose one unit.";s:22:"fq_no_restriction_info";s:50:"Both decimals and fractions are accepted as input.";s:22:"additional_rating_info";s:97:"Please note that the values given here are expressed as percentages and these must add up to 100.";s:17:"intprecision_info";s:485:"‘Divisible by’ affects only the creation of variables, if the value for the precision is 0. In this case, you define for ‘Divisible by’ an integer value, which must be divisible by with the created variable. A value of 10 thus generates only integers that are divisible by 10. A value of 5 produces integers that are divisible by 5, etc. For a precision of 0, ‘Divisible by’ is a mandatory field and must contain a positive integer. The default value is 1 for any integers.";s:14:"tolerance_info";s:159:"The tolerance specifies an allowable percentage deviation from the result value. With a tolerance of 0, only the exact result value is evaluated to be correct.";s:16:"result_unit_info";s:90:"Please note that the selected result unit must also be activated in ‘Available units’.";s:19:"cloze_gap_size_info";s:216:"If you enter a value greater than 0, this gap text field will be created with the fixed length of this value. If you do not enter a value, the gap text field will be created with the value of the global fixed length.";s:13:"save_and_next";s:17:"Save and Continue";s:25:"positive_numbers_required";s:35:"Please enter only positive numbers.";s:24:"user_has_finished_a_test";s:34:"A participant has finished a test.";s:21:"tst_attached_xls_file";s:73:"You find the test result for this participant in the attached Excel file.";s:34:"tst_notification_explanation_admin";s:72:"You receive this mail from ILIAS because you activated the notification.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'certificate'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:112:{s:24:"certificate_a4_landscape";s:30:"A4 Landscape (210 mm x 297 mm)";s:14:"certificate_a4";s:20:"A4 (297 mm x 210 mm)";s:24:"certificate_a5_landscape";s:30:"A5 Landscape (148 mm x 210 mm)";s:14:"certificate_a5";s:20:"A5 (210 mm x 148 mm)";s:28:"certificate_background_image";s:16:"Background Image";s:18:"certificate_bottom";s:6:"Bottom";s:33:"certificate_confirm_deletion_text";s:70:"Do you really want to delete the certificate and all its related data?";s:18:"certificate_custom";s:9:"Custom...";s:18:"certificate_delete";s:23:"Delete Certificate Data";s:16:"certificate_edit";s:34:"Create/Edit a Certificate Template";s:38:"certificate_enabled_scorm_introduction";s:97:"If checked, the certificate will be offered for all users who finished the SCORM learning module.";s:25:"certificate_enabled_scorm";s:7:"Enabled";s:24:"certificate_error_import";s:53:"An error occurred during the import of a certificate!";s:32:"certificate_error_upload_bgimage";s:60:"An error occurred during the upload of the background image!";s:18:"certificate_export";s:18:"Export Certificate";s:18:"certificate_failed";s:6:"failed";s:16:"certificate_left";s:4:"Left";s:28:"certificate_letter_landscape";s:37:"Letter Landscape (8.5 inch x 11 inch)";s:18:"certificate_letter";s:27:"Letter (11 inch x 8.5 inch)";s:23:"certificate_margin_body";s:11:"Body Margin";s:27:"certificate_not_well_formed";s:91:"The certificate text is not well formed. Please enter valid XHTML for the certificate text!";s:23:"certificate_padding_top";s:11:"Top Padding";s:28:"certificate_page_format_info";s:59:"Please select the default page format for new certificates.";s:23:"certificate_page_format";s:11:"Page Format";s:22:"certificate_pageheight";s:11:"Page Height";s:21:"certificate_pagewidth";s:10:"Page Width";s:18:"certificate_passed";s:6:"passed";s:23:"certificate_ph_birthday";s:20:"Birthday of the user";s:19:"certificate_ph_city";s:26:"City of the user\'s address";s:22:"certificate_ph_country";s:29:"Country of the user\'s address";s:19:"certificate_ph_date";s:11:"Actual date";s:23:"certificate_ph_datetime";s:20:"Actual date and time";s:25:"certificate_ph_department";s:22:"Department of the user";s:24:"certificate_ph_firstname";s:22:"First name of the user";s:23:"certificate_ph_fullname";s:55:"Full name of the user (title, first name and last name)";s:26:"certificate_ph_institution";s:23:"Institution of the user";s:27:"certificate_ph_introduction";s:38:"The following placeholders may be used";s:25:"certificate_ph_lastaccess";s:37:"Last access date and time of the user";s:23:"certificate_ph_lastname";s:21:"Last name of the user";s:23:"certificate_ph_marklong";s:29:"Users mark (official version)";s:24:"certificate_ph_markshort";s:26:"Users mark (short version)";s:24:"certificate_ph_maxpoints";s:24:"Maximum available points";s:21:"certificate_ph_passed";s:59:"‘passed’ or ‘failed’, depending on the test results";s:28:"certificate_ph_resultpercent";s:30:"Reached percentage of the user";s:27:"certificate_ph_resultpoints";s:13:"Score of user";s:25:"certificate_ph_salutation";s:10:"Salutation";s:26:"certificate_ph_scormpoints";s:46:"Points of the SCORM learning module in percent";s:25:"certificate_ph_scormtitle";s:34:"Title of the SCORM learning module";s:21:"certificate_ph_street";s:28:"Street of the user\'s address";s:24:"certificate_ph_testtitle";s:17:"Title of the test";s:20:"certificate_ph_title";s:17:"Title of the user";s:22:"certificate_ph_zipcode";s:30:"ZIP code of the user\'s address";s:31:"certificate_points_notavailable";s:31:"This value cannot be calculated";s:19:"certificate_preview";s:24:"Show Certificate Preview";s:17:"certificate_right";s:5:"Right";s:20:"certificate_settings";s:20:"Certificate Settings";s:34:"certificate_short_name_description";s:154:"Please enter a short title for the certificate name. The short title will be part of the certificate name: YYMMDD_[surname]_[SHORT_TITLE]_certificate.pdf.";s:22:"certificate_short_name";s:28:"Certificate file short title";s:16:"certificate_show";s:16:"Show Certificate";s:27:"certificate_status_complete";s:45:"The certificate is complete and could be used";s:29:"certificate_status_incomplete";s:29:"The certificate is incomplete";s:18:"certificate_status";s:6:"Status";s:16:"certificate_text";s:16:"Certificate Text";s:15:"certificate_top";s:3:"Top";s:28:"certificate_unit_description";s:71:"Enter units of measure as VALUE[cm|mm|in|pt|pc|px|em], e.g. 10mm or 3in";s:17:"certificate_usage";s:213:"Please note that the usage of certificates is only available if the ILIAS Java-Server is running. The configuration for Java-Server is available on the main page of the ILIAS administration in section Webservices.";s:26:"certificate_var_max_points";s:2:"46";s:32:"certificate_var_result_mark_long";s:4:"Good";s:33:"certificate_var_result_mark_short";s:1:"B";s:29:"certificate_var_result_passed";s:6:"passed";s:30:"certificate_var_result_percent";s:3:"83%";s:29:"certificate_var_result_points";s:2:"38";s:29:"certificate_var_user_birthday";s:10:"1977-05-08";s:25:"certificate_var_user_city";s:11:"Anytown, NY";s:28:"certificate_var_user_country";s:3:"USA";s:31:"certificate_var_user_department";s:16:"Customer Support";s:30:"certificate_var_user_firstname";s:4:"Jane";s:29:"certificate_var_user_fullname";s:12:"Dr. Jane Doe";s:32:"certificate_var_user_institution";s:17:"ILIAS Open Source";s:29:"certificate_var_user_lastname";s:3:"Doe";s:31:"certificate_var_user_salutation";s:4:"Mrs.";s:27:"certificate_var_user_street";s:15:"100 Main Street";s:26:"certificate_var_user_title";s:3:"Dr.";s:28:"certificate_var_user_zipcode";s:5:"12345";s:29:"certificate_visibility_always";s:14:"Always Visible";s:35:"certificate_visibility_introduction";s:86:"Participants will be offered to download the certificate from the test results screen.";s:28:"certificate_visibility_never";s:11:"Not Visible";s:29:"certificate_visibility_passed";s:38:"Only Visible if a User Passed the Test";s:22:"certificate_visibility";s:10:"Visibility";s:22:"certificate_wrong_unit";s:29:"You have entered a wrong unit";s:23:"certificate_wrong_units";s:37:"You have entered a wrong set of units";s:23:"default_background_info";s:185:"This background image will be chosen as default background for all certificates. If you need another background image in a certficiate, you have to upload one in the certificate editor.";s:20:"download_certificate";s:20:"Download Certificate";s:29:"certificate_ph_scormmaxpoints";s:102:"Maximum value in the range for the raw score of the last relevant sco (most suitable for a final exam)";s:20:"certificate_ph_login";s:5:"Login";s:26:"certificate_var_user_login";s:4:"jdoe";s:29:"certificate_ph_date_completed";s:18:"Date of completion";s:33:"certificate_ph_datetime_completed";s:27:"Date and time of completion";s:30:"certificate_ph_passed_exercise";s:28:"‘Passed’ or ‘Failed’";s:19:"certificate_ph_mark";s:10:"Users mark";s:28:"certificate_ph_exercisetitle";s:14:"Exercise Title";s:38:"certificate_visibility_passed_exercise";s:42:"Only Visible if a User Passed the Exercise";s:21:"certificate_ph_no_sco";s:141:"If items are selected to determine the overall learning progress status, titles and points for these items could be displayed in certificate.";s:19:"certificate_ph_scos";s:136:"The following items were selected to determine the overall learning progress status and are available for statements in the certificate:";s:24:"certificate_ph_title_sco";s:5:"title";s:24:"certificate_ph_sco_title";s:25:"placeholder<br/>for title";s:32:"certificate_ph_sco_points_scaled";s:41:"placeholder<br/>for points<br/>in percent";s:29:"certificate_ph_sco_points_raw";s:26:"placeholder<br/>for points";s:29:"certificate_ph_sco_points_max";s:34:"placeholder<br/>for points<br/>max";s:25:"certificate_file_basename";s:11:"Certificate";s:29:"certificate_var_matriculation";s:5:"12345";s:28:"certificate_ph_matriculation";s:32:"Matriculation number of the user";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'cntr'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:38:{s:17:"cntr_add_new_item";s:12:"Add New Item";s:23:"cntr_back_to_old_editor";s:18:"Back to Old Editor";s:27:"cntr_disable_multi_commands";s:22:"Disable Multi Commands";s:26:"cntr_enable_multi_commands";s:21:"Enable Multi Commands";s:24:"cntr_hide_title_and_icon";s:19:"Hide Title and Icon";s:11:"cntr_manage";s:6:"Manage";s:36:"cntr_old_editor_open_standard_editor";s:20:"Open Standard Editor";s:23:"cntr_old_editor_warning";s:226:"The maintenance of this editor will be discontinued in a future major releases of ILIAS. You may still use it to edit the content of this page now. But we recommend to switch to the standard page editor of ILIAS when possible.";s:13:"cntr_ordering";s:7:"Sorting";s:17:"cntr_page_actions";s:12:"Page Actions";s:18:"cntr_saved_sorting";s:14:"Saved Sorting.";s:29:"cntr_switch_to_new_editor_cmd";s:64:"Switch to new content of this page. Old content will be removed.";s:33:"cntr_switch_to_new_editor_message";s:200:"This is the supported standard editor. The content from the old editor cannot be transferred. Please start adding new page content below. If you click the following link, the new content will be used.";s:20:"cntr_switched_editor";s:24:"Switched to new content.";s:22:"cntr_text_media_editor";s:14:"Customize Page";s:17:"cntr_view_by_type";s:20:"Grouped-by-Type View";s:22:"cntr_view_info_by_type";s:60:"This content presentation groups all items by resource type.";s:23:"cntr_view_info_sessions";s:99:"This content presentation groups all sessions first. After that the other course content is listed.";s:21:"cntr_view_info_simple";s:55:"This content presentation lists all items in one block.";s:18:"cntr_view_sessions";s:13:"Sessions View";s:16:"cntr_view_simple";s:11:"Simple View";s:14:"edit_questions";s:14:"Edit Questions";s:33:"container_import_zip_file_invalid";s:109:"The uploaded file is not a valid ILIAS export file. To upload a directory structure please use a file object.";s:18:"cntr_adopt_content";s:13:"Adopt Content";s:35:"prtf_create_portfolio_from_template";s:30:"Create Portfolio From Template";s:24:"exc_next_deadline_single";s:8:"Deadline";s:32:"cntr_container_only_on_their_own";s:105:"Categories, courses, groups or folders can only be copied as single objects. Please select one item only.";s:18:"objects_duplicated";s:14:"Objects copied";s:23:"cntr_tax_none_available";s:34:"There are no taxonomies available.";s:32:"cntr_taxonomy_sideblock_settings";s:21:"Presentation Settings";s:28:"cntr_taxonomy_show_sideblock";s:27:"Show taxonomy in side block";s:26:"sorting_new_items_position";s:24:"Position For New Objects";s:24:"sorting_new_items_at_top";s:3:"Top";s:27:"sorting_new_items_at_bottom";s:6:"Bottom";s:23:"sorting_new_items_order";s:21:"Order For New Objects";s:25:"cntr_taxonomy_definitions";s:19:"Taxonomy Definition";s:18:"cntr_tax_list_info";s:72:"The following are all taxonomies that have been defined for this object.";s:16:"cont_custom_icon";s:11:"Custom Icon";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'rbac'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:671:{s:20:"accs_edit_permission";s:73:"User can change permissions of Accessibility Settings  in Administration.";s:9:"accs_read";s:65:"User has read access to Accessibility Settings in Administration.";s:12:"accs_visible";s:53:"Accessibility Settings are visible in Administration.";s:10:"accs_write";s:55:"User can edit Accessibility Settings in Administration.";s:19:"adm_edit_permission";s:66:"User can change permissions of General Settings in Administration.";s:8:"adm_read";s:59:"User has read access to General Settings in Administration.";s:11:"adm_visible";s:47:"General Settings are visible in Administration.";s:9:"adm_write";s:49:"User can edit General Settings in Administration.";s:24:"adopt_perm_from_template";s:24:"Copy Permission Settings";s:20:"adve_edit_permission";s:61:"User can change permission settings of Editing administration";s:9:"adve_read";s:46:"User has read access to Editing Administration";s:12:"adve_visible";s:33:"Editing Administration is visible";s:10:"adve_write";s:48:"User can edit settings of Editing Administration";s:20:"assf_edit_permission";s:73:"User can change permission settings of Test and Assessment administration";s:9:"assf_read";s:55:"User has read access Test and Assessment Administration";s:12:"assf_visible";s:45:"Test and Assessment administration is visible";s:10:"assf_write";s:60:"User can edit settings of Test and Assessment Administration";s:20:"auth_edit_permission";s:85:"User can change permission settings of Authentication and Registration administration";s:9:"auth_read";s:73:"User has read access to administration of Authentication and Registration";s:12:"auth_visible";s:60:"Administration of Authentication and Registration is visible";s:10:"auth_write";s:58:"User can edit settings for Authentication and Registration";s:26:"cat_cat_administrate_users";s:69:"User can create and administrate local user accounts in this category";s:8:"cat_copy";s:22:"User can copy category";s:10:"cat_delete";s:32:"User can move or delete category";s:19:"cat_edit_permission";s:35:"User can change permission settings";s:14:"cat_read_users";s:58:"User can read local user accounts created in this category";s:8:"cat_read";s:32:"User has read access to category";s:11:"cat_visible";s:19:"Category is visible";s:9:"cat_write";s:53:"User can edit settings of category and manage content";s:20:"cert_edit_permission";s:66:"User can change permission settings of Certificates administration";s:9:"cert_read";s:51:"User has read access to Certificates Administration";s:12:"cert_visible";s:38:"Certificates Administration is visible";s:10:"cert_write";s:53:"User can edit settings in Certificates Administration";s:32:"change_existing_object_type_desc";s:78:"This will also change the permissions of already existing objects of that type";s:28:"change_existing_objects_desc";s:215:"The permission settings of this role will be adopted to ALL existing objects. If you want to change permissions only for specific object types please click the checkboxes to the right of the appropriate object type.";s:23:"change_existing_objects";s:23:"Change Existing Objects";s:29:"change_existing_prefix_single";s:6:"Change";s:22:"change_existing_prefix";s:15:"Change Existing";s:29:"change_existing_suffix_single";s:6:"&nbsp;";s:22:"change_existing_suffix";s:6:"&nbsp;";s:8:"crs_copy";s:20:"User can copy course";s:16:"rbac_create_fold";s:13:"Create Folder";s:10:"crs_delete";s:30:"User can move or delete course";s:26:"crs_edit_learning_progress";s:40:"User can edit learning progress settings";s:19:"crs_edit_permission";s:35:"User can change permission settings";s:8:"crs_join";s:20:"User can join course";s:9:"crs_leave";s:32:"User can unsubscribe from course";s:8:"crs_read";s:30:"User has read access to course";s:11:"crs_visible";s:17:"Course is visible";s:9:"crs_write";s:48:"User can edit course settings and manage content";s:19:"edit_roleassignment";s:20:"Edit role assignment";s:8:"exc_copy";s:22:"User can copy exercise";s:10:"exc_delete";s:32:"User can move or delete exercise";s:26:"exc_edit_learning_progress";s:40:"User can edit learning progress settings";s:19:"exc_edit_permission";s:35:"User can change permission settings";s:8:"exc_read";s:32:"User can participate at exercise";s:11:"exc_visible";s:19:"Exercise is visible";s:9:"exc_write";s:50:"User can edit settings and assignments of exercise";s:20:"extt_edit_permission";s:74:"User can change permission settings of Third Party Software administration";s:9:"extt_read";s:62:"User has read access to administration of Third Party Software";s:12:"extt_visible";s:49:"Administration of Third Party Software is visible";s:10:"extt_write";s:46:"User can edit settings of Third Party Software";s:11:"feed_delete";s:32:"User can move or delete web feed";s:20:"feed_edit_permission";s:35:"User can change permission settings";s:9:"feed_read";s:33:"User can read content of web feed";s:12:"feed_visible";s:19:"Web feed is visible";s:10:"feed_write";s:31:"User can edit web feed settings";s:9:"file_copy";s:18:"User can copy file";s:11:"file_delete";s:28:"User can move or delete file";s:20:"file_edit_permission";s:35:"User can change permission settings";s:9:"file_read";s:22:"User can download file";s:12:"file_visible";s:15:"File is visible";s:10:"file_write";s:58:"User can edit file settings and upload new version of file";s:9:"fold_copy";s:20:"User can copy folder";s:11:"fold_delete";s:30:"User can move or delete folder";s:27:"fold_edit_learning_progress";s:40:"User can edit learning progress settings";s:20:"fold_edit_permission";s:35:"User can change permission settings";s:9:"fold_read";s:30:"User has read access to folder";s:12:"fold_visible";s:17:"Folder is visible";s:10:"fold_write";s:51:"User can edit settings of folder and manage content";s:13:"frm_add_reply";s:28:"Users can reply to a posting";s:14:"frm_add_thread";s:25:"User can add a new thread";s:8:"frm_copy";s:19:"User can copy forum";s:10:"frm_delete";s:29:"User can move or delete forum";s:19:"frm_edit_permission";s:35:"User can change permission settings";s:16:"frm_moderate_frm";s:41:"User can edit, censor and delete postings";s:8:"frm_read";s:27:"User can read forum content";s:11:"frm_visible";s:16:"Forum is visible";s:9:"frm_write";s:43:"User can edit forum settings and moderators";s:8:"glo_copy";s:22:"User can copy glossary";s:10:"glo_delete";s:32:"User can move or delete glossary";s:19:"glo_edit_permission";s:35:"User can change permission settings";s:8:"glo_read";s:30:"User can read glossary content";s:11:"glo_visible";s:19:"Glossary is visible";s:9:"glo_write";s:46:"User can edit content and settings of glossary";s:8:"grp_copy";s:19:"User can copy group";s:10:"grp_delete";s:29:"User can move or delete group";s:26:"grp_edit_learning_progress";s:40:"User can edit learning progress settings";s:19:"grp_edit_permission";s:35:"User can change permission settings";s:8:"grp_join";s:19:"User can join group";s:9:"grp_leave";s:31:"User can unsubscribe from group";s:8:"grp_read";s:29:"User has read access to group";s:11:"grp_visible";s:16:"Group is visible";s:9:"grp_write";s:47:"User can edit group settings and manage content";s:9:"htlm_copy";s:34:"User can copy HTML learning module";s:11:"htlm_delete";s:44:"User can move or delete HTML learning module";s:27:"htlm_edit_learning_progress";s:40:"User can edit learning progress settings";s:20:"htlm_edit_permission";s:35:"User can change permission settings";s:9:"htlm_read";s:34:"User can read HTML learning module";s:12:"htlm_visible";s:31:"HTML learning module is visible";s:10:"htlm_write";s:58:"User can edit content and settings of HTML learning module";s:7:"lm_copy";s:35:"User can copy ILIAS learning module";s:9:"lm_delete";s:45:"User can move or delete ILIAS learning module";s:25:"lm_edit_learning_progress";s:40:"User can edit learning progress settings";s:18:"lm_edit_permission";s:35:"User can change permission settings";s:7:"lm_read";s:35:"User can read ILIAS learning module";s:10:"lm_visible";s:32:"ILIAS Learning Module is visible";s:8:"lm_write";s:59:"User can edit content and settings of ILIAS learning module";s:20:"lngf_edit_permission";s:62:"User can change permission settings of Language administration";s:9:"lngf_read";s:47:"User has read access to Language administration";s:12:"lngf_visible";s:34:"Language administration is visible";s:10:"lngf_write";s:87:"User can edit settings in Language administration and use extended language maintenance";s:20:"lrss_edit_permission";s:72:"User can change permission settings of Learning Resources administration";s:9:"lrss_read";s:51:"Read access to administration of Learning Resources";s:12:"lrss_visible";s:47:"Administration of Learning Resources is visible";s:10:"lrss_write";s:62:"User can edit settings of Learning Resources in administration";s:9:"mail_read";s:43:"User has read access to Mail administration";s:14:"mail_smtp_mail";s:52:"User can send e-mails per SMTP to external addresses";s:19:"mail_system_message";s:38:"User can send internal system messages";s:12:"mail_visible";s:30:"Mail administration is visible";s:10:"mail_write";s:45:"User can edit settings in Mail administration";s:9:"mcst_copy";s:23:"User can copy mediacast";s:11:"mcst_delete";s:33:"User can move or delete mediacast";s:20:"mcst_edit_permission";s:35:"User can change permission settings";s:9:"mcst_read";s:23:"User can read mediacast";s:12:"mcst_visible";s:20:"Mediacast is visible";s:10:"mcst_write";s:47:"User can edit content and settings of mediacast";s:10:"mep_delete";s:34:"User can move or delete media pool";s:19:"mep_edit_permission";s:35:"User can change permission settings";s:8:"mep_read";s:62:"User has read access to media pool and can reuse media objects";s:11:"mep_visible";s:21:"Media pool is visible";s:9:"mep_write";s:48:"User can edit content and settings of media pool";s:20:"mobs_edit_permission";s:73:"User can change permission settings in Media Objects/Pools administration";s:9:"mobs_read";s:58:"User has read access to Media Objects/Pools administration";s:12:"mobs_visible";s:45:"Media Objects/Pools administration is visible";s:10:"mobs_write";s:60:"User can edit settings in Media Objects/Pools administration";s:20:"nwss_edit_permission";s:72:"User can change permission settings in News and Web Feeds administration";s:9:"nwss_read";s:56:"User has read access to ews and Web Feeds administration";s:12:"nwss_visible";s:44:"News and Web Feeds administration is visible";s:10:"nwss_write";s:59:"User can edit settings in News and Web Feeds administration";s:20:"pays_edit_permission";s:58:"User can change permission settings in Shop administration";s:9:"pays_read";s:43:"User has read access to Shop administration";s:12:"pays_visible";s:30:"Shop administration is visible";s:10:"pays_write";s:45:"User can edit settings in Shop administration";s:18:"ps_edit_permission";s:70:"User can change permission settings of Privacy/Security administration";s:21:"ps_export_member_data";s:49:"User can export member data in courses and groups";s:7:"ps_read";s:55:"User has read access to Privacy/Security administration";s:10:"ps_visible";s:42:"Privacy/Security administration is visible";s:8:"ps_write";s:57:"User can edit settings in Privacy/Security administration";s:8:"qpl_copy";s:37:"User can copy question pool for tests";s:10:"qpl_delete";s:37:"User can move or delete question pool";s:19:"qpl_edit_permission";s:35:"User can change permission settings";s:8:"qpl_read";s:61:"User can read test questions in pool and insert them in tests";s:11:"qpl_visible";s:24:"Question pool is visible";s:9:"qpl_write";s:58:"User can edit test questions and settings of question pool";s:15:"rbac_create_cat";s:17:"Create Categories";s:20:"root_edit_permission";s:35:"User can change permission settings";s:9:"root_read";s:48:"User has read access to <i>Repository - Home</i>";s:12:"root_visible";s:35:"<i>Repository - Home</i> is visible";s:10:"root_write";s:69:"User can edit settings of <i>Repository - Home</i> and manage content";s:9:"sahs_copy";s:40:"User can copy SCORM/AICC learning module";s:11:"sahs_delete";s:50:"User can move or delete SCORM/AICC learning module";s:27:"sahs_edit_learning_progress";s:40:"User can edit learning progress settings";s:20:"sahs_edit_permission";s:35:"User can change permission settings";s:9:"sahs_read";s:40:"User can read SCORM/AICC learning module";s:12:"sahs_visible";s:37:"SCORM/AICC learning module is visible";s:10:"sahs_write";s:64:"User can edit content and settings of SCORM/AICC learning module";s:20:"seas_edit_permission";s:60:"User can change permission settings or Search administration";s:9:"seas_read";s:45:"User has read access to Search administration";s:11:"seas_search";s:39:"User can use the global search in ILIAS";s:12:"seas_visible";s:32:"Search administration is visible";s:10:"seas_write";s:38:"Edit settings in Search administration";s:9:"sess_copy";s:21:"User can copy session";s:8:"spl_copy";s:39:"User can copy question pool for surveys";s:10:"spl_delete";s:37:"User can move or delete question pool";s:19:"spl_edit_permission";s:35:"User can change permission settings";s:8:"spl_read";s:64:"User can read survey questions in pool and insert them in survey";s:11:"spl_visible";s:24:"Question pool is visible";s:9:"spl_write";s:60:"User can edit survey questions and settings of question pool";s:20:"stys_edit_permission";s:71:"User can change permission settings of Layout and Styles administration";s:9:"stys_read";s:56:"User has read access to Layout and Styles administration";s:12:"stys_visible";s:43:"Layout and Styles administration is visible";s:10:"stys_write";s:58:"User can edit settings in Layout and Styles administration";s:8:"svy_copy";s:20:"User can copy survey";s:10:"svy_delete";s:30:"User can move or delete survey";s:19:"svy_edit_permission";s:35:"User can change permission settings";s:10:"svy_invite";s:34:"User can invite others to a survey";s:8:"svy_read";s:32:"User can participate at a survey";s:11:"svy_visible";s:17:"Survey is visible";s:9:"svy_write";s:44:"User can edit content and settings of survey";s:20:"tags_edit_permission";s:61:"User can change permission settings in Tagging administration";s:9:"tags_read";s:46:"User has read access to Tagging administration";s:12:"tags_visible";s:33:"Tagging administration is visible";s:10:"tags_write";s:48:"User can edit settings in Tagging administration";s:11:"trac_delete";s:29:"User can delete tracking data";s:20:"trac_edit_permission";s:77:"Change permission settings in Statistics and Learning Progress administration";s:9:"trac_read";s:71:"User has read access to Statistics and Learning Progress administration";s:12:"trac_visible";s:58:"Statistics and Learning Progress administration is visible";s:8:"tst_copy";s:18:"User can copy test";s:10:"tst_delete";s:28:"User can move or delete test";s:26:"tst_edit_learning_progress";s:40:"User can edit learning progress settings";s:19:"tst_edit_permission";s:35:"User can change permission settings";s:8:"tst_read";s:25:"User can perform the test";s:11:"tst_visible";s:15:"Test is visible";s:9:"tst_write";s:42:"User can edit content and settings of test";s:11:"usrf_delete";s:29:"User can delete user accounts";s:20:"usrf_edit_permission";s:58:"User can change permission settings in User administration";s:24:"usrf_edit_roleassignment";s:47:"User can change role assignment of user account";s:23:"usrf_push_desktop_items";s:69:"User is allowed to push items on the personal desktop.of role members";s:15:"usrf_read_users";s:66:"User has read access to local user accounts (local administrators)";s:9:"usrf_read";s:43:"User has read access to User administration";s:12:"usrf_visible";s:30:"User administration is visible";s:10:"usrf_write";s:36:"Edit settings in User administration";s:9:"webr_copy";s:21:"User can copy weblink";s:11:"webr_delete";s:31:"User can move or delete weblink";s:20:"webr_edit_permission";s:35:"User can change permission settings";s:9:"webr_read";s:30:"User can read and use weblinks";s:12:"webr_visible";s:18:"Weblink is visible";s:10:"webr_write";s:34:"User can edit settings of weblinks";s:9:"wiki_copy";s:18:"User can copy wiki";s:11:"wiki_delete";s:28:"User can move or delete wiki";s:17:"wiki_edit_content";s:35:"User can create and edit wiki pages";s:20:"wiki_edit_permission";s:35:"User can change permission settings";s:9:"wiki_read";s:26:"User can read wiki content";s:12:"wiki_visible";s:15:"Wiki is visible";s:10:"wiki_write";s:30:"User can edit settings of wiki";s:15:"cals_edit_event";s:61:"User can create and edit public calendars and events in ILIAS";s:20:"cals_edit_permission";s:63:"User can change permission settings for Calendar administration";s:9:"cals_read";s:47:"User has read access to Calendar Administration";s:12:"cals_visible";s:34:"Calendar Administration is visible";s:10:"cals_write";s:49:"User can edit settings of Calendar Administration";s:9:"catr_copy";s:32:"User can copy category reference";s:11:"catr_delete";s:42:"User can move or delete category reference";s:20:"catr_edit_permission";s:35:"User can change permission settings";s:9:"catr_read";s:33:"Read access to Category Reference";s:12:"catr_visible";s:29:"Category reference is visible";s:10:"catr_write";s:44:"User can edit settings of category reference";s:20:"cmps_edit_permission";s:83:"User can change permission settings of Plugins, Modules and Services administration";s:9:"cmps_read";s:71:"User has read access to administration of Plugins, Modules and Services";s:12:"cmps_visible";s:67:"Administration of Plugins, Modules and Services settings is visible";s:10:"cmps_write";s:55:"User can edit settings of Plugins, Modules and Services";s:16:"rbac_create_sess";s:14:"Create Session";s:14:"crs_edit_event";s:20:"Edit Calendar Events";s:9:"crsr_copy";s:30:"User can copy course reference";s:11:"crsr_delete";s:40:"User can move or delete course reference";s:20:"crsr_edit_permission";s:35:"User can change permission settings";s:9:"crsr_read";s:31:"Read access to Course Reference";s:12:"crsr_visible";s:27:"Course reference is visible";s:10:"crsr_write";s:42:"User can edit settings of course reference";s:22:"edit_learning_progress";s:22:"Edit Learning Progress";s:20:"facs_edit_permission";s:71:"User can change permission settings of Files and Folders administration";s:9:"facs_read";s:59:"User has read access to administration of Files and Folders";s:12:"facs_visible";s:46:"Administration of Files and Folders is visible";s:10:"facs_write";s:61:"User can edit settings in administration of Files and Folders";s:16:"filter_all_roles";s:33:"Show all roles of current context";s:19:"filter_global_roles";s:22:"Show only global roles";s:25:"filter_local_roles_object";s:46:"Show only local roles defined at this position";s:18:"filter_local_roles";s:40:"Show only local roles of current context";s:25:"filter_roles_local_policy";s:53:"Show only roles using a local policy at this position";s:14:"grp_edit_event";s:20:"Edit Calendar Events";s:22:"info_user_view_changed";s:17:"User view changed";s:5:"leave";s:5:"Leave";s:20:"mcts_edit_permission";s:63:"User can change permission settings in Mediacast administration";s:9:"mcts_read";s:48:"User has read access to Mediacast administration";s:12:"mcts_visible";s:35:"Mediacast administration is visible";s:10:"mcts_write";s:50:"User can edit settings in Mediacast administration";s:19:"mds_edit_permission";s:62:"User can change permission settings in Metadata administration";s:8:"mds_read";s:47:"User has read access to Metadata administration";s:11:"mds_visible";s:34:"Metadata administration is visible";s:9:"mds_write";s:49:"User can edit settings in Metadata administration";s:20:"msg_no_roles_of_type";s:47:"No Roles available with selected filter setting";s:20:"pdts_edit_permission";s:70:"User can change permission settings of Personal Desktop administration";s:9:"pdts_read";s:55:"User has read access to Personal Desktop administration";s:12:"pdts_visible";s:42:"Personal Desktop administration is visible";s:10:"pdts_write";s:48:"Edit settings of Personal Desktop administration";s:17:"perm_administrate";s:12:"Administrate";s:22:"perm_class_create_desc";s:69:"Determine which object types may be created under the current object.";s:17:"perm_class_create";s:18:"Create new Objects";s:23:"perm_class_general_desc";s:101:"Common operations available for all objects. Hover the cursor over operation to get more information.";s:18:"perm_class_general";s:18:"General operations";s:22:"perm_class_object_desc";s:27:"Object-specific operations.";s:17:"perm_class_object";s:18:"Special Operations";s:20:"perm_class_rbac_desc";s:134:"Access control to Permission settings (this menu) and local policy settings for automatic permission settings for new created objects.";s:15:"perm_class_rbac";s:19:"Permission settings";s:20:"perm_local_role_desc";s:83:"This role is locally defined at the current object and correspond to a local policy";s:15:"perm_local_role";s:10:"Local Role";s:26:"perm_use_local_policy_desc";s:106:"If local policy is activated, you may define different default permission settings for the current object.";s:21:"perm_use_local_policy";s:16:"Use local policy";s:32:"rbac_change_existing_confirm_tbl";s:42:"Settings for ‘Change Existing Objects’";s:31:"rbac_delete_local_policies_info";s:105:"If activated, all local policies will be deleted. The object permissions will be rewritten and protected.";s:26:"rbac_delete_local_policies";s:21:"Delete Local Policies";s:16:"rbac_delete_role";s:11:"Delete Role";s:29:"rbac_keep_local_policies_info";s:131:"Choose this mode for keeping all local policies. The object permissions will be adapted to these policies and afterwards protected.";s:24:"rbac_keep_local_policies";s:19:"Keep Local Policies";s:19:"rbac_local_policies";s:14:"Local Policies";s:20:"rbac_role_delete_qst";s:122:"Are you sure you want to delete the following role?<br />All permissions granted by this role will be deleted permanently.";s:21:"rbac_role_delete_self";s:143:"<strong>Attention:</strong> You are assigned to this role. If you continue this delete operation, you may loose access to some ILIAS materials.";s:22:"rbac_role_exists_alert";s:85:"A role with the same name already exists in this context. Please choose another name.";s:43:"rbac_unprotected_delete_local_policies_info";s:110:"If activated, all local policies will be deleted. Permissions in courses and groups will be newly initialized.";s:41:"rbac_unprotected_keep_local_policies_info";s:44:"Choose this mode to keep all local policies.";s:11:"rcrs_delete";s:34:"User can move or delete ECS Course";s:20:"rcrs_edit_permission";s:35:"User can change permission settings";s:9:"rcrs_read";s:23:"User can use ECS Course";s:12:"rcrs_visible";s:21:"ECS Course is visible";s:10:"rcrs_write";s:36:"User can edit settings of ECS Course";s:20:"recf_edit_permission";s:70:"User can change permission settings of Restored Objects administration";s:9:"recf_read";s:55:"User has read access to Restored Objects administration";s:12:"recf_visible";s:42:"Restored Objects administration is visible";s:10:"recf_write";s:68:"Edit Settings and restore objects in Restored Objects administration";s:16:"rbac_create_catr";s:25:"Create Category Reference";s:15:"rbac_create_crs";s:13:"Create Course";s:16:"rbac_create_crsr";s:23:"Create Course Reference";s:15:"rbac_create_exc";s:15:"Create Exercise";s:16:"rbac_create_feed";s:15:"Create Web Feed";s:16:"rbac_create_file";s:11:"Upload File";s:15:"rbac_create_frm";s:12:"Create Forum";s:15:"rbac_create_glo";s:15:"Create Glossary";s:15:"rbac_create_grp";s:12:"Create Group";s:16:"rbac_create_htlm";s:27:"Create HTML Learning Module";s:14:"rbac_create_lm";s:28:"Create ILIAS Learning Module";s:16:"rbac_create_mcst";s:16:"Create Mediacast";s:15:"rbac_create_mep";s:17:"Create Media Pool";s:15:"rbac_create_qpl";s:25:"Create Question Pool Test";s:16:"rbac_create_rcrs";s:17:"Create ECS Course";s:16:"rbac_create_sahs";s:33:"Create SCORM/AICC Learning Module";s:15:"rbac_create_spl";s:27:"Create Question Pool Survey";s:15:"rbac_create_svy";s:13:"Create Survey";s:15:"rbac_create_tst";s:11:"Create Test";s:16:"rbac_create_webr";s:14:"Create Weblink";s:16:"rbac_create_wiki";s:11:"Create Wiki";s:11:"sess_delete";s:31:"User can move or delete session";s:15:"sess_edit_event";s:20:"Edit Calendar Events";s:20:"sess_edit_permission";s:35:"User can change permission settings";s:9:"sess_read";s:32:"User has read access to sessions";s:12:"sess_visible";s:20:"Sessions are visible";s:10:"sess_write";s:42:"User can edit session content and settings";s:20:"svyf_edit_permission";s:56:"User change permission settings in Survey administration";s:9:"svyf_read";s:45:"User has read access to Survey administration";s:12:"svyf_visible";s:32:"Survey administration is visible";s:10:"svyf_write";s:38:"Edit settings in Survey administration";s:25:"mail_mail_to_global_roles";s:35:"User can send mails to global roles";s:30:"rbac_msg_user_already_assigned";s:51:"The chosen users are already assigned to this role.";s:23:"rbac_add_new_local_role";s:18:"Add New Local Role";s:27:"cals_add_consultation_hours";s:54:"User can offer and edit consultation hours in calendar";s:3:"log";s:3:"Log";s:8:"rbac_log";s:3:"Log";s:12:"rbac_changes";s:7:"Changes";s:22:"rbac_log_operation_add";s:24:"Added Operation for "%s"";s:22:"rbac_log_operation_rmv";s:26:"Removed Operation for "%s"";s:24:"rbac_log_inheritance_add";s:28:"Stopped Inheritance for "%s"";s:24:"rbac_log_inheritance_rmv";s:28:"Allowed Inheritance for "%s"";s:22:"rbac_log_source_object";s:13:"Source object";s:25:"rbac_log_edit_permissions";s:16:"Edit Permissions";s:20:"rbac_log_move_object";s:11:"Move Object";s:20:"rbac_log_link_object";s:11:"Link Object";s:20:"rbac_log_copy_object";s:11:"Copy Object";s:22:"rbac_log_create_object";s:13:"Create Object";s:22:"rbac_log_edit_template";s:18:"Edit Role Template";s:31:"rbac_log_edit_template_existing";s:38:"Use Role Template for Existing Objects";s:21:"rbac_log_change_owner";s:22:"Change Owner of Object";s:22:"rbac_log_changed_owner";s:16:"Changed Owner to";s:24:"rbac_role_add_to_desktop";s:23:"Add To Personal Desktop";s:29:"rbac_role_add_to_desktop_info";s:56:"Make object a selected desktop item for all role members";s:21:"rbac_role_rights_copy";s:16:"Copy Permissions";s:27:"rbac_role_rights_copy_empty";s:4:"None";s:37:"rbac_role_rights_copy_change_existing";s:23:"Change Existing Objects";s:16:"perm_global_role";s:11:"Global Role";s:26:"perm_protected_global_role";s:21:"Protected Global Role";s:25:"perm_protected_local_role";s:20:"Protected Local Role";s:27:"perm_role_path_info_created";s:22:"Created in %1$s "%2$s"";s:31:"perm_role_path_info_inheritance";s:35:"using local policy from %1$s "%2$s"";s:10:"read_users";s:28:"Read Access to User Accounts";s:22:"cat_administrate_users";s:32:"Administrate Local User Accounts";s:15:"edit_permission";s:18:"Change Permissions";s:10:"edit_event";s:13:"Edit Calendar";s:20:"book_edit_permission";s:52:"User can change permission settings for booking pool";s:12:"book_visible";s:23:"Booking pool is visible";s:9:"book_read";s:49:"User can book resources / objects in booking pool";s:11:"book_delete";s:36:"User can move or delete booking pool";s:10:"book_write";s:50:"User can edit settings and content of booking pool";s:16:"rbac_create_book";s:19:"Create Booking Pool";s:5:"write";s:13:"Edit Settings";s:17:"rbac_local_policy";s:12:"Local Policy";s:15:"role_block_role";s:10:"Block Role";s:20:"role_block_role_desc";s:67:"The access to this and all subordinated objects is will be revoked.";s:28:"role_confirm_block_role_info";s:185:"The following operations will be performed:<br /><br />- the role permissions of this and all subordinated objects will be blocked.<br />- the new permission settings will be protected.";s:30:"role_confirm_block_role_header";s:45:"Do you really want to block the chosen roles?";s:18:"push_desktop_items";s:34:"Push Items on the Personal Desktop";s:9:"smtp_mail";s:11:"SMTP E-Mail";s:20:"mail_to_global_roles";s:12:"Global Mails";s:9:"add_reply";s:9:"Add Reply";s:10:"add_thread";s:10:"Add Thread";s:12:"moderate_frm";s:8:"Moderate";s:27:"rbac_repository_permissions";s:22:"Repository Permissions";s:22:"rbac_admin_permissions";s:26:"Administration Permissions";s:22:"add_consultation_hours";s:22:"Add Consultation Hours";s:18:"export_member_data";s:16:"Access User Data";s:42:"rbac_change_existing_objects_desc_new_role";s:77:"The permission settings of this role will be adopted to ALL existing objects.";s:12:"frma_visible";s:31:"Forum Administration is visible";s:9:"frma_read";s:44:"User has read access to Forum Administration";s:10:"frma_write";s:46:"User can edit settings in Forum Administration";s:20:"frma_edit_permission";s:59:"User can change permission settings of Forum administration";s:15:"rbac_create_usr";s:39:"User is allowed to create user accounts";s:27:"precondition_obligatory_alt";s:30:"Precondition must be fulfilled";s:31:"precondition_not_obligatory_alt";s:24:"Precondition is optional";s:20:"active_preconditions";s:13:"Preconditions";s:23:"precondition_obligatory";s:10:"Compulsory";s:28:"precondition_obligatory_info";s:62:"Compulsory preconditions must be fulfilled, for having access.";s:32:"precondition_obligatory_settings";s:21:"Precondition Settings";s:27:"precondition_num_obligatory";s:28:"Number of Required Materials";s:30:"precondition_num_optional_info";s:83:"Please enter the minimum number of materials required to fulfill this precondition.";s:6:"invite";s:18:"Inviting to survey";s:16:"rbac_global_rolt";s:20:"Global Role Template";s:19:"rbac_role_selection";s:9:"Role Type";s:16:"rbac_auto_global";s:26:"Auto generated global role";s:14:"rbac_ud_global";s:24:"User defined global role";s:15:"rbac_auto_local";s:25:"Auto generated local role";s:13:"rbac_ud_local";s:23:"User defined local role";s:14:"rbac_auto_rolt";s:28:"Auto generated role template";s:12:"rbac_ud_rolt";s:26:"User defined role template";s:19:"rbac_context_global";s:6:"Global";s:12:"chtr_visible";s:19:"Chatroom is visible";s:9:"chtr_read";s:42:"User can join and participate at Chat Room";s:10:"chtr_write";s:49:"User can edit settings of Chat Room and ban users";s:20:"chtr_edit_permission";s:49:"User can change Permission Settings for Chat Room";s:13:"chtr_moderate";s:41:"User can moderate discussion in chat room";s:12:"otpl_visible";s:47:"Administration of Didactic Templates is visible";s:9:"otpl_read";s:57:"User has read access to Didactic Templates administration";s:10:"otpl_write";s:44:"User can edit settings of Didactic Templates";s:20:"otpl_edit_permission";s:75:"User can change permission settings in administration of Didactic Templates";s:21:"rbac_back_to_overview";s:17:"Back to Role List";s:24:"rbac_choose_copy_targets";s:52:"Please enter a query for selecting the target roles.";s:24:"rbac_select_copy_targets";s:30:"Please select the target roles";s:15:"rbac_role_title";s:10:"Role Title";s:19:"rbac_copy_behaviour";s:18:"Role Copy Settings";s:32:"rbac_not_change_existing_objects";s:30:"Do NOT change existing objects";s:14:"rbac_copy_role";s:9:"Copy Role";s:18:"rbac_copy_finished";s:17:"Finished copying.";s:24:"rbac_precondition_source";s:17:"Condition Trigger";s:24:"rbac_precondition_target";s:26:"Condition limits access to";s:22:"rbac_precondition_mode";s:4:"Mode";s:26:"rbac_precondition_mode_all";s:17:"All Preconditions";s:31:"rbac_precondition_mode_all_info";s:54:"All preconditions need to be fulfilled to give access.";s:29:"rbac_precondition_mode_subset";s:23:"Subset of Preconditions";s:34:"rbac_precondition_mode_subset_info";s:113:"A subset of preconditions need to be fulfilled to give access. Some preconditions may still be set as compulsory.";s:33:"rbac_precondition_save_obligatory";s:15:"Save Compulsory";s:34:"rbac_precondition_minimum_optional";s:49:"At least 2 preconditions have to remain optional.";s:12:"prfa_visible";s:35:"Portfolio administration is visible";s:9:"prfa_read";s:48:"User has read access to Portfolio administration";s:10:"prfa_write";s:50:"User can edit settings in Portfolio administration";s:20:"prfa_edit_permission";s:63:"User can change permission settings of Portfolio administration";s:12:"skmg_visible";s:47:"Competence Management administration is visible";s:9:"skmg_read";s:63:"User has read access to administration of Competence Management";s:10:"skmg_write";s:47:"User can edit settings of Competence Management";s:20:"skmg_edit_permission";s:75:"User can change permission settings of Competence Management administration";s:12:"blga_visible";s:30:"Blog Administration is visible";s:9:"blga_read";s:43:"User has read access to Blog Administration";s:10:"blga_write";s:45:"User can edit settings in Blog Administration";s:20:"blga_edit_permission";s:58:"User can change permission settings of Blog administration";s:8:"moderate";s:8:"Moderate";s:16:"rbac_create_chtr";s:16:"Create Chat Room";s:19:"rbac_edit_condition";s:17:"Edit Precondition";s:26:"rbac_condition_delete_sure";s:60:"Are you sure you want to delete the following preconditions?";s:18:"tst_tst_statistics";s:34:"User has access to test statistics";s:12:"blog_visible";s:15:"Blog is visible";s:9:"blog_read";s:26:"User can read blog content";s:9:"blog_copy";s:18:"User can copy blog";s:10:"blog_write";s:27:"User can edit blog settings";s:11:"blog_delete";s:28:"User can move or delete blog";s:20:"blog_edit_permission";s:35:"User can change permission settings";s:16:"rbac_create_blog";s:11:"Create Blog";s:10:"trac_write";s:64:"Edit settings in Statistics and Learning Progress administration";s:11:"dcl_visible";s:26:"Data Collection is visible";s:8:"dcl_read";s:30:"Read access to Data Collection";s:8:"dcl_copy";s:29:"User can copy data collection";s:9:"dcl_write";s:53:"User can edit settings and content of data collection";s:10:"dcl_delete";s:39:"User can move or delete data collection";s:19:"dcl_edit_permission";s:35:"User can change permission settings";s:13:"dcl_add_entry";s:25:"User can add/edit entries";s:15:"rbac_create_dcl";s:22:"Create Data Collection";s:12:"poll_visible";s:15:"Poll is visible";s:9:"poll_read";s:28:"User can participate at poll";s:10:"poll_write";s:39:"User can edit poll settings and content";s:11:"poll_delete";s:28:"User can move or delete poll";s:9:"poll_copy";s:18:"User can copy poll";s:20:"poll_edit_permission";s:35:"User can change permission settings";s:16:"rbac_create_poll";s:11:"Create Poll";s:15:"fld_create_poll";s:11:"Create Poll";s:20:"hlps_edit_permission";s:58:"User can change permissions of Help System administration.";s:9:"hlps_read";s:51:"User has read access to Help System administration.";s:12:"hlps_visible";s:38:"Help System administration is visible.";s:10:"hlps_write";s:61:"User can edit settings of Help System and upload new versions";s:16:"rbac_import_role";s:11:"Import Role";s:18:"rbac_role_imported";s:27:"The role has been imported.";s:13:"internal_mail";s:13:"Internal Mail";s:18:"mail_internal_mail";s:41:"User can use internal mail system (ILIAS)";s:9:"itgr_read";s:32:"User can see items in item group";s:10:"itgr_write";s:48:"User can edit content and settings of item group";s:9:"itgr_copy";s:24:"User can copy item group";s:11:"itgr_delete";s:34:"User can move or delete item group";s:20:"itgr_edit_permission";s:35:"User can change permission settings";s:16:"rbac_create_itgr";s:17:"Create Item Group";s:10:"contribute";s:10:"Contribute";s:15:"blog_contribute";s:19:"User can contribute";s:14:"lp_other_users";s:45:"See learning progress overview of other users";s:19:"trac_lp_other_users";s:45:"See learning progress overview of other users";s:20:"ecss_edit_permission";s:55:"User can edit permission settings of ECS administration";s:9:"ecss_read";s:34:"User can read general ECS settings";s:12:"ecss_visible";s:24:"ECS settings are visible";s:10:"ecss_write";s:26:"User can edit ECS settings";s:11:"rfil_delete";s:32:"User can move or delete ECS File";s:20:"rfil_edit_permission";s:35:"User can change permission settings";s:9:"rfil_read";s:21:"User can use ECS File";s:12:"rfil_visible";s:19:"ECS File is visible";s:10:"rfil_write";s:34:"User can edit settings of ECS File";s:11:"rgrp_delete";s:33:"User can move or delete ECS Group";s:20:"rgrp_edit_permission";s:35:"User can change permission settings";s:9:"rgrp_read";s:22:"User can use ECS Group";s:12:"rgrp_visible";s:20:"ECS Group is visible";s:10:"rgrp_write";s:35:"User can edit settings of ECS Group";s:11:"rglo_delete";s:36:"User can move or delete ECS Glossary";s:20:"rglo_edit_permission";s:35:"User can change permission settings";s:9:"rglo_read";s:25:"User can use ECS Glossary";s:12:"rglo_visible";s:23:"ECS Glossary is visible";s:10:"rglo_write";s:38:"User can edit settings of ECS Glossary";s:10:"rlm_delete";s:43:"User can move or delete ECS Learning Module";s:19:"rlm_edit_permission";s:35:"User can change permission settings";s:8:"rlm_read";s:32:"User can use ECS Learning Module";s:11:"rlm_visible";s:30:"ECS Learning Module is visible";s:9:"rlm_write";s:45:"User can edit settings of ECS Learning Module";s:11:"rtst_delete";s:32:"User can move or delete ECS Test";s:20:"rtst_edit_permission";s:35:"User can change permission settings";s:9:"rtst_read";s:21:"User can use ECS Test";s:12:"rtst_visible";s:19:"ECS Test is visible";s:10:"rtst_write";s:34:"User can edit settings of ECS Test";s:11:"rwik_delete";s:32:"User can move or delete ECS Wiki";s:20:"rwik_edit_permission";s:35:"User can change permission settings";s:9:"rwik_read";s:21:"User can use ECS Wiki";s:12:"rwik_visible";s:19:"ECS Wiki is visible";s:10:"rwik_write";s:34:"User can edit settings of ECS Wiki";s:11:"rcat_delete";s:36:"User can move or delete ECS Category";s:20:"rcat_edit_permission";s:35:"User can change permission settings";s:9:"rcat_read";s:25:"User can use ECS Category";s:12:"rcat_visible";s:23:"ECS Category is visible";s:10:"rcat_write";s:38:"User can edit settings of ECS Category";s:12:"itgr_visible";s:21:"Item group is visible";s:11:"chtr_delete";s:30:"User can move or delete course";s:12:"bibl_visible";s:23:"Bibliography is visible";s:9:"bibl_read";s:34:"User can read bibliography content";s:9:"bibl_copy";s:17:"Copy Bibliography";s:10:"bibl_write";s:35:"User can edit bibliography settings";s:11:"bibl_delete";s:36:"User can move or delete bibliography";s:20:"bibl_edit_permission";s:35:"User can change permission settings";s:12:"bibs_visible";s:38:"Bibliography-Administration is visible";s:9:"bibs_read";s:34:"User can read bibliography content";s:10:"bibs_write";s:35:"User can edit bibliography settings";s:11:"bibs_delete";s:31:"User can delete library entries";s:9:"bibs_copy";s:26:"User can copy bibliography";s:20:"bibs_edit_permission";s:35:"User can change permission settings";s:19:"edit_userassignment";s:20:"Edit User Assignment";s:20:"sysc_edit_permission";s:44:"User can change permissions of System Check.";s:9:"sysc_read";s:37:"User has read access to System Check.";s:12:"sysc_visible";s:24:"System Check is visible.";s:10:"sysc_write";s:30:"User can execute System Check.";s:12:"delete_files";s:12:"Delete Files";s:16:"cld_delete_files";s:42:"Users can delete Files in the cloud object";s:14:"delete_folders";s:14:"Delete Folders";s:18:"cld_delete_folders";s:44:"Users can delete Folders in the cloud object";s:13:"files_visible";s:13:"Files Visible";s:17:"cld_files_visible";s:37:"Files are visible in the cloud object";s:15:"folders_visible";s:15:"Folders Visible";s:19:"cld_folders_visible";s:39:"Folders are visible in the cloud object";s:14:"folders_create";s:14:"Create Folders";s:18:"cld_folders_create";s:42:"Folders may be created in the cloud object";s:11:"cld_visible";s:23:"Cloud Object is visible";s:8:"cld_read";s:28:"User can open a Cloud Object";s:9:"cld_write";s:35:"User can edit cloud object settings";s:10:"cld_delete";s:28:"User can delete cloud object";s:14:"cld_permission";s:35:"User can change permission settings";s:10:"cld_upload";s:41:"User can upload files to the cloud object";s:12:"cld_download";s:45:"User can download files from the cloud object";s:19:"cld_edit_permission";s:35:"User can change permission settings";s:12:"prtt_visible";s:29:"Portfolio Template is visible";s:9:"prtt_read";s:42:"User has read access to portfolio template";s:9:"prtt_copy";s:32:"User can copy portfolio template";s:10:"prtt_write";s:56:"User can edit settings and content of portfolio template";s:11:"prtt_delete";s:42:"User can move or delete portfolio template";s:20:"prtt_edit_permission";s:58:"User can change permission settings for portfolio template";s:23:"rbac_copy_role_add_perm";s:15:"Add Permissions";s:26:"rbac_copy_role_remove_perm";s:18:"Remove Permissions";s:19:"rbac_copy_role_copy";s:16:"Copy Permissions";s:16:"rbac_create_prtt";s:25:"Create Portfolio Template";s:16:"glo_edit_content";s:21:"User can edit content";s:16:"rbac_create_rolt";s:24:"Create new Role Template";s:16:"rbac_create_role";s:15:"Create new Role";s:16:"il_orgu_employee";s:28:"Organisational Unit Employee";s:16:"il_orgu_superior";s:28:"Organisational Unit Superior";s:16:"rbac_create_bibl";s:19:"Create Bibliography";s:15:"rbac_create_cld";s:19:"Create Cloud Object";s:12:"crss_visible";s:32:"Course administration is visible";s:9:"crss_read";s:45:"User has read access to Course administration";s:10:"crss_write";s:38:"Edit settings in Course administration";s:20:"crss_edit_permission";s:60:"User can change permission settings in Course administration";s:12:"grps_visible";s:31:"Group administration is visible";s:9:"grps_read";s:44:"User has read access to Group administration";s:10:"grps_write";s:37:"Edit settings in Group administration";s:20:"grps_edit_permission";s:59:"User can change permission settings in Group administration";s:12:"wiks_visible";s:30:"Wiki administration is visible";s:9:"wiks_read";s:43:"User has read access to Wiki administration";s:10:"wiks_write";s:36:"Edit settings in Wiki administration";s:20:"wiks_edit_permission";s:58:"User can change permission settings in Wiki administration";s:11:"tos_visible";s:42:"Terms of Service administration is visible";s:8:"tos_read";s:55:"User has read access to Terms of Service administration";s:9:"tos_write";s:48:"Edit settings in Terms of Service administration";s:19:"tos_edit_permission";s:70:"User can change permission settings in Terms of Service administration";s:12:"wbrs_visible";s:33:"Weblink administration is visible";s:9:"wbrs_read";s:46:"User has read access to Weblink administration";s:10:"wbrs_write";s:39:"Edit settings in Weblink administration";s:20:"wbrs_edit_permission";s:61:"User can change permission settings in Weblink administration";s:12:"reps_visible";s:36:"Repository administration is visible";s:9:"reps_read";s:49:"User has read access to Repository administration";s:10:"reps_write";s:42:"Edit settings in Repository administration";s:20:"reps_edit_permission";s:64:"User can change permission settings in Repository administration";s:27:"orgu_view_learning_progress";s:22:"View Learning Progress";s:12:"orgu_visible";s:30:"Organisational Unit is visible";s:9:"orgu_read";s:43:"User has read access to Organisational Unit";s:10:"orgu_write";s:45:"User can edit settings of Organisational Unit";s:15:"orgu_read_users";s:69:"User can read local user accounts created in this Organisational Unit";s:27:"orgu_cat_administrate_users";s:80:"User can create and administrate local user accounts in this Organisational Unit";s:11:"orgu_delete";s:43:"User can move or delete Organisational Unit";s:20:"orgu_edit_permission";s:35:"User can change permission settings";s:9:"orgu_copy";s:24:"Copy Organisational Unit";s:31:"orgu_view_learning_progress_rec";s:45:"View Learning Progress of Unit incl. Subunits";s:16:"rbac_create_orgu";s:27:"Create Organisational Units";s:15:"statistics_read";s:15:"View Statistics";s:20:"wiki_statistics_read";s:15:"View Statistics";s:12:"excs_visible";s:34:"Exercise administration is visible";s:9:"excs_read";s:47:"User has read access to Exercise administration";s:10:"excs_write";s:40:"Edit settings in Exercise administration";s:20:"excs_edit_permission";s:62:"User can change permission settings in Exercise administration";s:12:"taxs_visible";s:34:"Taxonomy administration is visible";s:9:"taxs_read";s:47:"User has read access to Taxonomy administration";s:10:"taxs_write";s:40:"Edit settings in Taxonomy administration";s:20:"taxs_edit_permission";s:62:"User can change permission settings in Taxonomy administration";s:22:"read_learning_progress";s:37:"View learning progress of other users";s:26:"crs_read_learning_progress";s:46:"User can view learning progress of other users";s:26:"grp_read_learning_progress";s:46:"User can view learning progress of other users";s:27:"fold_read_learning_progress";s:46:"User can view learning progress of other users";s:25:"lm_read_learning_progress";s:46:"User can view learning progress of other users";s:27:"htlm_read_learning_progress";s:46:"User can view learning progress of other users";s:27:"sahs_read_learning_progress";s:46:"User can view learning progress of other users";s:26:"tst_read_learning_progress";s:46:"User can view learning progress of other users";s:26:"exc_read_learning_progress";s:46:"User can view learning progress of other users";s:27:"sess_read_learning_progress";s:46:"User can view learning progress of other users";s:16:"condition_failed";s:6:"Failed";s:27:"condition_learning_progress";s:29:"Derive from Learning Progress";s:22:"rbac_precondition_hide";s:11:"Hide Object";s:27:"rbac_precondition_hide_info";s:152:" This option allows to hide the object for users who currently have not fulfilled the preconditions. Therefore, all not accessible content is invisible.";s:32:"rbac_cant_import_role_wrong_type";s:46:"Can\'t import a role from item %s into item %s.";s:8:"ilias_id";s:8:"ILIAS-ID";s:9:"feed_copy";s:21:"User can copy webfeed";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'forum'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:150:{s:15:"ascending_order";s:29:"Latest postings at the bottom";s:16:"descending_order";s:26:"Latest postings at the top";s:27:"activate_current_and_childs";s:21:"Activate All Postings";s:18:"activate_new_posts";s:17:"Activate Postings";s:21:"activate_only_current";s:16:"Activate Posting";s:17:"activate_post_txt";s:54:"Would you really like to activate the current posting?";s:13:"activate_post";s:8:"Activate";s:12:"close_topics";s:5:"Close";s:21:"fmr_copy_threads_info";s:109:"You have the possibility to copy single threads. Only the beginning of the chosen threads will be duplicated.";s:15:"forum_add_quote";s:13:"Add Quotation";s:30:"forums_all_threads_marked_read";s:36:"All threads have been marked as read";s:22:"forums_attachments_add";s:14:"Add attachment";s:18:"forums_attachments";s:11:"Attachments";s:21:"forums_censor_comment";s:17:"Comment of Censor";s:16:"forums_count_art";s:18:"Number of Articles";s:16:"forums_count_thr";s:17:"Number of Threads";s:12:"forums_count";s:16:"Number of Forums";s:17:"forums_created_by";s:10:"Created by";s:18:"forums_delete_file";s:17:"Delete attachment";s:27:"forums_disable_notification";s:36:"Disable Notification for this Thread";s:26:"forums_download_attachment";s:13:"Download file";s:16:"forums_edit_post";s:12:"Edit Article";s:26:"forums_enable_notification";s:35:"Enable Notification for this Thread";s:23:"forums_info_censor_post";s:43:"Are you sure you want to hide this article?";s:24:"forums_info_censor2_post";s:18:"Revoke Censorship?";s:23:"forums_info_delete_post";s:69:"Are you sure you want to delete this article including any responses?";s:16:"forums_mark_read";s:16:"Mark All as Read";s:17:"forums_new_thread";s:10:"New Thread";s:25:"forums_no_posts_available";s:73:"This thread has no posts yet or the moderator deactivated the first post.";s:28:"forums_notification_disabled";s:21:"Notification disabled";s:27:"forums_notification_enabled";s:20:"Notification enabled";s:25:"forums_notification_intro";s:72:"This mail was automatically sent to you by the ILIAS installation %s, %s";s:29:"forums_notification_show_post";s:16:"Show posting: %s";s:27:"forums_notification_subject";s:20:"New posting in forum";s:19:"forums_notification";s:12:"Notification";s:39:"forums_post_and_children_were_activated";s:54:"The posting and all its child postings were activated.";s:19:"forums_post_deleted";s:24:"Posting has been deleted";s:20:"forums_post_modified";s:25:"Posting has been modified";s:33:"forums_post_needs_to_be_activated";s:76:"A new posting has been created, but it needs to be activated by a moderator.";s:21:"forums_post_new_entry";s:30:"A new posting has been created";s:25:"forums_post_was_activated";s:26:"The posting was activated.";s:26:"forums_posts_not_available";s:22:"Postings Not Available";s:12:"forums_posts";s:12:"All postings";s:19:"forums_print_thread";s:12:"Print Thread";s:14:"forums_subject";s:7:"Subject";s:15:"forums_the_post";s:7:"Posting";s:25:"forums_thread_create_date";s:10:"Created on";s:25:"forums_thread_create_from";s:12:"Created from";s:20:"forums_thread_marked";s:35:"The thread has been marked as read.";s:23:"forums_thread_new_entry";s:26:"New topic has been created";s:13:"forums_thread";s:6:"Thread";s:17:"forums_your_reply";s:10:"Your Reply";s:6:"forums";s:6:"Forums";s:26:"frm_anonymous_posting_desc";s:94:"If enabled, registered users can post to this forum only by using a pseudonym or without name.";s:21:"frm_anonymous_posting";s:22:"Posting with pseudonym";s:16:"frm_default_view";s:12:"Default View";s:25:"frm_detach_moderator_role";s:21:"Detach Moderator Role";s:15:"frm_moderator_f";s:9:"Moderator";s:15:"frm_moderator_m";s:9:"Moderator";s:37:"frm_moderator_role_added_successfully";s:45:"The user was added as moderator successfully.";s:41:"frm_moderators_detached_role_successfully";s:68:"The moderator role was detached for all selected users successfully.";s:28:"frm_moderators_not_exist_yet";s:26:"Please choose a moderator.";s:34:"frm_moderators_select_at_least_one";s:37:"Please choose at least one moderator.";s:25:"frm_moderators_select_one";s:23:"Please choose one user.";s:14:"frm_moderators";s:10:"Moderators";s:26:"frm_post_not_activated_yet";s:18:"Not activated yet.";s:13:"frm_pseudonym";s:9:"Pseudonym";s:39:"frm_purifier_not_implemented_for_type_x";s:41:"Purifier for type %s not implemented yet.";s:40:"frm_statistics_disabled_for_participants";s:42:"Statistics are disabled for forum members.";s:27:"frm_statistics_enabled_desc";s:46:"Enable posting statistics for all participants";s:22:"frm_statistics_enabled";s:17:"Enable Statistics";s:22:"frm_statistics_ranking";s:18:"Number of Postings";s:14:"frm_statistics";s:10:"Statistics";s:23:"frm_sure_delete_threads";s:54:"Are you sure you want to delete the following threads?";s:15:"frm_wizard_page";s:21:"Copy Forum (Step 2/2)";s:7:"is_read";s:12:"Mark as Read";s:22:"make_topics_non_sticky";s:23:"Make Threads Non-Sticky";s:18:"make_topics_sticky";s:19:"Make Threads Sticky";s:18:"move_chosen_topics";s:19:"Move Chosen Threads";s:8:"new_post";s:8:"New Post";s:17:"no_forum_selected";s:47:"No forum selected for moving the chosen threads";s:20:"post_activation_desc";s:71:"Before being published all postings need to be approved by a moderator.";s:34:"post_censored_comment_by_moderator";s:38:"Posting Censored, Comment by Moderator";s:13:"reopen_topics";s:6:"Reopen";s:26:"select_at_least_one_thread";s:34:"Please select at least one thread.";s:6:"sticky";s:6:"Sticky";s:6:"thread";s:6:"Thread";s:26:"threads_moved_successfully";s:60:"The chosen threads were moved to another forum successfully.";s:11:"topic_close";s:6:"Closed";s:31:"topics_please_select_one_action";s:24:"Please select an action.";s:27:"forums_post_activation_mail";s:198:"Unless the following posting is not activated, it is not visible for other forum users. You receive this email because you are assigned as moderator and have the permission to activate this posting.";s:10:"post_reply";s:3:"Re:";s:14:"preset_subject";s:23:"Preset subject on reply";s:17:"add_re_to_subject";s:34:"Add ‘Re: ’ to subject on reply";s:22:"add_re_to_subject_info";s:58:"If activated, ‘Re: ’ is added to the subject on reply.";s:17:"enter_new_subject";s:26:"Please enter a new subject";s:14:"frm_edit_title";s:10:"Edit Title";s:13:"empty_subject";s:43:"On reply the user has to enter a new title.";s:19:"frm_subject_setting";s:15:"Subject setting";s:25:"user_decides_notification";s:36:"Each user decides about notification";s:20:"mark_moderator_posts";s:20:"Mark moderator posts";s:25:"mark_moderator_posts_desc";s:48:"If activated moderator posts will be highlighted";s:17:"cont_captcha_code";s:4:"Code";s:26:"frm_at_least_one_moderator";s:39:"There has to be at least one moderator.";s:21:"select_max_one_thread";s:30:"Please select one thread only!";s:13:"sort_by_posts";s:13:"Sort by Posts";s:34:"forums_forum_notification_disabled";s:64:"You will no longer be notified about new messages in this forum.";s:17:"number_of_threads";s:36:"Displayed Number of Threads per Page";s:10:"frm_rating";s:6:"Rating";s:21:"enable_thread_ratings";s:13:"Thread Rating";s:26:"enable_thread_ratings_info";s:47:"If activated users are allowed to rate threads.";s:8:"frm_copy";s:10:"Copy Forum";s:26:"frm_notification_activated";s:22:"Notification Activated";s:28:"frm_notification_deactivated";s:24:"Notification Deactivated";s:12:"sort_by_date";s:12:"Sort by date";s:18:"error_reading_file";s:35:"There was an error reading the file";s:21:"sorting_manual_sticky";s:32:"Manual sorting of sticky threads";s:19:"frm_sorting_threads";s:14:"Thread Sorting";s:17:"frm_sorting_posts";s:13:"Posts Sorting";s:28:"sticky_threads_always_on_top";s:180:"‘Sticky Threads’ are always listed at the top of the list of threads. Within the ‘Sticky Threads’ you are able to sort the threads manually, if you have chosen this option.";s:5:"merge";s:5:"Merge";s:20:"please_choose_target";s:39:"Please choose a thread as merge target.";s:22:"frm_sure_merge_threads";s:85:"Are you sure you want to merge these threads? Warning: This action can not be undone.";s:39:"not_allowed_to_merge_into_another_forum";s:56:"It is not possible to merge threads of different forums.";s:22:"frm_selected_merge_src";s:28:"Selected Thread to Merge: %s";s:21:"error_same_thread_ids";s:46:"Source and target thread have to be different.";s:13:"frm_merge_src";s:19:"Selected Thread: %s";s:16:"frm_merge_target";s:10:"Target: %s";s:27:"merged_threads_successfully";s:45:"The selected threads were merged successfully";s:24:"switch_threads_for_merge";s:129:"The selected thread is older than the target thread. To ensure a successful merge, the source and target thread will be switched.";s:23:"merge_posts_into_thread";s:32:"Merge Postings into other Thread";s:20:"move_thread_to_forum";s:26:"Move Thread to other Forum";s:16:"post_reply_count";s:7:"Re(%s):";s:24:"frm_max_notification_age";s:21:"Max. Notification Age";s:29:"frm_max_notification_age_unit";s:6:"Day(s)";s:29:"frm_max_notification_age_info";s:140:"Please define the maximum age of postings to send notifications for. It is recommended to choose a higher value than the scheduled interval.";s:26:"sel_threads_already_sticky";s:54:"At least one of the selected threads is already sticky";s:28:"sel_threads_already_unsticky";s:56:"At least one of the selected threads is already unsticky";s:23:"sel_threads_make_sticky";s:46:"The selected threads has been marked as sticky";s:25:"sel_threads_make_unsticky";s:53:"The selected threads are not marked as sticky anymore";s:23:"selected_threads_closed";s:36:"The selected threads has been closed";s:25:"selected_threads_reopened";s:38:"The selected threads has been reopened";s:14:"frm_censorship";s:6:"Censor";s:21:"frm_revoke_censorship";s:17:"Revoke Censorship";s:22:"frm_censorship_applied";s:45:"The censorship has been successfully applied.";s:22:"frm_censorship_revoked";s:45:"The censorship has been successfully revoked.";s:16:"frm_mark_as_read";s:12:"Mark as read";s:18:"frm_mark_as_unread";s:14:"Mark as unread";s:21:"forums_thread_deleted";s:61:"The selected thread including all postings have been deleted.";s:22:"forums_threads_deleted";s:62:"The selected threads including all postings have been deleted.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'content'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1170:{s:14:"add_menu_entry";s:14:"Add Menu Entry";s:9:"all_pages";s:22:"Entire Learning Module";s:3:"all";s:3:"All";s:18:"choose_public_mode";s:30:"Access for Users not logged-in";s:19:"choose_public_pages";s:30:"Choose public accessible pages";s:11:"citate_from";s:15:"Citate From ...";s:11:"citate_page";s:16:"Citate this Page";s:9:"citate_to";s:13:"Citate To ...";s:6:"citate";s:6:"Citate";s:15:"cont_act_number";s:18:"Chapter Numeration";s:18:"cont_activate_page";s:13:"Activate Page";s:14:"cont_activated";s:9:"Activated";s:15:"cont_activation";s:10:"Activation";s:11:"cont_active";s:11:"Enable Menu";s:13:"cont_add_area";s:8:"Add Area";s:23:"cont_add_change_comment";s:18:"Add change comment";s:15:"cont_add_circle";s:10:"Add Circle";s:19:"cont_add_definition";s:14:"Add Definition";s:17:"cont_add_elements";s:42:"Click on placeholders to add new elements.";s:13:"cont_add_file";s:8:"Add File";s:19:"cont_add_fullscreen";s:15:"Add Full Screen";s:16:"cont_add_polygon";s:11:"Add Polygon";s:18:"cont_add_rectangle";s:13:"Add Rectangle";s:12:"cont_add_tab";s:9:"Add Panel";s:18:"cont_added_comment";s:34:"Comment has been added to history.";s:15:"cont_added_term";s:10:"Term added";s:15:"cont_Additional";s:22:"Additional Information";s:16:"cont_adjust_size";s:11:"Adjust Size";s:10:"cont_align";s:9:"Alignment";s:15:"cont_all_closed";s:10:"All Closed";s:20:"cont_all_definitions";s:15:"All Definitions";s:14:"cont_all_pages";s:9:"All Pages";s:17:"cont_alphabetic_s";s:20:"Alphabetic a, b, …";s:15:"cont_alphabetic";s:20:"Alphabetic A, B, …";s:11:"cont_anchor";s:6:"Anchor";s:10:"cont_annex";s:5:"Annex";s:16:"cont_api_adapter";s:16:"API Adapter Name";s:20:"cont_api_func_prefix";s:20:"API Functions Prefix";s:18:"cont_areas_deleted";s:18:"Map areas deleted.";s:26:"cont_assign_characteristic";s:21:"Assign Characteristic";s:16:"cont_assign_full";s:18:"Assign Full Screen";s:15:"cont_assign_std";s:15:"Assign Standard";s:23:"cont_assign_translation";s:18:"Assign translation";s:24:"cont_assignments_deleted";s:33:"The assignments have been deleted";s:15:"cont_autoindent";s:11:"Auto Indent";s:14:"cont_autostart";s:9:"Autostart";s:9:"cont_back";s:4:"Back";s:11:"cont_bb_tip";s:52:"Tip: Styles can be applied quickly to selected text.";s:13:"cont_behavior";s:8:"Behavior";s:10:"cont_Block";s:5:"Block";s:14:"cont_booktitle";s:10:"Book title";s:11:"cont_bottom";s:6:"Bottom";s:27:"cont_browser_not_js_capable";s:61:"JavaScript enabled editing is not supported for your browser.";s:16:"cont_bullet_list";s:11:"Bullet List";s:22:"cont_cant_copy_folders";s:38:"Folders cannot be copied to clipboard.";s:18:"cont_cant_del_full";s:42:"Deletion of full screen file not possible.";s:17:"cont_cant_del_std";s:44:"Deletion of standard view file not possible.";s:12:"cont_caption";s:7:"Caption";s:11:"cont_center";s:6:"Center";s:28:"cont_change_object_reference";s:23:"Change Object Reference";s:16:"cont_change_type";s:11:"Change Type";s:19:"cont_chap_and_pages";s:18:"Chapters and Pages";s:32:"cont_chap_copy_select_target_now";s:46:"Chapter marked for copying. Select target now.";s:27:"cont_chap_select_target_now";s:45:"Chapter marked for moving. Select target now.";s:25:"cont_chapters_after_pages";s:74:"Please note that pages have to precede all sub-chapters of the same level.";s:23:"cont_chapters_and_pages";s:18:"Chapters and Pages";s:18:"cont_chapters_only";s:13:"Chapters only";s:13:"cont_chapters";s:8:"Chapters";s:19:"cont_characteristic";s:11:"Style Class";s:34:"cont_choose_characteristic_section";s:8:"Sections";s:31:"cont_choose_characteristic_text";s:13:"Text Elements";s:26:"cont_choose_characteristic";s:21:"Choose Characteristic";s:20:"cont_choose_cont_obj";s:21:"Choose Content Object";s:20:"cont_choose_glossary";s:15:"Choose Glossary";s:24:"cont_choose_media_source";s:19:"Choose Media Source";s:34:"cont_choose_pages_or_chapters_only";s:44:"Please select either pages or chapters only.";s:11:"cont_Circle";s:6:"Circle";s:21:"cont_citation_err_one";s:35:"You must select exactly one edition";s:33:"cont_citation_selection_not_valid";s:29:"You\'re selection is not valid";s:13:"cont_Citation";s:8:"Citation";s:14:"cont_citations";s:9:"Citations";s:20:"cont_click_br_corner";s:60:"Please click on the bottom right corner of the desired area.";s:17:"cont_click_center";s:43:"Please click on center of the desired area.";s:17:"cont_click_circle";s:51:"Please click on a circle point of the desired area.";s:23:"cont_click_next_or_save";s:140:"Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)";s:21:"cont_click_next_point";s:46:"Please click on the next point of the polygon.";s:25:"cont_click_starting_point";s:50:"Please click on the starting point of the polygon.";s:20:"cont_click_tl_corner";s:56:"Please click on the top left corner of the desired area.";s:9:"cont_Code";s:4:"Code";s:12:"cont_colspan";s:9:"Col. Span";s:19:"cont_confirm_delete";s:42:"Do you really want to delete this item(s)?";s:26:"cont_constrain_proportions";s:21:"Constrain Proportions";s:16:"cont_content_obj";s:14:"Content Object";s:12:"cont_content";s:7:"Content";s:13:"cont_contents";s:8:"Contents";s:11:"cont_coords";s:11:"Coordinates";s:16:"cont_copy_object";s:11:"copy object";s:22:"cont_copy_to_clipboard";s:17:"Copy to clipboard";s:23:"cont_copy_to_media_pool";s:18:"Copy to media pool";s:38:"cont_could_not_determine_resource_size";s:58:"ILIAS could not automatically determine the resource size.";s:15:"cont_create_dir";s:16:"Create Directory";s:28:"cont_create_export_file_html";s:25:"Create Export File (HTML)";s:29:"cont_create_export_file_scorm";s:26:"Create Export File (SCORM)";s:27:"cont_create_export_file_xml";s:24:"Create Export File (XML)";s:23:"cont_create_export_file";s:18:"Create Export File";s:18:"cont_create_folder";s:13:"Create Folder";s:24:"cont_create_html_version";s:19:"Create HTML Package";s:15:"cont_create_mob";s:19:"Create Media Object";s:16:"cont_credit_mode";s:11:"Credit Mode";s:15:"cont_credit_off";s:9:"No Credit";s:14:"cont_credit_on";s:6:"Credit";s:12:"cont_credits";s:7:"Credits";s:20:"cont_cross_reference";s:15:"Cross reference";s:20:"cont_current_chapter";s:15:"Current Chapter";s:17:"cont_current_page";s:12:"Current Page";s:18:"cont_current_style";s:13:"Current Style";s:20:"cont_current_version";s:15:"Current Version";s:16:"cont_custom_size";s:11:"Custom Size";s:11:"cont_custom";s:6:"Custom";s:18:"cont_data_from_lms";s:17:"adlcp:datafromlms";s:16:"cont_de_activate";s:13:"(De-)Activate";s:20:"cont_deactivate_page";s:15:"Deactivate Page";s:16:"cont_deactivated";s:11:"Deactivated";s:10:"cont_debug";s:16:"Enable Test Tool";s:12:"cont_debugpw";s:8:"Password";s:12:"cont_decimal";s:7:"Decimal";s:15:"cont_def_layout";s:14:"Default Layout";s:20:"cont_def_lesson_mode";s:19:"Default Lesson Mode";s:18:"cont_def_map_areas";s:18:"Default Link Areas";s:21:"cont_def_organization";s:7:"default";s:12:"cont_default";s:7:"Default";s:15:"cont_definition";s:10:"Definition";s:16:"cont_definitions";s:11:"Definitions";s:19:"cont_del_assignment";s:17:"Delete assignment";s:20:"cont_delete_selected";s:6:"Delete";s:17:"cont_delete_style";s:12:"Delete Style";s:22:"cont_delete_track_data";s:20:"Delete Tracking Data";s:17:"cont_dependencies";s:12:"Dependencies";s:20:"cont_derive_from_obj";s:18:"Derive from Object";s:12:"cont_details";s:7:"Details";s:16:"cont_dir_created";s:27:"Directory has been created.";s:16:"cont_dir_deleted";s:27:"Directory has been deleted.";s:13:"cont_dir_file";s:14:"Directory/File";s:16:"cont_dir_renamed";s:27:"Directory has been renamed.";s:27:"cont_double_click_to_delete";s:80:"Double-click on content elements to select them for (de-)activation or deletion.";s:19:"cont_download_title";s:14:"Download Title";s:19:"cont_downloads_desc";s:77:"Offers all public export files for download (e.g. for offline use or import).";s:26:"cont_downloads_public_desc";s:56:"Allow download even for anonymous users (in public area)";s:14:"cont_downloads";s:15:"Enable Download";s:27:"cont_drag_and_drop_elements";s:64:"Drag and drop content elements on placeholders to move elements.";s:16:"cont_e_g_example";s:4:"e.g.";s:20:"cont_ed_align_center";s:13:"Align: Center";s:24:"cont_ed_align_left_float";s:17:"Align: Left Float";s:18:"cont_ed_align_left";s:11:"Align: Left";s:25:"cont_ed_align_right_float";s:18:"Align: Right Float";s:19:"cont_ed_align_right";s:12:"Align: Right";s:14:"cont_ed_atable";s:14:"Advanced Table";s:13:"cont_ed_class";s:5:"Style";s:16:"cont_ed_col_left";s:16:"Move Column Left";s:17:"cont_ed_col_right";s:17:"Move Column Right";s:17:"cont_ed_copy_clip";s:17:"Copy to Clipboard";s:18:"cont_ed_delete_col";s:13:"Delete Column";s:19:"cont_ed_delete_item";s:11:"Delete Item";s:18:"cont_ed_delete_row";s:10:"Delete Row";s:14:"cont_ed_delete";s:6:"Delete";s:14:"cont_ed_dtable";s:10:"Data Table";s:17:"cont_ed_edit_data";s:9:"Edit Data";s:18:"cont_ed_edit_files";s:10:"Edit Files";s:17:"cont_ed_edit_prop";s:15:"Edit Properties";s:12:"cont_ed_edit";s:4:"Edit";s:14:"cont_ed_enable";s:22:"(De-)Activate Elements";s:13:"cont_ed_flist";s:10:" File List";s:10:"cont_ed_go";s:2:"Go";s:21:"cont_ed_insert_atable";s:21:"Insert Advanced Table";s:19:"cont_ed_insert_code";s:11:"Insert Code";s:21:"cont_ed_insert_dtable";s:17:"Insert Data Table";s:23:"cont_ed_insert_filelist";s:16:"Insert File List";s:19:"cont_ed_insert_incl";s:22:"Insert Content Snippet";s:19:"cont_ed_insert_list";s:20:"Insert Advanced List";s:18:"cont_ed_insert_map";s:10:"Insert Map";s:20:"cont_ed_insert_media";s:18:"Insert Image/Media";s:18:"cont_ed_insert_par";s:11:"Insert Text";s:20:"cont_ed_insert_pcqst";s:15:"Insert Question";s:20:"cont_ed_insert_plach";s:18:"Insert Placeholder";s:21:"cont_ed_insert_repobj";s:20:"Insert Resource List";s:22:"cont_ed_insert_section";s:14:"Insert Section";s:19:"cont_ed_insert_tabs";s:16:"Insert Accordion";s:17:"cont_ed_item_down";s:14:"Move Item Down";s:15:"cont_ed_item_up";s:12:"Move Item Up";s:12:"cont_ed_list";s:14:" Advanced List";s:17:"cont_ed_moveafter";s:10:"Move After";s:18:"cont_ed_movebefore";s:11:"Move Before";s:21:"cont_ed_new_col_after";s:16:"New Column After";s:22:"cont_ed_new_col_before";s:17:"New Column Before";s:22:"cont_ed_new_item_after";s:14:"New Item After";s:23:"cont_ed_new_item_before";s:15:"New Item Before";s:21:"cont_ed_new_row_after";s:13:"New Row After";s:22:"cont_ed_new_row_before";s:14:"New Row Before";s:11:"cont_ed_par";s:4:"Text";s:18:"cont_ed_paste_clip";s:20:"Paste From Clipboard";s:13:"cont_ed_paste";s:5:"Paste";s:15:"cont_ed_pglprop";s:22:"Page Layout Properties";s:18:"cont_ed_plachmedia";s:17:"Placeholder Media";s:17:"cont_ed_plachprop";s:22:"Placeholder Properties";s:21:"cont_ed_plachquestion";s:20:"Placeholder Question";s:17:"cont_ed_plachtext";s:16:"Placeholder Text";s:16:"cont_ed_row_down";s:13:"Move Row Down";s:14:"cont_ed_row_up";s:11:"Move Row Up";s:21:"cont_ed_select_pctext";s:16:"Select Text Item";s:23:"cont_ed_split_page_next";s:18:"Split to Next Page";s:18:"cont_ed_split_page";s:17:"Split to New Page";s:16:"cont_ed_textitem";s:10:" Text Item";s:13:"cont_ed_width";s:5:"Width";s:14:"cont_edit_area";s:9:"Edit Area";s:30:"cont_edit_file_list_properties";s:25:"Edit File List Properties";s:22:"cont_edit_lrs_settings";s:13:"Edit Settings";s:24:"cont_edit_mob_alias_prop";s:37:"Edit Media Object Instance Properties";s:19:"cont_edit_mob_files";s:12:"Object Files";s:24:"cont_edit_mob_properties";s:28:"Edit Media Object Properties";s:13:"cont_edit_mob";s:17:"Edit Media Object";s:13:"cont_edit_par";s:9:"Edit Text";s:22:"cont_edit_shape_circle";s:19:"Edit Shape (Circle)";s:23:"cont_edit_shape_polygon";s:20:"Edit Shape (Polygon)";s:25:"cont_edit_shape_rectangle";s:22:"Edit Shape (Rectangle)";s:13:"cont_edit_src";s:16:"Edit Source Code";s:15:"cont_edit_style";s:10:"Edit Style";s:24:"cont_edit_tab_properties";s:16:"Table Properties";s:14:"cont_edit_tabs";s:10:"Properties";s:14:"cont_edit_term";s:9:"Edit Term";s:12:"cont_edition";s:7:"Edition";s:21:"cont_empty_mep_folder";s:42:"There are no media objects in this folder.";s:19:"cont_empty_question";s:79:"Question editing not finished. Please either click and edit or delete question.";s:47:"cont_enable_time_scheduled_page_activation_info";s:105:"If enabled, an activation period (date/time) can be selected in the learning module editor for each page.";s:42:"cont_enable_time_scheduled_page_activation";s:30:"Time Scheduled Page Activation";s:8:"cont_end";s:3:"End";s:21:"cont_enter_a_dir_name";s:30:"Please enter a directory name.";s:17:"cont_enter_a_file";s:21:"Please select a file.";s:12:"cont_Example";s:7:"Example";s:13:"cont_Excursus";s:8:"Excursus";s:15:"cont_export_all";s:10:"Export all";s:17:"cont_export_files";s:12:"Export Files";s:19:"cont_export_success";s:25:"Success-data (aggregated)";s:20:"cont_export_tracking";s:20:"Export Tracking Data";s:16:"cont_export_type";s:11:"Export-Type";s:17:"cont_external_url";s:12:"external url";s:13:"cont_external";s:8:"external";s:17:"cont_file_created";s:22:"File has been created.";s:17:"cont_file_deleted";s:22:"File has been deleted.";s:25:"cont_file_from_repository";s:20:"File From Repository";s:17:"cont_file_renamed";s:22:"File has been renamed.";s:18:"cont_file_unzipped";s:23:"File has been unzipped.";s:9:"cont_file";s:4:"File";s:17:"cont_FileListItem";s:25:"File List Item (Standard)";s:10:"cont_files";s:5:"Files";s:15:"cont_first_open";s:18:"First Panel Opened";s:20:"cont_first_row_style";s:21:"First Row Style Class";s:21:"cont_fix_tree_confirm";s:140:"Please execute this command only if the tree structure of this learning module is corrupted, e.g. if blank items occur in the explorer view.";s:13:"cont_fix_tree";s:13:"Fix structure";s:11:"cont_footer";s:6:"Footer";s:19:"cont_force_all_open";s:16:"Force All Opened";s:17:"cont_format_error";s:35:"This operation is not allowed here!";s:11:"cont_format";s:6:"Format";s:19:"cont_frame_botright";s:32:"Content Details (Glossary) Frame";s:22:"cont_frame_maincontent";s:13:"Content Frame";s:16:"cont_frame_right";s:21:"Content Details Frame";s:14:"cont_frame_toc";s:10:"Side Frame";s:19:"cont_frame_topright";s:37:"Content Details (FAQ and Media) Frame";s:15:"cont_free_pages";s:10:"Free Pages";s:19:"cont_full_is_in_dir";s:56:"Deletion not possible. Full screen file is in directory.";s:15:"cont_fullscreen";s:11:"Full Screen";s:23:"cont_general_properties";s:18:"General Properties";s:13:"cont_get_link";s:8:"get link";s:18:"cont_get_orig_size";s:17:"Set original size";s:15:"cont_glo_assign";s:15:"Assign Glossary";s:15:"cont_glo_create";s:15:"Create Glossary";s:15:"cont_glo_detach";s:15:"Detach Glossary";s:13:"cont_glo_menu";s:4:"Menu";s:19:"cont_glo_properties";s:19:"Glossary Properties";s:11:"cont_header";s:6:"Header";s:14:"cont_Headline1";s:10:"Headline 1";s:14:"cont_Headline2";s:10:"Headline 2";s:14:"cont_Headline3";s:10:"Headline 3";s:11:"cont_height";s:6:"Height";s:14:"cont_hidenavig";s:20:"Hide Navigation Tree";s:9:"cont_Hint";s:4:"Hint";s:18:"cont_how_published";s:13:"How published";s:9:"cont_href";s:4:"href";s:15:"cont_html_table";s:10:"HTML Table";s:11:"cont_id_ref";s:13:"identifierref";s:13:"cont_imagemap";s:9:"Image Map";s:14:"cont_import_id";s:10:"identifier";s:20:"cont_import_tracking";s:20:"Import Tracking Data";s:29:"cont_import_validation_errors";s:191:"Some errors occurred during validation of the learning module. The presentation of the learning module may be ok, but it is likely that you are not able to edit the pages that contain errors.";s:22:"cont_insert_as_chapter";s:17:"Insert as Chapter";s:25:"cont_insert_as_subchapter";s:21:"Insert as Sub-chapter";s:29:"cont_insert_chapter_from_clip";s:29:"Paste Chapters from Clipboard";s:19:"cont_insert_chapter";s:14:"Insert Chapter";s:21:"cont_insert_file_item";s:16:"Insert File Item";s:21:"cont_insert_file_list";s:16:"Insert File List";s:16:"cont_insert_list";s:20:"Insert Advanced List";s:15:"cont_insert_map";s:10:"Insert Map";s:15:"cont_insert_mob";s:19:"Insert Media Object";s:24:"cont_insert_new_footnote";s:19:"insert new footnote";s:26:"cont_insert_page_from_clip";s:26:"Paste Pages from Clipboard";s:16:"cont_insert_page";s:11:"Insert Page";s:15:"cont_insert_par";s:11:"Insert Text";s:21:"cont_insert_resources";s:20:"Insert Resource List";s:18:"cont_insert_search";s:27:"Please insert a search term";s:19:"cont_insert_section";s:14:"Insert Section";s:15:"cont_insert_src";s:18:"Insert source code";s:32:"cont_insert_subchapter_from_clip";s:33:"Paste Sub-chapters from Clipboard";s:22:"cont_insert_subchapter";s:18:"Insert Sub-chapter";s:17:"cont_insert_table";s:12:"Insert Table";s:16:"cont_insert_tabs";s:11:"Insert Tabs";s:19:"cont_inst_map_areas";s:19:"Instance Link Areas";s:18:"cont_internal_link";s:13:"internal link";s:19:"cont_internal_links";s:14:"Internal Links";s:13:"cont_internal";s:8:"internal";s:23:"cont_invalid_new_module";s:68:"Incompatible module! Please make sure imsmanifest.xml is not changed";s:15:"cont_is_visible";s:9:"isvisible";s:9:"cont_isbn";s:4:"ISBN";s:9:"cont_issn";s:4:"ISSN";s:9:"cont_item";s:4:"Item";s:12:"cont_journal";s:7:"Journal";s:20:"cont_js_chap_editing";s:27:"Use JavaScript Editing Mode";s:12:"cont_keyword";s:7:"Keyword";s:16:"cont_last_access";s:11:"Last Access";s:15:"cont_latest_rev";s:15:"Latest Revision";s:24:"cont_layout_1window_desc";s:81:"Content in the main frame. FAQ, glossary and media links open in separate window.";s:19:"cont_layout_1window";s:10:"One Window";s:24:"cont_layout_2window_desc";s:77:"Content in the left frame. FAQ, glossary and media links open in right frame.";s:19:"cont_layout_2window";s:11:"Two Windows";s:24:"cont_layout_3window_desc";s:109:"Content in the left frame. FAQ and media links open in top-right frame, glossary links in bottom-right frame.";s:19:"cont_layout_3window";s:13:"Three Windows";s:27:"cont_layout_fullscreen_desc";s:123:"Content in the main frame. FAQ, glossary and media links open in separate window. No ILIAS main menu and no navigation bar.";s:22:"cont_layout_fullscreen";s:11:"Full Screen";s:25:"cont_layout_per_page_info";s:118:"Allow to set individual layouts for each page. This automatically activates the ‘Synchronize Frames’ setting, too.";s:20:"cont_layout_per_page";s:15:"Layout per Page";s:29:"cont_layout_presentation_desc";s:101:"Content in the main frame. FAQ, glossary and media links open in separate window. No ILIAS main menu.";s:24:"cont_layout_presentation";s:12:"Presentation";s:24:"cont_layout_toc2win_desc";s:113:"Table of contents in the left, content in the right frame. FAQ, glossary and media links open in separate window.";s:19:"cont_layout_toc2win";s:17:"Table of Contents";s:27:"cont_layout_toc2windyn_desc";s:130:"Table of contents in the left, content in the right frame. FAQ, glossary and media links open dynamically a frame at bottom-right.";s:22:"cont_layout_toc2windyn";s:25:"Table of Contents Dynamic";s:11:"cont_layout";s:6:"Layout";s:15:"cont_left_float";s:14:"Left, Floating";s:9:"cont_left";s:4:"Left";s:14:"cont_link_area";s:9:"Link Area";s:13:"cont_link_ext";s:15:"Link (external)";s:13:"cont_link_int";s:15:"Link (internal)";s:16:"cont_link_select";s:13:"Internal Link";s:14:"cont_link_type";s:9:"Link Type";s:9:"cont_link";s:4:"Link";s:16:"cont_linked_mobs";s:20:"Linked media objects";s:10:"cont_links";s:5:"Links";s:15:"cont_list_files";s:10:"List Files";s:20:"cont_list_properties";s:15:"List Properties";s:9:"cont_List";s:4:"List";s:19:"cont_lk_chapter_new";s:19:"Chapter (New Frame)";s:15:"cont_lk_chapter";s:7:"Chapter";s:17:"cont_lk_media_faq";s:17:"Media (FAQ Frame)";s:20:"cont_lk_media_inline";s:14:"Media (Inline)";s:19:"cont_lk_media_media";s:19:"Media (Media Frame)";s:17:"cont_lk_media_new";s:17:"Media (New Frame)";s:16:"cont_lk_page_faq";s:16:"Page (FAQ Frame)";s:16:"cont_lk_page_new";s:16:"Page (New Frame)";s:12:"cont_lk_page";s:4:"Page";s:14:"cont_lk_survey";s:6:"Survey";s:16:"cont_lk_term_new";s:25:"Glossary Term (New Frame)";s:12:"cont_lk_term";s:13:"Glossary Term";s:22:"cont_lm_default_layout";s:33:"Default Layout of Learning Module";s:12:"cont_lm_menu";s:4:"Menu";s:18:"cont_lm_properties";s:24:"Learning Module Settings";s:14:"cont_localfile";s:10:"Local File";s:14:"cont_LocalFile";s:10:"Local File";s:13:"cont_location";s:8:"Location";s:17:"cont_lrs_settings";s:8:"Settings";s:11:"cont_lvalue";s:12:"Data element";s:13:"cont_manifest";s:8:"Manifest";s:14:"cont_map_areas";s:10:"Link Areas";s:27:"cont_map_file_not_generated";s:47:"Sorry. Unable to generate map file for editing.";s:18:"cont_mastery_score";s:18:"adlcp:masteryscore";s:21:"cont_max_time_allowed";s:20:"adlcp:maxtimeallowed";s:17:"cont_media_placeh";s:30:"Click and edit to insert media";s:18:"cont_media_placehl";s:17:"Media Placeholder";s:17:"cont_media_source";s:12:"Media Source";s:10:"cont_Media";s:16:"Media (Standard)";s:18:"cont_mep_structure";s:20:"Media Pool Structure";s:26:"cont_missing_preconditions";s:75:"You need to fulfill the following preconditions to access the chapter "%s".";s:13:"cont_Mnemonic";s:8:"Mnemonic";s:17:"cont_mob_def_prop";s:18:"Default Properties";s:14:"cont_mob_files";s:12:"Object Files";s:24:"cont_mob_from_media_pool";s:22:"Choose From Media Pool";s:18:"cont_mob_inst_prop";s:19:"Instance Properties";s:13:"cont_mob_prop";s:17:"Object Properties";s:15:"cont_mob_usages";s:5:"Usage";s:10:"cont_month";s:5:"Month";s:16:"cont_move_object";s:11:"move object";s:26:"cont_msg_multiple_editions";s:54:"It\'s not possible to show details of multiple editions";s:9:"cont_name";s:4:"Name";s:13:"cont_new_area";s:13:"New Link Area";s:19:"cont_new_assignment";s:14:"New assignment";s:12:"cont_new_dir";s:13:"New Directory";s:13:"cont_new_file";s:8:"New File";s:18:"cont_new_media_obj";s:16:"New Media Object";s:12:"cont_new_mob";s:16:"New Media Object";s:21:"cont_new_module_added";s:43:"New version of module uploaded successfully";s:12:"cont_new_tab";s:9:"New Panel";s:13:"cont_new_term";s:8:"New Term";s:13:"cont_next_rev";s:13:"Next Revision";s:14:"cont_no_access";s:9:"No Access";s:21:"cont_no_assign_itself";s:39:"The object cannot be assigned to itself";s:15:"cont_no_caption";s:10:"No Caption";s:16:"cont_no_glossary";s:21:"No glossary assigned.";s:16:"cont_no_manifest";s:48:"No imsmanifest.xml file found in main directory.";s:20:"cont_no_object_found";s:41:"Could not find any object with this title";s:23:"cont_no_page_in_chapter";s:71:"Sorry, but there is currently no activated content within this chapter.";s:12:"cont_no_page";s:14:"No Page found.";s:18:"cont_no_parameters";s:13:"No Parameters";s:21:"cont_no_subdir_in_zip";s:84:"Zip command failed or import file invalid.<br>It does not contain a sub-folder \'%s\'.";s:12:"cont_no_text";s:7:"No Text";s:16:"cont_no_zip_file";s:30:"Import file is not a zip file.";s:11:"cont_nomenu";s:19:"Hide Navigation Bar";s:9:"cont_none";s:4:"None";s:24:"cont_not_js_chap_editing";s:30:"Use No-JavaScript Editing Mode";s:18:"cont_nr_col_footer";s:14:"Footer Columns";s:18:"cont_nr_col_header";s:14:"Header Columns";s:12:"cont_nr_cols";s:17:"Number of Columns";s:13:"cont_nr_items";s:15:"Number of Items";s:18:"cont_nr_row_footer";s:11:"Footer Rows";s:18:"cont_nr_row_header";s:11:"Header Rows";s:12:"cont_nr_rows";s:14:"Number of Rows";s:19:"cont_number_of_tabs";s:16:"Number of Panels";s:15:"cont_number_std";s:8:"Standard";s:16:"cont_number_type";s:11:"Number Type";s:11:"cont_Number";s:6:"Number";s:18:"cont_numbered_list";s:13:"Numbered List";s:16:"cont_obj_removed";s:16:"Objects removed.";s:18:"cont_offline_files";s:16:"Offline versions";s:21:"cont_offline_versions";s:16:"Offline Versions";s:12:"cont_offline";s:16:"Offline Versions";s:11:"cont_online";s:6:"Online";s:26:"cont_operation_not_allowed";s:30:"This operation is not allowed.";s:7:"cont_or";s:2:"or";s:10:"cont_order";s:10:"Order Type";s:17:"cont_organization";s:12:"Organization";s:18:"cont_organizations";s:13:"Organizations";s:14:"cont_orig_size";s:13:"Original Size";s:20:"cont_page_activation";s:15:"Page Activation";s:17:"cont_page_compare";s:26:"Compare Selected Revisions";s:31:"cont_page_currently_deactivated";s:46:"Sorry, but this page is currently deactivated.";s:30:"cont_page_deactivated_elements";s:35:"Page contains deactivated elements.";s:21:"cont_page_deactivated";s:20:"Page is deactivated.";s:16:"cont_page_header";s:11:"Page Header";s:16:"cont_page_layout";s:11:"Page Layout";s:14:"cont_page_link";s:9:"Page Link";s:27:"cont_page_select_target_now";s:42:"Page marked for moving. Select target now.";s:26:"cont_pages_and_subchapters";s:21:"Subchapters and Pages";s:10:"cont_pages";s:5:"Pages";s:14:"cont_parameter";s:9:"Parameter";s:15:"cont_parameters";s:10:"parameters";s:25:"cont_paste_from_clipboard";s:20:"Paste from clipboard";s:16:"cont_paste_table";s:11:"Paste Table";s:12:"cont_pc_code";s:4:"Code";s:15:"cont_pc_deleted";s:15:"Deleted Content";s:12:"cont_pc_dtab";s:10:"Data Table";s:13:"cont_pc_flist";s:9:"File List";s:12:"cont_pc_hacc";s:22:"Accordion (Horizontal)";s:12:"cont_pc_incl";s:15:"Content Snippet";s:12:"cont_pc_list";s:13:"Advanced List";s:11:"cont_pc_map";s:3:"Map";s:11:"cont_pc_mob";s:5:"Media";s:16:"cont_pc_modified";s:16:"Modified Content";s:11:"cont_pc_new";s:11:"New Content";s:11:"cont_pc_par";s:4:"Text";s:11:"cont_pc_qst";s:8:"Question";s:11:"cont_pc_res";s:8:"Resource";s:11:"cont_pc_sec";s:7:"Section";s:11:"cont_pc_tab";s:14:"Advanced Table";s:12:"cont_pc_vacc";s:20:"Accordion (Vertical)";s:23:"cont_personal_clipboard";s:18:"Personal Clipboard";s:15:"cont_pg_content";s:12:"Page Content";s:13:"cont_pg_title";s:10:"Page Title";s:24:"cont_please_enter_a_term";s:20:"Please enter a term.";s:18:"cont_please_select";s:13:"please select";s:9:"cont_Poly";s:7:"Polygon";s:13:"cont_position";s:8:"Position";s:16:"cont_prereq_type";s:24:"adlcp:prerequisites.type";s:18:"cont_prerequisites";s:19:"adlcp:prerequisites";s:12:"cont_preview";s:7:"Preview";s:17:"cont_previous_rev";s:17:"Previous Revision";s:27:"cont_print_no_page_selected";s:32:"Please select at least one page.";s:20:"cont_print_selection";s:20:"Print View Selection";s:23:"cont_print_view_pre_glo";s:39:"Prevent Glossary Appendix in Print View";s:15:"cont_print_view";s:10:"Print View";s:18:"cont_public_access";s:13:"Public Access";s:22:"cont_public_notes_desc";s:64:"Allow users to share notes on every page of the learning module.";s:17:"cont_public_notes";s:12:"Public Notes";s:14:"cont_publisher";s:9:"Publisher";s:12:"cont_purpose";s:7:"Purpose";s:11:"cont_qtries";s:29:"Number of Tries for Questions";s:20:"cont_question_placeh";s:33:"Click and edit to insert question";s:21:"cont_question_placehl";s:20:"Question Placeholder";s:18:"cont_question_pool";s:13:"Question Pool";s:18:"cont_question_type";s:13:"Question Type";s:12:"cont_Reading";s:7:"Reading";s:9:"cont_Rect";s:9:"Rectangle";s:17:"cont_ref_helptext";s:40:"(e.g. http://www.server.org/myimage.jpg)";s:15:"cont_ref_images";s:17:"Referenced Images";s:14:"cont_reference";s:9:"Reference";s:11:"cont_Remark";s:6:"Remark";s:22:"cont_remove_fullscreen";s:18:"Remove Full Screen";s:14:"cont_removeiln";s:29:"really remove internal link ?";s:15:"cont_rename_dir";s:16:"Rename Directory";s:29:"cont_replace_mob_feature_info";s:132:"Activates a feature that allows you to replace a media object while keeping the other properties of a media instance in the content.";s:24:"cont_replace_mob_feature";s:32:"Replace Media Objects in Content";s:26:"cont_repository_item_links";s:21:"Repository Item Links";s:20:"cont_repository_item";s:15:"Repository Item";s:23:"cont_resize_explanation";s:109:"If this option is activated uploaded image files are automatically resized to the specified width and height.";s:24:"cont_resize_explanation2";s:74:"This function resizes local image files to the specified width and height.";s:17:"cont_resize_image";s:13:"Resize images";s:15:"cont_resize_img";s:17:"Resize Image File";s:18:"cont_resource_size";s:22:"Original Resource Size";s:18:"cont_resource_type";s:4:"type";s:13:"cont_resource";s:8:"Resource";s:14:"cont_resources";s:9:"Resources";s:13:"cont_revision";s:8:"Revision";s:16:"cont_right_float";s:15:"Right, Floating";s:10:"cont_right";s:5:"Right";s:26:"cont_rollback_confirmation";s:59:"Do you really want to restore this old version of the page?";s:13:"cont_rollback";s:8:"Rollback";s:12:"cont_roman_s";s:16:"Roman i, ii, …";s:10:"cont_roman";s:16:"Roman I, II, …";s:12:"cont_rowspan";s:8:"Row Span";s:11:"cont_rvalue";s:5:"Value";s:20:"cont_save_all_titles";s:11:"Save Titles";s:31:"cont_save_positions_and_classes";s:32:"Save Positions and Style Classes";s:19:"cont_save_positions";s:14:"Save Positions";s:15:"cont_save_spans";s:10:"Save Spans";s:16:"cont_save_widths";s:11:"Save Widths";s:19:"cont_saved_map_area";s:14:"Saved map area";s:19:"cont_saved_map_data";s:14:"Saved map data";s:19:"cont_sc_auto_review";s:25:"Set Review when Completed";s:24:"cont_sc_less_mode_browse";s:6:"Browse";s:24:"cont_sc_less_mode_normal";s:6:"Normal";s:26:"cont_sc_max_attempt_exceed";s:57:"Max. number of attempts for this module has been reached.";s:19:"cont_sc_max_attempt";s:13:"Max. Attempts";s:19:"cont_sc_new_version";s:18:"Upload new version";s:15:"cont_sc_preview";s:7:"Preview";s:20:"cont_sc_stat_browsed";s:7:"Browsed";s:22:"cont_sc_stat_completed";s:9:"Completed";s:19:"cont_sc_stat_failed";s:6:"Failed";s:23:"cont_sc_stat_incomplete";s:10:"Incomplete";s:26:"cont_sc_stat_not_attempted";s:13:"Not attempted";s:19:"cont_sc_stat_passed";s:6:"Passed";s:20:"cont_sc_stat_running";s:7:"Running";s:13:"cont_sc_title";s:5:"title";s:16:"cont_sc_usession";s:25:"Unlimited Session Timeout";s:15:"cont_sc_version";s:7:"Version";s:25:"cont_scheduled_activation";s:20:"Scheduled Activation";s:11:"cont_school";s:6:"School";s:10:"cont_score";s:5:"Score";s:15:"cont_scorm_type";s:15:"adlcp:scormtype";s:27:"cont_select_from_upload_dir";s:38:"-- Select from the upload directory --";s:16:"cont_select_item";s:25:"Select at least one item.";s:24:"cont_select_max_one_item";s:28:"Please select one item only.";s:24:"cont_select_max_one_term";s:28:"Please select one term only.";s:22:"cont_select_media_pool";s:17:"Select Media Pool";s:23:"cont_select_one_edition";s:35:"Please select at least one edition.";s:35:"cont_select_one_translation_warning";s:53:"It is not possible to show more than one translation.";s:27:"cont_select_one_translation";s:29:"Please select one translation";s:26:"cont_select_par_or_section";s:48:"Please select at least one paragraph or section.";s:16:"cont_select_term";s:21:"Please select a term.";s:23:"cont_select_translation";s:48:"Please select the assignment from the list above";s:11:"cont_select";s:6:"Select";s:36:"cont_selected_items_have_been_copied";s:115:"Selected items have been copied to the clipboard. Click target placeholders to paste them into the learning module.";s:33:"cont_selected_items_have_been_cut";s:112:"Selected items have been cut to the clipboard. Click target placeholders to paste them into the learning module.";s:21:"cont_selected_pg_chap";s:23:"Selected Pages/Chapters";s:18:"cont_series_editor";s:13:"Series editor";s:17:"cont_series_title";s:12:"Series title";s:18:"cont_series_volume";s:13:"Series volume";s:11:"cont_series";s:6:"Series";s:14:"cont_set_after";s:12:"insert after";s:15:"cont_set_before";s:13:"insert before";s:15:"cont_set_cancel";s:6:"cancel";s:14:"cont_set_class";s:9:"Set Class";s:18:"cont_set_edit_mode";s:13:"Set Edit Mode";s:13:"cont_set_into";s:11:"insert into";s:13:"cont_set_link";s:9:"Edit Link";s:14:"cont_set_shape";s:10:"Edit Shape";s:19:"cont_set_start_file";s:14:"Set Start File";s:26:"cont_set_styles_and_widths";s:22:"Save Styles and Widths";s:15:"cont_set_styles";s:10:"Set Styles";s:23:"cont_set_tab_style_info";s:48:"Activate checkboxes in table cells to set style.";s:14:"cont_set_width";s:9:"Set Width";s:10:"cont_shape";s:5:"Shape";s:18:"cont_show_citation";s:18:"Show with citation";s:14:"cont_show_info";s:9:"Show Info";s:22:"cont_show_line_numbers";s:17:"Show line numbers";s:20:"cont_show_print_view";s:15:"Show Print View";s:9:"cont_show";s:4:"Show";s:9:"cont_size";s:12:"Size (Bytes)";s:17:"cont_skip_chapter";s:17:"Skip this chapter";s:18:"cont_snippets_used";s:21:"Used Content Snippets";s:11:"cont_source";s:6:"Source";s:9:"cont_span";s:4:"Span";s:12:"cont_Special";s:7:"Special";s:22:"cont_spreadsheet_table";s:17:"Spreadsheet Table";s:14:"cont_src_other";s:5:"other";s:8:"cont_src";s:11:"Source code";s:13:"cont_st_on_pg";s:29:"this function is not allowed.";s:13:"cont_st_title";s:13:"Chapter Title";s:18:"cont_StandardTable";s:14:"Standard Table";s:21:"cont_start_value_info";s:50:"Enter start value as decimal number. Default is 1.";s:16:"cont_start_value";s:11:"Start Value";s:10:"cont_start";s:5:"Start";s:14:"cont_startfile";s:10:"Start File";s:11:"cont_status";s:6:"Status";s:18:"cont_std_is_in_dir";s:58:"Deletion not possible. Standard view file is in directory.";s:13:"cont_std_view";s:13:"Standard View";s:14:"cont_structure";s:9:"structure";s:10:"cont_style";s:5:"Style";s:16:"cont_subchapters";s:11:"Subchapters";s:28:"cont_synchronize_frames_desc";s:157:"This option synchronises the table of contents frame with the content frame and clears additional frames in 3 window view. But it also decreases performance.";s:23:"cont_synchronize_frames";s:18:"Synchronize Frames";s:16:"cont_syntax_help";s:11:"Syntax Help";s:20:"cont_tab_cont_height";s:14:"Content Height";s:19:"cont_tab_cont_width";s:13:"Content Width";s:17:"cont_table_border";s:12:"Table Border";s:26:"cont_table_cell_properties";s:21:"Table Cell Properties";s:22:"cont_table_cellpadding";s:18:"Table Cell Padding";s:22:"cont_table_cellspacing";s:18:"Table Cell Spacing";s:27:"cont_table_html_import_info";s:68:"Import only works with XHTML conform tables. Table must be root tag!";s:22:"cont_table_html_import";s:17:"Import HTML Table";s:21:"cont_table_properties";s:16:"Table Properties";s:34:"cont_table_spreadsheet_import_info";s:74:"Paste table from spreadsheet application via clipboard into the text area.";s:29:"cont_table_spreadsheet_import";s:18:"Spreadsheet Import";s:16:"cont_table_width";s:11:"Table Width";s:10:"cont_table";s:5:"Table";s:17:"cont_TableContent";s:13:"Table Content";s:17:"cont_tabs_acc_hor";s:20:"Horizontal Accordion";s:17:"cont_tabs_acc_ver";s:18:"Vertical Accordion";s:19:"cont_tabs_accordion";s:9:"Accordion";s:26:"cont_tabs_confirm_deletion";s:65:"Are you sure that all panels and their content should be deleted?";s:24:"cont_tabs_hor_align_info";s:50:"Horizontal accordions will always be aligned left.";s:18:"cont_tabs_hor_tabs";s:15:"Horizontal Tabs";s:9:"cont_tabs";s:6:"Panels";s:19:"cont_target_missing";s:14:"Target Missing";s:25:"cont_target_within_source";s:40:"Target must not be within source object.";s:9:"cont_term";s:4:"Term";s:10:"cont_terms";s:5:"Terms";s:13:"cont_text_acc";s:7:"Accent:";s:14:"cont_text_code";s:5:"Code:";s:13:"cont_text_com";s:8:"Comment:";s:13:"cont_text_emp";s:14:"Emphatic Text:";s:12:"cont_text_fn";s:9:"Footnote:";s:13:"cont_text_iln";s:20:"Internal Link, e.g.:";s:13:"cont_text_imp";s:10:"Important:";s:17:"cont_text_keyword";s:7:"Keyword";s:16:"cont_text_placeh";s:29:"Click and edit to insert text";s:17:"cont_text_placehl";s:16:"Text Placeholder";s:14:"cont_text_quot";s:10:"Quotation:";s:13:"cont_text_str";s:12:"Strong Text:";s:13:"cont_text_tex";s:11:"LaTeX Code:";s:14:"cont_text_type";s:14:"Text Item Type";s:13:"cont_text_xln";s:14:"External Link:";s:22:"cont_time_limit_action";s:21:"adlcp:timelimitaction";s:9:"cont_time";s:4:"Time";s:20:"cont_title_footnotes";s:9:"Footnotes";s:10:"cont_title";s:5:"title";s:13:"cont_toc_mode";s:23:"Table of Contents Items";s:8:"cont_toc";s:17:"Table of Contents";s:8:"cont_top";s:3:"Top";s:15:"cont_total_time";s:10:"Total Time";s:19:"cont_tracking_bysco";s:10:"By Chapter";s:20:"cont_tracking_byuser";s:7:"By User";s:18:"cont_tracking_data";s:13:"Tracking Data";s:19:"cont_tracking_items";s:14:"Tracking Items";s:26:"cont_translations_assigned";s:37:"The translation(s) have been assigned";s:17:"cont_translations";s:14:"Translation(s)";s:15:"cont_tree_fixed";s:30:"Tree structure has been fixed.";s:9:"cont_type";s:4:"Type";s:14:"cont_Unordered";s:9:"Unordered";s:15:"cont_update_map";s:8:"Edit Map";s:17:"cont_update_names";s:12:"Update Names";s:21:"cont_update_resources";s:20:"Update Resource List";s:19:"cont_update_section";s:14:"Update Section";s:16:"cont_update_tabs";s:13:"Update Panels";s:11:"cont_update";s:6:"Update";s:20:"cont_upload_dir_info";s:231:"Server directory from which large SCORM and HTML packages can be copied instead of being uploaded. Only ILIAS administrators will see a selection of files from this directory. Please enter a full server path without trailing slash.";s:15:"cont_upload_dir";s:16:"Upload directory";s:16:"cont_upload_file";s:11:"Upload File";s:18:"cont_uploaded_file";s:13:"Existing File";s:8:"cont_url";s:3:"URL";s:10:"cont_usage";s:5:"Usage";s:31:"cont_use_same_resource_as_above";s:30:"Use the same resource as above";s:28:"cont_users_have_mob_in_clip1";s:40:"This media object is in the clipboard of";s:28:"cont_users_have_mob_in_clip2";s:8:"user(s).";s:18:"cont_validate_file";s:13:"Validate File";s:12:"cont_version";s:7:"version";s:13:"cont_versions";s:8:"Versions";s:25:"cont_view_last_export_log";s:15:"Last Export Log";s:20:"cont_where_published";s:15:"Where published";s:10:"cont_width";s:5:"Width";s:19:"cont_wiki_page_link";s:14:"Wiki Page Link";s:12:"cont_wysiwyg";s:15:"Content WYSIWYG";s:13:"cont_xml_base";s:8:"xml:base";s:9:"cont_year";s:4:"Year";s:21:"cont_zip_file_invalid";s:68:"File is not a valid import file.<br>It does not contain a file \'%s\'.";s:15:"content_current";s:7:"Current";s:12:"content_last";s:4:"Last";s:20:"content_page_history";s:12:"Page History";s:19:"copied_to_clipboard";s:30:"Copied object(s) to clipboard.";s:13:"dgl_pagebreak";s:9:"Pagebreak";s:19:"glo_definition_abbr";s:4:"Def.";s:16:"glo_term_used_in";s:44:"The following resources linking to that term";s:10:"glo_usages";s:22:"Glossary is used in...";s:11:"HTML export";s:11:"HTML Export";s:17:"import_sco_object";s:10:"Import SCO";s:18:"lm_menu_edit_entry";s:15:"Edit menu entry";s:20:"lm_menu_entry_target";s:6:"Target";s:19:"lm_menu_entry_title";s:5:"Title";s:17:"lm_menu_new_entry";s:23:"Create a new menu entry";s:30:"lm_menu_select_internal_object";s:25:"Select internal object >>";s:28:"lm_menu_select_object_to_add";s:52:"Please select the object you want to add to the menu";s:18:"mep_folder_created";s:17:"Added new folder.";s:15:"msg_entry_added";s:16:"Menu entry added";s:17:"msg_entry_removed";s:18:"Menu entry removed";s:17:"msg_entry_updated";s:18:"Menu entry updated";s:25:"msg_page_no_public_access";s:138:"The page you called is not available in the public area. Only registered users may view this page. Please login first to access this page.";s:19:"msg_page_not_public";s:18:"Page is not public";s:10:"pages from";s:10:"Pages From";s:5:"Pages";s:5:"Pages";s:3:"par";s:9:"Paragraph";s:10:"PDF export";s:10:"PDF Export";s:2:"pg";s:4:"Page";s:14:"public_section";s:11:"Public Area";s:12:"read offline";s:12:"Read Offline";s:18:"saved_media_object";s:19:"Saved media object.";s:21:"scplayer_collapsetree";s:12:"Collapse All";s:17:"scplayer_continue";s:8:"Continue";s:17:"scplayer_debugger";s:14:"Show test tool";s:13:"scplayer_exit";s:4:"Exit";s:16:"scplayer_exitall";s:8:"Exit All";s:19:"scplayer_expandtree";s:10:"Expand All";s:17:"scplayer_hidetree";s:9:"Hide Tree";s:22:"scplayer_phpmysqlcheck";s:79:"You need MYSQL 4.1 or higher and enabled JSON-support to use the JavaScript-RTE";s:17:"scplayer_previous";s:8:"Previous";s:13:"scplayer_next";s:4:"Next";s:17:"scplayer_showtree";s:9:"Show Tree";s:14:"scplayer_start";s:5:"Start";s:19:"scplayer_suspendall";s:11:"Suspend All";s:13:"select_a_file";s:21:"Please select a file.";s:19:"selected_pages_only";s:19:"Only Selected Pages";s:12:"selectFooter";s:16:"Select As Footer";s:12:"selectHeader";s:16:"Select As Header";s:11:"seq_abandon";s:56:"An Abandon Navigation Request was received an processed.";s:14:"seq_abandonall";s:47:"The current course session has been abandoned..";s:11:"seq_blocked";s:35:"The sequencing session was blocked.";s:9:"seq_close";s:31:"Please close the player-window.";s:18:"seq_coursecomplete";s:32:"The current course is completed.";s:12:"seq_deadlock";s:31:"The sequencer is in a deadlock.";s:14:"seq_endsession";s:37:"The current course session has ended.";s:9:"seq_error";s:44:"An internal error in the sequencer occurred.";s:17:"seq_invalidnavreq";s:42:"The sequencer received an invalid request.";s:11:"seq_nothing";s:32:"There is no activity to deliver.";s:7:"seq_toc";s:79:"From the Table Of Contents on the left, choose an activity to begin the course.";s:15:"set_public_mode";s:22:"Set public access mode";s:2:"st";s:7:"Chapter";s:12:"start export";s:12:"Start Export";s:14:"text_repr_info";s:35:"Used for image ‘alt’ attribute.";s:9:"text_repr";s:19:"Text Representation";s:12:"cont_lk_file";s:13:"File/Document";s:16:"cont_select_file";s:11:"Select File";s:16:"cont_create_link";s:11:"Create Link";s:17:"glo_used_in_scorm";s:108:"The glossary is used by the SCORM module. If deleted, references to the glossary cannot be resolved anymore.";s:21:"glo_presentation_view";s:17:"Presentation View";s:16:"glo_add_new_term";s:12:"Add New Term";s:24:"glo_term_is_used_n_times";s:47:"The term is used %s time(s) in content modules.";s:15:"glo_list_usages";s:11:"List Usages";s:17:"cont_sco_glossary";s:13:"Unit Glossary";s:20:"glo_quick_navigation";s:16:"Quick Navigation";s:21:"glo_presentation_mode";s:17:"Presentation Mode";s:14:"glo_table_form";s:13:"In Table Form";s:19:"glo_table_form_info";s:135:"Terms and definition are first shown in a two-column overview. Clicking the term opens the full content of a term on a separate screen.";s:23:"glo_text_snippet_length";s:25:"Definition Snippet Length";s:28:"glo_text_snippet_length_info";s:75:"Length of the text snippet of the definition that is shown in the overview.";s:20:"glo_full_definitions";s:16:"Full Definitions";s:25:"glo_full_definitions_info";s:59:"Terms and definitions are fully displayed in the main view.";s:16:"glo_editing_view";s:12:"Editing View";s:23:"cont_link_whole_picture";s:18:"Link Whole Picture";s:29:"cont_edit_shape_whole_picture";s:26:"Edit Shape (Whole Picture)";s:14:"cont_alignment";s:9:"Alignment";s:18:"cont_set_alignment";s:13:"Set Alignment";s:19:"cont_users_answered";s:14:"Users Answered";s:24:"cont_correct_after_first";s:17:"First Try Correct";s:11:"cont_second";s:6:"Second";s:19:"cont_third_and_more";s:13:"Third or More";s:10:"cont_never";s:5:"Never";s:21:"cont_download_no_menu";s:88:"Download will not be available to users since the learning module menu is not activated.";s:25:"cont_download_no_download";s:85:"Download will not be available to users, since the download feature is not activated.";s:31:"cont_no_download_file_available";s:53:"There is currently no public download file available.";s:11:"htlm_import";s:27:"Import HTML Learning Module";s:14:"cont_selection";s:9:"Selection";s:19:"cont_whole_glossary";s:14:"Whole Glossary";s:19:"cont_selected_terms";s:14:"Selected Terms";s:13:"cont_new_page";s:8:"New Page";s:13:"cont_new_chap";s:11:"New Chapter";s:19:"cont_submit_answers";s:6:"Submit";s:18:"cont_wrong_answers";s:15:"Incorrect Items";s:20:"cont_tries_remaining";s:15:"Tries Remaining";s:21:"cont_please_try_again";s:17:"Please try again!";s:24:"cont_all_answers_correct";s:8:"Correct!";s:27:"cont_enough_answers_correct";s:35:"Correct, but not the best solution!";s:25:"cont_nr_of_tries_exceeded";s:25:"Number of tries exceeded.";s:26:"cont_correct_answers_shown";s:27:"Correct solution see above.";s:25:"cont_wrong_answers_single";s:17:"Incorrect Choice.";s:14:"cont_added_tab";s:12:"Panel added.";s:33:"cont_ed_insert_login_page_element";s:25:"Insert Login Page Element";s:30:"cont_insert_login_page_element";s:25:"Insert Login Page Element";s:30:"cont_update_login_page_element";s:25:"Update Login Page Element";s:19:"cont_final_sco_page";s:19:"Final Page for SCOs";s:18:"cont_final_lm_page";s:30:"Final Page for Learning Module";s:32:"cont_really_delete_special_pages";s:57:"Do you really want to delete the following special pages?";s:26:"cont_create_final_sco_page";s:26:"Create Final Page for SCOs";s:25:"cont_create_final_lm_page";s:37:"Create Final Page for Learning Module";s:19:"page_does_not_exist";s:43:"We are sorry, but this page does not exist.";s:15:"cont_save_types";s:10:"Save Types";s:20:"cont_layout_template";s:15:"Layout Template";s:17:"cont_special_page";s:20:"Special Content Page";s:24:"cont_final_sco_page_info";s:102:"A status page will be displayed at the end of a SCO, if all questions have been answered successfully.";s:23:"cont_final_lm_page_info";s:105:"A status page will be displayed, if all questions of the learning module have been answered successfully.";s:13:"cont_page_toc";s:13:"Page Overview";s:22:"cont_presentation_view";s:17:"Presentation View";s:20:"cont_deactivate_html";s:25:"Deactivate HTML Rendering";s:18:"cont_deactivate_js";s:18:"Activate Form Mode";s:21:"cont_deactivate_media";s:16:"Deactivate Media";s:18:"cont_activate_html";s:23:"Activate HTML Rendering";s:16:"cont_activate_js";s:24:"Activate Javascript Mode";s:19:"cont_activate_media";s:14:"Activate Media";s:15:"cont_par_format";s:9:"Paragraph";s:16:"cont_char_format";s:9:"Character";s:10:"cont_lists";s:5:"Lists";s:19:"cont_more_functions";s:4:"More";s:11:"cont_saving";s:9:"Saving...";s:21:"cont_link_to_internal";s:22:"Link to ILIAS Resource";s:21:"cont_link_to_external";s:24:"Link to External Website";s:17:"cont_link_to_wiki";s:35:"Link to Wiki Page (Insert Brackets)";s:13:"cont_standard";s:8:"Standard";s:19:"cont_char_style_com";s:7:"Comment";s:20:"cont_char_style_quot";s:9:"Quotation";s:19:"cont_char_style_acc";s:11:"Accentuated";s:20:"cont_char_style_code";s:4:"Code";s:8:"cont_tex";s:10:"Latex Code";s:7:"cont_fn";s:8:"Footnote";s:18:"cont_ed_insert_iim";s:24:"Insert Interactive Image";s:11:"cont_pc_iim";s:17:"Interactive Image";s:22:"cont_ed_insert_profile";s:20:"Insert Personal Data";s:12:"cont_pc_prof";s:13:"Personal Data";s:19:"cont_insert_profile";s:21:"Publish Personal Data";s:19:"cont_update_profile";s:19:"Edit Published Data";s:17:"cont_profile_mode";s:4:"Mode";s:25:"cont_profile_mode_inherit";s:9:"Automatic";s:30:"cont_profile_mode_inherit_info";s:25:"Use your profile settings";s:24:"cont_profile_mode_manual";s:6:"Manual";s:29:"cont_profile_mode_manual_info";s:23:"Use the following data:";s:27:"cont_ed_insert_verification";s:18:"Insert Certificate";s:12:"cont_pc_vrfc";s:11:"Certificate";s:24:"cont_insert_verification";s:15:"Add Certificate";s:24:"cont_update_verification";s:16:"Edit Certificate";s:24:"cont_verification_object";s:11:"Certificate";s:19:"cont_ed_insert_blog";s:11:"Insert Blog";s:12:"cont_pc_blog";s:4:"Blog";s:16:"cont_insert_blog";s:16:"Add Blog Posting";s:16:"cont_update_blog";s:17:"Edit Blog Posting";s:17:"cont_active_areas";s:8:"Triggers";s:19:"cont_content_popups";s:14:"Content Popups";s:19:"cont_overlay_images";s:14:"Overlay Images";s:15:"cont_add_images";s:10:"Add Images";s:14:"cont_add_popup";s:9:"Add Popup";s:17:"cont_WholePicture";s:13:"Whole Picture";s:18:"cont_overlay_image";s:13:"Overlay Image";s:18:"cont_content_popup";s:13:"Content Popup";s:30:"cont_update_titles_and_actions";s:25:"Update Titles and Actions";s:17:"cont_trigger_area";s:12:"Trigger Area";s:11:"cont_marker";s:6:"Marker";s:28:"cont_saved_interactive_image";s:25:"Created Interactive Image";s:15:"cont_base_image";s:16:"Background Image";s:20:"cont_edit_base_image";s:21:"Edit Background Image";s:27:"cont_really_delete_overlays";s:52:"Do you really want to delete the following overlays?";s:31:"cont_overlays_have_been_deleted";s:27:"Overlays have been deleted.";s:14:"cont_new_popup";s:9:"New Popup";s:25:"cont_really_delete_popups";s:50:"Do you really want to delete the following popups?";s:29:"cont_popups_have_been_deleted";s:25:"Popups have been deleted.";s:21:"cont_new_trigger_area";s:16:"New Trigger Area";s:27:"cont_really_delete_triggers";s:52:"Do you really want to delete the following triggers?";s:15:"cont_new_marker";s:10:"New Marker";s:26:"cont_edit_overlay_position";s:21:"Edit Overlay Position";s:25:"cont_edit_marker_position";s:20:"Edit Marker Position";s:24:"cont_edit_popup_position";s:19:"Edit Popup Position";s:28:"cont_drag_element_click_save";s:71:"Drag and drop the element to the desired position. Then hit ‘Save’.";s:25:"cont_correct_answers_also";s:17:"Also correct are:";s:24:"cont_correct_answer_also";s:16:"Also correct is:";s:18:"cont_remove_format";s:13:"Remove Format";s:21:"cont_ed_edit_multiple";s:23:"Edit Paragraph Sequence";s:13:"cont_pc_qover";s:17:"Question Overview";s:20:"cont_ed_insert_qover";s:24:"Insert Question Overview";s:17:"cont_update_qover";s:24:"Update Question Overview";s:24:"cont_qover_short_message";s:14:"Status Message";s:29:"cont_qover_short_message_info";s:97:"A message ‘You have correctly answered C out of Y questions of this unit.’ will be displayed.";s:23:"cont_qover_list_wrong_q";s:32:"List of Wrong Answered Questions";s:28:"cont_qover_list_wrong_q_info";s:60:"A list of wrong or not answered questions will be displayed.";s:15:"cont_edit_qover";s:22:"Edit Question Overview";s:19:"cont_ov_all_correct";s:42:"You have correctly answered all questions.";s:20:"cont_ov_some_correct";s:53:"You have correctly answered [x] out of [y] questions.";s:22:"cont_ov_wrong_answered";s:59:"The following questions were not answered or answered wrong";s:22:"cont_update_login_page";s:23:"Edit Login Page Element";s:19:"cont_lpe_login_form";s:10:"Login Form";s:23:"cont_lpe_cas_login_form";s:14:"CAS Login Form";s:24:"cont_lpe_shib_login_form";s:21:"Shibboleth Login Form";s:26:"cont_lpe_openid_login_form";s:17:"OpenId Login Form";s:26:"cont_lpe_registration_link";s:21:"New Registration Link";s:27:"cont_lpe_language_selection";s:18:"Language Selection";s:28:"cont_lpe_user_agreement_link";s:19:"User Agreement Link";s:22:"cont_insert_login_page";s:22:"Add Login Page Element";s:20:"cont_html_export_ids";s:15:"HTML Export IDs";s:25:"cont_html_export_ids_info";s:117:"Allows maintaining extra IDs for ILIAS learning modules that are used for naming HTML files when HTML export is done.";s:14:"cont_export_id";s:9:"Export ID";s:29:"cont_exp_ids_not_resp_format1";s:48:"Export IDs may only use the following characters";s:29:"cont_exp_ids_not_resp_format2";s:36:"Please check and correct your input.";s:21:"cont_saved_export_ids";s:22:"Saved HTML Export IDs.";s:38:"content_some_export_ids_multiple_times";s:87:"Some export IDs are used multiple times. This will lead to missing pages in the export.";s:25:"cont_exp_id_used_multiple";s:29:"Export ID used multiple times";s:14:"mob_upload_dir";s:16:"Upload Directory";s:19:"mob_upload_dir_info";s:227:"Server directory from which multiple files can be used to create media objects in media pools. Only ILIAS administrators will see a selection of files from this directory. Please enter a full server path without trailing slash.";s:29:"cont_exp_ids_not_resp_format3";s:36:"The ID must not start with a number.";s:19:"cont_current_usages";s:14:"Current Usages";s:15:"cont_all_usages";s:15:"Include History";s:15:"cont_set_layout";s:10:"Set Layout";s:20:"cont_missing_snippet";s:54:"Missing Content Snippet. The snippet has been deleted.";s:24:"cont_enable_page_history";s:12:"Page History";s:29:"cont_enable_page_history_info";s:70:"Stores older versions of pages and allows roll back to older versions.";s:17:"cont_localization";s:12:"Localization";s:22:"cont_localization_info";s:71:"Language used for predefined texts, e.g. ‘Previous’ and ’Next’.";s:16:"cont_maintenance";s:11:"Maintenance";s:25:"cont_switch_to_media_pool";s:26:"Switch to other Media Pool";s:23:"cont_edit_personal_data";s:18:"Edit Personal Data";s:21:"cont_paragraph_styles";s:16:"Paragraph Styles";s:11:"cont_cc_str";s:6:"Strong";s:11:"cont_cc_emp";s:8:"Emphatic";s:11:"cont_cc_imp";s:9:"Important";s:26:"cont_more_character_styles";s:24:"...more character styles";s:10:"cont_blist";s:11:"Bullet List";s:10:"cont_nlist";s:13:"Numbered List";s:17:"cont_list_outdent";s:12:"Outdent List";s:16:"cont_list_indent";s:11:"Indent List";s:10:"cont_pword";s:15:"Paste from Word";s:17:"cont_new_question";s:12:"New Question";s:28:"cont_copy_question_from_pool";s:23:"Copy Question from Pool";s:23:"cont_select_other_qpool";s:17:"Select other Pool";s:28:"cont_copy_question_into_page";s:14:"Copy into Page";s:9:"cont_open";s:7:"Display";s:16:"cont_open_normal";s:29:"in tab / new window with link";s:20:"cont_open_iframe_max";s:24:"in iframe with full size";s:24:"cont_open_iframe_defined";s:39:"in iframe with defined width and height";s:26:"cont_open_window_undefined";s:46:"in new window without defined width and height";s:24:"cont_open_window_defined";s:43:"in new window with defined width and height";s:15:"cont_open_width";s:5:"width";s:16:"cont_open_heigth";s:6:"height";s:21:"cont_debug_deactivate";s:109:"The test tool can be globally deactivated in the ILIAS administration (Administration » Learning Resources).";s:22:"cont_debug_deactivated";s:115:"The test tool is currently globally deactivated in the ILIAS administration (Administration » Learning Resources).";s:24:"cont_file_from_workspace";s:22:"File From My Workspace";s:21:"cont_sc_auto_continue";s:13:"Auto-Continue";s:21:"cont_ed_insert_skills";s:18:"Insert Competences";s:14:"cont_pc_skills";s:10:"Competence";s:18:"cont_insert_skills";s:17:"Insert Competence";s:18:"cont_update_skills";s:15:"Edit Competence";s:24:"cont_scorm_ed_properties";s:37:"Learning Module Properties / Glossary";s:37:"sahs_empty_objectives_are_not_allowed";s:34:"Please enter a learning objective.";s:14:"cont_edit_mode";s:9:"Edit Mode";s:12:"cont_ed_copy";s:4:"Copy";s:11:"cont_ed_cut";s:3:"Cut";s:28:"cont_sel_el_copied_use_paste";s:103:"Selected elements have been copied. Please click the desired target placeholder and select ‘Paste’.";s:25:"cont_sel_el_cut_use_paste";s:100:"Selected elements have been cut. Please click the desired target placeholder and select ‘Paste’.";s:34:"cont_cp_question_diff_formats_info";s:69:"Please note that some formatting is not supported in content modules.";s:15:"cont_sequencing";s:25:"Sequencing and Navigation";s:17:"cont_interactions";s:29:"Store Results of Interactions";s:15:"cont_objectives";s:30:"Store Learning Objectives Data";s:13:"cont_comments";s:14:"Store Comments";s:18:"cont_time_from_lms";s:38:"Processing Time Determination by ILIAS";s:21:"cont_lm_comments_desc";s:67:"Allow users to share comments on every page of the learning module.";s:20:"cont_online_help_ids";s:10:"Screen-IDs";s:15:"cont_screen_ids";s:10:"Screen-IDs";s:25:"cont_captcha_verification";s:17:"User Verification";s:17:"cont_captcha_code";s:4:"Code";s:9:"glo_style";s:14:"Glossary Style";s:17:"cont_current_term";s:12:"Current Term";s:17:"glo_show_taxonomy";s:13:"Show Taxonomy";s:25:"cont_show_activation_info";s:20:"Show Activation Info";s:30:"cont_show_activation_info_info";s:156:"If the scheduled activation is not yet reached, the page will not be skipped. The information when the page will be activated will be displayed to the user.";s:23:"cont_page_activation_on";s:36:"The content will be activated on %s.";s:10:"cont_hover";s:5:"Hover";s:11:"cont_always";s:6:"Always";s:19:"cont_highlight_mode";s:14:"Highlight Mode";s:10:"cont_light";s:5:"Light";s:9:"cont_dark";s:4:"Dark";s:13:"cont_accented";s:8:"Accented";s:8:"cont_set";s:3:"Set";s:12:"cont_link_no";s:7:"No Link";s:22:"cont_AdvancedKnowledge";s:18:"Advanced Knowledge";s:13:"cont_show_adv";s:23:"Show Advanced Knowledge";s:13:"cont_hide_adv";s:23:"Hide Advanced Knowledge";s:22:"cont_auto_last_visited";s:25:"Open Last Visited Chapter";s:17:"cont_check_values";s:11:"Value Check";s:22:"cont_resources_of_type";s:17:"Resources of Type";s:32:"cont_element_refers_removed_itgr";s:83:"This content element refers to an item group that has been removed in the meantime.";s:29:"cont_initial_attached_content";s:21:"Initial Extra Content";s:10:"cont_topic";s:5:"Topic";s:19:"cont_selected_topic";s:14:"Selected Topic";s:15:"cont_all_topics";s:10:"All Topics";s:20:"cont_highlight_class";s:15:"Highlight Class";s:17:"cont_presentation";s:12:"Presentation";s:18:"cont_scorm_options";s:13:"SCORM Options";s:17:"cont_rte_settings";s:12:"RTE Settings";s:14:"cont_debugging";s:9:"Debugging";s:27:"cont_auto_last_visited_info";s:79:"Opens the last visited SCO/Asset when the learner reenters the learning module.";s:21:"cont_credit_mode_info";s:66:"This setting is only affective if the lesson mode is ‘normal’.";s:27:"cont_sc_auto_review_info_12";s:81:"Set the lesson mode to ‘review’ when a learner has completed or passed a SCO.";s:21:"cont_sc_usession_info";s:83:"This setting activates periodical requests to the server to keep the session alive.";s:20:"cont_sequencing_info";s:81:"Enable the sequencing and navigation behaviour as defined by the learning module.";s:23:"cont_time_from_lms_info";s:45:"Processing time is set by ILIAS, not by SCOs.";s:20:"help_assign_help_ids";s:29:"Chapter/Screen-IDs Assignment";s:24:"cont_custom_menu_entries";s:19:"Custom Menu Entries";s:32:"cont_anonymous_user_missing_perm";s:76:"Anonymous users currently have no permission to access this learning module.";s:27:"glo_term_must_belong_to_glo";s:78:"The action can only be performed on terms, which are defined in this glossary.";s:23:"cont_offline_mode_allow";s:18:"Allow Offline Mode";s:28:"cont_offline_mode_allow_info";s:181:"In offline mode, learning modules can only be processed with the SCORM offline player. The tracking data are transferred if the learner clicks on ‘finish offline mode’ in ILIAS.";s:39:"cont_profile_mode_template_inherit_info";s:24:"Use the profile settings";s:28:"content_plugin_not_activated";s:59:"The page content element plugin is currently not activated.";s:24:"cont_verification_placeh";s:36:"Click and edit to insert certificate";s:25:"cont_verification_placehl";s:23:"Certificate Placeholder";s:25:"cont_ed_plachverification";s:23:"Placeholder Certificate";s:15:"cont_glossaries";s:10:"Glossaries";s:20:"cont_auto_glossaries";s:22:"Auto-Linked Glossaries";s:19:"cont_link_glo_in_lm";s:63:"Should all glossary terms be linked in the learning module now?";s:25:"cont_hide_head_foot_print";s:43:"Hide custom header and footer in print view";s:23:"glo_add_term_properties";s:44:"Activate Additional Glossary Term Properties";s:33:"cont_ed_insert_consultation_hours";s:25:"Insert Consultation Hours";s:30:"cont_insert_consultation_hours";s:25:"Insert Consultation Hours";s:30:"cont_update_consultation_hours";s:23:"Edit Consultation Hours";s:14:"cont_cach_mode";s:4:"Mode";s:24:"cont_cach_mode_automatic";s:9:"Automatic";s:29:"cont_cach_mode_automatic_info";s:46:"All your consultation hours will be published.";s:21:"cont_cach_mode_manual";s:6:"Manual";s:26:"cont_cach_mode_manual_info";s:70:"Only the consultation hours of the following groups will be published.";s:24:"cont_activate_multi_lang";s:24:"Activate Multilinguality";s:17:"cont_current_lang";s:16:"Current Language";s:26:"cont_edit_language_version";s:12:"Edit Version";s:36:"cont_page_translation_does_not_exist";s:143:"The translation page does not exist yet and will be created by copying the content of the current master page. Language of the translation page";s:13:"content_until";s:22:"At least locked until:";s:20:"content_no_edit_lock";s:45:"The page is currently locked by another user.";s:25:"cont_disable_def_feedback";s:33:"Disable Default Question Feedback";s:30:"cont_disable_def_feedback_info";s:132:"If disabled, answered questions will not show any feedback for the learner. You need to provide custom feedbacks for your questions.";s:36:"cont_multilang_currently_deactivated";s:51:"Multilinguality support is currently not activated.";s:8:"save_new";s:12:"Save and New";s:24:"cont_sc_auto_review_2004";s:21:"Automatic Review Mode";s:29:"cont_sc_auto_review_info_2004";s:302:"If the automatic review mode is enabled, then the tracking data for a chapter (SCO) of the learning module are not stored when one of these options apply. In the rare case however, that the learning module makes use of Sequencing & Navigation according to SCORM 2004, this option should not be enabled.";s:22:"cont_sc_auto_review_no";s:8:"disabled";s:50:"cont_sc_auto_review_completed_not_failed_or_passed";s:78:"if completed or passed, but not failed (recommended for Automatic Review Mode)";s:26:"cont_sc_auto_review_passed";s:9:"if passed";s:36:"cont_sc_auto_review_passed_or_failed";s:19:"if passed or failed";s:29:"cont_sc_auto_review_completed";s:12:"if completed";s:40:"cont_sc_auto_review_completed_and_passed";s:23:"if completed and passed";s:39:"cont_sc_auto_review_completed_or_passed";s:22:"if completed or passed";s:17:"cont_auto_suspend";s:51:"Ensure getting tracking data from previous attempts";s:22:"cont_auto_suspend_info";s:131:"This option is for SCORM learning modules, which support SCORM 2004 in an inadequate way by not sending proper values for cmi.exit.";s:17:"glo_hide_taxonomy";s:13:"Hide Taxonomy";s:17:"cont_col_ordering";s:15:"Column Ordering";s:18:"lm_activate_rating";s:25:"Activate Rating For Pages";s:9:"lm_rating";s:20:"Rate Learning Module";s:12:"lm_rate_page";s:9:"Rate page";s:14:"cont_wiki_page";s:9:"Wiki Page";s:16:"cont_choose_wiki";s:11:"Choose Wiki";s:21:"cont_manage_multilang";s:22:"Manage Multilinguality";s:14:"cont_languages";s:9:"Languages";s:13:"cont_language";s:8:"Language";s:13:"cont_add_lang";s:12:"Add Language";s:21:"cont_conf_delete_lang";s:63:"Do you really want to drop support for the following languages?";s:17:"cont_back_to_page";s:12:"Back to Page";s:13:"cont_got_lock";s:105:"This page has been locked for your editing. Please release the page after you have done all your changes.";s:19:"cont_finish_editing";s:14:"Finish Editing";s:23:"cont_page_lock_released";s:46:"Editing finished. Page lock has been released.";s:19:"cont_fourth_edition";s:22:"SCORM 2004 4th edition";s:24:"cont_fourth_edition_info";s:216:"SCORM 2004 4th edition offers some advantages compared to the 3rd edition. Further data over SCO boundaries can be exchanged for example. These options are however rarely used and have a negative effect on the speed.";s:20:"offline_mode_manager";s:11:"Offline use";s:18:"offline_mode_users";s:21:"Users in offline mode";s:42:"cont_offline_mode_disable_not_allowed_info";s:98:"Since the learning module is currently used in offline mode, the offline mode can not be disabled.";s:22:"stop_user_offline_mode";s:17:"Stop offline mode";s:31:"stop_user_offline_mode_for_user";s:21:"Stop offline mode for";s:27:"info_stop_offline_mode_sure";s:76:"Note: The learning progress achieved in offline mode are lost. Are you sure?";s:21:"cont_edit_definitions";s:16:"Edit Definitions";s:20:"cont_edit_definition";s:15:"Edit Definition";s:25:"cont_ed_insert_my_courses";s:17:"Insert My Courses";s:22:"cont_insert_my_courses";s:17:"Insert My Courses";s:22:"cont_update_my_courses";s:15:"Edit My Courses";s:27:"cont_my_courses_no_settings";s:26:"There are no settings yet.";s:15:"glo_online_info";s:67:"Only if the glossary is online, users are able to use the glossary.";s:19:"glo_mode_level_info";s:77:"All terms of glossaries on the same level in the repository will be included.";s:20:"glo_mode_normal_info";s:57:"Only terms created within this glossary will be included.";s:21:"glo_mode_subtree_info";s:99:"All terms of glossaries on the same level and subsequent levels in the repository will be included.";s:20:"glo_content_settings";s:7:"Content";s:22:"glo_show_taxonomy_info";s:113:"The taxonomy will be visible in the presentation view of the glossary and can be used to select referenced terms.";s:24:"cont_def_feedb_activated";s:79:"Default feedback texts are currently activated in the learning module settings.";s:26:"cont_def_feedb_deactivated";s:81:"Default feedback texts are currently deactivated in the learning module settings.";s:29:"cont_help_no_valid_tooltip_id";s:46:"The tooltip ID you have entered was not valid.";s:28:"cont_ed_insert_amd_page_list";s:16:"Insert Page List";s:25:"cont_insert_amd_page_list";s:16:"Insert Page List";s:25:"cont_update_amd_page_list";s:14:"Edit Page List";s:20:"cont_ed_insert_templ";s:23:"Insert Content Template";s:13:"cont_template";s:8:"Template";s:19:"cont_progress_icons";s:14:"Progress Icons";s:24:"cont_progress_icons_info";s:151:"Show progress icons instead of chapter page icons in presentation mode. Please note that progress information is stored only with ILIAS 5.0 and higher.";s:20:"cont_self_assessment";s:15:"Self Assessment";s:10:"cont_tries";s:18:"Question Behaviour";s:25:"cont_tries_reset_on_visit";s:19:"Reset on Page Visit";s:30:"cont_tries_reset_on_visit_info";s:126:"Questions start with 0 number of tries each time a learner visits a page. Learner has to answer questions on every page visit.";s:16:"cont_tries_store";s:19:"Store Answer Status";s:21:"cont_tries_store_info";s:145:"Number of tries are accumulated and stored. Correctly answered questions must not be answered again. Learners may run out of tries for questions.";s:22:"cont_restrict_forw_nav";s:27:"Restrict Forward Navigation";s:27:"cont_restrict_forw_nav_info";s:99:"Learners cannot navigate to subsequent pages unless they answered all previous questions correctly.";s:28:"cont_no_page_access_unansw_q";s:89:"You need to answer all questions of previous pages correctly to gain access to this page.";s:19:"cont_question_stats";s:9:"Statistic";s:18:"cont_blocked_users";s:13:"Blocked Users";s:13:"cont_last_try";s:8:"Last Try";s:13:"cont_unlocked";s:8:"Unlocked";s:22:"cont_reset_nr_of_tries";s:21:"Reset Number of Tries";s:26:"cont_unlock_allow_continue";s:26:"Unlock / Allow to Continue";s:22:"cont_start_file_set_to";s:30:"%s has been set as start file.";s:28:"cont_blocked_users_mail_link";s:56:"Click on the following link to open the learning module:";s:25:"cont_out_of_focus_message";s:68:"This page is not related to your current learning objective anymore.";s:29:"cont_show_content_after_focus";s:33:"Continue with the Learning Module";s:23:"cont_to_focus_beginning";s:49:"Back to Content related to the Learning Objective";s:24:"cont_to_focus_return_crs";s:14:"Back to Course";s:35:"cont_out_of_focus_message_last_page";s:80:"This is the last page of the content related to your current learning objective.";s:21:"cont_ie_compatibility";s:38:"Internet Explorer 7 compatibility mode";s:26:"cont_ie_compatibility_info";s:187:"Especially for older learning modules it can be helpful to activate the compatibility mode. Please note that the compatibility mode can be disabled in newer versions of Internet Explorer.";s:20:"cont_ie_force_render";s:39:"Force Internet Explorer to render again";s:25:"cont_ie_force_render_info";s:216:"Enable this option only if content of the learning module is not displayed correctly with Internet Explorer due to many frames or iFrames. Additionally you have to set the option ‘Display’ to ‘in new window’.";s:23:"cont_ed_click_to_add_pg";s:26:"Click here to add content.";s:22:"cont_table_border_info";s:93:"Keep this empty to make content style settings effective. Values must include unit (like px).";s:27:"cont_table_cellpadding_info";s:93:"Keep this empty to make content style settings effective. Values must include unit (like px).";s:28:"cont_notify_on_blocked_users";s:30:"Notifications on Blocked Users";s:33:"cont_notify_on_blocked_users_info";s:69:"You will be notified if users are blocked when they run out of tries.";s:17:"cont_user_blocked";s:42:"User out of tries in learning module "%s".";s:18:"cont_user_blocked2";s:177:"A user has run out of tries for answering a question in the learning module. The user will not be able to navigate further through the learning module without your intervention.";s:18:"cont_user_blocked3";s:59:"Open the learning module in edit mode and enter the screen:";s:27:"cont_lm_mail_permanent_link";s:58:"Click on the following link to access the learning module:";s:13:"cont_download";s:8:"Download";s:20:"cont_tracking_modify";s:11:"Modify Data";s:13:"cont_pc_amdpl";s:9:"Page List";s:34:"cont_automatically_set_store_tries";s:83:"Option "$1" has been activated automatically, because option "$2" has been enabled.";s:12:"cont_license";s:7:"License";s:17:"cont_license_info";s:27:"Enables the license feature";s:11:"cont_biblio";s:20:"Bibliographical Data";s:16:"cont_biblio_info";s:40:"Enables the bibliographical data feature";s:16:"cont_qtries_info";s:62:"Default value for number of tries for newly created questions.";s:13:"cont_settings";s:29:"Settings for learning modules";s:21:"cont_wiki_link_dialog";s:26:"Link to Wiki Page (Dialog)";s:20:"lm_no_download_files";s:52:"There are currently no files for download available.";s:9:"cont_sqst";s:35:"Survey Question (Assigned Material)";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'crs'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:735:{s:26:"activation_times_not_valid";s:37:"The availability period is not valid.";s:9:"add_event";s:11:"Add Session";s:8:"assigned";s:8:"Assigned";s:23:"contact_email_not_valid";s:32:"the contact e-mail is not valid.";s:26:"crs_accept_subscriber_body";s:64:"we are pleased to confirm your registration for the course "%s".";s:21:"crs_accept_subscriber";s:31:"Registration confirmed for "%s"";s:19:"crs_access_password";s:8:"Password";s:10:"crs_access";s:6:"Access";s:14:"crs_activation";s:10:"Activation";s:20:"crs_add_archive_html";s:21:"Create a HTML Archive";s:19:"crs_add_archive_xml";s:20:"Create a XML Archive";s:16:"crs_add_grouping";s:25:"Add Membership Limitation";s:22:"crs_add_grp_assignment";s:16:"Assign course(s)";s:20:"crs_add_html_archive";s:16:"Add HTML archive";s:14:"crs_add_member";s:13:"Add Member(s)";s:17:"crs_add_objective";s:13:"Add Objective";s:32:"crs_add_remove_from_desktop_info";s:62:"Allow the members to add course items to the personal desktop.";s:27:"crs_add_remove_from_desktop";s:14:"Add to Desktop";s:15:"crs_add_starter";s:16:"Add Start Object";s:19:"crs_add_subscribers";s:14:"Add subscriber";s:21:"crs_added_member_body";s:65:"we are pleased to announce your registration for the course "%s".";s:16:"crs_added_member";s:33:"Your registration for course "%s"";s:21:"crs_added_new_archive";s:28:"A new archive has been added";s:19:"crs_added_objective";s:42:"A new learning objective has been created.";s:18:"crs_added_starters";s:25:"Assigned start object(s).";s:17:"crs_added_to_list";s:96:"You have been assigned to the waiting list. You are assigned to position %s on the waiting list.";s:9:"crs_added";s:16:"Added new course";s:19:"crs_admin_no_notify";s:31:"Administrator (no notification)";s:16:"crs_admin_notify";s:28:"Administrator (notification)";s:9:"crs_admin";s:13:"Administrator";s:18:"crs_administrators";s:14:"Administrators";s:9:"crs_agree";s:10:"Acceptance";s:20:"crs_agreement_header";s:14:"User Agreement";s:22:"crs_agreement_required";s:78:"You have to accept the user agreement, if you want to register to this course.";s:13:"crs_allow_abo";s:34:"Allow subscription of course items";s:28:"crs_already_assigned_to_list";s:45:"You are already assigned to the waiting list.";s:20:"crs_archive_disabled";s:11:"Deactivated";s:20:"crs_archive_download";s:37:"Allow the Download of Course Archives";s:16:"crs_archive_info";s:121:"If enabled, all course content will we suppressed. Only HTML archives of this course will be available to course members.";s:16:"crs_archive_lang";s:8:"Language";s:30:"crs_archive_language_selection";s:18:"Language Selection";s:16:"crs_archive_read";s:11:"Read access";s:23:"crs_archive_select_type";s:12:"Archive view";s:25:"crs_archive_type_disabled";s:13:"Not available";s:16:"crs_archive_type";s:12:"Archive type";s:11:"crs_archive";s:8:"Archives";s:20:"crs_archives_deleted";s:32:"The archive(s) have been deleted";s:13:"crs_auto_fill";s:9:"Auto Fill";s:31:"crs_availability_limitless_info";s:71:"Choose this mode to give course members unlimited access to the course.";s:27:"crs_availability_until_info";s:88:"Choose this mode to give course members access to the course for a fixed period of time.";s:23:"crs_blocked_member_body";s:49:"your membership for course "%s" has been blocked.";s:18:"crs_blocked_member";s:33:"Membership blocked in course "%s"";s:11:"crs_blocked";s:14:"Access Refused";s:25:"crs_cancel_subscr_request";s:25:"Delete Membership Request";s:28:"crs_cancel_subscription_body";s:56:"%s has cancelled his/her membership for the course "%s".";s:29:"crs_cancel_subscription_body2";s:155:"There might be other members on a waiting list of your course.\\nYou should check for the waiting list now.\\nTo view the members of your course, click here:";s:23:"crs_cancel_subscription";s:21:"User left course "%s"";s:17:"crs_change_status";s:28:"Changes status of objective:";s:28:"crs_chapter_already_assigned";s:36:"These chapters are already assigned.";s:24:"crs_contact_consultation";s:12:"Consultation";s:22:"crs_contact_email_info";s:53:"Enter one or more (comma separated) e-mail addresses.";s:17:"crs_contact_email";s:6:"E-Mail";s:16:"crs_contact_name";s:4:"Name";s:17:"crs_contact_phone";s:9:"Telephone";s:26:"crs_contact_responsibility";s:14:"Responsibility";s:11:"crs_contact";s:7:"Contact";s:11:"crs_content";s:14:"Course Content";s:24:"crs_copy_cat_not_allowed";s:37:"It is not possible to copy categories";s:17:"crs_count_members";s:17:"Number of members";s:19:"crs_count_questions";s:19:"Number of questions";s:15:"crs_create_date";s:11:"Create date";s:17:"crs_crs_structure";s:16:"Course structure";s:9:"crs_dates";s:5:"Dates";s:20:"crs_deassign_lm_sure";s:48:"Are you sure you want to delete this assignment?";s:15:"crs_delete_file";s:12:"Delete File?";s:25:"crs_delete_from_list_sure";s:69:"Are you sure, you want to deassign the following users from the list?";s:28:"crs_delete_from_waiting_list";s:24:"Remove from waiting list";s:17:"crs_delete_member";s:8:"Deassign";s:23:"crs_delete_members_sure";s:60:"Do you want to delete the following members from this course";s:24:"crs_delete_objectve_sure";s:57:"Are you sure, you want to delete the selected objectives?";s:27:"crs_delete_subscribers_sure";s:41:"Do you want to delete the following users";s:22:"crs_delete_subscribers";s:17:"Delete subscriber";s:11:"crs_details";s:14:"Course Details";s:23:"crs_dismiss_member_body";s:51:"your membership has been terminated in course "%s".";s:18:"crs_dismiss_member";s:29:"Membership terminated in "%s"";s:16:"crs_edit_archive";s:13:"Edit Archives";s:16:"crs_edit_content";s:10:"Edit items";s:22:"crs_edit_start_objects";s:18:"Edit Start Objects";s:16:"crs_edit_timings";s:12:"Edit Timings";s:14:"crs_enable_map";s:17:"Enable Course Map";s:7:"crs_end";s:3:"End";s:18:"crs_existing_files";s:15:"Existing Files:";s:10:"crs_export";s:13:"Course export";s:17:"crs_file_download";s:18:"Files for Download";s:13:"crs_file_name";s:9:"File Name";s:18:"crs_file_size_info";s:8:"Filesize";s:8:"crs_file";s:4:"File";s:12:"crs_filename";s:9:"File Name";s:15:"crs_free_places";s:16:"Available Places";s:8:"crs_from";s:4:"From";s:20:"crs_further_settings";s:16:"Further Settings";s:16:"crs_general_info";s:19:"General Information";s:24:"crs_general_informations";s:19:"General Information";s:19:"crs_grouping_assign";s:17:"Change assignment";s:24:"crs_grouping_delete_sure";s:66:"Do you really want to delete the following membership limitations?";s:20:"crs_grouping_deleted";s:24:"Deleted course grouping.";s:32:"crs_grouping_modified_assignment";s:19:"Changed assignment.";s:23:"crs_grouping_select_one";s:32:"Please select a course grouping.";s:12:"crs_grouping";s:15:"Course grouping";s:24:"crs_groupings_ask_delete";s:22:"Delete course grouping";s:13:"crs_groupings";s:16:"Course groupings";s:22:"crs_grp_added_grouping";s:32:"Added new membership limitation.";s:24:"crs_grp_already_assigned";s:47:"You are already member of this course grouping.";s:18:"crs_grp_assign_crs";s:13:"Assign course";s:29:"crs_grp_assigned_courses_info";s:17:"Assigned courses:";s:24:"crs_grp_assigned_courses";s:17:"Assigned courses.";s:32:"crs_grp_courses_already_assigned";s:43:"The selected courses were already assigned.";s:22:"crs_grp_crs_assignment";s:17:"Course assignment";s:26:"crs_grp_deassigned_courses";s:17:"Delete assignment";s:19:"crs_grp_enter_title";s:21:"Please enter a title.";s:16:"crs_grp_info_reg";s:45:"You can only register to one of this courses:";s:30:"crs_grp_matriculation_required";s:134:"This course grouping requires an unique matriculation number. <br />Please insert this value in your settings on the personal desktop.";s:25:"crs_grp_modified_grouping";s:20:"Saved modifications.";s:26:"crs_grp_no_course_selected";s:25:"Please select one course.";s:27:"crs_grp_no_courses_assigned";s:20:"No assigned courses.";s:30:"crs_grp_table_assigned_courses";s:16:"Assigned courses";s:19:"crs_header_archives";s:15:"Course Archives";s:25:"crs_header_delete_members";s:64:"Would you like to remove the following members from this course?";s:29:"crs_header_delete_subscribers";s:18:"Delete subscribers";s:23:"crs_header_edit_members";s:12:"Edit Members";s:18:"crs_header_members";s:14:"Course members";s:35:"crs_header_remove_from_waiting_list";s:28:"Waiting list: deassign users";s:17:"crs_hide_link_lms";s:14:"Hide materials";s:24:"crs_hide_link_objectives";s:15:"Hide objectives";s:16:"crs_hide_link_or";s:20:"Hide other resources";s:21:"crs_hide_link_session";s:13:"Hide sessions";s:17:"crs_hide_link_tst";s:10:"Hide tests";s:8:"crs_html";s:4:"HTML";s:18:"crs_important_info";s:21:"Important Information";s:14:"crs_info_agree";s:74:"I accept, that the above data types are visible for course administrators.";s:18:"crs_info_agreement";s:63:"The following data types are visible for course administrators:";s:17:"crs_info_download";s:18:"Files for Download";s:25:"crs_info_reg_confirmation";s:216:"You have to request for membership to access this course. Please describe your interest for becoming member in the message form. You will be notified as soon as an administrator has accepted or declined your request.";s:24:"crs_info_reg_deactivated";s:28:"Course admittance is closed.";s:19:"crs_info_reg_direct";s:34:"You can join this course directly.";s:21:"crs_info_reg_password";s:86:"If a course administrator has given you the course password, you can join this course.";s:12:"crs_info_reg";s:10:"Admittance";s:17:"crs_info_settings";s:18:"Course Information";s:14:"crs_info_start";s:142:"Please work through all of the course items stated below.<br />After you have processed all marked objects new course items will be activated.";s:26:"crs_item_availability_info";s:174:"Choose this option for making the item available for a fixed period of time. If ‘Visibility’ is checked, the item will remain visible but not accessible for the learners.";s:24:"crs_item_presetting_info";s:65:"Choose this option to offer the learners suggested editing times.";s:16:"crs_join_request";s:4:"Send";s:22:"crs_learning_materials";s:9:"Materials";s:16:"crs_lim_assigned";s:43:"Already assigned to associated course "%s".";s:14:"crs_list_users";s:10:"List users";s:25:"crs_lm_assignment_deleted";s:19:"Deleted assignment.";s:17:"crs_lm_assignment";s:28:"Learning material assignment";s:15:"crs_lm_deassign";s:18:"Delete assignment.";s:30:"crs_lm_no_assignments_selected";s:29:"Please select one assignment.";s:24:"crs_lms_already_assigned";s:47:"These learning materials were already assigned.";s:23:"crs_mail_permanent_link";s:89:"Click on the following link to find all of the information you need regarding the course:";s:16:"crs_map_location";s:19:"Course Map Location";s:16:"crs_map_settings";s:12:"Map Settings";s:13:"crs_materials";s:9:"Materials";s:23:"crs_max_members_reached";s:46:"The maximum number of members has been reached";s:21:"crs_mem_change_status";s:13:"Change status";s:17:"crs_mem_send_mail";s:9:"Send Mail";s:25:"crs_member_administration";s:17:"Edit Participants";s:18:"crs_member_blocked";s:16:"Member (blocked)";s:13:"crs_member_of";s:17:"Member of course:";s:20:"crs_member_unblocked";s:18:"Member (unblocked)";s:18:"crs_member_updated";s:27:"The member has been updated";s:10:"crs_member";s:6:"Member";s:19:"crs_members_deleted";s:15:"Deleted members";s:25:"crs_members_footer_passed";s:6:"passed";s:18:"crs_members_footer";s:16:"course member(s)";s:15:"crs_members_map";s:18:"Course Members Map";s:23:"crs_members_print_title";s:14:"Course members";s:17:"crs_members_table";s:19:"Course Participants";s:17:"crs_members_title";s:14:"Course members";s:11:"crs_members";s:7:"Members";s:17:"crs_min_one_admin";s:67:"There has to be at least one administrator assigned to this course.";s:13:"crs_move_down";s:9:"Move down";s:11:"crs_move_up";s:7:"Move up";s:14:"crs_moved_item";s:17:"Moved course item";s:19:"crs_moved_objective";s:25:"Moved learning objective.";s:14:"crs_new_search";s:10:"New search";s:14:"crs_new_status";s:19:"Your new status is:";s:25:"crs_new_subscription_body";s:34:"%s has registered for course "%s".";s:33:"crs_new_subscription_request_body";s:44:"%s has requested membership for course "%s".";s:34:"crs_new_subscription_request_body2";s:36:"To confirm this registration, go to:";s:28:"crs_new_subscription_request";s:27:"Request to join course "%s"";s:20:"crs_new_subscription";s:31:"User registered for course "%s"";s:8:"crs_news";s:11:"Course News";s:23:"crs_no_archive_selected";s:20:"No archives selected";s:25:"crs_no_archives_available";s:31:"There are no archives available";s:24:"crs_no_archives_selected";s:24:"Please select an archive";s:23:"crs_no_chapter_selected";s:24:"Please select a chapter.";s:16:"crs_no_exercises";s:37:"No exercises found inside this course";s:25:"crs_no_groupings_assigned";s:37:"No groupings assigned to this course.";s:22:"crs_no_groups_selected";s:21:"Please select a group";s:18:"crs_no_items_found";s:8:"No items";s:15:"crs_no_language";s:11:"No language";s:18:"crs_no_lm_selected";s:36:"Please select one learning material.";s:19:"crs_no_lms_assigned";s:41:"There are no learning materials assigned.";s:24:"crs_no_lms_inside_course";s:47:"No learning materials found inside this course.";s:21:"crs_no_lms_inside_crs";s:91:"No learning materials inside this course, which can be assigned to this learning objective.";s:22:"crs_no_member_selected";s:24:"Please select one member";s:23:"crs_no_members_assigned";s:44:"There are no members assigned to this course";s:13:"crs_no_notify";s:31:"No notify for new registrations";s:26:"crs_no_objective_lms_found";s:96:"This course does not contain learning material that could be assigned to the learning objective.";s:25:"crs_no_objective_selected";s:28:"Please select one objective.";s:25:"crs_no_objectives_created";s:33:"There are no objectives assigned.";s:24:"crs_no_question_selected";s:27:"Please select one question.";s:25:"crs_no_questions_assigned";s:32:"There are no questions assigned.";s:20:"crs_no_results_found";s:16:"No results found";s:21:"crs_no_roles_selected";s:20:"Please select a role";s:22:"crs_no_starter_created";s:41:"No start objects assigned to this course.";s:27:"crs_no_subscribers_selected";s:20:"Please select a user";s:23:"crs_no_tests_inside_crs";s:78:"No tests inside this course, which can be assigned to this learning objective.";s:18:"crs_no_title_given";s:40:"Please insert a title for the objective.";s:18:"crs_no_users_added";s:16:"No members added";s:21:"crs_no_users_selected";s:25:"You did not select a user";s:28:"crs_no_valid_member_id_given";s:18:"No valid member Id";s:17:"crs_not_available";s:15:"-Not available-";s:34:"crs_notification_explanation_admin";s:99:"You receive mail from ILIAS because you are course administrator / tutor with notification enabled.";s:16:"crs_notification";s:12:"Notification";s:10:"crs_notify";s:28:"Notify for new registrations";s:6:"crs_nr";s:3:"Nr.";s:22:"crs_number_users_added";s:62:"The following number of users has been assigned to the course:";s:22:"crs_obj_final_req_info";s:71:"If this number of points is achieved, the learning objective is passed.";s:24:"crs_obj_initial_req_info";s:98:"If this number of points is achieved, no course materials will be recommended for further editing.";s:23:"crs_obj_required_points";s:15:"Required Points";s:26:"crs_objective_accomplished";s:12:"Accomplished";s:21:"crs_objective_add_mat";s:16:"Assign Materials";s:21:"crs_objective_add_qst";s:16:"Assign Questions";s:24:"crs_objective_all_points";s:12:"Total Points";s:28:"crs_objective_assign_chapter";s:15:"Assign chapters";s:23:"crs_objective_assign_lm";s:16:"Save Assignments";s:29:"crs_objective_assign_question";s:15:"Assign question";s:32:"crs_objective_assigned_materials";s:27:"Assigned Learning Materials";s:26:"crs_objective_assigned_qst";s:18:"Assigned Questions";s:31:"crs_objective_deassign_question";s:17:"Delete assignment";s:34:"crs_objective_delete_lm_assignment";s:17:"Delete assignment";s:23:"crs_objective_err_limit";s:51:"Please enter a percentage number between 1 and 100.";s:24:"crs_objective_final_test";s:26:"Questions Achievement Test";s:28:"crs_objective_insert_percent";s:48:"Please enter only percentages between 1 and 100.";s:23:"crs_objective_limit_err";s:63:"The required points should not be higher than the total points.";s:22:"crs_objective_modified";s:27:"Updated learning objective.";s:28:"crs_objective_no_title_given";s:21:"Please enter a title.";s:30:"crs_objective_not_accomplished";s:16:"Not accomplished";s:33:"crs_objective_overview_objectives";s:8:"Overview";s:42:"crs_objective_overview_question_assignment";s:28:"Overview Question Assignment";s:20:"crs_objective_points";s:8:"Point(s)";s:21:"crs_objective_pretest";s:18:"After initial test";s:25:"crs_objective_qst_summary";s:28:"Overview Question Assignment";s:33:"crs_objective_question_assignment";s:19:"Question assignment";s:25:"crs_objective_random_warn";s:69:"You can not use random tests in combination with learning objectives.";s:20:"crs_objective_result";s:16:"After final test";s:27:"crs_objective_saved_sorting";s:14:"Saved sorting.";s:29:"crs_objective_self_assessment";s:24:"Questions Placement Test";s:20:"crs_objective_status";s:16:"Objective Status";s:18:"crs_objective_step";s:4:"Step";s:26:"crs_objective_updated_test";s:22:"Updated modifications.";s:28:"crs_objective_wiz_final_info";s:35:"Assignment of final test questions.";s:34:"crs_objective_wiz_final_limit_info";s:60:"Here you can define the limits for the final test questions.";s:29:"crs_objective_wiz_final_limit";s:21:"Limits for Final Test";s:23:"crs_objective_wiz_final";s:20:"Final Test Questions";s:32:"crs_objective_wiz_materials_info";s:91:"You can assign course materials that are recommended for processing the learning objective.";s:27:"crs_objective_wiz_materials";s:22:"Assign Course Material";s:27:"crs_objective_wiz_self_info";s:130:"Please define the initial test questions. Initial tests are intended to examine the previous knowledge of the course participants.";s:33:"crs_objective_wiz_self_limit_info";s:52:"Please define the limits for initial test questions.";s:28:"crs_objective_wiz_self_limit";s:23:"Limits for Initial Test";s:22:"crs_objective_wiz_self";s:22:"Initial Test Questions";s:28:"crs_objective_wiz_title_info";s:72:"Please choose a title and a short description of the learning objective.";s:23:"crs_objective_wiz_title";s:27:"Describe Learning Objective";s:29:"crs_objectives_assign_chapter";s:14:"Assign Chapter";s:26:"crs_objectives_assigned_lm";s:42:"The selected materials have been assigned.";s:27:"crs_objectives_assigned_lms";s:27:"Assigned learning materials";s:37:"crs_objectives_assigned_new_questions";s:21:"Added new assignment.";s:33:"crs_objectives_assigned_questions";s:18:"Assigned questions";s:33:"crs_objectives_chapter_assignment";s:18:"Chapter assignment";s:37:"crs_objectives_deassign_question_sure";s:57:"Are you sure, you want to delete the following questions?";s:22:"crs_objectives_deleted";s:26:"Delete learning objectives";s:40:"crs_objectives_edit_question_assignments";s:24:"Edit Question Assignment";s:25:"crs_objectives_info_final";s:244:"You did not accomplish all course objectives in the previous exam. <br />Please select the not completed objectives one after another and review the related materials. <br />After you have reviewed these objectives, you can take the exam again.";s:28:"crs_objectives_info_finished";s:69:"Congratulations, you have accomplished all objectives of this course!";s:24:"crs_objectives_info_none";s:142:"The following is a list of the course objectives.<br /> Please select the objectives one after another and work through the related materials.";s:39:"crs_objectives_info_pretest_non_suggest";s:220:"The following are the results of your self assessment. <br />According to this you have fulfilled any learning objective. You can now take the final exam of this course, which is located in the test section of this page.";s:27:"crs_objectives_info_pretest";s:306:"The following are the results of your self assessment. <br />Please select the not completed objectives one after another and work through their related material. <br />After you have processed these objectives, you can take the final exam of this course, which is located in the test section of this page.";s:28:"crs_objectives_lm_assignment";s:30:"Assignment of Course Materials";s:25:"crs_objectives_max_points";s:14:"Maximum points";s:35:"crs_objectives_no_question_selected";s:27:"Please select one question.";s:27:"crs_objectives_nr_questions";s:19:"Number of questions";s:29:"crs_objectives_qst_deassigned";s:41:"The question assignment has been deleted.";s:25:"crs_objectives_reset_sure";s:86:"You want to delete all results of this course. <br />All test results will be deleted.";s:22:"crs_objectives_reseted";s:16:"Reseted results.";s:14:"crs_objectives";s:19:"Learning Objectives";s:11:"crs_offline";s:7:"Offline";s:11:"crs_options";s:7:"Options";s:19:"crs_other_groupings";s:26:"Groupings of other courses";s:19:"crs_other_resources";s:15:"Other Resources";s:10:"crs_passed";s:6:"Passed";s:22:"crs_password_not_valid";s:26:"Your password is not valid";s:21:"crs_password_required";s:48:"This registration procedure requires a password.";s:7:"crs_pdf";s:3:"PDF";s:27:"crs_persons_on_waiting_list";s:27:"Persons on the Waiting List";s:21:"crs_presentation_type";s:17:"Presentation Type";s:14:"crs_print_list";s:13:"Generate List";s:23:"crs_question_assignment";s:19:"Question assignment";s:19:"crs_reg_deactivated";s:8:"Disabled";s:16:"crs_reg_lim_info";s:135:"If enabled, registrations are only possible during a fixed period of time. Please choose also one of the registration procedures below.";s:16:"crs_reg_max_info";s:71:"Define the maximum number of users that can be assigned to this course.";s:19:"crs_reg_notify_info";s:118:"If enabled all course administrators/tutors with status ‘Notify’ will be informed by mail about new registrations.";s:14:"crs_reg_period";s:17:"Self-Registration";s:15:"crs_reg_subject";s:7:"Message";s:32:"crs_reg_subscription_deactivated";s:24:"Registration is disabled";s:32:"crs_reg_subscription_end_earlier";s:32:"The registration time is expired";s:40:"crs_reg_subscription_max_members_reached";s:40:"The maximum number of users is exceeded.";s:32:"crs_reg_subscription_start_later";s:34:"The registration time starts later";s:17:"crs_reg_type_info";s:73:"This setting is only relevant, if the registration is not ‘Disabled’.";s:18:"crs_reg_unlim_info";s:114:"If enabled, there is no time limit for registrations. Please choose also one of the registration procedures below.";s:13:"crs_reg_until";s:19:"Registration Period";s:29:"crs_reg_user_already_assigned";s:39:"You are already assigned to this course";s:31:"crs_reg_user_already_subscribed";s:53:"You have already requested membership for this course";s:20:"crs_reg_user_blocked";s:32:"You are blocked from this course";s:7:"crs_reg";s:21:"Registration Settings";s:28:"crs_registration_deactivated";s:55:"Only course administrators can add users to the course.";s:24:"crs_registration_limited";s:27:"Limited Registration Period";s:21:"crs_registration_type";s:22:"Registration Procedure";s:26:"crs_registration_unlimited";s:29:"Unlimited Registration Period";s:16:"crs_registration";s:19:"Course Registration";s:26:"crs_reject_subscriber_body";s:77:"we regret to say that your registration has been refused for the course "%s".";s:21:"crs_reject_subscriber";s:29:"Registration refused for "%s"";s:17:"crs_reset_results";s:13:"Reset Results";s:15:"crs_role_status";s:13:"Role / Status";s:8:"crs_role";s:4:"Role";s:30:"crs_search_enter_search_string";s:28:"Please enter a search string";s:14:"crs_search_for";s:10:"Search for";s:18:"crs_search_members";s:11:"User search";s:14:"crs_search_str";s:11:"Search Term";s:16:"crs_search_users";s:12:"Search Users";s:27:"crs_select_archive_language";s:40:"Please select a language for the archive";s:25:"crs_select_exactly_one_lm";s:42:"Please select exactly one learning module.";s:26:"crs_select_exactly_one_tst";s:31:"Please select exactly one test.";s:20:"crs_select_native_lm";s:70:"Single chapters can only be assigned to native ILIAS learning modules.";s:22:"crs_select_one_archive";s:25:"Please select one archive";s:21:"crs_select_one_object";s:30:"Please select one course item.";s:28:"crs_select_registration_type";s:38:"Please select an admittance procedure.";s:18:"crs_select_starter";s:19:"Select Start Object";s:18:"crs_selected_users";s:21:"Selected Participants";s:23:"crs_set_on_waiting_list";s:154:"You can add your join request to the waiting list. You will receive a message from a course administrator when your request has been approved or rejected.";s:18:"crs_settings_saved";s:14:"Settings saved";s:12:"crs_settings";s:15:"Course Settings";s:17:"crs_show_link_lms";s:23:"Show learning materials";s:24:"crs_show_link_objectives";s:15:"Show objectives";s:16:"crs_show_link_or";s:20:"Show other resources";s:21:"crs_show_link_session";s:13:"Show sessions";s:17:"crs_show_link_tst";s:10:"Show tests";s:21:"crs_show_members_info";s:60:"If activated, course members can access the members gallery.";s:16:"crs_show_members";s:12:"Show Members";s:24:"crs_show_objectives_view";s:14:"Objective view";s:8:"crs_size";s:9:"File size";s:19:"crs_sort_activation";s:18:"Sort by Activation";s:20:"crs_sort_manual_info";s:67:"This mode offers you the possibility to sort course items manually.";s:15:"crs_sort_manual";s:13:"Sort Manually";s:20:"crs_sort_timing_info";s:63:"Sort course items be their activation time or timings settings.";s:19:"crs_sort_title_info";s:61:"Choose this mode to sort course items automatically by title.";s:14:"crs_sort_title";s:28:"Titles in Alphabetical Order";s:17:"crs_sortorder_abo";s:20:"Content Item Sorting";s:13:"crs_sortorder";s:4:"Sort";s:17:"crs_start_objects";s:13:"Start Objects";s:9:"crs_start";s:5:"Start";s:19:"crs_starter_deleted";s:19:"Removed assignment.";s:29:"crs_starters_already_assigned";s:33:"This object was already assigned.";s:23:"crs_status_changed_body";s:44:"your status in course "%s" has been changed.";s:18:"crs_status_changed";s:22:"Changed status in "%s"";s:10:"crs_status";s:6:"Status";s:13:"crs_structure";s:16:"Course structure";s:25:"crs_subscribe_member_body";s:64:"we are pleased to confirm your registration for the course "%s".";s:20:"crs_subscribe_member";s:33:"Your registration for course "%s"";s:21:"crs_subscribe_wl_body";s:211:"you have been assigned to the waiting list of course "%s".\\nYou are assigned to position %s on the list.\\n\\nYou will receive a message from a course administrator when your request has been approved or rejected.";s:16:"crs_subscribe_wl";s:33:"Your registration for course "%s"";s:14:"crs_subscriber";s:10:"Subscriber";s:23:"crs_subscribers_deleted";s:21:"Deleted subscriber(s)";s:15:"crs_subscribers";s:13:"Join Requests";s:34:"crs_subscription_max_members_short";s:25:"Limited Number of Members";s:28:"crs_subscription_max_members";s:14:"Maximum Number";s:23:"crs_subscription_notify";s:24:"Notify for subscriptions";s:37:"crs_subscription_options_confirmation";s:18:"Request Membership";s:36:"crs_subscription_options_deactivated";s:11:"Deactivated";s:31:"crs_subscription_options_direct";s:13:"Join Directly";s:33:"crs_subscription_options_password";s:25:"Join with Course Password";s:26:"crs_subscription_requested";s:45:"You have requested membership for the course.";s:27:"crs_subscription_successful";s:26:"You have joined the course";s:21:"crs_subscription_type";s:17:"Subscription type";s:16:"crs_subscription";s:12:"Subscription";s:14:"crs_suggest_lm";s:30:"Suggest learning materials if:";s:22:"crs_suggested_sections";s:18:"Suggested Sections";s:18:"crs_suggestion_end";s:13:"Suggested End";s:33:"crs_sure_delete_selected_archives";s:44:"Are you sure to delete the selected archives";s:12:"crs_syllabus";s:8:"Syllabus";s:23:"crs_table_start_objects";s:13:"Start Objects";s:24:"crs_test_status_complete";s:8:"Complete";s:28:"crs_test_status_not_complete";s:12:"Not complete";s:22:"crs_test_status_random";s:11:"Random test";s:8:"crs_time";s:17:"Subscription time";s:32:"crs_timings_availability_enabled";s:21:"Temporarily Available";s:28:"crs_timings_availability_tbl";s:12:"Availability";s:22:"crs_timings_changeable";s:22:"Time Target Changeable";s:19:"crs_timings_changed";s:16:"Timings Modified";s:25:"crs_timings_disabled_info";s:42:"Choose this option to disable any timings.";s:20:"crs_timings_disabled";s:16:"Timings Disabled";s:20:"crs_timings_duration";s:8:"Duration";s:23:"crs_timings_early_begin";s:14:"Earliest Start";s:15:"crs_timings_end";s:11:"Finish Time";s:22:"crs_timings_from_until";s:12:"(From/Until)";s:19:"crs_timings_in_days";s:9:"(In Days)";s:23:"crs_timings_info_active";s:8:"(Active)";s:20:"crs_timings_late_end";s:10:"Latest End";s:23:"crs_timings_not_changed";s:20:"Timings not Modified";s:23:"crs_timings_planed_info";s:19:"Planed Editing Time";s:24:"crs_timings_planed_start";s:6:"Planed";s:26:"crs_timings_presetting_tbl";s:11:"Time Target";s:22:"crs_timings_presetting";s:19:"Time Target Enabled";s:24:"crs_timings_short_active";s:7:"Enabled";s:28:"crs_timings_short_changeable";s:10:"Changeable";s:33:"crs_timings_short_limit_start_end";s:15:"Latest End Date";s:27:"crs_timings_short_start_end";s:10:"Suggestion";s:26:"crs_timings_start_end_info";s:11:"(Start/End)";s:17:"crs_timings_start";s:10:"Start Time";s:21:"crs_timings_sug_begin";s:15:"Suggested Start";s:19:"crs_timings_sug_end";s:13:"Suggested End";s:26:"crs_timings_suggested_info";s:22:"Suggested Editing Time";s:22:"crs_timings_time_frame";s:10:"Time Frame";s:24:"crs_timings_update_error";s:90:"Your settings are not valid, please verify the timings for the following course materials:";s:28:"crs_timings_visibility_short";s:10:"Visibility";s:22:"crs_timings_visibility";s:74:"If chosen, the material is visible even outside of the given availability.";s:6:"crs_to";s:5:"Until";s:19:"crs_tutor_no_notify";s:23:"Tutor (no notification)";s:16:"crs_tutor_notify";s:20:"Tutor (notification)";s:9:"crs_tutor";s:5:"Tutor";s:10:"crs_tutors";s:6:"Tutors";s:25:"crs_unblocked_member_body";s:49:"your membership in course "%s" has been restored.";s:20:"crs_unblocked_member";s:29:"Access granted in course "%s"";s:13:"crs_unblocked";s:13:"Free entrance";s:13:"crs_unlimited";s:9:"Unlimited";s:27:"crs_unsubscribe_member_body";s:58:"We confirm your cancellation of membership in course "%s".";s:22:"crs_unsubscribe_member";s:46:"Your cancellation of membership in course "%s"";s:20:"crs_unsubscribe_sure";s:54:"Are you sure you want to unsubscribe from this course?";s:25:"crs_unsubscribed_from_crs";s:44:"You have been unsubscribed from this course.";s:20:"crs_update_objective";s:32:"Checklist for Learning Objective";s:25:"crs_update_subscr_request";s:25:"Update Membership Request";s:23:"crs_user_agreement_info";s:47:"Visible Personal Data for Course Administrators";s:18:"crs_user_agreement";s:19:"Released Data Types";s:25:"crs_user_already_assigned";s:51:"The chosen user is already assigned to this course.";s:14:"crs_user_login";s:10:"User Login";s:15:"crs_users_added";s:24:"Added user to the course";s:26:"crs_users_already_assigned";s:43:"The user is already assigned to this course";s:27:"crs_users_removed_from_list";s:58:"The selected users have been removed from the waiting list";s:16:"crs_view_archive";s:12:"Archive View";s:23:"crs_view_info_objective";s:241:"Course for individualised studying: Performance on learning objectives organises the course work. Content might be recommended based on individual performance in a placement test. A final test can be used to prove learning objective mastery.";s:20:"crs_view_info_timing";s:39:"Presentation mode for timings settings.";s:13:"crs_view_mode";s:19:"Course Presentation";s:18:"crs_view_objective";s:33:"Learning Objectives-Driven Course";s:15:"crs_view_timing";s:12:"Timings View";s:24:"crs_visibility_limitless";s:9:"Unlimited";s:20:"crs_visibility_until";s:27:"Limited Availability Period";s:13:"crs_wait_info";s:95:"If the maximum number of users is exceeded, new registrations will be placed on a waiting list.";s:16:"crs_waiting_list";s:12:"Waiting List";s:35:"crs_warn_no_max_set_on_waiting_list";s:204:"The maximum number of course members is exceeded. You can add your join request to the waiting list. You will receive a message from a course administrator when your request has been approved or rejected.";s:31:"crs_warn_wl_set_on_waiting_list";s:207:"Some users are already assigned to the waiting list. You can add your join request to the waiting list. You will receive a message from a course administrator when your request has been approved or rejected.";s:12:"crs_wiz_back";s:4:"Back";s:12:"crs_wiz_next";s:4:"Save";s:7:"crs_xml";s:3:"XML";s:18:"crs_youre_position";s:33:"Your Position on the Waiting List";s:17:"edit_timings_list";s:12:"Edit Timings";s:19:"event_add_new_event";s:17:"Added new session";s:27:"event_assign_materials_info";s:64:"Assigned materials will be displayed directly below the session.";s:28:"event_assign_materials_table";s:23:"Assignment of Materials";s:22:"event_assign_materials";s:16:"Assign Materials";s:18:"event_btn_add_edit";s:32:"Add Session and Assign Materials";s:13:"event_btn_add";s:11:"Add Session";s:15:"event_clone_btn";s:17:"Duplicate Session";s:12:"event_cloned";s:32:"The Session has been duplicated.";s:16:"event_csv_export";s:10:"CSV Export";s:15:"event_date_time";s:13:"Date and Time";s:10:"event_date";s:15:"Date of Session";s:17:"event_delete_file";s:12:"Delete File?";s:17:"event_delete_sure";s:38:"Do really want to delete this session?";s:10:"event_desc";s:11:"Description";s:22:"event_details_workflow";s:16:"Details/Workflow";s:11:"event_digit";s:5:"Digit";s:18:"event_edit_members";s:17:"Edit Participants";s:14:"event_end_date";s:3:"End";s:25:"event_etime_smaller_stime";s:79:"The finish time is earlier than the start time. Please enter a valid time span.";s:20:"event_existing_files";s:15:"Existing Files:";s:19:"event_file_download";s:18:"Files for Download";s:15:"event_file_name";s:9:"File Name";s:20:"event_file_size_info";s:9:"File Size";s:10:"event_file";s:4:"File";s:11:"event_files";s:14:"Assigned Files";s:20:"event_full_time_info";s:9:"full-time";s:13:"event_fullday";s:9:"Full-Time";s:19:"event_fulltime_info";s:13:"All Day Event";s:26:"event_further_informations";s:19:"Further Information";s:19:"event_general_infos";s:19:"General Information";s:24:"event_general_properties";s:19:"General Information";s:16:"event_inc_admins";s:19:"Show Administrators";s:17:"event_inc_members";s:12:"Show Members";s:16:"event_inc_tutors";s:11:"Show Tutors";s:14:"event_lecturer";s:4:"Name";s:14:"event_location";s:8:"Location";s:15:"event_materials";s:17:"Session Materials";s:22:"event_not_participated";s:16:"Not Participated";s:14:"event_overview";s:25:"Participation in Sessions";s:27:"event_participant_selection";s:21:"Participant Selection";s:18:"event_participated";s:12:"Participated";s:19:"event_participation";s:13:"Participation";s:14:"event_register";s:8:"Register";s:16:"event_registered";s:41:"You have been registered to this session.";s:23:"event_registration_info";s:39:"Allow users to register to the session.";s:31:"event_registration_participance";s:12:"Registration";s:18:"event_registration";s:12:"Registration";s:23:"event_save_participants";s:17:"Save Participance";s:25:"event_section_information";s:19:"Session Information";s:16:"event_select_one";s:31:"-- Please select one session --";s:16:"event_start_date";s:5:"Start";s:18:"event_table_create";s:11:"New Session";s:18:"event_table_update";s:12:"Edit Session";s:16:"event_tbl_admins";s:14:"Administrators";s:17:"event_tbl_members";s:7:"Members";s:22:"event_tbl_participants";s:20:"List of Participants";s:22:"event_tbl_participated";s:12:"Participated";s:20:"event_tbl_registered";s:10:"Registered";s:16:"event_tbl_tutors";s:6:"Tutors";s:10:"event_time";s:4:"Time";s:11:"event_title";s:5:"Title";s:16:"event_tutor_data";s:30:"Information About the Lecturer";s:16:"event_unregister";s:10:"Unregister";s:18:"event_unregistered";s:27:"You have been unregistered.";s:13:"event_updated";s:14:"Saved Settings";s:5:"event";s:7:"Session";s:18:"events_clone_title";s:17:"Duplicate Session";s:14:"events_deleted";s:15:"Session deleted";s:6:"events";s:8:"Sessions";s:14:"export_members";s:19:"Export Participants";s:26:"grouping_change_assignment";s:17:"Change Assignment";s:10:"import_crs";s:13:"Import Course";s:13:"learners_view";s:13:"Learners view";s:23:"max_members_not_numeric";s:41:"Please check the maximum number of users.";s:11:"save_status";s:11:"Save Status";s:20:"sess_attendance_list";s:15:"Attendance List";s:14:"sess_date_time";s:19:"Session Appointment";s:24:"sess_gen_attendance_list";s:13:"Generate List";s:16:"sess_gen_comment";s:28:"Generate Column for Comments";s:19:"sess_gen_mark_title";s:25:"Generate Column for Notes";s:18:"sess_gen_signature";s:30:"Generate Column for Signatures";s:14:"sess_join_info";s:61:"Please click Attend if you want to take part at this session.";s:15:"sess_limit_info";s:63:"Choose this option for limiting the number of visible sessions.";s:10:"sess_limit";s:24:"Limit Number of Sessions";s:13:"sess_num_next";s:28:"Number of Following Sessions";s:13:"sess_num_prev";s:23:"Number of Past Sessions";s:26:"sess_print_attendance_list";s:10:"Print List";s:14:"sess_signature";s:9:"Signature";s:28:"subscription_times_not_valid";s:37:"The registration period is not valid.";s:19:"timing_accept_table";s:16:"Timings: Remarks";s:15:"timing_accepted";s:8:"Accepted";s:19:"timing_not_accepted";s:12:"Not Accepted";s:13:"timing_remark";s:6:"Remark";s:20:"timing_tutor_visible";s:35:"Remark is visible for course tutors";s:18:"timing_user_accept";s:14:"Accept Timings";s:20:"timing_user_accepted";s:16:"Timings Accepted";s:12:"timings_edit";s:12:"Edit Timings";s:10:"timings_of";s:11:"Timings Off";s:19:"timings_timings_off";s:33:"Switch Timings Administration Off";s:18:"timings_timings_on";s:32:"Switch Timings Administration On";s:15:"timings_timings";s:7:"Timings";s:16:"timings_usr_edit";s:12:"Edit Timings";s:7:"timings";s:7:"Timings";s:11:"tutor_email";s:6:"E-Mail";s:15:"tutor_firstname";s:10:"First name";s:14:"tutor_lastname";s:9:"Last name";s:10:"tutor_name";s:4:"Name";s:11:"tutor_phone";s:5:"Phone";s:11:"tutor_title";s:5:"Title";s:11:"user_fields";s:11:"User Fields";s:27:"crs_notification_salutation";s:24:"Dear course participant,";s:22:"crs_custom_user_fields";s:25:"Course Relevant User Data";s:18:"crs_members_groups";s:21:"Memberships in Groups";s:13:"crs_groups_nr";s:21:"Number of Memberships";s:16:"crs_add_to_group";s:12:"Add to Group";s:12:"crs_reg_code";s:18:"Admission per Link";s:17:"crs_reg_code_link";s:25:"Link for Direct Admission";s:18:"crs_reg_code_value";s:4:"Link";s:25:"crs_reg_code_enabled_info";s:129:"Besides the chosen registration procedure and permissions this option allows users to enter directly by using the following link.";s:10:"crs_import";s:13:"Import Course";s:19:"crs_grp_assignments";s:39:"Assignments of Course Members to Groups";s:21:"crs_auto_notification";s:28:"Welcome-Mail For New Members";s:26:"crs_auto_notification_info";s:61:"New members get a mail notification when added to the course.";s:25:"crs_activate_notification";s:21:"Activate Notification";s:27:"crs_deactivate_notification";s:23:"Deactivate Notification";s:26:"crs_notification_activated";s:22:"Notification Activated";s:28:"crs_notification_deactivated";s:24:"Notification Deactivated";s:31:"crs_link_show_all_prev_sessions";s:26:"Show all previous sessions";s:27:"crs_link_hide_prev_sessions";s:22:"Hide previous sessions";s:31:"crs_link_show_all_next_sessions";s:26:"Show all upcoming sessions";s:27:"crs_link_hide_next_sessions";s:22:"Hide upcoming sessions";s:19:"event_blank_columns";s:18:"Additional Columns";s:23:"crs_starter_delete_sure";s:60:"Are you sure you want to delete the following start objects?";s:26:"crs_course_status_of_users";s:22:"Passed Status of Users";s:24:"crs_status_determination";s:13:"Determination";s:31:"crs_status_determination_manual";s:32:"Independent of Learning Progress";s:27:"crs_status_determination_lp";s:25:"Through Learning Progress";s:29:"crs_status_determination_sync";s:60:"Sync passed status with learning progress of all members now";s:37:"crs_subject_course_group_notification";s:17:"Daily Mail for %s";s:39:"crs_intro_course_group_notification_for";s:37:"This is the daily news digest for: %s";s:34:"crs_course_group_notification_link";s:5:"Link:";s:26:"crs_activation_online_info";s:144:"Set the course online to make it visible and available for course members. If not, only course administrators and tutors will have access to it.";s:38:"crs_activation_limited_visibility_info";s:72:"If chosen, the course is visible even outside of the given availability.";s:32:"crs_member_passed_status_changed";s:21:"Passed Status Changed";s:8:"crs_copy";s:11:"Copy Course";s:27:"crs_notification_list_title";s:30:"Notification About New Members";s:26:"event_list_registered_only";s:23:"Only Registered Members";s:24:"crs_passed_status_system";s:6:"System";s:27:"crs_passed_status_manual_by";s:9:"Manual by";s:13:"crs_mail_type";s:15:"Mail to Members";s:20:"crs_mail_tutors_only";s:34:"For Tutors and Administrators only";s:12:"crs_mail_all";s:20:"For all Participants";s:32:"crs_status_determination_lp_info";s:160:"When the learning progress changes to ‘Completed’, the course status ‘Passed’ will be set automatically. Tutors still can overwrite the status manually.";s:25:"crs_mail_tutors_only_info";s:98:"Only administrators and tutors can use the feature ‘Mail to Members’ in the ‘Members’ tab.";s:17:"crs_mail_all_info";s:102:"Members, administrators and tutors can use the feature ‘Mail to Members’ in the ‘Members’ tab.";s:23:"crs_registration_period";s:6:"Period";s:34:"crs_registration_confirmation_info";s:68:"Interested users can send a request/message to course administrator.";s:18:"crs_reg_no_selfreg";s:17:"No Self-enrolment";s:21:"crs_reg_password_info";s:60:"Users need to type in this password when joining the course.";s:23:"crs_loc_subtab_creation";s:6:"Create";s:19:"crs_cdf_edit_member";s:30:"Edit Course Relevant User Data";s:21:"crs_cdf_tbl_last_edit";s:34:"Last Update (Course-specific Data)";s:29:"crs_subscription_failed_limit";s:53:"The maximum number of participants has been exceeded.";s:26:"crs_loc_learning_objective";s:18:"Learning Objective";s:17:"crs_loc_suggested";s:53:"Please work through the following learning materials.";s:18:"crs_loc_itest_info";s:12:"Initial Test";s:18:"crs_loc_qtest_info";s:14:"Qualified Test";s:15:"crs_loc_tt_info";s:56:"You have reached %1$d%%. The test is passed with %2$d%%.";s:30:"crs_objective_status_configure";s:20:"Checklist for Course";s:29:"crs_objective_status_settings";s:15:"Course Settings";s:30:"crs_objective_status_materials";s:21:"Create Course Content";s:26:"crs_objective_status_itest";s:21:"Assign Placement Test";s:26:"crs_objective_status_qtest";s:23:"Assign Achievement Test";s:31:"crs_objective_status_objectives";s:29:"Configure Learning Objectives";s:26:"crs_objective_status_start";s:20:"Define Start Objects";s:31:"crs_objective_status_fullfilled";s:2:"OK";s:30:"crs_objective_action_materials";s:15:"Assign Material";s:26:"crs_objective_action_qtest";s:36:"Assign Questions of Achievement Test";s:26:"crs_objective_action_itest";s:34:"Assign Questions of Placement Test";s:21:"crs_loc_qt_visibility";s:30:"Visibility of Achievement Test";s:25:"crs_loc_qt_visibility_all";s:45:"Show Achievement Test Covering all Objectives";s:24:"crs_loc_qt_visibility_lo";s:51:"Show Achievement Test for Each Individual Objective";s:22:"crs_loc_limited_passes";s:19:"Limited Test Passes";s:14:"crs_loc_passes";s:16:"Number of Passes";s:19:"crs_loc_passes_info";s:29:"Maximum Number of test passes";s:29:"crs_loc_err_stat_no_materials";s:29:"No Course Materials available";s:22:"crs_loc_err_stat_no_qt";s:29:"No Achievement Test available";s:22:"crs_loc_err_stat_no_it";s:27:"No Placement Test available";s:39:"crs_objective_status_objective_creation";s:25:"Create Learning Objective";s:30:"crs_loc_form_create_objectives";s:26:"Create Learning Objectives";s:25:"crs_loc_err_no_active_mat";s:44:"Learning objectives without assigned content";s:24:"crs_loc_err_no_active_it";s:40:"Learning Objectives without Initial Test";s:24:"crs_loc_err_no_active_qt";s:43:"Learning Objectives without Qualifying Test";s:24:"crs_loc_err_no_active_lo";s:28:"No active Learning Objective";s:20:"crs_loc_settings_tbl";s:50:"Settings for the Learning Objectives-Driven Course";s:21:"crs_loc_settings_type";s:13:"Course Design";s:24:"crs_loc_type_initial_all";s:33:"Course Starts with Placement Test";s:24:"crs_loc_type_initial_sel";s:65:"Course starts with Placement Test for Selected Learning Objective";s:22:"crs_loc_type_qualified";s:28:"Credit-by-examination design";s:21:"crs_loc_type_practise";s:40:"Course Starts with Learning and Practise";s:21:"crs_loc_tab_materials";s:8:"Material";s:17:"crs_loc_tab_itest";s:14:"Placement Test";s:17:"crs_loc_tab_qtest";s:16:"Achievement Test";s:26:"crs_loc_settings_itest_tbl";s:31:"Settings for the Placement Test";s:22:"crs_loc_tab_objectives";s:19:"Learning Objectives";s:26:"crs_loc_settings_qtest_tbl";s:32:"Settings for the Qualifying Test";s:17:"crs_loc_tab_start";s:13:"Start Objects";s:26:"crs_loc_confirm_delete_tst";s:83:"Do you really want to deassign the test of this learning objective oriented course?";s:20:"crs_loc_tbl_tst_type";s:9:"Test Mode";s:22:"crs_loc_form_assign_it";s:15:"Test Assignment";s:20:"crs_loc_form_tst_new";s:15:"Create New Test";s:19:"crs_loc_form_assign";s:17:"Use Existing Test";s:27:"crs_loc_form_available_tsts";s:15:"Available Tests";s:23:"crs_loc_tbl_tst_qst_qpl";s:24:"Questions/Question Pools";s:19:"crs_loc_tst_num_qst";s:20:"Number of Questions:";s:16:"crs_loc_tst_qpls";s:25:"Available Question Pools:";s:29:"crs_loc_form_random_limits_it";s:32:"Define Questions of Initial Test";s:29:"crs_loc_form_random_limits_qt";s:35:"Define Questions of Qualifying Test";s:23:"crs_loc_rand_assign_qpl";s:29:"Assignment form Question Pool";s:16:"crs_loc_rand_qpl";s:24:"Available Question Pools";s:15:"crs_loc_num_qst";s:19:"Number of Questions";s:12:"crs_loc_perc";s:29:"Required Percentage of Points";s:25:"crs_loc_delete_assignment";s:13:"Deassign Test";s:25:"crs_loc_err_no_active_qst";s:28:"Objectives without questions";s:26:"crs_loc_qtst_for_objective";s:22:"Qualifying Test "%1$s"";s:26:"crs_loc_itst_for_objective";s:19:"Initial Test "%1$s"";s:29:"crs_loc_progress_result_itest";s:22:"Result of Initial Test";s:29:"crs_loc_progress_result_qtest";s:6:"Result";s:37:"crs_loc_progress_no_result_do_initial";s:29:"Please take the initial test.";s:35:"crs_loc_progress_objective_complete";s:37:"You completed the learning objective.";s:30:"crs_loc_progress_do_qualifying";s:32:"Please take the qualifying test.";s:36:"crs_loc_progress_do_qualifying_again";s:59:"Please work through the learning objective materials again.";s:29:"crs_loc_err_nr_tries_exceeded";s:96:"The number of passes per objective exceeds the possible number of passes of the Qualifying Test.";s:19:"crs_loc_passes_left";s:31:"Remaining number of test passes";s:22:"crs_loc_passes_reached";s:31:"No further test passes possible";s:19:"crs_loc_tst_new_run";s:19:"Start New Test Pass";s:18:"crs_loc_tst_resume";s:18:"Continue Test Pass";s:22:"crs_loc_settings_reset";s:12:"Test Results";s:29:"crs_loc_settings_reset_enable";s:30:"Allow ‘Reset Test Results’";s:34:"crs_loc_settings_reset_enable_info";s:99:"If activated, all users are able to reset their individual test results and start the course again.";s:37:"crs_loc_progress_no_result_no_initial";s:87:"Please work through the following learning materials and then take the qualifying test.";s:28:"crs_loc_qst_resume_tst_itest";s:206:"You have already started an initial test to another learning objective. Either you finish the started test or you stop it and start this one. But running two initial tests at the same time is not supported.";s:28:"crs_loc_qst_resume_tst_qtest";s:211:"You have already started a qualifying test to another learning objective. Either you finish the started test or you stop it and start this one. But running two qualifying tests at the same time is not supported.";s:29:"crs_loc_type_initial_all_info";s:286:"Based on individual results of the placement test, ILIAS recommends learning content for the not-yet-sufficient learning objectives. The final achievement test assesses whether a test participant already mastered the learning objectives or if additional learning and training is needed.";s:27:"crs_loc_type_qualified_info";s:387:"The course starts with a test to assess if a course member already mastered the learning objectives. For all passed learning objectives, users do not have to work through any of the learning content or take more tests. For all not-yet-sufficient learning objectives, ILIAS recommends learning content. The mastery of the remaining learning objectives is tested in an additional test run.";s:26:"crs_loc_type_practise_info";s:251:"Course members can use the full range of learning objectives and assigned learning content immediately. They can take the achievement testto assess whether they mastered the learning objectives already of if additional learning and training is needed.";s:33:"crs_loc_form_tst_new_initial_info";s:44:"Create a new test to serve as Placement Test";s:35:"crs_loc_form_tst_new_qualified_info";s:2:"--";s:32:"crs_loc_form_assign_initial_info";s:57:"Select a test from this course to serve as Placement Test";s:34:"crs_loc_form_assign_qualified_info";s:2:"--";s:22:"crs_loc_tst_assignment";s:15:"Test Assignment";s:16:"crs_show_all_obj";s:10:"Expand All";s:16:"crs_hide_all_obj";s:12:"Collapse All";s:46:"crs_admission_link_failure_registration_period";s:53:"Can\'t register: Course is out of registration period.";s:45:"crs_admission_link_failure_membership_limited";s:45:"Can\'t register: Course membership is limited.";s:39:"crs_admission_link_success_registration";s:39:"Successfully registered to course "%s".";s:17:"crs_usr_agreement";s:14:"User Agreement";s:34:"crs_unsubscribe_member_explanation";s:82:"You receive this message because you unsubscribed from the course mentioned above.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'dateplaner'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:523:{s:15:"add_appointment";s:15:"Add Appointment";s:8:"add_data";s:15:"Additional Data";s:4:"app_";s:5:"Inbox";s:8:"app_date";s:12:"Create Event";s:7:"app_day";s:8:"Day View";s:12:"app_freetime";s:47:"Free time of other group members (catch a time)";s:9:"app_inbox";s:5:"Inbox";s:8:"app_list";s:14:"List of Events";s:9:"app_month";s:10:"Month View";s:14:"app_properties";s:10:"Properties";s:8:"app_week";s:9:"Week View";s:11:"application";s:8:"Calendar";s:5:"apply";s:5:"Apply";s:4:"back";s:4:"Back";s:10:"begin_date";s:10:"Begin Date";s:8:"busytime";s:18:"Busy time in group";s:6:"c_date";s:12:"Create Event";s:12:"cal_accepted";s:8:"Accepted";s:19:"cal_add_appointment";s:18:"Create Appointment";s:16:"cal_add_category";s:19:"Create New Calendar";s:17:"cal_add_milestone";s:13:"Add Milestone";s:11:"cal_all_day";s:7:"All Day";s:16:"cal_appointments";s:14:"Appointment(s)";s:8:"cal_apps";s:22:"Number of Appointments";s:25:"cal_assigned_appointments";s:21:"Assigned Appointments";s:18:"cal_cache_disabled";s:8:"Disabled";s:17:"cal_cache_enabled";s:7:"Enabled";s:14:"cal_cache_info";s:118:"If activated, calendar appointments on the personal desktop and in the repository are calculated only every x-minutes.";s:9:"cal_cache";s:14:"Calendar Cache";s:15:"cal_cal_details";s:16:"Calendar Details";s:12:"cal_cal_type";s:13:"Calendar Type";s:18:"cal_calendar_color";s:5:"Color";s:17:"cal_calendar_name";s:13:"Calendar Name";s:22:"cal_category_selection";s:18:"Calendar Selection";s:28:"cal_change_responsible_users";s:24:"Change Responsible Users";s:25:"cal_changed_events_header";s:28:"New and Changed Appointments";s:10:"cal_create";s:6:"Create";s:23:"cal_created_appointment";s:24:"Created new appointment.";s:28:"cal_created_milestone_resp_q";s:80:"Added milestone. Please select users that are responsible to meet the milestone.";s:21:"cal_created_milestone";s:16:"Added milestone.";s:9:"cal_daily";s:5:"Daily";s:20:"cal_date_format_info";s:46:"Please choose a format for the input of dates.";s:11:"cal_day_end";s:7:"Day End";s:16:"cal_day_of_month";s:16:"Day of the month";s:16:"cal_day_overview";s:12:"Day Overview";s:9:"cal_day_s";s:6:"Day(s)";s:17:"cal_day_selection";s:10:"Select Day";s:13:"cal_day_start";s:9:"Day Start";s:17:"cal_day_week_view";s:22:"Day/Week View Settings";s:12:"cal_deadline";s:8:"Deadline";s:12:"cal_declined";s:8:"Declined";s:24:"cal_def_date_format_info";s:46:"Please choose a format for the input of dates.";s:19:"cal_def_date_format";s:25:"Default Date Input Format";s:24:"cal_def_time_format_info";s:62:"Please choose a format for the input and presentation of time.";s:19:"cal_def_time_format";s:19:"Default Time Format";s:21:"cal_def_timezone_info";s:70:"Please choose a default timezone for the presentation of appointments.";s:16:"cal_def_timezone";s:16:"Default Timezone";s:18:"cal_def_week_start";s:10:"Week Start";s:20:"cal_default_calendar";s:21:"Personal Appointments";s:16:"cal_del_app_sure";s:55:"Do you really want to delete the selected appointments?";s:16:"cal_del_cal_sure";s:50:"Do you really want to delete the chosen calendars?";s:19:"cal_delete_app_sure";s:56:"Do you really want to delete the following appointments?";s:15:"cal_deleted_app";s:44:"The selected appointments have been deleted.";s:11:"cal_details";s:19:"Appointment Details";s:20:"cal_dstart_dend_warn";s:80:"Please check your input. The start of a day should be before the end of the day.";s:12:"cal_duration";s:8:"Duration";s:20:"cal_edit_appointment";s:16:"Edit Appointment";s:17:"cal_edit_category";s:13:"Edit Calendar";s:18:"cal_edit_milestone";s:14:"Edit Milestone";s:32:"cal_enable_group_milestones_desc";s:55:"This option enables milestone planning in the calendar.";s:27:"cal_enable_group_milestones";s:17:"Enable Milestones";s:7:"cal_end";s:3:"End";s:9:"cal_every";s:6:"Every:";s:9:"cal_fifth";s:5:"Fifth";s:9:"cal_first";s:5:"First";s:10:"cal_fourth";s:6:"Fourth";s:17:"cal_fullday_title";s:13:"All Day Event";s:11:"cal_fullday";s:9:"Date/Time";s:19:"cal_global_settings";s:15:"Global Settings";s:6:"cal_in";s:2:"in";s:8:"cal_last";s:4:"Last";s:18:"cal_month_overview";s:14:"Month Overview";s:11:"cal_month_s";s:8:"Month(s)";s:19:"cal_month_selection";s:12:"Select Month";s:11:"cal_monthly";s:7:"Monthly";s:14:"cal_ms_details";s:17:"Milestone Details";s:24:"cal_ms_users_responsible";s:17:"Users Responsible";s:11:"cal_new_app";s:15:"New Appointment";s:10:"cal_new_ms";s:13:"New Milestone";s:13:"cal_no_ending";s:11:"No End Date";s:17:"cal_no_recurrence";s:13:"No Recurrence";s:18:"cal_no_recurrences";s:14:"No Recurrences";s:10:"cal_on_the";s:7:"On the:";s:6:"cal_on";s:3:"On:";s:17:"cal_rec_err_limit";s:44:"Please enter a valid number of appointments.";s:15:"cal_recurrences";s:11:"Recurrences";s:15:"cal_responsible";s:11:"Responsible";s:26:"cal_save_responsible_users";s:22:"Save Responsible Users";s:21:"cal_search_info_share";s:72:"Please enter the name of the desired user/role for sharing the calendar.";s:10:"cal_search";s:11:"Search Term";s:10:"cal_second";s:6:"Second";s:13:"cal_server_tz";s:15:"Server Timezone";s:16:"cal_share_accept";s:17:"Accept Invitation";s:13:"cal_share_cal";s:26:"Share Calendar (Read-only)";s:22:"cal_share_cal_editable";s:31:"Share Calendar (Read and Write)";s:27:"cal_shared_access_table_col";s:6:"Access";s:28:"cal_shared_access_read_write";s:14:"Read and Write";s:27:"cal_shared_access_read_only";s:9:"Read-only";s:17:"cal_share_decline";s:18:"Decline Invitation";s:23:"cal_share_search_header";s:14:"Share Calendar";s:28:"cal_share_search_role_header";s:14:"Role Selection";s:27:"cal_share_search_usr_header";s:14:"User Selection";s:9:"cal_share";s:14:"Share Calendar";s:20:"cal_shared_calendars";s:30:"Shared Calendars (Invitations)";s:17:"cal_shared_header";s:16:"Shared Calendars";s:23:"cal_shared_selected_usr";s:59:"The calendar has been shared with the selected users/roles.";s:9:"cal_start";s:5:"Start";s:23:"cal_subscription_header";s:16:"Calendar Address";s:21:"cal_subscription_info";s:166:"Please use the following address to access your calendar from other applications. You can copy and paste this into any calendar product that supports the ical format.";s:20:"cal_subscription_url";s:13:"Calendar URL:";s:19:"cal_sync_cache_info";s:85:"If activated, new/modified calendar appointments are calculated only every x minutes.";s:14:"cal_sync_cache";s:14:"Calendar Cache";s:17:"cal_sync_disabled";s:8:"Disabled";s:16:"cal_sync_enabled";s:7:"Enabled";s:15:"cal_sync_header";s:24:"Synchronisation Settings";s:20:"cal_table_categories";s:18:"Calendar Selection";s:19:"cal_task_completion";s:15:"Task Completion";s:9:"cal_third";s:5:"Third";s:20:"cal_time_format_info";s:62:"Please choose a format for the input and presentation of time.";s:17:"cal_timezone_info";s:48:"Please choose the nearest city in your timezone.";s:12:"cal_type_crs";s:15:"Course Calendar";s:12:"cal_type_grp";s:14:"Group Calendar";s:13:"cal_type_info";s:88:"Please choose one calendar type. ‘Public Calendars’ are visible for all ILIAS users.";s:17:"cal_type_personal";s:16:"Private Calendar";s:13:"cal_type_sess";s:16:"Session Calendar";s:15:"cal_type_system";s:15:"Public Calendar";s:12:"cal_type_usr";s:17:"Personal Calendar";s:15:"cal_unshare_cal";s:12:"Stop Sharing";s:25:"cal_unshared_selected_usr";s:53:"Stopped sharing the calendar with the selected users.";s:17:"cal_user_settings";s:17:"Calendar Settings";s:17:"cal_user_timezone";s:14:"ILIAS-Timezone";s:19:"cal_export_timezone";s:28:"Timezone for Calendar Export";s:22:"cal_export_timezone_tz";s:18:"Use ILIAS-Timezone";s:23:"cal_export_timezone_utc";s:45:"Use Timezone UTC (compatible with MS Outlook)";s:20:"cal_user_date_format";s:17:"Date Input Format";s:20:"cal_user_time_format";s:11:"Time Format";s:15:"cal_week_abbrev";s:1:"W";s:19:"cal_week_month_view";s:24:"Week/Month View Settings";s:17:"cal_week_overview";s:13:"Week Overview";s:10:"cal_week_s";s:7:"Week(s)";s:18:"cal_week_selection";s:11:"Select Week";s:14:"cal_week_start";s:10:"Week Start";s:11:"cal_weekday";s:7:"Weekday";s:10:"cal_weekly";s:6:"Weekly";s:8:"cal_what";s:5:"Title";s:9:"cal_where";s:8:"Location";s:10:"cal_year_s";s:7:"Year(s)";s:10:"cal_yearly";s:6:"Yearly";s:12:"changedDates";s:14:"Changed Events";s:8:"changeTo";s:10:"Change to:";s:16:"checkforfreetime";s:19:"Check for free time";s:7:"created";s:7:"Created";s:22:"crs_cal_activation_end";s:10:"Course End";s:24:"crs_cal_activation_start";s:12:"Course Start";s:15:"crs_cal_reg_end";s:16:"Registration End";s:17:"crs_cal_reg_start";s:18:"Registration Start";s:18:"date_format_middle";s:5:"m/d/y";s:11:"date_format";s:9:"m/d/Y H:i";s:4:"date";s:4:"Date";s:8:"DateText";s:7:"Message";s:8:"Day_long";s:8:"Day View";s:7:"del_all";s:17:"Delete all events";s:7:"del_one";s:16:"Delete one event";s:12:"deletedDates";s:14:"Deleted Events";s:7:"discard";s:7:"Discard";s:16:"dv_button_cancel";s:6:"Cancel";s:16:"dv_button_delete";s:6:"Delete";s:16:"dv_button_insert";s:6:"Insert";s:16:"dv_button_update";s:6:"Update";s:13:"dv_date_begin";s:11:"Start Date:";s:11:"dv_date_end";s:9:"End Date:";s:10:"dv_date_hm";s:11:"Hour:Minute";s:10:"dv_enddate";s:9:"End date:";s:14:"dv_groupselect";s:13:"Group select:";s:12:"dv_Grouptime";s:9:"Free time";s:17:"dv_groupview_text";s:12:"Group:<br />";s:12:"dv_groupview";s:12:"Group event:";s:11:"dv_keywords";s:9:"Keywords:";s:16:"dv_keywordselect";s:15:"Keyword select:";s:10:"dv_message";s:8:"Message:";s:10:"dv_noGroup";s:8:"no Group";s:8:"dv_noKey";s:10:"no Keyword";s:10:"dv_preview";s:18:"<b>! Preview !</b>";s:16:"dv_rotation_date";s:16:"Recurrence date:";s:15:"dv_rotation_end";s:15:"Recurrence end:";s:11:"dv_rotation";s:11:"Recurrence:";s:12:"dv_shorttext";s:11:"Short text:";s:12:"dv_startdate";s:11:"Start date:";s:7:"dv_text";s:5:"Text:";s:12:"dv_whole_day";s:10:"Whole day:";s:17:"dv_whole_rotation";s:74:"Would you like to delete the entire recurring series? (click the checkbox)";s:8:"end_date";s:8:"End Date";s:16:"endtime_for_view";s:21:"Finish time for view:";s:20:"err_end_before_start";s:46:"The appointment must not start before the end.";s:17:"err_missing_title";s:34:"Please enter an appointment title.";s:17:"ERROR_DATE_EXISTS";s:26:"This event already exists.";s:16:"ERROR_DB_CONNECT";s:29:"The database is disconnected.";s:8:"ERROR_DB";s:21:"Database write error!";s:13:"ERROR_DEL_MSG";s:75:"This is a recurring event. Would you like to delete one event or the series";s:15:"ERROR_END_START";s:52:"Wrong end date input. End date is before start date.";s:13:"ERROR_ENDDATE";s:40:"Wrong end date input. Format: dd/mm/yyyy";s:13:"ERROR_ENDTIME";s:32:"Wrong finish time. Format: hh:mm";s:18:"ERROR_FILE_CSV_MSG";s:29:"Please take a valid CSV file.";s:16:"ERROR_JAVASCRIPT";s:131:"<B><CENTER>your browser doesn\'t accept JavaScript.<br />Please close this Window after insert manually.<br />Thank you</CENTER></B>";s:17:"error_minical_img";s:31:"Cannot create GD-picture-stream";s:19:"ERROR_ROT_END_START";s:72:"Wrong recurring end date input. Recurring end date is before start date.";s:17:"ERROR_ROTATIONEND";s:50:"Wrong recurring end date input. Format: dd/mm/yyyy";s:15:"ERROR_SHORTTEXT";s:47:"Wrong short text input. Short text is required.";s:15:"ERROR_STARTDATE";s:42:"Wrong start date input. Format: dd/mm/yyyy";s:15:"ERROR_STARTTIME";s:31:"Wrong start time. Format: hh:mm";s:8:"ERROR_TS";s:21:"Incorrect date format";s:7:"execute";s:15:"Execute choices";s:11:"extra_dates";s:14:"One Day Events";s:7:"Fr_long";s:6:"Friday";s:8:"Fr_short";s:2:"Fr";s:4:"free";s:4:"Free";s:8:"freetime";s:18:"Free Time in group";s:5:"group";s:5:"Group";s:15:"grp_cal_reg_end";s:16:"Registration End";s:17:"grp_cal_reg_start";s:18:"Registration Start";s:10:"help_day_l";s:57:"In the day view all events of a chosen day are displayed.";s:8:"help_day";s:17:"Calendar Day View";s:14:"help_enddate_l";s:112:"Contains the finish time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.";s:12:"help_enddate";s:30:"End date - syntax [dd/mm/yyyy]";s:18:"help_endrotation_l";s:109:"At this day the repetition will end.<br />The symbol opens a small calendar for choosing the appropriate date";s:16:"help_endrotation";s:31:"Finish time syntax [dd/mm/yyyy]";s:14:"help_endtime_l";s:65:"Contains the finish time of the appointment using 24-hour format.";s:12:"help_endtime";s:43:"Finish time - syntax [hh/mm] 24-hour format";s:13:"help_filename";s:15:"dp_help_en.html";s:14:"help_fullday_l";s:130:"If the event stretches over a whole day, please choose this option.<br />This will hide the start time, finish time, and end date.";s:12:"help_fullday";s:32:"Whole day event - syntax[on/off]";s:12:"help_further";s:48:"<br /><b>click here for further information.</b>";s:12:"help_group_l";s:193:"Contains the groups for which the logged-in user has administrator rights and for which a date can be created.<br />After choosing this it is possible to view the unscheduled time of the group.";s:10:"help_group";s:22:"Group events selection";s:12:"help_inbox_l";s:62:"Here all new, changed, and deleted group events are displayed.";s:10:"help_inbox";s:14:"Calendar Inbox";s:14:"help_keyword_l";s:58:"Contains the keywords which a user can associate to dates.";s:12:"help_keyword";s:17:"Keyword selection";s:17:"help_keywordUse_l";s:106:"Choose one or more keywords from the dialog box.<br />TIP: use the CTRL key for selecting several entries.";s:15:"help_keywordUse";s:17:"Keyword selection";s:11:"help_list_l";s:70:"In the event list, all events of a given period of time are displayed.";s:9:"help_list";s:19:"Calendar event list";s:12:"help_month_l";s:60:"In the month view all events of a given month are displayed.";s:10:"help_month";s:19:"Calendar month view";s:21:"help_properties_alt_l";s:111:"Choose a keyword from the dialog box.<br />Change the keyword in the text field. Important: max. 20 characters.";s:19:"help_properties_alt";s:19:"Changes the keyword";s:21:"help_properties_del_l";s:77:"Choose a keyword from the dialog box. Click the button to delete the keyword.";s:19:"help_properties_del";s:19:"Deletes the keyword";s:24:"help_properties_import_l";s:112:"Here a CSC file can be selected, which contains Outlook-Events. These events will be imported into the calendar.";s:22:"help_properties_import";s:27:"Import of Outlook CSV files";s:21:"help_properties_new_l";s:72:"Add a new keyword to the field ‘new’. Important: max. 20 characters.";s:19:"help_properties_new";s:33:"Add a keyword, max. 20 characters";s:22:"help_properties_time_l";s:213:"The standard display time for the day view and week view can be changed. If dates are outside of the display time for a given days or week, the display time will be changed for that time span. Standard is 8h -18h.";s:20:"help_properties_time";s:35:"Display time for day view/week view";s:15:"help_rotation_l";s:49:"Contains the type of the recurrence / repetition.";s:13:"help_rotation";s:10:"Recurrence";s:16:"help_shorttext_l";s:51:"Here one can enter the short text for a given date.";s:14:"help_shorttext";s:30:"Short text, max. 50 characters";s:16:"help_startdate_l";s:111:"Contains the start time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.";s:14:"help_startdate";s:31:"Start date - syntax[dd/mm/yyyy]";s:16:"help_starttime_l";s:58:"Contains the start time of the event using 24-hour format.";s:14:"help_starttime";s:41:"Start time - syntax[hh/mm] 24-hour format";s:11:"help_text_l";s:46:"Here one can enter the text for a given event.";s:9:"help_text";s:4:"Text";s:11:"help_week_l";s:58:"In the week view all events of a given week are displayed.";s:9:"help_week";s:18:"Calendar week view";s:4:"hour";s:4:"hour";s:11:"ical_export";s:11:"iCal Export";s:11:"importDates";s:24:"Import of Outlook Events";s:5:"inbox";s:5:"Inbox";s:17:"insertImportDates";s:42:"These events were successfully registered:";s:10:"k_alldates";s:10:"All Events";s:4:"keep";s:4:"Keep";s:7:"keyword";s:7:"Keyword";s:8:"keywords";s:8:"Keywords";s:13:"Language_file";s:7:"English";s:11:"last_change";s:12:"Last changed";s:12:"Listbox_long";s:14:"List of Events";s:7:"long_01";s:7:"January";s:7:"long_02";s:8:"February";s:7:"long_03";s:5:"March";s:7:"long_04";s:5:"April";s:7:"long_05";s:3:"May";s:7:"long_06";s:4:"June";s:7:"long_07";s:4:"July";s:7:"long_08";s:6:"August";s:7:"long_09";s:9:"September";s:7:"long_10";s:7:"October";s:7:"long_11";s:8:"November";s:7:"long_12";s:8:"December";s:10:"main_dates";s:11:"Main Events";s:5:"menue";s:4:"Menu";s:6:"mmonth";s:10:"Last Month";s:7:"Mo_long";s:6:"Monday";s:8:"Mo_short";s:2:"Mo";s:10:"Month_long";s:10:"Month View";s:5:"month";s:5:"Month";s:4:"more";s:4:"More";s:5:"mweek";s:9:"Last Week";s:6:"myeahr";s:9:"Last Year";s:7:"new_doc";s:16:"Create new event";s:8:"newDates";s:10:"New Events";s:10:"newKeyword";s:4:"New:";s:8:"no_entry";s:19:"No events available";s:10:"o_day_date";s:13:"24-hour event";s:2:"of";s:2:"of";s:8:"open_day";s:8:"Day View";s:6:"pmonth";s:10:"Next Month";s:9:"printlist";s:5:"Print";s:10:"properties";s:10:"Properties";s:5:"pweek";s:9:"Next Week";s:5:"pyear";s:9:"Next Year";s:4:"r_14";s:13:"Every 14 days";s:9:"r_4_weeks";s:13:"Every 4 weeks";s:5:"r_day";s:9:"Every day";s:10:"r_halfyear";s:15:"Every half year";s:7:"r_month";s:11:"Every month";s:14:"r_nonrecurring";s:4:"Once";s:6:"r_week";s:10:"Every week";s:6:"r_year";s:10:"Every year";s:14:"readimportfile";s:6:"Insert";s:14:"rotation_dates";s:17:"Recurrence events";s:8:"rotation";s:10:"Recurrence";s:7:"Sa_long";s:8:"Saturday";s:8:"Sa_short";s:2:"Sa";s:13:"semester_name";s:13:"Semester Name";s:8:"short_01";s:3:"Jan";s:8:"short_02";s:3:"Feb";s:8:"short_03";s:3:"Mar";s:8:"short_04";s:3:"Apr";s:8:"short_05";s:3:"May";s:8:"short_06";s:3:"Jun";s:8:"short_07";s:3:"Jul";s:8:"short_08";s:3:"Aug";s:8:"short_09";s:3:"Sep";s:8:"short_10";s:3:"Oct";s:8:"short_11";s:3:"Nov";s:8:"short_12";s:3:"Dec";s:9:"shorttext";s:10:"Short Text";s:10:"singleDate";s:12:"Single Event";s:18:"starttime_for_view";s:20:"Start time for view:";s:7:"Su_long";s:6:"Sunday";s:8:"Su_short";s:2:"Su";s:4:"Text";s:4:"Text";s:7:"Th_long";s:8:"Thursday";s:8:"Th_short";s:2:"Th";s:8:"timedate";s:11:"Time / Date";s:9:"timeslice";s:5:"Time:";s:2:"to";s:2:"to";s:5:"today";s:5:"Today";s:7:"Tu_long";s:7:"Tuesday";s:8:"Tu_short";s:2:"Tu";s:4:"View";s:5:"View:";s:8:"viewlist";s:4:"View";s:7:"We_long";s:9:"Wednesday";s:8:"We_short";s:2:"We";s:9:"Week_long";s:9:"Week View";s:4:"week";s:4:"Week";s:8:"wk_short";s:2:"WK";s:4:"year";s:4:"Year";s:20:"yui_cal_choose_month";s:6:"Month:";s:19:"yui_cal_choose_year";s:5:"Year:";s:28:"cal_grp_new_notification_sub";s:29:"New Appointment in Group "%s"";s:24:"cal_grp_notification_sub";s:33:"Changed Appointment in Group "%s"";s:28:"cal_crs_new_notification_sub";s:30:"New Appointment in Course "%s"";s:24:"cal_crs_notification_sub";s:34:"Changed Appointment in Course "%s"";s:29:"cal_grp_new_notification_body";s:49:"a new appointment has been created in group "%s".";s:29:"cal_crs_new_notification_body";s:50:"a new appointment has been created in course "%s".";s:25:"cal_grp_notification_body";s:46:"an appointment has been changed in group "%s".";s:25:"cal_crs_notification_body";s:47:"an appointment has been changed in course "%s".";s:16:"cal_notification";s:17:"Mail Notification";s:21:"cal_notification_info";s:91:"If enabled, all course/group participants will be notified per mail about this appointment.";s:25:"cal_adm_notification_info";s:112:"Choose this option, to send optional mail notifications to course/group participants about changed appointments.";s:16:"cal_repeat_until";s:12:"Repeat until";s:26:"cal_upcoming_events_header";s:15:"Upcoming Events";s:16:"cal_back_to_list";s:12:"Back to List";s:18:"cal_back_to_search";s:14:"Back to Search";s:11:"cal_unshare";s:14:"Cancel Sharing";s:10:"cal_manage";s:9:"Calendars";s:17:"cal_delete_single";s:28:"Delete only this appointment";s:22:"cal_delete_recurrences";s:22:"Delete all recurrences";s:15:"cal_back_to_cal";s:16:"Back to Calendar";s:18:"cal_ch_form_header";s:18:"Consultation Hours";s:16:"cal_ch_form_info";s:82:"This option enables the management of personal consultation hours in the calendar.";s:11:"cal_ch_form";s:25:"Enable Consultation Hours";s:22:"app_consultation_hours";s:18:"Consultation Hours";s:19:"cal_ch_add_sequence";s:31:"Add Consultation Hours Sequence";s:15:"cal_ch_duration";s:28:"Duration of Each Appointment";s:23:"cal_ch_num_appointments";s:22:"Number of Appointments";s:19:"cal_ch_num_bookings";s:23:"Booking per Appointment";s:15:"cal_ch_deadline";s:19:"Latest Registration";s:20:"cal_ch_deadline_info";s:68:"Please define the number of hours until the registration is blocked.";s:28:"cal_ch_num_appointments_info";s:49:"Please define the number of sequent appointments.";s:18:"cal_ch_personal_ch";s:27:"Personal Consultation Hours";s:9:"cal_ch_ch";s:18:"Consultation Hours";s:26:"cal_consultation_hours_for";s:22:"Consultation hours for";s:20:"cal_ch_booking_owner";s:5:"Owner";s:23:"cal_ch_current_bookings";s:16:"Current Bookings";s:11:"cal_ch_book";s:16:"Book Appointment";s:21:"cal_ch_cancel_booking";s:14:"Cancel Booking";s:24:"cal_confirm_booking_info";s:48:"Please confirm the booking for this appointment.";s:19:"cal_confirm_booking";s:15:"Confirm Booking";s:23:"cal_cancel_booking_info";s:48:"Please confirm the cancellation of this booking.";s:18:"cal_cancel_booking";s:14:"Cancel Booking";s:21:"cal_booking_confirmed";s:45:"The appointment has been booked successfully.";s:28:"cal_cancel_booking_confirmed";s:44:"The booking has been cancelled successfully.";s:32:"cal_booking_confirmation_subject";s:36:"The appointment "%s" has been booked";s:29:"cal_booking_confirmation_body";s:41:"your appointment with %s has been booked.";s:29:"cal_booking_confirmation_link";s:24:"Link to the appointment:";s:29:"cal_booking_confirmation_user";s:46:"This is a copy from the original mail to user:";s:32:"cal_booking_cancellation_subject";s:39:"The appointment "%s" has been cancelled";s:29:"cal_booking_cancellation_body";s:44:"your appointment with %s has been cancelled.";s:29:"cal_booking_cancellation_user";s:46:"This is a copy from the original mail to user:";s:14:"cal_booked_out";s:9:"booked up";s:13:"cal_book_free";s:9:"available";s:15:"cal_date_booked";s:6:"booked";s:15:"cal_ch_bookings";s:12:"Participants";s:26:"cal_ch_multi_edit_sequence";s:26:"Edit multiple appointments";s:17:"cal_registrations";s:25:"Appointment Registrations";s:20:"cal_cg_registrations";s:42:"Registration for Course/Group Appointments";s:24:"cal_cg_registration_info";s:73:"Gives users the possibility to register to course and group appointments.";s:16:"cal_reg_register";s:8:"Register";s:18:"cal_reg_unregister";s:10:"Unregister";s:24:"cal_reg_registered_users";s:16:"Registered Users";s:22:"cal_confirm_unreg_info";s:53:"Please confirm the cancellation of this registration.";s:20:"cal_confirm_reg_info";s:53:"Please confirm the registration for this appointment.";s:14:"cal_ch_booking";s:16:"Resource Booking";s:20:"cal_ch_personal_book";s:17:"Personal Bookings";s:14:"cal_ch_manager";s:25:"Consultation Hour Manager";s:19:"cal_ch_manager_info";s:58:"Login of the user who will manage your consultation hours.";s:19:"cal_ch_unknown_user";s:40:"The given login does not match any user.";s:20:"cal_ch_target_object";s:17:"Repository Object";s:25:"cal_ch_target_object_info";s:49:"Restrict appointments to given repository object.";s:32:"cal_ch_unknown_repository_object";s:48:"The given repository object ref-id is not valid.";s:18:"cal_cache_settings";s:5:"Cache";s:22:"cal_milestone_settings";s:10:"Milestones";s:15:"cal_cal_deleted";s:31:"The calendars have been deleted";s:18:"cal_reg_registered";s:25:"You have been registered.";s:20:"cal_reg_unregistered";s:27:"You have been unregistered.";s:19:"cal_ical_infoscreen";s:9:"Subscribe";s:16:"cal_add_calendar";s:12:"Add Calendar";s:23:"cal_import_appointments";s:19:"Import Appointments";s:14:"cal_import_tbl";s:19:"Import Appointments";s:15:"cal_import_file";s:11:"Import File";s:20:"cal_import_file_info";s:58:"Choose the file, that contains your calendar appointments.";s:20:"cal_imported_success";s:27:"Imported %1$s appointments.";s:11:"cal_type_rl";s:17:"Calendar Location";s:14:"cal_type_local";s:14:"Local Calendar";s:15:"cal_type_remote";s:12:"Web Calendar";s:14:"cal_remote_url";s:3:"URL";s:16:"cal_type_rl_info";s:86:"If you know the address to a calendar (in iCal format), you can type the address here.";s:19:"cal_cal_synchronize";s:20:"Synchronise Calendar";s:20:"cal_cal_sync_success";s:34:"Successfully synchronised calendar";s:28:"cal_setting_global_vis_repos";s:19:"Repository Calendar";s:26:"cal_setting_global_crs_vis";s:15:"Show in Courses";s:26:"cal_setting_global_grp_vis";s:14:"Show in Groups";s:31:"cal_setting_global_crs_vis_info";s:151:"If enabled, the calendar is shown in shown in courses by default. In any case the calendar presentation can be enabled/disabled in the course settings.";s:31:"cal_setting_global_grp_vis_info";s:149:"If enabled, the calendar is shown in shown in groups by default. In any case the calendar presentation can be enabled/disabled in the group settings.";s:23:"cal_notification_crsgrp";s:42:"Notification for Course/Group Participants";s:22:"cal_notification_users";s:31:"Notification for Selected Users";s:30:"cal_adm_notification_user_info";s:74:"Choose this option, to send optional mail notifications to selected users.";s:33:"cal_err_invalid_notification_rcps";s:119:"The list of notification recipients is not valid. Please choose only ILIAS user account names or valid email addresses.";s:21:"cal_user_notification";s:17:"User Notification";s:26:"cal_user_notification_info";s:114:"Selected users will be notified about this appointment by email. Please enter ILIAS user names or email addresses.";s:19:"cal_cg_notification";s:25:"Course/Group Notification";s:29:"cal_mail_notification_subject";s:28:"Appointment Invitation: "%s"";s:26:"cal_mail_notification_body";s:40:"you have been invited to an appointment.";s:20:"cal_webcal_sync_info";s:61:"Automatically synchronise external calendars every x minutes.";s:15:"cal_webcal_sync";s:33:"External Calendar Synchronisation";s:14:"cal_ch_app_grp";s:24:"Consultation Hour Groups";s:15:"cal_ch_app_list";s:30:"Consultation Hour Appointments";s:17:"cal_ch_grp_header";s:23:"Consultation Hour Group";s:14:"cal_ch_add_grp";s:34:"Create new Consultation Hour Group";s:11:"cal_ch_grps";s:24:"Consultation Hour Groups";s:20:"cal_ch_assigned_apps";s:22:"Number of Appointments";s:16:"cal_ch_max_books";s:17:"Bookings per User";s:18:"cal_ch_grp_add_tbl";s:34:"Create new Consultation Hour Group";s:21:"cal_ch_grp_update_tbl";s:28:"Edit Consultation Hour Group";s:19:"cal_ch_grp_multiple";s:17:"Bookings per User";s:24:"cal_ch_grp_multiple_info";s:55:"You can define the maximum number of bookings per user.";s:20:"cal_ch_grp_selection";s:38:"Assignment to Consultation Hour Groups";s:24:"cal_ch_grp_no_assignment";s:18:"-- Not Assigned --";s:22:"cal_ch_grp_delete_sure";s:68:"Do you really want to delete the following consultation hour groups?";s:21:"cal_ch_delete_booking";s:14:"Delete Booking";s:21:"cal_ch_reject_booking";s:14:"Cancel Booking";s:19:"cal_ch_bookings_tbl";s:19:"Booked Appointments";s:19:"cal_ch_app_bookings";s:8:"Bookings";s:24:"cal_ch_canceled_bookings";s:40:"The selected bookings have been deleted.";s:23:"cal_ch_deleted_bookings";s:41:"The selected bookings have been canceled.";s:26:"cal_ch_delete_booking_sure";s:52:"Do you really want to delete the following bookings?";s:26:"cal_ch_cancel_booking_sure";s:52:"Do you really want to cancel the following bookings?";s:26:"cal_ch_assign_participants";s:12:"Assign Users";s:26:"cal_ch_booking_message_tbl";s:7:"Comment";s:15:"cal_ch_field_ch";s:30:"Consultation Hour Appointments";s:18:"cal_ch_export_apps";s:19:"Booked Appointments";s:31:"cal_ch_booking_reminder_subject";s:17:"Reminder for "%s"";s:28:"cal_ch_booking_reminder_body";s:39:"your appointment with "%s" starts soon.";s:20:"cal_ch_cron_reminder";s:31:"Send Consultation Hour Reminder";s:25:"cal_ch_cron_reminder_info";s:84:"If enabled, notification mails about upcoming consultation hour events will be send.";s:25:"cal_ch_cron_reminder_days";s:14:"Number of Days";s:26:"cal_ch_delete_booking_info";s:128:"‘Delete Booking’ will not notify users by email. If you want to notify users, please choose the action ‘Cancel Booking’.";s:26:"cal_ch_cancel_booking_info";s:139:"‘Cancel Booking’ sends notification mails to the users. If you do not want to notify the users, choose the option ‘Delete Booking’.";s:30:"cal_ch_delete_app_booking_info";s:116:"The following appointments have existing bookings. If you delete these appointments, the users will not be notified.";s:30:"cal_ch_user_assignment_success";s:56:"The users have been assigned to the chosen appointments.";s:34:"cal_ch_user_assignment_failed_info";s:108:"The following users could not be assigned to appointments, since the maximum number of bookings is exceeded.";s:23:"cal_booking_failed_info";s:66:"This appointment is booked out. Please choose another appointment.";s:16:"remote_pass_info";s:78:"Please enter your account data if the access to the web calendar is protected.";s:15:"cal_edit_single";s:21:"Edit this Appointment";s:20:"cal_edit_recurrences";s:21:"Edit all Appointments";s:12:"cal_ical_url";s:8:"iCal-URL";s:16:"cal_exc_deadline";s:8:"Deadline";s:28:"cal_exc_peer_review_deadline";s:17:"Feedback Deadline";s:12:"cal_type_exc";s:17:"Exercise Calendar";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'ecs'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:239:{s:11:"cert_serial";s:25:"Certificate Serial Number";s:7:"ecs_abr";s:12:"Abbreviation";s:25:"ecs_account_duration_info";s:160:"New ECS-User accounts are limited to the session duration. After assigning a user to a course the activation period will be extended by the given number months.";s:20:"ecs_account_duration";s:27:"Activation Period Extension";s:17:"ecs_active_header";s:21:"Import/Export Allowed";s:10:"ecs_active";s:24:"Enable ECS Functionality";s:21:"ecs_approval_rcp_info";s:117:"Enter one or more login names of users (comma separated) that will be informed about new approved courses per e-mail.";s:16:"ecs_approval_rcp";s:35:"Notification About Approved Courses";s:18:"ecs_attribute_name";s:14:"Attribute Name";s:11:"ecs_ca_cert";s:14:"CA Certificate";s:29:"ecs_cat_mapping_duration_info";s:94:"Choose this mode for assigning Course Links based on date ranges (e.g start time of a course).";s:24:"ecs_cat_mapping_duration";s:10:"Date Range";s:26:"ecs_cat_mapping_fixed_info";s:80:"Choose this mode for assigning Course Links to categories based on fixed values.";s:21:"ecs_cat_mapping_fixed";s:12:"Fixed Values";s:20:"ecs_cat_mapping_type";s:15:"Assignment Type";s:22:"ecs_cat_mapping_values";s:15:"Attribute Value";s:20:"ecs_category_mapping";s:24:"Assignment to Categories";s:12:"ecs_cert_key";s:15:"Certificate Key";s:19:"ecs_check_import_id";s:54:"The import id is not valid. Please check this setting.";s:15:"ecs_client_cert";s:18:"Client Certificate";s:15:"ecs_communities";s:12:"Participants";s:23:"ecs_connection_settings";s:19:"Connection Settings";s:7:"ecs_dns";s:10:"Domainname";s:12:"ecs_duration";s:8:"Duration";s:17:"ecs_econ_rcp_info";s:112:"Enter one or more login names of users (comma separated) that will be informed about new ECS content per e-mail.";s:12:"ecs_econ_rcp";s:32:"Notification About New E-Content";s:25:"ecs_edit_category_mapping";s:15:"Edit Assignment";s:9:"ecs_email";s:6:"E-Mail";s:22:"ecs_enable_participant";s:15:"Allow Im/Export";s:21:"ecs_err_invalid_dates";s:50:"The starting must be earlier than the finish time.";s:20:"ecs_err_invalid_type";s:40:"Please state a valid category object id.";s:21:"ecs_err_missing_value";s:42:"Please check your input: Attribute values.";s:24:"ecs_error_extract_serial";s:83:"Cannot read serial number of certificate. Please check the client certificate path.";s:21:"ecs_event_appointment";s:10:"Event Date";s:25:"ecs_export_created_body_a";s:30:"A new course has been released";s:19:"ecs_export_disabled";s:26:"Do not release this Course";s:18:"ecs_export_enabled";s:19:"Release this Course";s:23:"ecs_export_obj_settings";s:23:"Course Release Settings";s:10:"ecs_export";s:15:"Course Releases";s:15:"ecs_field_begin";s:5:"Begin";s:18:"ecs_field_courseID";s:9:"Course ID";s:20:"ecs_field_courseType";s:11:"Course Type";s:17:"ecs_field_credits";s:7:"Credits";s:15:"ecs_field_cycle";s:5:"Cycle";s:13:"ecs_field_day";s:3:"Day";s:13:"ecs_field_end";s:3:"End";s:18:"ecs_field_lecturer";s:11:"Lecturer(s)";s:17:"ecs_field_part_id";s:14:"Participant ID";s:14:"ecs_field_room";s:4:"Room";s:24:"ecs_field_semester_hours";s:25:"Semester Periods per Week";s:15:"ecs_field_start";s:5:"Start";s:23:"ecs_field_study_courses";s:15:"Study Course(s)";s:14:"ecs_field_term";s:4:"Term";s:14:"ecs_field_time";s:4:"Time";s:20:"ecs_global_role_info";s:68:"The chosen role will be assigned to newly created ECS user accounts.";s:16:"ecs_ignore_field";s:35:"Disable export/update of this field";s:18:"ecs_import_id_info";s:75:"Please enter the ID of the category, where new Course Links will be created";s:13:"ecs_import_id";s:9:"Import ID";s:10:"ecs_import";s:16:"Imported Objects";s:20:"ecs_imported_content";s:18:"Imported E-Content";s:17:"ecs_imported_from";s:13:"Imported From";s:16:"ecs_key_password";s:12:"Key Password";s:18:"ecs_local_settings";s:14:"Local Settings";s:15:"ecs_mapping_tbl";s:47:"Mapping of ECS-Data to ILIAS Advanced Meta Data";s:12:"ecs_mappings";s:16:"ECS Data Mapping";s:13:"ecs_meta_data";s:9:"Meta Data";s:24:"ecs_new_approval_subject";s:30:"A new course has been released";s:24:"ecs_new_category_mapping";s:44:"New Assignment of Course Links to Categories";s:24:"ecs_new_econtent_subject";s:21:"New E-Content created";s:17:"ecs_new_user_body";s:40:"A new ECS user account has been created.";s:20:"ecs_new_user_profile";s:18:"User profile data:";s:20:"ecs_new_user_subject";s:20:"New ECS User Account";s:12:"ecs_no_owner";s:33:"Please select one community name.";s:12:"ecs_no_value";s:13:"Not available";s:17:"ecs_not_published";s:22:"No approvals selected.";s:17:"ecs_notifications";s:13:"Notifications";s:22:"ecs_participants_infos";s:19:"Further Information";s:16:"ecs_participants";s:12:"Participants";s:16:"ecs_polling_info";s:70:"Please define the polling time for creation and update of Course Links";s:11:"ecs_polling";s:12:"Polling Time";s:8:"ecs_port";s:4:"Port";s:12:"ecs_protocol";s:8:"Protocol";s:14:"ecs_publish_as";s:11:"Publish as:";s:15:"ecs_publish_for";s:12:"Release for:";s:17:"ecs_published_for";s:14:"Published for:";s:23:"ecs_rcrs_created_body_a";s:34:"A new ECS Course has been created:";s:21:"ecs_read_remote_links";s:18:"Update ECS Courses";s:20:"ecs_released_content";s:18:"Released E-Content";s:12:"ecs_released";s:16:"Released Objects";s:19:"ecs_remote_imported";s:48:"Information about ECS Course has been refreshed.";s:24:"ecs_remote_user_settings";s:30:"Settings for ECS User Accounts";s:8:"ecs_role";s:15:"Role Assignment";s:19:"ecs_server_settings";s:17:"ECS Functionality";s:14:"ecs_server_url";s:10:"Server URL";s:12:"ecs_settings";s:8:"Settings";s:20:"ecs_tbl_active_rules";s:36:"Active Rules for Category Assignment";s:13:"ecs_unique_id";s:14:"Participant-ID";s:17:"ecs_user_rcp_info";s:110:"Enter one or more login names of users (comma separated) that will be informed about new ECS users per e-mail.";s:12:"ecs_user_rcp";s:28:"Notification About ECS Users";s:15:"ecs_add_new_ecs";s:11:"Add New ECS";s:17:"ecs_available_ecs";s:13:"Available ECS";s:14:"ecs_tbl_active";s:6:"Active";s:15:"ecs_server_addr";s:14:"Server Address";s:12:"ecs_activate";s:8:"Activate";s:14:"ecs_deactivate";s:10:"Deactivate";s:18:"ecs_not_configured";s:14:"Not configured";s:14:"ecs_tbl_import";s:6:"Import";s:14:"ecs_tbl_export";s:6:"Export";s:19:"ecs_tbl_import_type";s:11:"Import Type";s:27:"ecs_tbl_settings_for_server";s:19:"ECS Settings for %s";s:17:"ecs_back_settings";s:12:"ECS Settings";s:17:"ecs_crs_alloc_set";s:22:"Edit Course Allocation";s:17:"ecs_dir_alloc_set";s:25:"Edit Directory Allocation";s:13:"ecs_crs_alloc";s:17:"Course Allocation";s:13:"ecs_dir_alloc";s:20:"Directory Allocation";s:20:"ecs_cert_valid_until";s:23:"Certificate valid until";s:13:"ecs_auth_type";s:19:"Authentication Type";s:18:"ecs_auth_type_cert";s:16:"Certificate-Base";s:20:"ecs_auth_type_apache";s:17:"Username/Password";s:15:"ecs_apache_user";s:8:"Username";s:15:"ecs_apache_pass";s:8:"Password";s:19:"ecs_field_community";s:9:"Community";s:14:"ecs_tab_import";s:6:"Import";s:14:"ecs_tab_export";s:6:"Export";s:15:"ecs_mapping_crs";s:19:"Mapping for Courses";s:16:"ecs_mapping_rcrs";s:23:"Mapping for ECS Courses";s:19:"ecs_mapping_exp_tbl";s:44:"Mapping ILIAS Advanced Meta Data to ECS-Data";s:14:"ecs_import_cms";s:17:"Campus Management";s:25:"ecs_node_mapping_activate";s:24:"Enable Directory Mapping";s:29:"ecs_node_mapping_create_empty";s:45:"Create Categories only, which contain Courses";s:34:"ecs_node_mapping_create_empty_info";s:86:"Usable only in combination with course mapping, which will be activated automatically.";s:24:"ecs_campus_connect_title";s:22:"CampusConnect Mappings";s:27:"ecs_invalid_import_type_cms";s:64:"The import type ‘Campus Management’ can be chosen only once.";s:23:"ecs_cc_mapping_overview";s:16:"Mapping Overview";s:16:"ecs_cms_dir_tree";s:19:"CMS Directory Trees";s:27:"ecs_cms_directory_trees_tbl";s:19:"CMS Directory Trees";s:25:"ecs_node_mapping_status_1";s:25:"Mapping of the Whole Tree";s:25:"ecs_node_mapping_status_2";s:14:"Manual Mapping";s:25:"ecs_node_mapping_status_3";s:8:"Unmapped";s:23:"ecs_confirm_delete_tree";s:77:"Do you really want to delete all assignments for this campus management tree?";s:20:"ecs_cms_tree_deleted";s:57:"The campus management tree assignments have been deleted.";s:10:"ecs_cms_id";s:35:"Root-ID in Campus Management System";s:17:"ecs_title_updates";s:22:"Transfer Title Updates";s:16:"ecs_tree_updates";s:21:"Transfer Tree Updates";s:20:"ecs_position_updates";s:25:"Transfer Position Updates";s:16:"ecs_general_info";s:19:"General Information";s:21:"ecs_local_information";s:19:"Further Information";s:18:"ecs_delete_setting";s:50:"Are you sure you want to delete the following ECS?";s:19:"ecs_setting_deleted";s:11:"ECS deleted";s:23:"ecs_cat_mapping_by_type";s:7:"By Type";s:28:"ecs_cat_mapping_by_type_info";s:42:"Choose this mode to assign by object type.";s:23:"ecs_err_invalid_by_type";s:44:"Please select a type when assigning by type.";s:18:"ecs_server_deleted";s:14:"Deleted Server";s:14:"ecs_crs_export";s:15:"Course Releases";s:27:"ecs_crs_export_obj_settings";s:23:"Course Release Settings";s:23:"ecs_crs_export_disabled";s:26:"Do not release this Course";s:22:"ecs_crs_export_enabled";s:19:"Release this Course";s:14:"ecs_cat_export";s:17:"Category Releases";s:27:"ecs_cat_export_obj_settings";s:25:"Category Release Settings";s:23:"ecs_cat_export_disabled";s:28:"Do not release this Category";s:22:"ecs_cat_export_enabled";s:21:"Release this Category";s:15:"ecs_wiki_export";s:13:"Wiki Releases";s:28:"ecs_wiki_export_obj_settings";s:21:"Wiki Release Settings";s:24:"ecs_wiki_export_disabled";s:24:"Do not release this Wiki";s:23:"ecs_wiki_export_enabled";s:17:"Release this Wiki";s:16:"ecs_availability";s:12:"Availability";s:13:"ecs_lm_export";s:24:"Learning Module Releases";s:26:"ecs_lm_export_obj_settings";s:32:"Learning Module Release Settings";s:22:"ecs_lm_export_disabled";s:35:"Do not release this Learning Module";s:21:"ecs_lm_export_enabled";s:28:"Release this Learning Module";s:14:"ecs_glo_export";s:17:"Glossary Releases";s:27:"ecs_glo_export_obj_settings";s:25:"Glossary Release Settings";s:23:"ecs_glo_export_disabled";s:28:"Do not release this Glossary";s:22:"ecs_glo_export_enabled";s:21:"Release this Glossary";s:15:"ecs_file_export";s:13:"File Releases";s:28:"ecs_file_export_obj_settings";s:21:"File Release Settings";s:24:"ecs_file_export_disabled";s:24:"Do not release this File";s:23:"ecs_file_export_enabled";s:17:"Release this File";s:14:"ecs_grp_export";s:14:"Group Releases";s:27:"ecs_grp_export_obj_settings";s:22:"Group Release Settings";s:23:"ecs_grp_export_disabled";s:25:"Do not release this Group";s:22:"ecs_grp_export_enabled";s:18:"Release this Group";s:14:"ecs_tst_export";s:13:"Test Releases";s:27:"ecs_tst_export_obj_settings";s:21:"Test Release Settings";s:23:"ecs_tst_export_disabled";s:24:"Do not release this Test";s:22:"ecs_tst_export_enabled";s:17:"Release this Test";s:24:"ecs_cms_tree_synchronize";s:16:"Synchronize Tree";s:25:"ecs_cms_tree_synchronized";s:31:"The tree has been synchronized.";s:27:"ecs_status_pending_unmapped";s:18:"Pending (unmapped)";s:34:"ecs_status_pending_unmapped_discon";s:40:"Pending (mapped, disconnection possible)";s:37:"ecs_status_pending_unmapped_nondiscon";s:42:"Pending (mapped, disconnection impossible)";s:17:"ecs_status_mapped";s:6:"Mapped";s:18:"ecs_status_deleted";s:7:"Deleted";s:17:"ecs_status_legend";s:6:"Legend";s:15:"ecs_cmap_enable";s:17:"Course Allocation";s:16:"ecs_cmap_def_cat";s:16:"Default Category";s:21:"ecs_cmap_def_cat_info";s:106:"Please enter the id of a category where all courses will be created that cannot be handled by other rules.";s:19:"ecs_cmap_all_in_one";s:22:"Course in one Category";s:24:"ecs_cmap_all_in_one_info";s:39:"Create all new courses in one category.";s:23:"ecs_cmap_all_in_one_cat";s:15:"Course Category";s:22:"ecs_cmap_multiple_atts";s:19:"Multiple Attributes";s:25:"ecs_cmap_att_organisation";s:12:"Organisation";s:17:"ecs_cmap_att_term";s:4:"Term";s:18:"ecs_cmap_att_title";s:5:"Title";s:21:"ecs_cmap_att_lecturer";s:8:"Lecturer";s:19:"ecs_cmap_atts_table";s:31:"Attribute Mapping Configuration";s:19:"ecs_cmap_attributes";s:18:"Mapping Attributes";s:17:"ecs_cmap_overview";s:16:"Mapping Overview";s:27:"ecs_cmap_mapping_form_title";s:31:"Course Assignment for Category:";s:20:"ecs_cmap_form_filter";s:15:"Filter Settings";s:24:"ecs_cmap_form_all_values";s:10:"All Values";s:25:"ecs_cmap_form_filter_info";s:30:"Manual values, comma separated";s:28:"ecs_cmap_form_create_subdirs";s:21:"Create Subdirectories";s:25:"ecs_cmap_form_subdir_type";s:18:"Subdirectory Title";s:26:"ecs_cmap_form_subdir_value";s:18:"Subdirectory Value";s:25:"ecs_cmap_form_subdir_name";s:17:"Subdirectory Name";s:26:"ecs_cmap_add_attribute_btn";s:13:"Add Attribute";s:29:"ecs_cmap_delete_attribute_btn";s:21:"Delete Last Attribute";s:30:"ecs_cmap_form_filter_by_values";s:26:"Filter by Attribute Values";s:25:"ecs_cmap_form_current_dir";s:17:"Current Directory";s:26:"ecs_cmap_form_dir_relation";s:19:"Directory Reference";s:14:"ecs_sync_trees";s:27:"Synchronise Directory Trees";s:17:"ecs_role_mappings";s:26:"Course/Group Role Mappings";s:22:"ecs_role_mapping_value";s:15:"Attribute Value";s:23:"ecs_cmap_att_courseType";s:11:"Course Type";s:28:"ecs_cmap_att_degreeProgramme";s:16:"Degree Programme";s:19:"ecs_cmap_att_module";s:6:"Module";s:18:"ecs_cmap_att_venue";s:5:"Venue";s:20:"ecs_cmap_delete_rule";s:14:"Delete Mapping";s:16:"ecs_server_title";s:25:"Name of ECS Configuration";s:13:"ecs_no_adv_md";s:32:"No Advanced Meta Data available.";s:19:"ecs_token_mechanism";s:20:"Authentication Token";s:24:"ecs_token_mechanism_info";s:110:"If enabled, the authentication on the hosting platform for remote objects, is done by the ECS-Token-Mechanism.";s:17:"ecs_part_settings";s:25:"Settings for Participant:";s:16:"ecs_export_types";s:23:"Exportable Object Types";s:16:"ecs_import_types";s:23:"Importable Object Types";s:20:"ecs_deprecated_token";s:43:"Support for Deprecated Authentication Token";s:25:"ecs_deprecated_token_info";s:128:"Offers support for installations (e.g ILIAS installations of version 4.x) which use a deprecated token authentication mechanism.";s:24:"ecs_refresh_participants";s:24:"Refresh ECS-Participants";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'exc'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:208:{s:18:"exc_add_assignment";s:14:"Add Assignment";s:21:"exc_add_feedback_file";s:23:"Deposit a Feedback File";s:19:"exc_add_participant";s:15:"Add Participant";s:19:"exc_assignment_view";s:15:"Assignment View";s:14:"exc_assignment";s:10:"Assignment";s:23:"exc_assignments_deleted";s:34:"The assignments have been deleted.";s:15:"exc_assignments";s:11:"Assignments";s:24:"exc_conf_del_assignments";s:55:"Do you really want to delete the following assignments?";s:12:"exc_deadline";s:8:"Deadline";s:19:"exc_edit_assignment";s:15:"Edit Assignment";s:20:"exc_edit_assignments";s:16:"Edit Assignments";s:19:"exc_edit_submission";s:15:"Edit Submission";s:12:"exc_ended_on";s:8:"Ended On";s:16:"exc_export_excel";s:14:"Export (Excel)";s:12:"exc_fb_files";s:14:"Feedback Files";s:19:"exc_grades_overview";s:11:"Grades View";s:10:"exc_grades";s:15:"Grades Overview";s:11:"exc_hand_in";s:7:"Hand In";s:19:"exc_list_submission";s:20:"List All Submissions";s:23:"exc_mail_permanent_link";s:51:"Click on the following link to access the exercise:";s:10:"exc_manage";s:6:"Manage";s:18:"exc_mandatory_info";s:64:"Mandatory assignments must be passed to pass the whole exercise.";s:13:"exc_mandatory";s:9:"Mandatory";s:10:"exc_min_nr";s:21:"Number of Assignments";s:25:"exc_msg_all_mandatory_ass";s:61:"You must pass all mandatory assignments to pass the exercise.";s:24:"exc_msg_failed_mandatory";s:48:"You failed in at least one mandatory assignment.";s:22:"exc_msg_min_number_ass";s:63:"You must pass a minimum of %s assignments to pass the exercise.";s:29:"exc_msg_missed_minimum_number";s:51:"You did not pass the minimum number of assignments.";s:34:"exc_msg_new_feedback_file_uploaded";s:52:"A new feedback file has been added to exercise "%s".";s:35:"exc_msg_new_feedback_file_uploaded2";s:49:"a tutor has uploaded a new feedback file for you.";s:28:"exc_msg_participants_removed";s:53:"The participants have been removed from the exercise.";s:25:"exc_msg_public_submission";s:53:"All submissions will be published after the deadline.";s:20:"exc_msg_saved_grades";s:36:"Grades and comments have been saved.";s:36:"exc_msg_sure_to_deassign_participant";s:144:"Are you sure that you want to remove the participants from all assignments of the exercise? This will also delete all their handed in resources!";s:18:"exc_new_assignment";s:14:"New Assignment";s:19:"exc_no_participants";s:36:"There are currently no participants.";s:21:"exc_order_by_deadline";s:17:"Order by Deadline";s:12:"exc_overview";s:8:"Overview";s:20:"exc_participant_view";s:16:"Participant View";s:15:"exc_participant";s:11:"Participant";s:17:"exc_pass_all_info";s:62:"All mandatory assignments must be passed to pass the exercise.";s:12:"exc_pass_all";s:25:"All Mandatory Assignments";s:24:"exc_pass_minimum_nr_info";s:145:"A minimum number of assignments must be passed to pass the exercise. This value must be equal or higher than the number of mandatory assignments.";s:19:"exc_pass_minimum_nr";s:29:"Minimum Number of Assignments";s:13:"exc_pass_mode";s:9:"Pass Mode";s:22:"exc_presentation_order";s:18:"Presentation Order";s:21:"exc_public_submission";s:18:"Public Submissions";s:14:"exc_save_order";s:10:"Save Order";s:15:"exc_saved_order";s:25:"Saved presentation order.";s:14:"exc_select_ass";s:17:"Select Assignment";s:15:"exc_select_part";s:18:"Select Participant";s:19:"exc_send_assignment";s:23:"Send Assignment by Mail";s:25:"exc_show_submissions_info";s:59:"Publish all submissions to all learners after the deadline.";s:20:"exc_show_submissions";s:34:"Publish Submissions after Deadline";s:14:"exc_start_time";s:10:"Start Time";s:15:"exc_starting_on";s:11:"Starting On";s:26:"exc_submissions_and_grades";s:22:"Submissions and Grades";s:27:"exc_submitted_files_deleted";s:37:"The selected files have been deleted.";s:13:"exc_total_exc";s:14:"Total Exercise";s:27:"exc_submission_notification";s:33:"Email Notification on Submissions";s:32:"exc_submission_notification_info";s:138:"You will be notified when submissions are uploaded. This is a personal setting which does not affect other administrators of the exercise.";s:32:"exc_submission_notification_body";s:47:"A new submission was uploaded for exercise "%s"";s:32:"exc_submission_notification_link";s:20:"Link to Exercise: %s";s:35:"exc_submission_notification_subject";s:47:"A new submission was uploaded for exercise "%s"";s:10:"exc_import";s:15:"Import Exercise";s:28:"exc_completion_by_submission";s:23:"Completed by Submission";s:33:"exc_completion_by_submission_info";s:198:"If enabled, the submission of at least one file causes the completion of an assignment. The score could be manually changed later. Switching this setting does not effect already submitted solutions.";s:15:"exc_type_upload";s:6:"Upload";s:13:"exc_type_blog";s:4:"Blog";s:18:"exc_type_portfolio";s:9:"Portfolio";s:17:"exc_blog_returned";s:15:"Assignment Blog";s:22:"exc_portfolio_returned";s:20:"Assignment Portfolio";s:15:"exc_create_blog";s:11:"Create Blog";s:20:"exc_create_portfolio";s:16:"Create Portfolio";s:27:"exc_create_blog_select_info";s:53:"Please select the resource folder to add the blog to.";s:32:"exc_create_portfolio_select_info";s:58:"Please select the resource folder to add the portfolio to.";s:16:"exc_blog_created";s:17:"Blog was created.";s:21:"exc_portfolio_created";s:22:"Portfolio was created.";s:15:"exc_select_blog";s:17:"Use Existing Blog";s:20:"exc_select_portfolio";s:22:"Use Existing Portfolio";s:20:"exc_select_blog_info";s:63:"Please select one of your blogs to use it with this assignment.";s:25:"exc_select_portfolio_info";s:68:"Please select one of your portfolios to use it with this assignment.";s:22:"exc_select_blog_change";s:18:"Use different blog";s:27:"exc_select_portfolio_change";s:23:"Use different portfolio";s:17:"exc_blog_selected";s:27:"The blog has been assigned.";s:22:"exc_portfolio_selected";s:32:"The portfolio has been assigned.";s:16:"exc_search_users";s:12:"Search Users";s:22:"exc_direct_submit_blog";s:120:"Would you like to submit the current version of the blog right now? You can do it anytime from the blog editor later on.";s:27:"exc_direct_submit_portfolio";s:130:"Would you like to submit the current version of the portfolio right now? You can do it anytime from the portfolio editor later on.";s:28:"exc_no_assignments_available";s:102:"No assignments created yet. Please open ‘Assignments’ and ‘Edit’ to create a first assignment.";s:25:"exc_no_deadline_specified";s:22:"No deadline specified.";s:20:"exc_type_upload_team";s:11:"Team Upload";s:8:"exc_team";s:4:"Team";s:19:"exc_team_member_add";s:24:"Add Team Member (Search)";s:29:"exc_team_member_container_add";s:33:"Add Team Member from Course/Group";s:16:"exc_team_members";s:12:"Team Members";s:21:"exc_team_at_least_one";s:39:"There has to be at least 1 team member.";s:12:"exc_team_log";s:8:"Team Log";s:26:"exc_team_log_remove_member";s:18:"Removed member %s.";s:23:"exc_team_log_add_member";s:16:"Added member %s.";s:24:"exc_team_log_create_team";s:13:"Team created.";s:21:"exc_team_log_add_file";s:14:"Added file %s.";s:24:"exc_team_log_remove_file";s:16:"Removed file %s.";s:8:"exc_copy";s:13:"Copy Exercise";s:32:"exc_team_notification_salutation";s:9:"Hello %s,";s:33:"exc_team_notification_subject_add";s:58:"Added as team member to upload assignment of exercise "%s"";s:30:"exc_team_notification_body_add";s:48:"you have been added to a team upload assignment.";s:33:"exc_team_notification_subject_rmv";s:54:"Removed from a team upload assignment of exercise "%s"";s:30:"exc_team_notification_body_rmv";s:53:"you have been removed from  a team upload assignment.";s:32:"exc_team_notification_changed_by";s:17:"Status changed by";s:26:"exc_team_notification_link";s:16:"Link to exercise";s:13:"exc_type_text";s:4:"Text";s:23:"exc_files_returned_text";s:15:"Assignment Text";s:24:"exc_text_assignment_edit";s:9:"Edit Text";s:24:"exc_text_assignment_show";s:9:"Show Text";s:15:"exc_peer_review";s:13:"Peer-Feedback";s:20:"exc_peer_review_info";s:42:"Not available for team upload assignments.";s:26:"exc_peer_review_min_number";s:58:"Number of feedback given required to see personal feedback";s:20:"exc_peer_review_give";s:13:"Give Feedback";s:24:"exc_peer_review_no_peers";s:40:"There are no peers to give feedback for.";s:22:"exc_peer_review_rating";s:6:"Rating";s:23:"exc_peer_review_updated";s:29:"Your feedback has been saved.";s:34:"exc_peer_review_show_not_rated_yet";s:68:"You must give feedback before you can see the feedback you received.";s:20:"exc_peer_review_show";s:22:"Show Received Feedback";s:18:"exc_needs_deadline";s:56:"This feature does only work with an assignment deadline.";s:29:"exc_team_upload_not_supported";s:54:"This feature does not support team upload assignments.";s:24:"exc_global_feedback_file";s:15:"Sample Solution";s:29:"exc_global_feedback_file_cron";s:12:"Notification";s:34:"exc_global_feedback_file_cron_info";s:86:"All learners will be notified via cron job when the sample solution becomes available.";s:33:"exc_feedback_notification_subject";s:53:"Feedback is available for assignment of exercise "%s"";s:36:"exc_feedback_notification_salutation";s:9:"Hello %s,";s:30:"exc_feedback_notification_body";s:55:"Feedback is now available for the following assignment.";s:30:"exc_feedback_notification_link";s:16:"Link to exercise";s:32:"exc_feedback_notification_reason";s:91:"You are receiving this email because you are a participant of the exercise mentioned above.";s:28:"exc_team_notification_reason";s:91:"You are receiving this email because you are a participant of the exercise mentioned above.";s:37:"exc_peer_review_no_peers_reviewed_yet";s:32:"There was no feedback given yet.";s:32:"exc_peer_review_ass_setting_info";s:58:"If enabled, users can rate their peers after the deadline.";s:24:"exc_peer_review_deadline";s:17:"Feedback Deadline";s:29:"exc_peer_review_deadline_info";s:92:"Feedback can be given up to this date and received feedback is only accessible from then on.";s:36:"exc_peer_review_deadline_info_button";s:12:"Deadline: %s";s:32:"exc_peer_review_deadline_reached";s:20:"Feedback time is up.";s:23:"exc_peer_review_comment";s:11:"My Feedback";s:28:"exc_peer_review_missing_info";s:67:"To see your received feedback, you still have to give %s feedbacks.";s:37:"exc_peer_review_missing_info_deadline";s:102:"To see your received feedback, you still have to give %1$s feedbacks. Access will be granted on: %2$s.";s:18:"exc_multi_feedback";s:14:"Multi-Feedback";s:26:"exc_download_zip_structure";s:22:"Download ZIP Structure";s:23:"exc_multi_feedback_file";s:19:"Multi-Feedback File";s:24:"exc_multi_feedback_files";s:20:"Multi-Feedback Files";s:17:"exc_fb_tutor_info";s:136:"When a feedback file is uploaded, a notification is sent to the user and the feedback file will be listed in the user\'s assignment view.";s:12:"exc_save_all";s:8:"Save All";s:17:"exc_save_selected";s:13:"Save Selected";s:15:"exc_no_team_yet";s:22:"Not assigned to a team";s:32:"exc_no_feedback_dir_found_in_zip";s:75:"The directory structure of the uploaded zip-archive could not be processed.";s:20:"exc_multi_feedb_info";s:527:"On this screen you can upload multiple feedbacks in one file. First click on ‘Download ZIP Structure’, save the ZIP file and extract it on your local computer. Put the feedback files into the corresponding user directories. Now compress the whole directory as one ZIP file again. Browse your local filesystem for the file and select it as the ‘Multi-Feedback File’ in the form below. After that click ‘Upload’. A confirmation screen will list the files. Please avoid using any special characters in your file names.";s:27:"exc_team_member_remove_sure";s:154:"Are you sure you want to remove the following members of your team? Please be aware that all files they have uploaded will also be removed from your team.";s:15:"exc_create_team";s:11:"Create Team";s:32:"exc_create_team_times_up_warning";s:61:"You cannot create a team anymore - please contact your tutor.";s:21:"exc_instruction_files";s:17:"Instruction Files";s:25:"exc_peer_review_cron_info";s:83:"If activated, exercise participants will be reminded to give pending peer feedback.";s:24:"exc_list_text_assignment";s:20:"List All Submissions";s:20:"exc_show_peer_review";s:18:"Show Peer-Feedback";s:32:"exc_create_portfolio_no_template";s:19:"Do not use template";s:16:"exc_notification";s:21:"Personal Notification";s:15:"exc_passing_exc";s:20:"Passing the Exercise";s:14:"exc_publishing";s:10:"Publishing";s:15:"exc_min_nr_info";s:77:"This value must be equal or higher than the number of compulsory assignments.";s:31:"exc_passed_status_determination";s:36:"Determination of Status ‘Passed’";s:23:"exc_completion_by_tutor";s:20:"Only manual by tutor";s:13:"exc_your_text";s:9:"Your Text";s:31:"exc_peer_review_min_number_info";s:125:"This number of other users work must be evaluated by a participant before the evaluation of his/her own work will be visible.";s:20:"exc_peer_review_file";s:11:"File Upload";s:25:"exc_peer_review_file_info";s:40:"Enable peers to upload 1 file per review";s:24:"exc_peer_review_personal";s:26:"Personalized Peer-Feedback";s:29:"exc_peer_review_personal_info";s:30:"Peers are shown with full name";s:25:"exc_peer_review_recipient";s:18:"Feedback Recipient";s:21:"exc_peer_review_giver";s:14:"Feedback Giver";s:29:"exc_global_feedback_file_date";s:12:"Availability";s:38:"exc_global_feedback_file_date_deadline";s:14:"After deadline";s:36:"exc_global_feedback_file_date_upload";s:16:"After submission";s:18:"exc_note_for_tutor";s:15:"Note for Tutors";s:28:"exc_comment_for_learner_edit";s:30:"Enter in Text Field as Comment";s:28:"exc_comment_for_learner_info";s:97:"A notification is sent to the user and the feedback will be listed in the user\'s assignment view.";s:34:"exc_msg_new_feedback_text_uploaded";s:46:"A new comment has been added to exercise "%s".";s:35:"exc_msg_new_feedback_text_uploaded2";s:40:"a tutor has added a new comment for you.";s:20:"exc_peer_upload_file";s:11:"Add file(s)";s:18:"exc_peer_edit_file";s:12:"Edit file(s)";s:20:"exc_no_team_yet_info";s:83:"You can create a team yourself or be added to an existing team by its team members.";s:25:"exc_team_assignment_adopt";s:36:"Adopt teams from existing assignment";s:30:"exc_team_assignment_adopt_none";s:22:"Do not adopt any teams";s:31:"exc_team_assignment_adopt_teams";s:5:"Teams";s:30:"exc_team_assignment_adopt_user";s:26:"Adopt team from assignment";s:35:"exc_team_assignment_adopt_none_user";s:15:"Create new team";s:42:"exc_team_assignment_adopt_already_assigned";s:16:"already assigned";s:26:"exc_peer_deadline_mismatch";s:122:"As feedback is given after the deadline has passed the feedback deadline must not be earlier than the assignment deadline.";s:32:"exc_peer_reviews_invalid_warning";s:19:"Invalid Peer Groups";s:24:"exc_peer_review_overview";s:16:"Show Peer Groups";s:38:"exc_peer_review_overview_invalid_users";s:13:"Invalid Users";s:29:"exc_peer_review_missing_users";s:60:"Users with submissions who are not part of the peer-feedback";s:34:"exc_peer_review_not_returned_users";s:63:"Users without submissions who are not part of the peer-feedback";s:32:"exc_peer_review_invalid_peer_ids";s:80:"Peer recipients who are not exercise members anymore or do not have a submission";s:33:"exc_peer_review_invalid_giver_ids";s:76:"Peer givers who are not exercise members anymore or do not have a submission";s:21:"exc_peer_review_reset";s:30:"Delete and Reset Peer-Feedback";s:26:"exc_peer_review_reset_sure";s:83:"Are you sure you want to delete the complete peer-feedback for the assignment "%s"?";s:26:"exc_peer_review_reset_done";s:67:"All Peer-Feedback-related data has been deleted for the assignment.";s:19:"exc_assignment_type";s:18:"Type of Submission";s:22:"exc_no_team_yet_notice";s:35:"You are not assigned to a team yet!";s:15:"exc_manage_team";s:11:"Manage Team";s:17:"exc_direct_submit";s:6:"Submit";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'exercise'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:14:{s:23:"exc_comment_for_learner";s:19:"Comment for Learner";s:11:"exc_comment";s:7:"Comment";s:19:"exc_crs_add_members";s:27:"Add Users of Current Course";s:10:"exc_failed";s:6:"Failed";s:23:"exc_feedback_from_tutor";s:19:"Feedback from Tutor";s:11:"exc_grading";s:7:"Grading";s:8:"exc_mark";s:4:"Mark";s:13:"exc_notgraded";s:10:"Not Graded";s:10:"exc_passed";s:6:"Passed";s:13:"exc_send_mail";s:12:"Send as Mail";s:19:"exc_your_submission";s:15:"Your Submission";s:40:"exc_start_date_should_be_before_end_date";s:37:"Start time should be before deadline.";s:19:"exc_to_desktop_info";s:52:"Add exercise to desktop of participant after hand-in";s:18:"exc_admin_settings";s:23:"Exercise Administration";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'form'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:41:{s:9:"form_days";s:4:"Days";s:15:"form_file_input";s:10:"File Input";s:11:"form_format";s:6:"Format";s:27:"form_hierarchy_add_elements";s:42:"Click on placeholders to add new elements.";s:29:"form_hierarchy_drag_drop_help";s:53:"Drag and drop icons on placeholders to move elements.";s:10:"form_hours";s:5:"Hours";s:21:"form_image_file_input";s:16:"Image File Input";s:14:"form_max_value";s:13:"Maximum Value";s:14:"form_min_value";s:13:"Minimum Value";s:12:"form_minutes";s:7:"Minutes";s:11:"form_months";s:6:"Months";s:34:"form_msg_file_cannot_write_to_disk";s:21:"Cannot write to disk.";s:29:"form_msg_file_missing_tmp_dir";s:44:"Temporary directory for file upload missing.";s:23:"form_msg_file_no_upload";s:56:"This input is required. Please select a file for upload.";s:32:"form_msg_file_partially_uploaded";s:42:"The file could not be uploaded completely.";s:26:"form_msg_file_size_exceeds";s:53:"The uploaded file exceeds the max. allowed file size.";s:32:"form_msg_file_upload_stopped_ext";s:33:"File upload stopped by extension.";s:25:"form_msg_file_virus_found";s:29:"Virus found in uploaded file.";s:29:"form_msg_file_wrong_file_type";s:16:"Wrong file type.";s:28:"form_msg_formula_is_required";s:31:"Please enter a correct formula.";s:31:"form_msg_numeric_value_required";s:29:"Please enter a numeric value.";s:23:"form_msg_value_too_high";s:43:"Value too high. Please enter a lower value.";s:22:"form_msg_value_too_low";s:43:"Value too low. Please enter a higher value.";s:26:"form_msg_wrong_date_format";s:49:"Wrong date format. Please enter the date as "%s"!";s:19:"form_msg_wrong_date";s:38:"Wrong date. Please enter a valid date.";s:34:"form_password_not_allowed_for_auth";s:79:"It is not possible to change the password for the chosen authentication method.";s:31:"form_password_required_for_auth";s:58:"Password is required for the chosen authentication method.";s:20:"form_retype_password";s:15:"Retype Password";s:12:"form_seconds";s:7:"Seconds";s:17:"form_alphabet_all";s:3:"All";s:18:"form_please_select";s:13:"Please Select";s:18:"form_link_internal";s:12:"Inside ILIAS";s:18:"form_link_external";s:14:"World Wide Web";s:13:"form_get_link";s:20:"Select Target Object";s:17:"form_retype_email";s:12:"Retype Email";s:15:"email_not_match";s:83:"Your entries for the email address don\'t match! Please re-enter your email address.";s:12:"captcha_code";s:17:"User Verification";s:20:"form_location_radius";s:6:"Radius";s:23:"form_location_radius_km";s:2:"km";s:16:"form_open_answer";s:11:"Open Answer";s:22:"form_hier_click_to_add";s:31:"Click here to add new elements.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'grp'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:162:{s:16:"crs_add_grouping";s:25:"Add Membership Limitation";s:24:"crs_grouping_delete_sure";s:60:"Are you sure you want to delete this membership limitation ?";s:20:"crs_grouping_deleted";s:30:"Deleted membership limitation.";s:23:"crs_grouping_select_one";s:40:"Please select one membership limitation.";s:22:"crs_grp_added_grouping";s:32:"Added new membership limitation.";s:18:"crs_grp_assign_crs";s:20:"Assignment of Groups";s:19:"crs_grp_enter_title";s:36:"Please fill out all required fields.";s:27:"crs_grp_no_courses_assigned";s:18:"No Groups Assigned";s:30:"crs_grp_table_assigned_courses";s:15:"Assigned Groups";s:26:"grouping_change_assignment";s:17:"Change Assignment";s:26:"grp_accept_subscriber_body";s:47:"You have been admitted to group "%1$s".\\n\\n%2$s";s:21:"grp_accept_subscriber";s:23:"Admission to group "%s"";s:17:"grp_added_to_list";s:110:"You have been assigned to the waiting list of group "%s". You are assigned to position %s on the waiting list.";s:10:"grp_admins";s:14:"Administrators";s:20:"grp_already_assigned";s:53:"You have already requested membership for this group.";s:25:"grp_cancel_subscr_request";s:25:"Delete Membership Request";s:15:"grp_change_type";s:17:"Change Group Type";s:15:"grp_closed_info";s:37:"Group is not visible for non-members.";s:10:"grp_closed";s:12:"Closed Group";s:17:"grp_delete_member";s:6:"Delete";s:24:"grp_deleted_export_files";s:21:"Deleted export files.";s:16:"grp_edit_members";s:17:"Edit Participants";s:14:"grp_enable_map";s:16:"Enable Group Map";s:24:"grp_general_informations";s:19:"General Information";s:16:"grp_grp_info_reg";s:45:"You can only register to one of these groups:";s:23:"grp_header_waiting_list";s:12:"Waiting List";s:17:"grp_icon_settings";s:13:"Icon Settings";s:17:"grp_info_settings";s:17:"Group Information";s:20:"grp_information_info";s:73:"This information will be show on the info page and for new registrations.";s:15:"grp_information";s:21:"Important Information";s:16:"grp_join_request";s:4:"Send";s:16:"grp_lim_assigned";s:42:"Already assigned to associated group "%s".";s:26:"grp_mail_admission_new_bod";s:64:"we are pleased to announce your registration for the group "%s".";s:26:"grp_mail_admission_new_sub";s:32:"Your registration for group "%s"";s:20:"grp_mail_dismiss_bod";s:50:"your membership in group "%s" has been terminated.";s:20:"grp_mail_dismiss_sub";s:35:"Membership terminated in group "%s"";s:29:"grp_mail_notification_reg_bod";s:33:"%s has registered for group "%s".";s:33:"grp_mail_notification_reg_req_bod";s:43:"%s has requested membership for group "%s".";s:34:"grp_mail_notification_reg_req_bod2";s:36:"To confirm this registration, go to:";s:33:"grp_mail_notification_reg_req_sub";s:26:"Request to join group "%s"";s:29:"grp_mail_notification_reg_sub";s:30:"User registered for group "%s"";s:31:"grp_mail_notification_unsub_bod";s:55:"%s has cancelled his/her membership for the group "%s".";s:32:"grp_mail_notification_unsub_bod2";s:153:"There might be other members on a waiting list of your group.\\nYou should check for the waiting list now.\\nTo view the members of your group, click here:";s:31:"grp_mail_notification_unsub_sub";s:20:"User left group "%s"";s:23:"grp_mail_permanent_link";s:88:"Click on the following link to find all of the information you need regarding the group:";s:19:"grp_mail_status_bod";s:43:"your status in group "%s" has been changed.";s:19:"grp_mail_status_sub";s:28:"Changed status in group "%s"";s:20:"grp_mail_sub_acc_bod";s:63:"we are pleased to confirm your registration for the group "%s".";s:20:"grp_mail_sub_acc_sub";s:31:"Registration confirmed for "%s"";s:20:"grp_mail_sub_dec_bod";s:72:"we regret to say that your registration has been refused for group "%s".";s:20:"grp_mail_sub_dec_sub";s:35:"Registration refused for group "%s"";s:29:"grp_mail_subscribe_member_bod";s:63:"we are pleased to confirm your registration for the group "%s".";s:29:"grp_mail_subscribe_member_sub";s:32:"Your registration for group "%s"";s:31:"grp_mail_unsubscribe_member_bod";s:126:"we confirm your cancellation of membership in group %s.\\nWe hope that you find an opportunity to participate in another group.";s:31:"grp_mail_unsubscribe_member_sub";s:45:"Your cancellation of membership in group "%s"";s:15:"grp_mail_wl_bod";s:209:"you have been assigned to the waiting list of group "%s".\\nYou are assigned to position %s on the list.\\n\\nYou will receive a message from a group administrator when your request has been approved or rejected.";s:15:"grp_mail_wl_sub";s:32:"Your registration for group "%s"";s:16:"grp_map_location";s:18:"Group Map Location";s:16:"grp_map_settings";s:12:"Map Settings";s:15:"grp_members_map";s:17:"Group Members Map";s:11:"grp_members";s:7:"Members";s:17:"grp_min_one_admin";s:66:"There has to be at least one administrator assigned to this group.";s:20:"grp_missing_grp_type";s:27:"Please choose a group type.";s:20:"grp_missing_password";s:30:"Please enter a group password.";s:17:"grp_missing_title";s:27:"Please enter a group title.";s:14:"grp_new_status";s:19:"Your new status is:";s:34:"grp_notification_explanation_admin";s:90:"You receive mail from ILIAS because you are group administrator with notification enabled.";s:16:"grp_notification";s:12:"Notification";s:14:"grp_notify_off";s:45:"Notification about new registrations disabled";s:13:"grp_notify_on";s:44:"Notification about new registrations enabled";s:13:"grp_open_info";s:53:"Non-members can see this group and join it directly..";s:8:"grp_open";s:10:"Open Group";s:16:"grp_pass_request";s:24:"Join With Group Password";s:15:"grp_public_info";s:73:"Group is visible for non-members but has special requirements to join it.";s:10:"grp_public";s:12:"Public Group";s:24:"grp_reg_deac_info_screen";s:27:"Group admittance is closed.";s:26:"grp_reg_direct_info_screen";s:33:"You can join this group directly.";s:19:"grp_reg_direct_info";s:20:"Direct registration.";s:14:"grp_reg_direct";s:19:"Direct Registration";s:21:"grp_reg_disabled_info";s:53:"Only group administrators can add users to the group.";s:16:"grp_reg_disabled";s:24:"No Registration Possible";s:11:"grp_reg_end";s:17:"Registration End:";s:22:"grp_reg_limit_num_info";s:27:"Limited Registration Period";s:17:"grp_reg_limit_num";s:23:"Maximum Number of Users";s:18:"grp_reg_limit_time";s:7:"Enabled";s:15:"grp_reg_limited";s:27:"Limited Registration Period";s:24:"grp_reg_max_members_info";s:70:"Define the maximum number of users that can be assigned to this group.";s:26:"grp_reg_passwd_info_screen";s:83:"If a group administrator has given you the group password, you can join this group.";s:21:"grp_reg_password_info";s:59:"Users need to type in this password when joining the group.";s:14:"grp_reg_period";s:24:"Self-Registration Period";s:23:"grp_reg_req_info_screen";s:141:"You can request membership for this group. You will get a message from a group administrator when your request has been admitted or declined.";s:20:"grp_reg_request_info";s:67:"Interested users can send a request/message to group administrator.";s:15:"grp_reg_request";s:18:"Request Membership";s:13:"grp_reg_start";s:19:"Registration Start:";s:15:"grp_reg_subject";s:7:"Message";s:26:"grp_registration_unlimited";s:9:"Unlimited";s:16:"grp_search_users";s:11:"Search User";s:19:"grp_select_one_file";s:23:"Please select one file.";s:18:"grp_selected_users";s:21:"Selected Participants";s:23:"grp_set_on_waiting_list";s:153:"You can add your join request to the waiting list. You will receive a message from a group administrator when your request has been approved or rejected.";s:12:"grp_settings";s:14:"Group Settings";s:7:"grp_typ";s:10:"Group Type";s:21:"grp_type_changed_info";s:59:"Changing the group type will reset all permission settings.";s:15:"grp_unsubscribe";s:11:"Unsubscribe";s:25:"grp_update_subscr_request";s:25:"Update Membership Request";s:15:"grp_users_added";s:24:"Added user to the group.";s:26:"grp_users_already_assigned";s:44:"The user is already assigned to this  group.";s:27:"grp_users_removed_from_list";s:59:"The selected users have been removed from the waiting list.";s:21:"grp_waiting_list_info";s:107:"If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.";s:16:"grp_waiting_list";s:12:"Waiting List";s:25:"grp_warn_grp_type_changed";s:83:"Do you really want to change the group type? All permission settings will be reset.";s:35:"grp_warn_no_max_set_on_waiting_list";s:202:"The maximum number of group members is exceeded. You can add your join request to the waiting list. You will receive a message from a group administrator when your request has been approved or rejected.";s:31:"grp_warn_wl_set_on_waiting_list";s:206:"Some users are already assigned to the waiting list. You can add your join request to the waiting list. You will receive a message from a group administrator when your request has been approved or rejected.";s:21:"grp_wrong_max_members";s:41:"Please check the maximum number of users.";s:24:"grp_wrong_reg_time_limit";s:52:"Please check the registration start and finish time.";s:25:"reg_grp_max_members_short";s:17:"Number of Members";s:19:"reg_grp_max_members";s:25:"Limited Number of Members";s:27:"grp_notification_salutation";s:23:"Dear group participant,";s:22:"grp_custom_user_fields";s:24:"Group Relevant User Data";s:12:"grp_reg_code";s:18:"Admission per Link";s:17:"grp_reg_code_link";s:25:"Link for Direct Admission";s:18:"grp_reg_code_value";s:4:"Link";s:25:"grp_reg_code_enabled_info";s:129:"Besides the chosen registration procedure and permissions this option allows users to enter directly by using the following link.";s:21:"grp_info_new_grp_type";s:14:"New Group Type";s:23:"grp_user_agreement_info";s:46:"Visible Personal Data for Group Administrators";s:14:"grp_info_agree";s:73:"I accept, that the above data types are visible for group administrators.";s:18:"grp_info_agreement";s:62:"The following data types are visible for group administrators:";s:20:"grp_agreement_header";s:14:"User Agreement";s:18:"grp_user_agreement";s:19:"Released Data Types";s:9:"grp_agree";s:10:"Acceptance";s:18:"grp_export_members";s:19:"Export Participants";s:15:"grp_role_status";s:11:"Role/Status";s:14:"grp_subscriber";s:10:"Subscriber";s:22:"grp_agreement_required";s:79:"You have to accept the user agreement, if you want to access the group content.";s:10:"grp_import";s:12:"Import Group";s:31:"grp_setting_header_presentation";s:18:"Group Presentation";s:31:"grp_setting_header_registration";s:18:"Group Registration";s:21:"grp_view_info_by_type";s:60:"This content presentation groups all items by resource type.";s:20:"grp_view_info_simple";s:55:"This content presentation lists all items in one block.";s:21:"grp_presentation_type";s:17:"Presentation Type";s:16:"grp_view_inherit";s:7:"Default";s:21:"grp_view_inherit_info";s:60:"The group presentation type is adopted from a parent course.";s:25:"grp_activate_notification";s:21:"Activate Notification";s:27:"grp_deactivate_notification";s:23:"Deactivate Notification";s:26:"grp_notification_activated";s:22:"Notification Activated";s:28:"grp_notification_deactivated";s:24:"Notification Deactivated";s:14:"grp_print_list";s:13:"Generate List";s:23:"grp_members_print_title";s:13:"Group Members";s:8:"grp_copy";s:10:"Copy Group";s:6:"events";s:8:"Sessions";s:13:"grp_mail_type";s:15:"Mail to Members";s:20:"grp_mail_tutors_only";s:23:"For Administrators only";s:12:"grp_mail_all";s:20:"For all Participants";s:18:"grp_reg_no_selfreg";s:17:"No Self-enrolment";s:25:"grp_mail_tutors_only_info";s:87:"Only administrators can use the feature ‘Mail to Members’ in the ‘Members’ tab.";s:17:"grp_mail_all_info";s:94:"Members and administrators can use the feature ‘Mail to Members’ in the ‘Members’ tab.";s:19:"grp_cdf_edit_member";s:29:"Edit Group Relevant User Data";s:21:"grp_cdf_tbl_last_edit";s:33:"Last Update (Group-specific Data)";s:46:"grp_admission_link_failure_registration_period";s:52:"Can\'t register: Group is out of registration period.";s:45:"grp_admission_link_failure_membership_limited";s:44:"Can\'t register: Group membership is limited.";s:39:"grp_admission_link_success_registration";s:38:"Successfully registered to group "%s".";s:17:"grp_usr_agreement";s:14:"User Agreement";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'mail'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:182:{s:35:"activate_serial_letter_placeholders";s:35:"Activate Serial-Letter Placeholders";s:24:"advice_mail_body_secured";s:130:"Because of security reasons ILIAS removed some elements of your message. Please check the secured message and send the mail again.";s:13:"also_as_email";s:14:"Also as E-Mail";s:2:"bc";s:3:"BCC";s:14:"back_to_folder";s:14:"Back to Folder";s:14:"current_folder";s:18:"Current Folder: %s";s:28:"chat_users_have_been_invited";s:38:"The following users have been invited:";s:24:"chat_users_without_login";s:84:"The following users don\'t have an ILIAS account and can\'t be invited to a chat room:";s:29:"chat_users_without_permission";s:64:"The following users don\'t have access to the selected chat room:";s:7:"forward";s:7:"Forward";s:20:"goto_invitation_chat";s:14:"Open Chat Room";s:33:"info_mail_external_sender_noreply";s:255:"Please enter the e-mail that shall be used as sender\'s address for automatically created system messages and notifications send by e-mail. <b<Note</b>: Use only a real existing address to avoid the rejection of such mails by spam filters and mail servers,";s:14:"invite_to_chat";s:14:"Invite to Chat";s:9:"linebreak";s:10:"Line break";s:23:"mail_account_mail_check";s:17:"Send Account Mail";s:17:"mail_account_mail";s:12:"Account Mail";s:18:"mail_add_recipient";s:24:"Please enter a recipient";s:18:"mail_add_subfolder";s:14:"Add Sub-folder";s:16:"mail_add_subject";s:22:"Please enter a subject";s:23:"mail_add_to_addressbook";s:15:"Add to Contacts";s:13:"mail_add_type";s:44:"Please add the type of mail you want to send";s:17:"mail_addr_entries";s:7:"Entries";s:33:"mail_assign_entry_to_mailing_list";s:48:"Assign an Entry of Your Contacts to Mailing List";s:16:"mail_attachments";s:11:"Attachments";s:24:"mail_auto_generated_info";s:72:"This mail was automatically sent to you by the ILIAS installation %s, %s";s:17:"mail_bc_not_valid";s:30:"The BCC recipient is not valid";s:14:"mail_bc_search";s:10:"BCC search";s:9:"mail_byte";s:4:"Byte";s:17:"mail_cc_not_valid";s:29:"The CC recipient is not valid";s:14:"mail_cc_search";s:9:"CC search";s:21:"mail_change_to_folder";s:17:"Switch to folder:";s:26:"mail_check_your_email_addr";s:32:"Your e-mail address is not valid";s:12:"mail_compose";s:15:"Compose Message";s:30:"mail_cronjob_notification_info";s:61:"You can activate a periodic notification about new mail here.";s:56:"mail_crs_list_members_not_available_for_at_least_one_crs";s:62:"The members of at least one selected course can not be listed.";s:35:"mail_crs_list_members_not_available";s:61:"It is not possible to list the members of the marked courses.";s:18:"mail_deleted_entry";s:23:"The entries are deleted";s:12:"mail_deleted";s:19:"The mail is deleted";s:15:"mail_edit_entry";s:10:"Edit Entry";s:20:"mail_email_forbidden";s:34:"You are not allowed to send e-mail";s:29:"mail_empty_trash_confirmation";s:51:"Are you sure you want to delete all mails in trash?";s:16:"mail_empty_trash";s:11:"Empty Trash";s:30:"mail_enter_login_or_email_addr";s:50:"Please enter a valid login name or e-mail address.";s:27:"mail_enter_valid_email_addr";s:36:"Please enter a valid e-mail address.";s:22:"mail_enter_valid_login";s:32:"Please enter a valid login name.";s:16:"mail_entry_added";s:15:"Added new Entry";s:18:"mail_entry_changed";s:20:"The entry is changed";s:17:"mail_entry_exists";s:50:"An entry with the given login name already exists.";s:25:"mail_entry_of_addressbook";s:17:"Entry of Contacts";s:28:"mail_external_sender_noreply";s:16:"no-reply Address";s:14:"mail_file_name";s:9:"File Name";s:14:"mail_file_size";s:9:"File Size";s:18:"mail_files_deleted";s:23:"The file(s) are deleted";s:19:"mail_folder_created";s:29:"A new folder has been created";s:19:"mail_folder_deleted";s:27:"The folder has been deleted";s:16:"mail_folder_edit";s:11:"Edit Folder";s:18:"mail_folder_exists";s:38:"A folder already exists with this name";s:24:"mail_folder_name_changed";s:27:"The folder has been renamed";s:16:"mail_folder_name";s:11:"Folder name";s:19:"mail_folder_options";s:14:"Folder Options";s:28:"mail_following_rcp_not_valid";s:39:"The following recipients are not valid:";s:19:"mail_global_options";s:14:"Global options";s:18:"mail_group_members";s:13:"Group Members";s:19:"mail_in_addressbook";s:19:"Already in Contacts";s:18:"mail_incoming_both";s:20:"local and forwarding";s:19:"mail_incoming_local";s:10:"only local";s:18:"mail_incoming_mail";s:13:"Incoming mail";s:18:"mail_incoming_smtp";s:25:"forward to e-mail address";s:13:"mail_incoming";s:13:"Incoming mail";s:23:"mail_insert_folder_name";s:27:"Please insert a folder name";s:17:"mail_insert_query";s:21:"Please insert a query";s:11:"mail_intern";s:8:"Internal";s:21:"mail_into_addressbook";s:15:"Add to Contacts";s:25:"mail_invite_users_to_chat";s:20:"Invite Users to Chat";s:17:"mail_list_members";s:12:"List members";s:17:"mail_mailing_list";s:12:"Mailing List";s:51:"mail_mailing_lists_all_addressbook_entries_assigned";s:68:"You have already assigned all of your contacts to this mailing list.";s:41:"mail_mailing_lists_no_addressbook_entries";s:54:"You have no entries in your contacts to add to a list.";s:18:"mail_mailing_lists";s:13:"Mailing Lists";s:14:"mail_mark_read";s:14:"Mark mail read";s:16:"mail_mark_unread";s:16:"Mark mail unread";s:29:"mail_maxsize_attachment_error";s:20:"The upload limit is:";s:30:"mail_members_added_addressbook";s:25:"Members added to Contacts";s:28:"mail_members_of_mailing_list";s:23:"Members of Mailing List";s:17:"mail_message_send";s:12:"Message sent";s:15:"mail_move_error";s:17:"Error moving mail";s:12:"mail_move_to";s:8:"Move to:";s:19:"mail_moved_to_trash";s:28:"Mail has been moved to trash";s:10:"mail_moved";s:23:"The mail has been moved";s:30:"mail_multiple_recipients_found";s:97:"Enter a more specific mail address. ILIAS found multiple possible recipients for this address: %s";s:15:"mail_my_courses";s:10:"My Courses";s:15:"mail_my_entries";s:11:"My Contacts";s:14:"mail_my_groups";s:9:"My Groups";s:21:"mail_my_mailing_lists";s:16:"My Mailing Lists";s:20:"mail_nacc_admin_mail";s:29:"Mail address of Administrator";s:21:"mail_nacc_client_name";s:11:"Client Name";s:19:"mail_nacc_ilias_url";s:19:"URL of ILIAS system";s:15:"mail_nacc_login";s:13:"Login Account";s:21:"mail_nacc_no_pw_block";s:94:"This text block is only included, if the new user account has been created without a password.";s:18:"mail_nacc_pw_block";s:96:"This text block is only included, if the new user account has been created including a password.";s:20:"mail_nacc_salutation";s:10:"Salutation";s:22:"mail_nacc_target_block";s:57:"This text is only included, if a target item is provided.";s:22:"mail_nacc_target_title";s:40:"Title of target item, e.g. course title.";s:21:"mail_nacc_target_type";s:57:"Type of target item, e.g. ‘Course’ for a course item.";s:16:"mail_nacc_target";s:78:"URL of target item, e.g. a linked course that is passed to ILIAS from outside.";s:25:"mail_nacc_use_placeholder";s:64:"The following placeholders may be used (only in Message Content)";s:14:"mail_new_entry";s:9:"New Entry";s:13:"mail_new_file";s:13:"Add new file:";s:22:"mail_no_attach_allowed";s:54:"System messages are not allowed to contain attachments";s:25:"mail_no_attachments_found";s:20:"No attachments found";s:30:"mail_no_permissions_write_smtp";s:47:"You have no permission to write external e-mail";s:23:"mail_no_recipient_found";s:87:"Enter a different mail address. ILIAS couldn\'t find a recipient with this mail address.";s:26:"mail_no_valid_mailing_list";s:21:"No Valid Mailing List";s:25:"mail_notification_subject";s:22:"New mail in your inbox";s:15:"mail_options_of";s:7:"Options";s:18:"mail_options_saved";s:13:"Options saved";s:25:"mail_received_x_new_mails";s:26:"You received %s new mails.";s:24:"mail_recipient_not_valid";s:26:"The recipient is not valid";s:13:"mail_s_unread";s:14:"Unread Mail(s)";s:6:"mail_s";s:7:"Mail(s)";s:25:"mail_salutation_anonymous";s:5:"Hello";s:17:"mail_salutation_f";s:5:"Hello";s:22:"mail_salutation_female";s:61:"Output for placeholder [MAIL_SALUTATION], if gender is female";s:23:"mail_salutation_general";s:61:"Output for placeholder [MAIL_SALUTATION], no gender specified";s:17:"mail_salutation_m";s:5:"Hello";s:20:"mail_salutation_male";s:59:"Output for placeholder [MAIL_SALUTATION], if gender is male";s:17:"mail_salutation_n";s:5:"Hello";s:10:"mail_saved";s:26:"The message has been saved";s:22:"mail_select_attachment";s:41:"Please select an attachment for download.";s:18:"mail_select_course";s:34:"Please select at least one course.";s:17:"mail_select_group";s:33:"Please select at least one group.";s:21:"mail_select_one_entry";s:25:"You must select one entry";s:20:"mail_select_one_file";s:24:"You must select one file";s:26:"mail_select_only_one_entry";s:29:"Please select only one entry.";s:29:"mail_send_with_system_address";s:24:"Send With System Address";s:36:"mail_settings_incoming_type_see_also";s:106:"You can find a further possibility to modify the incoming type of e-mails for users <a href="%s">here</a>.";s:24:"mail_subject_prefix_info";s:93:"Enter a text, which will be prepended to the subject line of outgoing auto generated e-mails.";s:19:"mail_subject_prefix";s:12:"Mail Subject";s:22:"mail_sure_delete_entry";s:54:"Are you sure you want to delete the following entries?";s:21:"mail_sure_delete_file";s:51:"Are you sure you want to delete the selected files?";s:23:"mail_sure_delete_folder";s:54:"The folder and its content will be removed permanently";s:16:"mail_sure_delete";s:51:"Are you sure you want to delete the marked mail(s)?";s:7:"mail_to";s:2:"To";s:22:"mail_user_addr_n_valid";s:44:"Following users have no valid e-mail address";s:19:"placeholders_advise";s:130:"Placeholders are only resolved for recipients in the To field.%sRecipients in the CC and BCC field will get unsolved placeholders.";s:19:"search_bc_recipient";s:20:"Search BCC Recipient";s:19:"search_cc_recipient";s:19:"Search CC Recipient";s:17:"search_recipients";s:17:"Search Recipients";s:12:"send_mail_to";s:7:"Mail to";s:26:"mail_prevent_smtp_globally";s:50:"Globally prevent sending external mails (via SMTP)";s:22:"mail_select_recipients";s:30:"Please select mail recipients:";s:24:"mail_member_notification";s:24:"Participant Notification";s:35:"mail_enable_crs_member_notification";s:19:"Course Notification";s:35:"mail_enable_grp_member_notification";s:18:"Group Notification";s:40:"mail_enable_crs_member_notification_info";s:88:"If enabled, course participants will be notified automatically about membership changes.";s:40:"mail_enable_grp_member_notification_info";s:87:"If enabled, group participants will be notified automatically about membership changes.";s:23:"mail_system_sender_name";s:11:"Sender Name";s:28:"mail_system_sender_name_info";s:253:"Please enter a name. This name will be used for automatically generated messages (internal and external). If you leave the field blank, ILIAS uses the short title of this installation. If the title is not well defined, ‘ILIAS’ is used as the sender.";s:23:"cron_update_addressbook";s:46:"Synchronize address book entries automatically";s:28:"cron_update_addressbook_desc";s:207:"If this option is enabled, users can specify whether address book entries which are related to user accounts, should be synchronized by the cron job. Only data that was released by the User, will be updated.";s:11:"auto_update";s:6:"Update";s:15:"mail_add_folder";s:18:"Add New Sub-folder";s:18:"mail_rename_folder";s:13:"Rename Folder";s:42:"system_notification_installation_signature";s:64:"This email has been sent automatically by the ILIAS installation";s:43:"system_notification_installation_changed_by";s:10:"Changed By";s:11:"mail_filter";s:6:"Filter";s:18:"mail_filter_sender";s:6:"Sender";s:22:"mail_filter_recipients";s:10:"Recipients";s:19:"mail_filter_subject";s:7:"Subject";s:16:"mail_filter_body";s:4:"Body";s:18:"mail_filter_attach";s:11:"Attachments";s:29:"mail_filter_field_placeholder";s:25:"Filter these messages ...";s:15:"mail_filter_txt";s:18:"Filter messages by";s:14:"search_content";s:13:"Search Result";s:22:"mail_nacc_if_timelimit";s:68:"This text is only included, if the user has a limited access period.";s:19:"mail_nacc_timelimit";s:18:"User access period";s:31:"mail_max_size_attachments_total";s:189:"Please enter the maximum file size allowed as attachment per mail. This setting is not related to other resource limits, e.g. upload_max_filesize etc. (since you can attach multiple files).";s:37:"mail_max_size_attachments_total_error";s:31:"The allowed attachment size is:";s:23:"link_check_introduction";s:35:"the following weblinks are invalid:";s:17:"link_check_reason";s:76:"You recife this mail because you enabled the notification for invalid links.";s:25:"link_check_affected_links";s:14:"Affected Links";s:21:"link_check_perma_link";s:14:"Permanent Link";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'maps'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:14:{s:21:"maps_enable_maps_info";s:52:"Activates Maps in user profiles, groups and courses.";s:16:"maps_enable_maps";s:11:"Enable Maps";s:14:"maps_extt_maps";s:4:"Maps";s:13:"maps_latitude";s:8:"Latitude";s:14:"maps_longitude";s:9:"Longitude";s:19:"maps_lookup_address";s:14:"Lookup Address";s:24:"maps_public_profile_info";s:30:"Show location in your profile.";s:13:"maps_settings";s:13:"Maps Settings";s:22:"maps_std_location_desc";s:26:"Click map to set location.";s:17:"maps_std_location";s:16:"Default Location";s:15:"maps_zoom_level";s:10:"Zoom Level";s:16:"maps_google_maps";s:11:"Google Maps";s:21:"maps_open_layers_maps";s:16:"Open Layers Maps";s:13:"maps_map_type";s:3:"Typ";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'meta'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:633:{s:13:"md_adv_active";s:6:"Active";s:16:"md_adv_add_value";s:9:"Add Value";s:23:"md_adv_added_new_record";s:18:"Added new data set";s:19:"md_adv_create_field";s:9:"New Field";s:20:"md_adv_create_record";s:12:"New Data Set";s:25:"md_adv_delete_fields_sure";s:61:"Do you really want to delete the following field definitions?";s:24:"md_adv_delete_files_sure";s:57:"Do you really want to delete the following export  files?";s:25:"md_adv_delete_record_sure";s:49:"Do really want to delete the following data sets?";s:20:"md_adv_deleted_files";s:21:"Deleted export files.";s:22:"md_adv_deleted_records";s:16:"Deleted Data Set";s:16:"md_adv_desc_show";s:16:"Show Description";s:17:"md_adv_edit_field";s:10:"Edit Field";s:18:"md_adv_edit_record";s:13:"Edit Data Set";s:19:"md_adv_field_fields";s:6:"Fields";s:18:"md_adv_field_names";s:11:"Field Names";s:18:"md_adv_field_table";s:11:"Edit Fields";s:18:"md_adv_fields_show";s:16:"Show Field Names";s:16:"md_adv_file_list";s:12:"Export Files";s:20:"md_adv_import_record";s:19:"Import Metadata Set";s:16:"md_adv_no_fields";s:17:"No Fields Defined";s:22:"md_adv_placeholder_for";s:16:"Placeholder for:";s:19:"md_adv_placeholders";s:12:"Placeholders";s:18:"md_adv_record_list";s:8:"Datasets";s:23:"md_adv_records_exported";s:35:"A new export file has been created.";s:14:"md_adv_records";s:18:"Included Data Sets";s:17:"md_adv_searchable";s:10:"Searchable";s:22:"md_adv_select_one_file";s:23:"Please choose one file.";s:11:"md_adv_show";s:4:"Show";s:25:"md_adv_substitution_table";s:47:"Presentation in the Repository/Personal Desktop";s:19:"md_adv_substitution";s:4:"Text";s:11:"md_advanced";s:17:"Advanced Metadata";s:16:"md_copyright_add";s:24:"Add Copyright Presetting";s:17:"md_copyright_edit";s:25:"Edit Copyright Presetting";s:24:"md_copyright_enable_info";s:65:"Choose this option to offer a selection of predefined copyrights.";s:20:"md_copyright_enabled";s:26:"Enable Copyright Selection";s:20:"md_copyright_preview";s:19:"Copyright (Preview)";s:22:"md_copyright_selection";s:18:"Copyright Defaults";s:21:"md_copyright_settings";s:18:"Copyright Settings";s:18:"md_copyright_value";s:9:"Copyright";s:12:"md_copyright";s:9:"Copyright";s:21:"md_copyrights_deleted";s:17:"Deleted Copyright";s:7:"md_days";s:5:"Days:";s:17:"md_delete_cp_sure";s:52:"Do you really want to delete the following entries ?";s:17:"md_delimiter_info";s:106:"The delimiter is used in the quick editing screen for keywords and authors separation. Default is ‘,’.";s:12:"md_delimiter";s:9:"Delimiter";s:9:"md_fields";s:6:"Fields";s:19:"md_general_settings";s:16:"General Settings";s:9:"md_months";s:6:"Month:";s:12:"md_obj_types";s:16:"Assigned Objects";s:22:"md_record_export_table";s:12:"Export Files";s:20:"md_record_list_table";s:23:"Available Metadata Sets";s:15:"md_separated_by";s:15:"Separated by %s";s:7:"md_time";s:5:"Time:";s:7:"md_used";s:5:"Usage";s:31:"meta_accessibility_restrictions";s:26:"Accessibility Restrictions";s:11:"meta_active";s:6:"Active";s:8:"meta_add";s:3:"Add";s:15:"meta_annotation";s:10:"Annotation";s:11:"meta_atomic";s:6:"Atomic";s:11:"meta_author";s:6:"Author";s:12:"meta_browser";s:7:"Browser";s:9:"meta_c_AD";s:7:"Andorra";s:9:"meta_c_AE";s:20:"United Arab Emirates";s:9:"meta_c_AF";s:11:"Afghanistan";s:9:"meta_c_AG";s:19:"Antigua And Barbuda";s:9:"meta_c_AI";s:8:"Anguilla";s:9:"meta_c_AL";s:7:"Albania";s:9:"meta_c_AM";s:7:"Armenia";s:9:"meta_c_AN";s:20:"Netherlands Antilles";s:9:"meta_c_AO";s:6:"Angola";s:9:"meta_c_AQ";s:10:"Antarctica";s:9:"meta_c_AR";s:9:"Argentina";s:9:"meta_c_AS";s:14:"American Samoa";s:9:"meta_c_AT";s:7:"Austria";s:9:"meta_c_AU";s:9:"Australia";s:9:"meta_c_AW";s:5:"Aruba";s:9:"meta_c_AZ";s:10:"Azerbaijan";s:9:"meta_c_BA";s:22:"Bosnia And Herzegowina";s:9:"meta_c_BB";s:8:"Barbados";s:9:"meta_c_BD";s:10:"Bangladesh";s:9:"meta_c_BE";s:7:"Belgium";s:9:"meta_c_BF";s:12:"Burkina Faso";s:9:"meta_c_BG";s:8:"Bulgaria";s:9:"meta_c_BH";s:7:"Bahrain";s:9:"meta_c_BI";s:7:"Burundi";s:9:"meta_c_BJ";s:5:"Benin";s:9:"meta_c_BM";s:7:"Bermuda";s:9:"meta_c_BN";s:17:"Brunei Darussalam";s:9:"meta_c_BO";s:7:"Bolivia";s:9:"meta_c_BR";s:6:"Brazil";s:9:"meta_c_BS";s:7:"Bahamas";s:9:"meta_c_BT";s:6:"Bhutan";s:9:"meta_c_BV";s:13:"Bouvet Island";s:9:"meta_c_BW";s:8:"Botswana";s:9:"meta_c_BY";s:7:"Belarus";s:9:"meta_c_BZ";s:6:"Belize";s:9:"meta_c_CA";s:6:"Canada";s:9:"meta_c_CC";s:23:"Cocos (Keeling) Islands";s:9:"meta_c_CF";s:24:"Central African Republic";s:9:"meta_c_CG";s:5:"Congo";s:9:"meta_c_CH";s:11:"Switzerland";s:9:"meta_c_CI";s:11:"Ivory Coast";s:9:"meta_c_CK";s:12:"Cook Islands";s:9:"meta_c_CL";s:5:"Chile";s:9:"meta_c_CM";s:8:"Cameroon";s:9:"meta_c_CN";s:5:"China";s:9:"meta_c_CO";s:8:"Colombia";s:9:"meta_c_CR";s:10:"Costa Rica";s:9:"meta_c_CU";s:4:"Cuba";s:9:"meta_c_CV";s:10:"Cape Verde";s:9:"meta_c_CX";s:16:"Christmas Island";s:9:"meta_c_CY";s:6:"Cyprus";s:9:"meta_c_CZ";s:14:"Czech Republic";s:9:"meta_c_DE";s:7:"Germany";s:9:"meta_c_DJ";s:8:"Djibouti";s:9:"meta_c_DK";s:7:"Denmark";s:9:"meta_c_DM";s:8:"Dominica";s:9:"meta_c_DO";s:18:"Dominican Republic";s:9:"meta_c_DZ";s:7:"Algeria";s:9:"meta_c_EC";s:7:"Ecuador";s:9:"meta_c_EE";s:7:"Estonia";s:9:"meta_c_EG";s:5:"Egypt";s:9:"meta_c_EH";s:14:"Western Sahara";s:9:"meta_c_ER";s:7:"Eritrea";s:9:"meta_c_ES";s:5:"Spain";s:9:"meta_c_ET";s:8:"Ethiopia";s:9:"meta_c_FI";s:7:"Finland";s:9:"meta_c_FJ";s:4:"Fiji";s:9:"meta_c_FK";s:16:"Falkland Islands";s:9:"meta_c_FM";s:10:"Micronesia";s:9:"meta_c_FO";s:13:"Faroe Islands";s:9:"meta_c_FR";s:6:"France";s:9:"meta_c_FX";s:20:"France, Metropolitan";s:9:"meta_c_GA";s:5:"Gabon";s:9:"meta_c_GB";s:14:"United Kingdom";s:9:"meta_c_GD";s:7:"Grenada";s:9:"meta_c_GE";s:7:"Giorgia";s:9:"meta_c_GF";s:13:"French Guiana";s:9:"meta_c_GH";s:5:"Ghana";s:9:"meta_c_GI";s:9:"Gibraltar";s:9:"meta_c_GL";s:9:"Greenland";s:9:"meta_c_GM";s:6:"Gambia";s:9:"meta_c_GN";s:6:"Guinea";s:9:"meta_c_GP";s:10:"Guadeloupe";s:9:"meta_c_GQ";s:17:"Equatorial Guinea";s:9:"meta_c_GR";s:6:"Greece";s:9:"meta_c_GS";s:44:"South Georgia And The South Sandwich Islands";s:9:"meta_c_GT";s:9:"Guatemala";s:9:"meta_c_GU";s:4:"Guam";s:9:"meta_c_GW";s:13:"Guinea-Bissau";s:9:"meta_c_GY";s:6:"Guyana";s:9:"meta_c_HM";s:27:"Heard And Nc Donald Islands";s:9:"meta_c_HN";s:8:"Honduras";s:9:"meta_c_HR";s:7:"Croatia";s:9:"meta_c_HT";s:5:"Haiti";s:9:"meta_c_HU";s:7:"Hungary";s:9:"meta_c_ID";s:9:"Indonesia";s:9:"meta_c_IE";s:7:"Ireland";s:9:"meta_c_IL";s:6:"Israel";s:9:"meta_c_IN";s:5:"India";s:9:"meta_c_IO";s:30:"British Indian Ocean Territory";s:9:"meta_c_IQ";s:4:"Iraq";s:9:"meta_c_IR";s:4:"Iran";s:9:"meta_c_IS";s:7:"Iceland";s:9:"meta_c_IT";s:5:"Italy";s:9:"meta_c_JM";s:7:"Jamaica";s:9:"meta_c_JO";s:6:"Jordan";s:9:"meta_c_JP";s:5:"Japan";s:9:"meta_c_KE";s:5:"Kenya";s:9:"meta_c_KG";s:10:"Kyrgyzstan";s:9:"meta_c_KH";s:8:"Cambodia";s:9:"meta_c_KI";s:8:"Kiribati";s:9:"meta_c_KM";s:7:"Comoros";s:9:"meta_c_KN";s:21:"Saint Kitts And Nevis";s:9:"meta_c_KP";s:40:"North Korea (People\'s Republic Of Korea)";s:9:"meta_c_KR";s:31:"South Korea (Republic Of Korea)";s:9:"meta_c_KW";s:6:"Kuwait";s:9:"meta_c_KY";s:14:"Cayman Islands";s:9:"meta_c_KZ";s:10:"Kazakhstan";s:9:"meta_c_LA";s:21:"Lao People\'s Republic";s:9:"meta_c_LB";s:7:"Lebanon";s:9:"meta_c_LC";s:11:"Saint Lucia";s:9:"meta_c_LI";s:13:"Liechtenstein";s:9:"meta_c_LK";s:9:"Sri Lanka";s:9:"meta_c_LR";s:7:"Liberia";s:9:"meta_c_LS";s:7:"Lesotho";s:9:"meta_c_LT";s:8:"Lithunia";s:9:"meta_c_LU";s:10:"Luxembourg";s:9:"meta_c_LV";s:6:"Latvia";s:9:"meta_c_LY";s:22:"Libyan Arab Jamahiriya";s:9:"meta_c_MA";s:7:"Morocco";s:9:"meta_c_MC";s:6:"Monaco";s:9:"meta_c_MD";s:7:"Moldova";s:9:"meta_c_MG";s:10:"Madagascar";s:9:"meta_c_MH";s:16:"Marshall Islands";s:9:"meta_c_MK";s:9:"Macedonia";s:9:"meta_c_ML";s:4:"Mali";s:9:"meta_c_MM";s:7:"Myanmar";s:9:"meta_c_MN";s:8:"Mongolia";s:9:"meta_c_MO";s:5:"Macau";s:9:"meta_c_MP";s:24:"Northern Mariana Islands";s:9:"meta_c_MQ";s:10:"Martinique";s:9:"meta_c_MR";s:10:"Mauritania";s:9:"meta_c_MS";s:10:"Montserrat";s:9:"meta_c_MT";s:5:"Malta";s:9:"meta_c_MU";s:9:"Mauritius";s:9:"meta_c_MV";s:8:"Maldives";s:9:"meta_c_MW";s:6:"Malawi";s:9:"meta_c_MX";s:6:"Mexico";s:9:"meta_c_MY";s:8:"Malaysia";s:9:"meta_c_MZ";s:10:"Mozambique";s:9:"meta_c_NA";s:7:"Namibia";s:9:"meta_c_NC";s:13:"New Caledonia";s:9:"meta_c_NE";s:5:"Niger";s:9:"meta_c_NF";s:14:"Norfolk Island";s:9:"meta_c_NG";s:7:"Nigeria";s:9:"meta_c_NI";s:9:"Nicaragua";s:9:"meta_c_NL";s:11:"Netherlands";s:9:"meta_c_NO";s:6:"Norway";s:9:"meta_c_NP";s:5:"Nepal";s:9:"meta_c_NR";s:5:"Nauru";s:9:"meta_c_NU";s:4:"Niue";s:9:"meta_c_NZ";s:11:"New Zealand";s:9:"meta_c_OM";s:4:"Oman";s:9:"meta_c_PA";s:6:"Panama";s:9:"meta_c_PE";s:4:"Peru";s:9:"meta_c_PF";s:16:"French Polynesia";s:9:"meta_c_PG";s:16:"Papua New Guinea";s:9:"meta_c_PH";s:11:"Philippines";s:9:"meta_c_PK";s:8:"Pakistan";s:9:"meta_c_PL";s:6:"Poland";s:9:"meta_c_PM";s:23:"St. Pierre And Miquelon";s:9:"meta_c_PN";s:8:"Pitcairn";s:9:"meta_c_PR";s:11:"Puerto Rico";s:9:"meta_c_PT";s:8:"Portugal";s:9:"meta_c_PW";s:5:"Palau";s:9:"meta_c_PY";s:8:"Paraguay";s:9:"meta_c_QA";s:5:"Qatar";s:9:"meta_c_RE";s:7:"Reunion";s:9:"meta_c_RO";s:7:"Romania";s:9:"meta_c_RU";s:18:"Russian Federation";s:9:"meta_c_RW";s:6:"Rwanda";s:9:"meta_c_SA";s:12:"Saudi Arabia";s:9:"meta_c_SB";s:15:"Solomon Islands";s:9:"meta_c_SC";s:10:"Seychelles";s:9:"meta_c_SD";s:5:"Sudan";s:9:"meta_c_SE";s:6:"Sweden";s:9:"meta_c_SG";s:9:"Singapore";s:9:"meta_c_SH";s:10:"St. Helena";s:9:"meta_c_SI";s:8:"Slovenia";s:9:"meta_c_SJ";s:30:"Svalbard And Jan Mayen Islands";s:9:"meta_c_SK";s:8:"Slovakia";s:9:"meta_c_SL";s:13:"Siearra Leone";s:9:"meta_c_SM";s:10:"San Marino";s:9:"meta_c_SN";s:7:"Senegal";s:9:"meta_c_SO";s:7:"Somalia";s:9:"meta_c_SR";s:8:"Suriname";s:9:"meta_c_ST";s:21:"Sao Tome And Principe";s:9:"meta_c_SV";s:11:"El Salvador";s:9:"meta_c_SY";s:20:"Syrian Arab Republic";s:9:"meta_c_SZ";s:9:"Swaziland";s:9:"meta_c_TC";s:24:"Turks And Caicos Islands";s:9:"meta_c_TD";s:4:"Chad";s:9:"meta_c_TF";s:27:"French Southern Territories";s:9:"meta_c_TG";s:4:"Togo";s:9:"meta_c_TH";s:8:"Thailand";s:9:"meta_c_TJ";s:10:"Tajikistan";s:9:"meta_c_TK";s:7:"Tokelau";s:9:"meta_c_TM";s:12:"Turkmenistan";s:9:"meta_c_TN";s:7:"Tunisia";s:9:"meta_c_TO";s:5:"Tonga";s:9:"meta_c_TP";s:10:"East Timor";s:9:"meta_c_TR";s:6:"Turkey";s:9:"meta_c_TT";s:19:"Trinidad And Tobago";s:9:"meta_c_TV";s:6:"Tuvalu";s:9:"meta_c_TW";s:6:"Taiwan";s:9:"meta_c_TZ";s:8:"Tanzania";s:9:"meta_c_UA";s:7:"Ukraine";s:9:"meta_c_UG";s:6:"Uganda";s:9:"meta_c_UM";s:27:"U.S. Minor Outlying Islands";s:9:"meta_c_US";s:5:"U.S.A";s:9:"meta_c_UY";s:7:"Uruguay";s:9:"meta_c_UZ";s:10:"Uzbekistan";s:9:"meta_c_VA";s:18:"Vatican City State";s:9:"meta_c_VC";s:32:"Saint Vincent And The Grenadines";s:9:"meta_c_VE";s:9:"Venezuela";s:9:"meta_c_VG";s:24:"Virgin Islands (British)";s:9:"meta_c_VI";s:19:"Virgin Islands (US)";s:9:"meta_c_VN";s:8:"Viet Nam";s:9:"meta_c_VU";s:7:"Vanuatu";s:9:"meta_c_WF";s:25:"Wallis And Futuna Islands";s:9:"meta_c_WS";s:5:"Samoa";s:9:"meta_c_YE";s:5:"Yemen";s:9:"meta_c_YT";s:7:"Mayotte";s:9:"meta_c_ZA";s:12:"South Africa";s:9:"meta_c_ZM";s:6:"Zambia";s:9:"meta_c_ZR";s:5:"Zaire";s:9:"meta_c_ZW";s:8:"Zimbabwe";s:9:"meta_c_ZZ";s:13:"Other Country";s:12:"meta_catalog";s:7:"Catalog";s:19:"meta_choose_element";s:41:"Please choose an element you want to add!";s:20:"meta_choose_language";s:24:"Please choose a language";s:19:"meta_choose_section";s:23:"Please choose a section";s:19:"meta_classification";s:14:"Classification";s:15:"meta_collection";s:10:"Collection";s:15:"meta_competency";s:10:"Competency";s:20:"meta_contentprovider";s:16:"Content provider";s:12:"meta_context";s:7:"Context";s:15:"meta_contribute";s:10:"Contribute";s:37:"meta_copyright_and_other_restrictions";s:32:"Copyright and Other Restrictions";s:14:"meta_copyright";s:9:"Copyright";s:9:"meta_cost";s:4:"Cost";s:13:"meta_coverage";s:8:"Coverage";s:11:"meta_cp_own";s:26:"Own Copyright Information:";s:12:"meta_creator";s:7:"Creator";s:18:"meta_current_value";s:13:"Current value";s:9:"meta_date";s:4:"Date";s:11:"meta_delete";s:6:"Delete";s:16:"meta_description";s:11:"Description";s:13:"meta_diagramm";s:7:"Diagram";s:14:"meta_difficult";s:9:"Difficult";s:15:"meta_difficulty";s:10:"Difficulty";s:10:"meta_draft";s:5:"Draft";s:13:"meta_duration";s:8:"Duration";s:9:"meta_easy";s:4:"Easy";s:11:"meta_editor";s:6:"Editor";s:14:"meta_education";s:9:"Education";s:22:"meta_educational_level";s:17:"Educational Level";s:26:"meta_educational_objective";s:21:"Educational Objective";s:16:"meta_educational";s:11:"Educational";s:25:"meta_educationalvalidator";s:21:"Educational validator";s:11:"meta_entity";s:6:"Entity";s:10:"meta_entry";s:5:"Entry";s:9:"meta_exam";s:4:"Exam";s:13:"meta_exercise";s:8:"Exercise";s:15:"meta_experiment";s:10:"Experiment";s:15:"meta_expositive";s:10:"Expositive";s:11:"meta_figure";s:6:"Figure";s:10:"meta_final";s:5:"Final";s:11:"meta_format";s:6:"Format";s:12:"meta_general";s:7:"General";s:10:"meta_graph";s:5:"Graph";s:22:"meta_graphicaldesigner";s:18:"Graphical designer";s:15:"meta_has_format";s:10:"Has Format";s:13:"meta_has_part";s:8:"Has Part";s:16:"meta_has_version";s:11:"Has Version";s:17:"meta_hierarchical";s:12:"Hierarchical";s:9:"meta_high";s:4:"High";s:21:"meta_higher_education";s:16:"Higher Education";s:7:"meta_id";s:2:"Id";s:9:"meta_idea";s:4:"Idea";s:15:"meta_identifier";s:10:"Identifier";s:10:"meta_index";s:5:"Index";s:23:"meta_info_tlt_not_valid";s:176:"The current value is not valid. Therefore it can not be used other sections, e.g for learning progress statistics. Please insert atypical learning time in hours and/or minutes.";s:14:"meta_initiator";s:9:"Initiator";s:25:"meta_installation_remarks";s:20:"Installation Remarks";s:27:"meta_instructional_designer";s:25:"Instructional designer(s)";s:26:"meta_instructionaldesigner";s:22:"Instructional designer";s:27:"meta_intended_end_user_role";s:22:"Intended End User Role";s:24:"meta_interactivity_level";s:19:"Interactivity Level";s:23:"meta_interactivity_type";s:18:"Interactivity Type";s:16:"meta_is_based_on";s:11:"Is Based On";s:17:"meta_is_basis_for";s:12:"Is Basis For";s:17:"meta_is_format_of";s:12:"Is Format Of";s:15:"meta_is_part_of";s:10:"Is Part Of";s:21:"meta_is_referenced_by";s:16:"Is Referenced By";s:19:"meta_is_required_by";s:14:"Is Required By";s:18:"meta_is_version_of";s:13:"Is Version Of";s:12:"meta_keyword";s:7:"Keyword";s:9:"meta_kind";s:4:"Kind";s:9:"meta_l_aa";s:4:"Afar";s:9:"meta_l_ab";s:9:"Abkhazian";s:9:"meta_l_af";s:9:"Afrikaans";s:9:"meta_l_am";s:7:"Amharic";s:9:"meta_l_ar";s:6:"Arabic";s:9:"meta_l_as";s:8:"Assamese";s:9:"meta_l_ay";s:6:"Aymara";s:9:"meta_l_az";s:11:"Azerbaijani";s:9:"meta_l_ba";s:7:"Bashkir";s:9:"meta_l_be";s:12:"Byelorussian";s:9:"meta_l_bg";s:9:"Bulgarian";s:9:"meta_l_bh";s:6:"Bihari";s:9:"meta_l_bi";s:7:"Bislama";s:9:"meta_l_bn";s:14:"Bengali;bangla";s:9:"meta_l_bo";s:7:"Tibetan";s:9:"meta_l_br";s:6:"Breton";s:9:"meta_l_ca";s:7:"Catalan";s:9:"meta_l_co";s:8:"Corsican";s:9:"meta_l_cs";s:5:"Czech";s:9:"meta_l_cy";s:5:"Welsh";s:9:"meta_l_da";s:6:"Danish";s:9:"meta_l_de";s:6:"German";s:9:"meta_l_dz";s:7:"Bhutani";s:9:"meta_l_el";s:5:"Greek";s:9:"meta_l_en";s:7:"English";s:9:"meta_l_eo";s:9:"Esperanto";s:9:"meta_l_es";s:7:"Spanish";s:9:"meta_l_et";s:8:"Estonian";s:9:"meta_l_eu";s:6:"Basque";s:9:"meta_l_fa";s:15:"Persian (farsi)";s:9:"meta_l_fi";s:7:"Finnish";s:9:"meta_l_fj";s:4:"Fiji";s:9:"meta_l_fo";s:7:"Faroese";s:9:"meta_l_fr";s:6:"French";s:9:"meta_l_fy";s:7:"Frisian";s:9:"meta_l_ga";s:5:"Irish";s:9:"meta_l_gd";s:12:"Scots gaelic";s:9:"meta_l_gl";s:8:"Galician";s:9:"meta_l_gn";s:7:"Guarani";s:9:"meta_l_gu";s:8:"Gujarati";s:9:"meta_l_ha";s:5:"Hausa";s:9:"meta_l_he";s:6:"Hebrew";s:9:"meta_l_hi";s:5:"Hindi";s:9:"meta_l_hr";s:8:"Croatian";s:9:"meta_l_hu";s:9:"Hungarian";s:9:"meta_l_hy";s:8:"Armenian";s:9:"meta_l_ia";s:11:"Interlingua";s:9:"meta_l_id";s:10:"Indonesian";s:9:"meta_l_ie";s:11:"Interlingue";s:9:"meta_l_ik";s:7:"Inupiak";s:9:"meta_l_is";s:9:"Icelandic";s:9:"meta_l_it";s:7:"Italian";s:9:"meta_l_iu";s:9:"Inuktitut";s:9:"meta_l_ja";s:8:"Japanese";s:9:"meta_l_jv";s:8:"Javanese";s:9:"meta_l_ka";s:8:"Georgian";s:9:"meta_l_kk";s:6:"Kazakh";s:9:"meta_l_kl";s:11:"Greenlandic";s:9:"meta_l_km";s:9:"Cambodian";s:9:"meta_l_kn";s:7:"Kannada";s:9:"meta_l_ko";s:6:"Korean";s:9:"meta_l_ks";s:8:"Kashmiri";s:9:"meta_l_ku";s:7:"Kurdish";s:9:"meta_l_ky";s:7:"Kirghiz";s:9:"meta_l_la";s:5:"Latin";s:9:"meta_l_ln";s:7:"Lingala";s:9:"meta_l_lo";s:8:"Laothian";s:9:"meta_l_lt";s:10:"Lithuanian";s:9:"meta_l_lv";s:15:"Latvian;lettish";s:9:"meta_l_mg";s:8:"Malagasy";s:9:"meta_l_mi";s:5:"Maori";s:9:"meta_l_mk";s:10:"Macedonian";s:9:"meta_l_ml";s:9:"Malayalam";s:9:"meta_l_mn";s:9:"Mongolian";s:9:"meta_l_mo";s:9:"Moldavian";s:9:"meta_l_mr";s:7:"Marathi";s:9:"meta_l_ms";s:5:"Malay";s:9:"meta_l_mt";s:7:"Maltese";s:9:"meta_l_my";s:7:"Burmese";s:9:"meta_l_na";s:5:"Nauru";s:9:"meta_l_ne";s:6:"Nepali";s:9:"meta_l_nl";s:5:"Dutch";s:9:"meta_l_no";s:9:"Norwegian";s:9:"meta_l_oc";s:7:"Occitan";s:9:"meta_l_om";s:12:"Afan (oromo)";s:9:"meta_l_or";s:5:"Oriya";s:9:"meta_l_pa";s:7:"Punjabi";s:9:"meta_l_pl";s:6:"Polish";s:9:"meta_l_ps";s:13:"Pashto;pushto";s:9:"meta_l_pt";s:10:"Portuguese";s:9:"meta_l_qu";s:7:"Quechua";s:9:"meta_l_rm";s:14:"Rhaeto-romance";s:9:"meta_l_rn";s:7:"Kurundi";s:9:"meta_l_ro";s:8:"Romanian";s:9:"meta_l_ru";s:7:"Russian";s:9:"meta_l_rw";s:11:"Kinyarwanda";s:9:"meta_l_sa";s:8:"Sanskrit";s:9:"meta_l_sd";s:6:"Sindhi";s:9:"meta_l_sg";s:6:"Sangho";s:9:"meta_l_sh";s:14:"Serbo-croatian";s:9:"meta_l_si";s:10:"Singhalese";s:9:"meta_l_sk";s:6:"Slovak";s:9:"meta_l_sl";s:9:"Slovenian";s:9:"meta_l_sm";s:6:"Samoan";s:9:"meta_l_sn";s:5:"Shona";s:9:"meta_l_so";s:6:"Somali";s:9:"meta_l_sq";s:8:"Albanian";s:9:"meta_l_sr";s:7:"Serbian";s:9:"meta_l_ss";s:7:"Siswati";s:9:"meta_l_st";s:7:"Sesotho";s:9:"meta_l_su";s:9:"Sundanese";s:9:"meta_l_sv";s:7:"Swedish";s:9:"meta_l_sw";s:7:"Swahili";s:9:"meta_l_ta";s:5:"Tamil";s:9:"meta_l_te";s:6:"Telugu";s:9:"meta_l_tg";s:5:"Tajik";s:9:"meta_l_th";s:4:"Thai";s:9:"meta_l_ti";s:8:"Tigrinya";s:9:"meta_l_tk";s:7:"Turkmen";s:9:"meta_l_tl";s:7:"Tagalog";s:9:"meta_l_tn";s:8:"Setswana";s:9:"meta_l_to";s:5:"Tonga";s:9:"meta_l_tr";s:7:"Turkish";s:9:"meta_l_ts";s:6:"Tsonga";s:9:"meta_l_tt";s:5:"Tatar";s:9:"meta_l_tw";s:3:"Twi";s:9:"meta_l_ug";s:5:"Uigur";s:9:"meta_l_uk";s:9:"Ukrainian";s:9:"meta_l_ur";s:4:"Urdu";s:9:"meta_l_uz";s:5:"Uzbek";s:9:"meta_l_vi";s:10:"Vietnamese";s:9:"meta_l_vo";s:7:"Volapuk";s:9:"meta_l_wo";s:5:"Wolof";s:9:"meta_l_xh";s:5:"Xhosa";s:9:"meta_l_yi";s:7:"Yiddish";s:9:"meta_l_yo";s:6:"Yoruba";s:9:"meta_l_za";s:6:"Zhuang";s:9:"meta_l_zh";s:7:"Chinese";s:9:"meta_l_zu";s:4:"Zulu";s:13:"meta_language";s:8:"Language";s:12:"meta_learner";s:7:"Learner";s:27:"meta_learning_resource_type";s:22:"Learning Resource Type";s:12:"meta_lecture";s:7:"Lecture";s:14:"meta_lifecycle";s:9:"Lifecycle";s:11:"meta_linear";s:6:"Linear";s:15:"meta_local_file";s:10:"Local File";s:13:"meta_location";s:8:"Location";s:8:"meta_low";s:3:"Low";s:11:"meta_mac_os";s:5:"MacOS";s:12:"meta_manager";s:7:"Manager";s:20:"meta_maximum_version";s:15:"Maximum Version";s:11:"meta_medium";s:6:"Medium";s:18:"meta_meta_metadata";s:13:"Meta-Metadata";s:19:"meta_metadatascheme";s:15:"Metadata Scheme";s:20:"meta_minimum_version";s:15:"Minimum Version";s:10:"meta_mixed";s:5:"Mixed";s:15:"meta_ms_windows";s:10:"MS-Windows";s:13:"meta_multi_os";s:8:"Multi-OS";s:9:"meta_name";s:4:"Name";s:19:"meta_narrative_text";s:14:"Narrative Text";s:14:"meta_networked";s:9:"Networked";s:16:"meta_new_element";s:11:"New Element";s:18:"meta_no_annotation";s:49:"No metadata available for the Annotation section.";s:22:"meta_no_classification";s:53:"No metadata available for the Classification section.";s:19:"meta_no_educational";s:50:"No metadata available for the Educational section.";s:17:"meta_no_lifecycle";s:48:"No metadata available for the Lifecycle section.";s:21:"meta_no_meta_metadata";s:52:"No metadata available for the Meta-Metadata section.";s:16:"meta_no_relation";s:47:"No metadata available for the Relation section.";s:14:"meta_no_rights";s:45:"No metadata available for the Rights section.";s:17:"meta_no_technical";s:48:"No metadata available for the Technical section.";s:7:"meta_no";s:2:"No";s:9:"meta_none";s:4:"None";s:21:"meta_operating_system";s:16:"Operating System";s:17:"meta_or_composite";s:12:"Or Composite";s:33:"meta_other_plattform_requirements";s:27:"Other Platform Requirements";s:10:"meta_other";s:5:"Other";s:11:"meta_pc_dos";s:6:"PC-DOS";s:18:"meta_please_select";s:13:"Please select";s:19:"meta_pointofcontact";s:19:"Point(s) of Contact";s:17:"meta_prerequisite";s:12:"Prerequisite";s:22:"meta_problem_statement";s:17:"Problem Statement";s:14:"meta_publisher";s:9:"Publisher";s:12:"meta_purpose";s:7:"Purpose";s:18:"meta_questionnaire";s:13:"Questionnaire";s:14:"meta_quickedit";s:10:"Quick Edit";s:14:"meta_reference";s:9:"Reference";s:15:"meta_references";s:10:"References";s:13:"meta_relation";s:8:"Relation";s:16:"meta_requirement";s:11:"Requirement";s:13:"meta_requires";s:8:"Requires";s:13:"meta_resource";s:8:"Resource";s:12:"meta_revised";s:7:"Revised";s:11:"meta_rights";s:6:"Rights";s:9:"meta_role";s:4:"Role";s:11:"meta_school";s:6:"School";s:17:"meta_scriptwriter";s:12:"Scriptwriter";s:19:"meta_security_level";s:14:"Security Level";s:20:"meta_self_assessment";s:15:"Self Assessment";s:21:"meta_semantic_density";s:16:"Semantic Density";s:15:"meta_simulation";s:10:"Simulation";s:9:"meta_size";s:4:"Size";s:16:"meta_skill_level";s:16:"Competence Level";s:10:"meta_slide";s:5:"Slide";s:11:"meta_source";s:6:"Source";s:11:"meta_status";s:6:"Status";s:14:"meta_structure";s:9:"Structure";s:24:"meta_subjectmatterexpert";s:24:"Subject matter expert(s)";s:10:"meta_table";s:5:"Table";s:15:"meta_taxon_path";s:10:"Taxon Path";s:10:"meta_taxon";s:5:"Taxon";s:12:"meta_teacher";s:7:"Teacher";s:14:"meta_technical";s:9:"Technical";s:25:"meta_technicalimplementer";s:21:"Technical implementer";s:23:"meta_technicalvalidator";s:19:"Technical validator";s:15:"meta_terminator";s:10:"Terminator";s:10:"meta_title";s:5:"Title";s:13:"meta_training";s:8:"Training";s:9:"meta_type";s:4:"Type";s:22:"meta_typical_age_range";s:17:"Typical Age Range";s:26:"meta_typical_learning_time";s:21:"Typical Learning Time";s:16:"meta_unavailable";s:11:"Unavailable";s:9:"meta_unix";s:4:"Unix";s:12:"meta_unknown";s:7:"Unknown";s:14:"meta_validator";s:9:"Validator";s:10:"meta_value";s:5:"Value";s:12:"meta_version";s:7:"Version";s:19:"meta_very_difficult";s:14:"Very Difficult";s:14:"meta_very_easy";s:9:"Very Easy";s:14:"meta_very_high";s:9:"Very High";s:13:"meta_very_low";s:8:"Very Low";s:8:"meta_yes";s:3:"Yes";s:13:"sco_propagate";s:21:"Propagate to all SCOs";s:9:"meta_c_AX";s:14:"Åland Islands";s:9:"meta_c_BL";s:17:"Saint Barthélemy";s:9:"meta_c_GG";s:8:"Guernsey";s:9:"meta_c_HK";s:9:"Hong Kong";s:9:"meta_c_IM";s:11:"Isle of Man";s:9:"meta_c_JE";s:6:"Jersey";s:9:"meta_c_ME";s:10:"Montenegro";s:9:"meta_c_MF";s:26:"Saint Martin (French part)";s:9:"meta_c_PS";s:34:"Palestinian Territories (Occupied)";s:9:"meta_c_RS";s:6:"Serbia";s:9:"meta_c_TL";s:11:"Timor-Leste";s:9:"meta_c_XK";s:6:"Kosovo";s:19:"md_adv_presentation";s:12:"Presentation";s:16:"udf_type_integer";s:7:"Integer";s:17:"md_adv_number_max";s:13:"Maximum Value";s:17:"md_adv_number_min";s:13:"Minimum Value";s:14:"udf_type_float";s:5:"Float";s:17:"udf_type_location";s:8:"Location";s:22:"md_adv_number_decimals";s:8:"Decimals";s:25:"md_adv_confirm_definition";s:43:"Please confirm the new definition settings.";s:39:"md_adv_confirm_definition_select_option";s:14:"Deleted Option";s:46:"md_adv_confirm_definition_select_option_remove";s:12:"Remove value";s:49:"md_adv_confirm_definition_select_option_overwrite";s:12:"Set value to";s:40:"md_adv_confirm_definition_select_section";s:32:"Migration of the deleted options";s:22:"md_adv_text_max_length";s:14:"Maximum Length";s:17:"md_adv_text_multi";s:9:"Multiline";s:20:"md_adv_number_suffix";s:6:"Suffix";s:20:"udf_type_selectmulti";s:27:"Selection List (Checkboxes)";s:43:"md_adv_confirm_definition_select_option_all";s:36:"Handle all existing entries the same";s:46:"md_adv_confirm_definition_select_option_single";s:30:"Decide for each existing entry";s:50:"md_adv_confirm_definition_select_option_all_action";s:9:"New Value";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'notes'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:29:{s:23:"notes_activate_comments";s:24:"Activate Public Comments";s:17:"notes_add_comment";s:11:"Add Comment";s:14:"notes_add_note";s:8:"Add Note";s:18:"notes_all_comments";s:12:"All Comments";s:13:"notes_comment";s:7:"Comment";s:25:"notes_deactivate_comments";s:26:"Deactivate Public Comments";s:18:"notes_edit_comment";s:12:"Edit Comment";s:15:"notes_edit_note";s:9:"Edit Note";s:19:"notes_hide_comments";s:13:"Hide Comments";s:11:"notes_label";s:5:"Label";s:17:"notes_my_comments";s:11:"My Comments";s:18:"notes_note_deleted";s:26:"The note has been deleted.";s:19:"notes_notes_deleted";s:28:"The notes have been deleted.";s:21:"notes_public_comments";s:15:"Public Comments";s:19:"notes_show_comments";s:13:"Show Comments";s:23:"notes_public_commenting";s:15:"Public Comments";s:24:"notes_private_annotating";s:18:"Private Annotation";s:13:"note_add_note";s:8:"Add Note";s:16:"note_add_comment";s:11:"Add Comment";s:19:"note_update_comment";s:14:"Update Comment";s:16:"note_update_note";s:11:"Update Note";s:14:"notes_comments";s:8:"Comments";s:51:"comments_feature_currently_not_activated_for_object";s:73:"The public comments feature is currently not activated for this resource.";s:17:"notes_no_comments";s:31:"No comment has been posted yet.";s:20:"note_content_removed";s:29:"The content has been removed.";s:14:"notes_sort_asc";s:14:"Sort Ascending";s:15:"notes_sort_desc";s:15:"Sort Descending";s:21:"notes_comment_deleted";s:29:"The comment has been deleted.";s:22:"notes_comments_deleted";s:31:"The comments have been deleted.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'payment'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:522:{s:15:"advanced_search";s:15:"Advanced Search";s:11:"coupon_type";s:11:"Coupon-Type";s:13:"currency_cent";s:4:"Cent";s:13:"currency_euro";s:4:"Euro";s:8:"currency";s:8:"Currency";s:21:"delete_addresses_bill";s:24:"Delete Billing addresses";s:20:"delete_addresses_bmf";s:20:"Delete BMF addresses";s:23:"delete_addresses_paypal";s:23:"Delete Paypal addresses";s:8:"duration";s:8:"Duration";s:10:"edit_topic";s:10:"Edit Topic";s:15:"enable_ean_info";s:154:"This is required for invoicing the public sector in Denmark. Click here to read <a href="http://www.oes.dk/sw1903.asp" target="_blank">more about EAN</a>.";s:10:"enable_ean";s:10:"Enable EAN";s:12:"excel_export";s:12:"Excel export";s:9:"filter_by";s:2:"by";s:24:"import_use_only_textfile";s:58:"Hint: Please use a plain-text file with one code per line.";s:4:"info";s:32:"Information about the pay method";s:9:"new_topic";s:9:"New Topic";s:13:"no_topics_yet";s:21:"No topics created yet";s:18:"no_vendor_selected";s:19:"No vendor selected.";s:14:"object_deleted";s:14:"Object Deleted";s:12:"pay_abstract";s:8:"Abstract";s:24:"pay_add_to_shopping_cart";s:20:"Add to shopping cart";s:26:"pay_added_to_shopping_cart";s:28:"Added item to shopping cart.";s:7:"pay_all";s:3:"All";s:11:"pay_article";s:7:"Article";s:13:"pay_bank_data";s:9:"Bank data";s:11:"pay_bill_no";s:11:"Invoice no.";s:22:"pay_bmf_account_holder";s:14:"Account holder";s:22:"pay_bmf_account_number";s:14:"Account number";s:12:"pay_bmf_back";s:4:"back";s:17:"pay_bmf_bank_code";s:9:"Bank code";s:19:"pay_bmf_card_holder";s:11:"Card holder";s:19:"pay_bmf_card_number";s:11:"Card number";s:20:"pay_bmf_check_number";s:12:"Check number";s:30:"pay_bmf_check_terms_conditions";s:71:"Please confirm that you\'ve read the terms and conditions and accept it.";s:24:"pay_bmf_credit_card_data";s:11:"Credit card";s:29:"pay_bmf_credit_card_not_valid";s:110:"The credit card data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly.";s:19:"pay_bmf_credit_card";s:11:"Credit card";s:24:"pay_bmf_debit_entry_data";s:11:"Debit entry";s:29:"pay_bmf_debit_entry_not_valid";s:110:"The debit entry data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly.";s:19:"pay_bmf_debit_entry";s:39:"Debit entry (german bank accounts only)";s:31:"pay_bmf_description_credit_card";s:249:"Please check out whether all articles you would like to order are in the shopping cart. By filling in your credit card data and clicking the "Save"-button you confirm your wish to order, that starts immediately. The data check may take some seconds.";s:31:"pay_bmf_description_debit_entry";s:257:"Please check out whether all articles you would like to order are in the shopping cart. By filling in your data for the debit entry and clicking the "Save"-button you confirm your wish to order, that starts immediately. The data check may take some seconds.";s:32:"pay_bmf_description_payment_type";s:25:"Please select how to pay.";s:33:"pay_bmf_description_personal_data";s:46:"Please fill out the following form completely.";s:20:"pay_bmf_house_number";s:12:"House number";s:16:"pay_bmf_optional";s:8:"optional";s:10:"pay_bmf_or";s:2:"or";s:26:"pay_bmf_password_not_valid";s:27:"Your password wasn\'t valid.";s:30:"pay_bmf_payment_type_not_valid";s:76:"The kind of paying you\'ve choosen isn\'t valid. Please select another option.";s:20:"pay_bmf_payment_type";s:14:"Kind of paying";s:31:"pay_bmf_personal_data_not_valid";s:93:"Your personal data isn\'t valid. Please check out whether all fields are filled out correctly.";s:21:"pay_bmf_personal_data";s:18:"Your personal data";s:21:"pay_bmf_please_select";s:13:"Please select";s:14:"pay_bmf_po_box";s:6:"PO Box";s:25:"pay_bmf_server_error_code";s:33:"Payment server returns error code";s:34:"pay_bmf_server_error_communication";s:46:"Error while communication with payment server.";s:29:"pay_bmf_server_error_sysadmin";s:60:"Please contact system administrator for further information.";s:27:"pay_bmf_shopping_cart_empty";s:28:"Your shopping card is empty.";s:23:"pay_bmf_street_or_pobox";s:47:"Please enter street and house number or po box.";s:23:"pay_bmf_subtotal_amount";s:15:"Subtotal amount";s:29:"pay_bmf_terms_conditions_read";s:59:"I have read the general terms and conditions and accept it.";s:29:"pay_bmf_terms_conditions_show";s:4:"show";s:24:"pay_bmf_terms_conditions";s:28:"General terms and conditions";s:14:"pay_bmf_thanks";s:36:"Thank you. Your order was submitted.";s:20:"pay_bmf_total_amount";s:12:"Total amount";s:16:"pay_bmf_validity";s:11:"valid until";s:20:"pay_bmf_vat_included";s:12:"VAT included";s:18:"pay_bmf_your_order";s:10:"Your order";s:16:"pay_change_price";s:33:"Change price/duration combination";s:16:"pay_click_to_buy";s:7:"Buy now";s:17:"pay_confirm_order";s:52:"Please confirm your order by entering your password.";s:28:"pay_crs_max_members_exceeded";s:83:"You cannot buy this course because the maximum number of users is already exceeded.";s:15:"pay_customer_no";s:12:"Customer no.";s:19:"pay_deleted_booking";s:27:"The entry has been deleted.";s:17:"pay_deleted_items";s:37:"The selected items have been deleted.";s:17:"pay_edit_abstract";s:13:"Edit Abstract";s:20:"pay_enable_shop_info";s:70:"If activated the ILIAS webshop is available and objects can be bought.";s:15:"pay_enable_shop";s:11:"Enable Shop";s:10:"pay_ending";s:9:"ends with";s:21:"pay_entitled_retrieve";s:29:"Entitled to retrieve data for";s:17:"pay_epay_canceled";s:25:"The payment was canceled.";s:16:"pay_epay_success";s:120:"The payment has been processed. Please be aware that it can take a few minutes before your purchase is fully registered.";s:16:"pay_expires_info";s:76:"This object is disposable. The payment has been expired, you can not buy it.";s:10:"pay_filter";s:6:"Filter";s:22:"pay_goto_buyed_objects";s:24:"Goto your bought objects";s:22:"pay_goto_shopping_cart";s:22:"Goto the shopping cart";s:10:"pay_header";s:4:"Shop";s:29:"pay_hide_advanced_search_info";s:62:"For simple shop with a few items hide the advanced search tab.";s:24:"pay_hide_advanced_search";s:20:"Hide Advanced Search";s:21:"pay_hide_coupons_info";s:122:"Hide coupons for the shopper. In case your shop is not using coupons this simplifies the buying process for your customer.";s:16:"pay_hide_coupons";s:12:"Hide coupons";s:23:"pay_hide_filtering_info";s:40:"Hide filtering options from the shopper.";s:18:"pay_hide_filtering";s:14:"Hide Filtering";s:18:"pay_hide_news_info";s:58:"Hides the shop news tab in case you\'re not using the news.";s:13:"pay_hide_news";s:9:"Hide news";s:13:"pay_hint_epay";s:11:"Tip to ePay";s:15:"pay_hint_paypal";s:15:"Hint for PayPal";s:13:"pay_info_epay";s:114:"When press ‘pay’ the ePay payment window opens. After you have completed the payment you will return to ILIAS.";s:15:"pay_info_paypal";s:401:"To pay for those objects that are in your shopping cart you\'ll leave ILIAS temporary and head for the PayPal website. Please follow the steps that are shown to you there. After paying successfully you\'ll be directed back to ILIAS automatically. Don\'t close the window of your browser at any time whilst the selling process. Otherwise the objects you\'ve bought can\'t be activated for you automatically.";s:8:"pay_info";s:314:"Access to the following material is not for free. If you want to gain access to a certain learning object please select a price. You can purchase one or several learning objects by using the button ‘shopping cart’ on your personal desktop.  You are going to gain immediate access to a chosen object and period.";s:37:"pay_item_already_in_sc_choose_another";s:109:"This object was already taken up in your shopping cart. Select if necessary a new price/duration combination.";s:22:"pay_item_already_in_sc";s:49:"This object already exists in your shopping cart.";s:11:"pay_locator";s:4:"Shop";s:28:"pay_manual_sorting_of_topics";s:24:"Manual Sorting of Topics";s:17:"pay_max_hits_info";s:63:"Please enter a number for the maximum number of search results.";s:12:"pay_max_hits";s:8:"Max hits";s:22:"pay_message_attachment";s:79:"As a confirmation for your order we send you a bill (PDF format) as attachment.";s:17:"pay_message_hello";s:4:"Dear";s:19:"pay_message_regards";s:15:"Yours sincerely";s:19:"pay_message_subject";s:16:"Your ILIAS order";s:18:"pay_message_thanks";s:31:"Thank you for your ILIAS order.";s:22:"pay_no_vendors_created";s:18:"No vendors created";s:24:"pay_not_buyed_any_object";s:31:"You have not bought any object.";s:19:"pay_order_date_from";s:15:"Order date from";s:18:"pay_order_date_til";s:14:"Order date til";s:19:"pay_order_paid_body";s:76:"Your invoice for %products% is attached this mail. Thank you for your order.";s:22:"pay_order_paid_subject";s:12:"Your invoice";s:14:"pay_payed_bill";s:18:"Bill already payed";s:16:"pay_unpayed_bill";s:55:"Please wire the open balance to the given bank account.";s:21:"pay_payed_credit_card";s:34:"The order was paid by credit card.";s:21:"pay_payed_debit_entry";s:34:"The order was paid by debit entry.";s:16:"pay_payed_paypal";s:29:"The order was paid by PayPal.";s:22:"pay_paypal_error_fails";s:59:"PayPal reports errors that occurred during the transaction.";s:21:"pay_paypal_error_info";s:86:"If necessary feel free to contact the system administrator of this ILIAS installation.";s:30:"pay_paypal_error_not_completed";s:44:"The transaction isn\'t totally completed yet.";s:30:"pay_paypal_error_prev_trans_id";s:59:"The transaction id given by PayPal was already used before.";s:31:"pay_paypal_error_wrong_customer";s:63:"Checking this transaction resulted in no match of the customer.";s:28:"pay_paypal_error_wrong_items";s:65:"Checking this transaction resulted in no match of the sold items.";s:29:"pay_paypal_error_wrong_vendor";s:61:"Checking this transaction resulted in no match of the vendor.";s:17:"pay_paypal_failed";s:51:"Your purchase of ILIAS objects using PayPal failed!";s:18:"pay_paypal_success";s:118:"Thanks for your purchase of ILIAS objects using PayPal! You\'ll receive a written confirmation in PDF format by e-mail.";s:22:"pay_paypal_unreachable";s:54:"The connection to the payment server of PayPal failed.";s:21:"pay_personal_settings";s:17:"Personal Settings";s:16:"pay_reset_filter";s:12:"Reset filter";s:16:"pay_save_sorting";s:12:"Save Sorting";s:19:"pay_select_one_item";s:23:"Please select one item.";s:16:"pay_select_price";s:43:"Please select a price/duration combination.";s:14:"pay_send_order";s:10:"Send order";s:23:"pay_shopping_cart_empty";s:28:"Your shopping cart is empty.";s:17:"pay_sorting_value";s:13:"Sorting Value";s:12:"pay_starting";s:11:"starts with";s:9:"pay_step1";s:47:"Your order - Step 1/3: Enter your personal data";s:9:"pay_step2";s:45:"Your order - Step 2/3: Choose kind of payment";s:21:"pay_step3_credit_card";s:70:"Your order - Step 3/3: Enter your credit card data and send your order";s:21:"pay_step3_debit_entry";s:63:"Your order - Step 3/3: Enter your bank data and send your order";s:13:"pay_thumbnail";s:9:"Thumbnail";s:36:"pay_topics_allow_custom_sorting_info";s:88:"If enabled, every user can determine the sorting of topics in the webshop independently.";s:31:"pay_topics_allow_custom_sorting";s:24:"Custom Sorting of Topics";s:36:"pay_topics_default_sorting_direction";s:35:"Default Sorting Direction of Topics";s:31:"pay_topics_default_sorting_type";s:30:"Default Sorting Type of Topics";s:23:"pay_topics_sort_by_date";s:7:"By Date";s:24:"pay_topics_sort_by_title";s:28:"Titles in Alphabetical Order";s:24:"pay_topics_sort_manually";s:8:"Manually";s:15:"pay_update_view";s:11:"Update view";s:11:"paya_access";s:6:"Access";s:17:"paya_add_customer";s:19:"Add Selling Process";s:20:"paya_add_price_title";s:9:"New price";s:14:"paya_add_price";s:13:"Add new price";s:21:"paya_added_new_object";s:60:"Added new object. Please edit the pay method and the prices.";s:20:"paya_added_new_price";s:17:"Created new price";s:18:"paya_added_trustee";s:20:"Created new trustee.";s:23:"paya_bookings_available";s:66:"This object has been sold. Please delete all statistic data first.";s:12:"paya_buyable";s:7:"Buyable";s:18:"paya_buyed_objects";s:14:"Bought Objects";s:20:"paya_count_purchaser";s:20:"Number of purchasers";s:35:"paya_coupon_codes_import_successful";s:18:"Import successful.";s:16:"paya_coupons_add";s:10:"Add Coupon";s:27:"paya_coupons_already_in_use";s:83:"The code you typed in belongs to the same coupon as a code which is already in use.";s:29:"paya_coupons_assigned_objects";s:16:"Assigned Objects";s:25:"paya_coupons_availability";s:35:"Maximum Number of Usage of one Code";s:23:"paya_coupons_code_chars";s:5:"Chars";s:38:"paya_coupons_code_deleted_successfully";s:20:"Deleted Successfully";s:28:"paya_coupons_code_generation";s:15:"Code Generation";s:24:"paya_coupons_code_length";s:11:"Code Length";s:17:"paya_coupons_code";s:4:"Code";s:25:"paya_coupons_codes_import";s:12:"Import Codes";s:32:"paya_coupons_codes_not_available";s:21:"No codes created yet.";s:18:"paya_coupons_codes";s:5:"Codes";s:25:"paya_coupons_coupon_added";s:13:"Coupon added.";s:29:"paya_coupons_coupon_not_found";s:42:"No coupon found for the code you typed in.";s:19:"paya_coupons_coupon";s:6:"Coupon";s:20:"paya_coupons_coupons";s:7:"Coupons";s:24:"paya_coupons_description";s:11:"Description";s:23:"paya_coupons_edit_codes";s:10:"Edit Codes";s:25:"paya_coupons_edit_objects";s:12:"Edit Objects";s:17:"paya_coupons_edit";s:11:"Edit Coupon";s:28:"paya_coupons_fix_all_objects";s:49:"%s %s discount on the total amount of all objects";s:33:"paya_coupons_fix_selected_objects";s:54:"%s %s discount on the total amount of selected objects";s:16:"paya_coupons_fix";s:3:"fix";s:17:"paya_coupons_from";s:10:"Valid From";s:27:"paya_coupons_generate_codes";s:14:"Generate Codes";s:25:"paya_coupons_import_codes";s:12:"Import Codes";s:38:"paya_coupons_import_error_opening_file";s:30:"Error opening the import file!";s:31:"paya_coupons_no_codes_generated";s:19:"No codes generated.";s:30:"paya_coupons_no_codes_selected";s:27:"You did not select any code";s:31:"paya_coupons_no_object_assigned";s:33:"No object assigned to the coupon.";s:26:"paya_coupons_not_available";s:23:"No coupons created yet.";s:22:"paya_coupons_not_found";s:17:"No coupons found.";s:22:"paya_coupons_not_valid";s:24:"The coupon is not valid.";s:28:"paya_coupons_number_of_codes";s:15:"Number of Codes";s:20:"paya_coupons_objects";s:7:"Objects";s:36:"paya_coupons_percentaged_all_objects";s:49:"%s %s discount on the total amount of all objects";s:41:"paya_coupons_percentaged_selected_objects";s:54:"%s %s discount on the total amount of selected objects";s:24:"paya_coupons_percentaged";s:11:"percentaged";s:34:"paya_coupons_sure_delete_all_codes";s:42:"Are you sure you want to delete all codes?";s:39:"paya_coupons_sure_delete_selected_codes";s:51:"Are you sure you want to delete the selected codes?";s:17:"paya_coupons_till";s:10:"Valid Till";s:18:"paya_coupons_title";s:5:"Title";s:22:"paya_coupons_type_auto";s:13:"Automatically";s:22:"paya_coupons_type_self";s:8:"Manually";s:17:"paya_coupons_type";s:11:"Coupon Type";s:31:"paya_coupons_unassigned_objects";s:18:"Unassigned Objects";s:27:"paya_coupons_usage_of_codes";s:14:"Usage of Codes";s:18:"paya_coupons_value";s:5:"Value";s:32:"paya_customer_added_successfully";s:61:"The selling process was added to the statistics successfully.";s:13:"paya_customer";s:8:"Customer";s:17:"paya_delete_price";s:12:"Delete price";s:23:"paya_delete_trustee_msg";s:26:"Deleted selected trustees.";s:23:"paya_deleted_last_price";s:32:"The last price has been deleted.";s:19:"paya_deleted_object";s:40:"Stopped payment for the selected object.";s:28:"paya_deleted_selected_prices";s:16:"Price(s) deleted";s:20:"paya_details_updated";s:16:"Details updated.";s:13:"paya_disabled";s:8:"Disabled";s:17:"paya_edit_details";s:12:"Edit Details";s:20:"paya_edit_pay_method";s:15:"Edit Pay Method";s:22:"paya_edit_prices_first";s:29:"Please edit the prices first.";s:16:"paya_edit_prices";s:11:"Edit Prices";s:12:"paya_enabled";s:7:"Enabled";s:16:"paya_enter_login";s:24:"Please enter a username.";s:22:"paya_err_adding_object";s:19:"Error adding object";s:26:"paya_error_adding_customer";s:69:"An error occurred while adding the selling process to the statistics.";s:27:"paya_error_mandatory_fields";s:40:"Please fill in all mandatory fields (*).";s:29:"paya_error_no_object_id_given";s:24:"Please choose an object.";s:25:"paya_error_update_booking";s:28:"Error saving statistic data.";s:12:"paya_expires";s:14:"Expire payment";s:19:"paya_filter_reseted";s:13:"Filter reset.";s:11:"paya_header";s:19:"Shop Administration";s:24:"paya_insert_only_numbers";s:28:"Please insert only integers.";s:16:"paya_insert_vats";s:15:"Insert Vat-Rate";s:12:"paya_locator";s:19:"Shop Administration";s:11:"paya_months";s:8:"Month(s)";s:24:"paya_no_booking_id_given";s:32:"Error: no ‘booking id’ given";s:16:"paya_no_bookings";s:23:"No statistic available.";s:23:"paya_no_object_selected";s:25:"Please select one object.";s:24:"paya_no_objects_assigned";s:29:"There are no objects to sell.";s:23:"paya_no_price_available";s:19:"No prices available";s:23:"paya_no_prices_selected";s:23:"Please select one price";s:26:"paya_no_settings_necessary";s:51:"There are no settings necessary for this pay method";s:16:"paya_no_trustees";s:20:"No trustees created.";s:19:"paya_no_valid_login";s:27:"This username is not valid.";s:20:"paya_no_vat_id_given";s:24:"There is no vat-id given";s:21:"paya_no_vats_assigned";s:16:"No vats assigned";s:23:"paya_no_vendor_selected";s:32:"You haven‘t selected a vendor.";s:24:"paya_not_assign_yourself";s:38:"It is not possible to assign yourself.";s:16:"paya_not_buyable";s:10:"Not to buy";s:27:"paya_object_not_purchasable";s:39:"It is not possible to sell this object.";s:11:"paya_object";s:7:"Objects";s:15:"paya_order_date";s:10:"Order date";s:29:"paya_pay_method_not_specified";s:13:"Not specified";s:15:"paya_pay_method";s:10:"Pay method";s:17:"paya_payed_access";s:12:"Payed/Access";s:10:"paya_payed";s:5:"Payed";s:17:"paya_perm_coupons";s:12:"Edit coupons";s:13:"paya_perm_obj";s:12:"Edit objects";s:14:"paya_perm_stat";s:15:"Edit statistics";s:20:"paya_price_not_valid";s:51:"This price is not valid. Please insert only numbers";s:26:"paya_select_object_to_sell";s:48:"Please select the object which you want to sell.";s:28:"paya_select_pay_method_first";s:35:"Please select one pay method first.";s:16:"paya_sell_object";s:11:"Sell object";s:18:"paya_shopping_cart";s:13:"Shopping Cart";s:14:"paya_statistic";s:9:"Statistic";s:23:"paya_sure_delete_object";s:88:"Are you sure, you want to stop payment for this object? All assigned data will get lost.";s:32:"paya_sure_delete_selected_prices";s:52:"Are you sure you want to delete the selected prices?";s:34:"paya_sure_delete_selected_trustees";s:54:"Are you sure you want to delete the selected trustees?";s:21:"paya_sure_delete_stat";s:48:"Are you sure, you want to delete this statistic?";s:20:"paya_sure_delete_vat";s:42:"Are you sure, you want to delete this vat?";s:21:"paya_sure_delete_vats";s:39:"Are you sure you want to delete vat(s)?";s:16:"paya_transaction";s:11:"Transaction";s:18:"paya_trustee_table";s:8:"Trustees";s:13:"paya_trustees";s:8:"Trustees";s:17:"paya_update_price";s:13:"Update prices";s:20:"paya_updated_booking";s:18:"Updated statistic.";s:18:"paya_updated_price";s:20:"The price was saved.";s:19:"paya_updated_prices";s:14:"Updated prices";s:21:"paya_updated_trustees";s:20:"Updated permissions.";s:26:"paya_user_already_assigned";s:22:"User already assigned.";s:23:"paya_vat_already_exists";s:28:"This vat rate already exists";s:20:"paya_vat_not_deleted";s:28:"This vat rate is not deleted";s:18:"paya_vat_not_valid";s:21:"This vat is not valid";s:14:"paya_vats_info";s:78:"If you like to sell an object without a vat, please insert a vat-rate with 0 %";s:11:"paya_vendor";s:6:"Vendor";s:15:"payment_add_vat";s:10:"Create VAT";s:36:"payment_already_bought_but_no_access";s:92:"You already bought the object %s, but you do not have access yet or your license is expired.";s:20:"payment_back_to_shop";s:12:"Back to Shop";s:23:"payment_cannot_find_vat";s:43:"Cannot find VAT data set for the passed id.";s:35:"payment_cannot_read_nonexisting_vat";s:52:"The ID for fechting the VAT data set was not passed.";s:32:"payment_cannot_save_existing_vat";s:28:"Cannot save an existing VAT.";s:37:"payment_cannot_update_nonexisting_vat";s:33:"Cannot update a non existing VAT.";s:16:"payment_edit_vat";s:8:"Edit VAT";s:27:"payment_login_to_buy_object";s:39:"Please login for purchasing the object.";s:21:"payment_news_add_news";s:13:"Add Shop News";s:32:"payment_news_archive_period_info";s:47:"Time period to define when news move to archive";s:27:"payment_news_archive_period";s:14:"Archive-Period";s:20:"payment_news_created";s:15:"Shop news added";s:24:"payment_news_delete_sure";s:48:"Are you sure, you want to delete this shop news?";s:20:"payment_news_deleted";s:17:"Shop news deleted";s:26:"payment_news_no_news_items";s:17:"No news available";s:27:"payment_news_settings_saved";s:28:"The settings have been saved";s:21:"payment_news_settings";s:18:"Shop News Settings";s:20:"payment_news_updated";s:24:"The news have been saved";s:12:"payment_news";s:9:"Shop News";s:25:"payment_no_price_selected";s:18:"No price selected.";s:30:"payment_no_price_type_selected";s:35:"Please select a type for the price.";s:16:"payment_no_topic";s:8:"No Topic";s:46:"payment_object_not_buyable_if_not_vat_assigned";s:74:"Until there is no VAT assigned the object cannot be bought in the webshop.";s:27:"payment_price_invalid_price";s:27:"Please enter a valid price.";s:30:"payment_shop_not_objects_found";s:33:"No objects to buy could be found.";s:17:"payment_tax_rates";s:9:"Tax Rates";s:26:"payment_vat_administration";s:14:"Administration";s:27:"payment_vat_already_created";s:40:"A VAT with this rate is already created.";s:32:"payment_vat_deleted_successfully";s:29:"VAT was deleted successfully.";s:53:"payment_vat_has_to_be_defined_by_administration_short";s:4:"----";s:25:"payment_vat_input_invalid";s:45:"Please insert a valid value for the VAT rate.";s:21:"payment_vat_rate_info";s:56:"Please insert the VAT rate (without the %-sign), e.g. 7.";s:22:"payment_vat_title_info";s:40:"Please insert a label/title for the VAT.";s:20:"pays_active_bookings";s:75:"There active bookings for the selected vendor(s). Please delete them first.";s:13:"pays_add_info";s:42:"Additional information for bill (optional)";s:15:"pays_add_vendor";s:10:"Add vendor";s:17:"pays_added_vendor";s:16:"Added new vendor";s:12:"pays_address";s:16:"Address for bill";s:29:"pays_already_assigned_vendors";s:52:"The following number of users were already assigned:";s:21:"pays_assigned_vendors";s:68:"The following number of users have been assigned to the vendor list:";s:15:"pays_auth_token";s:28:"Unique Token Given by PayPal";s:14:"pays_bank_data";s:18:"Bank data for bill";s:9:"pays_bill";s:4:"Bill";s:26:"pays_bmf_bewirtschafter_nr";s:12:"Operator No.";s:23:"pays_bmf_ca_certificate";s:22:"Path to CA-Certificate";s:27:"pays_bmf_client_certificate";s:26:"Path to Client-Certificate";s:18:"pays_bmf_client_id";s:9:"Cliend Id";s:24:"pays_bmf_epayment_server";s:15:"ePayment-Server";s:24:"pays_bmf_haushaltsstelle";s:20:"Accounting Entry BMF";s:34:"pays_bmf_kennzeichen_mahnverfahren";s:20:"Dunning Procedure Id";s:18:"pays_bmf_object_id";s:9:"Object Id";s:27:"pays_bmf_settings_not_valid";s:97:"Your settings for BMF aren\'t valid. Please check out whether all fields are filled out correctly.";s:17:"pays_bmf_settings";s:16:"Settings for BMF";s:16:"pays_bmf_timeout";s:7:"Timeout";s:29:"pays_bmf_waehrungskennzeichen";s:19:"Currency (e.g. EUR)";s:8:"pays_bmf";s:3:"BMF";s:26:"pays_cost_center_not_valid";s:33:"Please enter a valid cost center.";s:16:"pays_cost_center";s:11:"Cost center";s:21:"pays_currency_subunit";s:28:"Currency (1/100) (e.g. Cent)";s:18:"pays_currency_unit";s:19:"Currency (e.g. EUR)";s:18:"pays_delete_vendor";s:13:"Deassign user";s:27:"pays_deleted_number_vendors";s:50:"The following number of vendors have been deleted:";s:18:"pays_eco_agreement";s:16:"Agreement Number";s:24:"pays_eco_cur_handle_code";s:13:"Currency Code";s:15:"pays_eco_layout";s:14:"Invoice Layout";s:22:"pays_eco_payment_terms";s:13:"Payment Terms";s:23:"pays_eco_product_number";s:14:"Product Number";s:16:"pays_edit_vendor";s:9:"Edit user";s:17:"pays_email_vendor";s:26:"Mail Address of the Vendor";s:25:"pays_epay_auth_email_info";s:71:"Email where information about processed transactions/payments are sent.";s:20:"pays_epay_auth_email";s:18:"Email Notification";s:25:"pays_epay_auth_token_info";s:100:"You also need to enter this in the ePay backend. The secret prevents users from simulating payments.";s:20:"pays_epay_auth_token";s:20:"Authentication Token";s:14:"pays_epay_info";s:265:"<a href="http://www.epay.dk" target="_blank">ePay</a> is a payment gateway that enables ILIAS to receive VISA, MasterCard, JCB, VISA Electron, MasterCard Maestro, Diners, AMEX etc. In order to use this you must have a seperate agreement with ePay and a Merchant Id.";s:30:"pays_epay_instant_capture_info";s:152:"If enabled all amounts are drawn from the customer’s account immediately. Please make sure this is legal in your country before enabling this feature.";s:25:"pays_epay_instant_capture";s:15:"Instant Capture";s:25:"pays_epay_merchant_number";s:11:"Merchant id";s:21:"pays_epay_server_host";s:11:"Server host";s:21:"pays_epay_server_path";s:11:"Server path";s:28:"pays_epay_settings_not_valid";s:62:"The ePay settings could not be saved because they are invalid.";s:18:"pays_epay_settings";s:18:"ePay configuration";s:9:"pays_epay";s:4:"ePay";s:21:"pays_erp_bad_settings";s:56:"Please change the settings for %s as they are not valid.";s:31:"pays_erp_connection_established";s:44:"Connection established with %s successfully.";s:14:"pays_erp_error";s:26:"Error interacting with %s!";s:13:"pays_erp_info";s:90:"Enterprise, Resource and Planning systems setup. Integrates ILIAS with accounting systems.";s:25:"pays_erp_invoice_attached";s:38:"Your invoice is attached this message.";s:28:"pays_erp_invoice_copies_info";s:24:"Copies will be saved in:";s:23:"pays_erp_invoice_copies";s:33:"Save copies of generated invoices";s:24:"pays_erp_invoice_deleted";s:20:"Test Invoice Deleted";s:27:"pays_erp_invoice_delpreview";s:19:"Delete Test Invoice";s:24:"pays_erp_invoice_nowrite";s:26:"Cannot write to directory.";s:24:"pays_erp_invoice_preview";s:31:"View test invoice in new window";s:17:"pays_erp_settings";s:12:"ERP Settings";s:15:"pays_erp_system";s:10:"ERP System";s:19:"pays_erp_tst_billed";s:10:"billed for";s:21:"pays_erp_tst_existing";s:15:"Existing Debtor";s:16:"pays_erp_tst_new";s:10:"New Debtor";s:20:"pays_erp_tst_product";s:103:"This is just a test invoice. In an actual purchase the name of the course or file will be printed here.";s:25:"pays_erp_updated_settings";s:39:"ERP settings updated and %s set active.";s:8:"pays_erp";s:3:"ERP";s:31:"pays_general_settings_not_valid";s:97:"Your general settings aren\'t valid. Please check out whether all fields are filled out correctly.";s:21:"pays_general_settings";s:16:"General settings";s:12:"pays_general";s:7:"General";s:25:"pays_header_select_vendor";s:16:"Vendor selection";s:12:"pays_invoice";s:7:"Invoice";s:22:"pays_no_username_given";s:17:"No username given";s:28:"pays_no_valid_username_given";s:23:"No valid username given";s:23:"pays_no_vendor_selected";s:18:"No vendor selected";s:20:"pays_number_bookings";s:15:"Active bookings";s:23:"pays_objects_bill_exist";s:89:"Pay method ‘bill’ is activated for some objects. Therefore it can not be deactivated.";s:22:"pays_objects_bmf_exist";s:88:"Pay method ‘BMF’ is activated for some objects. Therefore it can not be deactivated.";s:25:"pays_objects_paypal_exist";s:91:"Pay method ‘PayPal’ is activated for some objects. Therefore it can not be deactivated.";s:12:"pays_offline";s:7:"Offline";s:11:"pays_online";s:6:"Online";s:15:"pays_page_style";s:10:"Page Style";s:16:"pays_pay_methods";s:11:"Pay methods";s:30:"pays_paypal_settings_not_valid";s:100:"Your settings for PayPal aren\'t valid. Please check out whether all fields are filled out correctly.";s:20:"pays_paypal_settings";s:19:"Settings for PayPal";s:11:"pays_paypal";s:6:"PayPal";s:13:"pays_pdf_path";s:36:"Path for generating bill as PDF file";s:16:"pays_server_host";s:41:"Server Host (e.g. https://www.paypal.com)";s:16:"pays_server_path";s:42:"Path to the Scripts (e.g. /cgi-bin/webscr)";s:33:"pays_sure_delete_selected_vendors";s:51:"Do you really want to delete the selected vendor(s)";s:30:"pays_too_many_vendors_selected";s:55:"Please select only one customer to perform this action.";s:25:"pays_updated_bmf_settings";s:35:"Your settings for BMF were updated.";s:26:"pays_updated_epay_settings";s:29:"Settings for ePay was updated";s:29:"pays_updated_general_settings";s:35:"Your general settings were updated.";s:23:"pays_updated_pay_method";s:19:"Changed pay method.";s:28:"pays_updated_paypal_settings";s:38:"Your settings for PayPal were updated.";s:26:"pays_user_already_assigned";s:48:"This user is already assigned to the vendor list";s:13:"pays_vat_rate";s:24:"VAT rate in % (optional)";s:11:"pays_vendor";s:6:"Vendor";s:7:"price_a";s:5:"Price";s:10:"price_from";s:4:"from";s:6:"prices";s:6:"Prices";s:12:"reset_filter";s:12:"Reset Filter";s:15:"search_in_title";s:15:"Search in title";s:16:"select_one_topic";s:33:"Please select at least one topic.";s:10:"set_filter";s:10:"Set Filter";s:9:"shop_info";s:16:"Shop Information";s:8:"sort_asc";s:14:"sort ascending";s:7:"sort_by";s:15:"Sort Objects by";s:9:"sort_desc";s:15:"sort descending";s:19:"sort_topics_by_date";s:4:"Date";s:20:"sort_topics_by_title";s:5:"Title";s:14:"sort_topics_by";s:14:"Sort Topics by";s:20:"sort_topics_manually";s:8:"Manually";s:4:"sort";s:4:"Sort";s:24:"statistics_filter_advice";s:83:"Please choose your favoured filter settings and press the ‘Update View’ button.";s:18:"sure_delete_topics";s:50:"Are you sure you want to delete the chosen topics?";s:12:"topic_edited";s:33:"The topic was edited successfully";s:11:"topic_saved";s:32:"The topic was saved successfully";s:11:"topic_title";s:5:"Title";s:5:"topic";s:5:"Topic";s:14:"topics_deleted";s:43:"The chosen topics were deleted successfully";s:6:"topics";s:6:"Topics";s:18:"unlimited_duration";s:18:"Unlimited duration";s:6:"update";s:6:"Update";s:12:"user_deleted";s:12:"User Deleted";s:8:"vat_rate";s:8:"Vat-Rate";s:9:"vat_title";s:9:"Vat-Title";s:8:"vat_unit";s:8:"Vat-Unit";s:4:"vats";s:4:"Vats";s:17:"paya_bill_history";s:12:"Bill History";s:21:"have_existing_account";s:81:"Do you already have an existing account? Please enter your username and password.";s:24:"have_no_existing_account";s:103:"if you don\'t have an account, you are able to login in with this account:(Username: %s  Password: %s ).";s:18:"please_use_account";s:57:"For further purchases please login with use your account.";s:13:"buy_extension";s:13:"Buy Extension";s:15:"extension_price";s:15:"Extension Price";s:16:"terms_conditions";s:3:"GTC";s:23:"accept_terms_conditions";s:56:"Please accept the %s to continue the purchasing process.";s:9:"documents";s:9:"Documents";s:21:"activate_placeholders";s:21:"Activate Placeholders";s:12:"billing_mail";s:13:"Billing-Email";s:14:"select_subtype";s:9:"Suboption";s:18:"pay_hide_shop_info";s:21:"Hide Shop-Information";s:23:"pay_hide_shop_info_info";s:30:"Hides the tab shop-information";s:17:"use_shop_specials";s:17:"Use Shop Specials";s:22:"use_shop_specials_info";s:126:"If enabled, it is possible to mark shop objects as a ‘special’-offer. These objects will be shown on the entire shop site.";s:7:"special";s:13:"Special-Offer";s:12:"special_info";s:62:"If enabled, this object will be shown on the entire shop site.";s:8:"shop_url";s:12:"Link to shop";s:23:"shop_bought_objects_url";s:22:"Link to bought objects";s:20:"ilias_invoice_number";s:20:"ILIAS invoice number";s:26:"userdefined_invoice_number";s:26:"Userdefined invoice number";s:23:"incremental_start_value";s:18:"Incremental Number";s:28:"incremental_start_value_info";s:78:"This start value will be used as first incremental number for the next period.";s:25:"incremental_current_value";s:26:"current incremental number";s:19:"invoice_number_text";s:25:"invoice number definition";s:19:"show_general_filter";s:19:"Show general filter";s:24:"show_general_filter_info";s:62:"Let users find buyable objects with this general search filter";s:18:"show_topics_filter";s:18:"Show topics filter";s:23:"show_topics_filter_info";s:54:"Let users find buyable objects with this topics filter";s:18:"show_shop_explorer";s:18:"Show shop explorer";s:23:"show_shop_explorer_info";s:56:"This shop explorer simplifies the navigation within shop";s:8:"position";s:4:"Pos.";s:6:"amount";s:6:"Amount";s:16:"external_bill_no";s:14:"%s Billing-No.";s:24:"day_of_service_provision";s:24:"Day of service provision";s:14:"total_netprice";s:28:"Total netprice (without VAT)";s:10:"unit_price";s:10:"Unit price";s:8:"plus_vat";s:8:"Plus VAT";s:6:"credit";s:6:"Credit";s:27:"period_of_service_provision";s:27:"Period of service provision";s:21:"check_shop_activation";s:34:"Check Shop Settings for activation";s:21:"please_enter_currency";s:23:"Please enter a currency";s:20:"please_enter_address";s:23:"Please enter an address";s:22:"please_enter_bank_data";s:29:"Please enter the bank details";s:21:"please_enter_pdf_path";s:51:"Please enter a path for generating bill as PDF file";s:29:"please_activate_one_paymethod";s:39:"Please activate at least one pay method";s:21:"please_enter_bmf_data";s:26:"Please enter your BMF data";s:24:"please_enter_paypal_data";s:29:"Please enter your Paypal data";s:22:"please_enter_epay_data";s:27:"Please enter your EPay data";s:17:"please_enter_vats";s:30:"Please create at least one vat";s:20:"please_create_vendor";s:33:"Please create at least one vendor";s:18:"shop_activation_ok";s:65:"The shop settings are complete. You can now activate the webshop.";s:17:"click_to_buy_info";s:134:"You are successfully logged on. For continuing the purchasing process accept the general terms and conditions and click the buy button";s:22:"click_to_continue_info";s:76:"To continue the shopping process, click on "Continue" to log in or register.";s:14:"duration_month";s:25:"Access duration in months";s:13:"duration_date";s:15:"Access duration";s:22:"please_choose_category";s:24:"Please choose a category";s:12:"placeholders";s:12:"Placeholders";s:17:"current_timestamp";s:22:"Current Unix Timestamp";s:7:"user_id";s:7:"User ID";s:18:"incremental_number";s:19:"Incrementing Number";s:15:"topics_settings";s:15:"Topics Settings";s:13:"enable_topics";s:13:"Enable Topics";s:18:"enable_topics_info";s:70:"If enabled, you can assign purchasable objects to self-created topics.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'pd'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:59:{s:22:"pd_enable_active_users";s:25:"Enable Active Users Block";s:27:"pd_enable_block_moving_info";s:69:"Allow users to reorganize the content blocks on the personal desktop.";s:22:"pd_enable_block_moving";s:19:"Enable Block Moving";s:19:"pd_enable_bookmarks";s:16:"Enable Bookmarks";s:30:"pd_enable_global_profiles_info";s:66:"If enabled, users can make their profiles visible to the internet.";s:25:"pd_enable_global_profiles";s:22:"Enable Public Profiles";s:29:"pd_enable_my_memberships_info";s:96:"‘My Courses and Groups’ contains all courses and groups the user is assigned to as a member.";s:24:"pd_enable_my_memberships";s:34:"Enable ‘My Courses and Groups’";s:24:"pd_enable_my_offers_info";s:99:"The view ‘Selected Items’ contains all objects which are placed on the user\'s Personal Desktop.";s:19:"pd_enable_my_offers";s:27:"Enable ‘Selected Items’";s:15:"pd_enable_notes";s:12:"Enable Notes";s:23:"pd_my_memberships_intro";s:27:"Welcome to Your Memberships";s:24:"pd_my_memberships_intro2";s:478:"This is your personal space for all courses and groups you participate in. Currently, there aren\'t any memberships assigned to you. To become a member of a course or group, there are two ways:<br /><ol><li>You can join courses or groups provided that joining them has been allowed by their administrators.</li><li>An administratrator of a course or group can assign a membership to you.</li></ol><br />In any case, the respective objects will appear automatically in this place.";s:17:"pd_my_memberships";s:14:"My Memberships";s:12:"pd_my_offers";s:14:"Selected Items";s:16:"pd_osi_host_info";s:63:"Instant Messenger Online Status Indicator Host (optional). See:";s:11:"pd_osi_host";s:8:"OSI Host";s:35:"pd_personal_items_default_view_info";s:44:"Choose the preferred view of Personal Items.";s:30:"pd_personal_items_default_view";s:12:"Default View";s:11:"pd_settings";s:16:"Personal Desktop";s:27:"pd_time_before_removal_info";s:85:"After this time of inactivity, users are removed from the list of ‘Active Users’.";s:22:"pd_time_before_removal";s:33:"Maximum Inactivity Time (Minutes)";s:27:"pd_view_select_at_least_one";s:94:"You have to select at least one view, either ‘Selected Items’ and/or ‘My Memberships’.";s:28:"pd_enable_personal_workspace";s:25:"Enable Personal Workspace";s:19:"pd_enable_wsp_blogs";s:12:"Enable Blogs";s:19:"pd_enable_wsp_files";s:12:"Enable Files";s:26:"pd_enable_wsp_certificates";s:19:"Enable Certificates";s:19:"pd_enable_wsp_links";s:12:"Enable Links";s:14:"pd_enable_prtf";s:17:"Enable Portfolios";s:18:"pd_enable_comments";s:15:"Enable Comments";s:27:"pd_enable_user_publish_info";s:90:"If enabled, users can publish their profiles, workspace objects and portfolios on the Web.";s:22:"pd_enable_user_publish";s:30:"Enable User Content Publishing";s:17:"pd_export_profile";s:20:"Export Personal Data";s:28:"pd_download_last_export_file";s:25:"Download Last Export File";s:23:"pd_import_personal_data";s:20:"Import Personal Data";s:15:"pd_profile_data";s:12:"Profile Data";s:12:"pd_bookmarks";s:9:"Bookmarks";s:8:"pd_notes";s:22:"Personal Desktop Notes";s:20:"pd_private_calendars";s:17:"Private Calendars";s:16:"block_show_pdcal";s:13:"Show Calendar";s:17:"block_show_pdmail";s:9:"Show Mail";s:16:"block_show_pdtag";s:12:"Show My Tags";s:17:"block_show_pdnews";s:9:"Show News";s:18:"block_show_pdusers";s:17:"Show Active Users";s:18:"block_show_pdnotes";s:10:"Show Notes";s:21:"block_show_chatviewer";s:16:"Show Chat Viewer";s:18:"block_show_pdbookm";s:14:"Show Bookmarks";s:19:"block_create_pdfeed";s:15:"Add New Webfeed";s:12:"block_show_x";s:7:"Show %s";s:26:"pd_info_delete_sure_remove";s:81:"Are you sure you want to remove the following objects from your Personal Desktop?";s:31:"pd_info_delete_sure_unsubscribe";s:64:"Are you sure you want to unsubscribe from the following objects?";s:16:"pd_min_one_admin";s:67:"There has to be at least one administrator assigned to this object.";s:18:"pd_remove_multiple";s:23:"Remove Multiple Objects";s:35:"pd_unsubscribe_multiple_memberships";s:20:"Unsubscribe Multiple";s:26:"pd_unsubscribe_memberships";s:11:"Unsubscribe";s:21:"pd_personal_workspace";s:18:"Personal Workspace";s:23:"pd_remove_multi_confirm";s:25:"The objects were removed.";s:27:"pd_enable_comments_del_user";s:40:"Comments may be deleted by their authors";s:28:"pd_enable_comments_del_tutor";s:36:"Any Comment may be deleted by tutors";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'ps'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:102:{s:35:"ps_account_security_mode_customized";s:28:"Customized Password Security";s:32:"ps_account_security_mode_default";s:32:"Standard Ilias Password Security";s:24:"ps_account_security_mode";s:17:"Password Security";s:21:"ps_agreement_accepted";s:23:"User Agreement Accepted";s:25:"crs_ps_agreement_req_info";s:73:"Please accept the user agreement for having access to the course content.";s:25:"grp_ps_agreement_req_info";s:72:"Please accept the user agreement for having access to the group content.";s:25:"ps_auto_https_description";s:97:"If enabled, ILIAS tries to detect the HTTPs Status by analysing the header value specified below.";s:25:"ps_auto_https_header_name";s:11:"Header Name";s:26:"ps_auto_https_header_value";s:12:"Header Value";s:13:"ps_auto_https";s:16:"Autodetect HTTPS";s:16:"ps_btn_add_value";s:9:"New Value";s:16:"ps_cdf_add_field";s:14:"Add User Field";s:18:"ps_cdf_added_field";s:24:"Added new selection box.";s:18:"ps_cdf_delete_sure";s:48:"Do you really want to delete these user fields ?";s:20:"ps_cdf_deleted_field";s:13:"Deleted value";s:14:"ps_cdf_deleted";s:19:"Deleted user fields";s:15:"crs_ps_cdf_info";s:29:"Further Course-Specific Data:";s:15:"grp_ps_cdf_info";s:28:"Further Group-Specific Data:";s:11:"ps_cdf_name";s:4:"Name";s:16:"ps_cdf_no_fields";s:22:"No User Fields Defined";s:20:"ps_cdf_no_name_given";s:20:"Please enter a name.";s:15:"ps_cdf_required";s:14:"Required Field";s:17:"ps_cdf_select_one";s:18:"Please select one.";s:11:"ps_cdf_type";s:4:"Type";s:12:"ps_cdf_value";s:5:"Value";s:21:"ps_cdf_warning_modify";s:131:"Attention: Minimum one user has accepted the user agreement. Modifying these course specific fields will reset all user agreements.";s:18:"ps_crs_user_fields";s:27:"Course-Specific User Fields";s:18:"ps_grp_user_fields";s:26:"Group-Specific User Fields";s:22:"ps_delete_export_files";s:20:"Deleted export files";s:20:"ps_edit_select_field";s:18:"Edit Selection Box";s:18:"ps_edit_text_field";s:15:"Edit Text Field";s:37:"ps_error_message_https_header_missing";s:95:"If you enable the automatic https detection you have to provide a header name and header value.";s:43:"ps_error_message_invalid_login_max_attempts";s:46:"Maximum login attempts may not be less than 0.";s:41:"ps_error_message_invalid_password_max_age";s:44:"Maximum password age may not be less than 0.";s:44:"ps_error_message_invalid_password_max_length";s:45:"Maximum password size may not be less than 0.";s:44:"ps_error_message_invalid_password_min_length";s:45:"Minimum password size may not be less than 0.";s:38:"ps_error_message_password_max_less_min";s:65:"Maximum password size may not be less than minimum password size.";s:44:"ps_error_message_password_min1_because_chars";s:46:"Minimum password size may not be less than %s.";s:52:"ps_error_message_password_min2_because_chars_numbers";s:97:"Minimum password size may not be less than %s if password have to contain characters and numbers.";s:55:"ps_error_message_password_min3_because_chars_numbers_sc";s:117:"Minimum password size may not be less than %s if password have to contain characters, numbers and special characters.";s:15:"ps_export_admin";s:14:"Administrators";s:17:"ps_export_confirm";s:39:"User Confirmation when Entering Courses";s:23:"ps_export_confirm_group";s:38:"User Confirmation when Entering Groups";s:16:"ps_export_course";s:42:"Visibility of User Profile Data in Courses";s:16:"ps_export_groups";s:41:"Visibility of User Profile Data in Groups";s:14:"ps_export_data";s:34:"Data Types of the Personal Profile";s:15:"ps_export_files";s:12:"Export Files";s:16:"ps_export_member";s:7:"Members";s:18:"ps_export_settings";s:15:"Export Settings";s:13:"ps_export_sub";s:11:"Subscribers";s:15:"ps_export_tutor";s:6:"Tutors";s:19:"ps_export_user_data";s:10:"Data Types";s:14:"ps_export_wait";s:25:"Users on the Waiting List";s:13:"ps_field_type";s:10:"Field Type";s:16:"ps_files_deleted";s:20:"Export Files Deleted";s:26:"ps_login_max_attempts_info";s:84:" Sets the maximum count of wrong login attempts. Leave empty to disable this option.";s:21:"ps_login_max_attempts";s:22:"Maximum Login Attempts";s:13:"ps_name_field";s:4:"Name";s:19:"ps_new_select_field";s:17:"New Selection Box";s:17:"ps_new_text_field";s:18:"Add new Text Field";s:15:"ps_not_accepted";s:12:"Not Accepted";s:46:"ps_password_change_on_first_login_enabled_info";s:100:"If enabled, users have to change their password on first login (except users registered themselves).";s:41:"ps_password_change_on_first_login_enabled";s:30:"Change Password on First Login";s:42:"ps_password_chars_and_numbers_enabled_info";s:61:"If enabled, passwords have to contain characters and numbers.";s:37:"ps_password_chars_and_numbers_enabled";s:28:"Force Characters and Numbers";s:24:"ps_password_max_age_info";s:83:"Sets the maximum age of passwords in days. Set this to 0 for disabling this option.";s:19:"ps_password_max_age";s:20:"Maximum Password Age";s:27:"ps_password_max_length_info";s:84:"Sets the maximum size of account passwords. Set this to 0 for disabling this option.";s:22:"ps_password_max_length";s:21:"Maximum Password Size";s:27:"ps_password_min_length_info";s:300:"Sets the minimum size of account passwords. If set to 0, the passwords anyway have to have a minimum size of 1. If the required length is altered, the new requirement will be applied only to those accounts that were created or changed after the new length was set. Existing accounts are not affected.";s:22:"ps_password_min_length";s:21:"Minimum Password Size";s:38:"ps_password_special_chars_enabled_info";s:57:"If enabled, passwords have to contain special characters.";s:33:"ps_password_special_chars_enabled";s:24:"Force Special Characters";s:17:"ps_perform_export";s:16:"Start CSV-Export";s:35:"ps_prevent_simultaneous_logins_info";s:96:"If enabled, simultaneous logins with the same account from different computers are not possible.";s:30:"ps_prevent_simultaneous_logins";s:27:"Prevent Simultaneous Logins";s:21:"ps_privacy_protection";s:16:"Privacy Settings";s:17:"ps_profile_export";s:31:"Protection of User Profile Data";s:20:"crs_ps_required_info";s:77:"Further Course-Specific fields are required for accessing the course content.";s:20:"grp_ps_required_info";s:75:"Further Group-Specific fields are required for accessing the group content.";s:22:"ps_security_protection";s:17:"Security Settings";s:13:"ps_select_one";s:29:"Please select one export file";s:18:"ps_show_crs_access";s:44:"Show last access time of course participants";s:18:"ps_show_grp_access";s:43:"Show last access time of group participants";s:7:"ps_size";s:10:"Files Size";s:19:"ps_type_select_long";s:28:"Selection Box (Fixed Values)";s:14:"ps_type_select";s:12:"Select Field";s:12:"ps_type_text";s:10:"Text Field";s:16:"ps_type_txt_long";s:28:"Text Field (Optional Values)";s:17:"ps_user_selection";s:22:"Participants Selection";s:17:"ps_warning_modify";s:117:"Attention: Minimum one user has accepted the user agreement. Modifying these settings will reset all user agreements.";s:12:"show_privacy";s:7:"Privacy";s:13:"show_security";s:8:"Security";s:8:"rbac_log";s:14:"Permission Log";s:13:"rbac_log_info";s:51:"Enable logging of all changes to object permissions";s:12:"rbac_log_age";s:16:"Keep Log Entries";s:17:"rbac_log_age_info";s:35:"Maximum age of log entries in month";s:18:"ps_cdf_data_fields";s:21:"Available User Fields";s:17:"ps_cdf_edit_field";s:15:"Edit Data Field";s:15:"ps_export_excel";s:18:"Start Excel Export";s:20:"ps_password_settings";s:17:"Password Settings";s:18:"cdf_edited_by_self";s:11:"by the User";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'registration'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:106:{s:21:"auth_radius_name_desc";s:50:"Please choose a name for this server configuration";s:16:"auth_radius_name";s:28:"Name of RADIUS Configuration";s:23:"auth_radius_role_select";s:5:"Role:";s:21:"auth_radius_sync_info";s:91:"If enabled new user accounts will be created automatically after successful authentication.";s:16:"auth_radius_sync";s:20:"User Synchronization";s:34:"reg_access_limitation_limited_time";s:29:"After registration access for";s:35:"reg_access_limitation_limited_until";s:23:"Access is limited until";s:34:"reg_access_limitation_missing_mode";s:53:"Please choose for all roles an Access Limitation Mode";s:35:"reg_access_limitation_mode_absolute";s:33:"Access is limited by a fixed date";s:35:"reg_access_limitation_mode_relative";s:57:"Limited access for a fixed time period after registration";s:36:"reg_access_limitation_mode_unlimited";s:20:"No access limitation";s:26:"reg_access_limitation_mode";s:22:"Access Limitation Mode";s:26:"reg_access_limitation_none";s:16:"Unlimited access";s:33:"reg_access_limitation_out_of_date";s:53:"One or more Roles have an outdated access limitation!";s:22:"reg_access_limitations";s:17:"Access Limitation";s:37:"reg_activation_your_confirmation_link";s:23:"Your confirmation link:";s:18:"reg_add_assignment";s:14:"New Assignment";s:20:"reg_added_assignment";s:21:"Added new assignment.";s:16:"reg_approve_info";s:76:"If checked any new user registration has to be approved by an administrator.";s:27:"reg_approve_needs_recipient";s:149:"You should define minimum one user who will be notified about new registrations, if the registration type ‘Registration with Approval’ is chosen.";s:11:"reg_approve";s:26:"Registration with Approval";s:19:"reg_available_roles";s:16:"Available Roles:";s:39:"reg_confirmation_hash_life_time_expired";s:66:"The confirmation link is not valid anymore. Please register again!";s:36:"reg_confirmation_hash_life_time_info";s:86:"Enter the lifetime (seconds) of confirmation links. Recommended value is 1800 seconds.";s:31:"reg_confirmation_hash_not_found";s:59:"No user account could be matched to this confirmation link.";s:32:"reg_confirmation_hash_not_passed";s:46:"The confirmation link was not entirely passed.";s:32:"reg_confirmation_link_successful";s:300:"You successfully submitted an account request to ILIAS. You will receive a confirmation e-mail in the next minutes. Please confirm your registration by clicking the confirmation link in this mail.<br />You will be redirected to the <a href="%s" title="login screen">login screen</a> after 20 seconds.";s:11:"reg_default";s:7:"Default";s:22:"reg_deleted_assignment";s:22:"Deleted assignment(s).";s:15:"reg_direct_info";s:80:"If this is checked, any new user registration request is automatically approved.";s:10:"reg_direct";s:19:"Direct Registration";s:12:"reg_disabled";s:24:"No Registration Possible";s:10:"reg_domain";s:6:"Domain";s:25:"reg_email_role_assignment";s:25:"Role Assignment By Domain";s:9:"reg_email";s:25:"Automatic Role Assignment";s:29:"reg_enable_access_limitations";s:24:"Enable Access Limitation";s:9:"reg_fixed";s:29:"Selection From Specified List";s:12:"reg_info_pwd";s:76:"If enabled passwords will be send automatically to the new users per E-Mail.";s:21:"reg_mail_body_approve";s:149:"You already have registered to ILIAS eLearning and received a e-mail with your account data. Now your account has been activated by an administrator.";s:26:"reg_mail_body_confirmation";s:90:"To confirm this registration enter the ILIAS user administration and activate the account.";s:29:"reg_mail_body_profile_changed";s:26:"your profile has changed !";s:21:"reg_mail_body_profile";s:13:"Profile data:";s:28:"reg_mail_body_pwd_generation";s:163:"Your account request will be reviewed by an administrator, and should be activated within 48 hours. You will be informed by e-mail when approval has been obtained.";s:20:"reg_mail_body_reason";s:131:"You receive mail from ILIAS because notifications about new registrations are enabled for your account in the ILIAS administration.";s:22:"reg_mail_new_user_body";s:31:"a new user has been registered.";s:17:"reg_mail_new_user";s:21:"New user registration";s:18:"reg_missing_domain";s:27:"Please fill out all fields.";s:16:"reg_missing_role";s:27:"Please fill out all fields.";s:21:"reg_notification_info";s:117:"Enter one or more Login-Ids of users (comma separated) that will be informed about new user registrations per e-mail.";s:16:"reg_notification";s:13:"Notifications";s:27:"reg_role_access_limitations";s:59:"Define access limitations of Roles for new registered Users";s:19:"reg_role_assignment";s:15:"Role Assignment";s:13:"reg_role_info";s:14:"Assigned Roles";s:14:"reg_select_one";s:24:"Please select one entry.";s:20:"reg_selectable_roles";s:16:"Selectable Roles";s:19:"reg_settings_header";s:25:"New Registration Settings";s:26:"reg_type_confirmation_info";s:186:"This type allows self-registration of users but requires an email confirmation to activate the account. This avoids self-registration to ILIAS with wrong or non-existent email addresses.";s:21:"reg_type_confirmation";s:37:"Registration with E-Mail Confirmation";s:8:"reg_type";s:17:"Registration Type";s:22:"reg_unknown_recipients";s:35:"The following logins are not valid:";s:21:"registration_settings";s:30:"ILIAS Auth / Self-Registration";s:34:"registration_user_new_account_mail";s:21:"Edit New Account Mail";s:25:"registration_tab_settings";s:21:"Registration Settings";s:22:"registration_tab_codes";s:18:"Registration Codes";s:27:"registration_reg_type_codes";s:23:"Registration with Codes";s:32:"registration_reg_type_codes_info";s:70:"This type allows self-registration of users but requires a valid code.";s:22:"registration_codes_add";s:9:"Add Codes";s:25:"registration_codes_export";s:12:"Export Codes";s:30:"registration_codes_edit_header";s:9:"Add Codes";s:25:"registration_codes_number";s:15:"Number Of Codes";s:24:"registration_codes_roles";s:11:"Global Role";s:17:"registration_code";s:4:"Code";s:22:"registration_generated";s:18:"Date Of Generation";s:17:"registration_used";s:13:"Date Of Usage";s:22:"registration_roles_all";s:9:"All Roles";s:26:"registration_generated_all";s:9:"All Dates";s:33:"registration_export_codes_no_data";s:33:"No codes to export were selected.";s:27:"registration_code_not_valid";s:71:"The given registration code is either invalid or already has been used.";s:31:"reg_confirmation_hash_life_time";s:8:"Lifetime";s:15:"reg_allow_codes";s:11:"Allow Codes";s:20:"reg_allow_codes_info";s:45:"Users are also allowed to register via codes.";s:25:"registration_code_no_role";s:117:"The registration code given does not specify a role and can not be used currently. Please contact your administrator.";s:26:"registration_no_valid_role";s:85:"There is currently no valid role for new accounts. Please contact your administrator.";s:31:"registration_code_optional_info";s:58:"If you have got a registration code, please enter it here.";s:31:"registration_code_required_info";s:61:"A pre-defined code is mandatory for the registration process.";s:27:"registration_code_role_info";s:81:"If you use a registration code, the role selection may be superseded by the code.";s:17:"reg_email_domains";s:49:"The following email address domains are valid: %s";s:19:"reg_allowed_domains";s:29:"Allowed Email Address Domains";s:24:"reg_allowed_domains_info";s:78:"Use * as wildcard and ; as separator. Registration codes override these rules.";s:35:"registration_codes_no_assigned_role";s:27:"No Predefined Assigned Role";s:30:"registration_codes_roles_local";s:13:"Local Role(s)";s:30:"registration_codes_roles_title";s:21:"Role for New Accounts";s:40:"registration_codes_roles_limitation_none";s:31:"No Predefined Access Limitation";s:42:"reg_access_limitation_mode_absolute_target";s:11:"Valid until";s:42:"reg_access_limitation_mode_relative_target";s:9:"Valid for";s:40:"registration_codes_access_limitation_all";s:3:"All";s:32:"registration_codes_override_info";s:73:"This setting overrides any values defined in ‘Registration Settings’.";s:39:"registration_codes_override_global_info";s:55:"These settings may be overridden by registration codes.";s:22:"reg_email_domains_code";s:53:"With a registration code any E-Mail-Address is valid.";s:30:"reg_mail_new_user_confirmation";s:32:"Request for account confirmation";s:23:"reg_mail_body_timelimit";s:50:"Your account has a limited period of validity: %s.";s:23:"registration_codes_type";s:9:"Code Type";s:27:"registration_codes_type_reg";s:17:"Registration Code";s:32:"registration_codes_type_reg_info";s:59:"Code can be used for the registration if a new user account";s:27:"registration_codes_type_ext";s:34:"Extension of limited user accounts";s:32:"registration_codes_type_ext_info";s:55:"Code can be used for the extension of limited accounts.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'style'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:301:{s:9:"sty_acopy";s:4:"Copy";s:22:"sty_add_characteristic";s:15:"Add Style Class";s:13:"sty_add_color";s:9:"Add Color";s:13:"sty_add_image";s:9:"Add Image";s:11:"sty_add_pgl";s:15:"Add Page Layout";s:16:"sty_add_template";s:12:"Add Template";s:24:"sty_added_characteristic";s:18:"Added style class.";s:7:"sty_all";s:3:"All";s:25:"sty_background_attachment";s:21:"Background Attachment";s:20:"sty_background_color";s:16:"Background Color";s:20:"sty_background_image";s:16:"Background Image";s:23:"sty_background_position";s:19:"Background Position";s:21:"sty_background_repeat";s:17:"Background Repeat";s:14:"sty_background";s:10:"Background";s:14:"sty_base_color";s:10:"Base Color";s:12:"sty_based_on";s:8:"Based on";s:19:"sty_border_collapse";s:15:"Border Collapse";s:16:"sty_border_color";s:12:"Border Color";s:16:"sty_border_style";s:12:"Border Style";s:16:"sty_border_width";s:12:"Border Width";s:10:"sty_border";s:6:"Border";s:10:"sty_bottom";s:6:"Bottom";s:17:"sty_caption_class";s:7:"Caption";s:16:"sty_caption_side";s:12:"Caption Side";s:11:"sty_caption";s:7:"Caption";s:33:"sty_characteristic_already_exists";s:63:"A style class with this title already exists within this style.";s:9:"sty_clear";s:5:"Clear";s:18:"sty_col_foot_class";s:13:"Column Footer";s:18:"sty_col_head_class";s:13:"Column Header";s:24:"sty_color_already_exists";s:52:"A color with this name already exists in this style.";s:14:"sty_color_code";s:10:"Color Code";s:17:"sty_color_flavors";s:13:"Color Flavors";s:14:"sty_color_info";s:290:"Predefined colors make it easy to reuse a color for different purposes. You refer to a predefined color by using its name with a leading ‘!’ for any color attribute in your style classes. To use a flavour, append a lightness value in brackets to the color name, e.g. ‘!MyColor(20)’.";s:14:"sty_color_name";s:10:"Color Name";s:9:"sty_color";s:5:"Color";s:10:"sty_colors";s:6:"Colors";s:12:"sty_commands";s:8:"Commands";s:25:"sty_confirm_char_deletion";s:67:"Are you sure that you want to delete the following style class(es)?";s:26:"sty_confirm_color_deletion";s:22:"Confirm Color Deletion";s:31:"sty_confirm_del_ind_styles_desc";s:154:"All learning modules with individual styles will be assigned to style \'%s\'. This will also delete all individual content styles. Are you sure to continue?";s:26:"sty_confirm_del_ind_styles";s:45:"Confirm Deletion of Individual Content Styles";s:29:"sty_confirm_template_deletion";s:25:"Confirm Template Deletion";s:25:"sty_copy_other_stylesheet";s:28:"Copy Style from Local Source";s:20:"sty_create_ind_style";s:23:"Create Individual Style";s:25:"sty_create_new_stylesheet";s:16:"Create new Style";s:14:"sty_create_pgl";s:18:"Create Page Layout";s:10:"sty_cursor";s:6:"Cursor";s:17:"sty_default_style";s:13:"Default Style";s:29:"sty_del_template_keep_classes";s:29:"Delete and keep Style Classes";s:16:"sty_del_template";s:28:"Delete Templates and Classes";s:16:"sty_delete_color";s:12:"Delete Color";s:29:"sty_disable_auto_margins_info";s:99:"Disables automatic setting of left/right to 0px, if media objects or tables are left/right aligned.";s:24:"sty_disable_auto_margins";s:20:"Disable Auto Margins";s:17:"sty_edit_template";s:13:"Edit Template";s:18:"sty_even_col_class";s:12:"Even Columns";s:18:"sty_even_row_class";s:9:"Even Rows";s:11:"sty_example";s:7:"Example";s:14:"sty_flist_char";s:9:"File List";s:9:"sty_float";s:5:"Float";s:15:"sty_font_family";s:11:"Font Family";s:13:"sty_font_size";s:9:"Font Size";s:16:"sty_font_stretch";s:12:"Font Stretch";s:14:"sty_font_style";s:10:"Font Style";s:16:"sty_font_variant";s:12:"Font Variant";s:15:"sty_font_weight";s:11:"Font Weight";s:21:"sty_generate_template";s:17:"Generate Template";s:17:"sty_ha_cntr_class";s:24:"Hor. Accordion Container";s:18:"sty_ha_icntr_class";s:29:"Hor. Accordion Item Container";s:18:"sty_ha_icont_class";s:27:"Hor. Accordion Item Content";s:18:"sty_ha_ihead_class";s:26:"Hor. Accordion Item Header";s:24:"sty_haccordion_templates";s:24:"Hor. Accordion Templates";s:10:"sty_height";s:6:"Height";s:8:"sty_hide";s:4:"Hide";s:14:"sty_horizontal";s:10:"Horizontal";s:14:"sty_image_file";s:10:"Image File";s:10:"sty_images";s:6:"Images";s:21:"sty_import_stylesheet";s:12:"Import Style";s:20:"sty_individual_style";s:16:"Individual Style";s:21:"sty_individual_styles";s:17:"Individual Styles";s:22:"sty_left_right_padding";s:23:"Cell Padding Left/Right";s:8:"sty_left";s:4:"Left";s:18:"sty_letter_spacing";s:14:"Letter Spacing";s:20:"sty_lightness_border";s:16:"Lightness Border";s:22:"sty_lightness_cell1_bg";s:27:"Lightness Cell 1 Background";s:24:"sty_lightness_cell1_text";s:21:"Lightness Cell 1 Text";s:22:"sty_lightness_cell2_bg";s:27:"Lightness Cell 2 Background";s:24:"sty_lightness_cell2_text";s:21:"Lightness Cell 2 Text";s:23:"sty_lightness_header_bg";s:27:"Lightness Header Background";s:25:"sty_lightness_header_text";s:21:"Lightness Header Text";s:15:"sty_line_height";s:11:"Line Height";s:13:"sty_link_char";s:4:"Link";s:13:"sty_list_char";s:4:"List";s:20:"sty_list_style_image";s:16:"List Style Image";s:23:"sty_list_style_position";s:19:"List Style Position";s:19:"sty_list_style_type";s:15:"List Style Type";s:22:"sty_margin_and_padding";s:18:"Margin and Padding";s:10:"sty_margin";s:6:"Margin";s:14:"sty_media_char";s:5:"Media";s:14:"sty_min_height";s:14:"Minimum Height";s:18:"sty_move_lm_styles";s:32:"Change Style of Learning Modules";s:14:"sty_move_style";s:12:"Change Style";s:37:"sty_msg_characteristic_already_exists";s:59:"A style class with this title already exists in this style.";s:40:"sty_msg_characteristic_must_only_include";s:69:"The title of style classes may only include the following characters:";s:31:"sty_msg_color_must_only_include";s:57:"The color name may only include the following characters:";s:29:"sty_msg_input_must_be_numeric";s:22:"Input must be numeric.";s:8:"sty_name";s:4:"Name";s:23:"sty_nr_learning_modules";s:26:"Number of Learning Modules";s:17:"sty_odd_col_class";s:11:"Odd Columns";s:17:"sty_odd_row_class";s:8:"Odd Rows";s:6:"sty_ol";s:13:"Numbered List";s:11:"sty_opacity";s:7:"Opacity";s:13:"sty_opt_saved";s:13:"Options saved";s:12:"sty_overflow";s:8:"Overflow";s:11:"sty_padding";s:7:"Padding";s:13:"sty_page_char";s:4:"Page";s:12:"sty_position";s:8:"Position";s:15:"sty_positioning";s:11:"Positioning";s:11:"sty_preview";s:7:"Preview";s:17:"sty_question_char";s:8:"Question";s:9:"sty_right";s:5:"Right";s:18:"sty_row_foot_class";s:10:"Row Footer";s:18:"sty_row_head_class";s:10:"Row Header";s:22:"sty_save_active_styles";s:18:"Save Active Styles";s:20:"sty_save_hide_status";s:16:"Save Hide Status";s:24:"sty_save_standard_styles";s:20:"Save Standard Styles";s:12:"sty_sco_char";s:17:"SCO and Objective";s:9:"sty_scope";s:5:"Scope";s:16:"sty_section_char";s:7:"Section";s:13:"sty_set_scope";s:9:"Set Scope";s:10:"sty_source";s:6:"Source";s:11:"sty_special";s:7:"Special";s:18:"sty_standard_style";s:14:"Standard Style";s:15:"sty_style_chars";s:13:"Style Classes";s:15:"sty_style_class";s:13:"Style Classes";s:19:"sty_table_cell_char";s:10:"Table Cell";s:14:"sty_table_char";s:5:"Table";s:15:"sty_table_class";s:17:"Table Style Class";s:27:"sty_table_template_bw_zebra";s:10:"Gray Zebra";s:32:"sty_table_template_colored_zebra";s:13:"Colored Zebra";s:27:"sty_table_template_no_zebra";s:8:"No Zebra";s:19:"sty_table_templates";s:15:"Table Templates";s:9:"sty_table";s:5:"Table";s:13:"sty_tabs_char";s:21:"Accordions and Panels";s:13:"sty_tag_hover";s:6:":hover";s:14:"sty_tag_normal";s:6:"Normal";s:19:"sty_template_layout";s:15:"Template Layout";s:17:"sty_template_name";s:4:"Name";s:13:"sty_templates";s:9:"Templates";s:14:"sty_text_align";s:14:"Text Alignment";s:19:"sty_text_block_char";s:12:"Text (Block)";s:19:"sty_text_decoration";s:15:"Text Decoration";s:15:"sty_text_indent";s:16:"Text Indentation";s:20:"sty_text_inline_char";s:16:"Text (Character)";s:18:"sty_text_transform";s:14:"Text Transform";s:8:"sty_text";s:4:"Text";s:22:"sty_top_bottom_padding";s:23:"Cell Padding Top/Bottom";s:7:"sty_top";s:3:"Top";s:16:"sty_type_flist_a";s:19:"File List Item Link";s:19:"sty_type_flist_cont";s:19:"File List Container";s:19:"sty_type_flist_head";s:17:"File List Heading";s:17:"sty_type_flist_li";s:14:"File List Item";s:14:"sty_type_flist";s:9:"File List";s:16:"sty_type_ha_cntr";s:24:"Hor. Accordion Container";s:17:"sty_type_ha_icntr";s:29:"Hor. Accordion Item Container";s:17:"sty_type_ha_icont";s:27:"Hor. Accordion Item Content";s:17:"sty_type_ha_ihead";s:26:"Hor. Accordion Item Header";s:17:"sty_type_heading1";s:9:"Heading 1";s:17:"sty_type_heading2";s:9:"Heading 2";s:17:"sty_type_heading3";s:9:"Heading 3";s:13:"sty_type_link";s:4:"Link";s:18:"sty_type_list_item";s:9:"List Item";s:15:"sty_type_list_o";s:13:"Numbered List";s:15:"sty_type_list_u";s:13:"Bulleted List";s:22:"sty_type_media_caption";s:13:"Media Caption";s:19:"sty_type_media_cont";s:15:"Media Container";s:14:"sty_type_media";s:5:"Media";s:18:"sty_type_page_bnav";s:17:"Bottom Navigation";s:18:"sty_type_page_cont";s:14:"Page Container";s:16:"sty_type_page_fn";s:8:"Footnote";s:19:"sty_type_page_frame";s:10:"Page Frame";s:18:"sty_type_page_lnav";s:15:"Left Navigation";s:23:"sty_type_page_lnavimage";s:21:"Left Navigation Image";s:22:"sty_type_page_lnavlink";s:20:"Left Navigation Link";s:17:"sty_type_page_nav";s:8:"Footnote";s:18:"sty_type_page_rnav";s:16:"Right Navigation";s:23:"sty_type_page_rnavimage";s:22:"Right Navigation Image";s:22:"sty_type_page_rnavlink";s:21:"Right Navigation Link";s:19:"sty_type_page_title";s:10:"Page Title";s:18:"sty_type_page_tnav";s:14:"Top Navigation";s:13:"sty_type_page";s:4:"Page";s:16:"sty_type_qanswer";s:6:"Answer";s:15:"sty_type_qfeedr";s:15:"Feedback, Right";s:15:"sty_type_qfeedw";s:15:"Feedback, Wrong";s:15:"sty_type_qinput";s:10:"Text Input";s:16:"sty_type_qlinput";s:15:"Long Text Input";s:16:"sty_type_qsubmit";s:23:"Question Submit Buttons";s:15:"sty_type_qtitle";s:14:"Question Title";s:17:"sty_type_question";s:8:"Question";s:17:"sty_type_sco_desc";s:15:"SCO Description";s:18:"sty_type_sco_desct";s:23:"SCO Description Heading";s:17:"sty_type_sco_keyw";s:12:"SCO Keywords";s:16:"sty_type_sco_obj";s:13:"SCO Objective";s:17:"sty_type_sco_objt";s:22:"SCO Objectives Heading";s:18:"sty_type_sco_title";s:9:"SCO Title";s:12:"sty_type_sco";s:3:"SCO";s:16:"sty_type_section";s:7:"Section";s:22:"sty_type_table_caption";s:13:"Table Caption";s:19:"sty_type_table_cell";s:10:"Table Cell";s:14:"sty_type_table";s:5:"Table";s:19:"sty_type_text_block";s:10:"Text Block";s:20:"sty_type_text_inline";s:9:"Character";s:16:"sty_type_va_cntr";s:25:"Vert. Accordion Container";s:17:"sty_type_va_icntr";s:30:"Vert. Accordion Item Container";s:17:"sty_type_va_icont";s:28:"Vert. Accordion Item Content";s:17:"sty_type_va_ihead";s:27:"Vert. Accordion Item Header";s:8:"sty_type";s:4:"Type";s:6:"sty_ul";s:11:"Bullet List";s:17:"sty_va_cntr_class";s:25:"Vert. Accordion Container";s:18:"sty_va_icntr_class";s:30:"Vert. Accordion Item Container";s:18:"sty_va_icont_class";s:28:"Vert. Accordion Item Content";s:18:"sty_va_ihead_class";s:27:"Vert. Accordion Item Header";s:24:"sty_vaccordion_templates";s:25:"Vert. Accordion Templates";s:18:"sty_vertical_align";s:18:"Vertical Alignment";s:12:"sty_vertical";s:8:"Vertical";s:15:"sty_white_space";s:11:"White Space";s:16:"sty_width_height";s:14:"Width x Height";s:9:"sty_width";s:5:"Width";s:16:"sty_word_spacing";s:12:"Word Spacing";s:19:"style_current_style";s:13:"Current Style";s:18:"style_delete_style";s:12:"Delete Style";s:16:"style_edit_style";s:10:"Edit Style";s:12:"sty_glo_char";s:8:"Glossary";s:20:"sty_type_glo_overlay";s:16:"Glossary Overlay";s:20:"sty_type_glo_ovtitle";s:20:"Term/Title (Overlay)";s:38:"sty_some_styles_obligatory_delete_rest";s:138:"The following style classes are compulsory and cannot be deleted. Do you want to continue and delete the remaining selected style classes?";s:25:"sty_delete_other_selected";s:8:"Continue";s:25:"sty_all_styles_obligatory";s:57:"All selected styles are compulsory and cannot be deleted.";s:31:"sty_copied_please_select_target";s:101:"The style classes have been copied. Please open the target style and click ‘Paste Style Classes’.";s:23:"sty_paste_style_classes";s:19:"Paste Style Classes";s:33:"sty_if_style_class_already_exists";s:32:"If style class already exists...";s:13:"sty_overwrite";s:9:"Overwrite";s:17:"sty_keep_existing";s:13:"Keep Existing";s:25:"sty_paste_characteristics";s:19:"Paste Style Classes";s:24:"sty_style_classes_copied";s:31:"Style classes have been copied.";s:20:"sty_type_glo_ovclink";s:27:"Glossary Overlay Close Link";s:21:"sty_type_glo_ovuglink";s:18:"Unit Glossary Link";s:25:"sty_type_glo_ovuglistlink";s:23:"Unit Glossary List Link";s:21:"style_move_style_into";s:4:"Into";s:12:"sty_rte_char";s:9:"SCORM RTE";s:17:"sty_type_rte_menu";s:8:"RTE Menu";s:18:"sty_type_rte_mlink";s:13:"RTE Menu Link";s:17:"sty_type_rte_tree";s:16:"RTE Tree Section";s:17:"sty_type_rte_node";s:13:"RTE Tree Node";s:19:"sty_type_rte_status";s:10:"RTE Status";s:18:"sty_type_rte_tlink";s:18:"RTE Tree Node Link";s:8:"sty_from";s:4:"From";s:6:"sty_to";s:2:"To";s:21:"sty_add_content_style";s:17:"Add Content Style";s:31:"sty_remove_global_default_state";s:27:"Remove Global Default State";s:29:"sty_remove_global_fixed_state";s:25:"Remove Global Fixed State";s:23:"sty_make_global_default";s:43:"Set as Global Default Style for New Objects";s:21:"sty_make_global_fixed";s:31:"Force this Style on New Objects";s:18:"sty_type_sco_fmess";s:19:"SCORM Final Message";s:13:"sty_type_qimg";s:14:"Question Image";s:14:"sty_type_qimgd";s:18:"Image Details Link";s:15:"sty_type_qordli";s:15:"Order List Item";s:15:"sty_type_qordul";s:10:"Order List";s:16:"sty_type_qetitem";s:15:"Error Text Item";s:16:"sty_type_qetcorr";s:20:"Error Text Corrected";s:12:"sty_type_iim";s:31:"Interactive Image Content Popup";s:15:"sty_type_marker";s:24:"Interactive Image Marker";s:22:"sty_import_page_layout";s:18:"Import Page Layout";s:14:"sty_type_qover";s:17:"Question Overview";s:30:"style_page_layout_module_scorm";s:5:"Scorm";s:34:"style_page_layout_module_portfolio";s:9:"Portfolio";s:17:"sty_type_rte_drag";s:8:"Drag Bar";s:19:"sty_type_rte_tclink";s:17:"Tree Control Link";s:17:"sty_type_rte_texp";s:9:"Tree Icon";s:16:"sty_type_rte_tli";s:14:"Tree List Item";s:16:"sty_type_rte_tul";s:9:"Tree List";s:20:"sty_move_user_styles";s:21:"Change Style of Users";s:13:"sty_substyles";s:9:"Substyles";s:21:"sty_assign_categories";s:17:"Assign Categories";s:12:"sty_substyle";s:8:"Substyle";s:19:"sty_cat_assignments";s:26:"Style/Category Assignments";s:18:"sty_add_assignment";s:14:"Add Assignment";s:10:"sty_switch";s:6:"Switch";s:11:"sty_default";s:7:"Default";s:17:"sty_media_queries";s:13:"Media Queries";s:19:"sty_add_media_query";s:15:"Add Media Query";s:20:"sty_edit_media_query";s:16:"Edit Media Query";s:20:"sty_media_query_info";s:100:"A separate CSS block is added for each media query after the default (no special media query) block.";s:9:"sty_order";s:5:"Order";s:9:"sty_query";s:5:"Query";s:14:"sty_save_order";s:10:"Save Order";s:21:"sty_sure_del_mqueries";s:72:"Do you really want to delete this media query and all related CSS rules?";s:10:"sty_custom";s:6:"Custom";s:14:"sty_custom_par";s:17:"Custom Parameters";s:19:"sty_custom_par_info";s:62:"Add custom CSS parameters using format ‘parameter: value’.";s:13:"sty_transform";s:9:"Transform";s:20:"sty_transform_origin";s:16:"Transform-Origin";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'survey'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:792:{s:12:"add_category";s:10:"Add Answer";s:11:"add_heading";s:11:"Add Heading";s:31:"add_limits_for_standard_numbers";s:89:"Please enter a lower and upper limit for the standard numbers you want to add as answers.";s:12:"add_material";s:12:"Add Material";s:23:"add_phrase_introduction";s:23:"Please select a Phrase:";s:10:"add_phrase";s:10:"Add Phrase";s:20:"add_standard_numbers";s:20:"Add Standard Numbers";s:20:"adm_no_special_users";s:79:"There are no special users defined who are able to run a survey more than once.";s:18:"adm_no_users_found";s:49:"No users were found that match the search string.";s:22:"adm_remove_select_user";s:44:"Please select at least one user for removal!";s:17:"adm_removed_users";s:13:"Users removed";s:22:"adm_search_select_user";s:32:"Please select at least one user!";s:27:"adm_search_string_too_small";s:57:"Please enter at least two characters in the search field!";s:17:"adm_special_users";s:57:"Special users who are able to run a survey more than once";s:24:"already_completed_survey";s:81:"You have already finished the survey! You are not able to enter the survey again.";s:13:"anonymization";s:13:"Anonymization";s:32:"anonymize_anonymous_introduction";s:185:"To grant you access to the survey, you must use a 5-character survey code which you can receive from the creator/maintainer of this survey.<br />Please enter it in the text field above.";s:25:"anonymize_registered_user";s:24:"Anonymized Survey Access";s:29:"anonymize_resume_introduction";s:124:"Please enter your survey access code to resume the survey. It was sent to your ILIAS mail inbox when you started the survey.";s:34:"anonymous_with_personalized_survey";s:59:"You must be a registered user to run a personalized survey!";s:6:"answer";s:6:"Answer";s:5:"apply";s:5:"Apply";s:15:"arithmetic_mean";s:15:"Arithmetic Mean";s:25:"ask_insert_questionblocks";s:78:"Are you sure you want to insert the following question block(s) to the survey?";s:20:"ask_insert_questions";s:72:"Are you sure you want to insert the following question(s) to the survey?";s:4:"back";s:4:"Back";s:6:"before";s:6:"before";s:20:"browse_for_questions";s:13:"Add from Pool";s:13:"cancel_survey";s:18:"Suspend the Survey";s:26:"cannot_create_survey_codes";s:72:"You do not possess sufficient permissions to create survey access codes!";s:18:"cannot_edit_survey";s:61:"You do not possess sufficient permissions to edit the survey!";s:26:"cannot_export_questionpool";s:77:"You do not possess sufficient permissions to export the survey question pool!";s:20:"cannot_export_survey";s:63:"You do not possess sufficient permissions to export the survey!";s:22:"cannot_maintain_survey";s:65:"You do not possess sufficient permissions to maintain the survey!";s:21:"cannot_manage_phrases";s:64:"You do not possess sufficient permissions to manage the phrases!";s:25:"cannot_participate_survey";s:71:"You do not possess sufficient permissions to participate in the survey!";s:24:"cannot_read_questionpool";s:73:"You do not possess sufficient permissions to read the question pool data!";s:18:"cannot_read_survey";s:66:"You do not possess sufficient permissions to read the survey data!";s:22:"cannot_save_metaobject";s:64:"You do not possess sufficient permissions to save the meta data!";s:36:"cannot_switch_to_online_no_questions";s:96:"The status cannot be changed to &quot;online&quot; because there are no questions in the survey!";s:10:"categories";s:7:"Answers";s:23:"category_delete_confirm";s:54:"Are you sure you want to delete the following answers?";s:27:"category_delete_select_none";s:46:"Please check at least one answer to delete it!";s:20:"category_nr_selected";s:41:"Number of users that selected this answer";s:8:"category";s:6:"Answer";s:5:"chart";s:5:"Chart";s:29:"check_category_to_save_phrase";s:50:"You must have a least one answer to save a phrase!";s:13:"codes_created";s:15:"Code(s) created";s:13:"codes_deleted";s:15:"Code(s) deleted";s:5:"codes";s:12:"Access Codes";s:8:"combobox";s:8:"Combobox";s:13:"concatenation";s:13:"Concatenation";s:28:"confirm_delete_all_user_data";s:60:"Are you sure you want to delete all user data of the survey?";s:31:"confirm_delete_single_user_data";s:70:"Are you sure you want to delete the survey data of the selected users?";s:22:"confirm_remove_heading";s:44:"Are you sure you want to remove the heading?";s:22:"confirm_sync_questions";s:145:"The question you changed is a copy which has been created for use with the active survey. Do you want to change the original of the question too?";s:14:"constraint_add";s:16:"Add Routing Rule";s:38:"constraints_first_question_description";s:84:"The first entity could not have any routing because there are no previous questions.";s:24:"constraints_introduction";s:442:"You can add a routing rule to a single question or a question block with multiple questions. Depending on the specific answer given to an earlier question participants get presented with a defined next question. Thus questions irrelevant to a participant will not be asked and the survey gets shorter or more specific depending on the answers provided earlier. No routing rules can be set for the first question or question block in a survey.";s:28:"constraints_list_of_entities";s:33:"Available hooks for routing rules";s:33:"constraints_no_nonessay_available";s:153:"There are no previous questions available to define routing rules. The following types are supported: Metric, Single Choice and Multiple Choice question.";s:51:"constraints_no_questions_or_questionblocks_selected";s:54:"Please select at least one question or question block!";s:11:"constraints";s:7:"Routing";s:8:"contains";s:8:"Contains";s:8:"continue";s:11:"Continue >>";s:11:"create_date";s:7:"Created";s:10:"create_new";s:10:"Create New";s:39:"create_questionpool_before_add_question";s:67:"You must create at least one question pool to store your questions!";s:8:"dc_agree";s:5:"agree";s:9:"dc_always";s:6:"always";s:18:"dc_definitelyfalse";s:16:"definitely false";s:17:"dc_definitelytrue";s:15:"definitely true";s:10:"dc_desired";s:7:"desired";s:11:"dc_disagree";s:8:"disagree";s:7:"dc_fair";s:4:"fair";s:8:"dc_false";s:5:"false";s:7:"dc_good";s:4:"good";s:12:"dc_manytimes";s:10:"many times";s:15:"dc_morenegative";s:13:"more negative";s:15:"dc_morepositive";s:13:"more positive";s:16:"dc_mostcertainly";s:14:"most certainly";s:19:"dc_mostcertainlynot";s:18:"most certainly not";s:7:"dc_must";s:4:"must";s:10:"dc_mustnot";s:8:"must not";s:10:"dc_neutral";s:7:"neutral";s:8:"dc_never";s:5:"never";s:5:"dc_no";s:2:"no";s:16:"dc_notacceptable";s:14:"not acceptable";s:7:"dc_poor";s:4:"poor";s:9:"dc_rarely";s:6:"rarely";s:9:"dc_should";s:6:"should";s:12:"dc_shouldnot";s:10:"should not";s:12:"dc_sometimes";s:9:"sometimes";s:16:"dc_stronglyagree";s:14:"strongly agree";s:18:"dc_stronglydesired";s:16:"strongly desired";s:19:"dc_stronglydisagree";s:17:"strongly disagree";s:20:"dc_stronglyundesired";s:18:"strongly undesired";s:7:"dc_true";s:4:"true";s:12:"dc_undecided";s:9:"undecided";s:12:"dc_undesired";s:9:"undesired";s:10:"dc_varying";s:7:"varying";s:11:"dc_verygood";s:9:"very good";s:6:"dc_yes";s:3:"yes";s:20:"define_questionblock";s:21:"Define Question Block";s:16:"delete_user_data";s:44:"Delete the Survey Data of the Selected Users";s:20:"description_maxchars";s:86:"If nothing entered the maximum number of characters for this text answer is unlimited.";s:9:"disinvite";s:26:"Take from Personal Desktop";s:21:"display_all_available";s:21:"Display all available";s:35:"dp_standard_attitude_agree_disagree";s:34:"Standard Attitude (agree-disagree)";s:45:"dp_standard_attitude_agree_undecided_disagree";s:44:"Standard Attitude (agree-undecided-disagree)";s:27:"dp_standard_attitude_agree5";s:77:"Standard Attitude (strongly agree-agree-undecided-disagree-strongly disagree)";s:46:"dp_standard_attitude_desired_neutral_undesired";s:45:"Standard Attitude (desired-neutral-undesired)";s:38:"dp_standard_attitude_desired_undesired";s:37:"Standard Attitude (desired-undesired)";s:29:"dp_standard_attitude_desired5";s:81:"Standard Attitude (strongly desired-desired-neutral-undesired-strongly undesired)";s:44:"dp_standard_attitude_good_fair_notacceptable";s:44:"Standard Attitude (good-fair-not acceptable)";s:39:"dp_standard_attitude_good_notacceptable";s:39:"Standard Attitude (good-not acceptable)";s:26:"dp_standard_attitude_good5";s:59:"Standard Attitude (very good-good-fair-poor-not acceptable)";s:26:"dp_standard_attitude_must5";s:61:"Standard Attitude (must-should-undecided-should not-must not)";s:36:"dp_standard_attitude_shold_shouldnot";s:37:"Standard Attitude (should-should not)";s:47:"dp_standard_attitude_should_undecided_shouldnot";s:47:"Standard Attitude (should-undecided-should not)";s:32:"dp_standard_behaviour_certainly5";s:91:"Standard Behavior (most certainly-more positive-undecided-more negative-most certainly not)";s:28:"dp_standard_behaviour_yes_no";s:26:"Standard Behavior (yes-no)";s:38:"dp_standard_behaviour_yes_undecided_no";s:36:"Standard Behavior (yes-undecided-no)";s:32:"dp_standard_beliefs_always_never";s:31:"Standard Beliefs (always-never)";s:42:"dp_standard_beliefs_always_sometimes_never";s:41:"Standard Beliefs (always-sometimes-never)";s:27:"dp_standard_beliefs_always5";s:57:"Standard Beliefs (always-many times-varying-rarely-never)";s:30:"dp_standard_beliefs_true_false";s:29:"Standard Beliefs (true-false)";s:40:"dp_standard_beliefs_true_undecided_false";s:39:"Standard Beliefs (true-undecided-false)";s:25:"dp_standard_beliefs_true5";s:72:"Standard Beliefs (definitely true-true-undecided-false-definitely false)";s:19:"dp_standard_numbers";s:16:"Standard Numbers";s:13:"duplicate_svy";s:16:"Duplicate Survey";s:9:"duplicate";s:9:"Duplicate";s:17:"edit_ask_continue";s:47:"Do you want to continue and edit this question?";s:29:"edit_constraints_introduction";s:87:"You have selected the following question(s)/question block(s) to edit the routing rules";s:12:"edit_heading";s:12:"Edit Heading";s:16:"end_date_reached";s:53:"You cannot start the survey. The end date is reached!";s:8:"end_date";s:8:"End Date";s:18:"enter_anonymous_id";s:18:"Survey Access Code";s:18:"enter_phrase_title";s:27:"Please enter a Phrase Title";s:25:"enter_questionblock_title";s:36:"Please enter a Question Block Title!";s:27:"enter_valid_number_of_codes";s:60:"Please enter a valid number to generate survey access codes!";s:11:"enter_value";s:13:"Enter a Value";s:16:"err_no_pool_name";s:47:"Please enter the name of a survey question pool";s:17:"error_add_heading";s:36:"Please enter a text for the heading!";s:24:"error_importing_question";s:77:"There was an error importing the question(s) from the file you have selected!";s:33:"error_retrieving_anonymous_survey";s:121:"The system could not find your survey data for survey code &quot;%s&quot;. Please check the survey code you have entered!";s:16:"eval_legend_link";s:72:"Please refer to the legend for the meaning of the column header symbols.";s:21:"evaluation_access_all";s:43:"All Registered Users can Access the Results";s:22:"evaluation_access_info";s:37:"You have access to the survey results";s:21:"evaluation_access_off";s:34:"Participants Cannot Access Results";s:30:"evaluation_access_participants";s:46:"All Survey Participants can Access the Results";s:17:"evaluation_access";s:31:"Participants\' Access to Results";s:10:"evaluation";s:10:"Statistics";s:20:"existing_constraints";s:22:"Existing Routing Rules";s:4:"exit";s:4:"Exit";s:12:"exp_type_csv";s:27:"Comma Separated Value (CSV)";s:14:"exp_type_excel";s:15:"Microsoft Excel";s:23:"export_all_survey_codes";s:23:"Export all Access Codes";s:14:"export_data_as";s:14:"Export Data As";s:28:"fill_out_all_category_fields";s:59:"Please fill out all answer fields before you add a new one!";s:41:"fill_out_all_required_fields_add_category";s:59:"Please fill out all required fields before you add answers!";s:44:"fill_out_all_required_fields_delete_category";s:62:"Please fill out all required fields before you delete answers!";s:42:"fill_out_all_required_fields_move_category";s:60:"Please fill out all required fields before you move answers!";s:40:"fill_out_all_required_fields_save_phrase";s:61:"Please fill out all required fields before you save a phrase!";s:25:"filter_all_question_types";s:18:"All Question Types";s:24:"filter_all_questionpools";s:18:"All Question Pools";s:26:"filter_show_question_types";s:19:"Show Question Types";s:25:"filter_show_questionpools";s:19:"Show Question Pools";s:6:"filter";s:6:"Filter";s:29:"form_data_modified_press_save";s:75:"The form data has been modified. Press the save button to keep the changes.";s:15:"found_questions";s:15:"Found Questions";s:11:"found_users";s:11:"Found Users";s:14:"geometric_mean";s:14:"Geometric Mean";s:13:"given_answers";s:13:"Given Answers";s:13:"glossary_term";s:13:"Glossary Term";s:13:"harmonic_mean";s:13:"Harmonic Mean";s:7:"heading";s:7:"Heading";s:10:"horizontal";s:10:"Horizontal";s:25:"import_error_closing_file";s:30:"Error closing the import file!";s:25:"import_error_opening_file";s:30:"Error opening the import file!";s:36:"import_error_survey_no_proper_values";s:51:"The survey properties do not contain proper values!";s:33:"import_error_survey_no_properties";s:53:"No survey properties found. Cannot import the survey!";s:23:"import_no_file_selected";s:17:"No file selected!";s:15:"import_question";s:18:"Import Question(s)";s:22:"import_wrong_file_type";s:16:"Wrong file type!";s:30:"info_anonymize_registered_user";s:17:"Anonymized Survey";s:24:"info_anonymize_with_code";s:41:"Anonymized Survey with Survey Code Access";s:27:"info_anonymize_without_code";s:45:"Anonymized Survey without Access Restrictions";s:12:"insert_after";s:12:"Insert After";s:13:"insert_before";s:13:"Insert Before";s:23:"insert_missing_question";s:65:"Please select at least one question to insert it into the survey!";s:28:"insert_missing_questionblock";s:71:"Please select at least one question block to insert it into the survey!";s:13:"internal_link";s:13:"Internal Link";s:27:"introduction_manage_phrases";s:90:"Manage your own phrases which are available for all the ordinal questions you edit/create.";s:12:"introduction";s:20:"Introductory Message";s:20:"invitation_mode_desc";s:73:"A link reference to the survey is created on the users\' personal desktop.";s:15:"invitation_mode";s:45:"Put Link to Survey on the Personal Desktop of";s:14:"invitation_off";s:25:"Do not put on any Desktop";s:10:"invitation";s:28:"Put Link On Personal Desktop";s:14:"invited_groups";s:14:"Invited Groups";s:13:"invited_users";s:14:"Selected Users";s:19:"label_resume_survey";s:30:"Enter your 5 digit survey code";s:16:"language_changed";s:16:"Language changed";s:11:"last_update";s:11:"Last Update";s:6:"layout";s:6:"Layout";s:6:"legend";s:6:"Legend";s:11:"lower_limit";s:11:"Lower Limit";s:11:"maintenance";s:12:"Participants";s:14:"manage_phrases";s:10:"My Phrases";s:27:"material_added_successfully";s:37:"You successfully set a material link!";s:13:"material_file";s:13:"Material File";s:8:"material";s:8:"Material";s:17:"materials_deleted";s:19:"Material(s) deleted";s:9:"materials";s:9:"Materials";s:17:"matrix_appearance";s:10:"Appearance";s:37:"matrix_bipolar_adjectives_description";s:104:"You may use a pair of bipolar adjectives to scale the column responses to words, short phrases, or texts";s:25:"matrix_bipolar_adjectives";s:18:"Bipolar Adjectives";s:32:"matrix_column_delete_select_none";s:46:"Please check at least one column to delete it!";s:36:"matrix_column_separators_description";s:121:"Select the check box if you want to have separators (thin lines) between the columns in the output of the Matrix Question";s:24:"matrix_column_separators";s:17:"Column Separators";s:22:"matrix_column_settings";s:22:"Matrix Column Settings";s:19:"matrix_columns_rows";s:17:"Column/Row Editor";s:14:"matrix_columns";s:14:"Matrix Columns";s:23:"matrix_error_no_columns";s:40:"Please fill in at least one column text!";s:20:"matrix_error_no_rows";s:37:"Please fill in at least one row text!";s:16:"matrix_left_pole";s:9:"Left Pole";s:21:"matrix_neutral_answer";s:72:"Text for a Neutral Column (‘Not Specified’, ‘I don\'t know’ etc.)";s:43:"matrix_neutral_column_separator_description";s:151:"Select the check box if you want to have a separator (thick line) between the neutral column and the other columns in the output of the Matrix Question";s:31:"matrix_neutral_column_separator";s:24:"Neutral Column Separator";s:36:"matrix_question_checkbox_not_checked";s:49:"Please check at least one check box in every row!";s:40:"matrix_question_radio_button_not_checked";s:45:"Please select an option button for every row!";s:17:"matrix_right_pole";s:10:"Right Pole";s:29:"matrix_row_delete_select_none";s:43:"Please check at least one row to delete it!";s:33:"matrix_row_separators_description";s:118:"Select the check box if you want to have separators (thin lines) between the rows in the output of the Matrix Question";s:21:"matrix_row_separators";s:14:"Row Separators";s:11:"matrix_rows";s:11:"Matrix Rows";s:23:"matrix_standard_answers";s:11:"Column Text";s:19:"matrix_subtype_date";s:4:"Date";s:26:"matrix_subtype_description";s:85:"Please select one of the above subtypes to define the behaviour of the answer fields.";s:21:"matrix_subtype_double";s:14:"Floating Point";s:22:"matrix_subtype_integer";s:7:"Integer";s:17:"matrix_subtype_mr";s:31:"Check Boxes (Multiple Response)";s:17:"matrix_subtype_sr";s:32:"Option Buttons (Single Response)";s:19:"matrix_subtype_text";s:4:"Text";s:19:"matrix_subtype_time";s:4:"Time";s:8:"maxchars";s:28:"Maximum Number of Characters";s:7:"maximum";s:13:"Maximum Value";s:14:"median_between";s:7:"between";s:6:"median";s:6:"Median";s:8:"menuback";s:4:"Back";s:16:"menubacktosurvey";s:18:"Back to the Survey";s:22:"message_mail_survey_id";s:239:"You have started the anonymized survey &quot;%s&quot;. To resume this survey you need the following 5 digit survey code:<br><br><strong>%s</strong><br><br>Resuming a survey is only possible, if you interrupt the survey before finishing it.";s:30:"metric_question_floating_point";s:110:"The value you entered is a floating point value. Floating point values are not allowed for this question type!";s:27:"metric_question_not_a_value";s:45:"The value you entered is not a numeric value!";s:29:"metric_question_out_of_bounds";s:67:"The value you entered is not between the minimum and maximum value!";s:35:"metric_subtype_description_interval";s:287:"Equivalent intervals between measurements allow a meaningful comparison between arbitrary pairs of measurements. The zero point on the scale is arbitrary, so negative values can be used. Examples of interval values are the year date in many calendars or the temperature in Celsius scale.";s:40:"metric_subtype_description_ratioabsolute";s:157:"The ratio absolute measurement uses natural numbers additional to the non-arbitrary zero point for example the number of children in a family or probability.";s:43:"metric_subtype_description_rationonabsolute";s:267:"In addition to the interval measurement there are also meaningful ratios between arbitrary pairs of numbers. The zero value on a ratio scale is non-arbitrary. Most physical quantities, such as length in centimeters or duration in seconds are measured on ratio scales.";s:7:"minimum";s:13:"Minimum Value";s:28:"missing_upper_or_lower_limit";s:40:"Please enter a lower and an upper limit!";s:21:"mode_nr_of_selections";s:16:"Nr of Selections";s:9:"mode_text";s:26:"Most Selected Value (Text)";s:4:"mode";s:19:"Most Selected Value";s:24:"msg_deleted_export_files";s:22:"Export file(s) deleted";s:36:"msg_enter_value_for_valid_constraint";s:52:"Please enter a value to create a valid routing rule!";s:20:"msg_users_disinvited";s:18:"User(s) disinvited";s:33:"multiple_choice_multiple_response";s:35:"Multiple Choice (Multiple Response)";s:31:"multiple_choice_single_response";s:33:"Multiple Choice (Single Response)";s:35:"multiple_choice_subtype_description";s:196:"Choose Multiple Choice (Single Response) if you want the participants to select only one answer and Multiple Choice (Multiple Response) if you want the participants to select one ore more answers.";s:16:"new_survey_codes";s:25:"new survey access code(s)";s:18:"next_question_rows";s:26:"Questions %d - %d of %d >>";s:24:"no_available_constraints";s:35:"There are no routing rules defined!";s:33:"no_category_selected_for_deleting";s:63:"Please select a least one answer if you want to delete answers!";s:29:"no_category_selected_for_move";s:44:"Please check at least one answer to move it!";s:22:"no_constraints_checked";s:79:"Please select a least one question or question block to edit the routing rules!";s:29:"no_question_selected_for_move";s:46:"Please check at least one question to move it!";s:32:"no_question_selected_for_removal";s:66:"Please check at least one question or question block to remove it!";s:27:"no_questionblocks_available";s:38:"There are no question blocks available";s:22:"no_questions_available";s:33:"There are no questions available!";s:17:"no_search_results";s:28:"There are no search results!";s:27:"no_target_selected_for_move";s:34:"You must select a target position!";s:15:"no_user_invited";s:96:"All invited users did not possess sufficient permissions to run the survey. No user was invited.";s:25:"no_user_or_group_selected";s:72:"Please check an option what are you searching for (users and/or groups)!";s:23:"no_user_phrases_defined";s:44:"There are no user defined phrases available!";s:28:"nominal_question_not_checked";s:40:"Please check one of the offered answers!";s:9:"non_ratio";s:8:"Interval";s:8:"not_used";s:12:"not used yet";s:10:"obligatory";s:10:"Compulsory";s:3:"off";s:3:"Off";s:7:"offline";s:7:"offline";s:13:"on_additional";s:18:"On, and additional";s:2:"on";s:2:"On";s:2:"or";s:2:"or";s:11:"orientation";s:11:"Orientation";s:5:"outro";s:18:"Concluding Remarks";s:28:"percentage_of_entered_values";s:43:"Percentage of users that entered this value";s:29:"percentage_of_offered_answers";s:29:"Percentage of offered answers";s:24:"percentage_of_selections";s:45:"Percentage of users that selected this answer";s:12:"phrase_added";s:12:"Phrase added";s:12:"phrase_saved";s:34:"The phrase was saved successfully!";s:13:"please_select";s:19:"-- please select --";s:16:"predefined_users";s:33:"Put on desktops of selected users";s:7:"preview";s:7:"Preview";s:22:"previous_question_rows";s:26:"<< Questions %d - %d of %d";s:26:"qpl_confirm_delete_phrases";s:56:"Are you sure you want to delete the following phrase(s)?";s:28:"qpl_confirm_delete_questions";s:58:"Are you sure you want to delete the following question(s)?";s:20:"qpl_copy_select_none";s:46:"Please check at least one question to copy it!";s:39:"qpl_define_questionblock_select_missing";s:75:"Please select a least two questions if you want to define a question block!";s:29:"qpl_delete_phrase_select_none";s:45:"Please check at least one phrase to delete it";s:21:"qpl_delete_rbac_error";s:45:"You have no rights to delete the question(s)!";s:22:"qpl_delete_select_none";s:48:"Please check at least one question to delete it!";s:22:"qpl_export_select_none";s:47:"Please check at least one question to export it";s:31:"qpl_past_questions_confirmation";s:78:"Are you sure you want to paste the following question(s) in the question pool?";s:19:"qpl_phrases_deleted";s:18:"Phrase(s) deleted.";s:21:"qpl_questions_deleted";s:20:"Question(s) deleted.";s:20:"qpl_questions_pasted";s:19:"Question(s) pasted.";s:20:"qpl_savephrase_empty";s:28:"Please enter a phrase title!";s:21:"qpl_savephrase_exists";s:67:"The phrase title already exists! Please enter another phrase title.";s:22:"qpl_unfold_select_none";s:80:"Please select at least one question block if you want to unfold question blocks!";s:31:"question_contains_no_categories";s:46:"There are no answers defined for this question";s:24:"question_has_constraints";s:13:"Routing Rules";s:13:"question_icon";s:13:"Question Icon";s:23:"question_mr_not_checked";s:49:"Please check at least one of the offered answers!";s:20:"question_not_checked";s:40:"Please check one of the offered answers!";s:19:"question_obligatory";s:27:"The question is compulsory!";s:25:"question_saved_for_upload";s:224:"The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!";s:13:"question_type";s:13:"Question Type";s:29:"questionblock_has_constraints";s:13:"Routing Rules";s:18:"questionblock_icon";s:18:"Questionblock Icon";s:22:"questionblock_inserted";s:23:"Question Block inserted";s:13:"questionblock";s:14:"Question Block";s:23:"questionblocks_inserted";s:24:"Question Blocks inserted";s:14:"questionblocks";s:15:"Question Blocks";s:18:"questions_inserted";s:21:"Question(s) inserted!";s:17:"questions_removed";s:45:"Question(s) and/or question block(s) removed!";s:9:"questions";s:9:"Questions";s:12:"questiontype";s:13:"Question Type";s:14:"ratio_absolute";s:14:"Ratio-Absolute";s:18:"ratio_non_absolute";s:18:"Ratio-Non-Absolute";s:19:"ratio_scale_ge_zero";s:65:"The minimum value for a ratio scale must be greater or equal zero";s:15:"remove_question";s:6:"Remove";s:16:"remove_questions";s:99:"Are you sure you want to remove the following question(s) and/or question block(s) from the survey?";s:12:"reset_filter";s:12:"Reset Filter";s:7:"results";s:7:"Results";s:13:"resume_survey";s:17:"Resume the Survey";s:8:"row_text";s:8:"Row Text";s:19:"save_back_to_survey";s:30:"Save and go back to the survey";s:21:"save_obligatory_state";s:32:"Save Compulsory States and Order";s:34:"save_phrase_categories_not_checked";s:66:"Please check at least two answers to save answers in a new phrase!";s:24:"save_phrase_introduction";s:175:"If you want to save the answers below as default phrase, please enter a phrase title. You can access a default phrase whenever you want to add a phrase to an ordinal question.";s:11:"save_phrase";s:14:"Save as Phrase";s:5:"scale";s:5:"Scale";s:16:"search_field_all";s:20:"Search in all fields";s:10:"search_for";s:10:"Search for";s:13:"search_groups";s:12:"Found Groups";s:17:"search_invitation";s:36:"Search for users or groups to invite";s:16:"search_questions";s:16:"Search Questions";s:12:"search_roles";s:11:"Found Roles";s:11:"search_term";s:11:"Search Term";s:15:"search_type_all";s:28:"Search in all Question Types";s:12:"search_users";s:12:"Search Users";s:13:"select_option";s:31:"--- Please select an option ---";s:20:"select_phrase_to_add";s:49:"Please select a phrase to add it to the question!";s:21:"select_prior_question";s:23:"Select a prior question";s:25:"select_questionpool_short";s:20:"Question Pool Survey";s:19:"select_questionpool";s:59:"Please select a question pool to store the created question";s:15:"select_relation";s:17:"Select a Relation";s:17:"select_svy_option";s:30:"--- Please select a survey ---";s:40:"select_target_position_for_move_question";s:92:"Please select a target position to move the question(s) and press one of the insert buttons!";s:31:"select_target_position_for_move";s:88:"Please select a target position to move the answers and press one of the insert buttons!";s:12:"select_value";s:13:"Enter a Value";s:9:"selection";s:9:"Selection";s:10:"set_filter";s:10:"Set Filter";s:29:"show_questiontext_description";s:211:"If this checkbox is selected, for every question in the question block the question text will be shown. If this checkbox is not selected, the question text of every question in the question block will be hidden.";s:17:"show_questiontext";s:25:"Display the Question Text";s:7:"skipped";s:7:"skipped";s:12:"specialusers";s:13:"Special Users";s:25:"spl_copy_insert_clipboard";s:52:"The selected question(s) are copied to the clipboard";s:20:"spl_copy_select_none";s:62:"Please check at least one question to copy it to the clipboard";s:22:"spl_general_properties";s:18:"General Properties";s:25:"spl_move_insert_clipboard";s:46:"The selected question(s) are marked for moving";s:18:"spl_move_same_pool";s:70:"It has no effect to move questions from inside the same question pool.";s:20:"spl_move_select_none";s:58:"Please check at least one question to select it for moving";s:31:"spl_online_property_description";s:65:"If the question pool is not online, it cannot be used in surveys.";s:19:"spl_online_property";s:6:"Online";s:20:"spl_paste_no_objects";s:91:"There are no questions in the clipboard. Please copy or move a question into the clipboard.";s:17:"spl_paste_success";s:55:"The question(s) have been pasted into the question pool";s:26:"spl_select_file_for_import";s:34:"You must select a file for import!";s:22:"start_date_not_reached";s:60:"You cannot start the survey until the start date is reached!";s:10:"start_date";s:10:"Start Date";s:12:"start_survey";s:12:"Start Survey";s:22:"subject_mail_survey_id";s:25:"Your survey code for "%s"";s:7:"subtype";s:7:"Subtype";s:24:"survey_code_message_sent";s:75:"A survey code which allows you to resume the survey was sent to your INBOX!";s:20:"survey_code_no_codes";s:49:"You have not created any survey access codes yet.";s:20:"survey_code_url_name";s:55:"URL <small>(use right mouse button to copy URL)</small>";s:15:"survey_code_url";s:21:"URL for Direct Access";s:16:"survey_code_used";s:11:"Code was ..";s:11:"survey_code";s:18:"Survey Access Code";s:17:"survey_codes_lang";s:27:"Preselected Survey Language";s:29:"survey_codes_no_anonymization";s:82:"You must create an anonymized survey with access codes to create new access codes!";s:39:"survey_error_insert_incomplete_question";s:82:"You tried to add an incomplete question to the survey! The question was not added.";s:13:"survey_finish";s:13:"Finish Survey";s:15:"survey_finished";s:63:"You have finished the survey. Thank you for your participation!";s:27:"survey_has_datasets_warning";s:137:"The survey already contains data sets. You cannot edit the survey questions until you remove these data sets in the participants section.";s:17:"survey_is_offline";s:61:"You cannot start the survey! The survey is currently offline.";s:11:"survey_next";s:7:"Next >>";s:22:"survey_offline_message";s:42:"Can\'t invite users. The survey is offline!";s:21:"survey_online_warning";s:59:"The survey is online. You cannot edit the survey questions!";s:15:"survey_previous";s:11:"<< Previous";s:22:"survey_question_editor";s:9:"List View";s:26:"survey_question_obligatory";s:58:"This question is compulsory. You must answer the question!";s:24:"survey_question_optional";s:10:"(Optional)";s:16:"survey_questions";s:9:"Questions";s:33:"survey_selected_user_data_deleted";s:64:"The survey data of the selected user(s) was deleted successfully";s:18:"survey_skip_finish";s:22:"Skip and Finish Survey";s:16:"survey_skip_next";s:7:"Skip >>";s:20:"survey_skip_previous";s:7:"<< Skip";s:17:"survey_skip_start";s:25:"Skip and Go To Start Page";s:12:"survey_start";s:16:"Go To Start Page";s:27:"survey_text_textheight_desc";s:55:"Enter the height in characters for the text input field";s:26:"survey_text_textwidth_desc";s:54:"Enter the width in characters for the text input field";s:23:"survey_use_start_button";s:49:"You must enter the survey using the start button!";s:20:"SurveyMatrixQuestion";s:15:"Matrix Question";s:20:"SurveyMetricQuestion";s:15:"Metric Question";s:28:"SurveyMultipleChoiceQuestion";s:44:"Multiple Choice Question (Multiple Response)";s:26:"SurveySingleChoiceQuestion";s:42:"Multiple Choice Question (Single Response)";s:18:"SurveyTextQuestion";s:5:"Essay";s:25:"svy_all_user_data_deleted";s:46:"All user data of this survey has been deleted!";s:40:"svy_check_evaluation_access_introduction";s:136:"Since this survey evaluation is only accessible by survey participants you need to enter your survey access code to open the evaluation.";s:42:"svy_check_evaluation_authentication_needed";s:21:"Authentication needed";s:30:"svy_check_evaluation_wrong_key";s:127:"You entered a wrong survey access code or you have not participated the survey. Your access to the survey evaluation is denied.";s:22:"svy_create_export_file";s:18:"Create Export File";s:24:"svy_delete_all_user_data";s:20:"Delete all User Data";s:18:"svy_eval_cumulated";s:8:"Overview";s:15:"svy_eval_detail";s:7:"Details";s:13:"svy_eval_user";s:15:"Per Participant";s:16:"svy_export_files";s:12:"Export Files";s:8:"svy_file";s:4:"File";s:22:"svy_general_properties";s:18:"General Properties";s:38:"svy_maintenance_information_no_results";s:110:"There are no existing user data sets for the survey. You need at least one user data set to maintain the data.";s:18:"svy_missing_author";s:92:"You have not entered the author\'s name in the survey properties! Please add an authors name.";s:21:"svy_missing_questions";s:92:"You do not have any questions in the survey! Please add at least one question to the survey.";s:17:"svy_missing_title";s:89:"You have not entered a survey title! Please go to the metadata section and enter a title.";s:14:"svy_page_error";s:114:"There was an error answering a survey question. Please refer to the question to get more information on the error!";s:15:"svy_page_errors";s:118:"There were errors answering the survey questions. Please refer to the questions to get more information on the errors!";s:26:"svy_select_file_for_import";s:34:"You must select a file for import!";s:24:"svy_select_questionpools";s:61:"Please select a question pool to store the imported questions";s:18:"svy_select_surveys";s:38:"Please select a survey for duplication";s:30:"svy_selected_user_data_deleted";s:64:"The survey data of the selected user(s) was deleted successfully";s:23:"svy_show_questiontitles";s:19:"Show Question Title";s:8:"svy_size";s:4:"Size";s:26:"svy_statistical_evaluation";s:22:"Statistical Evaluation";s:27:"svy_status_missing_elements";s:35:"The following elements are missing:";s:18:"svy_status_missing";s:51:"There are required elements missing in this survey!";s:13:"svy_status_ok";s:62:"The status of the survey is OK. There are no missing elements.";s:26:"text_maximum_chars_allowed";s:91:"Please do not enter more than a maximum of %s characters. Any characters above will be cut.";s:28:"text_question_not_filled_out";s:33:"Please fill out the answer field!";s:18:"text_resume_survey";s:355:"You are trying to resume an anonymized survey. To continue the survey with your previously entered values please enter the 5 digit survey code which you received after starting the survey (it was sent with a message to your ILIAS mail folder). Instead of typing your survey code you also can copy it from your inbox and paste it into the text field below.";s:19:"title_resume_survey";s:37:"Resume the Survey - Enter Survey Code";s:6:"unfold";s:6:"Unfold";s:15:"unlimited_users";s:39:"Put on desktops of all registered users";s:17:"uploaded_material";s:17:"Uploaded Material";s:27:"upper_limit_must_be_greater";s:53:"The upper limit must be greater than the lower limit!";s:11:"upper_limit";s:11:"Upper Limit";s:21:"use_anonymous_id_desc";s:130:"If checked, the username in anonymized surveys will be shown as the survey code, otherwise the text ‘Anonymous’ will be shown.";s:16:"use_anonymous_id";s:16:"Show Survey Code";s:26:"use_browser_print_function";s:50:"Please use the print function of your web browser.";s:25:"use_google_chart_api_desc";s:278:"If checked, the charts in the cumulated results details of the survey statistics are drawn using the <a href="http://code.google.com/apis/chart/" target="_blank">Google Chart API</a>. Please note that a permanent internet connection is required for the Google Chart API to work.";s:20:"use_google_chart_api";s:20:"Use Google Chart API";s:4:"used";s:4:"used";s:14:"users_answered";s:14:"Users Answered";s:13:"users_invited";s:26:"%s users have been invited";s:13:"users_skipped";s:13:"Users Skipped";s:16:"value_nr_entered";s:39:"Number of users that entered that value";s:6:"values";s:6:"Values";s:8:"vertical";s:8:"Vertical";s:29:"view_constraints_introduction";s:75:"You are viewing the preconditions of the following question/question block:";s:11:"view_phrase";s:11:"View Phrase";s:23:"warning_question_in_use";s:345:"Warning! The question you want to edit is in use by the surveys listed below. If you decide to continue and save/apply the question, all answers of the surveys listed below will be deleted. If you want to change the question and use it in another survey, please choose duplicate in the question browser to create a new instance of this question.";s:29:"warning_question_not_complete";s:29:"The question is not complete!";s:36:"wrong_categories_selected_for_insert";s:95:"ILIAS could not perform the desired action. Please check exactly one answer as target position!";s:22:"wrong_survey_code_used";s:92:"You cannot enter the survey, because you tried to start it with an unauthorized survey code.";s:16:"svy_search_users";s:23:"Search for participants";s:21:"dont_use_questionpool";s:77:"Don\'t insert the questions in a question pool (only available in this survey)";s:17:"other_answer_desc";s:51:"Add an additional choice (other) with a text field.";s:18:"other_answer_label";s:32:"Label of other answer (optional)";s:16:"use_other_answer";s:11:"Open answer";s:27:"question_mr_no_other_answer";s:40:"Please enter a text for the other answer";s:35:"question_mr_no_other_answer_checked";s:65:"You need to select the checkbox if you enter a text for an answer";s:35:"question_sr_no_other_answer_checked";s:69:"You need to select the radio button if you enter a text for an answer";s:15:"use_min_answers";s:17:"Answer selections";s:22:"use_min_answers_option";s:33:"Set a number of answer selections";s:14:"nr_min_answers";s:7:"Minimum";s:14:"nr_max_answers";s:7:"Maximum";s:22:"err_maxvaluegeminvalue";s:119:"The maximum value must be greater or equal than the minimum value and less or equal than the maximum number of answers.";s:20:"err_minvalueganswers";s:69:"The minimum must be less or equal than the maximum number of answers.";s:18:"err_no_min_answers";s:35:"Please check at least %s answer(s).";s:18:"err_no_max_answers";s:32:"Please check at most %s answers.";s:20:"err_no_exact_answers";s:34:"Please check exactly %s answer(s).";s:5:"label";s:5:"Label";s:10:"label_info";s:65:"Alternative identifier for further data processing (e.g. in SPSS)";s:17:"export_label_only";s:17:"Export label only";s:17:"export_title_only";s:17:"Export title only";s:18:"export_title_label";s:22:"Export title and label";s:16:"mailnotification";s:40:"Seperate E-Mail for Each Finished Survey";s:13:"mailaddresses";s:19:"Recipient addresses";s:18:"mailaddresses_info";s:95:"Enter a comma separated list of recipients who will receive a notification on finished surveys.";s:19:"mailparticipantdata";s:27:"Additional participant data";s:24:"mailparticipantdata_info";s:101:"This information will be precede the automatically included results section of the notification mail.";s:12:"table_fields";s:44:"Definition of field names for external mails";s:11:"tablefields";s:11:"Field names";s:20:"mail_import_example1";s:24:"email;firstname;lastname";s:20:"mail_import_example2";s:33:"sandraowen@domain.tld;Sandra;Owen";s:20:"mail_import_example3";s:35:"kennethbirt@domain.tld;Kenneth;Birt";s:16:"tablefields_info";s:70:"Please enter a comma separated list of field names for external mails.";s:18:"externalRecipients";s:24:"External code recipients";s:11:"edit_phrase";s:11:"Edit phrase";s:10:"phrase_new";s:17:"Create new phrase";s:18:"no_phrase_selected";s:17:"Nothing selected.";s:12:"other_answer";s:12:"Other answer";s:20:"constraint_fulfilled";s:9:"Show page";s:15:"conjunction_and";s:31:"if each constraint is fulfilled";s:14:"conjunction_or";s:30:"if one constraint is fulfilled";s:21:"conjunction_and_title";s:41:"Fulfill each of the following constraints";s:20:"conjunction_or_title";s:40:"Fulfill one of the following constraints";s:25:"err_external_rcp_no_email";s:58:"The import data must at least contain an ‘email’ field";s:32:"err_external_rcp_no_email_column";s:148:"The import data must at least contain a column ‘email’ with the title ‘email’ in the first row and the email addresses in the following rows";s:16:"err_no_selection";s:22:"You made no selection.";s:27:"external_recipients_deleted";s:29:"Deleted external recipient(s)";s:28:"external_recipients_imported";s:39:"External recipients have been imported.";s:21:"external_mails_import";s:41:"Import external recipients of survey keys";s:13:"externalmails";s:11:"Import file";s:17:"mail_survey_codes";s:29:"Mail access codes or messages";s:18:"externalmails_info";s:196:"The import file must be a CSV file, columns separated by a semicolon. The first row contains the column titles. The file must at least contain an ‘email’ column containing the recipient email.";s:12:"externaltext";s:11:"Import text";s:17:"externaltext_info";s:214:"The import text must be arranged in rows and columns, columns separated by a semicolon. The first row contains the column titles. The text must at least contain an ‘email’ column containing the recipient email.";s:16:"import_from_file";s:28:"Import user data from a file";s:16:"import_from_text";s:28:"Import user data from a text";s:19:"import_from_dataset";s:22:"Import from a data set";s:10:"recipients";s:10:"Recipients";s:11:"send_to_all";s:17:"To all recipients";s:13:"not_sent_only";s:55:"Only to new recipients (who did not receive a mail yet)";s:16:"send_to_answered";s:43:"To all recipients who did finish the survey";s:18:"send_to_unanswered";s:58:"To all recipients who did not finish the survey (reminder)";s:20:"message_content_info";s:326:"Enter the mail message for the notification mail containing the survey codes for the participants. You may use the placeholders [code] (the access code), [url] (the URL to this survey), and participant related data depending on your import fields: %s. The placeholders will be replaced with the imported user data in the mail.";s:26:"default_codes_mail_subject";s:23:"Your access code for %s";s:26:"default_codes_mail_message";s:99:"Your survey access code is [code]. You can start the survey in your web browser using the URL [url]";s:25:"please_enter_mail_subject";s:27:"Please enter a mail subject";s:25:"please_enter_mail_message";s:27:"Please enter a mail message";s:19:"participating_users";s:19:"Participating Users";s:22:"please_enter_mail_code";s:47:"Please enter the access code placeholder [code]";s:15:"mail_sent_short";s:4:"Sent";s:21:"finished_mail_subject";s:28:"The survey "%s" was finished";s:18:"msg_min_nr_answers";s:35:"Please check at least %s answer(s).";s:18:"msg_max_nr_answers";s:32:"Please check at most %s answers.";s:22:"msg_min_max_nr_answers";s:48:"Please check at least %s and at most %s answers.";s:25:"msg_min_max_exact_answers";s:34:"Please check exactly %s answer(s).";s:19:"msg_duplicate_scale";s:33:"Please enter unique scale values.";s:11:"workingtime";s:12:"Working time";s:18:"save_reuse_message";s:31:"Save message text for later use";s:16:"save_reuse_title";s:18:"Message text title";s:14:"saved_messages";s:18:"Available messages";s:20:"insert_saved_message";s:19:"Insert Message Text";s:20:"delete_saved_message";s:19:"Delete Message Text";s:20:"msg_message_inserted";s:20:"Messagetext inserted";s:23:"msg_no_message_inserted";s:28:"Please select a message text";s:19:"msg_message_deleted";s:19:"Messagetext deleted";s:22:"msg_no_message_deleted";s:34:"Please select a saved message text";s:31:"question_changed_in_survey_only";s:35:"Question was changed only in survey";s:20:"survey_prev_question";s:13:"Previous Page";s:20:"survey_next_question";s:9:"Next Page";s:14:"survey_jump_to";s:7:"Jump to";s:23:"survey_add_new_question";s:11:"Create Page";s:15:"survey_use_pool";s:8:"Use Pool";s:21:"svy_settings_template";s:8:"Template";s:20:"survey_per_page_view";s:9:"Page View";s:20:"survey_dnd_move_next";s:17:"Move to Next Page";s:24:"survey_dnd_move_previous";s:21:"Move to Previous Page";s:21:"survey_dnd_split_page";s:10:"Split Page";s:33:"survey_dnd_double_click_to_delete";s:72:"Double click on a content element to select it for cutting and deleting.";s:26:"survey_dnd_clear_clipboard";s:15:"Clear Clipboard";s:16:"survey_dnd_paste";s:5:"Paste";s:37:"survey_has_datasets_warning_page_view";s:108:"The survey already contains data sets. You cannot edit the survey questions until you remove these datasets.";s:42:"survey_has_datasets_warning_page_view_link";s:17:"Edit Participants";s:21:"survey_using_template";s:126:"This survey uses the template %s. If you do not want to use a template and have access to all settings, please click here: %s.";s:26:"survey_using_template_link";s:27:"Do not use template anymore";s:29:"survey_confirm_template_reset";s:62:"Are you sure that you do not want to use the template anymore?";s:21:"survey_template_reset";s:30:"The template has been removed.";s:24:"survey_introduction_info";s:60:"This message is permanently displayed on the ‘Info’-tab.";s:20:"survey_question_pool";s:13:"Question Pool";s:26:"survey_question_pool_usage";s:13:"Question Pool";s:21:"survey_pool_selection";s:14:"Pool Selection";s:14:"survey_no_pool";s:24:"Do not use question pool";s:15:"survey_new_pool";s:24:"Create new question pool";s:20:"survey_existing_pool";s:26:"Use existing question pool";s:18:"survey_delete_page";s:11:"Delete Page";s:19:"survey_at_beginning";s:16:"At The Beginning";s:18:"survey_behind_page";s:6:"Behind";s:22:"survey_show_blocktitle";s:16:"Show Block Title";s:34:"survey_show_blocktitle_description";s:57:"If activated the block title will be shown in the survey.";s:19:"survey_block_hidden";s:6:"hidden";s:20:"survey_block_visible";s:7:"visible";s:28:"survey_question_text_visible";s:12:"Text visible";s:27:"survey_question_text_hidden";s:11:"Text hidden";s:16:"survey_move_page";s:9:"Move Page";s:17:"survey_page_moved";s:24:"The page has been moved.";s:29:"survey_copy_questions_to_pool";s:20:"Add to question pool";s:37:"no_question_selected_for_copy_to_pool";s:84:"Please select at least one question, which is not already linked to a question pool.";s:31:"survey_copy_select_questionpool";s:31:"Question pool to put the copies";s:35:"survey_copy_to_questionpool_success";s:53:"The questions were copied into the pool successfully.";s:23:"survey_auto_block_title";s:11:"Page Header";s:20:"survey_edit_settings";s:13:"Edit Settings";s:12:"survey_order";s:10:"Sort Order";s:21:"survey_cancel_preview";s:14:"Cancel Preview";s:28:"survey_cannot_preview_survey";s:21:"Preview not available";s:33:"survey_questions_to_clipboard_cut";s:88:"Question(s) were copied to the clipboard. Please select a target or empty the clipboard.";s:34:"survey_questions_to_clipboard_copy";s:88:"Question(s) were copied to the clipboard. Please select a target or empty the clipboard.";s:23:"survey_clipboard_notice";s:90:"There are question(s) in the clipboard. Select the target position or empty the clipboard.";s:19:"survey_edit_heading";s:12:"Edit Heading";s:21:"survey_delete_heading";s:14:"Remove Heading";s:31:"survey_available_question_pools";s:15:"Available Pools";s:26:"survey_question_pool_title";s:10:"Pool Title";s:27:"survey_sync_question_copies";s:20:"Sync Question Copies";s:32:"survey_sync_question_copies_info";s:70:"The selected questions will be replaced with the current pool version.";s:36:"survey_sync_insufficient_permissions";s:24:"Insufficient Permissions";s:19:"survey_sync_success";s:36:"The selected questions were updated.";s:27:"svy_presentation_properties";s:12:"Presentation";s:13:"svy_save_sync";s:29:"Save and Sync Question Copies";s:21:"survey_question_title";s:14:"Question Title";s:40:"survey_question_editor_settings_template";s:34:"List View (in Tab ‘Questions’)";s:28:"survey_sure_delete_questions";s:73:"Are you sure that you want to delete the following questions or headings?";s:17:"svy_participation";s:13:"Participation";s:21:"svy_page_add_question";s:10:"Add new %s";s:19:"svy_create_question";s:15:"Create Question";s:16:"freetext_answers";s:12:"Open Answers";s:18:"svy_neutral_answer";s:72:"Text for a Neutral Answer (‘Not Specified’, ‘I don\'t know’ etc.)";s:41:"svy_matrix_layout_percentages_sum_invalid";s:42:"The column settings do not sum up to 100%.";s:8:"svy_copy";s:11:"Copy Survey";s:26:"svy_activation_online_info";s:56:"Only if a survey is online, users can participate in it.";s:31:"svy_availability_limitless_info";s:59:"Choose this mode for making the survey available limitless.";s:27:"svy_availability_until_info";s:76:"Choose this mode for making the survey available for a fixed period of time.";s:38:"svy_activation_limited_visibility_info";s:115:"Outside the indicated period, only the title of the survey will be displayed while the question are not accessible.";s:33:"survey_question_pool_usage_active";s:52:"Questions can be added optionally to a question pool";s:38:"survey_question_pool_usage_active_info";s:86:"Each time a question is created it has to be decided if a question pool is to be used.";s:35:"survey_question_pool_usage_inactive";s:45:"Questions are created directly in the survey.";s:40:"survey_question_pool_usage_inactive_info";s:104:"The questions can be added to a question pool manually later but are created only for this survey first.";s:17:"svy_invite_action";s:23:"Put on Personal Desktop";s:23:"survey_code_delete_sure";s:59:"Are you sure you want to delete the following access codes?";s:16:"survey_360_title";s:5:"360°";s:15:"survey_360_mode";s:14:"360° Feedback";s:26:"survey_360_self_evaluation";s:15:"Self-Evaluation";s:22:"survey_360_self_raters";s:28:"Appraisees Select Own Raters";s:25:"survey_360_self_appraisee";s:19:"Open 360° Feedback";s:18:"survey_360_results";s:32:"Access To Results For Appraisees";s:23:"survey_360_results_none";s:20:"No Access to Results";s:22:"survey_360_results_own";s:32:"Access to Feedback of Own Raters";s:22:"survey_360_results_all";s:13:"All Feedbacks";s:21:"survey_360_appraisees";s:10:"Appraisees";s:22:"survey_360_edit_raters";s:13:"Manage Raters";s:32:"survey_360_sure_delete_appraises";s:57:"Are you sure you want to remove the following appraisees?";s:29:"survey_360_sure_delete_raters";s:60:"Are you sure you want to remove the following raters for %s?";s:29:"survey_360_add_external_rater";s:18:"Add External Rater";s:24:"survey_360_no_appraisees";s:50:"There are currently no appraisees for you to rate.";s:29:"survey_360_add_self_appraisee";s:40:"Add yourself as appraisee to this survey";s:21:"survey_360_list_title";s:10:"360° Mode";s:27:"survey_360_select_appraisee";s:6:"Select";s:20:"survey_360_appraisee";s:9:"Appraisee";s:29:"survey_activate_skill_service";s:27:"Activate Competence Service";s:19:"survey_skill_assign";s:30:"Question/Competence Assignment";s:12:"survey_skill";s:10:"Competence";s:24:"survey_assign_competence";s:17:"Assign Competence";s:24:"survey_remove_competence";s:17:"Remove Competence";s:23:"survey_skill_thresholds";s:21:"Competence Thresholds";s:18:"survey_skill_level";s:16:"Competence Level";s:21:"survey_up_to_x_points";s:14:"Up to x points";s:17:"survey_skill_nr_q";s:19:"Number of Questions";s:29:"survey_skill_max_scale_points";s:17:"Max. Scale Points";s:20:"survey_reached_level";s:13:"Reached Level";s:19:"survey_sum_of_means";s:33:"Sum of Arithm. Means per Question";s:18:"survey_calc_skills";s:27:"Determine Competence Levels";s:19:"survey_write_skills";s:17:"Write Competences";s:26:"survey_360_rater_mail_sent";s:9:"Mail sent";s:36:"survey_360_rater_code_mail_on_demand";s:19:"generated on demand";s:43:"survey_360_rater_message_content_registered";s:28:"Message Content (Registered)";s:42:"survey_360_rater_message_content_anonymous";s:27:"Message Content (Anonymous)";s:51:"survey_360_rater_message_content_registered_default";s:65:"You can start the survey in your web browser using the URL [url].";s:50:"survey_360_rater_message_content_anonymous_default";s:100:"Your survey access code is [code]. You can start the survey in your web browser using the URL [url].";s:32:"survey_360_rater_subject_default";s:49:"You have been invited as rater to a 360° survey.";s:26:"survey_360_raters_finished";s:15:"Raters Finished";s:25:"survey_360_rater_finished";s:15:"Survey Finished";s:18:"survey_competences";s:11:"Competences";s:34:"svy_skl_comp_assignm_not_supported";s:62:"Competence assignment is not supported for this question type.";s:8:"svy_back";s:4:"Back";s:30:"survey_360_appraisee_is_closed";s:36:"The appraisee has closed his survey.";s:31:"survey_360_no_closed_appraisees";s:39:"No appraisee has closed his survey yet.";s:32:"survey_360_rate_other_appraisees";s:15:"Rate appraisees";s:25:"survey_360_appraisee_info";s:14:"Appraisee Info";s:29:"survey_360_raters_status_info";s:15:"Raters finished";s:33:"survey_360_appraisee_close_action";s:23:"Close Survey For Raters";s:38:"survey_360_appraisee_close_action_info";s:41:"This will give access to your statistics.";s:44:"survey_360_appraisee_close_action_info_skill";s:75:"This will give access to your statistics and update your competence levels.";s:41:"survey_360_appraisee_close_action_success";s:50:"You have closed your 360° survey for your raters.";s:40:"survey_360_appraisee_close_action_status";s:24:"Survey was closed on %s.";s:31:"survey_360_sure_appraisee_close";s:65:"Are you sure you want to close the survey for all of your raters?";s:32:"survey_360_appraisee_close_table";s:9:"Closed on";s:20:"svy_eval_competences";s:18:"Competence Results";s:16:"svy_gap_analysis";s:12:"Gap Analysis";s:26:"svy_all_survey_competences";s:22:"All Survey Competences";s:17:"survey_360_raters";s:6:"Raters";s:11:"svy_results";s:7:"Results";s:12:"svy_analysis";s:8:"Analysis";s:28:"survey_notification_settings";s:12:"Notification";s:23:"survey_reminder_setting";s:27:"Remind Users to Participate";s:21:"survey_reminder_start";s:5:"Start";s:19:"survey_reminder_end";s:3:"End";s:25:"survey_reminder_frequency";s:9:"Frequency";s:30:"survey_reminder_frequency_days";s:4:"Days";s:32:"survey_notification_target_group";s:12:"Target Group";s:46:"survey_notification_target_group_parent_course";s:34:"All members of parent course/group";s:55:"survey_notification_target_group_parent_course_inactive";s:57:"No parent course/group given - no reminders will be sent!";s:40:"survey_notification_target_group_invited";s:58:"All users who got the survey put on their Personal Desktop";s:45:"survey_notification_target_group_invited_info";s:32:"Number of current recipients: %s";s:33:"survey_notification_tutor_setting";s:42:"One E-Mail after all Participants Finished";s:36:"survey_notification_tutor_recipients";s:17:"Tutors (Login[s])";s:44:"survey_notification_tutor_recipients_invalid";s:41:"Please state users with write permission.";s:33:"survey_notification_tutor_subject";s:46:"All participants have finished the survey "%s"";s:36:"survey_notification_tutor_salutation";s:9:"Hello %s,";s:30:"survey_notification_tutor_body";s:58:"The following survey has been finished by all participants";s:30:"survey_notification_tutor_link";s:14:"Link to Survey";s:23:"survey_reminder_subject";s:28:"Survey "%s" was not finished";s:26:"survey_reminder_salutation";s:9:"Hello %s,";s:20:"survey_reminder_body";s:53:"the following survey has not been finished by you yet";s:20:"survey_reminder_link";s:3:"URL";s:11:"survey_mode";s:4:"Mode";s:19:"survey_default_mode";s:6:"Survey";s:24:"survey_default_mode_info";s:27:"Use for evaluation purposes";s:20:"survey_360_mode_info";s:33:"Use for peer-reviewing of persons";s:47:"survey_360_appraisee_close_action_success_admin";s:63:"The 360° surveys of the appraisees were closed for the raters.";s:37:"survey_360_sure_appraisee_close_admin";s:72:"Are you sure you want to close the surveys for the following appraisees?";s:28:"survey_360_remove_appraisees";s:19:"Remove Appraisee(s)";s:41:"survey_notification_finished_introduction";s:50:"The following participant has finished the survey.";s:35:"survey_notification_finished_reason";s:96:"You are receiving this email because you activated notifications for the survey mentioned above.";s:33:"svy_result_mail_notification_info";s:95:"On finishing the survey the answers of each participant will be sent to the defined recipients.";s:25:"survey_reminder_cron_info";s:63:"If activated, users will be reminded to participate in surveys.";s:31:"mailparticipantdata_placeholder";s:89:"These placeholders are replaced by actual user data if ‘Privacy’ is ‘With Names’:";s:25:"spl_save_obligatory_state";s:22:"Save Compulsory States";s:20:"survey_not_available";s:3:"n/a";s:23:"survey_results_finished";s:15:"Survey finished";s:20:"svy_view_own_results";s:18:"View given answers";s:20:"svy_mail_own_results";s:18:"Mail given answers";s:28:"svy_mail_own_results_subject";s:26:"Survey "%s" - Your Answers";s:25:"svy_mail_own_results_body";s:65:"the following is a complete summary of your survey participation.";s:20:"svy_results_view_own";s:33:"Participants can View Own Answers";s:20:"svy_results_mail_own";s:33:"Participants can Mail Own Answers";s:22:"svy_eval_skipped_value";s:22:"Results: ‘skipped’";s:26:"svy_eval_skipped_value_lng";s:23:"Use language file entry";s:31:"svy_eval_skipped_value_lng_info";s:19:"Current value: "%s"";s:29:"svy_eval_skipped_value_custom";s:16:"Use custom value";s:34:"svy_eval_skipped_value_custom_info";s:54:"Define any (or empty) value to use for skipped answers";s:35:"svy_eval_skipped_value_custom_value";s:5:"Value";s:16:"svy_import_codes";s:12:"Import Codes";s:21:"svy_import_codes_info";s:40:"This import requires a "%s" export file.";s:30:"svy_evaluation_access_all_info";s:92:"All registered users that can access the survey can also look at the results of this survey.";s:30:"svy_evaluation_access_off_info";s:91:"Only Users that can edit the survey (write permission) have access to the survey\'s results.";s:39:"svy_evaluation_access_participants_info";s:95:"All users that participated in the survey may choose to look at the results after finishing it.";s:25:"svy_results_mail_own_info";s:60:"Particiants can request a mail containing their own answers.";s:25:"svy_results_view_own_info";s:119:"After finishing the survey, participants can view a list of all answers they provided. They cannot change their answers";s:31:"survey_360_self_evaluation_info";s:62:"Appraisees are allowed to rate themselves using the questions.";s:27:"survey_360_self_raters_info";s:102:"Appraisees autonomously select and invite those persons that are supposed to provide feedback to them.";s:30:"survey_360_self_appraisee_info";s:136:"On the ‘Info’-tab a link is displayed to all users. By clicking this link they can add themselves as appraisee and receive feedback.";s:28:"survey_360_results_none_info";s:58:"Appraisees can not access the feedback provided by raters.";s:27:"survey_360_results_own_info";s:60:"Appraisees can access only the feedback of their own raters.";s:27:"survey_360_results_all_info";s:128:"All appraisees of the 360°-Survey can view all feedback provided by all raters of all appraisees, not only by their own raters.";s:34:"survey_activate_skill_service_info";s:173:"A new tab ‘Competences’ will be displayed. In this tab questions are assigned to competences, then thresholds are ascribed for reaching a specific level of a competence.";s:28:"survey_execution_sure_finish";s:97:"Are you sure you want to finish the survey? You will not be able to edit your answers afterwards.";s:21:"survey_execution_exit";s:18:"Back to repository";s:19:"survey_access_codes";s:30:"Authentication by Access Codes";s:24:"survey_access_codes_info";s:168:"Users get access to the survey by entering a code on the ‘Info’-tab. These access codes are generated in a sub-tab ‘Access Codes’ in the tab ‘Participants’.";s:28:"survey_results_anonymization";s:7:"Privacy";s:27:"survey_results_personalized";s:10:"With Names";s:32:"survey_results_personalized_info";s:170:"In the tab ‘Results’ the names of the participants and their respective answers are listed. Users having access to this tab can inspect who has provided which answer.";s:25:"survey_results_anonymized";s:32:"Without Names / Anonymous Survey";s:30:"survey_results_anonymized_info";s:186:"In the tab ‘Results’ participants\' names are replaced by codes. Users having access to this tab cannot attribute answers to named participants but only to user ‘iTXaF’ (example).";s:20:"material_added_empty";s:47:"The object does not have any suitable material.";s:29:"survey_sure_delete_constraint";s:80:"Are you sure you want to delete the routing rule "%1$s" for the question "%2$s"?";s:25:"survey_constraint_deleted";s:34:"The routing rule has been deleted.";s:33:"svy_settings_section_before_start";s:34:"Information before start of survey";s:27:"svy_settings_section_access";s:32:"Administering the survey: Access";s:39:"svy_settings_section_question_behaviour";s:47:"Administering the survey: Behaviour of question";s:30:"svy_settings_section_finishing";s:20:"Finishing the survey";s:30:"svy_settings_section_reminders";s:9:"Reminders";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'tagging'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:18:{s:17:"tagging_all_users";s:9:"All Users";s:21:"tagging_edit_settings";s:13:"Edit Settings";s:29:"tagging_enable_all_users_info";s:107:"Adds a section ‘All Users’ to the info screens that lists all tags of all users attached to a resource.";s:24:"tagging_enable_all_users";s:22:"Show Tags of All Users";s:22:"tagging_enable_tagging";s:14:"Enable Tagging";s:22:"tagging_forbidden_tags";s:14:"Forbidden Tags";s:25:"tagging_resources_for_tag";s:24:"Resources tagged with %s";s:20:"tagging_search_users";s:12:"Search Users";s:16:"tagging_settings";s:8:"Settings";s:16:"tagging_tag_info";s:86:"To attach tags to a resource open the info screen of the resource and enter your tags.";s:11:"tagging_tag";s:3:"Tag";s:12:"tagging_tags";s:4:"Tags";s:23:"tagging_users_using_tag";s:15:"Users Using Tag";s:15:"tagging_set_tag";s:8:"Set Tags";s:19:"tagging_other_users";s:19:"Tags of Other Users";s:34:"tag_some_obj_tagged_without_access";s:122:"You do not have the permissions to access some of the tagged objects anymore. Should the tag be removed for these objects?";s:37:"tag_remove_tags_of_obj_without_access";s:10:"Remove Tag";s:16:"tag_tags_deleted";s:47:"Tag has been removed from inaccessible objects.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'trac'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:363:{s:13:"found_objects";s:13:"Found Objects";s:22:"found_too_much_objects";s:94:"Thereby more than %s objects totally were found. Therefore refine your search request, please.";s:16:"info_all_objects";s:67:"The following user tracking refers to all objects of the type \'%s\'.";s:15:"info_dwell_time";s:88:"Attention: The total dwell time of an object isn\'t addicted to the given period of time!";s:18:"info_found_objects";s:114:"The user tracking refers to the following objects of the type \'%s\' that were found according to your search terms.";s:18:"info_valid_request";s:54:"The maximum valid time between two requests of a user.";s:10:"last_login";s:10:"Last Login";s:26:"meta_typical_learning_time";s:21:"Typical learning time";s:14:"newUT_settings";s:26:"Learning Module Statistics";s:9:"obj_types";s:12:"Object Types";s:16:"search_area_info";s:25:"Please choose one object.";s:12:"search_terms";s:14:"Search Term(s)";s:10:"select_one";s:24:"Please select one object";s:12:"stats_access";s:6:"Access";s:14:"stats_accesses";s:8:"Accesses";s:9:"stats_all";s:3:"All";s:33:"stats_chapter_average_page_number";s:35:"Average Number of Pages per Chapter";s:28:"stats_chapter_depth_coverage";s:29:"Degree of Coverage with Depth";s:27:"stats_chapter_fewest_access";s:13:"Fewest Access";s:21:"stats_chapter_listing";s:15:"Chapter Listing";s:44:"stats_chapter_longest_total_dwell_time_depth";s:22:"Total Dwell Time Depth";s:31:"stats_chapter_most_access_depth";s:22:"Most Access with Depth";s:24:"stats_chapter_most_pages";s:10:"Most Pages";s:20:"stats_chapter_number";s:18:"Number of Chapters";s:23:"stats_chapter_statisics";s:18:"Chapter Statistics";s:40:"stats_chapter_stubbiest_total_dwell_time";s:26:"Stubbiest Total Dwell Time";s:17:"stats_chapter_top";s:36:"Top-Chapter (variance, access, etc.)";s:29:"stats_chapter_total_statistic";s:23:"Total-Chapter-Statistic";s:13:"stats_chapter";s:7:"Chapter";s:12:"stats_choice";s:9:"Selection";s:13:"stats_current";s:9:"Currently";s:11:"stats_depth";s:5:"Depth";s:14:"stats_duration";s:8:"Duration";s:16:"stats_equivalent";s:16:"is equivalent to";s:10:"stats_hits";s:4:"Hits";s:10:"stats_hour";s:1:"h";s:25:"stats_interval_dwell_time";s:22:"Interval of Dwell Time";s:26:"stats_interval_page_access";s:27:"Interval of Access to Pages";s:14:"stats_interval";s:8:"Interval";s:10:"stats_last";s:4:"Last";s:12:"stats_legend";s:6:"Legend";s:21:"stats_measurable_hits";s:39:"Measurable Hits (Hits within a Session)";s:12:"stats_minute";s:1:"m";s:16:"stats_navigation";s:57:"Navigation/Observation Model (requires JRE 1.5 or higher)";s:19:"stats_new_selection";s:13:"New Selection";s:16:"stats_occurrence";s:10:"Occurrence";s:8:"stats_of";s:2:"of";s:25:"stats_page_average_access";s:26:"Average of Access to pages";s:29:"stats_page_average_dwell_time";s:30:"Average of Dwell Time to Pages";s:27:"stats_page_deviation_access";s:28:"Deviation of Access to Pages";s:31:"stats_page_deviation_dwell_time";s:32:"Deviation of Dwell Time to Pages";s:24:"stats_page_fewest_access";s:13:"Fewest Access";s:28:"stats_page_highest_deviation";s:17:"Highest Deviation";s:27:"stats_page_highest_varcoeff";s:29:"Highest Variation Coefficient";s:26:"stats_page_least_deviation";s:15:"Least Deviation";s:18:"stats_page_listing";s:12:"Page Listing";s:37:"stats_page_longest_average_dwell_time";s:18:"Average Dwell Time";s:35:"stats_page_longest_total_dwell_time";s:16:"Total Dwell Time";s:26:"stats_page_lowest_varcoeff";s:28:"Lowest Variation Coefficient";s:24:"stats_page_median_access";s:25:"Median of Access to Pages";s:28:"stats_page_median_dwell_time";s:29:"Median of Dwell Time to Pages";s:22:"stats_page_mode_access";s:23:"Mode of Access to Pages";s:22:"stats_page_most_access";s:13:"Most Accesses";s:24:"stats_page_number_access";s:25:"Number of Access to Pages";s:17:"stats_page_number";s:15:"Number of Pages";s:23:"stats_page_range_access";s:24:"Range of Access to Pages";s:27:"stats_page_range_dwell_time";s:28:"Range of Dwell Time to Pages";s:39:"stats_page_stubbiest_average_dwell_time";s:28:"Stubbiest Average Dwell Time";s:37:"stats_page_stubbiest_total_dwell_time";s:26:"Stubbiest Total Dwell Time";s:27:"stats_page_total_dwell_time";s:22:"Total-Pages-Dwell time";s:26:"stats_page_total_statistic";s:21:"Total-Pages-Statistic";s:26:"stats_page_varcoeff_access";s:40:"Variation Coefficient of Access to Pages";s:30:"stats_page_varcoeff_dwell_time";s:44:"Variation Coefficient of Dwell time to Pages";s:26:"stats_page_variance_access";s:27:"Variance of Access to Pages";s:30:"stats_page_variance_dwell_time";s:31:"Variance of Dwell Time to Pages";s:10:"stats_page";s:4:"Page";s:21:"stats_pages_statisics";s:15:"Page Statistics";s:11:"stats_pages";s:5:"Pages";s:9:"stats_sec";s:3:"sec";s:13:"stats_sel_lng";s:7:"English";s:28:"stats_session_average_length";s:22:"Average Session Length";s:33:"stats_session_average_page_access";s:35:"Average Access to Pages per Session";s:30:"stats_session_evaluable_access";s:24:"Evaluable Session Access";s:27:"stats_session_evaluable_usr";s:14:"Evaluable User";s:23:"stats_session_evaluable";s:18:"Evaluable Sessions";s:26:"stats_session_involved_usr";s:24:"Number of involved Users";s:21:"stats_session_listing";s:15:"Session Listing";s:40:"stats_session_longest_total_duration_usr";s:31:"Longest Total Duration per User";s:21:"stats_session_longest";s:15:"Longest Session";s:18:"stats_session_most";s:13:"Most Sessions";s:20:"stats_session_number";s:18:"Number of Sessions";s:28:"stats_session_total_duration";s:30:"Total Duration of all Sessions";s:29:"stats_session_total_statistic";s:23:"Total-Session-Statistic";s:13:"stats_session";s:7:"Session";s:24:"stats_sessions_statisics";s:18:"Session Statistics";s:14:"stats_sessions";s:8:"Sessions";s:11:"stats_start";s:5:"Start";s:15:"stats_summation";s:9:"Summation";s:18:"stats_tracked_user";s:14:"Selected Users";s:11:"stats_until";s:5:"until";s:19:"stats_user_selected";s:13:"User selected";s:10:"stats_user";s:7:"User(s)";s:10:"stats_with";s:4:"with";s:16:"total_dwell_time";s:16:"Total Dwell Time";s:14:"trac_activated";s:18:"Tracking Activated";s:16:"trac_active_both";s:45:"User Tracking and Learning Progress Activated";s:19:"trac_active_lp_only";s:27:"Learning Progress Activated";s:19:"trac_active_ut_only";s:23:"User Tracking Activated";s:24:"trac_added_no_shown_list";s:36:"The selected objects will be hidden.";s:26:"trac_anonymized_info_short";s:12:"(Anonymized)";s:20:"trac_anonymized_info";s:46:"If enabled, all statistics will be anonymized.";s:15:"trac_anonymized";s:10:"Anonymized";s:13:"trac_assigned";s:8:"Assigned";s:16:"trac_assignments";s:11:"Assignments";s:10:"trac_below";s:6:"Below:";s:22:"trac_collection_assign";s:42:"Select for Learning Progress Determination";s:24:"trac_collection_deassign";s:44:"Deselect for Learning Progress Determination";s:12:"trac_comment";s:7:"Comment";s:13:"trac_comments";s:8:"Comments";s:14:"trac_completed";s:9:"Completed";s:20:"trac_crs_assignments";s:26:"Assignment of Course Items";s:14:"trac_crs_items";s:23:"Assignable Course Items";s:16:"trac_crs_members";s:20:"Course Participants:";s:16:"trac_crs_objects";s:19:"Course Participants";s:24:"trac_crs_releavant_items";s:12:"Course Items";s:23:"trac_crs_relevant_items";s:16:"Course Materials";s:20:"trac_edit_collection";s:124:"Please assign materials. If the status of all assigned items is ‘Completed’ the overall status is completed by the user.";s:18:"trac_edit_progress";s:22:"Edit Learning Progress";s:14:"trac_edit_time";s:15:"Processing Time";s:16:"trac_edit_visits";s:77:"Please define the number of visits that is necessary to complete this object.";s:16:"trac_edited_scos";s:17:"Processed Content";s:24:"trac_editing_time_passed";s:19:"Editing Time Passed";s:11:"trac_failed";s:6:"Failed";s:16:"trac_filter_area";s:4:"Area";s:18:"trac_filter_hidden";s:6:"Hidden";s:25:"trac_filter_limit_reached";s:78:"The number of hits is limited to %s. Please use the filter to reduce the hits.";s:21:"trac_filter_no_access";s:16:"No objects found";s:16:"trac_filter_none";s:4:"None";s:22:"trac_filter_repository";s:17:"In the Repository";s:24:"trac_fold_relevant_items";s:14:"Folder Content";s:23:"trac_grp_relevant_items";s:15:"Group Materials";s:16:"trac_head_timing";s:10:"Edit Until";s:18:"trac_hide_selected";s:19:"Hide Selected Items";s:9:"trac_hide";s:4:"Hide";s:16:"trac_in_progress";s:11:"In Progress";s:18:"trac_inactive_both";s:47:"User Tracking and Learning Progress Deactivated";s:16:"trac_info_edited";s:78:"Set the status to ‘Completed’ if you think you have processed all content.";s:16:"trac_last_access";s:11:"Last Access";s:33:"trac_learning_progress_tbl_header";s:21:"Learning Progress of:";s:22:"trac_learning_progress";s:17:"Learning Progress";s:18:"trac_lm_statistics";s:17:"Access Statistics";s:30:"trac_lp_determination_info_crs";s:69:"Select the items that determine the overall learning progress status.";s:30:"trac_lp_determination_info_sco";s:98:"Select the items that determine the overall learning progress status of the SCORM learning module.";s:21:"trac_lp_determination";s:34:"Determination of Learning Progress";s:14:"trac_lp_filter";s:6:"Filter";s:9:"trac_mark";s:4:"Mark";s:10:"trac_marks";s:5:"Marks";s:25:"trac_mode_collection_info";s:70:"Define the materials that will determine the learning progress status.";s:20:"trac_mode_collection";s:34:"Automatic by Collection of Objects";s:26:"trac_mode_deactivated_info";s:31:"No progress will be calculated.";s:21:"trac_mode_deactivated";s:11:"Deactivated";s:15:"trac_mode_event";s:25:"Participation in Sessions";s:32:"trac_mode_exercise_returned_info";s:53:"The status ‘Completed’ can be set only by tutors.";s:27:"trac_mode_exercise_returned";s:15:"Exercise Solved";s:30:"trac_mode_manual_by_tutor_info";s:78:"The overall status (i.e. ‘Completed’ or ‘Failed’) is be set by tutors.";s:25:"trac_mode_manual_by_tutor";s:15:"Manual by Tutor";s:21:"trac_mode_manual_info";s:64:"Users have to decide if they reached the ‘Completed’ status.";s:16:"trac_mode_manual";s:17:"Manual by Learner";s:25:"trac_mode_objectives_info";s:109:"The learning progress will be calculated automatically according to the number of passed learning objectives.";s:20:"trac_mode_objectives";s:32:"Automatic by Learning Objectives";s:20:"trac_mode_scorm_aicc";s:38:"Automatic by Collection of SCORM Items";s:20:"trac_mode_scorm_info";s:79:"The learning progress status will be determined by the status of selected SCOs.";s:28:"trac_mode_scorm_package_info";s:92:"The learning progress status will be determined by the SCORM course package status directly.";s:23:"trac_mode_scorm_package";s:32:"Automatic by SCORM Course Status";s:15:"trac_mode_scorm";s:38:"Automatic by Collection of SCORM Items";s:28:"trac_mode_test_finished_info";s:39:"Users have to finish a test completely.";s:23:"trac_mode_test_finished";s:13:"Test Finished";s:26:"trac_mode_test_passed_info";s:74:"The test has to be passed by a user to receive the status ‘Completed’.";s:21:"trac_mode_test_passed";s:11:"Test Passed";s:18:"trac_mode_tlt_info";s:161:"Users who reached the Typical Learning Time will gain the status ‘Completed’. Two requests of a user within %s seconds will be counted as one coherent visit.";s:13:"trac_mode_tlt";s:21:"Typical Learning Time";s:21:"trac_mode_visits_info";s:83:"Define the number of visits that is required for completing this learning material.";s:16:"trac_mode_visits";s:16:"Number of Visits";s:9:"trac_mode";s:4:"Mode";s:24:"trac_modifications_saved";s:14:"Saved settings";s:10:"trac_modus";s:4:"Mode";s:17:"trac_no_attempted";s:13:"Not Attempted";s:15:"trac_no_content";s:53:"No information about the learning progress available.";s:24:"trac_no_sahs_items_found";s:17:"No objects found.";s:17:"trac_not_accessed";s:12:"Not Accessed";s:17:"trac_not_assigned";s:12:"Not Assigned";s:18:"trac_not_attempted";s:13:"Not Attempted";s:18:"trac_not_completed";s:13:"Not Completed";s:21:"trac_not_participated";s:16:"Not Participated";s:19:"trac_not_registered";s:14:"Not Registered";s:15:"trac_num_visits";s:16:"Number of Visits";s:12:"trac_objects";s:5:"Users";s:16:"trac_occurrences";s:5:"Path:";s:17:"trac_participated";s:12:"Participated";s:20:"trac_processing_time";s:23:"Assumed Processing Time";s:13:"trac_progress";s:26:"Personal Learning Progress";s:10:"trac_query";s:17:"Title/Description";s:23:"trac_reached_objectives";s:27:"Reached Learning Objectives";s:19:"trac_reached_points";s:14:"Achieved Score";s:19:"trac_reached_visits";s:15:"Required Visits";s:12:"trac_refresh";s:7:"Refresh";s:15:"trac_registered";s:10:"Registered";s:23:"trac_repository_changes";s:25:"Changes in the repository";s:20:"trac_required_visits";s:25:"Number of Required Visits";s:24:"trac_sahs_relevant_items";s:13:"Content Items";s:16:"trac_select_area";s:11:"Select Area";s:15:"trac_select_one";s:21:"You made no selection";s:19:"trac_settings_saved";s:15:"Saved settings.";s:13:"trac_settings";s:8:"Settings";s:16:"trac_show_hidden";s:4:"Show";s:9:"trac_show";s:22:"Show Learning Progress";s:15:"trac_spent_time";s:10:"Spent Time";s:11:"trac_status";s:6:"Status";s:16:"trac_time_passed";s:21:"Editing Time Exceeded";s:22:"trac_title_description";s:19:"Title / Description";s:17:"trac_total_online";s:17:"Total Time Online";s:21:"trac_update_edit_user";s:14:"Saved settings";s:19:"trac_updated_status";s:31:"Saved learning progress status.";s:20:"trac_user_activities";s:15:"User activities";s:14:"trac_user_data";s:9:"User Data";s:13:"trac_usr_list";s:5:"Users";s:18:"trac_valid_request";s:26:"Max. Time Between Requests";s:13:"trac_view_crs";s:14:"Back to Course";s:14:"trac_view_list";s:12:"Back to List";s:16:"trac_visits_info";s:50:"A click counts as new visit only after %s seconds.";s:11:"trac_visits";s:16:"Number of Visits";s:28:"tracking_time_span_not_valid";s:39:"Please enter a valid number of seconds.";s:9:"view_mode";s:9:"View Mode";s:18:"vm_access_of_users";s:15:"Access of Users";s:17:"vm_days_of_period";s:14:"Days of Period";s:15:"vm_times_of_day";s:13:"Times of Days";s:17:"trac_first_access";s:12:"First Access";s:15:"trac_read_count";s:13:"Access Number";s:18:"trac_spent_seconds";s:10:"Time Spent";s:15:"trac_percentage";s:10:"Percentage";s:13:"trac_learners";s:8:"Learners";s:12:"trac_summary";s:7:"Summary";s:18:"trac_learners_back";s:16:"Back To Learners";s:17:"trac_user_objects";s:25:"Learning Objects for User";s:13:"trac_subitems";s:14:"Show Sub-Items";s:17:"trac_participants";s:17:"Show Participants";s:10:"trac_title";s:5:"Title";s:11:"trac_matrix";s:11:"Matrix View";s:19:"registration_filter";s:20:"Date of Registration";s:10:"user_total";s:10:"User Total";s:15:"create_date_min";s:21:"Earliest Registration";s:15:"create_date_max";s:19:"Latest Registration";s:14:"read_count_avg";s:18:"Average page views";s:30:"trac_mode_deactivated_info_new";s:51:"The learning progress status will not be displayed.";s:27:"trac_lp_determination_tutor";s:39:"Display of objects in learning progress";s:36:"trac_lp_determination_info_crs_tutor";s:64:"This selection is not connected to the learning progress status.";s:12:"trac_average";s:7:"Average";s:8:"trac_sum";s:3:"Sum";s:11:"trac_others";s:6:"Others";s:36:"trac_learning_progress_settings_info";s:22:"Activate extended data";s:8:"trac_all";s:3:"All";s:14:"trac_view_mode";s:9:"View Mode";s:18:"trac_view_mode_all";s:11:"All Objects";s:25:"trac_view_mode_collection";s:46:"Only objects that determine the overall status";s:25:"trac_name_of_installation";s:20:"Name of Installation";s:16:"trac_object_name";s:14:"Name of Object";s:16:"trac_object_link";s:14:"Link to Object";s:17:"trac_object_owner";s:15:"Owner of Object";s:16:"trac_report_date";s:14:"Date of Report";s:17:"trac_report_owner";s:15:"Owner of Report";s:26:"trac_first_and_last_access";s:21:"First and Last Access";s:29:"trac_read_count_spent_seconds";s:19:"Time Spent / Access";s:23:"trac_object_stat_access";s:15:"Usage Intensity";s:15:"trac_show_graph";s:10:"Show Graph";s:11:"trac_figure";s:10:"Key Figure";s:22:"trac_object_stat_types";s:17:"Number of Objects";s:14:"trac_reference";s:10:"References";s:10:"trac_trash";s:14:"Moved to Trash";s:22:"trac_object_stat_daily";s:11:"Daily Usage";s:22:"trac_object_stat_admin";s:11:"Manage Data";s:16:"trac_delete_data";s:11:"Delete Data";s:21:"trac_sure_delete_data";s:218:"Are you sure you want to delete the complete data for the following months? This will remove all statistics for that period incl. Usage Intensity, Daily Usage, Learning Progress Statistics Course and Number of Objects.";s:17:"trac_data_deleted";s:22:"Data has been deleted.";s:19:"trac_sync_obj_stats";s:11:"Update Data";s:27:"trac_sync_obj_stats_success";s:22:"Data has been updated.";s:19:"trac_status_changed";s:18:"Last Status Change";s:25:"trac_learning_progress_of";s:23:"Learning Progress of %s";s:42:"trac_learning_progress_objects_description";s:61:"This table shows an overview of all your courses and objects.";s:20:"trac_group_materials";s:39:"Create Grouping with Optional Materials";s:22:"trac_release_materials";s:45:"Disintegrate Grouping with Optional Materials";s:25:"trac_group_materials_save";s:35:"Save Number of Compulsory Materials";s:24:"trac_group_materials_num";s:30:"Number of Compulsory Materials";s:36:"trac_grouped_material_obligatory_err";s:124:"The number materials which must be passed has to be greater than 0 and smaller than the number of materials of the grouping.";s:15:"trac_min_passed";s:35:"Minimum Number of Passed Materials:";s:22:"trac_object_statistics";s:17:"Object Statistics";s:33:"trac_determines_learning_progress";s:28:"Determines Learning Progress";s:19:"trac_manual_display";s:28:"Display in Learning Progress";s:22:"trac_manual_no_display";s:35:"Do not display in Learning Progress";s:24:"trac_manual_is_displayed";s:12:"Is Displayed";s:13:"trac_log_info";s:44:"Last Aggregation: %s (Unprocessed items: %s)";s:18:"trac_log_info_link";s:6:"Update";s:19:"trac_object_stat_lp";s:35:"Learning Progress Statistics Course";s:23:"trac_object_stat_lp_min";s:4:"Min.";s:23:"trac_object_stat_lp_max";s:4:"Max.";s:18:"trac_members_short";s:7:"Members";s:12:"trac_current";s:7:"Current";s:16:"trac_aggregation";s:11:"Aggregation";s:18:"session_statistics";s:18:"Session Statistics";s:21:"trac_last_aggregation";s:16:"Last Aggregation";s:28:"trac_last_maxed_out_sessions";s:14:"Last Full Load";s:22:"trac_maxed_out_counter";s:14:"Rejected Users";s:20:"trac_sessions_opened";s:10:"Admissions";s:20:"trac_sessions_closed";s:8:"Leavings";s:19:"trac_maxed_out_time";s:15:"Full Load [min]";s:18:"trac_closed_manual";s:6:"Logout";s:18:"trac_closed_expire";s:7:"Timeout";s:16:"trac_closed_idle";s:9:"Idle Time";s:22:"trac_closed_idle_first";s:23:"Idle Time (1st Request)";s:17:"trac_closed_login";s:18:"Anonymous To Login";s:34:"trac_session_statistics_mode_today";s:5:"Today";s:37:"trac_session_statistics_mode_last_day";s:13:"Last 24 Hours";s:38:"trac_session_statistics_mode_last_week";s:11:"Last 7 Days";s:39:"trac_session_statistics_mode_last_month";s:12:"Last 30 Days";s:23:"trac_session_active_avg";s:25:"Active Sessions (Average)";s:23:"trac_session_active_min";s:25:"Active Sessions (Minimum)";s:23:"trac_session_active_max";s:25:"Active Sessions (Maximum)";s:31:"trac_session_statistics_no_data";s:43:"No data for this statistics could be found.";s:23:"trac_sync_session_stats";s:14:"Aggregate Data";s:31:"trac_sync_session_stats_success";s:39:"Data aggregation was done successfully.";s:32:"trac_session_statistics_mode_day";s:3:"Day";s:33:"trac_session_statistics_mode_week";s:4:"Week";s:34:"trac_session_statistics_mode_month";s:5:"Month";s:24:"trac_current_system_load";s:19:"Current System Load";s:22:"trac_short_system_load";s:10:"Short term";s:21:"trac_long_system_load";s:9:"Long term";s:25:"trac_periodic_system_load";s:8:"Periodic";s:13:"trac_begin_at";s:10:"Start date";s:10:"trac_scale";s:5:"Scale";s:12:"trac_measure";s:6:"Figure";s:11:"trac_end_at";s:8:"End Date";s:33:"trac_session_statistics_mode_year";s:4:"Year";s:16:"trac_closed_misc";s:5:"Misc.";s:27:"trac_lp_on_personal_desktop";s:37:"Learning Progress on Personal Desktop";s:22:"trac_lp_learner_access";s:37:"Accessible Personal Learning Progress";s:22:"trac_filter_has_status";s:49:"Show also objects with status ‘not attempted’";s:16:"trac_mode_plugin";s:6:"Plugin";s:32:"trac_lp_on_personal_desktop_info";s:59:"If active, learning progress is available in the main menu.";s:27:"trac_lp_learner_access_info";s:63:"If active, users can access their own learning progress status.";s:24:"trac_mode_collection_tlt";s:35:"Typical Learning Time (per Chapter)";s:29:"trac_mode_collection_tlt_info";s:106:"Users who reached the Typical Learning Time of all relevant chapters will gain the status ‘Completed’.";s:27:"trac_mode_collection_manual";s:31:"Manual by Learner (per Chapter)";s:32:"trac_mode_collection_manual_info";s:79:"Users have to decide for each chapter whether their status is completed or not.";s:35:"trac_collection_manual_learner_info";s:61:"The learning progress for this object has to be set manually.";s:41:"trac_collection_manual_learner_changed_ts";s:10:"Changed on";s:38:"trac_collection_manual_learner_lm_info";s:36:"Activate all chapters you completed.";s:32:"trac_collection_tlt_learner_info";s:76:"The learning progress for this object is based on the typical learning time.";s:35:"trac_collection_tlt_learner_subitem";s:57:"You have spent %s of the %s needed for completion (%s%%).";s:16:"trac_lp_list_gui";s:36:"Personal Desktop, Repository, Search";s:21:"trac_lp_list_gui_info";s:72:"If activated, the learning progress status is included in objects lists.";s:27:"trac_object_statistics_info";s:85:"If activated, the basic data for the usage statistics will be gathered and processed.";s:19:"trac_mode_questions";s:9:"Questions";s:24:"trac_mode_questions_info";s:80:"Users who answered all questions correctly will gain the status ‘Completed’.";s:20:"trac_mode_event_info";s:76:"The learning progress status will be determined by the participation status.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'user'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:102:{s:19:"user_access_limited";s:7:"Limited";s:21:"user_access_unlimited";s:9:"Unlimited";s:33:"user_activate_public_profile_info";s:79:"First and last name will always be visible in your profile, if it is activated.";s:28:"user_activate_public_profile";s:10:"Activation";s:15:"user_activation";s:10:"Activation";s:8:"user_all";s:3:"All";s:8:"user_any";s:3:"Any";s:10:"user_field";s:5:"Field";s:16:"user_global_role";s:11:"Global Role";s:22:"user_last_login_before";s:17:"Last Login Before";s:19:"user_limited_access";s:14:"Limited Access";s:27:"user_member_of_course_group";s:22:"Member of Course/Group";s:15:"user_no_courses";s:19:"No Courses Assigned";s:14:"user_no_groups";s:18:"No Groups Assigned";s:31:"user_please_select_course_group";s:34:"Please select a course or a group.";s:24:"user_public_profile_info";s:114:"Please select which personal data is visible in your profile and which users should be able to visit your profile.";s:36:"user_screen_reader_optimization_info";s:44:"Improve ILIAS for usage with screen readers.";s:31:"user_screen_reader_optimization";s:26:"Screen Reader Optimization";s:24:"user_select_course_group";s:19:"Select Course/Group";s:23:"user_visible_in_profile";s:24:"Visible in Personal Data";s:19:"usr_link_to_profile";s:15:"Link to Profile";s:32:"usr_public_profile_disabled_info";s:57:"Your information is only visible to administrative staff.";s:27:"usr_public_profile_disabled";s:16:"Profile Disabled";s:30:"usr_public_profile_global_info";s:40:"Your profile is visible to the internet.";s:25:"usr_public_profile_global";s:46:"WWW / Accessible for all Users on the Internet";s:33:"usr_public_profile_logged_in_info";s:65:"Your information is only visible to users logged into the system.";s:28:"usr_public_profile_logged_in";s:27:"Visible for Logged in Users";s:32:"enable_local_user_administration";s:32:"Enable Local User Administration";s:37:"enable_local_user_administration_info";s:92:"If enabled, local user accounts can be administrated in categories and organisational units.";s:20:"restrict_user_access";s:34:"Restricted Access to User Accounts";s:25:"restrict_user_access_info";s:211:"Enabled this option only if you want to restrict the access to user accounts. If enabled access to local and global user accounts is only granted when a role has the permission ‘Read Access to User Account’.";s:25:"user_adm_enable_alpha_nav";s:46:"Alphabetical Navigation in User Administration";s:17:"user_ext_profiles";s:17:"Extended Profiles";s:22:"user_ext_profiles_desc";s:54:"Allows users to add individual tabs to their profiles.";s:16:"user_ext_profile";s:16:"Extended Profile";s:21:"user_new_profile_page";s:16:"New Profile Page";s:13:"user_add_page";s:8:"Add Page";s:10:"user_order";s:5:"Order";s:22:"user_sure_delete_pages";s:57:"Are you sure that you want to delete the following pages?";s:27:"user_selected_pages_deleted";s:37:"The selected pages have been deleted.";s:29:"user_save_ordering_and_titles";s:24:"Save ordering and titles";s:20:"user_profile_preview";s:7:"Preview";s:15:"user_portfolios";s:10:"Portfolios";s:20:"user_portfolios_desc";s:52:"Users can create portfolios and use them as profile.";s:22:"user_profile_portfolio";s:120:"If you want to use a portfolio as your profile, go to the portfolio section and set ‘My Profile’ for that portfolio.";s:18:"user_account_codes";s:26:"Account Reactivation Codes";s:22:"user_account_codes_add";s:9:"Add Codes";s:25:"user_account_codes_export";s:12:"Export Codes";s:30:"user_account_codes_edit_header";s:9:"Add Codes";s:25:"user_account_codes_number";s:15:"Number Of Codes";s:17:"user_account_code";s:4:"Code";s:29:"user_account_code_valid_until";s:11:"Valid Until";s:36:"user_account_code_valid_until_static";s:8:"End Date";s:37:"user_account_code_valid_until_dynamic";s:14:"Number of Days";s:27:"user_account_code_generated";s:18:"Date Of Generation";s:22:"user_account_code_used";s:11:"Date Of Use";s:17:"user_account_used";s:13:"Date Of Usage";s:31:"user_account_code_generated_all";s:9:"All Dates";s:33:"user_account_export_codes_no_data";s:33:"No codes to export were selected.";s:27:"user_account_code_not_valid";s:71:"The given registration code is either invalid or already has been used.";s:39:"user_account_code_valid_until_unlimited";s:9:"Unlimited";s:25:"user_account_code_setting";s:36:"Enable Account Re-Activation By Code";s:30:"user_account_code_setting_info";s:70:"Inactive Accounts can be re-activated by users with pre-defined codes.";s:31:"user_profile_portfolio_selected";s:107:"You are currently using a portfolio as your profile. Activation can be set there using the ‘Share’ tab.";s:29:"user_allow_delete_own_account";s:33:"Allow users to delete own account";s:42:"user_delete_own_account_notification_email";s:18:"Notification Email";s:28:"user_delete_own_account_info";s:110:"Here you can delete your current user account. Keep in mind that the deletion of your account is irreversible!";s:45:"user_delete_own_account_password_confirmation";s:32:"Enter password for authorisation";s:42:"user_delete_own_account_final_confirmation";s:72:"Please confirm for the last time to remove your user account from ILIAS!";s:37:"user_delete_own_account_email_subject";s:20:"User account deleted";s:34:"user_delete_own_account_email_body";s:54:"Your user account "%s" has been deleted from %s on %s.";s:23:"user_store_last_visited";s:12:"Last Visited";s:20:"user_lv_keep_entries";s:21:"Remember last visited";s:29:"user_lv_keep_only_for_session";s:36:"Remember only during current session";s:20:"user_lv_do_not_store";s:27:"Never remember last visited";s:14:"user_ownership";s:18:"Repository Objects";s:23:"user_delete_own_account";s:14:"Delete Account";s:33:"user_account_deleted_confirmation";s:93:"Your account has been deleted. An email containing detailed information has been sent to you.";s:20:"tos_show_signed_text";s:12:"Show Details";s:20:"tos_not_accepted_yet";s:16:"Not accepted yet";s:20:"tos_accepted_content";s:16:"Accepted Content";s:43:"user_delete_own_account_logout_confirmation";s:88:"Your account has been flagged for deletion. Please authenticate to continue the process.";s:37:"user_delete_own_account_logout_button";s:25:"Proceed to Authentication";s:31:"user_delete_own_account_aborted";s:42:"Aborted deletion, account was not changed.";s:21:"inform_user_mail_info";s:142:"If activated, an email will be sent to the user. Its content can be defined in Administration > User Management > Settings > New Account Mail.";s:6:"usr_id";s:7:"User ID";s:9:"interests";s:9:"Interests";s:17:"interests_general";s:17:"General Interests";s:22:"interests_help_offered";s:13:"Offering Help";s:22:"interests_help_looking";s:16:"Looking For Help";s:21:"passwd_generation_pre";s:21:"Pre-defined Passwords";s:27:"send_mail_to_inactive_users";s:12:"Warning Mail";s:32:"send_mail_to_inactive_users_desc";s:305:"If set, a warning mail will be sent to the user before his/her account is deleted due to inactivity. Please make sure that sending external mails is possible. On activation with reminder mail, it may happen, that the time frame between reminder mail and deletion is smaller than the configured time frame.";s:34:"send_mail_to_inactive_users_suffix";s:21:"Days before Deletion.";s:40:"send_mail_to_inactive_users_numbers_only";s:47:"Only positive non decimal numbers are accepted.";s:48:"send_mail_to_inactive_users_must_be_smaller_than";s:77:"This value must be smaller than the value ‘Days passed since last login’.";s:16:"del_mail_subject";s:40:"(ILIAS) – Your account will be deleted";s:13:"del_mail_body";s:189:"Hello %1$s, %2$s you haven\'t logged in for a long period of time, on %3$s. So your account will be probably deleted on %4$s. You have to login again to prevent the deletion of your account.";s:39:"delete_inactive_user_accounts_frequency";s:9:"Frequency";s:44:"delete_inactive_user_accounts_frequency_desc";s:71:"Frequency, in which the deletion and email distribution will be tested.";s:35:"send_mail_reminder_window_too_small";s:60:"Your Frequency setting is too large for this reminder value.";s:8:"feedhash";s:12:"Newsfeedhash";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'wiki'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:182:{s:20:"wiki_activate_rating";s:25:"Activate Rating For Pages";s:14:"wiki_all_pages";s:9:"All Pages";s:12:"wiki_article";s:7:"Article";s:16:"wiki_contributor";s:11:"Contributor";s:17:"wiki_contributors";s:12:"Contributors";s:15:"wiki_created_by";s:10:"Created By";s:15:"wiki_discussion";s:10:"Discussion";s:9:"wiki_edit";s:4:"Edit";s:11:"wiki_failed";s:6:"Failed";s:24:"wiki_feedback_from_tutor";s:19:"Feedback from Tutor";s:21:"wiki_general_settings";s:16:"General Settings";s:12:"wiki_grading";s:7:"Grading";s:12:"wiki_history";s:7:"History";s:17:"wiki_introduction";s:12:"Introduction";s:20:"wiki_last_changed_by";s:15:"Last Changed By";s:17:"wiki_last_changed";s:11:"Last Change";s:22:"wiki_last_visited_page";s:17:"Last Visited Page";s:14:"wiki_main_page";s:9:"Main Page";s:9:"wiki_mark";s:4:"Mark";s:15:"wiki_media_list";s:10:"Media List";s:26:"wiki_msg_short_name_regexp";s:87:"Short title must not start with a number and must not contain the following characters:";s:14:"wiki_new_pages";s:9:"New Pages";s:18:"wiki_no_start_page";s:38:"Wiki is missing a valid starting page.";s:14:"wiki_notgraded";s:10:"Not Graded";s:35:"wiki_number_users_notes_or_comments";s:60:"Number of users that attached notes or comments to this page";s:19:"wiki_orphaned_pages";s:14:"Orphaned Pages";s:24:"wiki_other_pages_linking";s:32:"Other Pages Linking to This Page";s:17:"wiki_page_changes";s:12:"Page Changes";s:17:"wiki_page_deleted";s:18:"Wiki page deleted.";s:31:"wiki_page_deletion_confirmation";s:44:"Do you really want to delete this wiki page?";s:14:"wiki_page_hits";s:9:"Page Hits";s:9:"wiki_page";s:4:"Page";s:10:"wiki_pages";s:5:"Pages";s:11:"wiki_passed";s:6:"Passed";s:29:"wiki_please_enter_search_term";s:27:"Please enter a search term.";s:18:"wiki_popular_pages";s:13:"Popular Pages";s:15:"wiki_print_view";s:10:"Print View";s:21:"wiki_quick_navigation";s:21:"Wiki Quick Navigation";s:16:"wiki_random_page";s:11:"Random Page";s:19:"wiki_recent_changes";s:14:"Recent Changes";s:19:"wiki_search_results";s:14:"Search Results";s:11:"wiki_search";s:6:"Search";s:13:"wiki_settings";s:13:"Wiki Settings";s:31:"wiki_short_title_already_in_use";s:76:"This title is already used by another wiki. Please select a different title.";s:22:"wiki_short_title_desc2";s:130:"This title will be used in links to the wiki. Once chosen you should not change this title, since users may loose their bookmarks.";s:16:"wiki_short_title";s:11:"Short Title";s:21:"wiki_start_page_title";s:16:"Start Page Title";s:15:"wiki_start_page";s:10:"Start Page";s:10:"wiki_style";s:5:"Style";s:20:"wiki_what_links_here";s:16:"What Links Here?";s:23:"wiki_what_links_to_page";s:24:"What links to page "%s"?";s:14:"wiki_wiki_page";s:9:"Wiki Page";s:16:"wiki_wiki_search";s:11:"Wiki Search";s:11:"wiki_import";s:11:"Import Wiki";s:22:"wiki_edit_notification";s:28:"Email Notification on Change";s:27:"wiki_edit_notification_info";s:45:"You will be notified when any page is edited.";s:32:"wiki_change_notification_subject";s:34:"Wiki "%1$s" has been changed: %2$s";s:41:"wiki_change_notification_page_body_update";s:40:"the following wiki page has been updated";s:41:"wiki_change_notification_page_body_delete";s:40:"the following wiki page has been deleted";s:34:"wiki_change_notification_page_link";s:3:"URL";s:33:"wiki_change_notification_body_new";s:35:"the following wiki page was created";s:29:"wiki_change_notification_link";s:3:"URL";s:29:"wiki_notification_toggle_info";s:19:"Change Notification";s:38:"wiki_notification_toggle_wiki_activate";s:17:"Activate for Wiki";s:40:"wiki_notification_toggle_wiki_deactivate";s:19:"Deactivate for Wiki";s:38:"wiki_notification_toggle_page_activate";s:17:"Activate for Page";s:40:"wiki_notification_toggle_page_deactivate";s:19:"Deactivate for Page";s:15:"wiki_whole_wiki";s:10:"Whole Wiki";s:19:"wiki_selected_pages";s:14:"Selected Pages";s:35:"wiki_change_notification_salutation";s:9:"Hello %s,";s:20:"wiki_public_comments";s:15:"Public Comments";s:13:"wiki_ordering";s:8:"Ordering";s:16:"wiki_indentation";s:11:"Indentation";s:29:"wiki_save_ordering_and_indent";s:29:"Save Ordering and Indentation";s:26:"wiki_sure_remove_imp_pages";s:82:"Do you really want to remove the following pages from the list of important pages?";s:22:"wiki_removed_imp_pages";s:34:"Important pages removed from list.";s:30:"wiki_ordering_and_indent_saved";s:31:"Ordering and Indentation saved.";s:19:"wiki_imp_page_added";s:11:"Page added.";s:13:"wiki_page_toc";s:26:"Enable Page Overview Block";s:18:"wiki_page_toc_info";s:116:"This lists all headings linked to the content at the beginning of each page if that page uses at least two headings.";s:19:"wiki_page_unblocked";s:35:"Write permission granted for users.";s:17:"wiki_page_blocked";s:94:"Wiki page is set to read-only. Only users with «Edit Settings» permission have write access.";s:16:"wiki_last_edited";s:11:"Last edited";s:24:"wiki_page_already_exists";s:38:"A page with this title already exists.";s:16:"wiki_rename_page";s:11:"Rename Page";s:18:"wiki_new_page_name";s:9:"New Title";s:22:"wiki_news_page_created";s:31:"New wiki page has been created.";s:22:"wiki_news_page_changed";s:27:"Wiki page has been updated.";s:15:"wiki_changed_by";s:10:"Changed by";s:24:"wiki_page_status_blocked";s:18:"Page is read-only.";s:14:"wiki_functions";s:14:"Wiki Functions";s:15:"wiki_navigation";s:15:"Wiki Navigation";s:15:"wiki_page_lists";s:10:"Page Lists";s:27:"wiki_notification_activated";s:35:"Notification Activated (Whole Wiki)";s:32:"wiki_page_notification_activated";s:36:"Notification Activated (Single Page)";s:33:"wiki_notification_deactivate_wiki";s:32:"Deactivate Notification for Wiki";s:33:"wiki_notification_deactivate_page";s:32:"Deactivate Notification for Page";s:31:"wiki_notification_activate_wiki";s:30:"Activate Notification for Wiki";s:31:"wiki_notification_activate_page";s:30:"Activate Notification for Page";s:15:"wiki_block_page";s:13:"Set Read-Only";s:17:"wiki_unblock_page";s:18:"Grant Write Access";s:16:"wiki_delete_page";s:11:"Delete Page";s:11:"wiki_rename";s:6:"Rename";s:14:"wiki_rate_page";s:19:"Rate this Wiki Page";s:17:"wiki_page_actions";s:12:"Page Actions";s:29:"wiki_notification_deactivated";s:24:"Notification Deactivated";s:20:"wiki_navigation_info";s:93:"Here you can add and remove links to existing wiki pages to the navigation block in the wiki.";s:42:"wiki_change_notification_page_body_comment";s:42:"the following wiki page has been commented";s:30:"wiki_activate_sideblock_rating";s:28:"Display Rating as Side Block";s:29:"wiki_activate_new_page_rating";s:29:"Activate Rating For New Pages";s:29:"wiki_activate_extended_rating";s:26:"Activate Rating Categories";s:25:"wiki_activate_page_rating";s:15:"Activate Rating";s:27:"wiki_deactivate_page_rating";s:17:"Deactivate Rating";s:20:"wiki_start_page_info";s:79:"If there does not exist a page with this title yet, a new page will be created.";s:17:"wiki_rate_overall";s:9:"Rate Wiki";s:8:"wiki_wpg";s:9:"Wiki Page";s:24:"wiki_add_page_properties";s:40:"Activate Additional Wiki Page Properties";s:22:"wiki_advmd_block_title";s:25:"Advanced Metadata of Page";s:26:"wiki_amd_page_list_no_hits";s:8:"No items";s:19:"wiki_stat_num_pages";s:15:"Number of Pages";s:19:"wiki_stat_new_pages";s:19:"Number of New Pages";s:23:"wiki_stat_new_pages_avg";s:36:"Average Number of New Pages per User";s:20:"wiki_stat_edit_pages";s:22:"Number of Edited Pages";s:24:"wiki_stat_edit_pages_avg";s:39:"Average Number of Edited Pages per User";s:19:"wiki_page_templates";s:14:"Page Templates";s:28:"wiki_template_status_removed";s:24:"Template status removed.";s:27:"wiki_remove_template_status";s:22:"Remove Template Status";s:19:"wiki_template_added";s:20:"Template page added.";s:20:"wiki_templ_new_pages";s:26:"Available on Page Creation";s:22:"wiki_templ_add_to_page";s:43:"Available for Being Added to Existing Pages";s:17:"wiki_add_template";s:19:"Set Template Status";s:24:"wiki_empty_page_template";s:36:"Empty Page Template on Page Creation";s:32:"wiki_page_not_exist_select_templ";s:72:"This page does not exist yet. Please select a template for the new page.";s:13:"wiki_new_page";s:8:"New Page";s:18:"wiki_page_template";s:13:"Page Template";s:15:"wiki_empty_page";s:10:"Empty Page";s:16:"wiki_create_page";s:11:"Create Page";s:15:"wiki_stat_scope";s:9:"Timeframe";s:16:"wiki_stat_figure";s:6:"Figure";s:23:"wiki_stat_deleted_pages";s:23:"Number of Deleted Pages";s:20:"wiki_stat_read_pages";s:23:"Number of Read Accesses";s:25:"wiki_stat_user_edit_pages";s:32:"Number of Users Who Edited Pages";s:29:"wiki_stat_user_edit_pages_avg";s:40:"Average Number of Users Who Edited Pages";s:20:"wiki_stat_num_rating";s:17:"Number of Ratings";s:24:"wiki_stat_num_rating_avg";s:34:"Average Number of Ratings per Page";s:20:"wiki_stat_rating_avg";s:14:"Average Rating";s:24:"wiki_stat_internal_links";s:24:"Number of Internal Links";s:28:"wiki_stat_internal_links_avg";s:41:"Average Number of Internal Links per Page";s:24:"wiki_stat_external_links";s:24:"Number of External Links";s:28:"wiki_stat_external_links_avg";s:41:"Average Number of External Links per Page";s:15:"wiki_stat_words";s:15:"Number of Words";s:19:"wiki_stat_words_avg";s:33:" Average Number of Words per Page";s:15:"wiki_stat_chars";s:20:"Number of Characters";s:19:"wiki_stat_chars_avg";s:37:"Average Number of Characters per Page";s:19:"wiki_stat_footnotes";s:19:"Number of Footnotes";s:23:"wiki_stat_footnotes_avg";s:36:"Average Number of Footnotes per Page";s:22:"wiki_stat_page_changes";s:17:"Number of Changes";s:26:"wiki_stat_page_changes_avg";s:25:"Average Number of Changes";s:24:"wiki_stat_page_user_edit";s:31:"Number of Users Who Edited Page";s:19:"wiki_stat_page_read";s:23:"Number of Read Accesses";s:29:"wiki_stat_page_internal_links";s:24:"Number of Internal Links";s:29:"wiki_stat_page_external_links";s:24:"Number of External Links";s:20:"wiki_stat_page_words";s:15:"Number of Words";s:25:"wiki_stat_page_characters";s:20:"Number of Characters";s:24:"wiki_stat_page_footnotes";s:19:"Number of Footnotes";s:22:"wiki_stat_page_ratings";s:17:"Number of Ratings";s:20:"wiki_show_print_view";s:10:"Print View";s:20:"wiki_show_pdf_export";s:10:"PDF Export";s:22:"wiki_set_as_start_page";s:17:"Set as Start Page";s:12:"wiki_purpose";s:7:"Purpose";s:20:"wiki_select_one_item";s:23:"Please select one item.";s:9:"wiki_link";s:9:"Wiki Link";s:13:"wiki_add_link";s:8:"Add Link";s:14:"wiki_link_text";s:9:"Link Text";s:16:"wiki_target_page";s:11:"Target Page";s:16:"wiki_page_exists";s:13:"Existing Page";s:18:"wiki_adv_md_hidden";s:31:"This block is currently hidden.";s:24:"wiki_page_list_form_info";s:87:"Adds a list of pages of this wiki that are all assigned to the selected metadata below.";s:18:"wiki_no_page_found";s:49:"No wiki page has been found for search term \'$1\'.";s:16:"wiki_pages_found";s:48:"The following pages match your search term \'$1\'.";s:19:"wiki_no_search_term";s:72:"No search term has been entered. All pages of the wiki are listed below.";s:28:"wiki_unhide_meta_adv_records";s:26:"Show additional properties";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'sess'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:30:{s:11:"sess_import";s:14:"Import Session";s:9:"sess_copy";s:12:"Copy Session";s:24:"sess_mail_permanent_link";s:90:"Click on the following link to find all of the information you need regarding the session:";s:13:"sess_reg_type";s:23:" Registration Procedure";s:15:"sess_reg_direct";s:19:"Direct Registration";s:16:"sess_reg_request";s:21:"Request Participation";s:17:"sess_reg_disabled";s:25:"No Registration Necessary";s:21:"sess_reg_request_info";s:84:"An administrator has to apply each user\'s request for participating at this session.";s:22:"sess_reg_disabled_info";s:64:"The registration is not deactivated for this session appointment";s:26:"sess_reg_max_members_short";s:17:"Number of Members";s:20:"sess_reg_max_members";s:25:"Limited Number of Members";s:25:"sess_reg_max_members_info";s:72:"Define the maximum number of users that can participate to this session.";s:21:"sess_reg_waiting_list";s:12:"Waiting List";s:26:"sess_reg_waiting_list_info";s:107:"If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.";s:16:"sess_section_reg";s:21:"Registration Settings";s:16:"sess_users_added";s:42:"Registered selected users for the session.";s:27:"sess_users_already_assigned";s:48:"The user is already registered for this session.";s:28:"sess_users_removed_from_list";s:59:"The selected users have been removed from the waiting list.";s:28:"sess_msg_applicants_assigned";s:36:"Applicant(s) registered for session.";s:27:"sess_msg_applicants_removed";s:31:"Applicant(s) removed from list.";s:23:"sess_registered_confirm";s:127:"The registration requires a confirmation of an administrator. You will be notified after the registration process is completed.";s:27:"sess_reg_max_users_exceeded";s:78:"A registration is not possible, since the maximum number of users id exceeded.";s:30:"sess_reg_max_users_exceeded_wl";s:69:"The maximum number of users for this session appointment is exceeded.";s:20:"sess_reg_added_to_wl";s:40:"You have been added to the waiting list.";s:21:"sess_mail_sub_dec_sub";s:37:"Registration refused for session "%s"";s:21:"sess_mail_sub_dec_bod";s:74:"we regret to say that your registration has been refused for session "%s".";s:21:"sess_mail_sub_acc_sub";s:29:"Registration for Session "%s"";s:21:"sess_mail_sub_acc_bod";s:42:"you have been registered for session "%s".";s:14:"sess_lp_preset";s:26:"Activate Learning Progress";s:19:"sess_lp_preset_info";s:58:"(De-)Actives the learning progress for all session events.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'book'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:105:{s:18:"book_booking_types";s:15:"Booking Objects";s:14:"book_schedules";s:9:"Schedules";s:18:"book_no_of_objects";s:14:"No. of Objects";s:9:"book_book";s:4:"Book";s:15:"book_list_items";s:12:"List Objects";s:13:"book_add_type";s:26:"Add Type Of Booking Object";s:17:"book_back_to_list";s:12:"Back to List";s:14:"book_edit_type";s:9:"Edit Type";s:18:"book_group_objects";s:13:"Group objects";s:23:"book_group_objects_info";s:118:"Treat objects as group, will only be differentiated internally. Please create at least 1 schedule to use this feature.";s:13:"book_schedule";s:8:"Schedule";s:17:"book_objects_list";s:15:"Booking Objects";s:17:"book_current_user";s:9:"Booked by";s:15:"book_add_object";s:10:"Add Object";s:16:"book_edit_object";s:11:"Edit Object";s:12:"book_is_used";s:7:"Is Used";s:17:"book_add_schedule";s:12:"Add Schedule";s:18:"book_edit_schedule";s:13:"Edit Schedule";s:18:"book_schedule_type";s:4:"Type";s:22:"book_schedule_type_fix";s:3:"Fix";s:27:"book_schedule_type_fix_info";s:38:"Can only be booked in given time slots";s:27:"book_schedule_type_flexible";s:8:"Flexible";s:32:"book_schedule_type_flexible_info";s:45:"Can be booked freely for given days and hours";s:20:"book_schedule_raster";s:11:"Time raster";s:25:"book_schedule_raster_info";s:19:"Minimum time entity";s:22:"book_schedule_rent_min";s:20:"Minimum booking time";s:22:"book_schedule_rent_max";s:20:"Maximum booking time";s:23:"book_schedule_rent_info";s:33:"Given in multiples of time raster";s:19:"book_schedule_break";s:27:"Auto-Break between Bookings";s:24:"book_schedule_break_info";s:33:"Given in multiples of time raster";s:18:"book_schedule_days";s:8:"Weekdays";s:23:"book_schedule_days_info";s:46:"Valid booking times for each day (HH:MM-HH:MM)";s:18:"book_schedule_slot";s:4:"Slot";s:13:"book_deadline";s:8:"Deadline";s:12:"book_minutes";s:7:"Minutes";s:18:"book_deadline_info";s:46:"Minimum time between booking and booked period";s:15:"book_type_added";s:30:"A booking type has been added.";s:17:"book_type_updated";s:34:"The booking type has been updated.";s:17:"book_type_deleted";s:34:"The booking type has been deleted.";s:17:"book_object_added";s:32:"A booking object has been added.";s:19:"book_object_updated";s:36:"The booking object has been updated.";s:19:"book_object_deleted";s:36:"The booking object has been deleted.";s:19:"book_schedule_added";s:34:"A booking schedule has been added.";s:21:"book_schedule_updated";s:38:"The booking schedule has been updated.";s:21:"book_schedule_deleted";s:38:"The booking schedule has been deleted.";s:19:"book_confirm_delete";s:49:"Do you really want to delete the following items?";s:15:"book_pool_added";s:30:"A booking pool has been added.";s:17:"book_create_title";s:16:"Add Booking Pool";s:10:"book_hours";s:5:"Hours";s:25:"book_reservation_fix_info";s:49:"The reservation can only be done for fixed hours.";s:22:"book_reservation_title";s:23:"Booking Reservation for";s:20:"book_confirm_booking";s:15:"Confirm Booking";s:26:"book_reservation_confirmed";s:32:"Your booking has been confirmed.";s:23:"book_reservation_failed";s:24:"Your booking has failed.";s:25:"book_reservation_status_2";s:6:"In Use";s:25:"book_reservation_status_5";s:9:"Cancelled";s:11:"book_period";s:6:"Period";s:18:"book_change_status";s:13:"Change Status";s:23:"book_reservation_cancel";s:6:"Cancel";s:22:"book_reservation_block";s:5:"Block";s:8:"book_log";s:12:"Reservations";s:22:"book_reservations_list";s:12:"Reservations";s:14:"book_cal_entry";s:11:"Booking of:";s:15:"book_public_log";s:19:"Public Reservations";s:20:"book_public_log_info";s:52:"The list of reservations can be viewed by all users.";s:11:"book_fromto";s:10:"Date Range";s:8:"book_all";s:8:"Show all";s:12:"book_earlier";s:7:"Earlier";s:10:"book_later";s:5:"Later";s:13:"book_slots_no";s:15:"Number of slots";s:18:"book_slots_no_info";s:45:"Available number of slots per day in schedule";s:15:"book_set_in_use";s:9:"Is in Use";s:19:"book_set_not_in_use";s:10:"Not in Use";s:15:"book_set_cancel";s:18:"Cancel Reservation";s:19:"book_set_not_cancel";s:11:"Undo Cancel";s:8:"book_not";s:3:"Not";s:21:"book_schedule_warning";s:115:"Currently, there is no schedule available. Before adding booking objects you need to create a schedule for booking.";s:8:"book_new";s:16:"New Booking Pool";s:8:"book_add";s:16:"Add Booking Pool";s:9:"book_edit";s:17:"Edit Booking Pool";s:26:"book_schedule_warning_edit";s:149:"Currently, there is no schedule available. To use the booking pool you need to create a schedule for booking (or switch to a different type of pool).";s:17:"book_type_warning";s:110:"Currently, there are no booking objects available. To use the booking pool you need to create booking objects.";s:19:"booking_nr_of_items";s:11:"Nr of Items";s:24:"book_schedule_type_fixed";s:14:"Fixed Schedule";s:29:"book_schedule_type_fixed_info";s:59:"This type can be used for rooms, video projectors and such.";s:23:"book_schedule_type_none";s:11:"No Schedule";s:28:"book_schedule_type_none_info";s:66:"This type can be used for seminar papers, seminar places and such.";s:32:"book_confirm_booking_no_schedule";s:51:"Are you sure you want to book the following object?";s:25:"book_additional_info_file";s:22:"Additional Description";s:29:"book_post_booking_information";s:24:"Post Booking Information";s:22:"book_post_booking_text";s:4:"Text";s:22:"book_post_booking_file";s:4:"File";s:18:"book_download_info";s:31:"Download Additional Description";s:47:"book_confirm_booking_schedule_number_of_objects";s:20:"Booking Confirmation";s:52:"book_confirm_booking_schedule_number_of_objects_info";s:44:"Please state the numbers of objects to book.";s:9:"book_copy";s:17:"Copy Booking Pool";s:18:"obj_book_duplicate";s:17:"Copy Booking Pool";s:26:"book_reservation_available";s:12:"%s available";s:34:"book_reservation_failed_overbooked";s:63:"The booking failed because the object is not available anymore.";s:19:"book_confirm_cancel";s:59:"Are you sure you want to cancel the following reservations?";s:27:"book_post_booking_text_info";s:61:"Use [PERIOD] and [OBJECT] to add booking details to the text.";s:31:"book_confirm_cancel_aggregation";s:23:"Number of Cancellations";s:18:"book_overall_limit";s:24:"Limit number of bookings";s:23:"book_overall_limit_info";s:61:"Maximum number of bookings for each user in this booking pool";s:26:"book_overall_limit_warning";s:48:"You have reached the maximum number of bookings.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'wsp'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:57:{s:22:"wsp_personal_workspace";s:12:"My Workspace";s:34:"wsp_personal_workspace_description";s:60:"Here you can manage your private files, blogs and artifacts.";s:22:"wsp_navigation_folders";s:11:"View Folder";s:15:"wsp_root_folder";s:12:"My Workspace";s:23:"wsp_navigation_resource";s:10:"Create New";s:13:"wsp_type_file";s:4:"File";s:13:"wsp_type_wfld";s:6:"Folder";s:13:"wsp_type_blog";s:4:"Blog";s:13:"wsp_type_tstv";s:17:"Certificate: Test";s:13:"wsp_type_excv";s:21:"Certificate: Exercise";s:24:"wsp_permission_add_users";s:9:"Add Users";s:29:"wsp_set_permission_registered";s:20:"All Registered Users";s:22:"wsp_set_permission_all";s:14:"World Wide Web";s:21:"wsp_remove_permission";s:17:"Remove Permission";s:30:"wsp_permission_registered_info";s:48:"This object is shared with all registered users.";s:23:"wsp_permission_all_info";s:31:"This object has been published.";s:15:"wsp_permissions";s:5:"Share";s:15:"wsp_shared_with";s:11:"Shared With";s:30:"wsp_set_permission_single_user";s:13:"A Single User";s:24:"wsp_set_permission_group";s:16:"Members of Group";s:25:"wsp_set_permission_course";s:17:"Members of Course";s:31:"wsp_set_permission_all_password";s:28:"World Wide Web with Password";s:22:"wsp_permission_removed";s:26:"The item has been removed.";s:22:"wsp_share_with_members";s:18:"Share with members";s:17:"wsp_share_success";s:27:"A new entry has been added.";s:22:"wsp_share_search_users";s:12:"Search Users";s:16:"wsp_tab_personal";s:12:"My Resources";s:14:"wsp_tab_shared";s:24:"Resources of Other Users";s:20:"wsp_shared_resources";s:16:"Shared Resources";s:21:"wsp_share_select_user";s:21:"Please select a user.";s:22:"wsp_copy_to_repository";s:18:"Copy to Repository";s:22:"wsp_move_to_repository";s:18:"Move to Repository";s:17:"wsp_status_shared";s:6:"Shared";s:13:"wsp_type_webr";s:7:"Weblink";s:31:"wsp_password_protected_resource";s:27:"Password-protected Resource";s:36:"wsp_password_protected_resource_info";s:53:"To access this resource you have to enter a password.";s:16:"wsp_password_for";s:12:"Password for";s:20:"wsp_invalid_password";s:30:"The given password is invalid.";s:20:"wsp_share_with_users";s:16:"Share with users";s:17:"wsp_tab_ownership";s:21:"My Repository Objects";s:15:"wsp_shared_date";s:13:"Date of Share";s:15:"wsp_shared_type";s:11:"Shared With";s:22:"wsp_shared_object_type";s:16:"Type of Resource";s:22:"wsp_shared_user_filter";s:10:"Login/Name";s:22:"wsp_shared_date_filter";s:11:"Shared From";s:32:"wsp_shared_mandatory_filter_info";s:93:"Please set at least one filter attribute. Text filters have to be at least 4 characters long.";s:24:"wsp_shared_member_filter";s:25:"Members of Course / Group";s:16:"wsp_shared_title";s:17:"Title of Resource";s:13:"wsp_list_excv";s:20:"Exercise Certificate";s:13:"wsp_list_tstv";s:16:"Test Certificate";s:13:"wsp_type_crsv";s:19:"Certificate: Course";s:13:"wsp_list_crsv";s:18:"Course Certificate";s:13:"wsp_type_scov";s:18:"Certificate: SCORM";s:13:"wsp_list_scov";s:17:"SCORM Certificate";s:22:"wsp_shared_table_title";s:6:"Shares";s:30:"wsp_shared_filter_reset_button";s:12:"Reset Search";s:24:"wsp_shared_filter_button";s:6:"Search";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'blog'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:110:{s:8:"blog_new";s:15:"Create New Blog";s:8:"blog_add";s:11:"Create Blog";s:16:"blog_add_posting";s:11:"Add Posting";s:19:"blog_permanent_link";s:9:"Permalink";s:13:"blog_comments";s:8:"Comments";s:14:"blog_list_more";s:4:"more";s:34:"blog_posting_deletion_confirmation";s:52:"Are you sure you want to delete the following entry?";s:35:"blog_number_users_notes_or_comments";s:61:"Number of users that attached notes or comments to this entry";s:20:"blog_posting_deleted";s:27:"The entry has been deleted.";s:17:"blog_enable_notes";s:15:"Public Comments";s:12:"blog_preview";s:7:"Preview";s:9:"blog_edit";s:9:"Edit Blog";s:11:"blog_banner";s:6:"Banner";s:21:"blog_background_color";s:16:"Background Color";s:15:"blog_font_color";s:10:"Font Color";s:18:"blog_back_to_ilias";s:13:"Back to ILIAS";s:18:"blog_exercise_info";s:62:"This blog is part of the assignment "%s" of the exercise "%s".";s:18:"blog_finalize_blog";s:24:"Finalize and Submit Blog";s:14:"blog_finalized";s:28:"The Blog has been submitted.";s:13:"blog_settings";s:19:"Blog Administration";s:25:"blog_preview_banner_width";s:12:"Banner Width";s:26:"blog_preview_banner_height";s:13:"Banner Height";s:19:"blog_preview_banner";s:13:"Custom Banner";s:28:"blog_exercise_submitted_info";s:65:"Your last submission was on %s, please check the export file: %s.";s:22:"blog_admin_toggle_info";s:86:"You can deactivate the blog feature completely in the Personal Desktop Administration.";s:20:"blog_profile_picture";s:23:"Display Profile Picture";s:19:"blog_rename_posting";s:14:"Rename Posting";s:15:"blog_navigation";s:8:"Postings";s:24:"blog_preview_banner_info";s:32:"Default size is 1370x100 pixels.";s:24:"blog_admin_inactive_info";s:73:"You can activate the blog feature in the Personal Desktop Administration.";s:21:"blog_new_posting_info";s:61:"The first text block is used as abstract in the posting list.";s:12:"blog_posting";s:12:"Blog Posting";s:32:"blog_change_notification_subject";s:26:"Blog "%s" has been updated";s:35:"blog_change_notification_salutation";s:9:"Hello %s,";s:33:"blog_change_notification_body_new";s:39:"the following blog posting was created.";s:36:"blog_change_notification_body_update";s:44:"the following blog posting has been updated.";s:37:"blog_change_notification_body_comment";s:46:"the following blog posting has been commented.";s:15:"blog_changed_by";s:15:"Last Changed By";s:29:"blog_change_notification_link";s:20:"Link to Blog Posting";s:27:"blog_notification_toggle_on";s:21:"Activate Notification";s:28:"blog_notification_toggle_off";s:23:"Deactivate Notification";s:27:"blog_notification_activated";s:22:"Notification Activated";s:29:"blog_notification_deactivated";s:24:"Notification Deactivated";s:10:"blog_draft";s:5:"Draft";s:15:"blog_draft_info";s:50:"This posting draft is only visible for the author.";s:17:"blog_toggle_draft";s:20:"Withdraw Publication";s:17:"blog_toggle_final";s:15:"Publish Posting";s:14:"blog_edit_date";s:9:"Edit Date";s:19:"blog_edit_date_info";s:48:"Publication status does not depend on this date.";s:15:"blog_enable_rss";s:12:"Activate RSS";s:20:"blog_enable_rss_info";s:75:"The RSS feed is public and independent of blog sharing or user permissions.";s:9:"blog_copy";s:9:"Copy Blog";s:13:"blog_keywords";s:8:"Keywords";s:16:"blog_no_keywords";s:34:"No keywords have been entered yet.";s:18:"blog_edit_keywords";s:13:"Edit Keywords";s:12:"blog_keyword";s:7:"Keyword";s:12:"blog_authors";s:7:"Authors";s:11:"blog_author";s:10:"Written by";s:20:"blog_enable_approval";s:16:"Approve Postings";s:25:"blog_enable_approval_info";s:109:"Postings are published only after being approved by a user with permission ‘Edit Settings’ for this blog.";s:12:"blog_approve";s:7:"Approve";s:19:"blog_needs_approval";s:14:"Needs Approval";s:17:"blog_contributors";s:12:"Contributors";s:20:"blog_add_contributor";s:15:"Add Contributor";s:17:"blog_search_users";s:12:"Search Users";s:27:"blog_contribute_other_roles";s:110:"In addition to the list of ‘Contributors’, users with one of the following roles can also add postings: %s";s:11:"blog_import";s:11:"Import Blog";s:23:"blog_toggle_draft_admin";s:23:"Deactivate Blog Posting";s:18:"blog_keywords_info";s:41:"Use +/- icons to add and remove keywords.";s:31:"blog_posting_edit_approval_info";s:65:"Posting remains to be approved by a tutor before being published.";s:28:"blog_draft_info_contributors";s:56:"This posting draft is only visible for the contributors.";s:15:"blog_allow_html";s:21:"Allow HTML/Javascript";s:20:"blog_allow_html_info";s:105:"Enables users to include HTML and/or Javascript in their blog postings. This can lead to security issues.";s:31:"blog_change_notification_reason";s:94:"You are receiving this email because you activated notifications for the blog mentioned above.";s:15:"blog_properties";s:15:"Blog Properties";s:10:"blog_style";s:10:"Blog Style";s:17:"blog_edit_posting";s:12:"Edit Posting";s:22:"blog_posting_not_found";s:35:"This blog posting is not available.";s:21:"blog_abstract_shorten";s:16:"Shorten Abstract";s:28:"blog_abstract_shorten_length";s:14:"Maximum Length";s:32:"blog_abstract_shorten_characters";s:10:"Characters";s:19:"blog_abstract_image";s:21:"Add Image To Abstract";s:24:"blog_abstract_image_info";s:42:"Images which are smaller will not be used.";s:25:"blog_abstract_image_width";s:5:"Width";s:26:"blog_abstract_image_height";s:6:"Height";s:26:"blog_abstract_image_pixels";s:2:"Px";s:37:"blog_change_notification_body_approve";s:42:"the following blog posting needs approval.";s:24:"blog_settings_navigation";s:17:"Navigation Column";s:23:"blog_presentation_frame";s:17:"Blog Presentation";s:26:"blog_presentation_overview";s:16:"Initial Overview";s:13:"blog_nav_mode";s:8:"Postings";s:24:"blog_nav_mode_month_list";s:19:"Show List of Months";s:29:"blog_nav_mode_month_list_info";s:64:"All months with postings are listed in the ‘Postings’ block.";s:35:"blog_nav_mode_month_list_num_detail";s:24:"Total number of postings";s:40:"blog_nav_mode_month_list_num_detail_info";s:112:"Latest postings are listed by date in reverse chronological order. Older postings are available via their month.";s:34:"blog_nav_mode_month_list_num_month";s:23:"Number of listed months";s:39:"blog_nav_mode_month_list_num_month_info";s:82:"Months above the limit will not be listed and related postings are not accessible.";s:26:"blog_nav_mode_month_single";s:19:"Show Selected Month";s:31:"blog_nav_mode_month_single_info";s:110:"Only postings of the selected month are listed in the ‘Postings’ block. Month can be changed by drop-down.";s:22:"blog_list_num_postings";s:18:"Number of postings";s:27:"blog_list_num_postings_info";s:59:"This setting is only used if no specific month is selected.";s:20:"blog_enable_keywords";s:8:"Keywords";s:25:"blog_enable_keywords_info";s:97:"Keywords can be set for postings. Clicking a keyword shows all postings tagged with this keyword.";s:23:"blog_enable_nav_authors";s:7:"Authors";s:28:"blog_enable_nav_authors_info";s:89:"List of blog authors is displayed. Clicking a username shows all postings of this author.";s:18:"blog_nav_sortorder";s:15:"Order of Blocks";s:36:"blog_profile_picture_repository_info";s:92:"Profile pictures of the authors are only shown on the postings pages, not on overview pages.";s:32:"blog_confirm_delete_contributors";s:59:"Are you sure you want to delete the following contributors?";s:19:"blog_keywords_other";s:14:"Other Keywords";s:24:"blog_keywords_other_info";s:48:"These keywords were set for other blog postings.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'prtf'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:73:{s:15:"prtf_portfolios";s:10:"Portfolios";s:18:"prtf_add_portfolio";s:13:"Add Portfolio";s:19:"prtf_edit_portfolio";s:14:"Edit Portfolio";s:21:"prtf_create_portfolio";s:13:"Add Portfolio";s:22:"prtf_portfolio_created";s:15:"Portfolio added";s:22:"prtf_portfolio_updated";s:17:"Portfolio updated";s:19:"prtf_set_as_default";s:17:"Set As My Profile";s:27:"prtf_sure_delete_portfolios";s:57:"Are you sure you want to delete the following portfolios?";s:22:"prtf_portfolio_deleted";s:18:"Portfolios deleted";s:13:"prtf_add_page";s:8:"Add Page";s:17:"prtf_page_created";s:12:"Page created";s:32:"prtf_sure_delete_portfolio_pages";s:80:"Are you sure you want to delete the following portfolio pages and/or blog pages?";s:27:"prtf_portfolio_page_deleted";s:36:"Portfolio and/or blog pages deleted.";s:22:"prtf_portfolio_default";s:7:"Default";s:21:"prtf_first_page_title";s:18:"Type of first page";s:27:"prtf_save_status_and_titles";s:22:"Save Status and Titles";s:22:"prtf_default_portfolio";s:10:"My Profile";s:18:"prtf_exercise_info";s:67:"This portfolio is part of the assignment "%s" of the exercise "%s".";s:23:"prtf_finalize_portfolio";s:29:"Finalize and Submit Portfolio";s:14:"prtf_finalized";s:33:"The portfolio has been submitted.";s:13:"prtf_settings";s:24:"Portfolio Administration";s:25:"prtf_preview_banner_width";s:12:"Banner Width";s:26:"prtf_preview_banner_height";s:13:"Banner Height";s:19:"prtf_preview_banner";s:13:"Custom Banner";s:11:"prtf_banner";s:6:"Banner";s:21:"prtf_background_color";s:16:"Background Color";s:15:"prtf_font_color";s:10:"Font Color";s:18:"prtf_no_blogs_info";s:95:"Your workspace does not contain any blogs. Create blogs to use them as part of your portfolios.";s:13:"prtf_add_blog";s:8:"Add Blog";s:28:"prtf_exercise_submitted_info";s:65:"Your last submission was on %s, please check the export file: %s.";s:22:"prtf_admin_toggle_info";s:91:"You can deactivate the portfolio feature completely in the Personal Desktop Administration.";s:20:"prtf_public_comments";s:15:"Public Comments";s:14:"prtf_copy_page";s:12:"Copy Page(s)";s:23:"prtf_existing_portfolio";s:18:"Existing Portfolio";s:18:"prtf_new_portfolio";s:13:"New Portfolio";s:17:"prtf_pages_copied";s:27:"The pages have been copied.";s:20:"prtf_profile_picture";s:23:"Display Profile Picture";s:20:"prtf_use_page_layout";s:15:"Use Page Layout";s:19:"prtf_tab_portfolios";s:13:"My Portfolios";s:20:"prtf_tab_other_users";s:25:"Portfolios of Other Users";s:21:"prtf_unset_as_default";s:19:"Unset As My Profile";s:24:"prtf_preview_banner_info";s:32:"Default size is 1370x100 pixels.";s:24:"prtf_admin_inactive_info";s:78:"You can activate the portfolio feature in the Personal Desktop Administration.";s:37:"prtf_set_default_publish_confirmation";s:132:"The portfolio needs to be shared at least with all registered users. Should it be visible to the internet without registration, too?";s:29:"prtf_unset_default_share_info";s:85:"Then changes were saved. Please check the current settings for the portfolio sharing.";s:15:"prtf_allow_html";s:21:"Allow HTML/Javascript";s:20:"prtf_allow_html_info";s:107:"Enables users to include HTML and/or Javascript in their portfolio pages. This can lead to security issues.";s:37:"prtf_template_editor_placeholder_info";s:51:"This placeholder will be replaced in the portfolio.";s:18:"prtf_creation_mode";s:13:"New Portfolio";s:27:"prtf_creation_mode_template";s:20:"Create from Template";s:26:"prtf_creation_mode_scratch";s:23:"Create without Template";s:32:"prtf_template_import_blog_create";s:15:"Create New Blog";s:31:"prtf_template_import_blog_reuse";s:17:"Use Existing Blog";s:32:"prtf_template_import_blog_ignore";s:16:"Remove Blog Page";s:35:"prtf_create_template_from_portfolio";s:9:"Portfolio";s:40:"prtf_create_template_from_portfolio_info";s:68:"Select a portfolio to use its content and settings for the template.";s:34:"prtf_template_import_quota_failure";s:81:"This portfolio template cannot be copied because it would exceed your disk quota.";s:15:"prtf_properties";s:20:"Portfolio Properties";s:10:"prtf_style";s:15:"Portfolio Style";s:31:"prtf_template_import_new_skills";s:69:"If activated, these items will be added to your personal competences.";s:35:"prtf_page_element_teaser_my_courses";s:63:"The portfolio will display a list of your current courses here.";s:34:"prtf_page_element_my_courses_title";s:18:"Course Memberships";s:31:"prtf_page_element_teaser_skills";s:54:"The portfolio will display your competence level here.";s:38:"prtf_page_element_teaser_blog_template";s:66:"The portfolio will display a blog of your personal workspace here.";s:43:"prtf_page_element_teaser_consultation_hours";s:62:"The portfolio will display a consultation hours calendar here.";s:29:"prtf_page_element_teaser_blog";s:55:"The portfolio will display selected blog postings here.";s:33:"prtf_page_element_teaser_settings";s:8:"Settings";s:33:"prtf_page_element_my_courses_info";s:90:"This is a list of all my courses which are currently online and where I have a membership.";s:21:"prtf_allow_my_courses";s:29:"Page Element ‘My Courses’";s:26:"prtf_allow_my_courses_info";s:71:"Enables to include a list of current course memberships in a portfolio.";s:44:"prtf_page_element_teaser_my_courses_inactive";s:47:"This type of page element has been deactivated.";s:22:"prtf_blog_page_created";s:20:"Blog has been added.";s:23:"prtf_edit_embedded_blog";s:14:"Edit Blog "%s"";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'scormdebug'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:160:{s:26:"scormdebug_global_activate";s:22:"Enable SCORM test tool";s:31:"scormdebug_global_activate_info";s:146:"If enabled, the SCORM test tool can be activated for desired learning modules. If disabled, the test tool is deactivated for all learning modules.";s:6:"error0";s:8:"No error";s:8:"error101";s:17:"General Exception";s:8:"error102";s:30:"General Initialization Failure";s:8:"error103";s:19:"Already Initialized";s:8:"error104";s:27:"Content Instance Terminated";s:8:"error111";s:27:"General Termination Failure";s:8:"error112";s:33:"Termination Before Initialization";s:8:"error113";s:29:"Termination After Termination";s:8:"error122";s:35:"Retrieve Data Before Initialization";s:8:"error123";s:31:"Retrieve Data After Termination";s:8:"error132";s:32:"Store Data Before Initialization";s:8:"error133";s:28:"Store Data After Termination";s:8:"error142";s:28:"Commit Before Initialization";s:8:"error143";s:24:"Commit After Termination";s:8:"error201";s:22:"General Argument Error";s:8:"error301";s:19:"General Get Failure";s:8:"error351";s:19:"General Set Failure";s:8:"error391";s:22:"General Commit Failure";s:8:"error401";s:28:"Undefined Data Model Element";s:8:"error402";s:32:"Unimplemented Data Model Element";s:8:"error403";s:40:"Data Model Element Value Not Initialized";s:8:"error404";s:31:"Data Model Element Is Read Only";s:8:"error405";s:32:"Data Model Element Is Write Only";s:8:"error406";s:32:"Data Model Element Type Mismatch";s:8:"error407";s:37:"Data Model Element Value Out Of Range";s:8:"error408";s:37:"Data Model Dependency Not Established";s:8:"SetValue";s:9:"send data";s:8:"GetValue";s:8:"get data";s:6:"Commit";s:10:"store data";s:10:"Initialize";s:28:"initialize API-communication";s:9:"Terminate";s:42:"store data and terminate API-communication";s:14:"GetErrorString";s:57:"retrieve a textual description of the current error state";s:12:"GetLastError";s:50:"request the error code for the current error state";s:13:"GetDiagnostic";s:62:"allows the LMS (!) to define additional diagnostic information";s:12:"cmi._version";s:40:"Represents the version of the data model";s:35:"cmi.comments_from_learner._children";s:40:"Listing of supported data model elements";s:32:"cmi.comments_from_learner._count";s:34:"Current number of learner comments";s:35:"cmi.comments_from_learner.n.comment";s:13:"Textual input";s:36:"cmi.comments_from_learner.n.location";s:45:"Point in the SCO to which the comment applies";s:37:"cmi.comments_from_learner.n.timestamp";s:71:"Point in time at which the comment was created or most recently changed";s:31:"cmi.comments_from_lms._children";s:40:"Listing of supported data model elements";s:28:"cmi.comments_from_lms._count";s:39:"Current number of comments from the LMS";s:31:"cmi.comments_from_lms.n.comment";s:45:"Comments or annotations associated with a SCO";s:32:"cmi.comments_from_lms.n.location";s:45:"Point in the SCO to which the comment applies";s:33:"cmi.comments_from_lms.n.timestamp";s:71:"Point in time at which the comment was created or most recently changed";s:21:"cmi.completion_status";s:51:"Indicates whether the learner has completed the SCO";s:24:"cmi.completion_threshold";s:63:"Used to determine whether the SCO should be considered complete";s:10:"cmi.credit";s:73:"Indicates whether the learner will be credited for performance in the SCO";s:9:"cmi.entry";s:59:"Asserts whether the learner has previously accessed the SCO";s:8:"cmi.exit";s:45:"Indicates how or why the learner left the SCO";s:26:"cmi.interactions._children";s:40:"Listing of supported data model elements";s:23:"cmi.interactions._count";s:54:"Current number of interactions being stored by the LMS";s:21:"cmi.interactions.n.id";s:32:"Unique label for the interaction";s:23:"cmi.interactions.n.type";s:37:"Which type of interaction is recorded";s:36:"cmi.interactions.n.objectives._count";s:103:"Current number of objectives (i.e., objective identifiers) being stored by the LMS for this interaction";s:34:"cmi.interactions.n.objectives.n.id";s:52:"Label for objectives associated with the interaction";s:28:"cmi.interactions.n.timestamp";s:115:"Point in time at which the interaction was first made available to the learner for learner interaction and response";s:43:"cmi.interactions.n.correct_responses._count";s:80:"Current number of correct responses being stored by the LMS for this interaction";s:46:"cmi.interactions.n.correct_responses.n.pattern";s:48:"One correct response pattern for the interaction";s:28:"cmi.interactions.n.weighting";s:62:"Weight given to the interaction relative to other interactions";s:35:"cmi.interactions.n.learner_response";s:56:"Data generated when a learner responds to an interaction";s:25:"cmi.interactions.n.result";s:51:"Judgment of the correctness of the learner response";s:26:"cmi.interactions.n.latency";s:127:"Time elapsed between the time the interaction was made available to the learner for response and the time of the first response";s:30:"cmi.interactions.n.description";s:48:"Brief informative description of the interaction";s:15:"cmi.launch_data";s:86:"Data provided to a SCO after launch, initialized from the dataFromLMS manifest element";s:14:"cmi.learner_id";s:61:"Identifies the learner on behalf of whom the SCO was launched";s:16:"cmi.learner_name";s:40:"Name provided for the learner by the LMS";s:32:"cmi.learner_preference._children";s:40:"Listing of supported data model elements";s:34:"cmi.learner_preference.audio_level";s:53:"Specifies an intended change in perceived audio level";s:31:"cmi.learner_preference.language";s:70:"The learner\'s preferred language for SCOs with multilingual capability";s:37:"cmi.learner_preference.delivery_speed";s:58:"The learner\'s preferred relative speed of content delivery";s:39:"cmi.learner_preference.audio_captioning";s:69:"Specifies whether captioning text corresponding to audio is displayed";s:12:"cmi.location";s:41:"The learner\'s current location in the SCO";s:20:"cmi.max_time_allowed";s:62:"Amount of accumulated time the learner is allowed to use a SCO";s:8:"cmi.mode";s:87:"Identifies one of three possible modes in which the SCO may be presented to the learner";s:24:"cmi.objectives._children";s:40:"Listing of supported data model elements";s:21:"cmi.objectives._count";s:52:"Current number of objectives being stored by the LMS";s:19:"cmi.objectives.n.id";s:30:"Unique label for the objective";s:32:"cmi.objectives.n.score._children";s:40:"Listing of supported data model elements";s:29:"cmi.objectives.n.score.scaled";s:69:"Number that reflects the performance of the learner for the objective";s:26:"cmi.objectives.n.score.raw";s:130:"Number that reflects the performance of the learner, for the objective, relative to the range bounded by the values of min and max";s:26:"cmi.objectives.n.score.min";s:64:"Minimum value, for the objective, in the range for the raw score";s:26:"cmi.objectives.n.score.max";s:64:"Maximum value, for the objective, in the range for the raw score";s:31:"cmi.objectives.n.success_status";s:56:"Indicates whether the learner has mastered the objective";s:34:"cmi.objectives.n.completion_status";s:68:"Indicates whether the learner has completed the associated objective";s:33:"cmi.objectives.n.progress_measure";s:76:"Measure of the progress the learner has made toward completing the objective";s:28:"cmi.objectives.n.description";s:57:"Provides a brief informative description of the objective";s:20:"cmi.progress_measure";s:70:"Measure of the progress the learner has made toward completing the SCO";s:24:"cmi.scaled_passing_score";s:47:"Scaled passing score required to master the SCO";s:19:"cmi.score._children";s:40:"Listing of supported data model elements";s:16:"cmi.score.scaled";s:51:"Number that reflects the performance of the learner";s:13:"cmi.score.raw";s:110:"Number that reflects the performance of the learner relative to the range bounded by the values of min and max";s:13:"cmi.score.min";s:44:"Minimum value in the range for the raw score";s:13:"cmi.score.max";s:44:"Maximum value in the range for the raw score";s:16:"cmi.session_time";s:85:"Amount of time that the learner has spent in the current learner session for this SCO";s:18:"cmi.success_status";s:50:"Indicates whether the learner has mastered the SCO";s:16:"cmi.suspend_data";s:66:"Provides space to store and retrieve data between learner sessions";s:21:"cmi.time_limit_action";s:70:"Indicates what the SCO should do when cmi.max_time_allowed is exceeded";s:14:"cmi.total_time";s:84:"Sum of all of the learner\'s session times accumulated in the current learner attempt";s:15:"adl.nav.request";s:68:"Navigation request to be processed immediately following Terminate()";s:30:"adl.nav.request_valid.continue";s:73:"Used by a SCO to determine if a Continue navigation request will succeed.";s:30:"adl.nav.request_valid.previous";s:73:"Used by a SCO to determine if a Previous navigation request will succeed.";s:28:"adl.nav.request_valid.choice";s:97:"Used by a SCO to determine if a Choice navigation request for a particular activity will succeed.";s:7:"i_green";s:11:"green: okay";s:5:"i_red";s:11:"red: error!";s:8:"i_orange";s:25:"orange: attention please!";s:6:"i_gray";s:30:"gray: error corrected by ILIAS";s:9:"i_fuchsia";s:59:"fuchsia: tolerated value because sent value is not rejected";s:5:"error";s:5:"error";s:13:"strange_error";s:13:"strange error";s:16:"strange_API-Call";s:16:"strange API-Call";s:7:"unknown";s:7:"unknown";s:15:"undefined_color";s:15:"undefined color";s:15:"description_for";s:15:"description for";s:4:"hide";s:4:"hide";s:19:"all_API-calls_shown";s:34:"All API-calls are currently shown.";s:29:"show_only_important_API-calls";s:30:"Show only important API-calls!";s:30:"only_important_API-Calls_shown";s:45:"Only important API-Calls are currently shown.";s:18:"show_all_API-calls";s:19:"Show all API-calls!";s:7:"log_for";s:27:"Log for the learning module";s:7:"started";s:7:"started";s:10:"nr_session";s:17:"number of session";s:18:"id_learning_module";s:25:"ID of the learning module";s:23:"sent_values_not_checked";s:59:"selected property: values sent by SCO are not fully checked";s:9:"SCO-title";s:9:"SCO-title";s:8:"SCO-name";s:8:"SCO-name";s:12:"milliseconds";s:12:"milliseconds";s:8:"API-call";s:8:"API-call";s:12:"return_value";s:12:"return value";s:9:"generated";s:9:"generated";s:7:"comment";s:7:"Comment";s:28:"summary_for_SCO_without_test";s:32:"Summary for a SCO without a test";s:25:"summary_for_SCO_with_test";s:29:"Summary for a SCO with a test";s:20:"no_missing_API-calls";s:42:"Missing API-calls had not been recognized.";s:17:"missing_API-calls";s:28:"These API-calls are missing:";s:11:"summary_csv";s:63:"Summary is generated as CSV-file to import for example in Excel";s:16:"summary_download";s:75:"You can click to ‘Logs’ and download it when you start this tool again.";s:19:"debugwindow_console";s:7:"Console";s:16:"debugwindow_logs";s:4:"Logs";s:19:"debugwindow_comment";s:7:"comment";s:25:"debugwindow_comment_enter";s:25:"Please enter your comment";s:27:"debugwindow_start_recording";s:15:"Start Recording";s:26:"debugwindow_stop_recording";s:14:"Stop Recording";s:26:"debugwindow_delete_logfile";s:14:"Delete logfile";s:29:"debugwindow_submission_failed";s:17:"Submission failed";s:18:"debugwindow_submit";s:6:"Submit";s:18:"debugwindow_cancel";s:6:"Cancel";s:20:"debugwindow_filename";s:9:"File Name";s:16:"debugwindow_date";s:4:"Date";s:18:"debugwindow_action";s:6:"Action";s:18:"debugwindow_delete";s:6:"Delete";s:20:"debugwindow_download";s:8:"Download";s:16:"debugwindow_open";s:4:"Open";s:26:"debugwindow_password_enter";s:26:"Please enter your password";s:24:"scormdebug_disable_cache";s:32:"Disable SCORM 2004 Browser Cache";s:29:"scormdebug_disable_cache_info";s:137:"This prevents the storage of the SCORM 2004 javascript files in the browser cache. Please use this function in time before a new release!";s:37:"completion_status_by_progress_measure";s:271:"Because there is a value for cmi.completion_threshold, the value for cmi.completion_status is evaluated by the LMS! This is done by comparing the value for cmi.completion_threshold with the value for cmi.progress_measure. The value for cmi.completion_status is currently:";s:30:"success_status_by_score_scaled";s:261:"Because there is a value for cmi.scaled_passing_score, the value for cmi.success_status is evaluated by the LMS! This is done by comparing the value for cmi.scaled_passing_score with the value for cmi.score.scaled. The value for cmi.success_status is currently:";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'tax'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:23:{s:12:"tax_taxonomy";s:8:"Taxonomy";s:8:"obj_taxn";s:4:"Node";s:8:"tax_node";s:4:"Node";s:9:"tax_nodes";s:5:"Nodes";s:15:"tax_create_node";s:11:"Create Node";s:16:"tax_new_tax_node";s:8:"New Node";s:9:"tax_order";s:5:"Order";s:11:"tax_sorting";s:7:"Sorting";s:16:"tax_alphabetical";s:12:"Alphabetical";s:10:"tax_manual";s:6:"Manual";s:12:"tax_order_nr";s:8:"Order Nr";s:23:"tax_target_within_nodes";s:56:"The target must not be a sub-node of the selected items.";s:24:"tax_please_select_target";s:25:"Please select the target.";s:19:"tax_delete_taxonomy";s:15:"Delete Taxonomy";s:20:"tax_confirm_deletion";s:70:"Do you really want to delete the whole taxonomy and all its relations?";s:15:"tax_tax_deleted";s:30:"The taxonomy has been deleted.";s:16:"tax_add_taxonomy";s:12:"Add Taxonomy";s:9:"tax_added";s:26:"Taxonomy has been created.";s:15:"tax_max_one_tax";s:49:"You can use maximum one taxonomy in this context.";s:16:"tax_node_sorting";s:16:"Sorting of Nodes";s:16:"tax_item_sorting";s:33:"Support Sorting of Assigned Items";s:18:"tax_assigned_items";s:14:"Assigned Items";s:29:"tax_admin_settings_repository";s:21:"Repository Taxonomies";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'help'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:18:{s:13:"help_tooltips";s:13:"Help Tooltips";s:15:"help_tooltip_id";s:10:"Tooltip ID";s:12:"help_tt_text";s:4:"Text";s:8:"help_all";s:3:"All";s:14:"help_component";s:9:"Component";s:11:"help_filter";s:6:"Filter";s:21:"help_open_online_help";s:16:"Open Online Help";s:20:"help_toggle_tooltips";s:20:"Toggle Help Tooltips";s:14:"help_help_file";s:17:"Help Package File";s:12:"help_modules";s:13:"Help Packages";s:29:"help_sure_delete_help_modules";s:51:"Are you sure that these packages should be deleted?";s:20:"help_module_uploaded";s:22:"Help package uploaded.";s:16:"help_imported_on";s:11:"Imported on";s:22:"help_tooltips_and_help";s:26:"Tooltips and Workflow Help";s:14:"help_help_only";s:18:"Workflow Help Only";s:18:"help_tooltips_only";s:13:"Tooltips Only";s:13:"help_set_mode";s:8:"Set Mode";s:11:"help_topcis";s:6:"Topics";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'dcl'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:200:{s:10:"dcl_record";s:5:"Entry";s:9:"dcl_hello";s:4:"Dear";s:7:"dcl_new";s:26:"Create New Data Collection";s:7:"dcl_add";s:22:"Create Data Collection";s:8:"dcl_copy";s:20:"Copy Data Collection";s:8:"dcl_edit";s:20:"Edit Data Collection";s:10:"dcl_import";s:22:"Import Data Collection";s:13:"dcl_in_export";s:9:"In Export";s:30:"dcl_field_title_change_warning";s:157:"You changed the title of the field hence some placeholders in the view definition might be broken. Those have to be fixed manually should the occasion arise.";s:31:"dcl_err_formula_field_not_found";s:31:"Field with title \'%s\' not found";s:13:"dcl_edit_type";s:9:"Edit Type";s:19:"dcl_activate_rating";s:21:"Activate Entry Rating";s:21:"dcl_activate_approval";s:23:"Activate Entry Approval";s:25:"dcl_activate_notification";s:21:"Activate Notification";s:22:"dcl_allowed_file_types";s:18:"Allowed File Types";s:12:"dcl_table_id";s:8:"Table ID";s:18:"dcl_add_new_record";s:13:"Add New Entry";s:15:"dcl_list_fields";s:6:"Fields";s:30:"dcl_record_view_viewdefinition";s:18:"Edit Detailed View";s:30:"dcl_record_edit_viewdefinition";s:18:"Edit Detailed View";s:30:"dcl_record_list_viewdefinition";s:19:"List Detailed Views";s:17:"dcl_add_new_field";s:13:"Add New Field";s:17:"dcl_add_new_table";s:13:"Add New Table";s:18:"dcl_field_datatype";s:15:"Field Data Type";s:12:"dcl_required";s:14:"Required Field";s:17:"dcl_edit_type_non";s:12:"Not editable";s:22:"dcl_edit_type_non_info";s:51:"Creating New Entries needs edit settings permission";s:19:"dcl_edit_type_unlim";s:9:"Unlimited";s:24:"dcl_edit_type_unlim_info";s:51:"Users with add/edit permission can add/edit entries";s:17:"dcl_edit_type_lim";s:7:"Limited";s:22:"dcl_edit_type_lim_info";s:80:"Access for users with add/edit permission is limited to the following date range";s:14:"dcl_edit_start";s:10:"Start-Date";s:12:"dcl_edit_end";s:8:"End-Date";s:10:"dcl_export";s:6:"Export";s:21:"dcl_table_list_fields";s:24:"Fields Of Selected Table";s:23:"dcl_view_viewdefinition";s:13:"Detailed View";s:13:"dcl_new_table";s:9:"New Table";s:16:"dcl_table_create";s:12:"Create Table";s:14:"dcl_table_edit";s:12:"Update Table";s:13:"dcl_new_field";s:9:"New Field";s:12:"dcl_datatype";s:8:"Datatype";s:11:"dcl_integer";s:7:"Integer";s:8:"dcl_text";s:4:"Text";s:13:"dcl_reference";s:9:"Reference";s:11:"dcl_boolean";s:7:"Boolean";s:12:"dcl_datetime";s:8:"Datetime";s:8:"dcl_file";s:10:"Fileupload";s:21:"dcl_field_description";s:11:"Description";s:18:"dcl_field_required";s:8:"Required";s:10:"dcl_length";s:6:"Length";s:15:"dcl_length_info";s:67:"(for more than 200 characters, use the additional option Text Area)";s:9:"dcl_regex";s:18:"Regular Expression";s:14:"dcl_regex_info";s:19:"(without delimiter)";s:10:"dcl_filter";s:6:"Filter";s:19:"dcl_max_text_length";s:14:"Maximum Length";s:16:"dcl_wrong_length";s:32:"The text you entered is to long.";s:15:"dcl_wrong_regex";s:90:"The text you entered does not match the specification for this field (Regular Expression).";s:20:"dcl_wrong_input_type";s:68:"The value you entered does not match the specification (Wrong Type).";s:10:"dcl_unique";s:6:"Unique";s:20:"dcl_unique_exception";s:56:"The value you entered is already taken by another Entry.";s:21:"dcl_unknown_exception";s:35:"The value you entered is not valid.";s:11:"dcl_checked";s:8:"Checked.";s:15:"dcl_not_checked";s:12:"Not checked.";s:7:"dcl_any";s:3:"Any";s:20:"dcl_noturl_exception";s:70:"You have to enter a Link (beginning with http://) or an email address.";s:31:"dcl_no_search_results_found_for";s:30:"No modules have been found for";s:18:"dcl_export_enabled";s:35:"Allow export function for all users";s:17:"dcl_no_fields_yet";s:82:"There are no fields defined for this table thus you cannot create any entries yet.";s:17:"dcl_create_fields";s:62:"Please create at least one field in the tab ‘List Fields’.";s:19:"dcl_inconsistent_at";s:66:"The Data Collection is inconsistent. A reference no longer exists.";s:11:"dcl_actions";s:7:"Actions";s:22:"dcl_export_table_excel";s:11:"Export .xls";s:35:"dcl_no_exportable_fields_or_no_data";s:49:"No exportable fields defined or no data available";s:18:"dcl_owner_editable";s:21:"Edit only own Etnries";s:9:"dcl_order";s:5:"Order";s:9:"dcl_title";s:11:"Field Title";s:15:"dcl_description";s:17:"Field Description";s:21:"dcl_msg_table_created";s:13:"Table created";s:8:"dcl_save";s:10:"Save Table";s:18:"dcl_record_deleted";s:13:"Entry deleted";s:25:"dcl_confirm_delete_record";s:18:"Delete this Entry?";s:15:"dcl_edit_record";s:10:"Edit Entry";s:17:"dcl_update_record";s:12:"Update Entry";s:14:"dcl_edit_field";s:10:"Edit Field";s:16:"dcl_update_field";s:12:"Update Field";s:16:"dcl_create_field";s:12:"Create Field";s:22:"dcl_msg_field_modified";s:13:"Field updated";s:31:"dcl_change_notification_subject";s:37:"Data Collection "%s" has been changed";s:21:"dcl_edit_notification";s:28:"Email Notification on Change";s:26:"dcl_edit_notification_info";s:45:"You will be notified when any table is edited";s:28:"dcl_change_notification_link";s:27:"Link to the Data Collection";s:38:"dcl_change_notification_dcl_new_record";s:36:"The following Entry has been created";s:41:"dcl_change_notification_dcl_update_record";s:36:"The following Entry has been updated";s:41:"dcl_change_notification_dcl_delete_record";s:41:"The following Entry page has been deleted";s:37:"dcl_change_why_you_receive_this_email";s:96:"You receive this message because you have activated the notification about this data collection.";s:9:"dcl_table";s:5:"Table";s:14:"dcl_changed_by";s:10:"Changed by";s:29:"dcl_notification_activate_dcl";s:41:"Activate Notification for Data Collection";s:31:"dcl_notification_deactivate_dcl";s:43:"Deactivate Notification for Data Collection";s:26:"dcl_notification_activated";s:22:"Notification Activated";s:28:"dcl_notification_deactivated";s:24:"Notification Deactivated";s:10:"dcl_locked";s:6:"Locked";s:18:"dcl_locked_tooltip";s:96:"Disable this field for users to edit. Does not include roles with the permission \'Edit Settings\'";s:18:"dcl_table_settings";s:14:"Table Settings";s:12:"dcl_add_perm";s:20:"User can add entries";s:13:"dcl_edit_perm";s:21:"User can edit entries";s:15:"dcl_delete_perm";s:23:"User can delete entries";s:17:"dcl_edit_by_owner";s:30:"Edit / Delete only own entries";s:11:"dcl_limited";s:34:"Limited Add / Edit / Delete Period";s:13:"dcl_record_id";s:8:"Entry ID";s:15:"dcl_limit_start";s:5:"Start";s:13:"dcl_limit_end";s:3:"End";s:7:"dcl_url";s:12:"URL or Email";s:14:"dcl_edit_table";s:19:"Edit Table Settings";s:20:"dcl_msg_table_edited";s:20:"Table Settings saved";s:23:"dcl_legend_placeholders";s:12:"Placeholders";s:10:"dcl_rating";s:6:"Rating";s:25:"dcl_editable_in_table_gui";s:30:"Please vote in the table view.";s:24:"dcl_table_settings_saved";s:31:"Table Settings have been saved.";s:19:"dcl_ILIAS_reference";s:23:"Link to an ILIAS module";s:21:"dcl_learning_progress";s:61:"Show the learning progress of the linked module of the viewer";s:10:"dcl_status";s:11:"Your Status";s:7:"dcl_mob";s:12:"Media Object";s:9:"dcl_width";s:5:"Width";s:10:"dcl_height";s:6:"Height";s:22:"dcl_notimage_exception";s:29:"The file has to be a picture.";s:11:"dcl_formula";s:7:"Formula";s:19:"dcl_prop_expression";s:10:"Expression";s:24:"dcl_prop_expression_info";s:358:"Supported operators: <b>%s</b><br>Supported functions: <b>%s</b><br>Use brackets <b>‘(’, ‘)’</b> to group calculations.<br>Concatenate strings and placeholders with &: <b>‘The result is ’ & [[Int 1]] * [[Int2]]</b><br>Using functions: <b>SUM([[Int 1]];[[Int 2]])</b><br><br>Available fields (click on title to copy field inside expression):<br>%s";s:28:"dcl_error_parsing_expression";s:24:"Error parsing expression";s:23:"dcl_display_action_menu";s:56:"Enable possibility to copy or link the referenced module";s:18:"dcl_reference_link";s:26:"Show as link in table view";s:24:"dcl_ILIAS_reference_link";s:26:"Show as link in table view";s:13:"dcl_text_area";s:8:"Textarea";s:16:"dcl_delete_table";s:12:"Delete Table";s:14:"dcl_table_info";s:267:"Users with the permission ‘edit settings’ (see tab ‘Permission’) always have permission to add/edit/delete entries. Users with permission ‘edit entry’ (see tab ‘Permissions’) only have permissions according to the settings specified in the form below.";s:24:"dcl_confirm_delete_table";s:72:"Do you really want to delete this table with it\'s content and structure?";s:26:"dcl_cant_delete_main_table";s:138:"You can\'t completely remove this table as it is the default table of this Data Collection. It\'s content and structure got removed instead.";s:22:"dcl_no_content_warning";s:71:"Attention, the Data Collection is online but does not have content yet!";s:11:"dcl_visible";s:21:"Visible for all users";s:14:"dcl_empty_view";s:16:"Delete this View";s:17:"dcl_activate_view";s:18:"Activate this view";s:19:"dcl_deactivate_view";s:20:"Deactivate this view";s:24:"dcl_confirm_delete_field";s:40:"Do you really want to delete this field?";s:20:"dcl_table_info_title";s:4:"Info";s:29:"dcl_confirm_delete_view_title";s:39:"Do you really want to delete this view?";s:28:"dcl_confirm_delete_view_text";s:129:"The View Definition of entries of this table will be removed irreversibly, the entries and fields themselves will not be changed.";s:22:"dcl_empty_view_success";s:50:"The View Definition has been deleted successfully.";s:20:"dcl_permissions_form";s:12:"User actions";s:15:"dcl_no_warnings";s:39:"The import terminated with no warnings.";s:27:"dcl_not_supported_in_import";s:49:"This type of field is not supported in the import";s:21:"dcl_no_such_reference";s:60:"The following value is not available in the reference table:";s:21:"dcl_file_not_readable";s:67:"The file could not be read. Please make sure to upload an XLS file.";s:21:"dcl_import_terminated";s:36:"The import terminated. Entries added";s:14:"dcl_max_import";s:50:"The maximum amount of imported entries is reached.";s:17:"dcl_row_not_found";s:45:" - This field couldn\'t be found in the table.";s:23:"dcl_import_records .xls";s:11:"Import .xls";s:27:"dcl_file_format_description";s:302:"The file needs to be an excel .XLS file with the data you want to import on the first sheet. In the first row there have to be exactly the names of the fields (case sensitive) you want to import and in the following rows you can add the values. It is strongly recommended to simulate your import first.";s:19:"dcl_simulate_import";s:15:"Simulate Import";s:17:"dcl_simulate_info";s:177:"Simulating the import will not add any fields into the Data Collection but may give you feedback on problems with the import file, thus helping you to prevent corrupted entries.";s:22:"dcl_multiple_selection";s:18:"Multiple Selection";s:22:"dcl_field_title_unique";s:67:"There exists already a field with this title. Title must be unique.";s:22:"dcl_table_title_unique";s:67:"There exists already a table with this title. Title must be unique.";s:17:"dcl_please_select";s:21:"--- Please select ---";s:7:"dcl_asc";s:21:"Ascending Order (ASC)";s:8:"dcl_desc";s:23:"Descending Order (DESC)";s:12:"dcl_comments";s:8:"Comments";s:24:"dcl_comments_description";s:44:"Displays the number of comments for a Entry.";s:25:"dcl_confirm_delete_fields";s:42:"Do you really want to delete these fields?";s:22:"dcl_msg_fields_deleted";s:14:"Deleted fields";s:6:"dcl_id";s:2:"ID";s:18:"dcl_id_description";s:16:"The internal ID.";s:17:"dcl_creation_date";s:13:"Creation Date";s:29:"dcl_creation_date_description";s:40:"The date on which the entry was created.";s:15:"dcl_last_update";s:11:"Last Edited";s:27:"dcl_last_update_description";s:35:"The date the entry was last edited.";s:9:"dcl_owner";s:5:"Owner";s:21:"dcl_owner_description";s:23:"The owner of the entry.";s:18:"dcl_last_edited_by";s:14:"Last edited by";s:30:"dcl_last_edited_by_description";s:37:"The user that edited this entry last.";s:19:"dcl_public_comments";s:34:"Enable public comments for Entries";s:22:"dcl_default_sort_field";s:18:"Default sort field";s:28:"dcl_default_sort_field_order";s:24:"Default sort field order";s:15:"dcl_prev_record";s:14:"Previous Entry";s:15:"dcl_next_record";s:10:"Next Entry";s:21:"dcl_record_from_total";s:8:"%d of %d";s:25:"dcl_view_own_records_perm";s:21:"View only own entries";s:20:"dcl_msg_no_perm_view";s:38:"No permission given to view this Entry";s:20:"dcl_msg_no_perm_edit";s:38:"No permission given to edit this Entry";s:17:"dcl_delete_fields";s:13:"Delete fields";s:20:"dcl_link_detail_page";s:27:"Link entries to detail page";s:10:"dcl_manage";s:6:"Manage";s:18:"dcl_delete_records";s:14:"Delete Entries";s:26:"dcl_confirm_delete_records";s:54:"Are you sure you want to delete the following Entries?";s:19:"dcl_deleted_records";s:31:"Successfully deleted %s Entries";s:26:"dcl_skipped_delete_records";s:54:"%s Entries were not deleted due to permission settings";s:22:"fieldtitle_allow_chars";s:17:"Allowed chars: %s";s:9:"add_value";s:13:"Add New Entry";s:15:"dcl_online_info";s:81:"Only if the Data Collection is online, users are able to use the Data Collection.";s:21:"dcl_notification_info";s:54:"Enables the individual notification feature for users.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'poll'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:72:{s:8:"poll_new";s:12:"Add New Poll";s:8:"poll_add";s:8:"Add Poll";s:9:"poll_copy";s:9:"Copy Poll";s:9:"poll_edit";s:9:"Edit Poll";s:13:"poll_question";s:8:"Question";s:10:"poll_image";s:5:"Image";s:17:"poll_view_results";s:15:"Display Results";s:24:"poll_view_results_always";s:6:"Always";s:23:"poll_view_results_never";s:5:"Never";s:28:"poll_view_results_after_vote";s:10:"After Vote";s:30:"poll_view_results_after_period";s:19:"After Voting Period";s:27:"poll_activation_online_info";s:59:"Activate this setting to make the poll accessible to users.";s:32:"poll_availability_limitless_info";s:57:"Choose this mode for making the poll available limitless.";s:28:"poll_availability_until_info";s:74:"Choose this mode for making the poll available for a fixed period of time.";s:39:"poll_activation_limited_visibility_info";s:70:"If chosen, the poll is visible even outside of the given availability.";s:15:"poll_add_answer";s:10:"Add Answer";s:11:"poll_answer";s:6:"Answer";s:12:"poll_answers";s:16:"Possible Answers";s:14:"poll_sortorder";s:5:"Order";s:15:"poll_percentage";s:18:"Current Percentage";s:17:"poll_update_order";s:12:"Update Order";s:16:"poll_edit_answer";s:11:"Edit Answer";s:21:"poll_info_delete_sure";s:59:"Are you sure that you want to delete the following answers?";s:9:"poll_vote";s:4:"Vote";s:26:"poll_block_message_offline";s:21:"This poll is offline.";s:27:"poll_block_message_inactive";s:36:"This poll will be available from %s.";s:32:"poll_block_message_already_voted";s:31:"You already voted in this poll.";s:29:"poll_block_message_no_answers";s:24:"This poll is incomplete.";s:19:"poll_active_no_edit";s:51:"This poll is currently active and cannot be edited.";s:18:"poll_votes_no_edit";s:88:"This poll already contains votes. You cannot edit the poll until you delete these votes.";s:15:"poll_population";s:8:"%s Votes";s:17:"poll_participants";s:12:"Participants";s:17:"poll_delete_votes";s:16:"Delete All Votes";s:22:"poll_delete_votes_sure";s:42:"Are you sure you want to delete all votes?";s:30:"poll_voting_period_and_results";s:25:"Voting Period and Results";s:18:"poll_voting_period";s:13:"Voting Period";s:28:"poll_voting_period_unlimited";s:9:"Unlimited";s:26:"poll_voting_period_limited";s:21:"Limited Voting Period";s:24:"poll_voting_period_start";s:10:"Start Time";s:22:"poll_voting_period_end";s:11:"Finish Time";s:13:"poll_absolute";s:13:"Current Votes";s:31:"poll_block_results_available_on";s:36:"The results will be available on %s.";s:11:"poll_import";s:11:"Import Poll";s:11:"poll_result";s:7:"Results";s:23:"poll_voting_period_info";s:23:"Deadline for Voting: %s";s:26:"poll_max_number_of_answers";s:41:"Maximum Number Of Answers per Participant";s:22:"poll_vote_error_single";s:23:"Please select 1 answer.";s:21:"poll_vote_error_multi";s:38:"Please select no more than %s answers.";s:19:"poll_result_sorting";s:7:"Sorting";s:27:"poll_result_sorting_answers";s:27:"In the order of the answers";s:25:"poll_result_sorting_votes";s:31:"By number of votes (descending)";s:9:"poll_mode";s:4:"Mode";s:19:"poll_mode_anonymous";s:9:"Anonymous";s:24:"poll_mode_anonymous_info";s:44:"Votes cannot be traced back to participants.";s:18:"poll_mode_personal";s:8:"Personal";s:23:"poll_mode_personal_info";s:98:"A list of participants with their respective votes is available when having sufficient permission.";s:26:"poll_non_anonymous_warning";s:65:"Your name and vote are visible for administrators in the results.";s:19:"poll_result_answers";s:5:"Votes";s:17:"poll_result_users";s:12:"Participants";s:27:"poll_notification_subscribe";s:21:"Activate Notification";s:29:"poll_notification_unsubscribe";s:23:"Deactivate Notification";s:30:"poll_vote_notification_subject";s:19:"Poll "%s": new vote";s:27:"poll_vote_notification_body";s:39:"the following poll has received a vote.";s:27:"poll_vote_notification_link";s:12:"Link to Poll";s:29:"poll_vote_notification_reason";s:94:"You are receiving this email because you activated notifications for the poll mentioned above.";s:13:"poll_comments";s:8:"Comments";s:20:"poll_show_results_as";s:15:"Show Results as";s:13:"poll_barchart";s:9:"Bar Chart";s:13:"poll_piechart";s:9:"Pie Chart";s:18:"poll_comments_info";s:50:"Deactivating Comments doesn\'t delete any Comments.";s:22:"poll_anonymous_warning";s:45:"Your name is not visible in the poll results.";s:41:"poll_view_results_after_period_impossible";s:33:"The voting period is not limited.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'tos'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:21:{s:19:"tos_last_reset_date";s:43:"The terms of service have been reset on %s.";s:20:"tos_agreement_by_lng";s:16:"Terms of Service";s:13:"tos_agreement";s:16:"Terms of Service";s:20:"tos_agreement_exists";s:8:"Existent";s:21:"tos_agreement_missing";s:7:"Missing";s:22:"tos_agreement_document";s:8:"Document";s:30:"tos_agreement_document_missing";s:7:"Missing";s:16:"tos_tos_settings";s:8:"Settings";s:17:"tos_status_enable";s:6:"Enable";s:15:"tos_status_desc";s:90:"If activated, users are forced to accept the terms of service before they can enter ILIAS.";s:27:"tos_reset_tos_for_all_users";s:22:"Reset Terms of Service";s:18:"tos_sure_reset_tos";s:187:"Are you sure you want to reset the terms of service for all users in system? This also applies to those accounts that are used for the SOAP web services, the chat server, or the cron job.";s:21:"tos_reset_successfull";s:50:"The terms of service have been reset successfully.";s:17:"tos_last_modified";s:11:"Last Change";s:22:"tos_acceptance_history";s:18:"Acceptance History";s:10:"tos_period";s:6:"Period";s:15:"tos_period_from";s:4:"From";s:16:"tos_period_until";s:5:"Until";s:23:"tos_acceptance_datetime";s:4:"Date";s:22:"tos_no_documents_exist";s:75:"Currently there are no terms of service for any of the installed languages.";s:32:"tos_no_documents_exist_cant_save";s:144:"Currently there are no terms of service for any of the installed languages. Please add at least one document for any of the installed languages.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'cron'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:46:{s:11:"cron_job_id";s:2:"Id";s:14:"cron_component";s:9:"Component";s:13:"cron_schedule";s:8:"Schedule";s:11:"cron_status";s:6:"Status";s:16:"cron_status_info";s:11:"Status Info";s:11:"cron_result";s:6:"Result";s:16:"cron_result_info";s:11:"Result Info";s:13:"cron_last_run";s:8:"Last Run";s:40:"cron_result_status_invalid_configuration";s:21:"Invalid Configuration";s:28:"cron_result_status_no_action";s:17:"Ok, no processing";s:21:"cron_result_status_ok";s:2:"Ok";s:26:"cron_result_status_crashed";s:7:"Crashed";s:24:"cron_result_status_reset";s:5:"Reset";s:20:"cron_action_activate";s:8:"Activate";s:22:"cron_action_deactivate";s:10:"Deactivate";s:17:"cron_action_reset";s:5:"Reset";s:16:"cron_action_edit";s:4:"Edit";s:18:"cron_status_active";s:6:"Active";s:20:"cron_status_inactive";s:8:"Inactive";s:19:"cron_schedule_daily";s:5:"Daily";s:20:"cron_schedule_weekly";s:6:"Weekly";s:21:"cron_schedule_monthly";s:7:"Monthly";s:23:"cron_schedule_quarterly";s:9:"Quarterly";s:20:"cron_schedule_yearly";s:6:"Yearly";s:24:"cron_schedule_in_minutes";s:16:"Every %s minutes";s:22:"cron_schedule_in_hours";s:14:"Every %s hours";s:21:"cron_schedule_in_days";s:13:"Every %s days";s:18:"cron_schedule_type";s:8:"Schedule";s:19:"cron_schedule_value";s:8:"Interval";s:23:"cron_changed_by_crontab";s:6:"SYSTEM";s:18:"cron_running_since";s:13:"Running since";s:15:"cron_action_run";s:7:"Execute";s:20:"cron_action_run_sure";s:47:"Are you sure you want to run the cron-job "%s"?";s:25:"cron_action_activate_sure";s:52:"Are you sure you want to activate the cron-job "%s"?";s:27:"cron_action_deactivate_sure";s:54:"Are you sure you want to deactivate the cron-job "%s"?";s:22:"cron_action_reset_sure";s:49:"Are you sure you want to reset the cron-job "%s"?";s:23:"cron_action_run_success";s:26:"Cron-Job run successfully.";s:20:"cron_action_run_fail";s:16:"Cron-Job failed.";s:28:"cron_action_activate_success";s:19:"Cron-Job activated.";s:30:"cron_action_deactivate_success";s:21:"Cron-Job deactivated.";s:25:"cron_action_reset_success";s:15:"Cron-Job reset.";s:24:"cron_action_edit_success";s:17:"Schedule updated.";s:31:"cron_no_executable_job_selected";s:47:"Please select at least one executable cron-job.";s:31:"cron_action_activate_sure_multi";s:58:"Are you sure you want to activate the following cron-jobs?";s:33:"cron_action_deactivate_sure_multi";s:60:"Are you sure you want to deactivate the following cron-jobs?";s:23:"cron_result_status_fail";s:6:"Failed";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'bibl'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:114:{s:8:"bibl_new";s:16:"New Bibliography";s:16:"bibl_link_online";s:16:"Lookup inventory";s:8:"bibl_add";s:16:"Add Bibliography";s:11:"bibl_import";s:19:"Import Bibliography";s:22:"download_original_file";s:22:"Download Original File";s:4:"Type";s:4:"Type";s:16:"override_entries";s:16:"Override Entries";s:9:"bibl_edit";s:17:"Edit Bibliography";s:17:"bibliography file";s:17:"Bibliography File";s:18:"obj_bibl_duplicate";s:22:"Duplicate Bibliography";s:11:"detail_view";s:11:"Detail View";s:19:"bibl_admin_settings";s:8:"Settings";s:23:"bibl_settings_libraries";s:9:"Libraries";s:17:"bibl_library_name";s:4:"Name";s:16:"bibl_library_url";s:8:"Base-URL";s:16:"bibl_library_img";s:9:"Image-URL";s:17:"bibl_settings_new";s:11:"Add Library";s:18:"bibl_settings_edit";s:12:"Edit Library";s:9:"libraries";s:9:"Libraries";s:10:"attr_order";s:15:"Attribute-Order";s:17:"attr_order_bibtex";s:24:"Attribute Order (Bibtex)";s:22:"attr_order_bibtex_info";s:24:"default: isbn,issn,title";s:14:"attr_order_ris";s:21:"Attribute Order (ris)";s:19:"attr_order_ris_info";s:18:"default: sn,ti, t1";s:18:"news_title_created";s:27:"New bibliography list added";s:20:"news_content_created";s:98:"A new bibliography list has been added. You can view the entries by clicking the link to the item.";s:18:"news_title_updated";s:25:"Bibliography list updated";s:20:"news_content_updated";s:103:"The bibliography list has been modified. You can view the new entries by clicking the link to the item.";s:9:"bibl_copy";s:17:"Copy Bibliography";s:19:"bib_default_address";s:7:"Address";s:18:"bib_default_author";s:6:"Author";s:21:"bib_default_booktitle";s:5:"Title";s:19:"bib_default_chapter";s:7:"Chapter";s:19:"bib_default_edition";s:7:"Edition";s:18:"bib_default_editor";s:6:"Editor";s:23:"bib_default_institution";s:11:"Institution";s:19:"bib_default_journal";s:7:"Journal";s:18:"bib_default_number";s:6:"Number";s:24:"bib_default_organization";s:12:"Organization";s:17:"bib_default_pages";s:5:"Pages";s:21:"bib_default_publisher";s:9:"Publisher";s:17:"bib_default_title";s:5:"Title";s:16:"bib_default_type";s:4:"Type";s:18:"bib_default_volume";s:6:"Volume";s:16:"bib_default_year";s:4:"Year";s:18:"bib_default_school";s:6:"School";s:15:"bib_default_url";s:3:"URL";s:20:"bib_default_crossref";s:15:"Cross Reference";s:20:"bib_default_keywords";s:8:"Keywords";s:16:"bib_default_isbn";s:9:"ISSN/ISBN";s:19:"bib_default_urldate";s:17:"Date of URL visit";s:20:"bib_default_language";s:8:"Language";s:18:"bib_default_series";s:6:"Series";s:16:"bib_default_cite";s:8:"Bib Cite";s:16:"bib_default_note";s:4:"Note";s:24:"bib_default_howpublished";s:12:"Published as";s:15:"bib_default_key";s:3:"Key";s:17:"bib_default_month";s:5:"Month";s:20:"bib_default_abstract";s:8:"Abstract";s:14:"ris_default_ty";s:4:"Type";s:14:"ris_default_id";s:12:"Reference ID";s:14:"ris_default_t1";s:5:"Title";s:14:"ris_default_ti";s:10:"Book title";s:14:"ris_default_ct";s:30:"Title of unpublished reference";s:14:"ris_default_a1";s:14:"Primary author";s:14:"ris_default_a2";s:16:"Secondary author";s:14:"ris_default_au";s:6:"Author";s:14:"ris_default_y1";s:12:"Primary date";s:14:"ris_default_py";s:16:"Publication year";s:14:"ris_default_n1";s:5:"Notes";s:14:"ris_default_kw";s:8:"Keywords";s:14:"ris_default_rp";s:14:"Reprint status";s:14:"ris_default_sp";s:10:"Start page";s:14:"ris_default_ep";s:11:"Ending page";s:14:"ris_default_jf";s:20:"Periodical full name";s:14:"ris_default_jo";s:32:"Periodical standard abbreviation";s:14:"ris_default_ja";s:41:"Periodical in which article was published";s:14:"ris_default_j1";s:37:"Periodical name - User abbreviation 1";s:14:"ris_default_j2";s:37:"Periodical name - User abbreviation 2";s:14:"ris_default_vl";s:6:"Volume";s:14:"ris_default_is";s:5:"Issue";s:14:"ris_default_t2";s:15:"Title secondary";s:14:"ris_default_cy";s:19:"City of Publication";s:14:"ris_default_pb";s:9:"Publisher";s:14:"ris_default_u1";s:6:"User 1";s:14:"ris_default_u2";s:6:"User 2";s:14:"ris_default_u3";s:6:"User 3";s:14:"ris_default_u4";s:6:"User 4";s:14:"ris_default_u5";s:6:"User 5";s:14:"ris_default_t3";s:12:"Title series";s:14:"ris_default_n2";s:8:"Abstract";s:14:"ris_default_sn";s:14:"ISSN/ISBN/ASIN";s:14:"ris_default_av";s:12:"Availability";s:14:"ris_default_m1";s:7:"Misc. 1";s:14:"ris_default_m2";s:7:"Misc. 2";s:14:"ris_default_m3";s:7:"Misc. 3";s:14:"ris_default_ad";s:7:"Address";s:14:"ris_default_ur";s:3:"URL";s:14:"ris_default_l1";s:11:"Link to PDF";s:14:"ris_default_l2";s:17:"Link to Full-text";s:14:"ris_default_l3";s:15:"Related records";s:14:"ris_default_l4";s:6:"Images";s:14:"ris_default_y2";s:14:"Primary date 2";s:14:"ris_default_a3";s:7:"Authors";s:14:"ris_default_ab";s:8:"Abstract";s:14:"ris_default_la";s:8:"Language";s:14:"ris_default_ts";s:2:"TS";s:14:"ris_default_do";s:3:"DOI";s:14:"ris_default_ed";s:15:"Further Persons";s:14:"ris_default_in";s:2:"In";s:14:"ris_default_et";s:7:"Edition";s:14:"ris_default_dp";s:17:"Database Provider";s:14:"ris_default_st";s:11:"Short Title";s:25:"bibl_library_show_in_list";s:24:"Show as link in the list";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'obj'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:26:{s:14:"edit_questions";s:14:"Edit Questions";s:22:"obj_select_master_lang";s:145:"Please select the master language. The current content will be assigned to the master language. The master language cannot be changed afterwards.";s:15:"obj_master_lang";s:15:"Master Language";s:20:"obj_additional_langs";s:20:"Additional Languages";s:27:"obj_deactivate_content_lang";s:39:"Deactivate Translation for Page Editing";s:11:"svy_results";s:7:"Results";s:19:"obj_multilinguality";s:15:"Multilinguality";s:12:"obj_features";s:19:"Additional Features";s:25:"obj_tool_setting_info_tab";s:8:"Info Tab";s:23:"obj_activation_list_gui";s:12:"Availability";s:30:"obj_tool_setting_info_tab_info";s:37:"The ‘Info’ tab will be displayed.";s:16:"obj_presentation";s:12:"Presentation";s:34:"obj_deactivate_content_transl_conf";s:113:"Do you really want to deactivate translation for page editing? Only contents of the master language will be kept.";s:27:"obj_cont_transl_deactivated";s:50:"Translation for page editing has been deactivated.";s:25:"obj_insert_into_clipboard";s:21:"Insert into Clipboard";s:22:"obj_inserted_clipboard";s:41:"Objects have been moved to the clipboard.";s:30:"obj_multilang_title_descr_only";s:145:"Translation is activated for title and description only. Translation support for Page editing (‘Customize Page’) needs additional activation.";s:25:"obj_activate_content_lang";s:37:"Activate Translation for Page Editing";s:17:"obj_add_languages";s:13:"Add Languages";s:22:"obj_activate_multilang";s:24:"Activate Multilinguality";s:24:"obj_deactivate_multilang";s:26:"Deactivate Multilinguality";s:29:"obj_deactivate_multilang_conf";s:100:"Do you really want to deactivate multilinguality? Only contents of the master language will be kept.";s:25:"obj_multilang_deactivated";s:37:"Multilinguality has been deactivated.";s:27:"obj_tool_setting_taxonomies";s:10:"Taxonomies";s:26:"obj_tool_setting_tag_cloud";s:9:"Tag Cloud";s:31:"obj_tool_setting_tag_cloud_info";s:73:"The ‘Tag Cloud’ block will be displayed inside the ‘Content’ tab.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'orgu'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:76:{s:22:"view_learning_progress";s:22:"View Learning Progress";s:16:"il_orgu_employee";s:8:"Employee";s:19:"orgu_staff_deassign";s:61:"Are you sure you want to deassign these users from this role?";s:24:"deassign_user_successful";s:55:"Users have been successfully deassigned from this role.";s:16:"il_orgu_superior";s:8:"Superior";s:10:"orgu_staff";s:5:"Staff";s:19:"orgu_msg_info_paste";s:44:"Please select the place to paste the object.";s:31:"orgu_view_learning_progress_rec";s:45:"View Learning Progress of Unit incl. Subunits";s:5:"Staff";s:5:"Staff";s:9:"orgu_edit";s:4:"Edit";s:8:"employee";s:8:"Employee";s:8:"superior";s:8:"Superior";s:7:"Actions";s:7:"Actions";s:22:"show_learning_progress";s:22:"Show Learning Progress";s:23:"users_successfuly_added";s:37:"The user has been added successfully.";s:18:"change_to_superior";s:18:"Change to superior";s:18:"change_to_employee";s:18:"Change to employee";s:23:"user_changed_successful";s:39:"The user has been changed successfully.";s:20:"ou_id_type_not_valid";s:80:"The ou_id type is not valid. Valid are: ‘reference_id’ or ‘external_id’.";s:22:"ou_parent_id_not_valid";s:36:"The ou_parent_id could not be found.";s:17:"import_successful";s:79:"The import terminated successfully. Created: %s, edited/moved: %s, deleted: %s.";s:31:"import_terminated_with_warnings";s:35:"The import terminated with warnings";s:29:"import_terminated_with_errors";s:34:"The import terminated with errors.";s:13:"import_failed";s:86:"The import failed. Make sure your file is in the xml format and has a valid structure.";s:20:"orgu_already_deleted";s:31:"The object was already deleted.";s:8:"orgu_new";s:23:"New Organisational Unit";s:8:"orgu_add";s:23:"Add Organisational Unit";s:11:"orgu_import";s:26:"Import Organisational Unit";s:9:"orgu_copy";s:24:"Copy Organisational Unit";s:18:"obj_orgu_duplicate";s:29:"Duplicate Organisational Unit";s:11:"local_staff";s:12:"Employees %s";s:9:"rec_staff";s:27:"Employees %s incl. Subunits";s:11:"placeholder";s:3:"...";s:13:"simple_import";s:17:"Simple XML Import";s:10:"simple_xml";s:17:"Simple XML Export";s:15:"import_xml_file";s:11:"Import File";s:26:"view_learning_progress_rec";s:45:"View Learning Progress of Unit incl. Subunits";s:12:"lp_is_anonym";s:77:"The learning progress can\'t be viewed because the data is stored anonymously.";s:17:"edit_translations";s:21:"Title and Description";s:11:"edit_ext_id";s:11:"External ID";s:6:"ext_id";s:11:"External ID";s:14:"ext_id_updated";s:46:"The external ID has been updated successfully.";s:8:"no_roles";s:44:"There are no additional roles at this point.";s:17:"local_other_roles";s:25:"Additional Local Roles %s";s:12:"backto_staff";s:13:"Back to Staff";s:17:"orgu_type_deleted";s:32:"Organisational Unit Type deleted";s:13:"orgu_type_add";s:28:"Add Organisational Unit Type";s:14:"orgu_type_edit";s:29:"Edit Organisational Unit Type";s:10:"orgu_types";s:5:"Types";s:21:"orgu_type_msg_deleted";s:32:"Deleted Organisational Unit Type";s:27:"orgu_type_msg_missing_title";s:50:"There must be set a title for the default language";s:27:"orgu_type_msg_unable_delete";s:92:"Unable to delete type because it is still assigned to the following Organisational Units: %s";s:32:"orgu_type_msg_deletion_prevented";s:43:"Deletion of object prevented by plugins: %s";s:38:"orgu_type_msg_setting_member_prevented";s:37:"Setting \'%s\' prevented by plugins: %s";s:32:"orgu_type_msg_updating_prevented";s:43:"Updating of object prevented by plugins: %s";s:34:"orgu_type_msg_assign_amd_prevented";s:44:"Assigning AMDRecord prevented by plugins: %s";s:36:"orgu_type_msg_deassign_amd_prevented";s:46:"Deassigning AMDRecord prevented by plugins: %s";s:44:"orgu_type_msg_setting_default_lang_prevented";s:57:"Setting \'%s\' as default language prevented by plugins: %s";s:44:"orgu_type_msg_missing_title_default_language";s:73:"There must be set a default language and a title for the default language";s:26:"orgu_type_custom_icon_info";s:92:"All Organisational Units having this type assigned will use the icon in the tree and header.";s:13:"orgu_settings";s:28:"Organisational Unit Settings";s:9:"orgu_type";s:24:"Organisational Unit Type";s:14:"orgu_orgu_type";s:24:"Organisational Unit Type";s:21:"orgu_type_custom_icon";s:45:"Custom Icon for this Organisational Unit Type";s:17:"orgu_adv_settings";s:17:"Advanced Settings";s:31:"orgu_type_msg_error_custom_icon";s:30:"Could not save the custom icon";s:28:"orgu_type_available_amd_sets";s:32:"Available Advanced Metadata sets";s:25:"orgu_type_assign_amd_sets";s:29:"Assign Advanced Metadata sets";s:18:"simple_user_import";s:19:"XML User Assignment";s:10:"simple_xls";s:19:"Simple Excel Export";s:21:"ou_external_id_exists";s:58:"A unit with the External ID already exists on this system.";s:22:"user_import_successful";s:62:"The import terminated successfully. Assigned: %s, Removed: %s.";s:10:"no_orgunit";s:60:"Please check your XML-File. There is no Organisational Unit.";s:13:"no_assignment";s:56:"Please check your XML-File. There is no User Assignment.";s:18:"org_unit_not_found";s:30:"Organisational Unit not found.";s:15:"ou_id_not_valid";s:20:"Import-ID not found.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'classification'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:4:{s:18:"clsfct_block_title";s:19:"Selection by Topics";s:17:"clsfct_block_info";s:35:"Your Selection filters the objects.";s:20:"clsfct_content_title";s:31:"Objects matching your selection";s:23:"clsfct_content_no_match";s:7:"No hits";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'mmbr'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:3:{s:19:"mmbr_selected_users";s:21:"Selected Participants";s:28:"mmbr_btn_mail_selected_users";s:9:"Send Mail";s:16:"info_refuse_sure";s:54:"Are you sure you want to refuse the following user(s)?";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'sysc'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:45:{s:14:"sysc_tab_trash";s:15:"Deleted Objects";s:25:"sysc_administrate_deleted";s:28:"Administrate Deleted Objects";s:18:"sysc_trash_restore";s:23:"Restore Deleted Objects";s:23:"sysc_trash_restore_info";s:80:"Restore deleted objects from trash bin and move the to the ‘Recovery Folder’";s:17:"sysc_trash_action";s:6:"Action";s:17:"sysc_trash_remove";s:34:"Remove deleted objects from system";s:22:"sysc_trash_remove_info";s:50:"Remove deleted objects (trash bin) from the system";s:20:"sysc_trash_limit_num";s:12:"Limit Number";s:20:"sysc_trash_limit_age";s:9:"Limit Age";s:21:"sysc_trash_limit_type";s:13:"Limit by Type";s:13:"sysc_overview";s:8:"Overview";s:11:"sysc_groups";s:19:"System Check Groups";s:13:"sysc_grp_tree";s:15:"Repository Tree";s:18:"sysc_grp_tree_desc";s:84:"Performs an analysis of the tree and prints all tree nodes along with analysis data.";s:18:"sysc_completed_num";s:16:"Fullfilled Tasks";s:15:"sysc_failed_num";s:20:"Not Fullfilled Tasks";s:18:"sysc_task_overview";s:5:"Tasks";s:20:"sysc_action_validate";s:8:"Validate";s:18:"sysc_action_repair";s:6:"Repair";s:25:"sysc_task_tree_duplicates";s:36:"Duplicate Entries in Repository Tree";s:30:"sysc_task_tree_duplicates_desc";s:62:"Search for duplicate entries in the repository tree structure.";s:19:"sysc_task_tree_dump";s:9:"List Tree";s:24:"sysc_task_tree_dump_desc";s:49:"Analyses and prints the repository tree structure";s:21:"sysc_action_list_tree";s:27:"Create Repository Tree Dump";s:21:"sysc_action_show_tree";s:25:"Show Repository Tree Dump";s:28:"sysc_tree_duplicate_failures";s:71:"Found duplicate entries in tree structure. Number of duoplicate entries";s:20:"sysc_message_success";s:15:"No errors found";s:23:"sysc_tree_list_failures";s:87:"A dump of the the repository tree has been created. Number of errors in tree structure:";s:14:"sysc_status_na";s:12:"Not Executed";s:19:"sysc_status_running";s:7:"Running";s:18:"sysc_status_failed";s:6:"Failed";s:21:"sysc_status_completed";s:9:"Completed";s:22:"sysc_task_tree_missing";s:34:"Missing Entries in Repository Tree";s:27:"sysc_task_tree_missing_desc";s:60:"Searches and repairs missing entries in the repository tree.";s:33:"sysc_message_tree_missing_confirm";s:79:"Do you really want to restore missing entries in the repository tree structure?";s:21:"sysc_btn_tree_missing";s:15:"Restore Missing";s:26:"sysc_tree_missing_failures";s:71:"Found missing entries in the tree structure. Number of missing entries:";s:21:"sysc_cron_empty_trash";s:16:"Delete Trash Bin";s:26:"sysc_cron_empty_trash_desc";s:118:"If enabled, the repository trash bin will be purged by given criteria (age, object type or maximum number of objects).";s:27:"sysc_task_tree_missing_tree";s:34:"Missing Entries in Repository Tree";s:32:"sysc_task_tree_missing_tree_desc";s:60:"Searches and repairs missing entries in the repository tree.";s:32:"sysc_task_tree_missing_reference";s:25:"Missing Object References";s:37:"sysc_task_tree_missing_reference_desc";s:70:"Searches and repairs missing object references in the repository tree.";s:19:"sysc_task_structure";s:14:"Tree structure";s:24:"sysc_task_structure_desc";s:52:"Analyzes and corrects the repository tree structure.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'scormtrac'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:87:{s:16:"audio_captioning";s:35:"learner_preference.audio_captioning";s:11:"audio_level";s:30:"learner_preference.audio_level";s:7:"c_entry";s:5:"entry";s:6:"c_exit";s:4:"exit";s:10:"c_language";s:27:"learner_preference.language";s:10:"c_location";s:8:"location";s:5:"c_max";s:9:"score.max";s:5:"c_min";s:9:"score.min";s:6:"c_mode";s:4:"mode";s:5:"c_raw";s:25:"score.raw: achieved score";s:11:"c_timestamp";s:11:"Last access";s:6:"c_type";s:4:"Type";s:17:"completion_status";s:17:"completion_status";s:20:"completion_threshold";s:20:"completion_threshold";s:11:"counter_all";s:9:"All users";s:15:"counter_correct";s:25:"Users with correct result";s:23:"counter_correct_percent";s:39:"Percentage of users with correct result";s:17:"counter_incorrect";s:27:"Users with incorrect result";s:25:"counter_incorrect_percent";s:41:"Percentage of users with incorrect result";s:13:"counter_other";s:23:"Users with other result";s:21:"counter_other_percent";s:37:"Percentage of users with other result";s:10:"cp_node_id";s:19:"ID of chapter / SCO";s:6:"credit";s:6:"credit";s:14:"delivery_speed";s:33:"learner_preference.delivery_speed";s:18:"exportselectedcore";s:31:"Basic report for chapters (SCO)";s:26:"exportselectedinteractions";s:29:"Basic report for interactions";s:2:"id";s:2:"ID";s:23:"interaction_description";s:26:"Description of interaction";s:14:"interaction_id";s:17:"ID of interaction";s:17:"interaction_value";s:21:"Result of interaction";s:7:"latency";s:13:"latency: time";s:15:"latency_seconds";s:24:"latency: time in seconds";s:11:"launch_data";s:37:"launch_data: data at start of the SCO";s:16:"learner_response";s:26:"learner_response: Response";s:5:"lm_id";s:25:"ID of the learning module";s:8:"lm_title";s:28:"Title of the learning module";s:16:"progress_measure";s:16:"progress_measure";s:6:"result";s:6:"result";s:6:"scaled";s:50:"score.scaled: score achieved as a decimal fraction";s:20:"scaled_passing_score";s:66:"scaled_passing_score: score required to pass as a decimal fraction";s:32:"sco_marked_for_learning_progress";s:30:"Relevant for learning progress";s:9:"sco_title";s:22:"Title of chapter / SCO";s:12:"session_time";s:38:"session_time: time in the last session";s:20:"session_time_seconds";s:49:"session_time: time in the last session in seconds";s:14:"success_status";s:23:"success_status: success";s:12:"suspend_data";s:40:"suspend_data: variable buffer of the SCO";s:10:"total_time";s:22:"total_time: total time";s:18:"total_time_seconds";s:33:"total_time: total time in seconds";s:19:"tracinteractionitem";s:26:"Evaluation per interaction";s:19:"tracinteractionuser";s:19:"Evaluation per user";s:26:"tracinteractionuseranswers";s:18:"Responses of users";s:7:"user_id";s:7:"User-ID";s:9:"weighting";s:9:"weighting";s:6:"report";s:6:"Report";s:19:"display_not_allowed";s:19:"Display not allowed";s:21:"exportselectedsuccess";s:24:"Basic report for success";s:16:"LearningModuleId";s:21:"ID of learning module";s:19:"LearningModuleTitle";s:24:"Title of learning module";s:21:"LearningModuleVersion";s:26:"Version of learning module";s:6:"Status";s:12:"Total status";s:10:"Percentage";s:28:"Percentage of completed SCOs";s:8:"Attempts";s:8:"Attempts";s:12:"existingSCOs";s:23:"Number of existing SCOs";s:11:"startedSCOs";s:22:"Number of started SCOs";s:13:"completedSCOs";s:30:"Number of fully completed SCOs";s:10:"passedSCOs";s:21:"Number of passed SCOs";s:24:"roundedTotal_timeSeconds";s:31:"Total time in seconds (rounded)";s:17:"counter_i_correct";s:31:"Correctly answered interactions";s:25:"counter_i_correct_percent";s:45:"Percentage of correctly answered interactions";s:19:"counter_i_incorrect";s:33:"Incorrectly answered interactions";s:27:"counter_i_incorrect_percent";s:47:"Percentage of incorrectly answered interactions";s:15:"counter_i_other";s:55:"Neither correctly nor incorrectly answered interactions";s:23:"counter_i_other_percent";s:69:"Percentage of neither correctly nor incorrectly answered interactions";s:6:"sco_id";s:19:"ID of chapter / SCO";s:13:"lesson_status";s:13:"lesson_status";s:9:"satisfied";s:17:"Status: satisfied";s:7:"measure";s:15:"Status: measure";s:23:"exportobjglobaltosystem";s:59:"Report for Objectives Global To System (used by Sequencing)";s:24:"exportselectedobjectives";s:21:"Report for objectives";s:5:"scope";s:5:"scope";s:7:"counter";s:7:"counter";s:16:"student_response";s:26:"student_response: Response";s:7:"ostatus";s:23:"Status of the objective";s:17:"exportselectedraw";s:14:"CMI (RAW) data";s:6:"lvalue";s:3:"Key";s:6:"rvalue";s:5:"Value";s:13:"identifierref";s:14:"SCO-Identifier";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'link'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:6:{s:18:"link_edit_int_link";s:18:"Edit Internal Link";s:13:"link_chapters";s:8:"Chapters";s:11:"link_wpages";s:10:"Wiki Pages";s:10:"link_terms";s:5:"Terms";s:9:"link_mobs";s:13:"Media Objects";s:9:"link_link";s:4:"Link";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'error'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:2:{s:24:"error_back_to_repository";s:18:"Back to Repository";s:15:"error_sry_error";s:25:"Sorry, an error occurred.";}')));

$ilDB->insert("lng_modules", array(
'module' => array('text', 'lm'), 'lang_key' => array('text', 'en'), 'lang_array' => array('clob', 'a:1:{s:7:"lm_copy";s:20:"Copy Learning Module";}')));


//
// lo_access
//
$fields = array (
	"timestamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lm_title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("lo_access", $fields);

$in_fields = array("usr_id");
$ilDB->addIndex("lo_access", $in_fields, "i1", false);


//
// loc_rnd_qpl
//
$fields = array (
	"container_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tst_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tst_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"qp_seq" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"percentage" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("loc_rnd_qpl", $fields);

$pk_fields = array("container_id","objective_id","tst_type");
$ilDB->addPrimaryKey("loc_rnd_qpl", $pk_fields);


//
// loc_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"itest" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"qtest" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"qt_vis_all" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"qt_vis_obj" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reset_results" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("loc_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("loc_settings", $pk_fields);


//
// loc_tst_run
//
$fields = array (
	"container_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"test_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"max_points" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"questions" => array (
		"notnull" => false
		,"length" => 1000
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("loc_tst_run", $fields);

$pk_fields = array("container_id","user_id","test_id","objective_id");
$ilDB->addPrimaryKey("loc_tst_run", $pk_fields);


//
// loc_user_results
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"course_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"objective_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"result_perc" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"limit_perc" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tries" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"is_final" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("loc_user_results", $fields);

$pk_fields = array("user_id","course_id","objective_id","type");
$ilDB->addPrimaryKey("loc_user_results", $pk_fields);


//
// loginname_history
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"login" => array (
		"notnull" => true
		,"length" => 80
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"history_date" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("loginname_history", $fields);

$pk_fields = array("usr_id","login","history_date");
$ilDB->addPrimaryKey("loginname_history", $pk_fields);


//
// mail
//
$fields = array (
	"mail_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"folder_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sender_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"send_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"m_status" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"m_type" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"m_email" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"m_subject" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"import_name" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"use_placeholders" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"m_message" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rcp_to" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rcp_cc" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rcp_bcc" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"attachments" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("mail", $fields);

$pk_fields = array("mail_id");
$ilDB->addPrimaryKey("mail", $pk_fields);

$in_fields = array("user_id");
$ilDB->addIndex("mail", $in_fields, "i1", false);

$in_fields = array("folder_id");
$ilDB->addIndex("mail", $in_fields, "i2", false);

$in_fields = array("m_status");
$ilDB->addIndex("mail", $in_fields, "i3", false);

$in_fields = array("sender_id","user_id");
$ilDB->addIndex("mail", $in_fields, "i4", false);

$ilDB->createSequence("mail", 1);


//
// mail_attachment
//
$fields = array (
	"mail_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"path" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("mail_attachment", $fields);

$pk_fields = array("mail_id");
$ilDB->addPrimaryKey("mail_attachment", $pk_fields);

$in_fields = array("path");
$ilDB->addIndex("mail_attachment", $in_fields, "i1", false);


//
// mail_obj_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 70
		,"fixed" => true
		,"type" => "text"
	)
	,"m_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("mail_obj_data", $fields);

$pk_fields = array("obj_id","user_id");
$ilDB->addPrimaryKey("mail_obj_data", $pk_fields);

$in_fields = array("user_id","m_type");
$ilDB->addIndex("mail_obj_data", $in_fields, "i1", false);

$ilDB->createSequence("mail_obj_data", 8);

$ilDB->insert("mail_obj_data", array(
'obj_id' => array('integer', '2'), 'user_id' => array('integer', '6'), 'title' => array('text', 'a_root'), 'm_type' => array('text', 'root')));

$ilDB->insert("mail_obj_data", array(
'obj_id' => array('integer', '3'), 'user_id' => array('integer', '6'), 'title' => array('text', 'b_inbox'), 'm_type' => array('text', 'inbox')));

$ilDB->insert("mail_obj_data", array(
'obj_id' => array('integer', '4'), 'user_id' => array('integer', '6'), 'title' => array('text', 'c_trash'), 'm_type' => array('text', 'trash')));

$ilDB->insert("mail_obj_data", array(
'obj_id' => array('integer', '5'), 'user_id' => array('integer', '6'), 'title' => array('text', 'd_drafts'), 'm_type' => array('text', 'drafts')));

$ilDB->insert("mail_obj_data", array(
'obj_id' => array('integer', '6'), 'user_id' => array('integer', '6'), 'title' => array('text', 'e_sent'), 'm_type' => array('text', 'sent')));

$ilDB->insert("mail_obj_data", array(
'obj_id' => array('integer', '7'), 'user_id' => array('integer', '6'), 'title' => array('text', 'z_local'), 'm_type' => array('text', 'local')));


//
// mail_options
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"linebreak" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"signature" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"incoming_type" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"cronjob_notification" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("mail_options", $fields);

$in_fields = array("user_id","linebreak");
$ilDB->addIndex("mail_options", $in_fields, "i1", false);

$ilDB->insert("mail_options", array(
'user_id' => array('integer', '6'), 'linebreak' => array('integer', '60'), 'signature' => array('text', ''), 'incoming_type' => array('integer', ''), 'cronjob_notification' => array('integer', '0')));


//
// mail_saved
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"m_type" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"m_email" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"m_subject" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"use_placeholders" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"m_message" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rcp_to" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rcp_cc" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rcp_bcc" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"attachments" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("mail_saved", $fields);


//
// mail_template
//
$fields = array (
	"lang" => array (
		"notnull" => true
		,"length" => 5
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"subject" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"body" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"sal_f" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"sal_m" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"sal_g" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"att_file" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("mail_template", $fields);

$pk_fields = array("type","lang");
$ilDB->addPrimaryKey("mail_template", $pk_fields);


//
// mail_tree
//
$fields = array (
	"tree" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("mail_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("mail_tree", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("mail_tree", $in_fields, "i2", false);

$in_fields = array("tree");
$ilDB->addIndex("mail_tree", $in_fields, "i3", false);

$ilDB->insert("mail_tree", array(
'tree' => array('integer', '6'), 'child' => array('integer', '2'), 'parent' => array('integer', '0'), 'lft' => array('integer', '1'), 'rgt' => array('integer', '12'), 'depth' => array('integer', '1')));

$ilDB->insert("mail_tree", array(
'tree' => array('integer', '6'), 'child' => array('integer', '3'), 'parent' => array('integer', '2'), 'lft' => array('integer', '2'), 'rgt' => array('integer', '3'), 'depth' => array('integer', '2')));

$ilDB->insert("mail_tree", array(
'tree' => array('integer', '6'), 'child' => array('integer', '4'), 'parent' => array('integer', '2'), 'lft' => array('integer', '4'), 'rgt' => array('integer', '5'), 'depth' => array('integer', '2')));

$ilDB->insert("mail_tree", array(
'tree' => array('integer', '6'), 'child' => array('integer', '5'), 'parent' => array('integer', '2'), 'lft' => array('integer', '6'), 'rgt' => array('integer', '7'), 'depth' => array('integer', '2')));

$ilDB->insert("mail_tree", array(
'tree' => array('integer', '6'), 'child' => array('integer', '6'), 'parent' => array('integer', '2'), 'lft' => array('integer', '8'), 'rgt' => array('integer', '9'), 'depth' => array('integer', '2')));

$ilDB->insert("mail_tree", array(
'tree' => array('integer', '6'), 'child' => array('integer', '7'), 'parent' => array('integer', '2'), 'lft' => array('integer', '10'), 'rgt' => array('integer', '11'), 'depth' => array('integer', '2')));


//
// map_area
//
$fields = array (
	"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"shape" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"coords" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"link_type" => array (
		"notnull" => false
		,"length" => 3
		,"fixed" => true
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"href" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"target" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"target_frame" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"highlight_mode" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"highlight_class" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("map_area", $fields);

$pk_fields = array("item_id","nr");
$ilDB->addPrimaryKey("map_area", $pk_fields);

$in_fields = array("link_type","target");
$ilDB->addIndex("map_area", $in_fields, "lt", false);


//
// media_item
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"width" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"height" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"halign" => array (
		"notnull" => false
		,"length" => 10
		,"default" => "Left"
		,"fixed" => true
		,"type" => "text"
	)
	,"caption" => array (
		"notnull" => false
		,"length" => 3000
		,"fixed" => false
		,"type" => "text"
	)
	,"nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"purpose" => array (
		"notnull" => false
		,"length" => 20
		,"default" => "Standard"
		,"fixed" => true
		,"type" => "text"
	)
	,"mob_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"location" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"location_type" => array (
		"notnull" => false
		,"length" => 10
		,"default" => "LocalFile"
		,"fixed" => true
		,"type" => "text"
	)
	,"format" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"param" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
	,"tried_thumb" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
	,"text_representation" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("media_item", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("media_item", $pk_fields);

$ilDB->createSequence("media_item", 1);


//
// member_agreement
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"accepted" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"acceptance_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("member_agreement", $fields);

$pk_fields = array("usr_id","obj_id");
$ilDB->addPrimaryKey("member_agreement", $pk_fields);


//
// mep_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"default_width" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"default_height" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("mep_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("mep_data", $pk_fields);


//
// mep_item
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"foreign_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("mep_item", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("mep_item", $pk_fields);

$in_fields = array("foreign_id","type");
$ilDB->addIndex("mep_item", $in_fields, "ft", false);

$ilDB->createSequence("mep_item", 2);

$ilDB->insert("mep_item", array(
'obj_id' => array('integer', '1'), 'type' => array('text', 'dummy'), 'title' => array('text', 'Dummy'), 'foreign_id' => array('integer', '1')));


//
// mep_tree
//
$fields = array (
	"mep_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("mep_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("mep_tree", $in_fields, "ch", false);

$in_fields = array("parent");
$ilDB->addIndex("mep_tree", $in_fields, "pa", false);

$in_fields = array("mep_id");
$ilDB->addIndex("mep_tree", $in_fields, "me", false);


//
// mob_parameter
//
$fields = array (
	"med_item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("mob_parameter", $fields);

$in_fields = array("med_item_id");
$ilDB->addIndex("mob_parameter", $in_fields, "i1", false);


//
// mob_usage
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usage_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"usage_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usage_hist_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usage_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("mob_usage", $fields);

$pk_fields = array("id","usage_type","usage_id","usage_hist_nr","usage_lang");
$ilDB->addPrimaryKey("mob_usage", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("mob_usage", $in_fields, "mi", false);

$in_fields = array("usage_id");
$ilDB->addIndex("mob_usage", $in_fields, "i1", false);


//
// module_class
//
$fields = array (
	"class" => array (
		"notnull" => true
		,"length" => 100
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"module" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"dir" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("module_class", $fields);

$pk_fields = array("class");
$ilDB->addPrimaryKey("module_class", $pk_fields);

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteLearningModuleGUI'), 'module' => array('text', 'RemoteLearningModule'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteTestGUI'), 'module' => array('text', 'RemoteTest'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteGlossaryGUI'), 'module' => array('text', 'RemoteGlossary'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilLinkResourceHandlerGUI'), 'module' => array('text', 'WebResource'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjPortfolioGUI'), 'module' => array('text', 'Portfolio'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilPortfolioRepositoryGUI'), 'module' => array('text', 'Portfolio'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjSurveyQuestionPoolGUI'), 'module' => array('text', 'SurveyQuestionPool'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjTestGUI'), 'module' => array('text', 'Test'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilHTLMEditorGUI'), 'module' => array('text', 'HTMLLearningModule'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilHTLMPresentationGUI'), 'module' => array('text', 'HTMLLearningModule'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilMediaCastHandlerGUI'), 'module' => array('text', 'MediaCast'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilSAHSPresentationGUI'), 'module' => array('text', 'ScormAicc'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilSAHSEditGUI'), 'module' => array('text', 'ScormAicc'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilLMEditorGUI'), 'module' => array('text', 'LearningModule'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilLMPresentationGUI'), 'module' => array('text', 'LearningModule'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilWikiHandlerGUI'), 'module' => array('text', 'Wiki'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteCourseGUI'), 'module' => array('text', 'RemoteCourse'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjCategoryReferenceGUI'), 'module' => array('text', 'CategoryReference'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteCategoryGUI'), 'module' => array('text', 'RemoteCategory'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteGroupGUI'), 'module' => array('text', 'RemoteGroup'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjQuestionPoolGUI'), 'module' => array('text', 'TestQuestionPool'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjSurveyGUI'), 'module' => array('text', 'Survey'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteFileGUI'), 'module' => array('text', 'RemoteFile'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjCourseReferenceGUI'), 'module' => array('text', 'CourseReference'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilGlossaryEditorGUI'), 'module' => array('text', 'Glossary'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilGlossaryPresentationGUI'), 'module' => array('text', 'Glossary'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjRemoteWikiGUI'), 'module' => array('text', 'RemoteWiki'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilExerciseHandlerGUI'), 'module' => array('text', 'Exercise'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjChatroomGUI'), 'module' => array('text', 'Chatroom'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilObjChatroomAdminGUI'), 'module' => array('text', 'Chatroom'), 'dir' => array('text', 'classes')));

$ilDB->insert("module_class", array(
'class' => array('text', 'ilMediaPoolPresentationGUI'), 'module' => array('text', 'MediaPool'), 'dir' => array('text', 'classes')));


//
// note
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rep_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"author" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"note_text" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"label" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"creation_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"update_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"subject" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"no_repository" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("note", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("note", $pk_fields);

$in_fields = array("author");
$ilDB->addIndex("note", $in_fields, "i1", false);

$in_fields = array("rep_obj_id","obj_id","obj_type");
$ilDB->addIndex("note", $in_fields, "i2", false);

$ilDB->createSequence("note", 1);


//
// note_settings
//
$fields = array (
	"rep_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"activated" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("note_settings", $fields);

$pk_fields = array("rep_obj_id","obj_id","obj_type");
$ilDB->addPrimaryKey("note_settings", $pk_fields);


//
// notification
//
$fields = array (
	"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"last_mail" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"page_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("notification", $fields);

$pk_fields = array("type","id","user_id");
$ilDB->addPrimaryKey("notification", $pk_fields);


//
// notification_channels
//
$fields = array (
	"channel_name" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"class" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"include" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"config_type" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("notification_channels", $fields);

$pk_fields = array("channel_name");
$ilDB->addPrimaryKey("notification_channels", $pk_fields);

$ilDB->insert("notification_channels", array(
'channel_name' => array('text', 'mail'), 'title' => array('text', 'mail'), 'description' => array('text', 'mail_desc'), 'class' => array('text', 'ilNotificationMailHandler'), 'include' => array('text', 'Services/Notifications/classes/class.ilNotificationMailHandler.php'), 'config_type' => array('text', 'set_by_admin')));

$ilDB->insert("notification_channels", array(
'channel_name' => array('text', 'osd'), 'title' => array('text', 'osd'), 'description' => array('text', 'osd_desc'), 'class' => array('text', 'ilNotificationOSDHandler'), 'include' => array('text', 'Services/Notifications/classes/class.ilNotificationOSDHandler.php'), 'config_type' => array('text', 'set_by_admin')));


//
// notification_data
//
$fields = array (
	"notification_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"serialized" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("notification_data", $fields);

$pk_fields = array("notification_id");
$ilDB->addPrimaryKey("notification_data", $pk_fields);

$ilDB->createSequence("notification_data", 1);


//
// notification_listener
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"module" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"sender_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"disabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("notification_listener", $fields);

$pk_fields = array("usr_id","module","sender_id");
$ilDB->addPrimaryKey("notification_listener", $pk_fields);


//
// notification_osd
//
$fields = array (
	"notification_osd_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"serialized" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"valid_until" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"time_added" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("notification_osd", $fields);

$pk_fields = array("notification_osd_id");
$ilDB->addPrimaryKey("notification_osd", $pk_fields);

$ilDB->createSequence("notification_osd", 1);


//
// notification_queue
//
$fields = array (
	"notification_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"valid_until" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("notification_queue", $fields);

$pk_fields = array("notification_id","usr_id");
$ilDB->addPrimaryKey("notification_queue", $pk_fields);


//
// notification_types
//
$fields = array (
	"type_name" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"notification_group" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"config_type" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("notification_types", $fields);

$pk_fields = array("type_name");
$ilDB->addPrimaryKey("notification_types", $pk_fields);

$ilDB->insert("notification_types", array(
'type_name' => array('text', 'chat_invitation'), 'title' => array('text', 'chat_invitation'), 'description' => array('text', 'chat_invitation_description'), 'notification_group' => array('text', 'chat'), 'config_type' => array('text', 'set_by_admin')));

$ilDB->insert("notification_types", array(
'type_name' => array('text', 'osd_maint'), 'title' => array('text', 'osd_maint'), 'description' => array('text', 'osd_maint_description'), 'notification_group' => array('text', 'osd_notification'), 'config_type' => array('text', 'set_by_admin')));


//
// notification_usercfg
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"module" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"channel" => array (
		"notnull" => true
		,"length" => 100
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("notification_usercfg", $fields);

$pk_fields = array("usr_id","module","channel");
$ilDB->addPrimaryKey("notification_usercfg", $pk_fields);

$ilDB->insert("notification_usercfg", array(
'usr_id' => array('integer', '-1'), 'module' => array('text', 'chat_invitation'), 'channel' => array('text', 'mail')));

$ilDB->insert("notification_usercfg", array(
'usr_id' => array('integer', '-1'), 'module' => array('text', 'chat_invitation'), 'channel' => array('text', 'osd')));

$ilDB->insert("notification_usercfg", array(
'usr_id' => array('integer', '-1'), 'module' => array('text', 'osd_main'), 'channel' => array('text', 'osd')));


//
// obj_content_master_lng
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"master_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("obj_content_master_lng", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("obj_content_master_lng", $pk_fields);


//
// obj_lp_stat
//
$fields = array (
	"type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"yyyy" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mm" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"dd" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"fulldate" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mem_cnt" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"in_progress" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"completed" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"failed" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"not_attempted" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("obj_lp_stat", $fields);

$pk_fields = array("obj_id","fulldate");
$ilDB->addPrimaryKey("obj_lp_stat", $pk_fields);


//
// obj_members
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"blocked" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"notification" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"passed" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"origin" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"origin_ts" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("obj_members", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("obj_members", $pk_fields);


//
// obj_stat
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"yyyy" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mm" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"dd" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"hh" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"read_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"childs_read_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"spent_seconds" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"childs_spent_seconds" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("obj_stat", $fields);

$in_fields = array("obj_id","yyyy","mm");
$ilDB->addIndex("obj_stat", $in_fields, "i1", false);

$in_fields = array("tstamp","obj_id");
$ilDB->addIndex("obj_stat", $in_fields, "i2", false);


//
// obj_stat_log
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"yyyy" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mm" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"dd" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"hh" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"read_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"childs_read_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"spent_seconds" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"childs_spent_seconds" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("obj_stat_log", $fields);


//
// obj_stat_tmp
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"yyyy" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mm" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"dd" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"hh" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"read_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"childs_read_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"spent_seconds" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"childs_spent_seconds" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("obj_stat_tmp", $fields);


//
// obj_type_stat
//
$fields = array (
	"type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"yyyy" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mm" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"dd" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"fulldate" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"cnt_references" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"cnt_objects" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"cnt_deleted" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("obj_type_stat", $fields);

$pk_fields = array("type","fulldate");
$ilDB->addPrimaryKey("obj_type_stat", $pk_fields);


//
// obj_user_data_hist
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"update_user" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"editing_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("obj_user_data_hist", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("obj_user_data_hist", $pk_fields);


//
// obj_user_stat
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"yyyy" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mm" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"dd" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"fulldate" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"counter" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("obj_user_stat", $fields);

$pk_fields = array("obj_id","fulldate");
$ilDB->addPrimaryKey("obj_user_stat", $pk_fields);


//
// object_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"default" => "none"
		,"fixed" => true
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => true
		,"type" => "text"
	)
	,"owner" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("object_data", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("object_data", $pk_fields);

$in_fields = array("type");
$ilDB->addIndex("object_data", $in_fields, "i1", false);

$in_fields = array("title");
$ilDB->addIndex("object_data", $in_fields, "i2", false);

$in_fields = array("import_id");
$ilDB->addIndex("object_data", $in_fields, "i4", false);

$in_fields = array("title","description");
$ilDB->addIndex("object_data", $in_fields, "i3", true);

$ilDB->createSequence("object_data", 231);

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '2'), 'type' => array('text', 'role'), 'title' => array('text', 'Administrator'), 'description' => array('text', 'Role for systemadministrators. This role grants access to everything!'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-01-16 15:31:45'), 'last_update' => array('timestamp', '2003-08-15 13:18:57'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '3'), 'type' => array('text', 'rolt'), 'title' => array('text', 'Author'), 'description' => array('text', 'Role template for authors with write & create permissions.'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-01-16 15:32:50'), 'last_update' => array('timestamp', '2005-07-20 16:13:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '4'), 'type' => array('text', 'role'), 'title' => array('text', 'User'), 'description' => array('text', 'Standard role for registered users. Grants read access to most objects.'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-01-16 15:34:00'), 'last_update' => array('timestamp', '2005-07-20 16:01:03'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '5'), 'type' => array('text', 'role'), 'title' => array('text', 'Guest'), 'description' => array('text', 'Role grants only a few visible & read permissions.'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-01-16 15:34:46'), 'last_update' => array('timestamp', '2005-07-20 16:01:35'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '6'), 'type' => array('text', 'usr'), 'title' => array('text', 'root user'), 'description' => array('text', 'ilias@yourserver.com'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-01-16 16:09:22'), 'last_update' => array('timestamp', '2003-09-30 19:50:01'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '7'), 'type' => array('text', 'usrf'), 'title' => array('text', 'User accounts'), 'description' => array('text', 'Manage user accounts here.'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-06-27 09:24:06'), 'last_update' => array('timestamp', '2004-01-20 12:23:47'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '8'), 'type' => array('text', 'rolf'), 'title' => array('text', 'Roles'), 'description' => array('text', 'Manage your roles here.'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-06-27 09:24:06'), 'last_update' => array('timestamp', '2004-01-20 12:23:40'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '1'), 'type' => array('text', 'root'), 'title' => array('text', 'ILIAS'), 'description' => array('text', 'This is the root node of the system!!!'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-06-24 15:15:03'), 'last_update' => array('timestamp', '2004-01-20 12:24:12'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '9'), 'type' => array('text', 'adm'), 'title' => array('text', 'System Settings'), 'description' => array('text', 'Folder contains the systems settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 12:37:33'), 'last_update' => array('timestamp', '2002-07-15 12:37:33'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '10'), 'type' => array('text', 'objf'), 'title' => array('text', 'Objectdefinitions'), 'description' => array('text', 'Manage ILIAS object types and object permissions. (only for experts!)'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 12:36:56'), 'last_update' => array('timestamp', '2004-01-20 12:23:53'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '11'), 'type' => array('text', 'lngf'), 'title' => array('text', 'Languages'), 'description' => array('text', 'Manage your system languages here.'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:52:51'), 'last_update' => array('timestamp', '2004-01-20 12:24:06'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '25'), 'type' => array('text', 'typ'), 'title' => array('text', 'usr'), 'description' => array('text', 'User object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:53:37'), 'last_update' => array('timestamp', '2003-08-15 12:30:56'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '34'), 'type' => array('text', 'typ'), 'title' => array('text', 'lm'), 'description' => array('text', 'Learning module Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:54:04'), 'last_update' => array('timestamp', '2003-08-15 12:33:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '37'), 'type' => array('text', 'typ'), 'title' => array('text', 'frm'), 'description' => array('text', 'Forum object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:54:22'), 'last_update' => array('timestamp', '2003-08-15 12:36:40'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '15'), 'type' => array('text', 'typ'), 'title' => array('text', 'grp'), 'description' => array('text', 'Group object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:54:37'), 'last_update' => array('timestamp', '2002-07-15 15:54:37'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '16'), 'type' => array('text', 'typ'), 'title' => array('text', 'cat'), 'description' => array('text', 'Category object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:54:54'), 'last_update' => array('timestamp', '2002-07-15 15:54:54'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '17'), 'type' => array('text', 'typ'), 'title' => array('text', 'crs'), 'description' => array('text', 'Course object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:55:08'), 'last_update' => array('timestamp', '2002-07-15 15:55:08'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '19'), 'type' => array('text', 'typ'), 'title' => array('text', 'mail'), 'description' => array('text', 'Mailmodule object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:55:49'), 'last_update' => array('timestamp', '2002-07-15 15:55:49'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '21'), 'type' => array('text', 'typ'), 'title' => array('text', 'adm'), 'description' => array('text', 'Administration Panel object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:56:38'), 'last_update' => array('timestamp', '2002-07-15 15:56:38'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '22'), 'type' => array('text', 'typ'), 'title' => array('text', 'usrf'), 'description' => array('text', 'User Folder object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:56:52'), 'last_update' => array('timestamp', '2002-07-15 15:56:52'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '23'), 'type' => array('text', 'typ'), 'title' => array('text', 'rolf'), 'description' => array('text', 'Role Folder object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:57:06'), 'last_update' => array('timestamp', '2002-07-15 15:57:06'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '24'), 'type' => array('text', 'typ'), 'title' => array('text', 'objf'), 'description' => array('text', 'Object-Type Folder object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:57:17'), 'last_update' => array('timestamp', '2002-07-15 15:57:17'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '26'), 'type' => array('text', 'typ'), 'title' => array('text', 'typ'), 'description' => array('text', 'Object Type Definition object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:58:16'), 'last_update' => array('timestamp', '2002-07-15 15:58:16'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '27'), 'type' => array('text', 'typ'), 'title' => array('text', 'rolt'), 'description' => array('text', 'Role template object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-07-15 15:58:16'), 'last_update' => array('timestamp', '2002-07-15 15:58:16'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '28'), 'type' => array('text', 'typ'), 'title' => array('text', 'lngf'), 'description' => array('text', 'Language Folder object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-08-28 14:22:01'), 'last_update' => array('timestamp', '2002-08-28 14:22:01'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '29'), 'type' => array('text', 'typ'), 'title' => array('text', 'lng'), 'description' => array('text', 'Language object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-08-30 10:18:29'), 'last_update' => array('timestamp', '2002-08-30 10:18:29'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '30'), 'type' => array('text', 'typ'), 'title' => array('text', 'role'), 'description' => array('text', 'Role Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-08-30 10:21:37'), 'last_update' => array('timestamp', '2002-08-30 10:21:37'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '31'), 'type' => array('text', 'typ'), 'title' => array('text', 'dbk'), 'description' => array('text', 'Digilib Book'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:29'), 'last_update' => array('timestamp', '2003-08-15 12:30:19'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '33'), 'type' => array('text', 'typ'), 'title' => array('text', 'root'), 'description' => array('text', 'Root Folder Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-12-21 00:04:00'), 'last_update' => array('timestamp', '2003-08-15 12:04:20'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '70'), 'type' => array('text', 'lng'), 'title' => array('text', 'en'), 'description' => array('text', 'installed'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', ''), 'last_update' => array('timestamp', '2015-11-24 11:30:23'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '14'), 'type' => array('text', 'role'), 'title' => array('text', 'Anonymous'), 'description' => array('text', 'Default role for anonymous users (with no account)'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 12:06:19'), 'last_update' => array('timestamp', '2005-07-20 15:15:06'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '18'), 'type' => array('text', 'typ'), 'title' => array('text', 'mob'), 'description' => array('text', 'Multimedia object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', ''), 'last_update' => array('timestamp', '2003-08-15 12:03:20'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '35'), 'type' => array('text', 'typ'), 'title' => array('text', 'notf'), 'description' => array('text', 'Note Folder Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-12-21 00:04:00'), 'last_update' => array('timestamp', '2002-12-21 00:04:00'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '36'), 'type' => array('text', 'typ'), 'title' => array('text', 'note'), 'description' => array('text', 'Note Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2002-12-21 00:04:00'), 'last_update' => array('timestamp', '2002-12-21 00:04:00'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '12'), 'type' => array('text', 'mail'), 'title' => array('text', 'Mail Settings'), 'description' => array('text', 'Configure global mail settings here.'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:28'), 'last_update' => array('timestamp', '2004-01-20 12:24:00'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '20'), 'type' => array('text', 'typ'), 'title' => array('text', 'sahs'), 'description' => array('text', 'SCORM/AICC Learning Module'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:28'), 'last_update' => array('timestamp', '2003-08-15 12:23:10'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '80'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_grp_admin'), 'description' => array('text', 'Administrator role template of groups'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:28'), 'last_update' => array('timestamp', '2005-07-20 17:04:15'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '81'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_grp_member'), 'description' => array('text', 'Member role template of groups'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:28'), 'last_update' => array('timestamp', '2005-07-20 17:07:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '82'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_grp_status_closed'), 'description' => array('text', 'Group role template'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:29'), 'last_update' => array('timestamp', '2003-08-15 13:21:38'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '83'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_grp_status_open'), 'description' => array('text', 'Group role template'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:29'), 'last_update' => array('timestamp', '2003-08-15 13:21:25'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '32'), 'type' => array('text', 'typ'), 'title' => array('text', 'glo'), 'description' => array('text', 'Glossary'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:30'), 'last_update' => array('timestamp', '2003-08-15 12:29:54'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '13'), 'type' => array('text', 'usr'), 'title' => array('text', 'Anonymous'), 'description' => array('text', 'Anonymous user account. DO NOT DELETE!'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-08-15 10:07:30'), 'last_update' => array('timestamp', '2003-08-15 10:07:30'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '71'), 'type' => array('text', 'lng'), 'title' => array('text', 'de'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2003-08-15 10:25:19'), 'last_update' => array('timestamp', '2003-09-30 19:50:06'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '72'), 'type' => array('text', 'lng'), 'title' => array('text', 'es'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2003-08-15 10:25:19'), 'last_update' => array('timestamp', '2003-08-15 10:25:19'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '73'), 'type' => array('text', 'lng'), 'title' => array('text', 'it'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2003-08-15 10:25:19'), 'last_update' => array('timestamp', '2003-08-15 10:25:19'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '84'), 'type' => array('text', 'typ'), 'title' => array('text', 'exc'), 'description' => array('text', 'Exercise object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-11-30 21:22:49'), 'last_update' => array('timestamp', '2003-11-30 21:22:49'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '85'), 'type' => array('text', 'typ'), 'title' => array('text', 'auth'), 'description' => array('text', 'Authentication settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-11-30 21:22:49'), 'last_update' => array('timestamp', '2003-11-30 21:22:49'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '86'), 'type' => array('text', 'auth'), 'title' => array('text', 'Authentication settings'), 'description' => array('text', 'Select and configure authentication mode for all user accounts'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-11-30 21:22:49'), 'last_update' => array('timestamp', '2003-11-30 21:22:49'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '87'), 'type' => array('text', 'typ'), 'title' => array('text', 'fold'), 'description' => array('text', 'Folder object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-11-30 21:22:50'), 'last_update' => array('timestamp', '2003-11-30 21:22:50'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '88'), 'type' => array('text', 'typ'), 'title' => array('text', 'file'), 'description' => array('text', 'File object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2003-11-30 21:22:50'), 'last_update' => array('timestamp', '2003-11-30 21:22:50'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '89'), 'type' => array('text', 'lng'), 'title' => array('text', 'fr'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2004-01-20 12:22:17'), 'last_update' => array('timestamp', '2004-01-20 12:22:17'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '90'), 'type' => array('text', 'lng'), 'title' => array('text', 'nl'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2004-01-20 12:22:17'), 'last_update' => array('timestamp', '2004-01-20 12:22:17'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '91'), 'type' => array('text', 'lng'), 'title' => array('text', 'pl'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2004-01-20 12:22:17'), 'last_update' => array('timestamp', '2004-01-20 12:22:17'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '92'), 'type' => array('text', 'lng'), 'title' => array('text', 'ua'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2004-01-20 12:22:17'), 'last_update' => array('timestamp', '2004-01-20 12:22:17'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '93'), 'type' => array('text', 'lng'), 'title' => array('text', 'zh'), 'description' => array('text', 'not_installed'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2004-01-20 12:22:17'), 'last_update' => array('timestamp', '2004-01-20 12:22:17'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '94'), 'type' => array('text', 'typ'), 'title' => array('text', 'tst'), 'description' => array('text', 'Test object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-02-18 21:17:40'), 'last_update' => array('timestamp', '2004-02-18 21:17:40'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '95'), 'type' => array('text', 'typ'), 'title' => array('text', 'qpl'), 'description' => array('text', 'Question pool object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-02-18 21:17:40'), 'last_update' => array('timestamp', '2004-02-18 21:17:40'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '182'), 'type' => array('text', 'typ'), 'title' => array('text', 'chta'), 'description' => array('text', 'Chatroom Administration Type'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:08'), 'last_update' => array('timestamp', '2011-08-07 11:39:08'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '99'), 'type' => array('text', 'typ'), 'title' => array('text', 'recf'), 'description' => array('text', 'RecoveryFolder object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-03-09 18:13:16'), 'last_update' => array('timestamp', '2004-03-09 18:13:16'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '100'), 'type' => array('text', 'recf'), 'title' => array('text', '__Restored Objects'), 'description' => array('text', 'Contains objects restored by recovery tool'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-03-09 18:13:16'), 'last_update' => array('timestamp', '2004-03-09 18:13:16'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '101'), 'type' => array('text', 'typ'), 'title' => array('text', 'mep'), 'description' => array('text', 'Media pool object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-04-19 00:09:14'), 'last_update' => array('timestamp', '2004-04-19 00:09:14'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '102'), 'type' => array('text', 'typ'), 'title' => array('text', 'htlm'), 'description' => array('text', 'HTML LM object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-04-19 00:09:15'), 'last_update' => array('timestamp', '2004-04-19 00:09:15'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '103'), 'type' => array('text', 'typ'), 'title' => array('text', 'svy'), 'description' => array('text', 'Survey object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-05-15 01:18:59'), 'last_update' => array('timestamp', '2004-05-15 01:18:59'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '104'), 'type' => array('text', 'typ'), 'title' => array('text', 'spl'), 'description' => array('text', 'Question pool object (Survey)'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-05-15 01:18:59'), 'last_update' => array('timestamp', '2004-05-15 01:18:59'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '106'), 'type' => array('text', 'typ'), 'title' => array('text', 'cals'), 'description' => array('text', 'Calendar Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-06-21 01:27:18'), 'last_update' => array('timestamp', '2004-06-21 01:27:18'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '107'), 'type' => array('text', 'cals'), 'title' => array('text', 'Calendar Settings'), 'description' => array('text', 'Configure Calendar Settings here'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-06-21 01:27:18'), 'last_update' => array('timestamp', '2004-06-21 01:27:18'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '108'), 'type' => array('text', 'typ'), 'title' => array('text', 'trac'), 'description' => array('text', 'UserTracking object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-07-11 01:03:12'), 'last_update' => array('timestamp', '2004-07-11 01:03:12'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '109'), 'type' => array('text', 'trac'), 'title' => array('text', '__User Tracking'), 'description' => array('text', 'System user tracking'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-07-11 01:03:12'), 'last_update' => array('timestamp', '2004-07-11 01:03:12'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '110'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_crs_admin'), 'description' => array('text', 'Administrator template for course admins'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-09-02 09:49:43'), 'last_update' => array('timestamp', '2005-07-20 16:47:58'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '111'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_crs_tutor'), 'description' => array('text', 'Tutor template for course tutors'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-09-02 09:49:43'), 'last_update' => array('timestamp', '2005-07-20 16:55:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '112'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_crs_member'), 'description' => array('text', 'Member template for course members'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-09-02 09:49:43'), 'last_update' => array('timestamp', '2005-07-20 16:59:41'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '113'), 'type' => array('text', 'typ'), 'title' => array('text', 'pays'), 'description' => array('text', 'Payment settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-09-02 09:49:45'), 'last_update' => array('timestamp', '2004-09-02 09:49:45'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '114'), 'type' => array('text', 'pays'), 'title' => array('text', 'Payment settings'), 'description' => array('text', 'Payment settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2004-09-02 09:49:45'), 'last_update' => array('timestamp', '2004-09-02 09:49:45'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '115'), 'type' => array('text', 'typ'), 'title' => array('text', 'assf'), 'description' => array('text', 'AssessmentFolder object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-01-07 17:21:15'), 'last_update' => array('timestamp', '2005-01-07 17:21:15'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '116'), 'type' => array('text', 'assf'), 'title' => array('text', '__Test&Assessment'), 'description' => array('text', 'Test&Assessment Administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-01-07 17:21:15'), 'last_update' => array('timestamp', '2005-01-07 17:21:15'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '117'), 'type' => array('text', 'typ'), 'title' => array('text', 'stys'), 'description' => array('text', 'Style Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-03-02 08:59:01'), 'last_update' => array('timestamp', '2005-03-02 08:59:01'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '118'), 'type' => array('text', 'stys'), 'title' => array('text', 'System Style Settings'), 'description' => array('text', 'Manage system skin and style settings here'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-03-02 08:59:01'), 'last_update' => array('timestamp', '2005-03-02 08:59:01'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '119'), 'type' => array('text', 'typ'), 'title' => array('text', 'icrs'), 'description' => array('text', 'iLinc course object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-03-02 08:59:01'), 'last_update' => array('timestamp', '2005-03-02 08:59:01'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '120'), 'type' => array('text', 'typ'), 'title' => array('text', 'icla'), 'description' => array('text', 'iLinc class room object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-03-02 08:59:01'), 'last_update' => array('timestamp', '2005-03-02 08:59:01'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '121'), 'type' => array('text', 'typ'), 'title' => array('text', 'crsg'), 'description' => array('text', 'Course grouping object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-03-02 08:59:02'), 'last_update' => array('timestamp', '2005-03-02 08:59:02'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '122'), 'type' => array('text', 'typ'), 'title' => array('text', 'webr'), 'description' => array('text', 'Link resource object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-03-13 22:41:38'), 'last_update' => array('timestamp', '2005-03-13 22:41:38'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '123'), 'type' => array('text', 'typ'), 'title' => array('text', 'seas'), 'description' => array('text', 'Search settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-06-20 09:50:00'), 'last_update' => array('timestamp', '2005-06-20 09:50:00'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '124'), 'type' => array('text', 'seas'), 'title' => array('text', 'Search settings'), 'description' => array('text', 'Search settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-06-20 09:50:00'), 'last_update' => array('timestamp', '2005-06-20 09:50:00'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '125'), 'type' => array('text', 'rolt'), 'title' => array('text', 'Local Administrator'), 'description' => array('text', 'Role template for local administrators.'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2005-07-20 15:33:13'), 'last_update' => array('timestamp', '2005-07-20 16:00:19'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '126'), 'type' => array('text', 'rolt'), 'title' => array('text', 'Co-Author'), 'description' => array('text', 'Role template for authors with limited permissions.'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2005-07-20 16:36:46'), 'last_update' => array('timestamp', '2005-07-20 16:42:50'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '127'), 'type' => array('text', 'typ'), 'title' => array('text', 'extt'), 'description' => array('text', 'external tools settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-07-20 18:10:04'), 'last_update' => array('timestamp', '2005-07-20 18:10:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '128'), 'type' => array('text', 'extt'), 'title' => array('text', 'External tools settings'), 'description' => array('text', 'Configuring external tools'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-07-20 18:10:04'), 'last_update' => array('timestamp', '2005-07-20 18:10:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '131'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_crs_non_member'), 'description' => array('text', 'Non-member template for course object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2005-11-07 12:41:21'), 'last_update' => array('timestamp', '2005-11-07 12:41:21'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '132'), 'type' => array('text', 'chtr'), 'title' => array('text', 'Public chat'), 'description' => array('text', 'Public chat'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2005-11-07 12:41:22'), 'last_update' => array('timestamp', '2005-11-07 12:41:22'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '133'), 'type' => array('text', 'rolf'), 'title' => array('text', '132'), 'description' => array('text', '(ref_id 24)'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2005-11-07 12:41:22'), 'last_update' => array('timestamp', '2005-11-07 12:41:22'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '134'), 'type' => array('text', 'role'), 'title' => array('text', 'il_chat_moderator_24'), 'description' => array('text', 'Moderator of chat obj_no.132'), 'owner' => array('integer', '6'), 'create_date' => array('timestamp', '2005-11-07 12:41:22'), 'last_update' => array('timestamp', '2005-11-07 12:41:22'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '135'), 'type' => array('text', 'typ'), 'title' => array('text', 'adve'), 'description' => array('text', 'Advanced editing object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2006-07-11 18:43:23'), 'last_update' => array('timestamp', '2006-07-11 18:43:23'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '136'), 'type' => array('text', 'adve'), 'title' => array('text', '__AdvancedEditing'), 'description' => array('text', 'Advanced Editing'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2006-07-11 18:43:23'), 'last_update' => array('timestamp', '2006-07-11 18:43:23'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '137'), 'type' => array('text', 'typ'), 'title' => array('text', 'ps'), 'description' => array('text', 'Privacy security settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-02-26 17:58:49'), 'last_update' => array('timestamp', '2007-02-26 17:58:49'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '138'), 'type' => array('text', 'ps'), 'title' => array('text', '__PrivacySecurity'), 'description' => array('text', 'Privacy and Security'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-02-26 17:58:49'), 'last_update' => array('timestamp', '2007-02-26 17:58:49'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '139'), 'type' => array('text', 'typ'), 'title' => array('text', 'nwss'), 'description' => array('text', 'News settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-02-26 17:58:50'), 'last_update' => array('timestamp', '2007-02-26 17:58:50'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '140'), 'type' => array('text', 'nwss'), 'title' => array('text', '__NewsSettings'), 'description' => array('text', 'News Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-02-26 17:58:50'), 'last_update' => array('timestamp', '2007-02-26 17:58:50'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '141'), 'type' => array('text', 'typ'), 'title' => array('text', 'feed'), 'description' => array('text', 'External Feed'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-02-26 17:58:50'), 'last_update' => array('timestamp', '2007-02-26 17:58:50'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '142'), 'type' => array('text', 'typ'), 'title' => array('text', 'mcst'), 'description' => array('text', 'Media Cast'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-04-03 13:43:46'), 'last_update' => array('timestamp', '2007-04-03 13:43:46'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '143'), 'type' => array('text', 'typ'), 'title' => array('text', 'pdts'), 'description' => array('text', 'Personal desktop settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-04-03 13:43:47'), 'last_update' => array('timestamp', '2007-04-03 13:43:47'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '144'), 'type' => array('text', 'pdts'), 'title' => array('text', '__PersonalDesktopSettings'), 'description' => array('text', 'Personal Desktop Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-04-03 13:43:47'), 'last_update' => array('timestamp', '2007-04-03 13:43:47'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '145'), 'type' => array('text', 'typ'), 'title' => array('text', 'rcrs'), 'description' => array('text', 'Remote Course Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-09-25 19:47:53'), 'last_update' => array('timestamp', '2007-09-25 19:47:53'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '146'), 'type' => array('text', 'typ'), 'title' => array('text', 'mds'), 'description' => array('text', 'Meta Data settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-09-25 19:47:53'), 'last_update' => array('timestamp', '2007-09-25 19:47:53'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '147'), 'type' => array('text', 'mds'), 'title' => array('text', '__MetaDataSettings'), 'description' => array('text', 'Meta Data Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-09-25 19:47:53'), 'last_update' => array('timestamp', '2007-09-25 19:47:53'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '148'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_frm_moderator'), 'description' => array('text', 'Moderator template for forum moderators'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2007-11-27 14:43:12'), 'last_update' => array('timestamp', '2007-11-27 14:43:12'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '149'), 'type' => array('text', 'typ'), 'title' => array('text', 'cmps'), 'description' => array('text', 'Component settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:54'), 'last_update' => array('timestamp', '2008-06-02 16:08:54'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '150'), 'type' => array('text', 'cmps'), 'title' => array('text', '__ComponentSettings'), 'description' => array('text', 'Component Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:54'), 'last_update' => array('timestamp', '2008-06-02 16:08:54'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '151'), 'type' => array('text', 'typ'), 'title' => array('text', 'facs'), 'description' => array('text', 'File Access settings object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:55'), 'last_update' => array('timestamp', '2008-06-02 16:08:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '152'), 'type' => array('text', 'facs'), 'title' => array('text', '__File Access'), 'description' => array('text', 'File Access settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:55'), 'last_update' => array('timestamp', '2008-06-02 16:08:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '153'), 'type' => array('text', 'typ'), 'title' => array('text', 'svyf'), 'description' => array('text', 'Survey Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:55'), 'last_update' => array('timestamp', '2008-06-02 16:08:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '154'), 'type' => array('text', 'svyf'), 'title' => array('text', '__SurveySettings'), 'description' => array('text', 'Survey Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:55'), 'last_update' => array('timestamp', '2008-06-02 16:08:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '155'), 'type' => array('text', 'typ'), 'title' => array('text', 'sess'), 'description' => array('text', 'Session object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:55'), 'last_update' => array('timestamp', '2008-06-02 16:08:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '156'), 'type' => array('text', 'typ'), 'title' => array('text', 'mcts'), 'description' => array('text', 'Mediacast settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:56'), 'last_update' => array('timestamp', '2008-06-02 16:08:56'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '157'), 'type' => array('text', 'mcts'), 'title' => array('text', '__MediacastSettings'), 'description' => array('text', 'Mediacast Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:56'), 'last_update' => array('timestamp', '2008-06-02 16:08:56'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '158'), 'type' => array('text', 'typ'), 'title' => array('text', 'wiki'), 'description' => array('text', 'Wiki'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-06-02 16:08:57'), 'last_update' => array('timestamp', '2008-06-02 16:08:57'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '159'), 'type' => array('text', 'typ'), 'title' => array('text', 'crsr'), 'description' => array('text', 'Course Reference Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-09-23 19:24:09'), 'last_update' => array('timestamp', '2008-09-23 19:24:09'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '160'), 'type' => array('text', 'typ'), 'title' => array('text', 'catr'), 'description' => array('text', 'Category Reference Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-09-23 19:24:09'), 'last_update' => array('timestamp', '2008-09-23 19:24:09'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '161'), 'type' => array('text', 'typ'), 'title' => array('text', 'tags'), 'description' => array('text', 'Tagging settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-09-23 19:24:09'), 'last_update' => array('timestamp', '2008-09-23 19:24:09'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '162'), 'type' => array('text', 'tags'), 'title' => array('text', '__TaggingSettings'), 'description' => array('text', 'Tagging Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2008-09-23 19:24:09'), 'last_update' => array('timestamp', '2008-09-23 19:24:09'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '163'), 'type' => array('text', 'typ'), 'title' => array('text', 'cert'), 'description' => array('text', 'Certificate settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:03:21'), 'last_update' => array('timestamp', '2009-07-20 13:03:21'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '164'), 'type' => array('text', 'cert'), 'title' => array('text', '__CertificateSettings'), 'description' => array('text', 'Certificate Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:03:21'), 'last_update' => array('timestamp', '2009-07-20 13:03:21'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '165'), 'type' => array('text', 'typ'), 'title' => array('text', 'lrss'), 'description' => array('text', 'Learning resources settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:03:21'), 'last_update' => array('timestamp', '2009-07-20 13:03:21'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '166'), 'type' => array('text', 'lrss'), 'title' => array('text', '__LearningResourcesSettings'), 'description' => array('text', 'Learning Resources Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:03:21'), 'last_update' => array('timestamp', '2009-07-20 13:03:21'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '167'), 'type' => array('text', 'typ'), 'title' => array('text', 'accs'), 'description' => array('text', 'Accessibility settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:07:28'), 'last_update' => array('timestamp', '2009-07-20 13:07:28'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '168'), 'type' => array('text', 'accs'), 'title' => array('text', '__AccessibilitySettings'), 'description' => array('text', 'Accessibility Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:07:28'), 'last_update' => array('timestamp', '2009-07-20 13:07:28'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '169'), 'type' => array('text', 'typ'), 'title' => array('text', 'mobs'), 'description' => array('text', 'Media Object/Pool settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:08:42'), 'last_update' => array('timestamp', '2009-07-20 13:08:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '170'), 'type' => array('text', 'mobs'), 'title' => array('text', '__MediaObjectSettings'), 'description' => array('text', 'Media Object/Pool Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2009-07-20 13:08:42'), 'last_update' => array('timestamp', '2009-07-20 13:08:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '171'), 'type' => array('text', 'typ'), 'title' => array('text', 'frma'), 'description' => array('text', 'Forum administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2010-07-19 16:42:55'), 'last_update' => array('timestamp', '2010-07-19 16:42:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '172'), 'type' => array('text', 'frma'), 'title' => array('text', '__ForumAdministration'), 'description' => array('text', 'Forum Administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2010-07-19 16:42:55'), 'last_update' => array('timestamp', '2010-07-19 16:42:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '173'), 'type' => array('text', 'typ'), 'title' => array('text', 'book'), 'description' => array('text', 'Booking Manager'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2010-07-19 16:43:10'), 'last_update' => array('timestamp', '2010-07-19 16:43:10'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '174'), 'type' => array('text', 'typ'), 'title' => array('text', 'skmg'), 'description' => array('text', 'Skill Management'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:00'), 'last_update' => array('timestamp', '2011-08-07 11:39:00'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '175'), 'type' => array('text', 'skmg'), 'title' => array('text', '__SkillManagement'), 'description' => array('text', 'Skill Management'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:00'), 'last_update' => array('timestamp', '2011-08-07 11:39:00'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '176'), 'type' => array('text', 'typ'), 'title' => array('text', 'blga'), 'description' => array('text', 'Blog administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:04'), 'last_update' => array('timestamp', '2011-08-07 11:39:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '177'), 'type' => array('text', 'blga'), 'title' => array('text', '__BlogAdministration'), 'description' => array('text', 'Blog Administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:04'), 'last_update' => array('timestamp', '2011-08-07 11:39:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '178'), 'type' => array('text', 'typ'), 'title' => array('text', 'prfa'), 'description' => array('text', 'Portfolio administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:04'), 'last_update' => array('timestamp', '2011-08-07 11:39:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '179'), 'type' => array('text', 'prfa'), 'title' => array('text', '__PortfolioAdministration'), 'description' => array('text', 'Portfolio Administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:04'), 'last_update' => array('timestamp', '2011-08-07 11:39:04'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '180'), 'type' => array('text', 'typ'), 'title' => array('text', 'chtr'), 'description' => array('text', 'Chatroom Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:06'), 'last_update' => array('timestamp', '2011-08-07 11:39:06'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '181'), 'type' => array('text', 'chta'), 'title' => array('text', 'Chatroom Admin'), 'description' => array('text', 'Chatroom General Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-08-07 11:39:06'), 'last_update' => array('timestamp', '2011-08-07 11:39:06'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '183'), 'type' => array('text', 'typ'), 'title' => array('text', 'otpl'), 'description' => array('text', 'Object Template administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-10-04 16:53:24'), 'last_update' => array('timestamp', '2011-10-04 16:53:24'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '184'), 'type' => array('text', 'otpl'), 'title' => array('text', '__ObjectTemplateAdministration'), 'description' => array('text', 'Object Template Administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-10-04 16:53:24'), 'last_update' => array('timestamp', '2011-10-04 16:53:24'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '185'), 'type' => array('text', 'chtr'), 'title' => array('text', 'Public Chatroom'), 'description' => array('text', 'Public Chatroom'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-10-04 16:53:25'), 'last_update' => array('timestamp', '2011-10-04 16:53:25'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '186'), 'type' => array('text', 'rolf'), 'title' => array('text', '185'), 'description' => array('text', '(ref_id )'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-10-04 16:53:25'), 'last_update' => array('timestamp', '2011-10-04 16:53:25'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '187'), 'type' => array('text', 'role'), 'title' => array('text', 'il_chat_moderator_46'), 'description' => array('text', 'Moderator of chat obj_no.185'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-10-04 16:53:25'), 'last_update' => array('timestamp', '2011-10-04 16:53:25'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '188'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_chat_moderator'), 'description' => array('text', 'Moderator template for chat moderators'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2011-10-04 16:53:25'), 'last_update' => array('timestamp', '2011-10-04 16:53:25'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '189'), 'type' => array('text', 'typ'), 'title' => array('text', 'blog'), 'description' => array('text', 'Blog Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:25:29'), 'last_update' => array('timestamp', '2012-09-04 14:25:29'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '190'), 'type' => array('text', 'typ'), 'title' => array('text', 'dcl'), 'description' => array('text', 'Data Collection Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:25:30'), 'last_update' => array('timestamp', '2012-09-04 14:25:30'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '191'), 'type' => array('text', 'typ'), 'title' => array('text', 'poll'), 'description' => array('text', 'Poll Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:25:41'), 'last_update' => array('timestamp', '2012-09-04 14:25:41'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '192'), 'type' => array('text', 'typ'), 'title' => array('text', 'hlps'), 'description' => array('text', 'Help Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:25:48'), 'last_update' => array('timestamp', '2012-09-04 14:25:48'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '193'), 'type' => array('text', 'hlps'), 'title' => array('text', 'HelpSettings'), 'description' => array('text', 'Help Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:25:48'), 'last_update' => array('timestamp', '2012-09-04 14:25:48'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '194'), 'type' => array('text', 'typ'), 'title' => array('text', 'itgr'), 'description' => array('text', 'Item Group'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:25:52'), 'last_update' => array('timestamp', '2012-09-04 14:25:52'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '195'), 'type' => array('text', 'typ'), 'title' => array('text', 'rcat'), 'description' => array('text', 'Remote Category Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:26:14'), 'last_update' => array('timestamp', '2012-09-04 14:26:14'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '196'), 'type' => array('text', 'typ'), 'title' => array('text', 'rwik'), 'description' => array('text', 'Remote Wiki Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:26:14'), 'last_update' => array('timestamp', '2012-09-04 14:26:14'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '197'), 'type' => array('text', 'typ'), 'title' => array('text', 'rlm'), 'description' => array('text', 'Remote Learning Module Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:26:15'), 'last_update' => array('timestamp', '2012-09-04 14:26:15'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '198'), 'type' => array('text', 'typ'), 'title' => array('text', 'rglo'), 'description' => array('text', 'Remote Glossary Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:26:15'), 'last_update' => array('timestamp', '2012-09-04 14:26:15'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '199'), 'type' => array('text', 'typ'), 'title' => array('text', 'rfil'), 'description' => array('text', 'Remote File Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:26:16'), 'last_update' => array('timestamp', '2012-09-04 14:26:16'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '200'), 'type' => array('text', 'typ'), 'title' => array('text', 'rgrp'), 'description' => array('text', 'Remote Group Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:26:16'), 'last_update' => array('timestamp', '2012-09-04 14:26:16'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '201'), 'type' => array('text', 'typ'), 'title' => array('text', 'rtst'), 'description' => array('text', 'Remote Test Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-09-04 14:26:17'), 'last_update' => array('timestamp', '2012-09-04 14:26:17'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '202'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_blog_contributor'), 'description' => array('text', 'Contributor template for blogs'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-10-27 19:30:37'), 'last_update' => array('timestamp', '2012-10-27 19:30:37'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '203'), 'type' => array('text', 'typ'), 'title' => array('text', 'ecss'), 'description' => array('text', 'ECS Administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-11-23 17:12:57'), 'last_update' => array('timestamp', '2012-11-23 17:12:57'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '204'), 'type' => array('text', 'ecss'), 'title' => array('text', '__ECSSettings'), 'description' => array('text', 'ECS Administration'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2012-11-23 17:12:57'), 'last_update' => array('timestamp', '2012-11-23 17:12:57'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '205'), 'type' => array('text', 'typ'), 'title' => array('text', 'tos'), 'description' => array('text', 'Terms of Service'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:35'), 'last_update' => array('timestamp', '2013-10-11 18:59:35'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '206'), 'type' => array('text', 'tos'), 'title' => array('text', 'Terms of Service'), 'description' => array('text', 'Terms of Service: Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:35'), 'last_update' => array('timestamp', '2013-10-11 18:59:35'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '207'), 'type' => array('text', 'typ'), 'title' => array('text', 'bibl'), 'description' => array('text', 'Bibliographic Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:37'), 'last_update' => array('timestamp', '2013-10-11 18:59:37'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '208'), 'type' => array('text', 'typ'), 'title' => array('text', 'sysc'), 'description' => array('text', 'System Check'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:40'), 'last_update' => array('timestamp', '2013-10-11 18:59:40'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '209'), 'type' => array('text', 'sysc'), 'title' => array('text', 'System Check'), 'description' => array('text', 'System Check'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:40'), 'last_update' => array('timestamp', '2013-10-11 18:59:40'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '210'), 'type' => array('text', 'typ'), 'title' => array('text', 'cld'), 'description' => array('text', 'Cloud Folder'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:40'), 'last_update' => array('timestamp', '2013-10-11 18:59:40'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '211'), 'type' => array('text', 'typ'), 'title' => array('text', 'reps'), 'description' => array('text', 'Repository Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '212'), 'type' => array('text', 'reps'), 'title' => array('text', 'Repository Settings'), 'description' => array('text', 'Repository Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '213'), 'type' => array('text', 'typ'), 'title' => array('text', 'crss'), 'description' => array('text', 'Course Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '214'), 'type' => array('text', 'crss'), 'title' => array('text', 'Course Settings'), 'description' => array('text', 'Course Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '215'), 'type' => array('text', 'typ'), 'title' => array('text', 'grps'), 'description' => array('text', 'Group Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '216'), 'type' => array('text', 'grps'), 'title' => array('text', 'Group Settings'), 'description' => array('text', 'Group Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '217'), 'type' => array('text', 'typ'), 'title' => array('text', 'wbrs'), 'description' => array('text', 'WebResource Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '218'), 'type' => array('text', 'wbrs'), 'title' => array('text', 'WebResource Settings'), 'description' => array('text', 'WebResource Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 18:59:42'), 'last_update' => array('timestamp', '2013-10-11 18:59:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '219'), 'type' => array('text', 'typ'), 'title' => array('text', 'prtt'), 'description' => array('text', 'Portfolio Template Object'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 19:04:51'), 'last_update' => array('timestamp', '2013-10-11 19:04:51'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '220'), 'type' => array('text', 'typ'), 'title' => array('text', 'orgu'), 'description' => array('text', 'Organisational Unit'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 19:04:52'), 'last_update' => array('timestamp', '2013-10-11 19:04:52'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '221'), 'type' => array('text', 'orgu'), 'title' => array('text', '__OrgUnitAdministration'), 'description' => array('text', 'Organisationsal Units'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 19:04:52'), 'last_update' => array('timestamp', '2013-10-11 19:04:52'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '222'), 'type' => array('text', 'rolt'), 'title' => array('text', 'il_orgu_superior'), 'description' => array('text', 'OrgUnit Superior Role Template'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-10-11 19:04:52'), 'last_update' => array('timestamp', '2013-10-11 19:04:52'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '223'), 'type' => array('text', 'typ'), 'title' => array('text', 'wiks'), 'description' => array('text', 'Wiki Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-11-06 17:13:57'), 'last_update' => array('timestamp', '2013-11-06 17:13:57'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '224'), 'type' => array('text', 'wiks'), 'title' => array('text', 'Wiki Settings'), 'description' => array('text', 'Wiki Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2013-11-06 17:13:57'), 'last_update' => array('timestamp', '2013-11-06 17:13:57'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '225'), 'type' => array('text', 'typ'), 'title' => array('text', 'excs'), 'description' => array('text', 'Exercise Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2014-09-23 21:48:42'), 'last_update' => array('timestamp', '2014-09-23 21:48:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '226'), 'type' => array('text', 'excs'), 'title' => array('text', 'Exercise Settings'), 'description' => array('text', 'Exercise Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2014-09-23 21:48:42'), 'last_update' => array('timestamp', '2014-09-23 21:48:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '227'), 'type' => array('text', 'typ'), 'title' => array('text', 'taxs'), 'description' => array('text', 'Taxonomy Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2014-09-23 21:48:42'), 'last_update' => array('timestamp', '2014-09-23 21:48:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '228'), 'type' => array('text', 'taxs'), 'title' => array('text', 'Taxonomy Settings'), 'description' => array('text', 'Taxonomy Settings'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2014-09-23 21:48:42'), 'last_update' => array('timestamp', '2014-09-23 21:48:42'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '229'), 'type' => array('text', 'typ'), 'title' => array('text', 'bibs'), 'description' => array('text', 'BibliographicAdmin'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2014-09-23 21:48:55'), 'last_update' => array('timestamp', '2014-09-23 21:48:55'), 'import_id' => array('text', '')));

$ilDB->insert("object_data", array(
'obj_id' => array('integer', '230'), 'type' => array('text', 'bibs'), 'title' => array('text', 'BibliographicAdmin'), 'description' => array('text', 'BibliographicAdmin'), 'owner' => array('integer', '-1'), 'create_date' => array('timestamp', '2014-09-23 21:48:55'), 'last_update' => array('timestamp', '2014-09-23 21:48:55'), 'import_id' => array('text', '')));


//
// object_description
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("object_description", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("object_description", $pk_fields);


//
// object_reference
//
$fields = array (
	"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"deleted" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("object_reference", $fields);

$pk_fields = array("ref_id");
$ilDB->addPrimaryKey("object_reference", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("object_reference", $in_fields, "i1", false);

$in_fields = array("deleted");
$ilDB->addIndex("object_reference", $in_fields, "i2", false);

$ilDB->createSequence("object_reference", 61);

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '1'), 'obj_id' => array('integer', '1'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '7'), 'obj_id' => array('integer', '7'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '8'), 'obj_id' => array('integer', '8'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '9'), 'obj_id' => array('integer', '9'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '10'), 'obj_id' => array('integer', '10'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '11'), 'obj_id' => array('integer', '11'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '12'), 'obj_id' => array('integer', '12'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '19'), 'obj_id' => array('integer', '114'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '14'), 'obj_id' => array('integer', '98'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '15'), 'obj_id' => array('integer', '100'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '16'), 'obj_id' => array('integer', '107'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '17'), 'obj_id' => array('integer', '109'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '18'), 'obj_id' => array('integer', '86'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '20'), 'obj_id' => array('integer', '116'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '21'), 'obj_id' => array('integer', '118'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '22'), 'obj_id' => array('integer', '124'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '23'), 'obj_id' => array('integer', '128'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '24'), 'obj_id' => array('integer', '132'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '25'), 'obj_id' => array('integer', '133'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '26'), 'obj_id' => array('integer', '136'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '27'), 'obj_id' => array('integer', '138'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '28'), 'obj_id' => array('integer', '140'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '29'), 'obj_id' => array('integer', '144'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '30'), 'obj_id' => array('integer', '147'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '31'), 'obj_id' => array('integer', '150'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '32'), 'obj_id' => array('integer', '152'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '33'), 'obj_id' => array('integer', '154'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '34'), 'obj_id' => array('integer', '157'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '35'), 'obj_id' => array('integer', '162'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '36'), 'obj_id' => array('integer', '164'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '37'), 'obj_id' => array('integer', '166'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '38'), 'obj_id' => array('integer', '168'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '39'), 'obj_id' => array('integer', '170'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '40'), 'obj_id' => array('integer', '172'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '41'), 'obj_id' => array('integer', '175'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '42'), 'obj_id' => array('integer', '177'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '43'), 'obj_id' => array('integer', '179'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '44'), 'obj_id' => array('integer', '181'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '45'), 'obj_id' => array('integer', '184'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '46'), 'obj_id' => array('integer', '185'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '47'), 'obj_id' => array('integer', '186'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '48'), 'obj_id' => array('integer', '193'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '49'), 'obj_id' => array('integer', '204'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '50'), 'obj_id' => array('integer', '206'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '51'), 'obj_id' => array('integer', '209'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '52'), 'obj_id' => array('integer', '212'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '53'), 'obj_id' => array('integer', '214'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '54'), 'obj_id' => array('integer', '216'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '55'), 'obj_id' => array('integer', '218'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '56'), 'obj_id' => array('integer', '221'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '57'), 'obj_id' => array('integer', '224'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '58'), 'obj_id' => array('integer', '226'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '59'), 'obj_id' => array('integer', '228'), 'deleted' => array('timestamp', '')));

$ilDB->insert("object_reference", array(
'ref_id' => array('integer', '60'), 'obj_id' => array('integer', '230'), 'deleted' => array('timestamp', '')));


//
// object_reference_ws
//
$fields = array (
	"wsp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"deleted" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("object_reference_ws", $fields);

$pk_fields = array("wsp_id");
$ilDB->addPrimaryKey("object_reference_ws", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("object_reference_ws", $in_fields, "i1", false);

$in_fields = array("deleted");
$ilDB->addIndex("object_reference_ws", $in_fields, "i2", false);

$ilDB->createSequence("object_reference_ws", 1);


//
// object_translation
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"lang_code" => array (
		"notnull" => true
		,"length" => 2
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"lang_default" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("object_translation", $fields);

$pk_fields = array("obj_id","lang_code");
$ilDB->addPrimaryKey("object_translation", $pk_fields);

$ilDB->insert("object_translation", array(
'obj_id' => array('integer', '9'), 'title' => array('text', 'Open Source eLearning'), 'description' => array('text', ''), 'lang_code' => array('text', 'en'), 'lang_default' => array('integer', '1')));


//
// openid_provider
//
$fields = array (
	"provider_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"url" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"image" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("openid_provider", $fields);

$pk_fields = array("provider_id");
$ilDB->addPrimaryKey("openid_provider", $pk_fields);

$ilDB->createSequence("openid_provider", 2);

$ilDB->insert("openid_provider", array(
'provider_id' => array('integer', '1'), 'enabled' => array('integer', '1'), 'name' => array('text', 'MyOpenID'), 'url' => array('text', 'http://%s.myopenid.com'), 'image' => array('integer', '1')));


//
// orgu_data
//
$fields = array (
	"orgu_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"orgu_type_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("orgu_data", $fields);

$pk_fields = array("orgu_id");
$ilDB->addPrimaryKey("orgu_data", $pk_fields);


//
// orgu_types
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"default_lang" => array (
		"notnull" => true
		,"length" => 4
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"icon" => array (
		"notnull" => false
		,"length" => 256
		,"fixed" => false
		,"type" => "text"
	)
	,"owner" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("orgu_types", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("orgu_types", $pk_fields);

$ilDB->createSequence("orgu_types", 1);


//
// orgu_types_adv_md_rec
//
$fields = array (
	"type_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"rec_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("orgu_types_adv_md_rec", $fields);

$pk_fields = array("type_id","rec_id");
$ilDB->addPrimaryKey("orgu_types_adv_md_rec", $pk_fields);


//
// orgu_types_trans
//
$fields = array (
	"orgu_type_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"lang" => array (
		"notnull" => true
		,"length" => 4
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"member" => array (
		"notnull" => true
		,"length" => 32
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("orgu_types_trans", $fields);

$pk_fields = array("orgu_type_id","lang","member");
$ilDB->addPrimaryKey("orgu_types_trans", $pk_fields);


//
// page_anchor
//
$fields = array (
	"page_parent_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"anchor_name" => array (
		"notnull" => true
		,"length" => 120
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"page_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("page_anchor", $fields);

$pk_fields = array("page_parent_type","page_id","page_lang","anchor_name");
$ilDB->addPrimaryKey("page_anchor", $pk_fields);


//
// page_editor_settings
//
$fields = array (
	"settings_grp" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("page_editor_settings", $fields);

$pk_fields = array("settings_grp","name");
$ilDB->addPrimaryKey("page_editor_settings", $pk_fields);


//
// page_history
//
$fields = array (
	"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent_type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"hdate" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"nr" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"content" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"ilias_version" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("page_history", $fields);

$pk_fields = array("page_id","parent_type","hdate","lang");
$ilDB->addPrimaryKey("page_history", $pk_fields);

$in_fields = array("page_id");
$ilDB->addIndex("page_history", $in_fields, "i1", false);

$in_fields = array("parent_id","parent_type","hdate");
$ilDB->addIndex("page_history", $in_fields, "i2", false);


//
// page_layout
//
$fields = array (
	"layout_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"content" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"style_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"special_page" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mod_scorm" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"mod_portfolio" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("page_layout", $fields);

$pk_fields = array("layout_id");
$ilDB->addPrimaryKey("page_layout", $pk_fields);

$ilDB->createSequence("page_layout", 6);

$ilDB->insert("page_layout", array(
'layout_id' => array('integer', '1'), 'content' => array('clob', ''), 'title' => array('text', '1A Simple text page with accompanying media'), 'description' => array('text', 'Example description'), 'active' => array('integer', '1'), 'style_id' => array('integer', '0'), 'special_page' => array('integer', '0'), 'mod_scorm' => array('integer', '1'), 'mod_portfolio' => array('integer', '')));

$ilDB->insert("page_layout", array(
'layout_id' => array('integer', '2'), 'content' => array('clob', ''), 'title' => array('text', '1C Text page with accompanying media and test'), 'description' => array('text', ''), 'active' => array('integer', '1'), 'style_id' => array('integer', '0'), 'special_page' => array('integer', '0'), 'mod_scorm' => array('integer', '1'), 'mod_portfolio' => array('integer', '')));

$ilDB->insert("page_layout", array(
'layout_id' => array('integer', '3'), 'content' => array('clob', ''), 'title' => array('text', '1E Text page with accompanying media followed by test and text'), 'description' => array('text', ''), 'active' => array('integer', '1'), 'style_id' => array('integer', '0'), 'special_page' => array('integer', '0'), 'mod_scorm' => array('integer', '1'), 'mod_portfolio' => array('integer', '')));

$ilDB->insert("page_layout", array(
'layout_id' => array('integer', '4'), 'content' => array('clob', ''), 'title' => array('text', '2C Simple media page with accompanying text and test'), 'description' => array('text', ''), 'active' => array('integer', '1'), 'style_id' => array('integer', '0'), 'special_page' => array('integer', '0'), 'mod_scorm' => array('integer', '1'), 'mod_portfolio' => array('integer', '')));

$ilDB->insert("page_layout", array(
'layout_id' => array('integer', '5'), 'content' => array('clob', ''), 'title' => array('text', '7C Vertical component navigation page with media and text'), 'description' => array('text', ''), 'active' => array('integer', '1'), 'style_id' => array('integer', '0'), 'special_page' => array('integer', '0'), 'mod_scorm' => array('integer', '1'), 'mod_portfolio' => array('integer', '')));


//
// page_object
//
$fields = array (
	"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"content" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"parent_type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => "lm"
		,"fixed" => false
		,"type" => "text"
	)
	,"last_change_user" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"view_cnt" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_change" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"created" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"create_user" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"render_md5" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"rendered_content" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rendered_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"activation_start" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"activation_end" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"active" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"is_empty" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"inactive_elements" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"int_links" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"show_activation_info" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
	,"edit_lock_user" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"edit_lock_ts" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("page_object", $fields);

$pk_fields = array("page_id","parent_type","lang");
$ilDB->addPrimaryKey("page_object", $pk_fields);

$in_fields = array("parent_id","parent_type","last_change");
$ilDB->addIndex("page_object", $in_fields, "i3", false);

$in_fields = array("content");
$ilDB->addIndex("page_object", $in_fields, "i1", true);

$ilDB->insert("page_object", array(
'page_id' => array('integer', '1'), 'parent_id' => array('integer', ''), 'content' => array('clob', '<PageObject><PageContent PCID="9f77db1d8a478497d69b99d938faa8ff"><Paragraph Language="en" Characteristic="Headline1">Headline 1</Paragraph></PageContent><PageContent PCID="134d24457cbc90ea1bf1a1323d7c3a89"><Table Language="en" Border="0px" CellPadding="2px" CellSpacing="0px" HorizontalAlign="Left" Width="100%"><TableRow PCID="ccade07caf9fd13e8c7012f29c9510be"><TableData PCID="a4e417c08feebeafb1487e60a2e245a4" Width="66%"><PageContent PCID="1f77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Text" Height="500px"/></PageContent></TableData><TableData PCID="46ac4936082485f457c7041278b5c5f5"><PageContent PCID="2e77eb1d8a478497d69b99d938fda8e"><PlaceHolder ContentClass="Media" Height="300px"/></PageContent></TableData> </TableRow></Table></PageContent></PageObject>'), 'parent_type' => array('text', 'stys'), 'last_change_user' => array('integer', ''), 'view_cnt' => array('integer', '0'), 'last_change' => array('timestamp', ''), 'created' => array('timestamp', ''), 'create_user' => array('integer', ''), 'render_md5' => array('text', ''), 'rendered_content' => array('clob', ''), 'rendered_time' => array('timestamp', ''), 'activation_start' => array('timestamp', ''), 'activation_end' => array('timestamp', ''), 'active' => array('integer', '1'), 'is_empty' => array('integer', '0'), 'inactive_elements' => array('integer', '0'), 'int_links' => array('integer', '0'), 'show_activation_info' => array('integer', '0'), 'lang' => array('text', '-'), 'edit_lock_user' => array('integer', ''), 'edit_lock_ts' => array('integer', '0')));

$ilDB->insert("page_object", array(
'page_id' => array('integer', '2'), 'parent_id' => array('integer', ''), 'content' => array('clob', '<PageObject><PageContent PCID="9f77db1d8a478497d69b99d938faa8ff"><Paragraph Language="en" Characteristic="Headline1">Headline 1</Paragraph></PageContent><PageContent PCID="134d24457cbc90ea1bf1a1323d7c3a89"><Table Language="en" Border="0px" CellPadding="2px" CellSpacing="0px" HorizontalAlign="Left" Width="100%"><TableRow PCID="ccade07caf9fd13e8c7012f29c9510be"><TableData PCID="a4e417c08feebeafb1487e60a2e245a4" Width="66%"><PageContent PCID="1f77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Text" Height="300px"/></PageContent><PageContent PCID="3f77eb1d8a478493d69b99d438fda8f"><PlaceHolder ContentClass="Question" Height="200px"/></PageContent></TableData><TableData PCID="46ac4936082485f457c7041278b5c5f5"><PageContent PCID="2e77eb1d8a478497d69b99d938fda8e"><PlaceHolder ContentClass="Media" Height="300px"/></PageContent></TableData> </TableRow></Table></PageContent></PageObject>'), 'parent_type' => array('text', 'stys'), 'last_change_user' => array('integer', ''), 'view_cnt' => array('integer', '0'), 'last_change' => array('timestamp', ''), 'created' => array('timestamp', ''), 'create_user' => array('integer', ''), 'render_md5' => array('text', ''), 'rendered_content' => array('clob', ''), 'rendered_time' => array('timestamp', ''), 'activation_start' => array('timestamp', ''), 'activation_end' => array('timestamp', ''), 'active' => array('integer', '1'), 'is_empty' => array('integer', '0'), 'inactive_elements' => array('integer', '0'), 'int_links' => array('integer', '0'), 'show_activation_info' => array('integer', '0'), 'lang' => array('text', '-'), 'edit_lock_user' => array('integer', ''), 'edit_lock_ts' => array('integer', '0')));

$ilDB->insert("page_object", array(
'page_id' => array('integer', '3'), 'parent_id' => array('integer', ''), 'content' => array('clob', '<PageObject><PageContent PCID="9f77db1d8a478497d69b99d938faa8ff"><Paragraph Language="en" Characteristic="Headline1">Headline 1</Paragraph></PageContent><PageContent PCID="134d24457cbc90ea1bf1a1323d7c3a89"><Table Language="en" Border="0px" CellPadding="2px" CellSpacing="0px" HorizontalAlign="Left" Width="100%"><TableRow PCID="ccade07caf9fd13e8c7012f29c9510be"><TableData PCID="a4e417c08feebeafb1487e60a2e245a4" Width="66%"><PageContent PCID="1f77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Text" Height="300px"/></PageContent><PageContent PCID="3f77eb1d8a478493d69b99d438fda8f"><PlaceHolder ContentClass="Question" Height="200px"/></PageContent><PageContent PCID="9b77eb1d8a478197d69b99d938fea8f"><PlaceHolder ContentClass="Text" Height="200px"/></PageContent></TableData><TableData PCID="46ac4936082485f457c7041278b5c5f5"><PageContent PCID="2e77eb1d8a478497d69b99d938fda8e"><PlaceHolder ContentClass="Media" Height="300px"/></PageContent></TableData> </TableRow></Table></PageContent></PageObject>'), 'parent_type' => array('text', 'stys'), 'last_change_user' => array('integer', ''), 'view_cnt' => array('integer', '0'), 'last_change' => array('timestamp', ''), 'created' => array('timestamp', ''), 'create_user' => array('integer', ''), 'render_md5' => array('text', ''), 'rendered_content' => array('clob', ''), 'rendered_time' => array('timestamp', ''), 'activation_start' => array('timestamp', ''), 'activation_end' => array('timestamp', ''), 'active' => array('integer', '1'), 'is_empty' => array('integer', '0'), 'inactive_elements' => array('integer', '0'), 'int_links' => array('integer', '0'), 'show_activation_info' => array('integer', '0'), 'lang' => array('text', '-'), 'edit_lock_user' => array('integer', ''), 'edit_lock_ts' => array('integer', '0')));

$ilDB->insert("page_object", array(
'page_id' => array('integer', '4'), 'parent_id' => array('integer', ''), 'content' => array('clob', '<PageObject><PageContent PCID="9f77db1d8a478497d69b99d938faa8ff"><Paragraph Language="en" Characteristic="Headline1">Headline 1</Paragraph></PageContent><PageContent PCID="134d24457cbc90ea1bf1a1323d7c3a89"><Table Language="en" Border="0px" CellPadding="2px" CellSpacing="0px" HorizontalAlign="Left" Width="100%"><TableRow PCID="ccade07caf9fd13e8c7012f29c9510be"><TableData PCID="46ac4936082485f457c7041278b5c5f5"><PageContent PCID="2e77eb1d8a478497d69b99d938fda8e"><PlaceHolder ContentClass="Media" Height="300px"/></PageContent></TableData><TableData PCID="a4e417c08feebeafb1487e60a2e245a4" Width="66%"><PageContent PCID="1f77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Text" Height="300px"/></PageContent><PageContent PCID="3f77eb1d8a478493d69b99d438fda8f"><PlaceHolder ContentClass="Question" Height="200px"/></PageContent></TableData></TableRow></Table></PageContent></PageObject>'), 'parent_type' => array('text', 'stys'), 'last_change_user' => array('integer', ''), 'view_cnt' => array('integer', '0'), 'last_change' => array('timestamp', ''), 'created' => array('timestamp', ''), 'create_user' => array('integer', ''), 'render_md5' => array('text', ''), 'rendered_content' => array('clob', ''), 'rendered_time' => array('timestamp', ''), 'activation_start' => array('timestamp', ''), 'activation_end' => array('timestamp', ''), 'active' => array('integer', '1'), 'is_empty' => array('integer', '0'), 'inactive_elements' => array('integer', '0'), 'int_links' => array('integer', '0'), 'show_activation_info' => array('integer', '0'), 'lang' => array('text', '-'), 'edit_lock_user' => array('integer', ''), 'edit_lock_ts' => array('integer', '0')));

$ilDB->insert("page_object", array(
'page_id' => array('integer', '5'), 'parent_id' => array('integer', ''), 'content' => array('clob', '<PageObject><PageContent PCID="9f77db1d8a478497d69b99d938faa8ff"><Paragraph Language="en" Characteristic="Headline1">Headline 1</Paragraph></PageContent><PageContent PCID="134d24457cbc90ea1bf1a1323d7c3a89"><Table Language="en" Border="0px" CellPadding="2px" CellSpacing="0px" HorizontalAlign="Left" Width="100%"><TableRow PCID="ccade07caf9fd13e8c7012f29c9510be"><TableData PCID="a4e417c08feebeafb1487e60a2e245a4" Width="100%"><PageContent PCID="1f77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Text" Height="300px"/></PageContent></TableData> </TableRow><TableRow PCID="efade08caf9fd13e8c7012f29c9510be"><TableData PCID="a4e417c08feebeafb1487e60a2e245a4" Width="100%"><PageContent PCID="124d24457cbc90ea1bf1a1323d7c3b89"><Table Language="en" Border="0px" CellPadding="2px" CellSpacing="0px" HorizontalAlign="Left" Width="100%"><TableRow PCID="dfade09caf9fd13e8c7012f29c9510be"><TableData PCID="e4e417c08feebeafb1487e60a2e245a5" Width="33%"><PageContent PCID="3e77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Media" Height="150px"/></PageContent><PageContent PCID="4e77eb1d8a478497d69b99d938fda8e"><PlaceHolder ContentClass="Text" Height="250px"/></PageContent></TableData><TableData PCID="a4e417c08feebeafb1487e60a2e245a5" Width="33%"><PageContent PCID="3a77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Media" Height="150px"/></PageContent><PageContent PCID="4ea7eb1d8a478497d69b99d938fda8e"><PlaceHolder ContentClass="Text" Height="250px"/></PageContent></TableData><TableData PCID="b4e417c08feebeafb1487e60a2e245a5" Width="33%"><PageContent PCID="3b77eb1d8a478497d69b99d938fda8f"><PlaceHolder ContentClass="Media" Height="150px"/></PageContent><PageContent PCID="4b77eb1d8a478497d69b99d938fda8e"><PlaceHolder ContentClass="Text" Height="250px"/></PageContent></TableData></TableRow></Table></PageContent></TableData></TableRow></Table></PageContent></PageObject>'), 'parent_type' => array('text', 'stys'), 'last_change_user' => array('integer', ''), 'view_cnt' => array('integer', '0'), 'last_change' => array('timestamp', ''), 'created' => array('timestamp', ''), 'create_user' => array('integer', ''), 'render_md5' => array('text', ''), 'rendered_content' => array('clob', ''), 'rendered_time' => array('timestamp', ''), 'activation_start' => array('timestamp', ''), 'activation_end' => array('timestamp', ''), 'active' => array('integer', '1'), 'is_empty' => array('integer', '0'), 'inactive_elements' => array('integer', '0'), 'int_links' => array('integer', '0'), 'show_activation_info' => array('integer', '0'), 'lang' => array('text', '-'), 'edit_lock_user' => array('integer', ''), 'edit_lock_ts' => array('integer', '0')));


//
// page_pc_usage
//
$fields = array (
	"pc_type" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"pc_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usage_type" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"usage_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usage_hist_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usage_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("page_pc_usage", $fields);

$pk_fields = array("pc_type","pc_id","usage_type","usage_id","usage_hist_nr","usage_lang");
$ilDB->addPrimaryKey("page_pc_usage", $pk_fields);


//
// page_qst_answer
//
$fields = array (
	"qst_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"try" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"passed" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"points" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "float"
	)
	,"unlocked" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("page_qst_answer", $fields);

$pk_fields = array("qst_id","user_id");
$ilDB->addPrimaryKey("page_qst_answer", $pk_fields);


//
// page_question
//
$fields = array (
	"page_parent_type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => false
		,"type" => "text"
	)
	,"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"page_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("page_question", $fields);

$in_fields = array("page_parent_type","page_id","page_lang");
$ilDB->addIndex("page_question", $in_fields, "i1", false);

$in_fields = array("question_id");
$ilDB->addIndex("page_question", $in_fields, "i2", false);


//
// page_style_usage
//
$fields = array (
	"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"page_type" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"page_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"template" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"stype" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"sname" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => true
		,"type" => "text"
	)
	,"page_lang" => array (
		"notnull" => true
		,"length" => 2
		,"default" => "-"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("page_style_usage", $fields);


//
// payment_coupons
//
$fields = array (
	"pc_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pc_title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"pc_description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"pc_type" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "fix"
		,"fixed" => true
		,"type" => "text"
	)
	,"pc_value" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"pc_from" => array (
		"notnull" => false
		,"type" => "date"
	)
	,"pc_till" => array (
		"notnull" => false
		,"type" => "date"
	)
	,"pc_from_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pc_till_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pc_uses" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pc_last_change_usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pc_last_changed" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("payment_coupons", $fields);

$pk_fields = array("pc_pk");
$ilDB->addPrimaryKey("payment_coupons", $pk_fields);

$in_fields = array("usr_id");
$ilDB->addIndex("payment_coupons", $in_fields, "i1", false);

$ilDB->createSequence("payment_coupons", 1);


//
// payment_coupons_codes
//
$fields = array (
	"pcc_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pcc_pc_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pcc_code" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("payment_coupons_codes", $fields);

$pk_fields = array("pcc_pk");
$ilDB->addPrimaryKey("payment_coupons_codes", $pk_fields);

$in_fields = array("pcc_pc_fk");
$ilDB->addIndex("payment_coupons_codes", $in_fields, "i1", false);

$ilDB->createSequence("payment_coupons_codes", 1);


//
// payment_coupons_obj
//
$fields = array (
	"pco_pc_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_coupons_obj", $fields);

$pk_fields = array("pco_pc_fk","ref_id");
$ilDB->addPrimaryKey("payment_coupons_obj", $pk_fields);


//
// payment_coupons_track
//
$fields = array (
	"pct_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pct_pcc_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pct_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("payment_coupons_track", $fields);

$pk_fields = array("pct_pk");
$ilDB->addPrimaryKey("payment_coupons_track", $pk_fields);

$in_fields = array("pct_pcc_fk");
$ilDB->addIndex("payment_coupons_track", $in_fields, "i1", false);

$in_fields = array("usr_id");
$ilDB->addIndex("payment_coupons_track", $in_fields, "i2", false);

$ilDB->createSequence("payment_coupons_track", 1);


//
// payment_currencies
//
$fields = array (
	"currency_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"unit" => array (
		"notnull" => true
		,"length" => 16
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"iso_code" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => false
		,"type" => "text"
	)
	,"symbol" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => false
		,"type" => "text"
	)
	,"conversion_rate" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
);
$ilDB->createTable("payment_currencies", $fields);

$pk_fields = array("currency_id");
$ilDB->addPrimaryKey("payment_currencies", $pk_fields);

$ilDB->createSequence("payment_currencies", 1);


//
// payment_erp
//
$fields = array (
	"erp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"erp_short" => array (
		"notnull" => true
		,"length" => 12
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 32
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
	,"url" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"save_copy" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"use_ean" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_erp", $fields);

$pk_fields = array("erp_id");
$ilDB->addPrimaryKey("payment_erp", $pk_fields);

$ilDB->insert("payment_erp", array(
'erp_id' => array('integer', '0'), 'erp_short' => array('text', 'none'), 'name' => array('text', 'none'), 'description' => array('text', 'No ERP system'), 'url' => array('text', ''), 'save_copy' => array('integer', '0'), 'use_ean' => array('integer', '0')));

$ilDB->insert("payment_erp", array(
'erp_id' => array('integer', '1'), 'erp_short' => array('text', 'eco'), 'name' => array('text', 'E-conomic'), 'description' => array('text', 'E-conomic online accounting system. Available in Danish, Deutch, Spanish, Norwegian, Swedish and English.'), 'url' => array('text', 'http://www.e-conomic.dk'), 'save_copy' => array('integer', '1'), 'use_ean' => array('integer', '1')));


//
// payment_erps
//
$fields = array (
	"erp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"erps_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"settings" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("payment_erps", $fields);

$pk_fields = array("erp_id","erps_id");
$ilDB->addPrimaryKey("payment_erps", $pk_fields);

$ilDB->insert("payment_erps", array(
'erp_id' => array('integer', '0'), 'erps_id' => array('integer', '0'), 'active' => array('integer', '1'), 'settings' => array('text', '')));

$ilDB->insert("payment_erps", array(
'erp_id' => array('integer', '1'), 'erps_id' => array('integer', '0'), 'active' => array('integer', '0'), 'settings' => array('text', '')));


//
// payment_news
//
$fields = array (
	"news_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"news_title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"creation_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"update_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"visibility" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "users"
		,"fixed" => false
		,"type" => "text"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"news_content" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("payment_news", $fields);

$pk_fields = array("news_id");
$ilDB->addPrimaryKey("payment_news", $pk_fields);

$in_fields = array("creation_date");
$ilDB->addIndex("payment_news", $in_fields, "i1", false);

$ilDB->createSequence("payment_news", 1);


//
// payment_objects
//
$fields = array (
	"pobject_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pay_method" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"vendor_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pt_topic_fk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"image" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"vat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"subtype" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"is_special" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_objects", $fields);

$pk_fields = array("pobject_id");
$ilDB->addPrimaryKey("payment_objects", $pk_fields);

$ilDB->createSequence("payment_objects", 1);


//
// payment_paymethods
//
$fields = array (
	"pm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pm_title" => array (
		"notnull" => true
		,"length" => 60
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"pm_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"save_usr_adr" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_paymethods", $fields);

$pk_fields = array("pm_id");
$ilDB->addPrimaryKey("payment_paymethods", $pk_fields);

$ilDB->createSequence("payment_paymethods", 5);

$ilDB->insert("payment_paymethods", array(
'pm_id' => array('integer', '1'), 'pm_title' => array('text', 'bill'), 'pm_enabled' => array('integer', '0'), 'save_usr_adr' => array('integer', '0')));

$ilDB->insert("payment_paymethods", array(
'pm_id' => array('integer', '2'), 'pm_title' => array('text', 'bmf'), 'pm_enabled' => array('integer', '0'), 'save_usr_adr' => array('integer', '0')));

$ilDB->insert("payment_paymethods", array(
'pm_id' => array('integer', '3'), 'pm_title' => array('text', 'paypal'), 'pm_enabled' => array('integer', '0'), 'save_usr_adr' => array('integer', '0')));

$ilDB->insert("payment_paymethods", array(
'pm_id' => array('integer', '4'), 'pm_title' => array('text', 'epay'), 'pm_enabled' => array('integer', '0'), 'save_usr_adr' => array('integer', '0')));


//
// payment_prices
//
$fields = array (
	"price_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pobject_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"duration" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"currency" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"price" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"unlimited_duration" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"extension" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"duration_from" => array (
		"notnull" => false
		,"type" => "date"
	)
	,"duration_until" => array (
		"notnull" => false
		,"type" => "date"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"price_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_prices", $fields);

$pk_fields = array("price_id");
$ilDB->addPrimaryKey("payment_prices", $pk_fields);

$ilDB->createSequence("payment_prices", 1);


//
// payment_settings
//
$fields = array (
	"keyword" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"scope" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("payment_settings", $fields);

$pk_fields = array("keyword");
$ilDB->addPrimaryKey("payment_settings", $pk_fields);

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'settings_id'), 'value' => array('clob', '0'), 'scope' => array('text', '')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'currency_unit'), 'value' => array('clob', ''), 'scope' => array('text', 'currencies')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'currency_subunit'), 'value' => array('clob', ''), 'scope' => array('text', 'currencies')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'address'), 'value' => array('clob', ''), 'scope' => array('text', 'invoice')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'bank_data'), 'value' => array('clob', ''), 'scope' => array('text', 'invoice')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'add_info'), 'value' => array('clob', ''), 'scope' => array('text', 'invoice')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'pdf_path'), 'value' => array('clob', ''), 'scope' => array('text', 'invoice')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'paypal'), 'value' => array('clob', ''), 'scope' => array('text', 'paypal')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'bmf'), 'value' => array('clob', ''), 'scope' => array('text', 'bmf')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'topics_allow_custom_sorting'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'topics_sorting_type'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'topics_sorting_direction'), 'value' => array('clob', ''), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'shop_enabled'), 'value' => array('clob', '0'), 'scope' => array('text', 'common')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'max_hits'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'hide_advanced_search'), 'value' => array('clob', ''), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'objects_allow_custom_sorting'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'hide_coupons'), 'value' => array('clob', ''), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'epay '), 'value' => array('clob', ''), 'scope' => array('text', '')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'hide_news'), 'value' => array('clob', ''), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'mail_use_placeholders'), 'value' => array('clob', '0'), 'scope' => array('text', 'invoice')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'mail_billing_text'), 'value' => array('clob', ''), 'scope' => array('text', 'invoice')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'hide_shop_info'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'use_shop_specials'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'ud_invoice_number'), 'value' => array('clob', '0'), 'scope' => array('text', 'invoice_number')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'invoice_number_text'), 'value' => array('clob', ''), 'scope' => array('text', 'invoice_number')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'inc_start_value'), 'value' => array('clob', '0'), 'scope' => array('text', 'invoice_number')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'inc_current_value'), 'value' => array('clob', '0'), 'scope' => array('text', '')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'inc_reset_period'), 'value' => array('clob', '0'), 'scope' => array('text', 'invoice_number')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'inc_last_reset'), 'value' => array('clob', ''), 'scope' => array('text', 'invoice_number')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'show_general_filter'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'show_topics_filter'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'show_shop_explorer'), 'value' => array('clob', '0'), 'scope' => array('text', 'gui')));

$ilDB->insert("payment_settings", array(
'keyword' => array('text', 'enable_topics'), 'value' => array('clob', '1'), 'scope' => array('text', 'gui')));


//
// payment_shopping_cart
//
$fields = array (
	"psc_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"customer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pobject_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"price_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"session_id" => array (
		"notnull" => true
		,"length" => 80
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("payment_shopping_cart", $fields);

$pk_fields = array("psc_id");
$ilDB->addPrimaryKey("payment_shopping_cart", $pk_fields);

$ilDB->createSequence("payment_shopping_cart", 1);


//
// payment_statistic
//
$fields = array (
	"booking_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"transaction" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"pobject_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"customer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"b_vendor_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"b_pay_method" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"order_date" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"duration" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
	,"price" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"discount" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"payed" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"access_granted" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"voucher" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"transaction_extern" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => true
		,"type" => "text"
	)
	,"street" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"po_box" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"zipcode" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"city" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"country" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"vat_rate" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"vat_unit" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"object_title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"currency_unit" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"email_extern" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"name_extern" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"access_enddate" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"access_startdate" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("payment_statistic", $fields);

$pk_fields = array("booking_id");
$ilDB->addPrimaryKey("payment_statistic", $pk_fields);

$ilDB->createSequence("payment_statistic", 1);


//
// payment_statistic_coup
//
$fields = array (
	"psc_ps_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"psc_pc_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"psc_pcc_fk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_statistic_coup", $fields);

$in_fields = array("psc_ps_fk");
$ilDB->addIndex("payment_statistic_coup", $in_fields, "i1", false);

$in_fields = array("psc_pc_fk");
$ilDB->addIndex("payment_statistic_coup", $in_fields, "i2", false);

$in_fields = array("psc_pcc_fk");
$ilDB->addIndex("payment_statistic_coup", $in_fields, "i3", false);


//
// payment_topic_usr_sort
//
$fields = array (
	"ptus_pt_topic_fk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ptus_usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ptus_sorting" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_topic_usr_sort", $fields);

$pk_fields = array("ptus_pt_topic_fk","ptus_usr_id");
$ilDB->addPrimaryKey("payment_topic_usr_sort", $pk_fields);


//
// payment_topics
//
$fields = array (
	"pt_topic_pk" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pt_topic_title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"pt_topic_sort" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pt_topic_created" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pt_topic_changed" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_topics", $fields);

$pk_fields = array("pt_topic_pk");
$ilDB->addPrimaryKey("payment_topics", $pk_fields);

$ilDB->createSequence("payment_topics", 1);


//
// payment_trustees
//
$fields = array (
	"vendor_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"trustee_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"perm_stat" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"perm_obj" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"perm_coupons" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("payment_trustees", $fields);

$pk_fields = array("vendor_id","trustee_id");
$ilDB->addPrimaryKey("payment_trustees", $pk_fields);


//
// payment_vats
//
$fields = array (
	"vat_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"vat_title" => array (
		"notnull" => true
		,"length" => 255
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"vat_rate" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
);
$ilDB->createTable("payment_vats", $fields);

$pk_fields = array("vat_id");
$ilDB->addPrimaryKey("payment_vats", $pk_fields);

$ilDB->createSequence("payment_vats", 1);


//
// payment_vendors
//
$fields = array (
	"vendor_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cost_center" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("payment_vendors", $fields);

$pk_fields = array("vendor_id");
$ilDB->addPrimaryKey("payment_vendors", $pk_fields);


//
// personal_clipboard
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 70
		,"fixed" => true
		,"type" => "text"
	)
	,"insert_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"parent" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("personal_clipboard", $fields);

$pk_fields = array("user_id","item_id","type");
$ilDB->addPrimaryKey("personal_clipboard", $pk_fields);

$in_fields = array("item_id","type");
$ilDB->addIndex("personal_clipboard", $in_fields, "it", false);


//
// personal_pc_clipboard
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"content" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"insert_time" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"order_nr" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("personal_pc_clipboard", $fields);

$in_fields = array("user_id");
$ilDB->addIndex("personal_pc_clipboard", $in_fields, "i1", false);


//
// pg_amd_page_list
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"data" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("pg_amd_page_list", $fields);

$pk_fields = array("id","field_id");
$ilDB->addPrimaryKey("pg_amd_page_list", $pk_fields);

$ilDB->createSequence("pg_amd_page_list", 1);


//
// preview_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"render_date" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"render_status" => array (
		"notnull" => true
		,"length" => 20
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("preview_data", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("preview_data", $pk_fields);


//
// qpl_a_cloze
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"shuffle" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"aorder" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"gap_id" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cloze_type" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"lowerlimit" => array (
		"notnull" => false
		,"length" => 20
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"upperlimit" => array (
		"notnull" => false
		,"length" => 20
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"gap_size" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_cloze", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_cloze", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_cloze", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_cloze", 1);


//
// qpl_a_cloze_combi_res
//
$fields = array (
	"combination_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"gap_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"answer" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"best_solution" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"row_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_cloze_combi_res", $fields);


//
// qpl_a_errortext
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"text_wrong" => array (
		"notnull" => true
		,"length" => 150
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"text_correct" => array (
		"notnull" => false
		,"length" => 150
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_errortext", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_errortext", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_errortext", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_errortext", 1);


//
// qpl_a_essay
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => false
		,"type" => "float"
	)
);
$ilDB->createTable("qpl_a_essay", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_essay", $pk_fields);

$ilDB->createSequence("qpl_a_essay", 1);


//
// qpl_a_imagemap
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"aorder" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"coords" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"area" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"points_unchecked" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
);
$ilDB->createTable("qpl_a_imagemap", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_imagemap", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_imagemap", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_imagemap", 1);


//
// qpl_a_kprim
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"position" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"imagefile" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"correctness" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_kprim", $fields);

$pk_fields = array("question_fi","position");
$ilDB->addPrimaryKey("qpl_a_kprim", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_kprim", $in_fields, "i1", false);


//
// qpl_a_matching
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"term_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"definition_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_matching", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_matching", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_matching", $in_fields, "i1", false);

$in_fields = array("term_fi");
$ilDB->addIndex("qpl_a_matching", $in_fields, "i2", false);

$ilDB->createSequence("qpl_a_matching", 1);


//
// qpl_a_mc
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"imagefile" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"points_unchecked" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"aorder" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_mc", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_mc", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_mc", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_mc", 1);


//
// qpl_a_mdef
//
$fields = array (
	"def_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"definition" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"morder" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"picture" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("qpl_a_mdef", $fields);

$pk_fields = array("def_id");
$ilDB->addPrimaryKey("qpl_a_mdef", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_mdef", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_mdef", 1);


//
// qpl_a_mterm
//
$fields = array (
	"term_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"term" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"picture" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("qpl_a_mterm", $fields);

$pk_fields = array("term_id");
$ilDB->addPrimaryKey("qpl_a_mterm", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_mterm", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_mterm", 1);


//
// qpl_a_ordering
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"solution_order" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"random_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_ordering", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_ordering", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_ordering", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_ordering", 1);


//
// qpl_a_sc
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"imagefile" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"aorder" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_sc", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_sc", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_sc", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_sc", 1);


//
// qpl_a_textsubset
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answertext" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"aorder" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_a_textsubset", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("qpl_a_textsubset", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_a_textsubset", $in_fields, "i1", false);

$ilDB->createSequence("qpl_a_textsubset", 1);


//
// qpl_fb_generic
//
$fields = array (
	"feedback_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"correctness" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"feedback" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("qpl_fb_generic", $fields);

$pk_fields = array("feedback_id");
$ilDB->addPrimaryKey("qpl_fb_generic", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_fb_generic", $in_fields, "i1", false);

$ilDB->createSequence("qpl_fb_generic", 1);


//
// qpl_fb_specific
//
$fields = array (
	"feedback_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"answer" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"feedback" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("qpl_fb_specific", $fields);

$pk_fields = array("feedback_id");
$ilDB->addPrimaryKey("qpl_fb_specific", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_fb_specific", $in_fields, "i1", false);

$ilDB->createSequence("qpl_fb_specific", 1);


//
// qpl_hint_tracking
//
$fields = array (
	"qhtr_track_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qhtr_active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qhtr_pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qhtr_question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qhtr_hint_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_hint_tracking", $fields);

$pk_fields = array("qhtr_track_id");
$ilDB->addPrimaryKey("qpl_hint_tracking", $pk_fields);

$ilDB->createSequence("qpl_hint_tracking", 1);


//
// qpl_hints
//
$fields = array (
	"qht_hint_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qht_question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qht_hint_index" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qht_hint_points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"qht_hint_text" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("qpl_hints", $fields);

$pk_fields = array("qht_hint_id");
$ilDB->addPrimaryKey("qpl_hints", $pk_fields);

$ilDB->createSequence("qpl_hints", 1);


//
// qpl_num_range
//
$fields = array (
	"range_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lowerlimit" => array (
		"notnull" => false
		,"length" => 20
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"upperlimit" => array (
		"notnull" => false
		,"length" => 20
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"aorder" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_num_range", $fields);

$pk_fields = array("range_id");
$ilDB->addPrimaryKey("qpl_num_range", $pk_fields);

$ilDB->createSequence("qpl_num_range", 1);


//
// qpl_qst_cloze
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"textgap_rating" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => false
		,"type" => "text"
	)
	,"identical_scoring" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"fixed_textlen" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"cloze_text" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("qpl_qst_cloze", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_cloze", $pk_fields);


//
// qpl_qst_errortext
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"errortext" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"textsize" => array (
		"notnull" => true
		,"default" => "100"
		,"type" => "float"
	)
	,"points_wrong" => array (
		"notnull" => true
		,"default" => "-1"
		,"type" => "float"
	)
);
$ilDB->createTable("qpl_qst_errortext", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_errortext", $pk_fields);


//
// qpl_qst_essay
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"maxnumofchars" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"keywords" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"textgap_rating" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => false
		,"type" => "text"
	)
	,"matchcondition" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"keyword_relation" => array (
		"notnull" => true
		,"length" => 3
		,"default" => "any"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("qpl_qst_essay", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_essay", $pk_fields);


//
// qpl_qst_fileupload
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"allowedextensions" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"maxsize" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"compl_by_submission" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_fileupload", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_fileupload", $pk_fields);


//
// qpl_qst_flash
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"params" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"applet" => array (
		"notnull" => false
		,"length" => 150
		,"fixed" => false
		,"type" => "text"
	)
	,"width" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "550"
		,"type" => "integer"
	)
	,"height" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "400"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_flash", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_flash", $pk_fields);


//
// qpl_qst_horder
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ordertext" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
	,"textsize" => array (
		"notnull" => false
		,"type" => "float"
	)
);
$ilDB->createTable("qpl_qst_horder", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_horder", $pk_fields);


//
// qpl_qst_imagemap
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"image_file" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"is_multiple_choice" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_imagemap", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_imagemap", $pk_fields);


//
// qpl_qst_javaapplet
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"image_file" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"params" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("qpl_qst_javaapplet", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_javaapplet", $pk_fields);


//
// qpl_qst_kprim
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"shuffle_answers" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answer_type" => array (
		"notnull" => true
		,"length" => 16
		,"default" => "singleLine"
		,"fixed" => false
		,"type" => "text"
	)
	,"thumb_size" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"opt_label" => array (
		"notnull" => true
		,"length" => 32
		,"default" => "right/wrong"
		,"fixed" => false
		,"type" => "text"
	)
	,"custom_true" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"custom_false" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"score_partsol" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"feedback_setting" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_kprim", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_kprim", $pk_fields);


//
// qpl_qst_matching
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"shuffle" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"matching_type" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"thumb_geometry" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "100"
		,"type" => "integer"
	)
	,"matching_mode" => array (
		"notnull" => false
		,"length" => 3
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("qpl_qst_matching", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_matching", $pk_fields);


//
// qpl_qst_mc
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"shuffle" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"allow_images" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"resize_images" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"thumb_size" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"feedback_setting" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_mc", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_mc", $pk_fields);


//
// qpl_qst_numeric
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"maxnumofchars" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_numeric", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_numeric", $pk_fields);


//
// qpl_qst_ordering
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ordering_type" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"thumb_geometry" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "100"
		,"type" => "integer"
	)
	,"element_height" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"scoring_type" => array (
		"notnull" => true
		,"length" => 3
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reduced_points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
);
$ilDB->createTable("qpl_qst_ordering", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_ordering", $pk_fields);


//
// qpl_qst_sc
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"shuffle" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"allow_images" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"resize_images" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"thumb_size" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"feedback_setting" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "2"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_sc", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_sc", $pk_fields);


//
// qpl_qst_textsubset
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"textgap_rating" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => false
		,"type" => "text"
	)
	,"correctanswers" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_textsubset", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("qpl_qst_textsubset", $pk_fields);


//
// qpl_qst_type
//
$fields = array (
	"question_type_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type_tag" => array (
		"notnull" => false
		,"length" => 35
		,"fixed" => false
		,"type" => "text"
	)
	,"plugin" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_qst_type", $fields);

$pk_fields = array("question_type_id");
$ilDB->addPrimaryKey("qpl_qst_type", $pk_fields);

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '1'), 'type_tag' => array('text', 'assSingleChoice'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '2'), 'type_tag' => array('text', 'assMultipleChoice'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '3'), 'type_tag' => array('text', 'assClozeTest'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '4'), 'type_tag' => array('text', 'assMatchingQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '5'), 'type_tag' => array('text', 'assOrderingQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '6'), 'type_tag' => array('text', 'assImagemapQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '7'), 'type_tag' => array('text', 'assJavaApplet'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '8'), 'type_tag' => array('text', 'assTextQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '9'), 'type_tag' => array('text', 'assNumeric'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '10'), 'type_tag' => array('text', 'assTextSubset'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '12'), 'type_tag' => array('text', 'assFlashQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '13'), 'type_tag' => array('text', 'assOrderingHorizontal'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '14'), 'type_tag' => array('text', 'assFileUpload'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '15'), 'type_tag' => array('text', 'assErrorText'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '16'), 'type_tag' => array('text', 'assFormulaQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("qpl_qst_type", array(
'question_type_id' => array('integer', '17'), 'type_tag' => array('text', 'assKprimChoice'), 'plugin' => array('integer', '0')));


//
// qpl_questionpool
//
$fields = array (
	"id_questionpool" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"isonline" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"questioncount" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"show_taxonomies" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nav_taxonomy" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("qpl_questionpool", $fields);

$pk_fields = array("id_questionpool");
$ilDB->addPrimaryKey("qpl_questionpool", $pk_fields);

$in_fields = array("obj_fi");
$ilDB->addIndex("qpl_questionpool", $in_fields, "i1", false);

$ilDB->createSequence("qpl_questionpool", 1);


//
// qpl_questions
//
$fields = array (
	"question_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_type_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"author" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"owner" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"working_time" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "00:00:00"
		,"fixed" => false
		,"type" => "text"
	)
	,"points" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"complete" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"original_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nr_of_tries" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_text" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"add_cont_edit_mode" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"external_id" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("qpl_questions", $fields);

$pk_fields = array("question_id");
$ilDB->addPrimaryKey("qpl_questions", $pk_fields);

$in_fields = array("question_type_fi");
$ilDB->addIndex("qpl_questions", $in_fields, "i1", false);

$in_fields = array("original_id");
$ilDB->addIndex("qpl_questions", $in_fields, "i2", false);

$in_fields = array("obj_fi");
$ilDB->addIndex("qpl_questions", $in_fields, "i3", false);

$in_fields = array("title");
$ilDB->addIndex("qpl_questions", $in_fields, "i4", false);

$ilDB->createSequence("qpl_questions", 1);


//
// qpl_sol_sug
//
$fields = array (
	"suggested_solution_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"internal_link" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"subquestion_index" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("qpl_sol_sug", $fields);

$pk_fields = array("suggested_solution_id");
$ilDB->addPrimaryKey("qpl_sol_sug", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("qpl_sol_sug", $in_fields, "i1", false);

$ilDB->createSequence("qpl_sol_sug", 1);


//
// rbac_fa
//
$fields = array (
	"rol_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"assign" => array (
		"notnull" => false
		,"length" => 1
		,"fixed" => true
		,"type" => "text"
	)
	,"protected" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "n"
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("rbac_fa", $fields);

$pk_fields = array("rol_id","parent");
$ilDB->addPrimaryKey("rbac_fa", $pk_fields);

$in_fields = array("parent");
$ilDB->addIndex("rbac_fa", $in_fields, "i1", false);

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '2'), 'parent' => array('integer', '8'), 'assign' => array('text', 'y'), 'protected' => array('text', 'y')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '3'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '4'), 'parent' => array('integer', '8'), 'assign' => array('text', 'y'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '5'), 'parent' => array('integer', '8'), 'assign' => array('text', 'y'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '83'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '82'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '80'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'y')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '81'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '14'), 'parent' => array('integer', '8'), 'assign' => array('text', 'y'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '110'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'y')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '111'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '112'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '125'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'y')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '126'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '131'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '134'), 'parent' => array('integer', '24'), 'assign' => array('text', 'y'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '148'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '187'), 'parent' => array('integer', '46'), 'assign' => array('text', 'y'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '188'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '202'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));

$ilDB->insert("rbac_fa", array(
'rol_id' => array('integer', '222'), 'parent' => array('integer', '8'), 'assign' => array('text', 'n'), 'protected' => array('text', 'n')));


//
// rbac_log
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"action" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"data" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("rbac_log", $fields);

$in_fields = array("ref_id");
$ilDB->addIndex("rbac_log", $in_fields, "i1", false);


//
// rbac_operations
//
$fields = array (
	"ops_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"operation" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => true
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"class" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
	,"op_order" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("rbac_operations", $fields);

$pk_fields = array("ops_id");
$ilDB->addPrimaryKey("rbac_operations", $pk_fields);

$in_fields = array("operation");
$ilDB->addIndex("rbac_operations", $in_fields, "i1", false);

$ilDB->createSequence("rbac_operations", 96);

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '1'), 'operation' => array('text', 'edit_permission'), 'description' => array('text', 'edit permissions'), 'class' => array('text', 'rbac'), 'op_order' => array('integer', '9000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '2'), 'operation' => array('text', 'visible'), 'description' => array('text', 'view object'), 'class' => array('text', 'general'), 'op_order' => array('integer', '1000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '3'), 'operation' => array('text', 'read'), 'description' => array('text', 'access object'), 'class' => array('text', 'general'), 'op_order' => array('integer', '2000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '4'), 'operation' => array('text', 'write'), 'description' => array('text', 'modify object'), 'class' => array('text', 'general'), 'op_order' => array('integer', '6000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '6'), 'operation' => array('text', 'delete'), 'description' => array('text', 'remove object'), 'class' => array('text', 'general'), 'op_order' => array('integer', '8000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '7'), 'operation' => array('text', 'join'), 'description' => array('text', 'join/subscribe'), 'class' => array('text', 'object'), 'op_order' => array('integer', '1200')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '8'), 'operation' => array('text', 'leave'), 'description' => array('text', 'leave/unsubscribe'), 'class' => array('text', 'object'), 'op_order' => array('integer', '1400')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '9'), 'operation' => array('text', 'add_reply'), 'description' => array('text', 'Reply to forum articles'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3050')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '10'), 'operation' => array('text', 'moderate_frm'), 'description' => array('text', 'delete forum articles'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3750')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '11'), 'operation' => array('text', 'smtp_mail'), 'description' => array('text', 'send external mail'), 'class' => array('text', 'object'), 'op_order' => array('integer', '210')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '12'), 'operation' => array('text', 'system_message'), 'description' => array('text', 'allow to send system messages'), 'class' => array('text', 'object'), 'op_order' => array('integer', '220')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '13'), 'operation' => array('text', 'create_usr'), 'description' => array('text', 'create new user account'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '14'), 'operation' => array('text', 'create_role'), 'description' => array('text', 'create new role definition'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '15'), 'operation' => array('text', 'create_rolt'), 'description' => array('text', 'create new role definition template'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '16'), 'operation' => array('text', 'create_cat'), 'description' => array('text', 'create new category'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '17'), 'operation' => array('text', 'create_grp'), 'description' => array('text', 'create new group'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '18'), 'operation' => array('text', 'create_frm'), 'description' => array('text', 'create new forum'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '19'), 'operation' => array('text', 'create_crs'), 'description' => array('text', 'create new course'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '20'), 'operation' => array('text', 'create_lm'), 'description' => array('text', 'create new learning module'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '21'), 'operation' => array('text', 'create_sahs'), 'description' => array('text', 'create new SCORM/AICC learning module'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '22'), 'operation' => array('text', 'create_glo'), 'description' => array('text', 'create new glossary'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '23'), 'operation' => array('text', 'create_dbk'), 'description' => array('text', 'create new digibook'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '24'), 'operation' => array('text', 'create_exc'), 'description' => array('text', 'create new exercise'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '25'), 'operation' => array('text', 'create_file'), 'description' => array('text', 'upload new file'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '26'), 'operation' => array('text', 'create_fold'), 'description' => array('text', 'create new folder'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '40'), 'operation' => array('text', 'edit_userassignment'), 'description' => array('text', 'change userassignment of roles'), 'class' => array('text', 'object'), 'op_order' => array('integer', '2500')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '41'), 'operation' => array('text', 'edit_roleassignment'), 'description' => array('text', 'change roleassignments of user accounts'), 'class' => array('text', 'object'), 'op_order' => array('integer', '2500')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '27'), 'operation' => array('text', 'create_tst'), 'description' => array('text', 'create new test'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '28'), 'operation' => array('text', 'create_qpl'), 'description' => array('text', 'create new question pool'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '74'), 'operation' => array('text', 'create_blog'), 'description' => array('text', 'Create Blog'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '30'), 'operation' => array('text', 'internal_mail'), 'description' => array('text', 'users can use mail system'), 'class' => array('text', 'object'), 'op_order' => array('integer', '200')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '31'), 'operation' => array('text', 'create_mep'), 'description' => array('text', 'create new media pool'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '32'), 'operation' => array('text', 'create_htlm'), 'description' => array('text', 'create new html learning module'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '42'), 'operation' => array('text', 'create_svy'), 'description' => array('text', 'create new survey'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '43'), 'operation' => array('text', 'create_spl'), 'description' => array('text', 'create new question pool (Survey)'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '63'), 'operation' => array('text', 'create_sess'), 'description' => array('text', 'create session'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '45'), 'operation' => array('text', 'invite'), 'description' => array('text', 'invite'), 'class' => array('text', 'object'), 'op_order' => array('integer', '2600')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '47'), 'operation' => array('text', 'cat_administrate_users'), 'description' => array('text', 'Administrate local user'), 'class' => array('text', 'object'), 'op_order' => array('integer', '7050')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '48'), 'operation' => array('text', 'read_users'), 'description' => array('text', 'read local users'), 'class' => array('text', 'object'), 'op_order' => array('integer', '7000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '49'), 'operation' => array('text', 'push_desktop_items'), 'description' => array('text', 'Allow pushing desktop items'), 'class' => array('text', 'object'), 'op_order' => array('integer', '2400')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '50'), 'operation' => array('text', 'create_webr'), 'description' => array('text', 'create web resource'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '51'), 'operation' => array('text', 'search'), 'description' => array('text', 'Allow using search'), 'class' => array('text', 'object'), 'op_order' => array('integer', '300')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '52'), 'operation' => array('text', 'moderate'), 'description' => array('text', 'Moderate objects'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3700')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '53'), 'operation' => array('text', 'create_icrs'), 'description' => array('text', 'create LearnLink Seminar'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '54'), 'operation' => array('text', 'create_icla'), 'description' => array('text', 'create LearnLink Seminar room'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '55'), 'operation' => array('text', 'edit_learning_progress'), 'description' => array('text', 'edit learning progress'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3600')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '56'), 'operation' => array('text', 'tst_statistics'), 'description' => array('text', 'view the statistics of a test'), 'class' => array('text', 'object'), 'op_order' => array('integer', '7100')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '57'), 'operation' => array('text', 'export_member_data'), 'description' => array('text', 'Export member data'), 'class' => array('text', 'object'), 'op_order' => array('integer', '')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '58'), 'operation' => array('text', 'copy'), 'description' => array('text', 'Copy Object'), 'class' => array('text', 'general'), 'op_order' => array('integer', '4000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '59'), 'operation' => array('text', 'create_feed'), 'description' => array('text', 'create external feed'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '60'), 'operation' => array('text', 'create_mcst'), 'description' => array('text', 'create media cast'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '61'), 'operation' => array('text', 'create_rcrs'), 'description' => array('text', 'create remote course'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '62'), 'operation' => array('text', 'add_thread'), 'description' => array('text', 'Add Threads'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3100')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '64'), 'operation' => array('text', 'edit_content'), 'description' => array('text', 'Edit content'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3000')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '65'), 'operation' => array('text', 'create_wiki'), 'description' => array('text', 'create wiki'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '66'), 'operation' => array('text', 'edit_event'), 'description' => array('text', 'Edit calendar event'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3600')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '67'), 'operation' => array('text', 'create_crsr'), 'description' => array('text', 'create course reference'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '68'), 'operation' => array('text', 'create_catr'), 'description' => array('text', 'create category reference'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '69'), 'operation' => array('text', 'mail_to_global_roles'), 'description' => array('text', 'User may send mails to global roles'), 'class' => array('text', 'object'), 'op_order' => array('integer', '230')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '72'), 'operation' => array('text', 'add_consultation_hours'), 'description' => array('text', 'Add Consultation Hours Calendar'), 'class' => array('text', 'object'), 'op_order' => array('integer', '300')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '71'), 'operation' => array('text', 'create_book'), 'description' => array('text', 'create booking pool'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '73'), 'operation' => array('text', 'create_chtr'), 'description' => array('text', 'create chatroom'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '75'), 'operation' => array('text', 'create_dcl'), 'description' => array('text', 'Create Data Collection'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '76'), 'operation' => array('text', 'create_poll'), 'description' => array('text', 'Create Poll'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '77'), 'operation' => array('text', 'add_entry'), 'description' => array('text', 'Add Entry'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3200')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '78'), 'operation' => array('text', 'create_itgr'), 'description' => array('text', 'Create Item Group'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '79'), 'operation' => array('text', 'contribute'), 'description' => array('text', 'Contribute'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3205')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '80'), 'operation' => array('text', 'lp_other_users'), 'description' => array('text', 'See LP Data Of Other Users'), 'class' => array('text', 'object'), 'op_order' => array('integer', '250')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '81'), 'operation' => array('text', 'create_bibl'), 'description' => array('text', 'Create Bibliographic'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '82'), 'operation' => array('text', 'create_cld'), 'description' => array('text', 'Create Cloud Folder'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '83'), 'operation' => array('text', 'upload'), 'description' => array('text', 'Upload Items'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3240')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '84'), 'operation' => array('text', 'delete_files'), 'description' => array('text', 'Delete Files'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3260')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '85'), 'operation' => array('text', 'delete_folders'), 'description' => array('text', 'Delete Folders'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3270')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '86'), 'operation' => array('text', 'download'), 'description' => array('text', 'Download Items'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3230')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '87'), 'operation' => array('text', 'files_visible'), 'description' => array('text', 'Files are visible'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3210')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '88'), 'operation' => array('text', 'folders_visible'), 'description' => array('text', 'Folders are visible'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3220')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '89'), 'operation' => array('text', 'folders_create'), 'description' => array('text', 'Folders may be created'), 'class' => array('text', 'object'), 'op_order' => array('integer', '3250')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '90'), 'operation' => array('text', 'create_prtt'), 'description' => array('text', 'Create Portfolio Template'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '91'), 'operation' => array('text', 'create_orgu'), 'description' => array('text', 'Create OrgUnit'), 'class' => array('text', 'create'), 'op_order' => array('integer', '9999')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '92'), 'operation' => array('text', 'view_learning_progress'), 'description' => array('text', 'View learning progress from users in this orgu.'), 'class' => array('text', 'object'), 'op_order' => array('integer', '270')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '93'), 'operation' => array('text', 'view_learning_progress_rec'), 'description' => array('text', 'View learning progress from users in this orgu and subsequent orgus.'), 'class' => array('text', 'object'), 'op_order' => array('integer', '280')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '94'), 'operation' => array('text', 'statistics_read'), 'description' => array('text', 'Read Statistics'), 'class' => array('text', 'object'), 'op_order' => array('integer', '2200')));

$ilDB->insert("rbac_operations", array(
'ops_id' => array('integer', '95'), 'operation' => array('text', 'read_learning_progress'), 'description' => array('text', 'Read Learning Progress'), 'class' => array('text', 'object'), 'op_order' => array('integer', '2300')));


//
// rbac_pa
//
$fields = array (
	"rol_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ops_id" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("rbac_pa", $fields);

$pk_fields = array("rol_id","ref_id");
$ilDB->addPrimaryKey("rbac_pa", $pk_fields);

$in_fields = array("ref_id");
$ilDB->addIndex("rbac_pa", $in_fields, "i1", false);

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '5'), 'ops_id' => array('text', 'a:2:{i:0;i:3;i:1;i:2;}'), 'ref_id' => array('integer', '1')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '14'), 'ops_id' => array('text', 'a:2:{i:0;i:3;i:1;i:2;}'), 'ref_id' => array('integer', '1')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '4'), 'ops_id' => array('text', 'a:2:{i:0;i:3;i:1;i:2;}'), 'ref_id' => array('integer', '1')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '2'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '3'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '4'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '5'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '14'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '80'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '81'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '82'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '83'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '110'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '111'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '112'), 'ops_id' => array('text', 'a:1:{i:0;s:2:"51";}'), 'ref_id' => array('integer', '22')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '134'), 'ops_id' => array('text', 'a:3:{i:0;i:52;i:1;i:3;i:2;i:2;}'), 'ref_id' => array('integer', '24')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '5'), 'ops_id' => array('text', 'a:2:{i:0;i:30;i:1;i:69;}'), 'ref_id' => array('integer', '12')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '4'), 'ops_id' => array('text', 'a:2:{i:0;i:30;i:1;i:69;}'), 'ref_id' => array('integer', '12')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '14'), 'ops_id' => array('text', 'a:1:{i:0;i:69;}'), 'ref_id' => array('integer', '12')));

$ilDB->insert("rbac_pa", array(
'rol_id' => array('integer', '187'), 'ops_id' => array('text', 'a:3:{i:0;i:52;i:1;i:3;i:2;i:2;}'), 'ref_id' => array('integer', '46')));


//
// rbac_ta
//
$fields = array (
	"typ_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ops_id" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("rbac_ta", $fields);

$pk_fields = array("typ_id","ops_id");
$ilDB->addPrimaryKey("rbac_ta", $pk_fields);

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '7')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '8')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '17')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '18')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '20')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '21')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '22')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '23')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '24')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '25')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '26')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '27')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '28')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '31')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '32')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '42')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '43')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '50')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '53')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '59')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '60')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '63')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '65')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '66')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '67')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '68')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '71')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '73')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '74')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '75')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '76')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '78')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '81')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '82')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '90')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '15'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '16')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '17')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '18')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '19')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '20')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '21')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '22')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '23')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '24')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '25')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '27')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '28')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '31')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '32')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '42')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '43')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '47')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '48')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '50')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '53')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '59')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '60')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '61')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '65')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '67')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '68')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '71')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '73')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '74')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '75')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '76')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '78')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '81')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '82')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '16'), 'ops_id' => array('integer', '90')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '7')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '8')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '17')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '18')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '20')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '21')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '22')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '23')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '24')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '25')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '26')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '27')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '28')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '31')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '32')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '42')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '43')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '50')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '53')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '59')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '60')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '63')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '65')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '66')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '67')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '68')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '71')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '73')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '74')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '75')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '76')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '78')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '81')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '82')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '90')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '17'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '11')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '12')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '30')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '19'), 'ops_id' => array('integer', '69')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '20'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '21'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '21'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '21'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '21'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '13')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '41')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '48')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '22'), 'ops_id' => array('integer', '49')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '14')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '15')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '23'), 'ops_id' => array('integer', '40')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '24'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '24'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '24'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '24'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '28'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '28'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '28'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '28'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '31'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '31'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '31'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '31'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '31'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '31'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '31'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '32'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '32'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '32'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '32'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '32'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '32'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '32'), 'ops_id' => array('integer', '64')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '16')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '17')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '18')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '19')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '20')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '21')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '22')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '23')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '24')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '25')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '27')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '28')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '31')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '32')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '42')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '43')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '50')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '53')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '59')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '60')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '61')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '65')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '67')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '68')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '71')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '73')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '74')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '75')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '76')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '78')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '81')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '82')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '90')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '33'), 'ops_id' => array('integer', '91')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '34'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '9')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '10')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '37'), 'ops_id' => array('integer', '62')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '84'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '85'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '85'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '85'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '85'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '17')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '18')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '20')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '21')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '22')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '23')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '24')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '25')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '26')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '27')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '28')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '31')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '32')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '42')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '43')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '50')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '53')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '60')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '63')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '65')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '71')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '73')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '74')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '75')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '76')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '78')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '81')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '82')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '90')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '87'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '88'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '88'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '88'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '88'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '88'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '88'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '56')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '94'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '95'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '95'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '95'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '95'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '95'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '95'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '96'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '96'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '96'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '96'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '96'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '96'), 'ops_id' => array('integer', '52')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '96'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '97'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '97'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '97'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '97'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '99'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '99'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '99'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '99'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '101'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '101'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '101'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '101'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '101'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '102'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '103'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '103'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '103'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '103'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '103'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '103'), 'ops_id' => array('integer', '45')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '103'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '104'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '104'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '104'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '104'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '104'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '104'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '106'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '106'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '106'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '106'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '106'), 'ops_id' => array('integer', '66')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '106'), 'ops_id' => array('integer', '70')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '106'), 'ops_id' => array('integer', '72')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '108'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '108'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '108'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '108'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '108'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '108'), 'ops_id' => array('integer', '80')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '113'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '113'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '113'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '113'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '115'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '115'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '115'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '115'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '117'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '117'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '117'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '117'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '7')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '8')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '119'), 'ops_id' => array('integer', '54')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '122'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '122'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '122'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '122'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '122'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '122'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '123'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '123'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '123'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '123'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '123'), 'ops_id' => array('integer', '51')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '127'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '127'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '127'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '127'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '135'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '135'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '135'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '135'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '137'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '137'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '137'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '137'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '137'), 'ops_id' => array('integer', '57')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '139'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '139'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '139'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '139'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '141'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '141'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '141'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '141'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '141'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '142'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '142'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '142'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '142'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '142'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '142'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '143'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '143'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '143'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '143'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '145'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '145'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '145'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '145'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '145'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '146'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '146'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '146'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '146'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '149'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '149'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '149'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '149'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '151'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '151'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '151'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '151'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '153'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '153'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '153'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '153'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '55')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '155'), 'ops_id' => array('integer', '95')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '156'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '156'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '156'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '156'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '64')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '158'), 'ops_id' => array('integer', '94')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '159'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '159'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '159'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '159'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '159'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '160'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '160'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '160'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '160'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '160'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '161'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '161'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '161'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '161'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '163'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '163'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '163'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '163'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '165'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '165'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '165'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '165'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '167'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '167'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '167'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '167'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '169'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '169'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '169'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '169'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '171'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '171'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '171'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '171'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '173'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '173'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '173'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '173'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '173'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '174'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '174'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '174'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '174'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '176'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '176'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '176'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '176'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '178'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '178'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '178'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '178'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '180'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '180'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '180'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '180'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '180'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '180'), 'ops_id' => array('integer', '52')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '180'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '182'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '182'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '182'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '182'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '183'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '183'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '183'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '183'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '189'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '189'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '189'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '189'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '189'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '189'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '189'), 'ops_id' => array('integer', '79')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '190'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '190'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '190'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '190'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '190'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '190'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '190'), 'ops_id' => array('integer', '77')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '191'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '191'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '191'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '191'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '191'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '192'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '192'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '192'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '192'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '194'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '194'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '194'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '194'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '194'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '194'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '195'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '195'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '195'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '195'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '195'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '196'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '196'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '196'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '196'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '196'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '197'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '197'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '197'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '197'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '197'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '198'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '198'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '198'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '198'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '198'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '199'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '199'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '199'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '199'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '199'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '200'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '200'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '200'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '200'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '200'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '201'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '201'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '201'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '201'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '201'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '203'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '203'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '203'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '203'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '205'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '205'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '205'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '205'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '207'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '207'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '207'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '207'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '207'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '207'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '208'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '208'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '208'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '208'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '83')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '84')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '85')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '86')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '87')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '88')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '210'), 'ops_id' => array('integer', '89')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '211'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '211'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '211'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '211'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '213'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '213'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '213'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '213'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '215'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '215'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '215'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '215'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '217'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '217'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '217'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '217'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '219'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '219'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '219'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '219'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '219'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '219'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '6')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '47')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '48')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '58')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '91')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '92')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '220'), 'ops_id' => array('integer', '93')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '223'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '223'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '223'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '223'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '225'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '225'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '225'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '225'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '227'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '227'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '227'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '227'), 'ops_id' => array('integer', '4')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '229'), 'ops_id' => array('integer', '1')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '229'), 'ops_id' => array('integer', '2')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '229'), 'ops_id' => array('integer', '3')));

$ilDB->insert("rbac_ta", array(
'typ_id' => array('integer', '229'), 'ops_id' => array('integer', '4')));


//
// rbac_templates
//
$fields = array (
	"rol_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 5
		,"fixed" => true
		,"type" => "text"
	)
	,"ops_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("rbac_templates", $fields);

$in_fields = array("rol_id");
$ilDB->addIndex("rbac_templates", $in_fields, "i1", false);

$in_fields = array("type");
$ilDB->addIndex("rbac_templates", $in_fields, "i2", false);

$in_fields = array("ops_id");
$ilDB->addIndex("rbac_templates", $in_fields, "i3", false);

$in_fields = array("parent");
$ilDB->addIndex("rbac_templates", $in_fields, "i4", false);

$in_fields = array("rol_id","parent");
$ilDB->addIndex("rbac_templates", $in_fields, "rp", false);

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'seas'), 'ops_id' => array('integer', '51'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'seas'), 'ops_id' => array('integer', '51'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'mail'), 'ops_id' => array('integer', '30'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '66'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '83'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '23'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '14'), 'type' => array('text', 'seas'), 'ops_id' => array('integer', '51'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '14'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '14'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '83'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '14'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '10'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '66'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '10'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'dbk'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'dbk'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'dbk'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '66'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '23'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '10'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '202'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '10'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '202'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'itgr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dbk'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dbk'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dbk'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '77'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '68'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '67'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '66'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '68'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '10'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '52'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '23'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '77'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '94'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '94'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '94'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '94'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '131'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '131'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '131'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '77'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'file'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '68'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '52'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '77'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'dcl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '78'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '68'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '67'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '66'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '66'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '63'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '67'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '76'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '75'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '74'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '68'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '67'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '53'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '26'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'crsr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '52'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '202'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '79'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '8'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '7'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '73'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '9'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '10'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '148'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '62'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '71'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '68'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '48'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '47'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '67'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '65'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '60'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '59'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '131'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '50'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '52'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'crs'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '52'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '43'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '79'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'catr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '79'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '79'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'frm'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'fold'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '19'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '16'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '19'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '16'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'grp'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'glo'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '188'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '188'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '188'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '188'), 'type' => array('text', 'chtr'), 'ops_id' => array('integer', '52'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '5'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '4'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '64'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mep'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'root'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '45'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '64'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '45'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '45'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '56'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '64'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '112'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '64'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '45'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '64'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'mcst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'poll'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'spl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'qpl'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '45'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '56'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '64'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'svy'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'webr'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '81'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '64'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '42'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '32'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '31'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '28'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '27'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '25'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '24'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '23'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '22'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '21'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '20'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '19'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '18'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '17'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '16'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '4'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'cat'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'book'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'blog'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '1'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'wiki'), 'ops_id' => array('integer', '6'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '222'), 'type' => array('text', 'orgu'), 'ops_id' => array('integer', '92'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '222'), 'type' => array('text', 'orgu'), 'ops_id' => array('integer', '2'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '222'), 'type' => array('text', 'orgu'), 'ops_id' => array('integer', '3'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'lm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'htlm'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sahs'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'tst'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '125'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'exc'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '55'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'sess'), 'ops_id' => array('integer', '95'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '3'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '126'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '110'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '111'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));

$ilDB->insert("rbac_templates", array(
'rol_id' => array('integer', '80'), 'type' => array('text', 'feed'), 'ops_id' => array('integer', '58'), 'parent' => array('integer', '8')));


//
// rbac_ua
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rol_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("rbac_ua", $fields);

$pk_fields = array("usr_id","rol_id");
$ilDB->addPrimaryKey("rbac_ua", $pk_fields);

$in_fields = array("usr_id");
$ilDB->addIndex("rbac_ua", $in_fields, "i1", false);

$in_fields = array("rol_id");
$ilDB->addIndex("rbac_ua", $in_fields, "i2", false);

$ilDB->insert("rbac_ua", array(
'usr_id' => array('integer', '6'), 'rol_id' => array('integer', '2')));

$ilDB->insert("rbac_ua", array(
'usr_id' => array('integer', '13'), 'rol_id' => array('integer', '14')));


//
// rcat_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("rcat_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("rcat_settings", $pk_fields);


//
// read_event
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_access" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"read_count" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"spent_seconds" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"first_access" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"childs_read_count" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"childs_spent_seconds" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("read_event", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("read_event", $pk_fields);


//
// reg_access_limit
//
$fields = array (
	"role_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"limit_absolute" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"limit_relative_d" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"limit_relative_m" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"limit_relative_y" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"limit_mode" => array (
		"notnull" => false
		,"length" => 16
		,"default" => "absolute"
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("reg_access_limit", $fields);

$pk_fields = array("role_id");
$ilDB->addPrimaryKey("reg_access_limit", $pk_fields);


//
// reg_er_assignments
//
$fields = array (
	"assignment_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"domain" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"role" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("reg_er_assignments", $fields);

$pk_fields = array("assignment_id");
$ilDB->addPrimaryKey("reg_er_assignments", $pk_fields);

$ilDB->createSequence("reg_er_assignments", 2);

$ilDB->insert("reg_er_assignments", array(
'assignment_id' => array('integer', '1'), 'domain' => array('text', ''), 'role' => array('integer', '0')));


//
// reg_registration_codes
//
$fields = array (
	"code_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"code" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"role" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"generated" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"used" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"role_local" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"alimit" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"alimitdt" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"reg_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"ext_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("reg_registration_codes", $fields);

$pk_fields = array("code_id");
$ilDB->addPrimaryKey("reg_registration_codes", $pk_fields);

$in_fields = array("code");
$ilDB->addIndex("reg_registration_codes", $in_fields, "i1", false);

$ilDB->createSequence("reg_registration_codes", 1);


//
// remote_course_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"availability_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"r_start" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"r_end" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("remote_course_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("remote_course_settings", $pk_fields);


//
// rfil_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"version" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"version_tstamp" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("rfil_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("rfil_settings", $pk_fields);


//
// rglo_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"availability_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("rglo_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("rglo_settings", $pk_fields);


//
// rgrp_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"availability_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"availability_start" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"availability_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("rgrp_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("rgrp_settings", $pk_fields);


//
// rlm_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"availability_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("rlm_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("rlm_settings", $pk_fields);


//
// role_data
//
$fields = array (
	"role_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"allow_register" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"assign_users" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"auth_mode" => array (
		"notnull" => false
		,"length" => 16
		,"default" => "default"
		,"fixed" => true
		,"type" => "text"
	)
	,"disk_quota" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"wsp_disk_quota" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("role_data", $fields);

$pk_fields = array("role_id");
$ilDB->addPrimaryKey("role_data", $pk_fields);

$ilDB->insert("role_data", array(
'role_id' => array('integer', '2'), 'allow_register' => array('integer', '0'), 'assign_users' => array('integer', '0'), 'auth_mode' => array('text', 'default'), 'disk_quota' => array('integer', '9223372036854775807'), 'wsp_disk_quota' => array('integer', '')));

$ilDB->insert("role_data", array(
'role_id' => array('integer', '3'), 'allow_register' => array('integer', '0'), 'assign_users' => array('integer', '0'), 'auth_mode' => array('text', 'default'), 'disk_quota' => array('integer', '0'), 'wsp_disk_quota' => array('integer', '')));

$ilDB->insert("role_data", array(
'role_id' => array('integer', '4'), 'allow_register' => array('integer', '0'), 'assign_users' => array('integer', '0'), 'auth_mode' => array('text', 'default'), 'disk_quota' => array('integer', '0'), 'wsp_disk_quota' => array('integer', '')));

$ilDB->insert("role_data", array(
'role_id' => array('integer', '5'), 'allow_register' => array('integer', '1'), 'assign_users' => array('integer', '0'), 'auth_mode' => array('text', 'default'), 'disk_quota' => array('integer', '0'), 'wsp_disk_quota' => array('integer', '')));

$ilDB->insert("role_data", array(
'role_id' => array('integer', '14'), 'allow_register' => array('integer', '0'), 'assign_users' => array('integer', '0'), 'auth_mode' => array('text', 'default'), 'disk_quota' => array('integer', '0'), 'wsp_disk_quota' => array('integer', '')));

$ilDB->insert("role_data", array(
'role_id' => array('integer', '134'), 'allow_register' => array('integer', '0'), 'assign_users' => array('integer', '0'), 'auth_mode' => array('text', 'default'), 'disk_quota' => array('integer', '0'), 'wsp_disk_quota' => array('integer', '')));

$ilDB->insert("role_data", array(
'role_id' => array('integer', '187'), 'allow_register' => array('integer', '0'), 'assign_users' => array('integer', '0'), 'auth_mode' => array('text', 'default'), 'disk_quota' => array('integer', '0'), 'wsp_disk_quota' => array('integer', '')));


//
// role_desktop_items
//
$fields = array (
	"role_item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"role_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_type" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("role_desktop_items", $fields);

$pk_fields = array("role_item_id");
$ilDB->addPrimaryKey("role_desktop_items", $pk_fields);

$in_fields = array("role_item_id","role_id");
$ilDB->addIndex("role_desktop_items", $in_fields, "i1", false);

$ilDB->createSequence("role_desktop_items", 1);


//
// rtst_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"availability_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"availability_start" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"availability_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("rtst_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("rtst_settings", $pk_fields);


//
// rwik_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"mid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"organization" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"local_information" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"remote_link" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"availability_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("rwik_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("rwik_settings", $pk_fields);


//
// sahs_lm
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"c_online" => array (
		"notnull" => false
		,"length" => 3
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"api_adapter" => array (
		"notnull" => false
		,"length" => 80
		,"default" => "API"
		,"fixed" => false
		,"type" => "text"
	)
	,"api_func_prefix" => array (
		"notnull" => false
		,"length" => 20
		,"default" => "LMS"
		,"fixed" => false
		,"type" => "text"
	)
	,"credit" => array (
		"notnull" => false
		,"length" => 10
		,"default" => "credit"
		,"fixed" => false
		,"type" => "text"
	)
	,"default_lesson_mode" => array (
		"notnull" => false
		,"length" => 8
		,"default" => "normal"
		,"fixed" => false
		,"type" => "text"
	)
	,"auto_review" => array (
		"notnull" => false
		,"length" => 3
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"c_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"max_attempt" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"module_version" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"editable" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"stylesheet" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"glossary" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_tries" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "3"
		,"type" => "integer"
	)
	,"unlimited_session" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"no_menu" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"hide_navig" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"debug" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"debugpw" => array (
		"notnull" => false
		,"length" => 50
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"entry_page" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"seq_exp_mode" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"localization" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => false
		,"type" => "text"
	)
	,"open_mode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"width" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "950"
		,"type" => "integer"
	)
	,"height" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "650"
		,"type" => "integer"
	)
	,"auto_continue" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"sequencing" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "y"
		,"fixed" => false
		,"type" => "text"
	)
	,"interactions" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "y"
		,"fixed" => false
		,"type" => "text"
	)
	,"objectives" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "y"
		,"fixed" => false
		,"type" => "text"
	)
	,"time_from_lms" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"comments" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "y"
		,"fixed" => false
		,"type" => "text"
	)
	,"auto_last_visited" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "y"
		,"fixed" => false
		,"type" => "text"
	)
	,"check_values" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "y"
		,"fixed" => false
		,"type" => "text"
	)
	,"offline_mode" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"offline_zip_created" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"auto_suspend" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"fourth_edition" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
	,"ie_compatibility" => array (
		"notnull" => false
		,"length" => 1
		,"fixed" => false
		,"type" => "text"
	)
	,"ie_force_render" => array (
		"notnull" => true
		,"length" => 1
		,"default" => "n"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sahs_lm", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sahs_lm", $pk_fields);


//
// sahs_sc13_sco
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"hide_obj_page" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_sco", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sahs_sc13_sco", $pk_fields);


//
// sahs_sc13_seq_assign
//
$fields = array (
	"identifier" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"sahs_sc13_tree_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_seq_assign", $fields);

$pk_fields = array("sahs_sc13_tree_node_id");
$ilDB->addPrimaryKey("sahs_sc13_seq_assign", $pk_fields);


//
// sahs_sc13_seq_cond
//
$fields = array (
	"cond" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"seqnodeid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"measurethreshold" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"operator" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"referencedobjective" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sahs_sc13_seq_cond", $fields);

$pk_fields = array("seqnodeid");
$ilDB->addPrimaryKey("sahs_sc13_seq_cond", $pk_fields);


//
// sahs_sc13_seq_course
//
$fields = array (
	"flow" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"choice" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"forwardonly" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_seq_course", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sahs_sc13_seq_course", $pk_fields);


//
// sahs_sc13_seq_item
//
$fields = array (
	"importid" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"seqnodeid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sahs_sc13_tree_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sequencingid" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"nocopy" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"nodelete" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"nomove" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"seqxml" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"rootlevel" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"importseqxml" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("sahs_sc13_seq_item", $fields);

$pk_fields = array("sahs_sc13_tree_node_id","rootlevel");
$ilDB->addPrimaryKey("sahs_sc13_seq_item", $pk_fields);


//
// sahs_sc13_seq_mapinfo
//
$fields = array (
	"seqnodeid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"readnormalizedmeasure" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"readsatisfiedstatus" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"targetobjectiveid" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"writenormalizedmeasure" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"writesatisfiedstatus" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_seq_mapinfo", $fields);

$pk_fields = array("seqnodeid");
$ilDB->addPrimaryKey("sahs_sc13_seq_mapinfo", $pk_fields);

$in_fields = array("targetobjectiveid");
$ilDB->addIndex("sahs_sc13_seq_mapinfo", $in_fields, "i1", false);


//
// sahs_sc13_seq_node
//
$fields = array (
	"seqnodeid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nodename" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"tree_node_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_seq_node", $fields);

$pk_fields = array("seqnodeid");
$ilDB->addPrimaryKey("sahs_sc13_seq_node", $pk_fields);

$in_fields = array("tree_node_id");
$ilDB->addIndex("sahs_sc13_seq_node", $in_fields, "i2", false);

$in_fields = array("nodename");
$ilDB->addIndex("sahs_sc13_seq_node", $in_fields, "i3", false);

$ilDB->createSequence("sahs_sc13_seq_node", 1);


//
// sahs_sc13_seq_obj
//
$fields = array (
	"seqnodeid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"minnormalizedmeasure" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"objectiveid" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"primary_obj" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"satisfiedbymeasure" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"import_objective_id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sahs_sc13_seq_obj", $fields);

$pk_fields = array("seqnodeid");
$ilDB->addPrimaryKey("sahs_sc13_seq_obj", $pk_fields);


//
// sahs_sc13_seq_rule
//
$fields = array (
	"action" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"childactivityset" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"conditioncombination" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"seqnodeid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"minimumcount" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"minimumpercent" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sahs_sc13_seq_rule", $fields);

$pk_fields = array("seqnodeid");
$ilDB->addPrimaryKey("sahs_sc13_seq_rule", $pk_fields);


//
// sahs_sc13_seq_templ
//
$fields = array (
	"seqnodeid" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sahs_sc13_seq_templ", $fields);

$in_fields = array("seqnodeid","id");
$ilDB->addIndex("sahs_sc13_seq_templ", $in_fields, "i1", false);


//
// sahs_sc13_seq_templts
//
$fields = array (
	"identifier" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"filename" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_seq_templts", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sahs_sc13_seq_templts", $pk_fields);

$ilDB->createSequence("sahs_sc13_seq_templts", 5);

$ilDB->insert("sahs_sc13_seq_templts", array(
'identifier' => array('text', 'pretestpost'), 'filename' => array('text', 'pretest_posttest.xml'), 'id' => array('integer', '1')));

$ilDB->insert("sahs_sc13_seq_templts", array(
'identifier' => array('text', 'linearpath'), 'filename' => array('text', 'linear_path.xml'), 'id' => array('integer', '2')));

$ilDB->insert("sahs_sc13_seq_templts", array(
'identifier' => array('text', 'linearpathforward'), 'filename' => array('text', 'linear_path_forward.xml'), 'id' => array('integer', '3')));

$ilDB->insert("sahs_sc13_seq_templts", array(
'identifier' => array('text', 'mandatoryoptions'), 'filename' => array('text', 'mandatory_options.xml'), 'id' => array('integer', '4')));


//
// sahs_sc13_seq_tree
//
$fields = array (
	"child" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"importid" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_seq_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("sahs_sc13_seq_tree", $in_fields, "i1", false);

$in_fields = array("importid");
$ilDB->addIndex("sahs_sc13_seq_tree", $in_fields, "i2", false);

$in_fields = array("parent");
$ilDB->addIndex("sahs_sc13_seq_tree", $in_fields, "i3", false);


//
// sahs_sc13_tree
//
$fields = array (
	"slm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("sahs_sc13_tree", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("sahs_sc13_tree", $in_fields, "i2", false);

$in_fields = array("slm_id");
$ilDB->addIndex("sahs_sc13_tree", $in_fields, "i3", false);


//
// sahs_sc13_tree_node
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => true
		,"type" => "text"
	)
	,"slm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("sahs_sc13_tree_node", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sahs_sc13_tree_node", $pk_fields);

$in_fields = array("slm_id");
$ilDB->addIndex("sahs_sc13_tree_node", $in_fields, "i1", false);

$in_fields = array("type");
$ilDB->addIndex("sahs_sc13_tree_node", $in_fields, "i2", false);

$ilDB->createSequence("sahs_sc13_tree_node", 2);

$ilDB->insert("sahs_sc13_tree_node", array(
'obj_id' => array('integer', '1'), 'title' => array('text', 'Dummy top node for all trees.'), 'type' => array('text', ''), 'slm_id' => array('integer', '0'), 'import_id' => array('text', ''), 'create_date' => array('timestamp', ''), 'last_update' => array('timestamp', '')));


//
// sahs_user
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"package_attempts" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"module_version" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"last_visited" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"hash" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"hash_end" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"offline_mode" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"last_access" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"total_time_sec" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sco_total_time_sec" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"percentage_completed" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"first_access" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_status_change" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("sahs_user", $fields);

$pk_fields = array("obj_id","user_id");
$ilDB->addPrimaryKey("sahs_user", $pk_fields);


//
// sc_item
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"identifierref" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"isvisible" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"parameters" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"prereq_type" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"prerequisites" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"maxtimeallowed" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"timelimitaction" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"datafromlms" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"masteryscore" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sc_item", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sc_item", $pk_fields);


//
// sc_manifest
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"version" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"xml_base" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sc_manifest", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sc_manifest", $pk_fields);


//
// sc_organization
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"structure" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sc_organization", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sc_organization", $pk_fields);


//
// sc_organizations
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"default_organization" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sc_organizations", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sc_organizations", $pk_fields);


//
// sc_resource
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"resourcetype" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"scormtype" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => false
		,"type" => "text"
	)
	,"href" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
	,"xml_base" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sc_resource", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sc_resource", $pk_fields);

$in_fields = array("import_id");
$ilDB->addIndex("sc_resource", $in_fields, "i1", false);


//
// sc_resource_dependen
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"res_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"identifierref" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"nr" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("sc_resource_dependen", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sc_resource_dependen", $pk_fields);

$ilDB->createSequence("sc_resource_dependen", 1);


//
// sc_resource_file
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"res_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"href" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"nr" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("sc_resource_file", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sc_resource_file", $pk_fields);

$ilDB->createSequence("sc_resource_file", 1);


//
// sc_resources
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"xml_base" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sc_resources", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("sc_resources", $pk_fields);


//
// scorm_object
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"c_type" => array (
		"notnull" => false
		,"length" => 3
		,"fixed" => true
		,"type" => "text"
	)
	,"slm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("scorm_object", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("scorm_object", $pk_fields);

$ilDB->createSequence("scorm_object", 1);


//
// scorm_tracking
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sco_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lvalue" => array (
		"notnull" => true
		,"length" => 64
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"c_timestamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"rvalue" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("scorm_tracking", $fields);

$pk_fields = array("user_id","sco_id","lvalue","obj_id");
$ilDB->addPrimaryKey("scorm_tracking", $pk_fields);

$in_fields = array("obj_id","sco_id","lvalue");
$ilDB->addIndex("scorm_tracking", $in_fields, "i2", false);


//
// scorm_tree
//
$fields = array (
	"slm_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("scorm_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("scorm_tree", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("scorm_tree", $in_fields, "i2", false);


//
// search_command_queue
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => true
		,"length" => 4
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"sub_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sub_type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => true
		,"type" => "text"
	)
	,"command" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"finished" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("search_command_queue", $fields);

$pk_fields = array("obj_id","obj_type","sub_id");
$ilDB->addPrimaryKey("search_command_queue", $pk_fields);


//
// search_data
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"target" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("search_data", $fields);

$pk_fields = array("obj_id","user_id");
$ilDB->addPrimaryKey("search_data", $pk_fields);

$ilDB->createSequence("search_data", 1);


//
// search_tree
//
$fields = array (
	"tree" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("search_tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("search_tree", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("search_tree", $in_fields, "i2", false);


//
// service_class
//
$fields = array (
	"class" => array (
		"notnull" => true
		,"length" => 100
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"service" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"dir" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("service_class", $fields);

$pk_fields = array("class");
$ilDB->addPrimaryKey("service_class", $pk_fields);

$ilDB->insert("service_class", array(
'class' => array('text', 'ilImprintGUI'), 'service' => array('text', 'Imprint'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilMailGUI'), 'service' => array('text', 'Mail'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilNotificationGUI'), 'service' => array('text', 'Notifications'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilPublicUserProfileGUI'), 'service' => array('text', 'User'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilObjPluginDispatchGUI'), 'service' => array('text', 'Repository'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilRepositoryGUI'), 'service' => array('text', 'Repository'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilNavigationHistoryGUI'), 'service' => array('text', 'Navigation'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilShopController'), 'service' => array('text', 'Payment'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilHelpGUI'), 'service' => array('text', 'Help'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilCharSelectorGUI'), 'service' => array('text', 'UIComponent'), 'dir' => array('text', 'CharSelector/classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilUIPluginRouterGUI'), 'service' => array('text', 'UIComponent'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilStartUpGUI'), 'service' => array('text', 'Init'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilAdministrationGUI'), 'service' => array('text', 'Administration'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilSharedResourceGUI'), 'service' => array('text', 'PersonalWorkspace'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilPreviewGUI'), 'service' => array('text', 'Preview'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilPersonalDesktopGUI'), 'service' => array('text', 'PersonalDesktop'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilAccordionPropertiesStorage'), 'service' => array('text', 'Accordion'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilTablePropertiesStorage'), 'service' => array('text', 'Table'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilCronManagerGUI'), 'service' => array('text', 'Cron'), 'dir' => array('text', 'classes')));

$ilDB->insert("service_class", array(
'class' => array('text', 'ilSearchController'), 'service' => array('text', 'Search'), 'dir' => array('text', 'classes')));


//
// settings
//
$fields = array (
	"module" => array (
		"notnull" => true
		,"length" => 50
		,"default" => "common"
		,"fixed" => false
		,"type" => "text"
	)
	,"keyword" => array (
		"notnull" => true
		,"length" => 50
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("settings", $fields);

$pk_fields = array("module","keyword");
$ilDB->addPrimaryKey("settings", $pk_fields);

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'user_adm_alpha_nav'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'user_account'), 'keyword' => array('text', 'lua_enabled'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'assessment'), 'keyword' => array('text', 'use_javascript'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'block_activated_pdtag'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'tags'), 'keyword' => array('text', 'enable'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_password_change_on_first_login_enabled'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'pd'), 'keyword' => array('text', 'enable_block_moving'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'forum_notification'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'rep_tree_limit_grp_crs'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'rep_tree_synchronize'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'preview_learner'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'password_assistance'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'convert_path'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'db_version'), 'value' => array('clob', '4472')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilias_version'), 'value' => array('clob', '3.2.3 2004-11-22')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'inst_info'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'inst_name'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'java_path'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'language'), 'value' => array('clob', 'en')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ldap_basedn'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ldap_port'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ldap_server'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'system_user_id'), 'value' => array('clob', '6')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'anonymous_role_id'), 'value' => array('clob', '14')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'error_recipient'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'pub_section'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'feedback_recipient'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'unzip_path'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'anonymous_user_id'), 'value' => array('clob', '13')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'zip_path'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_registration'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'system_role_id'), 'value' => array('clob', '2')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'recovery_folder_id'), 'value' => array('clob', '15')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'bench_max_records'), 'value' => array('clob', '10000')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_bench'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'sys_user_tracking_id'), 'value' => array('clob', '17')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_tracking'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'save_user_related_data'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'auth_mode'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'auto_registration'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'approve_recipient'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_login'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_passwd'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_passwd2'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_firstname'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_gender'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_lastname'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_institution'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_department'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_street'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_city'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_zipcode'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_country'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_phone_office'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_phone_home'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_phone_mobile'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_fax'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_email'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_hobby'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_default_role'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'require_referral_comment'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_js_edit'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'sys_assessment_folder_id'), 'value' => array('clob', '20')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'default_repository_view'), 'value' => array('clob', 'flat')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_calendar'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'custom_icon_big_width'), 'value' => array('clob', '32')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'custom_icon_big_height'), 'value' => array('clob', '32')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'custom_icon_small_width'), 'value' => array('clob', '22')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'custom_icon_small_height'), 'value' => array('clob', '22')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'icon_position_in_lists'), 'value' => array('clob', 'item_rows')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'new_registration_type'), 'value' => array('clob', '4')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_trash'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'sys_advanced_editing_id'), 'value' => array('clob', '26')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilinc_akclassvalues_required'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'shib_hos_type'), 'value' => array('clob', 'external_wayf')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'shib_federation_name'), 'value' => array('clob', 'Shibboleth')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'shib_idp_list'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'assessment'), 'keyword' => array('text', 'assessment_manual_scoring'), 'value' => array('clob', '8,14')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'show_user_activity'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'user_activity_time'), 'value' => array('clob', '5')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'block_activated_pdusers'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'custom_icon_tiny_width'), 'value' => array('clob', '16')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'custom_icon_tiny_height'), 'value' => array('clob', '16')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'usr_settings_hide_hide_own_online_status'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'news'), 'keyword' => array('text', 'acc_cache_mins'), 'value' => array('clob', '10')));

$ilDB->insert("settings", array(
'module' => array('text', 'file_access'), 'keyword' => array('text', 'inline_file_extensions'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'survey'), 'keyword' => array('text', 'unlimited_invitation'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_account_security_mode'), 'value' => array('clob', '2')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'chat_export_status'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'chat_export_period'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'usr_settings_hide_delicious'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'search_max_hits'), 'value' => array('clob', '10')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'reg_hash_life_time'), 'value' => array('clob', '600')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'disable_contacts'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'disable_contacts_require_mail'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'loginname_change_blocking_time'), 'value' => array('clob', '3600')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'mail_subject_prefix'), 'value' => array('clob', '[ILIAS]')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'proxy_host'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'proxy_port'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'proxy_status'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'usr_settings_hide_sel_country'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'usr_settings_disable_sel_country'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'usr_settings_visib_reg_sel_country'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'usr_settings_visib_lua_sel_country'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'usr_settings_changeable_lua_sel_country'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'session_max_count'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'session_min_idle'), 'value' => array('clob', '15')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'session_max_idle'), 'value' => array('clob', '30')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'session_max_idle_after_first_request'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'session_allow_client_maintenance'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'lm'), 'keyword' => array('text', 'time_scheduled_page_activation'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_anonymous_fora'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'notifications'), 'keyword' => array('text', 'enable_osd'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'notifications'), 'keyword' => array('text', 'enable_mail'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'enable_sahs_pd'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'chatroom'), 'keyword' => array('text', 'public_room_ref'), 'value' => array('clob', '46')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'obj_dis_creation_dbk'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilrqtix'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilmpathix'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilGlobalTstPoolUsageSettingInitilisation'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'rep_shorten_description'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'rep_shorten_description_length'), 'value' => array('clob', '128')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilpghi2'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilpgi3'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilchtrbacfix'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'lp_desktop'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'lp_learner'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'obj_dis_creation_icrs'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'obj_dis_creation_icla'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'MathJax'), 'keyword' => array('text', 'path_to_mathjax'), 'value' => array('clob', 'http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'reuse_of_loginnames'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilchtrperms'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'iltosobjinstall'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'tos_status'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilfrmthri2'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'obj_dis_creation_cld'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ilfrmnoti1'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_password_chars_and_numbers_enabled'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_password_special_chars_enabled'), 'value' => array('clob', '')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_password_min_length'), 'value' => array('clob', '6')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_password_max_length'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_password_max_age'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_login_max_attempts'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'lm_qst_imap_migr_run'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'dbupdate_randtest_pooldef_migration_fix'), 'value' => array('clob', '2')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'db_update_running'), 'value' => array('clob', '0')));

$ilDB->insert("settings", array(
'module' => array('text', 'assessment'), 'keyword' => array('text', 'ass_process_lock_mode'), 'value' => array('clob', 'db')));

$ilDB->insert("settings", array(
'module' => array('text', 'assessment'), 'keyword' => array('text', 'quest_process_lock_mode_autoinit_done'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'ps_export_scorm'), 'value' => array('clob', '1')));

$ilDB->insert("settings", array(
'module' => array('text', 'common'), 'keyword' => array('text', 'db_hotfixes_5_0'), 'value' => array('clob', '13')));


//
// settings_deactivated_s
//
$fields = array (
	"skin" => array (
		"notnull" => true
		,"length" => 100
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"style" => array (
		"notnull" => true
		,"length" => 100
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("settings_deactivated_s", $fields);

$pk_fields = array("skin","style");
$ilDB->addPrimaryKey("settings_deactivated_s", $pk_fields);


//
// shib_role_assignment
//
$fields = array (
	"rule_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"role_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"plugin" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"plugin_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"add_on_update" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"remove_on_update" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("shib_role_assignment", $fields);

$pk_fields = array("rule_id");
$ilDB->addPrimaryKey("shib_role_assignment", $pk_fields);

$ilDB->createSequence("shib_role_assignment", 1);


//
// skl_assigned_material
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"level_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"wsp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_assigned_material", $fields);

$pk_fields = array("user_id","top_skill_id","tref_id","skill_id","level_id","wsp_id");
$ilDB->addPrimaryKey("skl_assigned_material", $pk_fields);


//
// skl_level
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"nr" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"trigger_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"trigger_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_level", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("skl_level", $pk_fields);

$ilDB->createSequence("skl_level", 1);


//
// skl_personal_skill
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_personal_skill", $fields);

$pk_fields = array("user_id","skill_node_id");
$ilDB->addPrimaryKey("skl_personal_skill", $pk_fields);


//
// skl_profile
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("skl_profile", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("skl_profile", $pk_fields);

$ilDB->createSequence("skl_profile", 1);


//
// skl_profile_level
//
$fields = array (
	"profile_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"base_skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"level_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_profile_level", $fields);

$pk_fields = array("profile_id","tref_id","base_skill_id");
$ilDB->addPrimaryKey("skl_profile_level", $pk_fields);


//
// skl_profile_user
//
$fields = array (
	"profile_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_profile_user", $fields);

$pk_fields = array("profile_id","user_id");
$ilDB->addPrimaryKey("skl_profile_user", $pk_fields);


//
// skl_self_eval
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
);
$ilDB->createTable("skl_self_eval", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("skl_self_eval", $pk_fields);

$ilDB->createSequence("skl_self_eval", 1);


//
// skl_self_eval_level
//
$fields = array (
	"skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"level_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"top_skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
);
$ilDB->createTable("skl_self_eval_level", $fields);

$pk_fields = array("user_id","top_skill_id","tref_id","skill_id");
$ilDB->addPrimaryKey("skl_self_eval_level", $pk_fields);


//
// skl_skill_resource
//
$fields = array (
	"base_skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"level_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rep_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"imparting" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ltrigger" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_skill_resource", $fields);

$pk_fields = array("base_skill_id","tref_id","level_id","rep_ref_id");
$ilDB->addPrimaryKey("skl_skill_resource", $pk_fields);


//
// skl_templ_ref
//
$fields = array (
	"skl_node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"templ_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_templ_ref", $fields);

$pk_fields = array("skl_node_id");
$ilDB->addPrimaryKey("skl_templ_ref", $pk_fields);


//
// skl_tree
//
$fields = array (
	"skl_tree_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_tree", $fields);

$ilDB->insert("skl_tree", array(
'skl_tree_id' => array('integer', '1'), 'child' => array('integer', '1'), 'parent' => array('integer', '0'), 'lft' => array('integer', '1'), 'rgt' => array('integer', '2'), 'depth' => array('integer', '1')));


//
// skl_tree_node
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => true
		,"type" => "text"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"self_eval" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_tree_node", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("skl_tree_node", $pk_fields);

$ilDB->createSequence("skl_tree_node", 2);

$ilDB->insert("skl_tree_node", array(
'obj_id' => array('integer', '1'), 'title' => array('text', 'Skill Tree Root Node'), 'type' => array('text', 'skrt'), 'create_date' => array('timestamp', '2011-08-07 11:39:00'), 'last_update' => array('timestamp', ''), 'self_eval' => array('integer', '0'), 'order_nr' => array('integer', '0'), 'status' => array('integer', '0')));


//
// skl_usage
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_usage", $fields);

$pk_fields = array("obj_id","skill_id","tref_id");
$ilDB->addPrimaryKey("skl_usage", $pk_fields);


//
// skl_user_has_level
//
$fields = array (
	"level_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"status_date" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"trigger_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"trigger_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"trigger_title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"trigger_obj_type" => array (
		"notnull" => false
		,"length" => 4
		,"default" => "crs"
		,"fixed" => false
		,"type" => "text"
	)
	,"self_eval" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_user_has_level", $fields);

$pk_fields = array("level_id","user_id","trigger_obj_id","tref_id","self_eval");
$ilDB->addPrimaryKey("skl_user_has_level", $pk_fields);


//
// skl_user_skill_level
//
$fields = array (
	"level_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"status_date" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"valid" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"trigger_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"trigger_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"trigger_title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"trigger_obj_type" => array (
		"notnull" => false
		,"length" => 4
		,"default" => "crs"
		,"fixed" => false
		,"type" => "text"
	)
	,"self_eval" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("skl_user_skill_level", $fields);

$in_fields = array("skill_id");
$ilDB->addIndex("skl_user_skill_level", $in_fields, "isk", false);

$in_fields = array("level_id");
$ilDB->addIndex("skl_user_skill_level", $in_fields, "ilv", false);

$in_fields = array("user_id");
$ilDB->addIndex("skl_user_skill_level", $in_fields, "ius", false);

$in_fields = array("status_date");
$ilDB->addIndex("skl_user_skill_level", $in_fields, "isd", false);

$in_fields = array("status");
$ilDB->addIndex("skl_user_skill_level", $in_fields, "ist", false);

$in_fields = array("valid");
$ilDB->addIndex("skl_user_skill_level", $in_fields, "ivl", false);


//
// sty_media_query
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mquery" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sty_media_query", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sty_media_query", $pk_fields);

$ilDB->createSequence("sty_media_query", 1);


//
// style_char
//
$fields = array (
	"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 30
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"characteristic" => array (
		"notnull" => true
		,"length" => 30
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"hide" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("style_char", $fields);

$pk_fields = array("style_id","type","characteristic");
$ilDB->addPrimaryKey("style_char", $pk_fields);

$in_fields = array("style_id");
$ilDB->addIndex("style_char", $in_fields, "i1", false);


//
// style_color
//
$fields = array (
	"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"color_name" => array (
		"notnull" => true
		,"length" => 30
		,"default" => "."
		,"fixed" => false
		,"type" => "text"
	)
	,"color_code" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("style_color", $fields);

$pk_fields = array("style_id","color_name");
$ilDB->addPrimaryKey("style_color", $pk_fields);


//
// style_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"uptodate" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"standard" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"category" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("style_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("style_data", $pk_fields);


//
// style_folder_styles
//
$fields = array (
	"folder_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("style_folder_styles", $fields);

$in_fields = array("folder_id");
$ilDB->addIndex("style_folder_styles", $in_fields, "i1", false);


//
// style_parameter
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tag" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"class" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"parameter" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"mq_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"custom" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("style_parameter", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("style_parameter", $pk_fields);

$ilDB->createSequence("style_parameter", 1);


//
// style_setting
//
$fields = array (
	"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("style_setting", $fields);

$pk_fields = array("style_id","name");
$ilDB->addPrimaryKey("style_setting", $pk_fields);


//
// style_template
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"preview" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"temp_type" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("style_template", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("style_template", $pk_fields);

$ilDB->createSequence("style_template", 1);


//
// style_template_class
//
$fields = array (
	"template_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"class_type" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => true
		,"type" => "text"
	)
	,"class" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("style_template_class", $fields);


//
// style_usage
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"style_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("style_usage", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("style_usage", $pk_fields);


//
// svy_360_appr
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"has_closed" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_360_appr", $fields);

$pk_fields = array("obj_id","user_id");
$ilDB->addPrimaryKey("svy_360_appr", $pk_fields);


//
// svy_360_rater
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"appr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"anonymous_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mail_sent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_360_rater", $fields);

$pk_fields = array("obj_id","appr_id","user_id","anonymous_id");
$ilDB->addPrimaryKey("svy_360_rater", $pk_fields);


//
// svy_anonymous
//
$fields = array (
	"anonymous_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_key" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"survey_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_key" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"externaldata" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"sent" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_anonymous", $fields);

$pk_fields = array("anonymous_id");
$ilDB->addPrimaryKey("svy_anonymous", $pk_fields);

$in_fields = array("survey_key","survey_fi");
$ilDB->addIndex("svy_anonymous", $in_fields, "i1", false);

$in_fields = array("survey_fi");
$ilDB->addIndex("svy_anonymous", $in_fields, "i2", false);

$in_fields = array("sent");
$ilDB->addIndex("svy_anonymous", $in_fields, "i3", false);

$ilDB->createSequence("svy_anonymous", 1);


//
// svy_answer
//
$fields = array (
	"answer_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"textanswer" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"rowvalue" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_answer", $fields);

$pk_fields = array("answer_id");
$ilDB->addPrimaryKey("svy_answer", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_answer", $in_fields, "i1", false);

$in_fields = array("active_fi");
$ilDB->addIndex("svy_answer", $in_fields, "i2", false);

$ilDB->createSequence("svy_answer", 1);


//
// svy_category
//
$fields = array (
	"category_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"defaultvalue" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"owner_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"neutral" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_category", $fields);

$pk_fields = array("category_id");
$ilDB->addPrimaryKey("svy_category", $pk_fields);

$in_fields = array("owner_fi");
$ilDB->addIndex("svy_category", $in_fields, "i1", false);

$ilDB->createSequence("svy_category", 36);

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '1'), 'title' => array('text', 'dc_desired'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '2'), 'title' => array('text', 'dc_undesired'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '3'), 'title' => array('text', 'dc_agree'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '4'), 'title' => array('text', 'dc_disagree'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '5'), 'title' => array('text', 'dc_good'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '6'), 'title' => array('text', 'dc_notacceptable'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '7'), 'title' => array('text', 'dc_should'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '8'), 'title' => array('text', 'dc_shouldnot'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '9'), 'title' => array('text', 'dc_true'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '10'), 'title' => array('text', 'dc_false'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '11'), 'title' => array('text', 'dc_always'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '12'), 'title' => array('text', 'dc_never'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '13'), 'title' => array('text', 'dc_yes'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '14'), 'title' => array('text', 'dc_no'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '15'), 'title' => array('text', 'dc_neutral'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '16'), 'title' => array('text', 'dc_undecided'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '17'), 'title' => array('text', 'dc_fair'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '18'), 'title' => array('text', 'dc_sometimes'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '19'), 'title' => array('text', 'dc_stronglydesired'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '20'), 'title' => array('text', 'dc_stronglyundesired'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '21'), 'title' => array('text', 'dc_stronglyagree'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '22'), 'title' => array('text', 'dc_stronglydisagree'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '23'), 'title' => array('text', 'dc_verygood'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '24'), 'title' => array('text', 'dc_poor'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '25'), 'title' => array('text', 'dc_must'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '26'), 'title' => array('text', 'dc_mustnot'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '27'), 'title' => array('text', 'dc_definitelytrue'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '28'), 'title' => array('text', 'dc_definitelyfalse'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '29'), 'title' => array('text', 'dc_manytimes'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '30'), 'title' => array('text', 'dc_varying'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '31'), 'title' => array('text', 'dc_rarely'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '32'), 'title' => array('text', 'dc_mostcertainly'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '33'), 'title' => array('text', 'dc_morepositive'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '34'), 'title' => array('text', 'dc_morenegative'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));

$ilDB->insert("svy_category", array(
'category_id' => array('integer', '35'), 'title' => array('text', 'dc_mostcertainlynot'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'neutral' => array('text', '0'), 'tstamp' => array('integer', '1085190181')));


//
// svy_constraint
//
$fields = array (
	"constraint_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"relation_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"conjunction" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_constraint", $fields);

$pk_fields = array("constraint_id");
$ilDB->addPrimaryKey("svy_constraint", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_constraint", $in_fields, "i1", false);

$in_fields = array("relation_fi");
$ilDB->addIndex("svy_constraint", $in_fields, "i2", false);

$ilDB->createSequence("svy_constraint", 1);


//
// svy_finished
//
$fields = array (
	"finished_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"anonymous_id" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"state" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lastpage" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"appr_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_finished", $fields);

$pk_fields = array("finished_id");
$ilDB->addPrimaryKey("svy_finished", $pk_fields);

$in_fields = array("survey_fi");
$ilDB->addIndex("svy_finished", $in_fields, "i1", false);

$in_fields = array("user_fi");
$ilDB->addIndex("svy_finished", $in_fields, "i2", false);

$in_fields = array("anonymous_id");
$ilDB->addIndex("svy_finished", $in_fields, "i3", false);

$ilDB->createSequence("svy_finished", 1);


//
// svy_inv_usr
//
$fields = array (
	"invited_user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_inv_usr", $fields);

$pk_fields = array("invited_user_id");
$ilDB->addPrimaryKey("svy_inv_usr", $pk_fields);

$in_fields = array("survey_fi");
$ilDB->addIndex("svy_inv_usr", $in_fields, "i1", false);

$in_fields = array("user_fi");
$ilDB->addIndex("svy_inv_usr", $in_fields, "i2", false);

$ilDB->createSequence("svy_inv_usr", 1);


//
// svy_material
//
$fields = array (
	"material_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"internal_link" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"import_id" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"material_title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"text_material" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"external_link" => array (
		"notnull" => false
		,"length" => 500
		,"fixed" => false
		,"type" => "text"
	)
	,"file_material" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"material_type" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_material", $fields);

$pk_fields = array("material_id");
$ilDB->addPrimaryKey("svy_material", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_material", $in_fields, "i1", false);

$ilDB->createSequence("svy_material", 1);


//
// svy_phrase
//
$fields = array (
	"phrase_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"defaultvalue" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"owner_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_phrase", $fields);

$pk_fields = array("phrase_id");
$ilDB->addPrimaryKey("svy_phrase", $pk_fields);

$in_fields = array("owner_fi");
$ilDB->addIndex("svy_phrase", $in_fields, "i1", false);

$ilDB->createSequence("svy_phrase", 23);

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '1'), 'title' => array('text', 'dp_standard_attitude_desired_undesired'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085190871')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '2'), 'title' => array('text', 'dp_standard_attitude_agree_disagree'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085190898')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '3'), 'title' => array('text', 'dp_standard_attitude_good_notacceptable'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085190918')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '4'), 'title' => array('text', 'dp_standard_attitude_shold_shouldnot'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085190946')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '5'), 'title' => array('text', 'dp_standard_beliefs_true_false'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085190973')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '6'), 'title' => array('text', 'dp_standard_beliefs_always_never'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '7'), 'title' => array('text', 'dp_standard_behaviour_yes_no'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '8'), 'title' => array('text', 'dp_standard_attitude_desired_neutral_undesired'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '9'), 'title' => array('text', 'dp_standard_attitude_agree_undecided_disagree'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '10'), 'title' => array('text', 'dp_standard_attitude_good_fair_notacceptable'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '11'), 'title' => array('text', 'dp_standard_attitude_should_undecided_shouldnot'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '12'), 'title' => array('text', 'dp_standard_beliefs_true_undecided_false'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '13'), 'title' => array('text', 'dp_standard_beliefs_always_sometimes_never'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '14'), 'title' => array('text', 'dp_standard_behaviour_yes_undecided_no'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085191547')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '15'), 'title' => array('text', 'dp_standard_attitude_desired5'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085195222')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '16'), 'title' => array('text', 'dp_standard_attitude_agree5'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085195237')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '17'), 'title' => array('text', 'dp_standard_attitude_good5'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085195249')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '18'), 'title' => array('text', 'dp_standard_attitude_must5'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085195264')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '19'), 'title' => array('text', 'dp_standard_beliefs_true5'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085195274')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '20'), 'title' => array('text', 'dp_standard_beliefs_always5'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085195292')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '21'), 'title' => array('text', 'dp_standard_behaviour_certainly5'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1085195308')));

$ilDB->insert("svy_phrase", array(
'phrase_id' => array('integer', '22'), 'title' => array('text', 'dp_standard_numbers'), 'defaultvalue' => array('text', '1'), 'owner_fi' => array('integer', '0'), 'tstamp' => array('integer', '1087738039')));


//
// svy_phrase_cat
//
$fields = array (
	"phrase_category_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"phrase_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"category_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"other" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"scale" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_phrase_cat", $fields);

$pk_fields = array("phrase_category_id");
$ilDB->addPrimaryKey("svy_phrase_cat", $pk_fields);

$in_fields = array("phrase_fi");
$ilDB->addIndex("svy_phrase_cat", $in_fields, "i1", false);

$in_fields = array("category_fi");
$ilDB->addIndex("svy_phrase_cat", $in_fields, "i2", false);

$ilDB->createSequence("svy_phrase_cat", 71);

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '1'), 'phrase_fi' => array('integer', '1'), 'category_fi' => array('integer', '1'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '2'), 'phrase_fi' => array('integer', '1'), 'category_fi' => array('integer', '2'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '3'), 'phrase_fi' => array('integer', '2'), 'category_fi' => array('integer', '3'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '4'), 'phrase_fi' => array('integer', '2'), 'category_fi' => array('integer', '4'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '5'), 'phrase_fi' => array('integer', '3'), 'category_fi' => array('integer', '5'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '6'), 'phrase_fi' => array('integer', '3'), 'category_fi' => array('integer', '6'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '7'), 'phrase_fi' => array('integer', '4'), 'category_fi' => array('integer', '7'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '8'), 'phrase_fi' => array('integer', '4'), 'category_fi' => array('integer', '8'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '9'), 'phrase_fi' => array('integer', '5'), 'category_fi' => array('integer', '9'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '10'), 'phrase_fi' => array('integer', '5'), 'category_fi' => array('integer', '10'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '11'), 'phrase_fi' => array('integer', '6'), 'category_fi' => array('integer', '11'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '12'), 'phrase_fi' => array('integer', '6'), 'category_fi' => array('integer', '12'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '13'), 'phrase_fi' => array('integer', '7'), 'category_fi' => array('integer', '13'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '14'), 'phrase_fi' => array('integer', '7'), 'category_fi' => array('integer', '14'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '15'), 'phrase_fi' => array('integer', '8'), 'category_fi' => array('integer', '1'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '16'), 'phrase_fi' => array('integer', '8'), 'category_fi' => array('integer', '15'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '17'), 'phrase_fi' => array('integer', '8'), 'category_fi' => array('integer', '2'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '18'), 'phrase_fi' => array('integer', '9'), 'category_fi' => array('integer', '3'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '19'), 'phrase_fi' => array('integer', '9'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '20'), 'phrase_fi' => array('integer', '9'), 'category_fi' => array('integer', '4'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '21'), 'phrase_fi' => array('integer', '10'), 'category_fi' => array('integer', '5'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '22'), 'phrase_fi' => array('integer', '10'), 'category_fi' => array('integer', '17'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '23'), 'phrase_fi' => array('integer', '10'), 'category_fi' => array('integer', '6'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '24'), 'phrase_fi' => array('integer', '11'), 'category_fi' => array('integer', '7'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '25'), 'phrase_fi' => array('integer', '11'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '26'), 'phrase_fi' => array('integer', '11'), 'category_fi' => array('integer', '8'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '27'), 'phrase_fi' => array('integer', '12'), 'category_fi' => array('integer', '9'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '28'), 'phrase_fi' => array('integer', '12'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '29'), 'phrase_fi' => array('integer', '12'), 'category_fi' => array('integer', '10'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '30'), 'phrase_fi' => array('integer', '13'), 'category_fi' => array('integer', '11'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '31'), 'phrase_fi' => array('integer', '13'), 'category_fi' => array('integer', '18'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '32'), 'phrase_fi' => array('integer', '13'), 'category_fi' => array('integer', '12'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '33'), 'phrase_fi' => array('integer', '14'), 'category_fi' => array('integer', '13'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '34'), 'phrase_fi' => array('integer', '14'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '35'), 'phrase_fi' => array('integer', '14'), 'category_fi' => array('integer', '14'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '36'), 'phrase_fi' => array('integer', '15'), 'category_fi' => array('integer', '19'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '37'), 'phrase_fi' => array('integer', '15'), 'category_fi' => array('integer', '1'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '38'), 'phrase_fi' => array('integer', '15'), 'category_fi' => array('integer', '15'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '39'), 'phrase_fi' => array('integer', '15'), 'category_fi' => array('integer', '2'), 'sequence' => array('integer', '4'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '40'), 'phrase_fi' => array('integer', '15'), 'category_fi' => array('integer', '20'), 'sequence' => array('integer', '5'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '41'), 'phrase_fi' => array('integer', '16'), 'category_fi' => array('integer', '21'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '42'), 'phrase_fi' => array('integer', '16'), 'category_fi' => array('integer', '3'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '43'), 'phrase_fi' => array('integer', '16'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '44'), 'phrase_fi' => array('integer', '16'), 'category_fi' => array('integer', '4'), 'sequence' => array('integer', '4'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '45'), 'phrase_fi' => array('integer', '16'), 'category_fi' => array('integer', '22'), 'sequence' => array('integer', '5'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '46'), 'phrase_fi' => array('integer', '17'), 'category_fi' => array('integer', '23'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '47'), 'phrase_fi' => array('integer', '17'), 'category_fi' => array('integer', '5'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '48'), 'phrase_fi' => array('integer', '17'), 'category_fi' => array('integer', '17'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '49'), 'phrase_fi' => array('integer', '17'), 'category_fi' => array('integer', '24'), 'sequence' => array('integer', '4'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '50'), 'phrase_fi' => array('integer', '17'), 'category_fi' => array('integer', '6'), 'sequence' => array('integer', '5'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '51'), 'phrase_fi' => array('integer', '18'), 'category_fi' => array('integer', '25'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '52'), 'phrase_fi' => array('integer', '18'), 'category_fi' => array('integer', '7'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '53'), 'phrase_fi' => array('integer', '18'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '54'), 'phrase_fi' => array('integer', '18'), 'category_fi' => array('integer', '8'), 'sequence' => array('integer', '4'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '55'), 'phrase_fi' => array('integer', '18'), 'category_fi' => array('integer', '26'), 'sequence' => array('integer', '5'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '56'), 'phrase_fi' => array('integer', '19'), 'category_fi' => array('integer', '27'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '57'), 'phrase_fi' => array('integer', '19'), 'category_fi' => array('integer', '9'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '58'), 'phrase_fi' => array('integer', '19'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '59'), 'phrase_fi' => array('integer', '19'), 'category_fi' => array('integer', '10'), 'sequence' => array('integer', '4'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '60'), 'phrase_fi' => array('integer', '19'), 'category_fi' => array('integer', '28'), 'sequence' => array('integer', '5'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '61'), 'phrase_fi' => array('integer', '20'), 'category_fi' => array('integer', '11'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '62'), 'phrase_fi' => array('integer', '20'), 'category_fi' => array('integer', '29'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '63'), 'phrase_fi' => array('integer', '20'), 'category_fi' => array('integer', '30'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '64'), 'phrase_fi' => array('integer', '20'), 'category_fi' => array('integer', '31'), 'sequence' => array('integer', '4'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '65'), 'phrase_fi' => array('integer', '20'), 'category_fi' => array('integer', '12'), 'sequence' => array('integer', '5'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '66'), 'phrase_fi' => array('integer', '21'), 'category_fi' => array('integer', '32'), 'sequence' => array('integer', '1'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '67'), 'phrase_fi' => array('integer', '21'), 'category_fi' => array('integer', '33'), 'sequence' => array('integer', '2'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '68'), 'phrase_fi' => array('integer', '21'), 'category_fi' => array('integer', '16'), 'sequence' => array('integer', '3'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '69'), 'phrase_fi' => array('integer', '21'), 'category_fi' => array('integer', '34'), 'sequence' => array('integer', '4'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));

$ilDB->insert("svy_phrase_cat", array(
'phrase_category_id' => array('integer', '70'), 'phrase_fi' => array('integer', '21'), 'category_fi' => array('integer', '35'), 'sequence' => array('integer', '5'), 'other' => array('integer', '0'), 'scale' => array('integer', '')));


//
// svy_qblk
//
$fields = array (
	"questionblock_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"show_questiontext" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"owner_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"show_blocktitle" => array (
		"notnull" => false
		,"length" => 1
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("svy_qblk", $fields);

$pk_fields = array("questionblock_id");
$ilDB->addPrimaryKey("svy_qblk", $pk_fields);

$in_fields = array("owner_fi");
$ilDB->addIndex("svy_qblk", $in_fields, "i1", false);

$ilDB->createSequence("svy_qblk", 1);


//
// svy_qblk_qst
//
$fields = array (
	"qblk_qst_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"questionblock_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qblk_qst", $fields);

$pk_fields = array("qblk_qst_id");
$ilDB->addPrimaryKey("svy_qblk_qst", $pk_fields);

$in_fields = array("survey_fi");
$ilDB->addIndex("svy_qblk_qst", $in_fields, "i1", false);

$in_fields = array("questionblock_fi");
$ilDB->addIndex("svy_qblk_qst", $in_fields, "i2", false);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_qblk_qst", $in_fields, "i3", false);

$ilDB->createSequence("svy_qblk_qst", 1);


//
// svy_qpl
//
$fields = array (
	"id_questionpool" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"isonline" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qpl", $fields);

$pk_fields = array("id_questionpool");
$ilDB->addPrimaryKey("svy_qpl", $pk_fields);

$in_fields = array("obj_fi");
$ilDB->addIndex("svy_qpl", $in_fields, "i1", false);

$ilDB->createSequence("svy_qpl", 1);


//
// svy_qst_constraint
//
$fields = array (
	"question_constraint_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"constraint_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qst_constraint", $fields);

$pk_fields = array("question_constraint_id");
$ilDB->addPrimaryKey("svy_qst_constraint", $pk_fields);

$in_fields = array("survey_fi");
$ilDB->addIndex("svy_qst_constraint", $in_fields, "i1", false);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_qst_constraint", $in_fields, "i2", false);

$in_fields = array("constraint_fi");
$ilDB->addIndex("svy_qst_constraint", $in_fields, "i3", false);

$ilDB->createSequence("svy_qst_constraint", 1);


//
// svy_qst_matrix
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"subtype" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"column_separators" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"row_separators" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"neutral_column_separator" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"column_placeholders" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"legend" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"singleline_row_caption" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"repeat_column_header" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"column_header_position" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"random_rows" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"column_order" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"column_images" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"row_images" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"bipolar_adjective1" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"bipolar_adjective2" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"layout" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qst_matrix", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("svy_qst_matrix", $pk_fields);


//
// svy_qst_matrixrows
//
$fields = array (
	"id_svy_qst_matrixrows" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"other" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"label" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("svy_qst_matrixrows", $fields);

$pk_fields = array("id_svy_qst_matrixrows");
$ilDB->addPrimaryKey("svy_qst_matrixrows", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_qst_matrixrows", $in_fields, "i1", false);

$ilDB->createSequence("svy_qst_matrixrows", 1);


//
// svy_qst_mc
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"orientation" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"use_min_answers" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"nr_min_answers" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"nr_max_answers" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qst_mc", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("svy_qst_mc", $pk_fields);


//
// svy_qst_metric
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"subtype" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "3"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("svy_qst_metric", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("svy_qst_metric", $pk_fields);


//
// svy_qst_oblig
//
$fields = array (
	"question_obligatory_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obligatory" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qst_oblig", $fields);

$pk_fields = array("question_obligatory_id");
$ilDB->addPrimaryKey("svy_qst_oblig", $pk_fields);

$in_fields = array("survey_fi","question_fi");
$ilDB->addIndex("svy_qst_oblig", $in_fields, "i1", false);

$ilDB->createSequence("svy_qst_oblig", 1);


//
// svy_qst_sc
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"orientation" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("svy_qst_sc", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("svy_qst_sc", $pk_fields);


//
// svy_qst_text
//
$fields = array (
	"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"maxchars" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"width" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "50"
		,"type" => "integer"
	)
	,"height" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "5"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qst_text", $fields);

$pk_fields = array("question_fi");
$ilDB->addPrimaryKey("svy_qst_text", $pk_fields);


//
// svy_qtype
//
$fields = array (
	"questiontype_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type_tag" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"plugin" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_qtype", $fields);

$pk_fields = array("questiontype_id");
$ilDB->addPrimaryKey("svy_qtype", $pk_fields);

$ilDB->createSequence("svy_qtype", 6);

$ilDB->insert("svy_qtype", array(
'questiontype_id' => array('integer', '1'), 'type_tag' => array('text', 'SurveyMultipleChoiceQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("svy_qtype", array(
'questiontype_id' => array('integer', '2'), 'type_tag' => array('text', 'SurveySingleChoiceQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("svy_qtype", array(
'questiontype_id' => array('integer', '3'), 'type_tag' => array('text', 'SurveyMetricQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("svy_qtype", array(
'questiontype_id' => array('integer', '4'), 'type_tag' => array('text', 'SurveyTextQuestion'), 'plugin' => array('integer', '0')));

$ilDB->insert("svy_qtype", array(
'questiontype_id' => array('integer', '5'), 'type_tag' => array('text', 'SurveyMatrixQuestion'), 'plugin' => array('integer', '0')));


//
// svy_quest_skill
//
$fields = array (
	"q_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"base_skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_quest_skill", $fields);

$pk_fields = array("q_id");
$ilDB->addPrimaryKey("svy_quest_skill", $pk_fields);


//
// svy_question
//
$fields = array (
	"question_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"questiontype_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"owner_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"author" => array (
		"notnull" => false
		,"length" => 100
		,"fixed" => false
		,"type" => "text"
	)
	,"obligatory" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"complete" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"created" => array (
		"notnull" => false
		,"length" => 14
		,"fixed" => false
		,"type" => "text"
	)
	,"original_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"questiontext" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"label" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("svy_question", $fields);

$pk_fields = array("question_id");
$ilDB->addPrimaryKey("svy_question", $pk_fields);

$in_fields = array("obj_fi");
$ilDB->addIndex("svy_question", $in_fields, "i1", false);

$in_fields = array("owner_fi");
$ilDB->addIndex("svy_question", $in_fields, "i2", false);

$in_fields = array("title","description");
$ilDB->addIndex("svy_question", $in_fields, "i3", true);

$ilDB->createSequence("svy_question", 1);


//
// svy_relation
//
$fields = array (
	"relation_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"longname" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"shortname" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_relation", $fields);

$pk_fields = array("relation_id");
$ilDB->addPrimaryKey("svy_relation", $pk_fields);

$ilDB->createSequence("svy_relation", 7);

$ilDB->insert("svy_relation", array(
'relation_id' => array('integer', '1'), 'longname' => array('text', 'less'), 'shortname' => array('text', '<'), 'tstamp' => array('integer', '1084867073')));

$ilDB->insert("svy_relation", array(
'relation_id' => array('integer', '2'), 'longname' => array('text', 'less_or_equal'), 'shortname' => array('text', '<='), 'tstamp' => array('integer', '1084867088')));

$ilDB->insert("svy_relation", array(
'relation_id' => array('integer', '3'), 'longname' => array('text', 'equal'), 'shortname' => array('text', '='), 'tstamp' => array('integer', '1084867096')));

$ilDB->insert("svy_relation", array(
'relation_id' => array('integer', '4'), 'longname' => array('text', 'not_equal'), 'shortname' => array('text', '<>'), 'tstamp' => array('integer', '1084867119')));

$ilDB->insert("svy_relation", array(
'relation_id' => array('integer', '5'), 'longname' => array('text', 'more_or_equal'), 'shortname' => array('text', '>='), 'tstamp' => array('integer', '1084867132')));

$ilDB->insert("svy_relation", array(
'relation_id' => array('integer', '6'), 'longname' => array('text', 'more'), 'shortname' => array('text', '>'), 'tstamp' => array('integer', '1084867143')));


//
// svy_settings
//
$fields = array (
	"settings_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"keyword" => array (
		"notnull" => true
		,"length" => 40
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("svy_settings", $fields);

$pk_fields = array("settings_id");
$ilDB->addPrimaryKey("svy_settings", $pk_fields);

$in_fields = array("usr_id");
$ilDB->addIndex("svy_settings", $in_fields, "i1", false);

$ilDB->createSequence("svy_settings", 1);


//
// svy_skill_threshold
//
$fields = array (
	"survey_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"base_skill_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"level_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"threshold" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_skill_threshold", $fields);

$pk_fields = array("survey_id","base_skill_id","tref_id","level_id");
$ilDB->addPrimaryKey("svy_skill_threshold", $pk_fields);


//
// svy_svy
//
$fields = array (
	"survey_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"author" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"introduction" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"outro" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"evaluation_access" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"invitation" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"invitation_mode" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"complete" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"anonymize" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"show_question_titles" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mailnotification" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"startdate" => array (
		"notnull" => false
		,"length" => 14
		,"fixed" => false
		,"type" => "text"
	)
	,"enddate" => array (
		"notnull" => false
		,"length" => 14
		,"fixed" => false
		,"type" => "text"
	)
	,"mailaddresses" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
	,"mailparticipantdata" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"template_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"pool_usage" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mode_360" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mode_360_self_eval" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mode_360_self_rate" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mode_360_self_appr" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mode_360_results" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mode_360_skill_service" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reminder_status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reminder_start" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"reminder_end" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"reminder_frequency" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reminder_target" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tutor_ntf_status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tutor_ntf_reci" => array (
		"notnull" => false
		,"length" => 2000
		,"fixed" => false
		,"type" => "text"
	)
	,"tutor_ntf_target" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reminder_last_sent" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"own_results_view" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"own_results_mail" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_svy", $fields);

$pk_fields = array("survey_id");
$ilDB->addPrimaryKey("svy_svy", $pk_fields);

$in_fields = array("obj_fi");
$ilDB->addIndex("svy_svy", $in_fields, "i1", false);

$in_fields = array("introduction");
$ilDB->addIndex("svy_svy", $in_fields, "i2", true);

$ilDB->createSequence("svy_svy", 1);


//
// svy_svy_qst
//
$fields = array (
	"survey_question_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"survey_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"heading" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_svy_qst", $fields);

$pk_fields = array("survey_question_id");
$ilDB->addPrimaryKey("svy_svy_qst", $pk_fields);

$in_fields = array("survey_fi");
$ilDB->addIndex("svy_svy_qst", $in_fields, "i1", false);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_svy_qst", $in_fields, "i2", false);

$ilDB->createSequence("svy_svy_qst", 1);


//
// svy_times
//
$fields = array (
	"finished_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"entered_page" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"left_page" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"first_question" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_times", $fields);

$in_fields = array("finished_fi");
$ilDB->addIndex("svy_times", $in_fields, "i1", false);


//
// svy_variable
//
$fields = array (
	"variable_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"category_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value1" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"value2" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"other" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"scale" => array (
		"notnull" => false
		,"length" => 3
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("svy_variable", $fields);

$pk_fields = array("variable_id");
$ilDB->addPrimaryKey("svy_variable", $pk_fields);

$in_fields = array("category_fi");
$ilDB->addIndex("svy_variable", $in_fields, "i1", false);

$in_fields = array("question_fi");
$ilDB->addIndex("svy_variable", $in_fields, "i2", false);

$ilDB->createSequence("svy_variable", 1);


//
// sysc_groups
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"component" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => true
		,"type" => "text"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("sysc_groups", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sysc_groups", $pk_fields);

$ilDB->createSequence("sysc_groups", 1);


//
// sysc_tasks
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"grp_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"identifier" => array (
		"notnull" => false
		,"length" => 64
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("sysc_tasks", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("sysc_tasks", $pk_fields);

$ilDB->createSequence("sysc_tasks", 1);


//
// syst_style_cat
//
$fields = array (
	"skin_id" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"style_id" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"substyle" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"category_ref_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("syst_style_cat", $fields);

$pk_fields = array("skin_id","style_id","substyle","category_ref_id");
$ilDB->addPrimaryKey("syst_style_cat", $pk_fields);


//
// table_properties
//
$fields = array (
	"table_id" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"property" => array (
		"notnull" => true
		,"length" => 20
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("table_properties", $fields);

$pk_fields = array("table_id","user_id","property");
$ilDB->addPrimaryKey("table_properties", $pk_fields);


//
// table_templates
//
$fields = array (
	"name" => array (
		"notnull" => true
		,"length" => 64
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"context" => array (
		"notnull" => true
		,"length" => 128
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("table_templates", $fields);

$pk_fields = array("name","user_id","context");
$ilDB->addPrimaryKey("table_templates", $pk_fields);


//
// tax_data
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sorting_mode" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_sorting" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tax_data", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("tax_data", $pk_fields);


//
// tax_node
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => true
		,"type" => "text"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"tax_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tax_node", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("tax_node", $pk_fields);

$ilDB->createSequence("tax_node", 2);

$ilDB->insert("tax_node", array(
'obj_id' => array('integer', '1'), 'title' => array('text', 'Dummy top node for all tax trees.'), 'type' => array('text', ''), 'create_date' => array('timestamp', '2012-09-04 14:25:23'), 'last_update' => array('timestamp', '2012-09-04 14:25:23'), 'tax_id' => array('integer', '0'), 'order_nr' => array('integer', '0')));


//
// tax_node_assignment
//
$fields = array (
	"node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"component" => array (
		"notnull" => true
		,"length" => 10
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"item_type" => array (
		"notnull" => true
		,"length" => 20
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tax_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tax_node_assignment", $fields);

$pk_fields = array("node_id","component","obj_id","item_type","item_id");
$ilDB->addPrimaryKey("tax_node_assignment", $pk_fields);

$in_fields = array("component","item_type","item_id");
$ilDB->addIndex("tax_node_assignment", $in_fields, "i1", false);


//
// tax_tree
//
$fields = array (
	"tax_tree_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tax_tree", $fields);

$pk_fields = array("tax_tree_id","child");
$ilDB->addPrimaryKey("tax_tree", $pk_fields);


//
// tax_usage
//
$fields = array (
	"tax_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tax_usage", $fields);

$pk_fields = array("tax_id","obj_id");
$ilDB->addPrimaryKey("tax_usage", $pk_fields);


//
// tos_acceptance_track
//
$fields = array (
	"tosv_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ts" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tos_acceptance_track", $fields);

$pk_fields = array("tosv_id","usr_id","ts");
$ilDB->addPrimaryKey("tos_acceptance_track", $pk_fields);

$in_fields = array("usr_id","ts");
$ilDB->addIndex("tos_acceptance_track", $in_fields, "i1", false);

$ilDB->createSequence("tos_acceptance_track", 1);


//
// tos_versions
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lng" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => false
		,"type" => "text"
	)
	,"src" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"text" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"hash" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"ts" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"src_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tos_versions", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("tos_versions", $pk_fields);

$in_fields = array("hash","lng");
$ilDB->addIndex("tos_versions", $in_fields, "i1", false);

$ilDB->createSequence("tos_versions", 1);


//
// tree
//
$fields = array (
	"tree" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"path" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("tree", $fields);

$in_fields = array("child");
$ilDB->addIndex("tree", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("tree", $in_fields, "i2", false);

$in_fields = array("tree");
$ilDB->addIndex("tree", $in_fields, "i3", false);

$in_fields = array("lft");
$ilDB->addIndex("tree", $in_fields, "i4", false);

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '1'), 'parent' => array('integer', '0'), 'lft' => array('integer', '1'), 'rgt' => array('integer', '344'), 'depth' => array('integer', '1'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '7'), 'parent' => array('integer', '9'), 'lft' => array('integer', '5'), 'rgt' => array('integer', '6'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '8'), 'parent' => array('integer', '9'), 'lft' => array('integer', '7'), 'rgt' => array('integer', '8'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '9'), 'parent' => array('integer', '1'), 'lft' => array('integer', '2'), 'rgt' => array('integer', '343'), 'depth' => array('integer', '2'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '10'), 'parent' => array('integer', '9'), 'lft' => array('integer', '9'), 'rgt' => array('integer', '10'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '11'), 'parent' => array('integer', '9'), 'lft' => array('integer', '11'), 'rgt' => array('integer', '12'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '12'), 'parent' => array('integer', '9'), 'lft' => array('integer', '3'), 'rgt' => array('integer', '4'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '14'), 'parent' => array('integer', '9'), 'lft' => array('integer', '13'), 'rgt' => array('integer', '18'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '15'), 'parent' => array('integer', '9'), 'lft' => array('integer', '19'), 'rgt' => array('integer', '20'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '16'), 'parent' => array('integer', '9'), 'lft' => array('integer', '21'), 'rgt' => array('integer', '22'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '17'), 'parent' => array('integer', '9'), 'lft' => array('integer', '23'), 'rgt' => array('integer', '24'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '18'), 'parent' => array('integer', '9'), 'lft' => array('integer', '25'), 'rgt' => array('integer', '26'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '19'), 'parent' => array('integer', '9'), 'lft' => array('integer', '27'), 'rgt' => array('integer', '28'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '20'), 'parent' => array('integer', '9'), 'lft' => array('integer', '29'), 'rgt' => array('integer', '30'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '21'), 'parent' => array('integer', '9'), 'lft' => array('integer', '31'), 'rgt' => array('integer', '32'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '22'), 'parent' => array('integer', '9'), 'lft' => array('integer', '33'), 'rgt' => array('integer', '34'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '23'), 'parent' => array('integer', '9'), 'lft' => array('integer', '35'), 'rgt' => array('integer', '36'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '24'), 'parent' => array('integer', '14'), 'lft' => array('integer', '14'), 'rgt' => array('integer', '17'), 'depth' => array('integer', '4'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '25'), 'parent' => array('integer', '24'), 'lft' => array('integer', '15'), 'rgt' => array('integer', '16'), 'depth' => array('integer', '5'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '26'), 'parent' => array('integer', '9'), 'lft' => array('integer', '37'), 'rgt' => array('integer', '38'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '27'), 'parent' => array('integer', '9'), 'lft' => array('integer', '39'), 'rgt' => array('integer', '40'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '28'), 'parent' => array('integer', '9'), 'lft' => array('integer', '41'), 'rgt' => array('integer', '42'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '29'), 'parent' => array('integer', '9'), 'lft' => array('integer', '43'), 'rgt' => array('integer', '44'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '30'), 'parent' => array('integer', '9'), 'lft' => array('integer', '45'), 'rgt' => array('integer', '46'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '31'), 'parent' => array('integer', '9'), 'lft' => array('integer', '47'), 'rgt' => array('integer', '48'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '32'), 'parent' => array('integer', '9'), 'lft' => array('integer', '49'), 'rgt' => array('integer', '50'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '33'), 'parent' => array('integer', '9'), 'lft' => array('integer', '51'), 'rgt' => array('integer', '52'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '34'), 'parent' => array('integer', '9'), 'lft' => array('integer', '53'), 'rgt' => array('integer', '54'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '35'), 'parent' => array('integer', '9'), 'lft' => array('integer', '55'), 'rgt' => array('integer', '56'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '36'), 'parent' => array('integer', '9'), 'lft' => array('integer', '57'), 'rgt' => array('integer', '58'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '37'), 'parent' => array('integer', '9'), 'lft' => array('integer', '59'), 'rgt' => array('integer', '60'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '38'), 'parent' => array('integer', '9'), 'lft' => array('integer', '61'), 'rgt' => array('integer', '62'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '39'), 'parent' => array('integer', '9'), 'lft' => array('integer', '63'), 'rgt' => array('integer', '64'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '40'), 'parent' => array('integer', '9'), 'lft' => array('integer', '65'), 'rgt' => array('integer', '66'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '41'), 'parent' => array('integer', '9'), 'lft' => array('integer', '67'), 'rgt' => array('integer', '68'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '42'), 'parent' => array('integer', '9'), 'lft' => array('integer', '69'), 'rgt' => array('integer', '70'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '43'), 'parent' => array('integer', '9'), 'lft' => array('integer', '71'), 'rgt' => array('integer', '72'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '44'), 'parent' => array('integer', '9'), 'lft' => array('integer', '73'), 'rgt' => array('integer', '278'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '45'), 'parent' => array('integer', '9'), 'lft' => array('integer', '279'), 'rgt' => array('integer', '280'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '46'), 'parent' => array('integer', '44'), 'lft' => array('integer', '74'), 'rgt' => array('integer', '177'), 'depth' => array('integer', '4'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '47'), 'parent' => array('integer', '46'), 'lft' => array('integer', '75'), 'rgt' => array('integer', '76'), 'depth' => array('integer', '5'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '48'), 'parent' => array('integer', '9'), 'lft' => array('integer', '281'), 'rgt' => array('integer', '282'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '49'), 'parent' => array('integer', '9'), 'lft' => array('integer', '283'), 'rgt' => array('integer', '284'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '50'), 'parent' => array('integer', '9'), 'lft' => array('integer', '285'), 'rgt' => array('integer', '286'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '51'), 'parent' => array('integer', '9'), 'lft' => array('integer', '287'), 'rgt' => array('integer', '288'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '52'), 'parent' => array('integer', '9'), 'lft' => array('integer', '289'), 'rgt' => array('integer', '290'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '53'), 'parent' => array('integer', '9'), 'lft' => array('integer', '291'), 'rgt' => array('integer', '292'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '54'), 'parent' => array('integer', '9'), 'lft' => array('integer', '293'), 'rgt' => array('integer', '294'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '55'), 'parent' => array('integer', '9'), 'lft' => array('integer', '295'), 'rgt' => array('integer', '296'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '56'), 'parent' => array('integer', '9'), 'lft' => array('integer', '297'), 'rgt' => array('integer', '298'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '57'), 'parent' => array('integer', '9'), 'lft' => array('integer', '299'), 'rgt' => array('integer', '300'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '58'), 'parent' => array('integer', '9'), 'lft' => array('integer', '301'), 'rgt' => array('integer', '302'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '59'), 'parent' => array('integer', '9'), 'lft' => array('integer', '303'), 'rgt' => array('integer', '304'), 'depth' => array('integer', '3'), 'path' => array('text', '')));

$ilDB->insert("tree", array(
'tree' => array('integer', '1'), 'child' => array('integer', '60'), 'parent' => array('integer', '9'), 'lft' => array('integer', '305'), 'rgt' => array('integer', '306'), 'depth' => array('integer', '3'), 'path' => array('text', '')));


//
// tree_workspace
//
$fields = array (
	"tree" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"child" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"lft" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"rgt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"depth" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tree_workspace", $fields);

$in_fields = array("child");
$ilDB->addIndex("tree_workspace", $in_fields, "i1", false);

$in_fields = array("parent");
$ilDB->addIndex("tree_workspace", $in_fields, "i2", false);

$in_fields = array("tree");
$ilDB->addIndex("tree_workspace", $in_fields, "i3", false);


//
// tst_active
//
$fields = array (
	"active_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"anonymous_id" => array (
		"notnull" => false
		,"length" => 5
		,"fixed" => false
		,"type" => "text"
	)
	,"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tries" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"submitted" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"submittimestamp" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"importname" => array (
		"notnull" => false
		,"length" => 400
		,"fixed" => false
		,"type" => "text"
	)
	,"taxfilter" => array (
		"notnull" => false
		,"length" => 1024
		,"fixed" => false
		,"type" => "text"
	)
	,"lastindex" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_finished_pass" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"answerstatusfilter" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"objective_container" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"start_lock" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("tst_active", $fields);

$pk_fields = array("active_id");
$ilDB->addPrimaryKey("tst_active", $pk_fields);

$in_fields = array("user_fi");
$ilDB->addIndex("tst_active", $in_fields, "i1", false);

$in_fields = array("test_fi");
$ilDB->addIndex("tst_active", $in_fields, "i2", false);

$in_fields = array("anonymous_id");
$ilDB->addIndex("tst_active", $in_fields, "i3", false);

$in_fields = array("user_fi","test_fi","anonymous_id");
$ilDB->addUniqueConstraint("tst_active", $in_fields, "uc1");

$ilDB->createSequence("tst_active", 1);


//
// tst_addtime
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"additionaltime" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_addtime", $fields);

$in_fields = array("active_fi");
$ilDB->addIndex("tst_addtime", $in_fields, "i1", false);


//
// tst_dyn_quest_set_cfg
//
$fields = array (
	"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"source_qpl_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tax_filter_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"order_tax" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"source_qpl_title" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"answer_filter_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"prev_quest_list_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_dyn_quest_set_cfg", $fields);

$pk_fields = array("test_fi");
$ilDB->addPrimaryKey("tst_dyn_quest_set_cfg", $pk_fields);


//
// tst_invited_user
//
$fields = array (
	"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"clientip" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_invited_user", $fields);

$pk_fields = array("test_fi","user_fi");
$ilDB->addPrimaryKey("tst_invited_user", $pk_fields);


//
// tst_manual_fb
//
$fields = array (
	"manual_feedback_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"feedback" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("tst_manual_fb", $fields);

$pk_fields = array("manual_feedback_id");
$ilDB->addPrimaryKey("tst_manual_fb", $pk_fields);

$in_fields = array("active_fi");
$ilDB->addIndex("tst_manual_fb", $in_fields, "i1", false);

$in_fields = array("question_fi");
$ilDB->addIndex("tst_manual_fb", $in_fields, "i2", false);

$in_fields = array("pass");
$ilDB->addIndex("tst_manual_fb", $in_fields, "i3", false);

$ilDB->createSequence("tst_manual_fb", 1);


//
// tst_mark
//
$fields = array (
	"mark_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"short_name" => array (
		"notnull" => false
		,"length" => 15
		,"fixed" => false
		,"type" => "text"
	)
	,"official_name" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"minimum_level" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"passed" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_mark", $fields);

$pk_fields = array("mark_id");
$ilDB->addPrimaryKey("tst_mark", $pk_fields);

$in_fields = array("test_fi");
$ilDB->addIndex("tst_mark", $in_fields, "i1", false);

$ilDB->createSequence("tst_mark", 1);


//
// tst_pass_result
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"maxpoints" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"questioncount" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"answeredquestions" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"workingtime" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hint_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hint_points" => array (
		"notnull" => false
		,"default" => "0"
		,"type" => "float"
	)
	,"obligations_answered" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"exam_id" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("tst_pass_result", $fields);

$in_fields = array("active_fi","pass");
$ilDB->addUniqueConstraint("tst_pass_result", $in_fields, "c1");


//
// tst_qst_solved
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"solved" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_qst_solved", $fields);

$pk_fields = array("active_fi","question_fi");
$ilDB->addPrimaryKey("tst_qst_solved", $pk_fields);


//
// tst_result_cache
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"max_points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"reached_points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"mark_short" => array (
		"notnull" => true
		,"length" => 256
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"mark_official" => array (
		"notnull" => true
		,"length" => 256
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"passed" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"failed" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hint_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hint_points" => array (
		"notnull" => false
		,"default" => "0"
		,"type" => "float"
	)
	,"obligations_answered" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_result_cache", $fields);

$in_fields = array("active_fi");
$ilDB->addIndex("tst_result_cache", $in_fields, "i1", false);


//
// tst_rnd_cpy
//
$fields = array (
	"copy_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tst_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qst_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qpl_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_rnd_cpy", $fields);

$pk_fields = array("copy_id");
$ilDB->addPrimaryKey("tst_rnd_cpy", $pk_fields);

$in_fields = array("qst_fi");
$ilDB->addIndex("tst_rnd_cpy", $in_fields, "i1", false);

$in_fields = array("qpl_fi");
$ilDB->addIndex("tst_rnd_cpy", $in_fields, "i2", false);

$in_fields = array("tst_fi");
$ilDB->addIndex("tst_rnd_cpy", $in_fields, "i3", false);

$ilDB->createSequence("tst_rnd_cpy", 1);


//
// tst_rnd_qpl_title
//
$fields = array (
	"title_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qpl_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"tst_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"qpl_title" => array (
		"notnull" => true
		,"length" => 1000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("tst_rnd_qpl_title", $fields);

$pk_fields = array("title_id");
$ilDB->addPrimaryKey("tst_rnd_qpl_title", $pk_fields);

$in_fields = array("qpl_fi");
$ilDB->addIndex("tst_rnd_qpl_title", $in_fields, "i1", false);

$in_fields = array("tst_fi");
$ilDB->addIndex("tst_rnd_qpl_title", $in_fields, "i2", false);

$ilDB->createSequence("tst_rnd_qpl_title", 1);


//
// tst_rnd_quest_set_cfg
//
$fields = array (
	"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"req_pools_homo_scored" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"quest_amount_cfg_mode" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"quest_amount_per_test" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"quest_sync_timestamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_rnd_quest_set_cfg", $fields);

$pk_fields = array("test_fi");
$ilDB->addPrimaryKey("tst_rnd_quest_set_cfg", $pk_fields);


//
// tst_rnd_quest_set_qpls
//
$fields = array (
	"def_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pool_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pool_title" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"pool_path" => array (
		"notnull" => false
		,"length" => 512
		,"fixed" => false
		,"type" => "text"
	)
	,"pool_quest_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"origin_tax_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"origin_node_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mapped_tax_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"mapped_node_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"quest_amount" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"sequence_pos" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_rnd_quest_set_qpls", $fields);

$pk_fields = array("def_id");
$ilDB->addPrimaryKey("tst_rnd_quest_set_qpls", $pk_fields);

$ilDB->createSequence("tst_rnd_quest_set_qpls", 1);


//
// tst_seq_qst_answstatus
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"correctness" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_seq_qst_answstatus", $fields);

$pk_fields = array("active_fi","pass","question_fi");
$ilDB->addPrimaryKey("tst_seq_qst_answstatus", $pk_fields);

$in_fields = array("active_fi","pass");
$ilDB->addIndex("tst_seq_qst_answstatus", $in_fields, "i1", false);

$in_fields = array("active_fi","question_fi");
$ilDB->addIndex("tst_seq_qst_answstatus", $in_fields, "i2", false);


//
// tst_seq_qst_checked
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_seq_qst_checked", $fields);

$pk_fields = array("active_fi","pass","question_fi");
$ilDB->addPrimaryKey("tst_seq_qst_checked", $pk_fields);


//
// tst_seq_qst_postponed
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"cnt" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_seq_qst_postponed", $fields);

$pk_fields = array("active_fi","pass","question_fi");
$ilDB->addPrimaryKey("tst_seq_qst_postponed", $pk_fields);

$in_fields = array("active_fi","pass");
$ilDB->addIndex("tst_seq_qst_postponed", $in_fields, "i1", false);

$in_fields = array("active_fi","question_fi");
$ilDB->addIndex("tst_seq_qst_postponed", $in_fields, "i2", false);


//
// tst_seq_qst_tracking
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => false
		,"length" => 16
		,"fixed" => false
		,"type" => "text"
	)
	,"orderindex" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_seq_qst_tracking", $fields);

$pk_fields = array("active_fi","pass","question_fi");
$ilDB->addPrimaryKey("tst_seq_qst_tracking", $pk_fields);

$in_fields = array("active_fi","pass");
$ilDB->addIndex("tst_seq_qst_tracking", $in_fields, "i1", false);

$in_fields = array("active_fi","question_fi");
$ilDB->addIndex("tst_seq_qst_tracking", $in_fields, "i2", false);


//
// tst_sequence
//
$fields = array (
	"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sequence" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"postponed" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"hidden" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_sequence", $fields);

$in_fields = array("active_fi","pass");
$ilDB->addUniqueConstraint("tst_sequence", $in_fields, "c1");


//
// tst_skl_qst_assigns
//
$fields = array (
	"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_base_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_tref_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_points" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_skl_qst_assigns", $fields);

$pk_fields = array("test_fi","question_fi","skill_base_fi","skill_tref_fi");
$ilDB->addPrimaryKey("tst_skl_qst_assigns", $pk_fields);


//
// tst_skl_thresholds
//
$fields = array (
	"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_base_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_tref_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"skill_level_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"threshold" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_skl_thresholds", $fields);

$pk_fields = array("test_fi","skill_base_fi","skill_tref_fi","skill_level_fi");
$ilDB->addPrimaryKey("tst_skl_thresholds", $pk_fields);


//
// tst_solutions
//
$fields = array (
	"solution_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"points" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"value1" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"value2" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"step" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_solutions", $fields);

$pk_fields = array("solution_id");
$ilDB->addPrimaryKey("tst_solutions", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("tst_solutions", $in_fields, "i1", false);

$in_fields = array("active_fi");
$ilDB->addIndex("tst_solutions", $in_fields, "i2", false);

$ilDB->createSequence("tst_solutions", 1);


//
// tst_test_defaults
//
$fields = array (
	"test_defaults_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"marks" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"defaults" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("tst_test_defaults", $fields);

$pk_fields = array("test_defaults_id");
$ilDB->addPrimaryKey("tst_test_defaults", $pk_fields);

$in_fields = array("user_fi");
$ilDB->addIndex("tst_test_defaults", $in_fields, "i1", false);

$ilDB->createSequence("tst_test_defaults", 1);


//
// tst_test_question
//
$fields = array (
	"test_question_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"test_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obligatory" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_test_question", $fields);

$pk_fields = array("test_question_id");
$ilDB->addPrimaryKey("tst_test_question", $pk_fields);

$in_fields = array("test_fi");
$ilDB->addIndex("tst_test_question", $in_fields, "i1", false);

$in_fields = array("question_fi");
$ilDB->addIndex("tst_test_question", $in_fields, "i2", false);

$ilDB->createSequence("tst_test_question", 1);


//
// tst_test_result
//
$fields = array (
	"test_result_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"points" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"manual" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hint_count" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"hint_points" => array (
		"notnull" => false
		,"default" => "0"
		,"type" => "float"
	)
	,"answered" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"step" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_test_result", $fields);

$pk_fields = array("test_result_id");
$ilDB->addPrimaryKey("tst_test_result", $pk_fields);

$in_fields = array("active_fi");
$ilDB->addIndex("tst_test_result", $in_fields, "i1", false);

$in_fields = array("question_fi");
$ilDB->addIndex("tst_test_result", $in_fields, "i2", false);

$in_fields = array("pass");
$ilDB->addIndex("tst_test_result", $in_fields, "i3", false);

$ilDB->createSequence("tst_test_result", 1);


//
// tst_test_rnd_qst
//
$fields = array (
	"test_random_question_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"question_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"sequence" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"src_pool_def_fi" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_test_rnd_qst", $fields);

$pk_fields = array("test_random_question_id");
$ilDB->addPrimaryKey("tst_test_rnd_qst", $pk_fields);

$in_fields = array("question_fi");
$ilDB->addIndex("tst_test_rnd_qst", $in_fields, "i1", false);

$in_fields = array("active_fi");
$ilDB->addIndex("tst_test_rnd_qst", $in_fields, "i2", false);

$in_fields = array("pass");
$ilDB->addIndex("tst_test_rnd_qst", $in_fields, "i3", false);

$ilDB->createSequence("tst_test_rnd_qst", 1);


//
// tst_tests
//
$fields = array (
	"test_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"author" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"introduction" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"sequence_settings" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"score_reporting" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"instant_verification" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"answer_feedback" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"answer_feedback_points" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"fixed_participants" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"show_cancel" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"anonymity" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"nr_of_tries" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"use_previous_answers" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"title_output" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"processing_time" => array (
		"notnull" => false
		,"length" => 8
		,"fixed" => false
		,"type" => "text"
	)
	,"enable_processing_time" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"reset_processing_time" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"reporting_date" => array (
		"notnull" => false
		,"length" => 14
		,"fixed" => false
		,"type" => "text"
	)
	,"shuffle_questions" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"ects_output" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"ects_fx" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"complete" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"ects_a" => array (
		"notnull" => true
		,"default" => "90"
		,"type" => "float"
	)
	,"ects_b" => array (
		"notnull" => true
		,"default" => "65"
		,"type" => "float"
	)
	,"ects_c" => array (
		"notnull" => true
		,"default" => "35"
		,"type" => "float"
	)
	,"ects_d" => array (
		"notnull" => true
		,"default" => "10"
		,"type" => "float"
	)
	,"ects_e" => array (
		"notnull" => true
		,"default" => "0"
		,"type" => "float"
	)
	,"keep_questions" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"count_system" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"mc_scoring" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"score_cutting" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"pass_scoring" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"password" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"allowedusers" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"alloweduserstimegap" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"results_presentation" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "3"
		,"type" => "integer"
	)
	,"show_summary" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"show_question_titles" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "1"
		,"fixed" => false
		,"type" => "text"
	)
	,"certificate_visibility" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"show_marker" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"kiosk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"resultoutput" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"finalstatement" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"showfinalstatement" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"showinfo" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"forcejs" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"customstyle" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"created" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mailnotification" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mailnottype" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"exportsettings" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"enabled_view_mode" => array (
		"notnull" => false
		,"length" => 20
		,"default" => "0"
		,"fixed" => false
		,"type" => "text"
	)
	,"template_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"pool_usage" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"online_status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"print_bs_with_res" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"offer_question_hints" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_enabled" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_anon" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_achieved_ts" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_score" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_percentage" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_hints" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_wtime" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_own_table" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_top_table" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"highscore_top_num" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"specific_feedback" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obligations_enabled" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"autosave" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"autosave_ival" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"pass_deletion_allowed" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"starting_time" => array (
		"notnull" => false
		,"length" => 14
		,"fixed" => false
		,"type" => "text"
	)
	,"ending_time" => array (
		"notnull" => false
		,"length" => 14
		,"fixed" => false
		,"type" => "text"
	)
	,"redirection_mode" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"redirection_url" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => false
		,"type" => "text"
	)
	,"examid_in_test_pass" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"examid_in_test_res" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"enable_examview" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"show_examview_html" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"show_examview_pdf" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"enable_archiving" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"question_set_type" => array (
		"notnull" => true
		,"length" => 32
		,"default" => "FIXED_QUEST_SET"
		,"fixed" => false
		,"type" => "text"
	)
	,"sign_submission" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"char_selector_availability" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"char_selector_definition" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"skill_service" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"result_tax_filters" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"show_grading_status" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"show_grading_mark" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"inst_fb_answer_fixation" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"intro_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"starting_time_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"ending_time_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"password_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"limit_users_enabled" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"broken" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_tests", $fields);

$pk_fields = array("test_id");
$ilDB->addPrimaryKey("tst_tests", $pk_fields);

$in_fields = array("obj_fi");
$ilDB->addIndex("tst_tests", $in_fields, "i1", false);

$in_fields = array("introduction");
$ilDB->addIndex("tst_tests", $in_fields, "i2", true);

$ilDB->createSequence("tst_tests", 1);


//
// tst_times
//
$fields = array (
	"times_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active_fi" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"started" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"finished" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"pass" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("tst_times", $fields);

$pk_fields = array("times_id");
$ilDB->addPrimaryKey("tst_times", $pk_fields);

$in_fields = array("active_fi");
$ilDB->addIndex("tst_times", $in_fields, "i1", false);

$in_fields = array("pass");
$ilDB->addIndex("tst_times", $in_fields, "i2", false);

$ilDB->createSequence("tst_times", 1);


//
// udf_clob
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("udf_clob", $fields);

$pk_fields = array("usr_id","field_id");
$ilDB->addPrimaryKey("udf_clob", $pk_fields);


//
// udf_data
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("udf_data", $fields);

$pk_fields = array("usr_id");
$ilDB->addPrimaryKey("udf_data", $pk_fields);

$ilDB->insert("udf_data", array(
'usr_id' => array('integer', '6')));

$ilDB->insert("udf_data", array(
'usr_id' => array('integer', '13')));


//
// udf_definition
//
$fields = array (
	"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_name" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
	,"field_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_values" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"visible" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"changeable" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"required" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"searchable" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"export" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"course_export" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"registration_visible" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"visible_lua" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"changeable_lua" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"group_export" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"certificate" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("udf_definition", $fields);

$pk_fields = array("field_id");
$ilDB->addPrimaryKey("udf_definition", $pk_fields);

$ilDB->createSequence("udf_definition", 1);


//
// udf_text
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("udf_text", $fields);

$pk_fields = array("usr_id","field_id");
$ilDB->addPrimaryKey("udf_text", $pk_fields);


//
// usr_account_codes
//
$fields = array (
	"code_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"code" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"valid_until" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"generated" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"used" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_account_codes", $fields);

$pk_fields = array("code_id");
$ilDB->addPrimaryKey("usr_account_codes", $pk_fields);

$in_fields = array("code");
$ilDB->addIndex("usr_account_codes", $in_fields, "i1", false);

$ilDB->createSequence("usr_account_codes", 1);


//
// usr_cron_mail_reminder
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ts" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_cron_mail_reminder", $fields);

$pk_fields = array("usr_id");
$ilDB->addPrimaryKey("usr_cron_mail_reminder", $pk_fields);


//
// usr_data
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"login" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"passwd" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"firstname" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"lastname" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"gender" => array (
		"notnull" => false
		,"length" => 1
		,"default" => "m"
		,"fixed" => true
		,"type" => "text"
	)
	,"email" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"institution" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"street" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"city" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"zipcode" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"country" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"phone_office" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"last_login" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"last_update" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"create_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"hobby" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"department" => array (
		"notnull" => false
		,"length" => 80
		,"fixed" => false
		,"type" => "text"
	)
	,"phone_home" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"phone_mobile" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"fax" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"time_limit_owner" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"time_limit_unlimited" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"time_limit_from" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"time_limit_until" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"time_limit_message" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"referral_comment" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
	,"matriculation" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"active" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"approve_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"agree_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"ilinc_id" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"ilinc_login" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"ilinc_passwd" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"client_ip" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"auth_mode" => array (
		"notnull" => false
		,"length" => 10
		,"default" => "default"
		,"fixed" => true
		,"type" => "text"
	)
	,"profile_incomplete" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ext_account" => array (
		"notnull" => false
		,"length" => 250
		,"fixed" => false
		,"type" => "text"
	)
	,"im_icq" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"im_yahoo" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"im_msn" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"im_aim" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"im_skype" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"feed_hash" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"delicious" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"latitude" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"longitude" => array (
		"notnull" => false
		,"length" => 30
		,"fixed" => false
		,"type" => "text"
	)
	,"loc_zoom" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"login_attempts" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_password_change" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"im_jabber" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"im_voip" => array (
		"notnull" => false
		,"length" => 40
		,"fixed" => false
		,"type" => "text"
	)
	,"reg_hash" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => true
		,"type" => "text"
	)
	,"birthday" => array (
		"notnull" => false
		,"type" => "date"
	)
	,"sel_country" => array (
		"notnull" => false
		,"length" => 2
		,"fixed" => false
		,"type" => "text"
	)
	,"last_visited" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"inactivation_date" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"is_self_registered" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"passwd_enc_type" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => false
		,"type" => "text"
	)
	,"passwd_salt" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_data", $fields);

$pk_fields = array("usr_id");
$ilDB->addPrimaryKey("usr_data", $pk_fields);

$in_fields = array("login","passwd");
$ilDB->addIndex("usr_data", $in_fields, "i1", false);

$in_fields = array("ext_account","auth_mode");
$ilDB->addIndex("usr_data", $in_fields, "i2", false);

$ilDB->insert("usr_data", array(
'usr_id' => array('integer', '6'), 'login' => array('text', 'root'), 'passwd' => array('text', 'dfa8327f5bfa4c672a04f9b38e348a70'), 'firstname' => array('text', 'root'), 'lastname' => array('text', 'user'), 'title' => array('text', ''), 'gender' => array('text', 'm'), 'email' => array('text', 'ilias@yourserver.com'), 'institution' => array('text', ''), 'street' => array('text', ''), 'city' => array('text', ''), 'zipcode' => array('text', ''), 'country' => array('text', ''), 'phone_office' => array('text', ''), 'last_login' => array('timestamp', '2005-07-20 15:11:40'), 'last_update' => array('timestamp', '2003-09-30 19:50:01'), 'create_date' => array('timestamp', ''), 'hobby' => array('text', ''), 'department' => array('text', ''), 'phone_home' => array('text', ''), 'phone_mobile' => array('text', ''), 'fax' => array('text', ''), 'time_limit_owner' => array('integer', '7'), 'time_limit_unlimited' => array('integer', '1'), 'time_limit_from' => array('integer', '0'), 'time_limit_until' => array('integer', '0'), 'time_limit_message' => array('integer', '0'), 'referral_comment' => array('text', ''), 'matriculation' => array('text', ''), 'active' => array('integer', '1'), 'approve_date' => array('timestamp', ''), 'agree_date' => array('timestamp', ''), 'ilinc_id' => array('integer', ''), 'ilinc_login' => array('text', ''), 'ilinc_passwd' => array('text', ''), 'client_ip' => array('text', ''), 'auth_mode' => array('text', 'default'), 'profile_incomplete' => array('integer', '0'), 'ext_account' => array('text', ''), 'im_icq' => array('text', ''), 'im_yahoo' => array('text', ''), 'im_msn' => array('text', ''), 'im_aim' => array('text', ''), 'im_skype' => array('text', ''), 'feed_hash' => array('text', ''), 'delicious' => array('text', ''), 'latitude' => array('text', ''), 'longitude' => array('text', ''), 'loc_zoom' => array('integer', '0'), 'login_attempts' => array('integer', '0'), 'last_password_change' => array('integer', '1217068076'), 'im_jabber' => array('text', ''), 'im_voip' => array('text', ''), 'reg_hash' => array('text', ''), 'birthday' => array('date', ''), 'sel_country' => array('text', ''), 'last_visited' => array('clob', ''), 'inactivation_date' => array('timestamp', ''), 'is_self_registered' => array('integer', '0'), 'passwd_enc_type' => array('text', 'md5'), 'passwd_salt' => array('text', '')));

$ilDB->insert("usr_data", array(
'usr_id' => array('integer', '13'), 'login' => array('text', 'anonymous'), 'passwd' => array('text', '294de3557d9d00b3d2d8a1e6aab028cf'), 'firstname' => array('text', 'anonymous'), 'lastname' => array('text', 'anonymous'), 'title' => array('text', ''), 'gender' => array('text', 'm'), 'email' => array('text', 'nomail'), 'institution' => array('text', ''), 'street' => array('text', ''), 'city' => array('text', ''), 'zipcode' => array('text', ''), 'country' => array('text', ''), 'phone_office' => array('text', ''), 'last_login' => array('timestamp', '2003-08-15 11:03:36'), 'last_update' => array('timestamp', '2003-08-15 10:07:30'), 'create_date' => array('timestamp', '2003-08-15 10:07:30'), 'hobby' => array('text', ''), 'department' => array('text', ''), 'phone_home' => array('text', ''), 'phone_mobile' => array('text', ''), 'fax' => array('text', ''), 'time_limit_owner' => array('integer', '7'), 'time_limit_unlimited' => array('integer', '1'), 'time_limit_from' => array('integer', '0'), 'time_limit_until' => array('integer', '0'), 'time_limit_message' => array('integer', '0'), 'referral_comment' => array('text', ''), 'matriculation' => array('text', ''), 'active' => array('integer', '1'), 'approve_date' => array('timestamp', ''), 'agree_date' => array('timestamp', ''), 'ilinc_id' => array('integer', ''), 'ilinc_login' => array('text', ''), 'ilinc_passwd' => array('text', ''), 'client_ip' => array('text', ''), 'auth_mode' => array('text', 'local'), 'profile_incomplete' => array('integer', '0'), 'ext_account' => array('text', ''), 'im_icq' => array('text', ''), 'im_yahoo' => array('text', ''), 'im_msn' => array('text', ''), 'im_aim' => array('text', ''), 'im_skype' => array('text', ''), 'feed_hash' => array('text', ''), 'delicious' => array('text', ''), 'latitude' => array('text', ''), 'longitude' => array('text', ''), 'loc_zoom' => array('integer', '0'), 'login_attempts' => array('integer', '0'), 'last_password_change' => array('integer', '1217068076'), 'im_jabber' => array('text', ''), 'im_voip' => array('text', ''), 'reg_hash' => array('text', ''), 'birthday' => array('date', ''), 'sel_country' => array('text', ''), 'last_visited' => array('clob', ''), 'inactivation_date' => array('timestamp', ''), 'is_self_registered' => array('integer', '0'), 'passwd_enc_type' => array('text', 'md5'), 'passwd_salt' => array('text', '')));


//
// usr_data_multi
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"field_id" => array (
		"notnull" => true
		,"length" => 255
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_data_multi", $fields);


//
// usr_ext_profile_page
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_ext_profile_page", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("usr_ext_profile_page", $pk_fields);

$ilDB->createSequence("usr_ext_profile_page", 1);


//
// usr_form_settings
//
$fields = array (
	"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"id" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"settings" => array (
		"notnull" => true
		,"length" => 4000
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_form_settings", $fields);

$pk_fields = array("user_id","id");
$ilDB->addPrimaryKey("usr_form_settings", $pk_fields);


//
// usr_portf_acl
//
$fields = array (
	"node_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"object_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"extended_data" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_portf_acl", $fields);

$pk_fields = array("node_id","object_id");
$ilDB->addPrimaryKey("usr_portf_acl", $pk_fields);


//
// usr_portfolio
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"is_online" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"is_default" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"bg_color" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"font_color" => array (
		"notnull" => false
		,"length" => 6
		,"fixed" => true
		,"type" => "text"
	)
	,"img" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => false
		,"type" => "text"
	)
	,"ppic" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_portfolio", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("usr_portfolio", $pk_fields);


//
// usr_portfolio_page
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"portfolio_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => true
		,"length" => 250
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"order_nr" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_portfolio_page", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("usr_portfolio_page", $pk_fields);

$ilDB->createSequence("usr_portfolio_page", 1);


//
// usr_pref
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"keyword" => array (
		"notnull" => true
		,"length" => 40
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_pref", $fields);

$pk_fields = array("usr_id","keyword");
$ilDB->addPrimaryKey("usr_pref", $pk_fields);

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'style'), 'value' => array('text', 'delos')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'skin'), 'value' => array('text', 'default')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_zip'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_upload'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_street'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_profile'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_phone'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_institution'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_hobby'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_email'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_country'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'public_city'), 'value' => array('text', 'n')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'language'), 'value' => array('text', 'en')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '6'), 'keyword' => array('text', 'show_users_online'), 'value' => array('text', 'y')));

$ilDB->insert("usr_pref", array(
'usr_id' => array('integer', '13'), 'keyword' => array('text', 'show_users_online'), 'value' => array('text', 'y')));


//
// usr_pwassist
//
$fields = array (
	"pwassist_id" => array (
		"notnull" => true
		,"length" => 180
		,"default" => ""
		,"fixed" => true
		,"type" => "text"
	)
	,"expires" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ctime" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_pwassist", $fields);

$pk_fields = array("pwassist_id");
$ilDB->addPrimaryKey("usr_pwassist", $pk_fields);

$in_fields = array("user_id");
$ilDB->addUniqueConstraint("usr_pwassist", $in_fields, "c1");


//
// usr_search
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"search_result" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"checked" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"failed" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"page" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"search_type" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"query" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"root" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"item_filter" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
	,"mime_filter" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_search", $fields);

$pk_fields = array("usr_id","search_type");
$ilDB->addPrimaryKey("usr_search", $pk_fields);


//
// usr_sess_istorage
//
$fields = array (
	"session_id" => array (
		"notnull" => true
		,"length" => 80
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"component_id" => array (
		"notnull" => true
		,"length" => 30
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"vkey" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => false
		,"length" => 1000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_sess_istorage", $fields);

$pk_fields = array("session_id","component_id","vkey");
$ilDB->addPrimaryKey("usr_sess_istorage", $pk_fields);


//
// usr_session
//
$fields = array (
	"session_id" => array (
		"notnull" => true
		,"length" => 250
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"expires" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"data" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"ctime" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_remind_ts" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"type" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"createtime" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"remote_addr" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("usr_session", $fields);

$pk_fields = array("session_id");
$ilDB->addPrimaryKey("usr_session", $pk_fields);

$in_fields = array("expires");
$ilDB->addIndex("usr_session", $in_fields, "i1", false);

$in_fields = array("user_id");
$ilDB->addIndex("usr_session", $in_fields, "i2", false);

$ilDB->insert("usr_session", array(
'session_id' => array('text', 'a5cce8547ad6c807f38629e7b45b1715'), 'expires' => array('integer', '1248096561'), 'data' => array('clob', '_authsession|a:0:{}_auth__authhttpa9f0e61a137d86aa9db53465e0801612|a:10:{s:12:"challengekey";s:32:"3b9d61518a1dd35403f310af0bc0c897";s:4:"data";a:0:{}s:9:"sessionip";s:14:"192.168.120.18";s:16:"sessionuseragent";s:99:"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.4; en-US; rv:1.9.0.11) Gecko/2009060214 Firefox/3.0.11";s:19:"sessionforwardedfor";s:0:"";s:15:"challengecookie";s:32:"fde9b4eef8ec1c11a6ac530015dbc3db";s:10:"registered";b:1;s:8:"username";s:4:"alex";s:9:"timestamp";i:1248075833;s:4:"idle";i:1248089361;}lang|s:2:"en";locator_data|a:0:{}locator_level|i:-1;il_help_targets|a:0:{}post_vars|a:0:{}referer|s:133:"/ilias3/ilias.php?ref_id=973&obj_id=861&active_node=861&cmd=edit&cmdClass=ilpageobjectgui&cmdNode=c6:cd:c8:7r&baseClass=ilLMEditorGUI";AccountId|s:3:"157";tbl_limit|i:10;il_pd_history|s:11:"ilcolumngui";pdfeed_71_blnav|N;il_nav_history|s:162:"a:1:{i:0;a:4:{s:6:"ref_id";s:3:"973";s:4:"link";s:44:"ilias.php?baseClass=ilLMEditorGUI&ref_id=973";s:5:"title";s:20:"A new learing module";s:4:"type";s:2:"lm";}}";paragraph_plugins|O:18:"ilParagraphPlugins":3:{s:7:"plugins";a:0:{}s:15:"pluginDirectory";s:38:"/htdocs/ilias3/Services/COPage/plugins";s:15:"skipDirectories";a:3:{s:46:"/htdocs/ilias3/Services/COPage/plugins/classes";s:4:"skip";s:48:"/htdocs/ilias3/Services/COPage/plugins/resources";s:4:"skip";s:42:"/htdocs/ilias3/Services/COPage/plugins/CVS";s:4:"skip";}}lmexpand|a:1:{i:0;s:1:"1";}cont_media_insert|s:9:"insertNew";expand|a:1:{i:0;s:1:"1";}'), 'ctime' => array('integer', '1248089361'), 'user_id' => array('integer', '157'), 'last_remind_ts' => array('integer', '0'), 'type' => array('integer', ''), 'createtime' => array('integer', ''), 'remote_addr' => array('text', '')));


//
// usr_session_log
//
$fields = array (
	"tstamp" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"maxval" => array (
		"notnull" => true
		,"length" => 3
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_session_log", $fields);


//
// usr_session_stats
//
$fields = array (
	"slot_begin" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"slot_end" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"active_min" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"active_max" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"active_avg" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"active_end" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"opened" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"closed_manual" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"closed_expire" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"closed_idle" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"closed_idle_first" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"closed_limit" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"closed_login" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"max_sessions" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"closed_misc" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_session_stats", $fields);

$in_fields = array("slot_end");
$ilDB->addIndex("usr_session_stats", $in_fields, "i1", false);


//
// usr_session_stats_raw
//
$fields = array (
	"session_id" => array (
		"notnull" => true
		,"length" => 80
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"type" => array (
		"notnull" => true
		,"length" => 2
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"start_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"end_time" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"end_context" => array (
		"notnull" => false
		,"length" => 2
		,"unsigned" => false
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("usr_session_stats_raw", $fields);

$pk_fields = array("session_id");
$ilDB->addPrimaryKey("usr_session_stats_raw", $pk_fields);


//
// ut_lp_coll_manual
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"subitem_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"completed" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_change" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ut_lp_coll_manual", $fields);

$pk_fields = array("obj_id","usr_id","subitem_id");
$ilDB->addPrimaryKey("ut_lp_coll_manual", $pk_fields);


//
// ut_lp_collections
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"item_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"grouping_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"num_obligatory" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"active" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "1"
		,"type" => "integer"
	)
	,"lpmode" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"default" => "5"
		,"type" => "integer"
	)
);
$ilDB->createTable("ut_lp_collections", $fields);

$in_fields = array("obj_id","item_id");
$ilDB->addIndex("ut_lp_collections", $in_fields, "i1", false);


//
// ut_lp_marks
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"completed" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"mark" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"u_comment" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status_changed" => array (
		"notnull" => false
		,"type" => "timestamp"
	)
	,"status_dirty" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"percentage" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ut_lp_marks", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("ut_lp_marks", $pk_fields);


//
// ut_lp_settings
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"obj_type" => array (
		"notnull" => false
		,"length" => 4
		,"fixed" => true
		,"type" => "text"
	)
	,"u_mode" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"visits" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ut_lp_settings", $fields);

$pk_fields = array("obj_id");
$ilDB->addPrimaryKey("ut_lp_settings", $pk_fields);


//
// ut_lp_user_status
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"status" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"additional_info" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
);
$ilDB->createTable("ut_lp_user_status", $fields);

$pk_fields = array("obj_id","usr_id");
$ilDB->addPrimaryKey("ut_lp_user_status", $pk_fields);

$in_fields = array("obj_id");
$ilDB->addIndex("ut_lp_user_status", $in_fields, "i1", false);

$in_fields = array("usr_id");
$ilDB->addIndex("ut_lp_user_status", $in_fields, "i2", false);


//
// ut_online
//
$fields = array (
	"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"online_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"access_time" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("ut_online", $fields);

$pk_fields = array("usr_id");
$ilDB->addPrimaryKey("ut_online", $pk_fields);


//
// webr_items
//
$fields = array (
	"link_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"webr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"title" => array (
		"notnull" => false
		,"length" => 127
		,"fixed" => false
		,"type" => "text"
	)
	,"description" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"target" => array (
		"notnull" => false
		,"length" => 4000
		,"fixed" => false
		,"type" => "text"
	)
	,"active" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"disable_check" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"create_date" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_update" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"last_check" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"valid" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("webr_items", $fields);

$pk_fields = array("link_id");
$ilDB->addPrimaryKey("webr_items", $pk_fields);

$in_fields = array("link_id","webr_id");
$ilDB->addIndex("webr_items", $in_fields, "i1", false);

$in_fields = array("title");
$ilDB->addIndex("webr_items", $in_fields, "i2", true);

$ilDB->createSequence("webr_items", 1);


//
// webr_params
//
$fields = array (
	"param_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"webr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"link_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"name" => array (
		"notnull" => false
		,"length" => 128
		,"fixed" => true
		,"type" => "text"
	)
	,"value" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("webr_params", $fields);

$pk_fields = array("param_id");
$ilDB->addPrimaryKey("webr_params", $pk_fields);

$in_fields = array("link_id");
$ilDB->addIndex("webr_params", $in_fields, "i1", false);

$ilDB->createSequence("webr_params", 1);


//
// wiki_page_template
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"wpage_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"new_pages" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"add_to_page" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("wiki_page_template", $fields);

$pk_fields = array("wiki_id","wpage_id");
$ilDB->addPrimaryKey("wiki_page_template", $pk_fields);


//
// wiki_stat
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ts" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"num_pages" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"del_pages" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"avg_rating" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ts_day" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => true
		,"type" => "text"
	)
	,"ts_hour" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("wiki_stat", $fields);

$pk_fields = array("wiki_id","ts");
$ilDB->addPrimaryKey("wiki_stat", $pk_fields);


//
// wiki_stat_page
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ts" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"int_links" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ext_links" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"footnotes" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"num_ratings" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"num_words" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"num_chars" => array (
		"notnull" => true
		,"length" => 8
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"avg_rating" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ts_day" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => true
		,"type" => "text"
	)
	,"ts_hour" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"deleted" => array (
		"notnull" => true
		,"length" => 1
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("wiki_stat_page", $fields);

$pk_fields = array("wiki_id","page_id","ts");
$ilDB->addPrimaryKey("wiki_stat_page", $pk_fields);


//
// wiki_stat_page_user
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"page_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ts" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"changes" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"read_events" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ts_day" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => true
		,"type" => "text"
	)
	,"ts_hour" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("wiki_stat_page_user", $fields);

$pk_fields = array("wiki_id","page_id","ts","user_id");
$ilDB->addPrimaryKey("wiki_stat_page_user", $pk_fields);


//
// wiki_stat_user
//
$fields = array (
	"wiki_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"user_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ts" => array (
		"notnull" => true
		,"default" => ""
		,"type" => "timestamp"
	)
	,"new_pages" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ts_day" => array (
		"notnull" => false
		,"length" => 10
		,"fixed" => true
		,"type" => "text"
	)
	,"ts_hour" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("wiki_stat_user", $fields);

$pk_fields = array("wiki_id","user_id","ts");
$ilDB->addPrimaryKey("wiki_stat_user", $pk_fields);


//
// write_event
//
$fields = array (
	"obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"parent_obj_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"usr_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"action" => array (
		"notnull" => true
		,"length" => 8
		,"default" => " "
		,"fixed" => false
		,"type" => "text"
	)
	,"ts" => array (
		"notnull" => true
		,"default" => "1970-01-01 00:00:00"
		,"type" => "timestamp"
	)
	,"write_id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
);
$ilDB->createTable("write_event", $fields);

$pk_fields = array("write_id");
$ilDB->addPrimaryKey("write_event", $pk_fields);

$in_fields = array("parent_obj_id","ts");
$ilDB->addIndex("write_event", $in_fields, "i1", false);

$in_fields = array("obj_id");
$ilDB->addIndex("write_event", $in_fields, "i2", false);

$ilDB->createSequence("write_event", 26);

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '7'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2002-06-26 23:24:06'), 'write_id' => array('integer', '1')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '8'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2002-06-26 23:24:06'), 'write_id' => array('integer', '2')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '9'), 'parent_obj_id' => array('integer', '1'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2002-07-15 02:37:33'), 'write_id' => array('integer', '3')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '10'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2002-07-15 02:36:56'), 'write_id' => array('integer', '4')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '11'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2002-07-15 05:52:51'), 'write_id' => array('integer', '5')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '12'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2003-08-15 00:07:28'), 'write_id' => array('integer', '6')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '98'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2004-02-18 16:17:40'), 'write_id' => array('integer', '7')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '100'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2004-03-09 13:13:16'), 'write_id' => array('integer', '8')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '107'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2004-06-20 15:27:18'), 'write_id' => array('integer', '9')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '109'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2004-07-10 15:03:12'), 'write_id' => array('integer', '10')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '86'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2003-11-30 16:22:49'), 'write_id' => array('integer', '11')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '114'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2004-09-01 23:49:45'), 'write_id' => array('integer', '12')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '116'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2005-01-07 12:21:15'), 'write_id' => array('integer', '13')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '118'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2005-03-02 03:59:01'), 'write_id' => array('integer', '14')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '124'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2005-06-19 23:50:00'), 'write_id' => array('integer', '15')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '128'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2005-07-20 08:10:04'), 'write_id' => array('integer', '16')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '132'), 'parent_obj_id' => array('integer', '98'), 'usr_id' => array('integer', '6'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2005-11-07 07:41:22'), 'write_id' => array('integer', '17')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '133'), 'parent_obj_id' => array('integer', '132'), 'usr_id' => array('integer', '6'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2005-11-07 07:41:22'), 'write_id' => array('integer', '18')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '136'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2006-07-11 08:43:23'), 'write_id' => array('integer', '19')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '138'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2007-02-26 12:58:49'), 'write_id' => array('integer', '20')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '140'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2007-02-26 12:58:50'), 'write_id' => array('integer', '21')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '144'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2007-04-03 03:43:47'), 'write_id' => array('integer', '22')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '147'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2007-09-25 09:47:53'), 'write_id' => array('integer', '23')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '150'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2008-06-02 06:08:54'), 'write_id' => array('integer', '24')));

$ilDB->insert("write_event", array(
'obj_id' => array('integer', '152'), 'parent_obj_id' => array('integer', '9'), 'usr_id' => array('integer', '-1'), 'action' => array('text', 'create'), 'ts' => array('timestamp', '2008-06-02 06:08:55'), 'write_id' => array('integer', '25')));


//
// xhtml_page
//
$fields = array (
	"id" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"content" => array (
		"notnull" => false
		,"type" => "clob"
	)
	,"save_content" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("xhtml_page", $fields);

$pk_fields = array("id");
$ilDB->addPrimaryKey("xhtml_page", $pk_fields);

$ilDB->createSequence("xhtml_page", 1);


//
// xmlnestedset
//
$fields = array (
	"ns_book_fk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"ns_type" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => true
		,"type" => "text"
	)
	,"ns_tag_fk" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"ns_l" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"ns_r" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("xmlnestedset", $fields);

$in_fields = array("ns_tag_fk");
$ilDB->addIndex("xmlnestedset", $in_fields, "i1", false);

$in_fields = array("ns_book_fk");
$ilDB->addIndex("xmlnestedset", $in_fields, "i2", false);


//
// xmlnestedsettmp
//
$fields = array (
	"ns_unique_id" => array (
		"notnull" => true
		,"length" => 32
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"ns_book_fk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ns_type" => array (
		"notnull" => true
		,"length" => 50
		,"default" => ""
		,"fixed" => false
		,"type" => "text"
	)
	,"ns_tag_fk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ns_l" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
	,"ns_r" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => ""
		,"type" => "integer"
	)
);
$ilDB->createTable("xmlnestedsettmp", $fields);

$in_fields = array("ns_tag_fk");
$ilDB->addIndex("xmlnestedsettmp", $in_fields, "i1", false);

$in_fields = array("ns_l");
$ilDB->addIndex("xmlnestedsettmp", $in_fields, "i2", false);

$in_fields = array("ns_r");
$ilDB->addIndex("xmlnestedsettmp", $in_fields, "i3", false);

$in_fields = array("ns_book_fk");
$ilDB->addIndex("xmlnestedsettmp", $in_fields, "i4", false);

$in_fields = array("ns_unique_id");
$ilDB->addIndex("xmlnestedsettmp", $in_fields, "i5", false);


//
// xmlparam
//
$fields = array (
	"tag_fk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"param_name" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => true
		,"type" => "text"
	)
	,"param_value" => array (
		"notnull" => false
		,"length" => 255
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("xmlparam", $fields);

$in_fields = array("tag_fk");
$ilDB->addIndex("xmlparam", $in_fields, "i1", false);


//
// xmltags
//
$fields = array (
	"tag_pk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tag_depth" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tag_name" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => true
		,"type" => "text"
	)
);
$ilDB->createTable("xmltags", $fields);

$pk_fields = array("tag_pk");
$ilDB->addPrimaryKey("xmltags", $pk_fields);

$ilDB->createSequence("xmltags", 1);


//
// xmlvalue
//
$fields = array (
	"tag_value_pk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tag_fk" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"tag_value" => array (
		"notnull" => false
		,"type" => "clob"
	)
);
$ilDB->createTable("xmlvalue", $fields);

$pk_fields = array("tag_value_pk");
$ilDB->addPrimaryKey("xmlvalue", $pk_fields);

$in_fields = array("tag_fk");
$ilDB->addIndex("xmlvalue", $in_fields, "i1", false);

$in_fields = array("tag_value");
$ilDB->addIndex("xmlvalue", $in_fields, "i2", true);

$ilDB->createSequence("xmlvalue", 1);


//
// sahs_sc13_seq_seq
//
$fields = array (
	"importid" => array (
		"notnull" => false
		,"length" => 32
		,"fixed" => false
		,"type" => "text"
	)
	,"activityabsolutedurationlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"activityexperienceddurlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptabsolutedurationlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptexperienceddurlimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"attemptlimit" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"begintimelimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"choice" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"choiceexit" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"completionsetbycontent" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"constrainchoice" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"seqnodeid" => array (
		"notnull" => true
		,"length" => 4
		,"unsigned" => false
		,"default" => "0"
		,"type" => "integer"
	)
	,"endtimelimit" => array (
		"notnull" => false
		,"length" => 20
		,"fixed" => false
		,"type" => "text"
	)
	,"flow" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"forwardonly" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"id" => array (
		"notnull" => false
		,"length" => 200
		,"fixed" => false
		,"type" => "text"
	)
	,"measuresatisfactionifactive" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"objectivemeasureweight" => array (
		"notnull" => false
		,"type" => "float"
	)
	,"objectivesetbycontent" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"preventactivation" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"randomizationtiming" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"reorderchildren" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"requiredforcompleted" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"requiredforincomplete" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"requiredfornotsatisfied" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"requiredforsatisfied" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"rollupobjectivesatisfied" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"rollupprogresscompletion" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"selectcount" => array (
		"notnull" => false
		,"length" => 4
		,"unsigned" => false
		,"type" => "integer"
	)
	,"selectiontiming" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"sequencingid" => array (
		"notnull" => false
		,"length" => 50
		,"fixed" => false
		,"type" => "text"
	)
	,"tracked" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"usecurrentattemptobjectiveinfo" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
	,"usecurrentattemptprogressinfo" => array (
		"notnull" => false
		,"length" => 1
		,"unsigned" => false
		,"type" => "integer"
	)
);
$ilDB->createTable("sahs_sc13_seq_seq", $fields);

$pk_fields = array("seqnodeid");
$ilDB->addPrimaryKey("sahs_sc13_seq_seq", $pk_fields);

$in_fields = array("id");
$ilDB->addIndex("sahs_sc13_seq_seq", $in_fields, "i1", false);

$ilDB->createSequence("booking_reservation_group");

}
?>
